/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],D=0,t=Q.length;D<t;D++)e[D]=ne[Q[D]];return e};define(ne[52],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=D;class t{constructor(P,I,E){this.id=P,this.definition=I,this.description=E,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(T,P){const I=["codicon","codicon-"+T];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=R;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function I(C){if(C instanceof t)return["codicon","codicon-"+C.id];const p=P.exec(C.id);if(!p)return I(t.error);const[,v,g]=p,y=["codicon","codicon-"+v];return g&&y.push("codicon-modifier-"+g.substr(1)),y}T.asClassNameArray=I;function E(C){return I(C).join(" ")}T.asClassName=E;function b(C){return"."+I(C).join(".")}T.asCSSSelector=b})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[63],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(P,I,E)=>{let b=null,C=null;if(typeof E.value=="function"?(b="value",C=E.value):typeof E.get=="function"&&(b="get",C=E.get),!C)throw new Error("not supported");E[b]=T(C,I)}}e.createDecorator=D;function t(T,P,I){let E=null,b=null;if(typeof I.value=="function"?(E="value",b=I.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(E="get",b=I.get),!b)throw new Error("not supported");const C=`$memoize$${P}`;I[E]=function(...p){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,p)}),this[C]}}e.memoize=t;function R(T,P,I){return D((E,b)=>{const C=`$debounce$${b}`,p=`$debounce$result$${b}`;return function(...v){this[p]||(this[p]=I?I():void 0),clearTimeout(this[C]),P&&(this[p]=P(this[p],...v),v=[this[p]]),this[C]=setTimeout(()=>{E.apply(this,v),this[p]=I?I():void 0},T)}})}e.debounce=R;function L(T,P,I){return D((E,b)=>{const C=`$throttle$timer$${b}`,p=`$throttle$result$${b}`,v=`$throttle$lastRun$${b}`,g=`$throttle$pending$${b}`;return function(...y){if(this[p]||(this[p]=I?I():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...y)),this[g])return;const w=this[v]+T;w<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[p]]),this[p]=I?I():void 0):(this[g]=!0,this[C]=setTimeout(()=>{this[g]=!1,this[v]=Date.now(),E.apply(this,[this[p]]),this[p]=I?I():void 0},w-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?l.isErrorNoTelemetry(o)?new l(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(s=>{s(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=D,e.errorHandler=new D;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function R(u){I(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=R;function L(u){I(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=L;function T(u){if(u instanceof Error){const{name:o,message:s}=u,n=u.stacktrace||u.stack;return{$isError:!0,name:o,message:s,stack:n,noTelemetry:l.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=T;const P="Canceled";function I(u){return u instanceof E?!0:u instanceof Error&&u.name===P&&u.message===P}e.isCancellationError=I;class E extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=E;function b(){const u=new Error(P);return u.name=u.message,u}e.canceled=b;function C(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=C;function p(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=p;function v(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function g(u){const o=new Error(`${u} has been disposed`);return o.name="DISPOSED",o}e.disposed=g;function y(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=y;class w extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=w;class d extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=d;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class l extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof l)return o;const s=new l;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=l;class f extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ne[18],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(Z,ie=0){return Z[Z.length-(1+ie)]}e.tail=t;function R(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=R;function L(Z,ie,se=(ue,de)=>ue===de){if(Z===ie)return!0;if(!Z||!ie||Z.length!==ie.length)return!1;for(let ue=0,de=Z.length;ue<de;ue++)if(!se(Z[ue],ie[ue]))return!1;return!0}e.equals=L;function T(Z,ie){const se=Z.length-1;ie<se&&(Z[ie]=Z[se]),Z.pop()}e.removeFastWithoutKeepingOrder=T;function P(Z,ie,se){return I(Z.length,ue=>se(Z[ue],ie))}e.binarySearch=P;function I(Z,ie){let se=0,ue=Z-1;for(;se<=ue;){const de=(se+ue)/2|0,ve=ie(de);if(ve<0)se=de+1;else if(ve>0)ue=de-1;else return de}return-(se+1)}e.binarySearch2=I;function E(Z,ie){let se=0,ue=Z.length;if(ue===0)return 0;for(;se<ue;){const de=Math.floor((se+ue)/2);ie(Z[de])?ue=de:se=de+1}return se}e.findFirstInSorted=E;function b(Z,ie,se){if(Z=Z|0,Z>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],de=[],ve=[],we=[];for(const Ee of ie){const Ce=se(Ee,ue);Ce<0?de.push(Ee):Ce>0?ve.push(Ee):we.push(Ee)}return Z<de.length?b(Z,de,se):Z<de.length+we.length?we[0]:b(Z-(de.length+we.length),ve,se)}e.quickSelect=b;function C(Z,ie){const se=[];let ue;for(const de of Z.slice(0).sort(ie))!ue||ie(ue[0],de)!==0?(ue=[de],se.push(ue)):ue.push(de);return se}e.groupBy=C;function p(Z,ie,se){const ue=[];function de(Ee,Ce,Ue){if(Ce===0&&Ue.length===0)return;const $e=ue[ue.length-1];$e&&$e.start+$e.deleteCount===Ee?($e.deleteCount+=Ce,$e.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Ce,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===Z.length){de(ve,0,ie.slice(we));break}if(we===ie.length){de(ve,Z.length-ve,[]);break}const Ee=Z[ve],Ce=ie[we],Ue=se(Ee,Ce);Ue===0?(ve+=1,we+=1):Ue<0?(de(ve,1,[]),ve+=1):Ue>0&&(de(ve,0,[Ce]),we+=1)}return ue}e.sortedDiff=p;function v(Z,ie,se){const ue=p(Z,ie,se),de=[],ve=[];for(const we of ue)de.push(...Z.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:de,added:ve}}e.delta=v;function g(Z,ie,se){if(se===0)return[];const ue=Z.slice(0,se).sort(ie);return w(Z,ie,ue,se,Z.length),ue}e.top=g;function y(Z,ie,se,ue,de){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=Z.length,Ce=Z.slice(0,se).sort(ie);for(let Ue=se,$e=Math.min(se+ue,Ee);Ue<Ee;Ue=$e,$e=Math.min($e+ue,Ee)){if(Ue>se&&await new Promise(He=>setTimeout(He)),de&&de.isCancellationRequested)throw new D.CancellationError;w(Z,ie,Ce,Ue,$e)}return Ce})().then(ve,we)})}e.topAsync=y;function w(Z,ie,se,ue,de){for(const ve=se.length;ue<de;ue++){const we=Z[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=E(se,Ce=>ie(we,Ce)<0);se.splice(Ee,0,we)}}}function d(Z){return Z.filter(ie=>!!ie)}e.coalesce=d;function m(Z){let ie=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[ie]=Z[se],ie+=1);Z.length=ie}e.coalesceInPlace=m;function l(Z,ie,se){Z.splice(se,0,Z.splice(ie,1)[0])}e.move=l;function f(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=f;function u(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=u;function o(Z,ie=se=>se){const se=new Set;return Z.filter(ue=>{const de=ie(ue);return se.has(de)?!1:(se.add(de),!0)})}e.distinct=o;function s(Z){const ie=new Set;return se=>{const ue=Z(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=s;function n(Z,ie){const se=i(Z,ie);if(se!==-1)return Z[se]}e.findLast=n;function i(Z,ie){for(let se=Z.length-1;se>=0;se--){const ue=Z[se];if(ie(ue))return se}return-1}e.lastIndex=i;function r(Z,ie){return Z.length>0?Z[0]:ie}e.firstOrDefault=r;function c(Z,ie){return Z.length>0?Z[Z.length-1]:ie}e.lastOrDefault=c;function a(Z,ie,se=(ue,de)=>ue===de){let ue=0;for(let de=0,ve=Math.min(Z.length,ie.length);de<ve&&se(Z[de],ie[de]);de++)ue++;return ue}e.commonPrefixLength=a;function h(Z){return[].concat(...Z)}e.flatten=h;function S(Z,ie){let se=typeof ie=="number"?Z:0;typeof ie=="number"?se=Z:(se=0,ie=Z);const ue=[];if(se<=ie)for(let de=se;de<ie;de++)ue.push(de);else for(let de=se;de>ie;de--)ue.push(de);return ue}e.range=S;function A(Z,ie,se){return Z.reduce((ue,de)=>(ue[ie(de)]=se?se(de):de,ue),Object.create(null))}e.index=A;function $(Z,ie){return Z.push(ie),()=>_(Z,ie)}e.insert=$;function _(Z,ie){const se=Z.indexOf(ie);if(se>-1)return Z.splice(se,1),ie}e.remove=_;function U(Z,ie,se){const ue=Z.slice(0,ie),de=Z.slice(ie);return ue.concat(se,de)}e.arrayInsert=U;function k(Z,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const de=Math.sin(ue++)*179426549;return de-Math.floor(de)}}else se=Math.random;for(let ue=Z.length-1;ue>0;ue-=1){const de=Math.floor(se()*(ue+1)),ve=Z[ue];Z[ue]=Z[de],Z[de]=ve}}e.shuffle=k;function N(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.unshift(ie))}e.pushToStart=N;function F(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.push(ie))}e.pushToEnd=F;function q(Z,ie){for(const se of ie)Z.push(se)}e.pushMany=q;function J(Z,ie){return Array.isArray(Z)?Z.map(ie):ie(Z)}e.mapArrayOrNot=J;function j(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=j;function H(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=H;function W(Z,ie){for(const se of Z){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=W;function z(Z,ie,se){const ue=X(Z,ie),de=Z.length,ve=se.length;Z.length=de+ve;for(let we=de-1;we>=ue;we--)Z[we+ve]=Z[we];for(let we=0;we<ve;we++)Z[we+ue]=se[we]}e.insertInto=z;function K(Z,ie,se,ue){const de=X(Z,ie),ve=Z.splice(de,se);return z(Z,de,ue),ve}e.splice=K;function X(Z,ie){return ie<0?Math.max(ie+Z.length,0):Math.min(ie,Z.length)}var ce;(function(Z){function ie(de){return de<0}Z.isLessThan=ie;function se(de){return de>0}Z.isGreaterThan=se;function ue(de){return de===0}Z.isNeitherLessOrGreaterThan=ue,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function B(Z,ie){return(se,ue)=>ie(Z(se),Z(ue))}e.compareBy=B;function G(...Z){return(ie,se)=>{for(const ue of Z){const de=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(de))return de}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=G;const O=(Z,ie)=>Z-ie;e.numberComparator=O;function M(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>0&&(se=de)}return se}e.findMaxBy=M;function x(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>=0&&(se=de)}return se}e.findLastMaxBy=x;function V(Z,ie){return M(Z,(se,ue)=>-ie(se,ue))}e.findMinBy=V;class ee{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=ee;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(de=>((ue||ce.isGreaterThan(ie(de,se)))&&(ue=!1,se=de),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(Z=>{})}),define(ne[117],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(I,E){if(!I)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=t;function R(I,E="Unreachable"){throw new Error(E)}e.assertNever=R;function L(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=L;function T(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(I,E){let b=0;for(;b<I.length-1;){const C=I[b],p=I[b+1];if(!E(C,p))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ne[79],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(t){const R=this;let L=!1,T;return function(){return L||(L=!0,T=t.apply(R,arguments)),T}}e.once=D}),define(ne[53],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(t){function R(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}t.is=R;const L=Object.freeze([]);function T(){return L}t.empty=T;function*P(s){yield s}t.single=P;function I(s){return s||L}t.from=I;function E(s){return!s||s[Symbol.iterator]().next().done===!0}t.isEmpty=E;function b(s){return s[Symbol.iterator]().next().value}t.first=b;function C(s,n){for(const i of s)if(n(i))return!0;return!1}t.some=C;function p(s,n){for(const i of s)if(n(i))return i}t.find=p;function*v(s,n){for(const i of s)n(i)&&(yield i)}t.filter=v;function*g(s,n){let i=0;for(const r of s)yield n(r,i++)}t.map=g;function*y(...s){for(const n of s)for(const i of n)yield i}t.concat=y;function*w(s){for(const n of s)for(const i of n)yield i}t.concatNested=w;function d(s,n,i){let r=i;for(const c of s)r=n(r,c);return r}t.reduce=d;function m(s,n){let i=0;for(const r of s)n(r,i++)}t.forEach=m;function*l(s,n,i=s.length){for(n<0&&(n+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);n<i;n++)yield s[n]}t.slice=l;function f(s,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,s];const r=s[Symbol.iterator]();for(let c=0;c<n;c++){const a=r.next();if(a.done)return[i,t.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=f;function u(s){return f(s)[0]}t.collect=u;function o(s,n,i=(r,c)=>r===c){const r=s[Symbol.iterator](),c=n[Symbol.iterator]();for(;;){const a=r.next(),h=c.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!i(a.value,h.value))return!1}}t.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(o){o.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function T(o,s=!1){let n=0;const i=o.length;let r="",c=0,a=16,h=0;function S(F){let q=0,J=0;for(;q<F;){const j=o.charCodeAt(n);if(j>=48&&j<=57)J=J*16+j-48;else if(j>=65&&j<=70)J=J*16+j-65+10;else if(j>=97&&j<=102)J=J*16+j-97+10;else break;n++,q++}return q<F&&(J=-1),J}function A(F){n=F,r="",c=0,a=16,h=0}function $(){const F=n;if(o.charCodeAt(n)===48)n++;else for(n++;n<o.length&&E(o.charCodeAt(n));)n++;if(n<o.length&&o.charCodeAt(n)===46)if(n++,n<o.length&&E(o.charCodeAt(n)))for(n++;n<o.length&&E(o.charCodeAt(n));)n++;else return h=3,o.substring(F,n);let q=n;if(n<o.length&&(o.charCodeAt(n)===69||o.charCodeAt(n)===101))if(n++,(n<o.length&&o.charCodeAt(n)===43||o.charCodeAt(n)===45)&&n++,n<o.length&&E(o.charCodeAt(n))){for(n++;n<o.length&&E(o.charCodeAt(n));)n++;q=n}else h=3;return o.substring(F,q)}function _(){let F="",q=n;for(;;){if(n>=i){F+=o.substring(q,n),h=2;break}const J=o.charCodeAt(n);if(J===34){F+=o.substring(q,n),n++;break}if(J===92){if(F+=o.substring(q,n),n++,n>=i){h=2;break}switch(o.charCodeAt(n++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=S(4);H>=0?F+=String.fromCharCode(H):h=4;break}default:h=5}q=n;continue}if(J>=0&&J<=31)if(I(J)){F+=o.substring(q,n),h=2;break}else h=6;n++}return F}function U(){if(r="",h=0,c=n,n>=i)return c=i,a=17;let F=o.charCodeAt(n);if(P(F)){do n++,r+=String.fromCharCode(F),F=o.charCodeAt(n);while(P(F));return a=15}if(I(F))return n++,r+=String.fromCharCode(F),F===13&&o.charCodeAt(n)===10&&(n++,r+=`
`),a=14;switch(F){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,r=_(),a=10;case 47:{const q=n-1;if(o.charCodeAt(n+1)===47){for(n+=2;n<i&&!I(o.charCodeAt(n));)n++;return r=o.substring(q,n),a=12}if(o.charCodeAt(n+1)===42){n+=2;const J=i-1;let j=!1;for(;n<J;){if(o.charCodeAt(n)===42&&o.charCodeAt(n+1)===47){n+=2,j=!0;break}n++}return j||(n++,h=1),r=o.substring(q,n),a=13}return r+=String.fromCharCode(F),n++,a=16}case 45:if(r+=String.fromCharCode(F),n++,n===i||!E(o.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=$(),a=11;default:for(;n<i&&k(F);)n++,F=o.charCodeAt(n);if(c!==n){switch(r=o.substring(c,n),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(F),n++,a=16}}function k(F){if(P(F)||I(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let F;do F=U();while(F>=12&&F<=15);return F}return{setPosition:A,getPosition:()=>n,scan:s?N:U,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>h}}e.createScanner=T;function P(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function I(o){return o===10||o===13||o===8232||o===8233}function E(o){return o>=48&&o<=57}var b;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(b||(b={}));function C(o,s){const n=[],i=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(S,A,$,_){c.value=S,c.offset=A,c.length=$,c.type=_,c.colonOffset=void 0,r=c}try{l(o,{onObjectBegin:(S,A)=>{if(s<=S)throw i;r=void 0,a=s>S,n.push("")},onObjectProperty:(S,A,$)=>{if(s<A||(h(S,A,$,"property"),n[n.length-1]=S,s<=A+$))throw i},onObjectEnd:(S,A)=>{if(s<=S)throw i;r=void 0,n.pop()},onArrayBegin:(S,A)=>{if(s<=S)throw i;r=void 0,n.push(0)},onArrayEnd:(S,A)=>{if(s<=S)throw i;r=void 0,n.pop()},onLiteralValue:(S,A,$)=>{if(s<A||(h(S,A,$,u(S)),s<=A+$))throw i},onSeparator:(S,A,$)=>{if(s<=A)throw i;if(S===":"&&r&&r.type==="property")r.colonOffset=A,a=!1,r=void 0;else if(S===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(a=!0,n[n.length-1]=""),r=void 0}}})}catch(S){if(S!==i)throw S}return{path:n,previousNode:r,isAtPropertyKey:a,matches:S=>{let A=0;for(let $=0;A<S.length&&$<n.length;$++)if(S[A]===n[$]||S[A]==="*")A++;else if(S[A]!=="**")return!1;return A===S.length}}}e.getLocation=C;function p(o,s=[],n=L.DEFAULT){let i=null,r=[];const c=[];function a(S){Array.isArray(r)?r.push(S):i!==null&&(r[i]=S)}return l(o,{onObjectBegin:()=>{const S={};a(S),c.push(r),r=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const S=[];a(S),c.push(r),r=S,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:a,onError:(S,A,$)=>{s.push({error:S,offset:A,length:$})}},n),r[0]}e.parse=p;function v(o,s=[],n=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function c(S){return i.children.push(S),S}l(o,{onObjectBegin:S=>{i=c({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,A,$)=>{i=c({type:"property",offset:A,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:A,length:$,parent:i})},onObjectEnd:(S,A)=>{i.length=S+A-i.offset,i=i.parent,r(S+A)},onArrayBegin:(S,A)=>{i=c({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,A)=>{i.length=S+A-i.offset,i=i.parent,r(S+A)},onLiteralValue:(S,A,$)=>{c({type:u(S),offset:A,length:$,parent:i,value:S}),r(A+$)},onSeparator:(S,A,$)=>{i.type==="property"&&(S===":"?i.colonOffset=A:S===","&&r(A))},onError:(S,A,$)=>{s.push({error:S,offset:A,length:$})}},n);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=v;function g(o,s){if(!o)return;let n=o;for(const i of s)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===i){n=c.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=g;function y(o){if(!o.parent||!o.parent.children)return[];const s=y(o.parent);if(o.parent.type==="property"){const n=o.parent.children[0].value;s.push(n)}else if(o.parent.type==="array"){const n=o.parent.children.indexOf(o);n!==-1&&s.push(n)}return s}e.getNodePath=y;function w(o){switch(o.type){case"array":return o.children.map(w);case"object":{const s=Object.create(null);for(const n of o.children){const i=n.children[1];i&&(s[n.children[0].value]=w(i))}return s}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=w;function d(o,s,n=!1){return s>=o.offset&&s<o.offset+o.length||n&&s===o.offset+o.length}e.contains=d;function m(o,s,n=!1){if(d(o,s,n)){const i=o.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=s;r++){const c=m(i[r],s,n);if(c)return c}return o}}e.findNodeAtOffset=m;function l(o,s,n=L.DEFAULT){const i=T(o,!1);function r(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(B){return B?G=>B(G,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=r(s.onObjectBegin),h=c(s.onObjectProperty),S=r(s.onObjectEnd),A=r(s.onArrayBegin),$=r(s.onArrayEnd),_=c(s.onLiteralValue),U=c(s.onSeparator),k=r(s.onComment),N=c(s.onError),F=n&&n.disallowComments,q=n&&n.allowTrailingComma;function J(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:F||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(B){case 12:case 13:F?j(10):k();break;case 16:j(1);break;case 15:case 14:break;default:return B}}}function j(B,G=[],O=[]){if(N(B),G.length+O.length>0){let M=i.getToken();for(;M!==17;){if(G.indexOf(M)!==-1){J();break}else if(O.indexOf(M)!==-1)break;M=J()}}}function H(B){const G=i.getTokenValue();return B?_(G):h(G),J(),!0}function W(){switch(i.getToken()){case 11:{let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(j(2),B=0)}catch{j(2)}_(B);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return J(),!0}function z(){return i.getToken()!==10?(j(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(U(":"),J(),ce()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function K(){a(),J();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||j(4,[],[]),U(","),J(),i.getToken()===2&&q)break}else B&&j(6,[],[]);z()||j(4,[],[2,5]),B=!0}return S(),i.getToken()!==2?j(7,[2],[]):J(),!0}function X(){A(),J();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||j(4,[],[]),U(","),J(),i.getToken()===4&&q)break}else B&&j(6,[],[]);ce()||j(4,[],[4,5]),B=!0}return $(),i.getToken()!==4?j(8,[4],[]):J(),!0}function ce(){switch(i.getToken()){case 3:return X();case 1:return K();case 10:return H(!0);default:return W()}}return J(),i.getToken()===17?n.allowEmptyContent?!0:(j(4,[],[]),!1):ce()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=l;function f(o,s){const n=T(o),i=[];let r,c=0,a;do switch(a=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:c!==a&&i.push(o.substring(c,a)),s!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,s)),c=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=f;function u(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ne[46],re([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(E,b,C){let p,v,g,y,w;if(b){for(y=b.offset,w=y+b.length,g=y;g>0&&!I(E,g-1);)g--;let a=w;for(;a<E.length&&!I(E,a);)a++;v=E.substring(g,a),p=T(v,C)}else v=E,p=0,g=0,y=0,w=E.length;const d=P(C,E);let m=!1,l=0,f;C.insertSpaces?f=L(" ",C.tabSize||4):f="	";const u=(0,D.createScanner)(v,!1);let o=!1;function s(){return d+L(f,p+l)}function n(){let a=u.scan();for(m=!1;a===15||a===14;)m=m||a===14,a=u.scan();return o=a===16||u.getTokenError()!==0,a}const i=[];function r(a,h,S){!o&&h<w&&S>y&&E.substring(h,S)!==a&&i.push({offset:h,length:S-h,content:a})}let c=n();if(c!==17){const a=u.getTokenOffset()+g,h=L(f,p);r(h,g,a)}for(;c!==17;){let a=u.getTokenOffset()+u.getTokenLength()+g,h=n(),S="";for(;!m&&(h===12||h===13);){const $=u.getTokenOffset()+g;r(" ",a,$),a=u.getTokenOffset()+u.getTokenLength()+g,S=h===12?s():"",h=n()}if(h===2)c!==1&&(l--,S=s());else if(h===4)c!==3&&(l--,S=s());else{switch(c){case 3:case 1:l++,S=s();break;case 5:case 12:S=s();break;case 13:m?S=s():S=" ";break;case 6:S=" ";break;case 10:if(h===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?S=" ":h!==5&&h!==17&&(o=!0);break;case 16:o=!0;break}m&&(h===12||h===13)&&(S=s())}const A=u.getTokenOffset()+g;r(S,a,A),c=h}return i}e.format=t;function R(E,b){const C=JSON.stringify(E,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?C.replace(/\r\n|\r|\n/g,b.eol):C}e.toFormattedString=R;function L(E,b){let C="";for(let p=0;p<b;p++)C+=E;return C}function T(E,b){let C=0,p=0;const v=b.tabSize||4;for(;C<E.length;){const g=E.charAt(C);if(g===" ")p++;else if(g==="	")p+=v;else break;C++}return Math.floor(p/v)}function P(E,b){for(let C=0;C<b.length;C++){const p=b.charAt(C);if(p==="\r")return C+1<b.length&&b.charAt(C+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=P;function I(E,b){return`\r
`.indexOf(E.charAt(b))!==-1}e.isEOL=I}),define(ne[80],re([0,1,35,46]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,b,C){return L(E,b,void 0,C)}e.removeProperty=R;function L(E,b,C,p,v){const g=b.slice(),y=[],w=(0,D.parseTree)(E,y);let d,m;for(;g.length>0&&(m=g.pop(),d=(0,D.findNodeAtLocation)(w,g),d===void 0&&C!==void 0);)typeof m=="string"?C={[m]:C}:C=[C];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const l=(0,D.findNodeAtLocation)(d,[m]);if(l!==void 0)if(C===void 0){if(!l.parent)throw new Error("Malformed AST");const f=d.children.indexOf(l.parent);let u,o=l.parent.offset+l.parent.length;if(f>0){const s=d.children[f-1];u=s.offset+s.length}else u=d.offset+1,d.children.length>1&&(o=d.children[1].offset);return T(E,{offset:u,length:o-u,content:""},p)}else return T(E,{offset:l.offset,length:l.length,content:JSON.stringify(C)},p);else{if(C===void 0)return[];const f=`${JSON.stringify(m)}: ${JSON.stringify(C)}`,u=v?v(d.children.map(s=>s.children[0].value)):d.children.length;let o;if(u>0){const s=d.children[u-1];o={offset:s.offset+s.length,length:0,content:","+f}}else d.children.length===0?o={offset:d.offset+1,length:0,content:f}:o={offset:d.offset+1,length:0,content:f+","};return T(E,o,p)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(C!==void 0){const l=`${JSON.stringify(C)}`;let f;if(d.children.length===0||m===0)f={offset:d.offset+1,length:0,content:d.children.length===0?l:l+","};else{const u=m===-1||m>d.children.length?d.children.length:m,o=d.children[u-1];f={offset:o.offset+o.length,length:0,content:","+l}}return T(E,f,p)}else{const l=m,f=d.children[l];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===l){const o=d.children[l-1],s=o.offset+o.length,n=d.offset+d.length;u={offset:s,length:n-2-s,content:""}}else u={offset:f.offset,length:d.children[l+1].offset-f.offset,content:""};return T(E,u,p)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(E,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(C)},p)}}e.setProperty=L;function T(E,b,C){let p=P(E,b),v=b.offset,g=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;v>0&&!(0,t.isEOL)(p,v-1);)v--;for(;g<p.length&&!(0,t.isEOL)(p,g);)g++}const y=(0,t.format)(p,{offset:v,length:g-v},C);for(let d=y.length-1;d>=0;d--){const m=y[d];p=P(p,m),v=Math.min(v,m.offset),g=Math.max(g,m.offset+m.length),g+=m.content.length-m.length}const w=E.length-(p.length-g)-v;return[{offset:v,length:w,content:p.substring(v,g)}]}e.withFormatting=T;function P(E,b){return E.substring(0,b.offset)+b.content+E.substring(b.offset+b.length)}e.applyEdit=P;function I(E,b){const C=b.slice(0).sort((v,g)=>{const y=v.offset-g.offset;return y===0?v.length-g.length:y});let p=E.length;for(let v=C.length-1;v>=0;v--){const g=C[v];if(g.offset+g.length<=p)E=P(E,g);else throw new Error("Overlapping edit");p=g.offset}return E}e.applyEdits=I}),define(ne[118],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(ne[2],re([0,1,79,53]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function T(c){L=c}if(e.setDisposableTracker=T,R){const c="__is_disposable_tracked__";T(new class{trackDisposable(a){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(h)},3e3)}setParent(a,h){if(a&&a!==m.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==m.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function P(c){return L?.trackDisposable(c),c}function I(c){L?.markAsDisposed(c)}function E(c,a){L?.setParent(c,a)}function b(c,a){if(!!L)for(const h of c)L.setParent(h,a)}function C(c){return L?.markAsSingleton(c),c}e.markAsSingleton=C;function p(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=p;function v(c){if(t.Iterable.is(c)){const a=[];for(const h of c)if(h)try{h.dispose()}catch(S){a.push(S)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=v;function g(c){for(const a of c)p(a)&&a.dispose();return[]}e.disposeIfDisposable=g;function y(...c){const a=w(()=>v(c));return b(c,a),a}e.combinedDisposable=y;function w(c){const a=P({dispose:(0,D.once)(()=>{I(a),c()})});return a}e.toDisposable=w;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return E(a,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new d,P(this),E(this._store,this)}dispose(){I(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&E(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,I(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&E(a,null),a}}e.MutableDisposable=l;class f{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let h=a;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,I(this))},this}}e.SafeDisposable=u;class o{constructor(){this.references=new Map}acquire(a,...h){let S=this.references.get(a);S||(S={counter:0,object:this.createReferencedObject(a,...h)},this.references.set(a,S));const{object:A}=S,$=(0,D.once)(()=>{--S.counter===0&&(this.destroyReferencedObject(a,S.object),this.references.delete(a))});return S.counter++,{object:A,dispose:$}}}e.ReferenceCollection=o;class s{constructor(a){this.referenceCollection=a}async acquire(a,...h){const S=this.referenceCollection.acquire(a,...h);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(A){throw S.dispose(),A}}}e.AsyncReferenceCollection=s;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function i(c){const a=new d;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=i;class r{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){I(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,h,S=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this._store.get(a)?.dispose(),this._store.set(a,h)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(ne[81],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class t{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const T=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,T){const P=new D(L);if(this._first===D.Undefined)this._first=P,this._last=P;else if(T){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const T=L.prev;T.next=L.next,L.next.prev=T}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=t}),function(){function Q(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function T(I){L.push(I,Date.now())}function P(){const I=[];for(let E=0;E<L.length;E+=2)I.push({name:L[E],startTime:L[E+1]});return I}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(R+T.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=D(t))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var t in D)(typeof exports=="object"?exports:Q)[t]=D[t]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(t){if(e[t])return e[t].exports;var R=e[t]={i:t,l:!1,exports:{}};return Q[t].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(t,R,L){D.o(t,R)||Object.defineProperty(t,R,{enumerable:!0,get:L})},D.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},D.t=function(t,R){if(1&R&&(t=D(t)),8&R||4&R&&typeof t=="object"&&t&&t.__esModule)return t;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:t}),2&R&&typeof t!="string")for(var T in t)D.d(L,T,function(P){return t[P]}.bind(null,T));return L},D.n=function(t){var R=t&&t.__esModule?function(){return t.default}:function(){return t};return D.d(R,"a",R),R},D.o=function(t,R){return Object.prototype.hasOwnProperty.call(t,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(t){var R;e=Q.exports=O,R=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],E=0,b=E++;I[b]="0|[1-9]\\d*";var C=E++;I[C]="[0-9]+";var p=E++;I[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;I[v]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var g=E++;I[g]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var y=E++;I[y]="(?:"+I[b]+"|"+I[p]+")";var w=E++;I[w]="(?:"+I[C]+"|"+I[p]+")";var d=E++;I[d]="(?:-("+I[y]+"(?:\\."+I[y]+")*))";var m=E++;I[m]="(?:-?("+I[w]+"(?:\\."+I[w]+")*))";var l=E++;I[l]="[0-9A-Za-z-]+";var f=E++;I[f]="(?:\\+("+I[l]+"(?:\\."+I[l]+")*))";var u=E++,o="v?"+I[v]+I[d]+"?"+I[f]+"?";I[u]="^"+o+"$";var s="[v=\\s]*"+I[g]+I[m]+"?"+I[f]+"?",n=E++;I[n]="^"+s+"$";var i=E++;I[i]="((?:<|>)?=?)";var r=E++;I[r]=I[C]+"|x|X|\\*";var c=E++;I[c]=I[b]+"|x|X|\\*";var a=E++;I[a]="[v=\\s]*("+I[c]+")(?:\\.("+I[c]+")(?:\\.("+I[c]+")(?:"+I[d]+")?"+I[f]+"?)?)?";var h=E++;I[h]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[m]+")?"+I[f]+"?)?)?";var S=E++;I[S]="^"+I[i]+"\\s*"+I[a]+"$";var A=E++;I[A]="^"+I[i]+"\\s*"+I[h]+"$";var $=E++;I[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=E++;I[_]="(?:~>?)";var U=E++;I[U]="(\\s*)"+I[_]+"\\s+",P[U]=new RegExp(I[U],"g");var k=E++;I[k]="^"+I[_]+I[a]+"$";var N=E++;I[N]="^"+I[_]+I[h]+"$";var F=E++;I[F]="(?:\\^)";var q=E++;I[q]="(\\s*)"+I[F]+"\\s+",P[q]=new RegExp(I[q],"g");var J=E++;I[J]="^"+I[F]+I[a]+"$";var j=E++;I[j]="^"+I[F]+I[h]+"$";var H=E++;I[H]="^"+I[i]+"\\s*("+s+")$|^$";var W=E++;I[W]="^"+I[i]+"\\s*("+o+")$|^$";var z=E++;I[z]="(\\s*)"+I[i]+"\\s*("+s+"|"+I[a]+")",P[z]=new RegExp(I[z],"g");var K=E++;I[K]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var X=E++;I[X]="^\\s*("+I[h]+")\\s+-\\s+("+I[h]+")\\s*$";var ce=E++;I[ce]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)R(B,I[B]),P[B]||(P[B]=new RegExp(I[B]));function G(ae,fe){if(ae instanceof O)return ae;if(typeof ae!="string"||ae.length>L||!(fe?P[n]:P[u]).test(ae))return null;try{return new O(ae,fe)}catch{return null}}function O(ae,fe){if(ae instanceof O){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof O))return new O(ae,fe);R("SemVer",ae,fe),this.loose=fe;var ge=ae.trim().match(fe?P[n]:P[u]);if(!ge)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<T)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,fe){var ge=G(ae,fe);return ge?ge.version:null},e.clean=function(ae,fe){var ge=G(ae.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ae){return R("SemVer.compare",this.version,this.loose,ae),ae instanceof O||(ae=new O(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},O.prototype.compareMain=function(ae){return ae instanceof O||(ae=new O(ae,this.loose)),x(this.major,ae.major)||x(this.minor,ae.minor)||x(this.patch,ae.patch)},O.prototype.comparePre=function(ae){if(ae instanceof O||(ae=new O(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ae.prerelease[fe];if(R("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return x(ge,be)}while(++fe)},O.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new O(ae,ge).inc(fe,be).version}catch{return null}},e.diff=function(ae,fe){if(Z(ae,fe))return null;var ge=G(ae),be=G(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=x;var M=/^[0-9]+$/;function x(ae,fe){var ge=M.test(ae),be=M.test(fe);return ge&&be&&(ae=+ae,fe=+fe),ge&&!be?-1:be&&!ge?1:ae<fe?-1:ae>fe?1:0}function V(ae,fe,ge){return new O(ae,ge).compare(new O(fe,ge))}function ee(ae,fe,ge){return V(ae,fe,ge)>0}function oe(ae,fe,ge){return V(ae,fe,ge)<0}function Z(ae,fe,ge){return V(ae,fe,ge)===0}function ie(ae,fe,ge){return V(ae,fe,ge)!==0}function se(ae,fe,ge){return V(ae,fe,ge)>=0}function ue(ae,fe,ge){return V(ae,fe,ge)<=0}function de(ae,fe,ge,be){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae===ge;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae!==ge;break;case"":case"=":case"==":Ie=Z(ae,ge,be);break;case"!=":Ie=ie(ae,ge,be);break;case">":Ie=ee(ae,ge,be);break;case">=":Ie=se(ae,ge,be);break;case"<":Ie=oe(ae,ge,be);break;case"<=":Ie=ue(ae,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function ve(ae,fe){if(ae instanceof ve){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,fe);R("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ae,fe){return x(fe,ae)},e.major=function(ae,fe){return new O(ae,fe).major},e.minor=function(ae,fe){return new O(ae,fe).minor},e.patch=function(ae,fe){return new O(ae,fe).patch},e.compare=V,e.compareLoose=function(ae,fe){return V(ae,fe,!0)},e.rcompare=function(ae,fe,ge){return V(fe,ae,ge)},e.sort=function(ae,fe){return ae.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ae,fe){return ae.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=ee,e.lt=oe,e.eq=Z,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=de,e.Comparator=ve;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof ve)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ce(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,fe,ge,be,Ie,Le,Re,Ne,Ae,Me,ze,ke,_e){return((fe=Ce(ge)?"":Ce(be)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Ne=Ce(Ae)?"":Ce(Me)?"<"+(+Ae+1)+".0.0":Ce(ze)?"<"+Ae+"."+(+Me+1)+".0":ke?"<="+Ae+"."+Me+"."+ze+"-"+ke:"<="+Ne)).trim()}function $e(ae,fe){for(var ge=0;ge<ae.length;ge++)if(!ae[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ae.length;ge++)if(R(ae[ge].semver),ae[ge].semver!==we&&ae[ge].semver.prerelease.length>0){var be=ae[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function He(ae,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ae)}function We(ae,fe,ge,be){var Ie,Le,Re,Ne,Ae;switch(ae=new O(ae,be),fe=new Ee(fe,be),ge){case">":Ie=ee,Le=ue,Re=oe,Ne=">",Ae=">=";break;case"<":Ie=oe,Le=se,Re=ee,Ne="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(ae,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var ze=fe.set[Me],ke=null,_e=null;if(ze.forEach(function(te){te.semver===we&&(te=new ve(">=0.0.0")),ke=ke||te,_e=_e||te,Ie(te.semver,ke.semver,be)?ke=te:Re(te.semver,_e.semver,be)&&(_e=te)}),ke.operator===Ne||ke.operator===Ae||(!_e.operator||_e.operator===Ne)&&Le(ae,_e.semver)||_e.operator===Ae&&Re(ae,_e.semver))return!1}return!0}ve.prototype.parse=function(ae){var fe=this.loose?P[H]:P[W],ge=ae.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ae);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new O(ge[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return R("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new O(ae,this.loose)),de(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,fe){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ae.value,fe),He(this.value,ge,fe);if(ae.operator==="")return ge=new Ee(this.value,fe),He(ae.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Le=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ne=de(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=de(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Le&&Re||Ne||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),R("range",ae,fe);var ge=fe?P[X]:P[K];ae=ae.replace(ge,Ue),R("hyphen replace",ae),ae=ae.replace(P[z],"$1$2$3"),R("comparator trim",ae,P[z]),ae=(ae=(ae=ae.replace(P[U],"$1~")).replace(P[q],"$1^")).split(/\s+/).join(" ");var be=fe?P[H]:P[W],Ie=ae.split(" ").map(function(Le){return function(Re,Ne){return R("comp",Re),Re=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(ze){return function(ke,_e){R("caret",ke,_e);var te=_e?P[j]:P[J];return ke.replace(te,function(le,he,me,Se,Pe){var De;return R("caret",ke,le,he,me,Se,Pe),Ce(he)?De="":Ce(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Ce(Se)?De=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Pe?(R("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Pe+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Pe+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Pe+" <"+(+he+1)+".0.0"):(R("no pr"),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),R("caret return",De),De})}(ze,Me)}).join(" ")}(Re,Ne),R("caret",Re),Re=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(ze){return function(ke,_e){var te=_e?P[N]:P[k];return ke.replace(te,function(le,he,me,Se,Pe){var De;return R("tilde",ke,le,he,me,Se,Pe),Ce(he)?De="":Ce(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Ce(Se)?De=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Pe?(R("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=">="+he+"."+me+"."+Se+Pe+" <"+he+"."+(+me+1)+".0"):De=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",R("tilde return",De),De})}(ze,Me)}).join(" ")}(Re,Ne),R("tildes",Re),Re=function(Ae,Me){return R("replaceXRanges",Ae,Me),Ae.split(/\s+/).map(function(ze){return function(ke,_e){ke=ke.trim();var te=_e?P[A]:P[S];return ke.replace(te,function(le,he,me,Se,Pe,De){R("xRange",ke,le,he,me,Se,Pe,De);var Be=Ce(me),Fe=Be||Ce(Se),Te=Fe||Ce(Pe);return he==="="&&Te&&(he=""),Be?le=he===">"||he==="<"?"<0.0.0":"*":he&&Te?(Fe&&(Se=0),Te&&(Pe=0),he===">"?(he=">=",Fe?(me=+me+1,Se=0,Pe=0):Te&&(Se=+Se+1,Pe=0)):he==="<="&&(he="<",Fe?me=+me+1:Se=+Se+1),le=he+me+"."+Se+"."+Pe):Fe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Te&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),R("xRange return",le),le})}(ze,Me)}).join(" ")}(Re,Ne),R("xrange",Re),Re=function(Ae,Me){return R("replaceStars",Ae,Me),Ae.trim().replace(P[ce],"")}(Re,Ne),R("stars",Re),Re}(Le,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Le){return!!Le.match(be)})),Ie=Ie.map(function(Le){return new ve(Le,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Le){return be.intersects(Le,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new O(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if($e(this.set[fe],ae))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new O(be=Re,ge)))}),be},e.minSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new O(be=Re,ge)))}),be},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,ge){return We(ae,fe,"<",ge)},e.gtr=function(ae,fe,ge){return We(ae,fe,">",ge)},e.outside=We,e.prerelease=function(ae,fe){var ge=G(ae,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ae,fe,ge){return ae=new Ee(ae,ge),fe=new Ee(fe,ge),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof O)return ae;if(typeof ae!="string")return null;var fe=ae.match(P[$]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,t,R=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(w){if(D===setTimeout)return setTimeout(w,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{t=typeof clearTimeout=="function"?clearTimeout:T}catch{t=T}})();var I,E=[],b=!1,C=-1;function p(){b&&I&&(b=!1,I.length?E=I.concat(E):C=-1,E.length&&v())}function v(){if(!b){var w=P(p);b=!0;for(var d=E.length;d;){for(I=E,E=[];++C<d;)I&&I[C].run();C=-1,d=E.length}I=null,b=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===T||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(w)}}function g(w,d){this.fun=w,this.array=d}function y(){}R.nextTick=function(w){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];E.push(new g(w,d)),E.length!==1||b||P(v)},g.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=y,R.addListener=y,R.once=y,R.off=y,R.removeListener=y,R.removeAllListeners=y,R.emit=y,R.prependListener=y,R.prependOnceListener=y,R.listeners=function(w){return[]},R.binding=function(w){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(w){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[119],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,I,E){this.level=P,this.key=I,this.value=E,this.forward=[]}}const R=void 0;class L{constructor(P,I=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new t(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,R,R)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,I){return L._insert(this,P,I,this.comparator)&&(this._size+=1),this}delete(P){const I=L._delete(this,P,this.comparator);return I&&(this._size-=1),I}forEach(P,I){let E=this._header.forward[0];for(;E;)P.call(I,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this._header.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static _search(P,I,E){let b=P._header;for(let C=P._level-1;C>=0;C--)for(;b.forward[C]&&E(b.forward[C].key,I)<0;)b=b.forward[C];if(b=b.forward[0],b&&E(b.key,I)===0)return b}static _insert(P,I,E,b){const C=[];let p=P._header;for(let v=P._level-1;v>=0;v--){for(;p.forward[v]&&b(p.forward[v].key,I)<0;)p=p.forward[v];C[v]=p}if(p=p.forward[0],p&&b(p.key,I)===0)return p.value=E,!1;{const v=L._randomLevel(P);if(v>P._level){for(let g=P._level;g<v;g++)C[g]=P._header;P._level=v}p=new t(v,I,E);for(let g=0;g<v;g++)p.forward[g]=C[g].forward[g],C[g].forward[g]=p;return!0}}static _randomLevel(P,I=.5){let E=1;for(;Math.random()<I&&E<P._maxLevel;)E+=1;return E}static _delete(P,I,E){const b=[];let C=P._header;for(let p=P._level-1;p>=0;p--){for(;C.forward[p]&&E(C.forward[p].key,I)<0;)C=C.forward[p];b[p]=C}if(C=C.forward[0],!C||E(C.key,I)!==0)return!1;for(let p=0;p<P._level&&b[p].forward[p]===C;p++)b[p].forward[p]=C.forward[p];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=L}),define(ne[42],re([0,1,9,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(f){const u=f;return u?typeof u.read=="function":!1}e.isReadable=R;function L(f){const u=f;return u?[u.on,u.pause,u.resume,u.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=L;function T(f){const u=f;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(f,u){return new I(f,u)}e.newWriteableStream=P;class I{constructor(u,o){this.reducer=u,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u<"u"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(o=>o(u))}emitError(u){this.listeners.error.length===0?(0,D.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(o=>o(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,o){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(u,o){if(this.state.destroyed)return;let s;switch(u){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const n=s.indexOf(o);n>=0&&s.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(f,u){const o=[];let s;for(;(s=f.read())!==null;)o.push(s);return u(o)}e.consumeReadable=E;function b(f,u,o){const s=[];let n;for(;(n=f.read())!==null&&s.length<o;)s.push(n);return n===null&&s.length>0?u(s):{read:()=>{if(s.length>0)return s.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return f.read()}}}e.peekReadable=b;function C(f,u){return new Promise((o,s)=>{const n=[];p(f,{onData:i=>{u&&n.push(i)},onError:i=>{u?s(i):o(void 0)},onEnd:()=>{o(u?u(n):void 0)}})})}e.consumeStream=C;function p(f,u){let o=!1;return f.on("error",s=>{o||u.onError(s)}),f.on("end",()=>{o||u.onEnd()}),f.on("data",s=>{o||u.onData(s)}),(0,t.toDisposable)(()=>o=!0)}e.listenStream=p;function v(f,u){return new Promise((o,s)=>{const n=new t.DisposableStore,i=[],r=h=>{if(i.push(h),i.length>u)return n.dispose(),f.pause(),o({stream:f,buffer:i,ended:!1})},c=h=>s(h),a=()=>o({stream:f,buffer:i,ended:!0});n.add((0,t.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),n.add((0,t.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),n.add((0,t.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}e.peekStream=v;function g(f,u){const o=P(u);return o.end(f),o}e.toStream=g;function y(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=y;function w(f){let u=!1;return{read:()=>u?null:(u=!0,f)}}e.toReadable=w;function d(f,u,o){const s=P(o);return p(f,{onData:n=>s.write(u.data(n)),onError:n=>s.error(u.error?u.error(n):n),onEnd:()=>s.end()}),s}e.transform=d;function m(f,u,o){let s=!1;return{read:()=>{const n=u.read();return s?n:(s=!0,n!==null?o([f,n]):f)}}}e.prefixedReadable=m;function l(f,u,o){let s=!1;const n=P(o);return p(u,{onData:i=>s?n.write(i):(s=!0,n.write(o([f,i]))),onError:i=>n.error(i),onEnd:()=>{s||(s=!0,n.write(f)),n.end()}}),n}e.prefixedStream=l}),define(ne[16],re([0,1,42]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let R,L;class T{static alloc(h){return t?new T(Buffer.allocUnsafe(h)):new T(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new T(h)}static fromString(h,S){return!(S?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(h)):(R||(R=new TextEncoder),new T(R.encode(h)))}static fromByteArray(h){const S=T.alloc(h.length);for(let A=0,$=h.length;A<$;A++)S.buffer[A]=h[A];return S}static concat(h,S){if(typeof S>"u"){S=0;for(let _=0,U=h.length;_<U;_++)S+=h[_].byteLength}const A=T.alloc(S);let $=0;for(let _=0,U=h.length;_<U;_++){const k=h[_];A.set(k,$),$+=k.byteLength}return A}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=T.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,S){return new T(this.buffer.subarray(h,S))}set(h,S){if(h instanceof T)this.buffer.set(h.buffer,S);else if(h instanceof Uint8Array)this.buffer.set(h,S);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),S);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,S){b(this.buffer,h,S)}readUInt32LE(h){return C(this.buffer,h)}writeUInt32LE(h,S){p(this.buffer,h,S)}readUInt8(h){return v(this.buffer,h)}writeUInt8(h,S){g(this.buffer,h,S)}}e.VSBuffer=T;function P(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=P;function I(a,h,S){a[S+0]=h&255,h=h>>>8,a[S+1]=h&255}e.writeUInt16LE=I;function E(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=E;function b(a,h,S){a[S+3]=h,h=h>>>8,a[S+2]=h,h=h>>>8,a[S+1]=h,h=h>>>8,a[S]=h}e.writeUInt32BE=b;function C(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=C;function p(a,h,S){a[S+0]=h&255,h=h>>>8,a[S+1]=h&255,h=h>>>8,a[S+2]=h&255,h=h>>>8,a[S+3]=h&255}e.writeUInt32LE=p;function v(a,h){return a[h]}e.readUInt8=v;function g(a,h,S){a[S]=h}e.writeUInt8=g;function y(a){return D.consumeReadable(a,h=>T.concat(h))}e.readableToBuffer=y;function w(a){return D.toReadable(a)}e.bufferToReadable=w;function d(a){return D.consumeStream(a,h=>T.concat(h))}e.streamToBuffer=d;async function m(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=m;function l(a){return D.toStream(a,h=>T.concat(h))}e.bufferToStream=l;function f(a){return D.transform(a,{data:h=>typeof h=="string"?T.fromString(h):T.wrap(h)},h=>T.concat(h))}e.streamToBufferReadableStream=f;function u(a){return D.newWriteableStream(h=>T.concat(h),a)}e.newWriteableBufferStream=u;function o(a,h){return D.prefixedReadable(a,h,S=>T.concat(S))}e.prefixedBufferReadable=o;function s(a,h){return D.prefixedStream(a,h,S=>T.concat(S))}e.prefixedBufferStream=s;function n(a){let h=0,S=0,A=0;const $=new Uint8Array(Math.floor(a.length/4*3)),_=k=>{switch(S){case 3:$[A++]=h|k,S=0;break;case 2:$[A++]=h|k>>>2,h=k<<6,S=3;break;case 1:$[A++]=h|k>>>4,h=k<<4,S=2;break;default:h=k<<2,S=1}};for(let k=0;k<a.length;k++){const N=a.charCodeAt(k);if(N>=65&&N<=90)_(N-65);else if(N>=97&&N<=122)_(N-97+26);else if(N>=48&&N<=57)_(N-48+52);else if(N===43||N===45)_(62);else if(N===47||N===95)_(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[k]}`)}}const U=A;for(;S>0;)_(0);return T.wrap($).slice(0,U)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},h=!0,S=!1){const A=S?r:i;let $="";const _=a.byteLength%3;let U=0;for(;U<a.byteLength-_;U+=3){const k=a[U+0],N=a[U+1],F=a[U+2];$+=A[k>>>2],$+=A[(k<<4|N>>>4)&63],$+=A[(N<<2|F>>>6)&63],$+=A[F&63]}if(_===1){const k=a[U+0];$+=A[k>>>2],$+=A[k<<4&63],h&&($+="==")}else if(_===2){const k=a[U+0],N=a[U+1];$+=A[k>>>2],$+=A[(k<<4|N>>>4)&63],$+=A[N<<2&63],h&&($+="=")}return $}e.encodeBase64=c}),define(ne[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(s){return typeof s=="string"}e.isString=D;function t(s){return Array.isArray(s)&&s.every(n=>D(n))}e.isStringArray=t;function R(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=R;function L(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}e.isTypedArray=L;function T(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=T;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function I(s){return s===!0||s===!1}e.isBoolean=I;function E(s){return typeof s>"u"}e.isUndefined=E;function b(s){return!C(s)}e.isDefined=b;function C(s){return E(s)||s===null}e.isUndefinedOrNull=C;function p(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=p;function v(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=v;function g(...s){const n=[];for(let i=0;i<s.length;i++){const r=s[i];if(C(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(r)}return n}e.assertAllDefined=g;const y=Object.prototype.hasOwnProperty;function w(s){if(!R(s))return!1;for(const n in s)if(y.call(s,n))return!1;return!0}e.isEmptyObject=w;function d(s){return typeof s=="function"}e.isFunction=d;function m(...s){return s.length>0&&s.every(d)}e.areFunctions=m;function l(s,n){const i=Math.min(s.length,n.length);for(let r=0;r<i;r++)f(s[r],n[r])}e.validateConstraints=l;function f(s,n){if(D(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(d(n)){try{if(s instanceof n)return}catch{}if(!C(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function u(s){return s===null?void 0:s}e.withNullAsUndefined=u;function o(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=o}),define(ne[32],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.keys(d).forEach(l=>{d[l]&&typeof d[l]=="object"?m[l]=t(d[l]):m[l]=d[l]}),m}e.deepClone=t;function R(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const l=m.shift();Object.freeze(l);for(const f in l)if(L.call(l,f)){const u=l[f];typeof u=="object"&&!Object.isFrozen(u)&&!(0,D.isTypedArray)(u)&&m.push(u)}}return d}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function T(d,m){return P(d,m,new Set)}e.cloneAndChange=T;function P(d,m,l){if((0,D.isUndefinedOrNull)(d))return d;const f=m(d);if(typeof f<"u")return f;if(Array.isArray(d)){const u=[];for(const o of d)u.push(P(o,m,l));return u}if((0,D.isObject)(d)){if(l.has(d))throw new Error("Cannot clone recursive data-structure");l.add(d);const u={};for(const o in d)L.call(d,o)&&(u[o]=P(d[o],m,l));return l.delete(d),u}return d}function I(d,m,l=!0){return(0,D.isObject)(d)?((0,D.isObject)(m)&&Object.keys(m).forEach(f=>{f in d?l&&((0,D.isObject)(d[f])&&(0,D.isObject)(m[f])?I(d[f],m[f],l):d[f]=m[f]):d[f]=m[f]}),d):m}e.mixin=I;function E(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let l,f;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(l=0;l<d.length;l++)if(!E(d[l],m[l]))return!1}else{const u=[];for(f in d)u.push(f);u.sort();const o=[];for(f in m)o.push(f);if(o.sort(),!E(u,o))return!1;for(l=0;l<u.length;l++)if(!E(d[u[l]],m[u[l]]))return!1}return!0}e.equals=E;function b(d){const m=new Set;return JSON.stringify(d,(l,f)=>{if((0,D.isObject)(f)||Array.isArray(f)){if(m.has(f))return"[Circular]";m.add(f)}return f})}e.safeStringify=b;function C(d,m){const l=Object.create(null);return!d||!m||Object.keys(m).forEach(u=>{const o=d[u],s=m[u];E(o,s)||(l[u]=s)}),l}e.distinct=C;function p(d,m){const l=m.toLowerCase(),f=Object.keys(d).find(u=>u.toLowerCase()===l);return f?d[f]:d[m]}e.getCaseInsensitive=p;function v(d,m){const l=Object.create(null);for(const[f,u]of Object.entries(d))m(f,u)&&(l[f]=u);return l}e.filter=v;function g(d){let m=[],l=Object.getPrototypeOf(d);for(;Object.prototype!==l;)m=m.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return m}e.getAllPropertyNames=g;function y(d){const m=[];for(const l of g(d))typeof d[l]=="function"&&m.push(l);return m}e.getAllMethodNames=y;function w(d,m){const l=u=>function(){const o=Array.prototype.slice.call(arguments,0);return m(u,o)},f={};for(const u of d)f[u]=l(u);return f}e.createProxyObject=w}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(R){return D.test(R)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let I=0,E="";return E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E}}()}),define(ne[120],re([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(T){const P=T.replace(/\-/g,":").toLowerCase();return!t.has(P)}function L(){const T=(0,D.networkInterfaces)();for(const P in T){const I=T[P];if(I){for(const{mac:E}of I)if(R(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[121],re([0,1,82]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,I,E,b=1){let C=!1;return new Promise(p=>{const v=setTimeout(()=>{if(!C)return C=!0,p(0)},E);R(P,I,b,g=>{if(!C)return C=!0,clearTimeout(v),p(g)})})}e.findFreePort=t;function R(P,I,E,b){if(I===0)return b(0);const C=new D.Socket;C.once("connect",()=>(T(C),R(P+E,I-1,E,b))),C.once("data",()=>{}),C.once("error",p=>(T(C),p.code!=="ECONNREFUSED"?R(P+E,I-1,E,b):b(P))),C.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,I,E){let b=!1,C,p=1;const v=D.createServer({pauseOnConnect:!0});function g(y,w){b||(b=!0,v.removeAllListeners(),v.close(),C&&clearTimeout(C),w(y))}return new Promise(y=>{C=setTimeout(()=>{g(0,y)},E),v.on("listening",()=>{g(P,y)}),v.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&p<I?(P++,p++,v.listen(P,"127.0.0.1")):g(0,y)}),v.on("close",()=>{g(0,y)}),v.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function T(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(ne[122],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function t(L){return L instanceof R?!0:L instanceof Error&&L.name===D&&L.message===D}e.isOfflineError=t;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(ne[123],re([0,1,16,9,122]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(I,E){if(!navigator.onLine)throw new R.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((C,p)=>{b.open(I.type||"GET",I.url||"",!0,I.user,I.password),T(b,I),b.responseType="arraybuffer",b.onerror=v=>p(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=v=>{C({res:{statusCode:b.status,headers:P(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=v=>p(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(b.timeout=I.timeout),b.send(I.data),E.onCancellationRequested(()=>{b.abort(),p((0,t.canceled)())})})}e.request=L;function T(I,E){if(E.headers){e:for(const b in E.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(b,E.headers[b])}}}function P(I){const E=Object.create(null);for(const b of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const C=b.indexOf(":");E[b.substr(0,C).trim().toLowerCase()]=b.substr(C+1).trim()}return E}}),define(ne[124],re([11,12]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[64],re([0,1,124]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,R=t*60,L=R*24,T=L*7,P=L*30,I=L*365;function E(C,p,v){typeof C!="number"&&(C=C.getTime());const g=Math.round((new Date().getTime()-C)/1e3);if(g<-30)return(0,D.localize)(0,null,E(new Date().getTime()+g*1e3,!1));if(g<30)return(0,D.localize)(1,null);let y;return g<t?(y=g,p?y===1?v?(0,D.localize)(2,null,y):(0,D.localize)(3,null,y):v?(0,D.localize)(4,null,y):(0,D.localize)(5,null,y):y===1?v?(0,D.localize)(6,null,y):(0,D.localize)(7,null,y):v?(0,D.localize)(8,null,y):(0,D.localize)(9,null,y)):g<R?(y=Math.floor(g/t),p?y===1?v?(0,D.localize)(10,null,y):(0,D.localize)(11,null,y):v?(0,D.localize)(12,null,y):(0,D.localize)(13,null,y):y===1?v?(0,D.localize)(14,null,y):(0,D.localize)(15,null,y):v?(0,D.localize)(16,null,y):(0,D.localize)(17,null,y)):g<L?(y=Math.floor(g/R),p?y===1?v?(0,D.localize)(18,null,y):(0,D.localize)(19,null,y):v?(0,D.localize)(20,null,y):(0,D.localize)(21,null,y):y===1?v?(0,D.localize)(22,null,y):(0,D.localize)(23,null,y):v?(0,D.localize)(24,null,y):(0,D.localize)(25,null,y)):g<T?(y=Math.floor(g/L),p?y===1?(0,D.localize)(26,null,y):(0,D.localize)(27,null,y):y===1?(0,D.localize)(28,null,y):(0,D.localize)(29,null,y)):g<P?(y=Math.floor(g/T),p?y===1?v?(0,D.localize)(30,null,y):(0,D.localize)(31,null,y):v?(0,D.localize)(32,null,y):(0,D.localize)(33,null,y):y===1?v?(0,D.localize)(34,null,y):(0,D.localize)(35,null,y):v?(0,D.localize)(36,null,y):(0,D.localize)(37,null,y)):g<I?(y=Math.floor(g/P),p?y===1?v?(0,D.localize)(38,null,y):(0,D.localize)(39,null,y):v?(0,D.localize)(40,null,y):(0,D.localize)(41,null,y):y===1?v?(0,D.localize)(42,null,y):(0,D.localize)(43,null,y):v?(0,D.localize)(44,null,y):(0,D.localize)(45,null,y)):(y=Math.floor(g/I),p?y===1?v?(0,D.localize)(46,null,y):(0,D.localize)(47,null,y):v?(0,D.localize)(48,null,y):(0,D.localize)(49,null,y):y===1?v?(0,D.localize)(50,null,y):(0,D.localize)(51,null,y):v?(0,D.localize)(52,null,y):(0,D.localize)(53,null,y))}e.fromNow=E;function b(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ne[125],re([11,12]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,18,15,125]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(C,p){return p&&(C.stack||C.stacktrace)?R.localize(0,null,P(C),T(C.stack)||T(C.stacktrace)):P(C)}function T(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?R.localize(1,null,C.message):C.message||R.localize(2,null)}function I(C=null,p=!1){if(!C)return R.localize(3,null);if(Array.isArray(C)){const v=D.coalesce(C),g=I(v[0],p);return v.length>1?R.localize(4,null,g,v.length):g}if(t.isString(C))return C;if(C.detail){const v=C.detail;if(v.error)return L(v.error,p);if(v.exception)return L(v.exception,p)}return C.stack?L(C,p):C.message?C.message:R.localize(5,null)}e.toErrorMessage=I;function E(C){const p=C;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=E;function b(C,p){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=p,v}e.createErrorWithActions=b}),define(ne[126],re([11,12]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[127],re([0,1,126]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ne[128],re([11,12]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,128]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,R=!1,L=!1,T=!1,P=!1,I=!1,E=!1,b=!1,C=!1,p=!1,v,g=e.LANGUAGE_DEFAULT,y,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const m=typeof d?.versions?.electron=="string",l=m&&d?.type==="renderer";if(typeof navigator=="object"&&!l)w=navigator.userAgent,t=w.indexOf("Windows")>=0,R=w.indexOf("Macintosh")>=0,b=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=w.indexOf("Linux")>=0,p=w?.indexOf("Mobi")>=0,I=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,g=v;else if(typeof d=="object"){t=d.platform==="win32",R=d.platform==="darwin",L=d.platform==="linux",T=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,E=m,C=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const a=d.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),S=h.availableLanguages["*"];v=h.locale,g=S||e.LANGUAGE_DEFAULT,y=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var f;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function u(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let o=0;R?o=1:t?o=3:L&&(o=2),e.isWindows=t,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=T,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=p,e.isCI=C,e.platform=o,e.userAgent=w,e.language=g;var s;(function(a){function h(){return e.language}a.value=h;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=S;function A(){return e.language==="en"}a.isDefault=A})(s=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let A=0,$=a.length;A<$;A++){const _=a[A];if(_.id===S.data.vscodeScheduleAsyncWork){a.splice(A,1),_.callback();return}}});let h=0;return S=>{const A=++h;a.push({id:A,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return a=>setTimeout(a)})();var n;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:t?1:3;let i=!0,r=!1;function c(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[37],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;t={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ne[10],re([0,1,37]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,R=97,L=90,T=122,P=46,I=47,E=92,b=58,C=63;class p extends Error{constructor(f,u,o){let s;typeof u=="string"&&u.indexOf("not ")===0?(s="must not be",u=u.replace(/^not /,"")):s="must be";const n=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${n} ${s} of type ${u}`;i+=`. Received type ${typeof o}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function v(l,f){if(typeof l!="string")throw new p(f,"string",l)}function g(l){return l===I||l===E}function y(l){return l===I}function w(l){return l>=t&&l<=L||l>=R&&l<=T}function d(l,f,u,o){let s="",n=0,i=-1,r=0,c=0;for(let a=0;a<=l.length;++a){if(a<l.length)c=l.charCodeAt(a);else{if(o(c))break;c=I}if(o(c)){if(!(i===a-1||r===1))if(r===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const h=s.lastIndexOf(u);h===-1?(s="",n=0):(s=s.slice(0,h),n=s.length-1-s.lastIndexOf(u)),i=a,r=0;continue}else if(s.length!==0){s="",n=0,i=a,r=0;continue}}f&&(s+=s.length>0?`${u}..`:"..",n=2)}else s.length>0?s+=`${u}${l.slice(i+1,a)}`:s=l.slice(i+1,a),n=a-i-1;i=a,r=0}else c===P&&r!==-1?++r:r=-1}return s}function m(l,f){if(f===null||typeof f!="object")throw new p("pathObject","Object",f);const u=f.dir||f.root,o=f.base||`${f.name||""}${f.ext||""}`;return u?u===f.root?`${u}${o}`:`${u}${l}${o}`:o}e.win32={resolve(...l){let f="",u="",o=!1;for(let s=l.length-1;s>=-1;s--){let n;if(s>=0){if(n=l[s],v(n,"path"),n.length===0)continue}else f.length===0?n=D.cwd():(n=D.env[`=${f}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==f.toLowerCase()&&n.charCodeAt(2)===E)&&(n=`${f}\\`));const i=n.length;let r=0,c="",a=!1;const h=n.charCodeAt(0);if(i===1)g(h)&&(r=1,a=!0);else if(g(h))if(a=!0,g(n.charCodeAt(1))){let S=2,A=S;for(;S<i&&!g(n.charCodeAt(S));)S++;if(S<i&&S!==A){const $=n.slice(A,S);for(A=S;S<i&&g(n.charCodeAt(S));)S++;if(S<i&&S!==A){for(A=S;S<i&&!g(n.charCodeAt(S));)S++;(S===i||S!==A)&&(c=`\\\\${$}\\${n.slice(A,S)}`,r=S)}}}else r=1;else w(h)&&n.charCodeAt(1)===b&&(c=n.slice(0,2),r=2,i>2&&g(n.charCodeAt(2))&&(a=!0,r=3));if(c.length>0)if(f.length>0){if(c.toLowerCase()!==f.toLowerCase())continue}else f=c;if(o){if(f.length>0)break}else if(u=`${n.slice(r)}\\${u}`,o=a,a&&f.length>0)break}return u=d(u,!o,"\\",g),o?`${f}\\${u}`:`${f}${u}`||"."},normalize(l){v(l,"path");const f=l.length;if(f===0)return".";let u=0,o,s=!1;const n=l.charCodeAt(0);if(f===1)return y(n)?"\\":l;if(g(n))if(s=!0,g(l.charCodeAt(1))){let r=2,c=r;for(;r<f&&!g(l.charCodeAt(r));)r++;if(r<f&&r!==c){const a=l.slice(c,r);for(c=r;r<f&&g(l.charCodeAt(r));)r++;if(r<f&&r!==c){for(c=r;r<f&&!g(l.charCodeAt(r));)r++;if(r===f)return`\\\\${a}\\${l.slice(c)}\\`;r!==c&&(o=`\\\\${a}\\${l.slice(c,r)}`,u=r)}}}else u=1;else w(n)&&l.charCodeAt(1)===b&&(o=l.slice(0,2),u=2,f>2&&g(l.charCodeAt(2))&&(s=!0,u=3));let i=u<f?d(l.slice(u),!s,"\\",g):"";return i.length===0&&!s&&(i="."),i.length>0&&g(l.charCodeAt(f-1))&&(i+="\\"),o===void 0?s?`\\${i}`:i:s?`${o}\\${i}`:`${o}${i}`},isAbsolute(l){v(l,"path");const f=l.length;if(f===0)return!1;const u=l.charCodeAt(0);return g(u)||f>2&&w(u)&&l.charCodeAt(1)===b&&g(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let f,u;for(let n=0;n<l.length;++n){const i=l[n];v(i,"path"),i.length>0&&(f===void 0?f=u=i:f+=`\\${i}`)}if(f===void 0)return".";let o=!0,s=0;if(typeof u=="string"&&g(u.charCodeAt(0))){++s;const n=u.length;n>1&&g(u.charCodeAt(1))&&(++s,n>2&&(g(u.charCodeAt(2))?++s:o=!1))}if(o){for(;s<f.length&&g(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(l,f){if(v(l,"from"),v(f,"to"),l===f)return"";const u=e.win32.resolve(l),o=e.win32.resolve(f);if(u===o||(l=u.toLowerCase(),f=o.toLowerCase(),l===f))return"";let s=0;for(;s<l.length&&l.charCodeAt(s)===E;)s++;let n=l.length;for(;n-1>s&&l.charCodeAt(n-1)===E;)n--;const i=n-s;let r=0;for(;r<f.length&&f.charCodeAt(r)===E;)r++;let c=f.length;for(;c-1>r&&f.charCodeAt(c-1)===E;)c--;const a=c-r,h=i<a?i:a;let S=-1,A=0;for(;A<h;A++){const _=l.charCodeAt(s+A);if(_!==f.charCodeAt(r+A))break;_===E&&(S=A)}if(A!==h){if(S===-1)return o}else{if(a>h){if(f.charCodeAt(r+A)===E)return o.slice(r+A+1);if(A===2)return o.slice(r+A)}i>h&&(l.charCodeAt(s+A)===E?S=A:A===2&&(S=3)),S===-1&&(S=0)}let $="";for(A=s+S+1;A<=n;++A)(A===n||l.charCodeAt(A)===E)&&($+=$.length===0?"..":"\\..");return r+=S,$.length>0?`${$}${o.slice(r,c)}`:(o.charCodeAt(r)===E&&++r,o.slice(r,c))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const f=e.win32.resolve(l);if(f.length<=2)return l;if(f.charCodeAt(0)===E){if(f.charCodeAt(1)===E){const u=f.charCodeAt(2);if(u!==C&&u!==P)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(w(f.charCodeAt(0))&&f.charCodeAt(1)===b&&f.charCodeAt(2)===E)return`\\\\?\\${f}`;return l},dirname(l){v(l,"path");const f=l.length;if(f===0)return".";let u=-1,o=0;const s=l.charCodeAt(0);if(f===1)return g(s)?l:".";if(g(s)){if(u=o=1,g(l.charCodeAt(1))){let r=2,c=r;for(;r<f&&!g(l.charCodeAt(r));)r++;if(r<f&&r!==c){for(c=r;r<f&&g(l.charCodeAt(r));)r++;if(r<f&&r!==c){for(c=r;r<f&&!g(l.charCodeAt(r));)r++;if(r===f)return l;r!==c&&(u=o=r+1)}}}}else w(s)&&l.charCodeAt(1)===b&&(u=f>2&&g(l.charCodeAt(2))?3:2,o=u);let n=-1,i=!0;for(let r=f-1;r>=o;--r)if(g(l.charCodeAt(r))){if(!i){n=r;break}}else i=!1;if(n===-1){if(u===-1)return".";n=u}return l.slice(0,n)},basename(l,f){f!==void 0&&v(f,"ext"),v(l,"path");let u=0,o=-1,s=!0,n;if(l.length>=2&&w(l.charCodeAt(0))&&l.charCodeAt(1)===b&&(u=2),f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,r=-1;for(n=l.length-1;n>=u;--n){const c=l.charCodeAt(n);if(g(c)){if(!s){u=n+1;break}}else r===-1&&(s=!1,r=n+1),i>=0&&(c===f.charCodeAt(i)?--i===-1&&(o=n):(i=-1,o=r))}return u===o?o=r:o===-1&&(o=l.length),l.slice(u,o)}for(n=l.length-1;n>=u;--n)if(g(l.charCodeAt(n))){if(!s){u=n+1;break}}else o===-1&&(s=!1,o=n+1);return o===-1?"":l.slice(u,o)},extname(l){v(l,"path");let f=0,u=-1,o=0,s=-1,n=!0,i=0;l.length>=2&&l.charCodeAt(1)===b&&w(l.charCodeAt(0))&&(f=o=2);for(let r=l.length-1;r>=f;--r){const c=l.charCodeAt(r);if(g(c)){if(!n){o=r+1;break}continue}s===-1&&(n=!1,s=r+1),c===P?u===-1?u=r:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||s===-1||i===0||i===1&&u===s-1&&u===o+1?"":l.slice(u,s)},format:m.bind(null,"\\"),parse(l){v(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const u=l.length;let o=0,s=l.charCodeAt(0);if(u===1)return g(s)?(f.root=f.dir=l,f):(f.base=f.name=l,f);if(g(s)){if(o=1,g(l.charCodeAt(1))){let S=2,A=S;for(;S<u&&!g(l.charCodeAt(S));)S++;if(S<u&&S!==A){for(A=S;S<u&&g(l.charCodeAt(S));)S++;if(S<u&&S!==A){for(A=S;S<u&&!g(l.charCodeAt(S));)S++;S===u?o=S:S!==A&&(o=S+1)}}}}else if(w(s)&&l.charCodeAt(1)===b){if(u<=2)return f.root=f.dir=l,f;if(o=2,g(l.charCodeAt(2))){if(u===3)return f.root=f.dir=l,f;o=3}}o>0&&(f.root=l.slice(0,o));let n=-1,i=o,r=-1,c=!0,a=l.length-1,h=0;for(;a>=o;--a){if(s=l.charCodeAt(a),g(s)){if(!c){i=a+1;break}continue}r===-1&&(c=!1,r=a+1),s===P?n===-1?n=a:h!==1&&(h=1):n!==-1&&(h=-1)}return r!==-1&&(n===-1||h===0||h===1&&n===r-1&&n===i+1?f.base=f.name=l.slice(i,r):(f.name=l.slice(i,n),f.base=l.slice(i,r),f.ext=l.slice(n,r))),i>0&&i!==o?f.dir=l.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let f="",u=!1;for(let o=l.length-1;o>=-1&&!u;o--){const s=o>=0?l[o]:D.cwd();v(s,"path"),s.length!==0&&(f=`${s}/${f}`,u=s.charCodeAt(0)===I)}return f=d(f,!u,"/",y),u?`/${f}`:f.length>0?f:"."},normalize(l){if(v(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===I,u=l.charCodeAt(l.length-1)===I;return l=d(l,!f,"/",y),l.length===0?f?"/":u?"./":".":(u&&(l+="/"),f?`/${l}`:l)},isAbsolute(l){return v(l,"path"),l.length>0&&l.charCodeAt(0)===I},join(...l){if(l.length===0)return".";let f;for(let u=0;u<l.length;++u){const o=l[u];v(o,"path"),o.length>0&&(f===void 0?f=o:f+=`/${o}`)}return f===void 0?".":e.posix.normalize(f)},relative(l,f){if(v(l,"from"),v(f,"to"),l===f||(l=e.posix.resolve(l),f=e.posix.resolve(f),l===f))return"";const u=1,o=l.length,s=o-u,n=1,i=f.length-n,r=s<i?s:i;let c=-1,a=0;for(;a<r;a++){const S=l.charCodeAt(u+a);if(S!==f.charCodeAt(n+a))break;S===I&&(c=a)}if(a===r)if(i>r){if(f.charCodeAt(n+a)===I)return f.slice(n+a+1);if(a===0)return f.slice(n+a)}else s>r&&(l.charCodeAt(u+a)===I?c=a:a===0&&(c=0));let h="";for(a=u+c+1;a<=o;++a)(a===o||l.charCodeAt(a)===I)&&(h+=h.length===0?"..":"/..");return`${h}${f.slice(n+c)}`},toNamespacedPath(l){return l},dirname(l){if(v(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===I;let u=-1,o=!0;for(let s=l.length-1;s>=1;--s)if(l.charCodeAt(s)===I){if(!o){u=s;break}}else o=!1;return u===-1?f?"/":".":f&&u===1?"//":l.slice(0,u)},basename(l,f){f!==void 0&&v(f,"ext"),v(l,"path");let u=0,o=-1,s=!0,n;if(f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,r=-1;for(n=l.length-1;n>=0;--n){const c=l.charCodeAt(n);if(c===I){if(!s){u=n+1;break}}else r===-1&&(s=!1,r=n+1),i>=0&&(c===f.charCodeAt(i)?--i===-1&&(o=n):(i=-1,o=r))}return u===o?o=r:o===-1&&(o=l.length),l.slice(u,o)}for(n=l.length-1;n>=0;--n)if(l.charCodeAt(n)===I){if(!s){u=n+1;break}}else o===-1&&(s=!1,o=n+1);return o===-1?"":l.slice(u,o)},extname(l){v(l,"path");let f=-1,u=0,o=-1,s=!0,n=0;for(let i=l.length-1;i>=0;--i){const r=l.charCodeAt(i);if(r===I){if(!s){u=i+1;break}continue}o===-1&&(s=!1,o=i+1),r===P?f===-1?f=i:n!==1&&(n=1):f!==-1&&(n=-1)}return f===-1||o===-1||n===0||n===1&&f===o-1&&f===u+1?"":l.slice(f,o)},format:m.bind(null,"/"),parse(l){v(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const u=l.charCodeAt(0)===I;let o;u?(f.root="/",o=1):o=0;let s=-1,n=0,i=-1,r=!0,c=l.length-1,a=0;for(;c>=o;--c){const h=l.charCodeAt(c);if(h===I){if(!r){n=c+1;break}continue}i===-1&&(r=!1,i=c+1),h===P?s===-1?s=c:a!==1&&(a=1):s!==-1&&(a=-1)}if(i!==-1){const h=n===0&&u?1:n;s===-1||a===0||a===1&&s===i-1&&s===n+1?f.base=f.name=l.slice(h,i):(f.name=l.slice(h,s),f.base=l.slice(h,i),f.ext=l.slice(s,i))}return n>0?f.dir=l.slice(0,n-1):u&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[129],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(b){const C=(0,D.extname)(b),p=t[C.toLowerCase()];return p!==void 0?p:T(b)}e.getMediaOrTextMime=L;function T(b){const C=(0,D.extname)(b);return R[C.toLowerCase()]}e.getMediaMime=T;function P(b){for(const C in R)if(R[C]===b)return C}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function E(b,C){const p=I.exec(b);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:C?void 0:b}e.normalizeMimeType=E}),define(ne[83],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...I){const E=I.reduce((p,v)=>(p[v]=!0,p),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!E[p]).forEach(p=>{for(let v=0;v<b.length;v++)if(p.search(b[v])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=L;function T(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[130],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(T=!0){return new R(T)}constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ne[3],re([0,1,9,79,2,81,130]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var E;(function(c){c.None=()=>R.Disposable.None;function a(M){if(I){const{onListenerDidAdd:x}=M,V=g.create();let ee=0;M.onListenerDidAdd=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),x?.()}}}function h(M){return(x,V=null,ee)=>{let oe=!1,Z;return Z=M(ie=>{if(!oe)return Z?Z.dispose():oe=!0,x.call(V,ie)},null,ee),oe&&Z.dispose(),Z}}c.once=h;function S(M,x,V){return N((ee,oe=null,Z)=>M(ie=>ee.call(oe,x(ie)),null,Z),V)}c.map=S;function A(M,x,V){return N((ee,oe=null,Z)=>M(ie=>{x(ie),ee.call(oe,ie)},null,Z),V)}c.forEach=A;function $(M,x,V){return N((ee,oe=null,Z)=>M(ie=>x(ie)&&ee.call(oe,ie),null,Z),V)}c.filter=$;function _(M){return M}c.signal=_;function U(...M){return(x,V=null,ee)=>(0,R.combinedDisposable)(...M.map(oe=>oe(Z=>x.call(V,Z),null,ee)))}c.any=U;function k(M,x,V,ee){let oe=V;return S(M,Z=>(oe=x(oe,Z),oe),ee)}c.reduce=k;function N(M,x){let V;const ee={onFirstListenerAdd(){V=M(oe.fire,oe)},onLastListenerRemove(){V?.dispose()}};x||a(ee);const oe=new w(ee);return x?.add(oe),oe.event}function F(M,x,V=100,ee=!1,oe,Z){let ie,se,ue,de=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=M(Ee=>{de++,se=x(se,Ee),ee&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Ce=se;se=void 0,ue=void 0,(!ee||de>1)&&we.fire(Ce),de=0},V)})},onLastListenerRemove(){ie.dispose()}};Z||a(ve);const we=new w(ve);return Z?.add(we),we.event}c.debounce=F;function q(M,x=(ee,oe)=>ee===oe,V){let ee=!0,oe;return $(M,Z=>{const ie=ee||!x(Z,oe);return ee=!1,oe=Z,ie},V)}c.latch=q;function J(M,x,V){return[c.filter(M,x,V),c.filter(M,ee=>!x(ee),V)]}c.split=J;function j(M,x=!1,V=[]){let ee=V.slice(),oe=M(se=>{ee?ee.push(se):ie.fire(se)});const Z=()=>{ee?.forEach(se=>ie.fire(se)),ee=null},ie=new w({onFirstListenerAdd(){oe||(oe=M(se=>ie.fire(se)))},onFirstListenerDidAdd(){ee&&(x?setTimeout(Z):Z())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}c.buffer=j;class H{constructor(x){this.event=x,this.disposables=new R.DisposableStore}map(x){return new H(S(this.event,x,this.disposables))}forEach(x){return new H(A(this.event,x,this.disposables))}filter(x){return new H($(this.event,x,this.disposables))}reduce(x,V){return new H(k(this.event,x,V,this.disposables))}latch(){return new H(q(this.event,void 0,this.disposables))}debounce(x,V=100,ee=!1,oe){return new H(F(this.event,x,V,ee,oe,this.disposables))}on(x,V,ee){return this.event(x,V,ee)}once(x,V,ee){return h(this.event)(x,V,ee)}dispose(){this.disposables.dispose()}}function W(M){return new H(M)}c.chain=W;function z(M,x,V=ee=>ee){const ee=(...se)=>ie.fire(V(...se)),oe=()=>M.on(x,ee),Z=()=>M.removeListener(x,ee),ie=new w({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}c.fromNodeEventEmitter=z;function K(M,x,V=ee=>ee){const ee=(...se)=>ie.fire(V(...se)),oe=()=>M.addEventListener(x,ee),Z=()=>M.removeEventListener(x,ee),ie=new w({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}c.fromDOMEventEmitter=K;function X(M){return new Promise(x=>h(M)(x))}c.toPromise=X;function ce(M,x){return x(void 0),M(V=>x(V))}c.runAndSubscribe=ce;function B(M,x){let V=null;function ee(Z){V?.dispose(),V=new R.DisposableStore,x(Z,V)}ee(void 0);const oe=M(Z=>ee(Z));return(0,R.toDisposable)(()=>{oe.dispose(),V?.dispose()})}c.runAndSubscribeWithStore=B;class G{constructor(x,V){this.obs=x,this._counter=0,this._hasChanged=!1;const ee={onFirstListenerAdd:()=>{x.addObserver(this)},onLastListenerRemove:()=>{x.removeObserver(this)}};V||a(ee),this.emitter=new w(ee),V&&V.add(this.emitter)}beginUpdate(x){this._counter++}handleChange(x,V){this._hasChanged=!0}endUpdate(x){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function O(M,x){return new G(M,x).emitter.event}c.fromObservable=O})(E=e.Event||(e.Event={}));class b{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${b._idPool++}`,b.all.add(this)}start(a){this._stopWatch=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=b,b.all=new Set,b._idPool=0;let C=-1;function p(c){const a=C;return C=c,{dispose(){C=a}}}e.setGlobalLeakWarningThreshold=p;class v{constructor(a,h=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,h){let S=C;if(typeof this.customThreshold=="number"&&(S=this.customThreshold),S<=0||h<S)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=S*.5;let $,_=0;for(const[U,k]of this._stacks)(!$||_<k)&&($=U,_=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${_}):`),console.warn($)}return()=>{const $=this._stacks.get(a.value)||0;this._stacks.set(a.value,$-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(a,h,S){this.callback=a,this.callbackThis=h,this.stack=S,this.subscription=new R.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class w{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=C>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const h of a)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,h,S)=>{this._listeners||(this._listeners=new L.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let $,_;this._leakageMon&&this._listeners.size>=30&&(_=g.create(),$=this._leakageMon.check(_,this._listeners.size+1)),P&&(_=_??g.create());const U=new y(a,h,_),k=this._listeners.push(U);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,h);const N=U.subscription.set(()=>{$?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof R.DisposableStore?S.add(N):Array.isArray(S)&&S.push(N),N}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const h of this._listeners)this._deliveryQueue.push(this,h,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class d{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(a,h,S){this._queue.push(new l(a,h,S))}clear(a){const h=new L.LinkedList;for(const S of this._queue)S.emitter!==a&&h.push(S);this._queue=h}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(h){(0,D.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=d;class m extends d{clear(a){this._queue.clear()}}class l{constructor(a,h,S){this.emitter=a,this.listener=h,this.event=S}}class f extends w{async fireAsync(a,h,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,a]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[A,$]=this._asyncDeliveryQueue.shift(),_=[],U={...$,token:h,waitUntil:k=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");S&&(k=S(k,A.callback)),_.push(k)}};try{A.invoke(U)}catch(k){(0,D.onUnexpectedError)(k);continue}Object.freeze(_),await Promise.allSettled(_).then(k=>{for(const N of k)N.status==="rejected"&&(0,D.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=f;class u extends w{constructor(a){super(a),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class o extends u{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=o;class s extends w{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const h={event:a,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const S=()=>{this.hasListeners&&this.unhook(h);const A=this.events.indexOf(h);this.events.splice(A,1)};return(0,R.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(h=>this.emitter.fire(h))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(a){return(h,S,A)=>a($=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>h.call(S,$)):h.call(S,$)},void 0,A)}bufferEvents(a){const h=[];this.buffers.push(h);const S=a();return this.buffers.pop(),h.forEach(A=>A()),S}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=R.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(ne[23],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,I){const E=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function I(E){return E===P.None||E===P.Cancelled||E instanceof L?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=T}),define(ne[131],re([0,1,23]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,I=this.task(P.token);return this.result={promise:I,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=t;class R{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const I=JSON.stringify(P);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=R;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const I=this.fn(P);return this._map.set(P,I),I}}e.CachedFunction=L}),define(ne[84],re([0,1,3,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=T=>({onDidChange:D.Event.None,value:T});e.staticObservableValue=R;class L extends t.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(ne[27],re([0,1,131,118]),function(Q,e,D,t){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=L;const T=/{(\d+)}/g;function P(te,...le){return le.length===0?te:te.replace(T,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?he:le[Se]})}e.format=P;const I=/{([^}]+)}/g;function E(te,le){return te.replace(I,(he,me)=>le[me]??he)}e.format2=E;function b(te){return te.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function C(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function p(te,le){let he=0;const me=le.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===me&&he++;return he}e.count=p;function v(te,le,he="\u2026"){return te.length<=le?te:`${te.substr(0,le)}${he}`}e.truncate=v;function g(te,le=" "){const he=y(te,le);return w(he,le)}e.trim=g;function y(te,le){if(!te||!le)return te;const he=le.length;if(he===0||te.length===0)return te;let me=0;for(;te.indexOf(le,me)===me;)me=me+he;return te.substring(me)}e.ltrim=y;function w(te,le){if(!te||!le)return te;const he=le.length,me=te.length;if(he===0||me===0)return te;let Se=me,Pe=-1;for(;Pe=te.lastIndexOf(le,Se-1),!(Pe===-1||Pe+he!==Se);){if(Pe===0)return"";Se=Pe}return te.substring(0,Se)}e.rtrim=w;function d(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function m(te){return te.replace(/\*/g,"")}e.stripWildcards=m;function l(te,le,he={}){if(!te)throw new Error("Cannot create regex from empty string");le||(te=C(te)),he.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=l;function f(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function u(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function o(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=o;function s(te){return te.split(/\r\n|\r|\n/)}e.splitLines=s;function n(te){for(let le=0,he=te.length;le<he;le++){const me=te.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=n;function i(te,le=0,he=te.length){for(let me=le;me<he;me++){const Se=te.charCodeAt(me);if(Se!==32&&Se!==9)return te.substring(le,me)}return te.substring(le,he)}e.getLeadingWhitespace=i;function r(te,le=te.length-1){for(let he=le;he>=0;he--){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=r;function c(te,le,he){const me=[];let Se=0;for(const Pe of te.matchAll(le)){if(me.push(te.slice(Se,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Se=Pe.index+Pe[0].length,me.push(he(Pe[0],...Pe.slice(1),Pe.index,te,Pe.groups))}return me.push(te.slice(Se)),Promise.all(me).then(Pe=>Pe.join(""))}e.replaceAsync=c;function a(te,le){return te<le?-1:te>le?1:0}e.compare=a;function h(te,le,he=0,me=te.length,Se=0,Pe=le.length){for(;he<me&&Se<Pe;he++,Se++){const Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe<Te)return-1;if(Fe>Te)return 1}const De=me-he,Be=Pe-Se;return De<Be?-1:De>Be?1:0}e.compareSubstring=h;function S(te,le){return A(te,le,0,te.length,0,le.length)}e.compareIgnoreCase=S;function A(te,le,he=0,me=te.length,Se=0,Pe=le.length){for(;he<me&&Se<Pe;he++,Se++){let Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe===Te)continue;if(Fe>=128||Te>=128)return h(te.toLowerCase(),le.toLowerCase(),he,me,Se,Pe);_(Fe)&&(Fe-=32),_(Te)&&(Te-=32);const qe=Fe-Te;if(qe!==0)return qe}const De=me-he,Be=Pe-Se;return De<Be?-1:De>Be?1:0}e.compareSubstringIgnoreCase=A;function $(te){return te>=48&&te<=57}e.isAsciiDigit=$;function _(te){return te>=97&&te<=122}e.isLowerAsciiLetter=_;function U(te){return te>=65&&te<=90}e.isUpperAsciiLetter=U;function k(te,le){return te.length===le.length&&A(te,le)===0}e.equalsIgnoreCase=k;function N(te,le){const he=le.length;return le.length>te.length?!1:A(te,le,0,he)===0}e.startsWithIgnoreCase=N;function F(te,le){const he=Math.min(te.length,le.length);let me;for(me=0;me<he;me++)if(te.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=F;function q(te,le){const he=Math.min(te.length,le.length);let me;const Se=te.length-1,Pe=le.length-1;for(me=0;me<he;me++)if(te.charCodeAt(Se-me)!==le.charCodeAt(Pe-me))return me;return he}e.commonSuffixLength=q;function J(te){return 55296<=te&&te<=56319}e.isHighSurrogate=J;function j(te){return 56320<=te&&te<=57343}e.isLowSurrogate=j;function H(te,le){return(te-55296<<10)+(le-56320)+65536}e.computeCodePoint=H;function W(te,le,he){const me=te.charCodeAt(he);if(J(me)&&he+1<le){const Se=te.charCodeAt(he+1);if(j(Se))return H(me,Se)}return me}e.getNextCodePoint=W;function z(te,le){const he=te.charCodeAt(le-1);if(j(he)&&le>1){const me=te.charCodeAt(le-2);if(J(me))return H(me,he)}return he}class K{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=z(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=W(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=K;class X{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new K(le,he)}nextGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Pe=he.offset,De=le.getGraphemeBreakType(he.nextCodePoint());if(be(Se,De)){he.setOffset(Pe);break}Se=De}return he.offset-me}prevGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Pe=he.offset,De=le.getGraphemeBreakType(he.prevCodePoint());if(be(De,Se)){he.setOffset(Pe);break}Se=De}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function ce(te,le){return new X(te,le).nextGraphemeLength()}e.nextCharLength=ce;function B(te,le){return new X(te,le).prevGraphemeLength()}e.prevCharLength=B;function G(te,le){le>0&&j(te.charCodeAt(le))&&le--;const he=le+ce(te,le);return[he-B(te,he),he]}e.getCharContainingOffset=G;function O(te){const le=new X(te);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=O;let M;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(te){return M||(M=x()),M.test(te)}e.containsRTL=V;const ee=/^[\t\n\r\x20-\x7E]*$/;function oe(te){return ee.test(te)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=Z;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function se(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=se;function ue(te,le){if(te.length<le)return te;const he=/\b/g;let me=0;for(;he.test(te)&&!(te.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=ue;const de=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(te){return te&&(te=te.replace(de,""),te=te.replace(ve,""),te=te.replace(we,"")),te}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ue(te){return Ce(te)?te.substr(1):te}e.stripUTF8BOM=Ue;function $e(te,le){if(!te||!le||te.length<le.length)return!1;const he=le.length,me=te.toLowerCase();let Se=0,Pe=-1;for(;Se<he;){const De=me.indexOf(le[Se],Pe+1);if(De<0)return!1;Pe=De,Se++}return!0}e.fuzzyContains=$e;function He(te,le=!1){return te?(le&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=He;function We(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=We;function ae(te,le=1){if(le===0)return"";let he=-1;do he=te.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?te:(te[he-1]==="\r"&&he--,te.substr(0,he))}e.getNLines=ae;function fe(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=fe;function ge(te){return Le.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function be(te,le){return te===0?le!==5&&le!==7:te===2&&le===3?!1:te===4||te===2||te===3||le===4||le===2||le===3?!0:!(te===8&&(le===8||le===9||le===11||le===12)||(te===11||te===9)&&(le===9||le===10)||(te===12||te===10)&&le===10||le===5||le===13||le===7||te===1||te===13&&le===14||te===6&&le===6)}var Ie;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let Se=1;for(;Se<=me;)if(le<he[3*Se])Se=2*Se;else if(le>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}Le._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(te,le){if(te===0)return 0;const he=Ae(te,le);if(he!==void 0)return he;const me=new K(le,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ne;function Ae(te,le){const he=new K(le,te);let me=he.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!se(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function Me(te){return 127995<=te&&te<=127999}var ze;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(le){return ke.cache.get(Array.from(le))}static getLocales(){return ke._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(te=>{function le(Te){const qe=new Map;for(let xe=0;xe<Te.length;xe+=2)qe.set(Te[xe],Te[xe+1]);return qe}function he(Te,qe){const xe=new Map(Te);for(const[Ze,st]of qe)xe.set(Ze,st);return xe}function me(Te,qe){if(!Te)return qe;const xe=new Map;for(const[Ze,st]of Te)qe.has(Ze)&&xe.set(Ze,st);return xe}const Se=R.ambiguousCharacterData.getValue();let Pe=te.filter(Te=>!Te.startsWith("_")&&Te in Se);Pe.length===0&&(Pe=["_default"]);let De;for(const Te of Pe){const qe=le(Se[Te]);De=me(De,qe)}const Be=le(Se._common),Fe=he(Be,De);return new ke(Fe)}),ke._locales=new t.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(le){return _e.getData().has(le)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[47],re([0,1,10,4,27,15]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function P(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function I(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function E(r,c=D.posix.sep){if(!r)return"";const a=r.length,h=r.charCodeAt(0);if(T(h)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let A=3;const $=A;for(;A<a&&!T(r.charCodeAt(A));A++);if($!==A&&!T(r.charCodeAt(A+1))){for(A+=1;A<a;A++)if(T(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,c)}}return c}else if(d(h)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<a;S++)if(T(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=E;function b(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let a=2;const h=a;for(;a<r.length&&(c=r.charCodeAt(a),c!==92);a++);return!(h===a||(c=r.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=b;const C=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,c=t.isWindows){const a=c?C:p;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||c&&v.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function y(r,c,a){const h=r===c;return!a||h?h:!r||!c?!1:(0,R.equalsIgnoreCase)(r,c)}e.isEqual=y;function w(r,c,a,h=D.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let A=c.length;return c.charAt(c.length-1)===h&&A--,r.charAt(A)===h}return c.charAt(c.length-1)!==h&&(c+=h),r.indexOf(c)===0}e.isEqualOrParent=w;function d(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=d;function m(r,c){return t.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(c,r)),r=(0,D.normalize)(r),t.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=m;function l(r){const c=(0,D.normalize)(r);return t.isWindows?r.length>3?!1:f(c)&&(r.length===2||c.charCodeAt(2)===92):c===D.posix.sep}e.isRootOrDriveLetter=l;function f(r,c=t.isWindows){return c?d(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(r){return f(r)?r[0]:void 0}e.getDriveLetter=u;function o(r,c,a){return c.length>r.length?-1:r===c?0:(a&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=o;function s(r){const c=r.split(":");let a,h,S;for(const A of c){const $=Number(A);(0,L.isNumber)($)?h===void 0?h=$:S===void 0&&(S=$):a=a?[a,A].join(":"):A}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:S!==void 0?S:h!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,c,a=8){let h="";for(let A=0;A<a;A++)h+=n.charAt(Math.floor(Math.random()*n.length));let S;return c?S=`${c}-${h}`:S=h,r?(0,D.join)(r,S):S}e.randomPath=i}),define(ne[65],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return R(d,0)}e.hash=t;function R(d,m){switch(typeof d){case"object":return d===null?L(349,m):Array.isArray(d)?I(d,m):E(d,m);case"string":return P(d,m);case"boolean":return T(d,m);case"number":return L(d,m);case"undefined":return L(937,m);default:return L(617,m)}}e.doHash=R;function L(d,m){return(m<<5)-m+d|0}e.numberHash=L;function T(d,m){return L(d?433:863,m)}function P(d,m){m=L(149417,m);for(let l=0,f=d.length;l<f;l++)m=L(d.charCodeAt(l),m);return m}e.stringHash=P;function I(d,m){return m=L(104579,m),d.reduce((l,f)=>R(f,l),m)}function E(d,m){return m=L(181387,m),Object.keys(d).sort().reduce((l,f)=>(l=P(f,l),R(d[f],l)),m)}class b{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=R(m,this._value),this._value}}e.Hasher=b;var C;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function p(d,m,l=32){const f=l-m,u=~((1<<f)-1);return(d<<m|(u&d)>>>f)>>>0}function v(d,m=0,l=d.byteLength,f=0){for(let u=0;u<l;u++)d[m+u]=f}function g(d,m,l="0"){for(;d.length<m;)d=l+d;return d}function y(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(l=>l.toString(16).padStart(2,"0")).join(""):g((d>>>0).toString(16),m/4)}e.toHexString=y;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const l=m.length;if(l===0)return;const f=this._buff;let u=this._buffLen,o=this._leftoverHighSurrogate,s,n;for(o!==0?(s=o,n=-1,o=0):(s=m.charCodeAt(0),n=0);;){let i=s;if(D.isHighSurrogate(s))if(n+1<l){const r=m.charCodeAt(n+1);D.isLowSurrogate(r)?(n++,i=D.computeCodePoint(s,r)):i=65533}else{o=s;break}else D.isLowSurrogate(s)&&(i=65533);if(u=this._push(f,u,i),n++,n<l)s=m.charCodeAt(n);else break}this._buffLen=u,this._leftoverHighSurrogate=o}_push(m,l,f){return f<128?m[l++]=f:f<2048?(m[l++]=192|(f&1984)>>>6,m[l++]=128|(f&63)>>>0):f<65536?(m[l++]=224|(f&61440)>>>12,m[l++]=128|(f&4032)>>>6,m[l++]=128|(f&63)>>>0):(m[l++]=240|(f&1835008)>>>18,m[l++]=128|(f&258048)>>>12,m[l++]=128|(f&4032)>>>6,m[l++]=128|(f&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=w._bigBlock32,l=this._buffDV;for(let a=0;a<64;a+=4)m.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)m.setUint32(a,p(m.getUint32(a-12,!1)^m.getUint32(a-32,!1)^m.getUint32(a-56,!1)^m.getUint32(a-64,!1),1),!1);let f=this._h0,u=this._h1,o=this._h2,s=this._h3,n=this._h4,i,r,c;for(let a=0;a<80;a++)a<20?(i=u&o|~u&s,r=1518500249):a<40?(i=u^o^s,r=1859775393):a<60?(i=u&o|u&s|o&s,r=2400959708):(i=u^o^s,r=3395469782),c=p(f,5)+i+n+r+m.getUint32(a*4,!1)&4294967295,n=s,s=o,o=p(u,30),u=f,f=c;this._h0=this._h0+f&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,18,27]),function(Q,e,D,t){"use strict";var R,L,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,i,r){let c=n.get(i);return c===void 0&&(c=r,n.set(i,c)),c}e.getOrSet=P;function I(n){const i=[];return n.forEach((r,c)=>{i.push(`${c} => ${r}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=I;function E(n){const i=[];return n.forEach(r=>{i.push(r)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=E;class b{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}e.StringIterator=b;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class p{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const c=this._value.charCodeAt(r);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var v;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(v||(v={}));class g{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(w||(w={}));class d{static forUris(i=()=>!1,r=()=>!1){return new d(new g(i,r))}static forPaths(i=!1){return new d(new p(void 0,!i))}static forStrings(){return new d(new b)}static forConfigKeys(){return new d(new C)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,r){if(r){const c=r.slice(0);(0,D.shuffle)(c);for(const a of c)this.set(a,i)}else{const c=i.slice(0);(0,D.shuffle)(c);for(const a of c)this.set(a[0],a[1])}}set(i,r){const c=this._iter.reset(i);let a;this._root||(this._root=new y,this._root.segment=c.value());const h=[];for(a=this._root;;){const A=c.cmp(a.segment);if(A>0)a.left||(a.left=new y,a.left.segment=c.value()),h.push([-1,a]),a=a.left;else if(A<0)a.right||(a.right=new y,a.right.segment=c.value()),h.push([1,a]),a=a.right;else if(c.hasNext())c.next(),a.mid||(a.mid=new y,a.mid.segment=c.value()),h.push([0,a]),a=a.mid;else break}const S=a.value;a.value=r,a.key=i;for(let A=h.length-1;A>=0;A--){const $=h[A][1];$.updateHeight();const _=$.balanceFactor();if(_<-1||_>1){const U=h[A][0],k=h[A+1][0];if(U===1&&k===1)h[A][1]=$.rotateLeft();else if(U===-1&&k===-1)h[A][1]=$.rotateRight();else if(U===1&&k===-1)$.right=h[A+1][1]=h[A+1][1].rotateRight(),h[A][1]=$.rotateLeft();else if(U===-1&&k===1)$.left=h[A+1][1]=h[A+1][1].rotateLeft(),h[A][1]=$.rotateRight();else throw new Error;if(A>0)switch(h[A-1][0]){case-1:h[A-1][1].left=h[A][1];break;case 1:h[A-1][1].right=h[A][1];break;case 0:h[A-1][1].mid=h[A][1];break}else this._root=h[0][1]}}return S}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const a=r.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const c=this._iter.reset(i),a=[];let h=this._root;for(;h;){const S=c.cmp(h.segment);if(S>0)a.push([-1,h]),h=h.left;else if(S<0)a.push([1,h]),h=h.right;else if(c.hasNext())c.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const S=this._min(h.right);if(S.key){const{key:A,value:$,segment:_}=S;this._delete(S.key,!1),h.key=A,h.value=$,h.segment=_}}else{const S=h.left??h.right;if(a.length>0){const[A,$]=a[a.length-1];switch(A){case-1:$.left=S;break;case 0:$.mid=S;break;case 1:$.right=S;break}}else this._root=S}for(let S=a.length-1;S>=0;S--){const A=a[S][1];A.updateHeight();const $=A.balanceFactor();if($>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),a[S][1]=A.rotateLeft()):$<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),a[S][1]=A.rotateRight()),S>0)switch(a[S-1][0]){case-1:a[S-1][1].left=a[S][1];break;case 1:a[S-1][1].right=a[S][1];break;case 0:a[S-1][1].mid=a[S][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let c=this._root,a;for(;c;){const h=r.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(r.hasNext())r.next(),a=c.value||a,c=c.mid;else break}return c&&c.value||a}findSuperstr(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const a=r.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[r,c]of this)i(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const c=r.balanceFactor();return c<-1||c>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=d;class m{constructor(i,r){this.uri=i,this.value=r}}class l{constructor(i,r){this[R]="ResourceMap",i instanceof l?(this.map=new Map(i.map),this.toKey=r??l.defaultToKey):(this.map=new Map,this.toKey=i??l.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new m(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[c,a]of this.map)i(a.value,a.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=l,l.defaultToKey=n=>n.toString();class f{constructor(i,r){this[L]="ResourceSet",!i||typeof i=="function"?this._map=new l(i):(this._map=new l(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((c,a)=>i.call(r,a,a,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var u;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class o{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const c=this._map.get(i);if(!!c)return r!==0&&this.touch(c,r),c.value}set(i,r,c=0){let a=this._map.get(i);if(a)a.value=r,c!==0&&this.touch(a,c);else{switch(a={key:i,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const c=this._state;let a=this._head;for(;a;){if(r?i.bind(r)(a.value,a.key,this):i(a.value,a.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,r=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.key,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return a}values(){const i=this,r=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:c.value,done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return a}entries(){const i=this,r=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const h={value:[c.key,c.value],done:!1};return c=c.next,h}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>i;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,c=i.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const c=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(c.previous=a,a.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const c=i.next,a=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=a,a.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,c)=>{i.push([c,r])}),i}fromJSON(i){this.clear();for(const[r,c]of i)this.set(r,c)}}e.LinkedMap=o;class s extends o{constructor(i,r=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s}),define(ne[85],re([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new D.LRUCache(1e4);function R(E){return I(E,"NFC",t)}e.normalizeNFC=R;const L=new D.LRUCache(1e4);function T(E){return I(E,"NFD",L)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function I(E,b,C){if(!E)return E;const p=C.get(E);if(p)return p;let v;return P.test(E)?v=E.normalize(b):v=E,C.set(E,v),v}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(b){return T(b).replace(E,"")}}()}),define(ne[86],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(t||(t={})),function(R){const L="error",T="warning",P="warn",I="info",E="ignore";function b(p){return p?D.equalsIgnoreCase(L,p)?R.Error:D.equalsIgnoreCase(T,p)||D.equalsIgnoreCase(P,p)?R.Warning:D.equalsIgnoreCase(I,p)?R.Info:R.Ignore:R.Ignore}R.fromValue=b;function C(p){switch(p){case R.Error:return L;case R.Warning:return T;case R.Info:return I;default:return E}}R.toString=C}(t||(t={})),e.default=t}),define(ne[7],re([0,1,10,4]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,T=/^\/\//;function P(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(n,i){return!n&&!i?"file":n}function E(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const b="",C="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(i){return i instanceof v?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,c,a,h,S=!1){typeof i=="object"?(this.scheme=i.scheme||b,this.authority=i.authority||b,this.path=i.path||b,this.query=i.query||b,this.fragment=i.fragment||b):(this.scheme=I(i,S),this.authority=r||b,this.path=E(this.scheme,c||b),this.query=a||b,this.fragment=h||b,P(this,S))}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:c,path:a,query:h,fragment:S}=i;return r===void 0?r=this.scheme:r===null&&(r=b),c===void 0?c=this.authority:c===null&&(c=b),a===void 0?a=this.path:a===null&&(a=b),h===void 0?h=this.query:h===null&&(h=b),S===void 0?S=this.fragment:S===null&&(S=b),r===this.scheme&&c===this.authority&&a===this.path&&h===this.query&&S===this.fragment?this:new y(r,c,a,h,S)}static parse(i,r=!1){const c=p.exec(i);return c?new y(c[2]||b,s(c[4]||b),s(c[5]||b),s(c[7]||b),s(c[9]||b),r):new y(b,b,b,b,b)}static file(i){let r=b;if(t.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(r=i.substring(2),i=C):(r=i.substring(2,c),i=i.substring(c)||C)}return new y("file",r,i,b,b)}static from(i){const r=new y(i.scheme,i.authority,i.path,i.query,i.fragment);return P(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&i.scheme==="file"?c=v.file(D.win32.join(l(i,!0),...r)).path:c=D.posix.join(i.path,...r),i.with({path:c})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof v)return i;{const r=new y(i);return r._formatted=i.external,r._fsPath=i._sep===g?i.fsPath:null,r}}else return i}}e.URI=v;const g=t.isWindows?1:void 0;class y extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=g),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(n,i){let r,c=-1;for(let a=0;a<n.length;a++){const h=n.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)c!==-1&&(r+=encodeURIComponent(n.substring(c,a)),c=-1),r!==void 0&&(r+=n.charAt(a));else{r===void 0&&(r=n.substr(0,a));const S=w[h];S!==void 0?(c!==-1&&(r+=encodeURIComponent(n.substring(c,a)),c=-1),r+=S):c===-1&&(c=a)}}return c!==-1&&(r+=encodeURIComponent(n.substring(c))),r!==void 0?r:n}function m(n){let i;for(let r=0;r<n.length;r++){const c=n.charCodeAt(r);c===35||c===63?(i===void 0&&(i=n.substr(0,r)),i+=w[c]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function l(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=l;function f(n,i){const r=i?m:d;let c="",{scheme:a,authority:h,path:S,query:A,fragment:$}=n;if(a&&(c+=a,c+=":"),(h||a==="file")&&(c+=C,c+=C),h){let _=h.indexOf("@");if(_!==-1){const U=h.substr(0,_);h=h.substr(_+1),_=U.indexOf(":"),_===-1?c+=r(U,!1):(c+=r(U.substr(0,_),!1),c+=":",c+=r(U.substr(_+1),!1)),c+="@"}h=h.toLowerCase(),_=h.indexOf(":"),_===-1?c+=r(h,!1):(c+=r(h.substr(0,_),!1),c+=h.substr(_))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const _=S.charCodeAt(1);_>=65&&_<=90&&(S=`/${String.fromCharCode(_+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const _=S.charCodeAt(0);_>=65&&_<=90&&(S=`${String.fromCharCode(_+32)}:${S.substr(2)}`)}c+=r(S,!0)}return A&&(c+="?",c+=r(A,!1)),$&&(c+="#",c+=i?$:d($,!1)),c}function u(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+u(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(o)?n.replace(o,i=>u(i)):n}}),define(ne[132],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(E){const b=E;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=t;function R(E){const b=[];let C;try{const p=JSON.parse(E.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),C=v.__$stack),b.push(...p)}catch{b.push("Unable to log remote console arguments",E.arguments)}return{args:b,stack:C}}e.parse=R;function L(E){if(typeof E!="string")return L(R(E).stack);const b=E;if(b){const C=T(b),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function T(E){if(!E)return E;const b=E.indexOf(`
`);return b===-1?E:E.substring(0,b)}function P(E,b){const{args:C,stack:p}=R(E),v=typeof C[0]=="string"&&C.length===1;let g=T(p);g&&(g=`(${g.trim()})`);let y=[];if(typeof C[0]=="string"?g&&v?y=[`%c[${b}] %c${C[0]} %c${g}`,I("blue"),I(""),I("grey")]:y=[`%c[${b}] %c${C[0]}`,I("blue"),I(""),...C.slice(1)]:y=[`%c[${b}]%`,I("blue"),...C],g&&!v&&y.push(g),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,y)}e.log=P;function I(E){return`color: ${E}`}}),define(ne[66],re([0,1,16,27,7]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(E){return JSON.stringify(E,P)}e.stringify=L;function T(E){let b=JSON.parse(E);return b=I(b),b}e.parse=T;function P(E,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function I(E,b=0){if(!E||b>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 15:return new Date(E.source)}if(E instanceof D.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let C=0;C<E.length;++C)E[C]=I(E[C],b+1);else for(const C in E)Object.hasOwnProperty.call(E,C)&&(E[C]=I(E[C],b+1))}return E}e.revive=I}),define(ne[24],re([0,1,4,7]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${R.vscodeRemoteResource}`}set(E,b,C){this._hosts[E]=b,this._ports[E]=C}setConnectionToken(E,b){this._connectionTokens[E]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const b=E.authority;let C=this._hosts[b];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const p=this._ports[b],v=this._connectionTokens[b];let g=`path=${encodeURIComponent(E.path)}`;return typeof v=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),t.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${C}:${p}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new L;class T{asBrowserUri(E,b){const C=this.toUri(E,b);return C.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?C.with({scheme:R.vscodeFileResource,authority:C.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(E,b){const C=this.toUri(E,b);return C.scheme===R.vscodeFileResource?C.with({scheme:R.file,authority:C.authority!==T.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(E,b){return t.URI.isUri(E)?E:t.URI.parse(b.toUrl(E))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var P;(function(I){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(E.get("3"));const b="vscode-coi";function C(v){let g;typeof v=="string"?g=new URL(v).searchParams:v instanceof URL?g=v.searchParams:t.URI.isUri(v)&&(g=new URL(v.toString(!0)).searchParams);const y=g?.get(b);if(!!y)return E.get(y)}I.getHeadersFromQuery=C;function p(v,g,y){if(!globalThis.crossOriginIsolated)return;const w=g&&y?"3":y?"2":"1";v instanceof URLSearchParams?v.set(b,w):v[b]=w}I.addSearchParam=p})(P=e.COI||(e.COI={}))}),define(ne[19],re([0,1,47,24,10,4,27,7]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=I;class E{constructor(g){this._ignorePathCasing=g}compare(g,y,w=!1){return g===y?0:(0,T.compare)(this.getComparisonKey(g,w),this.getComparisonKey(y,w))}isEqual(g,y,w=!1){return g===y?!0:!g||!y?!1:this.getComparisonKey(g,w)===this.getComparisonKey(y,w)}getComparisonKey(g,y=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,y,w=!1){if(g.scheme===y.scheme){if(g.scheme===t.Schemas.file)return D.isEqualOrParent(I(g),I(y),this._ignorePathCasing(g))&&g.query===y.query&&(w||g.fragment===y.fragment);if((0,e.isEqualAuthority)(g.authority,y.authority))return D.isEqualOrParent(g.path,y.path,this._ignorePathCasing(g),"/")&&g.query===y.query&&(w||g.fragment===y.fragment)}return!1}joinPath(g,...y){return P.URI.joinPath(g,...y)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return R.posix.basename(g.path)}extname(g){return R.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let y;return g.scheme===t.Schemas.file?y=P.URI.file(R.dirname(I(g))).path:(y=R.posix.dirname(g.path),g.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),y="/")),g.with({path:y})}normalizePath(g){if(!g.path.length)return g;let y;return g.scheme===t.Schemas.file?y=P.URI.file(R.normalize(I(g))).path:y=R.posix.normalize(g.path),g.with({path:y})}relativePath(g,y){if(g.scheme!==y.scheme||!(0,e.isEqualAuthority)(g.authority,y.authority))return;if(g.scheme===t.Schemas.file){const m=R.relative(I(g),I(y));return L.isWindows?D.toSlashes(m):m}let w=g.path||"/";const d=y.path||"/";if(this._ignorePathCasing(g)){let m=0;for(const l=Math.min(w.length,d.length);m<l&&!(w.charCodeAt(m)!==d.charCodeAt(m)&&w.charAt(m).toLowerCase()!==d.charAt(m).toLowerCase());m++);w=d.substr(0,m)+w.substr(m)}return R.posix.relative(w,d)}resolvePath(g,y){if(g.scheme===t.Schemas.file){const w=P.URI.file(R.resolve(I(g),y));return g.with({authority:w.authority,path:w.path})}return y=D.toPosixPath(y),g.with({path:R.posix.resolve(g.path,y)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,y){return g===y||g!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(g,y)}hasTrailingPathSeparator(g,y=R.sep){if(g.scheme===t.Schemas.file){const w=I(g);return w.length>D.getRoot(w).length&&w[w.length-1]===y}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,y=R.sep){return(0,e.hasTrailingPathSeparator)(g,y)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,y=R.sep){let w=!1;if(g.scheme===t.Schemas.file){const d=I(g);w=d!==void 0&&d.length===D.getRoot(d).length&&d[d.length-1]===y}else{y="/";const d=g.path;w=d.length===1&&d.charCodeAt(d.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(g,y)?g.with({path:g.path+"/"}):g}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(v=>v.scheme===t.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new E(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(v,g){const y=[];for(let w=0;w<v.length;w++){const d=g(v[w]);v.some((m,l)=>l===w?!1:(0,e.isEqualOrParent)(d,g(m)))||y.push(v[w])}return y}e.distinctParents=b;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function g(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(l=>{const[f,u]=l.split(":");f&&u&&w.set(f,u)});const m=y.path.substring(0,y.path.indexOf(";"));return m&&w.set(v.META_DATA_MIME,m),w}v.parseMetaData=g})(C=e.DataUri||(e.DataUri={}));function p(v,g,y){if(g){let w=v.path;return w&&w[0]!==R.posix.sep&&(w=R.posix.sep+w),v.with({scheme:y,authority:g,path:w})}return v.with({scheme:y})}e.toLocalResource=p}),define(ne[6],re([0,1,23,9,3,2,19,4]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(G){return!!G&&typeof G.then=="function"}e.isThenable=I;function E(G){const O=new D.CancellationTokenSource,M=G(O.token),x=new Promise((V,ee)=>{const oe=O.token.onCancellationRequested(()=>{oe.dispose(),O.dispose(),ee(new t.CancellationError)});Promise.resolve(M).then(Z=>{oe.dispose(),O.dispose(),V(Z)},Z=>{oe.dispose(),O.dispose(),ee(Z)})});return new class{cancel(){O.cancel()}then(V,ee){return x.then(V,ee)}catch(V){return this.then(void 0,V)}finally(V){return x.finally(V)}}}e.createCancelablePromise=E;function b(G,O,M){return new Promise((x,V)=>{const ee=O.onCancellationRequested(()=>{ee.dispose(),x(M)});G.then(x,V).finally(()=>ee.dispose())})}e.raceCancellation=b;function C(G,O){return new Promise((M,x)=>{const V=O.onCancellationRequested(()=>{V.dispose(),x(new t.CancellationError)});G.then(M,x).finally(()=>V.dispose())})}e.raceCancellationError=C;async function p(G){let O=-1;const M=G.map((V,ee)=>V.then(oe=>(O=ee,oe))),x=await Promise.race(M);return G.forEach((V,ee)=>{ee!==O&&V.cancel()}),x}e.raceCancellablePromises=p;function v(G,O,M){let x;const V=setTimeout(()=>{x?.(void 0),M?.()},O);return Promise.race([G.finally(()=>clearTimeout(V)),new Promise(ee=>x=ee)])}e.raceTimeout=v;function g(G){return new Promise((O,M)=>{const x=G();I(x)?x.then(O,M):O(x)})}e.asPromise=g;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(M,M).then(x)})}return new Promise((M,x)=>{this.queuedPromise.then(M,x)})}return this.activePromise=O(),new Promise((M,x)=>{this.activePromise.then(V=>{this.activePromise=null,M(V)},V=>{this.activePromise=null,x(V)})})}}e.Throttler=y;class w{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=w;class d{constructor(){this.promiseMap=new Map}queue(O,M){const V=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(O)===V&&this.promiseMap.delete(O)});return this.promiseMap.set(O,V),V}}e.SequencerByKey=d;const m=(G,O)=>{let M=!0;const x=setTimeout(()=>{M=!1,O()},G);return{isTriggered:()=>M,dispose:()=>{clearTimeout(x),M=!1}}},l=G=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,G())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,M=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,ee)=>{this.doResolve=V,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const x=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?l(x):m(M,x),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class u{constructor(O){this.delayer=new f(O),this.throttler=new y}trigger(O,M){return this.delayer.trigger(()=>this.throttler.queue(O),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class o{constructor(){this._isOpen=!1,this._promise=new Promise((O,M)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class s extends o{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function n(G,O){return O?new Promise((M,x)=>{const V=setTimeout(()=>{ee.dispose(),M()},G),ee=O.onCancellationRequested(()=>{clearTimeout(V),ee.dispose(),x(new t.CancellationError)})}):E(M=>n(G,M))}e.timeout=n;function i(G,O=0){const M=setTimeout(G,O);return(0,L.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=i;function r(G){const O=[];let M=0;const x=G.length;function V(){return M<x?G[M++]():null}function ee(oe){oe!=null&&O.push(oe);const Z=V();return Z?Z.then(ee):Promise.resolve(O)}return Promise.resolve(null).then(ee)}e.sequence=r;function c(G,O=x=>!!x,M=null){let x=0;const V=G.length,ee=()=>{if(x>=V)return Promise.resolve(M);const oe=G[x++];return Promise.resolve(oe()).then(ie=>O(ie)?Promise.resolve(ie):ee())};return ee()}e.first=c;function a(G,O=x=>!!x,M=null){if(G.length===0)return Promise.resolve(M);let x=G.length;const V=()=>{x=-1;for(const ee of G)ee.cancel?.()};return new Promise((ee,oe)=>{for(const Z of G)Z.then(ie=>{--x>=0&&O(ie)?(V(),ee(ie)):x===0&&ee(M)}).catch(ie=>{--x>=0&&(V(),oe(ie))})})}e.firstParallel=a;class h{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((M,x)=>{this.outstandingPromises.push({factory:O,c:M,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class S extends h{constructor(){super(1)}}e.Queue=S;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new W;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,M=T.extUri){const x=M.getComparisonKey(O);let V=this.queues.get(x);return V||(V=new S,R.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(x),this.onDidQueueDrain()}),this.queues.set(x,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class ${constructor(O,M){this._token=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},M)}setIfNotSet(O,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},M))}}e.TimeoutTimer=$;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setInterval(()=>{O()},M)}}e.IntervalTimer=_;class U{constructor(O,M){this.timeoutToken=-1,this.runner=O,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class k{constructor(O,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class N extends U{constructor(O,M){super(O,M),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class F extends L.Disposable{constructor(O,M){super(),this.options=O,this.handler=M,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,P.setTimeout0)(()=>{if(O)return;const M=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(G,O)=>{const M=requestIdleCallback(G,typeof O=="number"?{timeout:O}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(M))}}}}();class q{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function J(G,O,M){let x;for(let V=0;V<M;V++)try{return await G()}catch(ee){x=ee,await n(O)}throw x}e.retry=J;class j{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(O,M,x){return this._pending={taskId:O,cancel:()=>x?.(),promise:M},M.then(()=>this.donePending(O),()=>this.donePending(O)),M}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let M,x;const V=new Promise((ee,oe)=>{M=ee,x=oe});this._next={run:O,promise:V,promiseResolve:M,promiseReject:x}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=j;class H{constructor(O,M=()=>Date.now()){this.interval=O,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,M)=>{this.completeCallback=O,this.errorCallback=M})}complete(O){return new Promise(M=>{this.completeCallback(O),this.resolved=!0,M()})}error(O){return new Promise(M=>{this.errorCallback(O),this.rejected=!0,M()})}cancel(){new Promise(O=>{this.errorCallback(new t.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=W;var z;(function(G){async function O(x){let V;const ee=await Promise.all(x.map(oe=>oe.then(Z=>Z,Z=>{V||(V=Z)})));if(typeof V<"u")throw V;return ee}G.settled=O;function M(x){return new Promise(async(V,ee)=>{try{await x(V,ee)}catch(oe){ee(oe)}})}G.withAsyncBody=M})(z=e.Promises||(e.Promises={}));var K;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(K||(K={}));class X{static fromArray(O){return new X(M=>{M.emitMany(O)})}static fromPromise(O){return new X(async M=>{M.emitMany(await O)})}static fromPromises(O){return new X(async M=>{await Promise.all(O.map(async x=>M.emitOne(await x)))})}static merge(O){return new X(async M=>{await Promise.all(O.map(async x=>{for await(const V of x)M.emitOne(V)}))})}constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const M={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(O(M)),this.resolve()}catch(x){this.reject(x)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,M){return new X(async x=>{for await(const V of O)x.emitOne(M(V))})}map(O){return X.map(this,O)}static filter(O,M){return new X(async x=>{for await(const V of O)M(V)&&x.emitOne(V)})}filter(O){return X.filter(this,O)}static coalesce(O){return X.filter(O,M=>!!M)}coalesce(){return X.coalesce(this)}static async toPromise(O){const M=[];for await(const x of O)M.push(x);return M}toPromise(){return X.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ce extends X{constructor(O,M){super(M),this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function B(G){const O=new D.CancellationTokenSource,M=G(O.token);return new ce(O,async x=>{const V=O.token.onCancellationRequested(()=>{V.dispose(),O.dispose(),x.reject(new t.CancellationError)});try{for await(const ee of M){if(O.token.isCancellationRequested)return;x.emitOne(ee)}V.dispose(),O.dispose()}catch(ee){V.dispose(),O.dispose(),x.reject(ee)}})}e.createCancelableAsyncIterable=B}),define(ne[87],re([0,1,18,6,47,34,10,4,27]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",C="[^/\\\\]",p=/\//g;function v(W,z){switch(W){case 0:return"";case 1:return`${C}*?`;default:return`(?:${b}|${C}+${b}${z?`|${b}${C}+`:""})*?`}}function g(W,z){if(!W)return[];const K=[];let X=!1,ce=!1,B="";for(const G of W){switch(G){case z:if(!X&&!ce){K.push(B),B="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}B+=G}return B&&K.push(B),K}e.splitGlobAware=g;function y(W){if(!W)return"";let z="";const K=g(W,e.GLOB_SPLIT);if(K.every(X=>X===e.GLOBSTAR))z=".*";else{let X=!1;K.forEach((ce,B)=>{if(ce===e.GLOBSTAR){if(X)return;z+=v(2,B===K.length-1)}else{let G=!1,O="",M=!1,x="";for(const V of ce){if(V!=="}"&&G){O+=V;continue}if(M&&(V!=="]"||!x)){let ee;V==="-"?ee=V:(V==="^"||V==="!")&&!x?ee="^":V===e.GLOB_SPLIT?ee="":ee=(0,I.escapeRegExpCharacters)(V),x+=ee;continue}switch(V){case"{":G=!0;continue;case"[":M=!0;continue;case"}":{z+=`(?:${g(O,",").map(Z=>y(Z)).join("|")})`,G=!1,O="";break}case"]":{z+="["+x+"]",M=!1,x="";break}case"?":z+=C;continue;case"*":z+=v(1);continue;default:z+=(0,I.escapeRegExpCharacters)(V)}}B<K.length-1&&(K[B+1]!==e.GLOBSTAR||B+2<K.length)&&(z+=b)}X=ce===e.GLOBSTAR})}return z}const w=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new L.LRUCache(1e4),s=function(){return!1},n=function(){return null};function i(W,z){if(!W)return n;let K;typeof W!="string"?K=W.pattern:K=W,K=K.trim();const X=`${K}_${!!z.trimForExclusions}`;let ce=o.get(X);if(ce)return r(ce,W);let B;return w.test(K)?ce=a(K.substr(4),K):(B=d.exec(c(K,z)))?ce=h(B[1],K):(z.trimForExclusions?l:m).test(K)?ce=S(K,z):(B=f.exec(c(K,z)))?ce=A(B[1].substr(1),K,!0):(B=u.exec(c(K,z)))?ce=A(B[1],K,!1):ce=$(K),o.set(X,ce),r(ce,W)}function r(W,z){if(typeof z=="string")return W;const K=function(X,ce){return(0,R.isEqualOrParent)(X,z.base,!P.isLinux)?W(X.substr(z.base.length+1),ce):null};return K.allBasenames=W.allBasenames,K.allPaths=W.allPaths,K.basenames=W.basenames,K.patterns=W.patterns,K}function c(W,z){return z.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,z){return function(K,X){return typeof K=="string"&&K.endsWith(W)?z:null}}function h(W,z){const K=`/${W}`,X=`\\${W}`,ce=function(G,O){return typeof G!="string"?null:O?O===W?z:null:G===W||G.endsWith(K)||G.endsWith(X)?z:null},B=[W];return ce.basenames=B,ce.patterns=[z],ce.allBasenames=B,ce}function S(W,z){const K=j(W.slice(1,-1).split(",").map(O=>i(O,z)).filter(O=>O!==n),W),X=K.length;if(!X)return n;if(X===1)return K[0];const ce=function(O,M){for(let x=0,V=K.length;x<V;x++)if(K[x](O,M))return W;return null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const G=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return G.length&&(ce.allPaths=G),ce}function A(W,z,K){const X=T.sep===T.posix.sep,ce=X?W:W.replace(p,T.sep),B=T.sep+ce,G=T.posix.sep+W;let O;return K?O=function(M,x){return typeof M=="string"&&(M===ce||M.endsWith(B)||!X&&(M===W||M.endsWith(G)))?z:null}:O=function(M,x){return typeof M=="string"&&(M===ce||!X&&M===W)?z:null},O.allPaths=[(K?"*/":"./")+W],O}function $(W){try{const z=new RegExp(`^${y(W)}$`);return function(K){return z.lastIndex=0,typeof K=="string"&&z.test(K)?W:null}}catch{return n}}function _(W,z,K){return!W||typeof z!="string"?!1:U(W)(z,void 0,K)}e.match=_;function U(W,z={}){if(!W)return s;if(typeof W=="string"||k(W)){const K=i(W,z);if(K===n)return s;const X=function(ce,B){return!!K(ce,B)};return K.allBasenames&&(X.allBasenames=K.allBasenames),K.allPaths&&(X.allPaths=K.allPaths),X}return q(W,z)}e.parse=U;function k(W){const z=W;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=k;function N(W){return W.allBasenames||[]}e.getBasenameTerms=N;function F(W){return W.allPaths||[]}e.getPathTerms=F;function q(W,z){const K=j(Object.getOwnPropertyNames(W).map(O=>J(O,W[O],z)).filter(O=>O!==n)),X=K.length;if(!X)return n;if(!K.some(O=>!!O.requiresSiblings)){if(X===1)return K[0];const O=function(V,ee){let oe;for(let Z=0,ie=K.length;Z<ie;Z++){const se=K[Z](V,ee);if(typeof se=="string")return se;(0,t.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const Z of oe){const ie=await Z;if(typeof ie=="string")return ie}return null})():null},M=K.find(V=>!!V.allBasenames);M&&(O.allBasenames=M.allBasenames);const x=K.reduce((V,ee)=>ee.allPaths?V.concat(ee.allPaths):V,[]);return x.length&&(O.allPaths=x),O}const ce=function(O,M,x){let V,ee;for(let oe=0,Z=K.length;oe<Z;oe++){const ie=K[oe];ie.requiresSiblings&&x&&(M||(M=(0,T.basename)(O)),V||(V=M.substr(0,M.length-(0,T.extname)(O).length)));const se=ie(O,M,V,x);if(typeof se=="string")return se;(0,t.isThenable)(se)&&(ee||(ee=[]),ee.push(se))}return ee?(async()=>{for(const oe of ee){const Z=await oe;if(typeof Z=="string")return Z}return null})():null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const G=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return G.length&&(ce.allPaths=G),ce}function J(W,z,K){if(z===!1)return n;const X=i(W,K);if(X===n)return n;if(typeof z=="boolean")return X;if(z){const ce=z.when;if(typeof ce=="string"){const B=(G,O,M,x)=>{if(!x||!X(G,O))return null;const V=ce.replace("$(basename)",M),ee=x(V);return(0,t.isThenable)(ee)?ee.then(oe=>oe?W:null):ee?W:null};return B.requiresSiblings=!0,B}}return X}function j(W,z){const K=W.filter(O=>!!O.basenames);if(K.length<2)return W;const X=K.reduce((O,M)=>{const x=M.basenames;return x?O.concat(x):O},[]);let ce;if(z){ce=[];for(let O=0,M=X.length;O<M;O++)ce.push(z)}else ce=K.reduce((O,M)=>{const x=M.patterns;return x?O.concat(x):O},[]);const B=function(O,M){if(typeof O!="string")return null;if(!M){let V;for(V=O.length;V>0;V--){const ee=O.charCodeAt(V-1);if(ee===47||ee===92)break}M=O.substr(V)}const x=X.indexOf(M);return x!==-1?ce[x]:null};B.basenames=X,B.patterns=ce,B.allBasenames=X;const G=W.filter(O=>!O.basenames);return G.push(B),G}function H(W,z){return(0,D.equals)(W,z,(K,X)=>typeof K=="string"&&typeof X=="string"?K===X:typeof K!="string"&&typeof X!="string"?K.base===X.base&&K.pattern===X.pattern:!1)}e.patternsEquals=H}),define(ne[133],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(b){return b.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const p=this._uriTransformer.transformIncoming(C);return p===C?C:t(D.URI.from(p))}transformOutgoing(C){const p=this._uriTransformer.transformOutgoing(C);return p===C?C:t(D.URI.from(p))}transformOutgoingURI(C){const p=this._uriTransformer.transformOutgoing(C);return p===C?C:D.URI.from(p)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function L(b,C,p){if(!b||p>200)return null;if(typeof b=="object"){if(b instanceof D.URI)return C.transformOutgoing(b);for(const v in b)if(Object.hasOwnProperty.call(b,v)){const g=L(b[v],C,p+1);g!==null&&(b[v]=g)}}return null}function T(b,C){const p=L(b,C,0);return p===null?b:p}e.transformOutgoingURIs=T;function P(b,C,p,v){if(!b||v>200)return null;if(typeof b=="object"){if(b.$mid===1)return p?D.URI.revive(C.transformIncoming(b)):C.transformIncoming(b);for(const g in b)if(Object.hasOwnProperty.call(b,g)){const y=P(b[g],C,p,v+1);y!==null&&(b[g]=y)}}return null}function I(b,C){const p=P(b,C,!1,0);return p===null?b:p}e.transformIncomingURIs=I;function E(b,C){const p=P(b,C,!0,0);return p===null?b:p}e.transformAndReviveIncomingURIs=E}),define(ne[134],re([0,1,36,9,34,30,120]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,C=0;const p=(0,D.networkInterfaces)();for(const v in p){const g=p[v];if(g)for(const{mac:y,internal:w}of g)w||(C+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(b+=1))}this._value=C>0?b/C:0}return this._value}};let P;async function I(){return P||(P=(async()=>await E()||L.generateUuid())()),P}e.getMachineId=I;async function E(){try{const b=await new Promise((p,v)=>{Q(["crypto"],p,v)}),C=(0,T.getMac)();return b.createHash("sha256").update(C,"utf8").digest("hex")}catch(b){t.onUnexpectedError(b);return}}}),define(ne[28],re([0,1,54,36,277,6,47,85,10,4,19,7]),function(Q,e,D,t,R,L,T,P,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function v(q,J=p.UNLINK){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return J===p.UNLINK?y(q):g(q)}async function g(q){try{const J=(0,T.randomPath)((0,t.tmpdir)());try{await D.promises.rename(q,J)}catch(j){return j.code==="ENOENT"?void 0:y(q)}y(J).catch(j=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function y(q){return(0,R.promisify)(D.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function w(q){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function d(q,J){return f(await(J?m(q):(0,R.promisify)(D.readdir)(q)))}async function m(q){try{return await(0,R.promisify)(D.readdir)(q,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const J=[],j=await d(q);for(const H of j){let W=!1,z=!1,K=!1;try{const X=await e.Promises.lstat((0,I.join)(q,H));W=X.isFile(),z=X.isDirectory(),K=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}J.push({name:H,isFile:()=>W,isDirectory:()=>z,isSymbolicLink:()=>K})}return J}function l(q){return f(D.readdirSync(q))}e.readdirSync=l;function f(q){return q.map(J=>typeof J=="string"?E.isMacintosh?(0,P.normalizeNFC)(J):J:(J.name=E.isMacintosh?(0,P.normalizeNFC)(J.name):J.name,J))}async function u(q){const J=await d(q),j=[];for(const H of J)await s.existsDirectory((0,I.join)(q,H))&&j.push(H);return j}function o(q,J=1e3){return new Promise(j=>{let H=!1;const W=setInterval(()=>{H||(H=!0,D.access(q,z=>{H=!1,z&&(clearInterval(W),j(void 0))}))},J)})}e.whenDeleted=o;var s;(function(q){async function J(W){let z;try{if(z=await e.Promises.lstat(W),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(E.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw X}throw K}}q.stat=J;async function j(W){try{const{stat:z,symbolicLink:K}=await q.stat(W);return z.isFile()&&K?.dangling!==!0}catch{}return!1}q.existsFile=j;async function H(W){try{const{stat:z,symbolicLink:K}=await q.stat(W);return z.isDirectory()&&K?.dangling!==!0}catch{}return!1}q.existsDirectory=H})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new L.ResourceQueue;function i(q,J,j){return n.queueFor(C.URI.file(q),b.extUriBiasedIgnorePathCase).queue(()=>{const H=S(j);return new Promise((W,z)=>a(q,J,H,K=>K?z(K):W()))})}let r=!0;function c(q){r=q}e.configureFlushOnWrite=c;function a(q,J,j,H){if(!r)return D.writeFile(q,J,{mode:j.mode,flag:j.flag},H);D.open(q,j.flag,j.mode,(W,z)=>{if(W)return H(W);D.writeFile(z,J,K=>{if(K)return D.close(z,()=>H(K));D.fdatasync(z,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),c(!1)),D.close(z,ce=>H(ce))))})})}function h(q,J,j){const H=S(j);if(!r)return D.writeFileSync(q,J,{mode:H.mode,flag:H.flag});const W=D.openSync(q,H.flag,H.mode);try{D.writeFileSync(W,J);try{D.fdatasyncSync(W)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),c(!1)}}finally{D.closeSync(W)}}e.writeFileSync=h;function S(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function A(q,J){if(q!==J)try{await e.Promises.rename(q,J)}catch(j){if(q.toLowerCase()!==J.toLowerCase()&&j.code==="EXDEV"||q.endsWith("."))await $(q,J,{preserveSymlinks:!1}),await v(q,p.MOVE);else throw j}}async function $(q,J,j){return U(q,J,{root:{source:q,target:J},options:j,handledSourcePaths:new Set})}const _=511;async function U(q,J,j){if(j.handledSourcePaths.has(q))return;j.handledSourcePaths.add(q);const{stat:H,symbolicLink:W}=await s.stat(q);if(W){if(j.options.preserveSymlinks)try{return await F(q,J,j)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(W.dangling)return}return H.isDirectory()?k(q,J,H.mode&_,j):N(q,J,H.mode&_)}async function k(q,J,j,H){await e.Promises.mkdir(J,{recursive:!0,mode:j});const W=await d(q);for(const z of W)await U((0,I.join)(q,z),(0,I.join)(J,z),H)}async function N(q,J,j){await e.Promises.copyFile(q,J),await e.Promises.chmod(J,j)}async function F(q,J,j){let H=await e.Promises.readlink(q);(0,T.isEqualOrParent)(H,j.root.source,!E.isLinux)&&(H=(0,I.join)(j.root.target,H.substr(j.root.source.length+1))),await e.Promises.symlink(H,J)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(q,J,j,H,W)=>new Promise((z,K)=>{D.read(q,J,j,H,W,(X,ce,B)=>X?K(X):z({bytesRead:ce,buffer:B}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(q,J,j,H,W)=>new Promise((z,K)=>{D.write(q,J,j,H,W,(X,ce,B)=>X?K(X):z({bytesWritten:ce,buffer:B}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return v}get move(){return A}get copy(){return $}}}),define(ne[135],re([0,1,54,10,4,27,28]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(p){if(R.isLinux)return p;const v=(0,t.dirname)(p);if(p===v)return p;const g=((0,t.basename)(p)||p).toLowerCase();try{const w=(0,T.readdirSync)(v).filter(d=>d.toLowerCase()===g);if(w.length===1){const d=P(v);if(d)return(0,t.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(g);if(d>=0){const m=P(v);if(m)return(0,t.join)(m,w[d])}}}catch{}return null}e.realcaseSync=P;async function I(p){if(R.isLinux)return p;const v=(0,t.dirname)(p);if(p===v)return p;const g=((0,t.basename)(p)||p).toLowerCase();try{const w=(await T.Promises.readdir(v)).filter(d=>d.toLowerCase()===g);if(w.length===1){const d=await I(v);if(d)return(0,t.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(g);if(d>=0){const m=await I(v);if(m)return(0,t.join)(m,w[d])}}}catch{}return null}e.realcase=I;async function E(p){try{return await T.Promises.realpath(p)}catch{const g=C(p);return await T.Promises.access(g,D.constants.R_OK),g}}e.realpath=E;function b(p){try{return D.realpathSync(p)}catch{const g=C(p);return D.accessSync(g,D.constants.R_OK),g}}e.realpathSync=b;function C(p){return(0,L.rtrim)((0,t.normalize)(p),t.sep)}}),define(ne[88],re([0,1,36,10,28]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(I||(I={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class C{constructor(u,o,s){this.exePath=u,this.displayName=o,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:f=!1}={}){return f?E===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:f=!1,findPreview:u=!1}={}){const o=p({useAlternateBitness:f});if(!o)return null;const s=t.join(o,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let n=-1,i=null;for(const a of await R.Promises.readdir(s)){let h=-1;if(u){const A=a.indexOf("-");if(A<0)continue;const $=a.substring(0,A);if(!L.test($)||a.substring(A+1)!=="preview")continue;h=parseInt($,10)}else{if(!L.test(a))continue;h=parseInt(a,10)}if(h<=n)continue;const S=t.join(s,a,"pwsh.exe");!await R.SymlinkSupport.existsFile(S)||(i=S,n=h)}if(!i)return null;const r=o.includes("x86")?" (x86)":"",c=u?" Preview":"";return new C(i,`PowerShell${c}${r}`,!0)}async function g({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const u=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:o,pwshMsixName:s}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(u))if(o.test(n)){const i=t.join(u,n,"pwsh.exe");return new C(i,s)}return null}function y(){const f=t.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(f,".NET Core PowerShell Global Tool")}function w(){const f=t.join(process.env.windir,E===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(f,"Windows PowerShell",!0)}async function*d(){let f=await v();f&&(yield f),f=await v({useAlternateBitness:!0}),f&&(yield f),f=await g(),f&&(yield f),f=y(),f&&(yield f),f=await v({findPreview:!0}),f&&(yield f),f=await g({findPreview:!0}),f&&(yield f),f=await v({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=w(),f&&(yield f)}async function*m(){for await(const f of d())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=m;async function l(){for await(const f of m())return f;return null}e.getFirstAvailablePowerShellInstallation=l}),define(ne[89],re([0,1,10,4,37,83,15,28]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function I(C=R.env){return C.comspec||"cmd.exe"}e.getWindowsShell=I;function E(C){let p=[],v=!1;const g=function(y){if(v){p.push(y);return}(!C.send(y,d=>{if(d&&console.error(d),v=!1,p.length>0){const m=p.slice(0);p=[],m.forEach(l=>g(l))}})||t.isWindows)&&(v=!0)};return{send:g}}e.createQueuedSender=E;var b;(function(C){async function p(v,g,y){if(D.isAbsolute(v))return v;if(g===void 0&&(g=R.cwd()),D.dirname(v)!=="."||(y===void 0&&T.isString(R.env.PATH)&&(y=R.env.PATH.split(D.delimiter)),y===void 0||y.length===0))return D.join(g,v);async function d(m){if(await P.Promises.exists(m)){let l;try{l=await P.Promises.stat(m)}catch(f){f.message.startsWith("EACCES")&&(l=await P.Promises.lstat(m))}return l?!l.isDirectory():!1}return!1}for(const m of y){let l;if(D.isAbsolute(m)?l=D.join(m,v):l=D.join(g,m,v),await d(l))return l;let f=l+".com";if(await d(f)||(f=l+".exe",await d(f)))return f}return D.join(g,v)}C.findExecutable=p})(b=e.win32||(e.win32={}))}),define(ne[136],re([0,1,48,24]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(T){return new Promise((P,I)=>{let E;const b=new Map;function C(v,g,y,w,d){const m=b.get(g);if(v===T||m){const l={name:p(y),cmd:y,pid:v,ppid:g,load:w,mem:d};b.set(v,l),v===T&&(E=l),m&&(m.children||(m.children=[]),m.children.push(l),m.children.length>1&&(m.children=m.children.sort((f,u)=>f.pid-u.pid)))}}function p(v){const g=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,l=/--crashes-directory/,f=/\\pipe\\winpty-control/,u=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(l.exec(v))return"electron-crash-reporter";if(f.exec(v))return"winpty-process";if(u.exec(v))return"console-window-host (Windows internal process)";let s=o.exec(v);if(s&&s.length===2){if(s[1]==="renderer")return g.exec(v)?"shared-process":y.exec(v)?"issue-reporter":w.exec(v)?"process-explorer":"window";if(s[1]==="utility"){if(d.exec(v))return"utility-network-service";if(m.exec(v))return"extension-host"}return s[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do s=n.exec(v),s&&(i+=s+" ");while(s);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,y)=>{Q(["windows-process-tree"],g,y)}).then(g=>{g.getProcessList(T,y=>{if(!y){I(new Error(`Root process ${T} not found`));return}g.getProcessCpuUsage(y,w=>{const d=new Map;w.forEach(m=>{const l=v(m.commandLine||"");d.set(m.pid,{name:p(l),cmd:l,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),E=d.get(T),E?(d.forEach(m=>{const l=d.get(m.ppid);l&&(l.children||(l.children=[]),l.children.push(m))}),d.forEach(m=>{m.children&&(m.children=m.children.sort((l,f)=>l.pid-f.pid))}),P(E)):I(new Error(`Root process ${T} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let v=function(){let g=[E];const y=[];for(;g.length;){const d=g.shift();d&&(y.push(d.pid),d.children&&(g=g.concat(d.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);w+=" "+y.join(" "),(0,D.exec)(w,{},(d,m,l)=>{if(d||l)I(d||new Error(l.toString()));else{const f=m.toString().split(`
`);for(let u=0;u<y.length;u++){const o=b.get(y[u]);o.load=parseFloat(f[u])}if(!E){I(new Error(`Root process ${T} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(g,y,w)=>{if(g||w)if(process.platform!=="linux")I(g||new Error(w.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(d,{},(m,l,f)=>{m||f?I(m||new Error(f.toString())):(L(l,C),v())})}else{const d=y.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${d} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,f,u)=>{l||u&&!u.includes("screen size is bogus")?I(l||new Error(u.toString())):(L(f,C),process.platform==="linux"?v():E?P(E):I(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=R;function L(T,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=T.toString().split(`
`);for(const b of E){const C=I.exec(b.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(ne[137],re([0,1,36,4,88,89]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(v,g){return v===1?t.isWindows?C():L.getWindowsShell(g):E(v,g)}e.getSystemShell=T;function P(v,g){return v===1?t.isWindows?p(g):L.getWindowsShell(g):E(v,g)}e.getSystemShellSync=P;let I=null;function E(v,g){if(t.isLinux&&v===2||t.isMacintosh&&v===3)return"/bin/bash";if(!I){let y;if(t.isWindows)y="/bin/bash";else{if(y=g.SHELL,!y)try{y=(0,D.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}I=y}return I}let b=null;async function C(){return b||(b=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),b}function p(v){if(b)return b;const g=t.isWindows&&parseFloat((0,D.release)())>=10,y=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${v.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?w:L.getWindowsShell(v)}});var pe=this&&this.__decorate||function(Q,e,D,t){var R=arguments.length,L=R<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,D):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,D,t);else for(var P=Q.length-1;P>=0;P--)(T=Q[P])&&(L=(R<3?T(L):R>3?T(e,D,L):T(e,D))||L);return R>3&&L&&Object.defineProperty(e,D,L),L};define(ne[39],re([0,1,18,6,16,23,63,9,3,2,66,27,15]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function g(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(d||(d={}));class m{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class l{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var f;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(f||(f={}));function u(W){const z=R.VSBuffer.alloc(4);return z.writeUInt32BE(W,0),z}function o(W){return W.read(4).readUInt32BE(0)}function s(W){const z=R.VSBuffer.alloc(1);return z.writeUInt8(W,0),z}const n={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},i=typeof Buffer<"u";function r(W,z){if(typeof z>"u")W.write(n.Undefined);else if(typeof z=="string"){const K=R.VSBuffer.fromString(z);W.write(n.String),W.write(u(K.byteLength)),W.write(K)}else if(i&&Buffer.isBuffer(z)){const K=R.VSBuffer.wrap(z);W.write(n.Buffer),W.write(u(K.byteLength)),W.write(K)}else if(z instanceof R.VSBuffer)W.write(n.VSBuffer),W.write(u(z.byteLength)),W.write(z);else if(Array.isArray(z)){W.write(n.Array),W.write(u(z.length));for(const K of z)r(W,K)}else{const K=R.VSBuffer.fromString(JSON.stringify(z));W.write(n.Object),W.write(u(K.byteLength)),W.write(K)}}function c(W){switch(W.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return W.read(o(W)).toString();case f.Buffer:return W.read(o(W)).buffer;case f.VSBuffer:return W.read(o(W));case f.Array:{const K=o(W),X=[];for(let ce=0;ce<K;ce++)X.push(c(W));return X}case f.Object:return JSON.parse(W.read(o(W)).toString())}}class a{constructor(z,K,X=null,ce=1e3){this.protocol=z,this.ctx=K,this.logger=X,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger?.logOutgoing(K,0,1,w(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(K,z.id,1,w(z.type),z.data);return}}}send(z,K=void 0){const X=new l;return r(X,z),r(X,K),this.sendBuffer(X.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const K=new m(z),X=c(K),ce=c(K),B=X[0];switch(B){case 100:return this.logger?.logIncoming(z.byteLength,X[1],1,`${g(B)}: ${X[2]}.${X[3]}`,ce),this.onPromise({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 102:return this.logger?.logIncoming(z.byteLength,X[1],1,`${g(B)}: ${X[2]}.${X[3]}`,ce),this.onEventListen({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 101:return this.logger?.logIncoming(z.byteLength,X[1],1,`${g(B)}`),this.disposeActiveRequest({type:B,id:X[1]});case 103:return this.logger?.logIncoming(z.byteLength,X[1],1,`${g(B)}`),this.disposeActiveRequest({type:B,id:X[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const X=new L.CancellationTokenSource;let ce;try{ce=K.call(this.ctx,z.name,z.arg,X.token)}catch(O){ce=Promise.reject(O)}const B=z.id;ce.then(O=>{this.sendResponse({id:B,data:O,type:201}),this.activeRequests.delete(z.id)},O=>{O instanceof Error?this.sendResponse({id:B,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:B,data:O,type:203}),this.activeRequests.delete(z.id)});const G=(0,E.toDisposable)(()=>X.cancel());this.activeRequests.set(z.id,G)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const X=z.id,B=K.listen(this.ctx,z.name,z.arg)(G=>this.sendResponse({id:X,data:G,type:204}));this.activeRequests.set(z.id,B)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const X=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:X})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const X of K)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=K}getChannel(z){const K=this;return{call(X,ce,B){return K.isDisposed?Promise.reject(new P.CancellationError):K.requestPromise(z,X,ce,B)},listen(X,ce){return K.isDisposed?I.Event.None:K.requestEvent(z,X,ce)}}}requestPromise(z,K,X,ce=L.CancellationToken.None){const B=this.lastRequestId++,O={id:B,type:100,channelName:z,name:K,arg:X};if(ce.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((V,ee)=>{if(ce.isCancellationRequested)return ee(new P.CancellationError);const oe=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(B),V(de.data);break;case 202:{this.handlers.delete(B);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ee(ve);break}case 203:this.handlers.delete(B),ee(de.data);break}};this.handlers.set(B,ue),this.sendRequest(O)};let Z=null;this.state===d.Idle?oe():(Z=(0,t.createCancelablePromise)(ue=>this.whenInitialized()),Z.then(()=>{Z=null,oe()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:B,type:101}),ee(new P.CancellationError)},se=ce.onCancellationRequested(ie);M=(0,E.combinedDisposable)((0,E.toDisposable)(ie),se),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(z,K,X){const ce=this.lastRequestId++,G={id:ce,type:102,channelName:z,name:K,arg:X};let O=null;const M=new I.Emitter({onFirstListenerAdd:()=>{O=(0,t.createCancelablePromise)(V=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(M),this.sendRequest(G)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(M),this.sendRequest({id:ce,type:103}))}}),x=V=>M.fire(V.data);return this.handlers.set(ce,x),M.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(K,z.id,0,`${g(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger?.logOutgoing(K,z.id,0,g(z.type));return}}}send(z,K=void 0){const X=new l;return r(X,z),r(X,K),this.sendBuffer(X.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const K=new m(z),X=c(K),ce=c(K),B=X[0];switch(B){case 200:return this.logger?.logIncoming(z.byteLength,0,0,w(B)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(z.byteLength,X[1],0,w(B),ce),this.onResponse({type:X[0],id:X[1],data:ce})}}onResponse(z){if(z.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([T.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class A{get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:X})=>{I.Event.once(K.onMessage)(B=>{const G=new m(B),O=c(G),M=new a(K,O),x=new S(K);this.channels.forEach((ee,oe)=>M.registerChannel(oe,ee));const V={channelServer:M,channelClient:x,ctx:O};this._connections.add(V),this._onDidAddConnection.fire(V),X(()=>{M.dispose(),x.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}getChannel(z,K){const X=this;return{call(ce,B,G){let O;if((0,p.isFunction)(K)){const x=(0,D.getRandomElement)(X.connections.filter(K));O=x?Promise.resolve(x):I.Event.toPromise(I.Event.filter(X.onDidAddConnection,K))}else O=K.routeCall(X,ce,B);const M=O.then(x=>x.channelClient.getChannel(z));return _(M).call(ce,B,G)},listen(ce,B){if((0,p.isFunction)(K))return X.getMulticastEvent(z,K,ce,B);const G=K.routeEvent(X,ce,B).then(O=>O.channelClient.getChannel(z));return _(G).listen(ce,B)}}}getMulticastEvent(z,K,X,ce){const B=this;let G=new E.DisposableStore;const O=new I.Emitter({onFirstListenerAdd:()=>{G=new E.DisposableStore;const M=new I.EventMultiplexer,x=new Map,V=oe=>{const ie=oe.channelClient.getChannel(z).listen(X,ce),se=M.add(ie);x.set(oe,se)},ee=oe=>{const Z=x.get(oe);!Z||(Z.dispose(),x.delete(oe))};B.connections.filter(K).forEach(V),I.Event.filter(B.onDidAddConnection,K)(V,void 0,G),B.onDidRemoveConnection(ee,void 0,G),M.event(O.fire,O,G),G.add(M)},onLastListenerRemove:()=>{G.dispose()}});return O.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(X=>{X.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class ${constructor(z,K,X=null){const ce=new l;r(ce,K),z.send(ce.buffer),this.channelClient=new S(z,X),this.channelServer=new a(z,K,X)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function _(W){return{call(z,K,X){return W.then(ce=>ce.call(z,K,X))},listen(z,K){const X=new I.Relay;return W.then(ce=>X.input=ce.listen(z,K)),X.event}}}e.getDelayedChannel=_;function U(W){let z=!1;return{call(K,X,ce){return z?W.call(K,X,ce):(0,t.timeout)(0).then(()=>z=!0).then(()=>W.call(K,X,ce))},listen(K,X){if(z)return W.listen(K,X);const ce=new I.Relay;return(0,t.timeout)(0).then(()=>z=!0).then(()=>ce.input=W.listen(K,X)),ce.event}}}e.getNextTickChannel=U;class k{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await I.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=k;var N;(function(W){function z(B,G){const O=B,M=G&&G.disableMarshalling,x=new Map;for(const V in O)X(V)&&x.set(V,I.Event.buffer(O[V],!0));return new class{listen(V,ee,oe){const Z=x.get(ee);if(Z)return Z;if(ce(ee)){const ie=O[ee];if(typeof ie=="function")return ie.call(O,oe)}throw new Error(`Event not found: ${ee}`)}call(V,ee,oe){const Z=O[ee];if(typeof Z=="function"){if(!M&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,b.revive)(oe[ie]);return Z.apply(O,oe)}throw new Error(`Method not found: ${ee}`)}}}W.fromService=z;function K(B,G){const O=G&&G.disableMarshalling;return new Proxy({},{get(M,x){if(typeof x=="string")return G?.properties?.has(x)?G.properties.get(x):ce(x)?function(V){return B.listen(x,V)}:X(x)?B.listen(x):async function(...V){let ee;G&&!(0,p.isUndefinedOrNull)(G.context)?ee=[G.context,...V]:ee=V;const oe=await B.call(x,ee);return O?oe:(0,b.revive)(oe)};throw new Error(`Property not found: ${String(x)}`)}})}W.toService=K;function X(B){return B[0]==="o"&&B[1]==="n"&&C.isUpperAsciiLetter(B.charCodeAt(2))}function ce(B){return/^onDynamic/.test(B)&&C.isUpperAsciiLetter(B.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const z=W.toString();if(z!=="[object Object]")return z}return W}function J(W){return Array.isArray(W)?W.map(q):q(W)}function j(W,z,K,X,ce,B,G){G=J(G);const O=F[ce],M=O[X%O.length];let x=[`%c[${W}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(B)?(x=x.concat(G),x.push(")")):x.push(G),console.log.apply(console,x)}e.logWithColors=j;class H{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,X,ce,B){this._totalOutgoing+=z,j(this._outgoingPrefix,this._totalOutgoing,z,K,X,ce,B)}logIncoming(z,K,X,ce,B){this._totalIncoming+=z,j(this._incomingPrefix,this._totalIncoming,z,K,X,ce,B)}}e.IPCLogger=H}),define(ne[138],re([0,1,16,3,39]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(I){this.port=I,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),I.start()}send(I){this.port.postMessage(I.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class T extends R.IPCClient{constructor(I,E){const b=new L(I);super(b,E),this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[90],re([0,1,16,3,2,39]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let c=0;function a(S,A){if(!r.has(S)){const $=String(++c);r.set(S,$)}return r.get(S)}function h(S,A,$,_){if(!i.enableDiagnostics)return;const U=a(S,A);if(_ instanceof D.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const k=D.VSBuffer.alloc(_.byteLength);k.set(_),i.records.push({timestamp:Date.now(),id:U,label:A,type:$,buff:k})}else i.records.push({timestamp:Date.now(),id:U,label:A,type:$,data:_})}i.traceSocketEvent=h})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function b(){return E||(E=D.VSBuffer.alloc(0)),E}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,c){if(r===0)return b();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const A=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=r),A}if(this._chunks[0].byteLength>r){const A=this._chunks[0].slice(0,r);return c&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),A}const a=D.VSBuffer.alloc(r);let h=0,S=0;for(;r>0;){const A=this._chunks[S];if(A.byteLength>r){const $=A.slice(0,r);a.set($,h),h+=r,c&&(this._chunks[S]=A.slice(r),this._totalLength-=r),r-=r}else a.set(A,h),h+=A.byteLength,c?(this._chunks.shift(),this._totalLength-=A.byteLength):S++,r-=A.byteLength}return a}}e.ChunkStream=C;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function v(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(r,c,a,h){this.type=r,this.id=c,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends R.Disposable{constructor(r){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new y(a,h,S,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=D.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(c,r.data)}_bufferAdd(r,c){const a=this._totalLength===0;return this._data.push(r,c),this._totalLength+=r.byteLength+c.byteLength,a}_bufferTake(){const r=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,c){this._bufferAdd(r,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class m extends R.Disposable{constructor(r){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new y(1,0,0,r))}}e.Protocol=m;class l extends L.IPCClient{static fromSocket(r,c){return new l(new m(r),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(r,c,a=null){super(r,c,a),this.protocol=r}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=l;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class u{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}length(){let r=0,c=this._first;for(;c;)c=c.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let c=0,a=this._first;for(;a;)r[c++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const c=new u(r);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class s{static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}constructor(){this.lastRuns=[];const r=Date.now();for(let c=0;c<s._HISTORY_LENGTH;c++)this.lastRuns[c]=r-1e3*c;setInterval(()=>{for(let c=s._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const r=Date.now(),c=(1+s._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<s._HISTORY_LENGTH;h++)r-this.lastRuns[h]<=c&&a++;return 1-a/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(r,c=null,a=s.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new y(5,0,0,b());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new y(7,0,0,b());this._socketWriter.write(r)}sendResume(){const r=new y(8,0,0,b());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,c){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new y(3,0,this._incomingAckId,b());this._socketWriter.write(r);const c=this._outgoingUnackMsg.toArray();for(let a=0,h=c.length;a<h;a++)this._socketWriter.write(c[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new y(6,0,0,b())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let a=0,h=c.length;a<h;a++)this._socketWriter.write(c[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new y(1,c,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const c=new y(2,0,0,r);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),c=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-c,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new y(3,0,this._incomingAckId,b());this._socketWriter.write(r)}_sendKeepAlive(){const r=new y(9,0,0,b());this._socketWriter.write(r)}}e.PersistentProtocol=n}),define(ne[139],re([0,1,91,3,39,138]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends R.IPCServer{static getOnDidClientConnect(){const I=t.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,b)=>b);return t.Event.map(I,E=>{const{port1:b,port2:C}=new MessageChannel,v={protocol:new L.Protocol(b),onDidClientDisconnect:t.Event.fromDOMEventEmitter(b,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),v})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[67],re([0,1,48,6,16,23,132,9,3,2,32,89,83,39]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends v.ChannelServer{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=g;class y{constructor(d,m){this.modulePath=d,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(l),this.child=null,this._client=null}getChannel(d){const m=this;return{call(l,f,u){return m.requestPromise(d,l,f,u)},listen(l,f){return m.requestEvent(d,l,f)}}}requestPromise(d,m,l,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(d),o=(0,t.createCancelablePromise)(i=>u.call(m,l,i)),s=f.onCancellationRequested(()=>o.cancel()),n=(0,E.toDisposable)(()=>o.cancel());return this.activeRequests.add(n),o.finally(()=>{s.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(d,m,l){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let f;const u=new I.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(d).listen(m,l)(u.fire,u),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,p.removeDangerousEnvVariables)(m.env),this.child=(0,D.fork)(this.modulePath,d,m);const l=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}l.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const u=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,o=r=>this.child&&this.child.connected&&u.send(r.buffer.toString("base64")),s=l.event,n={send:o,onMessage:s};this._client=new v.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,c)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,E.dispose)(a)),this.activeRequests.clear(),r!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:c})})}return this._client}getCachedChannel(d){let m=this.channels.get(d);return m||(m=this.client.getChannel(d),this.channels.set(d,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(ne[140],re([0,1,16,9,3,2,10,4,30,39,90]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class p{traceSocketEvent(a,h){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,h)}constructor(a,h=""){this._canWrite=!0,this.debugLabel=h,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=S=>{if(this.traceSocketEvent("error",{code:S?.code,message:S?.message}),S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}},this.socket.on("error",this._errorListener),this._closeListener=S=>{this.traceSocketEvent("close",{hadError:S}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const h=S=>{this.traceSocketEvent("read",S),a(D.VSBuffer.wrap(S))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(a){const h=S=>{a({type:0,hadError:S,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(a){const h=()=>{a()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=p;var v;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var g;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(g||(g={}));class y extends L.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,h){this.socket.traceSocketEvent(a,h)}constructor(a,h,S,A){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:S?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new w(this,h,S,A,this._onData,($,_)=>this._write($,_))),this._register(this._flowManager.onError($=>{console.error($),(0,t.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,h){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let S=2;a.byteLength<126?S+=0:a.byteLength<2**16?S+=2:S+=8;const A=D.VSBuffer.alloc(S);if(h?A.writeUInt8(194,0):A.writeUInt8(130,0),a.byteLength<126)A.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){A.writeUInt8(126,1);let $=1;A.writeUInt8(a.byteLength>>>8&255,++$),A.writeUInt8(a.byteLength>>>0&255,++$)}else{A.writeUInt8(127,1);let $=1;A.writeUInt8(0,++$),A.writeUInt8(0,++$),A.writeUInt8(0,++$),A.writeUInt8(0,++$),A.writeUInt8(a.byteLength>>>24&255,++$),A.writeUInt8(a.byteLength>>>16&255,++$),A.writeUInt8(a.byteLength>>>8&255,++$),A.writeUInt8(a.byteLength>>>0&255,++$)}this.socket.write(D.VSBuffer.concat([A,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),S=h.readUInt8(0),A=(S&128)>>>7,$=(S&64)>>>6,_=h.readUInt8(1),U=(_&128)>>>7,k=_&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(k===126?2:0)+(k===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),S=h.readUInt8(1),A=(S&128)>>>7;let $=S&127,_=1;$===126?$=h.readUInt8(++_)*2**8+h.readUInt8(++_):$===127&&($=h.readUInt8(++_)*0+h.readUInt8(++_)*0+h.readUInt8(++_)*0+h.readUInt8(++_)*0+h.readUInt8(++_)*2**24+h.readUInt8(++_)*2**16+h.readUInt8(++_)*2**8+h.readUInt8(++_));let U=0;A&&(U=h.readUInt8(++_)*2**24+h.readUInt8(++_)*2**16+h.readUInt8(++_)*2**8+h.readUInt8(++_)),this._state.state=3,this._state.readLen=$,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),l(h,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(h,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class w extends L.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(a,h,S,A,$,_){super(),this._tracer=a,this._onData=$,this._writeFn=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,h?(this._zlibInflateStream=this._register(new d(this._tracer,A,S,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const h=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(h,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,h){return new Promise((S,A)=>{a.write(h),a.flush($=>S($))})}acceptFrame(a,h,S){this._readQueue.push({data:a,isCompressed:h,isLastFrameOfMessage:S}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const h=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(h)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,h,S){return new Promise((A,$)=>{a.write(h),S&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(_=>A(_))})}}class d extends L.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(a,h,S,A){super(),this._tracer=a,this._recordInflateBytes=h,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(A),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(D.VSBuffer.wrap($))}),S&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",S.buffer),this._zlibInflate.write(S.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const h=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(h)})}}class m extends L.Disposable{constructor(a,h){super(),this._tracer=a,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",S=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:S?.message,code:S?.code}),this._onError.fire(S)}),this._zlibDeflate.on("data",S=>{this._tracer.traceSocketEvent("zlibDeflateData",S),this._pendingDeflateData.push(D.VSBuffer.wrap(S))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let h=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.byteLength-4),a(h)})}}function l(c,a){if(a===0)return;const h=c.byteLength>>>2;for(let k=0;k<h;k++){const N=c.readUInt32BE(k*4);c.writeUInt32BE(N^a,k*4)}const S=h*4,A=c.byteLength-S,$=a>>>24&255,_=a>>>16&255,U=a>>>8&255;A>=1&&c.writeUInt8(c.readUInt8(S)^$,S),A>=2&&c.writeUInt8(c.readUInt8(S+1)^_,S+1),A>=3&&c.writeUInt8(c.readUInt8(S+2)^U,S+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function u(){const c=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,T.join)(C().os.tmpdir(),`vscode-ipc-${c}.sock`),s(a),a}e.createRandomIPCHandle=u;function o(c,a,h){const S=C().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${h}-${a}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${h}-${a}.sock`):A=(0,T.join)(c,`${h}-${a}.sock`),s(A),A}e.createStaticIPCHandle=o;function s(c){const a=f[P.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class n extends E.IPCServer{static toClientConnectionEvent(a){const h=R.Event.fromNodeEventEmitter(a,"connection");return R.Event.map(h,S=>({protocol:new b.Protocol(new p(S,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(S,"close"))}))}constructor(a){super(n.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(c){return new Promise((a,h)=>{const S=C().net.createServer();S.on("error",h),S.listen(c,()=>{S.removeListener("error",h),a(new n(S))})})}e.serve=i;function r(c,a){return new Promise((h,S)=>{const A=C().net.createConnection(c,()=>{A.removeListener("error",S),h(b.Client.fromSocket(new p(A,`ipc-client${a}`),a))});A.once("error",S)})}e.connect=r}),define(ne[68],re([0,1,6,3,2,15]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function P(C){const p=C;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class E extends R.Disposable{constructor(p,v=Object.create(null)){super(),this.database=p,this.options=v,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=I.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((v,g)=>this.accept(g,v)),p.deleted?.forEach(v=>this.accept(v,void 0))}accept(p,v){if(this.state===I.Closed)return;let g=!1;(0,L.isUndefinedOrNull)(v)?g=this.cache.delete(p):this.cache.get(p)!==v&&(this.cache.set(p,v),g=!0),g&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===I.None&&(this.state=I.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,v){const g=this.cache.get(p);return(0,L.isUndefinedOrNull)(g)?v:g}getBoolean(p,v){const g=this.get(p);return(0,L.isUndefinedOrNull)(g)?v:g==="true"}getNumber(p,v){const g=this.get(p);return(0,L.isUndefinedOrNull)(g)?v:parseInt(g,10)}async set(p,v){if(this.state===I.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(p);const g=String(v);if(this.cache.get(p)!==g)return this.cache.set(p,g),this.pendingInserts.set(p,g),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===I.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=I.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((v,g)=>this.items.set(g,v)),p.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=b}),define(ne[141],re([11,12]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[142],re([11,12]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[143],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[144],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[145],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[146],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[147],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[148],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[149],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[150],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[151],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[152],re([11,12]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[153],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[154],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[155],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[156],re([11,12]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[157],re([11,12]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[158],re([11,12]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[159],re([11,12]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[160],re([11,12]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[161],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[162],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[163],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[164],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[165],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[166],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[167],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[168],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[169],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[170],re([11,12]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[92],re([0,1,64,63,24,10,37,19,7]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class E{get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=T.env.VSCODE_PORTABLE;return y?I.URI.file((0,L.join)(y,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,L.resolve)(y):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,L.resolve)(y):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,L.resolve)(y);const w=T.env.VSCODE_EXTENSIONS;if(w)return w;const d=T.env.VSCODE_PORTABLE;return d?(0,L.join)(d,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(w=>/^[^:/?#]+?:\/\//.test(w)?I.URI.parse(w):I.URI.file((0,L.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?I.URI.parse(y):I.URI.file((0,L.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(y=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(y))}get extensionLogLevel(){const y=[];for(const w of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);d&&d[1]&&d[2]&&y.push([d[1],d[2]])}return y.length?y:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=T.env.VSCODE_PORTABLE;return y?I.URI.file((0,L.join)(y,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this._args}constructor(y,w,d){this._args=y,this.paths=w,this.productService=d,this.editSessionId=this.args.editSessionId}}pe([t.memoize],E.prototype,"appRoot",null),pe([t.memoize],E.prototype,"userHome",null),pe([t.memoize],E.prototype,"userDataPath",null),pe([t.memoize],E.prototype,"appSettingsHome",null),pe([t.memoize],E.prototype,"tmpDir",null),pe([t.memoize],E.prototype,"cacheHome",null),pe([t.memoize],E.prototype,"stateResource",null),pe([t.memoize],E.prototype,"userRoamingDataHome",null),pe([t.memoize],E.prototype,"userDataSyncHome",null),pe([t.memoize],E.prototype,"userDataSyncLogResource",null),pe([t.memoize],E.prototype,"editSessionsLogResource",null),pe([t.memoize],E.prototype,"sync",null),pe([t.memoize],E.prototype,"machineSettingsResource",null),pe([t.memoize],E.prototype,"workspaceStorageHome",null),pe([t.memoize],E.prototype,"localHistoryHome",null),pe([t.memoize],E.prototype,"keyboardLayoutResource",null),pe([t.memoize],E.prototype,"argvResource",null),pe([t.memoize],E.prototype,"isExtensionDevelopment",null),pe([t.memoize],E.prototype,"untitledWorkspacesHome",null),pe([t.memoize],E.prototype,"installSourcePath",null),pe([t.memoize],E.prototype,"builtinExtensionsPath",null),pe([t.memoize],E.prototype,"extensionsPath",null),pe([t.memoize],E.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],E.prototype,"extensionDevelopmentKind",null),pe([t.memoize],E.prototype,"extensionTestsLocationURI",null),pe([t.memoize],E.prototype,"debugExtensionHost",null),pe([t.memoize],E.prototype,"logLevel",null),pe([t.memoize],E.prototype,"extensionLogLevel",null),pe([t.memoize],E.prototype,"serviceMachineIdResource",null),pe([t.memoize],E.prototype,"telemetryLogResource",null),pe([t.memoize],E.prototype,"disableWorkspaceTrust",null),pe([t.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function b(g,y){return v(g["inspect-extensions"],g["inspect-brk-extensions"],5870,y,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=b;function C(g,y){return v(g["inspect-search"],g["inspect-brk-search"],5876,y,g.extensionEnvironment)}e.parseSearchPort=C;function p(g,y){return v(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,y,g.extensionEnvironment)}e.parsePtyHostPort=p;function v(g,y,w,d,m,l){const u=Number(y||g)||(d?null:w),o=u?Boolean(!!y):!1;let s;if(l)try{s=JSON.parse(l)}catch{}return{port:u,break:o,debugId:m,env:s}}}),define(ne[171],re([0,1,278,4,143]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(y,w,d=T){const m=y.find(c=>c.length>0&&c[0]!=="-"),l={},f=["_"],u=[],o={};let s;for(const c in w){const a=w[c];a.type==="subcommand"?c===m&&(s=a):(a.alias&&(l[c]=a.alias),a.type==="string"||a.type==="string[]"?(f.push(c),a.deprecates&&f.push(...a.deprecates)):a.type==="boolean"&&(u.push(c),a.deprecates&&u.push(...a.deprecates)),a.global&&(o[c]=a))}if(s&&m){const c=o;for(const A in s.options)c[A]=s.options[A];const a=y.filter(A=>A!==m),h=d.getSubcommandReporter?d.getSubcommandReporter(m):void 0,S=P(a,c,h);return{[m]:S}}const n=D(y,{string:f,boolean:u,alias:l}),i={},r=n;i._=n._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in w){const a=w[c];if(a.type==="subcommand")continue;a.alias&&delete r[a.alias];let h=r[c];if(a.deprecates)for(const S of a.deprecates)r.hasOwnProperty(S)&&(h||(h=r[S],h&&d.onDeprecatedOption(S,a.deprecationMessage||(0,R.localize)(36,null,c))),delete r[S]);if(typeof h<"u"){if(a.type==="string[]"){if(Array.isArray(h)||(h=[h]),!a.allowEmptyValue){const S=h.filter(A=>A.length>0);S.length!==h.length&&(d.onEmptyValue(c),h=S.length>0?S:void 0)}}else a.type==="string"&&(Array.isArray(h)?(h=h.pop(),d.onMultipleValues(c,h)):!h&&!a.allowEmptyValue&&(d.onEmptyValue(c),h=void 0));i[c]=h,a.deprecationMessage&&d.onDeprecatedOption(c,a.deprecationMessage)}delete r[c]}for(const c in r)d.onUnknownOption(c);return i}e.parseArgs=P;function I(y,w){let d="";return w.args&&(Array.isArray(w.args)?d=` <${w.args.join("> <")}>`:d=` <${w.args}>`),w.alias?`-${w.alias} --${y}${d}`:`--${y}${d}`}function E(y,w){const d=[];for(const m in y){const l=y[m],f=I(m,l);d.push([f,l.description])}return b(d,w)}e.formatOptions=E;function b(y,w){const m=y.reduce((u,o)=>Math.max(u,o[0].length),12)+2+1;if(w-m<25)return y.reduce((u,o)=>u.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);const l=w-m-1,f=[];for(const u of y){const o=u[0],s=p(u[1],l),n=C(m-o.length-2);f.push("  "+o+n+s[0]);for(let i=1;i<s.length;i++)f.push(C(m)+s[i])}return f}function C(y){return" ".repeat(y)}function p(y,w){const d=[];for(;y.length;){const m=y.length<w?y.length:y.lastIndexOf(" ",w),l=y.slice(0,m).trim();y=y.slice(m),d.push(l)}return d}function v(y,w,d,m,l){const f=process.stdout.isTTY&&process.stdout.columns||80,u=l?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",o=[`${y} ${d}`];o.push(""),o.push(`${(0,R.localize)(38,null)}: ${w} [${(0,R.localize)(39,null)}]${u}`),o.push(""),l?.noPipe!==!0&&(t.isWindows?o.push((0,R.localize)(40,null,w)):o.push((0,R.localize)(41,null,w)),o.push(""));const s={},n=[];for(const i in m){const r=m[i];if(r.type==="subcommand")r.description&&n.push({command:i,description:r.description});else if(r.description&&r.cat){let c=s[r.cat];c||(s[r.cat]=c={}),c[i]=r}}for(const i in s){const r=i,c=s[r];c&&(o.push(L[r]),o.push(...E(c,f)),o.push(""))}return n.length&&(o.push((0,R.localize)(42,null)),o.push(...b(n.map(i=>[i.command,i.description]),f)),o.push("")),o.join(`
`)}e.buildHelpMessage=v;function g(y,w){return`${y||(0,R.localize)(43,null)}
${w||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=g}),define(ne[172],re([0,1,279,144,171]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function T(p,v){const g=(f,u)=>{console.warn((0,t.localize)(0,null,f,u))},y=f=>{console.warn((0,t.localize)(1,null,f))},w=(f,u)=>{console.warn((0,t.localize)(2,null,f,u))},d=f=>({onUnknownOption:u=>{f!=="tunnel"&&console.warn((0,t.localize)(3,null,u,f))},onMultipleValues:g,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:f!=="tunnel"?d:void 0}),m={onUnknownOption:f=>{console.warn((0,t.localize)(4,null,f))},onMultipleValues:g,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:d},l=(0,R.parseArgs)(p,R.OPTIONS,v?m:void 0);return l.goto&&l._.forEach(f=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(5,null))),l["max-memory"]&&D(parseInt(l["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),l}function P(p){const v=p.findIndex(g=>!/^-/.test(g));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function I(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=P(v)||[]);const g=!C(process.env);return T(v,g)}e.parseMainProcessArgv=I;function E(p){let[,,...v]=p;return process.env.VSCODE_DEV&&(v=P(v)||[]),T(v,!0)}e.parseCLIProcessArgv=E;function b(p,...v){const g=p.indexOf("--");return g===-1?p.push(...v):p.splice(g,0,...v),p}e.addArg=b;function C(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function Q(e,D,t){function R(T,P){const I=L(T,P),E=[I];return e.isAbsolute(I)||E.unshift(t),e.resolve(...E)}function L(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,P);const b=T["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,P)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[173],re([280,36,37]),function(e,D,t){return Q(e,D,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[174],re([0,1,36,92,173]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends t.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=L}),define(ne[175],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(w){const d=w.match(T);return d?d[1]:null}function b(w){if(w.indexOf("://")===-1){const d=w.match(t);return d?E(d[2]):null}try{const d=D.URI.parse(w);if(d.authority)return E(d.authority)}catch{}return null}function C(w,d){const m=new Set;let l;for(;l=P.exec(w);){const u=b(l[1]);u&&m.add(u)}const f=new Set(d);return Array.from(m).map(u=>f.has(u)?u:u.replace(I,"a"))}e.getDomainsOfRemotes=C;function p(w){const d=w.match(L);return d?d[2]:null}function v(w,d,m){return w&&d?(m&&d.endsWith(".git")&&(d=d.substr(0,d.length-4)),d.indexOf("/")===0?`${w}${d}`:`${w}/${d}`):null}function g(w,d){if(w.indexOf("://")===-1){const m=w.match(R);if(m)return v(m[2],m[3],d)}try{const m=D.URI.parse(w);if(m.authority)return v(p(m.authority),m.path,d)}catch{}return null}function y(w,d=!1){const m=[];let l;for(;l=P.exec(w);){const f=g(l[1],d);f&&m.push(f)}return m}e.getRemotes=y}),define(ne[176],re([0,1,15,147]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(T,P,I){try{L(T,P,I)}catch{}return T}e.localizeManifest=R;function L(T,P,I){const E=(b,C,p)=>{const v=b[C];if((0,D.isString)(v)){const g=v,y=g.length;if(y>1&&g[0]==="%"&&g[y-1]==="%"){const w=g.substr(1,y-2);let d=P[w];d===void 0&&I&&(d=I[w]);const m=typeof d=="string"?d:d.message;if(m!==void 0){const l=I?.[w],f=typeof l=="string"?l:l?.message;if(p&&(C==="title"||C==="category")&&f&&f!==m){const u={value:m,original:f};b[C]=u}else b[C]=m}else console.warn(`[${T.name}]: ${(0,t.localize)(0,null,w)}`)}}else if((0,D.isObject)(v))for(const g in v)v.hasOwnProperty(g)&&(g==="commands"?E(v,g,!0):E(v,g,p));else if(Array.isArray(v))for(let g=0;g<v.length;g++)E(v,g,p)};for(const b in T)T.hasOwnProperty(b)&&E(T,b)}}),define(ne[177],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,T,P,I){return this.channel.call("promptImportantExtensionsInstallNotification",[L,T,P,I])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class t{constructor(L){this.service=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,P){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(ne[69],re([0,1,19,86,152,55]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(d){return d=d.trim(),d==="*"||T.test(d)}e.isValidVersionStr=I;function E(d){if(!I(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(T);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=E;function b(d){if(!d)return null;const m=d.majorBase,l=d.majorMustEqual,f=d.minorBase;let u=d.minorMustEqual;const o=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(m===0||(u=!1),s=!1);let n=0;if(d.preRelease){const i=P.exec(d.preRelease);if(i){const[,r,c,a]=i;n=Date.UTC(Number(r),Number(c)-1,Number(a))}}return{majorBase:m,majorMustEqual:l,minorBase:f,minorMustEqual:u,patchBase:o,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:n}}e.normalizeVersion=b;function C(d,m,l){let f;typeof d=="string"?f=b(E(d)):f=d;let u;m instanceof Date?u=m.getTime():typeof m=="string"&&(u=new Date(m).getTime());let o;if(typeof l=="string"?o=b(E(l)):o=l,!f||!o)return!1;const s=f.majorBase,n=f.minorBase,i=f.patchBase;let r=o.majorBase,c=o.minorBase,a=o.patchBase;const h=o.notBefore;let S=o.majorMustEqual,A=o.minorMustEqual,$=o.patchMustEqual;return o.isMinimum?s>r?!0:s<r?!1:n>c?!0:n<c||u&&u<h?!1:i>=a:(s===1&&r===0&&(!S||!A||!$)&&(r=1,c=0,a=0,S=!0,A=!1,$=!1),s<r?!1:s>r?!S:n<c?!1:n>c?!A:i<a?!1:i>a?!$:!(u&&u<h))}e.isValidVersion=C;function p(d,m,l,f,u){const o=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return o.push([t.default.Error,R.localize(0,null)]),o;if(typeof f.name!="string")return o.push([t.default.Error,R.localize(1,null,"name")]),o;if(typeof f.version!="string")return o.push([t.default.Error,R.localize(2,null,"version")]),o;if(!f.engines)return o.push([t.default.Error,R.localize(3,null,"engines")]),o;if(typeof f.engines.vscode!="string")return o.push([t.default.Error,R.localize(4,null,"engines.vscode")]),o;if(typeof f.extensionDependencies<"u"&&!w(f.extensionDependencies))return o.push([t.default.Error,R.localize(5,null,"extensionDependencies")]),o;if(typeof f.activationEvents<"u"){if(!w(f.activationEvents))return o.push([t.default.Error,R.localize(6,null,"activationEvents")]),o;if(typeof f.main>"u"&&typeof f.browser>"u")return o.push([t.default.Error,R.localize(7,null,"activationEvents","main")]),o}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&o.push([t.default.Warning,R.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return o.push([t.default.Error,R.localize(9,null,"main")]),o;{const i=(0,D.joinPath)(l,f.main);(0,D.isEqualOrParent)(i,l)||o.push([t.default.Warning,R.localize(10,null,i.path,l.path)])}if(typeof f.activationEvents>"u")return o.push([t.default.Error,R.localize(11,null,"activationEvents","main")]),o}if(typeof f.browser<"u"){if(typeof f.browser!="string")return o.push([t.default.Error,R.localize(12,null,"browser")]),o;{const i=(0,D.joinPath)(l,f.browser);(0,D.isEqualOrParent)(i,l)||o.push([t.default.Warning,R.localize(13,null,i.path,l.path)])}if(typeof f.activationEvents>"u")return o.push([t.default.Error,R.localize(14,null,"activationEvents","browser")]),o}if(!L.valid(f.version))return o.push([t.default.Error,R.localize(15,null)]),o;const s=[];if(!v(d,m,f,u,s))for(const i of s)o.push([t.default.Error,i]);return o}e.validateExtensionManifest=p;function v(d,m,l,f,u){return f||typeof l.main>"u"&&typeof l.browser>"u"?!0:y(d,m,l.engines.vscode,u)}e.isValidExtensionVersion=v;function g(d,m,l){return d==="*"||y(m,l,d)}e.isEngineValid=g;function y(d,m,l,f=[]){const u=b(E(l));if(!u)return f.push(R.localize(16,null,l)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return f.push(R.localize(17,null,l)),!1}else if(!u.majorMustEqual)return f.push(R.localize(18,null,l)),!1;return C(d,m,u)?!0:(f.push(R.localize(19,null,d,l)),!1)}function w(d){if(!Array.isArray(d))return!1;for(let m=0,l=d.length;m<l;m++)if(typeof d[m]!="string")return!1;return!0}}),define(ne[49],re([0,1,16,30]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,T,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const b=(await T.readFile(L.serviceMachineIdResource)).value.toString();I=(0,t.isUUID)(b)?b:null}catch{I=null}if(!I){I=(0,t.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=R}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,L=[],T=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ne[93],re([0,1,56]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function L(P,I,E){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(E))),t.push([P,I])}e.registerSingleton=L;function T(){return t}e.getSingletonServiceDescriptors=T}),define(ne[178],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class t{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const P=this.lookupOrInsertNode(L),I=this.lookupOrInsertNode(T);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let P=this._nodes.get(T);return P||(P=new D(T,L),this._nodes.set(T,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,P]of this._nodes)L.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const P=new Set([L]),I=this._findCycle(T,P);if(I)return I}}_findCycle(L,T){for(const[P,I]of L.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const E=this._findCycle(I,T);if(E)return E;T.delete(P)}}}e.Graph=t}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function t(T,P,I){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:T,index:I}):(P[D.DI_DEPENDENCIES]=[{id:T,index:I}],P[D.DI_TARGET]=P)}function R(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const P=function(I,E,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,I,b)};return P.toString=()=>T,D.serviceIds.set(T,P),P}e.createDecorator=R;function L(T){return T}e.refineServiceDecorator=L}),define(ne[179],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[17],re([0,1,15,7,5]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=L;function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function E(d,m){const l=Object.create(null);for(const f in d)b(l,f,d[f],m);return l}e.toValuesTree=E;function b(d,m,l,f){const u=m.split("."),o=u.pop();let s=d;for(let n=0;n<u.length;n++){const i=u[n];let r=s[i];switch(typeof r){case"undefined":r=s[i]=Object.create(null);break;case"object":break;default:f(`Ignoring ${m} as ${u.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[o]=l}catch{f(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${m} as ${u.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=b;function C(d,m){const l=m.split(".");p(d,l)}e.removeFromValueTree=C;function p(d,m){const l=m.shift();if(m.length===0){delete d[l];return}if(Object.keys(d).indexOf(l)!==-1){const f=d[l];typeof f=="object"&&!Array.isArray(f)&&(p(f,m),Object.keys(f).length===0&&delete d[l])}}function v(d,m,l){function f(s,n){let i=s;for(const r of n){if(typeof i!="object"||i===null)return;i=i[r]}return i}const u=m.split("."),o=f(d,u);return typeof o>"u"?l:o}e.getConfigurationValue=v;function g(d,m,l){Object.keys(m).forEach(f=>{f!=="__proto__"&&(f in d?D.isObject(d[f])&&D.isObject(m[f])?g(d[f],m[f],l):l&&(d[f]=m[f]):d[f]=m[f])})}e.merge=g;function y(d,m,l){const f=d.inspect(m),u=d.inspect(l);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:f.defaultValue}e.getMigratedSettingValue=y;function w(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ne[180],re([0,1,4,27,5]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",D.isEdge),L.set("isFirefox",D.isFirefox),L.set("isChrome",D.isChrome),L.set("isSafari",D.isSafari);const T=Object.prototype.hasOwnProperty;var P;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return p.INSTANCE}static has(k){return v.create(k)}static equals(k,N){return g.create(k,N)}static notEquals(k,N){return d.create(k,N)}static regex(k,N){return n.create(k,N)}static in(k,N){return y.create(k,N)}static notIn(k,N){return w.create(k,N)}static not(k){return m.create(k)}static and(...k){return c.create(k,null)}static or(...k){return a.create(k,null,!0)}static greater(k,N){return f.create(k,N)}static greaterEquals(k,N){return u.create(k,N)}static smaller(k,N){return o.create(k,N)}static smallerEquals(k,N){return s.create(k,N)}static deserialize(k,N=!1){if(!!k)return this._deserializeOrExpression(k,N)}static _deserializeOrExpression(k,N){const F=k.split("||");return a.create(F.map(q=>this._deserializeAndExpression(q,N)),null,!0)}static _deserializeAndExpression(k,N){const F=k.split("&&");return c.create(F.map(q=>this._deserializeOne(q,N)),null)}static _deserializeOne(k,N){if(k=k.trim(),k.indexOf("!=")>=0){const F=k.split("!=");return d.create(F[0].trim(),this._deserializeValue(F[1],N))}if(k.indexOf("==")>=0){const F=k.split("==");return g.create(F[0].trim(),this._deserializeValue(F[1],N))}if(k.indexOf("=~")>=0){const F=k.split("=~");return n.create(F[0].trim(),this._deserializeRegexValue(F[1],N))}if(k.indexOf(" not in ")>=0){const F=k.split(" not in ");return w.create(F[0].trim(),this._deserializeValue(F[1],N))}if(k.indexOf(" in ")>=0){const F=k.split(" in ");return y.create(F[0].trim(),this._deserializeValue(F[1],N))}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const F=k.split(">=");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const F=k.split(">");return f.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const F=k.split("<=");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const F=k.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(k)?m.create(k.substr(1).trim()):v.create(k)}static _deserializeValue(k,N){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const F=/^'([^']*)'$/.exec(k);return F?F[1].trim():k}static _deserializeRegexValue(k,N){if((0,t.isFalsyOrWhitespace)(k)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=k.indexOf("/"),q=k.lastIndexOf("/");if(F===q||F<0){if(N)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const J=k.slice(F+1,q),j=k[q+1]==="i"?"i":"";try{return new RegExp(J,j)}catch(H){if(N)throw new Error(`bad regexp-value '${k}', parse error: ${H}`);return console.warn(`bad regexp-value '${k}', parse error: ${H}`),null}}}e.ContextKeyExpr=I;function E(U,k){const N=U?U.substituteConstants():void 0,F=k?k.substituteConstants():void 0;return!N&&!F?!0:!N||!F?!1:N.equals(F)}e.expressionsAreEqualWithConstantSubstitution=E;function b(U,k){return U.cmp(k)}class C{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class p{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class v{static create(k,N=null){const F=L.get(k);return typeof F=="boolean"?F?p.INSTANCE:C.INSTANCE:new v(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:S(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?p.INSTANCE:C.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class g{static create(k,N,F=null){if(typeof N=="boolean")return N?v.create(k,F):m.create(k,F);const q=L.get(k);return typeof q=="boolean"?N===(q?"true":"false")?p.INSTANCE:C.INSTANCE:new g(k,N,F)}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?p.INSTANCE:C.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class y{static create(k,N){return new y(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.valueKey),F=k.getValue(this.key);return Array.isArray(N)?N.includes(F):typeof F=="string"&&typeof N=="object"&&N!==null?T.call(N,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=y;class w{static create(k,N){return new w(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=11,this._negated=y.create(k,N)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class d{static create(k,N,F=null){if(typeof N=="boolean")return N?m.create(k,F):v.create(k,F);const q=L.get(k);return typeof q=="boolean"?N===(q?"true":"false")?C.INSTANCE:p.INSTANCE:new d(k,N,F)}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?C.INSTANCE:p.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class m{static create(k,N=null){const F=L.get(k);return typeof F=="boolean"?F?C.INSTANCE:p.INSTANCE:new m(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:S(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?C.INSTANCE:p.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function l(U,k){if(typeof U=="string"){const N=parseFloat(U);isNaN(N)||(U=N)}return typeof U=="string"||typeof U=="number"?k(U):C.INSTANCE}class f{static create(k,N,F=null){return l(N,q=>new f(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class u{static create(k,N,F=null){return l(N,q=>new u(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class o{static create(k,N,F=null){return l(N,q=>new o(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class s{static create(k,N,F=null){return l(N,q=>new s(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class n{static create(k,N){return new n(k,N)}constructor(k,N){this.key=k,this.regexp=N,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const N=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return N<F?-1:N>F?1:0}equals(k){if(k.type===this.type){const N=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return this.key===k.key&&N===F}return!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{static create(k){return new i(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new i(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(U){let k=null;for(let N=0,F=U.length;N<F;N++){const q=U[N].substituteConstants();if(U[N]!==q&&k===null){k=[];for(let J=0;J<N;J++)k[J]=U[J]}k!==null&&(k[N]=q)}return k===null?U:k}class c{static create(k,N){return c._normalizeArr(k,N)}constructor(k,N){this.expr=k,this.negated=N,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const q=b(this.expr[N],k.expr[N]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=r(this.expr);return k===this.expr?this:c.create(k,this.negated)}evaluate(k){for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].evaluate(k))return!1;return!0}static _normalizeArr(k,N){const F=[];let q=!1;for(const J of k)if(!!J){if(J.type===1){q=!0;continue}if(J.type===0)return C.INSTANCE;if(J.type===6){F.push(...J.expr);continue}F.push(J)}if(F.length===0&&q)return p.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(b);for(let J=1;J<F.length;J++)F[J-1].equals(F[J])&&(F.splice(J,1),J--);if(F.length===1)return F[0];for(;F.length>1;){const J=F[F.length-1];if(J.type!==9)break;F.pop();const j=F.pop(),H=F.length===0,W=a.create(J.expr.map(z=>c.create([z,j],null)),null,H);W&&(F.push(W),F.sort(b))}return F.length===1?F[0]:new c(F,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new c(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());this.negated=a.create(k,this,!0)}return this.negated}}class a{static create(k,N,F){return a._normalizeArr(k,N,F)}constructor(k,N){this.expr=k,this.negated=N,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const q=b(this.expr[N],k.expr[N]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=r(this.expr);return k===this.expr?this:a.create(k,this.negated,!1)}evaluate(k){for(let N=0,F=this.expr.length;N<F;N++)if(this.expr[N].evaluate(k))return!0;return!1}static _normalizeArr(k,N,F){let q=[],J=!1;if(k){for(let j=0,H=k.length;j<H;j++){const W=k[j];if(!!W){if(W.type===0){J=!0;continue}if(W.type===1)return p.INSTANCE;if(W.type===9){q=q.concat(W.expr);continue}q.push(W)}}if(q.length===0&&J)return C.INSTANCE;q.sort(b)}if(q.length!==0){if(q.length===1)return q[0];for(let j=1;j<q.length;j++)q[j-1].equals(q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0];if(F){for(let j=0;j<q.length;j++)for(let H=j+1;H<q.length;H++)$(q[j],q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0]}return new a(q,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new a(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());for(;k.length>1;){const N=k.shift(),F=k.shift(),q=[];for(const j of _(N))for(const H of _(F))q.push(c.create([j,H],null));const J=k.length===0;k.unshift(a.create(q,null,J))}this.negated=k[0]}return this.negated}}class h extends v{static all(){return h._info.values()}constructor(k,N,F){super(k,null),this._defaultValue=N,typeof F=="object"?h._info.push({...F,key:k}):F!==!0&&h._info.push({key:k,description:F,type:N!=null?typeof N:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return g.create(this.key,k)}notEqualsTo(k){return d.create(this.key,k)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function S(U,k){return U<k?-1:U>k?1:0}function A(U,k,N,F){return U<N?-1:U>N?1:k<F?-1:k>F?1:0}function $(U,k){if(k.type===6&&U.type!==9&&U.type!==6){for(const q of k.expr)if(U.equals(q))return!0}const N=U.negate(),F=_(N).concat(_(k));F.sort(b);for(let q=0;q<F.length;q++){const j=F[q].negate();for(let H=q+1;H<F.length;H++){const W=F[H];if(j.equals(W))return!0}}return!1}e.implies=$;function _(U){return U.type===9?U.expr:[U]}}),define(ne[94],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t;class R{async getPerformanceInfo(T,P){return{}}async getSystemInfo(T,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,P){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=R}),define(ne[95],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[13],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,146,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(d,m){switch(d){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(d,m){return m==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(d,m,l){return P(m,l)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===l?!0:E(l).includes(d)}e.isTargetPlatformCompatible=I;function E(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=b;var C;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var p;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var v;(function(d){d.Install="install",d.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var y;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(m,l){super(m),this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[181],re([0,1,3,2,66,32,7,133,29]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(w,d){return T.URI.revive(d?d.transformIncoming(w):w)}function b(w,d){return d?d.transformOutgoingURI(w):w}function C(w,d){d=d||P.DefaultURITransformer;const m=w.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...w,manifest:void 0},d),manifest:m}}function p(w,d){return d?(0,L.cloneAndChange)(w,m=>m instanceof T.URI?d.transformOutgoingURI(m):void 0):w}class v{constructor(d,m){this.service=d,this.getUriTransformer=m,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,m){const l=this.getUriTransformer(d);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,f=>f.map(u=>({...u,local:u.local?p(u.local,l):u.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,m,l){const f=this.getUriTransformer(d);switch(m){case"zip":return this.service.zip(C(l[0],f)).then(u=>b(u,f));case"unzip":return this.service.unzip(E(l[0],f));case"install":return this.service.install(E(l[0],f),(0,R.revive)(l[1]));case"getManifest":return this.service.getManifest(E(l[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(l[0]);case"installFromGallery":return this.service.installFromGallery(l[0],(0,R.revive)(l[1]));case"uninstall":return this.service.uninstall(C(l[0],f),(0,R.revive)(l[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(C(l[0],f));case"getInstalled":return this.service.getInstalled(l[0],T.URI.revive(l[1])).then(u=>u.map(o=>p(o,f)));case"getMetadata":return this.service.getMetadata(C(l[0],f));case"updateMetadata":return this.service.updateMetadata(C(l[0],f),l[1]).then(u=>p(u,f));case"updateExtensionScope":return this.service.updateExtensionScope(C(l[0],f),l[1]).then(u=>p(u,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class g extends t.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(d){super(),this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(l=>({...l,local:l.local?C(l.local,null):l.local,source:this.isUriComponents(l.source)?T.URI.revive(l.source):l.source,profileLocation:T.URI.revive(l.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire({identifier:m.identifier,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire({...m,profileLocation:T.URI.revive(m.profileLocation)})))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const m=await this.getTargetPlatform();return d.allTargetPlatforms.some(l=>(0,I.isTargetPlatformCompatible)(l,d.allTargetPlatforms,m))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(m=>T.URI.revive(m)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,m){return Promise.resolve(this.channel.call("install",[d,m])).then(l=>C(l,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,m){return Promise.resolve(this.channel.call("installFromGallery",[d,m])).then(l=>C(l,null))}uninstall(d,m){return Promise.resolve(this.channel.call("uninstall",[d,m]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null,m){return Promise.resolve(this.channel.call("getInstalled",[d,m])).then(l=>l.map(f=>C(f,null)))}getMetadata(d){return Promise.resolve(this.channel.call("getMetadata",[d]))}updateMetadata(d,m){return Promise.resolve(this.channel.call("updateMetadata",[d,m])).then(l=>C(l,null))}updateExtensionScope(d,m){return Promise.resolve(this.channel.call("updateExtensionScope",[d,m])).then(l=>C(l,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class y{constructor(d){this.service=d}listen(d,m){throw new Error("Invalid listen")}call(d,m,l){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(ne[96],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function R(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var L;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],re([0,1,34,10,27,15,7,154,5]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function E(j){return j.create===!0}e.isFileOpenForWriteOptions=E;var b;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var C;(function(j){j[j.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var p;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=v;function g(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=g;function y(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=y;function w(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;function m(j){return v(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var l;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(H,W){super(H),this.code=W}}e.FileSystemProviderError=f;function u(j,H){const W=new f(j.toString(),H);return s(W,H),W}e.createFileSystemProviderError=u;function o(j){return j||u((0,P.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=o;function s(j,H){return j.name=H?`${H} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=s;function n(j){if(!j)return l.Unknown;if(j instanceof f)return j.code;const H=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!H)return l.Unknown;switch(H[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=n;function i(j){if(j instanceof A)return j.fileOperationResult;switch(n(j)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(H,W,z){this.resource=H,this.operation=W,this.target=z}isOperation(H){return this.operation===H}}e.FileOperationEvent=c;var a;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const z=new Map;for(const K of H){const X=z.get(K.type);switch(X?X.push([K.resource,K]):z.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,X]of z)switch(K){case 1:this.added=D.TernarySearchTree.forUris(()=>W),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>W),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>W),this.deleted.fill(X);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...z){if(!H)return!1;const K=z.length>0;return!!((!K||z.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!K||z.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!K||z.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function S(j,H,W){return!j||!H||j===H||H.length>j.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),W?(0,R.startsWithIgnoreCase)(j,H):j.indexOf(H)===0)}e.isParent=S;class A extends Error{constructor(H,W,z){super(H),this.fileOperationResult=W,this.options=z}}e.FileOperationError=A;class $ extends A{constructor(H,W,z){super(H,2,z),this.stat=W}}e.NotModifiedSinceFileOperationError=$;var _;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=k;async function N(j,H){if(!H.hasProvider(T.URI.from({scheme:j.scheme})))return new Promise(W=>{const z=H.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===j.scheme&&K.added&&(z.dispose(),W())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(H){return(0,L.isNumber)(H)||(H=0),H<F.KB?(0,P.localize)(1,null,H.toFixed(0)):H<F.MB?(0,P.localize)(2,null,(H/F.KB).toFixed(2)):H<F.GB?(0,P.localize)(3,null,(H/F.MB).toFixed(2)):H<F.TB?(0,P.localize)(4,null,(H/F.GB).toFixed(2)):(0,P.localize)(5,null,(H/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var q;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function J(j){return{maxFileSize:j===0?300*F.MB:16*F.GB,maxHeapSize:j===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=J});var Y=this&&this.__param||function(Q,e){return function(D,t){e(D,t,Q)}};define(ne[182],re([0,1,97,42,14]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const I=(await this.fileService.readFileStream(P)).value;return new Promise((E,b)=>{const C=(0,D.createHash)("md5");(0,t.listenStream)(I,{onData:p=>C.update(p.buffer),onError:p=>b(p),onEnd:()=>E(C.digest("base64").replace(/=+$/,""))})})}};L=pe([Y(0,R.IFileService)],L),e.ChecksumService=L}),define(ne[183],re([0,1,16,38,9,3,2,42,7,30,14]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends T.Disposable{constructor(v,g){super(),this.channel=v,this.extraCapabilities=g,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,g){const{buffer:y}=await this.channel.call("readFile",[v,g]);return y}readFileStream(v,g,y){const w=(0,P.newWriteableStream)(m=>D.VSBuffer.concat(m.map(l=>D.VSBuffer.wrap(l))).buffer),d=this.channel.listen("readFileStream",[v,g])(m=>{if(m instanceof D.VSBuffer)w.write(m.buffer);else{if(m==="end")w.end();else{let l=m;l instanceof Error||(l=(0,b.createFileSystemProviderError)((0,t.toErrorMessage)(l),b.FileSystemProviderErrorCode.Unknown)),w.error(l),w.end()}d.dispose()}});return y.onCancellationRequested(()=>{w.error((0,R.canceled)()),w.end(),d.dispose()}),w}writeFile(v,g,y){return this.channel.call("writeFile",[v,D.VSBuffer.wrap(g),y])}open(v,g){return this.channel.call("open",[v,g])}close(v){return this.channel.call("close",[v])}async read(v,g,y,w,d){const[m,l]=await this.channel.call("read",[v,g,d]);return y.set(m.buffer.slice(0,l),w),l}write(v,g,y,w,d){return this.channel.call("write",[v,g,D.VSBuffer.wrap(y),w,d])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,g){return this.channel.call("delete",[v,g])}rename(v,g,y){return this.channel.call("rename",[v,g,y])}copy(v,g,y){return this.channel.call("copy",[v,g,y])}cloneFile(v,g){return this.channel.call("cloneFile",[v,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const g=v;this._onDidChange.fire(g.map(y=>({resource:I.URI.revive(y.resource),type:y.type})))}else{const g=v;this._onDidWatchError.fire(g)}}))}watch(v,g){const y=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,y,v,g]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=C}),define(ne[98],re([0,1,16,9,155,14]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(b,C,p,v,g,y){let w;try{await P(b,C,p,v,g,y)}catch(d){w=d}finally{w&&g.errorTransformer&&(w=g.errorTransformer(w)),typeof w<"u"&&p.error(w),p.end()}}e.readFileIntoStream=T;async function P(b,C,p,v,g,y){I(y);const w=await b.open(C,{create:!1});try{I(y);let d=0,m=0,l=g&&typeof g.length=="number"?g.length:void 0,f=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),u=g&&typeof g.position=="number"?g.position:0,o=0;do m=await b.read(w,u,f.buffer,o,f.byteLength-o),u+=m,o+=m,d+=m,typeof l=="number"&&(l-=m),o===f.byteLength&&(await p.write(v(f)),f=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),o=0);while(m>0&&(typeof l!="number"||l>0)&&I(y)&&E(d,g));if(o>0){let s=o;typeof l=="number"&&(s=Math.min(o,l)),p.write(v(f.slice(0,s)))}}catch(d){throw(0,L.ensureFileSystemProviderError)(d)}finally{await b.close(w)}}function I(b){if(b.isCancellationRequested)throw(0,t.canceled)();return!0}function E(b,C){if(C?.limits){if(typeof C.limits.memory=="number"&&b>C.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&b>C.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,87,2,10,4,7,14]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(d){return d.recursive===!0}e.isRecursiveWatchRequest=I;class E extends t.Disposable{constructor(m,l,f,u){super(),this.onFileChanges=m,this.onLogMessage=l,this.verboseLogging=f,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(l=>this.onFileChanges(l))),m.add(this.watcher.onDidLogMessage(l=>this.onLogMessage(l))),m.add(this.watcher.onDidError(l=>this.onError(l)))}onError(m){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class b extends E{constructor(m,l,f){super(m,l,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class C extends E{constructor(m,l,f){super(m,l,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function p(d){return d.map(m=>({type:m.type,resource:T.URI.file(m.path)}))}e.toFileChanges=p;function v(d){const m=new w;for(const l of d)m.processEvent(l);return m.coalesce()}e.coalesceEvents=v;function g(d,m){return typeof m=="string"&&!m.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(m)?{base:d,pattern:m}:m}e.normalizeWatcherPattern=g;function y(d,m){const l=[];for(const f of m)l.push((0,D.parse)(g(d,f)));return l}e.parseWatcherPatterns=y;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return L.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const l=this.mapPathToChange.get(this.toKey(m));let f=!1;if(l){const u=l.type,o=m.type;l.path!==m.path&&(m.type===2||m.type===1)?f=!0:u===1&&o===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(l)):u===2&&o===1?l.type=0:u===1&&o===0||(l.type=o)}else f=!0;f&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],l=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(m.push(f),!1):!0).sort((f,u)=>f.path.length-u.path.length).filter(f=>l.some(u=>(0,P.isParent)(f.path,u,!L.isLinux))?!1:(l.push(f.path),!0)).concat(m)}}}),define(ne[184],re([0,1,54,6,23,47,2,85,10,4,135,28,57]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends T.Disposable{constructor(w,d,m,l){super(),this.request=w,this.onDidFilesChange=d,this.onLogMessage=m,this.verboseLogging=l,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await C.Promises.stat(w);this._register(await this.doWatch(w,d.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let d=w.path;try{d=await C.Promises.realpath(w.path),w.path===d&&(d=await(0,b.realcase)(w.path)??w.path),w.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${d})`)}catch{}return d}async doWatch(w,d){if(E.isMacintosh&&(0,L.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const m=new R.CancellationTokenSource(this.cts.token),l=new T.DisposableStore;try{const f=(0,I.basename)(w),u=(0,D.watch)(w);l.add((0,T.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${w}'`);const o=new Set;if(d)try{for(const n of await C.Promises.readdir(w))o.add(n)}catch(n){this.error(n)}const s=new Map;l.add((0,T.toDisposable)(()=>{for(const[,n]of s)n.dispose();s.clear()})),u.on("error",(n,i)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),u.on("change",(n,i)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let r="";if(i&&(r=i.toString(),E.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!(!r||n!=="change"&&n!=="rename"))if(d)if(n==="rename"){s.get(r)?.dispose();const c=setTimeout(async()=>{if(s.delete(r),r===f&&!await C.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,I.join)(w,r));if(m.token.isCancellationRequested)return;let h;a?o.has(r)?h=0:(h=1,o.add(r)):(o.delete(r),h=2),this.onFileChange({path:(0,I.join)(this.request.path,r),type:h})},v.FILE_DELETE_HANDLER_DELAY);s.set(r,(0,T.toDisposable)(()=>clearTimeout(c)))}else{let c;o.has(r)?c=0:(c=1,o.add(r)),this.onFileChange({path:(0,I.join)(this.request.path,r),type:c})}else if(n==="rename"||r!==f){const c=setTimeout(async()=>{const a=await C.Promises.exists(w);m.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),l.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);l.clear(),l.add((0,T.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await C.Promises.exists(w)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${f.toString()})`)}return(0,T.toDisposable)(()=>{m.dispose(!0),l.dispose()})}async onFileChange(w,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!d&&this.excludes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const l=(0,p.coalesceEvents)(m);if(l.length>0){if(this.verboseLogging)for(const u of l)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(l)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(E.isLinux)return C.Promises.exists(w);try{const d=(0,I.basename)(w);return(await C.Promises.readdir((0,I.dirname)(w))).some(l=>l===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function g(y,w,d,m,l=512){const f=await C.Promises.open(y,"r"),u=Buffer.allocUnsafe(l),o=new R.CancellationTokenSource(m);let s,n=!1;const i={path:y,excludes:[],recursive:!1},r=new v(i,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:h}=await C.Promises.read(f,u,0,l,null);if(!h||o.token.isCancellationRequested)break;w(u.slice(0,h))}}catch(h){s=new Error(h),o.dispose(!0)}finally{n=!1}}})()});return await r.ready,d(),new Promise((c,a)=>{o.token.onCancellationRequested(async()=>{r.dispose();try{await C.Promises.close(f)}catch(h){s=new Error(h)}s?a(s):c()})})}e.watchFileContents=g}),define(ne[185],re([0,1,3,87,2,4,184]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const b=this.normalizeRequests(E),C=b.filter(v=>{const g=this.watchers.get(v.path);return g?!(0,t.patternsEquals)(g.request.excludes,v.excludes)||!(0,t.patternsEquals)(g.request.includes,v.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:v})=>!b.find(g=>g.path===v.path&&(0,t.patternsEquals)(g.excludes,v.excludes)&&(0,t.patternsEquals)(g.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.trace(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const v of p)this.stopWatching(v);for(const v of C)this.startWatching(v)}startWatching(E){const b=new T.NodeJSFileWatcherLibrary(E,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),C={request:E,instance:b};this.watchers.set(E.path,C)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const b=this.watchers.get(E);b&&(this.watchers.delete(E),b.instance.dispose())}normalizeRequests(E){const b=new Map;for(const C of E){const p=L.isLinux?C.path:C.path.toLowerCase();b.set(p,C)}return Array.from(b.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,b]of this.watchers)b.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,b){return b?`[File Watcher (node.js)] ${E} (path: ${b.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=P}),define(ne[186],re([0,1,57,185]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(T,P,I){super(T,P,I),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(ne[187],re([0,1,24,39,67,57]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(I,E,b){super(I,E,b),this.init()}createWatcher(I){const E=I.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(E.onDidProcessExit(({code:b,signal:C})=>this.onError(`terminated by itself with code ${b}, signal: ${C}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[70],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[L,T]of R)this.set(L,T)}set(R,L){const T=this._entries.get(R);return this._entries.set(R,L),T}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(ne[188],re([0,1,6,9,2,56,178,5,70,81]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class p{constructor(w=new I.ServiceCollection,d=!1,m,l=b){this._services=w,this._strict=d,this._parent=m,this._enableTracing=l,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=l?m?._globalGraph??new T.Graph(f=>f):void 0}createChild(w){return new p(w,this._strict,this,this._enableTracing)}invokeFunction(w,...d){const m=g.traceInvocation(this._enableTracing,w);let l=!1;try{return w({get:u=>{if(l)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(u,m);if(!o)throw new Error(`[invokeFunction] unknown service '${u}'`);return o}},...d)}finally{l=!0,m.stop()}}createInstance(w,...d){let m,l;return w instanceof L.SyncDescriptor?(m=g.traceCreation(this._enableTracing,w.ctor),l=this._createInstance(w.ctor,w.staticArguments.concat(d),m)):(m=g.traceCreation(this._enableTracing,w),l=this._createInstance(w,d,m)),m.stop(),l}_createInstance(w,d=[],m){const l=P._util.getServiceDependencies(w).sort((o,s)=>o.index-s.index),f=[];for(const o of l){const s=this._getOrCreateServiceInstance(o.id,m);s||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${o.id}.`,!1),f.push(s)}const u=l.length>0?l[0].index:d.length;if(d.length!==u){console.trace(`[createInstance] First service dependency of ${w.name} at position ${u+1} conflicts with ${d.length} static arguments`);const o=u-d.length;o>0?d=d.concat(new Array(o)):d=d.slice(0,u)}return Reflect.construct(w,d.concat(f))}_setServiceInstance(w,d){if(this._services.get(w)instanceof L.SyncDescriptor)this._services.set(w,d);else if(this._parent)this._parent._setServiceInstance(w,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const d=this._services.get(w);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):d}_getOrCreateServiceInstance(w,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const m=this._getServiceInstanceOrDescriptor(w);return m instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,m,d.branch(w,!0)):(d.branch(w,!1),m)}_safeCreateAndCacheServiceInstance(w,d,m){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,d,m)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,d,m){const l=new T.Graph(o=>o.id.toString());let f=0;const u=[{id:w,desc:d,_trace:m}];for(;u.length;){const o=u.pop();if(l.lookupOrInsertNode(o),f++>1e3)throw new C(l);for(const s of P._util.getServiceDependencies(o.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(s.id);if(n||this._throwIfStrict(`[createInstance] ${w} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(o.id),String(s.id)),n instanceof L.SyncDescriptor){const i={id:s.id,desc:n,_trace:o._trace.branch(s.id,!0)};l.insertEdge(o,i),u.push(i)}}}for(;;){const o=l.roots();if(o.length===0){if(!l.isEmpty())throw new C(l);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof L.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}l.removeNode(s)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,d,m=[],l,f){if(this._services.get(w)instanceof L.SyncDescriptor)return this._createServiceInstance(w,d,m,l,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,d,m,l,f);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(w,d,m=[],l,f){if(l){const u=new p(void 0,this._strict,this,this._enableTracing);u._globalGraphImplicitDependency=String(w);const o=new Map,s=new D.IdleValue(()=>{const n=u._createInstance(d,m,f);for(const[i,r]of o){const c=n[i];if(typeof c=="function")for(const a of r)c.apply(n,a)}return o.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!s.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=o.get(i);return a||(a=new E.LinkedList,o.set(i,a)),(S,A,$)=>{const _=a.push([S,A,$]);return(0,R.toDisposable)(_)}}if(i in n)return n[i];const r=s.value;let c=r[i];return typeof c!="function"||(c=c.bind(r),n[i]=c),c},set(n,i,r){return s.value[i]=r,!0}})}else return this._createInstance(d,m,f)}_throwIfStrict(w,d){if(d&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=p;var v;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(v||(v={}));class g{static traceInvocation(w,d){return w?new g(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(w,d){return w?new g(0,d.name):g._None}constructor(w,d){this.type=w,this.name=d,this._start=Date.now(),this._dep=[]}branch(w,d){const m=new g(2,w.toString());return this._dep.push([w,d,m]),m}stop(){const w=Date.now()-this._start;g._totals+=w;let d=!1;function m(f,u){const o=[],s=new Array(f+1).join("	");for(const[n,i,r]of u._dep)if(i&&r){d=!0,o.push(`${s}CREATES -> ${n}`);const c=m(f+1,r);c&&o.push(c)}else o.push(`${s}uses -> ${n}`);return o.join(`
`)}const l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(w>2||d)&&g.all.add(l.join(`
`))}}e.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(ne[189],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,L){this.server=R,this.router=L}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,L){this.server.registerChannel(R,L)}}e.MessagePortMainProcessService=D}),define(ne[58],re([0,1,39,56,93,5]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(v,g,y,w){const d=y.getChannel(v);return P(g)?w.createInstance(new t.SyncDescriptor(g.channelClientCtor,[d])):D.ProxyChannel.toService(d,g?.proxyOptions)}}function P(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let I=class extends T{constructor(v,g,y,w){super(v,g,y,w)}};I=pe([Y(2,e.IMainProcessService),Y(3,L.IInstantiationService)],I);function E(p,v,g){(0,R.registerSingleton)(p,new t.SyncDescriptor(I,[v,g],!0))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let b=class extends T{constructor(v,g,y,w){super(v,g,y,w)}};b=pe([Y(2,e.ISharedProcessService),Y(3,L.IInstantiationService)],b);function C(p,v,g){(0,R.registerSingleton)(p,new t.SyncDescriptor(b,[v,g],!0))}e.registerSharedProcessRemoteService=C}),define(ne[71],re([0,1,23,2,4,157,29,5]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let I=class extends t.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new D.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let C;try{C=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const v=C.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(y=>y.startsWith("lp-"))).map(g=>{const y=g.properties.localizedLanguages?.[0],w=this.getLocale(g);return{...this.createQuickPickItem(w,y,g),extensionId:g.identifier.id,galleryExtension:g}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(b){return b.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(b,C,p){const v=C??b;let g;if(v!==b&&(g=`(${b})`),b.toLowerCase()===R.language.toLowerCase()&&(g??="",g+=(0,L.localize)(0,null)),p?.installCount){g??="";const y=p.installCount;let w;y>1e6?w=`${Math.floor(y/1e5)/10}M`:y>1e3?w=`${Math.floor(y/1e3)}K`:w=String(y),g+=` $(cloud-download) ${w}`}return{id:b,label:v,description:g}}};I=pe([Y(0,T.IExtensionGalleryService)],I),e.LanguagePackBaseService=I}),define(ne[190],re([0,1,2,71]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=pe([Y(0,t.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(ne[8],re([0,1,38,3,2,34,4,7,5]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function E(){return new Date().toISOString()}var b;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function C(c,a,h){switch(a){case b.Trace:c.trace(h);break;case b.Debug:c.debug(h);break;case b.Info:c.info(h);break;case b.Warning:c.warn(h);break;case b.Error:c.error(h);break;case b.Critical:c.critical(h);break;default:throw new Error("Invalid log level")}}e.log=C;function p(c){let a="";for(let h=0;h<c.length;h++){let S=c[h];if(typeof S=="object")try{S=JSON.stringify(S)}catch{}a+=(h>0?" ":"")+S}return a}e.format=p;class v extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class g extends v{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...h){this.checkLogLevel(b.Trace)&&this.log(b.Trace,p([a,...h]))}debug(a,...h){this.checkLogLevel(b.Debug)&&this.log(b.Debug,p([a,...h]))}info(a,...h){this.checkLogLevel(b.Info)&&this.log(b.Info,p([a,...h]))}warn(a,...h){this.checkLogLevel(b.Warning)&&this.log(b.Warning,p([a,...h]))}error(a,...h){if(this.checkLogLevel(b.Error))if(a instanceof Error){const S=Array.prototype.slice.call(arguments);S[0]=a.stack,this.log(b.Error,p(S))}else this.log(b.Error,p([a,...h]))}critical(a,...h){this.checkLogLevel(b.Critical)&&this.log(b.Critical,p([a,...h]))}flush(){}}e.AbstractMessageLogger=g;class y extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!T.isWindows}trace(a,...h){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...h):console.log(`[main ${E()}]`,a,...h))}debug(a,...h){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...h):console.log(`[main ${E()}]`,a,...h))}info(a,...h){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...h):console.log(`[main ${E()}]`,a,...h))}warn(a,...h){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,a,...h):console.warn(`[main ${E()}]`,a,...h))}error(a,...h){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,a,...h):console.error(`[main ${E()}]`,a,...h))}critical(a,...h){this.getLevel()<=b.Critical&&(this.useColors?console.error(`\x1B[90m[main ${E()}]\x1B[0m`,a,...h):console.error(`[main ${E()}]`,a,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class w extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...h){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",a,...h)}debug(a,...h){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...h)}info(a,...h){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",a,...h)}warn(a,...h){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",a,...h)}error(a,...h){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",a,...h)}critical(a,...h){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...h)}dispose(){}flush(){}}e.ConsoleLogger=w;class d extends v{constructor(a,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(h)}trace(a,...h){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(a),...h])}debug(a,...h){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(a),...h])}info(a,...h){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(a),...h])}warn(a,...h){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(a),...h])}error(a,...h){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(a),...h])}critical(a,...h){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(a),...h])}extractMessage(a){return typeof a=="string"?a:(0,D.toErrorMessage)(a,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class m extends v{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const h of this.logServices)h.setLevel(a);super.setLevel(a)}trace(a,...h){for(const S of this.logServices)S.trace(a,...h)}debug(a,...h){for(const S of this.logServices)S.debug(a,...h)}info(a,...h){for(const S of this.logServices)S.info(a,...h)}warn(a,...h){for(const S of this.logServices)S.warn(a,...h)}error(a,...h){for(const S of this.logServices)S.error(a,...h)}critical(a,...h){for(const S of this.logServices)S.critical(a,...h)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=m;class l extends R.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...h){this.logger.trace(a,...h)}debug(a,...h){this.logger.debug(a,...h)}info(a,...h){this.logger.info(a,...h)}warn(a,...h){this.logger.warn(a,...h)}error(a,...h){this.logger.error(a,...h)}critical(a,...h){this.logger.critical(a,...h)}flush(){this.logger.flush()}}e.LogService=l;class f extends R.Disposable{constructor(a,h){super(),this.logLevel=a,this.loggerItems=new L.ResourceMap,this._register(h(S=>this.setLevel(S)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,h,S){let A=this.loggerItems.get(a)?.logger;return A||(S=h?.always?b.Trace:S,A=this.doCreateLogger(a,S??this.logLevel,h),this.loggerItems.set(a,{logger:A,logLevel:S})),A}setLevel(a,h){const S=P.URI.isUri(a)?a:void 0,A=S?h:a;if(S){const $=this.loggerItems.get(S);$&&$.logLevel!==A&&($.logLevel=A,$.logger.setLevel(A))}else this.logLevel=A,this.loggerItems.forEach(({logLevel:$,logger:_})=>{$===void 0&&_.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=f;class u{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return b.Info}trace(a,...h){}debug(a,...h){}info(a,...h){}warn(a,...h){}error(a,...h){}critical(a,...h){}dispose(){}flush(){}}e.NullLogger=u;class o extends u{}e.NullLogService=o;class s extends f{constructor(){super(b.Info,t.Event.None)}doCreateLogger(a,h,S){return new u}}e.NullLoggerService=s;function n(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const a=i(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function i(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=i;function r(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(ne[191],re([0,1,6,9,2,10,28,13,8]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(C,p){super(),this.environmentService=C,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,L.basename)(this.environmentService.logsPath),p=(0,L.dirname)(this.environmentService.logsPath),y=(await T.Promises.readdir(p)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==C),w=y.slice(0,Math.max(0,y.length-9));w.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(d=>T.Promises.rm((0,L.join)(p,d)))))}catch(C){(0,t.onUnexpectedError)(C)}}};E=pe([Y(0,P.IEnvironmentService),Y(1,I.ILogService)],E),e.LogsDataCleaner=E}),define(ne[192],re([0,1,18,6,9,3,2,10,57,8]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends T.Disposable{constructor(p,v){super(),this.logService=p,this.options=v,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(p,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,v):this.watchNonRecursive(p,v)}watchUniversal(p,v){const g={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:v.recursive},y=(0,D.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,I.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const v of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const v of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(v)&&p.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,v){const g={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:!1},y=(0,D.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,I.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ne[193],re([0,1,18,6,16,23,3,65,53,2,34,24,194,19,42,153,14,98,8]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends E.Disposable{constructor(u){super(),this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(u,o){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${u}`);const s=new E.DisposableStore;return this.provider.set(u,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:o}),s.add(o.onDidChangeFile(n=>this._onDidFilesChange.fire(new w.FileChangesEvent(n,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),s.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:u}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:o}),this.provider.delete(u),(0,E.dispose)(s)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(s){o.push(s)}}),!this.provider.has(u)&&await t.Promises.settled(o)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,o){const s=this.provider.get(u.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return I.Iterable.map(this.provider,([u,o])=>({scheme:u,capabilities:o.capabilities}))}async withProvider(u){if(!(0,v.isAbsolutePath)(u))throw new w.FileOperationError((0,y.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const o=this.provider.get(u.scheme);if(!o){const s=new Error;throw s.name="ENOPRO",s.message=(0,y.localize)(1,null,u.toString()),s}return o}async withReadProvider(u){const o=await this.withProvider(u);if((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasReadWriteCapability)(o)||(0,w.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const o=await this.withProvider(u);if((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,o){try{return await this.doResolveFile(u,o)}catch(s){throw(0,w.toFileSystemProviderErrorCode)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,y.localize)(2,null,this.resourceForError(u)),1):(0,w.ensureFileSystemProviderError)(s)}}async doResolveFile(u,o){const s=await this.withProvider(u),n=this.isPathCaseSensitive(s),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,c=o?.resolveMetadata,a=await s.stat(u);let h;return this.toFileStat(s,u,a,void 0,!!c,(S,A)=>(h||(h=b.TernarySearchTree.forUris(()=>!n),h.set(u,!0),i&&h.fill(!0,i)),h.get(S.resource)||h.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&r?A===1:!1))}async toFileStat(u,o,s,n,i,r){const{providerExtUri:c}=this.getExtUri(u),a={resource:o,name:c.basename(o),isFile:(s.type&w.FileType.File)!==0,isDirectory:(s.type&w.FileType.Directory)!==0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&w.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,w.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(a.isDirectory&&r(a,n)){try{const h=await u.readdir(o),S=await t.Promises.settled(h.map(async([A,$])=>{try{const _=c.joinPath(o,A),U=i?await u.stat(_):{type:$};return await this.toFileStat(u,_,U,h.length,i,r)}catch(_){return this.logService.trace(_),null}}));a.children=(0,D.coalesce)(S)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(u){return t.Promises.settled(u.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(u){const o=await this.withProvider(u),s=await o.stat(u);return this.toFileStat(o,u,s,void 0,!0,()=>!1)}async exists(u){const o=await this.withProvider(u);try{return!!await o.stat(u)}catch{return!1}}async canCreateFile(u,o){try{await this.doValidateCreateFile(u,o)}catch(s){return s}return!0}async doValidateCreateFile(u,o){if(!o?.overwrite&&await this.exists(u))throw new w.FileOperationError((0,y.localize)(3,null,this.resourceForError(u)),3,o)}async createFile(u,o=R.VSBuffer.fromString(""),s){await this.doValidateCreateFile(u,s);const n=await this.writeFile(u,o);return this._onDidRunOperation.fire(new w.FileOperationEvent(u,0,n)),n}async writeFile(u,o,s){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,u,s)||await this.mkdirp(n,i.dirname(u));let c;if((0,w.hasReadWriteCapability)(n)&&!(o instanceof R.VSBuffer))if((0,g.isReadableStream)(o)){const a=await(0,g.peekStream)(o,3);a.ended?c=R.VSBuffer.concat(a.buffer):c=a}else c=(0,g.peekReadable)(o,a=>R.VSBuffer.concat(a),3);else c=o;!(0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)&&c instanceof R.VSBuffer?await this.doWriteUnbuffered(n,u,s,c):await this.doWriteBuffered(n,u,s,c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c),this._onDidRunOperation.fire(new w.FileOperationEvent(u,4))}catch(r){throw new w.FileOperationError((0,y.localize)(4,null,this.resourceForError(u),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),s)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,o,s){if(!!s?.unlock&&!(u.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(o)));let i;try{i=await u.stat(o)}catch{return}if((i.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,y.localize)(6,null,this.resourceForError(o)),0,s);if(this.throwIfFileIsReadonly(o,i),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&s.mtime<i.mtime&&s.etag!==(0,w.etag)({mtime:s.mtime,size:i.size}))throw new w.FileOperationError((0,y.localize)(7,null),3,s);return i}async readFile(u,o,s){const n=await this.withReadProvider(u);return o?.atomic?this.doReadFileAtomic(n,u,o,s):this.doReadFile(n,u,o,s)}async doReadFileAtomic(u,o,s,n){return new Promise((i,r)=>{this.writeQueue.queueFor(o,this.getExtUri(u).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(u,o,s,n);i(c)}catch(c){r(c)}})})}async doReadFile(u,o,s,n){const i=await this.doReadFileStream(u,o,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,R.streamToBuffer)(i.value)}}async readFileStream(u,o,s){const n=await this.withReadProvider(u);return this.doReadFileStream(n,u,o,s)}async doReadFileStream(u,o,s,n){const i=new L.CancellationTokenSource(n),r=this.validateReadFile(o,s).then(a=>a,a=>{throw i.cancel(),a});let c;try{return typeof s?.etag=="string"&&s.etag!==w.ETAG_DISABLED&&await r,s?.atomic&&(0,w.hasFileAtomicReadCapability)(u)||!((0,w.hasOpenReadWriteCloseCapability)(u)||(0,w.hasFileReadStreamCapability)(u))||(0,w.hasReadWriteCapability)(u)&&s?.preferUnbuffered?c=this.readFileUnbuffered(u,o,s):(0,w.hasFileReadStreamCapability)(u)?c=this.readFileStreamed(u,o,i.token,s):c=this.readFileBuffered(u,o,i.token,s),{...await r,value:c}}catch(a){c&&await(0,g.consumeStream)(c);const h=(0,y.localize)(8,null,this.resourceForError(o),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(h,a.stat,s):new w.FileOperationError(h,(0,w.toFileOperationResult)(a),s)}}readFileStreamed(u,o,s,n=Object.create(null)){const i=u.readFileStream(o,n,s);return(0,g.transform)(i,{data:r=>r instanceof R.VSBuffer?r:R.VSBuffer.wrap(r),error:r=>new w.FileOperationError((0,y.localize)(9,null,this.resourceForError(o),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),n)},r=>R.VSBuffer.concat(r))}readFileBuffered(u,o,s,n=Object.create(null)){const i=(0,R.newWriteableBufferStream)();return(0,d.readFileIntoStream)(u,o,i,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new w.FileOperationError((0,y.localize)(10,null,this.resourceForError(o),(0,w.ensureFileSystemProviderError)(r).toString()),(0,w.toFileOperationResult)(r),n)},s),i}readFileUnbuffered(u,o,s){const n=(0,g.newWriteableStream)(i=>R.VSBuffer.concat(i));return(async()=>{try{let i;s?.atomic&&(0,w.hasFileAtomicReadCapability)(u)?i=await u.readFile(o,{atomic:!0}):i=await u.readFile(o),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.validateReadFileLimits(o,i.byteLength,s),n.end(R.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(u,o){const s=await this.resolve(u,{resolveMetadata:!0});if(s.isDirectory)throw new w.FileOperationError((0,y.localize)(11,null,this.resourceForError(u)),0,o);if(typeof o?.etag=="string"&&o.etag!==w.ETAG_DISABLED&&o.etag===s.etag)throw new w.NotModifiedSinceFileOperationError((0,y.localize)(12,null),s,o);return this.validateReadFileLimits(u,s.size,o),s}validateReadFileLimits(u,o,s){if(s?.limits){let n;if(typeof s.limits.memory=="number"&&o>s.limits.memory&&(n=9),typeof s.limits.size=="number"&&o>s.limits.size&&(n=7),typeof n=="number")throw new w.FileOperationError((0,y.localize)(13,null,this.resourceForError(u)),n)}}async canMove(u,o,s){return this.doCanMoveCopy(u,o,"move",s)}async canCopy(u,o,s){return this.doCanMoveCopy(u,o,"copy",s)}async doCanMoveCopy(u,o,s,n){if(u.toString()!==o.toString())try{const i=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,u,r,o,s,n)}catch(i){return i}return!0}async move(u,o,s){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(n,u,i,o,"move",!!s),c=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,r==="move"?2:3,c)),c}async copy(u,o,s){const n=await this.withReadProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(n,u,i,o,"copy",!!s),c=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,r==="copy"?3:2,c)),c}async doMoveCopy(u,o,s,n,i,r){if(o.toString()===n.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(u,o,s,n,i,r);if(c&&!a&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(n)),i==="copy"){if(u===s&&(0,w.hasFileFolderCopyCapability)(u))await u.copy(o,n,{overwrite:r});else{const h=await this.resolve(o);h.isDirectory?await this.doCopyFolder(u,h,s,n):await this.doCopyFile(u,o,s,n)}return i}else return u===s?(await u.rename(o,n,{overwrite:r}),i):(await this.doMoveCopy(u,o,s,n,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(u,o,s,n){if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(u,o,s,n);if((0,w.hasOpenReadWriteCloseCapability)(u)&&(0,w.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(u,o,s,n);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(u,o,s,n);if((0,w.hasReadWriteCapability)(u)&&(0,w.hasReadWriteCapability)(s))return this.doPipeUnbuffered(u,o,s,n)}async doCopyFolder(u,o,s,n){await s.mkdir(n),Array.isArray(o.children)&&await t.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(u,await this.resolve(i.resource),s,r):this.doCopyFile(u,i.resource,s,r)}))}async doValidateMoveCopy(u,o,s,n,i,r){let c=!1;if(u===s){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(u);if(S||(c=h.isEqual(o,n)),c&&i==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(o),this.resourceForError(n)));if(!c&&h.isEqualOrParent(n,o))throw new Error((0,y.localize)(15,null,this.resourceForError(o),this.resourceForError(n)))}const a=await this.exists(n);if(a&&!c){if(!r)throw new w.FileOperationError((0,y.localize)(16,null,this.resourceForError(o),this.resourceForError(n)),4);if(u===s){const{providerExtUri:h}=this.getExtUri(u);if(h.isEqualOrParent(o,n))throw new Error((0,y.localize)(17,null,this.resourceForError(o),this.resourceForError(n)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}getExtUri(u){const o=this.isPathCaseSensitive(u);return{providerExtUri:o?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(o,u);const s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(u,0,s)),s}async mkdirp(u,o){const s=[],{providerExtUri:n}=this.getExtUri(u);for(;!n.isEqual(o,n.dirname(o));)try{if(((await u.stat(o)).type&w.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,w.toFileSystemProviderErrorCode)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(o)),o=n.dirname(o)}for(let i=s.length-1;i>=0;i--){o=n.joinPath(o,s[i]);try{await u.mkdir(o)}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(u,o){try{await this.doValidateDelete(u,o)}catch(s){return s}return!0}async doValidateDelete(u,o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!o?.useTrash&&!(s.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(u)));let i;try{i=await s.stat(u)}catch{}if(i)this.throwIfFileIsReadonly(u,i);else throw new w.FileOperationError((0,y.localize)(20,null,this.resourceForError(u)),1);if(!!!o?.recursive){const c=await this.resolve(u);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(u)))}return s}async del(u,o){const s=await this.doValidateDelete(u,o),n=!!o?.useTrash,i=!!o?.recursive;await s.delete(u,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new w.FileOperationEvent(u,1))}async cloneFile(u,o){const s=await this.withProvider(u),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(s===n&&this.getExtUri(s).providerExtUri.isEqual(u,o))return;if(s===n&&(0,w.hasFileCloneCapability)(s))return s.cloneFile(u,o);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o));const i=this.writeQueue.queueFor(u,this.getExtUri(s).providerExtUri);return s===n&&(0,w.hasFileFolderCopyCapability)(s)?i.queue(()=>s.copy(u,o,{overwrite:!0})):i.queue(()=>this.doCopyFile(s,u,n,o))}watch(u,o={recursive:!1,excludes:[]}){const s=new E.DisposableStore;let n=!1,i=()=>{n=!0};return s.add((0,E.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(u,o);n?(0,E.dispose)(r):i=()=>(0,E.dispose)(r)}catch(r){this.logService.error(r)}})(),s}async doWatch(u,o){const s=await this.withProvider(u),n=(0,P.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(u),o]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:s.watch(u,o)},this.activeWatchers.set(n,i)),i.count+=1,(0,E.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,E.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,E.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,o,s,n){return this.writeQueue.queueFor(o,this.getExtUri(u).providerExtUri).queue(async()=>{const i=await u.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,g.isReadableStream)(n)||(0,g.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(u,i,n):await this.doWriteReadableBufferedQueued(u,i,n)}catch(r){throw(0,w.ensureFileSystemProviderError)(r)}finally{await u.close(i)}})}async doWriteStreamBufferedQueued(u,o,s){let n=0,i;if((0,g.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=R.VSBuffer.concat(s.buffer);await this.doWriteBuffer(u,o,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,c)=>{(0,g.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(u,o,a,a.byteLength,n,0)}catch(h){return c(h)}n+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>c(a),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(u,o,s){let n=0,i;for(;(i=s.read())!==null;)await this.doWriteBuffer(u,o,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(u,o,s,n,i,r){let c=0;for(;c<n;)c+=await u.write(o,i+c,s.buffer,r+c,n-c)}async doWriteUnbuffered(u,o,s,n){return this.writeQueue.queueFor(o,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,o,s,n))}async doWriteUnbufferedQueued(u,o,s,n){let i;n instanceof R.VSBuffer?i=n:(0,g.isReadableStream)(n)?i=await(0,R.streamToBuffer)(n):(0,g.isReadableBufferedStream)(n)?i=await(0,R.bufferedStreamToBuffer)(n):i=(0,R.readableToBuffer)(n),await u.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(u,o,s,n){return this.writeQueue.queueFor(n,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,o,s,n))}async doPipeBufferedQueued(u,o,s,n){let i,r;try{i=await u.open(o,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,S=0;do S=await u.read(i,a,c.buffer,h,c.byteLength-h),await this.doWriteBuffer(s,r,c,S,a,h),a+=S,h+=S,h===c.byteLength&&(h=0);while(S>0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof i=="number"?u.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async doPipeUnbuffered(u,o,s,n){return this.writeQueue.queueFor(n,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,o,s,n))}async doPipeUnbufferedQueued(u,o,s,n){return s.writeFile(n,await u.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,o,s,n){return this.writeQueue.queueFor(n,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,o,s,n))}async doPipeUnbufferedToBufferedQueued(u,o,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const r=await u.readFile(o);await this.doWriteBuffer(s,i,R.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,w.ensureFileSystemProviderError)(r)}finally{await s.close(i)}}async doPipeBufferedToUnbuffered(u,o,s,n){const i=await(0,R.streamToBuffer)(this.readFileBuffered(u,o,L.CancellationToken.None));await this.doWriteUnbuffered(s,n,void 0,i)}throwIfFileSystemIsReadonly(u,o){if(u.capabilities&2048)throw new w.FileOperationError((0,y.localize)(22,null,this.resourceForError(o)),6);return u}throwIfFileIsReadonly(u,o){if((o.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,y.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===C.Schemas.file?u.fsPath:u.toString(!0)}};l=pe([Y(0,m.ILogService)],l),e.FileService=l}),define(ne[195],re([0,1,54,281,6,34,16,3,47,2,10,4,19,42,28,156,14,98,192,38,187,186]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(D)}catch(s){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(s)}`)}})();class o extends m.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(r=>p.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:r}=await g.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await g.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(n,c.name))).type:a=this.toType(c),r.push([c.name,a])}catch(a){this.logService.trace(a)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let r;return i?.dangling?r=w.FileType.Unknown:n.isFile()?r=w.FileType.File:n.isDirectory()?r=w.FileType.Directory:r=w.FileType.Unknown,i&&(r|=w.FileType.SymbolicLink),r}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const c=new R.Barrier;return this.resourceLocks.set(n,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,E.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),r=await this.createResourceLock(n));const c=this.toFilePath(n);return await g.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{r?.dispose()}}traceLock(n){o.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,r){const c=(0,v.newWriteableStream)(a=>T.VSBuffer.concat(a.map(h=>T.VSBuffer.wrap(h))).buffer);return(0,d.readFileIntoStream)(this,n,c,a=>a.buffer,{...i,bufferSize:256*1024},r),c}async writeFile(n,i,r){let c;try{const a=this.toFilePath(n);if(!r.create||!r.overwrite){if(await g.Promises.exists(a)){if(!r.overwrite)throw(0,w.createFileSystemProviderError)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,w.createFileSystemProviderError)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(n,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){o.canFlush=n}async open(n,i){const r=this.toFilePath(n);let c;(0,w.isFileOpenForWriteOptions)(i)&&(c=await this.createResourceLock(n));let a;try{if((0,w.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await g.SymlinkSupport.stat(r);S.mode&128||await g.Promises.chmod(r,S.mode|128)}catch(S){this.logService.trace(S)}let h;if((0,w.isFileOpenForWriteOptions)(i)){if(C.isWindows)try{await g.Promises.truncate(r,0),h="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}h||(h="w")}else h="r";a=await g.Promises.open(r,h)}catch(h){throw c?.dispose(),(0,w.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(a,0),(0,w.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,n),c){const h=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,c),h&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),h.dispose())}return a}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&o.canFlush)try{await g.Promises.fdatasync(n)}catch(r){o.configureFlushOnWrite(!1),this.logService.error(r)}return await g.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,c,a){const h=this.normalizePos(n,i);let S=null;try{S=(await g.Promises.read(n,r,c,a,h)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(n,h,S)}return S}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,r){const c=this.mapHandleToPos.get(n);typeof c=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(n,c+r):this.mapHandleToPos.delete(n)))}async write(n,i,r,c,a){return(0,R.retry)(()=>this.doWrite(n,i,r,c,a),100,3)}async doWrite(n,i,r,c,a){const h=this.normalizePos(n,i);let S=null;try{S=(await g.Promises.write(n,r,c,a,h)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),A)}finally{this.updatePos(n,h,S)}return S}async mkdir(n){try{await g.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const r=this.toFilePath(n);i.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(n,i,r){const c=this.toFilePath(n),a=this.toFilePath(i);if(c!==a)try{await this.validateTargetDeleted(n,i,"move",r.overwrite),await g.Promises.move(c,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,y.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(n,i,r){const c=this.toFilePath(n),a=this.toFilePath(i);if(c!==a)try{await this.validateTargetDeleted(n,i,"copy",r.overwrite),await g.Promises.copy(c,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,y.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(n,i,r,c){const a=this.toFilePath(n),h=this.toFilePath(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,I.isEqual)(a,h,!0)),S&&r==="copy")throw(0,w.createFileSystemProviderError)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!S&&await g.Promises.exists(h)){if(!c)throw(0,w.createFileSystemProviderError)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,r){const c=this.toFilePath(n),a=this.toFilePath(i),h=!!(this.capabilities&1024);if((0,I.isEqual)(c,a,!h))return;const S=new E.DisposableStore;try{const[A,$]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);S.add(A),S.add($),r&&await g.Promises.mkdir((0,b.dirname)(a),{recursive:!0}),await g.Promises.copyFile(c,a)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(A)}finally{S.dispose()}}createUniversalWatcher(n,i,r){return new f.UniversalWatcherClient(c=>n(c),c=>i(c),r)}createNonRecursiveWatcher(n,i,r){return new u.NodeJSWatcherClient(c=>n(c),c=>i(c),r)}toFileSystemProviderError(n){if(n instanceof w.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=w.FileSystemProviderErrorCode.NoPermissions;break;default:i=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let r=this.toFileSystemProviderError(i);if(n&&r.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await g.SymlinkSupport.stat(this.toFilePath(n));c.mode&128||(r=(0,w.createFileSystemProviderError)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return r}}e.DiskFileSystemProvider=o,o.TRACE_LOG_RESOURCE_LOCKS=!1,o.canFlush=!0}),define(ne[99],re([0,1,6,3,2,5,8]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,L.createDecorator)("lifecycleSharedProcessService");let P=class extends R.Disposable{constructor(E){super(),this.logService=E,this.pendingWillShutdownPromise=void 0,this._onWillShutdown=this._register(new t.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(b){E.push(b)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(E)}catch(b){this.logService.error(b)}})(),this.pendingWillShutdownPromise}};P=pe([Y(0,T.ILogService)],P),e.SharedProcessLifecycleService=P}),define(ne[100],re([0,1,3,7,8]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(p,v){this.logService=p,this.loggerService=v,this.onDidChangeLogLevel=D.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(p,v,g){switch(v){case"setLevel":return g[1]?this.loggerService.setLevel(t.URI.revive(g[1]),g[0]):this.logService.setLevel(g[0])}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class T{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p,v){T.setLevel(this.channel,p,v)}static setLevel(p,v,g){return p.call("setLevel",[v,g])}}e.LogLevelChannelClient=T;class P{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,v){throw new Error(`Event not found: ${v}`)}async call(p,v,g){switch(v){case"createLogger":this.createLogger(t.URI.revive(g[0]),g[1]);return;case"log":return this.log(t.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${v}`)}createLogger(p,v){this.loggers.set(p.toString(),this.loggerService.createLogger(p,v))}consoleLog(p,v){let g=console.log;switch(p){case R.LogLevel.Error:g=console.error;break;case R.LogLevel.Warning:g=console.warn;break;case R.LogLevel.Info:g=console.info;break}g.call(console,...v)}log(p,v){const g=this.loggers.get(p.toString());if(!g)throw new Error("Create the logger before logging");for(const[y,w]of v)(0,R.log)(g,y,w)}}e.LoggerChannel=P;class I extends R.AbstractLoggerService{constructor(p,v,g){super(p,v),this.channel=g}createConsoleMainLogger(){return new R.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}doCreateLogger(p,v,g){return new E(this.channel,p,v,g)}}e.LoggerChannelClient=I;class E extends R.AbstractMessageLogger{constructor(p,v,g,y){super(y?.always),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[v,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const g=[[p,v]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(p){this.channel.call("log",[this.file,p])}}class b extends R.LogService{constructor(p,v){super(v),this.parent=p,this._register(p.onDidChangeLogLevel(g=>v.setLevel(g)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=b}),define(ne[59],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[60],re([0,1,3,53,2,5]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class T extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(E){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(E),t.Iterable.reduce(this.policies.entries(),(C,[p,v])=>({...C,[p]:v}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[b,C])=>({...E,[b]:{definition:C,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=T;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[196],re([0,1,3,2,60]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(I){this.service=I,this.disposables=new t.DisposableStore}listen(I,E){switch(E){case"onDidChange":return D.Event.map(this.service.onDidChange,b=>b.reduce((C,p)=>({...C,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${E}`)}call(I,E,b){switch(E){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(b)}throw new Error(`Call not found: ${E}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class T extends R.AbstractPolicyService{constructor(I,E){super(),this.channel=E;for(const b in I){const{definition:C,value:p}=I[b];this.policyDefinitions[b]=C,p!==void 0&&this.policies.set(b,p)}this.channel.listen("onDidChange")(b=>{for(const C in b){const p=b[C];p===null?this.policies.delete(C):this.policies.set(C,p)}this._onDidChange.fire(Object.keys(b))})}async initializePolicies(I){const E=await this.channel.call("registerPolicyDefinitions",I);for(const b in E)this.policies.set(b,E[b])}}e.PolicyChannelClient=T}),define(ne[101],re([0,1,24,4,37,19]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const P=t.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,L.dirname)(D.FileAccess.asFileUri("",Q));if(T=Q.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath),R.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const I=Q.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);Object.assign(T,{version:I.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ne[25],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[197],re([0,1,6,9,2,10,28,8,25]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(C,p,v){super(),this.productService=p,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},3e4)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),v=(0,L.dirname)(C),g=(0,L.basename)(C),y=await T.Promises.readdir(v);await Promise.all(y.map(async w=>{if(w===g)return;const d=(0,L.join)(v,w),m=await T.Promises.stat(d);if(m.isDirectory()&&p-m.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),T.Promises.rm(d)}))}catch(p){(0,t.onUnexpectedError)(p)}}};E=pe([Y(1,I.IProductService),Y(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[198],re([0,1,6,9,2,10,28,13,8,25]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let b=class extends R.Disposable{constructor(p,v,g){super(),this.environmentService=p,this.logService=v,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),v=JSON.parse(await T.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(v)){const l=v[m];p[`${l.hash}.${m}`]=!0}const g=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(g))return;const w=await T.Promises.readdir(g);for(const m of w){if(p[m]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await T.Promises.rm((0,L.join)(g,m))}const d=Date.now();for(const m of Object.keys(p)){const l=(0,L.join)(g,m),f=await T.Promises.readdir(l);for(const u of f){if(u==="tcf.json")continue;const o=(0,L.join)(l,u),s=await T.Promises.stat(o);s.isDirectory()&&d-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(m,u)}`),await T.Promises.rm(o))}}}catch(p){(0,t.onUnexpectedError)(p)}}};b=pe([Y(0,P.INativeEnvironmentService),Y(1,I.ILogService),Y(2,E.IProductService)],b),e.LanguagePackCachedDataCleaner=b}),define(ne[199],re([0,1,10,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var R;(function(L){function T(I){return Boolean(I.samples&&I.timeDeltas)}L.isValidProfile=T;function P(I,E="noAbsolutePaths"){for(const b of I.nodes)b.callFrame&&b.callFrame.url&&((0,D.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(b.callFrame.url))&&(b.callFrame.url=(0,D.join)(E,(0,D.basename)(b.callFrame.url)));return I}L.rewriteAbsolutePaths=P})(R=e.Utils||(e.Utils={}))}),define(ne[200],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((E,b)=>{Q(["v8-inspect-profiler"],E,b)})).startProfiling({port:L.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this._sessions.set(I,P),I}async stopProfiling(L){const T=this._sessions.get(L);if(!T)throw new Error(`UNKNOWN session '${L}'`);const P=await T.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=t}),define(ne[40],re([0,1,117,15]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(T,P){D.ok(t.isString(T)),D.ok(t.isObject(P)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new R}),define(ne[102],re([0,1,3,40]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,E){this.schemasById[R(I)]=E,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;t.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[43],re([0,1,18,3,15,142,17,102,40]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=I.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const n=this.doRegisterConfigurations(o,s);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(o){const s=this.doDeregisterConfigurations(o);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:o,remove:s}){const n=[];n.push(...this.doDeregisterConfigurations(s)),n.push(...this.doRegisterConfigurations(o,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(n)})}registerDefaultConfigurations(o){const s=[],n=[];for(const{overrides:i,source:r}of o)for(const c in i)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.configurationDefaultsOverrides.get(c),h=a?.valuesSources??new Map;if(r)for(const _ of Object.keys(i[c]))h.set(_,r);const S={...a?.value||{},...i[c]};this.configurationDefaultsOverrides.set(c,{source:r,value:S,valuesSources:h});const A=(0,T.getLanguageTagSettingPlainKey)(c),$={type:"object",default:S,description:L.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:R.isString(r)?void 0:r,defaultValueSource:r};n.push(...y(c)),this.configurationProperties[c]=$,this.defaultLanguageConfigurationOverridesNode.properties[c]=$}else{this.configurationDefaultsOverrides.set(c,{value:i[c],source:r});const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const s=[];for(const{overrides:n,source:i}of o)for(const r in n){const c=this.configurationDefaultsOverrides.get(r),a=R.isString(i)?i:i?.id,h=R.isString(c?.source)?c?.source:c?.source?.id;if(a===h)if(s.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const S=this.configurationProperties[r];S&&(this.updatePropertyDefaultValue(r,S),this.updateSchema(r,S))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const s of o)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,s){const n=[];return o.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(o){const s=[],n=i=>{if(i.properties)for(const r in i.properties){s.push(r);const c=this.configurationProperties[r];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of o){n(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return s}validateAndRegisterProperties(o,s=!0,n,i,r=3){r=R.isUndefinedOrNull(o.scope)?r:o.scope;const c=[],a=o.properties;if(a)for(const S in a){const A=a[S];if(s&&l(S,A)){delete a[S];continue}if(A.source=n,A.defaultDefaultValue=a[S].default,this.updatePropertyDefaultValue(S,A),e.OVERRIDE_PROPERTY_REGEX.test(S)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!i?.includes(S):A.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.excludedConfigurationProperties[S]=a[S],delete a[S];continue}else this.configurationProperties[S]=a[S],a[S].policy?.name&&this.policyConfigurations.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),c.push(S)}const h=o.allOf;if(h)for(const S of h)c.push(...this.validateAndRegisterProperties(S,s,n,i,r));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const s=n=>{const i=n.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);n.allOf?.forEach(s)};s(o)}updateSchema(o,s){switch(e.allSettings.properties[o]=s,s.scope){case 1:e.applicationSettings.properties[o]=s;break;case 2:e.machineSettings.properties[o]=s;break;case 6:e.machineOverridableSettings.properties[o]=s;break;case 3:e.windowSettings.properties[o]=s;break;case 4:e.resourceSettings.properties[o]=s;break;case 5:e.resourceSettings.properties[o]=s,this.resourceLanguageSettingsSchema.properties[o]=s;break}}removeFromSchema(o,s){switch(delete e.allSettings.properties[o],s.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const s=`[${o}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,n),e.allSettings.properties[s]=n,e.applicationSettings.properties[s]=n,e.machineSettings.properties[s]=n,e.machineOverridableSettings.properties[s]=n,e.windowSettings.properties[s]=n,e.resourceSettings.properties[s]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,s){const n=this.configurationDefaultsOverrides.get(o);let i=n?.value,r=n?.source;R.isUndefined(i)&&(i=s.defaultDefaultValue,r=void 0),R.isUndefined(i)&&(i=d(s.type)),s.default=i,s.defaultValueSource=r}}const v="\\[([^\\]]+)\\]",g=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(u){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let s=g.exec(u);for(;s?.length;){const n=s[1].trim();n&&o.push(n),s=g.exec(u)}}return(0,D.distinct)(o)}e.overrideIdentifiersFromKey=y;function w(u){return u.reduce((o,s)=>`${o}[${s}]`,"")}e.keyFromOverrideIdentifiers=w;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new p;I.Registry.add(e.Extensions.Configuration,m);function l(u,o){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?L.localize(7,null,u):m.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):o.policy?.name&&m.getPolicyConfigurations().get(o.policy?.name)!==void 0?L.localize(9,null,u,o.policy?.name,m.getPolicyConfigurations().get(o.policy?.name)):null:L.localize(6,null)}e.validateProperty=l;function f(){const u=[],o=m.getConfigurationProperties();for(const s of Object.keys(o))u.push([s,o[s].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=f}),define(ne[72],re([0,1,18,3,35,2,34,32,15,7,17,43,40]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(s={},n=[],i=[],r){this._contents=s,this._keys=n,this._overrides=i,this.raw=r,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof v)return n;const i=new g("");return i.parseRaw(n),i.configurationModel});this._rawConfiguration=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(s){return s?(0,b.getConfigurationValue)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,c=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:r,merged:c}}getOverrideValue(s,n){const i=this.getContentsForOverrideIdentifer(n);return i?s?(0,b.getConfigurationValue)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return D.distinct(s)}override(s){let n=this.overrideConfigurations.get(s);return n||(n=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,n)),n}merge(...s){const n=P.deepClone(this.contents),i=P.deepClone(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of s)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(n,a.contents);for(const h of a.overrides){const[S]=i.filter(A=>D.equals(A.identifiers,h.identifiers));S?(this.mergeContents(S.contents,h.contents),S.keys.push(...h.keys),S.keys=D.distinct(S.keys)):i.push(P.deepClone(h))}for(const h of a.keys)r.indexOf(h)===-1&&r.push(h)}return new v(n,r,i,c.every(a=>a instanceof v)?void 0:c)}freeze(){return this.frozen=!0,this}clone(){return new v(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(s){const n=this.getContentsForOverrideIdentifer(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[r];const a=n[r];a&&(typeof c=="object"&&typeof a=="object"?(c=P.deepClone(c),this.mergeContents(c,a)):c=a),i[r]=c}return new v(i,this.keys,this.overrides)}mergeContents(s,n){for(const i of Object.keys(n)){if(i in s&&I.isObject(s[i])&&I.isObject(n[i])){this.mergeContents(s[i],n[i]);continue}s[i]=P.deepClone(n[i])}}checkAndFreeze(s){return this.frozen&&!Object.isFrozen(s)?P.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let n=null,i=null;const r=c=>{c&&(i?this.mergeContents(i,c):i=P.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[s])?n=c.contents:c.identifiers.includes(s)&&r(c.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,n){this.addKey(s),(0,b.addToValueTree)(this.contents,s,n,i=>{throw new Error(i)})}removeValue(s){this.removeKey(s)&&(0,b.removeFromValueTree)(this.contents,s)}addKey(s){let n=this.keys.length;for(let i=0;i<n;i++)s.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,s)}removeKey(s){const n=this.keys.indexOf(s);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=v;class g{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,n){if(!I.isUndefinedOrNull(s)){const i=this.doParseContent(s);this.parseRaw(i,n)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,n){this._raw=s;const{contents:i,keys:r,overrides:c,restricted:a,hasExcludedProperties:h}=this.doParseRaw(s,n);this._configurationModel=new v(i,r,c,h?[s]:void 0),this._restrictedConfigurations=a||[]}doParseContent(s){let n={},i=null,r=[];const c=[],a=[];function h(A){Array.isArray(r)?r.push(A):i!==null&&(r[i]=A)}const S={onObjectBegin:()=>{const A={};h(A),c.push(r),r=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const A=[];h(A),c.push(r),r=A,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:h,onError:(A,$,_)=>{a.push({error:A,offset:$,length:_})}};if(s)try{R.visit(s,S),n=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(s,n){const i=p.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(s,i,!0,n);s=r.raw;const c=(0,b.toValuesTree)(s,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),a=Object.keys(s),h=this.toOverrides(s,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:c,keys:a,overrides:h,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(s,n,i,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const a={},h=[];for(const S in s)if(C.OVERRIDE_PROPERTY_REGEX.test(S)&&i){const A=this.filter(s[S],n,!1,r);a[S]=A.raw,c=c||A.hasExcludedProperties,h.push(...A.restricted)}else{const A=n[S],$=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&h.push(S),($===void 0||r.scopes===void 0||r.scopes.includes($))&&!(r.skipRestricted&&A?.restricted)?a[S]=s[S]:c=!0}return{raw:a,restricted:h,hasExcludedProperties:c}}toOverrides(s,n){const i=[];for(const r of Object.keys(s))if(C.OVERRIDE_PROPERTY_REGEX.test(r)){const c={};for(const a in s[r])c[a]=s[r][a];i.push({identifiers:(0,C.overrideIdentifiersFromKey)(r),keys:Object.keys(c),contents:(0,b.toValuesTree)(c,n)})}return i}}e.ConfigurationModelParser=g;class y extends L.Disposable{constructor(s,n,i,r){super(),this.userSettingsResource=s,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&i.isEqual(c.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class w{constructor(s,n,i,r,c,a,h,S,A,$,_,U,k){this.key=s,this.overrides=n,this.value=i,this.overrideIdentifiers=r,this.defaultConfiguration=c,this.policyConfiguration=a,this.applicationConfiguration=h,this.userConfiguration=S,this.localUserConfiguration=A,this.remoteUserConfiguration=$,this.workspaceConfiguration=_,this.folderConfigurationModel=U,this.memoryInspectValue=k}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(s,n,i,r,c=new v,a=new v,h=new T.ResourceMap,S=new v,A=new T.ResourceMap,$=!0){this._defaultConfiguration=s,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=c,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=S,this._memoryConfigurationByResource=A,this._freeze=$,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(s,n,i){return this.getConsolidatedConfigurationModel(s,n,i).getValue(s)}updateValue(s,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new v,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(s):r.setValue(s,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,n,i){const r=this.getConsolidatedConfigurationModel(s,n,i),c=D.distinct(r.overrides.map(S=>S.identifiers).flat()).filter(S=>r.getOverrideValue(s,S)!==void 0),a=this.getFolderConfigurationModelForResource(n.resource,i),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new w(s,n,r.getValue(s),c.length?c:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),i?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,h.inspect(s,n.overrideIdentifier))}keys(s){const n=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,n){this._folderConfigurations.set(s,n),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:r,updated:c,removed:a}=f(this._defaultConfiguration,s);n=[...r,...c,...a]}for(const r of n)for(const c of(0,C.overrideIdentifiersFromKey)(r)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=s.getKeysForOverrideIdentifier(c),S=[...h.filter(A=>a.indexOf(A)===-1),...a.filter(A=>h.indexOf(A)===-1),...a.filter(A=>!P.equals(this._defaultConfiguration.override(c).getValue(A),s.override(c).getValue(A)))];i.push([c,S])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:r}=f(this._policyConfiguration,s),c=[...n,...i,...r];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:r,overrides:c}=f(this.applicationConfiguration,s),a=[...n,...i,...r];return a.length&&this.updateApplicationConfiguration(s),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:c}=f(this.localUserConfiguration,s),a=[...n,...i,...r];return a.length&&this.updateLocalUserConfiguration(s),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:c}=f(this.remoteUserConfiguration,s),a=[...n,...i,...r];return a.length&&this.updateRemoteUserConfiguration(s),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:r,overrides:c}=f(this.workspaceConfiguration,s),a=[...n,...i,...r];return a.length&&this.updateWorkspaceConfiguration(s),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(s,n){const i=this.folderConfigurations.get(s),{added:r,updated:c,removed:a,overrides:h}=f(i,n),S=[...r,...c,...a];return(S.length||!i)&&this.updateFolderConfiguration(s,n),{keys:S,overrides:h}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:r,removed:c,overrides:a}=f(n,void 0);return{keys:[...i,...r,...c],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,n,i){let r=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:s},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&s){const r=n.getFolder(s);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const c=this._memoryConfigurationByResource.get(s);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let n=this._foldersConsolidatedConfigurations.get(s);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(s);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(s,n)):n=i}return n}getFolderConfigurationModelForResource(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,n)=>{const{contents:i,overrides:r,keys:c}=this._folderConfigurations.get(n);return s.push([n,{contents:i,overrides:r,keys:c}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>s.add(n)),this.userConfiguration.freeze().keys.forEach(n=>s.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>s.add(i))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.parseConfigurationModel(s.defaults),i=this.parseConfigurationModel(s.policy),r=this.parseConfigurationModel(s.application),c=this.parseConfigurationModel(s.user),a=this.parseConfigurationModel(s.workspace),h=s.folders.reduce((S,A)=>(S.set(E.URI.revive(A[0]),this.parseConfigurationModel(A[1])),S),new T.ResourceMap);return new d(n,i,r,c,new v,a,h,new v,new T.ResourceMap,!1)}static parseConfigurationModel(s){return new v(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=d;function m(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,n=new Map;for(const r of o)r.keys.forEach(c=>s.add(c)),r.overrides.forEach(([c,a])=>{const h=(0,T.getOrSet)(n,c,new Set);a.forEach(S=>h.add(S))});const i=[];return n.forEach((r,c)=>i.push([c,[...r.values()]])),{keys:[...s.values()],overrides:i}}e.mergeChanges=m;class l{constructor(s,n,i,r){this.change=s,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;s.keys.forEach(h=>c.add(h)),s.overrides.forEach(([,h])=>h.forEach(S=>c.add(S))),this.affectedKeys=[...c.values()];const a=new v;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(s,n,this.currentWorkspace);return!P.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(s,n){let i=(0,b.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(s=s[r],!s)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=l;function f(o,s){const{added:n,removed:i,updated:r}=u(s?.rawConfiguration,o?.rawConfiguration),c=[],a=o?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const S=h.filter(A=>!a.includes(A));for(const A of S)c.push([A,s.getKeysForOverrideIdentifier(A)])}if(o){const S=a.filter(A=>!h.includes(A));for(const A of S)c.push([A,o.getKeysForOverrideIdentifier(A)])}if(s&&o){for(const S of a)if(h.includes(S)){const A=u({contents:o.getOverrideValue(void 0,S)||{},keys:o.getKeysForOverrideIdentifier(S)},{contents:s.getOverrideValue(void 0,S)||{},keys:s.getKeysForOverrideIdentifier(S)});c.push([S,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:i,updated:r,overrides:c}}function u(o,s){const n=o?s?o.keys.filter(c=>s.keys.indexOf(c)===-1):[...o.keys]:[],i=s?o?s.keys.filter(c=>o.keys.indexOf(c)===-1):[...s.keys]:[],r=[];if(o&&s){for(const c of s.keys)if(o.keys.indexOf(c)!==-1){const a=(0,b.getConfigurationValue)(s.contents,c),h=(0,b.getConfigurationValue)(o.contents,c);P.equals(a,h)||r.push(c)}}return{added:n,removed:i,updated:r}}}),define(ne[201],re([0,1,18,3,2,32,15,17,72,43,8,60,40]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new g(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:l})=>this.onDidUpdateConfiguration(m,l))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,l){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class g extends I.ConfigurationModel{constructor(m={}){const l=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(l),u=Object.create(null),o=[];for(const s in l){const n=m[s],i=n!==void 0?n:l[s].default;(0,P.addToValueTree)(u,s,i,r=>console.error(`Conflict in default settings: ${r}`))}for(const s of Object.keys(u))E.OVERRIDE_PROPERTY_REGEX.test(s)&&o.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(u[s]),contents:(0,P.toValuesTree)(u[s],n=>console.error(`Conflict in default settings file: ${n}`))});super(u,f,o)}}e.DefaultConfigurationModel=g;class y{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let w=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(m,l,f){super(),this.defaultConfiguration=m,this.policyService=l,this.logService=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const l={},f=[],u=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(const o of m){const s=u[o];if(!s){f.push(o);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}f.push(o),l[s.policy.name]={type:s.type}}}return(0,T.isEmptyObject)(l)||await this.policyService.registerPolicyDefinitions(l),f}onDidChangePolicies(m){const l=p.Registry.as(E.Extensions.Configuration).getPolicyConfigurations(),f=(0,D.coalesce)(m.map(u=>l.get(u)));this.update(f,!0)}update(m,l){const f=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),u=[],o=this._configurationModel.isEmpty();for(const s of m){const n=f[s]?.policy?.name;if(n){const i=this.policyService.getPolicyValue(n);(o?i!==void 0:!(0,L.equals)(this._configurationModel.getValue(s),i))&&u.push([s,i])}else this._configurationModel.getValue(s)!==void 0&&u.push([s,void 0])}if(u.length){const s=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const n of s.keys)this._configurationModel.setValue(n,s.getValue(n));for(const[n,i]of u)i===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,i);l&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=pe([Y(1,C.IPolicyService),Y(2,b.ILogService)],w),e.PolicyConfiguration=w}),define(ne[202],re([0,1,6,3,2,19,17,72,201,60]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends R.Disposable{constructor(p,v,g,y){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=g instanceof E.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,g,y)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:d})=>this.onDidDefaultConfigurationChange(w,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,v,g]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(p,v,new P.ConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(p,v){const g=typeof p=="string"?p:void 0,y=(0,T.isConfigurationOverrides)(p)?p:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(g,y,void 0)}updateValue(p,v,g,y){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const v=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(g,v,2)}onDidDefaultConfigurationChange(p,v){const g=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(p,v);this.trigger(y,g,7)}onDidPolicyConfigurationChange(p){const v=this.configuration.toData(),g=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(g,v,7)}trigger(p,v,g){const y=new P.ConfigurationChangeEvent(p,{data:v},this.configuration);y.source=g,y.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ne[203],re([0,1,9,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends D.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}constructor(P,I=R.Unknown,E){super(P),this._message=P,this._code=I,this._detail=E,this.isHandled=I===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(ne[103],re([0,1,24]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=t;function R(E){if(!E)return;const b=E.indexOf("+");return b<0?E:E.substr(0,b)}e.getRemoteName=R;function L(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(E){const{host:b,port:C}=I(E);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:C}}e.parseAuthorityWithPort=T;function P(E,b){let{host:C,port:p}=I(E);return typeof p>"u"&&(p=b),{host:C,port:p}}e.parseAuthorityWithOptionalPort=P;function I(E){const b=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const C=E.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const p=E.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:E,port:void 0}}}),define(ne[44],re([0,1,27,5,103]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=L;function T(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y>"u"||y===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){const d=typeof y=="string"?y:y.value,m=typeof w=="string"?w:w.value;return D.equalsIgnoreCase(d,m)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=E;function b(g){return C(g)}e.isApplicationScopedExtension=b;function C(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function p(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function v(g,y){if(y){const w=`onResolveRemoteAuthority:${(0,R.getRemoteName)(y)}`;return g.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],re([0,1,27,29,44,4,7,9,37]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,D.compareIgnoreCase)(s.id,n.id)===0}e.areSameExtensions=E;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new C(n.identifier,i,r)}static parse(n){const i=b.exec(n);return i&&i[1]&&i[2]?new C({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof C?E(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=C;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const n=p.exec(s);return n&&n[1]?[y(n[1]),n[2]]:[y(s),void 0]}e.getIdAndVersion=v;function g(s,n){return`${s}.${n}`}e.getExtensionId=g;function y(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function w(s,n){return y(g(s,n))}e.getGalleryExtensionId=w;function d(s,n){const i=[],r=c=>{for(const a of i)if(a.some(h=>E(n(h),n(c))))return a;return null};for(const c of s){const a=r(c);a?a.push(c):i.push([c])}return i}e.groupByExtension=d;function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function l(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=l,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function f(s,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&i.every(a=>!E(a.identifier,{id:c}))){const a=s.filter(h=>E(h.identifier,{id:c}));a.length===1&&(i.push(a[0]),r.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=f;async function u(s,n){if(!L.isLinux)return!1;let i;try{i=(await s.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=u;async function o(s,n){const i=await u(s,n),r=(0,t.getTargetPlatform)(i?"alpine":L.platform,I.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=o}),define(ne[50],re([0,1,6,16,2,34,7,33,14,5,8]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let C=class extends R.Disposable{constructor(v,g){super(),this.fileService=v,this.logService=g,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,g){return this.withProfileExtensions(g,y=>(y=y.filter(w=>v.some(([d])=>!(0,P.areSameExtensions)(w.identifier,d.identifier))),y.push(...v.map(([w,d])=>({identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:d}))),y))}removeExtensionFromProfile(v,g){return this.withProfileExtensions(g,y=>y.filter(w=>!(0,P.areSameExtensions)(w.identifier,v)))}async withProfileExtensions(v,g){return this.getResourceAccessQueue(v).queue(async()=>{let y=[];try{const w=await this.fileService.readFile(v),d=JSON.parse(w.value.toString());for(const m of d){if(!m.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",m);continue}if(!m.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",m);continue}if(!m.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",m);continue}y.push({identifier:m.identifier,location:T.URI.revive(m.location),version:m.version,metadata:m.metadata})}}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}if(g){y=g(y);const w=y.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),metadata:d.metadata}));await this.fileService.writeFile(v,t.VSBuffer.fromString(JSON.stringify(w)))}return y})}getResourceAccessQueue(v){let g=this.resourcesAccessQueueMap.get(v);return g||(g=new D.Queue,this.resourcesAccessQueueMap.set(v,g)),g}};C=pe([Y(0,I.IFileService),Y(1,b.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(ne[204],re([0,1,23,33]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(L,T,P,I,E){try{const b=await L.getExtensionsControlManifest();if(!b.deprecated)return;const C=await L.getInstalled(1);for(const[p,v]of Object.entries(b.deprecated)){if(!v?.extension)continue;const{id:g,autoMigrate:y,preRelease:w}=v.extension;if(!y)continue;const d=C.find(l=>(0,t.areSameExtensions)(l.identifier,{id:p}));if(!d)continue;const m=(await T.getExtensions([{id:g,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!m){E.info(`Skipping migrating '${d.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{E.info(`Migrating '${d.identifier.id}' extension to '${g}' extension...`);const l=!I.getDisabledExtensions().some(u=>(0,t.areSameExtensions)(u,d.identifier));await L.uninstall(d),E.info(`Uninstalled the unsupported extension '${d.identifier.id}'`);let f=C.find(u=>(0,t.areSameExtensions)(u.identifier,{id:g}));(!f||!f.isPreReleaseVersion&&l)&&(f=await L.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:d.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${f.identifier.id}'`),l||(await I.disableExtension(f.identifier),E.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${d.identifier.id}' is disabled`)),y.storage&&(P.addToMigrationList((0,t.getExtensionId)(d.manifest.publisher,d.manifest.name),(0,t.getExtensionId)(f.manifest.publisher,f.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${d.identifier.id}' extension to '${g}' extension.`)}catch(l){E.error(l)}}}catch(b){E.error(b)}}e.migrateUnsupportedExtensions=R}),define(ne[205],re([0,1,6,9,2,4,19,55,7,30,28,13,29,33,14,8]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class extends R.Disposable{constructor(m,l,f,u){super(),this.fileService=l,this.extensionGalleryService=f,this.logService=u,this.extensionsDownloadDir=I.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,l){await this.cleanUpPromise;const f=this.getName(m),u=(0,T.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(u)){const o=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(m,o,l);try{await this.rename(o,u,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(o)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,o.path),s}}return u}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,l,f){try{await b.Promises.rename(m.fsPath,l.fsPath)}catch(u){if(L.isWindows&&u&&u.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${m} to ${l} with 'EPERM' error. Trying again...`),this.rename(m,l,f);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const l=[],f=[];for(const s of m.children){const n=v.ExtensionKey.parse(s.name);n&&f.push([n,s])}const u=(0,v.groupByExtension)(f,([s])=>s),o=[];for(const s of u)s.sort((n,i)=>P.rcompare(n[0].version,i[0].version)),l.push(...s.slice(1).map(n=>n[1].resource)),o.push(s[0][1]);o.sort((s,n)=>s.mtime-n.mtime),l.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(s=>s.resource)),await D.Promises.settled(l.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?v.ExtensionKey.create(m).toString().toLowerCase():(0,E.generateUuid)()}};w=pe([Y(0,C.INativeEnvironmentService),Y(1,g.IFileService),Y(2,p.IExtensionGalleryService),Y(3,y.ILogService)],w),e.ExtensionsDownloader=w}),define(ne[206],re([0,1,2,10,28,44]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(I,E){super(),this.environmentService=I,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(E.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(I){I.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(I){I.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[207],re([0,1,97,18,6,2,24,10,28,13,29,33,8,71,4,7]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let w=class extends v.LanguagePackBaseService{constructor(f,u,o,s){super(o),this.extensionManagementService=f,this.logService=s,this.cache=this._register(new d(u,s)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(f){const o=(await this.cache.getLanguagePacks())[g.Language.value()];if(!o){this.logService.warn(`No language pack found for ${g.Language.value()}`);return}const s=o.translations[f];return s?y.URI.file(s):void 0}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),u=Object.keys(f).map(o=>{const s=f[o];return{...this.createQuickPickItem(o,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return u.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),u.sort((o,s)=>o.label.localeCompare(s.label)),u}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const u=await this.cache.getLanguagePacks();Object.keys(u).some(o=>u[o]&&u[o].extensions.some(s=>(0,C.areSameExtensions)(s.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),o=await this.cache.update(u);return!(0,t.equals)(Object.keys(f),Object.keys(o))}};w=pe([Y(0,b.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,b.IExtensionGalleryService),Y(3,p.ILogService)],w),e.NativeLanguagePackService=w;let d=class extends L.Disposable{constructor(f,u){super(),this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(u=>{Object.keys(u).forEach(o=>delete u[o]),this.createLanguagePacksFromExtensions(u,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...u){for(const o of u)o&&o.manifest&&o.manifest.contributes&&o.manifest.contributes.localizations&&o.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,o);Object.keys(f).forEach(o=>this.updateHash(f[o]))}createLanguagePacksFromExtension(f,u){const o=u.identifier,s=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const n of s)if(u.location.scheme===T.Schemas.file&&m(n)){let i=f[n.languageId];i||(i={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},f[n.languageId]=i);const r=i.extensions.filter(c=>(0,C.areSameExtensions)(c.extensionIdentifier,o))[0];r?r.version=u.manifest.version:i.extensions.push({extensionIdentifier:o,version:u.manifest.version});for(const c of n.translations)i.translations[c.id]=(0,P.join)(u.location.fsPath,c.path)}}updateHash(f){if(f){const u=(0,D.createHash)("md5");for(const o of f.extensions)u.update(o.extensionIdentifier.uuid||o.extensionIdentifier.id).update(o.version);f.hash=u.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,o=>o.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(o)).then(o=>{try{return JSON.parse(o)}catch{return{}}}).then(o=>(u=f(o),o)).then(o=>{for(const n of Object.keys(o))o[n]||delete o[n];this.languagePacks=o,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),I.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>u,o=>this.logService.error(o))})}};d=pe([Y(0,E.INativeEnvironmentService),Y(1,p.ILogService)],d);function m(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const f of l.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(ne[208],re([0,1,6,16,23,9,3,2,30,90,203,103]),function(Q,e,D,t,R,L,T,P,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var v;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function g(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(B){const G=new R.CancellationTokenSource;return setTimeout(()=>G.cancel(),B),G.token}function w(B,G){if(B.isCancellationRequested||G.isCancellationRequested)return R.CancellationToken.Cancelled;const O=new R.CancellationTokenSource;return B.onCancellationRequested(()=>O.cancel()),G.onCancellationRequested(()=>O.cancel()),O.token}class d{get didTimeout(){return this._state==="timedout"}constructor(G){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((O,M)=>{this._resolvePromise=O,this._rejectPromise=M}),G.isCancellationRequested?this._timeout():this._disposables.add(G.onCancellationRequested(()=>this._timeout()))}registerDisposable(G){this._state==="pending"?this._disposables.add(G):G.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(G))}reject(G){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(G))}}function m(B,G){const O=new d(G);return O.registerDisposable(B.onControlMessage(M=>{const x=JSON.parse(M.toString()),V=W(x);V?O.reject(V):O.resolve(x)})),O.promise}function l(B,G,O,M,x,V,ee,oe){const Z=new d(oe);return G.connect(O,M,x,V,ee,(ie,se)=>{Z.didTimeout?(ie&&B.error(ie),se?.dispose()):ie||!se?Z.reject(ie):Z.resolve(se)}),Z.promise}function f(B,G){const O=new d(G);return B.then(M=>{O.didTimeout||O.resolve(M)},M=>{O.didTimeout||O.reject(M)}),O.promise}async function u(B,G,O,M){const x=X(B,G);B.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let V;try{V=await l(B.logService,B.socketFactory,B.host,B.port,(0,C.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${g(G)}-${B.reconnectionToken}`,M)}catch(se){throw B.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),B.logService.error(se),se}B.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),ee=B.reconnectionProtocol,oe=!1):(ee=new E.PersistentProtocol(V,null),oe=!0),B.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Z=await f(B.signService.createNewMessage((0,I.generateUuid)()),M),ie={type:"auth",auth:B.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(t.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await m(ee,w(M,y(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(B.logService.trace(`${x} 4/6. received SignRequest control message.`),!await f(B.signService.validate(Z,se.signedData),M)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const de=await f(B.signService.sign(se.data),M),ve={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:G};return O&&(ve.args=O),B.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(t.VSBuffer.fromString(JSON.stringify(ve))),{protocol:ee,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(B.logService.error(`${x} the handshake timed out. Error:`),B.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${x} received error control message when negotiating connection. Error:`),B.logService.error(se)),oe&&H(ee),se}}async function o(B,G,O,M){const x=Date.now(),V=X(B,G),{protocol:ee,ownsProtocol:oe}=await u(B,G,O,M),Z=new d(M);return Z.registerDisposable(ee.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=W(se);ue?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ue),oe&&H(ee),Z.reject(ue)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ce(x)}!`),Z.resolve({protocol:ee,firstMessage:se}))})),Z.promise}async function s(B,G){const{protocol:O}=await o(B,1,void 0,G);return{protocol:O}}async function n(B,G,O){const{protocol:M,firstMessage:x}=await o(B,2,G,O),V=x&&x.debugPort;return{protocol:M,debugPort:V}}async function i(B,G,O){const M=Date.now(),x=X(B,3),{protocol:V}=await u(B,3,G,O);return B.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${ce(M)}!`),V}async function r(B,G,O){const{host:M,port:x,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:M,port:x,connectionToken:V,reconnectionToken:G,reconnectionProtocol:O,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,G,O){return h(B,async M=>{const{protocol:x}=await s(M,R.CancellationToken.None);return new J(B,G,O,M.reconnectionToken,x)})}e.connectRemoteAgentManagement=c;async function a(B,G){return h(B,async O=>{const{protocol:M,debugPort:x}=await n(O,G,R.CancellationToken.None);return new j(B,G,O.reconnectionToken,M,x)})}e.connectRemoteAgentExtensionHost=a;async function h(B,G){for(let M=1;;M++)try{const x=(0,I.generateUuid)(),V=await r(B,x,null);return await G(V)}catch(x){if(M<5)B.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(x);else throw B.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(x),q.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(x)),x}}async function S(B,G,O){const M=await r(B,(0,I.generateUuid)(),null);return await i(M,{host:G,port:O},R.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function A(B){return(0,D.createCancelablePromise)(G=>new Promise((O,M)=>{const x=setTimeout(O,B*1e3);G.onCancellationRequested(()=>{clearTimeout(x),O()})}))}var $;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})($=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(G,O){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=_;class U{constructor(G,O,M,x){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.durationSeconds=M,this.cancellableTimer=x,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class k{constructor(G,O,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=k;class N{constructor(G,O,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=4}}e.ConnectionGainEvent=N;class F{constructor(G,O,M,x){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.handled=x,this.type=3}}e.ReconnectionPermanentFailureEvent=F;class q extends P.Disposable{static triggerPermanentFailure(G,O,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=G,this._permanentFailureAttempt=O,this._permanentFailureHandled=M,this._instances.forEach(x=>x._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(G=>G._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(G=>G._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||q._permanentFailure}constructor(G,O,M,x,V){super(),this._connectionType=G,this._options=O,this.reconnectionToken=M,this.protocol=x,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(x.onSocketClose(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(x.onSocketTimeout(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),q._instances.push(this),this._register((0,P.toDisposable)(()=>{const ee=q._instances.indexOf(this);ee>=0&&q._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(q._permanentFailureMillisSinceLastIncomingData,q._permanentFailureAttempt,q._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const G=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const x=M<O.length?O[M]:O[O.length-1];try{if(x>0){const ee=A(x);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this._options.logService.info(`${G} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${G} resolving connection...`);const V=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${G} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,y(p)),this._options.logService.info(`${G} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,L.isCancellationError)(V)){this._options.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,b.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(G,O,M){this._reconnectionFailureIsFatal?q.triggerPermanentFailure(G,O,M):this._gotoPermanentFailure(G,O,M)}_gotoPermanentFailure(G,O,M){this._onDidStateChange.fire(new F(this.reconnectionToken,G,O,M)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=q,q._permanentFailure=!1,q._permanentFailureMillisSinceLastIncomingData=0,q._permanentFailureAttempt=0,q._permanentFailureHandled=!1,q._instances=[];class J extends q{constructor(G,O,M,x,V){super(1,G,x,V,!0),this.client=this._register(new E.Client(V,{remoteAuthority:O,clientId:M},G.ipcLogger))}async _reconnect(G,O){await s(G,O)}}e.ManagementPersistentConnection=J;class j extends q{constructor(G,O,M,x,V){super(2,G,M,x,!1),this._startArguments=O,this.debugPort=V}async _reconnect(G,O){await n(G,this._startArguments,O)}}e.ExtensionHostPersistentConnection=j;function H(B){try{B.acceptDisconnect();const G=B.getSocket();B.dispose(),G.dispose()}catch(G){(0,L.onUnexpectedError)(G)}}function W(B){if(B&&B.type==="error"){const G=new Error(`Connection error: ${B.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function z(B,G){for(;B.length<G;)B+=" ";return B}function K(B,G,O){return`[remote-connection][${z(g(B),13)}][${G.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function X(B,G){return`${K(G,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ce(B){return`${Date.now()-B} ms`}}),define(ne[209],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[210],re([0,1,82,140]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,L,T,P,I,E){const b=p=>E(p,void 0),C=D.createConnection({host:R,port:L},()=>{C.removeListener("error",b);const p=Buffer.alloc(16);for(let w=0;w<16;w++)p[w]=Math.round(Math.random()*256);const v=p.toString("base64"),g=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${L}${T}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];C.write(g.join(`\r
`)+`\r
\r
`);const y=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",y),E(void 0,new t.NodeSocket(C,I)))};C.on("data",y)});C.setNoDelay(!0),C.once("error",b)}}}),define(ne[211],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelStatus=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var t;(function(R){R.Uninitialized="uninitialized",R.Disconnected="disconnected",R.Connecting="connecting",R.Connected="connected"})(t=e.TunnelStatus||(e.TunnelStatus={}))}),define(ne[212],re([0,1,123,17,8]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,I){this.configurationService=P,this.logService=I}async request(P,I){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const E=await(0,D.request)(P,I);return this.logService.trace("RequestService#request (browser) - success",P.url),E}catch(E){throw this.logService.error("RequestService#request (browser) - error",P.url,E),E}}async resolveProxy(P){}};L=pe([Y(0,t.IConfigurationService),Y(1,R.ILogService)],L),e.RequestService=L}),define(ne[45],re([0,1,16,158,43,5,40]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=P;function I(y){return y.res.statusCode===204}async function E(y){return I(y)?null:(await(0,D.streamToBuffer)(y.stream)).toString()}e.asText=E;async function b(y){if(!P(y))throw new Error("Server returned "+y.res.statusCode);return E(y)}e.asTextOrError=b;async function C(y){if(!P(y))throw new Error("Server returned "+y.res.statusCode);if(I(y))return null;const d=(await(0,D.streamToBuffer)(y.stream)).toString();try{return JSON.parse(d)}catch(m){throw m.message+=`:
`+d,m}}e.asJson=C;function p(y){g(y)}e.updateProxyConfigurationsScope=p;let v;function g(y){const w=T.Registry.as(R.Extensions.Configuration),d=v;v={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[v],remove:d?[d]:[]})}g(2)}),define(ne[213],re([0,1,23,24,14,45]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(I,E){this.requestService=I,this.fileService=E}async download(I,E,b=D.CancellationToken.None){if(I.scheme===t.Schemas.file||I.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(I,E);return}const C={type:"GET",url:I.toString(!0)},p=await this.requestService.request(C,b);if(p.res.statusCode===200)await this.fileService.writeFile(E,p.stream);else{const v=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${v}`)}}};T=pe([Y(0,L.IRequestService),Y(1,R.IFileService)],T),e.DownloadService=T}),define(ne[214],re([0,1,18,23,2,19,175,14,8,25,45]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends R.Disposable{constructor(v,g,y,w){super(),this.fileService=v,this.productService=g,this.requestService=y,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,d])=>this.allConfigBasedTips.set(d.configPath,d))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const g=[];for(const[y,w]of this.allConfigBasedTips)if(!(w.configScheme&&w.configScheme!==v.scheme))try{const d=await this.fileService.readFile((0,L.joinPath)(v,y)),m=new Map;Object.entries(w.recommendations).forEach(([f,u])=>{if((0,D.isNonEmptyArray)(u.remotes))for(const o of u.remotes)m.set(o,{extensionId:f,extensionName:u.name,configName:w.configName,important:!!u.important,isExtensionPack:!!u.isExtensionPack,whenNotInstalled:u.whenNotInstalled});else g.push({extensionId:f,extensionName:u.name,configName:w.configName,important:!!u.important,isExtensionPack:!!u.isExtensionPack,whenNotInstalled:u.whenNotInstalled})});const l=(0,T.getDomainsOfRemotes)(d.value.toString(),[...m.keys()]);for(const f of l){const u=m.get(f);u&&g.push(u)}}catch{}return g}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(v.res.statusCode!==200)return[];const g=await(0,b.asJson)(v);return g?g.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};C=pe([Y(0,P.IFileService),Y(1,E.IProductService),Y(2,b.IRequestService),Y(3,I.ILogService)],C),e.ExtensionTipsService=C}),define(ne[215],re([0,1,16,23]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.service=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,E,b=t.CancellationToken.None){switch(I){case"request":return this.service.request(E[0],b).then(async({res:C,stream:p})=>{const v=await(0,D.streamToBuffer)(p);return[{statusCode:C.statusCode,headers:C.headers},v]});case"resolveProxy":return this.service.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class L{constructor(P){this.channel=P}async request(P,I){const[E,b]=await this.channel.call("request",[P],I);return{res:E,stream:(0,D.bufferToStream)(b)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=L}),define(ne[216],re([0,1,212,215]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(T,P,I){this.configurationService=P,this.logService=I,this.browserRequestService=new D.RequestService(P,I),this.mainRequestService=new t.RequestChannelClient(T.getChannel("request"))}request(T,P){return this.getRequestService().request(T,P)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(ne[104],re([0,1,65,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(L){return(0,D.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[217],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[218],re([0,1,91,6,23,3,2,24,30,8,104,217]),function(Q,e,D,t,R,L,T,P,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(y){this.logService=y,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const w=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${w})`);const d=(0,b.hash)(y);this.processeDisposables.has(d)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${w})`),this.doDisposeWorker(y));const m=new R.CancellationTokenSource;let l,f,u;this.processeDisposables.set(d,i=>{m.dispose(!0),l?.terminate(y,R.CancellationToken.None),f?.close(),u?.close(),this.processeDisposables.delete(d);const r=this.processResolvers.get(d);r&&(this.processResolvers.delete(d),r({reason:i}))}),l=await this.getOrCreateWebWorker(y);const o=new Promise(i=>{this.processResolvers.set(d,i)});if(m.token.isCancellationRequested)return o;const{port1:s,port2:n}=new MessageChannel;return f=s,u=n,await l.spawn(y,u,m.token),m.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${w})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[f])),o}getOrCreateWebWorker(y){let w=this.workers.get(y.process.moduleId);if(!w){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const d=new v(y.process.type,this.logService);w=d.init(),d.onDidProcessSelfTerminate(({configuration:m,reason:l})=>{this.doDisposeWorker(m,l)}),this.workers.set(y.process.moduleId,w)}return w}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,w){const d=this.processeDisposables.get((0,b.hash)(y));d&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),d(w))}};p=pe([Y(0,E.ILogService)],p),e.SharedProcessWorkerService=p;class v extends T.Disposable{constructor(y,w){super(),this.type=y,this.logService=w,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new t.DeferredPromise,w=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return w.onerror=d=>{this.logService.error(`SharedProcess: worker error (${this.type})`,d.message)},w.onmessageerror=d=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,d)},w.onmessage=d=>{const{id:m,message:l,configuration:f,nonce:u}=d.data;switch(m){case C.SharedProcessWorkerMessages.Ready:y.complete(w);break;case C.SharedProcessWorkerMessages.Ack:if(u){const o=this.mapMessageNonceToPendingMessageResolve.get(u);o&&(this.mapMessageNonceToPendingMessageResolve.delete(u),o())}break;case C.SharedProcessWorkerMessages.SelfTerminated:f&&l&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(l)});break;case C.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,l);break;case C.SharedProcessWorkerMessages.Info:l&&this.logService.info(l);break;case C.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,l);break;case C.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,l);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,d)}},w.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,w,d){const m=await this.workerReady;if(!w.isCancellationRequested)return new Promise(l=>{const f=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,l);const u={...y,nonce:f};d?m.postMessage(u,[d]):m.postMessage(u),w.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&l()})})}spawn(y,w,d){const m={id:C.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(m,d,w)}terminate(y,w){const d={id:C.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(d,w)}}}),define(ne[219],re([0,1,63,24,174]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.vscodeUserData})}}pe([D.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[220],re([0,1,48,10,159,23,38,9,4,30,137,172,6]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let g;async function y(d,m,l){return m["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(l)&&!m["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(l)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=p.Promises.withAsyncBody(async(f,u)=>{const o=new L.CancellationTokenSource,s=setTimeout(()=>{o.dispose(!0),u(new Error((0,R.localize)(0,null)))},v);try{f(await w(d,o.token))}catch(n){!(0,P.isCancellationError)(n)&&!o.token.isCancellationRequested?u(new Error((0,R.localize)(1,null,(0,T.toErrorMessage)(n)))):f({})}finally{clearTimeout(s),o.dispose()}})),g)}e.getResolvedShellEnv=y;async function w(d,m){const l=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",l);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",f);const u=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(u+"(.*)"+u),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",s);const n=await(0,b.getSystemShell)(I.OS,s);return d.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(m.isCancellationRequested)return r((0,P.canceled)());const c=(0,t.basename)(n);let a,h;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${S} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${S} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,c==="tcsh"?h=["-ic"]:h=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const A=(0,D.spawn)(n,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});m.onCancellationRequested(()=>(A.kill(),r((0,P.canceled)()))),A.on("error",U=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(U)),r(U)});const $=[];A.stdout.on("data",U=>$.push(U));const _=[];A.stderr.on("data",U=>_.push(U)),A.on("close",(U,k)=>{const N=Buffer.concat($).toString("utf8");d.trace("getUnixShellEnvironment#raw",N);const F=Buffer.concat(_).toString("utf8");if(F.trim()&&d.trace("getUnixShellEnvironment#stderr",F),U||k)return r(new Error((0,R.localize)(2,null,U,k)));const q=o.exec(N),J=q?q[1]:"{}";try{const j=JSON.parse(J);l?j.ELECTRON_RUN_AS_NODE=l:delete j.ELECTRON_RUN_AS_NODE,f?j.ELECTRON_NO_ATTACH_CONSOLE=f:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",j),i(j)}catch(j){d.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(j)),r(j)}})})}}),define(ne[105],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[221],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,L)=>Q(["vsda"],R,L))}async createNewMessage(R){try{const L=await this.vsda(),T=new L.validator;if(T){const P=String(D._nextId++);return this.validators.set(P,T),{id:P,data:T.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,L){if(!R.id)return!0;const T=this.validators.get(R.id);if(!T)return!1;this.validators.delete(R.id);try{return T.validate(L)==="ok"}catch{return!1}}async sign(R){try{const L=await this.vsda(),T=new L.signer;if(T)return T.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(ne[73],re([0,1,3,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends t.Disposable{constructor(C,p,v){super(),this.channel=C,this.profile=p,this.workspace=v}async getItems(){const C={profile:this.profile,workspace:this.workspace},p=await this.channel.call("getItems",C);return new Map(p)}updateItems(C){const p={profile:this.profile,workspace:this.workspace};return C.insert&&(p.insert=Array.from(C.insert.entries())),C.delete&&(p.delete=Array.from(C.delete.values())),this.channel.call("updateItems",p)}}class L extends R{constructor(C,p){super(C,p,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(C=>this.onDidChangeStorage(C)))}onDidChangeStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class T extends L{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class P extends L{constructor(C,p){super(C,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends R{constructor(C,p){super(C,void 0,p),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class E{constructor(C){this.channel=C}isUsed(C){const p={payload:C,profile:void 0,workspace:void 0};return this.channel.call("isUsed",p)}}e.StorageClient=E}),define(ne[106],re([0,1,4,37,7,30]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,b,C,p,v,g,y,w,d,m){const l=Object.create(null);l["common.machineId"]=y,l.sessionID=(0,L.generateUuid)()+Date.now(),l.commitHash=v,l.version=g,l["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.PlatformToString)(D.platform),l["common.nodePlatform"]=t.platform,l["common.nodeArch"]=p,l["common.product"]=m||"desktop",w&&(l["common.msftInternal"]=w);let f=0;const u=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),D.isLinuxSnap&&(l["common.snap"]="true");const o=T(C);o&&(l["common.platformDetail"]=o);try{const s=await E.readFile(R.URI.file(d));l["common.source"]=s.value.toString().slice(0,30)}catch{}return l}e.resolveCommonProperties=P;function I(E){const b=t.env.USERDNSDOMAIN;if(!b)return!1;const C=b.toLowerCase();return E.some(p=>C===p)}e.verifyMicrosoftInternalDomain=I}),define(ne[22],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[222],re([0,1,36,53,6,35,24,10,4,7,134,28,136,94,14,25,22]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function m(s,n){const i=`${s}::${n.join(":")}`,r=d.get(i);if(r)return r;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,h=new Map,S=2e4;function A(_,U,k,N){const F=U.substring(_.length+1);return R.Promises.withAsyncBody(async q=>{let J;try{J=await C.Promises.readdir(U,{withFileTypes:!0})}catch{q();return}if(N.count>=S){N.count+=J.length,N.maxReached=!0,q();return}let j=J.length;if(j===0){q();return}let H=J;N.count+J.length>S&&(N.maxReached=!0,j=S-N.count,H=J.slice(0,j)),N.count+=J.length;for(const W of H)if(W.isDirectory()){if(k.includes(W.name)||await A(_,(0,P.join)(U,W.name),k,N),--j===0){q();return}}else{const z=W.name.lastIndexOf(".");if(z>=0){const K=W.name.substring(z+1);K&&a.set(K,(a.get(K)??0)+1)}for(const K of c)K.relativePathPattern?.test(F)!==!1&&K.filePattern.test(W.name)&&h.set(K.tag,(h.get(K.tag)??0)+1);if(--j===0){q();return}}})}const $=R.Promises.withAsyncBody(async _=>{const U={count:0,maxReached:!1};await A(s,s,n,U);const k=await u(s);_({configFiles:l(h),fileTypes:l(a),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:k})});return d.set(i,$),$}e.collectWorkspaceStats=m;function l(s){return[...t.Iterable.map(s.entries(),([n,i])=>({name:n,count:i}))].sort((n,i)=>i.count-n.count)}function f(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},n=D.cpus();return n&&n.length>0&&(s.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),s}e.getMachineInfo=f;async function u(s){try{const n=new Map,i=(0,P.join)(s,".vscode","launch.json"),r=await C.Promises.readFile(i),c=[],a=(0,L.parse)(r.toString(),c);if(c.length)return console.log(`Unable to parse ${i}`),[];if((0,L.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const S=h.type;S&&(n.has(S)?n.set(S,n.get(S)+1):n.set(S,1))}return l(n)}catch{return[]}}e.collectLaunchConfigs=u;let o=class{constructor(n,i){this.telemetryService=n,this.productService=i}formatMachineInfo(n){const i=[];return i.push(`OS Version:       ${n.os}`),i.push(`CPUs:             ${n.cpus}`),i.push(`Memory (System):  ${n.memory}`),i.push(`VM:               ${n.vmHint}`),i.join(`
`)}formatEnvironment(n){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const r=D.cpus();return r&&r.length>0&&i.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||i.push(`Load (avg):       ${D.loadavg().map(c=>Math.round(c)).join(", ")}`),i.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${n.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(n,i){return Promise.all([(0,p.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async r=>{let[c,a]=r,h=this.formatProcessList(n,c);return i.forEach(S=>{if((0,v.isRemoteDiagnosticError)(S))h+=`
${S.errorMessage}`,a+=`
${S.errorMessage}`;else if(h+=`

Remote: ${S.hostName}`,S.processes&&(h+=`
${this.formatProcessList(n,S.processes)}`),S.workspaceMetadata){a+=`
|  Remote: ${S.hostName}`;for(const A of Object.keys(S.workspaceMetadata)){const $=S.workspaceMetadata[A];let _=`${$.fileCount} files`;$.maxFilesReached&&(_=`more than ${_}`),a+=`|    Folder (${A}): ${_}`,a+=this.formatWorkspaceStats($)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(n,i){const{memory:r,vmHint:c,os:a,cpus:h}=f(),S={os:a,memory:r,cpus:h,vmHint:c,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:i};return I.isWindows||(S.load=`${D.loadavg().map(A=>Math.round(A)).join(", ")}`),I.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(n,i){const r=[];return(0,p.listProcesses)(n.mainPID).then(async c=>(r.push(""),r.push(this.formatEnvironment(n)),r.push(""),r.push(this.formatProcessList(n,c)),n.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(n))),i.forEach(a=>{if((0,v.isRemoteDiagnosticError)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.formatMachineInfo(a.machineInfo)),a.processes&&r.push(this.formatProcessList(n,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const S=a.workspaceMetadata[h];let A=`${S.fileCount} files`;S.maxFilesReached&&(A=`more than ${A}`),r.push(`Folder (${h}): ${A}`),r.push(this.formatWorkspaceStats(S))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(n){const i=[];let c=0;const a=($,_)=>{const U=` ${$}(${_})`;c+U.length>60?(i.push(h),h="|                 ",c=h.length):c+=U.length,h+=U};let h="|      File types:";const S=10,A=n.fileTypes.length>S?S:n.fileTypes.length;for(let $=0;$<A;$++){const _=n.fileTypes[$];a(_.name,_.count)}if(i.push(h),n.configFiles.length>=0&&(h="|      Conf files:",c=0,n.configFiles.forEach($=>{a($.name,$.count)}),i.push(h)),n.launchConfigFiles.length>0){let $="|      Launch Configs:";n.launchConfigFiles.forEach(_=>{$+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),i.push($)}return i.join(`
`)}expandGPUFeatures(n){const i=Math.max(...Object.keys(n).map(r=>r.length));return Object.keys(n).map(r=>`${r}:  ${" ".repeat(i-r.length)}  ${n[r]}`).join(`
                  `)}formatWorkspaceMetadata(n){const i=[],r=[];return n.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(i.push(`|  Window (${c.title})`),c.folderURIs.forEach(a=>{const h=E.URI.revive(a);if(h.scheme===T.Schemas.file){const S=h.fsPath;r.push(m(S,["node_modules",".git"]).then(A=>{let $=`${A.fileCount} files`;A.maxFilesReached&&($=`more than ${$}`),i.push(`|    Folder (${(0,P.basename)(S)}): ${$}`),i.push(this.formatWorkspaceStats(A))}).catch(A=>{i.push(`|      Error: Unable to collect workspace stats for folder ${S} (${A.toString()})`)}))}else i.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(c=>i.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(n,i){const r=new Map;n.windows.forEach(a=>r.set(a.pid,a.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(n.mainPID,r,c,i,0),c.join(`
`)}formatProcessItem(n,i,r,c,a){const h=a===0;let S;h?S=c.pid===n?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(a)} ${c.name}`,c.name==="window"&&(S=`${S} (${i.get(c.pid)})`));const A=process.platform==="win32"?c.mem:D.totalmem()*(c.mem/100);r.push(`${c.load.toFixed(0).padStart(5," ")}	${(A/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(c.children)&&c.children.forEach($=>this.formatProcessItem(n,i,r,$,a+1))}async getWorkspaceFileExtensions(n){const i=new Set;for(const{uri:r}of n.folders){const c=E.URI.revive(r);if(c.scheme!==T.Schemas.file)continue;const a=c.fsPath;try{(await m(a,["node_modules",".git"])).fileTypes.forEach(S=>i.add(S.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(n){for(const{uri:i}of n.folders){const r=E.URI.revive(i);if(r.scheme!==T.Schemas.file)continue;const c=r.fsPath;try{const a=await m(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};o=pe([Y(0,w.ITelemetryService),Y(1,y.IProductService)],o),e.DiagnosticsService=o}),define(ne[223],re([0,1,3,22,13,2,8,7,10,48,25,4,6,99,17]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let y=class extends L.Disposable{constructor(d,m,l,f,u,o){super(),this.telemetryService=d,this.productService=m,this.environmentService=l,this._onDidTokenFailedEmitter=new D.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new D.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new D.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus="disconnected";const s=P.URI.file((0,I.join)((0,I.dirname)(l.logsPath),"remoteTunnel.log"));this._logger=this._register(f.createLogger(s,{name:"remoteTunnel"})),this._register(u.onWillShutdown(n=>{this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this.dispose()}))}async getAccount(){return this._account}async updateAccount(d){if(d&&this._account?d.token!==this._account.token||d.authenticationProviderId!==this._account.authenticationProviderId:d!==this._account){this._account=d,this._onDidChangeAccountEmitter.fire(d),this._logger.info(`Account updated: ${d?d.authenticationProviderId:"undefined"}`),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!d});try{this.updateTunnelProcess()}catch(m){this._logger.error(m)}}}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus("disconnected");return}this.setTunnelStatus("connecting");const d=this.runCodeTunneCommand("login",["user","login","--provider",this._account.authenticationProviderId,"--access-token",this._account.token]);this._tunnelProcess=d;try{await d}catch(m){this._logger.error(m),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus("disconnected")}if(this._tunnelProcess===d){const m=this.runCodeTunneCommand("tunnel",["--random-name"],l=>{});this._tunnelProcess=m,m.finally(()=>{m===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus("disconnected"))})}}setTunnelStatus(d){d!==this._tunnelStatus&&(this._tunnelStatus=d,this._onDidChangeTunnelStatusEmitter.fire(d))}runCodeTunneCommand(d,m,l=()=>{}){return(0,p.createCancelablePromise)(f=>new Promise((u,o)=>{f.isCancellationRequested&&u();let s;if(f.onCancellationRequested(()=>{s&&(this._logger.info(`${d} terminating (${s.pid})`),s.kill())}),process.env.VSCODE_DEV)this._logger.info(`${d} Spawning: cargo run --bin code-tunnel -- ${m.join(" ")}`),s=(0,E.spawn)("cargo",["run","--bin","code-tunnel","--",...m],{cwd:(0,I.join)(this.environmentService.appRoot,"cli")});else{const n=(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.tunnelApplicationName}${C.isWindows?".exe":""}`);this._logger.info(`${d} Spawning: ${n} ${m.join(" ")}`),s=(0,E.spawn)(n,m)}s.stdout.on("data",n=>{if(s){const i=n.toString();l(i,!1),this._logger.info(`${d} stdout (${s.pid}):  + ${i}`)}}),s.stderr.on("data",n=>{if(s){const i=n.toString();l(i,!0),this._logger.info(`${d} stderr (${s.pid}):  + ${i}`)}}),s.on("exit",n=>{s&&(this._logger.info(`${d} exit (${s.pid}):  + ${n}`),s=void 0,u())}),s.on("error",n=>{s&&(this._logger.info(`${d} error (${s.pid}):  + ${n}`),s=void 0,o())})}))}};y=pe([Y(0,t.ITelemetryService),Y(1,b.IProductService),Y(2,R.INativeEnvironmentService),Y(3,T.ILoggerService),Y(4,v.ISharedProcessLifecycleService),Y(5,g.IConfigurationService)],y),e.RemoteTunnelService=y}),define(ne[107],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,{eventName:P,data:I}){return this.appenders.forEach(E=>E.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class t{constructor(L){this.channel=L}log(L,T){return this.channel.call("log",{eventName:L,data:T}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ne[51],re([0,1,32,84,15,17,106,22]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,r){return Promise.resolve(void 0)}publicLog2(i,r){return this.publicLog(i,r)}publicLogError(i,r){return Promise.resolve(void 0)}publicLogError2(i,r){return this.publicLogError(i,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class E{async publicLog(i,r,c){}async publicLogError(i,r,c){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(n,i){return i.onDidChangeConfiguration(r=>{r.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(r.source),configurationKeys:d(r.sourceConfig)})})}e.configurationTelemetry=b;function C(n,i){return!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=C;function p(n){const i=n.getValue(P.TELEMETRY_SETTING_ID),r=n.getValue("telemetry.enableCrashReporter");if(n.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function v(n){const i={},r={},c={};w(n,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const h=c[a];typeof h=="number"?r[a]=h:typeof h=="boolean"?r[a]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${h.length}`),i[a]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(i[a]=h)}return{properties:i,measurements:r}}e.validateTelemetryData=v;const g=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function y(n){if(!n)return"none";for(const i of g)if(n.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=y;function w(n,i,r=0,c){if(!!n)for(const a of Object.getOwnPropertyNames(n)){const h=n[a],S=c?c+a:a;Array.isArray(h)?i[S]=(0,D.safeStringify)(h):h instanceof Date?i[S]=h.toISOString():(0,R.isObject)(h)?r<2?w(h,i,r+1,S+"."):i[S]=(0,D.safeStringify)(h):i[S]=h}}function d(n){if(!n)return[];const i=[];return m(i,"",n),i}function m(n,i,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(c=>m(n,i?`${i}.${c}`:c,r[c])):n.push(i)}function l(n,i){const r=n.msftInternalDomains||[],c=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(r)||c}e.isInternalTelemetry=l;function f(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=f;function u(n,i){let r=n;const c=[];for(const A of i)for(;;){const $=A.exec(n);if(!$)break;c.push([$.index,A.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(r="";;){const A=h.exec(n);if(!A)break;!a.test(A[0])&&c.every(([$,_])=>A.index<$||A.index>=_)&&(r+=n.substring(S,A.index)+"<REDACTED: user-file-path>",S=h.lastIndex)}return S<n.length&&(r+=n.substr(S)),r}function o(n){if(!n)return n;const i=n.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of r)if(c.regex.test(i))return`<REDACTED: ${c.label}>`;return n}function s(n,i){return(0,D.cloneAndChange)(n,r=>{if(typeof r=="string"){let c=r;c=u(c,i);for(const a of i)c=c.replace(a,"");return c=o(c),c}})}e.cleanData=s}),define(ne[224],re([0,1,49,51]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(L,T,P,I,E,b,C){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`};if((0,t.supportsTelemetry)(T,P)&&(0,t.getTelemetryLevel)(I)===3){const v=await(0,D.getServiceMachineId)(P,E,b),{sessionId:g}=await C.getTelemetryInfo();p["X-Market-User-Id"]=v,p["VSCode-SessionId"]=g}return p}e.resolveMarketplaceHeaders=R}),define(ne[225],re([0,1,9,32,51]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(I,E,b){const C=await new Promise((w,d)=>{Q(["@microsoft/1ds-core-js"],w,d)}),p=await new Promise((w,d)=>{Q(["@microsoft/1ds-post-js"],w,d)}),v=new C.AppInsightsCore,g=new p.PostChannel,y={instrumentationKey:I,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(b){y.extensionConfig={};const w={alwaysUseXhrOverride:!0,httpXHROverride:b};y.extensionConfig[g.identifier]=w}return v.initialize(y,[]),v.addTelemetryInitializer(w=>{E&&(w.ext=w.ext??{},w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),v}class P{constructor(E,b,C,p,v){this._isInternalTelemetry=E,this._eventPrefix=b,this._defaultData=C,this._xhrOverride=v,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(E){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){E(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(b=>{E(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(E,b){if(!this._aiCoreOrKey)return;b=(0,t.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b);const C=this._eventPrefix+"/"+E;try{this._withAIClient(p=>{p.pluginVersionString=b?.properties.version??"Unknown",p.track({name:C,baseData:{name:C,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(E=>{this._withAIClient(b=>{b.unload(!0,()=>{this._aiCoreOrKey=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ne[108],re([0,1,2,13,8,51]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(I,E,b=""){super(),this.prefix=b;const C=I.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(I.createLogger(E.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,E){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,L.validateTelemetryData)(E))}};T=pe([Y(0,R.ILoggerService),Y(1,t.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[109],re([0,1,2,32,84,4,27,160,17,43,101,25,40,22,51]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(m,l,f){this._configurationService=l,this._productService=f,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,l){this._experimentProperties[m]=l}_updateTelemetryLevel(){let m=(0,g.getTelemetryLevel)(this._configurationService);const l=this._productService.enabledTelemetryLevels;if(l){this._sendErrorTelemetry=this.sendErrorTelemetry?l.error:!1;const f=l.usage?3:l.error?2:0;m=Math.min(m,f)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,l=m.sessionID,f=m["common.machineId"],u=m["common.firstSessionDate"],o=m["common.msftInternal"];return{sessionId:l,machineId:f,firstSessionDate:u,msftInternal:o}}dispose(){this._disposables.dispose()}_log(m,l,f,u){return this.telemetryLevel.value<l?Promise.resolve(void 0):this._commonProperties.then(o=>{f=(0,t.mixin)(f,o),f=(0,t.mixin)(f,this._experimentProperties),f=(0,g.cleanData)(f,this._cleanupPatterns),this._appenders.forEach(s=>s.log(m,f))},o=>{console.error(o)})}publicLog(m,l,f){return this._log(m,3,l,f)}publicLog2(m,l,f){return this.publicLog(m,l,f)}publicLogError(m,l){return this._sendErrorTelemetry?this._log(m,2,l,!0):Promise.resolve(void 0)}publicLogError2(m,l){return this.publicLogError(m,l)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=pe([Y(1,I.IConfigurationService),Y(2,C.IProductService)],y),e.TelemetryService=y;function w(){const d=(0,P.localize)(0,null,b.default.nameLong),m=b.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=L.isWeb?"":(0,P.localize)(3,null),f=(0,P.localize)(4,null),u=(0,P.localize)(5,null),o=(0,P.localize)(6,null),s=(0,P.localize)(7,null),n=`
|       | ${f} | ${u} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,P.localize)(8,null);return`
${d} ${m} ${l}

&nbsp;

${s}
${n}

&nbsp;

${i}
`}p.Registry.as(E.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(E.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,P.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,P.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[226],re([0,1,282,225]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends t.AbstractOneDataSystemAppender{constructor(T,P,I,E){const b={sendPOST:(C,p)=>{const v={method:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data)}};try{const g=D.request(C.urlString,v,y=>{y.on("data",function(w){p(y.statusCode??200,y.headers,w.toString())}),y.on("error",function(w){p(0,{})})});g.write(C.data),g.end()}catch{p(0,{})}}};super(T,P,I,E,b)}}e.OneDataSystemAppender=R}),define(ne[227],re([0,1,24,67,17,13,8,25,22,107,108,109]),function(Q,e,D,t,R,L,T,P,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(g,y,w,d,m){this.configurationService=g,this.telemetryService=y,this.loggerService=w,this.environmentService=d,this.productService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(g){if(!this.customTelemetryServices.has(g.id)){const{machineId:y,sessionId:w}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=y,d["common.vscodesessionid"]=w;const m=[g.id,JSON.stringify(d),g.aiKey],f=new t.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new E.TelemetryAppenderClient(f),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${g.id}] `)];this.customTelemetryServices.set(g.id,new C.TelemetryService({appenders:u,sendErrorTelemetry:g.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(g.id)}async publicLog(g,y,w){await(await this.getCustomTelemetryService(g)).publicLog(y,w)}async publicLogError(g,y,w){await(await this.getCustomTelemetryService(g)).publicLogError(y,w)}};p=pe([Y(0,R.IConfigurationService),Y(1,I.ITelemetryService),Y(2,T.ILoggerService),Y(3,L.IEnvironmentService),Y(4,P.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(ne[228],re([0,1,6,23,3,2,8]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(E,b){super(),this._logService=b,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((b,C)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,b),this._onCreateRequest.fire({requestId:p,...E});const v=new t.CancellationTokenSource;(0,D.timeout)(this._timeout,v.token).then(()=>C(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(E,b){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,L.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(b)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=pe([Y(1,T.ILogService)],P),e.RequestStore=P}),define(ne[110],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(l){l.Shell="terminal.integrated.shell.",l.ShellArgs="terminal.integrated.shellArgs.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(l){l.ShellLinux="terminal.integrated.shell.linux",l.ShellMacOs="terminal.integrated.shell.osx",l.ShellWindows="terminal.integrated.shell.windows",l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationShellLinux="terminal.integrated.automationShell.linux",l.AutomationShellMacOs="terminal.integrated.automationShell.osx",l.AutomationShellWindows="terminal.integrated.automationShell.windows",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ShellArgsLinux="terminal.integrated.shellArgs.linux",l.ShellArgsMacOs="terminal.integrated.shellArgs.osx",l.ShellArgsWindows="terminal.integrated.shellArgs.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(l){l.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var P;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.Log="log",l.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(l){l.TerminalView="view",l.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(g=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}));var d;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[229],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[230],re([0,1,36,24,32,10,4,37,27,15,28]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let u=0;return f&&f.length===4&&(u=parseInt(f[3])),u}e.getWindowsBuildNumber=C;async function p(f,u,o,s=P.env,n=b.Promises.exists){if(L.isAbsolute(f))return await n(f)?f:void 0;if(u===void 0&&(u=P.cwd()),L.dirname(f)!=="."){const a=L.join(u,f);return await n(a)?a:void 0}const r=(0,R.getCaseInsensitive)(s,"PATH");if(o===void 0&&(0,E.isString)(r)&&(o=r.split(L.delimiter)),o===void 0||o.length===0){const a=L.join(u,f);return await n(a)?a:void 0}for(const a of o){let h;if(L.isAbsolute(a)?h=L.join(a,f):h=L.join(u,a,f),await n(h))return h;if(T.isWindows){let S=h+".com";if(await n(S)||(S=h+".exe",await n(S)))return S}}const c=L.join(u,f);return await n(c)?c:void 0}e.findExecutable=p;function v(f,u,o,s,n){if(!u.shellIntegration.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration||T.isWindows&&!u.windowsEnableConpty)return;const i=f.args,r=P.platform==="win32"?L.basename(f.executable).toLowerCase():L.basename(f.executable),c=L.dirname(t.FileAccess.asFileUri("",Q).fsPath);let a;const h={VSCODE_INJECTION:"1"};if(T.isWindows){if(r==="pwsh.exe")return!i||m(i)?a=e.shellIntegrationArgs.get(g.WindowsPwsh):d(i)&&(a=e.shellIntegrationArgs.get(g.WindowsPwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],c,""),{newArgs:a,envMixin:h}):void 0;s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(r){case"bash":return!i||i.length===0?a=e.shellIntegrationArgs.get(g.Bash):l(i)&&(h.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(g.Bash)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],c),{newArgs:a,envMixin:h}):void 0;case"pwsh":return!i||m(i)?a=e.shellIntegrationArgs.get(g.Pwsh):d(i)&&(a=e.shellIntegrationArgs.get(g.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],c,""),{newArgs:a,envMixin:h}):void 0;case"zsh":{if(!i||i.length===0?a=e.shellIntegrationArgs.get(g.Zsh):l(i)?a=e.shellIntegrationArgs.get(g.ZshLogin):(i===e.shellIntegrationArgs.get(g.Zsh)||i===e.shellIntegrationArgs.get(g.ZshLogin))&&(a=i),!a)return;a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],c);const S=L.join(D.tmpdir(),`${D.userInfo().username}-${n.applicationName}-zsh`);h.ZDOTDIR=S;const A=o?.ZDOTDIR??D.homedir()??"~";h.USER_ZDOTDIR=A;const $=[];return $.push({source:L.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(S,".zshrc")}),$.push({source:L.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(S,".zprofile")}),$.push({source:L.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(S,".zshenv")}),$.push({source:L.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(S,".zlogin")}),{newArgs:a,envMixin:h,filesToCopy:$}}}s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=v;var g;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(g=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(g.Zsh,["-i"]),e.shellIntegrationArgs.set(g.ZshLogin,["-il"]),e.shellIntegrationArgs.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],w=["-nol","-nologo"];function d(f){return typeof f=="string"?y.includes(f.toLowerCase()):f.length===1&&y.includes(f[0].toLowerCase())||f.length===2&&(y.includes(f[0].toLowerCase())||y.includes(f[1].toLowerCase()))&&(w.includes(f[0].toLowerCase())||w.includes(f[1].toLowerCase()))}function m(f){return typeof f=="string"?w.includes(f.toLowerCase()):f.length===0||f?.length===1&&w.includes(f[0].toLowerCase())}function l(f){return f==="string"&&y.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&y.includes(f[0].toLowerCase())}}),define(ne[231],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function t(L){return L===D.HIGH_CONTRAST_DARK||L===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function R(L){return L===D.DARK||L===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(ne[111],re([0,1,52,3,2,5,40,231]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var I;(function(w){function d(m){return m&&typeof m=="object"&&typeof m.id=="string"}w.isThemeColor=d})(I=e.ThemeColor||(e.ThemeColor={}));function E(w){return{id:w}}e.themeColorFromId=E;var b;(function(w){function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||I.isThemeColor(i.color))}w.isThemeIcon=d;const m=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const r=m.exec(i);if(!r)return;const[,c]=r;return{id:c}}w.fromString=l;function f(i){return{id:i}}w.fromId=f;function u(i,r){let c=i.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),r&&(c=`${c}~${r}`),{id:c}}w.modify=u;function o(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}w.getModifier=o;function s(i,r){return i.id===r.id&&i.color?.id===r.color?.id}w.isEqual=s;function n(i,r){return{id:i.id,color:r?E(r):void 0}}w.asThemeIcon=n,w.asClassNameArray=D.CSSIcon.asClassNameArray,w.asClassName=D.CSSIcon.asClassName,w.asCSSSelector=D.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(w){switch(w){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,R.toDisposable)(()=>{const m=this.themingParticipants.indexOf(d);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new p;T.Registry.add(e.Extensions.ThemingContribution,v);function g(w){return v.onColorThemeChange(w)}e.registerThemingParticipant=g;class y extends R.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,m){let l=this.theme.getColor(d);return l&&m&&(l=m(l,this.theme)),l?l.toString():null}}e.Themable=y}),define(ne[232],re([0,1,52,7,162,111]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(p,v){const g=[{name:null,description:(0,R.localize)(0,null)}];return g.push(...p.map(y=>({name:y.profileName,description:P(y)}))),v&&g.push(...v.map(y=>({name:y.title,description:I(y)}))),{values:g.map(y=>y.name),markdownDescriptions:g.map(y=>y.description)}}e.createProfileSchemaEnums=T;function P(p){let v=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?v+=`
- args: "${p.args}"`:v+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(v+=`
- overrideName: ${p.overrideName}`),p.color&&(v+=`
- color: ${p.color}`),p.env&&(v+=`
- env: ${JSON.stringify(p.env)}`),v}function I(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function E(p,v){if(!p&&!v)return!0;if(typeof p=="string"&&typeof v=="string")return p===v;if(Array.isArray(p)&&Array.isArray(v)){if(p.length!==v.length)return!1;for(let g=0;g<p.length;g++)if(p[g]!==v[g])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function b(p,v){if(!p&&!v)return!0;if(!p||!v)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(v))return p.id===v.id&&p.color===v.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof v=="object"&&"light"in v&&"dark"in v){const g=p,y=v;if((t.URI.isUri(g.light)||C(g.light))&&(t.URI.isUri(g.dark)||C(g.dark))&&(t.URI.isUri(y.light)||C(y.light))&&(t.URI.isUri(y.dark)||C(y.dark)))return g.light.path===y.light.path&&g.dark.path===y.dark.path}if(t.URI.isUri(p)&&t.URI.isUri(v)||C(p)||C(v)){const g=p,y=v;return g.path===y.path&&g.scheme===y.scheme}return!1}e.terminalIconsEqual=b;function C(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=C}),define(ne[233],re([0,1,52,161,43,40,232]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),f=>`$(${f.id})`)};const P={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...P}},b=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),g=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){L.Registry.as(R.Extensions.Configuration).registerConfiguration(w),l()}e.registerTerminalPlatformConfiguration=d;let m;function l(f,u){const o=L.Registry.as(R.Extensions.Configuration);let s;f&&(s=(0,T.createProfileSchemaEnums)(f?.profiles,u));const n=m;m={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?s?.values:void 0,markdownEnumDescriptions:f?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?s?.values:void 0,markdownEnumDescriptions:f?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?s?.values:void 0,markdownEnumDescriptions:f?.os===1?s?.markdownDescriptions:void 0}}},o.updateConfigurations({add:[m],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=l}),define(ne[234],re([0,1,48,52,10,4,28,88,230,111]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,C=!0;function p(s,n,i,r,c=process.env,a,h,S,A){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},L.isWindows?v(i,a,c,h,r.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:r.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:r.getValue("terminal.integrated.defaultProfile.windows"),A,S):f(a,h,i,s&&typeof s=="object"?{...s}:r.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:r.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,S,c)}e.detectAvailableProfiles=p;async function v(s,n,i,r,c,a,h,S,A){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${$?"Sysnative":"System32"}`;let U=!1;(0,I.getWindowsBuildNumber)()>=16299&&(U=!0),await w(S);const k=new Map;s&&(k.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),u(a,k);const N=await g(k.entries(),h,n,i,r,A);if(s||c)try{const F=await m(`${_}\\${U?"wsl":"bash"}.exe`,h);for(const q of F)(!a||!(q.profileName in a))&&N.push(q)}catch{C&&(r?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return N}async function g(s,n,i,r=process.env,c,a){const h=[];for(const[S,A]of s){if(A===null)continue;let $,_,U;if("source"in A){const F=b?.get(A.source);if(!F)continue;$=F.paths,_=A.args||F.args,A.icon?U=y(A.icon):F.icon&&(U=F.icon)}else $=Array.isArray(A.path)?A.path:[A.path],_=L.isWindows||Array.isArray(A.args)?A.args:void 0,U=y(A.icon);const k=await a?.($)||$.slice(),N=await o(S,n,k,i,r,_,A.env,A.overrideName,A.isAutoDetected,c);N?(N.isAutoDetected=A.isAutoDetected,N.icon=U,N.color=A.color,h.push(N)):c?.debug("Terminal profile not validated",S,$)}return c?.debug("Validated terminal profiles",h),h}function y(s){return typeof s=="string"?{id:s}:s}async function w(s){b&&!s||(b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),b.set("PowerShell",{profileName:"PowerShell",paths:s||await d(),icon:E.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function d(){const s=[];for await(const n of(0,P.enumeratePowerShellInstallations)())s.push(n.exePath);return s}async function m(s,n){const i=[],r=await new Promise((h,S)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,$)=>{if(A)return S("Problem occurred when getting wsl distros");h($)})});if(!r)return[];const c=new RegExp(/[\r?\n]/),a=r.split(c).filter(h=>h.trim().length>0&&h!=="");for(const h of a){if(h===""||h.startsWith("docker-desktop"))continue;const S=`${h} (WSL)`,A={profileName:S,path:s,args:["-d",`${h}`],isDefault:S===n,icon:l(h),isAutoDetected:!1};i.push(A)}return i}function l(s){return s.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):s.includes("Debian")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function f(s,n,i,r,c,a,h,S){const A=new Map;if(i){const $=(await s.readFile("/etc/shells")).toString(),_=a||$.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),U=new Map;for(const k of _){let N=(0,R.basename)(k),F=U.get(N)||0;F++,F>1&&(N=`${N} (${F})`),U.set(N,F),A.set(N,{path:k,isAutoDetected:!0})}}return u(r,A),await g(A.entries(),c,s,S,n,h)}function u(s,n){if(!!s)for(const[i,r]of Object.entries(s))r===null||!("path"in r)&&!("source"in r)?n.delete(i):(r.icon=r.icon||n.get(i)?.icon,n.set(i,r))}async function o(s,n,i,r,c,a,h,S,A,$){if(i.length===0)return Promise.resolve(void 0);const _=i.shift();if(_==="")return o(s,n,i,r,c,a,h,S,A);const U={profileName:s,path:_,args:a,env:h,overrideName:S,isAutoDetected:A,isDefault:s===n};if((0,R.basename)(_)===_){const N=c.PATH?c.PATH.split(R.delimiter):void 0,F=await(0,I.findExecutable)(_,void 0,N,void 0,r.existsFile);return F?(U.path=F,U.isFromPath=!0,U):o(s,n,i,r,c,a)}return await r.existsFile((0,R.normalize)(_))?U:o(s,n,i,r,c,a,h,S,A)}}),define(ne[235],re([0,1,3,2,24,4,39,67,17,13,92,220,8,100,228,110,233,234]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let l=0,f=class extends t.Disposable{constructor(o,s,n,i){super(),this._reconnectConstants=o,this._configurationService=s,this._environmentService=n,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new g.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,b.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?o.debugBrk=s.port:!s.break&&s.port&&(o.debug=s.port));const n=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,o);this._onPtyHostStart.fire(),T.ProxyChannel.toService(n.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const r=n.getChannel(y.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const c=T.ProxyChannel.toService(n.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(a=>this._onProcessData.fire(a))),this._register(c.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(c.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(c.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(c.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(c.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(c.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[n,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,s,n,i,r,c,a,h,S,A,$){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),U=await this._proxy.createProcess(o,s,n,i,r,c,a,h,S,A,$);return clearTimeout(_),l=Math.max(l,U),U}updateTitle(o,s,n){return this._proxy.updateTitle(o,s,n)}updateIcon(o,s,n,i){return this._proxy.updateIcon(o,s,n,i)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o,s){return this._proxy.detachFromProcess(o,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,s){return this._proxy.shutdown(o,s)}input(o,s){return this._proxy.input(o,s)}processBinary(o,s){return this._proxy.processBinary(o,s)}resize(o,s,n){return this._proxy.resize(o,s,n)}acknowledgeDataEvent(o,s){return this._proxy.acknowledgeDataEvent(o,s)}setUnicodeVersion(o,s){return this._proxy.setUnicodeVersion(o,s)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}installAutoReply(o,s){return this._proxy.installAutoReply(o,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(o){return this._proxy.uninstallAutoReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,s,n,i=!1){const r=await this._shellEnv;return(0,d.detectAvailableProfiles)(s,n,i,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}getRevivedPtyNewId(o){return this._proxy.getRevivedPtyNewId(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,s){return this._proxy.requestDetachInstance(o,s)}async acceptDetachInstanceReply(o,s){return this._proxy.acceptDetachInstanceReply(o,s)}async freePortKillProcess(o){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(o)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o,s){return this._proxy.reviveTerminalProcesses(o,s)}async refreshProperty(o,s){return this._proxy.refreshProperty(o,s)}async updateProperty(o,s,n){return this._proxy.updateProperty(o,s,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:s})}async acceptPtyHostResolvedVariables(o,s){this._resolveVariablesRequestStore.acceptReply(o,s)}};f=pe([Y(1,I.IConfigurationService),Y(2,E.IEnvironmentService),Y(3,p.ILogService)],f),e.PtyHostService=f}),define(ne[74],re([0,1,3,4,5,8]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var T;(function(y){y.Http="http",y.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=C;function p(y,w){return w?w!==1&&y<1024:!t.isWindows&&y<1024}e.isPortPrivileged=p;class v{constructor(w,d,m){this.remoteAddress=w,this.localAddress=d,this._dispose=m,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let g=class{constructor(w){this.logService=w,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],d=Array.from(this._tunnels.values());for(const m of d){const l=Array.from(m.values());for(const f of l){const u=await f.value;u&&w.push(u)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:d}of w.values())await d.then(m=>m?.dispose());w.clear()}this._tunnels.clear()}setEnvironmentTunnel(w,d,m,l,f){this.addTunnelToMap(w,d,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:d,localAddress:m,privacy:l,protocol:f,dispose:()=>Promise.resolve()}))}openTunnel(w,d,m,l,f=!1,u,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${l}.`),!w)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(w,d,m,l,f,u,o);return s?s.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==d||n.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const d=this._tunnels.get(w.tunnelRemoteHost);if(d){const m=d.get(w.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async tryDisposeTunnel(w,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${d}.`);const l=m.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(d),l}}async closeTunnel(w,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${d} `);const m=this._tunnels.get(w);if(m&&m.has(d)){const l=m.get(d);l.refcount=0,await this.tryDisposeTunnel(w,d,l)}}addTunnelToMap(w,d,m){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(w,d){const m=this._tunnels.get(w);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,d){const m=[w];b(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):C(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const l=m.map(f=>this._tunnels.get(f));for(const f of l){const u=f?.get(d);if(u)return u}}canTunnel(w){return!!E(w)}doIsPortPrivileged(w,d,m,l){if(d)return!1;if(m){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(f?.length===4){const u=parseInt(f[1]),o=parseInt(f[2]);if(u>10||u===10&&o>=14)return!1}}return w<1024}createWithProvider(w,d,m,l,f,u,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${l}.`);const s=m;this._factoryInProgress.add(s);const n=l===void 0?m:l,i={elevationRequired:f?this.isPortPrivileged(n):!1},r={remoteAddress:{host:d,port:m},localAddressPort:l,privacy:u,public:u?u!==P.Private:void 0,protocol:o},c=w.forwardPort(r,i);return c?(this.addTunnelToMap(d,m,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),c}};g=pe([Y(0,L.ILogService)],g),e.AbstractTunnelService=g}),define(ne[236],re([0,1,8,74,2,9,6]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let I=class Lt extends R.Disposable{constructor(b,C){super(),this._tunnelService=b,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++Lt._lastId)}}async startTunnel(b,C,p,v,g,y){const w=new P,d=await Promise.resolve(this._tunnelService.openTunnel(b,w,p,v,g,y));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${v} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),w.dispose(),await d.dispose(),(0,L.canceled)();return w.setTunnel(d),this._tunnels.set(C,w),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${d.localAddress} (local) to ${p}:${v} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(b,C){const p=this._tunnels.get(b);!p||p.setAddress(C)}async destroyTunnel(b){const C=this._tunnels.get(b);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await C.dispose();return}this._disposedTunnels.add(b)}};I._lastId=0,I=pe([Y(0,t.ISharedTunnelsService),Y(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(ne[237],re([0,1,82,36,121,210,6,2,17,8,25,208,74,105,4]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(f,u,o,s,n){let i;for(let r=3;r&&(i?.dispose(),i=await new w(f,u,o,s,n).waitForReady(),!(n&&R.BROWSER_RESTRICTED_PORTS[n]||!R.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));r--);return i}class w extends P.Disposable{constructor(u,o,s,n,i){super(),this.defaultTunnelHost=o,this.suggestedLocalPort=i,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){let u=await(0,R.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),o=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address(),o||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async _onConnection(u){u.pause();const o=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,C.connectRemoteAgentTunnel)(this._options,o,this.tunnelRemotePort),n=s.getSocket().socket,i=s.readEntireBuffer();s.dispose(),i.byteLength>0&&u.write(i.buffer),u.on("end",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),n.end()}),u.on("close",()=>n.end()),u.on("error",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),n.destroy()}),n.on("end",()=>u.end()),n.on("close",()=>u.end()),n.on("error",()=>{u.destroy()}),u.pipe(n),n.pipe(u),u.localAddress&&this._socketsDispose.set(u.localAddress,()=>{u.end(),n.end()})}}let d=class extends p.AbstractTunnelService{constructor(u,o,s,n,i){super(o),this.socketFactory=u,this.signService=s,this.productService=n,this.configurationService=i}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(u){return this.doIsPortPrivileged(u,g.isWindows,g.isMacintosh,t.release())}retainOrCreateTunnel(u,o,s,n,i,r,c){const a=this.getTunnelFromMap(o,s);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,s,n,i,r,c);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${n}.`);const h={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},S=y(h,this.defaultTunnelHost,o,s,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,s,S),S}}};d=pe([Y(1,E.ILogService),Y(2,v.ISignService),Y(3,b.IProductService),Y(4,I.IConfigurationService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(u,o,s,n){super(L.nodeSocketFactory,u,o,s,n)}};m=pe([Y(0,E.ILogService),Y(1,v.ISignService),Y(2,b.IProductService),Y(3,I.IConfigurationService)],m),e.TunnelService=m;let l=class extends P.Disposable{constructor(u,o,s,n){super(),this.logService=u,this.productService=o,this.signService=s,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(u,o,s,n,i,r,c,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${n} on local port ${i}.`),!this._tunnelServices.has(u)){const h=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(h),this._tunnelServices.set(u,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(o,s,n,i,r,c,a)}};l=pe([Y(0,E.ILogService),Y(1,b.IProductService),Y(2,v.ISignService),Y(3,I.IConfigurationService)],l),e.SharedTunnelsService=l}),define(ne[31],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[238],re([0,1,3,2,7,13,33,14,8,31]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let b=class extends t.Disposable{constructor(p,v,g,y,w){super(),this.extensionsManagementService=p,this.logService=y,this.uriIdentityService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(m=>{this.installedExtensions=m.map(l=>l.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(m=>this.onInstallExtension(m))),this._register(p.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(p.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const d=R.URI.file(g.extensionsPath);this._register(v.watch(d)),this._register(D.Event.filter(v.onDidFilesChange,m=>m.rawChanges.some(l=>this.doesChangeAffects(l,d)))(()=>this.onDidChange()))}doesChangeAffects(p,v){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),v)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const v of p)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(v=>!(0,T.areSameExtensions)(v,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,T.areSameExtensions)(v,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),v=p.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,T.areSameExtensions)(w,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),g=this.installedExtensions.filter(y=>this.installingExtensions.some(w=>(0,T.areSameExtensions)(w,y))?!1:p.every(w=>!(0,T.areSameExtensions)(w.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=p.map(y=>y.identifier),(v.length||g.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:g})}}};b=pe([Y(1,P.IFileService),Y(2,L.INativeEnvironmentService),Y(3,I.ILogService),Y(4,E.IUriIdentityService)],b),e.ExtensionsWatcher=b}),define(ne[239],re([0,1,31,93,14,19,119,3,2]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(p){this.uri=p,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let b=class{constructor(p){this._fileService=p,this._dispooables=new I.DisposableStore,this._limit=2**16;const v=new Map,g=y=>{let w=v.get(y.scheme);return w===void 0&&(w=p.hasProvider(y)&&!this._fileService.hasCapability(y,1024),v.set(y.scheme,w)),w};this._dispooables.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(y=>{v.delete(y.scheme)})),this.extUri=new L.ExtUri(g),this._canonicalUris=new T.SkipList((y,w)=>this.extUri.compare(y,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,L.normalizePath)(p));const v=this._canonicalUris.get(p);return v?v.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new E(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((g,y)=>g[1].touch<y[1].touch?1:g[1].touch>y[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let g=0;g<v;g++)this._canonicalUris.set(p[g][0],p[g][1].touch())}};b=pe([Y(0,R.IFileService)],b),e.UriIdentityService=b,(0,t.registerSingleton)(D.IUriIdentityService,b,1)}),define(ne[240],re([0,1,3,2,14,42,34,16]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends t.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(b,C,p,v){super(),this.fileSystemScheme=b,this.fileSystemProvider=C,this.userDataScheme=p,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(g=>this.handleFileChanges(g)))}watch(b,C){this.watchResources.set(b,b);const p=this.fileSystemProvider.watch(this.toFileSystemResource(b),C);return(0,t.toDisposable)(()=>{this.watchResources.delete(b),p.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,C,p){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(C),p)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,C,p){const v=(0,L.newWriteableStream)(g=>P.VSBuffer.concat(g.map(y=>P.VSBuffer.wrap(y))).buffer);return(async()=>{try{const g=await this.readFile(b);v.end(g)}catch(g){v.error(g),v.end()}})(),v}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,C,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),C,p)}delete(b,C){return this.fileSystemProvider.delete(this.toFileSystemResource(b),C)}copy(b,C,p){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(b),this.toFileSystemResource(C),p);throw new Error("copy not supported")}handleFileChanges(b){const C=[];for(const p of b){if(p.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(p.resource);this.watchResources.findSubstr(v)&&C.push({resource:v,type:p.type})}C.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(C))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(ne[61],re([0,1,80]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(T,P,I,E){const b=(0,D.setProperty)(T,P,I,E)[0];return b&&(T=T.substring(0,b.offset)+b.content+T.substring(b.offset+b.length)),T}e.edit=t;function R(T,P,I){let E=I;for(;E>=0;){if(T.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&T.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function L(T,P,I){let E=I;for(;E>=0;)if(T.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&T.charAt(E)===P.charAt(1)))return E;return T.length-1}e.getLineEndOffset=L}),define(ne[241],re([0,1,32,55,15]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(v,g,y,w,d,m){const l=[],f=[],u=[];if(!g){const F=v.filter(({identifier:q})=>d.every(J=>J.toLowerCase()!==q.id.toLowerCase()));return{local:{added:l,removed:f,updated:u},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}v=v.map(C),g=g.map(C),y=y?y.map(C):null;const o=new Map,s=F=>{F.uuid&&o.set(F.id.toLowerCase(),F.uuid)};v.forEach(({identifier:F})=>s(F)),g.forEach(({identifier:F})=>s(F)),y?.forEach(({identifier:F})=>s(F));const n=F=>{const q=F.identifier.uuid||o.get(F.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${F.identifier.id.toLowerCase()}`},i=(F,q)=>(F.set(n(q),q),F),r=v.reduce(i,new Map),c=g.reduce(i,new Map),a=g.reduce((F,q)=>i(F,(0,D.deepClone)(q)),new Map),h=y?y.reduce(i,new Map):null,S=w.reduce(i,new Map),A=d.reduce((F,q)=>{const J=o.get(q.toLowerCase());return F.add(J?`uuid:${J}`:`id:${q.toLowerCase()}`)},new Set),$=m.reduce((F,{id:q,uuid:J})=>(J=J??o.get(q.toLowerCase()),F.add(J?`uuid:${J}`:`id:${q.toLowerCase()}`)),new Set),_=T(r,c,A,!1);if(_.added.size>0||_.removed.size>0||_.updated.size>0){const F=T(h,r,A,!1),q=T(h,c,A,!0),J=(j,H,W,z)=>({...z,installed:H.installed||W.installed,version:W.version&&(!H.installed||t.gt(W.version,H.version))?W.version:H.version,state:I(H,W,h?.get(j)),preRelease:(H.installed?z.preRelease:W.preRelease)??H.preRelease});for(const j of q.removed.values()){const H=r.get(j);if(!H)continue;const W=(0,R.assertIsDefined)(h?.get(j)),z=!$.has(j)&&W.installed;H.installed&&z?f.push(H.identifier):a.set(j,H)}for(const j of q.added.values()){const H=(0,R.assertIsDefined)(c.get(j)),W=r.get(j);if(W){if(_.updated.has(j)){const z=J(j,W,H,H);P(W,H,!1,!1)||u.push(p(z,j)),a.set(j,z)}}else H.installed&&l.push(p(H,j))}for(const j of q.updated.values()){const H=(0,R.assertIsDefined)(c.get(j)),W=(0,R.assertIsDefined)(h?.get(j)),z=r.get(j);if(z)if(!$.has(j)&&W.installed&&z.installed&&!H.installed)f.push(z.identifier);else{const X=J(j,z,H,H);u.push(p(X,j)),a.set(j,X)}else H.installed&&l.push(p(H,j))}for(const j of F.added.values())q.added.has(j)||a.set(j,(0,R.assertIsDefined)(r.get(j)));for(const j of F.updated.values()){if(q.removed.has(j)||q.updated.has(j))continue;const H=(0,R.assertIsDefined)(r.get(j)),W=(0,R.assertIsDefined)(c.get(j));a.set(j,J(j,H,W,H))}for(const j of F.removed.values())q.updated.has(j)||q.removed.has(j)||S.has(j)||!(0,R.assertIsDefined)(c.get(j)).installed||$.has(j)||!(0,R.assertIsDefined)(h?.get(j)).installed||a.delete(j)}const U=[],k=T(c,a,new Set,!0),N=k.added.size>0||k.updated.size>0||k.removed.size>0;return N&&a.forEach((F,q)=>U.push(p(F,q))),{local:{added:l,removed:f,updated:u},remote:N?{added:[...k.added].map(F=>a.get(F)),updated:[...k.updated].map(F=>a.get(F)),removed:[...k.removed].map(F=>c.get(F)),all:U}:null}}e.merge=L;function T(v,g,y,w){const d=v?[...v.keys()].filter(o=>!y.has(o)):[],m=[...g.keys()].filter(o=>!y.has(o)),l=m.filter(o=>d.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),f=d.filter(o=>m.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),u=new Set;for(const o of d){if(f.has(o))continue;const s=v.get(o),n=g.get(o);(!n||!P(s,n,w,!0))&&u.add(o)}return{added:l,removed:f,updated:u}}function P(v,g,y,w){return!(v.disabled!==g.disabled||w&&v.installed!==g.installed||v.installed&&g.installed&&v.preRelease!==g.preRelease||!b(v.state,g.state)||y&&v.version!==g.version)}function I(v,g,y){const w=v.state,d=g.state,m=y?.state;if(!g.version||w&&t.gt(v.version,g.version))return w;if(d&&t.gt(g.version,v.version)||!w)return d;if(!d)return w;const l=(0,D.deepClone)(w),f=m?E(m,d):{added:Object.keys(d).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set},u=m?E(m,w):{added:Object.keys(w).reduce((o,s)=>(o.add(s),o),new Set),removed:new Set,updated:new Set};for(const o of[...f.added.values(),...f.updated.values()])l[o]=d[o];for(const o of f.removed.values())u.updated.has(o)||delete l[o];return l}function E(v,g){const y=Object.keys(v),w=Object.keys(g),d=w.filter(f=>y.indexOf(f)===-1).reduce((f,u)=>(f.add(u),f),new Set),m=y.filter(f=>w.indexOf(f)===-1).reduce((f,u)=>(f.add(u),f),new Set),l=new Set;for(const f of y){if(m.has(f))continue;const u=v[f],o=g[f];(0,D.equals)(u,o)||l.add(f)}return{added:d,removed:m,updated:l}}function b(v={},g={}){const{added:y,removed:w,updated:d}=E(v,g);return y.size===0&&w.size===0&&d.size===0}function C(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function p(v,g){const y={identifier:{id:v.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!v.preRelease};return v.version&&(y.version=v.version),v.disabled&&(y.disabled=!0),v.installed&&(y.installed=!0),v.state&&(y.state=v.state),y}}),define(ne[112],re([0,1,18,17,5]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return E=E.filter(b=>b!==P&&b!==`-${P}`),I&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}updateSynchronizedExtensions(P,I){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return E=E.filter(b=>b!==P&&b!==`-${P}`),I&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}getIgnoredExtensions(P){const I=P.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),b=[],C=[];if(Array.isArray(E))for(const p of E)p.startsWith("-")?C.push(p.substring(1)):b.push(p);return(0,D.distinct)([...I,...b].filter(p=>C.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};L=pe([Y(0,t.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[242],re([0,1,18,35,32,180,61]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(f){return(0,t.parse)(f)||[]}e.parseKeybindings=P;async function I(f,u,o,s,n){const i=P(f),r=P(u),c=o?P(o):null,a=[...i,...r,...c||[]].map(J=>J.key),h=await n.resolveUserBindings(a),S=b(i,r,c,h);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const A=p(i),$=p(r),_=c?p(c):null,U=g(A,$,h),k=_?g(_,A,h):{added:[...A.keys()].reduce((J,j)=>(J.add(j),J),new Set),removed:new Set,updated:new Set},N=_?g(_,$,h):{added:[...$.keys()].reduce((J,j)=>(J.add(j),J),new Set),removed:new Set,updated:new Set},F=E(U,k,N);let q=f;for(const J of F.removed.values())F.conflicts.has(J)||(q=m(q,J,s));for(const J of F.added.values()){if(F.conflicts.has(J))continue;const j=$.get(J);if(j.some(H=>H.command!==`-${J}`&&S.conflicts.has(h[H.key]))){F.conflicts.add(J);continue}q=d(q,j,s)}for(const J of F.updated.values()){if(F.conflicts.has(J))continue;const j=$.get(J);if(j.some(H=>H.command!==`-${J}`&&S.conflicts.has(h[H.key]))){F.conflicts.add(J);continue}q=l(q,J,j,s)}return{mergeContent:q,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=I;function E(f,u,o){const s=new Set,n=new Set,i=new Set,r=new Set;for(const c of u.removed.values())o.updated.has(c)&&r.add(c);for(const c of o.removed.values())r.has(c)||(u.updated.has(c)?r.add(c):n.add(c));for(const c of u.added.values())r.has(c)||o.added.has(c)&&f.updated.has(c)&&r.add(c);for(const c of o.added.values())r.has(c)||(u.added.has(c)?f.updated.has(c)&&r.add(c):s.add(c));for(const c of u.updated.values())r.has(c)||o.updated.has(c)&&f.updated.has(c)&&r.add(c);for(const c of o.updated.values())r.has(c)||(u.updated.has(c)?f.updated.has(c)&&r.add(c):i.add(c));return{added:s,removed:n,updated:i,conflicts:r}}function b(f,u,o,s){const n=new Set,i=C(f,s),r=C(u,s),c=o?C(o,s):null,a=v(i,r);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const h=c?v(c,i):{added:[...i.keys()].reduce((k,N)=>(k.add(N),k),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=c?v(c,r):{added:[...r.keys()].reduce((k,N)=>(k.add(N),k),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:A,removed:$,updated:_,conflicts:U}=E(a,h,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:$,updated:_,conflicts:U}}function C(f,u){const o=new Map;for(const s of f){const n=u[s.key];let i=o.get(n);i||(i=[],o.set(n,i)),i.push(s)}return o}function p(f){const u=new Map;for(const o of f){const s=o.command[0]==="-"?o.command.substring(1):o.command;let n=u.get(s);n||(n=[],u.set(s,n)),n.push(o)}return u}function v(f,u){const o=[...f.keys()],s=[...u.keys()],n=s.filter(c=>o.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),i=o.filter(c=>s.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),r=new Set;for(const c of o){if(i.has(c))continue;const a=f.get(c).map(S=>({...S,key:c})),h=u.get(c).map(S=>({...S,key:c}));(0,D.equals)(a,h,(S,A)=>w(S,A))||r.add(c)}return{added:n,removed:i,updated:r}}function g(f,u,o){const s=[...f.keys()],n=[...u.keys()],i=n.filter(a=>s.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),r=s.filter(a=>n.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),c=new Set;for(const a of s){if(r.has(a))continue;const h=f.get(a).map(A=>({...A,key:o[A.key]})),S=u.get(a).map(A=>({...A,key:o[A.key]}));y(h,S)||c.add(a)}return{added:i,removed:r,updated:c}}function y(f,u){return!(!(0,D.equals)(f.filter(({command:o})=>o[0]!=="-"),u.filter(({command:o})=>o[0]!=="-"),(o,s)=>w(o,s))||!(0,D.equals)(f.filter(({command:o})=>o[0]==="-"),u.filter(({command:o})=>o[0]==="-"),(o,s)=>w(o,s)))}function w(f,u){if(f.command!==u.command||f.key!==u.key)return!1;const o=L.ContextKeyExpr.deserialize(f.when),s=L.ContextKeyExpr.deserialize(u.when);return!(o&&!s||!o&&s||o&&s&&!o.equals(s)||!R.equals(f.args,u.args))}function d(f,u,o){for(const s of u)f=T.edit(f,[-1],s,o);return f}function m(f,u,o){const s=P(f);for(let n=s.length-1;n>=0;n--)(s[n].command===u||s[n].command===`-${u}`)&&(f=T.edit(f,[n],void 0,o));return f}function l(f,u,o,s){const n=P(f),i=n.findIndex(r=>r.command===u||r.command===`-${u}`);for(let r=n.length-1;r>=0;r--)(n[r].command===u||n[r].command===`-${u}`)&&(f=T.edit(f,[r],void 0,s));for(let r=o.length-1;r>=0;r--)f=T.edit(f,[i],o[r],s);return f}}),define(ne[243],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,T,P){const I={},E={},b=new Set;if(!T)return{local:{added:I,updated:E,removed:[...b.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const C=t(L,T);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:I,updated:E,removed:[...b.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=t(P,L),v=t(P,T),g={},y={},w=new Set,d=new Set;for(const m of p.removed.values())v.updated.has(m)?I[m]=T[m]:w.add(m);for(const m of v.removed.values())d.has(m)||(p.updated.has(m)?d.add(m):b.add(m));for(const m of p.updated.values())d.has(m)||(v.updated.has(m)?C.updated.has(m)&&d.add(m):y[m]=L[m]);for(const m of v.updated.values())d.has(m)||(p.updated.has(m)?C.updated.has(m)&&d.add(m):L[m]!==void 0&&(E[m]=T[m]));for(const m of p.added.values())d.has(m)||(v.added.has(m)?C.updated.has(m)&&d.add(m):g[m]=L[m]);for(const m of v.added.values())d.has(m)||(p.added.has(m)?C.updated.has(m)&&d.add(m):I[m]=T[m]);return{local:{added:I,removed:[...b.values()],updated:E},remote:{added:g,removed:[...w.values()],updated:y},conflicts:[...d.values()]}}e.merge=D;function t(L,T){const P=L?Object.keys(L):[],I=T?Object.keys(T):[],E=I.filter(p=>P.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),b=P.filter(p=>I.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),C=new Set;for(const p of P){if(b.has(p))continue;const v=L[p],g=T[p];v!==g&&C.add(p)}return{added:E,removed:b,updated:C}}function R(L,T){const{added:P,removed:I,updated:E}=t(L,T);return P.size===0&&I.size===0&&E.size===0}e.areSame=R}),define(ne[244],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,L,T,P){const I={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!L){const b=R.filter(({id:C})=>!P.includes(C));return b.length?I.remote.added=b:I.remote=null,I}const E=t(R,L,P);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=t(T,R,P),C=t(T,L,P);for(const p of C.removed){const v=R.find(g=>g.id===p);v&&I.local.removed.push(v)}for(const p of C.added){const v=L.find(g=>g.id===p);b.added.includes(p)?E.updated.includes(p)&&I.local.updated.push(v):I.local.added.push(v)}for(const p of C.updated)I.local.updated.push(L.find(v=>v.id===p));for(const p of b.added)C.added.includes(p)||I.remote.added.push(R.find(v=>v.id===p));for(const p of b.updated)C.removed.includes(p)||C.updated.includes(p)||I.remote.updated.push(R.find(v=>v.id===p));for(const p of b.removed)I.remote.removed.push(L.find(v=>v.id===p))}return I.remote.added.length===0&&I.remote.removed.length===0&&I.remote.updated.length===0&&(I.remote=null),I}e.merge=D;function t(R,L,T){R=R?R.filter(({id:p})=>!T.includes(p)):[],L=L.filter(({id:p})=>!T.includes(p));const P=R.map(({id:p})=>p),I=L.map(({id:p})=>p),E=I.filter(p=>P.indexOf(p)===-1),b=P.filter(p=>I.indexOf(p)===-1),C=[];for(const{id:p,name:v,shortName:g}of R){if(b.includes(p))continue;const y=L.find(w=>w.id===p);(!y||y.name!==v||y.shortName!==g)&&C.push(p)}return{added:E,removed:b,updated:C}}}),define(ne[26],re([0,1,18,15,168,43,29,5,102,40]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const r=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(c=>!!r[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function C(){const r=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(r).filter(S=>!!r[S].ignoreSync),a=Object.keys(r).filter(S=>r[S].scope===2||r[S].scope===6),h=b();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...a,...h])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const r="vscode://schemas/ignoredSettings",c=E.Registry.as(L.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=E.Registry.as(I.Extensions.JSONContribution),h=()=>{const S=b(),A=C().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),$=Object.keys(L.allSettings.properties).filter(k=>A.indexOf(k)===-1),_=A.filter(k=>S.indexOf(k)===-1),U={items:{type:"string",enum:[...$,..._.map(k=>`-${k}`)]}};a.registerSchema(r,U)};return c.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=p;function v(r){return r&&(0,t.isObject)(r)&&(0,t.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=v;var g;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(g=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(r,...c){return r?[r,...c]:c}e.getPathSegments=y;function w(r,c,a,h){return h.joinPath(a.userDataSyncHome,...y(r,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=w,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(r){const c={};return c[e.HEADER_EXECUTION_ID]=r,c}e.createSyncHeaders=d;var m;(function(r){r.Unauthorized="Unauthorized",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.UnresolvedConflicts="UnresolvedConflicts",r.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class l extends Error{constructor(c,a,h,S){super(c),this.code=a,this.resource=h,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=l;class f extends l{constructor(c,a,h,S,A){super(c,h,void 0,A),this.url=a,this.serverCode=S}}e.UserDataSyncStoreError=f;class u extends l{constructor(c,a){super(c,a)}}e.UserDataAutoSyncError=u,function(r){function c(a){if(a instanceof r)return a;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(h&&h[1]){const S=h[2]==="unknown"?void 0:h[2],A=h[3]==="unknown"?void 0:h[3];return new r(a.message,h[1],S,A)}return new r(a.message,"Unknown")}r.toUserDataSyncError=c}(l=e.UserDataSyncError||(e.UserDataSyncError={}));var o;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(o=e.SyncStatus||(e.SyncStatus={}));var s;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var n;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(r){return`sync.enable.${r}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ne[245],re([0,1,32,26]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(T,P,I,E,b){if(!P)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const C=L(T,P);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=I?L(I,P):{added:Object.keys(P).reduce((m,l)=>(m.add(l),m),new Set),removed:new Set,updated:new Set},v=I?L(I,T):{added:Object.keys(T).reduce((m,l)=>(m.add(l),m),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},y=D.deepClone(P),w=!I;for(const m of v.added.values())m!==t.SYNC_SERVICE_URL_TYPE&&w&&p.added.has(m)||(y[m]=T[m]);for(const m of v.updated.values())y[m]=T[m];for(const m of v.removed.values())E.unregistered.includes(m)||delete y[m];for(const m of p.added.values()){const l=P[m];if(E.machine.includes(m)){b.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(I&&v.added.has(m))continue;const f=T[m];f&&f.value===l.value||m===t.SYNC_SERVICE_URL_TYPE&&w&&v.added.has(m)||(f?g.updated[m]=l:g.added[m]=l)}for(const m of p.updated.values()){const l=P[m];if(E.machine.includes(m)){b.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(v.updated.has(m)||v.removed.has(m))continue;const f=T[m];f&&f.value===l.value||(g.updated[m]=l)}for(const m of p.removed.values()){if(E.machine.includes(m)){b.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}v.updated.has(m)||v.removed.has(m)||g.removed.push(m)}const d=L(P,y);return{local:g,remote:{added:[...d.added],updated:[...d.updated],removed:[...d.removed],all:d.added.size===0&&d.removed.size===0&&d.updated.size===0?null:y}}}e.merge=R;function L(T,P){const I=Object.keys(T),E=Object.keys(P),b=E.filter(v=>I.indexOf(v)===-1).reduce((v,g)=>(v.add(g),v),new Set),C=I.filter(v=>E.indexOf(v)===-1).reduce((v,g)=>(v.add(g),v),new Set),p=new Set;for(const v of I){if(C.has(v))continue;const g=T[v],y=P[v];D.equals(g,y)||p.add(v)}return{added:b,removed:C,updated:p}}}),define(ne[246],re([0,1,18,35,80,46,32,61,26]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function E(a,h,S){let A=[];S?A=C(S):A=b(h);const $=[],_=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const U of A)U.startsWith("-")?_.push(U.substring(1)):$.push(U);return(0,D.distinct)([...a,...$].filter(U=>_.indexOf(U)===-1))}e.getIgnoredSettings=E;function b(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function C(a){const h=(0,t.parse)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function p(a,h){const S=(0,t.parse)(a)||{};let A="{}";for(const $ of Object.keys(S)){const _=(0,R.setProperty)(A,[$],S[$],h);A=(0,R.applyEdits)(A,_)}return A}e.removeComments=p;function v(a,h,S,A){if(S.length){const $=c(h),_=(0,t.parse)(h)||{},U=(0,t.parse)(a);if(!U)return a;const k=[];for(const N of S){const F=_[N],q=U[N];F===void 0?a=P.edit(a,[N],void 0,A):q!==void 0?a=P.edit(a,[N],F,A):k.push(o(N,$))}k.sort((N,F)=>N.startOffset-F.startOffset),k.forEach(N=>a=m(N.setting.key,h,a,A))}return a}e.updateIgnoredSettings=v;function g(a,h,S,A,$,_){const U=v(a,h,A,_),k=S!==U,N=S!==h;if(!k&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!N)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(N&&!k)return{conflictsSettings:[],localContent:v(h,a,A,_),remoteContent:null,hasConflicts:!1};if(S===null&&w(a)){const V=y(a,h,A)?null:v(h,a,A,_);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let F=a,q=h;const J=(0,t.parse)(a),j=(0,t.parse)(h),H=S?(0,t.parse)(S):null,W=A.reduce((V,ee)=>(V.add(ee),V),new Set),z=d(J,j,W),K=d(H,J,W),X=d(H,j,W),ce=new Map,B=new Set,G=V=>{B.add(V);const ee=$.filter(({key:oe})=>oe===V)[0];ee?(F=P.edit(F,[V],ee.value,_),q=P.edit(q,[V],ee.value,_)):ce.set(V,{key:V,localValue:J[V],remoteValue:j[V]})};for(const V of K.removed.values())X.updated.has(V)?G(V):q=P.edit(q,[V],void 0,_);for(const V of X.removed.values())B.has(V)||(K.updated.has(V)?G(V):F=P.edit(F,[V],void 0,_));for(const V of K.updated.values())B.has(V)||(X.updated.has(V)?z.updated.has(V)&&G(V):q=P.edit(q,[V],J[V],_));for(const V of X.updated.values())B.has(V)||(K.updated.has(V)?z.updated.has(V)&&G(V):F=P.edit(F,[V],j[V],_));for(const V of K.added.values())B.has(V)||(X.added.has(V)?z.updated.has(V)&&G(V):q=m(V,F,q,_));for(const V of X.added.values())B.has(V)||(K.added.has(V)?z.updated.has(V)&&G(V):F=m(V,q,F,_));const O=ce.size>0||!y(F,q,A),M=O||!y(F,a,[]),x=O||!y(q,h,[]);return{localContent:M?F:null,remoteContent:x?q:null,conflictsSettings:[...ce.values()],hasConflicts:O}}e.merge=g;function y(a,h,S){if(a===h)return!0;const A=(0,t.parse)(a),$=(0,t.parse)(h),_=S.reduce((N,F)=>(N.add(F),N),new Set),U=c(a).filter(N=>!(N.setting&&_.has(N.setting.key))),k=c(h).filter(N=>!(N.setting&&_.has(N.setting.key)));if(U.length!==k.length)return!1;for(let N=0;N<U.length;N++){const F=U[N],q=k[N];if(F.setting&&q.setting){if(F.setting.key!==q.setting.key||!T.equals(A[F.setting.key],$[F.setting.key]))return!1}else if(!F.setting&&!q.setting){if(F.value!==q.value)return!1}else return!1}return!0}e.areSame=y;function w(a){return a?c(a).length===0:!0}e.isEmpty=w;function d(a,h,S){const A=a?Object.keys(a).filter(N=>!S.has(N)):[],$=Object.keys(h).filter(N=>!S.has(N)),_=$.filter(N=>A.indexOf(N)===-1).reduce((N,F)=>(N.add(F),N),new Set),U=A.filter(N=>$.indexOf(N)===-1).reduce((N,F)=>(N.add(F),N),new Set),k=new Set;if(a)for(const N of A){if(U.has(N))continue;const F=a[N],q=h[N];T.equals(F,q)||k.add(N)}return{added:_,removed:U,updated:k}}function m(a,h,S,A){const $=(0,t.parse)(h),_=c(h),U=c(S),k=l(a,_,U);return f(S,a,$[a],k,U,A)}e.addSetting=m;function l(a,h,S){const A=h.findIndex(_=>_.setting?.key===a),$=h[A-1];if($){if($.setting){const U=o($.setting.key,S);if(U)return{index:S.indexOf(U),insertAfter:!0}}else{const U=s(A,h);if(U){const k=o(U.setting.key,S);if(k){const N=n(S.indexOf(k),S),F=i(h,U,h[A]);if(N){const q=i(S,k,N),J=r(F,q);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.indexOf(N),insertAfter:!1}}else{const q=i(S,k,S[S.length-1]),J=r(F,q);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const _=h[A+1];if(_)if(_.setting){const U=o(_.setting.key,S);if(U)return{index:S.indexOf(U),insertAfter:!1}}else{const U=n(A,h);if(U){const k=o(U.setting.key,S);if(k){const N=s(S.indexOf(k),S),F=i(h,h[A],U);if(N){const q=i(S,N,k),J=r(F.reverse(),q.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:S.indexOf(N),insertAfter:!0}}else{const q=i(S,S[0],k),J=r(F.reverse(),q.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function f(a,h,S,A,$,_){let U;return A.index===-1?U=(0,R.setProperty)(a,[h],S,_):U=u(a,h,S,A,$,_).map(k=>(0,R.withFormatting)(a,k,_)[0]),(0,R.applyEdits)(a,U)}function u(a,h,S,A,$,_){const U=`${JSON.stringify(h)}: ${JSON.stringify(S)}`,k=(0,L.getEOL)(_,a),N=$[A.index];if(A.insertAfter){const F=[];if(N.setting)F.push({offset:N.endOffset,length:0,content:","+U});else{const q=n(A.index,$),J=s(A.index,$),j=J?.setting?.commaOffset;J&&j===void 0&&F.push({offset:J.endOffset,length:0,content:","});const H=j!==void 0&&j>N.endOffset;F.push({offset:H?j+1:N.endOffset,length:0,content:q?k+U+",":k+U})}return F}else{if(N.setting)return[{offset:N.startOffset,length:0,content:U+","}];const F=($[A.index-1]&&!$[A.index-1].setting?k:"")+U+(n(A.index,$)?",":"")+k;return[{offset:N.startOffset,length:0,content:F}]}}function o(a,h){return h.filter(S=>S.setting?.key===a)[0]}function s(a,h){for(let S=a-1;S>=0;S--)if(h[S].setting)return h[S]}function n(a,h){for(let S=a+1;S<h.length;S++)if(h[S].setting)return h[S]}function i(a,h,S){const A=a.indexOf(h),$=a.indexOf(S);return a.filter((_,U)=>A<U&&U<$)}function r(a,h){if(a.length&&h.length){let S=0;for(;S<h.length&&S<a.length;S++)if(a[S].value!==h[S].value)return h[S-1];return h[S-1]}}function c(a){const h=[];let S=-1,A,$;const _={onObjectBegin:U=>{S++},onObjectProperty:(U,k,N)=>{S===0&&(A=k,$=U)},onObjectEnd:(U,k)=>{S--,S===0&&h.push({startOffset:A,endOffset:U+k,value:a.substring(A,U+k),setting:{key:$,commaOffset:void 0}})},onArrayBegin:(U,k)=>{S++},onArrayEnd:(U,k)=>{S--,S===0&&h.push({startOffset:A,endOffset:U+k,value:a.substring(A,U+k),setting:{key:$,commaOffset:void 0}})},onLiteralValue:(U,k,N)=>{S===0&&h.push({startOffset:A,endOffset:k+N,value:a.substring(A,k+N),setting:{key:$,commaOffset:void 0}})},onSeparator:(U,k,N)=>{if(S===0&&U===","){let F=h.length-1;for(;F>=0&&!h[F].setting;F--);const q=h[F];q&&h.splice(F,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:k}})}},onComment:(U,k)=>{S===0&&h.push({startOffset:U,endOffset:U+k,value:a.substring(U,U+k)})}};return(0,t.visit)(a,_),h}}),define(ne[75],re([0,1,3,2,5,26]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let T=class extends t.Disposable{get account(){return this._account}constructor(I,E){super(),this.userDataSyncStoreService=I,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};T=pe([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[247],re([0,1,2,7]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(p){this.service=p}listen(p,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(p,v,g){switch(v){case"triggerSync":return this.service.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(g[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class L{constructor(p){this.service=p}listen(p,v){throw new Error(`Event not found: ${v}`)}call(p,v,g){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(g[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class T{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=T;class P{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(p,v,g){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(g[0],g[1]);case"setEnablements":return this.service.setEnablements(g)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(p,v,g){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(g)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class E{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(p,v,g){switch(v){case"switch":return this.service.switch(g[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class b extends D.Disposable{constructor(p){super(),this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:t.URI.revive(p.url),type:p.type,defaultUrl:t.URI.revive(p.defaultUrl),insidersUrl:t.URI.revive(p.insidersUrl),stableUrl:t.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=b}),define(ne[248],re([0,1,13,8]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends t.AbstractLogger{constructor(T,P){super(),this.logger=this._register(T.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}critical(T,...P){this.logger.critical(T,...P)}flush(){this.logger.flush()}};R=pe([Y(0,t.ILoggerService),Y(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(ne[249],re([0,1,6,3,2]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:E}){super(),this.disposables=this._register(new R.DisposableStore),t.Event.latch(t.Event.any(P,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[113],re([0,1,170,10,34,19,7,5,24]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function E(s){const n=s;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=E,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,t.basename)(s)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=s;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=b;function C(s){const n=s;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=C;function p(s){const n=s;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const i=s;if(i?.configPath)return{id:i.id,configPath:T.URI.revive(i.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=p;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function g(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=g;function y(s){const n=s;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=y;class w{constructor(n,i,r,c,a){this._id=n,this._transient=r,this._configuration=c,this._ignorePathCasing=a,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class d{constructor(n,i){this.raw=i,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function m(s){return new d({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(s,n){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,n.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function f(s){let n;return T.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=f;function u(s,n){return!l(s,n)&&!f(s)}e.isSavedWorkspace=u;function o(s){return(typeof s=="string"?(0,t.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(ne[20],re([0,1,65,3,2,19,15,7,163,13,14,5,8,113,34,31,6,30,27]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function l(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&P.URI.isUri(i.location)&&P.URI.isUri(i.globalStorageHome)&&P.URI.isUri(i.settingsResource)&&P.URI.isUri(i.keybindingsResource)&&P.URI.isUri(i.tasksResource)&&P.URI.isUri(i.snippetsHome)&&((0,T.isUndefined)(i.extensionsResource)||P.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=l,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function f(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:P.URI.revive(n.location).with({scheme:i}),globalStorageHome:P.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:P.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:P.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:P.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:P.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:P.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function u(n,i,r,c){return{id:n,name:i,location:r,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:(0,L.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=u;let o=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,c,a){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=c,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new g.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(h=>u((0,L.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags})):[];let r;const c=new g.ResourceMap,a=u((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),i.length){const h=this.getStoredProfileAssociations();if(h.workspaces)for(const[S,A]of Object.entries(h.workspaces)){const $=P.URI.parse(S),_=P.URI.parse(A),U=i.find(k=>this.uriIdentityService.extUri.isEqual(k.location,_));U&&c.set($,U)}if(h.emptyWindow){const S=P.URI.parse(h.emptyWindow);r=i.find(A=>this.uriIdentityService.extUri.isEqual(A.location,S))}}this._profilesObject={profiles:i,workspaces:c,emptyWindow:r}}return this._profilesObject}async createTransientProfile(i){const r="Temp",c=new RegExp(`${(0,m.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const S of this.profiles){const A=c.exec(S.name),$=A?parseInt(A[1]):0;a=$>a?$:a}const h=`${r} ${a+1}`;return this.createProfile((0,D.hash)((0,d.generateUuid)()).toString(16),h,{transient:!0},i)}async createNamedProfile(i,r,c){return this.createProfile((0,D.hash)((0,d.generateUuid)()).toString(16),i,r,c)}async createProfile(i,r,c,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.doCreateProfile(i,r,c);return a&&await this.setProfileForWorkspace(a,h),h}async doCreateProfile(i,r,c){let a=this.profileCreationPromises.get(r);return a||(a=(async()=>{try{const h=this.profiles.find($=>$.name===r||$.id===i);if(h)return h;const S=u(i,r,(0,L.joinPath)(this.profilesHome,i),c);await this.fileService.createFolder(S.location);const A=[];return this._onWillCreateProfile.fire({profile:S,join($){A.push($)}}),await w.Promises.settled(A),this.updateProfiles([S],[],[]),S}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,a)),a}async updateProfile(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=u(c.id,r.name??c.name,c.location,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:r,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.logService.error(a)}r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(i,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(i);return c||(c=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,c)),c}async setProfileForWorkspace(i,r){this.setProfileForWorkspaceSync(i,r)}setProfileForWorkspaceSync(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,c)}unsetWorkspace(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return P.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,c){const a=[...this.profiles,...i],h=[];this.transientProfilesObject.profiles=[];for(let S of a)S.isDefault||r.some(A=>S.id===A.id)||(S=c.find(A=>S.id===A.id)??S,S.isTransient?this.transientProfilesObject.profiles.push(S):h.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.saveStoredProfiles(h),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,c)}triggerProfilesChanges(i,r,c){this._onDidChangeProfiles.fire({added:i,removed:r,updated:c,all:this.profiles})}updateWorkspaceAssociation(i,r,c){c=r?.isTransient?!0:c,c||this.updateWorkspaceAssociation(i,void 0,!0);const a=this.getWorkspace(i),h=c?this.transientProfilesObject:this.profilesObject;P.URI.isUri(a)?(h.workspaces.delete(a),r&&h.workspaces.set(a,r)):h.emptyWindow=r,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[c,a]of this.profilesObject.workspaces.entries())i[c.toString()]=a.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};o.PROFILES_KEY="userDataProfiles",o.PROFILE_ASSOCIATIONS_KEY="profileAssociations",o=pe([Y(0,E.IEnvironmentService),Y(1,b.IFileService),Y(2,y.IUriIdentityService),Y(3,p.ILogService)],o),e.UserDataProfilesService=o;class s extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=s}),define(ne[250],re([0,1,6,2,20]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends t.Disposable{constructor(P){super(),this._register(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};L=pe([Y(0,R.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[251],re([0,1,18,6,23,9,3,2,4,7,145,29,33,44,8,25,22,20]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(n,i,r,c,a){super(),this.galleryService=n,this.telemetryService=i,this.logService=r,this.productService=c,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:h})=>h.cancel()),this.uninstallingExtensions.forEach(h=>h.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const i=await this.getTargetPlatform();return n.allTargetPlatforms.some(r=>(0,C.isTargetPlatformCompatible)(r,n.allTargetPlatforms,i))}async installFromGallery(n,i={}){try{if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(b.localize(0,null),C.ExtensionManagementErrorCode.Internal);const r=await this.checkAndGetCompatibleVersion(n,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(r.manifest,r.extension,i)}catch(r){throw u(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(n),error:r}),this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(r),f(r)}}async uninstall(n,i={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.uninstallExtension(n,i)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const i=await this.getTargetPlatform(),[r]=await this.galleryService.getExtensions([{...n.identifier,preRelease:n.preRelease}],{targetPlatform:i,compatible:!0},R.CancellationToken.None);if(!r)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.extensionsControlManifest||n-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=n),this.extensionsControlManifest}registerParticipant(n){this.participants.push(n)}async installExtension(n,i,r){const c=_=>`${p.ExtensionKey.create(_).toString()}${r.profileLocation?`-${r.profileLocation.toString()}`:""}`;if(!E.URI.isUri(i)){const _=this.installingExtensions.get(c(i));if(_){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:U}=await _.task.waitUntilTaskIsFinished();return U}r={...r,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],h=[],S=[],A=this.createInstallExtensionTask(n,i,r);E.URI.isUri(i)||this.installingExtensions.set(c(i),{task:A,waitingTasks:[]}),this._onInstallExtension.fire({identifier:A.identifier,source:i,profileLocation:r.profileLocation}),this.logService.info("Installing extension:",A.identifier.id),a.push({task:A,manifest:n});let $=!1;try{if(r.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const U=await this.getAllDepsAndPackExtensions(A.identifier,n,!!r.installOnlyNewlyAddedFromExtensionPack,!!r.installPreReleaseVersion,r.profileLocation),k=await this.getInstalled(void 0,r.profileLocation);for(const{gallery:N,manifest:F}of U){$=$||!!F.extensionDependencies?.some(j=>(0,p.areSameExtensions)({id:j},A.identifier));const q=c(N),J=this.installingExtensions.get(q);if(J){if(this.canWaitForTask(A,J.task)){this.logService.info("Waiting for already requested installing extension",N.identifier.id,A.identifier.id),J.waitingTasks.push(A);const j=J.task.identifier;h.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,H=>H.some(W=>(0,p.areSameExtensions)(W.identifier,j)))).then(H=>{if(!H.find(z=>(0,p.areSameExtensions)(z.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else if(!k.some(({identifier:j})=>(0,p.areSameExtensions)(j,N.identifier))){const j=this.createInstallExtensionTask(F,N,{...r,donotIncludePackAndDependencies:!0});this.installingExtensions.set(q,{task:j,waitingTasks:[A]}),this._onInstallExtension.fire({identifier:j.identifier,source:N,profileLocation:r.profileLocation}),this.logService.info("Installing extension:",j.identifier.id,A.identifier.id),a.push({task:j,manifest:F})}}}catch(U){if(E.URI.isUri(A.source))(0,D.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",A.identifier.id,U.message),(0,D.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",A.identifier.id,U.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),U}const _=a.reduce((U,{task:k,manifest:N})=>(U.set(k.identifier.id.toLowerCase(),{task:k,manifest:N}),U),new Map);for(;_.size;){let U;const k=[..._.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(F=>_.has(F.toLowerCase())));k.length?U=_.size===1?k:k.filter(({task:N})=>!(N===A&&!$)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:N})=>N.identifier.id)),U=[..._.values()]),await this.joinAllSettled(U.map(async({task:N})=>{const F=new Date().getTime();try{const{local:q}=await N.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(q,N.source,r,R.CancellationToken.None))),!E.URI.isUri(N.source)){const J=N.operation===3,j=J?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(u(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(N.source),duration:new Date().getTime()-F,durationSinceUpdate:j}),I.isWeb&&N.operation!==3)try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch{}}S.push({local:q,identifier:N.identifier,operation:N.operation,source:N.source,context:r.context,profileLocation:r.profileLocation,applicationScoped:q.isApplicationScoped})}catch(q){throw E.URI.isUri(N.source)||u(this.telemetryService,N.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(N.source),duration:new Date().getTime()-F,error:q}),this.logService.error("Error while installing the extension:",N.identifier.id),q}finally{_.delete(N.identifier.id.toLowerCase())}}))}return h.length&&await this.joinAllSettled(h),S.forEach(({identifier:U})=>this.logService.info("Extension installed successfully:",U.id)),this._onDidInstallExtensions.fire(S),S.filter(({identifier:U})=>(0,p.areSameExtensions)(U,A.identifier))[0].local}catch(_){if(a.forEach(({task:U})=>U.cancel()),S.length)try{const U=await Promise.allSettled(S.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0,profileLocation:r.profileLocation}).run()));for(let k=0;k<U.length;k++){const N=U[k],{identifier:F}=S[k];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,L.getErrorMessage)(N.reason))}}catch(U){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(U),S.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(a.map(({task:U})=>({identifier:U.identifier,operation:2,source:U.source,context:r.context,profileLocation:r.profileLocation}))),_}finally{for(const[_,{task:U,waitingTasks:k}]of this.installingExtensions.entries()){const N=k.indexOf(A);N!==-1&&k.splice(N,1),k.length===0&&(U===A||N!==-1)&&this.installingExtensions.delete(_)}}}canWaitForTask(n,i){for(const[,{task:r,waitingTasks:c}]of this.installingExtensions.entries())if(r===n&&(c.includes(i)||c.some(a=>this.canWaitForTask(a,i)))||r===i&&c[0]&&!this.canWaitForTask(n,c[0]))return!1;return!0}async joinAllSettled(n){const i=[],r=[],c=await Promise.allSettled(n);for(const a of c)a.status==="fulfilled"?i.push(a.value):r.push(a.reason);if(r.length)throw l(r);return i}async getAllDepsAndPackExtensions(n,i,r,c,a){if(!this.galleryService.isEnabled())return[];const h=await this.getInstalled(void 0,a),S=[n],A=[],$=async(_,U)=>{const k=U.extensionDependencies||[],N=[...k];if(U.extensionPack){const F=r?h.find(q=>(0,p.areSameExtensions)(q.identifier,_)):void 0;for(const q of U.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:q}))||N.every(J=>!(0,p.areSameExtensions)({id:J},{id:q}))&&N.push(q)}if(N.length){const F=[...S,...A.map(J=>J.gallery.identifier)],q=N.filter(J=>F.every(j=>!(0,p.areSameExtensions)(j,{id:J})));if(q.length){const J=await this.galleryService.getExtensions(q.map(j=>({id:j,preRelease:c})),R.CancellationToken.None);for(const j of J){if(F.find(z=>(0,p.areSameExtensions)(z,j.identifier)))continue;const H=k.some(z=>(0,p.areSameExtensions)({id:z},j.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(j,!1,c)}catch(z){if(z instanceof C.ExtensionManagementError&&z.code===C.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!H){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw z}A.push({gallery:W.extension,manifest:W.manifest}),await $(W.extension.identifier,W.manifest)}}}};return await $(n,i),A}async checkAndGetCompatibleVersion(n,i,r){if((await this.getExtensionsControlManifest()).malicious.some(S=>(0,p.areSameExtensions)(n.identifier,S)))throw new C.ExtensionManagementError(b.localize(3,null,n.identifier.id),C.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const S=await this.getTargetPlatform();throw new C.ExtensionManagementError(b.localize(4,null,n.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(S)),C.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(n,i,r);if(a){if(r&&!i&&n.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new C.ExtensionManagementError(b.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!r&&n.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([n.identifier],R.CancellationToken.None))[0]?new C.ExtensionManagementError(b.localize(6,null,n.identifier.id),C.ExtensionManagementErrorCode.ReleaseVersionNotFound):new C.ExtensionManagementError(b.localize(7,null,n.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const h=await this.galleryService.getManifest(a,R.CancellationToken.None);if(h===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new C.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async getCompatibleVersion(n,i,r){const c=await this.getTargetPlatform();let a=null;return!i&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==r&&(a=(await this.galleryService.getExtensions([{...n.identifier,preRelease:r}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(n,r,c)&&(a=n),a||(i?a=(await this.galleryService.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(n,r,c)),a}async uninstallExtension(n,i){const r=$=>`${$.id.toLowerCase()}${i.versionOnly?`-${n.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,c=this.uninstallingExtensions.get(r(n.identifier));if(c)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),c.waitUntilTaskIsFinished();const a=($,_)=>{const U=this.createUninstallExtensionTask($,_);return this.uninstallingExtensions.set(r(U.extension.identifier),U),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this._onUninstallExtension.fire({identifier:$.identifier,profileLocation:i.profileLocation,applicationScoped:$.isApplicationScoped}),U},h=($,_)=>{_?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString(),_.message):this.logService.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,_.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),u(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)($),error:_}),this._onDidUninstallExtension.fire({identifier:$.identifier,version:$.manifest.version,error:_?.code,profileLocation:i.profileLocation,applicationScoped:$.isApplicationScoped})},S=[],A=[];try{S.push(a(n,i));const $=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const _=this.getAllPackExtensionsToUninstall(n,$);for(const U of _)this.uninstallingExtensions.has(r(U.identifier))?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):S.push(a(U,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.checkForDependents(S.map(_=>_.extension),$,n),await this.joinAllSettled(S.map(async _=>{try{if(await _.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(_.extension,i,R.CancellationToken.None))),_.extension.identifier.uuid)try{await this.galleryService.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}h(_.extension)}catch(U){const k=U instanceof C.ExtensionManagementError?U:new C.ExtensionManagementError((0,L.getErrorMessage)(U),C.ExtensionManagementErrorCode.Internal);throw h(_.extension,k),k}finally{A.push(_)}}))}catch($){const _=$ instanceof C.ExtensionManagementError?$:new C.ExtensionManagementError((0,L.getErrorMessage)($),C.ExtensionManagementErrorCode.Internal);for(const U of S){try{U.cancel()}catch{}A.includes(U)||h(U.extension,_)}throw _}finally{for(const $ of S)this.uninstallingExtensions.delete(r($.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}checkForDependents(n,i,r){for(const c of n){const a=this.getDependents(c,i);if(a.length){const h=a.filter(S=>!n.some(A=>(0,p.areSameExtensions)(A.identifier,S.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(c,h,r))}}}getDependentsErrorMessage(n,i,r){return r===n?i.length===1?b.localize(8,null,r.manifest.displayName||r.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?b.localize(9,null,r.manifest.displayName||r.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):b.localize(10,null,r.manifest.displayName||r.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?b.localize(11,null,r.manifest.displayName||r.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?b.localize(12,null,r.manifest.displayName||r.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):b.localize(13,null,r.manifest.displayName||r.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(n,i,r=[]){if(r.indexOf(n)!==-1)return[];r.push(n);const c=n.manifest.extensionPack?n.manifest.extensionPack:[];if(c.length){const a=i.filter(S=>!S.isBuiltin&&c.some(A=>(0,p.areSameExtensions)({id:A},S.identifier))),h=[];for(const S of a)h.push(...this.getAllPackExtensionsToUninstall(S,i,r));return[...a,...h]}return[]}getDependents(n,i){return i.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(c=>(0,p.areSameExtensions)({id:c},n.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(n,i,r){return r.profileLocation&&(0,v.isApplicationScopedExtension)(n)&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(n,i,r)}createUninstallExtensionTask(n,i){return i.profileLocation&&n.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(n,i)}};m=pe([Y(0,C.IExtensionGalleryService),Y(1,w.ITelemetryService),Y(2,g.ILogService),Y(3,y.IProductService),Y(4,d.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function l(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((i,r)=>new Error(`${i.message}${i.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=l;function f(s){if(s instanceof C.ExtensionManagementError)return s;const n=new C.ExtensionManagementError(s.message,C.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}function u(s,n,{extensionData:i,duration:r,error:c,durationSinceUpdate:a}){const h=c?c instanceof C.ExtensionManagementError?c.code:C.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(n,{...i,success:!c,duration:r,errorcode:h,durationSinceUpdate:a})}e.reportTelemetry=u;class o{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(n=>new Promise((i,r)=>{const c=n.onCancellationRequested(()=>{c.dispose(),r(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=o}),define(ne[76],re([0,1,18,6,32,16,9,35,127,2,24,10,4,19,55,86,15,7,148,13,33,44,69,14,5,8,25,3,66,50,20,31,176]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u,o,s,n,i,r,c,a,h,S,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(j){function H(W,z){if(W===z)return!0;const K=Object.keys(W),X=new Set;for(const ce of Object.keys(z))X.add(ce);if(K.length!==X.size)return!1;for(const ce of K){if(W[ce]!==z[ce])return!1;X.delete(ce)}return X.size===0}j.equals=H})(_=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let U=class extends E.Disposable{constructor(H,W,z,K,X,ce,B,G,O,M,x){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=W,this.extensionsControlLocation=z,this.cacheLocation=K,this.userDataProfilesService=X,this.extensionsProfileScannerService=ce,this.fileService=B,this.logService=G,this.environmentService=O,this.productService=M,this.instantiationService=x,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,(0,v.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,(0,v.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,W,z){const[K,X]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(W)]),ce=z?await this.scanExtensionsUnderDevelopment(H,[...K,...X]):[];return this.dedupExtensions(K,X,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const W=[];W.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),W.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[z,K]=await Promise.all(W);return this.applyScanOptions([...z,...K],0,H,!1)}async scanUserExtensions(H){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(H.profileLocation??this.userExtensionsLocation,!!H.profileLocation,1,!H.includeUninstalled,H.language);let K=await(H.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return K=await this.applyScanOptions(K,1,H,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(H,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(K=>K.scheme===b.Schemas.file).map(async K=>{const X=await this.createExtensionScannerInput(K,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(X)).map(B=>(B.type=W.find(G=>(0,f.areSameExtensions)(G.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,X)))}))).flat();return this.applyScanOptions(z,"development",H,!0)}return[]}async scanExistingExtension(H,W,z){const K=await this.createExtensionScannerInput(H,!1,W,!0,z.language),X=await this.extensionsScanner.scanExtension(K);return!X||!z.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(H,W,z){const K=await this.createExtensionScannerInput(H,!1,W,!0,z.language),X=await this.extensionsScanner.scanOneOrMultipleExtensions(K);return this.applyScanOptions(X,W,z,!0)}async scanMetadata(H){const W=(0,v.joinPath)(H,"package.json"),z=(await this.fileService.readFile(W)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(H,W){const z=(0,v.joinPath)(H,"package.json"),K=(await this.fileService.readFile(z)).value.toString(),X=JSON.parse(K);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,X.__metadata={...X.__metadata,...W},await this.fileService.writeFile((0,v.joinPath)(H,"package.json"),L.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async applyScanOptions(H,W,z,K){return z.includeAllVersions||(H=this.dedupExtensions(W===0?H:void 0,W===1?H:void 0,W==="development"?H:void 0,await this.getTargetPlatform(),K)),z.includeInvalid||(H=H.filter(X=>X.isValid)),H.sort((X,ce)=>{const B=C.basename(X.location.fsPath),G=C.basename(ce.location.fsPath);return B<G?-1:B>G?1:0})}dedupExtensions(H,W,z,K,X){const ce=(G,O,M)=>{if(G.isValid&&!O.isValid)return!1;if(G.isValid===O.isValid){if(X&&g.gt(G.manifest.version,O.manifest.version))return this.logService.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(g.eq(G.manifest.version,O.manifest.version)){if(G.type===0)return this.logService.debug(`Skipping extension ${O.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===K)return this.logService.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${G.location.path} with ${O.location.path}.`):this.logService.debug(`Overwriting user extension ${G.location.path} with ${O.location.path}.`),!0},B=new Map;return H?.forEach(G=>{const O=u.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);(!M||ce(M,G,!1))&&B.set(O,G)}),W?.forEach(G=>{const O=u.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);if(!M&&H&&G.type===0){this.logService.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!M||ce(M,G,!1))&&B.set(O,G)}),z?.forEach(G=>{const O=u.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);(!M||ce(M,G,!0))&&B.set(O,G),B.set(O,G)}),[...B.values()]}async scanDefaultSystemExtensions(H,W){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),X=await(H&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",X.length),X}async scanDevSystemExtensions(H,W){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const K=W?await this.getBuiltInExtensionControl():{},X=[],ce=d.URI.file(C.normalize(C.join(b.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const G of z){const O=K[G.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":X.push((0,v.joinPath)(ce,G.name));break;default:X.push(d.URI.file(O));break}}const B=await Promise.all(X.map(async G=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(G,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,D.coalesce)(B)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,W,z,K,X,ce=!0){const B=await this.getTranslations(X??p.language),G=await this.getMtime(H),O=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=O?await this.getMtime(O):void 0;return new k(H,G,O,M,W,z,K,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,X,B)}async getMtime(H){try{const W=await this.fileService.stat(H);if(typeof W.mtime=="number")return W.mtime}catch{}}};U=pe([Y(4,S.IUserDataProfilesService),Y(5,h.IExtensionsProfileScannerService),Y(6,s.IFileService),Y(7,i.ILogService),Y(8,l.IEnvironmentService),Y(9,r.IProductService),Y(10,n.IInstantiationService)],U),e.AbstractExtensionsScannerService=U;class k{constructor(H,W,z,K,X,ce,B,G,O,M,x,V,ee,oe){this.location=H,this.mtime=W,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=K,this.profile=X,this.type=ce,this.excludeObsolete=B,this.validate=G,this.productVersion=O,this.productDate=M,this.productCommit=x,this.devMode=V,this.language=ee,this.translations=oe}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,W){return(0,v.isEqual)(H.location,W.location)&&H.mtime===W.mtime&&(0,v.isEqual)(H.applicationExtensionslocation,W.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&H.profile===W.profile&&H.type===W.type&&H.excludeObsolete===W.excludeObsolete&&H.validate===W.validate&&H.productVersion===W.productVersion&&H.productDate===W.productDate&&H.productCommit===W.productCommit&&H.devMode===W.devMode&&H.language===W.language&&_.equals(H.translations,W.translations)}}let N=class extends E.Disposable{constructor(H,W,z,K,X){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=W,this.uriIdentityService=z,this.fileService=K,this.logService=X}async scanExtensions(H){const W=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let z={};if(H.excludeObsolete&&H.type===1)try{const K=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(K)}catch{}return(0,w.isEmptyObject)(z)?W:W.filter(K=>!z[f.ExtensionKey.create(K).toString()])}async scanExtensionsFromLocation(H){const W=await this.fileService.resolve(H.location);if(!W.children?.length)return[];const z=await Promise.all(W.children.map(async K=>{if(!K.isDirectory||H.type===1&&(0,v.basename)(K.resource).indexOf(".")===0)return null;const X=new k(K.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(X)}));return(0,D.coalesce)(z).sort((K,X)=>K.location.path<X.location.path?-1:1)}async scanExtensionsFromProfile(H){let W=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){W=W.filter(K=>!K.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,K=>!!K.metadata?.isApplicationScoped,H);W.push(...z)}return W}async scanExtensionsFromProfileResource(H,W,z){const K=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!K.length)return[];const X=await Promise.all(K.map(async ce=>{if(W(ce)){const B=new k(ce.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(B,ce.metadata)}return null}));return(0,D.coalesce)(X)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,v.joinPath)(H.location,"package.json"))){const W=await this.scanExtension(H);return W?[W]:[]}else return await this.scanExtensions(H)}catch(W){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(H,W){try{let z=await this.scanExtensionManifest(H.location);if(z){z.publisher||(z.publisher=u.UNDEFINED_PUBLISHER),W=W??z.__metadata,delete z.__metadata;const K=(0,f.getGalleryExtensionId)(z.publisher,z.name),X=W?.id?{id:K,uuid:W.id}:{id:K},ce=W?.isSystem?0:H.type,B=ce===0||!!W?.isBuiltin;z=await this.translateManifest(H.location,z,k.createNlsConfiguration(H));const G={type:ce,identifier:X,manifest:z,location:H.location,isBuiltin:B,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return H.validate?this.validate(G,H):G}}catch(z){H.type!==0&&this.logService.error(z)}return null}validate(H,W){let z=!0;const K=(0,o.validateExtensionManifest)(W.productVersion,W.productDate,W.location,H.manifest,H.isBuiltin);for(const[X,ce]of K)X===y.default.Error&&(z=!1,this.logService.error(this.formatMessage(W.location,ce)));return H.isValid=z,H.validations=K,H}async scanExtensionManifest(H){const W=(0,v.joinPath)(H,"package.json");let z;try{z=(await this.fileService.readFile(W)).value.toString()}catch(X){return(0,s.toFileOperationResult)(X)!==1&&this.logService.error(this.formatMessage(H,(0,m.localize)(0,null,W.path,X.message))),null}let K;try{K=JSON.parse(z)}catch{const ce=[];(0,P.parse)(z,ce);for(const B of ce)this.logService.error(this.formatMessage(H,(0,m.localize)(1,null,W.path,B.offset,B.length,(0,I.getParseErrorMessage)(B.error))));return null}return(0,P.getNodeType)(K)!=="object"?(this.logService.error(this.formatMessage(H,(0,m.localize)(2,null,W.path))),null):K}async translateManifest(H,W,z){const K=await this.getLocalizedMessages(H,W,z);if(K)try{const X=[],ce=await this.resolveOriginalMessageBundle(K.default,X);if(X.length>0)return X.forEach(G=>{this.logService.error(this.formatMessage(H,(0,m.localize)(3,null,K.default?.path,(0,I.getParseErrorMessage)(G.error))))}),W;if((0,P.getNodeType)(K)!=="object")return this.logService.error(this.formatMessage(H,(0,m.localize)(4,null,K.default?.path))),W;const B=K.values||Object.create(null);return(0,$.localizeManifest)(W,B,ce)}catch{}return W}async getLocalizedMessages(H,W,z){const K=(0,v.joinPath)(H,"package.nls.json"),X=(O,M)=>{M.forEach(x=>{this.logService.error(this.formatMessage(H,(0,m.localize)(5,null,O?.path,(0,I.getParseErrorMessage)(x.error))))})},ce=O=>{this.logService.error(this.formatMessage(H,(0,m.localize)(6,null,O?.path)))},B=`${W.publisher}.${W.name}`,G=z.translations[B];if(G)try{const O=d.URI.file(G),M=(await this.fileService.readFile(O)).value.toString(),x=[],V=(0,P.parse)(M,x);return x.length>0?(X(O,x),{values:void 0,default:K}):(0,P.getNodeType)(V)!=="object"?(ce(O),{values:void 0,default:K}):{values:V.contents?V.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.fileService.exists(K))return;let M;try{M=await this.findMessageBundles(H,z)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const x=(await this.fileService.readFile(M.localized)).value.toString(),V=[],ee=(0,P.parse)(x,V);return V.length>0?(X(M.localized,V),{values:void 0,default:M.original}):(0,P.getNodeType)(ee)!=="object"?(ce(M.localized),{values:void 0,default:M.original}):{values:ee,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(H,W){if(H)try{const z=(await this.fileService.readFile(H)).value.toString();return(0,P.parse)(z,W)}catch{}}findMessageBundles(H,W){return new Promise((z,K)=>{const X=ce=>{const B=(0,v.joinPath)(H,`package.nls.${ce}.json`);this.fileService.exists(B).then(G=>{G&&z({localized:B,original:(0,v.joinPath)(H,"package.nls.json")});const O=ce.lastIndexOf("-");O===-1?z({localized:(0,v.joinPath)(H,"package.nls.json"),original:null}):(ce=ce.substring(0,O),X(ce))})};if(W.devMode||W.pseudo||!W.language)return z({localized:(0,v.joinPath)(H,"package.nls.json"),original:null});X(W.language)})}formatMessage(H,W){return`[${H.path}]: ${W}`}};N=pe([Y(1,h.IExtensionsProfileScannerService),Y(2,A.IUriIdentityService),Y(3,s.IFileService),Y(4,i.ILogService)],N);let F=class extends N{constructor(H,W,z,K,X,ce){super(W,z,K,X,ce),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const W=await this.readExtensionCache();if(this.input=H,W&&W.input&&k.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(K=>(K.location=d.URI.revive(K.location),K));const z=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:z}),z}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),W=JSON.parse(H.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(H)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const W=H.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(z,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}};F=pe([Y(2,h.IExtensionsProfileScannerService),Y(3,A.IUriIdentityService),Y(4,s.IFileService),Y(5,i.ILogService)],F);function q(j,H){const W=(0,f.getExtensionId)(j.manifest.publisher,j.manifest.name);return{id:W,identifier:new u.ExtensionIdentifier(W),isBuiltin:j.type===0,isUserBuiltin:j.type===1&&j.isBuiltin,isUnderDevelopment:H,extensionLocation:j.location,uuid:j.identifier.uuid,targetPlatform:j.targetPlatform,...j.manifest}}e.toExtensionDescription=q;class J extends U{constructor(H,W,z,K,X,ce,B,G,O,M,x){super(H,W,(0,v.joinPath)(z,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(K,u.MANIFEST_CACHE_FOLDER),X,ce,B,G,O,M,x),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const V=await this.fileService.readFile(d.URI.file(p.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[252],re([0,1,48,6,38,3,2,24,10,28,8,20]),function(Q,e,D,t,R,L,T,P,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends T.Disposable{constructor(g,y){super(),this.userDataProfilesService=g,this.logService=y,this.processesLimiter=new t.Limiter(5)}async postUninstall(g){const y=this.parseScript(g,"uninstall");return y&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,g).then(()=>this.logService.info(g.identifier.id,g.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(g.identifier.id,g.manifest.version,`Failed to run post uninstall script: ${w}`)))),E.Promises.rm(this.getExtensionStoragePath(g)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(g,y){const w=`vscode:${y}`;if(g.location.scheme===P.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[w]=="string"){const d=g.manifest.scripts[w].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${w} should be a node script`),null):{script:(0,I.join)(g.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(g,y,w,d,m){return new Promise((l,f)=>{const u=this.start(g,y,w,m);let o;const s=n=>{o&&(clearTimeout(o),o=null),n?f(n):l(void 0)};u.on("error",n=>{s((0,R.toErrorMessage)(n)||"Unknown")}),u.on("exit",(n,i)=>{s(n?`post-${y} process exited with code ${n}`:void 0)}),d&&(o=setTimeout(()=>{o=null,u.kill(),f("timed out")},5e3))})}start(g,y,w,d){const m={silent:!0,execArgv:void 0},l=(0,D.fork)(g,[`--type=extension-post-${y}`,...w],m);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(l.stdout,"data"),u=L.Event.fromNodeEventEmitter(l.stderr,"data");f(n=>this.logService.info(d.identifier.id,d.manifest.version,`post-${y}`,n)),u(n=>this.logService.error(d.identifier.id,d.manifest.version,`post-${y}`,n));const o=L.Event.any(L.Event.map(f,n=>({data:`%c${n}`,format:[""]})),L.Event.map(u,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(o,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}getExtensionStoragePath(g){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};p=pe([Y(0,C.IUserDataProfilesService),Y(1,b.ILogService)],p),e.ExtensionsLifecycle=p}),define(ne[253],re([0,1,7,13,50,76,14,5,8,25,20]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends L.NativeExtensionsScannerService{constructor(v,g,y,w,d,m,l){super(D.URI.file(d.builtinExtensionsPath),D.URI.file(d.extensionsPath),d.userHome,D.URI.file(d.userDataPath),v,g,y,w,d,m,l)}};C=pe([Y(0,b.IUserDataProfilesService),Y(1,R.IExtensionsProfileScannerService),Y(2,T.IFileService),Y(3,I.ILogService),Y(4,t.INativeEnvironmentService),Y(5,E.IProductService),Y(6,P.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(ne[21],re([0,1,6,3,2,194,15,68,5,20]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var p;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function v(m){const l=m.get(e.TARGET_KEY);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.loadKeyTargets=v;class g extends R.Disposable{constructor(l={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=l,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(l,f){if(f===e.TARGET_KEY){switch(l){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:l})}else this._onDidChangeValue.fire({scope:l,key:f,target:this.getKeyTargets(l)[f]})}emitWillSaveState(l){this._onWillSaveState.fire({reason:l})}get(l,f,u){return this.getStorage(f)?.get(l,u)}getBoolean(l,f,u){return this.getStorage(f)?.getBoolean(l,u)}getNumber(l,f,u){return this.getStorage(f)?.getNumber(l,u)}store(l,f,u,o){if((0,T.isUndefinedOrNull)(f)){this.remove(l,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(l,u,o),this.getStorage(u)?.set(l,f)})}remove(l,f){this.withPausedEmitters(()=>{this.updateKeyTarget(l,f,void 0),this.getStorage(f)?.delete(l)})}withPausedEmitters(l){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{l()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(l,f){const u=[],o=this.getKeyTargets(l);for(const s of Object.keys(o))o[s]===f&&u.push(s);return u}updateKeyTarget(l,f,u){const o=this.getKeyTargets(f);typeof u=="number"?o[l]!==u&&(o[l]=u,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(o))):typeof o[l]=="number"&&(delete o[l],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(l){switch(l){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(l){const f=this.getStorage(l);return f?v(f):Object.create(null)}isNew(l){return this.getBoolean(e.IS_NEW_KEY,l)===!0}async flush(l=b.NONE){this._onWillSaveState.fire({reason:l});const f=this.getStorage(-1),u=this.getStorage(0),o=this.getStorage(1);switch(l){case b.NONE:await D.Promises.settled([f?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await D.Promises.settled([f?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return d(l,f,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(l,f){return this.emitWillSaveState(b.NONE),(0,E.isUserDataProfile)(l)?this.switchToProfile(l,f):this.switchToWorkspace(l,f)}canSwitchProfile(l,f){return!(l.id===f.id||y(f)&&y(l))}switchData(l,f,u,o){this.withPausedEmitters(()=>{if(o)for(const[s,n]of l)f.set(s,n);else{const s=new Set;for(const[n,i]of l)s.add(n),f.get(n)!==i&&this.emitDidChangeValue(u,n);for(const[n]of f.items)s.has(n)||this.emitDidChangeValue(u,n)}})}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;function y(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class w extends g{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(l=>this.emitDidChangeValue(1,l))),this._register(this.profileStorage.onDidChangeStorage(l=>this.emitDidChangeValue(0,l))),this._register(this.applicationStorage.onDidChangeStorage(l=>this.emitDidChangeValue(-1,l)))}getStorage(l){switch(l){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(l){return!1}}e.InMemoryStorageService=w;async function d(m,l,f,u,o,s){const n=_=>{try{return JSON.parse(_)}catch{return _}},i=new Map,r=new Map;m.forEach((_,U)=>{i.set(U,_),r.set(U,n(_))});const c=new Map,a=new Map;l.forEach((_,U)=>{c.set(U,_),a.set(U,n(_))});const h=new Map,S=new Map;f.forEach((_,U)=>{h.set(U,_),S.set(U,n(_))}),console.group(u!==o?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const A=[];if(i.forEach((_,U)=>{A.push({key:U,value:_})}),console.table(A),console.groupEnd(),console.log(r),u!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const _=[];c.forEach((U,k)=>{_.push({key:k,value:U})}),console.table(_),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const $=[];h.forEach((_,U)=>{$.push({key:U,value:_})}),console.table($),console.groupEnd(),console.log(S)}e.logStorage=d}),define(ne[114],re([0,1,3,2,15,29,33,21]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends t.Disposable{constructor(C,p){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(p.onDidInstallExtensions(v=>v.forEach(({local:g,operation:y})=>{g&&y===4&&this._removeFromDisabledExtensions(g.identifier)})))}async enableExtension(C,p){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:p}),!0):!1}async disableExtension(C,p){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){const p=this.getDisabledExtensions();return p.every(v=>!(0,T.areSameExtensions)(v,C))?(p.push(C),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(C){const p=this.getDisabledExtensions();for(let v=0;v<p.length;v++){const g=p[v];if((0,T.areSameExtensions)(g,C))return p.splice(v,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(C){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,p){this.storageManger.set(C,p,0)}};I=pe([Y(0,P.IStorageService),Y(1,L.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class E extends t.Disposable{constructor(C){super(),this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(C,p){let v;return p===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,p)),v=this.storage[C]):v=this._get(C,p),JSON.parse(v)}set(C,p,v){const g=JSON.stringify(p.map(({id:w,uuid:d})=>({id:w,uuid:d})));this._get(C,v)!==g&&(v===0&&(p.length?this.storage[C]=g:delete this.storage[C]),this._set(C,p.length?g:void 0,v))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const v=this.get(C.key,C.scope);delete this.storage[C.key];const g=this.get(C.key,C.scope),y=v.filter(d=>!g.some(m=>(0,T.areSameExtensions)(d,m))),w=g.filter(d=>!v.some(m=>(0,T.areSameExtensions)(m,d)));(y.length||w.length)&&this._onDidChange.fire([...y,...w])}}_get(C,p){return this.storageService.get(C,p,"[]")}_set(C,p,v){p?this.storageService.store(C,p,v,1):this.storageService.remove(C,v)}}e.StorageManager=E}),define(ne[254],re([0,1,18,23,9,4,37,15,7,17,13,29,33,69,14,8,25,45,224,21,22]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=L.isWeb?"web":(0,C.getTargetPlatform)(L.platform,T.arch);var o;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function s(...O){return String(O.reduce((M,x)=>M|x,0))}var n;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class h{constructor(M=a){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,x=this.state.pageSize){return new h({...this.state,pageNumber:M,pageSize:x})}withFilter(M,...x){const V=[...this.state.criteria,...x.length?x.map(ee=>({filterType:M,value:ee})):[{filterType:M}]];return new h({...this.state,criteria:V})}withSortBy(M){return new h({...this.state,sortBy:M})}withSortOrder(M){return new h({...this.state,sortOrder:M})}withFlags(...M){return new h({...this.state,flags:M.reduce((x,V)=>x|V,0)})}withAssetTypes(...M){return new h({...this.state,assetTypes:M})}withSource(M){return new h({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:x,pageSize:V,sortBy:ee,sortOrder:oe,flags:Z,assetTypes:ie}=this.state;return{filters:[{criteria:M,pageNumber:x,pageSize:V,sortBy:ee,sortOrder:oe}],assetTypes:ie,flags:Z}}get searchText(){const M=this.state.criteria.filter(x=>x.filterType===n.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function S(O,M){const x=(O||[]).filter(V=>V.statisticName===M)[0];return x?x.value:0}function A(O){const M="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(V=>V.assetType.indexOf(M)===0).reduce((V,ee)=>{const oe=U(O,ee.assetType);return oe&&V.push([ee.assetType.substring(M.length),oe]),V},[])}function $(O){if(O.properties){const M=O.properties.filter(ee=>ee.key===i.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=M.filter(ee=>x.test(ee.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return U(O,i.Repository)}function _(O){return{uri:`${O.fallbackAssetUri}/${i.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${i.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function U(O,M){return O.files.filter(V=>V.assetType===M)[0]?{uri:`${O.assetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function k(O,M){const x=O.properties?O.properties.filter(ee=>ee.key===M):[],V=x.length>0&&x[0].value;return V?V.split(",").map(ee=>(0,p.adoptToGalleryExtensionId)(ee)):[]}function N(O){const M=O.properties?O.properties.filter(x=>x.key===r.Engine):[];return M.length>0&&M[0].value||""}function F(O){const M=O.properties?O.properties.filter(x=>x.key===r.PreRelease):[];return M.length>0&&M[0].value==="true"}function q(O){const M=O.properties?O.properties.filter(V=>V.key===r.LocalizedLanguages):[],x=M.length>0&&M[0].value||"";return x?x.split(","):[]}function J(O){return O.properties?.find(M=>M.key===r.SponsorLink)?.value}function j(O){return O.indexOf("preview")!==-1}function H(O){return O.targetPlatform?(0,C.toTargetPlatform)(O.targetPlatform):"undefined"}function W(O){const M=(0,D.distinct)(O.versions.map(H)),x=!!O.tags?.includes(C.WEB_EXTENSION_TAG),V=M.indexOf("web");return x?V===-1&&M.push("web"):V!==-1&&M.splice(V,1),M}function z(O,M){const x=(0,C.getFallbackTargetPlarforms)(M);for(let V=0;V<O.length;V++){const ee=O[V];if(ee.version===O[V-1]?.version){let oe=V;const Z=H(ee);if(Z===M)for(;oe>0&&O[oe-1].version===ee.version;)oe--;else if(x.includes(Z))for(;oe>0&&O[oe-1].version===ee.version&&H(O[oe-1])!==M;)oe--;oe!==V&&(O.splice(V,1),O.splice(oe,0,ee))}}return O}e.sortExtensionVersions=z;function K(O,M,x){O.telemetryData={index:M,querySource:x}}function X(O,M,x){const V=O.versions[0],ee={manifest:U(M,i.Manifest),readme:U(M,i.Details),changelog:U(M,i.Changelog),license:U(M,i.License),repository:$(M),download:_(M),icon:U(M,i.Icon),coreTranslations:A(M)};return{identifier:{id:(0,p.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:M.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(V),description:O.shortDescription||"",installCount:S(O.statistics,"install"),rating:S(O.statistics,"averagerating"),ratingCount:S(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:x,assets:ee,properties:{dependencies:k(M,r.Dependency),extensionPack:k(M,r.ExtensionPack),engine:N(M),localizedLanguages:q(M),targetPlatform:H(M),isPreReleaseVersion:F(M)},hasPreReleaseVersion:F(V),hasReleaseVersion:!0,preview:j(O.flags)}}let ce=class{constructor(M,x,V,ee,oe,Z,ie,se){this.requestService=x,this.logService=V,this.environmentService=ee,this.telemetryService=oe,this.fileService=Z,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue?.serviceUrl,this.extensionsGallerySearchUrl=ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,x,V){const ee=t.CancellationToken.isCancellationToken(x)?{}:x,oe=t.CancellationToken.isCancellationToken(x)?x:V,Z=[],ie=[],se=[],ue=[];let de=!0;for(const Ee of M){Ee.uuid?ie.push(Ee.uuid):Z.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Ce}if(!ie.length&&!Z.length)return[];let ve=new h().withPage(1,M.length);ie.length&&(ve=ve.withFilter(n.ExtensionId,...ie)),Z.length&&(ve=ve.withFilter(n.ExtensionName,...Z)),(ee.queryAllVersions||de)&&(ve=ve.withFlags(ve.flags,o.IncludeVersions)),ee.source&&(ve=ve.withSource(ee.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:ee.targetPlatform??u,includePreRelease:se,versions:ue,compatible:!!ee.compatible},oe);return ee.source&&we.forEach((Ee,Ce)=>K(Ee,Ce,ee.source)),we}async getCompatibleExtension(M,x,V){if((0,C.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(M,x,V))return M;const ee=new h().withFlags(o.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,M.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(ee,{targetPlatform:V,compatible:!0,includePreRelease:x},t.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(M,x,V){if(!(0,C.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,V)||!x&&M.properties.isPreReleaseVersion)return!1;let ee=M.properties.engine;if(!ee){const oe=await this.getManifest(M,t.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ee=oe.engines.vscode}return(0,v.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(M,x,V,ee,oe){if(!(0,C.isTargetPlatformCompatible)(H(M),ee,oe)||x!=="any"&&F(M)!==(x==="prerelease"))return!1;if(V)try{const Z=await this.getEngine(M);if(!(0,v.isEngineValid)(Z,this.productService.version,this.productService.date))return!1}catch(Z){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,R.getErrorMessage)(Z)),!1}return!0}async query(M,x){let V=M.text||"";const ee=M.pageSize??50;let oe=new h().withPage(1,ee);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(n.Category,we||ve),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(n.Tag,we||ve),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(n.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),oe=oe.withFilter(n.SearchText,V)),oe=oe.withSortBy(0)):M.ids?oe=oe.withFilter(n.ExtensionId,...M.ids):M.names?oe=oe.withFilter(n.ExtensionName,...M.names):oe=oe.withSortBy(4),typeof M.sortBy=="number"&&(oe=oe.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(oe=oe.withSortOrder(M.sortOrder)),M.source&&(oe=oe.withSource(M.source));const Z=async(de,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(de,{targetPlatform:u,compatible:!1,includePreRelease:!!M.includePreRelease},ve);return we.forEach((Ce,Ue)=>K(Ce,(de.pageNumber-1)*de.pageSize+Ue,M.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await Z(oe,x),ue=async(de,ve)=>{if(ve.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await Z(oe.withPage(de+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(M,x,V){const ee=M.flags;!!(M.flags&o.IncludeLatestVersionOnly)&&!!(M.flags&o.IncludeVersions)&&(M=M.withFlags(M.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(M.flags&o.IncludeLatestVersionOnly)&&!(M.flags&o.IncludeVersions)&&(M=M.withFlags(M.flags,o.IncludeLatestVersionOnly)),x.versions?.length&&(M=M.withFlags(M.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),M=M.withFlags(M.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:oe,total:Z}=await this.queryRawGalleryExtensions(M,V);if(!(M.flags&o.IncludeLatestVersionOnly)){const de=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,x);we&&de.push(we)}return{extensions:de,total:Z}}const se=[],ue=new Map;for(let de=0;de<oe.length;de++){const ve=oe[de],we={id:(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Ue=>(0,p.areSameExtensions)(Ue,we))?.includePreRelease;if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(W(ve),x.targetPlatform))continue;const Ce=await this.toGalleryExtensionWithCriteria(ve,x);!Ce||Ce.properties.isPreReleaseVersion&&(!Ee||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==x.targetPlatform&&Ce.hasPreReleaseVersion?ue.set(ve.extensionId,de):se.push([de,Ce])}if(ue.size){const de=new Date().getTime(),ve=new h().withFlags(ee&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,ue.size).withFilter(n.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,x,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:ue.size});for(const Ee of we){const Ce=ue.get(Ee.identifier.uuid);se.push([Ce,Ee])}}return{extensions:se.sort((de,ve)=>de[0]-ve[0]).map(([,de])=>de),total:Z}}async toGalleryExtensionWithCriteria(M,x){const V={id:(0,p.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},ee=x.versions?.find(se=>(0,p.areSameExtensions)(se,V))?.version,oe=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(se=>(0,p.areSameExtensions)(se,V))?.includePreRelease,Z=W(M),ie=z(M.versions,x.targetPlatform);if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(Z,x.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(ee&&ue.version!==ee)){if(await this.isValidVersion(ue,oe?"any":"release",x.compatible,Z,x.targetPlatform))return X(M,ue,Z);if(ee&&ue.version===ee)return null}}return ee||x.compatible?null:X(M,M.versions[0],Z)}async queryRawGalleryExtensions(M,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,o.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,s(o.Unpublished));const V=await this.commonHeadersPromise,ee=JSON.stringify(M.raw),oe={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(ve=>ve.filterType===n.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:oe},x),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,d.asJson)(ie);if(de){const ve=de.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(de){throw se=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Z,success:!!ie&&(0,d.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,R.isCancellationError)(se)?"canceled":(0,R.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(M,x,V,ee){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${M}.${x}/version/${V}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${x}/${V}/stats?statType=${ee}`),Z=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:Z};try{await this.requestService.request({type:"POST",url:oe,headers:se},t.CancellationToken.None)}catch{}}async download(M,x,V){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const ee=(0,p.getGalleryExtensionTelemetryData)(M),oe=new Date().getTime(),Z=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ie=V===2?"install":V===3?"update":"",se=ie?{uri:`${M.assets.download.uri}${I.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${I.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(x,ue.stream),Z(new Date().getTime()-oe)}async getReadme(M,x){if(M.assets.readme){const V=await this.getAsset(M.assets.readme,{},x);return await(0,d.asTextOrError)(V)||""}return""}async getManifest(M,x){if(M.assets.manifest){const V=await this.getAsset(M.assets.manifest,{},x),ee=await(0,d.asTextOrError)(V);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(M,x){const V=U(M,i.Manifest);if(!V)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},oe=await this.getAsset(V,{headers:ee});return await(0,d.asJson)(oe)}async getCoreTranslation(M,x){const V=M.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(V){const ee=await this.getAsset(V[1]),oe=await(0,d.asTextOrError)(ee);return oe?JSON.parse(oe):null}return null}async getChangelog(M,x){if(M.assets.changelog){const V=await this.getAsset(M.assets.changelog,{},x);return await(0,d.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(M,x,V){let ee=new h().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?ee=ee.withFilter(n.ExtensionId,M.identifier.uuid):ee=ee.withFilter(n.ExtensionName,M.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(ee,t.CancellationToken.None);if(!oe.length)return[];const Z=W(oe[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(Z,V))return[];const ie=[];await Promise.all(oe[0].versions.map(async de=>{try{await this.isValidVersion(de,x?"any":"release",!0,Z,V)&&ie.push(de)}catch{}}));const se=[],ue=new Set;for(const de of z(ie,V))ue.has(de.version)||(ue.add(de.version),se.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:F(de)}));return se}async getAsset(M,x={},V=t.CancellationToken.None){const ee=await this.commonHeadersPromise,oe={type:"GET"},Z={...ee,...x.headers||{}};x={...x,...oe,headers:Z};const ie=M.uri,se=M.fallbackUri,ue={...x,url:ie};try{const de=await this.requestService.request(ue,V);if(de.res.statusCode===200)return de;const ve=await(0,d.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ve}`)}catch(de){if((0,R.isCancellationError)(de))throw de;const ve=(0,R.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...x,url:se};return this.requestService.request(we,V)}}async getEngine(M){let x=N(M);if(!x){const V=await this.getManifestFromRawExtensionVersion(M,t.CancellationToken.None);if(!V)throw new Error("Manifest was not found");x=V.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,d.asJson)(M),V=[],ee={};if(x){for(const oe of x.malicious)V.push({id:oe});if(x.migrateToPreRelease)for(const[oe,Z]of Object.entries(x.migrateToPreRelease))(!Z.engine||(0,v.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(ee[oe.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[oe,Z]of Object.entries(x.deprecated))Z&&(ee[oe.toLowerCase()]=(0,P.isBoolean)(Z)?{}:Z)}return{malicious:V,deprecated:ee}}};ce=pe([Y(1,d.IRequestService),Y(2,y.ILogService),Y(3,b.IEnvironmentService),Y(4,f.ITelemetryService),Y(5,g.IFileService),Y(6,w.IProductService),Y(7,E.IConfigurationService)],ce);let B=class extends ce{constructor(M,x,V,ee,oe,Z,ie,se){super(M,x,V,ee,oe,Z,ie,se)}};B=pe([Y(0,l.IStorageService),Y(1,d.IRequestService),Y(2,y.ILogService),Y(3,b.IEnvironmentService),Y(4,f.ITelemetryService),Y(5,g.IFileService),Y(6,w.IProductService),Y(7,E.IConfigurationService)],B),e.ExtensionGalleryService=B;let G=class extends ce{constructor(M,x,V,ee,oe,Z,ie){super(void 0,M,x,V,ee,oe,Z,ie)}};G=pe([Y(0,d.IRequestService),Y(1,y.ILogService),Y(2,b.IEnvironmentService),Y(3,f.ITelemetryService),Y(4,g.IFileService),Y(5,w.IProductService),Y(6,E.IConfigurationService)],G),e.ExtensionGalleryServiceWithNoStorageService=G}),define(ne[77],re([0,1,5,3,2,21,33,25,18,8,15]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Xe extends R.Disposable{static toKey(g){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const y=C.exec(g);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(g,y){const w=await g.getInstalled(),d=[];for(const[m,l]of Xe.readAllExtensionsWithKeysForSync(y)){const f=w.find(u=>(0,T.areSameExtensions)(u.identifier,{id:m}))?.manifest.version;for(const u of l)f!==u&&d.push(Xe.toKey({id:m,version:u}))}for(const m of d)y.remove(m,0)}static readAllExtensionsWithKeysForSync(g){const y=new Map,w=g.keys(0,1);for(const d of w){const m=Xe.fromKey(d);if(m){let l=y.get(m.id.toLowerCase());l||y.set(m.id.toLowerCase(),l=[]),l.push(m.version)}}return y}constructor(g,y,w){super(),this.storageService=g,this.productService=y,this.logService=w,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Xe.readAllExtensionsWithKeysForSync(g),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const y=Xe.fromKey(g.key);if(y){if(this.storageService.get(g.key,0)===void 0)this.extensionsWithKeysForSync.delete(y.id.toLowerCase());else{let w=this.extensionsWithKeysForSync.get(y.id.toLowerCase());w||this.extensionsWithKeysForSync.set(y.id.toLowerCase(),w=[]),w.push(y.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(g){if((0,b.isString)(g))return g;const y=g.manifest?g.manifest.publisher:g.publisher,w=g.manifest?g.manifest.name:g.name;return(0,T.getExtensionId)(y,w)}getExtensionState(g,y){const w=this.getExtensionId(g),d=this.storageService.get(w,y?0:1);if(d)try{return JSON.parse(d)}catch(m){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${y}): ${m}`)}}setExtensionState(g,y,w){const d=this.getExtensionId(g);y===void 0?this.storageService.remove(d,w?0:1):this.storageService.store(d,JSON.stringify(y),w?0:1,1)}setKeysForSync(g,y){this.storageService.store(Xe.toKey(g),JSON.stringify(y),0,1)}getKeysForSync(g){const y=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],w=this.storageService.get(Xe.toKey(g),0),d=w?JSON.parse(w):void 0;return d&&y?(0,I.distinct)([...d,...y]):d||y}addToMigrationList(g,y){if(g!==y){const w=this.migrationList.filter(d=>!d.includes(g)&&!d.includes(y));w.push([g,y]),this.migrationList=w}}getSourceExtensionToMigrate(g){const y=this.migrationList.find(([,w])=>g===w);return y?y[0]:void 0}get migrationList(){const g=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(g);if(Array.isArray(y))return y}catch{}return[]}set migrationList(g){g.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(g),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=pe([Y(0,L.IStorageService),Y(1,P.IProductService),Y(2,E.ILogService)],p),e.ExtensionStorageService=p}),define(ne[255],re([0,1,18,6,3,10,4,37,7,149,13,29,33,214,96,14,8,59,25,45,21,22]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const o="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let n=class extends v.ExtensionTipsService{constructor(r,c,a,h,S,A,$,_,U,k){super($,_,U,k),this.environmentService=r,this.telemetryService=c,this.extensionManagementService=a,this.storageService=h,this.nativeHostService=S,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&Object.entries(_.exeBasedExtensionTips).forEach(([N,F])=>{const q=[],J=[],j=[];Object.entries(F.recommendations).forEach(([H,W])=>{W.important?F.important?q.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):J.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):j.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),q.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:q}),J.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:J}),j.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:j})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...r,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(r,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,a)}groupImportantTipsByExe(r,c){const a=new Map;r.forEach(_=>a.set(_.extensionId.toLowerCase(),_));const{installed:h,uninstalled:S}=this.groupByInstalled([...a.keys()],c);for(const _ of h){const U=a.get(_);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:U.exeName})}for(const _ of S){const U=a.get(_);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:U.exeName})}const A=this.getPromptedExecutableTips(),$=new Map;for(const _ of S){const U=a.get(_);if(U&&(!A[U.exeName]||!A[U.exeName].includes(U.extensionId))){let k=$.get(U.exeName);k||(k=[],$.set(U.exeName,k)),k.push(U)}}return $}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[r,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(r);break;case"incompatibleWindow":{const h=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,t.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const r=this.getLastPromptedMediumExeTime(),c=Date.now()-r,a=7*24*60*60*1e3;if(c<a){const A=this._register((0,t.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},a-c));return}const[h,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(S[0].exeName,S);const $=this._register((0,t.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const $=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register($(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const $=this._register((0,t.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(r){const c=await this.extensionManagementService.getInstalled(1),a=r.filter(S=>!S.whenNotInstalled||S.whenNotInstalled.every(A=>c.every($=>!(0,p.areSameExtensions)($.identifier,{id:A})))).map(({extensionId:S})=>S.toLowerCase()),h=(0,E.localize)(0,null,r[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,h,`@exe:"${r[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let r=this.storageService.getNumber(s,-1);return r||(r=Date.now(),this.updateLastPromptedMediumExeTime(r)),r}updateLastPromptedMediumExeTime(r){this.storageService.store(s,r,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(o,-1,"{}"))}addToRecommendedExecutables(r,c){const a=this.getPromptedExecutableTips();a[r]=c.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(o,JSON.stringify(a),-1,0)}groupByInstalled(r,c){const a=[],h=[],S=c.reduce((A,$)=>(A.add($.identifier.id.toLowerCase()),A),new Set);return r.forEach(A=>{S.has(A.toLowerCase())?a.push(A):h.push(A)}),{installed:a,uninstalled:h}}async getValidExecutableBasedExtensionTips(r){const c=[],a=new Map;for(const h of r.keys()){const S=r.get(h);if(!S||!(0,D.isNonEmptyArray)(S.recommendations))continue;const A=[];T.isWindows?S.windowsPath&&A.push(S.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(A.push((0,L.join)("/usr/local/bin",h)),A.push((0,L.join)("/usr/bin",h)),A.push((0,L.join)(this.environmentService.userHome.fsPath,h)));for(const $ of A){let _=a.get($);if(_===void 0&&(_=await this.fileService.exists(I.URI.file($)),a.set($,_)),_)for(const{extensionId:U,extensionName:k,isExtensionPack:N,whenNotInstalled:F}of S.recommendations)c.push({extensionId:U,extensionName:k,isExtensionPack:N,exeName:h,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath,whenNotInstalled:F})}}return c}};n=pe([Y(0,b.INativeEnvironmentService),Y(1,u.ITelemetryService),Y(2,C.IExtensionManagementService),Y(3,f.IStorageService),Y(4,d.INativeHostService),Y(5,g.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,m.IProductService),Y(8,l.IRequestService),Y(9,w.ILogService)],n),e.ExtensionTipsService=n}),define(ne[256],re([0,1,6,2,19,68,21,73,20]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends T.AbstractStorageService{constructor(C,p,v,g){super(),this.initialWorkspace=C,this.initialProfiles=p,this.mainProcessService=v,this.environmentService=g,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new t.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new t.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const C=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),p=this._register(new L.Storage(C));return this._register(p.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),p}createProfileStorage(C){this.profileStorageDisposables.clear(),this.profileStorageProfile=C;let p;if((0,T.isProfileUsingDefaultStorage)(C))p=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),C));p=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(p.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),p}createWorkspaceStorage(C){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=C?.id;let p;if(C){const v=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),C));p=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(p.onDidChangeStorage(g=>this.emitDidChangeValue(1,g)))}return p}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(C,p){if(!this.canSwitchProfile(this.profileStorageProfile,C))return;const v=this.profileStorage,g=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(C),await this.profileStorage.init(),this.switchData(g,this.profileStorage,0,p)}async switchToWorkspace(C,p){const v=this.workspaceStorage,g=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init(),this.switchData(g,this.workspaceStorage,1,p)}hasScope(C){return(0,I.isUserDataProfile)(C)?this.profileStorageProfile.id===C.id:this.workspaceStorageId===C.id}}e.NativeStorageService=E}),define(ne[257],re([0,1,3,2,19,13,58,20]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends t.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(b,C,p){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this.channel=C.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(p.userRoamingDataHome,"profiles"),this._profiles=b.map(v=>(0,P.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const g=v.added.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme)),y=v.removed.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme)),w=v.updated.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme));this._profiles=v.all.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:g,removed:y,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(b){this.enabled=b}isEnabled(){return this.enabled}async createNamedProfile(b,C,p){const v=await this.channel.call("createNamedProfile",[b,C,p]);return(0,P.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(b,C,p,v){const g=await this.channel.call("createProfile",[b,C,p,v]);return(0,P.reviveProfile)(g,this.profilesHome.scheme)}async createTransientProfile(b){const C=await this.channel.call("createTransientProfile",[b]);return(0,P.reviveProfile)(C,this.profilesHome.scheme)}async setProfileForWorkspace(b,C){await this.channel.call("setProfileForWorkspace",[b,C])}removeProfile(b){return this.channel.call("removeProfile",[b])}async updateProfile(b,C){const p=await this.channel.call("updateProfile",[b,C]);return(0,P.reviveProfile)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};I=pe([Y(1,T.IMainProcessService),Y(2,L.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(ne[41],re([0,1,18,6,16,23,3,35,2,27,15,7,164,17,13,14,8,49,21,22,31,26,20]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=s;let n=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(h,S,A,$,_,U,k,N,F,q,J,j){super(),this.syncResource=h,this.collection=S,this.fileService=A,this.environmentService=$,this.userDataSyncStoreService=U,this.userDataSyncBackupStoreService=k,this.userDataSyncEnablementService=N,this.telemetryService=F,this.logService=q,this.configurationService=J,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=`${(0,E.uppercaseFirstLetter)(this.resource)}${h.profile.isDefault?"":` (${h.profile.name})`}`,this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath($.userDataSyncHome,...(0,u.getPathSegments)(h.profile.isDefault?void 0:h.profile.id,h.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(h.profile.isDefault?void 0:h.profile.id,h.syncResource,$,this.extUri),this.currentMachineIdPromise=(0,d.getServiceMachineId)($,A,_)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const S=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(S)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?await this.hasRemoteChanged(h):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){this._status!==h&&(this._status=h,this._onDidChangStatus.fire(h))}async sync(h,S={}){await this._sync(h,!0,this.getUserDataSyncConfiguration(),S)}async preview(h,S,A={}){return this._sync(h,!1,S,A)}async apply(h,S={}){try{this.syncHeaders={...S};const A=await this.doApply(h);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,S,A,$){try{if(this.syncHeaders={...$},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const U=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(h,U);return _=await this.performSync(k,U,S,A),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(h){const S=await this.resolveContent(h);if(!S)return!1;const A=this.parseSyncData(S);if(!A)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const $=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,$),U=await this.isRemoteDataFromCurrentMachine(_),k=await this.generateSyncPreview({ref:_.ref,syncData:A},$,U,this.getUserDataSyncConfiguration(),L.CancellationToken.None),N=[];for(const F of k){const q=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);N.push([F,{...q,remoteChange:J!==0?J:2}])}await this.applyResult(_,$,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(h){const S=await this.currentMachineIdPromise;return!!h.syncData?.machineId&&h.syncData.machineId===S}async getLatestRemoteUserData(h,S){if(S){const A=h?h[this.resource]:void 0;if(S.ref===A||A===void 0&&S.syncData===null)return S}return this.getRemoteUserData(S)}async performSync(h,S,A,$){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,h.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(h,S,A,$)}catch(_){if(_ instanceof u.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,S,A,$);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),S=await this.getLastSyncUserData(),this.performSync(h,S,A,$)}throw _}}async doSync(h,S,A,$){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(h,S,A,$,U)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(h){return await this.updateSyncResourcePreview(h,async S=>{const A=await this.getMergeResult(S,L.CancellationToken.None);await this.fileService.writeFile(S.previewResource,R.VSBuffer.fromString(A?.content||""));const $=A&&!A.hasConflicts?await this.getAcceptResult(S,S.previewResource,void 0,L.CancellationToken.None):void 0;return S.acceptResult=$,S.mergeState=A.hasConflicts?"conflict":$?"accepted":"preview",S.localChange=$?$.localChange:A.localChange,S.remoteChange=$?$.remoteChange:A.remoteChange,S}),this.syncPreviewPromise}async accept(h,S){return await this.updateSyncResourcePreview(h,async A=>{const $=await this.getAcceptResult(A,h,S,L.CancellationToken.None);return A.acceptResult=$,A.mergeState="accepted",A.localChange=$.localChange,A.remoteChange=$.remoteChange,A}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async S=>{const A=await this.getMergeResult(S,L.CancellationToken.None);return await this.fileService.writeFile(S.previewResource,R.VSBuffer.fromString(A.content||"")),S.acceptResult=void 0,S.mergeState="preview",S.localChange=A.localChange,S.remoteChange=A.remoteChange,S}),this.syncPreviewPromise}async updateSyncResourcePreview(h,S){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const $=A.resourcePreviews.findIndex(({localResource:_,remoteResource:U,previewResource:k})=>this.extUri.isEqual(_,h)||this.extUri.isEqual(U,h)||this.extUri.isEqual(k,h));$!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const U=[...A.resourcePreviews];return U[$]=await S(U[$]),{...A,resourcePreviews:U}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(h){if(!this.syncPreviewPromise)return"idle";const S=await this.syncPreviewPromise;return S.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":S.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(S.remoteUserData,S.lastSyncUserData,S.resourcePreviews.map(A=>[A,A.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(h){const S=h.filter(({mergeState:A})=>A==="conflict");(0,D.equals)(this._conflicts,S,(A,$)=>this.extUri.isEqual(A.previewResource,$.previewResource))||(this._conflicts=S,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const h=await this.getLastSyncUserData();return!!h&&h.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource,this.collection)).map(({created:S,ref:A})=>({created:S,uri:this.toRemoteBackupResource(A)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.syncResource.profile,this.resource)).map(({created:S,ref:A})=>({created:S,uri:this.toLocalBackupResource(A)}))}toRemoteBackupResource(h){return C.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.syncResource.profile.isDefault?"":`${this.syncResource.profile.id}/`}${this.resource}/${h}`})}toLocalBackupResource(h){return C.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.syncResource.profile.id}/${this.resource}/${h}`})}async getMachineId({uri:h}){const S=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(S))){const{content:A}=await this.getUserData(S);if(A)return this.parseSyncData(A)?.machineId}}async resolveContent(h){const S=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(S))){const{content:A}=await this.getUserData(S);return A}return this.extUri.isEqual(h,this.toLocalBackupResource(S))?this.userDataSyncBackupStoreService.resolveContent(this.syncResource.profile,this.resource,S):null}async resolvePreviewContent(h){const S=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(S)for(const A of S.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,h))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,h))return A.remoteContent;if(this.extUri.isEqual(A.localResource,h))return A.localContent;if(this.extUri.isEqual(A.baseResource,h))return A.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(h,S,A,$,_){const U=await this.isRemoteDataFromCurrentMachine(h),k=await this.generateSyncPreview(h,S,U,$,_),N=[];for(const F of k){const q=F.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)N.push({...F,acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=A?await this.getMergeResult(F,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,R.VSBuffer.fromString(J?.content||""));const j=J&&!J.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,_):void 0;N.push({...F,acceptResult:j,mergeState:J?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:J?J.localChange:F.localChange,remoteChange:j?j.remoteChange:J?J.remoteChange:F.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:h,lastSyncUserData:S,resourcePreviews:N,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),S=JSON.parse(h.value.toString()),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=S.version&&A&&S.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${S.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;const $=S;if($.content===null)return{ref:S.ref,syncData:null};const _=JSON.parse($.content);if(s(_))return{...S,syncData:_,content:void 0}}catch(h){h instanceof y.FileOperationError&&h.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(h)}return null}async updateLastSyncUserData(h,S={}){if(S.ref||S.content||S.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),$={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:A,...S};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify($)))}async getRemoteUserData(h){const{ref:S,content:A}=await this.getUserData(h);let $=null;return A!==null&&($=this.parseSyncData(A)),{ref:S,syncData:$}}parseSyncData(h){try{const S=JSON.parse(h);if(s(S))return S}catch(S){this.logService.error(S)}throw new u.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(h){if((0,b.isString)(h)){const S=await this.userDataSyncStoreService.resolveResourceContent(this.resource,h,this.collection);return{ref:h,content:S}}else{const S=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,S,this.collection,this.syncHeaders)}}async updateRemoteUserData(h,S){const A=await this.currentMachineIdPromise,$={version:this.version,machineId:A,content:h};try{return S=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify($),S,this.collection,this.syncHeaders),{ref:S,syncData:$}}catch(_){throw _ instanceof u.UserDataSyncError&&_.code==="TooLarge"&&(_=new u.UserDataSyncError(_.message,_.code,this.resource)),_}}async backupLocal(h){const S={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(S))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=pe([Y(2,y.IFileService),Y(3,g.IEnvironmentService),Y(4,m.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,u.IUserDataSyncEnablementService),Y(8,l.ITelemetryService),Y(9,u.IUserDataSyncLogService),Y(10,v.IConfigurationService),Y(11,f.IUriIdentityService)],n),e.AbstractSynchroniser=n;let i=class extends n{constructor(h,S,A,$,_,U,k,N,F,q,J,j,H){super(S,A,$,_,U,k,N,F,q,J,j,H),this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(W=>this.onFileChanges(W)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(h,S,A){try{S?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(h),A?void 0:S):await this.fileService.createFile(this.file,R.VSBuffer.fromString(h),{overwrite:A})}catch($){throw $ instanceof y.FileOperationError&&$.fileOperationResult===1||$ instanceof y.FileOperationError&&$.fileOperationResult===3?new u.UserDataSyncError($.message,"LocalPreconditionFailed"):$}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};i=pe([Y(3,y.IFileService),Y(4,g.IEnvironmentService),Y(5,m.IStorageService),Y(6,u.IUserDataSyncStoreService),Y(7,u.IUserDataSyncBackupStoreService),Y(8,u.IUserDataSyncEnablementService),Y(9,l.ITelemetryService),Y(10,u.IUserDataSyncLogService),Y(11,v.IConfigurationService),Y(12,f.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let r=class extends i{constructor(h,S,A,$,_,U,k,N,F,q,J,j,H,W){super(h,S,A,$,_,U,k,N,F,q,J,H,W),this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(h,S){const A=[],$=(0,P.parse)(h,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,b.isUndefined)($)&&S!==Array.isArray($)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=pe([Y(3,y.IFileService),Y(4,g.IEnvironmentService),Y(5,m.IStorageService),Y(6,u.IUserDataSyncStoreService),Y(7,u.IUserDataSyncBackupStoreService),Y(8,u.IUserDataSyncEnablementService),Y(9,l.ITelemetryService),Y(10,u.IUserDataSyncLogService),Y(11,u.IUserDataSyncUtilService),Y(12,v.IConfigurationService),Y(13,f.IUriIdentityService)],r),e.AbstractJsonFileSynchroniser=r;let c=class{constructor(h,S,A,$,_,U){this.resource=h,this.userDataProfilesService=S,this.environmentService=A,this.logService=$,this.fileService=_,this.extUri=U.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(void 0,this.resource,A,this.extUri)}async initialize({ref:h,content:S}){if(!S){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(S);if(!!A)try{await this.doInitialize({ref:h,syncData:A})}catch($){this.logService.error($)}}parseSyncData(h){try{const S=JSON.parse(h);if(s(S))return S}catch(S){this.logService.error(S)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,S={}){const A={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,...S};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(A)))}};c=pe([Y(1,o.IUserDataProfilesService),Y(2,g.IEnvironmentService),Y(3,w.ILogService),Y(4,y.IFileService),Y(5,f.IUriIdentityService)],c),e.AbstractInitializer=c}),define(ne[258],re([0,1,18,16,3,35,4,15,165,17,13,14,21,22,31,20,41,242,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function l(o,s,n){try{const i=JSON.parse(o);if(!s)return(0,P.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,P.isUndefined)(i.mac)?null:i.mac;case 3:return(0,P.isUndefined)(i.linux)?null:i.linux;case 1:return(0,P.isUndefined)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.getKeybindingsContentFromSyncContent=l;let f=class extends w.AbstractJsonFileSynchroniser{constructor(s,n,i,r,c,a,h,S,A,$,_,U,k){super(s.keybindingsResource,{syncResource:"keybindings",profile:s},n,S,A,$,i,r,h,U,c,_,a,k),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(a.onDidChangeConfiguration,N=>N.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,n,i,r){const c=s.syncData?l(s.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&i?s:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,h=await this.getLocalFileContent(),S=await this.getFormattingOptions();let A=null,$=!1,_=!1,U=!1;if(c){let F=h?h.value.toString():"[]";if(F=F||"[]",this.hasErrors(F,!0))throw new m.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==F||a!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,d.merge)(F,c,a,S,this.userDataSyncUtilService);q.hasChanges&&(A=q.mergeContent,U=q.hasConflicts,$=U||q.mergeContent!==F,_=U||q.mergeContent!==c)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=h.value.toString(),_=!0);const k={content:U?a:A,localChange:$?h?2:1:0,remoteChange:_?2:0,hasConflicts:U},N=h?h.value.toString():null;return[{fileContent:h,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:N,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const n=this.getKeybindingsContentFromLastSyncUserData(s);if(n===null)return!0;const i=await this.getLocalFileContent(),r=i?i.value.toString():"",c=await this.getFormattingOptions(),a=await(0,d.merge)(r||"[]",n,n,c,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(s,n){return s.previewResult}async getAcceptResult(s,n,i,r){if(this.extUri.isEqual(n,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(s,n,i,r){const{fileContent:c}=i[0][0];let{content:a,localChange:h,remoteChange:S}=i[0][1];if(h===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new m.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(a||"[]",c,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),S!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(a||"[]",s.syncData?.content);s=await this.updateRemoteUserData(A,r?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const n=(0,L.parse)(s.value.toString());if((0,D.isNonEmptyArray)(n))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:n}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let n=await super.resolveContent(s);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(s)),n){const i=this.parseSyncData(n);if(i)switch(this.extUri.basename(s)){case"keybindings.json":return l(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:l(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,n){let i={};try{i=JSON.parse(n||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=s,T.OS){case 2:i.mac=s;break;case 3:i.linux=s;break;case 1:i.windows=s;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=pe([Y(2,m.IUserDataSyncStoreService),Y(3,m.IUserDataSyncBackupStoreService),Y(4,m.IUserDataSyncLogService),Y(5,E.IConfigurationService),Y(6,m.IUserDataSyncEnablementService),Y(7,C.IFileService),Y(8,b.IEnvironmentService),Y(9,p.IStorageService),Y(10,m.IUserDataSyncUtilService),Y(11,v.ITelemetryService),Y(12,g.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let u=class extends w.AbstractInitializer{constructor(s,n,i,r,c){super("keybindings",n,i,r,s,c)}async doInitialize(s){const n=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,t.VSBuffer.fromString(n)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,L.parse)(s.value.toString());return!(0,D.isNonEmptyArray)(n)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return l(s,!0,this.logService)}catch(n){return this.logService.error(n),null}}};u=pe([Y(0,C.IFileService),Y(1,y.IUserDataProfilesService),Y(2,b.IEnvironmentService),Y(3,m.IUserDataSyncLogService),Y(4,g.IUriIdentityService)],u),e.KeybindingsInitializer=u}),define(ne[259],re([0,1,16,3,166,17,72,13,29,14,21,22,31,20,41,61,246,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(o){return o&&o.settings&&typeof o.settings=="string"&&Object.keys(o).length===1}function l(o){const s=JSON.parse(o);return m(s)?s:{settings:o}}e.parseSettingsSyncContent=l;let f=class extends g.AbstractJsonFileSynchroniser{constructor(s,n,i,r,c,a,h,S,A,$,_,U,k,N){super(s.settingsResource,{syncResource:"settings",profile:s},n,i,r,c,a,h,_,U,S,A,$,N),this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const n=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(s,n),r=this.getSettingsSyncContent(i),c=new T.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&c.parse(r.settings),c.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,n,i){const r=await this.getLocalFileContent(),c=await this.getFormattingOptions(),a=this.getSettingsSyncContent(s);n=n===null&&i?s:n;const h=n?this.getSettingsSyncContent(n):null,S=await this.getIgnoredSettings();let A=null,$=!1,_=!1,U=!1;if(a){let q=r?r.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,w.merge)(q,a.settings,h?h.settings:null,S,[],c);A=J.localContent||J.remoteContent,$=J.localContent!==null,_=J.remoteContent!==null,U=J.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=r.value.toString().trim()||"{}",this.validateContent(A),_=!0);const k=r?r.value.toString():null,N=h?.settings??null,F={content:U?N:A,localChange:$?2:0,remoteChange:_?2:0,hasConflicts:U};return[{fileContent:r,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:k,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const n=this.getSettingsSyncContent(s);if(n===null)return!0;const i=await this.getLocalFileContent(),r=i?i.value.toString().trim():"",c=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,w.merge)(r||"{}",n.settings,n.settings,c,[],a).remoteContent!==null}async getMergeResult(s,n){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,w.updateIgnoredSettings)(s.previewResult.content,"{}",r,i):null}}async getAcceptResult(s,n,i,r){const c=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:s.fileContent?(0,w.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",a,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:s.remoteContent!==null?(0,w.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,s.fileContent?s.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(s,n,i,r){const{fileContent:c}=i[0][0];let{content:a,localChange:h,remoteChange:S}=i[0][1];if(h===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(a,c,r),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),S!==0){const A=await this.getFormattingOptions(),$=this.getSettingsSyncContent(s),_=await this.getIgnoredSettings(a);a=(0,w.updateIgnoredSettings)(a,$?$.settings:"{}",_,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),r?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const n=await this.getFormattingOptions(),i=(0,y.edit)(s.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,w.isEmpty)(i)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:n}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s))return this.resolvePreviewContent(s);let n=await super.resolveContent(s);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(s)),n){const i=this.parseSyncData(n);if(i){const r=this.parseSettingsSyncContent(i.content);if(r)switch(this.extUri.basename(s)){case"settings.json":return r.settings}}}return null}async resolvePreviewContent(s){let n=await super.resolvePreviewContent(s);if(n){const i=await this.getFormattingOptions(),r=await this.getIgnoredSettings();n=(0,w.updateIgnoredSettings)(n,"{}",r,i)}return n}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return l(s)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:c})=>!!c)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(n,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new d.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};f=pe([Y(2,E.IFileService),Y(3,P.IEnvironmentService),Y(4,b.IStorageService),Y(5,d.IUserDataSyncStoreService),Y(6,d.IUserDataSyncBackupStoreService),Y(7,d.IUserDataSyncLogService),Y(8,d.IUserDataSyncUtilService),Y(9,L.IConfigurationService),Y(10,d.IUserDataSyncEnablementService),Y(11,C.ITelemetryService),Y(12,I.IExtensionManagementService),Y(13,p.IUriIdentityService)],f),e.SettingsSynchroniser=f;let u=class extends g.AbstractInitializer{constructor(s,n,i,r,c){super("settings",n,i,r,s,c)}async doInitialize(s){const n=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,w.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return l(s)}catch(n){this.logService.error(n)}return null}};u=pe([Y(0,E.IFileService),Y(1,v.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,d.IUserDataSyncLogService),Y(4,p.IUriIdentityService)],u),e.SettingsInitializer=u}),define(ne[260],re([0,1,16,3,32,17,13,14,21,22,31,20,41,243,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let y=class extends p.AbstractSynchroniser{constructor(m,l,f,u,o,s,n,i,r,c,a,h){super({syncResource:"snippets",profile:m},l,u,f,o,s,n,c,a,i,r,h),this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,S=>S.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,l,f){const u=await this.getSnippetsFileContents(),o=this.toSnippetsContents(u),s=m.syncData?this.parseSnippets(m.syncData):null;l=l===null&&f?m:l;const n=l&&l.syncData?this.parseSnippets(l.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(o,s,n);return this.getResourcePreviews(i,u,s||{},n||{})}async hasRemoteChanged(m){const l=m.syncData?this.parseSnippets(m.syncData):null;if(l===null)return!0;const f=await this.getSnippetsFileContents(),u=this.toSnippetsContents(f),o=(0,v.merge)(u,l,l);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(m,l){return m.previewResult}async getAcceptResult(m,l,f,u){if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async applyResult(m,l,f,u){const o=f.map(([s,n])=>({...s,acceptResult:n}));o.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,u)),o.some(({remoteChange:s})=>s!==0)&&(m=await this.updateRemoteSnippets(o,m,u)),l?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.fileService.del(s)}catch{}}getResourcePreviews(m,l,f,u){const o=new Map;for(const s of Object.keys(m.local.added)){const n={content:m.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(m.local.updated)){const n={content:m.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=l[s]?l[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of m.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=l[s]?l[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(m.remote.added)){const n={content:m.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=l[s]?l[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(m.remote.updated)){const n={content:m.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=l[s]?l[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of m.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of m.conflicts){const n={content:u[s]??null,hasConflicts:!0,localChange:l[s]?2:1,remoteChange:f[s]?2:1},i=l[s]?l[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(l))if(!o.has(s)){const n={content:l[s]?l[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=l[s]?l[s].value.toString():null;o.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async getAssociatedResources({uri:m}){const l=await super.resolveContent(m);if(l){const f=this.parseSyncData(l);if(f){const u=this.parseSnippets(f),o=[];for(const s of Object.keys(u)){const n=this.extUri.joinPath(m,s),i=this.extUri.joinPath(this.snippetsFolder,s),r=await this.fileService.exists(i);o.push({resource:n,comparableResource:r?i:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let l=await super.resolveContent(m);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(m)),l){const f=this.parseSyncData(l);if(f)return this.parseSnippets(f)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const l={};for(const f of m)f.fileContent&&(l[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(l)))}async updateLocalSnippets(m,l){for(const{fileContent:f,acceptResult:u,localResource:o,remoteResource:s,localChange:n}of m)if(n!==0){const i=s?this.extUri.basename(s):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,i);n===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):n===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,D.VSBuffer.fromString(u.content),{overwrite:l}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,D.VSBuffer.fromString(u.content),l?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(m,l,f){const u=l.syncData?this.parseSnippets(l.syncData):{},o=(0,R.deepClone)(u);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:r}of m)if(r!==0){const c=n?this.extUri.basename(n):this.extUri.basename(i);r===3?delete o[c]:o[c]=s.content}return(0,v.areSame)(u,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),l=await this.updateRemoteUserData(JSON.stringify(o),f?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),l}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const l={};for(const f of Object.keys(m))l[f]=m[f].value.toString();return l}async getSnippetsFileContents(){const m={};let l;try{l=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof P.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of l.children||[]){const u=f.resource,o=this.extUri.extname(u);if(o===".json"||o===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,u),n=await this.fileService.readFile(u);m[s]=n}}return m}};y=pe([Y(2,T.IEnvironmentService),Y(3,P.IFileService),Y(4,I.IStorageService),Y(5,g.IUserDataSyncStoreService),Y(6,g.IUserDataSyncBackupStoreService),Y(7,g.IUserDataSyncLogService),Y(8,L.IConfigurationService),Y(9,g.IUserDataSyncEnablementService),Y(10,E.ITelemetryService),Y(11,b.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let w=class extends p.AbstractInitializer{constructor(m,l,f,u,o){super("snippets",l,f,u,m,o)}async doInitialize(m){const l=m.syncData?JSON.parse(m.syncData.content):null;if(!l){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(l)){const o=l[u];if(o){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,u);await this.fileService.createFile(s,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};w=pe([Y(0,P.IFileService),Y(1,C.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,g.IUserDataSyncLogService),Y(4,b.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(ne[261],re([0,1,16,17,13,14,21,22,31,20,41,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(w,d){try{return JSON.parse(w).tasks}catch(m){return d.error(m),null}}e.getTasksContentFromSyncContent=p;let v=class extends b.AbstractFileSynchroniser{constructor(d,m,l,f,u,o,s,n,i,r,c,a){super(d.tasksResource,{syncResource:"tasks",profile:d},m,n,i,r,l,f,s,c,u,o,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(d,m,l,f){const u=d.syncData?p(d.syncData.content,this.logService):null;m=m===null&&l?d:m;const o=m?.syncData?p(m.syncData.content,this.logService):null,s=await this.getLocalFileContent();let n=null,i=!1,r=!1,c=!1;if(u){const S=s?s.value.toString():null;if(!o||o!==S||o!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=y(S,u,o);n=A.content,c=A.hasConflicts,i=A.hasLocalChanged,r=A.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=s.value.toString(),r=!0);const a={content:c?o:n,localChange:i?s?2:1:0,remoteChange:r?2:0,hasConflicts:c},h=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:o,localResource:this.localResource,localContent:h,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const m=d?.syncData?p(d.syncData.content,this.logService):null;if(m===null)return!0;const l=await this.getLocalFileContent(),f=l?l.value.toString():null,u=y(f,m,m);return u.hasLocalChanged||u.hasRemoteChanged}async getMergeResult(d,m){return d.previewResult}async getAcceptResult(d,m,l,f){if(this.extUri.isEqual(m,this.localResource))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:d.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return l===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(d,m,l,f){const{fileContent:u}=l[0][0],{content:o,localChange:s,remoteChange:n}=l[0][1];if(s===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),u&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(u.value.toString()))),await this.updateLocalFileContent(o||"{}",u,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(o||"{}"));d=await this.updateRemoteUserData(i,f?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:d}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(d,"tasks.json"),comparableResource:m}]}async resolveContent(d){if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let m=await super.resolveContent(d);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(d)),m){const l=this.parseSyncData(m);if(l)switch(this.extUri.basename(d)){case"tasks.json":return p(l.content,this.logService)}}return null}toTasksSyncContent(d){return{tasks:d}}};v=pe([Y(2,C.IUserDataSyncStoreService),Y(3,C.IUserDataSyncBackupStoreService),Y(4,C.IUserDataSyncLogService),Y(5,t.IConfigurationService),Y(6,C.IUserDataSyncEnablementService),Y(7,L.IFileService),Y(8,R.IEnvironmentService),Y(9,T.IStorageService),Y(10,P.ITelemetryService),Y(11,I.IUriIdentityService)],v),e.TasksSynchroniser=v;let g=class extends b.AbstractInitializer{constructor(d,m,l,f,u){super("tasks",m,l,f,d,u),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(d){const m=d.syncData?p(d.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(m)),await this.updateLastSyncUserData(d)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};g=pe([Y(0,L.IFileService),Y(1,E.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,C.IUserDataSyncLogService),Y(4,I.IUriIdentityService)],g),e.TasksInitializer=g;function y(w,d,m){if(w===null&&d===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=m!==w,f=m!==d;return!l&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!f?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!l?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[262],re([0,1,46,7,17,13,14,21,22,31,20,41,244,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let g=class pt extends C.AbstractSynchroniser{constructor(d,m,l,f,u,o,s,n,i,r,c,a,h){super({syncResource:"profiles",profile:d},m,f,u,o,s,n,c,a,i,r,h),this.userDataProfilesService=l,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const d=await this.getLastSyncUserData();return d?.syncData?y(d.syncData):null}async getRemoteSyncedProfiles(d){const m=await this.getLastSyncUserData(),l=await this.getLatestRemoteUserData(d,m);return l?.syncData?y(l.syncData):null}async generateSyncPreview(d,m,l){const f=d.syncData?y(d.syncData):null,u=m?.syncData?y(m.syncData):null,o=this.getLocalUserDataProfiles(),{local:s,remote:n}=(0,p.merge)(o,f,u,[]),i={local:s,remote:n,content:u?this.stringifyRemoteProfiles(u):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:n!==null?2:0},r=this.stringifyLocalProfiles(o,!1);return[{baseResource:this.baseResource,baseContent:u?this.stringifyRemoteProfiles(u):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:f?this.stringifyRemoteProfiles(f):null,remoteProfiles:f,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const m=d?.syncData?y(d.syncData):null,l=this.getLocalUserDataProfiles(),{remote:f}=(0,p.merge)(l,m,m,[]);return!!f?.added.length||!!f?.removed.length||!!f?.updated.length}async getMergeResult(d,m){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,m,l,f){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(m,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(d){const m=this.getLocalUserDataProfiles(),l=(0,p.merge)(m,null,null,[]),{local:f,remote:u}=l;return{content:d.localContent,local:f,remote:u,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:u!==null?2:0}}async acceptRemote(d){const m=d.remoteContent?JSON.parse(d.remoteContent):null,l=[],f=[];for(const u of this.getLocalUserDataProfiles()){const o=m?.find(s=>s.id===u.id);o&&(l.push({id:u.id,name:u.name,collection:o.collection}),f.push(u))}if(m!==null){const u=(0,p.merge)(f,m,l,[]),{local:o,remote:s}=u;return{content:d.remoteContent,local:o,remote:s,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:s!==null?2:0}}else return{content:d.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(d,m,l,f){const{local:u,remote:o,localChange:s,remoteChange:n}=l[0][1];if(s===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),s!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const i=[];for(const r of u.added)i.push(this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName}));for(const r of u.removed)i.push(this.userDataProfilesService.removeProfile(r));for(const r of u.updated){const c=this.userDataProfilesService.profiles.find(a=>a.id===r.id);c?i.push(this.userDataProfilesService.updateProfile(c,{name:r.name,shortName:r.shortName})):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(n!==0){const i=l[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const r of o?.added||[]){const c=await this.userDataSyncStoreService.createCollection(this.syncHeaders);i.push({id:r.id,name:r.name,collection:c,shortName:r.shortName})}for(const r of o?.removed||[])i.splice(i.findIndex(({id:c})=>r.id===c),1);for(const r of o?.updated||[]){const c=i.find(({id:a})=>r.id===a);c&&i.splice(i.indexOf(c),1,{id:r.id,name:r.name,collection:c.collection,shortName:r.shortName})}d=await this.updateRemoteUserData(this.stringifyRemoteProfiles(i),f?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${o?.added.length?` Added: ${JSON.stringify(o.added.map(r=>r.name))}.`:""}${o?.updated.length?` Updated: ${JSON.stringify(o.updated.map(r=>r.name))}.`:""}${o?.removed.length?` Removed: ${JSON.stringify(o.removed.map(r=>r.name))}.`:""}`);for(const r of o?.removed||[])await this.userDataSyncStoreService.deleteCollection(r.collection,this.syncHeaders)}m?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"profiles.json"),comparableResource:pt.PROFILES_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,pt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)){const l=await this.resolvePreviewContent(d);return l&&(0,D.toFormattedString)(JSON.parse(l),{})}let m=await super.resolveContent(d);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(d)),m){const l=this.parseSyncData(m);if(l)switch(this.extUri.basename(d)){case"profiles.json":return(0,D.toFormattedString)(y(l),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(d=>!d.isDefault&&!d.isTransient)}stringifyRemoteProfiles(d){return JSON.stringify([...d].sort((m,l)=>m.name.localeCompare(l.name)))}stringifyLocalProfiles(d,m){const l=[...d].sort((f,u)=>f.name.localeCompare(u.name)).map(f=>({id:f.id,name:f.name}));return m?(0,D.toFormattedString)(l,{}):JSON.stringify(l)}};g.PROFILES_DATA_URI=t.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),g=pe([Y(2,b.IUserDataProfilesService),Y(3,T.IFileService),Y(4,L.IEnvironmentService),Y(5,P.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncLogService),Y(9,R.IConfigurationService),Y(10,v.IUserDataSyncEnablementService),Y(11,I.ITelemetryService),Y(12,E.IUriIdentityService)],g),e.UserDataProfilesManifestSynchroniser=g;function y(w){return JSON.parse(w.content)}}),define(ne[263],re([0,1,6,16,64,2,19,17,13,14,20,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends L.Disposable{constructor(g,y,w,d,m){super(),this.environmentService=g,this.fileService=y,this.configurationService=w,this.logService=d,this.userDataProfilesService=m;for(const l of this.userDataProfilesService.profiles)for(const f of C.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(l,f))}async getAllRefs(g,y){const w=this.getResourceBackupHome(g,y),d=await this.fileService.resolve(w);return d.children?d.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort().reverse().map(l=>({ref:l.name,created:this.getCreationTime(l)})):[]}async resolveContent(g,y,w){if(!w){const d=await this.getAllRefs(g,y);d.length&&(w=d[d.length-1].ref)}if(w){const d=(0,T.joinPath)(this.environmentService.userDataSyncHome,y,w);return(await this.fileService.readFile(d)).value.toString()}return null}async backup(g,y,w){const d=this.getResourceBackupHome(g,y),m=(0,T.joinPath)(d,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(m,t.VSBuffer.fromString(w))}catch(l){this.logService.error(l)}try{this.cleanUpBackup(d)}catch{}}getResourceBackupHome(g,y){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...g.isDefault?[y]:[g.id,y])}async cleanUpBackup(g){try{try{if(!await this.fileService.exists(g))return}catch{return}const y=await this.fileService.resolve(g);if(y.children){const w=y.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let m=w.filter(f=>Date.now()-this.getCreationTime(f)>d);const l=w.length-m.length;l<10&&(m=m.slice(10-l)),await D.Promises.settled(m.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(g){return g.ctime||new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};p=pe([Y(0,I.IEnvironmentService),Y(1,E.IFileService),Y(2,P.IConfigurationService),Y(3,C.IUserDataSyncLogService),Y(4,b.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(ne[264],re([0,1,3,2,4,13,21,22,26]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let b=class extends t.Disposable{constructor(p,v,g,y){super(),this.storageService=p,this.telemetryService=v,this.environmentService=g,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:p}),this.storageService.store(E,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,I.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,v){if(this.isResourceEnabled(p)!==v){const g=(0,I.getEnablementKey)(p);this.storeResourceEnablement(g,v)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,v){this.storageService.store(p,v,-1,R.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(E===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=I.ALL_SYNC_RESOURCES.filter(g=>(0,I.getEnablementKey)(g)===p.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};b=pe([Y(0,T.IStorageService),Y(1,P.ITelemetryService),Y(2,L.IEnvironmentService),Y(3,I.IUserDataSyncStoreManagementService)],b),e.UserDataSyncEnablementService=b}),define(ne[78],re([0,1,3,2,4,27,169,13,14,5,25,49,21,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const g="sync.currentMachineName",y="Safari",w="Chrome",d="Edge",m="Firefox",l="Android";function f(s){switch(s){case y:case w:case d:case m:case l:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function u(){return R.isSafari?y:R.isChrome?w:R.isEdge?d:R.isFirefox?m:R.isAndroid?l:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let o=class rt extends t.Disposable{constructor(n,i,r,c,a,h){super(),this.storageService=r,this.userDataSyncStoreService=c,this.logService=a,this.productService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(n,i,r)}async getMachines(n){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(n)).machines.map(c=>({...c,isCurrent:c.id===i}))}async addCurrentMachine(n){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(n);r.machines.some(({id:c})=>c===i)||(r.machines.push({id:i,name:this.computeCurrentMachineName(r.machines),platform:u()}),await this.writeMachinesData(r))}async removeCurrentMachine(n){const i=await this.currentMachineIdPromise,r=await this.readMachinesData(n),c=r.machines.filter(({id:a})=>a!==i);c.length!==r.machines.length&&(r.machines=c,await this.writeMachinesData(r))}async renameMachine(n,i,r){const c=await this.readMachinesData(r),a=c.machines.find(({id:h})=>h===n);if(a){a.name=i,await this.writeMachinesData(c);const h=await this.currentMachineIdPromise;n===h&&this.storageService.store(g,i,-1,1)}}async setEnablements(n){const i=await this.readMachinesData();for(const[r,c]of n){const a=i.machines.find(h=>h.id===r);a&&(a.disabled=c?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(n){const i=this.storageService.get(g,-1);if(i)return i;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,c=new RegExp(`${(0,L.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let a=0;for(const h of n){const S=c.exec(h.name),A=S?parseInt(S[1]):0;a=A>a?A:a}return`${r} #${a+1}`}async readMachinesData(n){this.userData=await this.readUserData(n);const i=this.parse(this.userData);if(i.version!==rt.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(n){const i=JSON.stringify(n),r=await this.userDataSyncStoreService.writeResource(rt.RESOURCE,i,this.userData?.ref||null);this.userData={ref:r,content:i},this._onDidChange.fire()}async readUserData(n){if(this.userData){const i=n&&n.latest?n.latest[rt.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(rt.RESOURCE,this.userData)}parse(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.logService.error(i)}return{version:rt.VERSION,machines:[]}}};o.VERSION=1,o.RESOURCE="machines",o=pe([Y(0,P.IEnvironmentService),Y(1,I.IFileService),Y(2,p.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncLogService),Y(5,b.IProductService)],o),e.UserDataSyncMachinesService=o}),define(ne[265],re([0,1,6,64,38,9,3,2,4,19,7,167,25,21,22,26,75,78]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",l="sync.sessionId",f="sync.storeUrl",u="sync.productQuality";let o=class extends P.Disposable{get syncUrl(){const i=this.storageService.get(f,-1);return i?b.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(f,i.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(u,-1)}set productQuality(i){i?this.storageService.store(u,i,-1,1):this.storageService.remove(u,-1)}constructor(i,r,c,a,h,S,A,$,_,U){super(),this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=c,this.userDataSyncEnablementService=a,this.userDataSyncService=h,this.logService=S,this.userDataSyncAccountService=A,this.telemetryService=$,this.userDataSyncMachinesService=_,this.storageService=U,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(r.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,r.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(c.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:r}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(c=>this.onDidFinishSync(c))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(r&&this.logService.info(r),this.autoSync.clear()):r&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(r))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,r,c){try{this.userDataSyncAccountService.account&&!c&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),r)this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const r=y.UserDataSyncError.toUserDataSyncError(i);r instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:r.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?I.isWeb&&r.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(r),this.successiveFailures++),this._onError.fire(r)}async disableMachineEventually(){this.storageService.store(m,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(m,-1)}async triggerSync(i,r,c){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(r&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",c)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};o=pe([Y(0,p.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncEnablementService),Y(4,y.IUserDataSyncService),Y(5,y.IUserDataSyncLogService),Y(6,w.IUserDataSyncAccountService),Y(7,g.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,v.IStorageService)],o),e.UserDataAutoSyncService=o;class s extends P.Disposable{constructor(i,r,c,a,h,S,A,$){super(),this.lastSyncUrl=i,this.interval=r,this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=a,this.userDataSyncService=h,this.userDataSyncMachinesService=S,this.logService=A,this.storageService=$,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(i,r){const c=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,L.isCancellationError)(h))return}return this.doSync(i,r,a)});return this.syncPromise=c,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),r=this.userDataSyncStoreManagementService.userDataSyncStore;return!!r&&!!i&&(!(0,E.isEqual)(r.defaultUrl,i.defaultUrl)||!(0,E.isEqual)(r.insidersUrl,i.insidersUrl)||!(0,E.isEqual)(r.stableUrl,i.stableUrl))}async doSync(i,r,c){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,r),c.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const h=this.storageService.get(l,-1);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const S=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(c.isCancellationRequested)return;const A=S.find($=>$.isCurrent);if(A?.disabled)throw new y.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch($){throw new y.UserDataAutoSyncError((0,R.toErrorMessage)($),$ instanceof y.UserDataSyncError?$.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(l,this.manifest.session,-1,1),c.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),a=h}this._onDidFinishSync.fire(a)}register(i){return super._register(i)}}s.INTERVAL_SYNCING="Interval"}),define(ne[62],re([0,1,2,68,5,21]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends D.Disposable{constructor(E){super(),this.storageService=E}async readStorageData(E){return this.withProfileScopedStorageService(E,async b=>this.getItems(b))}async updateStorageData(E,b,C){return this.withProfileScopedStorageService(E,async p=>this.writeItems(p,b,C))}async withProfileScopedStorageService(E,b){if(this.storageService.hasScope(E))return b(this.storageService);const C=await this.createStorageDatabase(E),p=new P(C);try{await p.initialize();const v=await b(p);return await p.flush(),v}finally{p.dispose(),await this.closeAndDispose(C)}}getItems(E){const b=new Map,C=p=>{for(const v of E.keys(0,p))b.set(v,{value:E.get(v,0),target:p})};return C(0),C(1),b}writeItems(E,b,C){for(const[p,v]of b)E.store(p,v,0,C)}async closeAndDispose(E){try{await E.close()}finally{(0,D.isDisposable)(E)&&E.dispose()}}};T=pe([Y(0,L.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class P extends L.AbstractStorageService{constructor(E){super({flushInterval:100}),this.profileStorage=this._register(new t.Storage(E))}doInitialize(){return this.profileStorage.init()}getStorage(E){return E===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[266],re([0,1,6,23,9,3,46,2,27,7,17,13,114,29,33,77,14,5,70,8,21,22,31,20,41,241,112,26,62]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u,o,s,n,i,r,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function h($,_){const U=JSON.parse($.content);if($.version===1||$.version===2){const k=(await _.getInstalled(0)).filter(N=>N.isBuiltin);for(const N of U)$.version===1&&(N.enabled===!1&&(N.disabled=!0),delete N.enabled),$.version===2&&k.every(F=>!(0,g.areSameExtensions)(F.identifier,N.identifier))&&(N.installed=!0)}return U}let S=class vt extends n.AbstractSynchroniser{constructor(_,U,k,N,F,q,J,j,H,W,z,K,X,ce,B,G,O,M){super({syncResource:"extensions",profile:_},U,N,k,F,q,J,X,ce,W,K,G),this.extensionManagementService=j,this.ignoredExtensionsManagementService=H,this.extensionGalleryService=z,this.userDataSyncProfilesStorageService=O,this.instantiationService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.profileLocation=_.extensionsResource,this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:V})=>!!V)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),L.Event.filter(O.onDidChange,x=>x.valueChanges.some(({profile:V,changes:ee})=>this.syncResource.profile.id===V.id&&ee.some(oe=>oe.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),B.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(_,U){const k=_.syncData?await h(_.syncData,this.extensionManagementService):null,N=U?.skippedExtensions||[],F=U?.builtinExtensions||[],q=U?.syncData?await h(U.syncData,this.extensionManagementService):null,J=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),j=await this.getLocalExtensions(J),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(J);k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:z}=(0,i.merge)(j,k,q,N,H,F),K={local:W,remote:z,content:this.getPreviewContent(j,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:z!==null?2:0},X=this.stringify(j,!1);return[{skippedExtensions:N,builtinExtensions:F,baseResource:this.baseResource,baseContent:q?this.stringify(q,!1):X,localResource:this.localResource,localContent:X,localExtensions:j,remoteResource:this.remoteResource,remoteExtensions:k,remoteContent:k?this.stringify(k,!1):null,previewResource:this.previewResource,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(_){const U=_.syncData?await h(_.syncData,this.extensionManagementService):null,k=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),N=await this.getLocalExtensions(k),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),{remote:q}=(0,i.merge)(N,U,U,_.skippedExtensions||[],F,_.builtinExtensions||[]);return q!==null}getPreviewContent(_,U,k,N){const F=[...U,...k],q=new Set,J=j=>{q.add(j.id.toLowerCase()),j.uuid&&q.add(j.uuid)};F.forEach(({identifier:j})=>J(j)),N.forEach(J);for(const j of _)q.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&q.has(j.identifier.uuid)||F.push(j);return this.stringify(F,!1)}async getMergeResult(_,U){return{..._.previewResult,hasConflicts:!1}}async getAcceptResult(_,U,k,N){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(_);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(_);if(this.extUri.isEqual(U,this.previewResource))return _.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(_){const U=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(U),N=(0,i.merge)(_.localExtensions,null,null,_.skippedExtensions,k,_.builtinExtensions),{local:F,remote:q}=N;return{content:_.localContent,local:F,remote:q,localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:q!==null?2:0}}async acceptRemote(_){const U=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(U),N=_.remoteContent?JSON.parse(_.remoteContent):null;if(N!==null){const F=(0,i.merge)(_.localExtensions,N,_.localExtensions,[],k,_.builtinExtensions),{local:q,remote:J}=F;return{content:_.remoteContent,local:q,remote:J,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:_.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(_,U,k,N){let{skippedExtensions:F,localExtensions:q}=k[0][0];const{local:J,remote:j,localChange:H,remoteChange:W}=k[0][1];if(H===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),H!==0&&(await this.backupLocal(JSON.stringify(q)),F=await this.updateLocalExtensions(J.added,J.removed,J.updated,F)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const z=JSON.stringify(j.all);_=await this.updateRemoteUserData(z,N?null:_.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(K=>K.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(K=>K.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(K=>K.identifier.id))}.`:""}`)}if(U?.ref!==_.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const z=q.filter(K=>!K.installed).map(K=>K.identifier);await this.updateLastSyncUserData(_,{skippedExtensions:F,builtinExtensions:z}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${F.length?` Skipped: ${JSON.stringify(F.map(K=>K.identifier.id))}.`:""}`)}}async getAssociatedResources({uri:_}){return[{resource:this.extUri.joinPath(_,"extensions.json"),comparableResource:vt.EXTENSIONS_DATA_URI}]}async resolveContent(_){if(this.extUri.isEqual(_,vt.EXTENSIONS_DATA_URI)){const k=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),F=(await this.getLocalExtensions(k)).filter(q=>!N.some(J=>(0,g.areSameExtensions)({id:J},q.identifier)));return this.stringify(F,!0)}if(this.extUri.isEqual(this.remoteResource,_)||this.extUri.isEqual(this.baseResource,_)||this.extUri.isEqual(this.localResource,_)||this.extUri.isEqual(this.acceptedResource,_)){const k=await this.resolvePreviewContent(_);return k&&this.stringify(JSON.parse(k),!0)}let U=await super.resolveContent(_);if(U)return U;if(U=await super.resolveContent(this.extUri.dirname(_)),U){const k=this.parseSyncData(U);if(k)switch(this.extUri.basename(_)){case"extensions.json":return this.stringify(this.parseExtensions(k),!0)}}return null}stringify(_,U){return _.sort((k,N)=>!k.identifier.uuid&&N.identifier.uuid?-1:k.identifier.uuid&&!N.identifier.uuid?1:(0,I.compare)(k.identifier.id,N.identifier.id)),U?(0,T.toFormattedString)(_,{}):JSON.stringify(_)}async hasLocalData(){try{const _=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if((await this.getLocalExtensions(_)).some(k=>k.installed||k.disabled))return!0}catch{}return!1}async updateLocalExtensions(_,U,k,N){return this.withProfileScopedServices(async(F,q)=>{const J=[],j=[],H=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(U.length){const z=H.filter(({identifier:K,isBuiltin:X})=>!X&&U.some(ce=>(0,g.areSameExtensions)(K,ce)));await D.Promises.settled(z.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),J.push(K.identifier)}))}(_.length||k.length)&&await D.Promises.settled([..._,...k].map(async z=>{const K=H.find(ce=>(0,g.areSameExtensions)(ce.identifier,z.identifier));if(K&&K.isBuiltin){z.state&&K.manifest.version===z.version&&this.updateExtensionState(z.state,K,K.manifest.version,q),F.getDisabledExtensions().some(B=>(0,g.areSameExtensions)(B,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await F.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await F.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id))),J.push(z.identifier);return}const X=(await this.extensionGalleryService.getExtensions([{...z.identifier,preRelease:z.preRelease}],t.CancellationToken.None))[0];if(z.state&&(K?K.manifest.version===z.version:!!X)&&this.updateExtensionState(z.state,K||X,K?.manifest.version,q),X)try{F.getDisabledExtensions().some(B=>(0,g.areSameExtensions)(B,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,X.version),await F.disableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,X.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,X.version),await F.enableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,X.version))),(!K||K.preRelease!==z.preRelease)&&(await this.extensionManagementService.canInstall(X)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,X.version),await this.extensionManagementService.installFromGallery(X,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:z.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,X.version),J.push(X.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,X.displayName||X.identifier.id),j.push(z)))}catch(ce){j.push(z),ce instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatiblePreRelease,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ce.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,X.displayName||X.identifier.id):(this.logService.error(ce),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,X.displayName||X.identifier.id))}else j.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const W=[];for(const z of N)J.some(K=>(0,g.areSameExtensions)(K,z.identifier))||W.push(z);for(const z of j)W.some(K=>(0,g.areSameExtensions)(K.identifier,z.identifier))||W.push(z);return W})}updateExtensionState(_,U,k,N){const F=N.getExtensionState(U,!0)||{},q=k?N.getKeysForSync({id:U.identifier.id,version:k}):void 0;q?q.forEach(J=>{F[J]=_[J]}):Object.keys(_).forEach(J=>F[J]=_[J]),N.setExtensionState(U,F,!0)}parseExtensions(_){return JSON.parse(_.content)}getLocalExtensions(_){return this.withProfileScopedServices(async(U,k)=>{const N=U.getDisabledExtensions();return _.map(F=>{const{identifier:q,isBuiltin:J,manifest:j,preRelease:H}=F,W={identifier:q,preRelease:H,version:j.version};N.some(z=>(0,g.areSameExtensions)(z,q))&&(W.disabled=!0),J||(W.installed=!0);try{const z=k.getKeysForSync({id:q.id,version:j.version});if(z){const K=k.getExtensionState(F,!0)||{};W.state=Object.keys(K).reduce((X,ce)=>(z.includes(ce)&&(X[ce]=K[ce]),X),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(z))}return W})})}async withProfileScopedServices(_){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(this.syncResource.profile,async U=>{const k=new P.DisposableStore,N=this.instantiationService.createChild(new m.ServiceCollection([f.IStorageService,U])),F=k.add(N.createInstance(p.GlobalExtensionEnablementService)),q=k.add(N.createInstance(y.ExtensionStorageService));try{return await _(F,q)}finally{k.dispose()}})}};S.EXTENSIONS_DATA_URI=E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),S=pe([Y(2,C.IEnvironmentService),Y(3,w.IFileService),Y(4,f.IStorageService),Y(5,c.IUserDataSyncStoreService),Y(6,c.IUserDataSyncBackupStoreService),Y(7,v.IExtensionManagementService),Y(8,r.IIgnoredExtensionsManagementService),Y(9,c.IUserDataSyncLogService),Y(10,v.IExtensionGalleryService),Y(11,b.IConfigurationService),Y(12,c.IUserDataSyncEnablementService),Y(13,u.ITelemetryService),Y(14,y.IExtensionStorageService),Y(15,o.IUriIdentityService),Y(16,a.IUserDataSyncProfilesStorageService),Y(17,d.IInstantiationService)],S),e.ExtensionsSynchroniser=S;let A=class extends n.AbstractInitializer{constructor(_,U,k,N,F,q,J){super("extensions",N,F,q,k,J),this.extensionManagementService=_,this.ignoredExtensionsManagementService=U}async parseExtensions(_){return _.syncData?await h(_.syncData,this.extensionManagementService):null}generatePreview(_,U){const k=[],N=[],F=[];for(const q of _){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(q.identifier.id))continue;const J=U.find(j=>(0,g.areSameExtensions)(j.identifier,q.identifier));J?(k.push(J),q.disabled&&F.push(q.identifier)):q.installed&&(N.push({...q.identifier,preRelease:!!q.preRelease}),q.disabled&&F.push(q.identifier))}return{installedExtensions:k,newExtensions:N,disabledExtensions:F,remoteExtensions:_}}};A=pe([Y(0,v.IExtensionManagementService),Y(1,r.IIgnoredExtensionsManagementService),Y(2,w.IFileService),Y(3,s.IUserDataProfilesService),Y(4,C.IEnvironmentService),Y(5,l.ILogService),Y(6,o.IUriIdentityService)],A),e.AbstractExtensionsInitializer=A}),define(ne[267],re([0,1,16,9,3,35,46,4,7,30,17,13,14,8,49,21,22,31,41,61,245,26,20,62]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const n="globalState.argv.",i=["locale"];function r(A,$){const _=A.storage?Object.keys(A.storage).sort():[],U={};return _.forEach(k=>U[k]=A.storage[k]),A.storage=U,$?(0,T.toFormattedString)(A,{}):JSON.stringify(A)}const c=1;let a=class St extends m.AbstractSynchroniser{constructor($,_,U,k,N,F,q,J,j,H,W,z,K){super({syncResource:"globalState",profile:$},_,k,J,z,N,F,j,H,q,W,K),this.userDataSyncProfilesStorageService=U,this.version=c,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(k.onDidFilesChange,X=>X.contains(this.environmentService.argvResource)),R.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,X=>!!(X.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||X.valueChanges.some(({profile:ce,changes:B})=>this.syncResource.profile.id===ce.id&&B.some(G=>G.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview($,_,U){const k=$.syncData?JSON.parse($.syncData.content):null;_=_===null&&U?$:_;const N=_&&_.syncData?JSON.parse(_.syncData.content):null,F=await this.getLocalGlobalState();k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=await this.getStorageKeys(N),{local:J,remote:j}=(0,f.merge)(F.storage,k?k.storage:null,N?N.storage:null,q,this.logService),H={content:null,local:J,remote:j,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:j.all!==null?2:0},W=r(F,!1);return[{baseResource:this.baseResource,baseContent:N?r(N,!1):W,localResource:this.localResource,localContent:W,localUserData:F,remoteResource:this.remoteResource,remoteContent:k?r(k,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async hasRemoteChanged($){const _=$.syncData?JSON.parse($.syncData.content):null;if(_===null)return!0;const U=await this.getLocalGlobalState(),k=await this.getStorageKeys(_),{remote:N}=(0,f.merge)(U.storage,_.storage,_.storage,k,this.logService);return N.all!==null}async getMergeResult($,_){return{...$.previewResult,hasConflicts:!1}}async getAcceptResult($,_,U,k){if(this.extUri.isEqual(_,this.localResource))return this.acceptLocal($);if(this.extUri.isEqual(_,this.remoteResource))return this.acceptRemote($);if(this.extUri.isEqual(_,this.previewResource))return $.previewResult;throw new Error(`Invalid Resource: ${_.toString()}`)}async acceptLocal($){return{content:$.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys($.localUserData.storage),removed:[],updated:[],all:$.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote($){if($.remoteContent!==null){const _=JSON.parse($.remoteContent),{local:U,remote:k}=(0,f.merge)($.localUserData.storage,_.storage,null,$.storageKeys,this.logService);return{content:$.remoteContent,local:U,remote:k,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:$.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult($,_,U,k){const{localUserData:N}=U[0][0],{local:F,remote:q,localChange:J,remoteChange:j}=U[0][1];if(J===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(F),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:q.all});$=await this.updateRemoteUserData(H,k?null:$.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${q.added.length?` Added: ${q.added}.`:""}${q.updated.length?` Updated: ${q.updated}.`:""}${q.removed.length?` Removed: ${q.removed}.`:""}`)}_?.ref!==$.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData($),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:$}){return[{resource:this.extUri.joinPath($,"globalState.json"),comparableResource:St.GLOBAL_STATE_DATA_URI}]}async resolveContent($){if(this.extUri.isEqual($,St.GLOBAL_STATE_DATA_URI)){const U=await this.getLocalGlobalState();return r(U,!0)}if(this.extUri.isEqual(this.remoteResource,$)||this.extUri.isEqual(this.baseResource,$)||this.extUri.isEqual(this.localResource,$)||this.extUri.isEqual(this.acceptedResource,$)){const U=await this.resolvePreviewContent($);return U&&r(JSON.parse(U),!0)}let _=await super.resolveContent($);if(_)return _;if(_=await super.resolveContent(this.extUri.dirname($)),_){const U=this.parseSyncData(_);if(U)switch(this.extUri.basename($)){case"globalState.json":return r(JSON.parse(U.content),!0)}}return null}async hasLocalData(){try{const{storage:$}=await this.getLocalGlobalState();if(Object.keys($).length>1||$[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const $={};if(this.syncResource.profile.isDefault){const U=await this.getLocalArgvContent(),k=(0,L.parse)(U);for(const N of i)k[N]!==void 0&&($[`${n}${N}`]={version:1,value:k[N]})}const _=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile);for(const[U,k]of _)k.value&&k.target===0&&($[U]={version:1,value:k.value});return{storage:$}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const $=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),$.value.toString()}catch($){this.logService.debug((0,t.getErrorMessage)($))}return"{}"}async writeLocalGlobalState({added:$,removed:_,updated:U}){const k={},N=new Map,F=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),q=(J,j)=>{for(const H of J){if(H.startsWith(n)){k[H.substring(n.length)]=j?j[H].value:void 0;continue}if(j){const W=j[H];W.value!==F.get(H)?.value&&N.set(H,W.value)}else F.get(H)!==void 0&&N.set(H,void 0)}};q(Object.keys($),$),q(Object.keys(U),U),q(_),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),N.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.syncResource.profile,N,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...N.keys()]))}async updateArgv($){const _=await this.getLocalArgvContent();let U=_;for(const k of Object.keys($))U=(0,l.edit)(U,[k],$[k],{});_!==U&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys($){const _=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),U=[],k=[];for(const[q,J]of _)J.target===0?U.push(q):J.target===1&&k.push(q);const N=[...U,...k],F=$?.storage?Object.keys($.storage).filter(q=>!q.startsWith(n)&&!N.includes(q)&&_.get(q)!==void 0):[];if(!P.isWeb){const q=[...u.ALL_SYNC_RESOURCES.map(J=>(0,u.getEnablementKey)(J)),u.SYNC_SERVICE_URL_TYPE];F.push(...q),k.push(...q)}return{user:U,machine:k,unregistered:F}}};a.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=pe([Y(2,s.IUserDataSyncProfilesStorageService),Y(3,p.IFileService),Y(4,u.IUserDataSyncStoreService),Y(5,u.IUserDataSyncBackupStoreService),Y(6,u.IUserDataSyncLogService),Y(7,C.IEnvironmentService),Y(8,u.IUserDataSyncEnablementService),Y(9,w.ITelemetryService),Y(10,b.IConfigurationService),Y(11,y.IStorageService),Y(12,d.IUriIdentityService)],a),e.GlobalStateSynchroniser=a;let h=class extends m.AbstractInitializer{constructor($,_,U,k,N,F){super("globalState",U,k,N,_,F),this.storageService=$}async doInitialize($){const _=$.syncData?JSON.parse($.syncData.content):null;if(!_){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const U={},k={};for(const N of Object.keys(_.storage))N.startsWith(n)?U[N.substring(n.length)]=_.storage[N].value:this.storageService.get(N,0)===void 0&&(k[N]=_.storage[N].value);if(Object.keys(U).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const F of Object.keys(U))N=(0,l.edit)(N,[F],U[F],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(k).length)for(const N of Object.keys(k))this.storageService.store(N,k[N],0,0)}};h=pe([Y(0,y.IStorageService),Y(1,p.IFileService),Y(2,o.IUserDataProfilesService),Y(3,C.IEnvironmentService),Y(4,u.IUserDataSyncLogService),Y(5,d.IUriIdentityService)],h),e.GlobalStateInitializer=h;let S=class{constructor($,_,U,k,N){this.userDataSyncStoreClient=$,this.storageService=_,this.environmentService=U,this.fileService=k,this.logService=N}getSyncStoreType($){return this.parseGlobalState($)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync($){const _=(0,u.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync($,_)}catch(U){if(U instanceof u.UserDataSyncError)switch(U.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync($,_)}throw U}}async doSync($,_){const U=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,_),k=this.parseGlobalState(U)||{storage:{}};k.storage[u.SYNC_SERVICE_URL_TYPE]={value:$,version:c};const N=await(0,g.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),F={version:c,machineId:N,content:r(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(F),U.ref,void 0,_)}parseGlobalState({content:$}){if(!$)return null;const _=JSON.parse($);if((0,m.isSyncData)(_))return _?JSON.parse(_.content):null;throw new Error("Invalid remote data")}};S=pe([Y(1,y.IStorageService),Y(2,C.IEnvironmentService),Y(3,p.IFileService),Y(4,v.ILogService)],S),e.UserDataSyncStoreTypeSynchronizer=S}),define(ne[268],re([0,1,18,6,23,38,3,2,19,15,30,17,13,29,5,25,21,22,20,266,267,258,259,260,261,262,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u,o,s,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let a=class extends P.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(_,U,k,N,F,q,J,j,H,W){super(),this.userDataSyncStoreService=_,this.userDataSyncStoreManagementService=U,this.instantiationService=k,this.logService=N,this.telemetryService=F,this.storageService=q,this.userDataSyncEnablementService=J,this.userDataProfilesService=j,this.productService=H,this.environmentService=W,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=U.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(c,-1,void 0),this._register((0,P.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(_,U){this.checkEnablement(),this.logService.info("Sync started.");const k=new Date().getTime(),N=(0,b.generateUuid)();try{const j=(0,r.createSyncHeaders)(N);U&&(j["Cache-Control"]="no-cache"),_=await this.userDataSyncStoreService.manifest(_,j)}catch(j){const H=r.UserDataSyncError.toUserDataSyncError(j);throw A(H,N,this.userDataSyncStoreManagementService,this.telemetryService),H}const F=!1,q=this;let J;return{manifest:_,async run(){if(F)throw new Error("Can run a task only once");J=(0,t.createCancelablePromise)(j=>q.sync(_,!1,N,j)),await J.finally(()=>J=void 0),q.logService.info(`Sync done. Took ${new Date().getTime()-k}ms`),q.updateLastSyncTime()},stop(){return J?.cancel(),q.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new r.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const _=new Date().getTime(),U=(0,b.generateUuid)(),k=(0,r.createSyncHeaders)(U);let N;try{N=await this.userDataSyncStoreService.manifest(null,k)}catch(J){const j=r.UserDataSyncError.toUserDataSyncError(J);throw A(j,U,this.userDataSyncStoreManagementService,this.telemetryService),j}await this.resetLocal();const F=this,q=new R.CancellationTokenSource;return{id:U,async merge(){return F.sync(N,!0,U,q.token)},async apply(){await F.applyManualSync(N,U,q.token),F.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),F.updateLastSyncTime()},stop(){return q.cancel(),F.stop()},dispose(){q.cancel(),F.stop()}}}async sync(_,U,k,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,_,U,k,N));const q=F.enabled.find(J=>J.resource==="profiles");if(q){const J=await q.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(J,_,U,k,N)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(_,U,k,N,F){for(const q of _){if(F.isCancellationRequested)return;const J=this.userDataProfilesService.profiles.find(H=>H.id===q.id);if(!J){this.logService.error(`Settings Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",q.name);const j=this.getOrCreateActiveProfileSynchronizer(J,q);this._syncErrors.push(...await this.syncProfile(j,U,k,N,F))}}async applyManualSync(_,U,k){const N=this.getActiveProfileSynchronizers();for(const H of N){if(k.isCancellationRequested)return;await H.apply(U,k)}const F=N.find(H=>H.profile.isDefault);if(!F)return;const q=F.enabled.find(H=>H.resource==="profiles");if(!q)return;const j=(await q.getRemoteSyncedProfiles(_?.latest??null)||[]).filter(H=>N.every(W=>W.profile.id!==H.id));j.length&&await this.syncRemoteProfiles(j,_,!1,U,k)}async syncProfile(_,U,k,N,F){return(await _.sync(U,k,N,F)).map(([J,j])=>({profile:_.profile,syncResource:J,error:j}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(_=>_.stop()))}async resolveContent(_){for(const U of this.userDataProfilesService.profiles){const k=await this.performAction(U,async N=>{const F=await N.resolveContent(_);if(F)return F});if(!(0,E.isUndefinedOrNull)(k))return k}return null}async replace(_,U){this.checkEnablement(),await this.performAction(_.profile,async k=>{if(_.syncResource===k.resource)return await k.replace(U),!0})}async accept(_,U,k,N){this.checkEnablement(),await this.performAction(_.profile,async F=>{if(_.syncResource===F.resource)return await F.accept(U,k),N&&await F.apply((0,E.isBoolean)(N)?!1:N.force,(0,r.createSyncHeaders)((0,b.generateUuid)())),!0})}async getRemoteSyncResourceHandles(_){return await this.performAction(_.profile,async k=>{if(k.resource===_.syncResource)return k.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(_){return await this.performAction(_.profile,async k=>{if(k.resource===_.syncResource)return k.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(_,U){return await this.performAction(_.profile,async N=>{if(N.resource===_.syncResource)return N.getAssociatedResources(U)})||[]}async getMachineId(_,U){return await this.performAction(_.profile,async N=>{if(N.resource===_.syncResource)return await N.getMachineId(U)||null})||void 0}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async U=>{if(U.resource!=="globalState"&&await U.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async U=>{if(await U.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(_){this.logService.error(_)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(c,-1);for(const[_]of this.activeProfileSynchronizers.values())try{await _.resetLocal()}catch(U){this.logService.error(U)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(_,U){const k=new P.DisposableStore;try{const N=this.activeProfileSynchronizers.get(_.id);if(N){const H=await this.performActionWithProfileSynchronizer(N[0],U,k);return(0,E.isUndefined)(H)?null:H}if(_.isDefault){const H=k.add(this.instantiationService.createInstance(h,_,void 0)),W=await this.performActionWithProfileSynchronizer(H,U,k);return(0,E.isUndefined)(W)?null:W}if(this.userDataProfilesService.isEnabled()||this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const F=k.add(this.instantiationService.createInstance(i.UserDataProfilesManifestSynchroniser,_,void 0)),q=await this.userDataSyncStoreService.manifest(null),j=(await F.getRemoteSyncedProfiles(q?.latest??null)||[]).find(H=>H.id===_.id);if(j){const H=k.add(this.instantiationService.createInstance(h,_,j.collection)),W=await this.performActionWithProfileSynchronizer(H,U,k);return(0,E.isUndefined)(W)?null:W}return null}finally{k.dispose()}}async performActionWithProfileSynchronizer(_,U,k){const N=[..._.enabled,..._.disabled.map(F=>k.add(_.createSynchronizer(F)))];for(const F of N){const q=await U(F);if(!(0,E.isUndefined)(q))return q}}setStatus(_){const U=this._status;this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_),U==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const _=this.getActiveProfileSynchronizers().map(U=>U.conflicts).flat();(0,D.equals)(this._conflicts,_,(U,k)=>U.profile.id===k.profile.id&&U.syncResource===k.syncResource&&(0,D.equals)(U.conflicts,k.conflicts,(N,F)=>(0,I.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(_,U){let k=this.activeProfileSynchronizers.get(_.id);if(!k){const N=new P.DisposableStore,F=N.add(this.instantiationService.createInstance(h,_,U?.collection));N.add(F.onDidChangeStatus(q=>this.setStatus(q))),N.add(F.onDidChangeConflicts(q=>this.updateConflicts())),N.add(F.onDidChangeLocal(q=>this._onDidChangeLocal.fire(q))),this.activeProfileSynchronizers.set(_.id,k=[F,N])}return k[0]}getActiveProfileSynchronizers(){const _=[];for(const[U]of this.activeProfileSynchronizers.values())_.push(U);return _}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,_])=>_.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=pe([Y(0,r.IUserDataSyncStoreService),Y(1,r.IUserDataSyncStoreManagementService),Y(2,g.IInstantiationService),Y(3,r.IUserDataSyncLogService),Y(4,d.ITelemetryService),Y(5,w.IStorageService),Y(6,r.IUserDataSyncEnablementService),Y(7,m.IUserDataProfilesService),Y(8,y.IProductService),Y(9,p.IEnvironmentService)],a),e.UserDataSyncService=a;let h=class extends P.Disposable{get enabled(){return this._enabled.sort((_,U)=>_[1]-U[1]).map(([_])=>_)}get disabled(){return r.ALL_SYNC_RESOURCES.filter(_=>!this.userDataSyncEnablementService.isResourceEnabled(_))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(_,U,k,N,F,q,J,j,H,W,z,K){super(),this._profile=_,this.collection=U,this.userDataSyncEnablementService=k,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=q,this.telemetryService=J,this.logService=j,this.productService=H,this.userDataProfilesService=W,this.configurationService=z,this.environmentService=K,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(W.onDidChangeProfiles(()=>{if(W.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!W.defaultProfile.extensionsResource&&this._profile.extensionsResource){this._profile=W.defaultProfile;for(const[X]of this._enabled)X instanceof l.ExtensionsSynchroniser&&(X.profileLocation=this._profile.extensionsResource)}})),this._register(k.onDidChangeResourceEnablement(([X,ce])=>this.onDidChangeResourceEnablement(X,ce))),this._register((0,P.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,X])=>X.dispose())));for(const X of r.ALL_SYNC_RESOURCES)k.isResourceEnabled(X)&&this.registerSynchronizer(X)}onDidChangeResourceEnablement(_,U){U?this.registerSynchronizer(_):this.deRegisterSynchronizer(_)}registerSynchronizer(_){if(this._enabled.some(([F])=>F.resource===_))return;if(_==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(_==="profiles"){if(!this._profile.isDefault||!this.userDataProfilesService.isEnabled())return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const U=new P.DisposableStore,k=U.add(this.createSynchronizer(_));U.add(k.onDidChangeStatus(()=>this.updateStatus())),U.add(k.onDidChangeConflicts(()=>this.updateConflicts())),U.add(k.onDidChangeLocal(()=>this._onDidChangeLocal.fire(_)));const N=this.getOrder(_);this._enabled.push([k,N,U])}deRegisterSynchronizer(_){const U=this._enabled.findIndex(([k])=>k.resource===_);if(U!==-1){const k=this._enabled.splice(U,1);for(const[N,,F]of k){if(N.status!=="idle"){const q=N.conflicts.conflicts.length>0;N.stop(),q&&this.updateConflicts(),this.updateStatus()}F.dispose()}}}createSynchronizer(_){switch(_){case"settings":return this.instantiationService.createInstance(o.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(u.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(s.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(n.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(f.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(l.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(i.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(_,U,k,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const q=[],J=(0,r.createSyncHeaders)(k),j=(this.collection?_?.collections?.[this.collection]?.latest:_?.latest)??null,H=U?await this.getUserDataSyncConfiguration(j):{};for(const W of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(W.resource))return[];try{if(U){const z=await W.preview(j,H,J);if(z)for(const K of z.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await W.merge(K.previewResource)}else await W.sync(j,J)}catch(z){const K=r.UserDataSyncError.toUserDataSyncError(z);if(A(K,k,this.userDataSyncStoreManagementService,this.telemetryService),S(z))throw K;this.logService.error(z),this.logService.error(`${W.resource}: ${(0,L.toErrorMessage)(z)}`),q.push([W.resource,K])}}return q}finally{this.updateStatus()}}async apply(_,U){const k=(0,r.createSyncHeaders)(_);for(const N of this.enabled){if(U.isCancellationRequested)return;try{await N.apply(!1,k)}catch(F){const q=r.UserDataSyncError.toUserDataSyncError(F);if(A(q,_,this.userDataSyncStoreManagementService,this.telemetryService),S(F))throw q;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,L.toErrorMessage)(F)}`)}}}async stop(){for(const _ of this.enabled)try{_.status!=="idle"&&await _.stop()}catch(U){this.logService.error(U)}}async resetLocal(){for(const _ of this.enabled)try{await _.resetLocal()}catch(U){this.logService.error(`${_.resource}: ${(0,L.toErrorMessage)(U)}`),this.logService.error(U)}}async getUserDataSyncConfiguration(_){if(!this.profile.isDefault)return{};const U=this.configurationService.getValue(r.USER_DATA_SYNC_CONFIGURATION_SCOPE),k=this.enabled.find(N=>N instanceof o.SettingsSynchroniser);if(k){const N=await k.getRemoteUserDataSyncConfiguration(_);return{...U,...N}}return U}setStatus(_){this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_))}updateStatus(){return this.updateConflicts(),this.enabled.some(_=>_.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(_=>_.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const _=this.enabled.filter(U=>U.status==="hasConflicts").filter(U=>U.conflicts.conflicts.length>0).map(U=>U.conflicts);(0,D.equals)(this._conflicts,_,(U,k)=>U.syncResource===k.syncResource&&(0,D.equals)(U.conflicts,k.conflicts,(N,F)=>(0,I.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}getOrder(_){switch(_){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};h=pe([Y(2,r.IUserDataSyncEnablementService),Y(3,g.IInstantiationService),Y(4,v.IExtensionGalleryService),Y(5,r.IUserDataSyncStoreManagementService),Y(6,d.ITelemetryService),Y(7,r.IUserDataSyncLogService),Y(8,y.IProductService),Y(9,m.IUserDataProfilesService),Y(10,C.IConfigurationService),Y(11,p.IEnvironmentService)],h);function S($){if($ instanceof r.UserDataSyncError)switch($.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function A($,_,U,k){k.publicLog2("sync/error",{code:$.code,serverCode:$ instanceof r.UserDataSyncStoreError?String($.serverCode):void 0,url:$ instanceof r.UserDataSyncStoreError?$.url:void 0,resource:$.resource,executionId:_,service:U.userDataSyncStore.url.toString()})}}),define(ne[269],re([0,1,3,2,7,20,26]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(C,p){return{...C,profile:(0,L.reviveProfile)(C.profile,p.profilesHome.scheme)}}class I{constructor(p,v,g){this.service=p,this.userDataProfilesService=v,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(p,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(p,v,g){try{return await this._call(p,v,g)}catch(y){throw this.logService.error(y),y}}async _call(p,v,g){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(g[0]));case"accept":return this.service.accept(P(g[0],this.userDataProfilesService),R.URI.revive(g[1]),g[2],g[3]);case"replace":return this.service.replace(P(g[0],this.userDataProfilesService),R.URI.revive(g[1]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(P(g[0],this.userDataProfilesService));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(P(g[0],this.userDataProfilesService));case"getAssociatedResources":return this.service.getAssociatedResources(P(g[0],this.userDataProfilesService),{created:g[1].created,uri:R.URI.revive(g[1].uri)});case"getMachineId":return this.service.getMachineId(P(g[0],this.userDataProfilesService),{created:g[1].created,uri:R.URI.revive(g[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const y=v.substring(11),w=g[0],d=this.getManualSyncTask(w);switch(g=g.slice(1),y){case"merge":return d.merge();case"apply":return d.apply();case"stop":return d.stop();case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(p){const v=this.manualSyncTasks.get(this.createKey(p));if(!v)throw new Error(`Manual sync taks not found: ${p}`);return v.manualSyncTask}async createManualSyncTask(){const p=new t.DisposableStore,v=p.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:p}),v.id}disposeManualSyncTask(p){p.dispose();const v=this.createKey(p.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=I;let E=class extends t.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(p,v){super(),this.userDataProfilesService=v,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,y,w){return p.call(g,y,w).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(g,y){return p.listen(g,y)}},this.channel.call("_getInitialData").then(([g,y,w])=>{this.updateStatus(g),this.updateConflicts(y),w&&this.updateLastSyncTime(w),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(y=>({...y,error:T.UserDataSyncError.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.channel.call("createManualSyncTask"),v=this;return new b(p,{async call(y,w,d){return v.channel.call(`manualSync/${y}`,[p,...Array.isArray(w)?w:[w]],d)},listen(){throw new Error("not supported")}})}replace(p,v){return this.channel.call("replace",[p,v])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(p,v,g,y){return this.channel.call("accept",[p,v,g,y])}resolveContent(p){return this.channel.call("resolveContent",[p])}async getLocalSyncResourceHandles(p){return(await this.channel.call("getLocalSyncResourceHandles",[p])).map(({created:g,uri:y})=>({created:g,uri:R.URI.revive(y)}))}async getRemoteSyncResourceHandles(p){return(await this.channel.call("getRemoteSyncResourceHandles",[p])).map(({created:g,uri:y})=>({created:g,uri:R.URI.revive(y)}))}async getAssociatedResources(p,v){return(await this.channel.call("getAssociatedResources",[p,v])).map(({resource:y,comparableResource:w})=>({resource:R.URI.revive(y),comparableResource:R.URI.revive(w)}))}async getMachineId(p,v){return this.channel.call("getMachineId",[p,v])}async updateStatus(p){this._status=p,this._onDidChangeStatus.fire(p)}async updateConflicts(p){this._conflicts=p.map(v=>({syncResource:v.syncResource,profile:(0,L.reviveProfile)(v.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:v.conflicts.map(g=>({...g,baseResource:R.URI.revive(g.baseResource),localResource:R.URI.revive(g.localResource),remoteResource:R.URI.revive(g.remoteResource),previewResource:R.URI.revive(g.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(p){this._lastSyncTime!==p&&(this._lastSyncTime=p,this._onDidChangeLastSyncTime.fire(p))}};E=pe([Y(1,L.IUserDataProfilesService)],E),e.UserDataSyncChannelClient=E;class b extends t.Disposable{constructor(p,v){super(),this.id=p,this.channel=v}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ne[270],re([0,1,6,23,9,3,2,129,4,19,15,7,30,17,13,14,25,45,49,21,26]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",o="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,r=1e3*60*5;let c=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,_,-1,I.isWeb?0:1)}constructor(_,U,k){super(),this.productService=_,this.configurationService=U,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(k.onDidChangeValue,N=>N.key===f.SYNC_SERVICE_URL_TYPE&&N.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,U){_=I.isWeb&&_?.web?{..._,..._.web}:_;const k={..._||{},...U||{}};if(k&&(0,b.isString)(k.url)&&(0,b.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(N=>Array.isArray(k.authenticationProviders[N].scopes))){const N=k,F=!!N.canSwitch&&!U?.url,q=N.url===N.insidersUrl?"insiders":"stable",J=(F?this.userDataSyncStoreType:void 0)||q,j=U?.url||(J==="insiders"?N.insidersUrl:J==="stable"?N.stableUrl:N.url);return{url:C.URI.parse(j),type:J,defaultType:q,defaultUrl:C.URI.parse(N.url),stableUrl:C.URI.parse(N.stableUrl),insidersUrl:C.URI.parse(N.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(N.authenticationProviders).reduce((H,W)=>(H.push({id:W,scopes:N.authenticationProviders[W].scopes}),H),[])}}}};c=pe([Y(0,w.IProductService),Y(1,v.IConfigurationService),Y(2,l.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let a=class extends c{constructor(_,U,k){super(_,U,k);const N=this.storageService.get(u,-1);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const F=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(u,JSON.stringify(F),-1,1):this.storageService.remove(u,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=pe([Y(0,w.IProductService),Y(1,v.IConfigurationService),Y(2,l.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let h=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(_,U,k,N,F,q,J){super(),this.requestService=k,this.logService=N,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,m.getServiceMachineId)(F,q,J).then(j=>{const H={"X-Client-Name":`${U.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(H["X-Client-Commit"]=U.commit),H}),this.session=new A(i,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(_,U){this.authToken={token:_,type:U}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,E.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(o,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]="application/json";const k=await this.request(U,{type:"GET",headers:_},[],t.CancellationToken.None);return await(0,d.asJson)(k)||[]}async createCollection(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]=P.Mimes.text;const k=await this.request(U,{type:"POST",headers:_},[],t.CancellationToken.None),N=await(0,d.asTextOrError)(k);if(!N)throw new f.UserDataSyncStoreError("Server did not return the collection id",U,"NoCollection",k.res.statusCode,k.res.headers[f.HEADER_OPERATION_ID]);return N}async deleteCollection(_,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=_?(0,E.joinPath)(this.userDataSyncStoreUrl,"collection",_).toString():(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},await this.request(k,{type:"DELETE",headers:U},[],t.CancellationToken.None)}async getAllResourceRefs(_,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=this.getResourceUrl(this.userDataSyncStoreUrl,U,_),N={},F=await this.request(k.toString(),{type:"GET",headers:N},[],t.CancellationToken.None);return(await(0,d.asJson)(F)||[]).map(({url:J,created:j})=>({ref:(0,E.relativePath)(k,k.with({path:J})),created:j*1e3}))}async resolveResourceContent(_,U,k,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),U).toString();N={...N},N["Cache-Control"]="no-cache";const q=await this.request(F,{type:"GET",headers:N},[],t.CancellationToken.None);return await(0,d.asTextOrError)(q)}async deleteResource(_,U,k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=U!==null?(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),U).toString():this.getResourceUrl(this.userDataSyncStoreUrl,k,_).toString(),F={};await this.request(N,{type:"DELETE",headers:F},[],t.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(_,{type:"DELETE",headers:U},[],t.CancellationToken.None)}async readResource(_,U,k,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),"latest").toString();N={...N},N["Cache-Control"]="no-cache",U&&(N["If-None-Match"]=U.ref);const q=await this.request(F,{type:"GET",headers:N},[304],t.CancellationToken.None);let J=null;if(q.res.statusCode===304&&(J=U),J===null){const j=q.res.headers.etag;if(!j)throw new f.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);const H=await(0,d.asTextOrError)(q);if(!H&&q.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",F,"EmptyResponse",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);J={ref:j,content:H}}return J}async writeResource(_,U,k,N,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=this.getResourceUrl(this.userDataSyncStoreUrl,N,_).toString();F={...F},F["Content-Type"]=P.Mimes.text,k&&(F["If-Match"]=k);const J=await this.request(q,{type:"POST",data:U,headers:F},[],t.CancellationToken.None),j=J.res.headers.etag;if(!j)throw new f.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",J.res.statusCode,J.res.headers[f.HEADER_OPERATION_ID]);return j}async manifest(_,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",_&&(U["If-None-Match"]=_.ref);const N=await this.request(k,{type:"GET",headers:U},[304],t.CancellationToken.None);let F=null;if(N.res.statusCode===304&&(F=_),!F){const J=N.res.headers.etag;if(!J)throw new f.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",N.res.statusCode,N.res.headers[f.HEADER_OPERATION_ID]);const j=await(0,d.asTextOrError)(N);if(!j&&N.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",k,"EmptyResponse",N.res.statusCode,N.res.headers[f.HEADER_OPERATION_ID]);j&&(F={...JSON.parse(j),ref:J})}const q=this.storageService.get(s,-1);return q&&F&&q!==F.session&&this.clearSession(),F===null&&q&&this.clearSession(),F&&this.storageService.store(s,F.session,-1,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(_,U,k){return U?(0,E.joinPath)(_,"collection",U,"resource",k):(0,E.joinPath)(_,"resource",k)}clearSession(){this.storageService.remove(s,-1),this.storageService.remove(n,-1)}async request(_,U,k,N){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${U.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;U.headers={...U.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:_,type:U.type,headers:{...U.headers,authorization:void 0}});let q;try{q=await this.session.request(_,U,N)}catch(W){if(!(W instanceof f.UserDataSyncStoreError)){let z="RequestFailed";const K=(0,R.getErrorMessage)(W).toLowerCase();K.includes("xhr timeout")?z="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?z="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":K.includes("headers must be an object")?z="RequestHeadersNotObject":(0,R.isCancellationError)(W)&&(z="RequestCanceled"),W=new f.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,z,void 0,void 0)}throw this.logService.info("Request failed",_),W}const J=q.res.headers[f.HEADER_OPERATION_ID],j={url:_,status:q.res.statusCode,"execution-id":U.headers[f.HEADER_EXECUTION_ID],"operation-id":J},H=(0,d.isSuccess)(q)||q.res.statusCode&&k.indexOf(q.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),q.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",q.res.statusCode,J);if(this._onTokenSucceed.fire(),q.res.statusCode===409)throw new f.UserDataSyncStoreError(`${U.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",q.res.statusCode,J);if(q.res.statusCode===410)throw new f.UserDataSyncStoreError(`${U.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",q.res.statusCode,J);if(q.res.statusCode===412)throw new f.UserDataSyncStoreError(`${U.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",q.res.statusCode,J);if(q.res.statusCode===413)throw new f.UserDataSyncStoreError(`${U.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",q.res.statusCode,J);if(q.res.statusCode===426)throw new f.UserDataSyncStoreError(`${U.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",q.res.statusCode,J);if(q.res.statusCode===429){const W=q.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new f.UserDataSyncStoreError(`${U.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",q.res.statusCode,J)):new f.UserDataSyncStoreError(`${U.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",q.res.statusCode,J)}if(!H)throw new f.UserDataSyncStoreError("Server returned "+q.res.statusCode,_,"Unknown",q.res.statusCode,J);return q}addSessionHeaders(_){let U=this.storageService.get(n,-1);U===void 0&&(U=(0,p.generateUuid)(),this.storageService.store(n,U,-1,1)),_["X-Machine-Session-Id"]=U;const k=this.storageService.get(s,-1);k!==void 0&&(_["X-User-Session-Id"]=k)}};h=pe([Y(1,w.IProductService),Y(2,d.IRequestService),Y(3,f.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,y.IFileService),Y(6,l.IStorageService)],h),e.UserDataSyncStoreClient=h;let S=class extends h{constructor(_,U,k,N,F,q,J){super(_.userDataSyncStore?.url,U,k,N,F,q,J),this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};S=pe([Y(0,f.IUserDataSyncStoreManagementService),Y(1,w.IProductService),Y(2,d.IRequestService),Y(3,f.IUserDataSyncLogService),Y(4,g.IEnvironmentService),Y(5,y.IFileService),Y(6,l.IStorageService)],S),e.UserDataSyncStoreService=S;class A{constructor(_,U,k,N){this.limit=_,this.interval=U,this.requestService=k,this.logService=N,this.requests=[],this.startTime=void 0}request(_,U,k){if(this.isExpired()&&this.reset(),U.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(U,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(ne[271],re([0,1,3,59,25,21,22,265,26,75,78]),function(Q,e,D,t,R,L,T,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(v,g,y,w,d,m,l,f,u,o,s){super(v,g,y,w,d,l,f,u,o,s),this._register(D.Event.debounce(D.Event.any(D.Event.map(m.onDidFocusWindow,()=>"windowFocus"),D.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};C=pe([Y(0,R.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncEnablementService),Y(4,I.IUserDataSyncService),Y(5,t.INativeHostService),Y(6,I.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,b.IUserDataSyncMachinesService),Y(10,L.IStorageService)],C),e.UserDataAutoSyncService=C}),define(ne[272],re([0,1,3,2,58,8,62,21,73,20]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let b=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(p,v,g,y){super(g),this.mainProcessService=p;const w=p.getChannel("profileStorageListener"),d=this._register(new t.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onFirstListenerAdd:()=>{d.value=w.listen("onDidChange")(m=>{y.trace("profile storage changes",m),this._onDidChange.fire({targetChanges:m.targetChanges.map(l=>(0,E.reviveProfile)(l,v.profilesHome.scheme)),valueChanges:m.valueChanges.map(l=>({...l,profile:(0,E.reviveProfile)(l.profile,v.profilesHome.scheme)}))})})},onLastListenerRemove:()=>d.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(p){const v=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new I.ApplicationStorageDatabaseClient(v):new I.ProfileStorageDatabaseClient(v,p)}};b=pe([Y(0,R.IMainProcessService),Y(1,E.IUserDataProfilesService),Y(2,P.IStorageService),Y(3,L.ILogService)],b),e.UserDataSyncProfilesStorageService=b}),define(ne[273],re([0,1,97,24,4,19]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(E){function b(){let C=E.scheme===t.Schemas.file?(0,L.originalFSPath)(E):E.toString();return R.isLinux||(C=C.toLowerCase()),(0,D.createHash)("md5").update(C).digest("hex")}return{id:b(),configPath:E}}e.getWorkspaceIdentifier=T;function P(E,b){function C(){if(E.scheme!==t.Schemas.file)return(0,D.createHash)("md5").update(E.toString()).digest("hex");if(!b)return;let v;return R.isLinux?v=b.ino:R.isMacintosh?v=b.birthtime.getTime():R.isWindows&&(typeof b.birthtimeMs=="number"?v=Math.floor(b.birthtimeMs):v=b.birthtime.getTime()),(0,D.createHash)("md5").update(E.fsPath).update(v?String(v):"").digest("hex")}const p=C();if(typeof p=="string")return{id:p,uri:E}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(ne[274],re([0,1,6,9,2,10,28,13,58,8,59,73,113,273]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let g=class extends R.Disposable{constructor(w,d,m,l){super(),this.environmentService=w,this.logService=d,this.nativeHostService=m,this.mainProcessService=l,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const w=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),d=new C.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(w.map(async m=>{const l=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,m);m.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||m===p.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(o=>o.workspace?.id===m)||await d.isUsed(l)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await T.Promises.rm(l))}))}catch(w){(0,t.onUnexpectedError)(w)}}};g=pe([Y(0,P.INativeEnvironmentService),Y(1,E.ILogService),Y(2,b.INativeHostService),Y(3,I.IMainProcessService)],g),e.UnusedWorkspaceStorageDataCleaner=g}),define(ne[115],re([0,1,54,6,10,15,28,141,283,284]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(o,s){let n=s.message;switch(o){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=o,this.cause=s}}e.ExtractError=b;function C(u){const o=u.externalFileAttributes>>16||33188;return[448,56,7].map(s=>o&s).reduce((s,n)=>s+n,o&61440)}function p(u){if(u instanceof b)return u;let o;return/end of central directory record signature not found/.test(u.message)&&(o="CorruptZip"),new b(o,u)}function v(u,o,s,n,i,r){const c=R.dirname(o),a=R.join(n,c);if(!a.startsWith(n))return Promise.reject(new Error(P.localize(0,null,o)));const h=R.join(n,o);let S;return r.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,$)=>{if(!r.isCancellationRequested)try{S=(0,D.createWriteStream)(h,{mode:s}),S.once("close",()=>A()),S.once("error",$),u.once("error",$),u.pipe(S)}catch(_){$(_)}}))}function g(u,o,s,n){let i=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return n.onCancellationRequested(()=>{i.cancel(),u.close()}),new Promise((c,a)=>{const h=new t.Sequencer,S=A=>{A.isCancellationRequested||(r++,u.readEntry())};u.once("error",a),u.once("close",()=>i.then(()=>{n.isCancellationRequested||u.entryCount===r?c():a(new b("Incomplete",new Error(P.localize(1,null,r,u.entryCount))))},a)),u.readEntry(),u.on("entry",A=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){S(n);return}const $=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test($)){const k=R.join(o,$);i=(0,t.createCancelablePromise)(N=>T.Promises.mkdir(k,{recursive:!0}).then(()=>S(N)).then(void 0,a));return}const _=w(u,A),U=C(A);i=(0,t.createCancelablePromise)(k=>h.queue(()=>_.then(N=>v(N,$,U,o,s,k).then(()=>S(k)))).then(null,a))})})}function y(u,o=!1){return new Promise((s,n)=>{(0,I.open)(u,o?{lazyEntries:!0}:void 0,(i,r)=>{i?n(p(i)):s((0,L.assertIsDefined)(r))})})}function w(u,o){return new Promise((s,n)=>{u.openReadStream(o,(i,r)=>{i?n(p(i)):s((0,L.assertIsDefined)(r))})})}function d(u,o){return new Promise((s,n)=>{const i=new E.ZipFile;o.forEach(c=>{c.contents?i.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&i.addFile(c.localPath,c.path)}),i.end();const r=(0,D.createWriteStream)(u);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>s(u))})}e.zip=d;function m(u,o,s={},n){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=y(u,!0);return s.overwrite&&(r=r.then(c=>T.Promises.rm(o).then(()=>c))),r.then(c=>g(c,o,{sourcePathRegex:i},n))}e.extract=m;function l(u,o){return y(u).then(s=>new Promise((n,i)=>{s.on("entry",r=>{r.fileName===o&&w(s,r).then(c=>n(c),c=>i(c))}),s.once("close",()=>i(new Error(P.localize(2,null,o))))}))}function f(u,o){return l(u,o).then(s=>new Promise((n,i)=>{const r=[];s.once("error",i),s.on("data",c=>r.push(c)),s.on("end",()=>n(Buffer.concat(r)))}))}e.buffer=f}),define(ne[275],re([0,1,115,151]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(L){return(0,D.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=R}),define(ne[116],re([0,1,6,38,9,2,24,10,4,19,55,15,7,30,28,115,150,95,13,251,29,33,50,76,205,252,275,206,238,44,69,14,5,8,25,22,31,20]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u,o,s,n,i,r,c,a,h,S,A,$,_,U,k,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(f.IExtensionManagementService);let q=class extends l.AbstractExtensionManagementService{constructor(B,G,O,M,x,V,ee,oe,Z,ie,se,ue){super(B,G,O,ie,ue),this.extensionsScannerService=x,this.extensionsProfileScannerService=V,this.downloadService=ee,this.fileService=Z,this.installGalleryExtensionsTasks=new Map;const de=this._register(oe.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>de.postUninstall(we))),this.manifestCache=this._register(new c.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(oe.createInstance(n.ExtensionsDownloader));const ve=this._register(new a.ExtensionsWatcher(this,Z,M,O,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Ce=>({identifier:Ce.identifier,operation:1,local:Ce}))),Ee.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const G=await this.collectFiles(B),O=await(0,y.zip)((0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,G);return p.URI.file(O)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:G,cleanup:O}=await this.downloadVsix(B),M=P.resolve(G.fsPath);try{return await(0,r.getManifest)(M)}finally{await O()}}getInstalled(B,G){return this.extensionsScanner.scanExtensions(B??null,G)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(B,G={}){this.logService.trace("ExtensionManagementService#install",B.toString());const{location:O,cleanup:M}=await this.downloadVsix(B);try{const x=await(0,r.getManifest)(P.resolve(O.fsPath));if(x.engines&&x.engines.vscode&&!(0,S.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,(0,u.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return await this.installExtension(x,O,G)}finally{await M()}}getMetadata(B){return this.extensionsScannerService.scanMetadata(B.location)}async updateMetadata(B,G){this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id);const O={...G};return G.isPreReleaseVersion&&(O.preRelease=!0),B=await this.extensionsScanner.updateMetadata(B,O),this.manifestCache.invalidate(),B}async updateExtensionScope(B,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.updateMetadata(B,{isMachineScoped:G}),this.manifestCache.invalidate(),B}removeUninstalledExtensions(B){return this.extensionsScanner.cleanUp(B)}async downloadVsix(B){if(B.scheme===T.Schemas.file)return{location:B,async cleanup(){}};this.logService.trace("Downloading extension from",B.toString());const G=(0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(B,G),this.logService.info("Downloaded extension to",G.toString()),{location:G,cleanup:async()=>{try{await this.fileService.del(G)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(B,G,O){let M;if(p.URI.isUri(G))M=new W(B,G,O,this.galleryService,this.extensionsScanner,this.logService);else{const x=u.ExtensionKey.create(G).toString();M=this.installGalleryExtensionsTasks.get(x),M||(this.installGalleryExtensionsTasks.set(x,M=new H(B,G,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x)))}return O.profileLocation?new z(M,O.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(B,G){return G.profileLocation?new X(B,G.profileLocation,this.extensionsProfileScannerService):new K(B,G,this.extensionsScanner)}async collectFiles(B){const G=async M=>{let x=await g.Promises.readdir(M);x=x.map(oe=>P.join(M,oe));const V=await Promise.all(x.map(oe=>g.Promises.stat(oe)));let ee=Promise.resolve([]);return V.forEach((oe,Z)=>{const ie=x[Z];oe.isFile()&&(ee=ee.then(se=>[...se,ie])),oe.isDirectory()&&(ee=ee.then(se=>G(ie).then(ue=>[...se,...ue])))}),ee};return(await G(B.location.fsPath)).map(M=>({path:`extension/${P.relative(B.location.fsPath,M)}`,localPath:M}))}};q=pe([Y(0,f.IExtensionGalleryService),Y(1,k.ITelemetryService),Y(2,_.ILogService),Y(3,m.INativeEnvironmentService),Y(4,s.IExtensionsScannerService),Y(5,o.IExtensionsProfileScannerService),Y(6,d.IDownloadService),Y(7,$.IInstantiationService),Y(8,A.IFileService),Y(9,U.IProductService),Y(10,N.IUriIdentityService),Y(11,F.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let J=class extends L.Disposable{constructor(B,G,O,M){super(),this.beforeRemovingExtension=B,this.fileService=G,this.extensionsScannerService=O,this.logService=M,this.uninstalledPath=(0,E.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(B){await this.removeUninstalledExtensions(),B&&await this.removeOutdatedExtensions()}async scanExtensions(B,G){const O={includeInvalid:!0,profileLocation:G};let M=[];return B===null||B===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):B===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(O)),M=B!==null?M.filter(x=>x.type===B):M,Promise.all(M.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(B){const G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(G.map(O=>this.toLocalExtension(O)))}async extractUserExtension(B,G,O,M){const x=B.toString(),V=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),ee=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,x);try{await g.Promises.rm(ee)}catch{throw new f.ExtensionManagementError(w.localize(1,null,ee,B.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(B,G,V,M),await this.extensionsScannerService.updateMetadata(p.URI.file(V),O);try{await this.rename(B,V,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(oe){try{await g.Promises.rm(V)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(oe)}. Deleted from extracted location`,V),oe}return this.scanLocalExtension(p.URI.file(ee),1)}async updateMetadata(B,G){return await this.extensionsScannerService.updateMetadata(B.location,G),this.scanLocalExtension(B.location,B.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...B){const G=B.map(O=>u.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{G.forEach(M=>O[M.toString()]=!0)})}async setInstalled(B){await this.withUninstalledExtensions(M=>delete M[B.toString()]);const O=(await this.scanUserExtensions(!0)).find(M=>u.ExtensionKey.create(M).equals(B))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(B,G){this.logService.trace(`Deleting ${G} extension from disk`,B.identifier.id,B.location.fsPath),await g.Promises.rm(B.location.fsPath),this.logService.info("Deleted from disk",B.identifier.id,B.location.fsPath)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.withUninstalledExtensions(G=>delete G[u.ExtensionKey.create(B).toString()])}async withUninstalledExtensions(B){return this.uninstalledFileLimiter.queue(async()=>{let G;try{G=await g.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let O={};if(G)try{O=JSON.parse(G)}catch{}return B&&(B(O),Object.keys(O).length?await g.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await g.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(B,G,O,M){this.logService.trace(`Started extracting the extension from ${G} to ${O}`);try{await g.Promises.rm(O)}catch(x){throw new f.ExtensionManagementError(this.joinErrors(x).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(G,O,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${O}:`,B.id)}catch(x){try{await g.Promises.rm(O)}catch{}let V=f.ExtensionManagementErrorCode.Extract;throw x instanceof y.ExtractError&&(x.type==="CorruptZip"?V=f.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(V=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(x.message,V)}}async rename(B,G,O,M){try{await g.Promises.rename(G,O)}catch(x){if(I.isWindows&&x&&x.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${G} to ${O} with 'EPERM' error. Trying again...`,B.id),this.rename(B,G,O,M);throw new f.ExtensionManagementError(x.message||w.localize(2,null,G,O),x.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(B,G){const O=await this.extensionsScannerService.scanExistingExtension(B,G,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(w.localize(3,null,B.path))}async toLocalExtension(B){const G=await this.fileService.resolve(B.location);let O,M;return G.children&&(O=G.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,M=G.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:O,changelogUrl:M,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated}}async removeUninstalledExtensions(){const B=await this.getUninstalledExtensions(),G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const V of G)B[u.ExtensionKey.create(V).toString()]||O.add(V.identifier.id.toLowerCase());const M=(0,u.groupByExtension)(G,V=>V.identifier);await D.Promises.settled(M.map(async V=>{const ee=V.sort((oe,Z)=>b.rcompare(oe.manifest.version,Z.manifest.version))[0];O.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}));const x=G.filter(V=>B[u.ExtensionKey.create(V).toString()]);await D.Promises.settled(x.map(V=>this.removeUninstalledExtension(V)))}async removeOutdatedExtensions(){const B=await this.extensionsScannerService.scanSystemExtensions({}),G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],M=await this.extensionsScannerService.getTargetPlatform(),x=(0,u.groupByExtension)(G,V=>V.identifier);for(const V of x)if(V.length>1&&O.push(...V.sort((ee,oe)=>{const Z=b.rcompare(ee.manifest.version,oe.manifest.version);return Z!==0?Z:ee.targetPlatform===M?-1:1}).slice(1)),V[0].type===0){const ee=B.find(oe=>(0,u.areSameExtensions)(oe.identifier,V[0].identifier));(!ee||b.gte(ee.manifest.version,V[0].manifest.version))&&O.push(V[0])}await D.Promises.settled(O.map(V=>this.removeExtension(V,"outdated")))}joinErrors(B){const G=Array.isArray(B)?B:[B];return G.length===1?G[0]instanceof Error?G[0]:new Error(G[0]):G.reduce((O,M)=>new Error(`${O.message}${O.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};J=pe([Y(1,A.IFileService),Y(2,s.IExtensionsScannerService),Y(3,_.ILogService)],J);class j extends l.AbstractExtensionTask{get operation(){return(0,C.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(B,G,O,M,x){super(),this.identifier=B,this.source=G,this.options=O,this.extensionsScanner=M,this.logService=x,this._operation=2}async installExtension(B,G){try{const O=await this.unsetUninstalledAndGetLocal(B.key);if(O)return this.extensionsScanner.updateMetadata(O,B.metadata)}catch{throw I.isMacintosh?new f.ExtensionManagementError(w.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(w.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(B,G)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const O=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),O}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.toString()]}async extract({zipPath:B,key:G,metadata:O},M){const x=await this.extensionsScanner.extractUserExtension(G,B,O,M);return this.logService.info("Extracting completed.",G.id),x}}class H extends j{constructor(B,G,O,M,x,V){super(G.identifier,G,O,x,V),this.manifest=B,this.gallery=G,this.extensionsDownloader=M}async doRun(B){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(V=>(0,u.areSameExtensions)(V.identifier,this.gallery.identifier));O&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,h.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,M),metadata:M};const x=await this.downloadExtension(this.gallery,this._operation);try{const V=await this.installExtension({zipPath:x,key:u.ExtensionKey.create(this.gallery),metadata:M},B);return O&&!this.options.profileLocation&&(O.targetPlatform!==V.targetPlatform||b.neq(O.manifest.version,V.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:V,metadata:M}}catch(V){throw await this.deleteDownloadedVSIX(x),V}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(p.URI.file(B))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,R.getErrorMessage)(G))}}async downloadExtension(B,G){let O;try{this.logService.trace("Started downloading extension:",B.identifier.id),O=(await this.extensionsDownloader.downloadExtension(B,G)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,O)}catch(M){throw new f.ExtensionManagementError((0,l.joinErrors)(M).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,r.getManifest)(O),O}catch(M){throw await this.deleteDownloadedVSIX(O),new f.ExtensionManagementError((0,l.joinErrors)(M).message,f.ExtensionManagementErrorCode.Invalid)}}}class W extends j{constructor(B,G,O,M,x,V){super({id:(0,u.getGalleryExtensionId)(B.publisher,B.name)},G,O,x,V),this.manifest=B,this.location=G,this.galleryService=M}async doRun(B){const G=new u.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ee=>(0,u.areSameExtensions)(this.identifier,ee.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(x.isApplicationScoped=(0,h.isApplicationScopedExtension)(this.manifest),x.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||M?.isBuiltin,x.installedTimestamp=Date.now(),M)if(this._operation=3,G.equals(new u.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&b.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const ee=await this.unsetUninstalledAndGetLocal(G);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:G,metadata:x},B),metadata:x}}async getMetadata(B,G,O){try{let[M]=await this.galleryService.getExtensions([{id:B,version:G}],O);if(M||([M]=await this.galleryService.getExtensions([{id:B}],O)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class z{constructor(B,G,O){this.task=B,this.profileLocation=G,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const B=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[B.local,B.metadata]],this.profileLocation),B}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class K extends l.AbstractExtensionTask{constructor(B,G,O){super(),this.extension=B,this.options=G,this.extensionsScanner=O}async doRun(B){const G=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=u.ExtensionKey.create(this.extension);G.push(...O.filter(x=>M.equals(u.ExtensionKey.create(x))))}else G.push(...O.filter(M=>(0,u.areSameExtensions)(M.identifier,this.extension.identifier)));if(!G.length)throw new Error(w.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const M of G)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(x){throw new Error(w.localize(9,null,(0,t.toErrorMessage)(x)))}}}class X extends l.AbstractExtensionTask{constructor(B,G,O){super(),this.extension=B,this.profileLocation=G,this.extensionsProfileScannerService=O}async doRun(B){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[276],re([0,1,2,29,33,50,77,204,116,44,5,8,21,31,20]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const y={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let w=class extends D.Disposable{constructor(l,f,u,o,s,n,i,r){super(),this.userDataProfilesService=f,l.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(l,u,o,s,r),T.ExtensionStorageService.removeOutdatedExtensionVersions(l,i),this._register(n.createInstance(d))}};w=pe([Y(0,I.INativeServerExtensionManagementService),Y(1,g.IUserDataProfilesService),Y(2,t.IExtensionGalleryService),Y(3,T.IExtensionStorageService),Y(4,t.IGlobalExtensionEnablementService),Y(5,b.IInstantiationService),Y(6,p.IStorageService),Y(7,C.ILogService)],w),e.ExtensionsCleaner=w;let d=class extends D.Disposable{constructor(l,f,u,o,s){super(),this.extensionManagementService=l,this.userDataProfilesService=f,this.extensionsProfileScannerService=u,this.uriIdentityService=o,this.logService=s,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:l,removed:f,all:u}){try{await Promise.all(f.map(o=>o.extensionsResource?this.removeExtensionsFromProfile(o.extensionsResource):Promise.resolve()))}catch(o){this.logService.error(o)}if(u.length===1){this.profileModeDisposables.clear();const o=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{o.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{l.length&&(await Promise.all(l.map(o=>o.extensionsResource?this.populateExtensionsFromProfile(o.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(o=>this.onDidChangeProfiles(o))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(o=>this.onDidInstallExtensions(o))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(o=>this.onDidUninstallExtension(o))),await this.uninstallExtensionsNotInProfiles()))}catch(o){this.logService.error(o)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(u=>u.installedTimestamp&&!this.profileExtensionsLocations.has(this.getKey(u.identifier,u.manifest.version)));f.length&&await Promise.all(f.map(u=>this.extensionManagementService.uninstall(u,y)))}async onDidInstallExtensions(l){for(const{local:f,profileLocation:u}of l)!f||!u||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),u)}async onDidUninstallExtension(l){!l.profileLocation||!l.version||this.removeExtensionWithKey(this.getKey(l.identifier,l.version),l.profileLocation)&&await this.uninstallExtensions([{identifier:l.identifier,version:l.version}])}async populateExtensionsFromProfile(l){const f=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const u of f)this.addExtensionWithKey(this.getKey(u.identifier,u.version),l)}async removeExtensionsFromProfile(l){const f=[];for(const u of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(u,l))continue;const o=this.fromKey(u);o&&f.push(o)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(l,f){let u=this.profileExtensionsLocations.get(l);u||(u=[],this.profileExtensionsLocations.set(l,u)),u.push(f)}removeExtensionWithKey(l,f){const u=this.profileExtensionsLocations.get(l);if(u){const o=u.findIndex(s=>this.uriIdentityService.extUri.isEqual(s,f));o>-1&&u.splice(o,1)}return u?.length?!1:(this.profileExtensionsLocations.delete(l),!0)}async uninstallExtensions(l){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(o=>o.installedTimestamp&&l.some(s=>this.getKey(o.identifier,o.manifest.version)===this.getKey(s.identifier,s.version)));u.length&&await Promise.all(u.map(o=>this.extensionManagementService.uninstall(o,y)))}getKey(l,f){return`${E.ExtensionIdentifier.toKey(l.id)}@${f}`}fromKey(l){const[f,u]=(0,R.getIdAndVersion)(l);return u?{identifier:{id:f},version:u}:void 0}};d=pe([Y(0,I.INativeServerExtensionManagementService),Y(1,g.IUserDataProfilesService),Y(2,L.IExtensionsProfileScannerService),Y(3,v.IUriIdentityService),Y(4,C.ILogService)],d)}),define(ne[285],re([0,1,91,36,38,9,2,24,19,7,39,139,197,276,198,190,191,274,179,182,17,202,94,222,95,213,13,219,114,254,29,181,255,116,96,177,14,193,195,56,5,188,70,189,58,71,207,8,100,59,101,25,45,21,256,106,22,107,108,109,51,227,110,229,235,77,112,26,75,263,247,248,78,264,268,269,270,271,272,62,249,105,221,74,237,209,236,104,218,31,239,4,240,183,200,199,76,253,20,50,196,60,257,216,226,250,223,211,99]),function(Q,e,D,t,R,L,T,P,I,E,b,C,p,v,g,y,w,d,m,l,f,u,o,s,n,i,r,c,a,h,S,A,$,_,U,k,N,F,q,J,j,H,W,z,K,X,ce,B,G,O,M,x,V,ee,oe,Z,ie,se,ue,de,ve,we,Ee,Ce,Ue,$e,He,We,ae,fe,ge,be,Ie,Le,Re,Ne,Ae,Me,ze,ke,_e,te,le,he,me,Se,Pe,De,Be,Fe,Te,qe,xe,Ze,st,yt,Tt,At,wt,Et,_t,bt,Ot,Ut,Mt,Nt,Ft,Ct,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class $t extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,this.registerListeners()}registerListeners(){const ye=async()=>{this.lifecycleService&&(await this.lifecycleService.fireOnWillShutdown(),this.lifecycleService.dispose(),this.lifecycleService=void 0),this.dispose()};process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(Ge,et)=>{this.onDisposeWorker(et)};D.ipcRenderer.on(Oe,je),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(B.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(g.LanguagePackCachedDataCleaner),ye.createInstance(d.UnusedWorkspaceStorageDataCleaner),ye.createInstance(w.LogsDataCleaner),ye.createInstance(y.LocalizationsUpdater),ye.createInstance(v.ExtensionsCleaner),ye.createInstance(Nt.UserDataProfilesCleaner)))}async initServices(){const ye=new W.ServiceCollection,Oe={_serviceBrand:void 0,...M.default};ye.set(x.IProductService,Oe);const je=new b.StaticRouter(Je=>Je==="main"),Ge=new z.MessagePortMainProcessService(this.server,je);ye.set(K.IMainProcessService,Ge);const et=this.configuration.policiesData?new _t.PolicyChannelClient(this.configuration.policiesData,Ge.getChannel("policy")):new bt.NullPolicyService;ye.set(bt.IPolicyService,et);const Ve=new c.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(r.INativeEnvironmentService,Ve);const ct=new G.LogLevelChannelClient(this.server.getChannel("logLevel",je)),tt=new G.LoggerChannelClient(this.configuration.logLevel,ct.onDidChangeLogLevel,Ge.getChannel("logger"));ye.set(B.ILoggerService,tt);const ut=this._register(new B.MultiplexLogService([this._register(new B.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,I.joinPath)(E.URI.file(Ve.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new G.FollowerLogService(ct,ut));ye.set(B.ILogService,Ke),this.lifecycleService=new Pt.SharedProcessLifecycleService(Ke),ye.set(Pt.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new Be.SharedProcessWorkerService(Ke),ye.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new F.FileService(Ke));ye.set(N.IFileService,Qe);const ht=this._register(new q.DiskFileSystemProvider(Ke));Qe.registerProvider(P.Schemas.file,ht);const dt=this._register(new xe.FileUserDataProvider(P.Schemas.file,this._register(new Ze.DiskFileSystemProviderClient(Ge.getChannel(Ze.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,Ke));Qe.registerProvider(P.Schemas.vscodeUserData,dt);const it=this._register(new Ot.UserDataProfilesNativeService(this.configuration.profiles,Ge,Ve));ye.set(wt.IUserDataProfilesService,it);const Ye=this._register(new u.ConfigurationService(it.defaultProfile.settingsResource,Qe,et,Ke));ye.set(f.IConfigurationService,Ye);const ot=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},Ge,Ve);ye.set(ee.IStorageService,ot),this._register((0,T.toDisposable)(()=>ot.flush())),await Promise.all([Ye.initialize(),ot.initialize()]),ye.set(Fe.IUriIdentityService,new Te.UriIdentityService(Qe)),ye.set(V.IRequestService,new Ut.SharedProcessRequestService(Ge,Ye,Ke)),ye.set(m.IChecksumService,new J.SyncDescriptor(l.ChecksumService,void 0,!1)),ye.set(yt.IV8InspectProfilingService,new J.SyncDescriptor(st.InspectProfilingService,void 0,!1));const lt=b.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(O.INativeHostService,lt),ye.set(n.IDownloadService,new J.SyncDescriptor(i.DownloadService,void 0,!0));const ft=this._register(new _e.ActiveWindowManager(lt)),gt=new b.StaticRouter(Je=>ft.getActiveClientId().then(mt=>Je===mt));ye.set(U.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",gt)));let nt;const at=[],Dt=(0,ve.isInternalTelemetry)(Oe,Ye);if((0,ve.supportsTelemetry)(Oe,Ve)){const Je=new ue.TelemetryLogAppender(tt,Ve);at.push(Je);const{installSourcePath:mt}=Ve;if(Oe.aiConfig?.ariaKey){const kt=new Mt.OneDataSystemAppender(Dt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>kt.flush())),at.push(kt)}nt=new de.TelemetryService({appenders:at,commonProperties:(0,Z.resolveCommonProperties)(Qe,(0,t.release)(),(0,t.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Dt,mt),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Ve)},Ye,Oe)}else{nt=ve.NullTelemetryService;const Je=ve.NullAppender;at.push(Je)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(at)),ye.set(ie.ITelemetryService,nt);const zt=new we.CustomEndpointTelemetryService(Ye,nt,tt,Ve,Oe);ye.set(ie.ICustomEndpointTelemetryService,zt),ye.set(Et.IExtensionsProfileScannerService,new J.SyncDescriptor(Et.ExtensionsProfileScannerService,void 0,!0)),ye.set(Tt.IExtensionsScannerService,new J.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),ye.set(_.INativeServerExtensionManagementService,new J.SyncDescriptor(_.ExtensionManagementService,void 0,!0)),ye.set(S.IExtensionGalleryService,new J.SyncDescriptor(h.ExtensionGalleryService,void 0,!0)),ye.set(S.IExtensionTipsService,new J.SyncDescriptor($.ExtensionTipsService,void 0,!1)),ye.set(X.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(o.IDiagnosticsService,new J.SyncDescriptor(s.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(be.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),ye.set(S.IGlobalExtensionEnablementService,new J.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),ye.set(He.IIgnoredExtensionsManagementService,new J.SyncDescriptor(He.IgnoredExtensionsManagementService,void 0,!0)),ye.set($e.IExtensionStorageService,new J.SyncDescriptor($e.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Le.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(Re.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new J.SyncDescriptor(ze.UserDataSyncProfilesStorageService,void 0,!0));const Rt=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},Ye,Ve,Ke);return Rt.initialize(),ye.set(Ce.ILocalPtyService,this._register(Rt)),ye.set(te.ISignService,new J.SyncDescriptor(le.SignService,void 0,!1)),ye.set(he.ISharedTunnelsService,new J.SyncDescriptor(me.SharedTunnelsService)),ye.set(Se.ISharedProcessTunnelService,new J.SyncDescriptor(Pe.SharedProcessTunnelService)),ye.set(Ct.IRemoteTunnelService,new J.SyncDescriptor(Ft.RemoteTunnelService)),new H.InstantiationService(ye)}initChannels(ye){const Oe=new G.LogLevelChannel(ye.get(B.ILogService),ye.get(B.ILoggerService));this.server.registerChannel("logLevel",Oe);const je=new A.ExtensionManagementChannel(ye.get(S.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",je);const Ge=b.ProxyChannel.fromService(ye.get(X.ILanguagePackService));this.server.registerChannel("languagePacks",Ge);const et=b.ProxyChannel.fromService(ye.get(o.IDiagnosticsService));this.server.registerChannel("diagnostics",et);const Ve=new A.ExtensionTipsChannel(ye.get(S.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ve);const ct=b.ProxyChannel.fromService(ye.get(m.IChecksumService));this.server.registerChannel("checksum",ct);const tt=b.ProxyChannel.fromService(ye.get(yt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",tt);const ut=new ge.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ut);const Ke=b.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ke);const Qe=new ge.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Qe);const ht=new ge.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ht);const dt=new Ne.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(wt.IUserDataProfilesService),ye.get(B.ILogService));this.server.registerChannel("userDataSync",dt);const it=this._register(ye.get(j.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),Ye=new ge.UserDataAutoSyncChannel(it);this.server.registerChannel("userDataAutoSync",Ye);const ot=ye.get(Ce.ILocalPtyService),lt=b.ProxyChannel.fromService(ot);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,lt);const ft=b.ProxyChannel.fromService(ye.get(Se.ISharedProcessTunnelService));this.server.registerChannel(Se.ipcSharedProcessTunnelChannelName,ft);const gt=b.ProxyChannel.fromService(ye.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,gt);const nt=b.ProxyChannel.fromService(ye.get(Ct.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",nt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,R.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Wt(It){const ye=new $t(It);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Wt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6455bf1608dfa1b955717f66295f0f9200db0f73/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
