/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingModel","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(z){for(var e=[],y=0,t=z.length;y<t;y++)e[y]=ee[z[y]];return e};define(ee[118],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function y(D){return D?D.replace(/\$\((.*?)\)/g,(I,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=y;class t{constructor(I,u,w){this.id=I,this.definition=u,this.description=w,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,I){const u=["codicon","codicon-"+D];return I&&u.push("codicon-modifier-"+I),u}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(C){if(C instanceof t)return["codicon","codicon-"+C.id];const E=I.exec(C.id);if(!E)return u(t.error);const[,d,f]=E,P=["codicon","codicon-"+d];return f&&P.push("codicon-modifier-"+f.substr(1)),P}D.asClassNameArray=u;function w(C){return u(C).join(" ")}D.asClassName=w;function v(C){return"."+u(C).join(".")}D.asCSSSelector=v})(R=e.CSSIcon||(e.CSSIcon={}))}),define(ee[119],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function y(I,u){const w=Math.pow(10,u);return Math.round(I*w)/w}class t{constructor(u,w,v,C=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=y(Math.max(Math.min(1,C),0),3)}static equals(u,w){return u.r===w.r&&u.g===w.g&&u.b===w.b&&u.a===w.a}}e.RGBA=t;class k{constructor(u,w,v,C){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=y(Math.max(Math.min(1,w),0),3),this.l=y(Math.max(Math.min(1,v),0),3),this.a=y(Math.max(Math.min(1,C),0),3)}static equals(u,w){return u.h===w.h&&u.s===w.s&&u.l===w.l&&u.a===w.a}static fromRGBA(u){const w=u.r/255,v=u.g/255,C=u.b/255,E=u.a,d=Math.max(w,v,C),f=Math.min(w,v,C);let P=0,b=0;const p=(f+d)/2,S=d-f;if(S>0){switch(b=Math.min(p<=.5?S/(2*p):S/(2-2*p),1),d){case w:P=(v-C)/S+(v<C?6:0);break;case v:P=(C-w)/S+2;break;case C:P=(w-v)/S+4;break}P*=60,P=Math.round(P)}return new k(P,b,p,E)}static _hue2rgb(u,w,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?u+(w-u)*6*v:v<1/2?w:v<2/3?u+(w-u)*(2/3-v)*6:u}static toRGBA(u){const w=u.h/360,{s:v,l:C,a:E}=u;let d,f,P;if(v===0)d=f=P=C;else{const b=C<.5?C*(1+v):C+v-C*v,p=2*C-b;d=k._hue2rgb(p,b,w+1/3),f=k._hue2rgb(p,b,w),P=k._hue2rgb(p,b,w-1/3)}return new t(Math.round(d*255),Math.round(f*255),Math.round(P*255),E)}}e.HSLA=k;class R{constructor(u,w,v,C){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=y(Math.max(Math.min(1,w),0),3),this.v=y(Math.max(Math.min(1,v),0),3),this.a=y(Math.max(Math.min(1,C),0),3)}static equals(u,w){return u.h===w.h&&u.s===w.s&&u.v===w.v&&u.a===w.a}static fromRGBA(u){const w=u.r/255,v=u.g/255,C=u.b/255,E=Math.max(w,v,C),d=Math.min(w,v,C),f=E-d,P=E===0?0:f/E;let b;return f===0?b=0:E===w?b=((v-C)/f%6+6)%6:E===v?b=(C-w)/f+2:b=(w-v)/f+4,new R(Math.round(b*60),P,E,u.a)}static toRGBA(u){const{h:w,s:v,v:C,a:E}=u,d=C*v,f=d*(1-Math.abs(w/60%2-1)),P=C-d;let[b,p,S]=[0,0,0];return w<60?(b=d,p=f):w<120?(b=f,p=d):w<180?(p=d,S=f):w<240?(p=f,S=d):w<300?(b=f,S=d):w<=360&&(b=d,S=f),b=Math.round((b+P)*255),p=Math.round((p+P)*255),S=Math.round((S+P)*255),new t(b,p,S,E)}}e.HSVA=R;class D{static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}static equals(u,w){return!u&&!w?!0:!u||!w?!1:u.equals(w)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof t)this.rgba=u;else if(u instanceof k)this._hsla=u,this.rgba=k.toRGBA(u);else if(u instanceof R)this._hsva=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&t.equals(this.rgba,u.rgba)&&k.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D._relativeLuminanceForComponent(this.rgba.r),w=D._relativeLuminanceForComponent(this.rgba.g),v=D._relativeLuminanceForComponent(this.rgba.b),C=.2126*u+.7152*w+.0722*v;return y(C,4)}static _relativeLuminanceForComponent(u){const w=u/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(u){const w=this.getRelativeLuminance(),v=u.getRelativeLuminance();return w>v?(w+.05)/(v+.05):(v+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const w=this.getRelativeLuminance(),v=u.getRelativeLuminance();return w>v}isDarkerThan(u){const w=this.getRelativeLuminance(),v=u.getRelativeLuminance();return w<v}lighten(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:w,g:v,b:C,a:E}=this.rgba;return new D(new t(w,v,C,E*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const w=u.rgba,v=this.rgba.a,C=w.a,E=v+C*(1-v);if(E<1e-6)return D.transparent;const d=this.rgba.r*v/E+w.r*C*(1-v)/E,f=this.rgba.g*v/E+w.g*C*(1-v)/E,P=this.rgba.b*v/E+w.b*C*(1-v)/E;return new D(new t(d,f,P,E))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:w,g:v,b:C,a:E}=this.rgba;return new D(new t(u.rgba.r-E*(u.rgba.r-w),u.rgba.g-E*(u.rgba.g-v),u.rgba.b-E*(u.rgba.b-C),1))}flatten(...u){const w=u.reduceRight((v,C)=>D._flatten(C,v));return D._flatten(this,w)}static _flatten(u,w){const v=1-u.rgba.a;return new D(new t(v*w.rgba.r+u.rgba.a*u.rgba.r,v*w.rgba.g+u.rgba.a*u.rgba.g,v*w.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(u,w,v){if(u.isLighterThan(w))return u;v=v||.5;const C=u.getRelativeLuminance(),E=w.getRelativeLuminance();return v=v*(E-C)/E,u.lighten(v)}static getDarkerColor(u,w,v){if(u.isDarkerThan(w))return u;v=v||.5;const C=u.getRelativeLuminance(),E=w.getRelativeLuminance();return v=v*(C-E)/C,u.darken(v)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(I){let u;(function(w){let v;(function(C){function E(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:I.Format.CSS.formatRGBA(s)}C.formatRGB=E;function d(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}C.formatRGBA=d;function f(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(s)}C.formatHSL=f;function P(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}C.formatHSLA=P;function b(s){const a=s.toString(16);return a.length!==2?"0"+a:a}function p(s){return`#${b(s.rgba.r)}${b(s.rgba.g)}${b(s.rgba.b)}`}C.formatHex=p;function S(s,a=!1){return a&&s.rgba.a===1?I.Format.CSS.formatHex(s):`#${b(s.rgba.r)}${b(s.rgba.g)}${b(s.rgba.b)}${b(Math.round(s.rgba.a*255))}`}C.formatHexA=S;function m(s){return s.isOpaque()?I.Format.CSS.formatHex(s):I.Format.CSS.formatRGBA(s)}C.format=m;function h(s){const a=s.length;if(a===0||s.charCodeAt(0)!==35)return null;if(a===7){const n=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),i=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),r=16*l(s.charCodeAt(5))+l(s.charCodeAt(6));return new I(new t(n,i,r,1))}if(a===9){const n=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),i=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),r=16*l(s.charCodeAt(5))+l(s.charCodeAt(6)),c=16*l(s.charCodeAt(7))+l(s.charCodeAt(8));return new I(new t(n,i,r,c/255))}if(a===4){const n=l(s.charCodeAt(1)),i=l(s.charCodeAt(2)),r=l(s.charCodeAt(3));return new I(new t(16*n+n,16*i+i,16*r+r))}if(a===5){const n=l(s.charCodeAt(1)),i=l(s.charCodeAt(2)),r=l(s.charCodeAt(3)),c=l(s.charCodeAt(4));return new I(new t(16*n+n,16*i+i,16*r+r,(16*c+c)/255))}return null}C.parseHex=h;function l(s){switch(s){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=w.CSS||(w.CSS={}))})(u=I.Format||(I.Format={}))}(D=e.Color||(e.Color={}))}),define(ee[53],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(D){return(I,u,w)=>{let v=null,C=null;if(typeof w.value=="function"?(v="value",C=w.value):typeof w.get=="function"&&(v="get",C=w.get),!C)throw new Error("not supported");w[v]=D(C,u)}}e.createDecorator=y;function t(D,I,u){let w=null,v=null;if(typeof u.value=="function"?(w="value",v=u.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(w="get",v=u.get),!v)throw new Error("not supported");const C=`$memoize$${I}`;u[w]=function(...E){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,E)}),this[C]}}e.memoize=t;function k(D,I,u){return y((w,v)=>{const C=`$debounce$${v}`,E=`$debounce$result$${v}`;return function(...d){this[E]||(this[E]=u?u():void 0),clearTimeout(this[C]),I&&(this[E]=I(this[E],...d),d=[this[E]]),this[C]=setTimeout(()=>{w.apply(this,d),this[E]=u?u():void 0},D)}})}e.debounce=k;function R(D,I,u){return y((w,v)=>{const C=`$throttle$timer$${v}`,E=`$throttle$result$${v}`,d=`$throttle$lastRun$${v}`,f=`$throttle$pending$${v}`;return function(...P){if(this[E]||(this[E]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[E]=I(this[E],...P)),this[f])return;const b=this[d]+D;b<=Date.now()?(this[d]=Date.now(),w.apply(this,[this[E]]),this[E]=u?u():void 0):(this[f]=!0,this[C]=setTimeout(()=>{this[f]=!1,this[d]=Date.now(),w.apply(this,[this[E]]),this[E]=u?u():void 0},b-Date.now()))}})}e.throttle=R}),define(ee[16],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(a=>{a(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=y,e.errorHandler=new y;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function k(l){u(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function R(l){u(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function D(l){if(l instanceof Error){const{name:s,message:a}=l,n=l.stacktrace||l.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:m.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=D;const I="Canceled";function u(l){return l instanceof w?!0:l instanceof Error&&l.name===I&&l.message===I}e.isCancellationError=u;class w extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=w;function v(){const l=new Error(I);return l.name=l.message,l}e.canceled=v;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function E(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=E;function d(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function f(l){const s=new Error(`${l} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function P(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=P;class b extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=b;class p extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=p;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const a=new m;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class h extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(ee[24],ie([0,1,16]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(H,re=0){return H[H.length-(1+re)]}e.tail=t;function k(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=k;function R(H,re,ne=(ce,ge)=>ce===ge){if(H===re)return!0;if(!H||!re||H.length!==re.length)return!1;for(let ce=0,ge=H.length;ce<ge;ce++)if(!ne(H[ce],re[ce]))return!1;return!0}e.equals=R;function D(H,re){const ne=H.length-1;re<ne&&(H[re]=H[ne]),H.pop()}e.removeFastWithoutKeepingOrder=D;function I(H,re,ne){return u(H.length,ce=>ne(H[ce],re))}e.binarySearch=I;function u(H,re){let ne=0,ce=H-1;for(;ne<=ce;){const ge=(ne+ce)/2|0,Re=re(ge);if(Re<0)ne=ge+1;else if(Re>0)ce=ge-1;else return ge}return-(ne+1)}e.binarySearch2=u;function w(H,re){let ne=0,ce=H.length;if(ce===0)return 0;for(;ne<ce;){const ge=Math.floor((ne+ce)/2);re(H[ge])?ce=ge:ne=ge+1}return ne}e.findFirstInSorted=w;function v(H,re,ne){if(H=H|0,H>=re.length)throw new TypeError("invalid index");const ce=re[Math.floor(re.length*Math.random())],ge=[],Re=[],Te=[];for(const Me of re){const Ae=ne(Me,ce);Ae<0?ge.push(Me):Ae>0?Re.push(Me):Te.push(Me)}return H<ge.length?v(H,ge,ne):H<ge.length+Te.length?Te[0]:v(H-(ge.length+Te.length),Re,ne)}e.quickSelect=v;function C(H,re){const ne=[];let ce;for(const ge of H.slice(0).sort(re))!ce||re(ce[0],ge)!==0?(ce=[ge],ne.push(ce)):ce.push(ge);return ne}e.groupBy=C;function E(H,re,ne){const ce=[];function ge(Me,Ae,ve){if(Ae===0&&ve.length===0)return;const pe=ce[ce.length-1];pe&&pe.start+pe.deleteCount===Me?(pe.deleteCount+=Ae,pe.toInsert.push(...ve)):ce.push({start:Me,deleteCount:Ae,toInsert:ve})}let Re=0,Te=0;for(;;){if(Re===H.length){ge(Re,0,re.slice(Te));break}if(Te===re.length){ge(Re,H.length-Re,[]);break}const Me=H[Re],Ae=re[Te],ve=ne(Me,Ae);ve===0?(Re+=1,Te+=1):ve<0?(ge(Re,1,[]),Re+=1):ve>0&&(ge(Re,0,[Ae]),Te+=1)}return ce}e.sortedDiff=E;function d(H,re,ne){const ce=E(H,re,ne),ge=[],Re=[];for(const Te of ce)ge.push(...H.slice(Te.start,Te.start+Te.deleteCount)),Re.push(...Te.toInsert);return{removed:ge,added:Re}}e.delta=d;function f(H,re,ne){if(ne===0)return[];const ce=H.slice(0,ne).sort(re);return b(H,re,ce,ne,H.length),ce}e.top=f;function P(H,re,ne,ce,ge){return ne===0?Promise.resolve([]):new Promise((Re,Te)=>{(async()=>{const Me=H.length,Ae=H.slice(0,ne).sort(re);for(let ve=ne,pe=Math.min(ne+ce,Me);ve<Me;ve=pe,pe=Math.min(pe+ce,Me)){if(ve>ne&&await new Promise(Se=>setTimeout(Se)),ge&&ge.isCancellationRequested)throw new y.CancellationError;b(H,re,Ae,ve,pe)}return Ae})().then(Re,Te)})}e.topAsync=P;function b(H,re,ne,ce,ge){for(const Re=ne.length;ce<ge;ce++){const Te=H[ce];if(re(Te,ne[Re-1])<0){ne.pop();const Me=w(ne,Ae=>re(Te,Ae)<0);ne.splice(Me,0,Te)}}}function p(H){return H.filter(re=>!!re)}e.coalesce=p;function S(H){let re=0;for(let ne=0;ne<H.length;ne++)H[ne]&&(H[re]=H[ne],re+=1);H.length=re}e.coalesceInPlace=S;function m(H,re,ne){H.splice(ne,0,H.splice(re,1)[0])}e.move=m;function h(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=h;function l(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=l;function s(H,re=ne=>ne){const ne=new Set;return H.filter(ce=>{const ge=re(ce);return ne.has(ge)?!1:(ne.add(ge),!0)})}e.distinct=s;function a(H){const re=new Set;return ne=>{const ce=H(ne);return re.has(ce)?!1:(re.add(ce),!0)}}e.uniqueFilter=a;function n(H,re){const ne=i(H,re);if(ne!==-1)return H[ne]}e.findLast=n;function i(H,re){for(let ne=H.length-1;ne>=0;ne--){const ce=H[ne];if(re(ce))return ne}return-1}e.lastIndex=i;function r(H,re){return H.length>0?H[0]:re}e.firstOrDefault=r;function c(H,re){return H.length>0?H[H.length-1]:re}e.lastOrDefault=c;function o(H,re,ne=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,Re=Math.min(H.length,re.length);ge<Re&&ne(H[ge],re[ge]);ge++)ce++;return ce}e.commonPrefixLength=o;function g(H){return[].concat(...H)}e.flatten=g;function M(H,re){let ne=typeof re=="number"?H:0;typeof re=="number"?ne=H:(ne=0,re=H);const ce=[];if(ne<=re)for(let ge=ne;ge<re;ge++)ce.push(ge);else for(let ge=ne;ge>re;ge--)ce.push(ge);return ce}e.range=M;function A(H,re,ne){return H.reduce((ce,ge)=>(ce[re(ge)]=ne?ne(ge):ge,ce),Object.create(null))}e.index=A;function _(H,re){return H.push(re),()=>G(H,re)}e.insert=_;function G(H,re){const ne=H.indexOf(re);if(ne>-1)return H.splice(ne,1),re}e.remove=G;function ae(H,re,ne){const ce=H.slice(0,re),ge=H.slice(re);return ce.concat(ne,ge)}e.arrayInsert=ae;function Q(H,re){let ne;if(typeof re=="number"){let ce=re;ne=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else ne=Math.random;for(let ce=H.length-1;ce>0;ce-=1){const ge=Math.floor(ne()*(ce+1)),Re=H[ce];H[ce]=H[ge],H[ge]=Re}}e.shuffle=Q;function X(H,re){const ne=H.indexOf(re);ne>-1&&(H.splice(ne,1),H.unshift(re))}e.pushToStart=X;function x(H,re){const ne=H.indexOf(re);ne>-1&&(H.splice(ne,1),H.push(re))}e.pushToEnd=x;function oe(H,re){for(const ne of re)H.push(ne)}e.pushMany=oe;function fe(H,re){return Array.isArray(H)?H.map(re):re(H)}e.mapArrayOrNot=fe;function V(H){return Array.isArray(H)?H:[H]}e.asArray=V;function j(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=j;function F(H,re){for(const ne of H){const ce=re(ne);if(ce!==void 0)return ce}}e.mapFind=F;function T(H,re,ne){const ce=N(H,re),ge=H.length,Re=ne.length;H.length=ge+Re;for(let Te=ge-1;Te>=ce;Te--)H[Te+Re]=H[Te];for(let Te=0;Te<Re;Te++)H[Te+ce]=ne[Te]}e.insertInto=T;function W(H,re,ne,ce){const ge=N(H,re),Re=H.splice(ge,ne);return T(H,ge,ce),Re}e.splice=W;function N(H,re){return re<0?Math.max(re+H.length,0):Math.min(re,H.length)}var J;(function(H){function re(ge){return ge<0}H.isLessThan=re;function ne(ge){return ge>0}H.isGreaterThan=ne;function ce(ge){return ge===0}H.isNeitherLessOrGreaterThan=ce,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function B(H,re){return(ne,ce)=>re(H(ne),H(ce))}e.compareBy=B;function $(...H){return(re,ne)=>{for(const ce of H){const ge=ce(re,ne);if(!J.isNeitherLessOrGreaterThan(ge))return ge}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const L=(H,re)=>H-re;e.numberComparator=L;function O(H,re){if(H.length===0)return;let ne=H[0];for(let ce=1;ce<H.length;ce++){const ge=H[ce];re(ge,ne)>0&&(ne=ge)}return ne}e.findMaxBy=O;function U(H,re){if(H.length===0)return;let ne=H[0];for(let ce=1;ce<H.length;ce++){const ge=H[ce];re(ge,ne)>=0&&(ne=ge)}return ne}e.findLastMaxBy=U;function q(H,re){return O(H,(ne,ce)=>-re(ne,ce))}e.findMinBy=q;class Y{constructor(re){this.items=re,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(re){let ne=this.firstIdx;for(;ne<this.items.length&&re(this.items[ne]);)ne++;const ce=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ce}takeFromEndWhile(re){let ne=this.lastIdx;for(;ne>=0&&re(this.items[ne]);)ne--;const ce=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const re=this.items[this.firstIdx];return this.firstIdx++,re}removeLast(){const re=this.items[this.lastIdx];return this.lastIdx--,re}takeCount(re){const ne=this.items.slice(this.firstIdx,this.firstIdx+re);return this.firstIdx+=re,ne}}e.ArrayQueue=Y;class se{constructor(re){this.iterate=re}forEach(re){this.iterate(ne=>(re(ne),!0))}toArray(){const re=[];return this.iterate(ne=>(re.push(ne),!0)),re}filter(re){return new se(ne=>this.iterate(ce=>re(ce)?ne(ce):!0))}map(re){return new se(ne=>this.iterate(ce=>ne(re(ce))))}some(re){let ne=!1;return this.iterate(ce=>(ne=re(ce),!ne)),ne}findFirst(re){let ne;return this.iterate(ce=>re(ce)?(ne=ce,!1):!0),ne}findLast(re){let ne;return this.iterate(ce=>(re(ce)&&(ne=ce),!0)),ne}findLastMaxBy(re){let ne,ce=!0;return this.iterate(ge=>((ce||J.isGreaterThan(re(ge,ne)))&&(ce=!1,ne=ge),!0)),ne}}e.CallbackIterable=se,se.empty=new se(H=>{})}),define(ee[120],ie([0,1,16]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(u,w){if(!u)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=t;function k(u,w="Unreachable"){throw new Error(w)}e.assertNever=k;function R(u){if(!u)throw new y.BugIndicatingError("Assertion Failed")}e.assert=R;function D(u){if(!u()){debugger;u(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function I(u,w){let v=0;for(;v<u.length-1;){const C=u[v],E=u[v+1];if(!w(C,E))return!1;v++}return!0}e.checkAdjacentItems=I}),define(ee[49],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=y}),define(ee[57],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(t){function k(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*I(a){yield a}t.single=I;function u(a){return a||R}t.from=u;function w(a){return!a||a[Symbol.iterator]().next().done===!0}t.isEmpty=w;function v(a){return a[Symbol.iterator]().next().value}t.first=v;function C(a,n){for(const i of a)if(n(i))return!0;return!1}t.some=C;function E(a,n){for(const i of a)if(n(i))return i}t.find=E;function*d(a,n){for(const i of a)n(i)&&(yield i)}t.filter=d;function*f(a,n){let i=0;for(const r of a)yield n(r,i++)}t.map=f;function*P(...a){for(const n of a)for(const i of n)yield i}t.concat=P;function*b(a){for(const n of a)for(const i of n)yield i}t.concatNested=b;function p(a,n,i){let r=i;for(const c of a)r=n(r,c);return r}t.reduce=p;function S(a,n){let i=0;for(const r of a)n(r,i++)}t.forEach=S;function*m(a,n,i=a.length){for(n<0&&(n+=a.length),i<0?i+=a.length:i>a.length&&(i=a.length);n<i;n++)yield a[n]}t.slice=m;function h(a,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,a];const r=a[Symbol.iterator]();for(let c=0;c<n;c++){const o=r.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=h;function l(a){return h(a)[0]}t.collect=l;function s(a,n,i=(r,c)=>r===c){const r=a[Symbol.iterator](),c=n[Symbol.iterator]();for(;;){const o=r.next(),g=c.next();if(o.done!==g.done)return!1;if(o.done)return!0;if(!i(o.value,g.value))return!1}}t.equals=s})(y=e.Iterable||(e.Iterable={}))}),define(ee[43],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(s){s.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(s,a=!1){let n=0;const i=s.length;let r="",c=0,o=16,g=0;function M(x){let oe=0,fe=0;for(;oe<x;){const V=s.charCodeAt(n);if(V>=48&&V<=57)fe=fe*16+V-48;else if(V>=65&&V<=70)fe=fe*16+V-65+10;else if(V>=97&&V<=102)fe=fe*16+V-97+10;else break;n++,oe++}return oe<x&&(fe=-1),fe}function A(x){n=x,r="",c=0,o=16,g=0}function _(){const x=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&w(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&w(s.charCodeAt(n)))for(n++;n<s.length&&w(s.charCodeAt(n));)n++;else return g=3,s.substring(x,n);let oe=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&w(s.charCodeAt(n))){for(n++;n<s.length&&w(s.charCodeAt(n));)n++;oe=n}else g=3;return s.substring(x,oe)}function G(){let x="",oe=n;for(;;){if(n>=i){x+=s.substring(oe,n),g=2;break}const fe=s.charCodeAt(n);if(fe===34){x+=s.substring(oe,n),n++;break}if(fe===92){if(x+=s.substring(oe,n),n++,n>=i){g=2;break}switch(s.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const j=M(4);j>=0?x+=String.fromCharCode(j):g=4;break}default:g=5}oe=n;continue}if(fe>=0&&fe<=31)if(u(fe)){x+=s.substring(oe,n),g=2;break}else g=6;n++}return x}function ae(){if(r="",g=0,c=n,n>=i)return c=i,o=17;let x=s.charCodeAt(n);if(I(x)){do n++,r+=String.fromCharCode(x),x=s.charCodeAt(n);while(I(x));return o=15}if(u(x))return n++,r+=String.fromCharCode(x),x===13&&s.charCodeAt(n)===10&&(n++,r+=`
`),o=14;switch(x){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,r=G(),o=10;case 47:{const oe=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!u(s.charCodeAt(n));)n++;return r=s.substring(oe,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const fe=i-1;let V=!1;for(;n<fe;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,V=!0;break}n++}return V||(n++,g=1),r=s.substring(oe,n),o=13}return r+=String.fromCharCode(x),n++,o=16}case 45:if(r+=String.fromCharCode(x),n++,n===i||!w(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=_(),o=11;default:for(;n<i&&Q(x);)n++,x=s.charCodeAt(n);if(c!==n){switch(r=s.substring(c,n),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(x),n++,o=16}}function Q(x){if(I(x)||u(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let x;do x=ae();while(x>=12&&x<=15);return x}return{setPosition:A,getPosition:()=>n,scan:a?X:ae,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>g}}e.createScanner=D;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function u(s){return s===10||s===13||s===8232||s===8233}function w(s){return s>=48&&s<=57}var v;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(v||(v={}));function C(s,a){const n=[],i=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function g(M,A,_,G){c.value=M,c.offset=A,c.length=_,c.type=G,c.colonOffset=void 0,r=c}try{m(s,{onObjectBegin:(M,A)=>{if(a<=M)throw i;r=void 0,o=a>M,n.push("")},onObjectProperty:(M,A,_)=>{if(a<A||(g(M,A,_,"property"),n[n.length-1]=M,a<=A+_))throw i},onObjectEnd:(M,A)=>{if(a<=M)throw i;r=void 0,n.pop()},onArrayBegin:(M,A)=>{if(a<=M)throw i;r=void 0,n.push(0)},onArrayEnd:(M,A)=>{if(a<=M)throw i;r=void 0,n.pop()},onLiteralValue:(M,A,_)=>{if(a<A||(g(M,A,_,l(M)),a<=A+_))throw i},onSeparator:(M,A,_)=>{if(a<=A)throw i;if(M===":"&&r&&r.type==="property")r.colonOffset=A,o=!1,r=void 0;else if(M===","){const G=n[n.length-1];typeof G=="number"?n[n.length-1]=G+1:(o=!0,n[n.length-1]=""),r=void 0}}})}catch(M){if(M!==i)throw M}return{path:n,previousNode:r,isAtPropertyKey:o,matches:M=>{let A=0;for(let _=0;A<M.length&&_<n.length;_++)if(M[A]===n[_]||M[A]==="*")A++;else if(M[A]!=="**")return!1;return A===M.length}}}e.getLocation=C;function E(s,a=[],n=R.DEFAULT){let i=null,r=[];const c=[];function o(M){Array.isArray(r)?r.push(M):i!==null&&(r[i]=M)}return m(s,{onObjectBegin:()=>{const M={};o(M),c.push(r),r=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const M=[];o(M),c.push(r),r=M,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:o,onError:(M,A,_)=>{a.push({error:M,offset:A,length:_})}},n),r[0]}e.parse=E;function d(s,a=[],n=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(M){i.type==="property"&&(i.length=M-i.offset,i=i.parent)}function c(M){return i.children.push(M),M}m(s,{onObjectBegin:M=>{i=c({type:"object",offset:M,length:-1,parent:i,children:[]})},onObjectProperty:(M,A,_)=>{i=c({type:"property",offset:A,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:M,offset:A,length:_,parent:i})},onObjectEnd:(M,A)=>{i.length=M+A-i.offset,i=i.parent,r(M+A)},onArrayBegin:(M,A)=>{i=c({type:"array",offset:M,length:-1,parent:i,children:[]})},onArrayEnd:(M,A)=>{i.length=M+A-i.offset,i=i.parent,r(M+A)},onLiteralValue:(M,A,_)=>{c({type:l(M),offset:A,length:_,parent:i,value:M}),r(A+_)},onSeparator:(M,A,_)=>{i.type==="property"&&(M===":"?i.colonOffset=A:M===","&&r(A))},onError:(M,A,_)=>{a.push({error:M,offset:A,length:_})}},n);const g=i.children[0];return g&&delete g.parent,g}e.parseTree=d;function f(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===i){n=c.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=f;function P(s){if(!s.parent||!s.parent.children)return[];const a=P(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.getNodePath=P;function b(s){switch(s.type){case"array":return s.children.map(b);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=b(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=b;function p(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.contains=p;function S(s,a,n=!1){if(p(s,a,n)){const i=s.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=a;r++){const c=S(i[r],a,n);if(c)return c}return s}}e.findNodeAtOffset=S;function m(s,a,n=R.DEFAULT){const i=D(s,!1);function r(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(B){return B?$=>B($,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=r(a.onObjectBegin),g=c(a.onObjectProperty),M=r(a.onObjectEnd),A=r(a.onArrayBegin),_=r(a.onArrayEnd),G=c(a.onLiteralValue),ae=c(a.onSeparator),Q=r(a.onComment),X=c(a.onError),x=n&&n.disallowComments,oe=n&&n.allowTrailingComma;function fe(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:x||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(B){case 12:case 13:x?V(10):Q();break;case 16:V(1);break;case 15:case 14:break;default:return B}}}function V(B,$=[],L=[]){if(X(B),$.length+L.length>0){let O=i.getToken();for(;O!==17;){if($.indexOf(O)!==-1){fe();break}else if(L.indexOf(O)!==-1)break;O=fe()}}}function j(B){const $=i.getTokenValue();return B?G($):g($),fe(),!0}function F(){switch(i.getToken()){case 11:{let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(V(2),B=0)}catch{V(2)}G(B);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return fe(),!0}function T(){return i.getToken()!==10?(V(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(ae(":"),fe(),J()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function W(){o(),fe();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||V(4,[],[]),ae(","),fe(),i.getToken()===2&&oe)break}else B&&V(6,[],[]);T()||V(4,[],[2,5]),B=!0}return M(),i.getToken()!==2?V(7,[2],[]):fe(),!0}function N(){A(),fe();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||V(4,[],[]),ae(","),fe(),i.getToken()===4&&oe)break}else B&&V(6,[],[]);J()||V(4,[],[4,5]),B=!0}return _(),i.getToken()!==4?V(8,[4],[]):fe(),!0}function J(){switch(i.getToken()){case 3:return N();case 1:return W();case 10:return j(!0);default:return F()}}return fe(),i.getToken()===17?n.allowEmptyContent?!0:(V(4,[],[]),!1):J()?(i.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=m;function h(s,a){const n=D(s),i=[];let r,c=0,o;do switch(o=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:c!==o&&i.push(s.substring(c,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),c=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=h;function l(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ee[121],ie([0,1,43]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(w,v,C){let E,d,f,P,b;if(v){for(P=v.offset,b=P+v.length,f=P;f>0&&!u(w,f-1);)f--;let o=b;for(;o<w.length&&!u(w,o);)o++;d=w.substring(f,o),E=D(d,C)}else d=w,E=0,f=0,P=0,b=w.length;const p=I(C,w);let S=!1,m=0,h;C.insertSpaces?h=R(" ",C.tabSize||4):h="	";const l=(0,y.createScanner)(d,!1);let s=!1;function a(){return p+R(h,E+m)}function n(){let o=l.scan();for(S=!1;o===15||o===14;)S=S||o===14,o=l.scan();return s=o===16||l.getTokenError()!==0,o}const i=[];function r(o,g,M){!s&&g<b&&M>P&&w.substring(g,M)!==o&&i.push({offset:g,length:M-g,content:o})}let c=n();if(c!==17){const o=l.getTokenOffset()+f,g=R(h,E);r(g,f,o)}for(;c!==17;){let o=l.getTokenOffset()+l.getTokenLength()+f,g=n(),M="";for(;!S&&(g===12||g===13);){const _=l.getTokenOffset()+f;r(" ",o,_),o=l.getTokenOffset()+l.getTokenLength()+f,M=g===12?a():"",g=n()}if(g===2)c!==1&&(m--,M=a());else if(g===4)c!==3&&(m--,M=a());else{switch(c){case 3:case 1:m++,M=a();break;case 5:case 12:M=a();break;case 13:S?M=a():M=" ";break;case 6:M=" ";break;case 10:if(g===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?M=" ":g!==5&&g!==17&&(s=!0);break;case 16:s=!0;break}S&&(g===12||g===13)&&(M=a())}const A=l.getTokenOffset()+f;r(M,o,A),c=g}return i}e.format=t;function k(w,v){const C=JSON.stringify(w,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?C.replace(/\r\n|\r|\n/g,v.eol):C}e.toFormattedString=k;function R(w,v){let C="";for(let E=0;E<v;E++)C+=w;return C}function D(w,v){let C=0,E=0;const d=v.tabSize||4;for(;C<w.length;){const f=w.charAt(C);if(f===" ")E++;else if(f==="	")E+=d;else break;C++}return Math.floor(E/d)}function I(w,v){for(let C=0;C<v.length;C++){const E=v.charAt(C);if(E==="\r")return C+1<v.length&&v.charAt(C+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=I;function u(w,v){return`\r
`.indexOf(w.charAt(v))!==-1}e.isEOL=u}),define(ee[122],ie([0,1,43,121]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,v,C){return R(w,v,void 0,C)}e.removeProperty=k;function R(w,v,C,E,d){const f=v.slice(),P=[],b=(0,y.parseTree)(w,P);let p,S;for(;f.length>0&&(S=f.pop(),p=(0,y.findNodeAtLocation)(b,f),p===void 0&&C!==void 0);)typeof S=="string"?C={[S]:C}:C=[C];if(p)if(p.type==="object"&&typeof S=="string"&&Array.isArray(p.children)){const m=(0,y.findNodeAtLocation)(p,[S]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const h=p.children.indexOf(m.parent);let l,s=m.parent.offset+m.parent.length;if(h>0){const a=p.children[h-1];l=a.offset+a.length}else l=p.offset+1,p.children.length>1&&(s=p.children[1].offset);return D(w,{offset:l,length:s-l,content:""},E)}else return D(w,{offset:m.offset,length:m.length,content:JSON.stringify(C)},E);else{if(C===void 0)return[];const h=`${JSON.stringify(S)}: ${JSON.stringify(C)}`,l=d?d(p.children.map(a=>a.children[0].value)):p.children.length;let s;if(l>0){const a=p.children[l-1];s={offset:a.offset+a.length,length:0,content:","+h}}else p.children.length===0?s={offset:p.offset+1,length:0,content:h}:s={offset:p.offset+1,length:0,content:h+","};return D(w,s,E)}}else if(p.type==="array"&&typeof S=="number"&&Array.isArray(p.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let h;if(p.children.length===0||S===0)h={offset:p.offset+1,length:0,content:p.children.length===0?m:m+","};else{const l=S===-1||S>p.children.length?p.children.length:S,s=p.children[l-1];h={offset:s.offset+s.length,length:0,content:","+m}}return D(w,h,E)}else{const m=S,h=p.children[m];let l;if(p.children.length===1)l={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===m){const s=p.children[m-1],a=s.offset+s.length,n=p.offset+p.length;l={offset:a,length:n-2-a,content:""}}else l={offset:h.offset,length:p.children[m+1].offset-h.offset,content:""};return D(w,l,E)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${p.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(C)},E)}}e.setProperty=R;function D(w,v,C){let E=I(w,v),d=v.offset,f=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;d>0&&!(0,t.isEOL)(E,d-1);)d--;for(;f<E.length&&!(0,t.isEOL)(E,f);)f++}const P=(0,t.format)(E,{offset:d,length:f-d},C);for(let p=P.length-1;p>=0;p--){const S=P[p];E=I(E,S),d=Math.min(d,S.offset),f=Math.max(f,S.offset+S.length),f+=S.content.length-S.length}const b=w.length-(E.length-f)-d;return[{offset:d,length:b,content:E.substring(d,f)}]}e.withFormatting=D;function I(w,v){return w.substring(0,v.offset)+v.content+w.substring(v.offset+v.length)}e.applyEdit=I;function u(w,v){const C=v.slice(0).sort((d,f)=>{const P=d.offset-f.offset;return P===0?d.length-f.length:P});let E=w.length;for(let d=C.length-1;d>=0;d--){const f=C[d];if(f.offset+f.length<=E)w=I(w,f);else throw new Error("Overlapping edit");E=f.offset}return w}e.applyEdits=u}),define(ee[123],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new y(()=>k(this.getValue()))}}e.Lazy=y}),define(ee[2],ie([0,1,49,57]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(c){R=c}if(e.setDisposableTracker=D,k){const c="__is_disposable_tracked__";D(new class{trackDisposable(o){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(g)},3e3)}setParent(o,g){if(o&&o!==S.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==S.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function I(c){return R?.trackDisposable(c),c}function u(c){R?.markAsDisposed(c)}function w(c,o){R?.setParent(c,o)}function v(c,o){if(!!R)for(const g of c)R.setParent(g,o)}function C(c){return R?.markAsSingleton(c),c}e.markAsSingleton=C;function E(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=E;function d(c){if(t.Iterable.is(c)){const o=[];for(const g of c)if(g)try{g.dispose()}catch(M){o.push(M)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=d;function f(c){for(const o of c)E(o)&&o.dispose();return[]}e.disposeIfDisposable=f;function P(...c){const o=b(()=>d(c));return v(c,o),o}e.combinedDisposable=P;function b(c){const o=I({dispose:(0,y.once)(()=>{u(o),c()})});return o}e.toDisposable=b;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new p,I(this),w(this._store,this)}dispose(){u(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&w(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&w(o,null),o}}e.MutableDisposable=m;class h{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(o){let g=o;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,u(this))},this}}e.SafeDisposable=l;class s{constructor(){this.references=new Map}acquire(o,...g){let M=this.references.get(o);M||(M={counter:0,object:this.createReferencedObject(o,...g)},this.references.set(o,M));const{object:A}=M,_=(0,y.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(o,M.object),this.references.delete(o))});return M.counter++,{object:A,dispose:_}}}e.ReferenceCollection=s;class a{constructor(o){this.referenceCollection=o}async acquire(o,...g){const M=this.referenceCollection.acquire(o,...g);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(A){throw M.dispose(),A}}}e.AsyncReferenceCollection=a;class n{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=n;function i(c){const o=new p;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=i;class r{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(o){return this._store.has(o)}get(o){return this._store.get(o)}set(o,g,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(o)?.dispose(),this._store.set(o,g)}deleteAndDispose(o){this._store.get(o)?.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(ee[94],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(R){this.element=R,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class t{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let R=this._first;for(;R!==y.Undefined;){const D=R.next;R.prev=y.Undefined,R.next=y.Undefined,R=D}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const I=new y(R);if(this._first===y.Undefined)this._first=I,this._last=I;else if(D){const w=this._last;this._last=I,I.prev=w,w.next=I}else{const w=this._first;this._first=I,I.next=w,w.prev=I}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(I))}}shift(){if(this._first!==y.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==y.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==y.Undefined&&R.next!==y.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===y.Undefined&&R.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):R.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):R.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==y.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(u){R.push(u,Date.now())}function I(){const u=[];for(let w=0;w<R.length;w+=2)u.push({name:R[w],startTime:R[w+1]});return u}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function y(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=y(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var t in y)(typeof exports=="object"?exports:z)[t]=y[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function y(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return z[t].call(k.exports,k,k.exports,y),k.l=!0,k.exports}return y.m=z,y.c=e,y.d=function(t,k,R){y.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},y.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},y.t=function(t,k){if(1&k&&(t=y(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(y.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)y.d(R,D,function(I){return t[I]}.bind(null,D));return R},y.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return y.d(k,"a",k),k},y.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},y.p="",y(y.s=0)}([function(z,e,y){(function(t){var k;e=z.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],u=e.src=[],w=0,v=w++;u[v]="0|[1-9]\\d*";var C=w++;u[C]="[0-9]+";var E=w++;u[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=w++;u[d]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var f=w++;u[f]="("+u[C]+")\\.("+u[C]+")\\.("+u[C]+")";var P=w++;u[P]="(?:"+u[v]+"|"+u[E]+")";var b=w++;u[b]="(?:"+u[C]+"|"+u[E]+")";var p=w++;u[p]="(?:-("+u[P]+"(?:\\."+u[P]+")*))";var S=w++;u[S]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var m=w++;u[m]="[0-9A-Za-z-]+";var h=w++;u[h]="(?:\\+("+u[m]+"(?:\\."+u[m]+")*))";var l=w++,s="v?"+u[d]+u[p]+"?"+u[h]+"?";u[l]="^"+s+"$";var a="[v=\\s]*"+u[f]+u[S]+"?"+u[h]+"?",n=w++;u[n]="^"+a+"$";var i=w++;u[i]="((?:<|>)?=?)";var r=w++;u[r]=u[C]+"|x|X|\\*";var c=w++;u[c]=u[v]+"|x|X|\\*";var o=w++;u[o]="[v=\\s]*("+u[c]+")(?:\\.("+u[c]+")(?:\\.("+u[c]+")(?:"+u[p]+")?"+u[h]+"?)?)?";var g=w++;u[g]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[S]+")?"+u[h]+"?)?)?";var M=w++;u[M]="^"+u[i]+"\\s*"+u[o]+"$";var A=w++;u[A]="^"+u[i]+"\\s*"+u[g]+"$";var _=w++;u[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=w++;u[G]="(?:~>?)";var ae=w++;u[ae]="(\\s*)"+u[G]+"\\s+",I[ae]=new RegExp(u[ae],"g");var Q=w++;u[Q]="^"+u[G]+u[o]+"$";var X=w++;u[X]="^"+u[G]+u[g]+"$";var x=w++;u[x]="(?:\\^)";var oe=w++;u[oe]="(\\s*)"+u[x]+"\\s+",I[oe]=new RegExp(u[oe],"g");var fe=w++;u[fe]="^"+u[x]+u[o]+"$";var V=w++;u[V]="^"+u[x]+u[g]+"$";var j=w++;u[j]="^"+u[i]+"\\s*("+a+")$|^$";var F=w++;u[F]="^"+u[i]+"\\s*("+s+")$|^$";var T=w++;u[T]="(\\s*)"+u[i]+"\\s*("+a+"|"+u[o]+")",I[T]=new RegExp(u[T],"g");var W=w++;u[W]="^\\s*("+u[o]+")\\s+-\\s+("+u[o]+")\\s*$";var N=w++;u[N]="^\\s*("+u[g]+")\\s+-\\s+("+u[g]+")\\s*$";var J=w++;u[J]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,u[B]),I[B]||(I[B]=new RegExp(u[B]));function $(Z,ue){if(Z instanceof L)return Z;if(typeof Z!="string"||Z.length>R||!(ue?I[n]:I[l]).test(Z))return null;try{return new L(Z,ue)}catch{return null}}function L(Z,ue){if(Z instanceof L){if(Z.loose===ue)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(Z,ue);k("SemVer",Z,ue),this.loose=ue;var de=Z.trim().match(ue?I[n]:I[l]);if(!de)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=$,e.valid=function(Z,ue){var de=$(Z,ue);return de?de.version:null},e.clean=function(Z,ue){var de=$(Z.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(Z){return k("SemVer.compare",this.version,this.loose,Z),Z instanceof L||(Z=new L(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},L.prototype.compareMain=function(Z){return Z instanceof L||(Z=new L(Z,this.loose)),U(this.major,Z.major)||U(this.minor,Z.minor)||U(this.patch,Z.patch)},L.prototype.comparePre=function(Z){if(Z instanceof L||(Z=new L(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],ye=Z.prerelease[ue];if(k("prerelease compare",ue,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return U(de,ye)}while(++ue)},L.prototype.inc=function(Z,ue){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ue,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new L(Z,de).inc(ue,ye).version}catch{return null}},e.diff=function(Z,ue){if(H(Z,ue))return null;var de=$(Z),ye=$(ue);if(de.prerelease.length||ye.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=U;var O=/^[0-9]+$/;function U(Z,ue){var de=O.test(Z),ye=O.test(ue);return de&&ye&&(Z=+Z,ue=+ue),de&&!ye?-1:ye&&!de?1:Z<ue?-1:Z>ue?1:0}function q(Z,ue,de){return new L(Z,de).compare(new L(ue,de))}function Y(Z,ue,de){return q(Z,ue,de)>0}function se(Z,ue,de){return q(Z,ue,de)<0}function H(Z,ue,de){return q(Z,ue,de)===0}function re(Z,ue,de){return q(Z,ue,de)!==0}function ne(Z,ue,de){return q(Z,ue,de)>=0}function ce(Z,ue,de){return q(Z,ue,de)<=0}function ge(Z,ue,de,ye){var Ce;switch(ue){case"===":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Ce=Z===de;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof de=="object"&&(de=de.version),Ce=Z!==de;break;case"":case"=":case"==":Ce=H(Z,de,ye);break;case"!=":Ce=re(Z,de,ye);break;case">":Ce=Y(Z,de,ye);break;case">=":Ce=ne(Z,de,ye);break;case"<":Ce=se(Z,de,ye);break;case"<=":Ce=ce(Z,de,ye);break;default:throw new TypeError("Invalid operator: "+ue)}return Ce}function Re(Z,ue){if(Z instanceof Re){if(Z.loose===ue)return Z;Z=Z.value}if(!(this instanceof Re))return new Re(Z,ue);k("comparator",Z,ue),this.loose=ue,this.parse(Z),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Z,ue){return U(ue,Z)},e.major=function(Z,ue){return new L(Z,ue).major},e.minor=function(Z,ue){return new L(Z,ue).minor},e.patch=function(Z,ue){return new L(Z,ue).patch},e.compare=q,e.compareLoose=function(Z,ue){return q(Z,ue,!0)},e.rcompare=function(Z,ue,de){return q(ue,Z,de)},e.sort=function(Z,ue){return Z.sort(function(de,ye){return e.compare(de,ye,ue)})},e.rsort=function(Z,ue){return Z.sort(function(de,ye){return e.rcompare(de,ye,ue)})},e.gt=Y,e.lt=se,e.eq=H,e.neq=re,e.gte=ne,e.lte=ce,e.cmp=ge,e.Comparator=Re;var Te={};function Me(Z,ue){if(Z instanceof Me)return Z.loose===ue?Z:new Me(Z.raw,ue);if(Z instanceof Re)return new Me(Z.value,ue);if(!(this instanceof Me))return new Me(Z,ue);if(this.loose=ue,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Ae(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function ve(Z,ue,de,ye,Ce,Fe,Oe,$e,Ne,He,Qe,Be,Ge){return((ue=Ae(de)?"":Ae(ye)?">="+de+".0.0":Ae(Ce)?">="+de+"."+ye+".0":">="+ue)+" "+($e=Ae(Ne)?"":Ae(He)?"<"+(+Ne+1)+".0.0":Ae(Qe)?"<"+Ne+"."+(+He+1)+".0":Be?"<="+Ne+"."+He+"."+Qe+"-"+Be:"<="+$e)).trim()}function pe(Z,ue){for(var de=0;de<Z.length;de++)if(!Z[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<Z.length;de++)if(k(Z[de].semver),Z[de].semver!==Te&&Z[de].semver.prerelease.length>0){var ye=Z[de].semver;if(ye.major===ue.major&&ye.minor===ue.minor&&ye.patch===ue.patch)return!0}return!1}return!0}function Se(Z,ue,de){try{ue=new Me(ue,de)}catch{return!1}return ue.test(Z)}function ke(Z,ue,de,ye){var Ce,Fe,Oe,$e,Ne;switch(Z=new L(Z,ye),ue=new Me(ue,ye),de){case">":Ce=Y,Fe=ce,Oe=se,$e=">",Ne=">=";break;case"<":Ce=se,Fe=ne,Oe=Y,$e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(Z,ue,ye))return!1;for(var He=0;He<ue.set.length;++He){var Qe=ue.set[He],Be=null,Ge=null;if(Qe.forEach(function(K){K.semver===Te&&(K=new Re(">=0.0.0")),Be=Be||K,Ge=Ge||K,Ce(K.semver,Be.semver,ye)?Be=K:Oe(K.semver,Ge.semver,ye)&&(Ge=K)}),Be.operator===$e||Be.operator===Ne||(!Ge.operator||Ge.operator===$e)&&Fe(Z,Ge.semver)||Ge.operator===Ne&&Oe(Z,Ge.semver))return!1}return!0}Re.prototype.parse=function(Z){var ue=this.loose?I[j]:I[F],de=Z.match(ue);if(!de)throw new TypeError("Invalid comparator: "+Z);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Te},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(Z){return k("Comparator.test",Z,this.loose),this.semver===Te||(typeof Z=="string"&&(Z=new L(Z,this.loose)),ge(Z,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(Z,ue){if(!(Z instanceof Re))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Me(Z.value,ue),Se(this.value,de,ue);if(Z.operator==="")return de=new Me(this.value,ue),Se(Z.semver,de,ue);var ye=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Fe=this.semver.version===Z.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),$e=ge(this.semver,"<",Z.semver,ue)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ne=ge(this.semver,">",Z.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return ye||Ce||Fe&&Oe||$e||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(Z){var ue=this.loose;Z=Z.trim(),k("range",Z,ue);var de=ue?I[N]:I[W];Z=Z.replace(de,ve),k("hyphen replace",Z),Z=Z.replace(I[T],"$1$2$3"),k("comparator trim",Z,I[T]),Z=(Z=(Z=Z.replace(I[ae],"$1~")).replace(I[oe],"$1^")).split(/\s+/).join(" ");var ye=ue?I[j]:I[F],Ce=Z.split(" ").map(function(Fe){return function(Oe,$e){return k("comp",Oe),Oe=function(Ne,He){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){k("caret",Be,Ge);var K=Ge?I[V]:I[fe];return Be.replace(K,function(le,he,me,Ee,Le){var Ue;return k("caret",Be,le,he,me,Ee,Le),Ae(he)?Ue="":Ae(me)?Ue=">="+he+".0.0 <"+(+he+1)+".0.0":Ae(Ee)?Ue=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Le?(k("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ue=he==="0"?me==="0"?">="+he+"."+me+"."+Ee+Le+" <"+he+"."+me+"."+(+Ee+1):">="+he+"."+me+"."+Ee+Le+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Ee+Le+" <"+(+he+1)+".0.0"):(k("no pr"),Ue=he==="0"?me==="0"?">="+he+"."+me+"."+Ee+" <"+he+"."+me+"."+(+Ee+1):">="+he+"."+me+"."+Ee+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Ee+" <"+(+he+1)+".0.0"),k("caret return",Ue),Ue})}(Qe,He)}).join(" ")}(Oe,$e),k("caret",Oe),Oe=function(Ne,He){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){var K=Ge?I[X]:I[Q];return Be.replace(K,function(le,he,me,Ee,Le){var Ue;return k("tilde",Be,le,he,me,Ee,Le),Ae(he)?Ue="":Ae(me)?Ue=">="+he+".0.0 <"+(+he+1)+".0.0":Ae(Ee)?Ue=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Le?(k("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ue=">="+he+"."+me+"."+Ee+Le+" <"+he+"."+(+me+1)+".0"):Ue=">="+he+"."+me+"."+Ee+" <"+he+"."+(+me+1)+".0",k("tilde return",Ue),Ue})}(Qe,He)}).join(" ")}(Oe,$e),k("tildes",Oe),Oe=function(Ne,He){return k("replaceXRanges",Ne,He),Ne.split(/\s+/).map(function(Qe){return function(Be,Ge){Be=Be.trim();var K=Ge?I[A]:I[M];return Be.replace(K,function(le,he,me,Ee,Le,Ue){k("xRange",Be,le,he,me,Ee,Le,Ue);var it=Ae(me),Je=it||Ae(Ee),je=Je||Ae(Le);return he==="="&&je&&(he=""),it?le=he===">"||he==="<"?"<0.0.0":"*":he&&je?(Je&&(Ee=0),je&&(Le=0),he===">"?(he=">=",Je?(me=+me+1,Ee=0,Le=0):je&&(Ee=+Ee+1,Le=0)):he==="<="&&(he="<",Je?me=+me+1:Ee=+Ee+1),le=he+me+"."+Ee+"."+Le):Je?le=">="+me+".0.0 <"+(+me+1)+".0.0":je&&(le=">="+me+"."+Ee+".0 <"+me+"."+(+Ee+1)+".0"),k("xRange return",le),le})}(Qe,He)}).join(" ")}(Oe,$e),k("xrange",Oe),Oe=function(Ne,He){return k("replaceStars",Ne,He),Ne.trim().replace(I[J],"")}(Oe,$e),k("stars",Oe),Oe}(Fe,ue)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(ye)})),Ce=Ce.map(function(Fe){return new Re(Fe,ue)})},Me.prototype.intersects=function(Z,ue){if(!(Z instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return Z.set.some(function(Ce){return Ce.every(function(Fe){return ye.intersects(Fe,ue)})})})})},e.toComparators=function(Z,ue){return new Me(Z,ue).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new L(Z,this.loose));for(var ue=0;ue<this.set.length;ue++)if(pe(this.set[ue],Z))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(Z,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return Z.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,de)))}),ye},e.minSatisfying=function(Z,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return Z.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,de)))}),ye},e.validRange=function(Z,ue){try{return new Me(Z,ue).range||"*"}catch{return null}},e.ltr=function(Z,ue,de){return ke(Z,ue,"<",de)},e.gtr=function(Z,ue,de){return ke(Z,ue,">",de)},e.outside=ke,e.prerelease=function(Z,ue){var de=$(Z,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Z,ue,de){return Z=new Me(Z,de),ue=new Me(ue,de),Z.intersects(ue)},e.coerce=function(Z){if(Z instanceof L)return Z;if(typeof Z!="string")return null;var ue=Z.match(I[_]);return ue==null?null:$((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,y(1))},function(z,e){var y,t,k=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I(b){if(y===setTimeout)return setTimeout(b,0);if((y===R||!y)&&setTimeout)return y=setTimeout,setTimeout(b,0);try{return y(b,0)}catch{try{return y.call(null,b,0)}catch{return y.call(this,b,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:R}catch{y=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var u,w=[],v=!1,C=-1;function E(){v&&u&&(v=!1,u.length?w=u.concat(w):C=-1,w.length&&d())}function d(){if(!v){var b=I(E);v=!0;for(var p=w.length;p;){for(u=w,w=[];++C<p;)u&&u[C].run();C=-1,p=w.length}u=null,v=!1,function(S){if(t===clearTimeout)return clearTimeout(S);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(S);try{t(S)}catch{try{return t.call(null,S)}catch{return t.call(this,S)}}}(b)}}function f(b,p){this.fun=b,this.array=p}function P(){}k.nextTick=function(b){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];w.push(new f(b,p)),w.length!==1||v||I(d)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=P,k.addListener=P,k.once=P,k.off=P,k.removeListener=P,k.removeAllListeners=P,k.emit=P,k.prependListener=P,k.prependOnceListener=P,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ee[124],ie([0,1]),function(z,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,u,w){this.level=I,this.key=u,this.value=w,this.forward=[]}}const k=void 0;class R{constructor(I,u=2**16){this.comparator=I,this[y]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(I){return Boolean(R._search(this,I,this.comparator))}get(I){return R._search(this,I,this.comparator)?.value}set(I,u){return R._insert(this,I,u,this.comparator)&&(this._size+=1),this}delete(I){const u=R._delete(this,I,this.comparator);return u&&(this._size-=1),u}forEach(I,u){let w=this._header.forward[0];for(;w;)I.call(u,w.value,w.key,this),w=w.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",u=this._header.forward[0];for(;u;)I+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return I}static _search(I,u,w){let v=I._header;for(let C=I._level-1;C>=0;C--)for(;v.forward[C]&&w(v.forward[C].key,u)<0;)v=v.forward[C];if(v=v.forward[0],v&&w(v.key,u)===0)return v}static _insert(I,u,w,v){const C=[];let E=I._header;for(let d=I._level-1;d>=0;d--){for(;E.forward[d]&&v(E.forward[d].key,u)<0;)E=E.forward[d];C[d]=E}if(E=E.forward[0],E&&v(E.key,u)===0)return E.value=w,!1;{const d=R._randomLevel(I);if(d>I._level){for(let f=I._level;f<d;f++)C[f]=I._header;I._level=d}E=new t(d,u,w);for(let f=0;f<d;f++)E.forward[f]=C[f].forward[f],C[f].forward[f]=E;return!0}}static _randomLevel(I,u=.5){let w=1;for(;Math.random()<u&&w<I._maxLevel;)w+=1;return w}static _delete(I,u,w){const v=[];let C=I._header;for(let E=I._level-1;E>=0;E--){for(;C.forward[E]&&w(C.forward[E].key,u)<0;)C=C.forward[E];v[E]=C}if(C=C.forward[0],!C||w(C.key,u)!==0)return!1;for(let E=0;E<I._level&&v[E].forward[E]===C;E++)v[E].forward[E]=C.forward[E];for(;I._level>0&&I._header.forward[I._level-1]===k;)I._level-=1;return!0}}e.SkipList=R}),define(ee[58],ie([0,1,16,2]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const l=h;return l?typeof l.read=="function":!1}e.isReadable=k;function R(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=R;function D(h){const l=h;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function I(h,l){return new u(h,l)}e.newWriteableStream=I;class u{constructor(l,s){this.reducer=l,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(s=>s(l))}emitError(l){this.listeners.error.length===0?(0,y.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(s=>s(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,s){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(l,s){if(this.state.destroyed)return;let a;switch(l){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(h,l){const s=[];let a;for(;(a=h.read())!==null;)s.push(a);return l(s)}e.consumeReadable=w;function v(h,l,s){const a=[];let n;for(;(n=h.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?l(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return h.read()}}}e.peekReadable=v;function C(h,l){return new Promise((s,a)=>{const n=[];E(h,{onData:i=>{l&&n.push(i)},onError:i=>{l?a(i):s(void 0)},onEnd:()=>{s(l?l(n):void 0)}})})}e.consumeStream=C;function E(h,l){let s=!1;return h.on("error",a=>{s||l.onError(a)}),h.on("end",()=>{s||l.onEnd()}),h.on("data",a=>{s||l.onData(a)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=E;function d(h,l){return new Promise((s,a)=>{const n=new t.DisposableStore,i=[],r=g=>{if(i.push(g),i.length>l)return n.dispose(),h.pause(),s({stream:h,buffer:i,ended:!1})},c=g=>a(g),o=()=>s({stream:h,buffer:i,ended:!0});n.add((0,t.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),n.add((0,t.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),n.add((0,t.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=d;function f(h,l){const s=I(l);return s.end(h),s}e.toStream=f;function P(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=P;function b(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=b;function p(h,l,s){const a=I(s);return E(h,{onData:n=>a.write(l.data(n)),onError:n=>a.error(l.error?l.error(n):n),onEnd:()=>a.end()}),a}e.transform=p;function S(h,l,s){let a=!1;return{read:()=>{const n=l.read();return a?n:(a=!0,n!==null?s([h,n]):h)}}}e.prefixedReadable=S;function m(h,l,s){let a=!1;const n=I(s);return E(l,{onData:i=>a?n.write(i):(a=!0,n.write(s([h,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(h)),n.end()}}),n}e.prefixedStream=m}),define(ee[17],ie([0,1,58]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{static alloc(g){return t?new D(Buffer.allocUnsafe(g)):new D(new Uint8Array(g))}static wrap(g){return t&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new D(g)}static fromString(g,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(g)):(k||(k=new TextEncoder),new D(k.encode(g)))}static fromByteArray(g){const M=D.alloc(g.length);for(let A=0,_=g.length;A<_;A++)M.buffer[A]=g[A];return M}static concat(g,M){if(typeof M>"u"){M=0;for(let G=0,ae=g.length;G<ae;G++)M+=g[G].byteLength}const A=D.alloc(M);let _=0;for(let G=0,ae=g.length;G<ae;G++){const Q=g[G];A.set(Q,_),_+=Q.byteLength}return A}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=D.alloc(this.byteLength);return g.set(this),g}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(g,M){return new D(this.buffer.subarray(g,M))}set(g,M){if(g instanceof D)this.buffer.set(g.buffer,M);else if(g instanceof Uint8Array)this.buffer.set(g,M);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),M);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return w(this.buffer,g)}writeUInt32BE(g,M){v(this.buffer,g,M)}readUInt32LE(g){return C(this.buffer,g)}writeUInt32LE(g,M){E(this.buffer,g,M)}readUInt8(g){return d(this.buffer,g)}writeUInt8(g,M){f(this.buffer,g,M)}}e.VSBuffer=D;function I(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0}e.readUInt16LE=I;function u(o,g,M){o[M+0]=g&255,g=g>>>8,o[M+1]=g&255}e.writeUInt16LE=u;function w(o,g){return o[g]*2**24+o[g+1]*2**16+o[g+2]*2**8+o[g+3]}e.readUInt32BE=w;function v(o,g,M){o[M+3]=g,g=g>>>8,o[M+2]=g,g=g>>>8,o[M+1]=g,g=g>>>8,o[M]=g}e.writeUInt32BE=v;function C(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0|o[g+2]<<16>>>0|o[g+3]<<24>>>0}e.readUInt32LE=C;function E(o,g,M){o[M+0]=g&255,g=g>>>8,o[M+1]=g&255,g=g>>>8,o[M+2]=g&255,g=g>>>8,o[M+3]=g&255}e.writeUInt32LE=E;function d(o,g){return o[g]}e.readUInt8=d;function f(o,g,M){o[M]=g}e.writeUInt8=f;function P(o){return y.consumeReadable(o,g=>D.concat(g))}e.readableToBuffer=P;function b(o){return y.toReadable(o)}e.bufferToReadable=b;function p(o){return y.consumeStream(o,g=>D.concat(g))}e.streamToBuffer=p;async function S(o){return o.ended?D.concat(o.buffer):D.concat([...o.buffer,await p(o.stream)])}e.bufferedStreamToBuffer=S;function m(o){return y.toStream(o,g=>D.concat(g))}e.bufferToStream=m;function h(o){return y.transform(o,{data:g=>typeof g=="string"?D.fromString(g):D.wrap(g)},g=>D.concat(g))}e.streamToBufferReadableStream=h;function l(o){return y.newWriteableStream(g=>D.concat(g),o)}e.newWriteableBufferStream=l;function s(o,g){return y.prefixedReadable(o,g,M=>D.concat(M))}e.prefixedBufferReadable=s;function a(o,g){return y.prefixedStream(o,g,M=>D.concat(M))}e.prefixedBufferStream=a;function n(o){let g=0,M=0,A=0;const _=new Uint8Array(Math.floor(o.length/4*3)),G=Q=>{switch(M){case 3:_[A++]=g|Q,M=0;break;case 2:_[A++]=g|Q>>>2,g=Q<<6,M=3;break;case 1:_[A++]=g|Q>>>4,g=Q<<4,M=2;break;default:g=Q<<2,M=1}};for(let Q=0;Q<o.length;Q++){const X=o.charCodeAt(Q);if(X>=65&&X<=90)G(X-65);else if(X>=97&&X<=122)G(X-97+26);else if(X>=48&&X<=57)G(X-48+52);else if(X===43||X===45)G(62);else if(X===47||X===95)G(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${o[Q]}`)}}const ae=A;for(;M>0;)G(0);return D.wrap(_).slice(0,ae)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},g=!0,M=!1){const A=M?r:i;let _="";const G=o.byteLength%3;let ae=0;for(;ae<o.byteLength-G;ae+=3){const Q=o[ae+0],X=o[ae+1],x=o[ae+2];_+=A[Q>>>2],_+=A[(Q<<4|X>>>4)&63],_+=A[(X<<2|x>>>6)&63],_+=A[x&63]}if(G===1){const Q=o[ae+0];_+=A[Q>>>2],_+=A[Q<<4&63],g&&(_+="==")}else if(G===2){const Q=o[ae+0],X=o[ae+1];_+=A[Q>>>2],_+=A[(Q<<4|X>>>4)&63],_+=A[X<<2&63],g&&(_+="=")}return _}e.encodeBase64=c}),define(ee[12],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function y(a){return typeof a=="string"}e.isString=y;function t(a){return Array.isArray(a)&&a.every(n=>y(n))}e.isStringArray=t;function k(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=k;function R(a){const n=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof n}e.isTypedArray=R;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function I(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=I;function u(a){return a===!0||a===!1}e.isBoolean=u;function w(a){return typeof a>"u"}e.isUndefined=w;function v(a){return!C(a)}e.isDefined=v;function C(a){return w(a)||a===null}e.isUndefinedOrNull=C;function E(a,n){if(!a)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=E;function d(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=d;function f(...a){const n=[];for(let i=0;i<a.length;i++){const r=a[i];if(C(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(r)}return n}e.assertAllDefined=f;const P=Object.prototype.hasOwnProperty;function b(a){if(!k(a))return!1;for(const n in a)if(P.call(a,n))return!1;return!0}e.isEmptyObject=b;function p(a){return typeof a=="function"}e.isFunction=p;function S(...a){return a.length>0&&a.every(p)}e.areFunctions=S;function m(a,n){const i=Math.min(a.length,n.length);for(let r=0;r<i;r++)h(a[r],n[r])}e.validateConstraints=m;function h(a,n){if(y(n)){if(typeof a!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(p(n)){try{if(a instanceof n)return}catch{}if(!C(a)&&a.constructor===n||n.length===1&&n.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function l(a){return a===null?void 0:a}e.withNullAsUndefined=l;function s(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=s}),define(ee[50],ie([0,1,12]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const S=Array.isArray(p)?[]:{};return Object.keys(p).forEach(m=>{p[m]&&typeof p[m]=="object"?S[m]=t(p[m]):S[m]=p[m]}),S}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const S=[p];for(;S.length>0;){const m=S.shift();Object.freeze(m);for(const h in m)if(R.call(m,h)){const l=m[h];typeof l=="object"&&!Object.isFrozen(l)&&!(0,y.isTypedArray)(l)&&S.push(l)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(p,S){return I(p,S,new Set)}e.cloneAndChange=D;function I(p,S,m){if((0,y.isUndefinedOrNull)(p))return p;const h=S(p);if(typeof h<"u")return h;if(Array.isArray(p)){const l=[];for(const s of p)l.push(I(s,S,m));return l}if((0,y.isObject)(p)){if(m.has(p))throw new Error("Cannot clone recursive data-structure");m.add(p);const l={};for(const s in p)R.call(p,s)&&(l[s]=I(p[s],S,m));return m.delete(p),l}return p}function u(p,S,m=!0){return(0,y.isObject)(p)?((0,y.isObject)(S)&&Object.keys(S).forEach(h=>{h in p?m&&((0,y.isObject)(p[h])&&(0,y.isObject)(S[h])?u(p[h],S[h],m):p[h]=S[h]):p[h]=S[h]}),p):S}e.mixin=u;function w(p,S){if(p===S)return!0;if(p==null||S===null||S===void 0||typeof p!=typeof S||typeof p!="object"||Array.isArray(p)!==Array.isArray(S))return!1;let m,h;if(Array.isArray(p)){if(p.length!==S.length)return!1;for(m=0;m<p.length;m++)if(!w(p[m],S[m]))return!1}else{const l=[];for(h in p)l.push(h);l.sort();const s=[];for(h in S)s.push(h);if(s.sort(),!w(l,s))return!1;for(m=0;m<l.length;m++)if(!w(p[l[m]],S[l[m]]))return!1}return!0}e.equals=w;function v(p){const S=new Set;return JSON.stringify(p,(m,h)=>{if((0,y.isObject)(h)||Array.isArray(h)){if(S.has(h))return"[Circular]";S.add(h)}return h})}e.safeStringify=v;function C(p,S){const m=Object.create(null);return!p||!S||Object.keys(S).forEach(l=>{const s=p[l],a=S[l];w(s,a)||(m[l]=a)}),m}e.distinct=C;function E(p,S){const m=S.toLowerCase(),h=Object.keys(p).find(l=>l.toLowerCase()===m);return h?p[h]:p[S]}e.getCaseInsensitive=E;function d(p,S){const m=Object.create(null);for(const[h,l]of Object.entries(p))S(h,l)&&(m[h]=l);return m}e.filter=d;function f(p){let S=[],m=Object.getPrototypeOf(p);for(;Object.prototype!==m;)S=S.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return S}e.getAllPropertyNames=f;function P(p){const S=[];for(const m of f(p))typeof p[m]=="function"&&S.push(m);return S}e.getAllMethodNames=P;function b(p,S){const m=l=>function(){const s=Array.prototype.slice.call(arguments,0);return S(l,s)},h={};for(const l of p)h[l]=m(l);return h}e.createProxyObject=b}),define(ee[30],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return y.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(I){for(let u=0;u<I.length;u++)I[u]=Math.floor(Math.random()*256);return I};const R=new Uint8Array(16),D=[];for(let I=0;I<256;I++)D.push(I.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,w="";return w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+="-",w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w+=D[R[u++]],w}}()}),define(ee[125],ie([0,1,76,40,49]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,I){if(await new Promise((v,C)=>{const E=t.createReadStream(D),d=y.createHash("sha1");E.pipe(d);const f=(0,k.once)((P,b)=>{E.removeAllListeners(),d.removeAllListeners(),P?C(P):v(b)});E.once("error",f),E.once("end",f),d.once("error",f),d.once("data",P=>f(void 0,P.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=R}),define(ee[126],ie([0,1,25]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const I=D.replace(/\-/g,":").toLowerCase();return!t.has(I)}function R(){const D=(0,y.networkInterfaces)();for(const I in D){const u=D[I];if(u){for(const{mac:w}of u)if(k(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ee[95],ie([0,1,77]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,u,w,v=1){let C=!1;return new Promise(E=>{const d=setTimeout(()=>{if(!C)return C=!0,E(0)},w);k(I,u,v,f=>{if(!C)return C=!0,clearTimeout(d),E(f)})})}e.findFreePort=t;function k(I,u,w,v){if(u===0)return v(0);const C=new y.Socket;C.once("connect",()=>(D(C),k(I+w,u-1,w,v))),C.once("data",()=>{}),C.once("error",E=>(D(C),E.code!=="ECONNREFUSED"?k(I+w,u-1,w,v):v(I))),C.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(I,u,w){let v=!1,C,E=1;const d=y.createServer({pauseOnConnect:!0});function f(P,b){v||(v=!0,d.removeAllListeners(),d.close(),C&&clearTimeout(C),b(P))}return new Promise(P=>{C=setTimeout(()=>{f(0,P)},w),d.on("listening",()=>{f(I,P)}),d.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&E<u?(I++,E++,d.listen(I,"127.0.0.1")):f(0,P)}),d.on("close",()=>{f(0,P)}),d.listen(I,"127.0.0.1")})}e.findFreePortFaster=R;function D(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(u){console.error(u)}}}),define(ee[127],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[128],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class y{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=y}),define(ee[41],ie([0,1,13,16]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,I){const u=(w,...v)=>{this.validateEvent(D,w)&&I(w,...v)};return this.mapListenerToWrapper.set(I,u),y.ipcMain.on(D,u),this}once(D,I){return y.ipcMain.once(D,(u,...w)=>{this.validateEvent(D,u)&&I(u,...w)}),this}handle(D,I){return y.ipcMain.handle(D,(u,...w)=>this.validateEvent(D,u)?I(u,...w):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return y.ipcMain.removeHandler(D),this}removeListener(D,I){const u=this.mapListenerToWrapper.get(I);return u&&(y.ipcMain.removeListener(D,u),this.mapListenerToWrapper.delete(I)),this}validateEvent(D,I){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=I.senderFrame,w=u.url;if(!w)return!0;let v="unknown";try{v=new URL(w).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${w}'.`),!1}return v!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${v}'.`),!1):u.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(ee[129],ie([0,1,13,41,12,127]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(u,w,v,C,E)=>{const d=I(u,C,v);d.popup({window:(0,k.withNullAsUndefined)(y.BrowserWindow.fromWebContents(u.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{d&&u.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=D;function I(u,w,v){const C=new y.Menu;return v.forEach(E=>{let d;E.type==="separator"?d=new y.MenuItem({type:E.type}):Array.isArray(E.submenu)?d=new y.MenuItem({submenu:I(u,w,E.submenu),label:E.label}):d=new y.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(f,P,b)=>u.sender.send(w,E.id,b)}),C.append(d)}),C}}),define(ee[130],ie([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(ee[131],ie([0,1,130]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,I=R*30,u=R*365;function w(C,E,d){typeof C!="number"&&(C=C.getTime());const f=Math.round((new Date().getTime()-C)/1e3);if(f<-30)return(0,y.localize)(0,null,w(new Date().getTime()+f*1e3,!1));if(f<30)return(0,y.localize)(1,null);let P;return f<t?(P=f,E?P===1?d?(0,y.localize)(2,null,P):(0,y.localize)(3,null,P):d?(0,y.localize)(4,null,P):(0,y.localize)(5,null,P):P===1?d?(0,y.localize)(6,null,P):(0,y.localize)(7,null,P):d?(0,y.localize)(8,null,P):(0,y.localize)(9,null,P)):f<k?(P=Math.floor(f/t),E?P===1?d?(0,y.localize)(10,null,P):(0,y.localize)(11,null,P):d?(0,y.localize)(12,null,P):(0,y.localize)(13,null,P):P===1?d?(0,y.localize)(14,null,P):(0,y.localize)(15,null,P):d?(0,y.localize)(16,null,P):(0,y.localize)(17,null,P)):f<R?(P=Math.floor(f/k),E?P===1?d?(0,y.localize)(18,null,P):(0,y.localize)(19,null,P):d?(0,y.localize)(20,null,P):(0,y.localize)(21,null,P):P===1?d?(0,y.localize)(22,null,P):(0,y.localize)(23,null,P):d?(0,y.localize)(24,null,P):(0,y.localize)(25,null,P)):f<D?(P=Math.floor(f/R),E?P===1?(0,y.localize)(26,null,P):(0,y.localize)(27,null,P):P===1?(0,y.localize)(28,null,P):(0,y.localize)(29,null,P)):f<I?(P=Math.floor(f/D),E?P===1?d?(0,y.localize)(30,null,P):(0,y.localize)(31,null,P):d?(0,y.localize)(32,null,P):(0,y.localize)(33,null,P):P===1?d?(0,y.localize)(34,null,P):(0,y.localize)(35,null,P):d?(0,y.localize)(36,null,P):(0,y.localize)(37,null,P)):f<u?(P=Math.floor(f/I),E?P===1?d?(0,y.localize)(38,null,P):(0,y.localize)(39,null,P):d?(0,y.localize)(40,null,P):(0,y.localize)(41,null,P):P===1?d?(0,y.localize)(42,null,P):(0,y.localize)(43,null,P):d?(0,y.localize)(44,null,P):(0,y.localize)(45,null,P)):(P=Math.floor(f/u),E?P===1?d?(0,y.localize)(46,null,P):(0,y.localize)(47,null,P):d?(0,y.localize)(48,null,P):(0,y.localize)(49,null,P):P===1?d?(0,y.localize)(50,null,P):(0,y.localize)(51,null,P):d?(0,y.localize)(52,null,P):(0,y.localize)(53,null,P))}e.fromNow=w;function v(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=v}),define(ee[132],ie([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(ee[44],ie([0,1,24,12,132]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(C,E){return E&&(C.stack||C.stacktrace)?k.localize(0,null,I(C),D(C.stack)||D(C.stacktrace)):I(C)}function D(C){return Array.isArray(C)?C.join(`
`):C}function I(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function u(C=null,E=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const d=y.coalesce(C),f=u(d[0],E);return d.length>1?k.localize(4,null,f,d.length):f}if(t.isString(C))return C;if(C.detail){const d=C.detail;if(d.error)return R(d.error,E);if(d.exception)return R(d.exception,E)}return C.stack?R(C,E):C.message?C.message:k.localize(5,null)}e.toErrorMessage=u;function w(C){const E=C;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=w;function v(C,E){let d;return typeof C=="string"?d=new Error(C):d=C,d.actions=E,d}e.createErrorWithActions=v}),define(ee[133],ie([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(ee[134],ie([0,1,133]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[135],ie([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(ee[4],ie([0,1,135]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,D=!1,I=!1,u=!1,w=!1,v=!1,C=!1,E=!1,d,f=e.LANGUAGE_DEFAULT,P,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?p=e.globals.vscode.process:typeof process<"u"&&(p=process);const S=typeof p?.versions?.electron=="string",m=S&&p?.type==="renderer";if(typeof navigator=="object"&&!m)b=navigator.userAgent,t=b.indexOf("Windows")>=0,k=b.indexOf("Macintosh")>=0,v=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=b.indexOf("Linux")>=0,E=b?.indexOf("Mobi")>=0,u=!0,d=y.getConfiguredDefaultLocale(y.localize(0,null))||e.LANGUAGE_DEFAULT,f=d;else if(typeof p=="object"){t=p.platform==="win32",k=p.platform==="darwin",R=p.platform==="linux",D=R&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,w=S,C=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const o=p.env.VSCODE_NLS_CONFIG;if(o)try{const g=JSON.parse(o),M=g.availableLanguages["*"];d=g.locale,f=M||e.LANGUAGE_DEFAULT,P=g._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let s=0;k?s=1:t?s=3:R&&(s=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=D,e.isNative=I,e.isElectron=w,e.isWeb=u,e.isWebWorker=u&&typeof e.globals.importScripts=="function",e.isIOS=v,e.isMobile=E,e.isCI=C,e.platform=s,e.userAgent=b,e.language=f;var a;(function(o){function g(){return e.language}o.value=g;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=M;function A(){return e.language==="en"}o.isDefault=A})(a=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let A=0,_=o.length;A<_;A++){const G=o[A];if(G.id===M.data.vscodeScheduleAsyncWork){o.splice(A,1),G.callback();return}}});let g=0;return M=>{const A=++g;o.push({id:A,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return o=>setTimeout(o)})();var n;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||v?2:t?1:3;let i=!0,r=!1;function c(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,i=new Uint16Array(o.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[34],ie([0,1,4]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const k=y.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],ie([0,1,34]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,I=46,u=47,w=92,v=58,C=63;class E extends Error{constructor(h,l,s){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const n=h.indexOf(".")!==-1?"property":"argument";let i=`The "${h}" ${n} ${a} of type ${l}`;i+=`. Received type ${typeof s}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function d(m,h){if(typeof m!="string")throw new E(h,"string",m)}function f(m){return m===u||m===w}function P(m){return m===u}function b(m){return m>=t&&m<=R||m>=k&&m<=D}function p(m,h,l,s){let a="",n=0,i=-1,r=0,c=0;for(let o=0;o<=m.length;++o){if(o<m.length)c=m.charCodeAt(o);else{if(s(c))break;c=u}if(s(c)){if(!(i===o-1||r===1))if(r===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==I||a.charCodeAt(a.length-2)!==I){if(a.length>2){const g=a.lastIndexOf(l);g===-1?(a="",n=0):(a=a.slice(0,g),n=a.length-1-a.lastIndexOf(l)),i=o,r=0;continue}else if(a.length!==0){a="",n=0,i=o,r=0;continue}}h&&(a+=a.length>0?`${l}..`:"..",n=2)}else a.length>0?a+=`${l}${m.slice(i+1,o)}`:a=m.slice(i+1,o),n=o-i-1;i=o,r=0}else c===I&&r!==-1?++r:r=-1}return a}function S(m,h){if(h===null||typeof h!="object")throw new E("pathObject","Object",h);const l=h.dir||h.root,s=h.base||`${h.name||""}${h.ext||""}`;return l?l===h.root?`${l}${s}`:`${l}${m}${s}`:s}e.win32={resolve(...m){let h="",l="",s=!1;for(let a=m.length-1;a>=-1;a--){let n;if(a>=0){if(n=m[a],d(n,"path"),n.length===0)continue}else h.length===0?n=y.cwd():(n=y.env[`=${h}`]||y.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==h.toLowerCase()&&n.charCodeAt(2)===w)&&(n=`${h}\\`));const i=n.length;let r=0,c="",o=!1;const g=n.charCodeAt(0);if(i===1)f(g)&&(r=1,o=!0);else if(f(g))if(o=!0,f(n.charCodeAt(1))){let M=2,A=M;for(;M<i&&!f(n.charCodeAt(M));)M++;if(M<i&&M!==A){const _=n.slice(A,M);for(A=M;M<i&&f(n.charCodeAt(M));)M++;if(M<i&&M!==A){for(A=M;M<i&&!f(n.charCodeAt(M));)M++;(M===i||M!==A)&&(c=`\\\\${_}\\${n.slice(A,M)}`,r=M)}}}else r=1;else b(g)&&n.charCodeAt(1)===v&&(c=n.slice(0,2),r=2,i>2&&f(n.charCodeAt(2))&&(o=!0,r=3));if(c.length>0)if(h.length>0){if(c.toLowerCase()!==h.toLowerCase())continue}else h=c;if(s){if(h.length>0)break}else if(l=`${n.slice(r)}\\${l}`,s=o,o&&h.length>0)break}return l=p(l,!s,"\\",f),s?`${h}\\${l}`:`${h}${l}`||"."},normalize(m){d(m,"path");const h=m.length;if(h===0)return".";let l=0,s,a=!1;const n=m.charCodeAt(0);if(h===1)return P(n)?"\\":m;if(f(n))if(a=!0,f(m.charCodeAt(1))){let r=2,c=r;for(;r<h&&!f(m.charCodeAt(r));)r++;if(r<h&&r!==c){const o=m.slice(c,r);for(c=r;r<h&&f(m.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&!f(m.charCodeAt(r));)r++;if(r===h)return`\\\\${o}\\${m.slice(c)}\\`;r!==c&&(s=`\\\\${o}\\${m.slice(c,r)}`,l=r)}}}else l=1;else b(n)&&m.charCodeAt(1)===v&&(s=m.slice(0,2),l=2,h>2&&f(m.charCodeAt(2))&&(a=!0,l=3));let i=l<h?p(m.slice(l),!a,"\\",f):"";return i.length===0&&!a&&(i="."),i.length>0&&f(m.charCodeAt(h-1))&&(i+="\\"),s===void 0?a?`\\${i}`:i:a?`${s}\\${i}`:`${s}${i}`},isAbsolute(m){d(m,"path");const h=m.length;if(h===0)return!1;const l=m.charCodeAt(0);return f(l)||h>2&&b(l)&&m.charCodeAt(1)===v&&f(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let h,l;for(let n=0;n<m.length;++n){const i=m[n];d(i,"path"),i.length>0&&(h===void 0?h=l=i:h+=`\\${i}`)}if(h===void 0)return".";let s=!0,a=0;if(typeof l=="string"&&f(l.charCodeAt(0))){++a;const n=l.length;n>1&&f(l.charCodeAt(1))&&(++a,n>2&&(f(l.charCodeAt(2))?++a:s=!1))}if(s){for(;a<h.length&&f(h.charCodeAt(a));)a++;a>=2&&(h=`\\${h.slice(a)}`)}return e.win32.normalize(h)},relative(m,h){if(d(m,"from"),d(h,"to"),m===h)return"";const l=e.win32.resolve(m),s=e.win32.resolve(h);if(l===s||(m=l.toLowerCase(),h=s.toLowerCase(),m===h))return"";let a=0;for(;a<m.length&&m.charCodeAt(a)===w;)a++;let n=m.length;for(;n-1>a&&m.charCodeAt(n-1)===w;)n--;const i=n-a;let r=0;for(;r<h.length&&h.charCodeAt(r)===w;)r++;let c=h.length;for(;c-1>r&&h.charCodeAt(c-1)===w;)c--;const o=c-r,g=i<o?i:o;let M=-1,A=0;for(;A<g;A++){const G=m.charCodeAt(a+A);if(G!==h.charCodeAt(r+A))break;G===w&&(M=A)}if(A!==g){if(M===-1)return s}else{if(o>g){if(h.charCodeAt(r+A)===w)return s.slice(r+A+1);if(A===2)return s.slice(r+A)}i>g&&(m.charCodeAt(a+A)===w?M=A:A===2&&(M=3)),M===-1&&(M=0)}let _="";for(A=a+M+1;A<=n;++A)(A===n||m.charCodeAt(A)===w)&&(_+=_.length===0?"..":"\\..");return r+=M,_.length>0?`${_}${s.slice(r,c)}`:(s.charCodeAt(r)===w&&++r,s.slice(r,c))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const h=e.win32.resolve(m);if(h.length<=2)return m;if(h.charCodeAt(0)===w){if(h.charCodeAt(1)===w){const l=h.charCodeAt(2);if(l!==C&&l!==I)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(b(h.charCodeAt(0))&&h.charCodeAt(1)===v&&h.charCodeAt(2)===w)return`\\\\?\\${h}`;return m},dirname(m){d(m,"path");const h=m.length;if(h===0)return".";let l=-1,s=0;const a=m.charCodeAt(0);if(h===1)return f(a)?m:".";if(f(a)){if(l=s=1,f(m.charCodeAt(1))){let r=2,c=r;for(;r<h&&!f(m.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&f(m.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&!f(m.charCodeAt(r));)r++;if(r===h)return m;r!==c&&(l=s=r+1)}}}}else b(a)&&m.charCodeAt(1)===v&&(l=h>2&&f(m.charCodeAt(2))?3:2,s=l);let n=-1,i=!0;for(let r=h-1;r>=s;--r)if(f(m.charCodeAt(r))){if(!i){n=r;break}}else i=!1;if(n===-1){if(l===-1)return".";n=l}return m.slice(0,n)},basename(m,h){h!==void 0&&d(h,"ext"),d(m,"path");let l=0,s=-1,a=!0,n;if(m.length>=2&&b(m.charCodeAt(0))&&m.charCodeAt(1)===v&&(l=2),h!==void 0&&h.length>0&&h.length<=m.length){if(h===m)return"";let i=h.length-1,r=-1;for(n=m.length-1;n>=l;--n){const c=m.charCodeAt(n);if(f(c)){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1),i>=0&&(c===h.charCodeAt(i)?--i===-1&&(s=n):(i=-1,s=r))}return l===s?s=r:s===-1&&(s=m.length),m.slice(l,s)}for(n=m.length-1;n>=l;--n)if(f(m.charCodeAt(n))){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1);return s===-1?"":m.slice(l,s)},extname(m){d(m,"path");let h=0,l=-1,s=0,a=-1,n=!0,i=0;m.length>=2&&m.charCodeAt(1)===v&&b(m.charCodeAt(0))&&(h=s=2);for(let r=m.length-1;r>=h;--r){const c=m.charCodeAt(r);if(f(c)){if(!n){s=r+1;break}continue}a===-1&&(n=!1,a=r+1),c===I?l===-1?l=r:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||a===-1||i===0||i===1&&l===a-1&&l===s+1?"":m.slice(l,a)},format:S.bind(null,"\\"),parse(m){d(m,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return h;const l=m.length;let s=0,a=m.charCodeAt(0);if(l===1)return f(a)?(h.root=h.dir=m,h):(h.base=h.name=m,h);if(f(a)){if(s=1,f(m.charCodeAt(1))){let M=2,A=M;for(;M<l&&!f(m.charCodeAt(M));)M++;if(M<l&&M!==A){for(A=M;M<l&&f(m.charCodeAt(M));)M++;if(M<l&&M!==A){for(A=M;M<l&&!f(m.charCodeAt(M));)M++;M===l?s=M:M!==A&&(s=M+1)}}}}else if(b(a)&&m.charCodeAt(1)===v){if(l<=2)return h.root=h.dir=m,h;if(s=2,f(m.charCodeAt(2))){if(l===3)return h.root=h.dir=m,h;s=3}}s>0&&(h.root=m.slice(0,s));let n=-1,i=s,r=-1,c=!0,o=m.length-1,g=0;for(;o>=s;--o){if(a=m.charCodeAt(o),f(a)){if(!c){i=o+1;break}continue}r===-1&&(c=!1,r=o+1),a===I?n===-1?n=o:g!==1&&(g=1):n!==-1&&(g=-1)}return r!==-1&&(n===-1||g===0||g===1&&n===r-1&&n===i+1?h.base=h.name=m.slice(i,r):(h.name=m.slice(i,n),h.base=m.slice(i,r),h.ext=m.slice(n,r))),i>0&&i!==s?h.dir=m.slice(0,i-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let h="",l=!1;for(let s=m.length-1;s>=-1&&!l;s--){const a=s>=0?m[s]:y.cwd();d(a,"path"),a.length!==0&&(h=`${a}/${h}`,l=a.charCodeAt(0)===u)}return h=p(h,!l,"/",P),l?`/${h}`:h.length>0?h:"."},normalize(m){if(d(m,"path"),m.length===0)return".";const h=m.charCodeAt(0)===u,l=m.charCodeAt(m.length-1)===u;return m=p(m,!h,"/",P),m.length===0?h?"/":l?"./":".":(l&&(m+="/"),h?`/${m}`:m)},isAbsolute(m){return d(m,"path"),m.length>0&&m.charCodeAt(0)===u},join(...m){if(m.length===0)return".";let h;for(let l=0;l<m.length;++l){const s=m[l];d(s,"path"),s.length>0&&(h===void 0?h=s:h+=`/${s}`)}return h===void 0?".":e.posix.normalize(h)},relative(m,h){if(d(m,"from"),d(h,"to"),m===h||(m=e.posix.resolve(m),h=e.posix.resolve(h),m===h))return"";const l=1,s=m.length,a=s-l,n=1,i=h.length-n,r=a<i?a:i;let c=-1,o=0;for(;o<r;o++){const M=m.charCodeAt(l+o);if(M!==h.charCodeAt(n+o))break;M===u&&(c=o)}if(o===r)if(i>r){if(h.charCodeAt(n+o)===u)return h.slice(n+o+1);if(o===0)return h.slice(n+o)}else a>r&&(m.charCodeAt(l+o)===u?c=o:o===0&&(c=0));let g="";for(o=l+c+1;o<=s;++o)(o===s||m.charCodeAt(o)===u)&&(g+=g.length===0?"..":"/..");return`${g}${h.slice(n+c)}`},toNamespacedPath(m){return m},dirname(m){if(d(m,"path"),m.length===0)return".";const h=m.charCodeAt(0)===u;let l=-1,s=!0;for(let a=m.length-1;a>=1;--a)if(m.charCodeAt(a)===u){if(!s){l=a;break}}else s=!1;return l===-1?h?"/":".":h&&l===1?"//":m.slice(0,l)},basename(m,h){h!==void 0&&d(h,"ext"),d(m,"path");let l=0,s=-1,a=!0,n;if(h!==void 0&&h.length>0&&h.length<=m.length){if(h===m)return"";let i=h.length-1,r=-1;for(n=m.length-1;n>=0;--n){const c=m.charCodeAt(n);if(c===u){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1),i>=0&&(c===h.charCodeAt(i)?--i===-1&&(s=n):(i=-1,s=r))}return l===s?s=r:s===-1&&(s=m.length),m.slice(l,s)}for(n=m.length-1;n>=0;--n)if(m.charCodeAt(n)===u){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1);return s===-1?"":m.slice(l,s)},extname(m){d(m,"path");let h=-1,l=0,s=-1,a=!0,n=0;for(let i=m.length-1;i>=0;--i){const r=m.charCodeAt(i);if(r===u){if(!a){l=i+1;break}continue}s===-1&&(a=!1,s=i+1),r===I?h===-1?h=i:n!==1&&(n=1):h!==-1&&(n=-1)}return h===-1||s===-1||n===0||n===1&&h===s-1&&h===l+1?"":m.slice(h,s)},format:S.bind(null,"/"),parse(m){d(m,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return h;const l=m.charCodeAt(0)===u;let s;l?(h.root="/",s=1):s=0;let a=-1,n=0,i=-1,r=!0,c=m.length-1,o=0;for(;c>=s;--c){const g=m.charCodeAt(c);if(g===u){if(!r){n=c+1;break}continue}i===-1&&(r=!1,i=c+1),g===I?a===-1?a=c:o!==1&&(o=1):a!==-1&&(o=-1)}if(i!==-1){const g=n===0&&l?1:n;a===-1||o===0||o===1&&a===i-1&&a===n+1?h.base=h.name=m.slice(g,i):(h.name=m.slice(g,a),h.base=m.slice(g,i),h.ext=m.slice(a,i))}return n>0?h.dir=m.slice(0,n-1):l&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[78],ie([0,1,4]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(I,...u){const w=u.reduce((E,d)=>(E[d]=!0,E),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(E=>!w[E]).forEach(E=>{for(let d=0;d<v.length;d++)if(E.search(v[d])!==-1){delete I[E];break}})}e.sanitizeProcessEnvironment=R;function D(I){!I||(delete I.DEBUG,y.isMacintosh&&delete I.DYLD_LIBRARY_PATH,y.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ee[79],ie([0,1,4]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=y.globals.performance&&typeof y.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ee[3],ie([0,1,16,49,2,94,79]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,u=!1;var w;(function(c){c.None=()=>k.Disposable.None;function o(O){if(u){const{onListenerDidAdd:U}=O,q=f.create();let Y=0;O.onListenerDidAdd=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),U?.()}}}function g(O){return(U,q=null,Y)=>{let se=!1,H;return H=O(re=>{if(!se)return H?H.dispose():se=!0,U.call(q,re)},null,Y),se&&H.dispose(),H}}c.once=g;function M(O,U,q){return X((Y,se=null,H)=>O(re=>Y.call(se,U(re)),null,H),q)}c.map=M;function A(O,U,q){return X((Y,se=null,H)=>O(re=>{U(re),Y.call(se,re)},null,H),q)}c.forEach=A;function _(O,U,q){return X((Y,se=null,H)=>O(re=>U(re)&&Y.call(se,re),null,H),q)}c.filter=_;function G(O){return O}c.signal=G;function ae(...O){return(U,q=null,Y)=>(0,k.combinedDisposable)(...O.map(se=>se(H=>U.call(q,H),null,Y)))}c.any=ae;function Q(O,U,q,Y){let se=q;return M(O,H=>(se=U(se,H),se),Y)}c.reduce=Q;function X(O,U){let q;const Y={onFirstListenerAdd(){q=O(se.fire,se)},onLastListenerRemove(){q?.dispose()}};U||o(Y);const se=new b(Y);return U?.add(se),se.event}function x(O,U,q=100,Y=!1,se,H){let re,ne,ce,ge=0;const Re={leakWarningThreshold:se,onFirstListenerAdd(){re=O(Me=>{ge++,ne=U(ne,Me),Y&&!ce&&(Te.fire(ne),ne=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ne;ne=void 0,ce=void 0,(!Y||ge>1)&&Te.fire(Ae),ge=0},q)})},onLastListenerRemove(){re.dispose()}};H||o(Re);const Te=new b(Re);return H?.add(Te),Te.event}c.debounce=x;function oe(O,U=(Y,se)=>Y===se,q){let Y=!0,se;return _(O,H=>{const re=Y||!U(H,se);return Y=!1,se=H,re},q)}c.latch=oe;function fe(O,U,q){return[c.filter(O,U,q),c.filter(O,Y=>!U(Y),q)]}c.split=fe;function V(O,U=!1,q=[]){let Y=q.slice(),se=O(ne=>{Y?Y.push(ne):re.fire(ne)});const H=()=>{Y?.forEach(ne=>re.fire(ne)),Y=null},re=new b({onFirstListenerAdd(){se||(se=O(ne=>re.fire(ne)))},onFirstListenerDidAdd(){Y&&(U?setTimeout(H):H())},onLastListenerRemove(){se&&se.dispose(),se=null}});return re.event}c.buffer=V;class j{constructor(U){this.event=U,this.disposables=new k.DisposableStore}map(U){return new j(M(this.event,U,this.disposables))}forEach(U){return new j(A(this.event,U,this.disposables))}filter(U){return new j(_(this.event,U,this.disposables))}reduce(U,q){return new j(Q(this.event,U,q,this.disposables))}latch(){return new j(oe(this.event,void 0,this.disposables))}debounce(U,q=100,Y=!1,se){return new j(x(this.event,U,q,Y,se,this.disposables))}on(U,q,Y){return this.event(U,q,Y)}once(U,q,Y){return g(this.event)(U,q,Y)}dispose(){this.disposables.dispose()}}function F(O){return new j(O)}c.chain=F;function T(O,U,q=Y=>Y){const Y=(...ne)=>re.fire(q(...ne)),se=()=>O.on(U,Y),H=()=>O.removeListener(U,Y),re=new b({onFirstListenerAdd:se,onLastListenerRemove:H});return re.event}c.fromNodeEventEmitter=T;function W(O,U,q=Y=>Y){const Y=(...ne)=>re.fire(q(...ne)),se=()=>O.addEventListener(U,Y),H=()=>O.removeEventListener(U,Y),re=new b({onFirstListenerAdd:se,onLastListenerRemove:H});return re.event}c.fromDOMEventEmitter=W;function N(O){return new Promise(U=>g(O)(U))}c.toPromise=N;function J(O,U){return U(void 0),O(q=>U(q))}c.runAndSubscribe=J;function B(O,U){let q=null;function Y(H){q?.dispose(),q=new k.DisposableStore,U(H,q)}Y(void 0);const se=O(H=>Y(H));return(0,k.toDisposable)(()=>{se.dispose(),q?.dispose()})}c.runAndSubscribeWithStore=B;class ${constructor(U,q){this.obs=U,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{U.addObserver(this)},onLastListenerRemove:()=>{U.removeObserver(this)}};q||o(Y),this.emitter=new b(Y),q&&q.add(this.emitter)}beginUpdate(U){this._counter++}handleChange(U,q){this._hasChanged=!0}endUpdate(U){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,U){return new $(O,U).emitter.event}c.fromObservable=L})(w=e.Event||(e.Event={}));class v{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${v._idPool++}`,v.all.add(this)}start(o){this._stopWatch=new D.StopWatch(!0),this.listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=v,v.all=new Set,v._idPool=0;let C=-1;function E(c){const o=C;return C=c,{dispose(){C=o}}}e.setGlobalLeakWarningThreshold=E;class d{constructor(o,g=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,g){let M=C;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||g<M)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let _,G=0;for(const[ae,Q]of this._stacks)(!_||G<Q)&&(_=ae,G=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${G}):`),console.warn(_)}return()=>{const _=this._stacks.get(o.value)||0;this._stacks.set(o.value,_-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class P{constructor(o,g,M){this.callback=o,this.callbackThis=g,this.stack=M,this.subscription=new k.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=C>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new v(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const g of o)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,g,M)=>{this._listeners||(this._listeners=new R.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let _,G;this._leakageMon&&this._listeners.size>=30&&(G=f.create(),_=this._leakageMon.check(G,this._listeners.size+1)),I&&(G=G??f.create());const ae=new P(o,g,G),Q=this._listeners.push(ae);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,g);const X=ae.subscription.set(()=>{_?.(),this._disposed||(Q(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(X):Array.isArray(M)&&M.push(X),X}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(const g of this._listeners)this._deliveryQueue.push(this,g,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(o,g,M){this._queue.push(new m(o,g,M))}clear(o){const g=new R.LinkedList;for(const M of this._queue)M.emitter!==o&&g.push(M);this._queue=g}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(g){(0,y.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=p;class S extends p{clear(o){this._queue.clear()}}class m{constructor(o,g,M){this.emitter=o,this.listener=g,this.event=M}}class h extends b{async fireAsync(o,g,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,o]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[A,_]=this._asyncDeliveryQueue.shift(),G=[],ae={..._,token:g,waitUntil:Q=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");M&&(Q=M(Q,A.callback)),G.push(Q)}};try{A.invoke(ae)}catch(Q){(0,y.onUnexpectedError)(Q);continue}Object.freeze(G),await Promise.allSettled(G).then(Q=>{for(const X of Q)X.status==="rejected"&&(0,y.onUnexpectedError)(X.reason)})}}}}e.AsyncEmitter=h;class l extends b{constructor(o){super(o),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=l;class s extends l{constructor(o){super(o),this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=s;class a extends b{constructor(o){super(o),this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){!this.hasListeners()||(this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=a;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const g={event:o,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const M=()=>{this.hasListeners&&this.unhook(g);const A=this.events.indexOf(g);this.events.splice(A,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(g=>this.emitter.fire(g))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(o){return(g,M,A)=>o(_=>{const G=this.buffers[this.buffers.length-1];G?G.push(()=>g.call(M,_)):g.call(M,_)},void 0,A)}bufferEvents(o){const g=[];this.buffers.push(g);const M=o();return this.buffers.pop(),g.forEach(A=>A()),M}}e.EventBufferer=i;class r{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(ee[23],ie([0,1,3]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,u){const w=setTimeout(I.bind(u),0);return{dispose(){clearTimeout(w)}}});var k;(function(I){function u(w){return w===I.None||w===I.Cancelled||w instanceof R?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}I.isCancellationToken=u,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(ee[136],ie([0,1,23]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new y.CancellationTokenSource,u=this.task(I.token);return this.result={promise:u,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class k{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const u=JSON.stringify(I);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=k;class R{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const u=this.fn(I);return this._map.set(I,u),u}}e.CachedFunction=R}),define(ee[96],ie([0,1,3,2]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:y.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}constructor(I){super(),this._value=I,this.changeEmitter=this._register(new y.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(ee[26],ie([0,1,136,123]),function(z,e,y,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function I(K,...le){return le.length===0?K:K.replace(D,function(he,me){const Ee=parseInt(me,10);return isNaN(Ee)||Ee<0||Ee>=le.length?he:le[Ee]})}e.format=I;const u=/{([^}]+)}/g;function w(K,le){return K.replace(u,(he,me)=>le[me]??he)}e.format2=w;function v(K){return K.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=v;function C(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function E(K,le){let he=0;const me=le.charCodeAt(0);for(let Ee=K.length-1;Ee>=0;Ee--)K.charCodeAt(Ee)===me&&he++;return he}e.count=E;function d(K,le,he="\u2026"){return K.length<=le?K:`${K.substr(0,le)}${he}`}e.truncate=d;function f(K,le=" "){const he=P(K,le);return b(he,le)}e.trim=f;function P(K,le){if(!K||!le)return K;const he=le.length;if(he===0||K.length===0)return K;let me=0;for(;K.indexOf(le,me)===me;)me=me+he;return K.substring(me)}e.ltrim=P;function b(K,le){if(!K||!le)return K;const he=le.length,me=K.length;if(he===0||me===0)return K;let Ee=me,Le=-1;for(;Le=K.lastIndexOf(le,Ee-1),!(Le===-1||Le+he!==Ee);){if(Le===0)return"";Ee=Le}return K.substring(0,Ee)}e.rtrim=b;function p(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function S(K){return K.replace(/\*/g,"")}e.stripWildcards=S;function m(K,le,he={}){if(!K)throw new Error("Cannot create regex from empty string");le||(K=C(K)),he.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(K,me)}e.createRegExp=m;function h(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function l(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function s(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=s;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function n(K){for(let le=0,he=K.length;le<he;le++){const me=K.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=n;function i(K,le=0,he=K.length){for(let me=le;me<he;me++){const Ee=K.charCodeAt(me);if(Ee!==32&&Ee!==9)return K.substring(le,me)}return K.substring(le,he)}e.getLeadingWhitespace=i;function r(K,le=K.length-1){for(let he=le;he>=0;he--){const me=K.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=r;function c(K,le,he){const me=[];let Ee=0;for(const Le of K.matchAll(le)){if(me.push(K.slice(Ee,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Ee=Le.index+Le[0].length,me.push(he(Le[0],...Le.slice(1),Le.index,K,Le.groups))}return me.push(K.slice(Ee)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=c;function o(K,le){return K<le?-1:K>le?1:0}e.compare=o;function g(K,le,he=0,me=K.length,Ee=0,Le=le.length){for(;he<me&&Ee<Le;he++,Ee++){const Je=K.charCodeAt(he),je=le.charCodeAt(Ee);if(Je<je)return-1;if(Je>je)return 1}const Ue=me-he,it=Le-Ee;return Ue<it?-1:Ue>it?1:0}e.compareSubstring=g;function M(K,le){return A(K,le,0,K.length,0,le.length)}e.compareIgnoreCase=M;function A(K,le,he=0,me=K.length,Ee=0,Le=le.length){for(;he<me&&Ee<Le;he++,Ee++){let Je=K.charCodeAt(he),je=le.charCodeAt(Ee);if(Je===je)continue;if(Je>=128||je>=128)return g(K.toLowerCase(),le.toLowerCase(),he,me,Ee,Le);G(Je)&&(Je-=32),G(je)&&(je-=32);const et=Je-je;if(et!==0)return et}const Ue=me-he,it=Le-Ee;return Ue<it?-1:Ue>it?1:0}e.compareSubstringIgnoreCase=A;function _(K){return K>=48&&K<=57}e.isAsciiDigit=_;function G(K){return K>=97&&K<=122}e.isLowerAsciiLetter=G;function ae(K){return K>=65&&K<=90}e.isUpperAsciiLetter=ae;function Q(K,le){return K.length===le.length&&A(K,le)===0}e.equalsIgnoreCase=Q;function X(K,le){const he=le.length;return le.length>K.length?!1:A(K,le,0,he)===0}e.startsWithIgnoreCase=X;function x(K,le){const he=Math.min(K.length,le.length);let me;for(me=0;me<he;me++)if(K.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=x;function oe(K,le){const he=Math.min(K.length,le.length);let me;const Ee=K.length-1,Le=le.length-1;for(me=0;me<he;me++)if(K.charCodeAt(Ee-me)!==le.charCodeAt(Le-me))return me;return he}e.commonSuffixLength=oe;function fe(K){return 55296<=K&&K<=56319}e.isHighSurrogate=fe;function V(K){return 56320<=K&&K<=57343}e.isLowSurrogate=V;function j(K,le){return(K-55296<<10)+(le-56320)+65536}e.computeCodePoint=j;function F(K,le,he){const me=K.charCodeAt(he);if(fe(me)&&he+1<le){const Ee=K.charCodeAt(he+1);if(V(Ee))return j(me,Ee)}return me}e.getNextCodePoint=F;function T(K,le){const he=K.charCodeAt(le-1);if(V(he)&&le>1){const me=K.charCodeAt(le-2);if(fe(me))return j(me,he)}return he}class W{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=T(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class N{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new W(le,he)}nextGraphemeLength(){const le=Fe.getInstance(),he=this._iterator,me=he.offset;let Ee=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Le=he.offset,Ue=le.getGraphemeBreakType(he.nextCodePoint());if(ye(Ee,Ue)){he.setOffset(Le);break}Ee=Ue}return he.offset-me}prevGraphemeLength(){const le=Fe.getInstance(),he=this._iterator,me=he.offset;let Ee=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Le=he.offset,Ue=le.getGraphemeBreakType(he.prevCodePoint());if(ye(Ue,Ee)){he.setOffset(Le);break}Ee=Ue}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=N;function J(K,le){return new N(K,le).nextGraphemeLength()}e.nextCharLength=J;function B(K,le){return new N(K,le).prevGraphemeLength()}e.prevCharLength=B;function $(K,le){le>0&&V(K.charCodeAt(le))&&le--;const he=le+J(K,le);return[he-B(K,he),he]}e.getCharContainingOffset=$;function L(K){const le=new N(K);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=L;let O;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(K){return O||(O=U()),O.test(K)}e.containsRTL=q;const Y=/^[\t\n\r\x20-\x7E]*$/;function se(K){return Y.test(K)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=H;function re(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=re;function ne(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ne;function ce(K,le){if(K.length<le)return K;const he=/\b/g;let me=0;for(;he.test(K)&&!(K.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return K.substring(me).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,Re=/\x1b\[\d+m/g,Te=/\x1b\[0?m/g;function Me(K){return K&&(K=K.replace(ge,""),K=K.replace(Re,""),K=K.replace(Te,"")),K}e.removeAnsiEscapeCodes=Me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=ve;function pe(K,le){if(!K||!le||K.length<le.length)return!1;const he=le.length,me=K.toLowerCase();let Ee=0,Le=-1;for(;Ee<he;){const Ue=me.indexOf(le[Ee],Le+1);if(Ue<0)return!1;Le=Ue,Ee++}return!0}e.fuzzyContains=pe;function Se(K,le=!1){return K?(le&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=ke;function Z(K,le=1){if(le===0)return"";let he=-1;do he=K.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?K:(K[he-1]==="\r"&&he--,K.substr(0,he))}e.getNLines=Z;function ue(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=ue;function de(K){return Fe.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=de;function ye(K,le){return K===0?le!==5&&le!==7:K===2&&le===3?!1:K===4||K===2||K===3||le===4||le===2||le===3?!0:!(K===8&&(le===8||le===9||le===11||le===12)||(K===11||K===9)&&(le===9||le===10)||(K===12||K===10)&&le===10||le===5||le===13||le===7||K===1||K===13&&le===14||K===6&&le===6)}var Ce;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let Ee=1;for(;Ee<=me;)if(le<he[3*Ee])Ee=2*Ee;else if(le>he[3*Ee+1])Ee=2*Ee+1;else return he[3*Ee+2];return 0}}Fe._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(K,le){if(K===0)return 0;const he=Ne(K,le);if(he!==void 0)return he;const me=new W(le,K);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=$e;function Ne(K,le){const he=new W(le,K);let me=he.prevCodePoint();for(;He(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!ne(me))return;let Ee=he.offset;return Ee>0&&he.prevCodePoint()===8205&&(Ee=he.offset),Ee}function He(K){return 127995<=K&&K<=127999}var Qe;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(le){return Be.cache.get(Array.from(le))}static getLocales(){return Be._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,k=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new y.LRUCachedFunction(K=>{function le(je){const et=new Map;for(let nt=0;nt<je.length;nt+=2)et.set(je[nt],je[nt+1]);return et}function he(je,et){const nt=new Map(je);for(const[lt,gt]of et)nt.set(lt,gt);return nt}function me(je,et){if(!je)return et;const nt=new Map;for(const[lt,gt]of je)et.has(lt)&&nt.set(lt,gt);return nt}const Ee=k.ambiguousCharacterData.getValue();let Le=K.filter(je=>!je.startsWith("_")&&je in Ee);Le.length===0&&(Le=["_default"]);let Ue;for(const je of Le){const et=le(Ee[je]);Ue=me(Ue,et)}const it=le(Ee._common),Je=he(it,Ue);return new Be(Je)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(le){return Ge.getData().has(le)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(ee[31],ie([0,1,9,4,26,12]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function I(r){return r.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=I;function u(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=u;function w(r,c=y.posix.sep){if(!r)return"";const o=r.length,g=r.charCodeAt(0);if(D(g)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let A=3;const _=A;for(;A<o&&!D(r.charCodeAt(A));A++);if(_!==A&&!D(r.charCodeAt(A+1))){for(A+=1;A<o;A++)if(D(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,c)}}return c}else if(p(g)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let M=r.indexOf("://");if(M!==-1){for(M+=3;M<o;M++)if(D(r.charCodeAt(M)))return r.slice(0,M+1)}return""}e.getRoot=w;function v(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const g=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(g===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=v;const C=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,c=t.isWindows){const o=c?C:E;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&d.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function P(r,c,o){const g=r===c;return!o||g?g:!r||!c?!1:(0,k.equalsIgnoreCase)(r,c)}e.isEqual=P;function b(r,c,o,g=y.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let A=c.length;return c.charAt(c.length-1)===g&&A--,r.charAt(A)===g}return c.charAt(c.length-1)!==g&&(c+=g),r.indexOf(c)===0}e.isEqualOrParent=b;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function S(r,c){return t.isWindows&&r.endsWith(":")&&(r+=y.sep),(0,y.isAbsolute)(r)||(r=(0,y.join)(c,r)),r=(0,y.normalize)(r),t.isWindows?(r=(0,k.rtrim)(r,y.sep),r.endsWith(":")&&(r+=y.sep)):(r=(0,k.rtrim)(r,y.sep),r||(r=y.sep)),r}e.sanitizeFilePath=S;function m(r){const c=(0,y.normalize)(r);return t.isWindows?r.length>3?!1:h(c)&&(r.length===2||c.charCodeAt(2)===92):c===y.posix.sep}e.isRootOrDriveLetter=m;function h(r,c=t.isWindows){return c?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function l(r){return h(r)?r[0]:void 0}e.getDriveLetter=l;function s(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=s;function a(r){const c=r.split(":");let o,g,M;for(const A of c){const _=Number(A);(0,R.isNumber)(_)?g===void 0?g=_:M===void 0&&(M=_):o=o?[o,A].join(":"):A}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:M!==void 0?M:g!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,c,o=8){let g="";for(let A=0;A<o;A++)g+=n.charAt(Math.floor(Math.random()*n.length));let M;return c?M=`${c}-${g}`:M=g,r?(0,y.join)(r,M):M}e.randomPath=i}),define(ee[66],ie([0,1,26]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,S){switch(typeof p){case"object":return p===null?R(349,S):Array.isArray(p)?u(p,S):w(p,S);case"string":return I(p,S);case"boolean":return D(p,S);case"number":return R(p,S);case"undefined":return R(937,S);default:return R(617,S)}}e.doHash=k;function R(p,S){return(S<<5)-S+p|0}e.numberHash=R;function D(p,S){return R(p?433:863,S)}function I(p,S){S=R(149417,S);for(let m=0,h=p.length;m<h;m++)S=R(p.charCodeAt(m),S);return S}e.stringHash=I;function u(p,S){return S=R(104579,S),p.reduce((m,h)=>k(h,m),S)}function w(p,S){return S=R(181387,S),Object.keys(p).sort().reduce((m,h)=>(m=I(h,m),k(p[h],m)),S)}class v{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=v;var C;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function E(p,S,m=32){const h=m-S,l=~((1<<h)-1);return(p<<S|(l&p)>>>h)>>>0}function d(p,S=0,m=p.byteLength,h=0){for(let l=0;l<m;l++)p[S+l]=h}function f(p,S,m="0"){for(;p.length<S;)p=m+p;return p}function P(p,S=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(m=>m.toString(16).padStart(2,"0")).join(""):f((p>>>0).toString(16),S/4)}e.toHexString=P;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const m=S.length;if(m===0)return;const h=this._buff;let l=this._buffLen,s=this._leftoverHighSurrogate,a,n;for(s!==0?(a=s,n=-1,s=0):(a=S.charCodeAt(0),n=0);;){let i=a;if(y.isHighSurrogate(a))if(n+1<m){const r=S.charCodeAt(n+1);y.isLowSurrogate(r)?(n++,i=y.computeCodePoint(a,r)):i=65533}else{s=a;break}else y.isLowSurrogate(a)&&(i=65533);if(l=this._push(h,l,i),n++,n<m)a=S.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=s}_push(S,m,h){return h<128?S[m++]=h:h<2048?(S[m++]=192|(h&1984)>>>6,S[m++]=128|(h&63)>>>0):h<65536?(S[m++]=224|(h&61440)>>>12,S[m++]=128|(h&4032)>>>6,S[m++]=128|(h&63)>>>0):(S[m++]=240|(h&1835008)>>>18,S[m++]=128|(h&258048)>>>12,S[m++]=128|(h&4032)>>>6,S[m++]=128|(h&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),P(this._h0)+P(this._h1)+P(this._h2)+P(this._h3)+P(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=b._bigBlock32,m=this._buffDV;for(let o=0;o<64;o+=4)S.setUint32(o,m.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)S.setUint32(o,E(S.getUint32(o-12,!1)^S.getUint32(o-32,!1)^S.getUint32(o-56,!1)^S.getUint32(o-64,!1),1),!1);let h=this._h0,l=this._h1,s=this._h2,a=this._h3,n=this._h4,i,r,c;for(let o=0;o<80;o++)o<20?(i=l&s|~l&a,r=1518500249):o<40?(i=l^s^a,r=1859775393):o<60?(i=l&s|l&a|s&a,r=2400959708):(i=l^s^a,r=3395469782),c=E(h,5)+i+n+r+S.getUint32(o*4,!1)&4294967295,n=a,a=s,s=E(l,30),l=h,h=c;this._h0=this._h0+h&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[29],ie([0,1,24,26]),function(z,e,y,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(n,i,r){let c=n.get(i);return c===void 0&&(c=r,n.set(i,c)),c}e.getOrSet=I;function u(n){const i=[];return n.forEach((r,c)=>{i.push(`${c} => ${r}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=u;function w(n){const i=[];return n.forEach(r=>{i.push(r)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=w;class v{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}e.StringIterator=v;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class E{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const c=this._value.charCodeAt(r);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var d;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(d||(d={}));class f{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(b||(b={}));class p{static forUris(i=()=>!1,r=()=>!1){return new p(new f(i,r))}static forPaths(i=!1){return new p(new E(void 0,!i))}static forStrings(){return new p(new v)}static forConfigKeys(){return new p(new C)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,r){if(r){const c=r.slice(0);(0,y.shuffle)(c);for(const o of c)this.set(o,i)}else{const c=i.slice(0);(0,y.shuffle)(c);for(const o of c)this.set(o[0],o[1])}}set(i,r){const c=this._iter.reset(i);let o;this._root||(this._root=new P,this._root.segment=c.value());const g=[];for(o=this._root;;){const A=c.cmp(o.segment);if(A>0)o.left||(o.left=new P,o.left.segment=c.value()),g.push([-1,o]),o=o.left;else if(A<0)o.right||(o.right=new P,o.right.segment=c.value()),g.push([1,o]),o=o.right;else if(c.hasNext())c.next(),o.mid||(o.mid=new P,o.mid.segment=c.value()),g.push([0,o]),o=o.mid;else break}const M=o.value;o.value=r,o.key=i;for(let A=g.length-1;A>=0;A--){const _=g[A][1];_.updateHeight();const G=_.balanceFactor();if(G<-1||G>1){const ae=g[A][0],Q=g[A+1][0];if(ae===1&&Q===1)g[A][1]=_.rotateLeft();else if(ae===-1&&Q===-1)g[A][1]=_.rotateRight();else if(ae===1&&Q===-1)_.right=g[A+1][1]=g[A+1][1].rotateRight(),g[A][1]=_.rotateLeft();else if(ae===-1&&Q===1)_.left=g[A+1][1]=g[A+1][1].rotateLeft(),g[A][1]=_.rotateRight();else throw new Error;if(A>0)switch(g[A-1][0]){case-1:g[A-1][1].left=g[A][1];break;case 1:g[A-1][1].right=g[A][1];break;case 0:g[A-1][1].mid=g[A][1];break}else this._root=g[0][1]}}return M}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const o=r.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const c=this._iter.reset(i),o=[];let g=this._root;for(;g;){const M=c.cmp(g.segment);if(M>0)o.push([-1,g]),g=g.left;else if(M<0)o.push([1,g]),g=g.right;else if(c.hasNext())c.next(),o.push([0,g]),g=g.mid;else break}if(!!g){if(r?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const M=this._min(g.right);if(M.key){const{key:A,value:_,segment:G}=M;this._delete(M.key,!1),g.key=A,g.value=_,g.segment=G}}else{const M=g.left??g.right;if(o.length>0){const[A,_]=o[o.length-1];switch(A){case-1:_.left=M;break;case 0:_.mid=M;break;case 1:_.right=M;break}}else this._root=M}for(let M=o.length-1;M>=0;M--){const A=o[M][1];A.updateHeight();const _=A.balanceFactor();if(_>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),o[M][1]=A.rotateLeft()):_<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),o[M][1]=A.rotateRight()),M>0)switch(o[M-1][0]){case-1:o[M-1][1].left=o[M][1];break;case 1:o[M-1][1].right=o[M][1];break;case 0:o[M-1][1].mid=o[M][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let c=this._root,o;for(;c;){const g=r.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(r.hasNext())r.next(),o=c.value||o,c=c.mid;else break}return c&&c.value||o}findSuperstr(i){const r=this._iter.reset(i);let c=this._root;for(;c;){const o=r.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[r,c]of this)i(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const c=r.balanceFactor();return c<-1||c>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=p;class S{constructor(i,r){this.uri=i,this.value=r}}class m{constructor(i,r){this[k]="ResourceMap",i instanceof m?(this.map=new Map(i.map),this.toKey=r??m.defaultToKey):(this.map=new Map,this.toKey=i??m.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new S(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r<"u"&&(i=i.bind(r));for(const[c,o]of this.map)i(o.value,o.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=m,m.defaultToKey=n=>n.toString();class h{constructor(i,r){this[R]="ResourceSet",!i||typeof i=="function"?this._map=new m(i):(this._map=new m(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((c,o)=>i.call(r,o,o,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var l;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class s{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const c=this._map.get(i);if(!!c)return r!==0&&this.touch(c,r),c.value}set(i,r,c=0){let o=this._map.get(i);if(o)o.value=r,c!==0&&this.touch(o,c);else{switch(o={key:i,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const c=this._state;let o=this._head;for(;o;){if(r?i.bind(r)(o.value,o.key,this):i(o.value,o.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:c.key,done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return o}values(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:c.value,done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return o}entries(){const i=this,r=this._state;let c=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:[c.key,c.value],done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return o}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>i;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,c=i.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const c=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(c.previous=o,o.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const c=i.next,o=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=o,o.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,c)=>{i.push([c,r])}),i}fromJSON(i){this.clear();for(const[r,c]of i)this.set(r,c)}}e.LinkedMap=s;class a extends s{constructor(i,r=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a}),define(ee[80],ie([0,1,29]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new y.LRUCache(1e4);function k(w){return u(w,"NFC",t)}e.normalizeNFC=k;const R=new y.LRUCache(1e4);function D(w){return u(w,"NFD",R)}e.normalizeNFD=D;const I=/[^\u0000-\u0080]/;function u(w,v,C){if(!w)return w;const E=C.get(w);if(E)return E;let d;return I.test(w)?d=w.normalize(v):d=w,C.set(w,d),d}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(v){return D(v).replace(w,"")}}()}),define(ee[97],ie([0,1,26]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",I="warn",u="info",w="ignore";function v(E){return E?y.equalsIgnoreCase(R,E)?k.Error:y.equalsIgnoreCase(D,E)||y.equalsIgnoreCase(I,E)?k.Warning:y.equalsIgnoreCase(u,E)?k.Info:k.Ignore:k.Ignore}k.fromValue=v;function C(E){switch(E){case k.Error:return R;case k.Warning:return D;case k.Info:return u;default:return w}}k.toString=C}(t||(t={})),e.default=t}),define(ee[7],ie([0,1,9,4]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function I(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(n,i){return!n&&!i?"file":n}function w(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const v="",C="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,c,o,g,M=!1){typeof i=="object"?(this.scheme=i.scheme||v,this.authority=i.authority||v,this.path=i.path||v,this.query=i.query||v,this.fragment=i.fragment||v):(this.scheme=u(i,M),this.authority=r||v,this.path=w(this.scheme,c||v),this.query=o||v,this.fragment=g||v,I(this,M))}get fsPath(){return m(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:c,path:o,query:g,fragment:M}=i;return r===void 0?r=this.scheme:r===null&&(r=v),c===void 0?c=this.authority:c===null&&(c=v),o===void 0?o=this.path:o===null&&(o=v),g===void 0?g=this.query:g===null&&(g=v),M===void 0?M=this.fragment:M===null&&(M=v),r===this.scheme&&c===this.authority&&o===this.path&&g===this.query&&M===this.fragment?this:new P(r,c,o,g,M)}static parse(i,r=!1){const c=E.exec(i);return c?new P(c[2]||v,a(c[4]||v),a(c[5]||v),a(c[7]||v),a(c[9]||v),r):new P(v,v,v,v,v)}static file(i){let r=v;if(t.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(r=i.substring(2),i=C):(r=i.substring(2,c),i=i.substring(c)||C)}return new P("file",r,i,v,v)}static from(i){const r=new P(i.scheme,i.authority,i.path,i.query,i.fragment);return I(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&i.scheme==="file"?c=d.file(y.win32.join(m(i,!0),...r)).path:c=y.posix.join(i.path,...r),i.with({path:c})}toString(i=!1){return h(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const r=new P(i);return r._formatted=i.external,r._fsPath=i._sep===f?i.fsPath:null,r}}else return i}}e.URI=d;const f=t.isWindows?1:void 0;class P extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(i=!1){return i?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=f),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(n,i){let r,c=-1;for(let o=0;o<n.length;o++){const g=n.charCodeAt(o);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||i&&g===47)c!==-1&&(r+=encodeURIComponent(n.substring(c,o)),c=-1),r!==void 0&&(r+=n.charAt(o));else{r===void 0&&(r=n.substr(0,o));const M=b[g];M!==void 0?(c!==-1&&(r+=encodeURIComponent(n.substring(c,o)),c=-1),r+=M):c===-1&&(c=o)}}return c!==-1&&(r+=encodeURIComponent(n.substring(c))),r!==void 0?r:n}function S(n){let i;for(let r=0;r<n.length;r++){const c=n.charCodeAt(r);c===35||c===63?(i===void 0&&(i=n.substr(0,r)),i+=b[c]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function m(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function h(n,i){const r=i?S:p;let c="",{scheme:o,authority:g,path:M,query:A,fragment:_}=n;if(o&&(c+=o,c+=":"),(g||o==="file")&&(c+=C,c+=C),g){let G=g.indexOf("@");if(G!==-1){const ae=g.substr(0,G);g=g.substr(G+1),G=ae.indexOf(":"),G===-1?c+=r(ae,!1):(c+=r(ae.substr(0,G),!1),c+=":",c+=r(ae.substr(G+1),!1)),c+="@"}g=g.toLowerCase(),G=g.indexOf(":"),G===-1?c+=r(g,!1):(c+=r(g.substr(0,G),!1),c+=g.substr(G))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const G=M.charCodeAt(1);G>=65&&G<=90&&(M=`/${String.fromCharCode(G+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const G=M.charCodeAt(0);G>=65&&G<=90&&(M=`${String.fromCharCode(G+32)}:${M.substr(2)}`)}c+=r(M,!0)}return A&&(c+="?",c+=r(A,!1)),_&&(c+="#",c+=i?_:p(_,!1)),c}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(s)?n.replace(s,i=>l(i)):n}}),define(ee[137],ie([0,1,7]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(w){const v=w;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.isRemoteConsoleLog=t;function k(w){const v=[];let C;try{const E=JSON.parse(w.arguments),d=E[E.length-1];d&&d.__$stack&&(E.pop(),C=d.__$stack),v.push(...E)}catch{v.push("Unable to log remote console arguments",w.arguments)}return{args:v,stack:C}}e.parse=k;function R(w){if(typeof w!="string")return R(k(w).stack);const v=w;if(v){const C=D(v),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(E&&E.length===4)return{uri:y.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=R;function D(w){if(!w)return w;const v=w.indexOf(`
`);return v===-1?w:w.substring(0,v)}function I(w,v){const{args:C,stack:E}=k(w),d=typeof C[0]=="string"&&C.length===1;let f=D(E);f&&(f=`(${f.trim()})`);let P=[];if(typeof C[0]=="string"?f&&d?P=[`%c[${v}] %c${C[0]} %c${f}`,u("blue"),u(""),u("grey")]:P=[`%c[${v}] %c${C[0]}`,u("blue"),u(""),...C.slice(1)]:P=[`%c[${v}]%`,u("blue"),...C],f&&!d&&P.push(f),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,P)}e.log=I;function u(w){return`color: ${w}`}}),define(ee[67],ie([0,1,17,26,7]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(w){return JSON.stringify(w,I)}e.stringify=R;function D(w){let v=JSON.parse(w);return v=u(v),v}e.parse=D;function I(w,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,t.regExpFlags)(v)}:v}function u(w,v=0){if(!w||v>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return k.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 15:return new Date(w.source)}if(w instanceof y.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let C=0;C<w.length;++C)w[C]=u(w[C],v+1);else for(const C in w)Object.hasOwnProperty.call(w,C)&&(w[C]=u(w[C],v+1))}return w}e.revive=u}),define(ee[14],ie([0,1,4,7]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebook="vscode-notebook",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${k.vscodeRemoteResource}`}set(w,v,C){this._hosts[w]=v,this._ports[w]=C}setConnectionToken(w,v){this._connectionTokens[w]=v}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const v=w.authority;let C=this._hosts[v];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const E=this._ports[v],d=this._connectionTokens[v];let f=`path=${encodeURIComponent(w.path)}`;return typeof d=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),t.URI.from({scheme:y.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${C}:${E}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new R;class D{asBrowserUri(w,v){const C=this.toUri(w,v);return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(w,v){const C=this.toUri(w,v);return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==D.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(w,v){return t.URI.isUri(w)?w:t.URI.parse(v.toUrl(w))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var I;(function(u){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(w.get("3"));const v="vscode-coi";function C(d){let f;typeof d=="string"?f=new URL(d).searchParams:d instanceof URL?f=d.searchParams:t.URI.isUri(d)&&(f=new URL(d.toString(!0)).searchParams);const P=f?.get(v);if(!!P)return w.get(P)}u.getHeadersFromQuery=C;function E(d,f,P){if(!globalThis.crossOriginIsolated)return;const b=f&&P?"3":P?"2":"1";d instanceof URLSearchParams?d.set(v,b):d[v]=b}u.addSearchParam=E})(I=e.COI||(e.COI={}))}),define(ee[18],ie([0,1,31,14,9,4,26,7]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(d){return(0,I.uriToFsPath)(d,!0)}e.originalFSPath=u;class w{constructor(f){this._ignorePathCasing=f}compare(f,P,b=!1){return f===P?0:(0,D.compare)(this.getComparisonKey(f,b),this.getComparisonKey(P,b))}isEqual(f,P,b=!1){return f===P?!0:!f||!P?!1:this.getComparisonKey(f,b)===this.getComparisonKey(P,b)}getComparisonKey(f,P=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:P?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,P,b=!1){if(f.scheme===P.scheme){if(f.scheme===t.Schemas.file)return y.isEqualOrParent(u(f),u(P),this._ignorePathCasing(f))&&f.query===P.query&&(b||f.fragment===P.fragment);if((0,e.isEqualAuthority)(f.authority,P.authority))return y.isEqualOrParent(f.path,P.path,this._ignorePathCasing(f),"/")&&f.query===P.query&&(b||f.fragment===P.fragment)}return!1}joinPath(f,...P){return I.URI.joinPath(f,...P)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return k.posix.basename(f.path)}extname(f){return k.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let P;return f.scheme===t.Schemas.file?P=I.URI.file(k.dirname(u(f))).path:(P=k.posix.dirname(f.path),f.authority&&P.length&&P.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),P="/")),f.with({path:P})}normalizePath(f){if(!f.path.length)return f;let P;return f.scheme===t.Schemas.file?P=I.URI.file(k.normalize(u(f))).path:P=k.posix.normalize(f.path),f.with({path:P})}relativePath(f,P){if(f.scheme!==P.scheme||!(0,e.isEqualAuthority)(f.authority,P.authority))return;if(f.scheme===t.Schemas.file){const S=k.relative(u(f),u(P));return R.isWindows?y.toSlashes(S):S}let b=f.path||"/";const p=P.path||"/";if(this._ignorePathCasing(f)){let S=0;for(const m=Math.min(b.length,p.length);S<m&&!(b.charCodeAt(S)!==p.charCodeAt(S)&&b.charAt(S).toLowerCase()!==p.charAt(S).toLowerCase());S++);b=p.substr(0,S)+b.substr(S)}return k.posix.relative(b,p)}resolvePath(f,P){if(f.scheme===t.Schemas.file){const b=I.URI.file(k.resolve(u(f),P));return f.with({authority:b.authority,path:b.path})}return P=y.toPosixPath(P),f.with({path:k.posix.resolve(f.path,P)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,P){return f===P||f!==void 0&&P!==void 0&&(0,D.equalsIgnoreCase)(f,P)}hasTrailingPathSeparator(f,P=k.sep){if(f.scheme===t.Schemas.file){const b=u(f);return b.length>y.getRoot(b).length&&b[b.length-1]===P}else{const b=f.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,P=k.sep){return(0,e.hasTrailingPathSeparator)(f,P)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,P=k.sep){let b=!1;if(f.scheme===t.Schemas.file){const p=u(f);b=p!==void 0&&p.length===y.getRoot(p).length&&p[p.length-1]===P}else{P="/";const p=f.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(f,P)?f.with({path:f.path+"/"}):f}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(d=>d.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(d,f){const P=[];for(let b=0;b<d.length;b++){const p=f(d[b]);d.some((S,m)=>m===b?!1:(0,e.isEqualOrParent)(p,f(S)))||P.push(d[b])}return P}e.distinctParents=v;var C;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function f(P){const b=new Map;P.path.substring(P.path.indexOf(";")+1,P.path.lastIndexOf(";")).split(";").forEach(m=>{const[h,l]=m.split(":");h&&l&&b.set(h,l)});const S=P.path.substring(0,P.path.indexOf(";"));return S&&b.set(d.META_DATA_MIME,S),b}d.parseMetaData=f})(C=e.DataUri||(e.DataUri={}));function E(d,f,P){if(f){let b=d.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),d.with({scheme:P,authority:f,path:b})}return d.with({scheme:P})}e.toLocalResource=E}),define(ee[8],ie([0,1,23,16,3,2,18,4]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u($){return!!$&&typeof $.then=="function"}e.isThenable=u;function w($){const L=new y.CancellationTokenSource,O=$(L.token),U=new Promise((q,Y)=>{const se=L.token.onCancellationRequested(()=>{se.dispose(),L.dispose(),Y(new t.CancellationError)});Promise.resolve(O).then(H=>{se.dispose(),L.dispose(),q(H)},H=>{se.dispose(),L.dispose(),Y(H)})});return new class{cancel(){L.cancel()}then(q,Y){return U.then(q,Y)}catch(q){return this.then(void 0,q)}finally(q){return U.finally(q)}}}e.createCancelablePromise=w;function v($,L,O){return new Promise((U,q)=>{const Y=L.onCancellationRequested(()=>{Y.dispose(),U(O)});$.then(U,q).finally(()=>Y.dispose())})}e.raceCancellation=v;function C($,L){return new Promise((O,U)=>{const q=L.onCancellationRequested(()=>{q.dispose(),U(new t.CancellationError)});$.then(O,U).finally(()=>q.dispose())})}e.raceCancellationError=C;async function E($){let L=-1;const O=$.map((q,Y)=>q.then(se=>(L=Y,se))),U=await Promise.race(O);return $.forEach((q,Y)=>{Y!==L&&q.cancel()}),U}e.raceCancellablePromises=E;function d($,L,O){let U;const q=setTimeout(()=>{U?.(void 0),O?.()},L);return Promise.race([$.finally(()=>clearTimeout(q)),new Promise(Y=>U=Y)])}e.raceTimeout=d;function f($){return new Promise((L,O)=>{const U=$();u(U)?U.then(L,O):L(U)})}e.asPromise=f;class P{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(O,O).then(U)})}return new Promise((O,U)=>{this.queuedPromise.then(O,U)})}return this.activePromise=L(),new Promise((O,U)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,U(q)})})}}e.Throttler=P;class b{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=b;class p{constructor(){this.promiseMap=new Map}queue(L,O){const q=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,q),q}}e.SequencerByKey=p;const S=($,L)=>{let O=!0;const U=setTimeout(()=>{O=!1,L()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(U),O=!1}}},m=$=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,$())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,Y)=>{this.doResolve=q,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?m(U):S(O,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class l{constructor(L){this.delayer=new h(L),this.throttler=new P}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class s{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class a extends s{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function n($,L){return L?new Promise((O,U)=>{const q=setTimeout(()=>{Y.dispose(),O()},$),Y=L.onCancellationRequested(()=>{clearTimeout(q),Y.dispose(),U(new t.CancellationError)})}):w(O=>n($,O))}e.timeout=n;function i($,L=0){const O=setTimeout($,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function r($){const L=[];let O=0;const U=$.length;function q(){return O<U?$[O++]():null}function Y(se){se!=null&&L.push(se);const H=q();return H?H.then(Y):Promise.resolve(L)}return Promise.resolve(null).then(Y)}e.sequence=r;function c($,L=U=>!!U,O=null){let U=0;const q=$.length,Y=()=>{if(U>=q)return Promise.resolve(O);const se=$[U++];return Promise.resolve(se()).then(re=>L(re)?Promise.resolve(re):Y())};return Y()}e.first=c;function o($,L=U=>!!U,O=null){if($.length===0)return Promise.resolve(O);let U=$.length;const q=()=>{U=-1;for(const Y of $)Y.cancel?.()};return new Promise((Y,se)=>{for(const H of $)H.then(re=>{--U>=0&&L(re)?(q(),Y(re)):U===0&&Y(O)}).catch(re=>{--U>=0&&(q(),se(re))})})}e.firstParallel=o;class g{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,U)=>{this.outstandingPromises.push({factory:L,c:O,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class M extends g{constructor(){super(1)}}e.Queue=M;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const U=O.getComparisonKey(L);let q=this.queues.get(U);return q||(q=new M,k.Event.once(q.onDrained)(()=>{q?.dispose(),this.queues.delete(U),this.onDidQueueDrain()}),this.queues.set(U,q)),q}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class _{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=_;class G{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=G;class ae{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ae;class Q{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Q;class X extends ae{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X;class x extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,I.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=($,L)=>{const O=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(O))}}}}();class oe{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=oe;async function fe($,L,O){let U;for(let q=0;q<O;q++)try{return await $()}catch(Y){U=Y,await n(L)}throw U}e.retry=fe;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,U){return this._pending={taskId:L,cancel:()=>U?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,U;const q=new Promise((Y,se)=>{O=Y,U=se});this._next={run:L,promise:q,promiseResolve:O,promiseReject:U}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=V;class j{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class F{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var T;(function($){async function L(U){let q;const Y=await Promise.all(U.map(se=>se.then(H=>H,H=>{q||(q=H)})));if(typeof q<"u")throw q;return Y}$.settled=L;function O(U){return new Promise(async(q,Y)=>{try{await U(q,Y)}catch(se){Y(se)}})}$.withAsyncBody=O})(T=e.Promises||(e.Promises={}));var W;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(W||(W={}));class N{static fromArray(L){return new N(O=>{O.emitMany(L)})}static fromPromise(L){return new N(async O=>{O.emitMany(await L)})}static fromPromises(L){return new N(async O=>{await Promise.all(L.map(async U=>O.emitOne(await U)))})}static merge(L){return new N(async O=>{await Promise.all(L.map(async U=>{for await(const q of U)O.emitOne(q)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(L(O)),this.resolve()}catch(U){this.reject(U)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new N(async U=>{for await(const q of L)U.emitOne(O(q))})}map(L){return N.map(this,L)}static filter(L,O){return new N(async U=>{for await(const q of L)O(q)&&U.emitOne(q)})}filter(L){return N.filter(this,L)}static coalesce(L){return N.filter(L,O=>!!O)}coalesce(){return N.coalesce(this)}static async toPromise(L){const O=[];for await(const U of L)O.push(U);return O}toPromise(){return N.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=N,N.EMPTY=N.fromArray([]);class J extends N{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function B($){const L=new y.CancellationTokenSource,O=$(L.token);return new J(L,async U=>{const q=L.token.onCancellationRequested(()=>{q.dispose(),L.dispose(),U.reject(new t.CancellationError)});try{for await(const Y of O){if(L.token.isCancellationRequested)return;U.emitOne(Y)}q.dispose(),L.dispose()}catch(Y){q.dispose(),L.dispose(),U.reject(Y)}})}e.createCancelableAsyncIterable=B}),define(ee[98],ie([0,1,24,8,31,29,9,4,26]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const v="[/\\\\]",C="[^/\\\\]",E=/\//g;function d(F,T){switch(F){case 0:return"";case 1:return`${C}*?`;default:return`(?:${v}|${C}+${v}${T?`|${v}${C}+`:""})*?`}}function f(F,T){if(!F)return[];const W=[];let N=!1,J=!1,B="";for(const $ of F){switch($){case T:if(!N&&!J){W.push(B),B="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":J=!0;break;case"]":J=!1;break}B+=$}return B&&W.push(B),W}e.splitGlobAware=f;function P(F){if(!F)return"";let T="";const W=f(F,e.GLOB_SPLIT);if(W.every(N=>N===e.GLOBSTAR))T=".*";else{let N=!1;W.forEach((J,B)=>{if(J===e.GLOBSTAR){if(N)return;T+=d(2,B===W.length-1)}else{let $=!1,L="",O=!1,U="";for(const q of J){if(q!=="}"&&$){L+=q;continue}if(O&&(q!=="]"||!U)){let Y;q==="-"?Y=q:(q==="^"||q==="!")&&!U?Y="^":q===e.GLOB_SPLIT?Y="":Y=(0,u.escapeRegExpCharacters)(q),U+=Y;continue}switch(q){case"{":$=!0;continue;case"[":O=!0;continue;case"}":{T+=`(?:${f(L,",").map(H=>P(H)).join("|")})`,$=!1,L="";break}case"]":{T+="["+U+"]",O=!1,U="";break}case"?":T+=C;continue;case"*":T+=d(1);continue;default:T+=(0,u.escapeRegExpCharacters)(q)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(T+=v)}N=J===e.GLOBSTAR})}return T}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new R.LRUCache(1e4),a=function(){return!1},n=function(){return null};function i(F,T){if(!F)return n;let W;typeof F!="string"?W=F.pattern:W=F,W=W.trim();const N=`${W}_${!!T.trimForExclusions}`;let J=s.get(N);if(J)return r(J,F);let B;return b.test(W)?J=o(W.substr(4),W):(B=p.exec(c(W,T)))?J=g(B[1],W):(T.trimForExclusions?m:S).test(W)?J=M(W,T):(B=h.exec(c(W,T)))?J=A(B[1].substr(1),W,!0):(B=l.exec(c(W,T)))?J=A(B[1],W,!1):J=_(W),s.set(N,J),r(J,F)}function r(F,T){if(typeof T=="string")return F;const W=function(N,J){return(0,k.isEqualOrParent)(N,T.base,!I.isLinux)?F(N.substr(T.base.length+1),J):null};return W.allBasenames=F.allBasenames,W.allPaths=F.allPaths,W.basenames=F.basenames,W.patterns=F.patterns,W}function c(F,T){return T.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function o(F,T){return function(W,N){return typeof W=="string"&&W.endsWith(F)?T:null}}function g(F,T){const W=`/${F}`,N=`\\${F}`,J=function($,L){return typeof $!="string"?null:L?L===F?T:null:$===F||$.endsWith(W)||$.endsWith(N)?T:null},B=[F];return J.basenames=B,J.patterns=[T],J.allBasenames=B,J}function M(F,T){const W=V(F.slice(1,-1).split(",").map(L=>i(L,T)).filter(L=>L!==n),F),N=W.length;if(!N)return n;if(N===1)return W[0];const J=function(L,O){for(let U=0,q=W.length;U<q;U++)if(W[U](L,O))return F;return null},B=W.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function A(F,T,W){const N=D.sep===D.posix.sep,J=N?F:F.replace(E,D.sep),B=D.sep+J,$=D.posix.sep+F;let L;return W?L=function(O,U){return typeof O=="string"&&(O===J||O.endsWith(B)||!N&&(O===F||O.endsWith($)))?T:null}:L=function(O,U){return typeof O=="string"&&(O===J||!N&&O===F)?T:null},L.allPaths=[(W?"*/":"./")+F],L}function _(F){try{const T=new RegExp(`^${P(F)}$`);return function(W){return T.lastIndex=0,typeof W=="string"&&T.test(W)?F:null}}catch{return n}}function G(F,T,W){return!F||typeof T!="string"?!1:ae(F)(T,void 0,W)}e.match=G;function ae(F,T={}){if(!F)return a;if(typeof F=="string"||Q(F)){const W=i(F,T);if(W===n)return a;const N=function(J,B){return!!W(J,B)};return W.allBasenames&&(N.allBasenames=W.allBasenames),W.allPaths&&(N.allPaths=W.allPaths),N}return oe(F,T)}e.parse=ae;function Q(F){const T=F;return T?typeof T.base=="string"&&typeof T.pattern=="string":!1}e.isRelativePattern=Q;function X(F){return F.allBasenames||[]}e.getBasenameTerms=X;function x(F){return F.allPaths||[]}e.getPathTerms=x;function oe(F,T){const W=V(Object.getOwnPropertyNames(F).map(L=>fe(L,F[L],T)).filter(L=>L!==n)),N=W.length;if(!N)return n;if(!W.some(L=>!!L.requiresSiblings)){if(N===1)return W[0];const L=function(q,Y){let se;for(let H=0,re=W.length;H<re;H++){const ne=W[H](q,Y);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(se||(se=[]),se.push(ne))}return se?(async()=>{for(const H of se){const re=await H;if(typeof re=="string")return re}return null})():null},O=W.find(q=>!!q.allBasenames);O&&(L.allBasenames=O.allBasenames);const U=W.reduce((q,Y)=>Y.allPaths?q.concat(Y.allPaths):q,[]);return U.length&&(L.allPaths=U),L}const J=function(L,O,U){let q,Y;for(let se=0,H=W.length;se<H;se++){const re=W[se];re.requiresSiblings&&U&&(O||(O=(0,D.basename)(L)),q||(q=O.substr(0,O.length-(0,D.extname)(L).length)));const ne=re(L,O,q,U);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(Y||(Y=[]),Y.push(ne))}return Y?(async()=>{for(const se of Y){const H=await se;if(typeof H=="string")return H}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function fe(F,T,W){if(T===!1)return n;const N=i(F,W);if(N===n)return n;if(typeof T=="boolean")return N;if(T){const J=T.when;if(typeof J=="string"){const B=($,L,O,U)=>{if(!U||!N($,L))return null;const q=J.replace("$(basename)",O),Y=U(q);return(0,t.isThenable)(Y)?Y.then(se=>se?F:null):Y?F:null};return B.requiresSiblings=!0,B}}return N}function V(F,T){const W=F.filter(L=>!!L.basenames);if(W.length<2)return F;const N=W.reduce((L,O)=>{const U=O.basenames;return U?L.concat(U):L},[]);let J;if(T){J=[];for(let L=0,O=N.length;L<O;L++)J.push(T)}else J=W.reduce((L,O)=>{const U=O.patterns;return U?L.concat(U):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let q;for(q=L.length;q>0;q--){const Y=L.charCodeAt(q-1);if(Y===47||Y===92)break}O=L.substr(q)}const U=N.indexOf(O);return U!==-1?J[U]:null};B.basenames=N,B.patterns=J,B.allBasenames=N;const $=F.filter(L=>!L.basenames);return $.push(B),$}function j(F,T){return(0,y.equals)(F,T,(W,N)=>typeof W=="string"&&typeof N=="string"?W===N:typeof W!="string"&&typeof N!="string"?W.base===N.base&&W.pattern===N.pattern:!1)}e.patternsEquals=j}),define(ee[35],ie([0,1,24,31,9,4,18,26]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(n,i){const{os:r,tildify:c,relative:o}=i;if(o){const A=w(n,o,r);if(typeof A=="string")return A}let g=n.fsPath;if(r===1&&!R.isWindows?g=g.replace(/\//g,"\\"):r!==1&&R.isWindows&&(g=g.replace(/\\/g,"/")),r!==1&&c?.userHome){const A=c.userHome.fsPath;let _;n.scheme!==c.userHome.scheme&&n.path.startsWith(k.posix.sep)?_=c.userHome.with({path:n.path}).fsPath:_=n.fsPath,g=E(_,A,r)}return(r===1?k.win32:k.posix).normalize(v(g,r===1))}e.getPathLabel=u;function w(n,i,r){const c=r===1?k.win32:k.posix,o=r===3?D.extUri:D.extUriIgnorePathCase,g=i.getWorkspace(),M=(0,y.firstOrDefault)(g.folders);if(!M)return;n.scheme!==M.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=M.uri.with({path:n.path}));const A=i.getWorkspaceFolder(n);if(!A)return;let _;if(o.isEqual(A.uri,n)?_="":_=o.relativePath(A.uri,n)??"",_&&(_=c.normalize(_)),g.folders.length>1&&!i.noPrefix){const G=A.name?A.name:o.basenameOrAuthority(A.uri);_=_?`${G} \u2022 ${_}`:G}return _}function v(n,i=R.isWindows){return(0,t.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=v;let C=Object.create(null);function E(n,i,r=R.OS){if(r===1||!n||!i)return n;let c=C.original===i?C.normalized:void 0;c||(c=i,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,I.rtrim)(c,k.posix.sep)}${k.posix.sep}`,C={original:i,normalized:c});let o=n;return R.isWindows&&(o=(0,t.toSlashes)(o)),(r===3?o.startsWith(c):(0,I.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:n}e.tildify=E;function d(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=d;const f="\u2026",P="\\\\",b="~";function p(n,i=k.sep){const r=new Array(n.length);let c=!1;for(let o=0;o<n.length;o++){const g=n[o];if(g===""){r[o]=`.${i}`;continue}if(!g){r[o]=g;continue}c=!0;let M="",A=g;A.indexOf(P)===0?(M=A.substr(0,A.indexOf(P)+P.length),A=A.substr(A.indexOf(P)+P.length)):A.indexOf(i)===0?(M=A.substr(0,A.indexOf(i)+i.length),A=A.substr(A.indexOf(i)+i.length)):A.indexOf(b)===0&&(M=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length));const _=A.split(i);for(let G=1;c&&G<=_.length;G++)for(let ae=_.length-G;c&&ae>=0;ae--){c=!1;let Q=_.slice(ae,ae+G).join(i);for(let X=0;!c&&X<n.length;X++)if(X!==o&&n[X]&&n[X].indexOf(Q)>-1){const x=ae+G===_.length,oe=ae>0&&n[X].indexOf(i)>-1?i+Q:Q,fe=n[X].endsWith(oe);c=!x||fe}if(!c){let X="";(_[0].endsWith(":")||M!=="")&&(ae===1&&(ae=0,G++,Q=_[0]+i+Q),ae>0&&(X=_[0]+i),X=M+X),ae>0&&(X=X+f+i),X=X+Q,ae+G<_.length&&(X=X+i+f),r[o]=X}}c&&(r[o]=g)}return r}e.shorten=p;var S;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function m(n,i=Object.create(null)){const r=[];let c=!1,o="";for(const g of n)if(g==="$"||c&&g==="{")o&&r.push({value:o,type:S.TEXT}),o="",c=!0;else if(g==="}"&&c){const M=i[o];if(typeof M=="string")M.length&&r.push({value:M,type:S.VARIABLE});else if(M){const A=r[r.length-1];(!A||A.type!==S.SEPARATOR)&&r.push({value:M.label,type:S.SEPARATOR})}o="",c=!1}else o+=g;return o&&!c&&r.push({value:o,type:S.TEXT}),r.filter((g,M)=>{if(g.type===S.SEPARATOR){const A=r[M-1],_=r[M+1];return[A,_].every(G=>G&&(G.type===S.VARIABLE||G.type===S.TEXT)&&G.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=m;function h(n,i){return R.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function l(n,i){return R.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function a(n){const i=n.indexOf("/")!==-1?k.posix:k.win32,r=i.basename(n),c=i.dirname(n);return r.length?{name:r,parentPath:c}:{name:c,parentPath:""}}e.splitName=a}),define(ee[138],ie([0,1,7]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(v){return v.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const E=this._uriTransformer.transformIncoming(C);return E===C?C:t(y.URI.from(E))}transformOutgoing(C){const E=this._uriTransformer.transformOutgoing(C);return E===C?C:t(y.URI.from(E))}transformOutgoingURI(C){const E=this._uriTransformer.transformOutgoing(C);return E===C?C:y.URI.from(E)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function R(v,C,E){if(!v||E>200)return null;if(typeof v=="object"){if(v instanceof y.URI)return C.transformOutgoing(v);for(const d in v)if(Object.hasOwnProperty.call(v,d)){const f=R(v[d],C,E+1);f!==null&&(v[d]=f)}}return null}function D(v,C){const E=R(v,C,0);return E===null?v:E}e.transformOutgoingURIs=D;function I(v,C,E,d){if(!v||d>200)return null;if(typeof v=="object"){if(v.$mid===1)return E?y.URI.revive(C.transformIncoming(v)):C.transformIncoming(v);for(const f in v)if(Object.hasOwnProperty.call(v,f)){const P=I(v[f],C,E,d+1);P!==null&&(v[f]=P)}}return null}function u(v,C){const E=I(v,C,!1,0);return E===null?v:E}e.transformIncomingURIs=u;function w(v,C){const E=I(v,C,!0,0);return E===null?v:E}e.transformAndReviveIncomingURIs=w}),define(ee[81],ie([0,1,25,16,29,30,126]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(v){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(v)}value(){if(this._value===void 0){let v=0,C=0;const E=(0,y.networkInterfaces)();for(const d in E){const f=E[d];if(f)for(const{mac:P,internal:b}of f)b||(C+=1,this._isVirtualMachineMacAddress(P.toUpperCase())&&(v+=1))}this._value=C>0?v/C:0}return this._value}};let I;async function u(){return I||(I=(async()=>await w()||R.generateUuid())()),I}e.getMachineId=u;async function w(){try{const v=await new Promise((E,d)=>{z(["crypto"],E,d)}),C=(0,D.getMac)();return v.createHash("sha256").update(C,"utf8").digest("hex")}catch(v){t.onUnexpectedError(v);return}}}),define(ee[21],ie([0,1,40,25,139,8,31,80,9,4,18,7]),function(z,e,y,t,k,R,D,I,u,w,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function d(oe,fe=E.UNLINK){if((0,D.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");return fe===E.UNLINK?P(oe):f(oe)}async function f(oe){try{const fe=(0,D.randomPath)((0,t.tmpdir)());try{await y.promises.rename(oe,fe)}catch(V){return V.code==="ENOENT"?void 0:P(oe)}P(fe).catch(V=>{})}catch(fe){if(fe.code!=="ENOENT")throw fe}}async function P(oe){return(0,k.promisify)(y.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function b(oe){if((0,D.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function p(oe,fe){return h(await(fe?S(oe):(0,k.promisify)(y.readdir)(oe)))}async function S(oe){try{return await(0,k.promisify)(y.readdir)(oe,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const fe=[],V=await p(oe);for(const j of V){let F=!1,T=!1,W=!1;try{const N=await e.Promises.lstat((0,u.join)(oe,j));F=N.isFile(),T=N.isDirectory(),W=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}fe.push({name:j,isFile:()=>F,isDirectory:()=>T,isSymbolicLink:()=>W})}return fe}function m(oe){return h(y.readdirSync(oe))}e.readdirSync=m;function h(oe){return oe.map(fe=>typeof fe=="string"?w.isMacintosh?(0,I.normalizeNFC)(fe):fe:(fe.name=w.isMacintosh?(0,I.normalizeNFC)(fe.name):fe.name,fe))}async function l(oe){const fe=await p(oe),V=[];for(const j of fe)await a.existsDirectory((0,u.join)(oe,j))&&V.push(j);return V}function s(oe,fe=1e3){return new Promise(V=>{let j=!1;const F=setInterval(()=>{j||(j=!0,y.access(oe,T=>{j=!1,T&&(clearInterval(F),V(void 0))}))},fe)})}e.whenDeleted=s;var a;(function(oe){async function fe(F){let T;try{if(T=await e.Promises.lstat(F),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(w.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw N}throw W}}oe.stat=fe;async function V(F){try{const{stat:T,symbolicLink:W}=await oe.stat(F);return T.isFile()&&W?.dangling!==!0}catch{}return!1}oe.existsFile=V;async function j(F){try{const{stat:T,symbolicLink:W}=await oe.stat(F);return T.isDirectory()&&W?.dangling!==!0}catch{}return!1}oe.existsDirectory=j})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function i(oe,fe,V){return n.queueFor(C.URI.file(oe),v.extUriBiasedIgnorePathCase).queue(()=>{const j=M(V);return new Promise((F,T)=>o(oe,fe,j,W=>W?T(W):F()))})}let r=!0;function c(oe){r=oe}e.configureFlushOnWrite=c;function o(oe,fe,V,j){if(!r)return y.writeFile(oe,fe,{mode:V.mode,flag:V.flag},j);y.open(oe,V.flag,V.mode,(F,T)=>{if(F)return j(F);y.writeFile(T,fe,W=>{if(W)return y.close(T,()=>j(W));y.fdatasync(T,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c(!1)),y.close(T,J=>j(J))))})})}function g(oe,fe,V){const j=M(V);if(!r)return y.writeFileSync(oe,fe,{mode:j.mode,flag:j.flag});const F=y.openSync(oe,j.flag,j.mode);try{y.writeFileSync(F,fe);try{y.fdatasyncSync(F)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),c(!1)}}finally{y.closeSync(F)}}e.writeFileSync=g;function M(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function A(oe,fe){if(oe!==fe)try{await e.Promises.rename(oe,fe)}catch(V){if(oe.toLowerCase()!==fe.toLowerCase()&&V.code==="EXDEV"||oe.endsWith("."))await _(oe,fe,{preserveSymlinks:!1}),await d(oe,E.MOVE);else throw V}}async function _(oe,fe,V){return ae(oe,fe,{root:{source:oe,target:fe},options:V,handledSourcePaths:new Set})}const G=511;async function ae(oe,fe,V){if(V.handledSourcePaths.has(oe))return;V.handledSourcePaths.add(oe);const{stat:j,symbolicLink:F}=await a.stat(oe);if(F){if(V.options.preserveSymlinks)try{return await x(oe,fe,V)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(F.dangling)return}return j.isDirectory()?Q(oe,fe,j.mode&G,V):X(oe,fe,j.mode&G)}async function Q(oe,fe,V,j){await e.Promises.mkdir(fe,{recursive:!0,mode:V});const F=await p(oe);for(const T of F)await ae((0,u.join)(oe,T),(0,u.join)(fe,T),j)}async function X(oe,fe,V){await e.Promises.copyFile(oe,fe),await e.Promises.chmod(fe,V)}async function x(oe,fe,V){let j=await e.Promises.readlink(oe);(0,D.isEqualOrParent)(j,V.root.source,!w.isLinux)&&(j=(0,u.join)(V.root.target,j.substr(V.root.source.length+1))),await e.Promises.symlink(j,fe)}e.Promises=new class{get access(){return(0,k.promisify)(y.access)}get stat(){return(0,k.promisify)(y.stat)}get lstat(){return(0,k.promisify)(y.lstat)}get utimes(){return(0,k.promisify)(y.utimes)}get read(){return(oe,fe,V,j,F)=>new Promise((T,W)=>{y.read(oe,fe,V,j,F,(N,J,B)=>N?W(N):T({bytesRead:J,buffer:B}))})}get readFile(){return(0,k.promisify)(y.readFile)}get write(){return(oe,fe,V,j,F)=>new Promise((T,W)=>{y.write(oe,fe,V,j,F,(N,J,B)=>N?W(N):T({bytesWritten:J,buffer:B}))})}get appendFile(){return(0,k.promisify)(y.appendFile)}get fdatasync(){return(0,k.promisify)(y.fdatasync)}get truncate(){return(0,k.promisify)(y.truncate)}get rename(){return(0,k.promisify)(y.rename)}get copyFile(){return(0,k.promisify)(y.copyFile)}get open(){return(0,k.promisify)(y.open)}get close(){return(0,k.promisify)(y.close)}get symlink(){return(0,k.promisify)(y.symlink)}get readlink(){return(0,k.promisify)(y.readlink)}get chmod(){return(0,k.promisify)(y.chmod)}get mkdir(){return(0,k.promisify)(y.mkdir)}get unlink(){return(0,k.promisify)(y.unlink)}get rmdir(){return(0,k.promisify)(y.rmdir)}get realpath(){return(0,k.promisify)(y.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return d}get move(){return A}get copy(){return _}}}),define(ee[99],ie([0,1,40,9,4,26,21]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(E){if(k.isLinux)return E;const d=(0,t.dirname)(E);if(E===d)return E;const f=((0,t.basename)(E)||E).toLowerCase();try{const b=(0,D.readdirSync)(d).filter(p=>p.toLowerCase()===f);if(b.length===1){const p=I(d);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(f);if(p>=0){const S=I(d);if(S)return(0,t.join)(S,b[p])}}}catch{}return null}e.realcaseSync=I;async function u(E){if(k.isLinux)return E;const d=(0,t.dirname)(E);if(E===d)return E;const f=((0,t.basename)(E)||E).toLowerCase();try{const b=(await D.Promises.readdir(d)).filter(p=>p.toLowerCase()===f);if(b.length===1){const p=await u(d);if(p)return(0,t.join)(p,b[0])}else if(b.length>1){const p=b.indexOf(f);if(p>=0){const S=await u(d);if(S)return(0,t.join)(S,b[p])}}}catch{}return null}e.realcase=u;async function w(E){try{return await D.Promises.realpath(E)}catch{const f=C(E);return await D.Promises.access(f,y.constants.R_OK),f}}e.realpath=w;function v(E){try{return y.realpathSync(E)}catch{const f=C(E);return y.accessSync(f,y.constants.R_OK),f}}e.realpathSync=v;function C(E){return(0,R.rtrim)((0,t.normalize)(E),t.sep)}}),define(ee[140],ie([0,1,25,9,21]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class C{constructor(l,s,a){this.exePath=l,this.displayName=s,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:h=!1}={}){return h?w===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:h=!1,findPreview:l=!1}={}){const s=E({useAlternateBitness:h});if(!s)return null;const a=t.join(s,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let n=-1,i=null;for(const o of await k.Promises.readdir(a)){let g=-1;if(l){const A=o.indexOf("-");if(A<0)continue;const _=o.substring(0,A);if(!R.test(_)||o.substring(A+1)!=="preview")continue;g=parseInt(_,10)}else{if(!R.test(o))continue;g=parseInt(o,10)}if(g<=n)continue;const M=t.join(a,o,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(i=M,n=g)}if(!i)return null;const r=s.includes("x86")?" (x86)":"",c=l?" Preview":"";return new C(i,`PowerShell${c}${r}`,!0)}async function f({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:s,pwshMsixName:a}=h?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(l))if(s.test(n)){const i=t.join(l,n,"pwsh.exe");return new C(i,a)}return null}function P(){const h=t.join(y.homedir(),".dotnet","tools","pwsh.exe");return new C(h,".NET Core PowerShell Global Tool")}function b(){const h=t.join(process.env.windir,w===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(h,"Windows PowerShell",!0)}async function*p(){let h=await d();h&&(yield h),h=await d({useAlternateBitness:!0}),h&&(yield h),h=await f(),h&&(yield h),h=P(),h&&(yield h),h=await d({findPreview:!0}),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await d({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=b(),h&&(yield h)}async function*S(){for await(const h of p())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=S;async function m(){for await(const h of S())return h;return null}e.getFirstAvailablePowerShellInstallation=m}),define(ee[82],ie([0,1,9,4,34,78,12,21]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(C=k.env){return C.comspec||"cmd.exe"}e.getWindowsShell=u;function w(C){let E=[],d=!1;const f=function(P){if(d){E.push(P);return}(!C.send(P,p=>{if(p&&console.error(p),d=!1,E.length>0){const S=E.slice(0);E=[],S.forEach(m=>f(m))}})||t.isWindows)&&(d=!0)};return{send:f}}e.createQueuedSender=w;var v;(function(C){async function E(d,f,P){if(y.isAbsolute(d))return d;if(f===void 0&&(f=k.cwd()),y.dirname(d)!=="."||(P===void 0&&D.isString(k.env.PATH)&&(P=k.env.PATH.split(y.delimiter)),P===void 0||P.length===0))return y.join(f,d);async function p(S){if(await I.Promises.exists(S)){let m;try{m=await I.Promises.stat(S)}catch(h){h.message.startsWith("EACCES")&&(m=await I.Promises.lstat(S))}return m?!m.isDirectory():!1}return!1}for(const S of P){let m;if(y.isAbsolute(S)?m=y.join(S,d):m=y.join(f,S,d),await p(m))return m;let h=m+".com";if(await p(h)||(h=m+".exe",await p(h)))return h}return y.join(f,d)}C.findExecutable=E})(v=e.win32||(e.win32={}))}),define(ee[100],ie([0,1,45,14]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((I,u)=>{let w;const v=new Map;function C(d,f,P,b,p){const S=v.get(f);if(d===D||S){const m={name:E(P),cmd:P,pid:d,ppid:f,load:b,mem:p};v.set(d,m),d===D&&(w=m),S&&(S.children||(S.children=[]),S.children.push(m),S.children.length>1&&(S.children=S.children.sort((h,l)=>h.pid-l.pid)))}}function E(d){const f=/--vscode-window-kind=shared-process/,P=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,S=/--utility-sub-type=node.mojom.NodeService/,m=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(m.exec(d))return"electron-crash-reporter";if(h.exec(d))return"winpty-process";if(l.exec(d))return"console-window-host (Windows internal process)";let a=s.exec(d);if(a&&a.length===2){if(a[1]==="renderer")return f.exec(d)?"shared-process":P.exec(d)?"issue-reporter":b.exec(d)?"process-explorer":"window";if(a[1]==="utility"){if(p.exec(d))return"utility-network-service";if(S.exec(d))return"extension-host"}return a[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do a=n.exec(d),a&&(i+=a+" ");while(a);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${i}`:d}if(process.platform==="win32"){const d=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,P)=>{z(["windows-process-tree"],f,P)}).then(f=>{f.getProcessList(D,P=>{if(!P){u(new Error(`Root process ${D} not found`));return}f.getProcessCpuUsage(P,b=>{const p=new Map;b.forEach(S=>{const m=d(S.commandLine||"");p.set(S.pid,{name:E(m),cmd:m,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),w=p.get(D),w?(p.forEach(S=>{const m=p.get(S.ppid);m&&(m.children||(m.children=[]),m.children.push(S))}),p.forEach(S=>{S.children&&(S.children=S.children.sort((m,h)=>m.pid-h.pid))}),I(w)):u(new Error(`Root process ${D} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let d=function(){let f=[w];const P=[];for(;f.length;){const p=f.shift();p&&(P.push(p.pid),p.children&&(f=f.concat(p.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);b+=" "+P.join(" "),(0,y.exec)(b,{},(p,S,m)=>{if(p||m)u(p||new Error(m.toString()));else{const h=S.toString().split(`
`);for(let l=0;l<P.length;l++){const s=v.get(P[l]);s.load=parseFloat(h[l])}if(!w){u(new Error(`Root process ${D} not found`));return}I(w)}})};(0,y.exec)("which ps",{},(f,P,b)=>{if(f||b)if(process.platform!=="linux")u(f||new Error(b.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,y.exec)(p,{},(S,m,h)=>{S||h?u(S||new Error(h.toString())):(R(m,C),d())})}else{const p=P.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${p} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,h,l)=>{m||l&&!l.includes("screen size is bogus")?u(m||new Error(l.toString())):(R(h,C),process.platform==="linux"?d():w?I(w):u(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,I){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=D.toString().split(`
`);for(const v of w){const C=u.exec(v.trim());C&&C.length===6&&I(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(ee[141],ie([0,1,25,4,140,82]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(d,f){return d===1?t.isWindows?C():R.getWindowsShell(f):w(d,f)}e.getSystemShell=D;function I(d,f){return d===1?t.isWindows?E(f):R.getWindowsShell(f):w(d,f)}e.getSystemShellSync=I;let u=null;function w(d,f){if(t.isLinux&&d===2||t.isMacintosh&&d===3)return"/bin/bash";if(!u){let P;if(t.isWindows)P="/bin/bash";else{if(P=f.SHELL,!P)try{P=(0,y.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}u=P}return u}let v=null;async function C(){return v||(v=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),v}function E(d){if(v)return v;const f=t.isWindows&&parseFloat((0,y.release)())>=10,P=d.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${d.windir}\\${P?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?b:R.getWindowsShell(d)}});var we=this&&this.__decorate||function(z,e,y,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,y):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,y,t);else for(var I=z.length-1;I>=0;I--)(D=z[I])&&(R=(k<3?D(R):k>3?D(e,y,R):D(e,y))||R);return k>3&&R&&Object.defineProperty(e,y,R),R};define(ee[46],ie([0,1,24,8,17,23,53,16,3,2,67,26,12]),function(z,e,y,t,k,R,D,I,u,w,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var d;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(d=e.RequestType||(e.RequestType={}));function f(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(P=e.ResponseType||(e.ResponseType={}));function b(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(p||(p={}));class S{constructor(T){this.buffer=T,this.pos=0}read(T){const W=this.buffer.slice(this.pos,this.pos+T);return this.pos+=W.byteLength,W}}class m{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var h;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(h||(h={}));function l(F){const T=k.VSBuffer.alloc(4);return T.writeUInt32BE(F,0),T}function s(F){return F.read(4).readUInt32BE(0)}function a(F){const T=k.VSBuffer.alloc(1);return T.writeUInt8(F,0),T}const n={Undefined:a(h.Undefined),String:a(h.String),Buffer:a(h.Buffer),VSBuffer:a(h.VSBuffer),Array:a(h.Array),Object:a(h.Object)},i=typeof Buffer<"u";function r(F,T){if(typeof T>"u")F.write(n.Undefined);else if(typeof T=="string"){const W=k.VSBuffer.fromString(T);F.write(n.String),F.write(l(W.byteLength)),F.write(W)}else if(i&&Buffer.isBuffer(T)){const W=k.VSBuffer.wrap(T);F.write(n.Buffer),F.write(l(W.byteLength)),F.write(W)}else if(T instanceof k.VSBuffer)F.write(n.VSBuffer),F.write(l(T.byteLength)),F.write(T);else if(Array.isArray(T)){F.write(n.Array),F.write(l(T.length));for(const W of T)r(F,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(T));F.write(n.Object),F.write(l(W.byteLength)),F.write(W)}}function c(F){switch(F.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return F.read(s(F)).toString();case h.Buffer:return F.read(s(F)).buffer;case h.VSBuffer:return F.read(s(F));case h.Array:{const W=s(F),N=[];for(let J=0;J<W;J++)N.push(c(F));return N}case h.Object:return JSON.parse(F.read(s(F)).toString())}}class o{constructor(T,W,N=null,J=1e3){this.protocol=T,this.ctx=W,this.logger=N,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(T,W){this.channels.set(T,W),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const W=this.send([T.type]);this.logger?.logOutgoing(W,0,1,b(T.type));return}case 201:case 202:case 204:case 203:{const W=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(W,T.id,1,b(T.type),T.data);return}}}send(T,W=void 0){const N=new m;return r(N,T),r(N,W),this.sendBuffer(N.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const W=new S(T),N=c(W),J=c(W),B=N[0];switch(B){case 100:return this.logger?.logIncoming(T.byteLength,N[1],1,`${f(B)}: ${N[2]}.${N[3]}`,J),this.onPromise({type:B,id:N[1],channelName:N[2],name:N[3],arg:J});case 102:return this.logger?.logIncoming(T.byteLength,N[1],1,`${f(B)}: ${N[2]}.${N[3]}`,J),this.onEventListen({type:B,id:N[1],channelName:N[2],name:N[3],arg:J});case 101:return this.logger?.logIncoming(T.byteLength,N[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:N[1]});case 103:return this.logger?.logIncoming(T.byteLength,N[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:N[1]})}}onPromise(T){const W=this.channels.get(T.channelName);if(!W){this.collectPendingRequest(T);return}const N=new R.CancellationTokenSource;let J;try{J=W.call(this.ctx,T.name,T.arg,N.token)}catch(L){J=Promise.reject(L)}const B=T.id;J.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(T.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(T.id)});const $=(0,w.toDisposable)(()=>N.cancel());this.activeRequests.set(T.id,$)}onEventListen(T){const W=this.channels.get(T.channelName);if(!W){this.collectPendingRequest(T);return}const N=T.id,B=W.listen(this.ctx,T.name,T.arg)($=>this.sendResponse({id:N,data:$,type:204}));this.activeRequests.set(T.id,B)}disposeActiveRequest(T){const W=this.activeRequests.get(T.id);W&&(W.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let W=this.pendingRequests.get(T.channelName);W||(W=[],this.pendingRequests.set(T.channelName,W));const N=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:T,timeoutTimer:N})}flushPendingRequests(T){const W=this.pendingRequests.get(T);if(W){for(const N of W)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var g;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(T,W=null){this.protocol=T,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=W}getChannel(T){const W=this;return{call(N,J,B){return W.isDisposed?Promise.reject(new I.CancellationError):W.requestPromise(T,N,J,B)},listen(N,J){return W.isDisposed?u.Event.None:W.requestEvent(T,N,J)}}}requestPromise(T,W,N,J=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:T,name:W,arg:N};if(J.isCancellationRequested)return Promise.reject(new I.CancellationError);let O;return new Promise((q,Y)=>{if(J.isCancellationRequested)return Y(new I.CancellationError);const se=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(B),q(ge.data);break;case 202:{this.handlers.delete(B);const Re=new Error(ge.data.message);Re.stack=ge.data.stack,Re.name=ge.data.name,Y(Re);break}case 203:this.handlers.delete(B),Y(ge.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let H=null;this.state===p.Idle?se():(H=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),H.then(()=>{H=null,se()}));const re=()=>{H?(H.cancel(),H=null):this.sendRequest({id:B,type:101}),Y(new I.CancellationError)},ne=J.onCancellationRequested(re);O=(0,w.combinedDisposable)((0,w.toDisposable)(re),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(T,W,N){const J=this.lastRequestId++,$={id:J,type:102,channelName:T,name:W,arg:N};let L=null;const O=new u.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(q=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest($)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:J,type:103}))}}),U=q=>O.fire(q.data);return this.handlers.set(J,U),O.event}sendRequest(T){switch(T.type){case 100:case 102:{const W=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger?.logOutgoing(W,T.id,0,`${f(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const W=this.send([T.type,T.id]);this.logger?.logOutgoing(W,T.id,0,f(T.type));return}}}send(T,W=void 0){const N=new m;return r(N,T),r(N,W),this.sendBuffer(N.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const W=new S(T),N=c(W),J=c(W),B=N[0];switch(B){case 200:return this.logger?.logIncoming(T.byteLength,0,0,b(B)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(T.byteLength,N[1],0,b(B),J),this.onResponse({type:N[0],id:N[1],data:J})}}onResponse(T){if(T.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(T.id)?.(T)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}we([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class A{get connections(){const T=[];return this._connections.forEach(W=>T.push(W)),T}constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:W,onDidClientDisconnect:N})=>{u.Event.once(W.onMessage)(B=>{const $=new S(B),L=c($),O=new o(W,L),U=new M(W);this.channels.forEach((Y,se)=>O.registerChannel(se,Y));const q={channelServer:O,channelClient:U,ctx:L};this._connections.add(q),this._onDidAddConnection.fire(q),N(()=>{O.dispose(),U.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}getChannel(T,W){const N=this;return{call(J,B,$){let L;if((0,E.isFunction)(W)){const U=(0,y.getRandomElement)(N.connections.filter(W));L=U?Promise.resolve(U):u.Event.toPromise(u.Event.filter(N.onDidAddConnection,W))}else L=W.routeCall(N,J,B);const O=L.then(U=>U.channelClient.getChannel(T));return G(O).call(J,B,$)},listen(J,B){if((0,E.isFunction)(W))return N.getMulticastEvent(T,W,J,B);const $=W.routeEvent(N,J,B).then(L=>L.channelClient.getChannel(T));return G($).listen(J,B)}}}getMulticastEvent(T,W,N,J){const B=this;let $=new w.DisposableStore;const L=new u.Emitter({onFirstListenerAdd:()=>{$=new w.DisposableStore;const O=new u.EventMultiplexer,U=new Map,q=se=>{const re=se.channelClient.getChannel(T).listen(N,J),ne=O.add(re);U.set(se,ne)},Y=se=>{const H=U.get(se);!H||(H.dispose(),U.delete(se))};B.connections.filter(W).forEach(q),u.Event.filter(B.onDidAddConnection,W)(q,void 0,$),B.onDidRemoveConnection(Y,void 0,$),O.event(L.fire,L,$),$.add(O)},onLastListenerRemove:()=>{$.dispose()}});return L.event}registerChannel(T,W){this.channels.set(T,W),this._connections.forEach(N=>{N.channelServer.registerChannel(T,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class _{constructor(T,W,N=null){const J=new m;r(J,W),T.send(J.buffer),this.channelClient=new M(T,N),this.channelServer=new o(T,W,N)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,W){this.channelServer.registerChannel(T,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function G(F){return{call(T,W,N){return F.then(J=>J.call(T,W,N))},listen(T,W){const N=new u.Relay;return F.then(J=>N.input=J.listen(T,W)),N.event}}}e.getDelayedChannel=G;function ae(F){let T=!1;return{call(W,N,J){return T?F.call(W,N,J):(0,t.timeout)(0).then(()=>T=!0).then(()=>F.call(W,N,J))},listen(W,N){if(T)return F.listen(W,N);const J=new u.Relay;return(0,t.timeout)(0).then(()=>T=!0).then(()=>J.input=F.listen(W,N)),J.event}}}e.getNextTickChannel=ae;class Q{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const W of T.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=Q;var X;(function(F){function T(B,$){const L=B,O=$&&$.disableMarshalling,U=new Map;for(const q in L)N(q)&&U.set(q,u.Event.buffer(L[q],!0));return new class{listen(q,Y,se){const H=U.get(Y);if(H)return H;if(J(Y)){const re=L[Y];if(typeof re=="function")return re.call(L,se)}throw new Error(`Event not found: ${Y}`)}call(q,Y,se){const H=L[Y];if(typeof H=="function"){if(!O&&Array.isArray(se))for(let re=0;re<se.length;re++)se[re]=(0,v.revive)(se[re]);return H.apply(L,se)}throw new Error(`Method not found: ${Y}`)}}}F.fromService=T;function W(B,$){const L=$&&$.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return $?.properties?.has(U)?$.properties.get(U):J(U)?function(q){return B.listen(U,q)}:N(U)?B.listen(U):async function(...q){let Y;$&&!(0,E.isUndefinedOrNull)($.context)?Y=[$.context,...q]:Y=q;const se=await B.call(U,Y);return L?se:(0,v.revive)(se)};throw new Error(`Property not found: ${String(U)}`)}})}F.toService=W;function N(B){return B[0]==="o"&&B[1]==="n"&&C.isUpperAsciiLetter(B.charCodeAt(2))}function J(B){return/^onDynamic/.test(B)&&C.isUpperAsciiLetter(B.charCodeAt(9))}})(X=e.ProxyChannel||(e.ProxyChannel={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const T=F.toString();if(T!=="[object Object]")return T}return F}function fe(F){return Array.isArray(F)?F.map(oe):oe(F)}function V(F,T,W,N,J,B,$){$=fe($);const L=x[J],O=L[N%L.length];let U=[`%c[${F}]%c[${String(T).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(U=U.concat($),U.push(")")):U.push($),console.log.apply(console,U)}e.logWithColors=V;class j{constructor(T,W){this._outgoingPrefix=T,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,W,N,J,B){this._totalOutgoing+=T,V(this._outgoingPrefix,this._totalOutgoing,T,W,N,J,B)}logIncoming(T,W,N,J,B){this._totalIncoming+=T,V(this._incomingPrefix,this._totalIncoming,T,W,N,J,B)}}e.IPCLogger=j}),define(ee[142],ie([0,1,17,3,46]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(u){this.port=u,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",w=>y.VSBuffer.wrap(w.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(u,w){const v=new R(u);super(v,w),this.protocol=v}dispose(){this.protocol.disconnect()}}e.Client=D}),define(ee[101],ie([0,1,17,3,2,46]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let c=0;function o(M,A){if(!r.has(M)){const _=String(++c);r.set(M,_)}return r.get(M)}function g(M,A,_,G){if(!i.enableDiagnostics)return;const ae=o(M,A);if(G instanceof y.VSBuffer||G instanceof Uint8Array||G instanceof ArrayBuffer||ArrayBuffer.isView(G)){const Q=y.VSBuffer.alloc(G.byteLength);Q.set(G),i.records.push({timestamp:Date.now(),id:ae,label:A,type:_,buff:Q})}else i.records.push({timestamp:Date.now(),id:ae,label:A,type:_,data:G})}i.traceSocketEvent=g})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function v(){return w||(w=y.VSBuffer.alloc(0)),w}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,c){if(r===0)return v();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const A=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=r),A}if(this._chunks[0].byteLength>r){const A=this._chunks[0].slice(0,r);return c&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),A}const o=y.VSBuffer.alloc(r);let g=0,M=0;for(;r>0;){const A=this._chunks[M];if(A.byteLength>r){const _=A.slice(0,r);o.set(_,g),g+=r,c&&(this._chunks[M]=A.slice(r),this._totalLength-=r),r-=r}else o.set(A,g),g+=A.byteLength,c?(this._chunks.shift(),this._totalLength-=A.byteLength):M++,r-=A.byteLength}return o}}e.ChunkStream=C;var E;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(E||(E={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class P{constructor(r,c,o,g){this.type=r,this.id=c,this.ack=o,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.Disposable{constructor(r){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,g=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new P(o,g,M,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=y.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(c,r.data)}_bufferAdd(r,c){const o=this._totalLength===0;return this._data.push(r,c),this._totalLength+=r.byteLength+c.byteLength,o}_bufferTake(){const r=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,c){this._bufferAdd(r,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class S extends k.Disposable{constructor(r){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new P(1,0,0,r))}}e.Protocol=S;class m extends R.IPCClient{static fromSocket(r,c){return new m(new S(r),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(r,c,o=null){super(r,c,o),this.protocol=r}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=m;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class l{constructor(r){this.data=r,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let r=0,c=this._first;for(;c;)c=c.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let c=0,o=this._first;for(;o;)r[c++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const c=new l(r);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class a{static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}constructor(){this.lastRuns=[];const r=Date.now();for(let c=0;c<a._HISTORY_LENGTH;c++)this.lastRuns[c]=r-1e3*c;setInterval(()=>{for(let c=a._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const r=Date.now(),c=(1+a._HISTORY_LENGTH)*1e3;let o=0;for(let g=0;g<a._HISTORY_LENGTH;g++)r-this.lastRuns[g]<=c&&o++;return 1-o/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(r,c=null,o=a.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new P(5,0,0,v());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new P(7,0,0,v());this._socketWriter.write(r)}sendResume(){const r=new P(8,0,0,v());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new P(3,0,this._incomingAckId,v());this._socketWriter.write(r);const c=this._outgoingUnackMsg.toArray();for(let o=0,g=c.length;o<g;o++)this._socketWriter.write(c[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new P(6,0,0,v())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let o=0,g=c.length;o<g;o++)this._socketWriter.write(c[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new P(1,c,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const c=new P(2,0,0,r);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),c=Date.now()-r.writtenTime,o=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&o>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const M=Math.max(2e4-c,2e4-o,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new P(3,0,this._incomingAckId,v());this._socketWriter.write(r)}_sendKeepAlive(){const r=new P(9,0,0,v());this._socketWriter.write(r)}}e.PersistentProtocol=n}),define(ee[143],ie([0,1,41,17,3,2,46,128]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(v,C){const E=k.Event.fromNodeEventEmitter(y.validatedIpcMain,C,(f,P)=>({event:f,message:P})),d=k.Event.filter(E,({event:f})=>f.sender.id===v);return k.Event.map(d,({message:f})=>f&&t.VSBuffer.wrap(f))}class w extends D.IPCServer{static getOnDidClientConnect(){const C=k.Event.fromNodeEventEmitter(y.validatedIpcMain,"vscode:hello",({sender:E})=>E);return k.Event.map(C,E=>{const d=E.id;w.Clients.get(d)?.dispose();const P=new k.Emitter;w.Clients.set(d,(0,R.toDisposable)(()=>P.fire()));const b=u(d,"vscode:message"),p=k.Event.any(k.Event.signal(u(d,"vscode:disconnect")),P.event);return{protocol:new I.Protocol(E,b),onDidClientDisconnect:p}})}constructor(){super(w.getOnDidClientConnect())}}e.Server=w,w.Clients=new Map}),define(ee[102],ie([0,1,41,3,30,142]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(w,v){super({addEventListener:(C,E)=>w.addListener(C,E),removeEventListener:(C,E)=>w.removeListener(C,E),postMessage:C=>w.postMessage(C),start:()=>w.start(),close:()=>w.close()},v)}}e.Client=D;async function I(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();u.webContents.send("vscode:createMessageChannel",w);const v=t.Event.fromNodeEventEmitter(y.validatedIpcMain,"vscode:createMessageChannelResult",(E,d)=>({nonce:d,port:E.ports[0]})),{port:C}=await t.Event.toPromise(t.Event.once(t.Event.filter(v,E=>E.nonce===w)));return C}e.connect=I}),define(ee[144],ie([0,1,45,8,17,23,137,16,3,2,50,82,78,46]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends d.ChannelServer{constructor(p){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=f;class P{constructor(p,S){this.modulePath=p,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new t.Delayer(m),this.child=null,this._client=null}getChannel(p){const S=this;return{call(m,h,l){return S.requestPromise(p,m,h,l)},listen(m,h){return S.requestEvent(p,m,h)}}}requestPromise(p,S,m,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(p),s=(0,t.createCancelablePromise)(i=>l.call(S,m,i)),a=h.onCancellationRequested(()=>s.cancel()),n=(0,w.toDisposable)(()=>s.cancel());return this.activeRequests.add(n),s.finally(()=>{a.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(p,S,m){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let h;const l=new u.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(p).listen(S,m)(l.fire,l),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,E.removeDangerousEnvVariables)(S.env),this.child=(0,y.fork)(this.modulePath,p,S);const m=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,D.isRemoteConsoleLog)(r)){(0,D.log)(r,`IPC Library: ${this.options.serverName}`);return}m.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const l=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,s=r=>this.child&&this.child.connected&&l.send(r.buffer.toString("base64")),a=m.event,n={send:s,onMessage:a};this._client=new d.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,c)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,w.dispose)(o)),this.activeRequests.clear(),r!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:c})})}return this._client}getCachedChannel(p){let S=this.channels.get(p);return S||(S=this.client.getChannel(p),this.channels.set(p,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=P}),define(ee[83],ie([0,1,17,16,3,2,9,4,30,46,101]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class E{traceSocketEvent(o,g){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,g)}constructor(o,g=""){this._canWrite=!0,this.debugLabel=g,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener),this._closeListener=M=>{this.traceSocketEvent("close",{hadError:M}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(o){const g=M=>{this.traceSocketEvent("read",M),o(y.VSBuffer.wrap(M))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(o){const g=M=>{o({type:0,hadError:M,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(o){const g=()=>{o()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(o){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,t.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,t.onUnexpectedError)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=E;var d;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var f;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(f||(f={}));class P extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(o,g){this.socket.traceSocketEvent(o,g)}constructor(o,g,M,A){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:M?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new b(this,g,M,A,this._onData,(_,G)=>this._write(_,G))),this._register(this._flowManager.onError(_=>{console.error(_),(0,t.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._flowManager.writeMessage(o)}_write(o,g){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let M=2;o.byteLength<126?M+=0:o.byteLength<2**16?M+=2:M+=8;const A=y.VSBuffer.alloc(M);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),o.byteLength<126)A.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){A.writeUInt8(126,1);let _=1;A.writeUInt8(o.byteLength>>>8&255,++_),A.writeUInt8(o.byteLength>>>0&255,++_)}else{A.writeUInt8(127,1);let _=1;A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(o.byteLength>>>24&255,++_),A.writeUInt8(o.byteLength>>>16&255,++_),A.writeUInt8(o.byteLength>>>8&255,++_),A.writeUInt8(o.byteLength>>>0&255,++_)}this.socket.write(y.VSBuffer.concat([A,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),M=g.readUInt8(0),A=(M&128)>>>7,_=(M&64)>>>6,G=g.readUInt8(1),ae=(G&128)>>>7,Q=G&127;this._state.state=2,this._state.readLen=2+(ae?4:0)+(Q===126?2:0)+(Q===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),M=g.readUInt8(1),A=(M&128)>>>7;let _=M&127,G=1;_===126?_=g.readUInt8(++G)*2**8+g.readUInt8(++G):_===127&&(_=g.readUInt8(++G)*0+g.readUInt8(++G)*0+g.readUInt8(++G)*0+g.readUInt8(++G)*0+g.readUInt8(++G)*2**24+g.readUInt8(++G)*2**16+g.readUInt8(++G)*2**8+g.readUInt8(++G));let ae=0;A&&(ae=g.readUInt8(++G)*2**24+g.readUInt8(++G)*2**16+g.readUInt8(++G)*2**8+g.readUInt8(++G)),this._state.state=3,this._state.readLen=_,this._state.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),m(g,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(g,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class b extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:y.VSBuffer.alloc(0)}constructor(o,g,M,A,_,G){super(),this._tracer=o,this._onData=_,this._writeFn=G,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,g?(this._zlibInflateStream=this._register(new p(this._tracer,A,M,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ae=>this._onError.fire(ae))),this._register(this._zlibDeflateStream.onError(ae=>this._onError.fire(ae)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(o){this._writeQueue.push(o),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const o=this._writeQueue.shift();if(this._zlibDeflateStream){const g=await this._deflateMessage(this._zlibDeflateStream,o);this._writeFn(g,!0)}else this._writeFn(o,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(o,g){return new Promise((M,A)=>{o.write(g),o.flush(_=>M(_))})}acceptFrame(o,g,M){this._readQueue.push({data:o,isCompressed:g,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const o=this._readQueue.shift();if(this._zlibInflateStream&&o.isCompressed){const g=await this._inflateFrame(this._zlibInflateStream,o.data,o.isLastFrameOfMessage);this._onData.fire(g)}else this._onData.fire(o.data)}this._isProcessingReadQueue=!1}}_inflateFrame(o,g,M){return new Promise((A,_)=>{o.write(g),M&&o.write(y.VSBuffer.fromByteArray([0,0,255,255])),o.flush(G=>A(G))})}}class p extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.concat(this._recordedInflateBytes):y.VSBuffer.alloc(0)}constructor(o,g,M,A){super(),this._tracer=o,this._recordInflateBytes=g,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(A),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(y.VSBuffer.wrap(_))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(o){this._recordInflateBytes&&this._recordedInflateBytes.push(o.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",o),this._zlibInflate.write(o.buffer)}flush(o){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const g=y.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,o(g)})}}class S extends R.Disposable{constructor(o,g){super(),this._tracer=o,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(y.VSBuffer.wrap(M))})}write(o){this._tracer.traceSocketEvent("zlibDeflateWrite",o.buffer),this._zlibDeflate.write(o.buffer)}flush(o){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let g=y.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.byteLength-4),o(g)})}}function m(c,o){if(o===0)return;const g=c.byteLength>>>2;for(let Q=0;Q<g;Q++){const X=c.readUInt32BE(Q*4);c.writeUInt32BE(X^o,Q*4)}const M=g*4,A=c.byteLength-M,_=o>>>24&255,G=o>>>16&255,ae=o>>>8&255;A>=1&&c.writeUInt8(c.readUInt8(M)^_,M),A>=2&&c.writeUInt8(c.readUInt8(M+1)^G,M+1),A>=3&&c.writeUInt8(c.readUInt8(M+2)^ae,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function l(){const c=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,D.join)(C().os.tmpdir(),`vscode-ipc-${c}.sock`),a(o),o}e.createRandomIPCHandle=l;function s(c,o,g){const M=C().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${g}-${o}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${g}-${o}.sock`):A=(0,D.join)(c,`${g}-${o}.sock`),a(A),A}e.createStaticIPCHandle=s;function a(c){const o=h[I.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class n extends w.IPCServer{static toClientConnectionEvent(o){const g=k.Event.fromNodeEventEmitter(o,"connection");return k.Event.map(g,M=>({protocol:new v.Protocol(new E(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}constructor(o){super(n.toClientConnectionEvent(o)),this.server=o}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(c){return new Promise((o,g)=>{const M=C().net.createServer();M.on("error",g),M.listen(c,()=>{M.removeListener("error",g),o(new n(M))})})}e.serve=i;function r(c,o){return new Promise((g,M)=>{const A=C().net.createConnection(c,()=>{A.removeListener("error",M),g(v.Client.fromSocket(new E(A,`ipc-client${o}`),o))});A.once("error",M)})}e.connect=r}),define(ee[103],ie([0,1,8,3,2,12]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function I(C){const E=C;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var u;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(u=e.StorageState||(e.StorageState={}));class w extends k.Disposable{constructor(E,d=Object.create(null)){super(),this.database=E,this.options=d,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new y.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((d,f)=>this.accept(f,d)),E.deleted?.forEach(d=>this.accept(d,void 0))}accept(E,d){if(this.state===u.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(d)?f=this.cache.delete(E):this.cache.get(E)!==d&&(this.cache.set(E,d),f=!0),f&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,d){const f=this.cache.get(E);return(0,R.isUndefinedOrNull)(f)?d:f}getBoolean(E,d){const f=this.get(E);return(0,R.isUndefinedOrNull)(f)?d:f==="true"}getNumber(E,d){const f=this.get(E);return(0,R.isUndefinedOrNull)(f)?d:parseInt(f,10)}async set(E,d){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(d))return this.delete(E);const f=String(d);if(this.cache.get(E)!==f)return this.cache.set(E,f),this.pendingInserts.set(E,f),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async delete(E){if(!(this.state===u.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!!this.hasPending)return this.doFlush(E)}async doFlush(E){return this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert?.forEach((d,f)=>this.items.set(f,d)),E.delete?.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=v}),define(ee[145],ie([0,1,8,3,29,9,21]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{get onDidChangeItemsExternal(){return t.Event.None}constructor(v,C=Object.create(null)){this.path=v,this.options=C,this.name=(0,R.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const v=await this.whenConnected,C=new Map;return(await this.all(v,"SELECT * FROM ItemTable")).forEach(d=>C.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${C.size} rows`),C}async updateItems(v){const C=await this.whenConnected;return this.doUpdateItems(C,v)}doUpdateItems(v,C){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${C.insert?(0,k.mapToString)(C.insert):"0"}), delete(${C.delete?(0,k.setToString)(C.delete):"0"})`),this.transaction(v,()=>{const E=C.insert,d=C.delete;if(E&&E.size>0){const f=[];f.push([]);let P=0;E.forEach((b,p)=>{let S=f[P];S.length>I.MAX_HOST_PARAMETERS&&(P++,S=[],f.push(S)),S.push(p,b)}),f.forEach(b=>{this.prepare(v,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,p=>p.run(b),()=>{const p=[];let S=0;return E.forEach((m,h)=>{p.push(h),S+=m.length}),`Keys: ${p.join(", ")} Length: ${S}`})})}if(d&&d.size){const f=[];f.push([]);let P=0;d.forEach(b=>{let p=f[P];p.length>I.MAX_HOST_PARAMETERS&&(P++,p=[],f.push(p)),p.push(b)}),f.forEach(b=>{this.prepare(v,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,p=>p.run(b),()=>{const p=[];return d.forEach(S=>{p.push(S)}),`Keys: ${p.join(", ")}`})})}})}async close(v){this.logger.trace(`[storage ${this.name}] close()`);const C=await this.whenConnected;return this.doClose(C,v)}doClose(v,C){return new Promise((E,d)=>{v.db.close(f=>(f&&this.handleSQLiteError(v,`[storage ${this.name}] close(): ${f}`),this.path===I.IN_MEMORY_PATH?E():!v.isErroneous&&!v.isInMemory?this.backup().then(E,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),E())):typeof C=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const b=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:C()}).then(()=>b(),p=>(b(),Promise.reject(p)))})).then(E,d):d(f||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const v=this.toBackupPath(this.path);return D.Promises.copy(this.path,v,{preserveSymlinks:!1})}toBackupPath(v){return`${v}.backup`}async checkIntegrity(v){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${v})`);const C=await this.whenConnected,E=await this.get(C,v?"PRAGMA integrity_check":"PRAGMA quick_check"),d=v?E.integrity_check:E.quick_check;return C.isErroneous?`${d} (last error: ${C.lastError})`:C.isInMemory?`${d} (in-memory!)`:d}async connect(v,C=!0){this.logger.trace(`[storage ${this.name}] open(${v}, retryOnBusy: ${C})`);try{return await this.doConnect(v)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&C)return await(0,y.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(v,!1);try{await D.Promises.unlink(v);try{await D.Promises.rename(this.toBackupPath(v),v)}catch{}return await this.doConnect(v)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(v,C){v.isErroneous=!0,v.lastError=C,this.logger.error(C)}doConnect(v){return new Promise((C,E)=>{new Promise((d,f)=>{z(["@vscode/sqlite3"],d,f)}).then(d=>{const f={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(v,P=>P?f.db&&P.code!=="SQLITE_CANTOPEN"?f.db.close(()=>E(P)):E(P):this.exec(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>C(f),b=>f.db.close(()=>E(b)))),isInMemory:v===I.IN_MEMORY_PATH};f.db.on("error",P=>this.handleSQLiteError(f,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&f.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},E)})}exec(v,C){return new Promise((E,d)=>{v.db.exec(C,f=>f?(this.handleSQLiteError(v,`[storage ${this.name}] exec(): ${f}`),d(f)):E())})}get(v,C){return new Promise((E,d)=>{v.db.get(C,(f,P)=>f?(this.handleSQLiteError(v,`[storage ${this.name}] get(): ${f}`),d(f)):E(P))})}all(v,C){return new Promise((E,d)=>{v.db.all(C,(f,P)=>f?(this.handleSQLiteError(v,`[storage ${this.name}] all(): ${f}`),d(f)):E(P))})}transaction(v,C){return new Promise((E,d)=>{v.db.serialize(()=>{v.db.run("BEGIN TRANSACTION"),C(),v.db.run("END TRANSACTION",f=>f?(this.handleSQLiteError(v,`[storage ${this.name}] transaction(): ${f}`),d(f)):E())})})}prepare(v,C,E,d){const f=v.db.prepare(C),P=b=>{this.handleSQLiteError(v,`[storage ${this.name}] prepare(): ${b} (${C}). Details: ${d()}`)};f.on("error",P),E(f),f.finalize(b=>{b&&P(b),f.removeListener("error",P)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class u{constructor(v){v&&typeof v.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=v.logTrace),v&&typeof v.logError=="function"&&(this.logError=v.logError)}get isTracing(){return!!this.logTrace}trace(v){this.logTrace?.(v)}error(v){this.logError?.(v)}}u.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[146],ie([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(ee[147],ie([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[148],ie([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[149],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(ee[150],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(ee[151],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[152],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[153],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[154],ie([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[155],ie([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[156],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(ee[157],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(ee[158],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(ee[159],ie([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[160],ie([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[161],ie([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[162],ie([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[163],ie([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[164],ie([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(ee[165],ie([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(ee[166],ie([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[167],ie([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[168],ie([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[169],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[170],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[171],ie([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(ee[172],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[173],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[174],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function y(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=y;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[175],ie([0,1,7]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let I=[];try{Array.isArray(D.workspaces)&&(I=D.workspaces.map(u=>({workspace:{id:u.id,configPath:y.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=k;function R(D){let I=[];try{Array.isArray(D.folders)&&(I=D.folders.map(u=>({folderUri:y.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=R}),define(ee[176],ie([0,1,3,2]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new y.Emitter,this._onReloadEmitter=new y.Emitter,this._onTerminateEmitter=new y.Emitter,this._onAttachEmitter=new y.Emitter}call(I,u,w){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(I,u,w){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(I){super(),this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,u,w){this.channel.call("attach",[I,u,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,u){this.channel.call("terminate",[I,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,u){return this.channel.call("openExtensionDevelopmentHostWindow",[I,u])}}e.ExtensionHostDebugChannelClient=R}),define(ee[177],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class y{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>z(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=y}),define(ee[178],ie([0,1,131,53,14,9,34,18,7]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",z).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const P=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",P)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return u.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const P=this.args["builtin-extensions-dir"];return P?(0,R.resolve)(P):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const P=this.args["extensions-download-dir"];return P?(0,R.resolve)(P):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const P=this.args["extensions-dir"];if(P)return(0,R.resolve)(P);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const p=D.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const P=this.args.extensionDevelopmentPath;if(Array.isArray(P))return P.map(b=>/^[^:/?#]+?:\/\//.test(b)?u.URI.parse(b):u.URI.file((0,R.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(P=>P==="ui"||P==="workspace"||P==="web"?P:"workspace")}get extensionTestsLocationURI(){const P=this.args.extensionTestsPath;if(P)return/^[^:/?#]+?:\/\//.test(P)?u.URI.parse(P):u.URI.file((0,R.normalize)(P))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const P=this.args["disable-extension"];if(P){if(typeof P=="string")return[P];if(Array.isArray(P)&&P.length>0)return P}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(P=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(P))}get extensionLogLevel(){const P=[];for(const b of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);p&&p[1]&&p[2]&&P.push([p[1],p[2]])}return P.length?P:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(P){this.args.continueOn=P}get args(){return this._args}constructor(P,b,p){this._args=P,this.paths=b,this.productService=p,this.editSessionId=this.args.editSessionId}}we([t.memoize],w.prototype,"appRoot",null),we([t.memoize],w.prototype,"userHome",null),we([t.memoize],w.prototype,"userDataPath",null),we([t.memoize],w.prototype,"appSettingsHome",null),we([t.memoize],w.prototype,"tmpDir",null),we([t.memoize],w.prototype,"cacheHome",null),we([t.memoize],w.prototype,"stateResource",null),we([t.memoize],w.prototype,"userRoamingDataHome",null),we([t.memoize],w.prototype,"userDataSyncHome",null),we([t.memoize],w.prototype,"userDataSyncLogResource",null),we([t.memoize],w.prototype,"editSessionsLogResource",null),we([t.memoize],w.prototype,"sync",null),we([t.memoize],w.prototype,"machineSettingsResource",null),we([t.memoize],w.prototype,"workspaceStorageHome",null),we([t.memoize],w.prototype,"localHistoryHome",null),we([t.memoize],w.prototype,"keyboardLayoutResource",null),we([t.memoize],w.prototype,"argvResource",null),we([t.memoize],w.prototype,"isExtensionDevelopment",null),we([t.memoize],w.prototype,"untitledWorkspacesHome",null),we([t.memoize],w.prototype,"installSourcePath",null),we([t.memoize],w.prototype,"builtinExtensionsPath",null),we([t.memoize],w.prototype,"extensionsPath",null),we([t.memoize],w.prototype,"extensionDevelopmentLocationURI",null),we([t.memoize],w.prototype,"extensionDevelopmentKind",null),we([t.memoize],w.prototype,"extensionTestsLocationURI",null),we([t.memoize],w.prototype,"debugExtensionHost",null),we([t.memoize],w.prototype,"logLevel",null),we([t.memoize],w.prototype,"extensionLogLevel",null),we([t.memoize],w.prototype,"serviceMachineIdResource",null),we([t.memoize],w.prototype,"telemetryLogResource",null),we([t.memoize],w.prototype,"disableWorkspaceTrust",null),we([t.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function v(f,P){return d(f["inspect-extensions"],f["inspect-brk-extensions"],5870,P,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=v;function C(f,P){return d(f["inspect-search"],f["inspect-brk-search"],5876,P,f.extensionEnvironment)}e.parseSearchPort=C;function E(f,P){return d(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,P,f.extensionEnvironment)}e.parsePtyHostPort=E;function d(f,P,b,p,S,m){const l=Number(P||f)||(p?null:b),s=l?Boolean(!!P):!1;let a;if(m)try{a=JSON.parse(m)}catch{}return{port:l,break:s,debugId:S,env:a}}}),define(ee[104],ie([0,1,277,4,149]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(P,b,p=D){const S=P.find(c=>c.length>0&&c[0]!=="-"),m={},h=["_"],l=[],s={};let a;for(const c in b){const o=b[c];o.type==="subcommand"?c===S&&(a=o):(o.alias&&(m[c]=o.alias),o.type==="string"||o.type==="string[]"?(h.push(c),o.deprecates&&h.push(...o.deprecates)):o.type==="boolean"&&(l.push(c),o.deprecates&&l.push(...o.deprecates)),o.global&&(s[c]=o))}if(a&&S){const c=s;for(const A in a.options)c[A]=a.options[A];const o=P.filter(A=>A!==S),g=p.getSubcommandReporter?p.getSubcommandReporter(S):void 0,M=I(o,c,g);return{[S]:M}}const n=y(P,{string:h,boolean:l,alias:m}),i={},r=n;i._=n._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in b){const o=b[c];if(o.type==="subcommand")continue;o.alias&&delete r[o.alias];let g=r[c];if(o.deprecates)for(const M of o.deprecates)r.hasOwnProperty(M)&&(g||(g=r[M],g&&p.onDeprecatedOption(M,o.deprecationMessage||(0,k.localize)(36,null,c))),delete r[M]);if(typeof g<"u"){if(o.type==="string[]"){if(Array.isArray(g)||(g=[g]),!o.allowEmptyValue){const M=g.filter(A=>A.length>0);M.length!==g.length&&(p.onEmptyValue(c),g=M.length>0?M:void 0)}}else o.type==="string"&&(Array.isArray(g)?(g=g.pop(),p.onMultipleValues(c,g)):!g&&!o.allowEmptyValue&&(p.onEmptyValue(c),g=void 0));i[c]=g,o.deprecationMessage&&p.onDeprecatedOption(c,o.deprecationMessage)}delete r[c]}for(const c in r)p.onUnknownOption(c);return i}e.parseArgs=I;function u(P,b){let p="";return b.args&&(Array.isArray(b.args)?p=` <${b.args.join("> <")}>`:p=` <${b.args}>`),b.alias?`-${b.alias} --${P}${p}`:`--${P}${p}`}function w(P,b){const p=[];for(const S in P){const m=P[S],h=u(S,m);p.push([h,m.description])}return v(p,b)}e.formatOptions=w;function v(P,b){const S=P.reduce((l,s)=>Math.max(l,s[0].length),12)+2+1;if(b-S<25)return P.reduce((l,s)=>l.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const m=b-S-1,h=[];for(const l of P){const s=l[0],a=E(l[1],m),n=C(S-s.length-2);h.push("  "+s+n+a[0]);for(let i=1;i<a.length;i++)h.push(C(S)+a[i])}return h}function C(P){return" ".repeat(P)}function E(P,b){const p=[];for(;P.length;){const S=P.length<b?P.length:P.lastIndexOf(" ",b),m=P.slice(0,S).trim();P=P.slice(S),p.push(m)}return p}function d(P,b,p,S,m){const h=process.stdout.isTTY&&process.stdout.columns||80,l=m?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",s=[`${P} ${p}`];s.push(""),s.push(`${(0,k.localize)(38,null)}: ${b} [${(0,k.localize)(39,null)}]${l}`),s.push(""),m?.noPipe!==!0&&(t.isWindows?s.push((0,k.localize)(40,null,b)):s.push((0,k.localize)(41,null,b)),s.push(""));const a={},n=[];for(const i in S){const r=S[i];if(r.type==="subcommand")r.description&&n.push({command:i,description:r.description});else if(r.description&&r.cat){let c=a[r.cat];c||(a[r.cat]=c={}),c[i]=r}}for(const i in a){const r=i,c=a[r];c&&(s.push(R[r]),s.push(...w(c,h)),s.push(""))}return n.length&&(s.push((0,k.localize)(42,null)),s.push(...v(n.map(i=>[i.command,i.description]),h)),s.push("")),s.join(`
`)}e.buildHelpMessage=d;function f(P,b){return`${P||(0,k.localize)(43,null)}
${b||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ee[179],ie([0,1,77,176,104]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(I,u){super(),this.windowsMainService=I,this.userDataProfilesMainService=u}call(I,u,w){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(I,u,w)}async openExtensionDevelopmentHostWindow(I,u){const w=(0,k.parseArgs)(I,k.OPTIONS);w.debugRenderer=u;const v=w.extensionDevelopmentPath;if(!v)return{success:!1};const[C]=await this.windowsMainService.openExtensionDevelopmentHostWindow(v,{context:5,cli:w,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(w)});if(!u)return{success:!0};const E=C.win;if(!E)return{success:!0};const d=E.webContents.debugger;let f=d.isAttached()?1/0:0;const P=(0,y.createServer)(b=>{f++===0&&d.attach();let p=!1;const S=l=>{p||b.write(JSON.stringify(l)+"\0")},m=(l,s,a,n)=>S({method:s,params:a,sessionId:n});E.on("close",()=>{d.removeListener("message",m),b.end(),p=!0}),d.addListener("message",m);let h=Buffer.alloc(0);b.on("data",l=>{h=Buffer.concat([h,l]);for(let s=h.indexOf(0);s!==-1;s=h.indexOf(0)){let a;try{const n=h.slice(0,s).toString("utf8");h=h.slice(s+1),a=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}d.sendCommand(a.method,a.params,a.sessionId).then(n=>S({id:a.id,sessionId:a.sessionId,result:n})).catch(n=>S({id:a.id,sessionId:a.sessionId,error:{code:0,message:n.message}}))}}),b.on("error",l=>{console.error("error on cdp pipe:",l)}),b.on("close",()=>{p=!0,--f===0&&d.detach()})});return await new Promise(b=>P.listen(0,b)),E.on("close",()=>P.close()),{rendererDebugPort:P.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ee[59],ie([0,1,278,150,104]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(E,d){const f=(h,l)=>{console.warn((0,t.localize)(0,null,h,l))},P=h=>{console.warn((0,t.localize)(1,null,h))},b=(h,l)=>{console.warn((0,t.localize)(2,null,h,l))},p=h=>({onUnknownOption:l=>{h!=="tunnel"&&console.warn((0,t.localize)(3,null,l,h))},onMultipleValues:f,onEmptyValue:P,onDeprecatedOption:b,getSubcommandReporter:h!=="tunnel"?p:void 0}),S={onUnknownOption:h=>{console.warn((0,t.localize)(4,null,h))},onMultipleValues:f,onEmptyValue:P,onDeprecatedOption:b,getSubcommandReporter:p},m=(0,k.parseArgs)(E,k.OPTIONS,d?S:void 0);return m.goto&&m._.forEach(h=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,t.localize)(5,null))),m["max-memory"]&&y(parseInt(m["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),m}function I(E){const d=E.findIndex(f=>!/^-/.test(f));if(d>-1)return[...E.slice(0,d),...E.slice(d+1)]}function u(E){let[,...d]=E;process.env.VSCODE_DEV&&(d=I(d)||[]);const f=!C(process.env);return D(d,f)}e.parseMainProcessArgv=u;function w(E){let[,,...d]=E;return process.env.VSCODE_DEV&&(d=I(d)||[]),D(d,!0)}e.parseCLIProcessArgv=w;function v(E,...d){const f=E.indexOf("--");return f===-1?E.push(...d):E.splice(f,0,...d),E}e.addArg=v;function C(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function z(e,y,t){function k(D,I){const u=R(D,I),w=[u];return e.isAbsolute(u)||w.unshift(t),e.resolve(...w)}function R(D,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,I);const v=D["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(C,"AppData","Roaming")}break;case"darwin":w=e.join(y.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,I)}return{getUserDataPath:k}}if(typeof define=="function")define(ee[180],ie([181,25,34]),function(e,y,t){return z(e,y,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=z(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[182],ie([0,1,25,178,180]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(I,u){super(I,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,k.getUserDataPath)(I,u.nameShort)},u)}}e.NativeEnvironmentService=R}),define(ee[183],ie([0,1,40,25,31]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const I=(0,k.randomPath)((0,t.tmpdir)());try{return(0,y.writeFileSync)(I,""),D&&console.log(`Marker file for --wait created: ${I}`),I}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFileSync=R}),define(ee[184],ie([0,1,12,152]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,I,u){try{R(D,I,u)}catch{}return D}e.localizeManifest=k;function R(D,I,u){const w=(v,C,E)=>{const d=v[C];if((0,y.isString)(d)){const f=d,P=f.length;if(P>1&&f[0]==="%"&&f[P-1]==="%"){const b=f.substr(1,P-2);let p=I[b];p===void 0&&u&&(p=u[b]);const S=typeof p=="string"?p:p.message;if(S!==void 0){const m=u?.[b],h=typeof m=="string"?m:m?.message;if(E&&(C==="title"||C==="category")&&h&&h!==S){const l={value:S,original:h};v[C]=l}else v[C]=S}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,b)}`)}}else if((0,y.isObject)(d))for(const f in d)d.hasOwnProperty(f)&&(f==="commands"?w(d,f,!0):w(d,f,E));else if(Array.isArray(d))for(let f=0;f<d.length;f++)w(d,f,E)};for(const v in D)D.hasOwnProperty(v)&&w(D,v)}}),define(ee[185],ie([0,1,18,97,154,186]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function u(p){return p=p.trim(),p==="*"||D.test(p)}e.isValidVersionStr=u;function w(p){if(!u(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=p.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=w;function v(p){if(!p)return null;const S=p.majorBase,m=p.majorMustEqual,h=p.minorBase;let l=p.minorMustEqual;const s=p.patchBase;let a=p.patchMustEqual;p.hasCaret&&(S===0||(l=!1),a=!1);let n=0;if(p.preRelease){const i=I.exec(p.preRelease);if(i){const[,r,c,o]=i;n=Date.UTC(Number(r),Number(c)-1,Number(o))}}return{majorBase:S,majorMustEqual:m,minorBase:h,minorMustEqual:l,patchBase:s,patchMustEqual:a,isMinimum:p.hasGreaterEquals,notBefore:n}}e.normalizeVersion=v;function C(p,S,m){let h;typeof p=="string"?h=v(w(p)):h=p;let l;S instanceof Date?l=S.getTime():typeof S=="string"&&(l=new Date(S).getTime());let s;if(typeof m=="string"?s=v(w(m)):s=m,!h||!s)return!1;const a=h.majorBase,n=h.minorBase,i=h.patchBase;let r=s.majorBase,c=s.minorBase,o=s.patchBase;const g=s.notBefore;let M=s.majorMustEqual,A=s.minorMustEqual,_=s.patchMustEqual;return s.isMinimum?a>r?!0:a<r?!1:n>c?!0:n<c||l&&l<g?!1:i>=o:(a===1&&r===0&&(!M||!A||!_)&&(r=1,c=0,o=0,M=!0,A=!1,_=!1),a<r?!1:a>r?!M:n<c?!1:n>c?!A:i<o?!1:i>o?!_:!(l&&l<g))}e.isValidVersion=C;function E(p,S,m,h,l){const s=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return s.push([t.default.Error,k.localize(0,null)]),s;if(typeof h.name!="string")return s.push([t.default.Error,k.localize(1,null,"name")]),s;if(typeof h.version!="string")return s.push([t.default.Error,k.localize(2,null,"version")]),s;if(!h.engines)return s.push([t.default.Error,k.localize(3,null,"engines")]),s;if(typeof h.engines.vscode!="string")return s.push([t.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof h.extensionDependencies<"u"&&!b(h.extensionDependencies))return s.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof h.activationEvents<"u"){if(!b(h.activationEvents))return s.push([t.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof h.main>"u"&&typeof h.browser>"u")return s.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&s.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return s.push([t.default.Error,k.localize(9,null,"main")]),s;{const i=(0,y.joinPath)(m,h.main);(0,y.isEqualOrParent)(i,m)||s.push([t.default.Warning,k.localize(10,null,i.path,m.path)])}if(typeof h.activationEvents>"u")return s.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof h.browser<"u"){if(typeof h.browser!="string")return s.push([t.default.Error,k.localize(12,null,"browser")]),s;{const i=(0,y.joinPath)(m,h.browser);(0,y.isEqualOrParent)(i,m)||s.push([t.default.Warning,k.localize(13,null,i.path,m.path)])}if(typeof h.activationEvents>"u")return s.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!R.valid(h.version))return s.push([t.default.Error,k.localize(15,null)]),s;const a=[];if(!d(p,S,h,l,a))for(const i of a)s.push([t.default.Error,i]);return s}e.validateExtensionManifest=E;function d(p,S,m,h,l){return h||typeof m.main>"u"&&typeof m.browser>"u"?!0:P(p,S,m.engines.vscode,l)}e.isValidExtensionVersion=d;function f(p,S,m){return p==="*"||P(S,m,p)}e.isEngineValid=f;function P(p,S,m,h=[]){const l=v(w(m));if(!l)return h.push(k.localize(16,null,m)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return h.push(k.localize(17,null,m)),!1}else if(!l.majorMustEqual)return h.push(k.localize(18,null,m)),!1;return C(p,S,l)?!0:(h.push(k.localize(19,null,p,m)),!1)}function b(p){if(!Array.isArray(p))return!1;for(let S=0,m=p.length;S<m;S++)if(typeof p[S]!="string")return!1;return!0}}),define(ee[187],ie([0,1,17,30]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,I){let u=I&&I.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const v=(await D.readFile(R.serviceMachineIdResource)).value.toString();u=(0,t.isUUID)(v)?v:null}catch{u=null}if(!u){u=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,y.VSBuffer.fromString(u))}catch{}}return I?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(ee[68],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=y}),define(ee[188],ie([0,1,68]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(I,u,w){u instanceof y.SyncDescriptor||(u=new y.SyncDescriptor(u,[],Boolean(w))),t.push([I,u])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(ee[189],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=y;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const I=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(D);I.outgoing.set(u.key,u),u.incoming.set(I.key,I)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const I of this._nodes.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let I=this._nodes.get(D);return I||(I=new y(D,R),this._nodes.set(D,I)),I}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,I]of this._nodes)R.push(`${D}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const I=new Set([R]),u=this._findCycle(D,I);if(u)return u}}_findCycle(R,D){for(const[I,u]of R.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const w=this._findCycle(u,D);if(w)return w;D.delete(I)}}}e.Graph=t}),define(ee[5],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function I(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=I})(y=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,I,u){I[y.DI_TARGET]===I?I[y.DI_DEPENDENCIES].push({id:D,index:u}):(I[y.DI_DEPENDENCIES]=[{id:D,index:u}],I[y.DI_TARGET]=I)}function k(D){if(y.serviceIds.has(D))return y.serviceIds.get(D);const I=function(u,w,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,u,v)};return I.toString=()=>D,y.serviceIds.set(D,I),I}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(ee[60],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,y.createDecorator)("backupMainService")}),define(ee[19],ie([0,1,12,7,5]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function u(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function w(p,S){const m=Object.create(null);for(const h in p)v(m,h,p[h],S);return m}e.toValuesTree=w;function v(p,S,m,h){const l=S.split("."),s=l.pop();let a=p;for(let n=0;n<l.length;n++){const i=l[n];let r=a[i];switch(typeof r){case"undefined":r=a[i]=Object.create(null);break;case"object":break;default:h(`Ignoring ${S} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}a=r}if(typeof a=="object"&&a!==null)try{a[s]=m}catch{h(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(a)}`)}else h(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=v;function C(p,S){const m=S.split(".");E(p,m)}e.removeFromValueTree=C;function E(p,S){const m=S.shift();if(S.length===0){delete p[m];return}if(Object.keys(p).indexOf(m)!==-1){const h=p[m];typeof h=="object"&&!Array.isArray(h)&&(E(h,S),Object.keys(h).length===0&&delete p[m])}}function d(p,S,m){function h(a,n){let i=a;for(const r of n){if(typeof i!="object"||i===null)return;i=i[r]}return i}const l=S.split("."),s=h(p,l);return typeof s>"u"?m:s}e.getConfigurationValue=d;function f(p,S,m){Object.keys(S).forEach(h=>{h!=="__proto__"&&(h in p?y.isObject(p[h])&&y.isObject(S[h])?f(p[h],S[h],m):m&&(p[h]=S[h]):p[h]=S[h])})}e.merge=f;function P(p,S,m){const h=p.inspect(S),l=p.inspect(m);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:h.defaultValue}e.getMigratedSettingValue=P;function b(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(ee[69],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,y.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,y.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,I){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=I}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const I of Object.keys(this.secretVault[R]||{}))D.push({account:I,password:this.secretVault[R][I]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ee[84],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,I){return{}}async getSystemInfo(D,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,I){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(ee[105],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService")}),define(ee[36],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[27],ie([0,1,53,9,83,36,182,5]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(R.IEnvironmentService);class u extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([y.memoize],u.prototype,"cachedLanguagesPath",null),we([y.memoize],u.prototype,"backupHome",null),we([y.memoize],u.prototype,"mainIPCHandle",null),we([y.memoize],u.prototype,"mainLockfile",null),we([y.memoize],u.prototype,"disableUpdates",null),we([y.memoize],u.prototype,"disableKeytar",null),we([y.memoize],u.prototype,"crossOriginIsolated",null),we([y.memoize],u.prototype,"codeCachePath",null),we([y.memoize],u.prototype,"useCodeCache",null),e.EnvironmentMainService=u}),define(ee[190],ie([0,1,151,5]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(p,S){switch(p){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function I(p,S){return S==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function u(p,S,m){return I(S,m)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===m?!0:w(m).includes(p)}e.isTargetPlatformCompatible=u;function w(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function v(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=v;var C;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var E;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var d;(function(p){p.Install="install",p.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var f;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var P;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(S,m){super(S),this.code=m,this.name=m}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,y.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,y.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[191],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,y.createDecorator)("extensionUrlTrustService")}),define(ee[192],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,y.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[106],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,y.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,y.createDecorator)("externalTerminal")}),define(ee[193],ie([0,1,45,14,9,4,78,21,82,155,106]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=w.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await P.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends E{openTerminal(h,l){return this.spawnTerminal(y,h,u.getWindowsShell(),l)}spawnTerminal(h,l,s,a){const n=l.windowsExec||d.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const i=k.basename(n).toLowerCase();if(i==="cmder"||i==="cmder.exe")return h.spawn(n,a?[a]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return n.indexOf(" ")>=0&&r.push('""'),r.push(n),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((c,o)=>{const g=b(process),M=h.spawn(s,r,{cwd:a,env:g});M.on("error",o),M.on("exit",()=>c())})}runInTerminal(h,l,s,a,n){const i="windowsExec"in n&&n.windowsExec?n.windowsExec:d.getDefaultTerminalWindows();return new Promise((r,c)=>{const o=`"${l} - ${C}"`,g=`""${s.join('" "')}" & pause"`,M=["/c","start",o,"/wait",i,"/c",g],A=Object.assign({},b(process),a);Object.keys(A).filter(ae=>A[ae]===null).forEach(ae=>delete A[ae]);const _={cwd:l,env:A,windowsVerbatimArguments:!0};y.spawn(d.CMD,M,_).on("error",ae=>{c(p(ae))}),r(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=d,d.CMD="cmd.exe";class f extends E{openTerminal(h,l){return this.spawnTerminal(y,h,l)}runInTerminal(h,l,s,a,n){const i=n.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(i===v.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const o=i===v.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,z).fsPath,"-t",h||C,"-w",l];for(const G of s)M.push("-a"),M.push(G);if(a){const G=Object.assign({},b(process),a);for(const ae in G){const Q=G[ae];Q===null?(M.push("-u"),M.push(ae)):(M.push("-e"),M.push(`${ae}=${Q}`))}}let A="";const _=y.spawn(f.OSASCRIPT,M);_.on("error",G=>{c(p(G))}),_.stderr.on("data",G=>{A+=G.toString()}),_.on("exit",G=>{if(G===0)r(void 0);else if(A){const ae=A.split(`
`,1);c(new Error(ae[0]))}else c(new Error(w.localize(1,null,o,G)))})}else c(new Error(w.localize(2,null,i)))})}spawnTerminal(h,l,s){const a=l.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((n,i)=>{const r=["-a",a];s&&r.push(s);const c=b(process),o=h.spawn("/usr/bin/open",r,{cwd:s,env:c});o.on("error",i),o.on("exit",()=>n())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class P extends E{openTerminal(h,l){return this.spawnTerminal(y,h,l)}runInTerminal(h,l,s,a,n){const i=n.linuxExec?Promise.resolve(n.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{const o=[];i.then(g=>{g.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const M=`${S(s)}; echo; read -p "${P.WAIT_MESSAGE}" -n1;`;o.push(`''${M}''`);const A=Object.assign({},b(process),a);Object.keys(A).filter(Q=>A[Q]===null).forEach(Q=>delete A[Q]);const _={cwd:l,env:A};let G="";const ae=y.spawn(g,o,_);ae.on("error",Q=>{c(p(Q))}),ae.stderr.on("data",Q=>{G+=Q.toString()}),ae.on("exit",Q=>{if(Q===0)r(void 0);else if(G){const X=G.split(`
`,1);c(new Error(X[0]))}else c(new Error(w.localize(4,null,g,Q)))})})})}static async getDefaultTerminalLinuxReady(){if(!P._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)P._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await I.Promises.exists("/etc/debian_version");P._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{h?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return P._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,l,s){const a=l.linuxExec?Promise.resolve(l.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((n,i)=>{a.then(r=>{const c=b(process),o=h.spawn(r,[],{cwd:s,env:c});o.on("error",i),o.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=P,P.WAIT_MESSAGE=w.localize(3,null);function b(m){const h={...m.env};return(0,D.sanitizeProcessEnvironment)(h),h}function p(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(w.localize(5,null,m.path)):m}function S(m){let h="";for(const l of m)l.indexOf(" ")>=0?h+='"'+l+'"':h+=l,h+=" ";return h}}),define(ee[15],ie([0,1,29,9,26,12,7,157,5]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function w(V){return V.create===!0}e.isFileOpenForWriteOptions=w;var v;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var C;(function(V){V[V.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var E;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function f(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=f;function P(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=P;function b(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function S(V){return d(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var m;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(j,F){super(j),this.code=F}}e.FileSystemProviderError=h;function l(V,j){const F=new h(V.toString(),j);return a(F,j),F}e.createFileSystemProviderError=l;function s(V){return V||l((0,I.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=s;function a(V,j){return V.name=j?`${j} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=a;function n(V){if(!V)return m.Unknown;if(V instanceof h)return V.code;const j=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!j)return m.Unknown;switch(j[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=n;function i(V){if(V instanceof A)return V.fileOperationResult;switch(n(V)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(j,F,T){this.resource=j,this.operation=F,this.target=T}isOperation(j){return this.operation===j}}e.FileOperationEvent=c;var o;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor(j,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const T=new Map;for(const W of j){const N=T.get(W.type);switch(N?N.push([W.resource,W]):T.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,N]of T)switch(W){case 1:this.added=y.TernarySearchTree.forUris(()=>F),this.added.fill(N);break;case 0:this.updated=y.TernarySearchTree.forUris(()=>F),this.updated.fill(N);break;case 2:this.deleted=y.TernarySearchTree.forUris(()=>F),this.deleted.fill(N);break}}contains(j,...F){return this.doContains(j,{includeChildren:!1},...F)}affects(j,...F){return this.doContains(j,{includeChildren:!0},...F)}doContains(j,F,...T){if(!j)return!1;const W=T.length>0;return!!((!W||T.includes(1))&&(this.added?.get(j)||F.includeChildren&&this.added?.findSuperstr(j))||(!W||T.includes(0))&&(this.updated?.get(j)||F.includeChildren&&this.updated?.findSuperstr(j))||(!W||T.includes(2))&&(this.deleted?.findSubstr(j)||F.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function M(V,j,F){return!V||!j||V===j||j.length>V.length?!1:(j.charAt(j.length-1)!==t.sep&&(j+=t.sep),F?(0,k.startsWithIgnoreCase)(V,j):V.indexOf(j)===0)}e.isParent=M;class A extends Error{constructor(j,F,T){super(j),this.fileOperationResult=F,this.options=T}}e.FileOperationError=A;class _ extends A{constructor(j,F,T){super(j,2,T),this.stat=F}}e.NotModifiedSinceFileOperationError=_;var G;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=Q;async function X(V,j){if(!j.hasProvider(D.URI.from({scheme:V.scheme})))return new Promise(F=>{const T=j.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===V.scheme&&W.added&&(T.dispose(),F())})})}e.whenProviderRegistered=X,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(j){return(0,R.isNumber)(j)||(j=0),j<x.KB?(0,I.localize)(1,null,j.toFixed(0)):j<x.MB?(0,I.localize)(2,null,(j/x.KB).toFixed(2)):j<x.GB?(0,I.localize)(3,null,(j/x.MB).toFixed(2)):j<x.TB?(0,I.localize)(4,null,(j/x.GB).toFixed(2)):(0,I.localize)(5,null,(j/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var oe;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function fe(V){return{maxFileSize:V===0?300*x.MB:16*x.GB,maxHeapSize:V===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=fe}),define(ee[194],ie([0,1,17,44,16,3,2,58,7,30,15]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends D.Disposable{constructor(d,f){super(),this.channel=d,this.extraCapabilities=f,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,f){const{buffer:P}=await this.channel.call("readFile",[d,f]);return P}readFileStream(d,f,P){const b=(0,I.newWriteableStream)(S=>y.VSBuffer.concat(S.map(m=>y.VSBuffer.wrap(m))).buffer),p=this.channel.listen("readFileStream",[d,f])(S=>{if(S instanceof y.VSBuffer)b.write(S.buffer);else{if(S==="end")b.end();else{let m=S;m instanceof Error||(m=(0,v.createFileSystemProviderError)((0,t.toErrorMessage)(m),v.FileSystemProviderErrorCode.Unknown)),b.error(m),b.end()}p.dispose()}});return P.onCancellationRequested(()=>{b.error((0,k.canceled)()),b.end(),p.dispose()}),b}writeFile(d,f,P){return this.channel.call("writeFile",[d,y.VSBuffer.wrap(f),P])}open(d,f){return this.channel.call("open",[d,f])}close(d){return this.channel.call("close",[d])}async read(d,f,P,b,p){const[S,m]=await this.channel.call("read",[d,f,p]);return P.set(S.buffer.slice(0,m),b),m}write(d,f,P,b,p){return this.channel.call("write",[d,f,y.VSBuffer.wrap(P),b,p])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,f){return this.channel.call("delete",[d,f])}rename(d,f,P){return this.channel.call("rename",[d,f,P])}copy(d,f,P){return this.channel.call("copy",[d,f,P])}cloneFile(d,f){return this.channel.call("cloneFile",[d,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const f=d;this._onDidChange.fire(f.map(P=>({resource:u.URI.revive(P.resource),type:P.type})))}else{const f=d;this._onDidWatchError.fire(f)}}))}watch(d,f){const P=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,P,d,f]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,P]))}}e.DiskFileSystemProviderClient=C}),define(ee[107],ie([0,1,17,16,158,15]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(v,C,E,d,f,P){let b;try{await I(v,C,E,d,f,P)}catch(p){b=p}finally{b&&f.errorTransformer&&(b=f.errorTransformer(b)),typeof b<"u"&&E.error(b),E.end()}}e.readFileIntoStream=D;async function I(v,C,E,d,f,P){u(P);const b=await v.open(C,{create:!1});try{u(P);let p=0,S=0,m=f&&typeof f.length=="number"?f.length:void 0,h=y.VSBuffer.alloc(Math.min(f.bufferSize,typeof m=="number"?m:f.bufferSize)),l=f&&typeof f.position=="number"?f.position:0,s=0;do S=await v.read(b,l,h.buffer,s,h.byteLength-s),l+=S,s+=S,p+=S,typeof m=="number"&&(m-=S),s===h.byteLength&&(await E.write(d(h)),h=y.VSBuffer.alloc(Math.min(f.bufferSize,typeof m=="number"?m:f.bufferSize)),s=0);while(S>0&&(typeof m!="number"||m>0)&&u(P)&&w(p,f));if(s>0){let a=s;typeof m=="number"&&(a=Math.min(s,m)),E.write(d(h.slice(0,a)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await v.close(b)}}function u(v){if(v.isCancellationRequested)throw(0,t.canceled)();return!0}function w(v,C){if(C?.limits){if(typeof C.limits.memory=="number"&&v>C.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&v>C.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[70],ie([0,1,98,2,9,4,7,15]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(p){return p.recursive===!0}e.isRecursiveWatchRequest=u;class w extends t.Disposable{constructor(S,m,h,l){super(),this.onFileChanges=S,this.onLogMessage=m,this.verboseLogging=h,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new t.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),S.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),S.add(this.watcher.onDidError(m=>this.onError(m)))}onError(S){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.MAX_RESTARTS=5;class v extends w{constructor(S,m,h){super(S,m,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class C extends w{constructor(S,m,h){super(S,m,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function E(p){return p.map(S=>({type:S.type,resource:D.URI.file(S.path)}))}e.toFileChanges=E;function d(p){const S=new b;for(const m of p)S.processEvent(m);return S.coalesce()}e.coalesceEvents=d;function f(p,S){return typeof S=="string"&&!S.startsWith(y.GLOBSTAR)&&!(0,k.isAbsolute)(S)?{base:p,pattern:S}:S}e.normalizeWatcherPattern=f;function P(p,S){const m=[];for(const h of S)m.push((0,y.parse)(f(p,h)));return m}e.parseWatcherPatterns=P;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return R.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const m=this.mapPathToChange.get(this.toKey(S));let h=!1;if(m){const l=m.type,s=S.type;m.path!==S.path&&(S.type===2||S.type===1)?h=!0:l===1&&s===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(m)):l===2&&s===1?m.type=0:l===1&&s===0||(m.type=s)}else h=!0;h&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],m=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(S.push(h),!1):!0).sort((h,l)=>h.path.length-l.path.length).filter(h=>m.some(l=>(0,I.isParent)(h.path,l,!R.isLinux))?!1:(m.push(h.path),!0)).concat(S)}}}),define(ee[195],ie([0,1,40,8,23,31,2,80,9,4,99,21,70]),function(z,e,y,t,k,R,D,I,u,w,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends D.Disposable{constructor(b,p,S,m){super(),this.request=b,this.onDidFilesChange=p,this.onLogMessage=S,this.verboseLogging=m,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,E.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,E.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const b=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await C.Promises.stat(b);this._register(await this.doWatch(b,p.isDirectory()))}catch(b){b.code!=="ENOENT"?this.error(b):this.trace(b)}}async normalizePath(b){let p=b.path;try{p=await C.Promises.realpath(b.path),b.path===p&&(p=await(0,v.realcase)(b.path)??b.path),b.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${p})`)}catch{}return p}async doWatch(b,p){if(w.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.error(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token),m=new D.DisposableStore;try{const h=(0,u.basename)(b),l=(0,y.watch)(b);m.add((0,D.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${b}'`);const s=new Set;if(p)try{for(const n of await C.Promises.readdir(b))s.add(n)}catch(n){this.error(n)}const a=new Map;m.add((0,D.toDisposable)(()=>{for(const[,n]of a)n.dispose();a.clear()})),l.on("error",(n,i)=>{this.error(`Failed to watch ${b} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),l.on("change",(n,i)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let r="";if(i&&(r=i.toString(),w.isMacintosh&&(r=(0,I.normalizeNFC)(r))),!(!r||n!=="change"&&n!=="rename"))if(p)if(n==="rename"){a.get(r)?.dispose();const c=setTimeout(async()=>{if(a.delete(r),r===h&&!await C.Promises.exists(b)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,u.join)(b,r));if(S.token.isCancellationRequested)return;let g;o?s.has(r)?g=0:(g=1,s.add(r)):(s.delete(r),g=2),this.onFileChange({path:(0,u.join)(this.request.path,r),type:g})},d.FILE_DELETE_HANDLER_DELAY);a.set(r,(0,D.toDisposable)(()=>clearTimeout(c)))}else{let c;s.has(r)?c=0:(c=1,s.add(r)),this.onFileChange({path:(0,u.join)(this.request.path,r),type:c})}else if(n==="rename"||r!==h){const c=setTimeout(async()=>{const o=await C.Promises.exists(b);S.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(b,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,D.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await C.Promises.exists(b)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${b} for changes using fs.watch() (${h.toString()})`)}return(0,D.toDisposable)(()=>{S.dispose(!0),m.dispose()})}async onFileChange(b,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!p&&this.excludes.some(S=>S(b.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${b.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(b.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${b.path}`):this.fileChangesBuffer.push(b);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,E.coalesceEvents)(S);if(m.length>0){if(this.verboseLogging)for(const l of m)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(m)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(b){if(w.isLinux)return C.Promises.exists(b);try{const p=(0,u.basename)(b);return(await C.Promises.readdir((0,u.dirname)(b))).some(m=>m===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(b){this.verboseLogging=b}error(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}warn(b){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}trace(b){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function f(P,b,p,S,m=512){const h=await C.Promises.open(P,"r"),l=Buffer.allocUnsafe(m),s=new k.CancellationTokenSource(S);let a,n=!1;const i={path:P,excludes:[],recursive:!1},r=new d(i,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(n)return;n=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:g}=await C.Promises.read(h,l,0,m,null);if(!g||s.token.isCancellationRequested)break;b(l.slice(0,g))}}catch(g){a=new Error(g),s.dispose(!0)}finally{n=!1}}})()});return await r.ready,p(),new Promise((c,o)=>{s.token.onCancellationRequested(async()=>{r.dispose();try{await C.Promises.close(h)}catch(g){a=new Error(g)}a?o(a):c()})})}e.watchFileContents=f}),define(ee[196],ie([0,1,3,98,2,4,195]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new y.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new y.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=y.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const v=this.normalizeRequests(w),C=v.filter(d=>{const f=this.watchers.get(d.path);return f?!(0,t.patternsEquals)(f.request.excludes,d.excludes)||!(0,t.patternsEquals)(f.request.includes,d.includes):!0}),E=Array.from(this.watchers.values()).filter(({request:d})=>!v.find(f=>f.path===d.path&&(0,t.patternsEquals)(f.excludes,d.excludes)&&(0,t.patternsEquals)(f.includes,d.includes))).map(({request:d})=>d.path);C.length&&this.trace(`Request to start watching: ${C.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const d of E)this.stopWatching(d);for(const d of C)this.startWatching(d)}startWatching(w){const v=new D.NodeJSFileWatcherLibrary(w,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),C={request:w,instance:v};this.watchers.set(w.path,C)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const v=this.watchers.get(w);v&&(this.watchers.delete(w),v.instance.dispose())}normalizeRequests(w){const v=new Map;for(const C of w){const E=R.isLinux?C.path:C.path.toLowerCase();v.set(E,C)}return Array.from(v.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,v]of this.watchers)v.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,v){return v?`[File Watcher (node.js)] ${w} (path: ${v.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=I}),define(ee[197],ie([0,1,70,196]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends y.AbstractNonRecursiveWatcherClient{constructor(D,I,u){super(D,I,u),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ee[198],ie([0,1,14,46,144,70]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(u,w,v){super(u,w,v),this.init()}createWatcher(u){const w=u.add(new k.Client(y.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(w.onDidProcessExit(({code:v,signal:C})=>this.onError(`terminated by itself with code ${v}, signal: ${C}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ee[85],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=y}),define(ee[199],ie([0,1,8,16,2,68,189,5,85,94]),function(z,e,y,t,k,R,D,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class C extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class E{constructor(b=new u.ServiceCollection,p=!1,S,m=v){this._services=b,this._strict=p,this._parent=S,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=m?S?._globalGraph??new D.Graph(h=>h):void 0}createChild(b){return new E(b,this._strict,this,this._enableTracing)}invokeFunction(b,...p){const S=f.traceInvocation(this._enableTracing,b);let m=!1;try{return b({get:l=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(l,S);if(!s)throw new Error(`[invokeFunction] unknown service '${l}'`);return s}},...p)}finally{m=!0,S.stop()}}createInstance(b,...p){let S,m;return b instanceof R.SyncDescriptor?(S=f.traceCreation(this._enableTracing,b.ctor),m=this._createInstance(b.ctor,b.staticArguments.concat(p),S)):(S=f.traceCreation(this._enableTracing,b),m=this._createInstance(b,p,S)),S.stop(),m}_createInstance(b,p=[],S){const m=I._util.getServiceDependencies(b).sort((s,a)=>s.index-a.index),h=[];for(const s of m){const a=this._getOrCreateServiceInstance(s.id,S);a||this._throwIfStrict(`[createInstance] ${b.name} depends on UNKNOWN service ${s.id}.`,!1),h.push(a)}const l=m.length>0?m[0].index:p.length;if(p.length!==l){console.trace(`[createInstance] First service dependency of ${b.name} at position ${l+1} conflicts with ${p.length} static arguments`);const s=l-p.length;s>0?p=p.concat(new Array(s)):p=p.slice(0,l)}return Reflect.construct(b,p.concat(h))}_setServiceInstance(b,p){if(this._services.get(b)instanceof R.SyncDescriptor)this._services.set(b,p);else if(this._parent)this._parent._setServiceInstance(b,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(b){const p=this._services.get(b);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(b):p}_getOrCreateServiceInstance(b,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(b));const S=this._getServiceInstanceOrDescriptor(b);return S instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(b,S,p.branch(b,!0)):(p.branch(b,!1),S)}_safeCreateAndCacheServiceInstance(b,p,S){if(this._activeInstantiations.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this._activeInstantiations.add(b);try{return this._createAndCacheServiceInstance(b,p,S)}finally{this._activeInstantiations.delete(b)}}_createAndCacheServiceInstance(b,p,S){const m=new D.Graph(s=>s.id.toString());let h=0;const l=[{id:b,desc:p,_trace:S}];for(;l.length;){const s=l.pop();if(m.lookupOrInsertNode(s),h++>1e3)throw new C(m);for(const a of I._util.getServiceDependencies(s.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(a.id);if(n||this._throwIfStrict(`[createInstance] ${b} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof R.SyncDescriptor){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};m.insertEdge(s,i),l.push(i)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,i)}m.removeNode(a)}}return this._getServiceInstanceOrDescriptor(b)}_createServiceInstanceWithOwner(b,p,S=[],m,h){if(this._services.get(b)instanceof R.SyncDescriptor)return this._createServiceInstance(b,p,S,m,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(b,p,S,m,h);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(b,p,S=[],m,h){if(m){const l=new E(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(b);const s=new Map,a=new y.IdleValue(()=>{const n=l._createInstance(p,S,h);for(const[i,r]of s){const c=n[i];if(typeof c=="function")for(const o of r)c.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new w.LinkedList,s.set(i,o)),(M,A,_)=>{const G=o.push([M,A,_]);return(0,k.toDisposable)(G)}}if(i in n)return n[i];const r=a.value;let c=r[i];return typeof c!="function"||(c=c.bind(r),n[i]=c),c},set(n,i,r){return a.value[i]=r,!0}})}else return this._createInstance(p,S,h)}_throwIfStrict(b,p){if(p&&console.warn(b),this._strict)throw new Error(b)}}e.InstantiationService=E;var d;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(d||(d={}));class f{static traceInvocation(b,p){return b?new f(1,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(b,p){return b?new f(0,p.name):f._None}constructor(b,p){this.type=b,this.name=p,this._start=Date.now(),this._dep=[]}branch(b,p){const S=new f(2,b.toString());return this._dep.push([b,p,S]),S}stop(){const b=Date.now()-this._start;f._totals+=b;let p=!1;function S(h,l){const s=[],a=new Array(h+1).join("	");for(const[n,i,r]of l._dep)if(i&&r){p=!0,s.push(`${a}CREATES -> ${n}`);const c=S(h+1,r);c&&s.push(c)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(b>2||p)&&f.all.add(m.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ee[6],ie([0,1,44,3,2,29,4,7,5]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function w(){return new Date().toISOString()}var v;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function C(c,o,g){switch(o){case v.Trace:c.trace(g);break;case v.Debug:c.debug(g);break;case v.Info:c.info(g);break;case v.Warning:c.warn(g);break;case v.Error:c.error(g);break;case v.Critical:c.critical(g);break;default:throw new Error("Invalid log level")}}e.log=C;function E(c){let o="";for(let g=0;g<c.length;g++){let M=c[g];if(typeof M=="object")try{M=JSON.stringify(M)}catch{}o+=(g>0?" ":"")+M}return o}e.format=E;class d extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=d;class f extends d{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...g){this.checkLogLevel(v.Trace)&&this.log(v.Trace,E([o,...g]))}debug(o,...g){this.checkLogLevel(v.Debug)&&this.log(v.Debug,E([o,...g]))}info(o,...g){this.checkLogLevel(v.Info)&&this.log(v.Info,E([o,...g]))}warn(o,...g){this.checkLogLevel(v.Warning)&&this.log(v.Warning,E([o,...g]))}error(o,...g){if(this.checkLogLevel(v.Error))if(o instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=o.stack,this.log(v.Error,E(M))}else this.log(v.Error,E([o,...g]))}critical(o,...g){this.checkLogLevel(v.Critical)&&this.log(v.Critical,E([o,...g]))}flush(){}}e.AbstractMessageLogger=f;class P extends d{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!D.isWindows}trace(o,...g){this.getLevel()<=v.Trace&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...g):console.log(`[main ${w()}]`,o,...g))}debug(o,...g){this.getLevel()<=v.Debug&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...g):console.log(`[main ${w()}]`,o,...g))}info(o,...g){this.getLevel()<=v.Info&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,o,...g):console.log(`[main ${w()}]`,o,...g))}warn(o,...g){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,o,...g):console.warn(`[main ${w()}]`,o,...g))}error(o,...g){this.getLevel()<=v.Error&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,o,...g):console.error(`[main ${w()}]`,o,...g))}critical(o,...g){this.getLevel()<=v.Critical&&(this.useColors?console.error(`\x1B[90m[main ${w()}]\x1B[0m`,o,...g):console.error(`[main ${w()}]`,o,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class b extends d{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...g){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",o,...g)}debug(o,...g){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...g)}info(o,...g){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",o,...g)}warn(o,...g){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",o,...g)}error(o,...g){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",o,...g)}critical(o,...g){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...g)}dispose(){}flush(){}}e.ConsoleLogger=b;class p extends d{constructor(o,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(g)}trace(o,...g){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(o),...g])}debug(o,...g){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(o),...g])}info(o,...g){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(o),...g])}warn(o,...g){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(o),...g])}error(o,...g){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(o),...g])}critical(o,...g){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(o),...g])}extractMessage(o){return typeof o=="string"?o:(0,y.toErrorMessage)(o,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class S extends d{constructor(o){super(),this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const g of this.logServices)g.setLevel(o);super.setLevel(o)}trace(o,...g){for(const M of this.logServices)M.trace(o,...g)}debug(o,...g){for(const M of this.logServices)M.debug(o,...g)}info(o,...g){for(const M of this.logServices)M.info(o,...g)}warn(o,...g){for(const M of this.logServices)M.warn(o,...g)}error(o,...g){for(const M of this.logServices)M.error(o,...g)}critical(o,...g){for(const M of this.logServices)M.critical(o,...g)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=S;class m extends k.Disposable{constructor(o){super(),this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...g){this.logger.trace(o,...g)}debug(o,...g){this.logger.debug(o,...g)}info(o,...g){this.logger.info(o,...g)}warn(o,...g){this.logger.warn(o,...g)}error(o,...g){this.logger.error(o,...g)}critical(o,...g){this.logger.critical(o,...g)}flush(){this.logger.flush()}}e.LogService=m;class h extends k.Disposable{constructor(o,g){super(),this.logLevel=o,this.loggerItems=new R.ResourceMap,this._register(g(M=>this.setLevel(M)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:o})=>o)}getLogger(o){return this.loggerItems.get(o)?.logger}createLogger(o,g,M){let A=this.loggerItems.get(o)?.logger;return A||(M=g?.always?v.Trace:M,A=this.doCreateLogger(o,M??this.logLevel,g),this.loggerItems.set(o,{logger:A,logLevel:M})),A}setLevel(o,g){const M=I.URI.isUri(o)?o:void 0,A=M?g:o;if(M){const _=this.loggerItems.get(M);_&&_.logLevel!==A&&(_.logLevel=A,_.logger.setLevel(A))}else this.logLevel=A,this.loggerItems.forEach(({logLevel:_,logger:G})=>{_===void 0&&G.setLevel(this.logLevel)})}getLogLevel(o){return this.loggerItems.get(o)?.logLevel}dispose(){this.loggerItems.forEach(({logger:o})=>o.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=h;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return v.Info}trace(o,...g){}debug(o,...g){}info(o,...g){}warn(o,...g){}error(o,...g){}critical(o,...g){}dispose(){}flush(){}}e.NullLogger=l;class s extends l{}e.NullLogService=s;class a extends h{constructor(){super(v.Info,t.Event.None)}doCreateLogger(o,g,M){return new l}}e.NullLoggerService=a;function n(c){if(c.verbose)return v.Trace;if(typeof c.logLevel=="string"){const o=i(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function i(c){switch(c){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=i;function r(c){switch(c){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=r});var te=this&&this.__param||function(z,e){return function(y,t){e(y,t,z)}};define(ee[200],ie([0,1,69,3,2,6,4,8]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let u=class Et extends k.Disposable{constructor(v){super(),this.logService=v,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(v,C){this.logService.trace("Getting password from keytar:",v,C);let E;try{E=await this.withKeytar()}catch{return null}const d=await(0,I.retry)(()=>E.getPassword(v,C),50,3);if(!d)return this.logService.trace("Did not get a password from keytar for account:",C),d;let f,P;try{const b=JSON.parse(d);f=b.content,P=b.hasNextChunk}catch{}if(!f||!P)return this.logService.trace("Got password from keytar for account:",C),d;try{let b=1;for(;P;){const p=await(0,I.retry)(()=>E.getPassword(v,`${C}-${b}`),50,3),S=JSON.parse(p);f+=S.content,P=S.hasNextChunk,b++}return this.logService.trace(`Got ${b}-chunked password from keytar for account:`,C),f}catch(b){return this.logService.error(b),d}}async setPassword(v,C,E){this.logService.trace("Setting password using keytar:",v,C);let d;try{d=await this.withKeytar()}catch(f){throw this.surfaceKeytarLoadError?.(f),f}if(D.isWindows&&E.length>Et.MAX_PASSWORD_LENGTH){let f=0,P=0,b=!0;for(;b;){const p=E.substring(f,f+Et.PASSWORD_CHUNK_SIZE);f+=Et.PASSWORD_CHUNK_SIZE,b=E.length-f>0;const S={content:p,hasNextChunk:b};await(0,I.retry)(()=>d.setPassword(v,P?`${C}-${P}`:C,JSON.stringify(S)),50,3),P++}this.logService.trace(`Got${P?` ${P}-chunked`:""} password from keytar for account:`,C)}else await(0,I.retry)(()=>d.setPassword(v,C,E),50,3),this.logService.trace("Got password from keytar for account:",C);this._onDidChangePassword.fire({service:v,account:C})}async deletePassword(v,C){this.logService.trace("Deleting password using keytar:",v,C);let E;try{E=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}const d=await E.getPassword(v,C);if(!d)return this.logService.trace("Did not get a password to delete from keytar for account:",C),!1;let f,P;try{const p=JSON.parse(d);f=p.content,P=p.hasNextChunk}catch{}let b=0;if(f&&P)try{for(b++;P;){const p=`${C}-${b}`,S=await E.getPassword(v,p);await E.deletePassword(v,p),P=JSON.parse(S).hasNextChunk,b++}}catch(p){this.logService.error(p)}return await E.deletePassword(v,C)?(this._onDidChangePassword.fire({service:v,account:C}),this.logService.trace(`Deleted${b?` ${b}-chunked`:""} password from keytar for account:`,C),!0):(this.logService.trace(`Keytar failed to delete${b?` ${b}-chunked`:""} password for account:`,C),!1)}async findPassword(v){let C;try{C=await this.withKeytar()}catch{return null}return await C.findPassword(v)}async findCredentials(v){let C;try{C=await this.withKeytar()}catch{return[]}return await C.findCredentials(v)}clear(){return this._keytarCache instanceof y.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};u.MAX_PASSWORD_LENGTH=2500,u.PASSWORD_CHUNK_SIZE=u.MAX_PASSWORD_LENGTH-100,u=we([te(0,R.ILogService)],u),e.BaseCredentialsMainService=u}),define(ee[201],ie([0,1,24,8,16,3,2,9,70,6]),function(z,e,y,t,k,R,D,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends D.Disposable{constructor(E,d){super(),this.logService=E,this.options=d,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(E,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,d):this.watchNonRecursive(E,d)}watchUniversal(E,d){const f={path:this.toFilePath(E),excludes:d.excludes,includes:d.includes,recursive:d.recursive},P=(0,y.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,k.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,u.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&E.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,d){const f={path:this.toFilePath(E),excludes:d.excludes,includes:d.includes,recursive:!1},P=(0,y.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,k.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,u.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,I.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(ee[202],ie([0,1,24,8,17,23,3,66,57,2,29,14,71,18,58,156,15,107,6]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends w.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,s){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${l}`);const a=new w.DisposableStore;return this.provider.set(l,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:s}),a.add(s.onDidChangeFile(n=>this._onDidFilesChange.fire(new b.FileChangesEvent(n,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&a.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),a.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:l}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:s}),this.provider.delete(l),(0,w.dispose)(a)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(a){s.push(a)}}),!this.provider.has(l)&&await t.Promises.settled(s)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,s){const a=this.provider.get(l.scheme);return!!(a&&a.capabilities&s)}listCapabilities(){return u.Iterable.map(this.provider,([l,s])=>({scheme:l,capabilities:s.capabilities}))}async withProvider(l){if(!(0,d.isAbsolutePath)(l))throw new b.FileOperationError((0,P.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const s=this.provider.get(l.scheme);if(!s){const a=new Error;throw a.name="ENOPRO",a.message=(0,P.localize)(1,null,l.toString()),a}return s}async withReadProvider(l){const s=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s)||(0,b.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const s=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,s){try{return await this.doResolveFile(l,s)}catch(a){throw(0,b.toFileSystemProviderErrorCode)(a)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,P.localize)(2,null,this.resourceForError(l)),1):(0,b.ensureFileSystemProviderError)(a)}}async doResolveFile(l,s){const a=await this.withProvider(l),n=this.isPathCaseSensitive(a),i=s?.resolveTo,r=s?.resolveSingleChildDescendants,c=s?.resolveMetadata,o=await a.stat(l);let g;return this.toFileStat(a,l,o,void 0,!!c,(M,A)=>(g||(g=v.TernarySearchTree.forUris(()=>!n),g.set(l,!0),i&&g.fill(!0,i)),g.get(M.resource)||g.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&r?A===1:!1))}async toFileStat(l,s,a,n,i,r){const{providerExtUri:c}=this.getExtUri(l),o={resource:s,name:c.basename(s),isFile:(a.type&b.FileType.File)!==0,isDirectory:(a.type&b.FileType.Directory)!==0,isSymbolicLink:(a.type&b.FileType.SymbolicLink)!==0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&b.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,b.etag)({mtime:a.mtime,size:a.size}),children:void 0};if(o.isDirectory&&r(o,n)){try{const g=await l.readdir(s),M=await t.Promises.settled(g.map(async([A,_])=>{try{const G=c.joinPath(s,A),ae=i?await l.stat(G):{type:_};return await this.toFileStat(l,G,ae,g.length,i,r)}catch(G){return this.logService.trace(G),null}}));o.children=(0,y.coalesce)(M)}catch(g){this.logService.trace(g),o.children=[]}return o}return o}async resolveAll(l){return t.Promises.settled(l.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async stat(l){const s=await this.withProvider(l),a=await s.stat(l);return this.toFileStat(s,l,a,void 0,!0,()=>!1)}async exists(l){const s=await this.withProvider(l);try{return!!await s.stat(l)}catch{return!1}}async canCreateFile(l,s){try{await this.doValidateCreateFile(l,s)}catch(a){return a}return!0}async doValidateCreateFile(l,s){if(!s?.overwrite&&await this.exists(l))throw new b.FileOperationError((0,P.localize)(3,null,this.resourceForError(l)),3,s)}async createFile(l,s=k.VSBuffer.fromString(""),a){await this.doValidateCreateFile(l,a);const n=await this.writeFile(l,s);return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,n)),n}async writeFile(l,s,a){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,l,a)||await this.mkdirp(n,i.dirname(l));let c;if((0,b.hasReadWriteCapability)(n)&&!(s instanceof k.VSBuffer))if((0,f.isReadableStream)(s)){const o=await(0,f.peekStream)(s,3);o.ended?c=k.VSBuffer.concat(o.buffer):c=o}else c=(0,f.peekReadable)(s,o=>k.VSBuffer.concat(o),3);else c=s;!(0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(n,l,a,c):await this.doWriteBuffered(n,l,a,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new b.FileOperationEvent(l,4))}catch(r){throw new b.FileOperationError((0,P.localize)(4,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),a)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,s,a){if(!!a?.unlock&&!(l.capabilities&8192))throw new Error((0,P.localize)(5,null,this.resourceForError(s)));let i;try{i=await l.stat(s)}catch{return}if((i.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,P.localize)(6,null,this.resourceForError(s)),0,a);if(this.throwIfFileIsReadonly(s,i),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==b.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&a.mtime<i.mtime&&a.etag!==(0,b.etag)({mtime:a.mtime,size:i.size}))throw new b.FileOperationError((0,P.localize)(7,null),3,a);return i}async readFile(l,s,a){const n=await this.withReadProvider(l);return s?.atomic?this.doReadFileAtomic(n,l,s,a):this.doReadFile(n,l,s,a)}async doReadFileAtomic(l,s,a,n){return new Promise((i,r)=>{this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(l,s,a,n);i(c)}catch(c){r(c)}})})}async doReadFile(l,s,a,n){const i=await this.doReadFileStream(l,s,{...a,preferUnbuffered:!0},n);return{...i,value:await(0,k.streamToBuffer)(i.value)}}async readFileStream(l,s,a){const n=await this.withReadProvider(l);return this.doReadFileStream(n,l,s,a)}async doReadFileStream(l,s,a,n){const i=new R.CancellationTokenSource(n),r=this.validateReadFile(s,a).then(o=>o,o=>{throw i.cancel(),o});let c;try{return typeof a?.etag=="string"&&a.etag!==b.ETAG_DISABLED&&await r,a?.atomic&&(0,b.hasFileAtomicReadCapability)(l)||!((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasFileReadStreamCapability)(l))||(0,b.hasReadWriteCapability)(l)&&a?.preferUnbuffered?c=this.readFileUnbuffered(l,s,a):(0,b.hasFileReadStreamCapability)(l)?c=this.readFileStreamed(l,s,i.token,a):c=this.readFileBuffered(l,s,i.token,a),{...await r,value:c}}catch(o){c&&await(0,f.consumeStream)(c);const g=(0,P.localize)(8,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(o).toString());throw o instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(g,o.stat,a):new b.FileOperationError(g,(0,b.toFileOperationResult)(o),a)}}readFileStreamed(l,s,a,n=Object.create(null)){const i=l.readFileStream(s,n,a);return(0,f.transform)(i,{data:r=>r instanceof k.VSBuffer?r:k.VSBuffer.wrap(r),error:r=>new b.FileOperationError((0,P.localize)(9,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),n)},r=>k.VSBuffer.concat(r))}readFileBuffered(l,s,a,n=Object.create(null)){const i=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(l,s,i,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new b.FileOperationError((0,P.localize)(10,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),n)},a),i}readFileUnbuffered(l,s,a){const n=(0,f.newWriteableStream)(i=>k.VSBuffer.concat(i));return(async()=>{try{let i;a?.atomic&&(0,b.hasFileAtomicReadCapability)(l)?i=await l.readFile(s,{atomic:!0}):i=await l.readFile(s),typeof a?.position=="number"&&(i=i.slice(a.position)),typeof a?.length=="number"&&(i=i.slice(0,a.length)),this.validateReadFileLimits(s,i.byteLength,a),n.end(k.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(l,s){const a=await this.resolve(l,{resolveMetadata:!0});if(a.isDirectory)throw new b.FileOperationError((0,P.localize)(11,null,this.resourceForError(l)),0,s);if(typeof s?.etag=="string"&&s.etag!==b.ETAG_DISABLED&&s.etag===a.etag)throw new b.NotModifiedSinceFileOperationError((0,P.localize)(12,null),a,s);return this.validateReadFileLimits(l,a.size,s),a}validateReadFileLimits(l,s,a){if(a?.limits){let n;if(typeof a.limits.memory=="number"&&s>a.limits.memory&&(n=9),typeof a.limits.size=="number"&&s>a.limits.size&&(n=7),typeof n=="number")throw new b.FileOperationError((0,P.localize)(13,null,this.resourceForError(l)),n)}}async canMove(l,s,a){return this.doCanMoveCopy(l,s,"move",a)}async canCopy(l,s,a){return this.doCanMoveCopy(l,s,"copy",a)}async doCanMoveCopy(l,s,a,n){if(l.toString()!==s.toString())try{const i=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,l,r,s,a,n)}catch(i){return i}return!0}async move(l,s,a){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,l,i,s,"move",!!a),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,r==="move"?2:3,c)),c}async copy(l,s,a){const n=await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(n,l,i,s,"copy",!!a),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,r==="copy"?3:2,c)),c}async doMoveCopy(l,s,a,n,i,r){if(s.toString()===n.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,s,a,n,i,r);if(c&&!o&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(n)),i==="copy"){if(l===a&&(0,b.hasFileFolderCopyCapability)(l))await l.copy(s,n,{overwrite:r});else{const g=await this.resolve(s);g.isDirectory?await this.doCopyFolder(l,g,a,n):await this.doCopyFile(l,s,a,n)}return i}else return l===a?(await l.rename(s,n,{overwrite:r}),i):(await this.doMoveCopy(l,s,a,n,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(l,s,a,n){if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(l,s,a,n);if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(l,s,a,n);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(l,s,a,n);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasReadWriteCapability)(a))return this.doPipeUnbuffered(l,s,a,n)}async doCopyFolder(l,s,a,n){await a.mkdir(n),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async i=>{const r=this.getExtUri(a).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(l,await this.resolve(i.resource),a,r):this.doCopyFile(l,i.resource,a,r)}))}async doValidateMoveCopy(l,s,a,n,i,r){let c=!1;if(l===a){const{providerExtUri:g,isPathCaseSensitive:M}=this.getExtUri(l);if(M||(c=g.isEqual(s,n)),c&&i==="copy")throw new Error((0,P.localize)(14,null,this.resourceForError(s),this.resourceForError(n)));if(!c&&g.isEqualOrParent(n,s))throw new Error((0,P.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}const o=await this.exists(n);if(o&&!c){if(!r)throw new b.FileOperationError((0,P.localize)(16,null,this.resourceForError(s),this.resourceForError(n)),4);if(l===a){const{providerExtUri:g}=this.getExtUri(l);if(g.isEqualOrParent(s,n))throw new Error((0,P.localize)(17,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}getExtUri(l){const s=this.isPathCaseSensitive(l);return{providerExtUri:s?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(s,l);const a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,a)),a}async mkdirp(l,s){const a=[],{providerExtUri:n}=this.getExtUri(l);for(;!n.isEqual(s,n.dirname(s));)try{if(((await l.stat(s)).type&b.FileType.Directory)===0)throw new Error((0,P.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,b.toFileSystemProviderErrorCode)(i)!==b.FileSystemProviderErrorCode.FileNotFound)throw i;a.push(n.basename(s)),s=n.dirname(s)}for(let i=a.length-1;i>=0;i--){s=n.joinPath(s,a[i]);try{await l.mkdir(s)}catch(r){if((0,b.toFileSystemProviderErrorCode)(r)!==b.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(l,s){try{await this.doValidateDelete(l,s)}catch(a){return a}return!0}async doValidateDelete(l,s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!s?.useTrash&&!(a.capabilities&4096))throw new Error((0,P.localize)(19,null,this.resourceForError(l)));let i;try{i=await a.stat(l)}catch{}if(i)this.throwIfFileIsReadonly(l,i);else throw new b.FileOperationError((0,P.localize)(20,null,this.resourceForError(l)),1);if(!!!s?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,P.localize)(21,null,this.resourceForError(l)))}return a}async del(l,s){const a=await this.doValidateDelete(l,s),n=!!s?.useTrash,i=!!s?.recursive;await a.delete(l,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new b.FileOperationEvent(l,1))}async cloneFile(l,s){const a=await this.withProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(a===n&&this.getExtUri(a).providerExtUri.isEqual(l,s))return;if(a===n&&(0,b.hasFileCloneCapability)(a))return a.cloneFile(l,s);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s));const i=this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri);return a===n&&(0,b.hasFileFolderCopyCapability)(a)?i.queue(()=>a.copy(l,s,{overwrite:!0})):i.queue(()=>this.doCopyFile(a,l,n,s))}watch(l,s={recursive:!1,excludes:[]}){const a=new w.DisposableStore;let n=!1,i=()=>{n=!0};return a.add((0,w.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(l,s);n?(0,w.dispose)(r):i=()=>(0,w.dispose)(r)}catch(r){this.logService.error(r)}})(),a}async doWatch(l,s){const a=await this.withProvider(l),n=(0,I.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(l),s]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:a.watch(l,s)},this.activeWatchers.set(n,i)),i.count+=1,(0,w.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,w.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,w.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,s,a,n){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{const i=await l.open(s,{create:!0,unlock:a?.unlock??!1});try{(0,f.isReadableStream)(n)||(0,f.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(l,i,n):await this.doWriteReadableBufferedQueued(l,i,n)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await l.close(i)}})}async doWriteStreamBufferedQueued(l,s,a){let n=0,i;if((0,f.isReadableBufferedStream)(a)){if(a.buffer.length>0){const r=k.VSBuffer.concat(a.buffer);await this.doWriteBuffer(l,s,r,r.byteLength,n,0),n+=r.byteLength}if(a.ended)return;i=a.stream}else i=a;return new Promise((r,c)=>{(0,f.listenStream)(i,{onData:async o=>{i.pause();try{await this.doWriteBuffer(l,s,o,o.byteLength,n,0)}catch(g){return c(g)}n+=o.byteLength,setTimeout(()=>i.resume())},onError:o=>c(o),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(l,s,a){let n=0,i;for(;(i=a.read())!==null;)await this.doWriteBuffer(l,s,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(l,s,a,n,i,r){let c=0;for(;c<n;)c+=await l.write(s,i+c,a.buffer,r+c,n-c)}async doWriteUnbuffered(l,s,a,n){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,s,a,n))}async doWriteUnbufferedQueued(l,s,a,n){let i;n instanceof k.VSBuffer?i=n:(0,f.isReadableStream)(n)?i=await(0,k.streamToBuffer)(n):(0,f.isReadableBufferedStream)(n)?i=await(0,k.bufferedStreamToBuffer)(n):i=(0,k.readableToBuffer)(n),await l.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(l,s,a,n){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,s,a,n))}async doPipeBufferedQueued(l,s,a,n){let i,r;try{i=await l.open(s,{create:!1}),r=await a.open(n,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,g=0,M=0;do M=await l.read(i,o,c.buffer,g,c.byteLength-g),await this.doWriteBuffer(a,r,c,M,o,g),o+=M,g+=M,g===c.byteLength&&(g=0);while(M>0)}catch(c){throw(0,b.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof i=="number"?l.close(i):Promise.resolve(),typeof r=="number"?a.close(r):Promise.resolve()])}}async doPipeUnbuffered(l,s,a,n){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,s,a,n))}async doPipeUnbufferedQueued(l,s,a,n){return a.writeFile(n,await l.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,s,a,n){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,s,a,n))}async doPipeUnbufferedToBufferedQueued(l,s,a,n){const i=await a.open(n,{create:!0,unlock:!1});try{const r=await l.readFile(s);await this.doWriteBuffer(a,i,k.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await a.close(i)}}async doPipeBufferedToUnbuffered(l,s,a,n){const i=await(0,k.streamToBuffer)(this.readFileBuffered(l,s,R.CancellationToken.None));await this.doWriteUnbuffered(a,n,void 0,i)}throwIfFileSystemIsReadonly(l,s){if(l.capabilities&2048)throw new b.FileOperationError((0,P.localize)(22,null,this.resourceForError(s)),6);return l}throwIfFileIsReadonly(l,s){if((s.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,P.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};m=we([te(0,S.ILogService)],m),e.FileService=m}),define(ee[86],ie([0,1,40,279,8,29,17,3,31,2,9,4,18,58,21,160,15,107,201,44,198,197]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(y)}catch(a){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(a)}`)}})();class s extends S.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new R.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:r}=await f.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await f.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,E.joinPath)(n,c.name))).type:o=this.toType(c),r.push([c.name,o])}catch(o){this.logService.trace(o)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let r;return i?.dangling?r=b.FileType.Unknown:n.isFile()?r=b.FileType.File:n.isDirectory()?r=b.FileType.Directory:r=b.FileType.Unknown,i&&(r|=b.FileType.SymbolicLink),r}async createResourceLock(n){const i=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const c=new k.Barrier;return this.resourceLocks.set(n,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(n,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),r=await this.createResourceLock(n));const c=this.toFilePath(n);return await f.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{r?.dispose()}}traceLock(n){s.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,i,r){const c=(0,d.newWriteableStream)(o=>D.VSBuffer.concat(o.map(g=>D.VSBuffer.wrap(g))).buffer);return(0,p.readFileIntoStream)(this,n,c,o=>o.buffer,{...i,bufferSize:256*1024},r),c}async writeFile(n,i,r){let c;try{const o=this.toFilePath(n);if(!r.create||!r.overwrite){if(await f.Promises.exists(o)){if(!r.overwrite)throw(0,b.createFileSystemProviderError)((0,P.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,b.createFileSystemProviderError)((0,P.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(n,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){s.canFlush=n}async open(n,i){const r=this.toFilePath(n);let c;(0,b.isFileOpenForWriteOptions)(i)&&(c=await this.createResourceLock(n));let o;try{if((0,b.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:M}=await f.SymlinkSupport.stat(r);M.mode&128||await f.Promises.chmod(r,M.mode|128)}catch(M){this.logService.trace(M)}let g;if((0,b.isFileOpenForWriteOptions)(i)){if(C.isWindows)try{await f.Promises.truncate(r,0),g="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}g||(g="w")}else g="r";o=await f.Promises.open(r,g)}catch(g){throw c?.dispose(),(0,b.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(o,0),(0,b.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(o,n),c){const g=this.mapHandleToLock.get(o);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.mapHandleToLock.set(o,c),g&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),g.dispose())}return o}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&s.canFlush)try{await f.Promises.fdatasync(n)}catch(r){s.configureFlushOnWrite(!1),this.logService.error(r)}return await f.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,r,c,o){const g=this.normalizePos(n,i);let M=null;try{M=(await f.Promises.read(n,r,c,o,g)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(n,g,M)}return M}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,r){const c=this.mapHandleToPos.get(n);typeof c=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(n,c+r):this.mapHandleToPos.delete(n)))}async write(n,i,r,c,o){return(0,k.retry)(()=>this.doWrite(n,i,r,c,o),100,3)}async doWrite(n,i,r,c,o){const g=this.normalizePos(n,i);let M=null;try{M=(await f.Promises.write(n,r,c,o,g)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),A)}finally{this.updatePos(n,g,M)}return M}async mkdir(n){try{await f.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const r=this.toFilePath(n);i.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(n,i,r){const c=this.toFilePath(n),o=this.toFilePath(i);if(c!==o)try{await this.validateTargetDeleted(n,i,"move",r.overwrite),await f.Promises.move(c,o)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,P.localize)(2,null,(0,v.basename)(c),(0,v.basename)((0,v.dirname)(o)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(n,i,r){const c=this.toFilePath(n),o=this.toFilePath(i);if(c!==o)try{await this.validateTargetDeleted(n,i,"copy",r.overwrite),await f.Promises.copy(c,o,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,P.localize)(3,null,(0,v.basename)(c),(0,v.basename)((0,v.dirname)(o)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(n,i,r,c){const o=this.toFilePath(n),g=this.toFilePath(i);let M=!1;if(!!(this.capabilities&1024)||(M=(0,u.isEqual)(o,g,!0)),M&&r==="copy")throw(0,b.createFileSystemProviderError)((0,P.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!M&&await f.Promises.exists(g)){if(!c)throw(0,b.createFileSystemProviderError)((0,P.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,r){const c=this.toFilePath(n),o=this.toFilePath(i),g=!!(this.capabilities&1024);if((0,u.isEqual)(c,o,!g))return;const M=new w.DisposableStore;try{const[A,_]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);M.add(A),M.add(_),r&&await f.Promises.mkdir((0,v.dirname)(o),{recursive:!0}),await f.Promises.copyFile(c,o)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(A)}finally{M.dispose()}}createUniversalWatcher(n,i,r){return new h.UniversalWatcherClient(c=>n(c),c=>i(c),r)}createNonRecursiveWatcher(n,i,r){return new l.NodeJSWatcherClient(c=>n(c),c=>i(c),r)}toFileSystemProviderError(n){if(n instanceof b.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=b.FileSystemProviderErrorCode.NoPermissions;break;default:i=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let r=this.toFileSystemProviderError(i);if(n&&r.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.toFilePath(n));c.mode&128||(r=(0,b.createFileSystemProviderError)(i,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return r}}e.DiskFileSystemProvider=s,s.TRACE_LOG_RESOURCE_LOCKS=!1,s.canFlush=!0}),define(ee[203],ie([0,1,3,86,2,17,58,23]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends k.Disposable{constructor(C,E){super(),this.provider=C,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(C,E,d){const f=this.getUriTransformer(C);switch(E){case"stat":return this.stat(f,d[0]);case"readdir":return this.readdir(f,d[0]);case"open":return this.open(f,d[0],d[1]);case"close":return this.close(d[0]);case"read":return this.read(d[0],d[1],d[2]);case"readFile":return this.readFile(f,d[0],d[1]);case"write":return this.write(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.writeFile(f,d[0],d[1],d[2]);case"rename":return this.rename(f,d[0],d[1],d[2]);case"copy":return this.copy(f,d[0],d[1],d[2]);case"cloneFile":return this.cloneFile(f,d[0],d[1]);case"mkdir":return this.mkdir(f,d[0]);case"delete":return this.delete(f,d[0],d[1]);case"watch":return this.watch(f,d[0],d[1],d[2],d[3]);case"unwatch":return this.unwatch(d[0],d[1])}throw new Error(`IPC Command ${E} not found`)}listen(C,E,d){const f=this.getUriTransformer(C);switch(E){case"fileChange":return this.onFileChange(f,d[0]);case"readFileStream":return this.onReadFileStream(f,d[0],d[1])}throw new Error(`Unknown event ${E}`)}stat(C,E){const d=this.transformIncoming(C,E,!0);return this.provider.stat(d)}readdir(C,E){const d=this.transformIncoming(C,E);return this.provider.readdir(d)}async readFile(C,E,d){const f=this.transformIncoming(C,E,!0),P=await this.provider.readFile(f,d);return R.VSBuffer.wrap(P)}onReadFileStream(C,E,d){const f=this.transformIncoming(C,E,!0),P=new I.CancellationTokenSource,b=new y.Emitter({onLastListenerRemove:()=>{P.cancel()}}),p=this.provider.readFileStream(f,d,P.token);return(0,D.listenStream)(p,{onData:S=>b.fire(R.VSBuffer.wrap(S)),onError:S=>b.fire(S),onEnd:()=>{b.fire("end"),b.dispose(),P.dispose()}}),b.event}writeFile(C,E,d,f){const P=this.transformIncoming(C,E);return this.provider.writeFile(P,d.buffer,f)}open(C,E,d){const f=this.transformIncoming(C,E,!0);return this.provider.open(f,d)}close(C){return this.provider.close(C)}async read(C,E,d){const f=R.VSBuffer.alloc(d),P=0,b=await this.provider.read(C,E,f.buffer,P,d);return[f,b]}write(C,E,d,f,P){return this.provider.write(C,E,d.buffer,f,P)}mkdir(C,E){const d=this.transformIncoming(C,E);return this.provider.mkdir(d)}delete(C,E,d){const f=this.transformIncoming(C,E);return this.provider.delete(f,d)}rename(C,E,d,f){const P=this.transformIncoming(C,E),b=this.transformIncoming(C,d);return this.provider.rename(P,b,f)}copy(C,E,d,f){const P=this.transformIncoming(C,E),b=this.transformIncoming(C,d);return this.provider.copy(P,b,f)}cloneFile(C,E,d){const f=this.transformIncoming(C,E),P=this.transformIncoming(C,d);return this.provider.cloneFile(f,P)}onFileChange(C,E){const d=new y.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(C,d))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return d.event}async watch(C,E,d,f,P){const b=this.sessionToWatcher.get(E);if(b){const p=this.transformIncoming(C,f),S=b.watch(d,p,P);this.watchRequests.set(E+d,S)}}async unwatch(C,E){const d=C+E,f=this.watchRequests.get(d);f&&((0,k.dispose)(f),this.watchRequests.delete(d))}dispose(){super.dispose();for(const[,C]of this.watchRequests)C.dispose();this.watchRequests.clear();for(const[,C]of this.sessionToWatcher)C.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class w extends k.Disposable{constructor(C,E,d,f){super(),this.uriTransformer=C,this.logService=d,this.environmentService=f,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(C){const E=this._register(new y.Emitter);this._register(E.event(d=>{C.fire(d.map(f=>({resource:this.uriTransformer.transformOutgoingURI(f.resource),type:f.type})))})),this._register(this.fileWatcher.onDidChangeFile(d=>E.fire(d))),this._register(this.fileWatcher.onDidWatchError(d=>C.fire(d)))}getRecursiveWatcherOptions(C){}getExtraExcludes(C){}watch(C,E,d){const f=this.getExtraExcludes(this.environmentService);return Array.isArray(f)&&(d.excludes=[...d.excludes,...f]),this.watcherRequests.set(C,this.fileWatcher.watch(E,d)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(C)),this.watcherRequests.delete(C)})}dispose(){super.dispose();for(const[,C]of this.watcherRequests)C.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=w}),define(ee[204],ie([0,1,13,159,4,7,15,9,203,138]),function(z,e,y,t,k,R,D,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class v extends u.AbstractDiskFileSystemProviderChannel{constructor(d,f,P){super(d,f),this.environmentService=P}getUriTransformer(d){return w.DefaultURITransformer}transformIncoming(d,f){return R.URI.revive(f)}async delete(d,f,P){if(!P.useTrash)return super.delete(d,f,P);const b=this.transformIncoming(d,f),p=(0,I.normalize)(b.fsPath);try{await y.shell.trashItem(p)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,I.basename)(p)):(0,t.localize)(1,null,(0,I.basename)(p)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,f){return new C(d,f,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=v;class C extends u.AbstractSessionFileWatcher{watch(d,f,P){if(P.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(d,f,P)}}}),define(ee[205],ie([0,1,6]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case y.LogLevel.Trace:return R.trace;case y.LogLevel.Debug:return R.debug;case y.LogLevel.Info:return R.info;case y.LogLevel.Warning:return R.warn;case y.LogLevel.Error:return R.error;case y.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends y.AbstractLogger{constructor(D=y.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(I=>{this._logger?.setLevel(I)}))}set logger(D){this._logger=D;for(const{level:I,args:u}of this.buffer)t(D,I).apply(D,u);this.buffer=[]}_log(D,...I){this._logger?t(this._logger,D).apply(this._logger,I):this.getLevel()<=D&&this.buffer.push({level:D,args:I})}trace(D,...I){this._log(y.LogLevel.Trace,D,...I)}debug(D,...I){this._log(y.LogLevel.Debug,D,...I)}info(D,...I){this._log(y.LogLevel.Info,D,...I)}warn(D,...I){this._log(y.LogLevel.Warning,D,...I)}error(D,...I){this._log(y.LogLevel.Error,D,...I)}critical(D,...I){this._log(y.LogLevel.Critical,D,...I)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(ee[206],ie([0,1,3,7,6]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(E,d){this.logService=E,this.loggerService=d,this.onDidChangeLogLevel=y.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,d){switch(d){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${d}`)}async call(E,d,f){switch(d){case"setLevel":return f[1]?this.loggerService.setLevel(t.URI.revive(f[1]),f[0]):this.logService.setLevel(f[0])}throw new Error(`Call not found: ${d}`)}}e.LogLevelChannel=R;class D{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E,d){D.setLevel(this.channel,E,d)}static setLevel(E,d,f){return E.call("setLevel",[d,f])}}e.LogLevelChannelClient=D;class I{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,d){throw new Error(`Event not found: ${d}`)}async call(E,d,f){switch(d){case"createLogger":this.createLogger(t.URI.revive(f[0]),f[1]);return;case"log":return this.log(t.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${d}`)}createLogger(E,d){this.loggers.set(E.toString(),this.loggerService.createLogger(E,d))}consoleLog(E,d){let f=console.log;switch(E){case k.LogLevel.Error:f=console.error;break;case k.LogLevel.Warning:f=console.warn;break;case k.LogLevel.Info:f=console.info;break}f.call(console,...d)}log(E,d){const f=this.loggers.get(E.toString());if(!f)throw new Error("Create the logger before logging");for(const[P,b]of d)(0,k.log)(f,P,b)}}e.LoggerChannel=I;class u extends k.AbstractLoggerService{constructor(E,d,f){super(E,d),this.channel=f}createConsoleMainLogger(){return new k.AdapterLogger({log:(E,d)=>{this.channel.call("consoleLog",[E,d])}})}doCreateLogger(E,d,f){return new w(this.channel,E,d,f)}}e.LoggerChannelClient=u;class w extends k.AbstractMessageLogger{constructor(E,d,f,P){super(P?.always),this.channel=E,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[d,P]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,d){const f=[[E,d]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(E){this.channel.call("log",[this.file,E])}}class v extends k.LogService{constructor(E,d){super(d),this.parent=E,this._register(E.onDidChangeLogLevel(f=>d.setLevel(f)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=v}),define(ee[207],ie([0,1,15,6]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(I,u,w,v,C){try{const E=await new Promise((f,P)=>{z(["spdlog"],f,P)});E.setFlushOn(t.LogLevel.Trace);const d=await E.createAsyncRotatingLogger(I,u,w,v);return C?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(E){console.error(E)}return null}function R(I,u,w){switch(u){case t.LogLevel.Trace:I.trace(w);break;case t.LogLevel.Debug:I.debug(w);break;case t.LogLevel.Info:I.info(w);break;case t.LogLevel.Warning:I.warn(w);break;case t.LogLevel.Error:I.error(w);break;case t.LogLevel.Critical:I.critical(w);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(u,w,v,C,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(u,w,v,C),this._register(this.onDidChangeLogLevel(d=>{this._logger?.setLevel(d)}))}async _createSpdLogLogger(u,w,v,C){const E=v?6:1,d=30/E*y.ByteSize.MB,f=await k(u,w,d,E,C);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:P,message:b}of this.buffer)R(this._logger,P,b);this.buffer=[]}}log(u,w){this._logger?R(this._logger,u,w):this.getLevel()<=u&&this.buffer.push({level:u,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(ee[208],ie([0,1,30,6,207]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(I){super(I.getLevel(),I.onDidChangeLogLevel)}doCreateLogger(I,u,w){return new k.SpdLogLogger(w?.name||(0,y.generateUuid)(),I.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,u)}};R=we([te(0,t.ILogService)],R),e.LoggerService=R}),define(ee[209],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function y(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=y;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!y(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(ee[37],ie([0,1,3,57,2,5]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(w){const v=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},v!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(w),t.Iterable.reduce(this.policies.entries(),(C,[E,d])=>({...C,[E]:d}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[v,C])=>({...w,[v]:{definition:C,value:this.policies.get(v)}}),{})}}e.AbstractPolicyService=D;class I{constructor(){this.onDidChange=y.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ee[210],ie([0,1,8,3,57,12,15,6,37]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function w(C,E){const d=[];for(const f of k.Iterable.concat(C.keys(),E.keys()))C.get(f)!==E.get(f)&&d.push(f);return d}let v=class extends u.AbstractPolicyService{constructor(E,d,f){super(),this.file=E,this.fileService=d,this.logService=f,this.throttledDelayer=this._register(new y.ThrottledDelayer(500));const P=t.Event.filter(d.onDidFilesChange,b=>b.affects(E));this._register(d.watch(E)),this._register(P(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(E){await this.refresh()}async read(){const E=new Map;try{const d=await this.fileService.readFile(this.file),f=JSON.parse(d.value.toString());if(!(0,R.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(f))this.policyDefinitions[P]&&E.set(P,f[P])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return E}async refresh(){const E=await this.read(),d=w(this.policies,E);this.policies=E,d.length>0&&this._onDidChange.fire(d)}};v=we([te(1,D.IFileService),te(2,I.ILogService)],v),e.FilePolicyService=v}),define(ee[211],ie([0,1,3,2,37]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(u){this.service=u,this.disposables=new t.DisposableStore}listen(u,w){switch(w){case"onDidChange":return y.Event.map(this.service.onDidChange,v=>v.reduce((C,E)=>({...C,[E]:this.service.getPolicyValue(E)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(u,w,v){switch(w){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(v)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(u,w){super(),this.channel=w;for(const v in u){const{definition:C,value:E}=u[v];this.policyDefinitions[v]=C,E!==void 0&&this.policies.set(v,E)}this.channel.listen("onDidChange")(v=>{for(const C in v){const E=v[C];E===null?this.policies.delete(C):this.policies.set(C,E)}this._onDidChange.fire(Object.keys(v))})}async initializePolicies(u){const w=await this.channel.call("registerPolicyDefinitions",u);for(const v in w)this.policies.set(v,w[v])}}e.PolicyChannelClient=D}),define(ee[54],ie([0,1,14,4,34,18]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const I=t.globals.vscode.context.configuration();if(I)D=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const I=(0,R.dirname)(y.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(I,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const u=z.__$__nodeRequire((0,R.joinPath)(I,"package.json").fsPath);Object.assign(D,{version:u.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(ee[20],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[212],ie([0,1,76,6,20]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(I,u){this.productService=I,this.logService=u,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,u){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(u);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,v,C]=w;let E=this.trustedExtensionUrlPublicKeys.get(I);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[I],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...E])}const d=Buffer.from(decodeURIComponent(C),"base64");if(d.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const f=d.slice(0,6),P=d.readUIntBE(0,6),b=Date.now()-P;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const p=d.slice(6),S=y.createVerify("SHA256");S.write(f),S.write(Buffer.from(v)),S.end();for(let m=0;m<E.length;m++){let h=E[m];if(h!==null){if(typeof h=="string")try{h=y.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),E[m]=h}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${m+1} for ${I}:`,l),E[m]=null;continue}if(S.verify(h,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};R=we([te(0,k.IProductService),te(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ee[213],ie([0,1,9,5]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var k;(function(R){function D(u){return Boolean(u.samples&&u.timeDeltas)}R.isValidProfile=D;function I(u,w="noAbsolutePaths"){for(const v of u.nodes)v.callFrame&&v.callFrame.url&&((0,y.isAbsolute)(v.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(v.callFrame.url))&&(v.callFrame.url=(0,y.join)(w,(0,y.basename)(v.callFrame.url)));return u}R.rewriteAbsolutePaths=I})(k=e.Utils||(e.Utils={}))}),define(ee[214],ie([0,1,9]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.bottomUp=e.buildModel=void 0;const t=(v,C)=>{const E=C[v];if(E.aggregateTime)return E.aggregateTime;let d=E.selfTime;for(const f of E.children)d+=t(f,C);return E.aggregateTime=d},k=v=>{let C=0;const E=new Map,d=f=>{const P=[f.functionName,f.url,f.scriptId,f.lineNumber,f.columnNumber].join(":"),b=E.get(P);if(b)return b.id;const p=C++;return E.set(P,{id:p,callFrame:f,location:{lineNumber:f.lineNumber+1,columnNumber:f.columnNumber+1}}),p};for(const f of v.nodes)f.locationId=d(f.callFrame),f.positionTicks=f.positionTicks?.map(P=>({...P,startLocationId:d({...f.callFrame,lineNumber:P.line-1,columnNumber:0}),endLocationId:d({...f.callFrame,lineNumber:P.line,columnNumber:0})}));return[...E.values()].sort((f,P)=>f.id-P.id).map(f=>({locations:[f.location],callFrame:f.callFrame}))},R=v=>{if(!v.timeDeltas||!v.samples)return{nodes:[],locations:[],samples:v.samples||[],timeDeltas:v.timeDeltas||[],duration:v.endTime-v.startTime};const{samples:C,timeDeltas:E}=v,f=k(v).map((h,l)=>{const s=h.locations[0];return{id:l,selfTime:0,aggregateTime:0,ticks:0,callFrame:h.callFrame,src:s}}),P=new Map,b=h=>{let l=P.get(h);return l===void 0&&(l=P.size,P.set(h,l)),l},p=new Array(v.nodes.length);for(let h=0;h<v.nodes.length;h++){const l=v.nodes[h],s=b(l.id);p[s]={id:s,selfTime:0,aggregateTime:0,locationId:l.locationId,children:l.children?.map(b)||[]};for(const a of l.positionTicks||[])a.startLocationId&&(f[a.startLocationId].ticks+=a.ticks)}for(const h of p)for(const l of h.children)p[l].parent=h.id;const S=v.endTime-v.startTime;let m=S-E[0];for(let h=0;h<E.length-1;h++){const l=E[h+1];p[b(C[h])].selfTime+=l,m-=l}p.length&&(p[b(C[E.length-1])].selfTime+=m,E.push(m));for(let h=0;h<p.length;h++){const l=p[h],s=f[l.locationId];s.aggregateTime+=t(h,p),s.selfTime+=l.selfTime}return{nodes:p,locations:f,samples:C.map(b),timeDeltas:E,duration:S}};e.buildModel=R;class D{static root(){return new D({id:-1,selfTime:0,aggregateTime:0,ticks:0,callFrame:{functionName:"(root)",lineNumber:-1,columnNumber:-1,scriptId:"0",url:""}})}get id(){return this.location.id}get callFrame(){return this.location.callFrame}get src(){return this.location.src}constructor(C,E){this.location=C,this.parent=E,this.children={},this.aggregateTime=0,this.selfTime=0,this.ticks=0,this.childrenSize=0}addNode(C){this.selfTime+=C.selfTime,this.aggregateTime+=C.aggregateTime}}const I=(v,C,E,d=C)=>{let f=v.children[C.locationId];f||(f=new D(E.locations[C.locationId],v),v.childrenSize++,v.children[C.locationId]=f),f.addNode(d),C.parent&&I(f,E.nodes[C.parent],E,d)};function u(v){return v.functionName.startsWith("(")&&v.functionName.endsWith(")")}function w(v,C,E=!1){const d=(0,e.buildModel)(v),f=D.root();for(const S of d.nodes)I(f,S,d),f.addNode(S);const P=Object.values(f.children).sort((S,m)=>m.selfTime-S.selfTime).slice(0,C),b=[];function p(S){let m=S.functionName||"(anonymous)";return S.url&&(m+="#",m+=E?S.url:(0,y.basename)(S.url),S.lineNumber>=0&&(m+=":",m+=S.lineNumber+1)),m}for(const S of P){const m={selfTime:S.selfTime/1e3,totalTime:S.aggregateTime/1e3,location:p(S.callFrame),caller:[],percentage:Math.round(S.selfTime/(d.duration/100)),isSpecial:u(S.callFrame)},h=[S];for(;h.length;){const l=h.pop();let s;for(const a of Object.values(l.children))(!s||s.selfTime<a.selfTime)&&(s=a);if(s){const a=Math.round(s.selfTime/(l.selfTime/100));m.caller.push({percentage:a,location:p(s.callFrame)}),h.push(s)}}b.push(m)}return b}e.bottomUp=w}),define(ee[61],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,y.createDecorator)("protocolMainService")}),define(ee[47],ie([0,1,120,12]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,I){y.ok(t.isString(D)),y.ok(t.isObject(I)),y.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,I)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(ee[215],ie([0,1,3,47]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,w){this.schemasById[k(u)]=w,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(ee[62],ie([0,1,24,3,12,147,19,215,47]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=u.Registry.as(I.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=this.doRegisterConfigurations(s,a);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const a=this.doDeregisterConfigurations(s);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=[];n.push(...this.doDeregisterConfigurations(a)),n.push(...this.doRegisterConfigurations(s,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,y.distinct)(n)})}registerDefaultConfigurations(s){const a=[],n=[];for(const{overrides:i,source:r}of s)for(const c in i)if(a.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.configurationDefaultsOverrides.get(c),g=o?.valuesSources??new Map;if(r)for(const G of Object.keys(i[c]))g.set(G,r);const M={...o?.value||{},...i[c]};this.configurationDefaultsOverrides.set(c,{source:r,value:M,valuesSources:g});const A=(0,D.getLanguageTagSettingPlainKey)(c),_={type:"object",default:M,description:R.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(r)?void 0:r,defaultValueSource:r};n.push(...P(c)),this.configurationProperties[c]=_,this.defaultLanguageConfigurationOverridesNode.properties[c]=_}else{this.configurationDefaultsOverrides.set(c,{value:i[c],source:r});const o=this.configurationProperties[c];o&&(this.updatePropertyDefaultValue(c,o),this.updateSchema(c,o))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const a=[];for(const{overrides:n,source:i}of s)for(const r in n){const c=this.configurationDefaultsOverrides.get(r),o=k.isString(i)?i:i?.id,g=k.isString(c?.source)?c?.source:c?.source?.id;if(o===g)if(a.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const M=this.configurationProperties[r];M&&(this.updatePropertyDefaultValue(r,M),this.updateSchema(r,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const a of s)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,a){const n=[];return s.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,a,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(s){const a=[],n=i=>{if(i.properties)for(const r in i.properties){a.push(r);const c=this.configurationProperties[r];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of s){n(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return a}validateAndRegisterProperties(s,a=!0,n,i,r=3){r=k.isUndefinedOrNull(s.scope)?r:s.scope;const c=[],o=s.properties;if(o)for(const M in o){const A=o[M];if(a&&m(M,A)){delete o[M];continue}if(A.source=n,A.defaultDefaultValue=o[M].default,this.updatePropertyDefaultValue(M,A),e.OVERRIDE_PROPERTY_REGEX.test(M)?A.scope=void 0:(A.scope=k.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=k.isUndefinedOrNull(A.restricted)?!!i?.includes(M):A.restricted),o[M].hasOwnProperty("included")&&!o[M].included){this.excludedConfigurationProperties[M]=o[M],delete o[M];continue}else this.configurationProperties[M]=o[M],o[M].policy?.name&&this.policyConfigurations.set(o[M].policy.name,M);!o[M].deprecationMessage&&o[M].markdownDeprecationMessage&&(o[M].deprecationMessage=o[M].markdownDeprecationMessage),c.push(M)}const g=s.allOf;if(g)for(const M of g)c.push(...this.validateAndRegisterProperties(M,a,n,i,r));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const a=n=>{const i=n.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);n.allOf?.forEach(a)};a(s)}updateSchema(s,a){switch(e.allSettings.properties[s]=a,a.scope){case 1:e.applicationSettings.properties[s]=a;break;case 2:e.machineSettings.properties[s]=a;break;case 6:e.machineOverridableSettings.properties[s]=a;break;case 3:e.windowSettings.properties[s]=a;break;case 4:e.resourceSettings.properties[s]=a;break;case 5:e.resourceSettings.properties[s]=a,this.resourceLanguageSettingsSchema.properties[s]=a;break}}removeFromSchema(s,a){switch(delete e.allSettings.properties[s],a.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const a=`[${s}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,a){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,r=n?.source;k.isUndefined(i)&&(i=a.defaultDefaultValue,r=void 0),k.isUndefined(i)&&(i=p(a.type)),a.default=i,a.defaultValueSource=r}}const d="\\[([^\\]]+)\\]",f=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function P(l){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let a=f.exec(l);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=f.exec(l)}}return(0,y.distinct)(s)}e.overrideIdentifiersFromKey=P;function b(l){return l.reduce((s,a)=>`${s}[${a}]`,"")}e.keyFromOverrideIdentifiers=b;function p(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const S=new E;u.Registry.add(e.Extensions.Configuration,S);function m(l,s){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):S.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):s.policy?.name&&S.getPolicyConfigurations().get(s.policy?.name)!==void 0?R.localize(9,null,l,s.policy?.name,S.getPolicyConfigurations().get(s.policy?.name)):null:R.localize(6,null)}e.validateProperty=m;function h(){const l=[],s=S.getConfigurationProperties();for(const a of Object.keys(s))l.push([a,s[a].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(ee[108],ie([0,1,24,3,43,2,29,50,12,7,19,62,47]),function(z,e,y,t,k,R,D,I,u,w,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class d{constructor(a={},n=[],i=[],r){this._contents=a,this._keys=n,this._overrides=i,this.raw=r,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const a=this.raw.map(n=>{if(n instanceof d)return n;const i=new f("");return i.parseRaw(n),i.configurationModel});this._rawConfiguration=a.reduce((n,i)=>i===n?i:n.merge(i),a[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(a){return a?(0,v.getConfigurationValue)(this.contents,a):this.contents}inspect(a,n){const i=this.rawConfiguration.getValue(a),r=n?this.rawConfiguration.getOverrideValue(a,n):void 0,c=n?this.rawConfiguration.override(n).getValue(a):i;return{value:i,override:r,merged:c}}getOverrideValue(a,n){const i=this.getContentsForOverrideIdentifer(n);return i?a?(0,v.getConfigurationValue)(i,a):i:void 0}getKeysForOverrideIdentifier(a){const n=[];for(const i of this.overrides)i.identifiers.includes(a)&&n.push(...i.keys);return y.distinct(n)}getAllOverrideIdentifiers(){const a=[];for(const n of this.overrides)a.push(...n.identifiers);return y.distinct(a)}override(a){let n=this.overrideConfigurations.get(a);return n||(n=this.createOverrideConfigurationModel(a),this.overrideConfigurations.set(a,n)),n}merge(...a){const n=I.deepClone(this.contents),i=I.deepClone(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of a)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.mergeContents(n,o.contents);for(const g of o.overrides){const[M]=i.filter(A=>y.equals(A.identifiers,g.identifiers));M?(this.mergeContents(M.contents,g.contents),M.keys.push(...g.keys),M.keys=y.distinct(M.keys)):i.push(I.deepClone(g))}for(const g of o.keys)r.indexOf(g)===-1&&r.push(g)}return new d(n,r,i,c.every(o=>o instanceof d)?void 0:c)}freeze(){return this.frozen=!0,this}clone(){return new d(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(a){const n=this.getContentsForOverrideIdentifer(a);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of y.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[r];const o=n[r];o&&(typeof c=="object"&&typeof o=="object"?(c=I.deepClone(c),this.mergeContents(c,o)):c=o),i[r]=c}return new d(i,this.keys,this.overrides)}mergeContents(a,n){for(const i of Object.keys(n)){if(i in a&&u.isObject(a[i])&&u.isObject(n[i])){this.mergeContents(a[i],n[i]);continue}a[i]=I.deepClone(n[i])}}checkAndFreeze(a){return this.frozen&&!Object.isFrozen(a)?I.deepFreeze(a):a}getContentsForOverrideIdentifer(a){let n=null,i=null;const r=c=>{c&&(i?this.mergeContents(i,c):i=I.deepClone(c))};for(const c of this.overrides)y.equals(c.identifiers,[a])?n=c.contents:c.identifiers.includes(a)&&r(c.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(a,n){this.addKey(a),(0,v.addToValueTree)(this.contents,a,n,i=>{throw new Error(i)})}removeValue(a){this.removeKey(a)&&(0,v.removeFromValueTree)(this.contents,a)}addKey(a){let n=this.keys.length;for(let i=0;i<n;i++)a.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,a)}removeKey(a){const n=this.keys.indexOf(a);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=d;class f{constructor(a){this._name=a,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(a,n){if(!u.isUndefinedOrNull(a)){const i=this.doParseContent(a);this.parseRaw(i,n)}}reparse(a){this._raw&&this.parseRaw(this._raw,a)}parseRaw(a,n){this._raw=a;const{contents:i,keys:r,overrides:c,restricted:o,hasExcludedProperties:g}=this.doParseRaw(a,n);this._configurationModel=new d(i,r,c,g?[a]:void 0),this._restrictedConfigurations=o||[]}doParseContent(a){let n={},i=null,r=[];const c=[],o=[];function g(A){Array.isArray(r)?r.push(A):i!==null&&(r[i]=A)}const M={onObjectBegin:()=>{const A={};g(A),c.push(r),r=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const A=[];g(A),c.push(r),r=A,i=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:g,onError:(A,_,G)=>{o.push({error:A,offset:_,length:G})}};if(a)try{k.visit(a,M),n=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(a,n){const i=E.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(a,i,!0,n);a=r.raw;const c=(0,v.toValuesTree)(a,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),o=Object.keys(a),g=this.toOverrides(a,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:c,keys:o,overrides:g,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(a,n,i,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:a,restricted:[],hasExcludedProperties:c};const o={},g=[];for(const M in a)if(C.OVERRIDE_PROPERTY_REGEX.test(M)&&i){const A=this.filter(a[M],n,!1,r);o[M]=A.raw,c=c||A.hasExcludedProperties,g.push(...A.restricted)}else{const A=n[M],_=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&g.push(M),(_===void 0||r.scopes===void 0||r.scopes.includes(_))&&!(r.skipRestricted&&A?.restricted)?o[M]=a[M]:c=!0}return{raw:o,restricted:g,hasExcludedProperties:c}}toOverrides(a,n){const i=[];for(const r of Object.keys(a))if(C.OVERRIDE_PROPERTY_REGEX.test(r)){const c={};for(const o in a[r])c[o]=a[r][o];i.push({identifiers:(0,C.overrideIdentifiersFromKey)(r),keys:Object.keys(c),contents:(0,v.toValuesTree)(c,n)})}return i}}e.ConfigurationModelParser=f;class P extends R.Disposable{constructor(a,n,i,r){super(),this.userSettingsResource=a,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&i.isEqual(c.resource,a)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const a=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(a.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class b{constructor(a,n,i,r,c,o,g,M,A,_,G,ae,Q){this.key=a,this.overrides=n,this.value=i,this.overrideIdentifiers=r,this.defaultConfiguration=c,this.policyConfiguration=o,this.applicationConfiguration=g,this.userConfiguration=M,this.localUserConfiguration=A,this.remoteUserConfiguration=_,this.workspaceConfiguration=G,this.folderConfigurationModel=ae,this.memoryInspectValue=Q}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class p{constructor(a,n,i,r,c=new d,o=new d,g=new D.ResourceMap,M=new d,A=new D.ResourceMap,_=!0){this._defaultConfiguration=a,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=c,this._workspaceConfiguration=o,this._folderConfigurations=g,this._memoryConfiguration=M,this._memoryConfigurationByResource=A,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(a,n,i){return this.getConsolidatedConfigurationModel(a,n,i).getValue(a)}updateValue(a,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new d,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(a):r.setValue(a,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(a,n,i){const r=this.getConsolidatedConfigurationModel(a,n,i),c=y.distinct(r.overrides.map(M=>M.identifiers).flat()).filter(M=>r.getOverrideValue(a,M)!==void 0),o=this.getFolderConfigurationModelForResource(n.resource,i),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new b(a,n,r.getValue(a),c.length?c:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),i?this._workspaceConfiguration.freeze():void 0,o?o.freeze():void 0,g.inspect(a,n.overrideIdentifier))}keys(a){const n=this.getFolderConfigurationModelForResource(void 0,a);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(a){this._defaultConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(a){this._policyConfiguration=a}updateApplicationConfiguration(a){this._applicationConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(a){this._localUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(a){this._remoteUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(a){this._workspaceConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(a,n){this._folderConfigurations.set(a,n),this._foldersConsolidatedConfigurations.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this._foldersConsolidatedConfigurations.delete(a)}compareAndUpdateDefaultConfiguration(a,n){const i=[];if(!n){const{added:r,updated:c,removed:o}=h(this._defaultConfiguration,a);n=[...r,...c,...o]}for(const r of n)for(const c of(0,C.overrideIdentifiersFromKey)(r)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(c),g=a.getKeysForOverrideIdentifier(c),M=[...g.filter(A=>o.indexOf(A)===-1),...o.filter(A=>g.indexOf(A)===-1),...o.filter(A=>!I.equals(this._defaultConfiguration.override(c).getValue(A),a.override(c).getValue(A)))];i.push([c,M])}return this.updateDefaultConfiguration(a),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(a){const{added:n,updated:i,removed:r}=h(this._policyConfiguration,a),c=[...n,...i,...r];return c.length&&this.updatePolicyConfiguration(a),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:n,updated:i,removed:r,overrides:c}=h(this.applicationConfiguration,a),o=[...n,...i,...r];return o.length&&this.updateApplicationConfiguration(a),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(a){const{added:n,updated:i,removed:r,overrides:c}=h(this.localUserConfiguration,a),o=[...n,...i,...r];return o.length&&this.updateLocalUserConfiguration(a),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(a){const{added:n,updated:i,removed:r,overrides:c}=h(this.remoteUserConfiguration,a),o=[...n,...i,...r];return o.length&&this.updateRemoteUserConfiguration(a),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(a){const{added:n,updated:i,removed:r,overrides:c}=h(this.workspaceConfiguration,a),o=[...n,...i,...r];return o.length&&this.updateWorkspaceConfiguration(a),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(a,n){const i=this.folderConfigurations.get(a),{added:r,updated:c,removed:o,overrides:g}=h(i,n),M=[...r,...c,...o];return(M.length||!i)&&this.updateFolderConfiguration(a,n),{keys:M,overrides:g}}compareAndDeleteFolderConfiguration(a){const n=this.folderConfigurations.get(a);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:i,updated:r,removed:c,overrides:o}=h(n,void 0);return{keys:[...i,...r,...c],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(a,n,i){let r=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(a)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:a},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&a){const r=n.getFolder(a);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const c=this._memoryConfigurationByResource.get(a);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(a){let n=this._foldersConsolidatedConfigurations.get(a);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(a);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(a,n)):n=i}return n}getFolderConfigurationModelForResource(a,n){if(n&&a){const i=n.getFolder(a);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((a,n)=>{const{contents:i,overrides:r,keys:c}=this._folderConfigurations.get(n);return a.push([n,{contents:i,overrides:r,keys:c}]),a},[])}}allKeys(){const a=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>a.add(n)),this.userConfiguration.freeze().keys.forEach(n=>a.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>a.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>a.add(i))),[...a.values()]}allOverrideIdentifiers(){const a=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i))),[...a.values()]}getAllKeysForOverrideIdentifier(a){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(a).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(a).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(a).forEach(r=>n.add(r))),[...n.values()]}static parse(a){const n=this.parseConfigurationModel(a.defaults),i=this.parseConfigurationModel(a.policy),r=this.parseConfigurationModel(a.application),c=this.parseConfigurationModel(a.user),o=this.parseConfigurationModel(a.workspace),g=a.folders.reduce((M,A)=>(M.set(w.URI.revive(A[0]),this.parseConfigurationModel(A[1])),M),new D.ResourceMap);return new p(n,i,r,c,new d,o,g,new d,new D.ResourceMap,!1)}static parseConfigurationModel(a){return new d(a.contents,a.keys,a.overrides).freeze()}}e.Configuration=p;function S(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const a=new Set,n=new Map;for(const r of s)r.keys.forEach(c=>a.add(c)),r.overrides.forEach(([c,o])=>{const g=(0,D.getOrSet)(n,c,new Set);o.forEach(M=>g.add(M))});const i=[];return n.forEach((r,c)=>i.push([c,[...r.values()]])),{keys:[...a.values()],overrides:i}}e.mergeChanges=S;class m{constructor(a,n,i,r){this.change=a,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;a.keys.forEach(g=>c.add(g)),a.overrides.forEach(([,g])=>g.forEach(M=>c.add(M))),this.affectedKeys=[...c.values()];const o=new d;this.affectedKeys.forEach(g=>o.setValue(g,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(a,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,a)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(a,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(a,n,this.currentWorkspace);return!I.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(a,n){let i=(0,v.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(a=a[r],!a)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=m;function h(s,a){const{added:n,removed:i,updated:r}=l(a?.rawConfiguration,s?.rawConfiguration),c=[],o=s?.getAllOverrideIdentifiers()||[],g=a?.getAllOverrideIdentifiers()||[];if(a){const M=g.filter(A=>!o.includes(A));for(const A of M)c.push([A,a.getKeysForOverrideIdentifier(A)])}if(s){const M=o.filter(A=>!g.includes(A));for(const A of M)c.push([A,s.getKeysForOverrideIdentifier(A)])}if(a&&s){for(const M of o)if(g.includes(M)){const A=l({contents:s.getOverrideValue(void 0,M)||{},keys:s.getKeysForOverrideIdentifier(M)},{contents:a.getOverrideValue(void 0,M)||{},keys:a.getKeysForOverrideIdentifier(M)});c.push([M,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:i,updated:r,overrides:c}}function l(s,a){const n=s?a?s.keys.filter(c=>a.keys.indexOf(c)===-1):[...s.keys]:[],i=a?s?a.keys.filter(c=>s.keys.indexOf(c)===-1):[...a.keys]:[],r=[];if(s&&a){for(const c of a.keys)if(s.keys.indexOf(c)!==-1){const o=(0,v.getConfigurationValue)(a.contents,c),g=(0,v.getConfigurationValue)(s.contents,c);I.equals(o,g)||r.push(c)}}return{added:n,removed:i,updated:r}}}),define(ee[216],ie([0,1,24,3,2,50,12,19,108,62,6,37,47]),function(z,e,y,t,k,R,D,I,u,w,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class d extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(E.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:m})=>this.onDidUpdateConfiguration(S,m))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,m){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=d;class f extends u.ConfigurationModel{constructor(S={}){const m=E.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(m),l=Object.create(null),s=[];for(const a in m){const n=S[a],i=n!==void 0?n:m[a].default;(0,I.addToValueTree)(l,a,i,r=>console.error(`Conflict in default settings: ${r}`))}for(const a of Object.keys(l))w.OVERRIDE_PROPERTY_REGEX.test(a)&&s.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(l[a]),contents:(0,I.toValuesTree)(l[a],n=>console.error(`Conflict in default settings file: ${n}`))});super(l,h,s)}}e.DefaultConfigurationModel=f;class P{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new u.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=P;let b=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(S,m,h){super(),this.defaultConfiguration=S,this.policyService=m,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new u.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const m={},h=[],l=E.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const s of S){const a=l[s];if(!a){h.push(s);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.logService.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}h.push(s),m[a.policy.name]={type:a.type}}}return(0,D.isEmptyObject)(m)||await this.policyService.registerPolicyDefinitions(m),h}onDidChangePolicies(S){const m=E.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),h=(0,y.coalesce)(S.map(l=>m.get(l)));this.update(h,!0)}update(S,m){const h=E.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),l=[],s=this._configurationModel.isEmpty();for(const a of S){const n=h[a]?.policy?.name;if(n){const i=this.policyService.getPolicyValue(n);(s?i!==void 0:!(0,R.equals)(this._configurationModel.getValue(a),i))&&l.push([a,i])}else this._configurationModel.getValue(a)!==void 0&&l.push([a,void 0])}if(l.length){const a=this._configurationModel;this._configurationModel=new u.ConfigurationModel;for(const n of a.keys)this._configurationModel.setValue(n,a.getValue(n));for(const[n,i]of l)i===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,i);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};b=we([te(1,C.IPolicyService),te(2,v.ILogService)],b),e.PolicyConfiguration=b}),define(ee[217],ie([0,1,8,3,2,18,19,108,216,37]),function(z,e,y,t,k,R,D,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class v extends k.Disposable{constructor(E,d,f,P){super(),this.settingsResource=E,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=f instanceof w.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,f,P)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,d)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:b,properties:p})=>this.onDidDefaultConfigurationChange(b,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(b=>this.onDidPolicyConfigurationChange(b))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[E,d,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(E,d,new I.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(E,d){const f=typeof E=="string"?E:void 0,P=(0,D.isConfigurationOverrides)(E)?E:(0,D.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(f,P,void 0)}updateValue(E,d,f,P){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const d=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(f,d,2)}onDidDefaultConfigurationChange(E,d){const f=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(E,d);this.trigger(P,f,7)}onDidPolicyConfigurationChange(E){const d=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(E);this.trigger(f,d,7)}trigger(E,d,f){const P=new I.ConfigurationChangeEvent(E,{data:d},this.configuration);P.source=f,P.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(P)}getTargetConfiguration(E){switch(E){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=v}),define(ee[218],ie([0,1,16,5]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends y.ErrorNoTelemetry{static isTemporarilyNotAvailable(I){return I instanceof R&&I._code===k.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof R&&I._code===k.NoResolverFound}static isHandled(I){return I instanceof R&&I.isHandled}constructor(I,u=k.Unknown,w){super(I),this._message=I,this._code=u,this._detail=w,this.isHandled=u===k.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ee[63],ie([0,1,14]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(w){return w.scheme===y.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=t;function k(w){if(!w)return;const v=w.indexOf("+");return v<0?w:w.substr(0,v)}e.getRemoteName=k;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(w){const{host:v,port:C}=u(w);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:v,port:C}}e.parseAuthorityWithPort=D;function I(w,v){let{host:C,port:E}=u(w);return typeof E>"u"&&(E=v),{host:C,port:E}}e.parseAuthorityWithOptionalPort=I;function u(w){const v=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const C=w.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const E=w.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:w,port:void 0}}}),define(ee[109],ie([0,1,26,5,63]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=R;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var u;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(u=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,b){if(typeof P>"u"||P===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof P=="string"||typeof b=="string"){const p=typeof P=="string"?P:P.value,S=typeof b=="string"?b:b.value;return y.equalsIgnoreCase(p,S)}return P._lower===b._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=w;function v(f){return C(f)}e.isApplicationScopedExtension=v;function C(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function E(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function d(f,P){if(P){const b=`onResolveRemoteAuthority:${(0,k.getRemoteName)(P)}`;return f.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[110],ie([0,1,26,190,109,4,7,16,34]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(a,n){return a.uuid&&n.uuid?a.uuid===n.uuid:a.id===n.id?!0:(0,y.compareIgnoreCase)(a.id,n.id)===0}e.areSameExtensions=w;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new C(n.identifier,i,r)}static parse(n){const i=v.exec(n);return i&&i[1]&&i[2]?new C({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof C?w(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=C;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(a){const n=E.exec(a);return n&&n[1]?[P(n[1]),n[2]]:[P(a),void 0]}e.getIdAndVersion=d;function f(a,n){return`${a}.${n}`}e.getExtensionId=f;function P(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function b(a,n){return P(f(a,n))}e.getGalleryExtensionId=b;function p(a,n){const i=[],r=c=>{for(const o of i)if(o.some(g=>w(n(g),n(c))))return o;return null};for(const c of a){const o=r(c);o?o.push(c):i.push([c])}return i}e.groupByExtension=p;function S(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function m(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(a,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&i.every(o=>!w(o.identifier,{id:c}))){const o=a.filter(g=>w(g.identifier,{id:c}));o.length===1&&(i.push(o[0]),r.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=h;async function l(a,n){if(!R.isLinux)return!1;let i;try{i=(await a.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await a.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function s(a,n){const i=await l(a,n),r=(0,t.getTargetPlatform)(i?"alpine":R.platform,u.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(ee[72],ie([0,1,8,17,2,29,7,110,15,5,6]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let C=class extends k.Disposable{constructor(d,f){super(),this.fileService=d,this.logService=f,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(d){return this.withProfileExtensions(d)}addExtensionsToProfile(d,f){return this.withProfileExtensions(f,P=>(P=P.filter(b=>d.some(([p])=>!(0,I.areSameExtensions)(b.identifier,p.identifier))),P.push(...d.map(([b,p])=>({identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:p}))),P))}removeExtensionFromProfile(d,f){return this.withProfileExtensions(f,P=>P.filter(b=>!(0,I.areSameExtensions)(b.identifier,d)))}async withProfileExtensions(d,f){return this.getResourceAccessQueue(d).queue(async()=>{let P=[];try{const b=await this.fileService.readFile(d),p=JSON.parse(b.value.toString());for(const S of p){if(!S.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",S);continue}if(!S.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",S);continue}if(!S.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",S);continue}P.push({identifier:S.identifier,location:D.URI.revive(S.location),version:S.version,metadata:S.metadata})}}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}if(f){P=f(P);const b=P.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(d,t.VSBuffer.fromString(JSON.stringify(b)))}return P})}getResourceAccessQueue(d){let f=this.resourcesAccessQueueMap.get(d);return f||(f=new y.Queue,this.resourcesAccessQueueMap.set(d,f)),f}};C=we([te(0,u.IFileService),te(1,v.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(ee[219],ie([0,1,8,17,23,16,3,2,30,101,218,63]),function(z,e,y,t,k,R,D,I,u,w,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var d;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function f(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function P(B){const $=new k.CancellationTokenSource;return setTimeout(()=>$.cancel(),B),$.token}function b(B,$){if(B.isCancellationRequested||$.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),$.onCancellationRequested(()=>L.cancel()),L.token}class p{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function S(B,$){const L=new p($);return L.registerDisposable(B.onControlMessage(O=>{const U=JSON.parse(O.toString()),q=F(U);q?L.reject(q):L.resolve(U)})),L.promise}function m(B,$,L,O,U,q,Y,se){const H=new p(se);return $.connect(L,O,U,q,Y,(re,ne)=>{H.didTimeout?(re&&B.error(re),ne?.dispose()):re||!ne?H.reject(re):H.resolve(ne)}),H.promise}function h(B,$){const L=new p($);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function l(B,$,L,O){const U=N(B,$);B.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let q;try{q=await m(B.logService,B.socketFactory,B.host,B.port,(0,C.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${f($)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let Y,se;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(q,null),Y=B.reconnectionProtocol,se=!1):(Y=new w.PersistentProtocol(q,null),se=!0),B.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const H=await h(B.signService.createNewMessage((0,u.generateUuid)()),O),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:H.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(re)));try{const ne=await S(Y,b(O,P(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Te=new Error("Unexpected handshake message");throw Te.code="VSCODE_CONNECTION_ERROR",Te}if(B.logService.trace(`${U} 4/6. received SignRequest control message.`),!await h(B.signService.validate(H,ne.signedData),O)){const Te=new Error("Refused to connect to unsupported server");throw Te.code="VSCODE_CONNECTION_ERROR",Te}const ge=await h(B.signService.sign(ne.data),O),Re={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:$};return L&&(Re.args=L),B.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(Re))),{protocol:Y,ownsProtocol:se}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${U} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${U} received error control message when negotiating connection. Error:`),B.logService.error(ne)),se&&j(Y),ne}}async function s(B,$,L,O){const U=Date.now(),q=N(B,$),{protocol:Y,ownsProtocol:se}=await l(B,$,L,O),H=new p(O);return H.registerDisposable(Y.onControlMessage(re=>{const ne=JSON.parse(re.toString()),ce=F(ne);ce?(B.logService.error(`${q} received error control message when negotiating connection. Error:`),B.logService.error(ce),se&&j(Y),H.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${J(U)}!`),H.resolve({protocol:Y,firstMessage:ne}))})),H.promise}async function a(B,$){const{protocol:L}=await s(B,1,void 0,$);return{protocol:L}}async function n(B,$,L){const{protocol:O,firstMessage:U}=await s(B,2,$,L),q=U&&U.debugPort;return{protocol:O,debugPort:q}}async function i(B,$,L){const O=Date.now(),U=N(B,3),{protocol:q}=await l(B,3,$,L);return B.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${J(O)}!`),q}async function r(B,$,L){const{host:O,port:U,connectionToken:q}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:U,connectionToken:q,reconnectionToken:$,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,$,L){return g(B,async O=>{const{protocol:U}=await a(O,k.CancellationToken.None);return new fe(B,$,L,O.reconnectionToken,U)})}e.connectRemoteAgentManagement=c;async function o(B,$){return g(B,async L=>{const{protocol:O,debugPort:U}=await n(L,$,k.CancellationToken.None);return new V(B,$,L.reconnectionToken,O,U)})}e.connectRemoteAgentExtensionHost=o;async function g(B,$){for(let O=1;;O++)try{const U=(0,u.generateUuid)(),q=await r(B,U,null);return await $(q)}catch(U){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(U);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(U),oe.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(U)),U}}async function M(B,$,L){const O=await r(B,(0,u.generateUuid)(),null);return await i(O,{host:$,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function A(B){return(0,y.createCancelablePromise)($=>new Promise((L,O)=>{const U=setTimeout(L,B*1e3);$.onCancellationRequested(()=>{clearTimeout(U),L()})}))}var _;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(_=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class G{constructor($,L){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=G;class ae{constructor($,L,O,U){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=U,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ae;class Q{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=Q;class X{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=X;class x{constructor($,L,O,U){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=U,this.type=3}}e.ReconnectionPermanentFailureEvent=x;class oe extends I.Disposable{static triggerPermanentFailure($,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(U=>U._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||oe._permanentFailure}constructor($,L,O,U,q){super(),this._connectionType=$,this._options=L,this.reconnectionToken=O,this.protocol=U,this._reconnectionFailureIsFatal=q,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new X(this.reconnectionToken,0,0)),this._register(U.onSocketClose(Y=>{const se=W(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${se} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(U.onSocketTimeout(Y=>{const se=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),oe._instances.push(this),this._register((0,I.toDisposable)(()=>{const Y=oe._instances.indexOf(this);Y>=0&&oe._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const $=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const U=O<L.length?L[O]:L[L.length-1];try{if(U>0){const Y=A(U);this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,Y)),this._options.logService.info(`${$} waiting for ${U} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${$} resolving connection...`);const q=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,P(E)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,R.isCancellationError)(q)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof v.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,v.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure($,L,O){this._reconnectionFailureIsFatal?oe.triggerPermanentFailure($,L,O):this._gotoPermanentFailure($,L,O)}_gotoPermanentFailure($,L,O){this._onDidStateChange.fire(new x(this.reconnectionToken,$,L,O)),j(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=oe,oe._permanentFailure=!1,oe._permanentFailureMillisSinceLastIncomingData=0,oe._permanentFailureAttempt=0,oe._permanentFailureHandled=!1,oe._instances=[];class fe extends oe{constructor($,L,O,U,q){super(1,$,U,q,!0),this.client=this._register(new w.Client(q,{remoteAuthority:L,clientId:O},$.ipcLogger))}async _reconnect($,L){await a($,L)}}e.ManagementPersistentConnection=fe;class V extends oe{constructor($,L,O,U,q){super(2,$,O,U,!1),this._startArguments=L,this.debugPort=q}async _reconnect($,L){await n($,this._startArguments,L)}}e.ExtensionHostPersistentConnection=V;function j(B){try{B.acceptDisconnect();const $=B.getSocket();B.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function F(B){if(B&&B.type==="error"){const $=new Error(`Connection error: ${B.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function T(B,$){for(;B.length<$;)B+=" ";return B}function W(B,$,L){return`[remote-connection][${T(f(B),13)}][${$.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function N(B,$){return`${W($,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function J(B){return`${Date.now()-B} ms`}}),define(ee[220],ie([0,1,77,83]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,I,u,w){const v=E=>w(E,void 0),C=y.createConnection({host:k,port:R},()=>{C.removeListener("error",v);const E=Buffer.alloc(16);for(let b=0;b<16;b++)E[b]=Math.round(Math.random()*256);const d=E.toString("base64"),f=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];C.write(f.join(`\r
`)+`\r
\r
`);const P=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",P),w(void 0,new t.NodeSocket(C,u)))};C.on("data",P)});C.setNoDelay(!0),C.once("error",v)}}}),define(ee[221],ie([0,1,25,45,40,181]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function I(d=!1){return(D===void 0||d)&&(D=u()),D}e.hasWSLFeatureInstalled=I;async function u(){const d=w();if(d===void 0)return!1;if(d>=22e3){const f=C();if(f)return new Promise(P=>{t.execFile(f,["--status"],b=>P(!b))})}else{const f=E();if(f)try{if((await k.promises.stat(f)).isFile())return!0}catch{}}return!1}function w(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());if(d)return parseInt(d[3])}function v(d){const f=process.env.SystemRoot;if(f){const P=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,P?"Sysnative":"System32",d)}}function C(){return v("wsl.exe")}function E(){return v("lxss\\LxssManager.dll")}}),define(ee[55],ie([0,1,17,164,62,5,47]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function I(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=I;function u(P){return P.res.statusCode===204}async function w(P){return u(P)?null:(await(0,y.streamToBuffer)(P.stream)).toString()}e.asText=w;async function v(P){if(!I(P))throw new Error("Server returned "+P.res.statusCode);return w(P)}e.asTextOrError=v;async function C(P){if(!I(P))throw new Error("Server returned "+P.res.statusCode);if(u(P))return null;const p=(await(0,y.streamToBuffer)(P.stream)).toString();try{return JSON.parse(p)}catch(S){throw S.message+=`:
`+p,S}}e.asJson=C;function E(P){f(P)}e.updateProxyConfigurationsScope=E;let d;function f(P){const b=D.Registry.as(k.Extensions.Configuration),p=d;d={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[d],remove:p?[p]:[]})}f(2)}),define(ee[222],ie([0,1,17,23]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(I){this.service=I}listen(I,u){throw new Error("Invalid listen")}call(I,u,w,v=t.CancellationToken.None){switch(u){case"request":return this.service.request(w[0],v).then(async({res:C,stream:E})=>{const d=await(0,y.streamToBuffer)(E);return[{statusCode:C.statusCode,headers:C.headers},d]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(I){this.channel=I}async request(I,u){const[w,v]=await this.channel.call("request",[I],u);return{res:w,stream:(0,y.bufferToStream)(v)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=R}),define(ee[223],ie([0,1,224,12]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,I){return D.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:D.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(D,I,u={}){const w=(0,y.parse)(D),v=u.proxyUrl||k(w,I);if(!v)return null;const C=(0,y.parse)(v);if(!/^https?:$/.test(C.protocol||""))return null;const E={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,t.isBoolean)(u.strictSSL)?u.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((d,f)=>{z(["http-proxy-agent"],d,f)}))(E):new(await new Promise((d,f)=>{z(["https-proxy-agent"],d,f)}))(E)}e.getProxyAgent=R}),define(ee[111],ie([0,1,45,9,165,23,44,16,4,30,141,59,8]),function(z,e,y,t,k,R,D,I,u,w,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const d=1e4;let f;async function P(p,S,m){return S["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(m)&&!S["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(m)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=E.Promises.withAsyncBody(async(h,l)=>{const s=new R.CancellationTokenSource,a=setTimeout(()=>{s.dispose(!0),l(new Error((0,k.localize)(0,null)))},d);try{h(await b(p,s.token))}catch(n){!(0,I.isCancellationError)(n)&&!s.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(n)))):h({})}finally{clearTimeout(a),s.dispose()}})),f)}e.getResolvedShellEnv=P;async function b(p,S){const m=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",m);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",h);const l=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",a);const n=await(0,v.getSystemShell)(u.OS,a);return p.trace("getUnixShellEnvironment#shell",n),new Promise((i,r)=>{if(S.isCancellationRequested)return r((0,I.canceled)());const c=(0,t.basename)(n);let o,g;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${M} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,g=["-Login","-Command"]):(o=`'${process.execPath}' ${M} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?g=["-ic"]:g=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),o);const A=(0,y.spawn)(n,[...g,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});S.onCancellationRequested(()=>(A.kill(),r((0,I.canceled)()))),A.on("error",ae=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ae)),r(ae)});const _=[];A.stdout.on("data",ae=>_.push(ae));const G=[];A.stderr.on("data",ae=>G.push(ae)),A.on("close",(ae,Q)=>{const X=Buffer.concat(_).toString("utf8");p.trace("getUnixShellEnvironment#raw",X);const x=Buffer.concat(G).toString("utf8");if(x.trim()&&p.trace("getUnixShellEnvironment#stderr",x),ae||Q)return r(new Error((0,k.localize)(2,null,ae,Q)));const oe=s.exec(X),fe=oe?oe[1]:"{}";try{const V=JSON.parse(fe);m?V.ELECTRON_RUN_AS_NODE=m:delete V.ELECTRON_RUN_AS_NODE,h?V.ELECTRON_NO_ATTACH_CONSOLE=h:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",V),i(V)}catch(V){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(V)),r(V)}})})}}),define(ee[87],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,y.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[225],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class y{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>z(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const I=String(y._nextId++);return this.validators.set(I,D),{id:I,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=y,y._nextId=1}),define(ee[38],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,y.createDecorator)("stateMainService")}),define(ee[22],ie([0,1,13,41,8,3,2,4,34,12,5,6,38,27]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,v.createDecorator)("lifecycleMainService");var f;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(f=e.ShutdownReason||(e.ShutdownReason={}));var P;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen",p[p.Eventually=4]="Eventually"})(P=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class Ct extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(S,m,h){super(),this.logService=S,this.stateMainService=m,this.environmentMainService=h,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Ct.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};y.app.addListener("before-quit",S);const m=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&y.app.quit()};y.app.addListener("window-all-closed",m),y.app.once("will-quit",h=>{this.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),y.app.removeListener("before-quit",S),y.app.removeListener("window-all-closed",m),y.app.quit()})})}fireOnWillShutdown(S){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const m=[];return this._onWillShutdown.fire({reason:S,join(h){m.push(h)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(m)}catch(h){this.logService.error(h)}try{await this.stateMainService.close()}catch(h){this.logService.error(h)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const m=this.phaseWhen.get(this._phase);m&&(m.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let m=this.phaseWhen.get(S);m||(m=new k.Barrier,this.phaseWhen.set(S,m)),await m.wait()}registerWindow(S){const m=new D.DisposableStore;this.windowCounter++,m.add(S.onWillLoad(l=>this._onWillLoadWindow.fire({window:S,workspace:l.workspace,reason:l.reason})));const h=(0,w.assertIsDefined)(S.win);h.on("close",l=>{const s=S.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),l.preventDefault(),this.unload(S,1).then(a=>{if(a){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(S),S.close()})}),h.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,m.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(S,m){await this.unload(S,3)||S.reload(m)}unload(S,m){const h=this.mapWindowIdToPendingUnload.get(S.id);if(h)return h;const l=this.doUnload(S,m).finally(()=>{this.mapWindowIdToPendingUnload.delete(S.id)});return this.mapWindowIdToPendingUnload.set(S.id,l),l}async doUnload(S,m){if(!S.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${S.id}`);const h=this._quitRequested?2:m,l=await this.onBeforeUnloadWindowInRenderer(S,h);return l?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(l)):(await this.onWillUnloadWindowInRenderer(S,h),!1)}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,m){return new Promise(h=>{const l=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${l}`,a=`vscode:cancel${l}`;t.validatedIpcMain.once(s,()=>{h(!1)}),t.validatedIpcMain.once(a,()=>{h(!0)}),S.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:a,reason:m})})}onWillUnloadWindowInRenderer(S,m){return new Promise(h=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(s,()=>h()),S.send("vscode:onWillUnload",{replyChannel:s,reason:m})})}quit(S){return this.trace(`Lifecycle#quit() - begin (willRestart: ${S})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(S&&this.stateMainService.setItem(Ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(m=>{this.pendingQuitPromiseResolve=m,this.trace("Lifecycle#quit() - calling app.quit()"),y.app.quit()}),this.pendingQuitPromise)}trace(S){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(S):this.logService.trace(S)}async relaunch(S){this.trace("Lifecycle#relaunch()");const m=process.argv.slice(1);if(S?.addArgs&&m.push(...S.addArgs),S?.removeArgs)for(const s of S.removeArgs){const a=m.indexOf(s);a>=0&&m.splice(a,1)}const h=()=>{try{if(I.isWindows){const s=(0,u.cwd)();s!==process.cwd()&&process.chdir(s)}}catch(s){this.logService.error(s)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),y.app.relaunch({args:m})};y.app.once("quit",h),await this.quit(!0)&&y.app.removeListener("quit",h)}async kill(S){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const m of y.BrowserWindow.getAllWindows())if(m&&!m.isDestroyed()){let h;m.webContents&&!m.webContents.isDestroyed()?h=new Promise(l=>m.once("closed",l)):h=Promise.resolve(),m.destroy(),await h}})()]),y.app.exit(S)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=we([te(0,C.ILogService),te(1,E.IStateMainService),te(2,d.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(ee[226],ie([0,1,4,3,2,5,22]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let I=class extends k.Disposable{constructor(v){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,v.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const v=await new Promise((C,E)=>{z(["native-keymap"],C,E)});this._keyboardLayoutData=u(v),y.isCI||v.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(v),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=we([te(0,D.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function u(w){const v=w.getKeyMap(),C=w.getCurrentKeyboardLayout();return{keyboardMapping:v,keyboardLayoutInfo:C}}}),define(ee[227],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,y.createDecorator)("stateService")}),define(ee[228],ie([0,1,8,17,12,36,15,6]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class u{constructor(C,E,d){this.storagePath=C,this.logService=E,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new y.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}}getItem(C,E){const d=this.storage[C];return(0,k.isUndefinedOrNull)(d)?E:d}setItem(C,E){this.setItems([{key:C,data:E}])}setItems(C){let E=!1;for(const{key:d,data:f}of C)this.storage[d]!==f&&((0,k.isUndefinedOrNull)(f)?(0,k.isUndefined)(this.storage[d])||(this.storage[d]=void 0,E=!0):(this.storage[d]=f,E=!0));E&&this.save()}removeItem(C){(0,k.isUndefined)(this.storage[C])||(this.storage[C]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const C=JSON.stringify(this.storage,null,4);if(C!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(C)),this.lastSavedStorageContents=C}catch(E){this.logService.error(E)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=u;let w=class{constructor(C,E,d){this.fileStorage=new u(C.stateResource,E,d)}async init(){await this.fileStorage.init()}getItem(C,E){return this.fileStorage.getItem(C,E)}};w=we([te(0,R.IEnvironmentService),te(1,I.ILogService),te(2,D.IFileService)],w),e.StateService=w}),define(ee[229],ie([0,1,228]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends y.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(ee[112],ie([0,1,4,34,7,30]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(w){if(y.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function I(w,v,C,E,d,f,P,b,p,S){const m=Object.create(null);m["common.machineId"]=P,m.sessionID=(0,R.generateUuid)()+Date.now(),m.commitHash=d,m.version=f,m["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,y.PlatformToString)(y.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=E,m["common.product"]=S||"desktop",b&&(m["common.msftInternal"]=b);let h=0;const l=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),y.isLinuxSnap&&(m["common.snap"]="true");const s=D(C);s&&(m["common.platformDetail"]=s);try{const a=await w.readFile(k.URI.file(p));m["common.source"]=a.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=I;function u(w){const v=t.env.USERDNSDOMAIN;if(!v)return!1;const C=v.toLowerCase();return w.some(E=>C===E)}e.verifyMicrosoftInternalDomain=u}),define(ee[32],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[230],ie([0,1,25,57,8,43,14,9,4,7,81,21,100,84,15,20,32]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function S(a,n){const i=`${a}::${n.join(":")}`,r=p.get(i);if(r)return r;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,g=new Map,M=2e4;function A(G,ae,Q,X){const x=ae.substring(G.length+1);return k.Promises.withAsyncBody(async oe=>{let fe;try{fe=await C.Promises.readdir(ae,{withFileTypes:!0})}catch{oe();return}if(X.count>=M){X.count+=fe.length,X.maxReached=!0,oe();return}let V=fe.length;if(V===0){oe();return}let j=fe;X.count+fe.length>M&&(X.maxReached=!0,V=M-X.count,j=fe.slice(0,V)),X.count+=fe.length;for(const F of j)if(F.isDirectory()){if(Q.includes(F.name)||await A(G,(0,I.join)(ae,F.name),Q,X),--V===0){oe();return}}else{const T=F.name.lastIndexOf(".");if(T>=0){const W=F.name.substring(T+1);W&&o.set(W,(o.get(W)??0)+1)}for(const W of c)W.relativePathPattern?.test(x)!==!1&&W.filePattern.test(F.name)&&g.set(W.tag,(g.get(W.tag)??0)+1);if(--V===0){oe();return}}})}const _=k.Promises.withAsyncBody(async G=>{const ae={count:0,maxReached:!1};await A(a,a,n,ae);const Q=await l(a);G({configFiles:m(g),fileTypes:m(o),fileCount:ae.count,maxFilesReached:ae.maxReached,launchConfigFiles:Q})});return p.set(i,_),_}e.collectWorkspaceStats=S;function m(a){return[...t.Iterable.map(a.entries(),([n,i])=>({name:n,count:i}))].sort((n,i)=>i.count-n.count)}function h(){const a={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},n=y.cpus();return n&&n.length>0&&(a.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),a}e.getMachineInfo=h;async function l(a){try{const n=new Map,i=(0,I.join)(a,".vscode","launch.json"),r=await C.Promises.readFile(i),c=[],o=(0,R.parse)(r.toString(),c);if(c.length)return console.log(`Unable to parse ${i}`),[];if((0,R.getNodeType)(o)==="object"&&o.configurations)for(const g of o.configurations){const M=g.type;M&&(n.has(M)?n.set(M,n.get(M)+1):n.set(M,1))}return m(n)}catch{return[]}}e.collectLaunchConfigs=l;let s=class{constructor(n,i){this.telemetryService=n,this.productService=i}formatMachineInfo(n){const i=[];return i.push(`OS Version:       ${n.os}`),i.push(`CPUs:             ${n.cpus}`),i.push(`Memory (System):  ${n.memory}`),i.push(`VM:               ${n.vmHint}`),i.join(`
`)}formatEnvironment(n){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const r=y.cpus();return r&&r.length>0&&i.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),i.push(`Memory (System):  ${(y.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),u.isWindows||i.push(`Load (avg):       ${y.loadavg().map(c=>Math.round(c)).join(", ")}`),i.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${n.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(n,i){return Promise.all([(0,E.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async r=>{let[c,o]=r,g=this.formatProcessList(n,c);return i.forEach(M=>{if((0,d.isRemoteDiagnosticError)(M))g+=`
${M.errorMessage}`,o+=`
${M.errorMessage}`;else if(g+=`

Remote: ${M.hostName}`,M.processes&&(g+=`
${this.formatProcessList(n,M.processes)}`),M.workspaceMetadata){o+=`
|  Remote: ${M.hostName}`;for(const A of Object.keys(M.workspaceMetadata)){const _=M.workspaceMetadata[A];let G=`${_.fileCount} files`;_.maxFilesReached&&(G=`more than ${G}`),o+=`|    Folder (${A}): ${G}`,o+=this.formatWorkspaceStats(_)}}}),{processInfo:g,workspaceInfo:o}})}async getSystemInfo(n,i){const{memory:r,vmHint:c,os:o,cpus:g}=h(),M={os:o,memory:r,cpus:g,vmHint:c,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:i};return u.isWindows||(M.load=`${y.loadavg().map(A=>Math.round(A)).join(", ")}`),u.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(n,i){const r=[];return(0,E.listProcesses)(n.mainPID).then(async c=>(r.push(""),r.push(this.formatEnvironment(n)),r.push(""),r.push(this.formatProcessList(n,c)),n.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(n))),i.forEach(o=>{if((0,d.isRemoteDiagnosticError)(o))r.push(`
${o.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${o.hostName}`),r.push(this.formatMachineInfo(o.machineInfo)),o.processes&&r.push(this.formatProcessList(n,o.processes)),o.workspaceMetadata)for(const g of Object.keys(o.workspaceMetadata)){const M=o.workspaceMetadata[g];let A=`${M.fileCount} files`;M.maxFilesReached&&(A=`more than ${A}`),r.push(`Folder (${g}): ${A}`),r.push(this.formatWorkspaceStats(M))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(n){const i=[];let c=0;const o=(_,G)=>{const ae=` ${_}(${G})`;c+ae.length>60?(i.push(g),g="|                 ",c=g.length):c+=ae.length,g+=ae};let g="|      File types:";const M=10,A=n.fileTypes.length>M?M:n.fileTypes.length;for(let _=0;_<A;_++){const G=n.fileTypes[_];o(G.name,G.count)}if(i.push(g),n.configFiles.length>=0&&(g="|      Conf files:",c=0,n.configFiles.forEach(_=>{o(_.name,_.count)}),i.push(g)),n.launchConfigFiles.length>0){let _="|      Launch Configs:";n.launchConfigFiles.forEach(G=>{_+=G.count>1?` ${G.name}(${G.count})`:` ${G.name}`}),i.push(_)}return i.join(`
`)}expandGPUFeatures(n){const i=Math.max(...Object.keys(n).map(r=>r.length));return Object.keys(n).map(r=>`${r}:  ${" ".repeat(i-r.length)}  ${n[r]}`).join(`
                  `)}formatWorkspaceMetadata(n){const i=[],r=[];return n.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(i.push(`|  Window (${c.title})`),c.folderURIs.forEach(o=>{const g=w.URI.revive(o);if(g.scheme===D.Schemas.file){const M=g.fsPath;r.push(S(M,["node_modules",".git"]).then(A=>{let _=`${A.fileCount} files`;A.maxFilesReached&&(_=`more than ${_}`),i.push(`|    Folder (${(0,I.basename)(M)}): ${_}`),i.push(this.formatWorkspaceStats(A))}).catch(A=>{i.push(`|      Error: Unable to collect workspace stats for folder ${M} (${A.toString()})`)}))}else i.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(c=>i.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(n,i){const r=new Map;n.windows.forEach(o=>r.set(o.pid,o.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(n.mainPID,r,c,i,0),c.join(`
`)}formatProcessItem(n,i,r,c,o){const g=o===0;let M;g?M=c.pid===n?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(o)} ${c.name}`,c.name==="window"&&(M=`${M} (${i.get(c.pid)})`));const A=process.platform==="win32"?c.mem:y.totalmem()*(c.mem/100);r.push(`${c.load.toFixed(0).padStart(5," ")}	${(A/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(c.children)&&c.children.forEach(_=>this.formatProcessItem(n,i,r,_,o+1))}async getWorkspaceFileExtensions(n){const i=new Set;for(const{uri:r}of n.folders){const c=w.URI.revive(r);if(c.scheme!==D.Schemas.file)continue;const o=c.fsPath;try{(await S(o,["node_modules",".git"])).fileTypes.forEach(M=>i.add(M.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(n){for(const{uri:i}of n.folders){const r=w.URI.revive(i);if(r.scheme!==D.Schemas.file)continue;const c=r.fsPath;try{const o=await S(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),o.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:g.name,count:g.count})}),o.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:g.name,count:g.count})}),o.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};s=we([te(0,b.ITelemetryService),te(1,P.IProductService)],s),e.DiagnosticsService=s}),define(ee[231],ie([0,1,8,2,6,21,25,9,32,213,214]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let C=class{constructor(d,f,P,b){this._window=d,this._sessionId=f,this._logService=P,this._telemetryService=b,this._profileAtOrAfter=0,this._session=new t.DisposableStore,this._isStarted=!1}async stop(){await this._isProfiling,this._logService.warn("[perf] STOPPING to monitor renderer",this._sessionId),this._session.clear();try{const d=this._window.webContents.debugger;await d.sendCommand("Profiler.disable"),d.detach()}catch{this._logService.error("[perf] FAILED to disable profiler",this._sessionId)}}receiveHeartbeat(){this._profileAtOrAfter=Date.now()+1e3}async start(){if(this._isStarted){this._logService.warn("[perf] already STARTED, ignoring request",this._sessionId);return}try{const f=this._window.webContents.debugger;f.attach(),await f.sendCommand("Profiler.enable")}catch{this._logService.error("[perf] FAILED to enable profiler",this._sessionId);return}this._logService.warn("[perf] started to EXPECT frequent heartbeat",this._sessionId),this._session.clear(),this._profileAtOrAfter=Date.now();const d=setInterval(()=>{Date.now()>=this._profileAtOrAfter&&(clearInterval(d),this._captureRendererProfile())},500);this._session.add((0,t.toDisposable)(()=>{this._isStarted=!1,clearInterval(d)}))}async _captureRendererProfile(){this._logService.warn("[perf] MISSED heartbeat, trying to profile renderer",this._sessionId);const d=(async()=>{const f=this._window.webContents.debugger;await f.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,y.timeout)(5e3);const P=await f.sendCommand("Profiler.stop");this._logService.warn("[perf] profiling DONE",this._sessionId),await this._store(P.profile),this._digest(P.profile)})();this._isProfiling=d.catch(f=>{this._logService.error("[perf] profiling the renderer FAILED",this._sessionId),this._logService.error(f)}).finally(()=>{this._isProfiling=void 0})}async _store(d){try{const f=(0,I.join)((0,D.tmpdir)(),`renderer-profile-${Date.now()}.cpuprofile`);await R.Promises.writeFile(f,JSON.stringify(d)),this._logService.info("[perf] stored profile to DISK",this._sessionId,f)}catch(f){this._logService.error("[perf] FAILED to write profile to disk",this._sessionId,f)}}_digest(d){if(!w.Utils.isValidProfile(d)){this._logService.warn("[perf] INVALID profile: no samples or timeDeltas",this._sessionId);return}const f=(0,v.bottomUp)(d,5,!1);for(const P of f){const b={sessionId:this._sessionId,selfTime:P.selfTime,totalTime:P.totalTime,percentage:P.percentage,functionName:P.location,callstack:P.caller.map(p=>`${p.percentage}|${p.location}`).join("<")};this._telemetryService.publicLog2("prof.freeze.sample",b)}}};C=we([te(2,k.ILogService),te(3,u.ITelemetryService)],C),e.WindowProfiler=C}),define(ee[232],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class y{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:I,data:u}){return this.appenders.forEach(w=>w.log(I,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=y;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[73],ie([0,1,50,96,12,19,112,32]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,r){return Promise.resolve(void 0)}publicLog2(i,r){return this.publicLog(i,r)}publicLogError(i,r){return Promise.resolve(void 0)}publicLogError2(i,r){return this.publicLogError(i,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class w{async publicLog(i,r,c){}async publicLogError(i,r,c){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(n,i){return i.onDidChangeConfiguration(r=>{r.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:p(r.sourceConfig)})})}e.configurationTelemetry=v;function C(n,i){return!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=C;function E(n){const i=n.getValue(I.TELEMETRY_SETTING_ID),r=n.getValue("telemetry.enableCrashReporter");if(n.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function d(n){const i={},r={},c={};b(n,c);for(let o in c){o=o.length>150?o.substr(o.length-149):o;const g=c[o];typeof g=="number"?r[o]=g:typeof g=="boolean"?r[o]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${g.length}`),i[o]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(i[o]=g)}return{properties:i,measurements:r}}e.validateTelemetryData=d;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function P(n){if(!n)return"none";for(const i of f)if(n.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=P;function b(n,i,r=0,c){if(!!n)for(const o of Object.getOwnPropertyNames(n)){const g=n[o],M=c?c+o:o;Array.isArray(g)?i[M]=(0,y.safeStringify)(g):g instanceof Date?i[M]=g.toISOString():(0,k.isObject)(g)?r<2?b(g,i,r+1,M+"."):i[M]=(0,y.safeStringify)(g):i[M]=g}}function p(n){if(!n)return[];const i=[];return S(i,"",n),i}function S(n,i,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(c=>S(n,i?`${i}.${c}`:c,r[c])):n.push(i)}function m(n,i){const r=n.msftInternalDomains||[],c=i.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||c}e.isInternalTelemetry=m;function h(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=h;function l(n,i){let r=n;const c=[];for(const A of i)for(;;){const _=A.exec(n);if(!_)break;c.push([_.index,A.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(r="";;){const A=g.exec(n);if(!A)break;!o.test(A[0])&&c.every(([_,G])=>A.index<_||A.index>=G)&&(r+=n.substring(M,A.index)+"<REDACTED: user-file-path>",M=g.lastIndex)}return M<n.length&&(r+=n.substr(M)),r}function s(n){if(!n)return n;const i=n.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of r)if(c.regex.test(i))return`<REDACTED: ${c.label}>`;return n}function a(n,i){return(0,y.cloneAndChange)(n,r=>{if(typeof r=="string"){let c=r;c=l(c,i);for(const o of i)c=c.replace(o,"");return c=s(c),c}})}e.cleanData=a}),define(ee[233],ie([0,1,187,73]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,I,u,w,v,C){const E={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,I)&&(0,t.getTelemetryLevel)(u)===3){const d=await(0,y.getServiceMachineId)(I,w,v),{sessionId:f}=await C.getTelemetryInfo();E["X-Market-User-Id"]=d,E["VSCode-SessionId"]=f}return E}e.resolveMarketplaceHeaders=k}),define(ee[234],ie([0,1,2,50,96,4,26,166,19,62,54,20,47,32,73]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{constructor(S,m,h){this._configurationService=m,this._productService=h,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,m){this._experimentProperties[S]=m}_updateTelemetryLevel(){let S=(0,f.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const h=m.usage?3:m.error?2:0;S=Math.min(S,h)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties,m=S.sessionID,h=S["common.machineId"],l=S["common.firstSessionDate"],s=S["common.msftInternal"];return{sessionId:m,machineId:h,firstSessionDate:l,msftInternal:s}}dispose(){this._disposables.dispose()}_log(S,m,h,l){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(s=>{h=(0,t.mixin)(h,s),h=(0,t.mixin)(h,this._experimentProperties),h=(0,f.cleanData)(h,this._cleanupPatterns),this._appenders.forEach(a=>a.log(S,h))},s=>{console.error(s)})}publicLog(S,m,h){return this._log(S,3,m,h)}publicLog2(S,m,h){return this.publicLog(S,m,h)}publicLogError(S,m){return this._sendErrorTelemetry?this._log(S,2,m,!0):Promise.resolve(void 0)}publicLogError2(S,m){return this.publicLogError(S,m)}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=we([te(1,u.IConfigurationService),te(2,C.IProductService)],P),e.TelemetryService=P;function b(){const p=(0,I.localize)(0,null,v.default.nameLong),S=v.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,I.localize)(3,null),h=(0,I.localize)(4,null),l=(0,I.localize)(5,null),s=(0,I.localize)(6,null),a=(0,I.localize)(7,null),n=`
|       | ${h} | ${l} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,I.localize)(8,null);return`
${p} ${S} ${m}

&nbsp;

${a}
${n}

&nbsp;

${i}
`}E.Registry.as(w.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(w.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,I.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,I.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[235],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var y;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(y=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===y.HIGH_CONTRAST_DARK||R===y.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===y.DARK||R===y.HIGH_CONTRAST_DARK}e.isDark=k}),define(ee[236],ie([0,1,118,3,2,5,47,235]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var u;(function(b){function p(S){return S&&typeof S=="object"&&typeof S.id=="string"}b.isThemeColor=p})(u=e.ThemeColor||(e.ThemeColor={}));function w(b){return{id:b}}e.themeColorFromId=w;var v;(function(b){function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||u.isThemeColor(i.color))}b.isThemeIcon=p;const S=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function m(i){const r=S.exec(i);if(!r)return;const[,c]=r;return{id:c}}b.fromString=m;function h(i){return{id:i}}b.fromId=h;function l(i,r){let c=i.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}b.modify=l;function s(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}b.getModifier=s;function a(i,r){return i.id===r.id&&i.color?.id===r.color?.id}b.isEqual=a;function n(i,r){return{id:i.id,color:r?w(r):void 0}}b.asThemeIcon=n,b.asClassNameArray=y.CSSIcon.asClassNameArray,b.asClassName=y.CSSIcon.asClassName,b.asCSSSelector=y.CSSIcon.asCSSSelector})(v=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function C(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(p);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const d=new E;D.Registry.add(e.Extensions.ThemingContribution,d);function f(b){return d.onColorThemeChange(b)}e.registerThemingParticipant=f;class P extends k.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,S){let m=this.theme.getColor(p);return m&&S&&(m=S(m,this.theme)),m?m.toString():null}}e.Themable=P}),define(ee[64],ie([0,1,13,3,2,4,19,5,38]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const w="#FFFFFF",v="#1E1E1E",C="#000000",E="#FFFFFF",d="theme",f="themeBackground",P="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let b=class extends k.Disposable{constructor(S,m){super(),this.stateMainService=S,this.configurationService=m,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,y.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(y.nativeTheme.shouldUseHighContrastColors)return{dark:y.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors)return{dark:y.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&y.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:y.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return S.dark?C:E;let m=this.stateMainService.getItem(f,null);if(!m)switch(this.stateMainService.getItem(d,"vs-dark").split(" ")[0]){case"vs":m=w;break;case"hc-black":m=C;break;case"hc-light":m=E;break;default:m=v}return R.isMacintosh&&m.toUpperCase()===v&&(m="#171717"),m}saveWindowSplash(S,m){this.stateMainService.setItems([{key:d,data:m.baseTheme},{key:f,data:m.colorInfo.background},{key:P,data:m}]),typeof S=="number"&&this.updateBackgroundColor(S,m)}updateBackgroundColor(S,m){for(const h of y.BrowserWindow.getAllWindows())if(h.id===S){h.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};b=we([te(0,u.IStateMainService),te(1,D.IConfigurationService)],b),e.ThemeMainService=b}),define(ee[113],ie([0,1,3,4,5,6]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(P){P.Http="http",P.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(P){P.ConstantPrivate="constantPrivate",P.Private="private",P.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var u;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore",P[P.OpenBrowserOnce=6]="OpenBrowserOnce"})(u=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=v,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=C;function E(P,b){return b?b!==1&&P<1024:!t.isWindows&&P<1024}e.isPortPrivileged=E;class d{constructor(b,p,S){this.remoteAddress=b,this.localAddress=p,this._dispose=S,this._onDispose=new y.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let f=class{constructor(b){this.logService=b,this._onTunnelOpened=new y.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new y.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new y.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],p=Array.from(this._tunnels.values());for(const S of p){const m=Array.from(S.values());for(const h of m){const l=await h.value;l&&b.push(l)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:p}of b.values())await p.then(S=>S?.dispose());b.clear()}this._tunnels.clear()}setEnvironmentTunnel(b,p,S,m,h){this.addTunnelToMap(b,p,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:p,localAddress:S,privacy:m,protocol:h,dispose:()=>Promise.resolve()}))}openTunnel(b,p,S,m,h=!1,l,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${S} on local port ${m}.`),!b)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.retainOrCreateTunnel(b,p,S,m,h,l,s);return a?a.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==p||n.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const p=this._tunnels.get(b.tunnelRemoteHost);if(p){const S=p.get(b.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,S))}}}}async tryDisposeTunnel(b,p,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${p}.`);const m=S.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(p),m}}async closeTunnel(b,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${p} `);const S=this._tunnels.get(b);if(S&&S.has(p)){const m=S.get(p);m.refcount=0,await this.tryDisposeTunnel(b,p,m)}}addTunnelToMap(b,p,S){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(p,{refcount:1,value:S})}async removeEmptyTunnelFromMap(b,p){const S=this._tunnels.get(b);S&&(await S.get(p)||S.delete(p),S.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,p){const S=[b];v(b)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):C(b)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const m=S.map(h=>this._tunnels.get(h));for(const h of m){const l=h?.get(p);if(l)return l}}canTunnel(b){return!!w(b)}doIsPortPrivileged(b,p,S,m){if(p)return!1;if(S){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(h?.length===4){const l=parseInt(h[1]),s=parseInt(h[2]);if(l>10||l===10&&s>=14)return!1}}return b<1024}createWithProvider(b,p,S,m,h,l,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${S} on local port ${m}.`);const a=S;this._factoryInProgress.add(a);const n=m===void 0?S:m,i={elevationRequired:h?this.isPortPrivileged(n):!1},r={remoteAddress:{host:p,port:S},localAddressPort:m,privacy:l,public:l?l!==I.Private:void 0,protocol:s},c=b.forwardPort(r,i);return c?(this.addTunnelToMap(p,S,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(a)})):this._factoryInProgress.delete(a),c}};f=we([te(0,R.ILogService)],f),e.AbstractTunnelService=f}),define(ee[237],ie([0,1,77,25,95,220,8,2,19,6,20,219,113,87,4]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function P(h,l,s,a,n){let i;for(let r=3;r&&(i?.dispose(),i=await new b(h,l,s,a,n).waitForReady(),!(n&&k.BROWSER_RESTRICTED_PORTS[n]||!k.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));r--);return i}class b extends I.Disposable{constructor(l,s,a,n,i){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=i,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=y.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){let l=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),s=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address(),s||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),s=this._server.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async _onConnection(l){l.pause();const s=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,C.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),n=a.getSocket().socket,i=a.readEntireBuffer();a.dispose(),i.byteLength>0&&l.write(i.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.destroy()}),n.on("end",()=>l.end()),n.on("close",()=>l.end()),n.on("error",()=>{l.destroy()}),l.pipe(n),n.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),n.end()})}}let p=class extends E.AbstractTunnelService{constructor(l,s,a,n,i){super(s),this.socketFactory=l,this.signService=a,this.productService=n,this.configurationService=i}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(l){return this.doIsPortPrivileged(l,f.isWindows,f.isMacintosh,t.release())}retainOrCreateTunnel(l,s,a,n,i,r,c){const o=this.getTunnelFromMap(s,a);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,s,a,n,i,r,c);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${a} on local port ${n}.`);const g={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},M=P(g,this.defaultTunnelHost,s,a,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,a,M),M}}};p=we([te(1,w.ILogService),te(2,d.ISignService),te(3,v.IProductService),te(4,u.IConfigurationService)],p),e.BaseTunnelService=p;let S=class extends p{constructor(l,s,a,n){super(R.nodeSocketFactory,l,s,a,n)}};S=we([te(0,w.ILogService),te(1,d.ISignService),te(2,v.IProductService),te(3,u.IConfigurationService)],S),e.TunnelService=S;let m=class extends I.Disposable{constructor(l,s,a,n){super(),this.logService=l,this.productService=s,this.signService=a,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(l,s,a,n,i,r,c,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${n} on local port ${i}.`),!this._tunnelServices.has(l)){const g=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(g),this._tunnelServices.set(l,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(s,a,n,i,r,c,o)}};m=we([te(0,w.ILogService),te(1,v.IProductService),te(2,d.ISignService),te(3,u.IConfigurationService)],m),e.SharedTunnelsService=m}),define(ee[48],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,y.createDecorator)("updateService")}),define(ee[238],ie([0,1,4,167,62,47]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[239],ie([0,1,3,48]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(I){this.service=I}listen(I,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(I,u,w){switch(u){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(w)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=k;class R{get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}constructor(I){this.channel=I,this._onStateChange=new y.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(I){return this.channel.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=R}),define(ee[88],ie([0,1,8,23,3,19,27,22,6,20,55,48]),function(z,e,y,t,k,R,D,I,u,w,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(f,P,b){return`${b.updateUrl}/api/update/${f}/${P}/${b.commit}`}e.createUpdateURL=E;let d=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,b,p,S,m,h){this.lifecycleMainService=P,this.configurationService=b,this.environmentMainService=p,this.requestService=S,this.logService=m,this.productService=h,this._state=C.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const P=this.getUpdateMode(),b=this.getProductQuality(P);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(C.State.Idle(this.getUpdateType())),P==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}P==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(P){return P==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(P=60*60*1e3){return(0,y.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(P){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(P){}getUpdateType(){return 1}doQuitAndInstall(){}};d=we([te(0,I.ILifecycleMainService),te(1,R.IConfigurationService),te(2,D.IEnvironmentMainService),te(3,v.IRequestService),te(4,u.ILogService),te(5,w.IProductService)],d),e.AbstractUpdateService=d}),define(ee[240],ie([0,1,13,53,3,2,19,27,22,6,20,55,32,48,88]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let P=class extends f.AbstractUpdateService{get onRawError(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"error",(p,S)=>S)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-available",(p,S,m)=>({url:S,version:m,productVersion:m}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(y.autoUpdater,"update-downloaded",(p,S,m,h)=>({releaseNotes:S,version:m,productVersion:m,date:h}))}constructor(p,S,m,h,l,s,a){super(p,S,h,l,s,a),this.telemetryService=m,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const m=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(d.State.Idle(1,m))}buildUpdateFeedUrl(p){let S;this.productService.darwinUniversalAssetId?S=this.productService.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,f.createUpdateURL)(S,p,this.productService);try{y.autoUpdater.setFeedURL({url:m})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return m}doCheckForUpdates(p){this.setState(d.State.CheckingForUpdates(p)),y.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(d.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(d.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),y.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};we([t.memoize],P.prototype,"onRawError",null),we([t.memoize],P.prototype,"onRawUpdateNotAvailable",null),we([t.memoize],P.prototype,"onRawUpdateAvailable",null),we([t.memoize],P.prototype,"onRawUpdateDownloaded",null),P=we([te(0,u.ILifecycleMainService),te(1,D.IConfigurationService),te(2,E.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,C.IRequestService),te(5,w.ILogService),te(6,v.IProductService)],P),e.DarwinUpdateService=P}),define(ee[241],ie([0,1,45,40,8,3,9,27,22,6,32,48]),function(z,e,y,t,k,R,D,I,u,w,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,b,p){if(this.lifecycleMainService=P,this.logService=p,this._state=C.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(C.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}scheduleCheckForUpdates(P=60*60*1e3){return(0,k.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(P){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(P){}};E=we([te(0,u.ILifecycleMainService),te(1,I.IEnvironmentMainService),te(2,w.ILogService)],E);let d=class extends E{constructor(P,b,p,S,m,h){super(p,S,m),this.snap=P,this.snapRevision=b,this.telemetryService=h;const l=(0,t.watch)(D.dirname(this.snap)),s=R.Event.fromNodeEventEmitter(l,"change",(r,c)=>c),a=R.Event.filter(s,r=>r==="current"),i=R.Event.debounce(a,(r,c)=>c,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(C.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(P=>{P?this.setState(C.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2)))},P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2,P.message||P))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,y.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const P=await new Promise((p,S)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(m,h)=>m?S(m):p(h))),b=D.basename(P);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,P=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=we([te(2,u.ILifecycleMainService),te(3,I.IEnvironmentMainService),te(4,w.ILogService),te(5,v.ITelemetryService)],d),e.SnapUpdateService=d}),define(ee[51],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,y.createDecorator)("IUriIdentityService")}),define(ee[242],ie([0,1,51,188,15,18,124,3,2]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(E){this.uri=E,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let v=class{constructor(E){this._fileService=E,this._dispooables=new u.DisposableStore,this._limit=2**16;const d=new Map,f=P=>{let b=d.get(P.scheme);return b===void 0&&(b=E.hasProvider(P)&&!this._fileService.hasCapability(P,1024),d.set(P.scheme,b)),b};this._dispooables.add(I.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(P=>{d.delete(P.scheme)})),this.extUri=new R.ExtUri(f),this._canonicalUris=new D.SkipList((P,b)=>this.extUri.compare(P,b,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,R.normalizePath)(E));const d=this._canonicalUris.get(E);return d?d.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new w(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((f,P)=>f[1].touch<P[1].touch?1:f[1].touch>P[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let f=0;f<d;f++)this._canonicalUris.set(E[f][0],E[f][1].touch())}};v=we([te(0,k.IFileService)],v),e.UriIdentityService=v,(0,t.registerSingleton)(y.IUriIdentityService,v,1)}),define(ee[114],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,y.createDecorator)("urlService")}),define(ee[243],ie([0,1,7]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(I){this.handler=I}listen(I,u){throw new Error(`Event not found: ${u}`)}call(I,u,w){switch(u){case"handleURL":return this.handler.handleURL(y.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=t;class k{constructor(I){this.channel=I}handleURL(I,u){return this.channel.call("handleURL",[I.toJSON(),u])}}e.URLHandlerChannelClient=k;class R{constructor(I){this.next=I}async routeCall(I,u,w,v){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(w){const C=y.URI.revive(w);if(C&&C.query){const E=/\bwindowId=(\d+)/.exec(C.query);if(E){const d=E[1],f=new RegExp(`window:${d}`),P=I.connections.find(b=>f.test(b.ctx));if(P)return P}}}return this.next.routeCall(I,u,w,v)}routeEvent(I,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=R}),define(ee[244],ie([0,1,8,2,7,20]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(w,v){const C=[...this.handlers.values()];return(0,y.first)(C.map(E=>()=>E.handleURL(w,v)),void 0,!1).then(E=>E||!1)}registerHandler(w){return this.handlers.add(w),(0,t.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=D;let I=class extends D{constructor(w){super(),this.productService=w}create(w){let{authority:v,path:C,query:E,fragment:d}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return v&&C&&C.indexOf("/")!==0&&(C=`/${C}`),k.URI.from({scheme:this.productService.urlProtocol,authority:v,path:C,query:E,fragment:d})}};I=we([te(0,R.IProductService)],I),e.NativeURLService=I}),define(ee[245],ie([0,1,13,8,3,2,4,7]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function u(v){try{return I.URI.parse(v)}catch{return null}}class w{constructor(C,E,d,f,P){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=C,D.isWindows){const S=f.isBuilt?[]:[`"${f.appRoot}"`];S.push("--open-url","--"),y.app.setAsDefaultProtocolClient(P.urlProtocol,process.execPath,S)}const b=k.Event.map(k.Event.fromNodeEventEmitter(y.app,"open-url",(S,m)=>({event:S,url:m})),({event:S,url:m})=>(S.preventDefault(),m));this.disposables.add(b(S=>{const m=u(S);!m||this.urlService.open(m,{originalUrl:S})})),d.getWindows().filter(S=>S.isReady).length>0?this.flush():k.Event.once(d.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const C=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||C.push(E);C.length!==0&&(this.uris=C,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(ee[246],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,y.createDecorator)("webviewManagerService")}),define(ee[247],ie([0,1,13,2,14,7]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const u=this.handleWebviewRequest.bind(this);y.protocol.registerFileProtocol(k.Schemas.vscodeWebview,u)}handleWebviewRequest(u,w){try{const v=R.URI.parse(u.url),C=D.validWebviewFilePaths.get(v.path);if(typeof C=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${C}`,d=k.FileAccess.asFileUri(E,z);return w({path:decodeURIComponent(d.fsPath),headers:{...k.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[74],ie([0,1,4]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(v){return!!v.workspaceUri}e.isWorkspaceToOpen=t;function k(v){return!!v.folderUri}e.isFolderToOpen=k;function R(v){return!!v.fileUri}e.isFileToOpen=R;function D(v){const C=I(v),E=v.getValue("window.menuBarVisibility");return E==="default"||C==="native"&&E==="compact"||y.isMacintosh&&y.isNative?"classic":E}e.getMenuBarVisibility=D;function I(v){if(y.isWeb)return"custom";const C=v.getValue("window");if(C){if(y.isMacintosh&&C.nativeTabs===!0||y.isMacintosh&&C.nativeFullScreen===!1)return"native";const f=C.titleBarStyle;if(f==="native"||f==="custom")return f}return y.isLinux?"native":"custom"}e.getTitleBarStyle=I;function u(v){if(!y.isWindows||y.isWeb||I(v)==="native")return!1;const C=v.getValue("window.experimental.windowControlsOverlay.enabled");return typeof C=="boolean"?C:!1}e.useWindowControlsOverlay=u;function w(v=0){return Math.pow(1.2,v)}e.zoomLevelToZoomFactor=w}),define(ee[115],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var y;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(y=e.LoadReason||(e.LoadReason={}));var t;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=k;var R;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(ee[33],ie([0,1,5]),function(z,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,y.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[248],ie([0,1,13,23,3,66,2,30,69,105,6,20,33]),function(z,e,y,t,k,R,D,I,u,w,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(P){P[P.Initial=1]="Initial",P[P.StoredCredentialsUsed=2]="StoredCredentialsUsed",P[P.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let f=class extends D.Disposable{constructor(b,p,S,m,h){super(),this.logService=b,this.windowsMainService=p,this.credentialsService=S,this.encryptionMainService=m,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=d.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=k.Event.fromNodeEventEmitter(y.app,"login",(p,S,m,h,l)=>({event:p,webContents:S,req:m,authInfo:h,callback:l}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:S,callback:m}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===d.LoginDialogShown&&S.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}m(h?.username,h?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const p=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let S,m;try{const a=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(a){const n=JSON.parse(await this.encryptionMainService.decrypt(a));S=n.username,m=n.password}}catch(a){this.logService.error(a)}if(this.state!==d.StoredCredentialsUsed&&typeof S=="string"&&typeof m=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=d.StoredCredentialsUsed,{username:S,password:m};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const l={authInfo:b,username:this.sessionCredentials?.username??S,password:this.sessionCredentials?.password??m,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=d.LoginDialogShown;const s=await new Promise(a=>{const n=async(i,r,c)=>{if(r===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",n),c){const o={username:c.username,password:c.password};try{if(c.remember){const g=await this.encryptionMainService.encrypt(JSON.stringify(o));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,g)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(g){this.logService.error(g)}a({username:o.username,password:o.password})}else a(void 0)};h.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=s,s}};f=we([te(0,v.ILogService),te(1,E.IWindowsMainService),te(2,u.ICredentialsMainService),te(3,w.IEncryptionMainService),te(4,C.IProductService)],f),e.ProxyAuthHandler=f}),define(ee[249],ie([0,1,69,6,36,20,33,200]),function(z,e,y,t,k,R,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let u=class extends I.BaseCredentialsMainService{constructor(v,C,E,d){super(v),this.environmentMainService=C,this.productService=E,this.windowsMainService=d,this.surfaceKeytarLoadError=f=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",f.message??f)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new y.InMemoryCredentialsProvider,this._keytarCache;const v=await new Promise((C,E)=>{z(["keytar"],C,E)});return await v.findCredentials("test-keytar-loads"),this._keytarCache=v,this._keytarCache}};u=we([te(0,t.ILogService),te(1,k.INativeEnvironmentService),te(2,R.IProductService),te(3,D.IWindowsMainService)],u),e.CredentialsNativeMainService=u}),define(ee[250],ie([0,1,16,2,3,6,22,79,45,280,8,14,50,4,34,13,33]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=P.UtilityProcess,S=typeof p<"u";let m=class Ut{constructor(a,n,i){this._logService=a,this._windowsMainService=i,this._shutdown=!1,this._extHosts=new Map,n.onWillShutdown(r=>{this._shutdown=!0,r.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(a){const n=this._extHosts.get(a);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(a){return this._getExtHost(a).onStdout}onDynamicStderr(a){return this._getExtHost(a).onStderr}onDynamicMessage(a){return this._getExtHost(a).onMessage}onDynamicError(a){return this._getExtHost(a).onError}onDynamicExit(a){return this._getExtHost(a).onExit}async canUseUtilityProcess(){return S}async createExtensionHost(a){if(this._shutdown)throw(0,y.canceled)();const n=String(++Ut._lastId);let i;if(a){if(!S)throw new Error("Cannot use UtilityProcess!");i=new l(n,this._logService,this._windowsMainService)}else i=new h(n,this._logService);return this._extHosts.set(n,i),i.onExit(({pid:r,code:c,signal:o})=>{this._logService.info(`Extension host with pid ${r} exited with code: ${c}, signal: ${o}.`),setTimeout(()=>{i.dispose(),this._extHosts.delete(n)})}),{id:n}}async start(a,n){if(this._shutdown)throw(0,y.canceled)();return this._getExtHost(a).start(n)}async enableInspectPort(a){if(this._shutdown)throw(0,y.canceled)();const n=this._extHosts.get(a);return n?n.enableInspectPort():!1}async kill(a){if(this._shutdown)throw(0,y.canceled)();const n=this._extHosts.get(a);!n||n.kill()}async _killAllNow(){for(const[,a]of this._extHosts)a.kill()}async _waitForAllExit(a){const n=[];for(const[,i]of this._extHosts)n.push(i.waitForExit(a));return v.Promises.settled(n).then(()=>{})}};m._lastId=0,m=we([te(0,R.ILogService),te(1,D.ILifecycleMainService),te(2,b.IWindowsMainService)],m),e.ExtensionHostStarter=m;let h=class extends t.Disposable{constructor(a,n){super(),this.id=a,this._logService=n,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(a){d.isCI&&this._logService.info("Calling fork to start extension host...");const n=I.StopWatch.create(!1);this._process=(0,u.fork)(C.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,E.mixin)({cwd:(0,f.cwd)()},a));const i=n.elapsed(),r=this._process.pid;this._logService.info(`Starting extension host with pid ${r} (fork() took ${i} ms).`);const c=new w.StringDecoder("utf-8");this._process.stdout?.on("data",g=>{const M=typeof g=="string"?g:c.write(g);this._onStdout.fire(M)});const o=new w.StringDecoder("utf-8");this._process.stderr?.on("data",g=>{const M=typeof g=="string"?g:o.write(g);this._onStderr.fire(M)}),this._process.on("message",g=>{this._onMessage.fire(g)}),this._process.on("error",g=>{this._onError.fire({error:(0,y.transformErrorForSerialization)(g)})}),this._process.on("exit",(g,M)=>{this._hasExited=!0,this._onExit.fire({pid:r,code:g,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):d.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(a){if(!this._process)return;const n=this._process.pid;this._logService.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,v.timeout)(a)]),this._hasExited||(this._logService.info(`Extension host with pid ${n} did not exit within ${a}ms.`),this._process.kill())}};h=we([te(1,R.ILogService)],h);let l=class extends t.Disposable{constructor(a,n,i){super(),this.id=a,this._logService=n,this._windowsMainService=i,this.onError=k.Event.None,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(a){const n=this._windowsMainService.getWindowById(a.responseWindowId);if(!n){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const i=n.win;if(!i||i.isDestroyed()||i.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=`extensionHost${this.id}`,c=C.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],g=a.execArgv||[],M={...a.env},A=!0;for(const x of Object.keys(M))M[x]=String(M[x]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(c,o,{serviceName:r,env:M,execArgv:g,allowLoadingUnsignedLibraries:A});const _=new w.StringDecoder("utf-8");this._process.stdout?.on("data",x=>{const oe=typeof x=="string"?x:_.write(x);this._onStdout.fire(oe)});const G=new w.StringDecoder("utf-8");this._process.stderr?.on("data",x=>{const oe=typeof x=="string"?x:G.write(x);this._onStderr.fire(oe)}),this._process.on("message",x=>{this._onMessage.fire(x)}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const ae=k.Event.fromNodeEventEmitter(this._process,"exit",(x,oe)=>oe);this._register(ae(x=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${x}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:x,signal:""})}));const{port1:Q,port2:X}=new P.MessageChannelMain;this._process.postMessage("null",[X]),i.webContents.postMessage(a.responseChannel,a.responseNonce,[Q])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(a){if(!this._process)return;const n=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,v.timeout)(a)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${a}ms, will kill it now.`),this._process.kill())}};l=we([te(1,R.ILogService),te(2,b.IWindowsMainService)],l)}),define(ee[251],ie([0,1,13,3,2,247,33]),function(z,e,y,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends k.Disposable{constructor(w){super(),this.windowsMainService=w,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,v){let C;if(typeof w.windowId=="number"){const{windowId:E}=w,d=this.windowsMainService.getWindowById(E);if(!d?.win)throw new Error(`Invalid windowId: ${E}`);C=d.win.webContents}else{const{webContentsId:E}=w;if(C=y.webContents.fromId(E),!C)throw new Error(`Invalid webContentsId: ${E}`)}C.isDestroyed()||C.setIgnoreMenuShortcuts(v)}async findInFrame(w,v,C,E){const f=this.getFrameByName(w,v);if(typeof f.findInFrame=="function"){f.findInFrame(C,{findNext:E.findNext,forward:E.forward});const P=(b,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),f.removeListener("found-in-frame",P))};f.on("found-in-frame",P)}}async stopFindInFrame(w,v,C){const d=this.getFrameByName(w,v);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(C.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,v){const C=this.windowsMainService.getWindowById(w.windowId);if(!C?.win)throw new Error(`Invalid windowId: ${w}`);const E=C.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===v);if(!E)throw new Error(`Unknown frame: ${v}`);return E}};I=we([te(0,D.IWindowsMainService)],I),e.WebviewMainService=I}),define(ee[252],ie([0,1,8,3,2]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:u,getActiveWindowId:w}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(I,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,y.createCancelablePromise)(()=>w()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(ee[28],ie([0,1,171,9,29,18,7,5,14]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function w(a){const n=a;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function v(a,n){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,t.basename)(a)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=a;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=v;function C(a){const n=a;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=C;function E(a){const n=a;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const i=a;if(i?.configPath)return{id:i.id,configPath:D.URI.revive(i.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=E;var d;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function f(a){const n=a;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function P(a){const n=a;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=P;class b{constructor(n,i,r,c,o){this._id=n,this._transient=r,this._configuration=c,this._ignorePathCasing=o,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class p{constructor(n,i){this.raw=i,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function S(a){return new p({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(a,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,n.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function h(a){let n;return D.URI.isUri(a)?n=a:n=a.configuration,n?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=h;function l(a,n){return!m(a,n)&&!h(a)}e.isSavedWorkspace=l;function s(a){return(typeof a=="string"?(0,t.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ee[56],ie([0,1,13,8,66,35,2,80,4,12,21,148,5,6,28]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let P=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,S){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,C.localize)(0,null)},S)}pickFolder(p,S){return this.doPick({...p,pickFolders:!0,title:(0,C.localize)(1,null)},S)}pickFile(p,S){return this.doPick({...p,pickFiles:!0,title:(0,C.localize)(2,null)},S)}pickWorkspace(p,S){const m=(0,C.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,C.localize)(4,null)),l=f.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:m,filters:l,buttonLabel:h},S)}async doPick(p,S){const m={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(m.properties=void 0,p.pickFiles&&p.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&m.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(m,(0,w.withNullAsUndefined)(S||y.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(p){if(p){let S=this.windowDialogQueues.get(p.id);return S||(S=new t.Queue,this.windowDialogQueues.set(p.id,S)),S}else return this.noWindowDialogueQueue}showMessageBox(p,S){return this.getWindowDialogQueue(S).queue(async()=>S?y.dialog.showMessageBox(S,p):y.dialog.showMessageBox(p))}async showSaveDialog(p,S){const m=this.acquireFileDialogLock(p,S);if(!m)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(S).queue(async()=>{let h;return S?h=await y.dialog.showSaveDialog(S,p):h=await y.dialog.showSaveDialog(p),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,D.dispose)(m)}}normalizePath(p){return p&&u.isMacintosh&&(p=(0,I.normalizeNFC)(p)),p}normalizePaths(p){return p.map(S=>this.normalizePath(S))}async showOpenDialog(p,S){p.defaultPath&&(await v.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const m=this.acquireFileDialogLock(p,S);if(!m)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(S).queue(async()=>{let h;return S?h=await y.dialog.showOpenDialog(S,p):h=await y.dialog.showOpenDialog(p),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,D.dispose)(m)}}acquireFileDialogLock(p,S){if(!S)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let m=this.windowFileDialogLocks.get(S.id);m||(m=new Set,this.windowFileDialogLocks.set(S.id,m));const h=(0,k.hash)(p);if(!m.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),m.add(h),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),m?.delete(h),m?.size===0&&this.windowFileDialogLocks.delete(S.id)})}};P=we([te(0,d.ILogService)],P),e.DialogMainService=P}),define(ee[253],ie([0,1,3,2,67,28]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(u,w){super(),this.logService=u,this.storageMainService=w,this.onDidChangeApplicationStorageEmitter=this._register(new y.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(w.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,w){this._register(y.Event.debounce(u.onDidChangeStorage,(v,C)=>(v?v.push(C):v=[C],v),D.STORAGE_CHANGE_DEBOUNCE_TIME)(v=>{v.length&&w.fire(this.serializeStorageChangeEvents(v,u))}))}serializeStorageChangeEvents(u,w){const v=new Map,C=new Set;return u.forEach(E=>{const d=w.get(E.key);typeof d=="string"?v.set(E.key,d):C.add(E.key)}),{changed:Array.from(v.entries()),deleted:Array.from(C.values())}}listen(u,w,v){switch(w){case"onDidChangeStorage":{const C=v.profile?(0,k.revive)(v.profile):void 0;if(!C)return this.onDidChangeApplicationStorageEmitter.event;let E=this.mapProfileToOnDidChangeProfileStorageEmitter.get(C.id);return E||(E=this._register(new y.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(C),E),this.mapProfileToOnDidChangeProfileStorageEmitter.set(C.id,E)),E.event}}throw new Error(`Event not found: ${w}`)}async call(u,w,v){const C=v.profile?(0,k.revive)(v.profile):void 0,E=(0,R.reviveIdentifier)(v.workspace),d=await this.withStorageInitialized(C,E);switch(w){case"getItems":return Array.from(d.items.entries());case"updateItems":{const f=v;if(f.insert)for(const[P,b]of f.insert)d.set(P,b);f.delete?.forEach(P=>d.delete(P));break}case"isUsed":{const f=v.payload;if(typeof f=="string")return this.storageMainService.isUsed(f)}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(u,w){let v;w?v=this.storageMainService.workspaceStorage(w):u?v=this.storageMainService.profileStorage(u):v=this.storageMainService.applicationStorage;try{await v.init()}catch(C){this.logService.error(`StorageIPC#init: Unable to init ${w?"workspace":u?"profile":"application"} storage due to ${C}`)}return v}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[39],ie([0,1,66,3,2,18,12,7,168,36,15,5,6,28,29,51,8,30,26]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&I.URI.isUri(i.location)&&I.URI.isUri(i.globalStorageHome)&&I.URI.isUri(i.settingsResource)&&I.URI.isUri(i.keybindingsResource)&&I.URI.isUri(i.tasksResource)&&I.URI.isUri(i.snippetsHome)&&((0,D.isUndefined)(i.extensionsResource)||I.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function h(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:I.URI.revive(n.location).with({scheme:i}),globalStorageHome:I.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:I.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:I.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:I.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:I.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:I.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=h,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(n,i,r,c){return{id:n,name:i,location:r,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=l;let s=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,r,c,o){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=c,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(g=>l((0,R.basename)(g.location),g.name,g.location,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags})):[];let r;const c=new f.ResourceMap,o=l((0,y.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,u.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?o.extensionsResource:void 0}),i.length){const g=this.getStoredProfileAssociations();if(g.workspaces)for(const[M,A]of Object.entries(g.workspaces)){const _=I.URI.parse(M),G=I.URI.parse(A),ae=i.find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,G));ae&&c.set(_,ae)}if(g.emptyWindow){const M=I.URI.parse(g.emptyWindow);r=i.find(A=>this.uriIdentityService.extUri.isEqual(A.location,M))}}this._profilesObject={profiles:i,workspaces:c,emptyWindow:r}}return this._profilesObject}async createTransientProfile(i){const r="Temp",c=new RegExp(`${(0,S.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const M of this.profiles){const A=c.exec(M.name),_=A?parseInt(A[1]):0;o=_>o?_:o}const g=`${r} ${o+1}`;return this.createProfile((0,y.hash)((0,p.generateUuid)()).toString(16),g,{transient:!0},i)}async createNamedProfile(i,r,c){return this.createProfile((0,y.hash)((0,p.generateUuid)()).toString(16),i,r,c)}async createProfile(i,r,c,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const g=await this.doCreateProfile(i,r,c);return o&&await this.setProfileForWorkspace(o,g),g}async doCreateProfile(i,r,c){let o=this.profileCreationPromises.get(r);return o||(o=(async()=>{try{const g=this.profiles.find(_=>_.name===r||_.id===i);if(g)return g;const M=l(i,r,(0,R.joinPath)(this.profilesHome,i),c);await this.fileService.createFolder(M.location);const A=[];return this._onWillCreateProfile.fire({profile:M,join(_){A.push(_)}}),await b.Promises.settled(A),this.updateProfiles([M],[],[]),M}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,o)),o}async updateProfile(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(o=>o.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=l(c.id,r.name??c.name,c.location,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:r,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.logService.error(o)}r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(o){this.logService.error(o)}}getOrSetProfileForWorkspace(i,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(i);return c||(c=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,c)),c}async setProfileForWorkspace(i,r){this.setProfileForWorkspaceSync(i,r)}setProfileForWorkspaceSync(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(o=>o.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,c)}unsetWorkspace(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return I.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,d.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,d.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,c){const o=[...this.profiles,...i],g=[];this.transientProfilesObject.profiles=[];for(let M of o)M.isDefault||r.some(A=>M.id===A.id)||(M=c.find(A=>M.id===A.id)??M,M.isTransient?this.transientProfilesObject.profiles.push(M):g.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.saveStoredProfiles(g),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,c)}triggerProfilesChanges(i,r,c){this._onDidChangeProfiles.fire({added:i,removed:r,updated:c,all:this.profiles})}updateWorkspaceAssociation(i,r,c){c=r?.isTransient?!0:c,c||this.updateWorkspaceAssociation(i,void 0,!0);const o=this.getWorkspace(i),g=c?this.transientProfilesObject:this.profilesObject;I.URI.isUri(o)?(g.workspaces.delete(o),r&&g.workspaces.set(o,r)):g.emptyWindow=r,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[c,o]of this.profilesObject.workspaces.entries())i[c.toString()]=o.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};s.PROFILES_KEY="userDataProfiles",s.PROFILE_ASSOCIATIONS_KEY="profileAssociations",s=we([te(0,w.IEnvironmentService),te(1,v.IFileService),te(2,P.IUriIdentityService),te(3,E.ILogService)],s),e.UserDataProfilesService=s;class a extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=a}),define(ee[89],ie([0,1,24,8,50,17,16,43,134,2,14,9,4,18,186,97,12,7,153,36,110,109,185,15,5,6,20,3,67,72,39,51,184]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a,n,i,r,c,o,g,M,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(V){function j(F,T){if(F===T)return!0;const W=Object.keys(F),N=new Set;for(const J of Object.keys(T))N.add(J);if(W.length!==N.size)return!1;for(const J of W){if(F[J]!==T[J])return!1;N.delete(J)}return N.size===0}V.equals=j})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let ae=class extends w.Disposable{constructor(j,F,T,W,N,J,B,$,L,O,U){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=F,this.extensionsControlLocation=T,this.cacheLocation=W,this.userDataProfilesService=N,this.extensionsProfileScannerService=J,this.fileService=B,this.logService=$,this.environmentService=L,this.productService=O,this.instantiationService=U,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,(0,d.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,(0,d.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(X,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,F,T){const[W,N]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(F)]),J=T?await this.scanExtensionsUnderDevelopment(j,[...W,...N]):[];return this.dedupExtensions(W,N,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const F=[];F.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),F.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[T,W]=await Promise.all(F);return this.applyScanOptions([...T,...W],0,j,!1)}async scanUserExtensions(j){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput(j.profileLocation??this.userExtensionsLocation,!!j.profileLocation,1,!j.includeUninstalled,j.language);let W=await(j.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return W=await this.applyScanOptions(W,1,j,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment(j,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const T=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===v.Schemas.file).map(async W=>{const N=await this.createExtensionScannerInput(W,!1,1,!0,j.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(N)).map(B=>(B.type=F.find($=>(0,h.areSameExtensions)($.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,N)))}))).flat();return this.applyScanOptions(T,"development",j,!0)}return[]}async scanExistingExtension(j,F,T){const W=await this.createExtensionScannerInput(j,!1,F,!0,T.language),N=await this.extensionsScanner.scanExtension(W);return!N||!T.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(j,F,T){const W=await this.createExtensionScannerInput(j,!1,F,!0,T.language),N=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(N,F,T,!0)}async scanMetadata(j){const F=(0,d.joinPath)(j,"package.json"),T=(await this.fileService.readFile(F)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(j,F){const T=(0,d.joinPath)(j,"package.json"),W=(await this.fileService.readFile(T)).value.toString(),N=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,N.__metadata={...N.__metadata,...F},await this.fileService.writeFile((0,d.joinPath)(j,"package.json"),R.VSBuffer.fromString(JSON.stringify(N,null,"	")))}async applyScanOptions(j,F,T,W){return T.includeAllVersions||(j=this.dedupExtensions(F===0?j:void 0,F===1?j:void 0,F==="development"?j:void 0,await this.getTargetPlatform(),W)),T.includeInvalid||(j=j.filter(N=>N.isValid)),j.sort((N,J)=>{const B=C.basename(N.location.fsPath),$=C.basename(J.location.fsPath);return B<$?-1:B>$?1:0})}dedupExtensions(j,F,T,W,N){const J=($,L,O)=>{if($.isValid&&!L.isValid)return!1;if($.isValid===L.isValid){if(N&&f.gt($.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(f.eq($.manifest.version,L.manifest.version)){if($.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${$.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${$.location.path} with ${L.location.path}.`),!0},B=new Map;return j?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!1))&&B.set(L,$)}),F?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);if(!O&&j&&$.type===0){this.logService.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!O||J(O,$,!1))&&B.set(L,$)}),T?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!0))&&B.set(L,$),B.set(L,$)}),[...B.values()]}async scanDefaultSystemExtensions(j,F){this.logService.trace("Started scanning system extensions");const T=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),N=await(j&&!T.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(T);return this.logService.trace("Scanned system extensions:",N.length),N}async scanDevSystemExtensions(j,F){const T=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!T?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},N=[],J=p.URI.file(C.normalize(C.join(v.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const $ of T){const L=W[$.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":N.push((0,d.joinPath)(J,$.name));break;default:N.push(p.URI.file(L));break}}const B=await Promise.all(N.map(async $=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput($,!1,0,!0,j))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,y.coalesce)(B)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,F,T,W,N,J=!0){const B=await this.getTranslations(N??E.language),$=await this.getMtime(j),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new Q(j,$,L,O,F,T,W,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,N,B)}async getMtime(j){try{const F=await this.fileService.stat(j);if(typeof F.mtime=="number")return F.mtime}catch{}}};ae=we([te(4,M.IUserDataProfilesService),te(5,g.IExtensionsProfileScannerService),te(6,a.IFileService),te(7,i.ILogService),te(8,m.IEnvironmentService),te(9,r.IProductService),te(10,n.IInstantiationService)],ae),e.AbstractExtensionsScannerService=ae;class Q{constructor(j,F,T,W,N,J,B,$,L,O,U,q,Y,se){this.location=j,this.mtime=F,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=W,this.profile=N,this.type=J,this.excludeObsolete=B,this.validate=$,this.productVersion=L,this.productDate=O,this.productCommit=U,this.devMode=q,this.language=Y,this.translations=se}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,F){return(0,d.isEqual)(j.location,F.location)&&j.mtime===F.mtime&&(0,d.isEqual)(j.applicationExtensionslocation,F.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&j.profile===F.profile&&j.type===F.type&&j.excludeObsolete===F.excludeObsolete&&j.validate===F.validate&&j.productVersion===F.productVersion&&j.productDate===F.productDate&&j.productCommit===F.productCommit&&j.devMode===F.devMode&&j.language===F.language&&G.equals(j.translations,F.translations)}}let X=class extends w.Disposable{constructor(j,F,T,W,N){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=F,this.uriIdentityService=T,this.fileService=W,this.logService=N}async scanExtensions(j){const F=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let T={};if(j.excludeObsolete&&j.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();T=JSON.parse(W)}catch{}return(0,b.isEmptyObject)(T)?F:F.filter(W=>!T[h.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(j){const F=await this.fileService.resolve(j.location);if(!F.children?.length)return[];const T=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||j.type===1&&(0,d.basename)(W.resource).indexOf(".")===0)return null;const N=new Q(W.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(N)}));return(0,y.coalesce)(T).sort((W,N)=>W.location.path<N.location.path?-1:1)}async scanExtensionsFromProfile(j){let F=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const T=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,j);F.push(...T)}return F}async scanExtensionsFromProfileResource(j,F,T){const W=await this.extensionsProfileScannerService.scanProfileExtensions(j);if(!W.length)return[];const N=await Promise.all(W.map(async J=>{if(F(J)){const B=new Q(J.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(B,J.metadata)}return null}));return(0,y.coalesce)(N)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,d.joinPath)(j.location,"package.json"))){const F=await this.scanExtension(j);return F?[F]:[]}else return await this.scanExtensions(j)}catch(F){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(j,F){try{let T=await this.scanExtensionManifest(j.location);if(T){T.publisher||(T.publisher=l.UNDEFINED_PUBLISHER),F=F??T.__metadata,delete T.__metadata;const W=(0,h.getGalleryExtensionId)(T.publisher,T.name),N=F?.id?{id:W,uuid:F.id}:{id:W},J=F?.isSystem?0:j.type,B=J===0||!!F?.isBuiltin;T=await this.translateManifest(j.location,T,Q.createNlsConfiguration(j));const $={type:J,identifier:N,manifest:T,location:j.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return j.validate?this.validate($,j):$}}catch(T){j.type!==0&&this.logService.error(T)}return null}validate(j,F){let T=!0;const W=(0,s.validateExtensionManifest)(F.productVersion,F.productDate,F.location,j.manifest,j.isBuiltin);for(const[N,J]of W)N===P.default.Error&&(T=!1,this.logService.error(this.formatMessage(F.location,J)));return j.isValid=T,j.validations=W,j}async scanExtensionManifest(j){const F=(0,d.joinPath)(j,"package.json");let T;try{T=(await this.fileService.readFile(F)).value.toString()}catch(N){return(0,a.toFileOperationResult)(N)!==1&&this.logService.error(this.formatMessage(j,(0,S.localize)(0,null,F.path,N.message))),null}let W;try{W=JSON.parse(T)}catch{const J=[];(0,I.parse)(T,J);for(const B of J)this.logService.error(this.formatMessage(j,(0,S.localize)(1,null,F.path,B.offset,B.length,(0,u.getParseErrorMessage)(B.error))));return null}return(0,I.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(j,(0,S.localize)(2,null,F.path))),null):W}async translateManifest(j,F,T){const W=await this.getLocalizedMessages(j,F,T);if(W)try{const N=[],J=await this.resolveOriginalMessageBundle(W.default,N);if(N.length>0)return N.forEach($=>{this.logService.error(this.formatMessage(j,(0,S.localize)(3,null,W.default?.path,(0,u.getParseErrorMessage)($.error))))}),F;if((0,I.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(j,(0,S.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,_.localizeManifest)(F,B,J)}catch{}return F}async getLocalizedMessages(j,F,T){const W=(0,d.joinPath)(j,"package.nls.json"),N=(L,O)=>{O.forEach(U=>{this.logService.error(this.formatMessage(j,(0,S.localize)(5,null,L?.path,(0,u.getParseErrorMessage)(U.error))))})},J=L=>{this.logService.error(this.formatMessage(j,(0,S.localize)(6,null,L?.path)))},B=`${F.publisher}.${F.name}`,$=T.translations[B];if($)try{const L=p.URI.file($),O=(await this.fileService.readFile(L)).value.toString(),U=[],q=(0,I.parse)(O,U);return U.length>0?(N(L,U),{values:void 0,default:W}):(0,I.getNodeType)(q)!=="object"?(J(L),{values:void 0,default:W}):{values:q.contents?q.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles(j,T)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const U=(await this.fileService.readFile(O.localized)).value.toString(),q=[],Y=(0,I.parse)(U,q);return q.length>0?(N(O.localized,q),{values:void 0,default:O.original}):(0,I.getNodeType)(Y)!=="object"?(J(O.localized),{values:void 0,default:O.original}):{values:Y,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(j,F){if(j)try{const T=(await this.fileService.readFile(j)).value.toString();return(0,I.parse)(T,F)}catch{}}findMessageBundles(j,F){return new Promise((T,W)=>{const N=J=>{const B=(0,d.joinPath)(j,`package.nls.${J}.json`);this.fileService.exists(B).then($=>{$&&T({localized:B,original:(0,d.joinPath)(j,"package.nls.json")});const L=J.lastIndexOf("-");L===-1?T({localized:(0,d.joinPath)(j,"package.nls.json"),original:null}):(J=J.substring(0,L),N(J))})};if(F.devMode||F.pseudo||!F.language)return T({localized:(0,d.joinPath)(j,"package.nls.json"),original:null});N(F.language)})}formatMessage(j,F){return`[${j.path}]: ${F}`}};X=we([te(1,g.IExtensionsProfileScannerService),te(2,A.IUriIdentityService),te(3,a.IFileService),te(4,i.ILogService)],X);let x=class extends X{constructor(j,F,T,W,N,J){super(F,T,W,N,J),this.cacheFile=j,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const F=await this.readExtensionCache();if(this.input=j,F&&F.input&&Q.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=p.URI.revive(W.location),W));const T=await super.scanExtensions(j);return await this.writeExtensionCache({input:j,result:T}),T}async readExtensionCache(){try{const j=await this.fileService.readFile(this.cacheFile),F=JSON.parse(j.value.toString());return{result:F.result,input:(0,o.revive)(F.input)}}catch(j){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(j))}return null}async writeExtensionCache(j){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(j)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const j=await this.readExtensionCache();if(!j)return;const F=j.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(T,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};x=we([te(2,g.IExtensionsProfileScannerService),te(3,A.IUriIdentityService),te(4,a.IFileService),te(5,i.ILogService)],x);function oe(V,j){const F=(0,h.getExtensionId)(V.manifest.publisher,V.manifest.name);return{id:F,identifier:new l.ExtensionIdentifier(F),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:j,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}e.toExtensionDescription=oe;class fe extends ae{constructor(j,F,T,W,N,J,B,$,L,O,U){super(j,F,(0,d.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(W,l.MANIFEST_CACHE_FOLDER),N,J,B,$,L,O,U),this.translationsPromise=(async()=>{if(E.translationsConfigFile)try{const q=await this.fileService.readFile(p.URI.file(E.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=fe}),define(ee[254],ie([0,1,7,36,72,89,15,5,6,20,39]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends R.NativeExtensionsScannerService{constructor(d,f,P,b,p,S,m){super(y.URI.file(p.builtinExtensionsPath),y.URI.file(p.extensionsPath),p.userHome,y.URI.file(p.userDataPath),d,f,P,b,p,S,m)}};C=we([te(0,v.IUserDataProfilesService),te(1,k.IExtensionsProfileScannerService),te(2,D.IFileService),te(3,u.ILogService),te(4,t.INativeEnvironmentService),te(5,w.IProductService),te(6,I.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(ee[255],ie([0,1,13,41,2,29,14,9,4,7,30,36,6,39]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let f=class extends k.Disposable{constructor(b,p,S){super(),this.environmentService=b,this.logService=S,this.validRoots=R.TernarySearchTree.forPaths(!u.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:b}=y.session;b.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,S)=>this.handleResourceRequest(p,S)),b.protocol.interceptFileProtocol(D.Schemas.file,(p,S)=>this.handleFileRequest(p,S)),this._register((0,k.toDisposable)(()=>{b.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(b){const p=(0,I.normalize)(b);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(b,p){const S=w.URI.parse(b.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${D.Schemas.file}: protocol (original URL: ${b.url})`),p({error:-3})}handleResourceRequest(b,p){const S=this.requestToNormalizedFilePath(b);let m;return this.environmentService.crossOriginIsolated&&((0,I.basename)(S)==="workbench.html"||(0,I.basename)(S)==="workbench-dev.html"?m=D.COI.CoopAndCoep:m=D.COI.getHeadersFromQuery(b.url)),this.validRoots.findSubstr(S)?p({path:S,headers:m}):this.validExtensions.has((0,I.extname)(S).toLowerCase())?p({path:S}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${S} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),p({error:-3}))}requestToNormalizedFilePath(b){const p=w.URI.parse(b.url),S=D.FileAccess.asFileUri(p);return(0,I.normalize)(S.fsPath)}createIPCObjectUrl(){let b;const p=w.URI.from({scheme:"vscode",path:(0,v.generateUuid)()}),S=p.toString(),m=async()=>b;return t.validatedIpcMain.handle(S,m),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:p,update:h=>b=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),t.validatedIpcMain.removeHandler(S)}}}};f=we([te(0,C.INativeEnvironmentService),te(1,d.IUserDataProfilesService),te(2,E.ILogService)],f),e.ProtocolMainService=f}),define(ee[256],ie([0,1,13,41,8,3,2,14,12,102,27,22,6,54,61,64,44,39,37]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends D.Disposable{constructor(l,s,a,n,i,r,c,o,g){super(),this.machineId=l,this.userEnv=s,this.environmentMainService=a,this.userDataProfilesService=n,this.lifecycleMainService=i,this.logService=r,this.policyService=c,this.themeMainService=o,this.protocolMainService=g,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,s)=>this.onWindowConnection(l,s)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,s)=>this.onWorkerConnection(l,s)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,s){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(l.sender.isDestroyed())return a.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",s,[a])}onWorkerConnection(l,s){this.logService.trace("SharedProcess: onWorkerConnection",s);const a=new D.DisposableStore,n=r=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${r}')`,s),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",s))},i=y.BrowserWindow.fromId(s.reply.windowId);if(!i||i.isDestroyed()||i.webContents.isDestroyed()||!s.reply.channel){n("unavailable");return}a.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,r=>r.window.win===i)(()=>n("load"))),a.add(R.Event.fromNodeEventEmitter(i,"closed")(()=>n("closed"))),i.webContents.postMessage(s.reply.channel,s.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...s){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...s)}catch(a){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,b.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new y.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:d.default,policiesData:this.policyService.serialize()}),this.window.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,s)=>this._onDidError.fire({type:2,details:s})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,s,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:s}})))}async connect(){await this.whenIpcReady;const l=(0,u.assertIsDefined)(this.window);return(0,w.connect)(l)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};m=we([te(2,v.IEnvironmentMainService),te(3,p.IUserDataProfilesService),te(4,C.ILifecycleMainService),te(5,E.ILogService),te(6,S.IPolicyService),te(7,P.IThemeMainService),te(8,f.IProtocolMainService)],m),e.SharedProcess=m}),define(ee[90],ie([0,1,8,3,2,71,12,103,5,39]),function(z,e,y,t,k,R,D,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var v;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var E;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));function d(S){const m=S.get(e.TARGET_KEY);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.loadKeyTargets=d;class f extends k.Disposable{constructor(m={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new y.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,y.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,h){if(h===e.TARGET_KEY){switch(m){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:m})}else this._onDidChangeValue.fire({scope:m,key:h,target:this.getKeyTargets(m)[h]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,h,l){return this.getStorage(h)?.get(m,l)}getBoolean(m,h,l){return this.getStorage(h)?.getBoolean(m,l)}getNumber(m,h,l){return this.getStorage(h)?.getNumber(m,l)}store(m,h,l,s){if((0,D.isUndefinedOrNull)(h)){this.remove(m,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,l,s),this.getStorage(l)?.set(m,h)})}remove(m,h){this.withPausedEmitters(()=>{this.updateKeyTarget(m,h,void 0),this.getStorage(h)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,h){const l=[],s=this.getKeyTargets(m);for(const a of Object.keys(s))s[a]===h&&l.push(a);return l}updateKeyTarget(m,h,l){const s=this.getKeyTargets(h);typeof l=="number"?s[m]!==l&&(s[m]=l,this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(s))):typeof s[m]=="number"&&(delete s[m],this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(m){switch(m){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(m){const h=this.getStorage(m);return h?d(h):Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=v.NONE){this._onWillSaveState.fire({reason:m});const h=this.getStorage(-1),l=this.getStorage(0),s=this.getStorage(1);switch(m){case v.NONE:await y.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await y.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return p(m,h,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(m,h){return this.emitWillSaveState(v.NONE),(0,w.isUserDataProfile)(m)?this.switchToProfile(m,h):this.switchToWorkspace(m,h)}canSwitchProfile(m,h){return!(m.id===h.id||P(h)&&P(m))}switchData(m,h,l,s){this.withPausedEmitters(()=>{if(s)for(const[a,n]of m)h.set(a,n);else{const a=new Set;for(const[n,i]of m)a.add(n),h.get(n)!==i&&this.emitDidChangeValue(l,n);for(const[n]of h.items)a.has(n)||this.emitDidChangeValue(l,n)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function P(S){return S.isDefault||!!S.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=P;class b extends f{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.profileStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),this._register(this.applicationStorage.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m)))}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(m){return!1}}e.InMemoryStorageService=b;async function p(S,m,h,l,s,a){const n=G=>{try{return JSON.parse(G)}catch{return G}},i=new Map,r=new Map;S.forEach((G,ae)=>{i.set(ae,G),r.set(ae,n(G))});const c=new Map,o=new Map;m.forEach((G,ae)=>{c.set(ae,G),o.set(ae,n(G))});const g=new Map,M=new Map;h.forEach((G,ae)=>{g.set(ae,G),M.set(ae,n(G))}),console.group(l!==s?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const A=[];if(i.forEach((G,ae)=>{A.push({key:ae,value:G})}),console.table(A),console.groupEnd(),console.log(r),l!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const G=[];c.forEach((ae,Q)=>{G.push({key:Q,value:ae})}),console.table(G),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const _=[];g.forEach((G,ae)=>{_.push({key:ae,value:G})}),console.table(_),console.groupEnd(),console.log(M)}e.logStorage=p}),define(ee[257],ie([0,1,24,8,3,2,9,79,7,21,103,145,6,90,32,28]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{get storage(){return this._storage}constructor(a,n){super(),this.logService=a,this.fileService=n,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new v.Storage(new v.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=v.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===v.StorageState.None)try{const a=await this.doCreate();this._storage.dispose(),this._storage=a,this._register(a.onDidChangeStorage(i=>this._onDidChangeStorage.fire({key:i}))),await this.doInit(a);const n=a.getBoolean(d.IS_NEW_KEY);n===void 0?a.set(d.IS_NEW_KEY,!0):n&&a.set(d.IS_NEW_KEY,!1)}catch(a){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.state=v.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===E.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this._storage.items}get(a,n){return this._storage.get(a,n)}set(a,n){return this._storage.set(a,n)}delete(a){return this._storage.delete(a)}async close(){const a=new I.StopWatch(!1);await this.doClose(),a.stop(),a.elapsed()>b.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(a),this._onDidCloseStorage.fire()}async logSlowClose(a){if(!!this.path)try{const n=(0,y.top)(Array.from(this._storage.items.entries()).map(([r,c])=>({key:r,length:c.length})),(r,c)=>c.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),i=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${i}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=v.StorageState.Closed,await this._storage.close()}}b.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends b{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}constructor(a,n,i,r){super(i,r),this.profile=a,this.options=n}async doCreate(){return new v.Storage(new C.SQLiteStorageDatabase(this.path??C.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class S extends p{constructor(a,n,i,r){super(a,n,i,r)}}e.ProfileStorageMain=S;class m extends p{constructor(a,n,i,r){super(n.defaultProfile,a,i,r)}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(f.firstSessionDateStorageKey,void 0)===void 0&&a.set(f.firstSessionDateStorageKey,new Date().toUTCString());const i=a.get(f.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();a.set(f.lastSessionDateStorageKey,typeof i>"u"?null:i),a.set(f.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=m;class h extends b{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}constructor(a,n,i,r,c){super(i,c),this.workspace=a,this.options=n,this.environmentService=r}async doCreate(){const{storageFilePath:a,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new v.Storage(new C.SQLiteStorageDatabase(a,{logging:this.createLoggingOptions()}),{hint:n?v.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:C.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,D.join)(a,h.WORKSPACE_STORAGE_NAME);return await w.Promises.exists(a)?{storageFilePath:n,wasCreated:!1}:(await w.Promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let n;if((0,P.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,P.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const i=(0,D.join)(a,h.WORKSPACE_META_NAME);await w.Promises.exists(i)||await w.Promises.writeFile(i,JSON.stringify(n,void 0,2))}catch(i){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class l extends b{get path(){}async doCreate(){return new v.Storage(new v.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(ee[258],ie([0,1,67,36,15,6,227,51,39]),function(z,e,y,t,k,R,D,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let w=class At extends u.UserDataProfilesService{constructor(C,E,d,f,P){super(d,f,E,P),this.stateService=C}getStoredProfiles(){return(0,y.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,y.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};w=we([te(0,D.IStateService),te(1,I.IUriIdentityService),te(2,t.IEnvironmentService),te(3,k.IFileService),te(4,R.ILogService)],w),e.UserDataProfilesService=w}),define(ee[42],ie([0,1,7,36,15,5,6,38,51,39,258]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(w.IUserDataProfilesService);let C=class ht extends v.UserDataProfilesService{constructor(d,f,P,b,p){super(d,f,P,b,p),this.stateMainService=d}setEnablement(d){super.setEnablement(d),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}checkAndCreateProfileFromCli(d){if(!!this.isEnabled()){if(d.profile){const f=this.profiles.find(P=>P.name===d.profile);return f?Promise.resolve(f):this.createNamedProfile(d.profile)}if(d["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(d){d.length?this.stateMainService.setItem(ht.PROFILES_KEY,d):this.stateMainService.removeItem(ht.PROFILES_KEY)}saveStoredProfileAssociations(d){d.emptyWindow||d.workspaces?this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,d):this.stateMainService.removeItem(ht.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const d="workspaceAndProfileInfo",f=this.stateMainService.getItem(d,void 0);if(f){this.stateMainService.removeItem(d);const P=f.reduce((b,{workspace:p,profile:S})=>(b[y.URI.revive(p).toString()]=y.URI.revive(S).toString(),b),{});this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}return super.getStoredProfileAssociations()}};C=we([te(0,I.IStateMainService),te(1,u.IUriIdentityService),te(2,t.IEnvironmentService),te(3,k.IFileService),te(4,D.ILogService)],C),e.UserDataProfilesMainService=C}),define(ee[259],ie([0,1,2,18,72,89,15,6,39,42]),function(z,e,y,t,k,R,D,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let v=class extends y.Disposable{constructor(E,d,f,P,b){super(),this.userDataProfilesService=E,this.fileService=d,this.extensionsScannerService=f,this.extensionsProfileScannerService=P,E.isEnabled()?(this._register(E.onWillCreateProfile(p=>{E.profiles.length===1&&p.join(this.initialize())})),this._register(E.onDidChangeProfiles(p=>{E.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>b.error(p))}async initialize(){const E=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(E)}catch{}const d=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(d.map(f=>[f,f.metadata]),E)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,u.EXTENSIONS_RESOURCE_NAME)}};v=we([te(0,w.IUserDataProfilesMainService),te(1,D.IFileService),te(2,R.IExtensionsScannerService),te(3,k.IExtensionsProfileScannerService),te(4,I.ILogService)],v),e.DefaultExtensionsProfileInitHandler=v}),define(ee[260],ie([0,1,13,24,4,7,21,19,59,5,6,114,33,42]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,w.createDecorator)(e.ID);let f=class{constructor(b,p,S,m,h){this.logService=b,this.windowsMainService=p,this.urlService=S,this.configurationService=m,this.userDataProfilesMainService=h}async start(b,p){this.logService.trace("Received data from other instance: ",b,p),k.isMacintosh&&y.app.focus({steal:!0});const S=this.parseOpenUrl(b);if(S.length){let m=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const h=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));h&&(m=h.ready())}m.then(()=>{for(const{uri:h,url:l}of S)this.urlService.open(h,{originalUrl:l})})}else return this.startOpenWindow(b,p)}parseOpenUrl(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,t.coalesce)(b._urls.map(p=>{try{return{uri:R.URI.parse(p),url:p}}catch{return null}})):[]}async startOpenWindow(b,p){const S=(0,u.isLaunchedFromCli)(p)?0:4;let m=[];const h=b.wait&&b.waitMarkerFilePath?R.URI.file(b.waitMarkerFilePath):void 0,l=b.remote||void 0,s=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(b),a={context:S,cli:b,userEnv:p,waitMarkerFileURI:h,remoteAuthority:l,profile:s};if(b.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,a);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let n=!1;if(b["new-window"]||b["unity-launch"]||s)n=!0;else if(b["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!k.isMacintosh}if(n)m=await this.windowsMainService.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const i=this.windowsMainService.getLastActiveWindow();i?(this.windowsMainService.openExistingWindow(i,a),m=[i]):m=await this.windowsMainService.open({...a,forceEmpty:!0})}}else m=await this.windowsMainService.open({...a,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(h&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,D.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};f=we([te(0,v.ILogService),te(1,E.IWindowsMainService),te(2,C.IURLService),te(3,I.IConfigurationService),te(4,d.IUserDataProfilesMainService)],f),e.LaunchMainService=f}),define(ee[91],ie([0,1,7,49,3,2,36,15,5,22,6,90,257,39,42,51]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,u.createDecorator)("storageMainService");let b=class extends R.Disposable{constructor(m,h,l,s,a,n){super(),this.logService=m,this.environmentService=h,this.userDataProfilesService=l,this.lifecycleMainService=s,this.fileService=a,this.uriIdentityService=n,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(m=>{m.window.profile&&this.profileStorage(m.window.profile).init(),m.workspace&&this.workspaceStorage(m.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(m=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=m.reason,m.join(this.applicationStorage.close());for(const[,h]of this.mapProfileToStorage)m.join(h.close());for(const[,h]of this.mapWorkspaceToStorage)m.join(h.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(m=>{m.join((async()=>{await this.fileService.exists(m.profile.globalStorageHome)||await this.fileService.createFolder(m.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(m=>{const h=this.mapProfileToStorage.get(m.profile.id);h&&m.join(h.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const m=new E.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(m.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),m}profileStorage(m){if((0,C.isProfileUsingDefaultStorage)(m))return this.applicationStorage;let h=this.mapProfileToStorage.get(m.id);if(!h){this.logService.trace(`StorageMainService: creating profile storage (${m.name})`),h=this.createProfileStorage(m),this.mapProfileToStorage.set(m.id,h);const l=this._register(h.onDidChangeStorage(s=>this._onDidChangeProfileStorage.fire({...s,storage:h,profile:m})));(0,t.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${m.name})`),this.mapProfileToStorage.delete(m.id),l.dispose()})}return h}createProfileStorage(m){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.ProfileStorageMain(m,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(m){let h=this.mapWorkspaceToStorage.get(m.id);return h||(this.logService.trace(`StorageMainService: creating workspace storage (${m.id})`),h=this.createWorkspaceStorage(m),this.mapWorkspaceToStorage.set(m.id,h),(0,t.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${m.id})`),this.mapWorkspaceToStorage.delete(m.id)})),h}createWorkspaceStorage(m){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.WorkspaceStorageMain(m,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(m){const h=y.URI.file(m);for(const l of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!l.path&&this.uriIdentityService.extUri.isEqualOrParent(y.URI.file(l.path),h))return!0;return!1}};b=we([te(0,v.ILogService),te(1,D.IEnvironmentService),te(2,f.IUserDataProfilesMainService),te(3,w.ILifecycleMainService),te(4,I.IFileService),te(5,P.IUriIdentityService)],b),e.StorageMainService=b,e.IApplicationStorageMainService=(0,u.createDecorator)("applicationStorageMainService");let p=class extends C.AbstractStorageService{constructor(m,h){super(),this.userDataProfilesService=m,this.storageMainService=h,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(m){if(m===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(m){if(m===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};p=we([te(0,d.IUserDataProfilesService),te(1,e.IStorageMainService)],p),e.ApplicationStorageMainService=p}),define(ee[261],ie([0,1,2,22,42]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends y.Disposable{constructor(I,u){super(),this.userDataProfilesService=u,this._register(I.onWillLoadWindow(w=>{w.reason===2&&this.unsetTransientProfileForWorkspace(w.window.openedWorkspace??"empty-window")})),this._register(I.onBeforeCloseWindow(w=>this.unsetTransientProfileForWorkspace(w.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(I){this.userDataProfilesService.getOrSetProfileForWorkspace(I).isTransient&&(this.userDataProfilesService.unsetWorkspace(I,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=we([te(0,t.ILifecycleMainService),te(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(ee[262],ie([0,1,3,2,90]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(I,u,w){super(),this.storageMainService=I,this.userDataProfilesService=u,this.logService=w;const v=this._register(new t.MutableDisposable);this._onDidChange=this._register(new y.Emitter({onFirstListenerAdd:()=>v.value=this.registerStorageChangeListeners(),onLastListenerRemove:()=>v.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new t.DisposableStore;return I.add(y.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(u,w)=>(u?u.push(w.key):u=[w.key],u),100)(u=>this.onDidChangeApplicationStorage(u))),I.add(y.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(u,w)=>{u||(u=new Map);let v=u.get(w.profile.id);return v||u.set(w.profile.id,v={profile:w.profile,keys:[],storage:w.storage}),v.keys.push(w.key),u},100)(u=>this.onDidChangeProfileStorage(u))),I}onDidChangeApplicationStorage(I){const u=I.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],w=[];if(I=I.filter(v=>v!==k.TARGET_KEY),I.length){const v=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);w.push({profile:this.userDataProfilesService.defaultProfile,changes:I.map(C=>({key:C,scope:0,target:v[C]}))})}this.triggerEvents(u,w)}onDidChangeProfileStorage(I){const u=[],w=new Map;for(const[v,C]of I.entries()){C.keys.includes(k.TARGET_KEY)&&u.push(C.profile);const E=C.keys.filter(d=>d!==k.TARGET_KEY);if(E.length){const d=(0,k.loadKeyTargets)(C.storage.storage);w.set(v,{profile:C.profile,changes:E.map(f=>({key:f,scope:0,target:d[f]}))})}}this.triggerEvents(u,[...w.values()])}triggerEvents(I,u){(I.length||u.length)&&this._onDidChange.fire({valueChanges:u,targetChanges:I})}listen(I,u,w){switch(u){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${u}`)}async call(I,u){throw new Error(`Call not found: ${u}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ee[116],ie([0,1,18,7,28]),function(z,e,y,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(u,w,v){for(const E of u){const d=E.openedWorkspace;if((0,k.isWorkspaceIdentifier)(d)){const f=await v(d);if(f){if(f.folders.some(P=>y.extUriBiasedIgnorePathCase.isEqualOrParent(w,P.uri)))return E}else if(y.extUriBiasedIgnorePathCase.isEqualOrParent(w,d.configPath))return E}}const C=u.filter(E=>(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqualOrParent(w,E.openedWorkspace.uri));if(C.length)return C.sort((E,d)=>-(E.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(u,w){for(const v of u)if((0,k.isWorkspaceIdentifier)(v.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.uri,w))return v}e.findWindowOnWorkspaceOrFolder=D;function I(u,w){const v=C=>w.some(E=>y.extUriBiasedIgnorePathCase.isEqual(t.URI.file(E),t.URI.file(C)));for(const C of u)if(C.config?.extensionDevelopmentPath?.some(E=>v(E)))return C}e.findWindowOnExtensionDevelopmentPath=I}),define(ee[263],ie([0,1,13,2,4,18,7,19,22,6,38,33,115,28]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let f=class Tt extends t.Disposable{get state(){return this._state}constructor(h,l,s,a,n){super(),this.windowsMainService=h,this.stateMainService=l,this.lifecycleMainService=s,this.logService=a,this.configurationService=n,this._state=P(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){y.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h=new Set,l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),n&&(l.lastActiveWindow=this.toWindowState(n),l.lastActiveWindow.uiState.mode===3&&h.add(l.lastActiveWindow.uiState.display))}const s=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);s&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(s),l.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(l.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!s.win?.isSimpleFullScreen()&&(l.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(l.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const i=this.toWindowState(n);return i.uiState.mode===3&&(h.has(i.uiState.display)?k.isMacintosh&&i.windowId!==l.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(i.uiState.mode=1):h.add(i.uiState.display)),i}));const a=p(l);this.stateMainService.setItem(Tt.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(s=>{const a=(0,d.isWorkspaceIdentifier)(h.openedWorkspace)&&s.workspace?.id===h.openedWorkspace.id,n=(0,d.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&s.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(s.folderUri,h.openedWorkspace.uri);(a||n)&&(s.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(h){return{windowId:h.id,workspace:(0,d.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const l=this.doGetNewWindowState(h),s=this.configurationService.getValue("window");if(l.mode===3){let a;l.hasDefaultState?a=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):a=!!(this.lifecycleMainService.wasRestarted||s?.restoreFullscreen),a||(l.mode=1)}return l}doGetNewWindowState(h){const l=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=h.workspace;if((0,d.isWorkspaceIdentifier)(c)){const g=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===c.id).map(M=>M.uiState);if(g.length)return g[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(c)){const g=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,c.uri)).map(M=>M.uiState);if(g.length)return g[0]}else if(h.backupPath){const g=this.state.openedWindows.filter(M=>M.backupPath===h.backupPath).map(M=>M.uiState);if(g.length)return g[0]}const o=this.lastClosedState||this.state.lastActiveWindow;if(!l&&o)return o.uiState}let s;const a=y.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(k.isMacintosh){const c=y.screen.getCursorScreenPoint();s=y.screen.getDisplayNearestPoint(c)}!s&&l&&(s=y.screen.getDisplayMatching(l.getBounds())),s||(s=y.screen.getPrimaryDisplay()||a[0])}let n=(0,E.defaultWindowState)();n.x=Math.round(s.bounds.x+s.bounds.width/2-n.width/2),n.y=Math.round(s.bounds.y+s.bounds.height/2-n.height/2);const i=this.configurationService.getValue("window");let r=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")n.mode=0,r=!1;else if(i.newWindowDimensions==="fullscreen")n.mode=3,r=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&l){const c=l.serializeWindowState();c.mode===3?n.mode=3:n=c,r=n.mode!==3&&i.newWindowDimensions==="offset"}}return r&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const l=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;l.some(s=>s.x===h.x||s.y===h.y);)h.x+=30,h.y+=30;return h}};f.windowsStateStorageKey="windowsState",f=we([te(0,C.IWindowsMainService),te(1,v.IStateMainService),te(2,u.ILifecycleMainService),te(3,w.ILogService),te(4,I.IConfigurationService)],f),e.WindowsStateHandler=f;function P(m){const h={openedWindows:[]},l=m||{openedWindows:[]};return l.lastActiveWindow&&(h.lastActiveWindow=b(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=b(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(h.openedWindows=l.openedWindows.map(s=>b(s))),h}e.restoreWindowsState=P;function b(m){const h={uiState:m.uiState};return m.backupPath&&(h.backupPath=m.backupPath),m.remoteAuthority&&(h.remoteAuthority=m.remoteAuthority),m.folder&&(h.folderUri=D.URI.parse(m.folder)),m.workspaceIdentifier&&(h.workspace={id:m.workspaceIdentifier.id,configPath:D.URI.parse(m.workspaceIdentifier.configURIPath)}),h}function p(m){return{lastActiveWindow:m.lastActiveWindow&&S(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&S(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(h=>S(h))}}e.getWindowsStateStoreData=p;function S(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(ee[92],ie([0,1,31,43,122,35,14,9,4,18,7,5,63,28]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,C.createDecorator)("workspacesService");function f(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=f;function P(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=P;function b(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=b;function p(M){return S(M)||m(M)}e.isStoredWorkspaceFolder=p;function S(M){const A=M;return typeof A?.path=="string"&&(!A.name||typeof A.name=="string")}function m(M){const A=M;return typeof A?.uri=="string"&&(!A.name||typeof A.name=="string")}function h(M,A,_,G,ae){if(M.scheme!==G.scheme)return{name:_,uri:M.toString(!0)};let Q=A?void 0:ae.relativePath(G,M);if(Q!==void 0)Q.length===0?Q=".":u.isWindows&&(Q=l(Q));else if(M.scheme===D.Schemas.file)Q=M.fsPath,u.isWindows&&(Q=l(Q));else if(ae.isEqualAuthority(M.authority,G.authority))Q=M.path;else return{name:_,uri:M.toString(!0)};return{name:_,path:Q}}e.getStoredWorkspaceFolder=h;function l(M){return M=(0,R.normalizeDriveLetter)(M),(0,y.isUNC)(M)||(M=(0,y.toSlashes)(M)),M}function s(M,A,_){const G=[],ae=new Set,Q=_.dirname(A);for(const X of M){let x;if(S(X))X.path&&(x=_.resolvePath(Q,X.path));else if(m(X))try{x=v.URI.parse(X.uri),x.path[0]!==I.posix.sep&&(x=x.with({path:I.posix.sep+x.path}))}catch(oe){console.warn(oe)}if(x){const oe=_.getComparisonKey(x);if(!ae.has(oe)){ae.add(oe);const fe=X.name||_.basenameOrAuthority(x);G.push(new d.WorkspaceFolder({uri:x,name:fe,index:G.length},X))}}}return G}e.toWorkspaceFolders=s;function a(M,A,_,G,ae){const Q=n(A,M),X=ae.dirname(A),x=ae.dirname(G),oe=[];for(const F of Q.folders){const T=S(F)?ae.resolvePath(X,F.path):v.URI.parse(F.uri);let W;_?W=!1:W=!S(F)||(0,I.isAbsolute)(F.path),oe.push(h(T,W,F.name,x,ae))}const fe={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},V=k.setProperty(M,["folders"],oe,fe);let j=k.applyEdits(M,V);return(0,w.isEqualAuthority)(Q.remoteAuthority,(0,E.getRemoteAuthority)(G))&&(j=k.applyEdits(j,k.removeProperty(j,["remoteAuthority"],fe))),j}e.rewriteWorkspaceFileForNewLocation=a;function n(M,A){const _=t.parse(A);if(_&&Array.isArray(_.folders))_.folders=_.folders.filter(G=>p(G));else throw new Error(`${M} looks like an invalid workspace file.`);return _}function i(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function r(M){return typeof M.folderUri=="string"}function c(M){return typeof M.fileUri=="string"}function o(M,A){const _={workspaces:[],files:[]};if(M){const G=function(Q,X){for(let x=0;x<Q.length;x++)try{X(Q[x],x)}catch(oe){A.warn(`Error restoring recent entry ${JSON.stringify(Q[x])}: ${oe.toString()}. Skip entry.`)}},ae=M;Array.isArray(ae.entries)&&G(ae.entries,Q=>{const X=Q.label,x=Q.remoteAuthority;i(Q)?_.workspaces.push({label:X,remoteAuthority:x,workspace:{id:Q.workspace.id,configPath:v.URI.parse(Q.workspace.configPath)}}):r(Q)?_.workspaces.push({label:X,remoteAuthority:x,folderUri:v.URI.parse(Q.folderUri)}):c(Q)&&_.files.push({label:X,remoteAuthority:x,fileUri:v.URI.parse(Q.fileUri)})})}return _}e.restoreRecentlyOpened=o;function g(M){const A={entries:[]};for(const _ of M.workspaces)P(_)?A.entries.push({folderUri:_.folderUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority}):A.entries.push({workspace:{id:_.workspace.id,configPath:_.workspace.configPath.toString()},label:_.label,remoteAuthority:_.remoteAuthority});for(const _ of M.files)A.entries.push({fileUri:_.fileUri.toString(),label:_.label,remoteAuthority:_.remoteAuthority});return A}e.toStoreData=g}),define(ee[93],ie([0,1,76,14,4,18]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(w){function v(){let C=w.scheme===t.Schemas.file?(0,R.originalFSPath)(w):w.toString();return k.isLinux||(C=C.toLowerCase()),(0,y.createHash)("md5").update(C).digest("hex")}return{id:v(),configPath:w}}e.getWorkspaceIdentifier=D;function I(w,v){function C(){if(w.scheme!==t.Schemas.file)return(0,y.createHash)("md5").update(w.toString()).digest("hex");if(!v)return;let d;return k.isLinux?d=v.ino:k.isMacintosh?d=v.birthtime.getTime():k.isWindows&&(typeof v.birthtimeMs=="number"?d=Math.floor(v.birthtimeMs):d=v.birthtime.getTime()),(0,y.createHash)("md5").update(w.fsPath).update(d?String(d):"").digest("hex")}const E=C();if(typeof E=="string")return{id:E,uri:w}}e.getSingleFolderWorkspaceIdentifier=I;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=u}),define(ee[264],ie([0,1,76,31,14,9,4,18,21,175,19,27,38,15,6,174,28,93]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class Ot{constructor(h,l,s,a){this.environmentMainService=h,this.configurationService=l,this.logService=s,this.stateMainService=a,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=I.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,i)=>(0,t.isEqual)(n,i,!D.isLinux)}}async initialize(){const h=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWindows),this.workspaces=await this.validateWorkspaces((0,w.deserializeWorkspaceInfos)(h)),this.folders=await this.validateFolders((0,w.deserializeFolderInfos)(h)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let h=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!h)try{const l=(0,R.join)(this.backupHome,"workspaces.json"),s=await u.Promises.readFile(l,"utf8");try{await u.Promises.unlink(l)}catch{}const a=JSON.parse(s);h={workspaces:Array.isArray(a.rootURIWorkspaces)?a.rootURIWorkspaces:[],folders:Array.isArray(a.folderWorkspaceInfos)?a.folderWorkspaceInfos:[],emptyWindows:Array.isArray(a.emptyWorkspaceInfos)?a.emptyWorkspaceInfos:[]}}catch(l){l.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${l.toString()}`)}return h??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(h,l){this.workspaces.some(a=>h.workspace.id===a.workspace.id)||(this.workspaces.push(h),this.storeWorkspacesMetadata());const s=(0,R.join)(this.backupHome,h.workspace.id);return l?this.moveBackupFolder(s,l).then(()=>s):s}async moveBackupFolder(h,l){if(await u.Promises.exists(h)&&await this.convertToEmptyWindowBackup(h),await u.Promises.exists(l))try{await u.Promises.rename(l,h)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}registerFolderBackup(h){return this.folders.some(l=>this.backupUriComparer.isEqual(h.folderUri,l.folderUri))||(this.folders.push(h),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(h))}registerEmptyWindowBackup(h){return this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,h.backupFolder))||(this.emptyWindows.push(h),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,h.backupFolder)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const l=new Set,s=[];for(const a of h){const n=a.workspace;if(!(0,b.isWorkspaceIdentifier)(n))return[];if(!l.has(n.id)){l.add(n.id);const i=(0,R.join)(this.backupHome,n.id);await this.doHasBackups(i)?n.configPath.scheme!==k.Schemas.file||await u.Promises.exists(n.configPath.fsPath)?s.push(a):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return s}async validateFolders(h){if(!Array.isArray(h))return[];const l=[],s=new Set;for(const a of h){const n=a.folderUri,i=this.backupUriComparer.getComparisonKey(n);if(!s.has(i)){s.add(i);const r=(0,R.join)(this.backupHome,this.getFolderHash(a));await this.doHasBackups(r)?n.scheme!==k.Schemas.file||await u.Promises.exists(n.fsPath)?l.push(a):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return l}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const l=[],s=new Set;for(const a of h){const n=a.backupFolder;if(typeof n!="string")return[];if(!s.has(n)){s.add(n);const i=(0,R.join)(this.backupHome,n);await this.doHasBackups(i)?l.push(a):await this.deleteStaleBackup(i)}}return l}async deleteStaleBackup(h){try{await u.Promises.rm(h,u.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}prepareNewEmptyWindowBackup(){let h=(0,p.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,h.id));)h=(0,p.createEmptyWorkspaceIdentifier)();return{backupFolder:h.id}}async convertToEmptyWindowBackup(h){const l=this.prepareNewEmptyWindowBackup(),s=(0,R.join)(this.backupHome,l.backupFolder);try{await u.Promises.rename(h,s)}catch(a){return this.logService.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.emptyWindows.push(l),!0}async getDirtyWorkspaces(){const h=[];for(const l of this.workspaces)await this.hasBackups(l)&&h.push(l);for(const l of this.folders)await this.hasBackups(l)&&h.push(l);return h}hasBackups(h){let l;return(0,w.isEmptyWindowBackupInfo)(h)?l=(0,R.join)(this.backupHome,h.backupFolder):(0,P.isFolderBackupInfo)(h)?l=(0,R.join)(this.backupHome,this.getFolderHash(h)):l=(0,R.join)(this.backupHome,h.workspace.id),this.doHasBackups(l)}async doHasBackups(h){try{const l=await u.Promises.readdir(h);for(const s of l)try{if((await u.Promises.readdir((0,R.join)(h,s))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const h={workspaces:this.workspaces.map(({workspace:l,remoteAuthority:s})=>{const a={id:l.id,configURIPath:l.configPath.toString()};return s&&(a.remoteAuthority=s),a}),folders:this.folders.map(({folderUri:l,remoteAuthority:s})=>{const a={folderUri:l.toString()};return s&&(a.remoteAuthority=s),a}),emptyWindows:this.emptyWindows.map(({backupFolder:l,remoteAuthority:s})=>{const a={backupFolder:l};return s&&(a.remoteAuthority=s),a})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,h)}getFolderHash(h){const l=h.folderUri;let s;return l.scheme===k.Schemas.file?s=D.isLinux?l.fsPath:l.fsPath.toLowerCase():s=l.toString().toLowerCase(),(0,y.createHash)("md5").update(s).digest("hex")}};S.backupWorkspacesMetadataStorageKey="backupWorkspaces",S=we([te(0,C.IEnvironmentMainService),te(1,v.IConfigurationService),te(2,f.ILogService),te(3,E.IStateMainService)],S),e.BackupMainService=S}),define(ee[52],ie([0,1,13,3,43,35,2,14,9,18,12,21,173,60,56,27,5,6,20,42,116,28,92,93]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let n=class extends D.Disposable{constructor(r,c,o,g,M,A){super(),this.environmentMainService=r,this.logService=c,this.userDataProfilesMainService=o,this.backupMainService=g,this.dialogMainService=M,this.productService=A,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const r=(await C.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(c=>(0,w.joinPath)(this.untitledWorkspacesHome,c,l.UNTITLED_WORKSPACE_NAME));for(const c of r){const o=(0,a.getWorkspaceIdentifier)(c),g=await this.resolveLocalWorkspace(c);g?this.untitledWorkspaces.push({workspace:o,remoteAuthority:g.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(r){r.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${r}).`)}}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,c=>C.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(r,c){if(!!this.isWorkspacePath(r)&&r.scheme===I.Schemas.file)try{const o=c(r.fsPath);return o instanceof Promise?o.then(g=>this.doResolveWorkspace(r,g),g=>{}):this.doResolveWorkspace(r,o)}catch{return}}isWorkspacePath(r){return(0,l.isUntitledWorkspace)(r,this.environmentMainService)||(0,l.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,c){try{const o=this.doParseStoredWorkspace(r,c),g=(0,a.getWorkspaceIdentifier)(r);return{id:g.id,configPath:g.configPath,folders:(0,s.toWorkspaceFolders)(o.folders,g.configPath,w.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.logService.warn(o.toString())}}doParseStoredWorkspace(r,c){const o=(0,k.parse)(c);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(g=>(0,s.isStoredWorkspaceFolder)(g));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(r,c){const{workspace:o,storedWorkspace:g}=this.newUntitledWorkspace(r,c),M=o.configPath.fsPath;return await C.Promises.mkdir((0,u.dirname)(M),{recursive:!0}),await C.Promises.writeFile(M,JSON.stringify(g,null,"	")),this.untitledWorkspaces.push({workspace:o,remoteAuthority:c}),o}newUntitledWorkspace(r=[],c){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),g=(0,w.joinPath)(this.untitledWorkspacesHome,o),M=(0,w.joinPath)(g,l.UNTITLED_WORKSPACE_NAME),A=[];for(const _ of r)A.push((0,s.getStoredWorkspaceFolder)(_.uri,!0,_.name,g,w.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(M),storedWorkspace:{folders:A,remoteAuthority:c}}}async getWorkspaceIdentifier(r){return(0,a.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,l.isUntitledWorkspace)(r.configPath,this.environmentMainService)}async deleteUntitledWorkspace(r){!this.isUntitledWorkspace(r)||(await this.doDeleteUntitledWorkspace(r),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(r),this._onDidDeleteUntitledWorkspace.fire(r))}async doDeleteUntitledWorkspace(r){const c=(0,w.originalFSPath)(r.configPath);try{await C.Promises.rm((0,u.dirname)(c));const o=(0,u.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);await C.Promises.exists(o)&&await C.Promises.writeFile((0,u.join)(o,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(g=>g.workspace.id!==r.id)}catch(o){this.logService.warn(`Unable to delete untitled workspace ${c} (${o}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(r,c,o){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,c,o))return;const M=await this.doEnterWorkspace(r,(0,a.getWorkspaceIdentifier)(o));if(!!M)return this._onDidEnterWorkspace.fire({window:r,workspace:M.workspace}),M}async isValidTargetWorkspacePath(r,c,o){if(!o)return!0;if((0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,o))return!1;if((0,h.findWindowOnWorkspaceOrFolder)(c,o)){const g={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(0,null))],message:(0,E.localize)(1,null,(0,w.basename)(o)),detail:(0,E.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(g,(0,v.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(r,c){if(!r.config)return;r.focus();let o;return r.config.extensionDevelopmentPath||(r.config.backupPath?o=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority},r.config.backupPath):o=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority})),(0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=c,r.config.backupPath=o,{workspace:c,backupPath:o}}};n=we([te(0,P.IEnvironmentMainService),te(1,p.ILogService),te(2,m.IUserDataProfilesMainService),te(3,d.IBackupMainService),te(4,f.IDialogMainService),te(5,S.IProductService)],n),e.WorkspacesManagementMainService=n}),define(ee[117],ie([0,1,13,41,23,5,33,28,52,12,6]),function(z,e,y,t,k,R,D,I,u,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let C=class{constructor(d,f,P){this.windowsMainService=d,this.workspacesManagementMainService=f,this.logService=P}async getRemoteDiagnostics(d){const f=this.windowsMainService.getWindows();return(await Promise.all(f.map(async b=>{const p=b.remoteAuthority;if(!p)return;const S=`vscode:getDiagnosticInfoResponse${b.id}`,m={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.getFolderURIs(b):void 0};return new Promise(h=>{b.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:S,args:m}),t.validatedIpcMain.once(S,(l,s)=>{s||h({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),h(s)}),setTimeout(()=>{h({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const d=[];for(const f of y.BrowserWindow.getAllWindows()){const P=this.windowsMainService.getWindowById(f.id);P?d.push(await this.codeWindowToInfo(P)):d.push(this.browserWindowToInfo(f))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!y.app.accessibilitySupportEnabled,gpuFeatureStatus:y.app.getGPUFeatureStatus()}}async codeWindowToInfo(d){const f=await this.getFolderURIs(d),P=(0,w.assertIsDefined)(d.win);return this.browserWindowToInfo(P,f,d.remoteAuthority)}browserWindowToInfo(d,f=[],P){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:f,remoteAuthority:P}}async getFolderURIs(d){const f=[],P=d.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(P))f.push(P.uri);else if((0,I.isWorkspaceIdentifier)(P)){const b=await this.workspacesManagementMainService.resolveLocalWorkspace(P.configPath);b&&b.folders.forEach(S=>{f.push(S.uri)})}return f}};C=we([te(0,D.IWindowsMainService),te(1,u.IWorkspacesManagementMainService),te(2,v.ILogService)],C),e.DiagnosticsMainService=C}),define(ee[65],ie([0,1,45,13,25,139,53,3,35,2,14,9,4,7,99,81,21,95,163,56,27,5,22,6,20,64,33,28,52,17,221,231,32]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a,n,i,r,c,o,g,M,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let G=class extends w.Disposable{constructor(Q,X,x,oe,fe,V,j,F,T,W){super(),this.sharedProcess=Q,this.windowsMainService=X,this.dialogMainService=x,this.lifecycleMainService=oe,this.environmentMainService=fe,this.logService=V,this.productService=j,this.themeMainService=F,this.workspacesManagementMainService=T,this.telemetryService=W,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,N=>N.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:N,x:J,y:B})=>({windowId:N.id,x:J,y:B})),({windowId:N})=>!!this.windowsMainService.getWindowById(N)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),N=>!!N),N=>N.id),I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(N,J)=>J.id),N=>!!this.windowsMainService.getWindowById(N))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(N,J,B)=>B),N=>!(Array.isArray(N)&&N.length===1&&N[0]==="workArea")),I.Event.fromNodeEventEmitter(t.screen,"display-added"),I.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100),this._profilingSessions=new Map}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(X=>({id:X.id,workspace:X.openedWorkspace??(0,c.toWorkspaceIdentifier)(X.backupPath,X.isExtensionDevelopmentHost),title:X.win?.getTitle()??"",filename:X.getRepresentedFilename(),dirty:X.isDocumentEdited()}))}async getWindowCount(Q){return this.windowsMainService.getWindowCount()}async getActiveWindowId(Q){const X=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(X)return X.id}openWindow(Q,X,x){return Array.isArray(X)?this.doOpenWindow(Q,X,x):this.doOpenEmptyWindow(Q,X)}async doOpenWindow(Q,X,x=Object.create(null)){X.length>0&&await this.windowsMainService.open({context:5,contextWindowId:Q,urisToOpen:X,cli:this.environmentMainService.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0})}async doOpenEmptyWindow(Q,X){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:Q},X)}async toggleFullScreen(Q){this.windowById(Q)?.toggleFullScreen()}async handleTitleDoubleClick(Q){this.windowById(Q)?.handleTitleDoubleClick()}async isMaximized(Q){const X=this.windowById(Q);return X?.win?X.win.isMaximized():!1}async maximizeWindow(Q){const X=this.windowById(Q);X?.win&&X.win.maximize()}async unmaximizeWindow(Q){const X=this.windowById(Q);X?.win&&X.win.unmaximize()}async minimizeWindow(Q){const X=this.windowById(Q);X?.win&&X.win.minimize()}async updateWindowControls(Q,X){const x=this.windowById(Q);x&&x.updateWindowControls(X)}async focusWindow(Q,X){X&&typeof X.windowId=="number"&&(Q=X.windowId),this.windowById(Q)?.focus({force:X?.force??!1})}async setMinimumSize(Q,X,x){const oe=this.windowById(Q);if(oe?.win){const[fe,V]=oe.win.getSize(),[j,F]=oe.win.getMinimumSize(),[T,W]=[X??j,x??F],[N,J]=[Math.max(fe,T),Math.max(V,W)];(j!==T||F!==W)&&oe.win.setMinimumSize(T,W),(fe!==N||V!==J)&&oe.win.setSize(N,J)}}async saveWindowSplash(Q,X){this.themeMainService.saveWindowSplash(Q,X)}async installShellCommand(Q){const{source:X,target:x}=await this.getShellCommandLink();try{const{symbolicLink:oe}=await b.SymlinkSupport.stat(X);if(oe&&!oe.dangling){const fe=await(0,f.realpath)(X);if(x===fe)return}await b.Promises.unlink(X)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await b.Promises.symlink(x,X)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:fe}=await this.showMessageBox(Q,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(fe===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${X}'\\" with administrator privileges"`;await(0,R.promisify)(y.exec)(V)}catch{throw new Error((0,S.localize)(3,null,X))}}}async uninstallShellCommand(Q){const{source:X}=await this.getShellCommandLink();try{await b.Promises.unlink(X)}catch(x){switch(x.code){case"EACCES":{const{response:oe}=await this.showMessageBox(Q,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const fe=`osascript -e "do shell script \\"rm '${X}'\\" with administrator privileges"`;await(0,R.promisify)(y.exec)(fe)}catch{throw new Error((0,S.localize)(7,null,X))}break}case"ENOENT":break;default:throw x}}}async getShellCommandLink(){const Q=(0,C.resolve)(this.environmentMainService.appRoot,"bin","code"),X=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(Q))throw new Error((0,S.localize)(8,null,Q));return{source:X,target:Q}}async showMessageBox(Q,X){return this.dialogMainService.showMessageBox(X,this.toBrowserWindow(Q))}async showSaveDialog(Q,X){return this.dialogMainService.showSaveDialog(X,this.toBrowserWindow(Q))}async showOpenDialog(Q,X){return this.dialogMainService.showOpenDialog(X,this.toBrowserWindow(Q))}toBrowserWindow(Q){const X=this.windowById(Q);if(X?.win)return X.win}async pickFileFolderAndOpen(Q,X){const x=await this.dialogMainService.pickFileFolder(X);x&&await this.doOpenPicked(await Promise.all(x.map(async oe=>await b.SymlinkSupport.existsDirectory(oe)?{folderUri:d.URI.file(oe)}:{fileUri:d.URI.file(oe)})),X,Q)}async pickFolderAndOpen(Q,X){const x=await this.dialogMainService.pickFolder(X);x&&await this.doOpenPicked(x.map(oe=>({folderUri:d.URI.file(oe)})),X,Q)}async pickFileAndOpen(Q,X){const x=await this.dialogMainService.pickFile(X);x&&await this.doOpenPicked(x.map(oe=>({fileUri:d.URI.file(oe)})),X,Q)}async pickWorkspaceAndOpen(Q,X){const x=await this.dialogMainService.pickWorkspace(X);x&&await this.doOpenPicked(x.map(oe=>({workspaceUri:d.URI.file(oe)})),X,Q)}async doOpenPicked(Q,X,x){await this.windowsMainService.open({context:3,contextWindowId:x,cli:this.environmentMainService.args,urisToOpen:Q,forceNewWindow:X.forceNewWindow})}async showItemInFolder(Q,X){t.shell.showItemInFolder(X)}async setRepresentedFilename(Q,X){this.windowById(Q)?.setRepresentedFilename(X)}async setDocumentEdited(Q,X){this.windowById(Q)?.setDocumentEdited(X)}async openExternal(Q,X){return E.isLinuxSnap?this.safeSnapOpenExternal(X):t.shell.openExternal(X),!0}safeSnapOpenExternal(Q){const X=process.env.GDK_PIXBUF_MODULE_FILE,x=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(Q),process.env.GDK_PIXBUF_MODULE_FILE=X,process.env.GDK_PIXBUF_MODULEDIR=x}moveItemToTrash(Q,X){return t.shell.trashItem(X)}async isAdmin(){let Q;return E.isWindows?Q=(await new Promise((X,x)=>{z(["native-is-elevated"],X,x)}))():Q=process.getuid()===0,Q}async writeElevated(Q,X,x,oe){const fe=await new Promise((V,j)=>{z(["@vscode/sudo-prompt"],V,j)});return new Promise((V,j)=>{const F=[`"${this.cliPath}"`];oe?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${X.fsPath}"`,`"${x.fsPath}"`);const T={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};fe.exec(F.join(" "),T,(W,N,J)=>{N&&this.logService.trace(`[sudo-prompt] received stdout: ${N}`),J&&this.logService.trace(`[sudo-prompt] received stderr: ${J}`),W?j(W):V(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,C.join)(this.environmentMainService.appRoot,"bin","code"):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return P.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return E.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(Q,X,x){process.kill(X,x)}async readClipboardText(Q,X){return t.clipboard.readText(X)}async writeClipboardText(Q,X,x){return t.clipboard.writeText(X,x)}async readClipboardFindText(Q){return t.clipboard.readFindText()}async writeClipboardFindText(Q,X){return t.clipboard.writeFindText(X)}async writeClipboardBuffer(Q,X,x,oe){return t.clipboard.writeBuffer(X,Buffer.from(x.buffer),oe)}async readClipboardBuffer(Q,X){return g.VSBuffer.wrap(t.clipboard.readBuffer(X))}async hasClipboard(Q,X,x){return t.clipboard.has(X,x)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(Q,X){this.windowById(Q)?.updateTouchBar(X)}async notifyReady(Q){this.windowById(Q)?.setReady()}async relaunch(Q,X){return this.lifecycleMainService.relaunch(X)}async reload(Q,X){const x=this.windowById(Q);if(x){if((0,c.isWorkspaceIdentifier)(x.openedWorkspace)){const oe=x.openedWorkspace.configPath;if(oe.scheme===v.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(oe))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(x,X?.disableExtensions!==void 0?{_:[],"disable-extensions":X.disableExtensions}:void 0)}}async closeWindow(Q){this.closeWindowById(Q,Q)}async closeWindowById(Q,X){const x=this.windowById(X);if(x?.win)return x.win.close()}async quit(Q){const X=this.windowsMainService.getLastActiveWindow();X?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&X.win?X.win.close():this.lifecycleMainService.quit()}async exit(Q,X){await this.lifecycleMainService.kill(X)}async resolveProxy(Q,X){const oe=this.windowById(Q)?.win?.webContents?.session;if(oe)return oe.resolveProxy(X)}findFreePort(Q,X,x,oe,fe=1){return(0,p.findFreePort)(X,x,oe,fe)}async openDevTools(Q,X){const x=this.windowById(Q);x?.win&&x.win.webContents.openDevTools(X)}async toggleDevTools(Q){const X=this.windowById(Q);X?.win&&X.win.webContents.toggleDevTools()}async sendInputEvent(Q,X){const x=this.windowById(Q);x?.win&&(X.type==="mouseDown"||X.type==="mouseUp")&&x.win.webContents.sendInputEvent(X)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async startHeartbeat(Q,X){const x=this.windowById(Q);if(!x||!x.win)return!1;if(!this._profilingSessions.has(x.id)){const oe=new A.WindowProfiler(x.win,X,this.logService,this.telemetryService);this._profilingSessions.set(x.id,oe),oe.start()}return!0}async sendHeartbeat(Q,X){const x=this.windowById(Q);return!x||!this._profilingSessions.has(x.id)||this._profilingSessions.get(x.id).receiveHeartbeat(),!1}async stopHeartbeat(Q,X){const x=this.windowById(Q);return!x||!this._profilingSessions.has(x.id)||(this._profilingSessions.get(x.id).stop(),this._profilingSessions.delete(x.id)),!1}async windowsGetStringRegKey(Q,X,x,oe){if(!E.isWindows)return;const fe=await new Promise((V,j)=>{z(["@vscode/windows-registry"],V,j)});try{return fe.GetStringRegKey(X,x,oe)}catch{return}}windowById(Q){if(typeof Q=="number")return this.windowsMainService.getWindowById(Q)}};we([D.memoize],G.prototype,"cliPath",null),G=we([te(1,r.IWindowsMainService),te(2,m.IDialogMainService),te(3,s.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,a.ILogService),te(6,n.IProductService),te(7,i.IThemeMainService),te(8,o.IWorkspacesManagementMainService),te(9,_.ITelemetryService)],G),e.NativeHostMainService=G}),define(ee[265],ie([0,1,13,41,25,35,2,14,4,100,161,84,117,56,27,5,6,65,54,20,61,74,31,12]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,P.createDecorator)("issueMainService");let n=class Nt{constructor(r,c,o,g,M,A,_,G,ae){this.userEnv=r,this.environmentMainService=c,this.logService=o,this.diagnosticsService=g,this.diagnosticsMainService=M,this.dialogMainService=A,this.nativeHostMainService=_,this.protocolMainService=G,this.productService=ae,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async r=>{const[c,o]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),g=await this.diagnosticsService.getSystemInfo(c,o);this.safeSend(r,"vscode:issueSystemInfoResponse",g)}),t.validatedIpcMain.on("vscode:listProcesses",async r=>{const c=[];try{c.push({name:(0,v.localize)(0,null),rootProcess:await(0,w.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(g=>{(0,C.isRemoteDiagnosticError)(g)?c.push({name:g.hostName,rootProcess:g}):g.processes&&c.push({name:g.hostName,rootProcess:g.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(r,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async r=>{const c={title:this.productService.nameLong,message:(0,v.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,v.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,v.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const o=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const c=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:(0,v.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,v.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(r,c)=>{const{id:o,from:g,args:M}=c;let A;switch(g){case"issueReporter":A=this.issueReporterParentWindow;break;case"processExplorer":A=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${g}`)}A?.webContents.send("vscode:runAction",{id:o,from:g,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(r,c)=>{this.nativeHostMainService.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async r=>{const c=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(r,"vscode:windowsInfoResponse",c.windows)})}safeSend(r,c,...o){r.sender.isDestroyed()||r.sender.send(c,...o)}async openReporter(r){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=y.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const c=new D.DisposableStore,o=c.add(this.protocolMainService.createIPCObjectUrl()),g=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(g,o,{backgroundColor:r.styles.backgroundColor,title:(0,v.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:S.default}),this.issueReporterWindow.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,c.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,c.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(r){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=y.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const c=new D.DisposableStore,o=c.add(this.protocolMainService.createIPCObjectUrl()),g=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(g,o,{backgroundColor:r.styles.backgroundColor,title:(0,v.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:S.default}),this.processExplorerWindow.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,c.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,c.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(r){r.isMinimized()&&r.restore(),r.focus()}createBrowserWindow(r,c,o,g){const M=new y.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:o.title,backgroundColor:o.backgroundColor||Nt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${g}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[r,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,c)}getWindowPosition(r,c,o){let g;const M=y.screen.getAllDisplays();if(M.length===1)g=M[0];else{if(u.isMacintosh){const G=y.screen.getCursorScreenPoint();g=y.screen.getDisplayNearestPoint(G)}!g&&r&&(g=y.screen.getDisplayMatching(r.getBounds())),g||(g=y.screen.getPrimaryDisplay()||M[0])}const A={width:c,height:o},_=g.bounds;return A.x=_.x+_.width/2-A.width/2,A.y=_.y+_.height/2-A.height/2,_.width>0&&_.height>0&&(A.x<_.x&&(A.x=_.x),A.y<_.y&&(A.y=_.y),A.x>_.x+_.width&&(A.x=_.x),A.y>_.y+_.height&&(A.y=_.y),A.width>_.width&&(A.width=_.width),A.height>_.height&&(A.height=_.height)),A}async getPerformanceInfo(){try{const[r,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,c)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const r=await y.contentTracing.stopRecording(`${(0,s.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,v.localize)(9,null),detail:(0,v.localize)(10,null,r),buttons:[(0,R.mnemonicButtonLabel)((0,v.localize)(11,null))],defaultId:0,noLink:!0},(0,a.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,r)}};n.DEFAULT_BACKGROUND_COLOR="#1E1E1E",n=we([te(1,f.IEnvironmentMainService),te(2,b.ILogService),te(3,C.IDiagnosticsService),te(4,E.IDiagnosticsMainService),te(5,d.IDialogMainService),te(6,p.INativeHostMainService),te(7,h.IProtocolMainService),te(8,m.IProductService)],n),e.IssueMainService=n}),define(ee[266],ie([0,1,23,19,27,22,6,65,20,55,32,48,88]),function(z,e,y,t,k,R,D,I,u,w,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends E.AbstractUpdateService{constructor(P,b,p,S,m,h,l,s){super(P,b,S,m,h,s),this.telemetryService=p,this.nativeHostMainService=l}buildUpdateFeedUrl(P){return(0,E.createUpdateURL)(`linux-${process.arch}`,P,this.productService)}doCheckForUpdates(P){!this.url||(this.setState(C.State.CheckingForUpdates(P)),this.requestService.request({url:this.url},y.CancellationToken.None).then(w.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P}),this.setState(C.State.Idle(1))):this.setState(C.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P});const p=P?b.message||b:void 0;this.setState(C.State.Idle(1,p))}))}async doDownloadUpdate(P){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):P.update.url&&this.nativeHostMainService.openExternal(void 0,P.update.url),this.setState(C.State.Idle(1))}};d=we([te(0,R.ILifecycleMainService),te(1,t.IConfigurationService),te(2,v.ITelemetryService),te(3,k.IEnvironmentMainService),te(4,w.IRequestService),te(5,D.ILogService),te(6,I.INativeHostMainService),te(7,u.IProductService)],d),e.LinuxUpdateService=d}),define(ee[267],ie([0,1,45,40,25,8,23,53,9,7,125,21,19,27,15,22,6,65,20,55,32,48,88]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(c,o=1e3){for(;!c();)await(0,R.timeout)(o)}let n;function i(){return typeof n>"u"&&(n=t.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?0:1),n}let r=class extends s.AbstractUpdateService{get cachePath(){const o=u.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return C.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,g,M,A,_,G,ae,Q,X){super(o,g,A,_,G,X),this.telemetryService=M,this.fileService=ae,this.nativeHostMainService=Q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(o){let g="win32";return process.arch!=="ia32"&&(g+=`-${process.arch}`),i()===1?g+="-archive":this.productService.target==="user"&&(g+="-user"),(0,s.createUpdateURL)(g,o,this.productService)}doCheckForUpdates(o){!this.url||(this.setState(l.State.CheckingForUpdates(o)),this.requestService.request({url:this.url},D.CancellationToken.None).then(m.asJson).then(g=>{const M=i();return!g||!g.url||!g.version||!g.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!o}),this.setState(l.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(l.State.AvailableForDownload(g)),Promise.resolve(null)):(this.setState(l.State.Downloading(g)),this.cleanup(g.version).then(()=>this.getUpdatePackagePath(g.version).then(A=>C.Promises.exists(A).then(_=>{if(_)return Promise.resolve(A);const G=g.url,ae=g.hash,Q=`${A}.tmp`;return this.requestService.request({url:G},D.CancellationToken.None).then(X=>this.fileService.writeFile(w.URI.file(Q),X.stream)).then(ae?()=>(0,v.checksum)(Q,g.hash):()=>{}).then(()=>C.Promises.rename(Q,A)).then(()=>A)})).then(A=>{const _=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},_&&g.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(g)):this.setState(l.State.Ready(g))})))}).then(void 0,g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!o});const M=o?g.message||g:void 0;this.setState(l.State.Idle(i(),M))}))}async doDownloadUpdate(o){o.update.url&&this.nativeHostMainService.openExternal(void 0,o.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(o){const g=await this.cachePath;return u.join(g,`CodeSetup-${this.productService.quality}-${o}.exe`)}async cleanup(o=null){const g=o?G=>!new RegExp(`${this.productService.quality}-${o}\\.exe$`).test(G):()=>!0,M=await this.cachePath,_=(await C.Promises.readdir(M)).filter(g).map(async G=>{try{await C.Promises.unlink(u.join(M,G))}catch{}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const o=this.state.update;this.setState(l.State.Updating(o));const g=await this.cachePath;this.availableUpdate.updateFilePath=u.join(g,`CodeSetup-${this.productService.quality}-${o.version}.flag`),await C.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,y.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const A=`${this.productService.win32MutexName}-ready`,_=await new Promise((G,ae)=>{z(["windows-mutex"],G,ae)});a(()=>_.isActive(A)).then(()=>this.setState(l.State.Ready(o)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,y.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const g=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!g};this.setState(l.State.Downloading(M)),this.availableUpdate={packagePath:o},g?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(M)):this.setState(l.State.Ready(M))}};we([I.memoize],r.prototype,"cachePath",null),r=we([te(0,P.ILifecycleMainService),te(1,E.IConfigurationService),te(2,h.ITelemetryService),te(3,d.IEnvironmentMainService),te(4,m.IRequestService),te(5,b.ILogService),te(6,f.IFileService),te(7,p.INativeHostMainService),te(8,S.IProductService)],r),e.Win32UpdateService=r}),define(ee[268],ie([0,1,13,8,23,44,3,35,2,14,9,71,4,7,169,60,19,56,27,59,15,22,6,20,61,233,91,32,236,64,74,33,28,52,115,119,37,38,54,42]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a,n,i,r,c,o,g,M,A,_,G,ae,Q,X,x,oe,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(V||(V={}));let j=class Wt extends u.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(T=>T.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(T,W,N,J,B,$,L,O,U,q,Y,se,H,re,ne,ce,ge,Re,Te){super(),this.logService=W,this.environmentMainService=N,this.policyService=J,this.userDataProfilesService=B,this.fileService=$,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=U,this.themeMainService=q,this.workspacesManagementMainService=Y,this.backupMainService=se,this.telemetryService=H,this.dialogMainService=re,this.lifecycleMainService=ne,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=Re,this.stateMainService=Te,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Ae]=this.restoreWindowState(T.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const ve=this.windowState.mode===0||this.windowState.mode===3,pe=this.configurationService.getValue("window");let Se=!1;typeof pe?.experimental?.useSandbox=="boolean"?Se=pe.experimental.useSandbox:Se=typeof oe.default.quality=="string"&&oe.default.quality!=="stable";const ke={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!ve,title:this.productService.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(pe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...Se?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};E.isLinux?ke.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):E.isWindows&&!this.environmentMainService.isBuilt&&(ke.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),E.isMacintosh&&!this.useNativeFullScreen()&&(ke.fullscreenable=!1),E.isMacintosh&&(ke.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(ke.acceptFirstMouse=!1));const Z=E.isMacintosh&&pe?.nativeTabs===!0;Z&&(ke.tabbingIdentifier=this.productService.nameShort);const ue=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ke.titleBarStyle="hidden",E.isMacintosh||(ke.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService))){const de=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=Q.Color.fromHex(de).isDarker()?"#FFFFFF":"#000000";ke.titleBarOverlay={height:29,color:de,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,C.mark)("code/willCreateCodeBrowserWindow"),this._win=new y.BrowserWindow(ke),(0,C.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,E.isMacintosh&&ue&&this._win.setSheetOffset(22),ue&&(E.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService)||E.isMacintosh)){const de=this.stateMainService.getItem(Wt.windowControlHeightStateStorageKey);de&&this.updateWindowControls({height:de})}E.isWindows&&ue&&this._win.hookWindowMessage(278,()=>{const[ye,Ce]=this._win.getPosition(),Fe=y.screen.getCursorScreenPoint(),Oe=Fe.x-ye,$e=Fe.y-Ce;return(()=>!(Oe>30&&$e>=0&&$e<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:$e})),0}),(E.isMacintosh||E.isWindows)&&Ae&&(!Z||y.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ve&&((0,C.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,C.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(T){E.isMacintosh?this._win.setRepresentedFilename(T):this.representedFilename=T}getRepresentedFilename(){return E.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(T){E.isMacintosh&&this._win.setDocumentEdited(T),this.documentEdited=T}isDocumentEdited(){return E.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(T){E.isMacintosh&&T?.force&&y.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.whenReadyCallbacks.push(T)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(T=>{function W(){N.dispose(),J.dispose(),T()}const N=this.onDidClose(()=>W()),J=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(W,N,J)=>this.onWindowError(3,{reason:J,exitCode:N})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),y.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),y.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async(W,N)=>{const J=await this.getMarketplaceHeaders();N({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,J)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(T,W){switch(T){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:T,reason:W?.reason,code:W?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,f.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,f.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,f.localize)(2,null))],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,f.localize)(5,null):void 0},this._win);if(N.response!==1){const J=N.response===0;await this.destroyWindow(J,N.checkboxChecked)}}else if(T===2){let N;W?N=(0,f.localize)(7,null,W.reason,W.exitCode??"<unknown>"):N=(0,f.localize)(6,null);const J=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,f.localize)(8,null)),(0,I.mnemonicButtonLabel)((0,f.localize)(9,null))],message:N,detail:(0,f.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,f.localize)(11,null):void 0},this._win),B=J.response===0;await this.destroyWindow(B,J.checkboxChecked)}break}}async destroyWindow(T,W){const N=this._config?.workspace;if(W&&N)try{const J=this.storageMainService.workspaceStorage(N);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.logService.error(J)}if(this._onDidDestroy.fire(),this._win?.destroy(),T&&this._config){let J,B;(0,_.isSingleFolderWorkspaceIdentifier)(N)?J={folderUri:N.uri}:(0,_.isWorkspaceIdentifier)(N)?J={workspaceUri:N.configPath}:B=!0;const[$]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(T){this._config?.workspace?.id===T.id&&(this._config.workspace=void 0)}onConfigurationUpdated(T){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const J=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||J!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=J;const B=N||"",$=J?`${J},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(T){E.isMacintosh&&T.win&&this._win.addTabbedWindow(T.win)}load(T,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(T,W),this.readyState===0?this._config=T:this.pendingLoadConfig=T,this.readyState=1,this._win.loadURL(w.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const N=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:T.workspace,reason:W.isReload?3:N?2:1})}updateConfiguration(T,W){const N=(this._config??this.pendingLoadConfig)?.userEnv;if(N){const J=(0,m.isLaunchedFromCli)(N)&&!(0,m.isLaunchedFromCli)(T.userEnv),B=this.isExtensionDevelopmentHost;(J||B)&&(T.userEnv={...N,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(T["disable-extensions"]=W.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this._win.isMaximized(),T.partsSplash=this.themeMainService.getWindowSplash(),(0,C.mark)("code/willOpenNewWindow"),T.perfMarks=(0,C.getMarks)(),this.configObjectUrl.update(T)}async reload(T){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&T&&(W.verbose=T.verbose,W.debugId=T.debugId,W.extensionEnvironment=T.extensionEnvironment,W["inspect-extensions"]=T["inspect-extensions"],W["inspect-brk-extensions"]=T["inspect-brk-extensions"],W["extensions-dir"]=T["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.continueOn=this.environmentMainService.continueOn,W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async validateWorkspaceBeforeReload(T){if((0,_.isWorkspaceIdentifier)(T.workspace)){const W=T.workspace.configPath;if(W.scheme===w.Schemas.file&&!await this.fileService.exists(W))return}else if((0,_.isSingleFolderWorkspaceIdentifier)(T.workspace)){const W=T.workspace.uri;if(W.scheme===w.Schemas.file&&!await this.fileService.exists(W))return}return T.workspace}serializeWindowState(){if(!this._win)return(0,ae.defaultWindowState)();if(this.isFullScreen){let N;try{N=y.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,ae.defaultWindowState)();return{mode:3,display:N?N.id:void 0,width:this.windowState.width||J.width,height:this.windowState.height||J.height,x:this.windowState.x||0,y:this.windowState.y||0}}const T=Object.create(null);let W;if(!E.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?T.mode=0:T.mode=1,W===1||W===0){let N;W===1?N=this.getBounds():N=this._win.getNormalBounds(),T.x=N.x,T.y=N.y,T.width=N.width,T.height=N.height}return T}updateWindowControls(T){T.height&&this.stateMainService.setItem(Wt.windowControlHeightStateStorageKey,T.height),E.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0}):E.isMacintosh&&T.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(T.height-15)/2})}restoreWindowState(T){(0,C.mark)("code/willRestoreCodeWindowState");let W=!1;if(T)try{const N=y.screen.getAllDisplays();W=N.length>1,T=this.validateWindowState(T,N)}catch(N){this.logService.warn(`Unexpected error validating window state: ${N}
${N.stack}`)}return(0,C.mark)("code/didRestoreCodeWindowState"),[T||(0,ae.defaultWindowState)(),W]}validateWindowState(T,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,T),typeof T.x!="number"||typeof T.y!="number"||typeof T.width!="number"||typeof T.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(T.width<=0||T.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let $=function(){!T||typeof T.x!="number"||typeof T.y!="number"||!B||(T.x<B.x&&(T.x=B.x),T.y<B.y&&(T.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),T.width>B.width&&(T.width=B.width),T.height>B.height&&(T.height=B.height),T.x>B.x+B.width-128&&(T.x=B.x+B.width-T.width),T.y>B.y+B.height-128&&(T.y=B.y+B.height-T.height),$()}return T}if(T.display&&T.mode===3){const B=W.find($=>$.id===T.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,ae.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let N,J;try{N=y.screen.getDisplayMatching({x:T.x,y:T.y,width:T.width,height:T.height}),J=this.getWorkingArea(N)}catch{}if(N&&J&&T.x+T.width>J.x&&T.y+T.height>J.y&&T.x<J.x+J.width&&T.y<J.y+J.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",J),T}getWorkingArea(T){if(T.workArea.width>0&&T.workArea.height>0)return T.workArea;if(T.bounds.width>0&&T.bounds.height>0)return T.bounds}getBounds(){const[T,W]=this._win.getPosition(),[N,J]=this._win.getSize();return{x:T,y:W,width:N,height:J}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(T){this.useNativeFullScreen()?this.setNativeFullScreen(T):this.setSimpleFullScreen(T),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return E.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(T){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(T)}doSetNativeFullScreen(T){E.isMacintosh&&(this.transientIsNativeFullScreen=T,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(T)}setSimpleFullScreen(T){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(T),this._win.webContents.focus()}useNativeFullScreen(){const T=this.configurationService.getValue("window");return!T||typeof T.nativeFullScreen!="boolean"||T.nativeTabs?!0:T.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let T=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}setMenuBarVisibility(T,W=!0){E.isMacintosh||(T==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,f.localize)(12,null)),T==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(T)}):this.doSetMenuBarVisibility(T))}doSetMenuBarVisibility(T){const W=this.isFullScreen;switch(T){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(E.isMacintosh)switch(y.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(T,W,...N){this.isReady?this.send(T,...N):this.ready().then(()=>{W.isCancellationRequested||this.send(T,...N)})}send(T,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this._win.webContents.send(T,...W)}catch(N){this.logService.warn(`Error sending IPC message to channel '${T}' of window ${this._id}: ${(0,R.toErrorMessage)(N)}`)}}}updateTouchBar(T){!E.isMacintosh||this.touchBarGroups.forEach((W,N)=>{const J=T[N];W.segments=this.createTouchBarGroupSegments(J)})}createTouchBar(){if(!!E.isMacintosh){for(let T=0;T<10;T++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new y.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(T=[]){const W=this.createTouchBarGroupSegments(T),N=new y.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:N.segments[J].id,from:"touchbar"})}});return N}createTouchBarGroupSegments(T=[]){return T.map(N=>{let J;N.icon&&!o.ThemeIcon.isThemeIcon(N.icon)&&N.icon?.dark?.scheme===w.Schemas.file&&(J=y.nativeImage.createFromPath(d.URI.revive(N.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let B;return typeof N.title=="string"?B=N.title:B=N.title.value,{id:N.id,label:J?void 0:B,icon:J}})}dispose(){super.dispose(),this._win=null}};j.windowControlHeightStateStorageKey="windowControlHeight",j=we([te(1,s.ILogService),te(2,S.IEnvironmentMainService),te(3,X.IPolicyService),te(4,fe.IUserDataProfilesMainService),te(5,h.IFileService),te(6,r.IApplicationStorageMainService),te(7,r.IStorageMainService),te(8,b.IConfigurationService),te(9,g.IThemeMainService),te(10,G.IWorkspacesManagementMainService),te(11,P.IBackupMainService),te(12,c.ITelemetryService),te(13,p.IDialogMainService),te(14,l.ILifecycleMainService),te(15,a.IProductService),te(16,n.IProtocolMainService),te(17,A.IWindowsMainService),te(18,x.IStateMainService)],j),e.CodeWindow=j}),define(ee[75],ie([0,1,13,24,8,3,35,2,14,4,18,7,21,172,5,22,6,91,92,28,52,29]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,f.createDecorator)("workspacesHistoryMainService");let s=class rt extends I.Disposable{constructor(n,i,r,c){super(),this.logService=n,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.applicationStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let i=[],r=[];for(const o of n)if((0,S.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&!this.containsWorkspace(i,o.workspace)&&i.push(o);else if((0,S.isRecentFolder)(o))this.containsFolder(i,o.folderUri)||i.push(o);else{const g=this.containsFile(r,o.fileUri),M=o.fileUri.scheme===u.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,v.basename)(o.fileUri))>=0;!g&&!M&&(r.push(o),w.isWindows&&o.fileUri.scheme===u.Schemas.file&&y.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.mergeEntriesFromStorage({workspaces:i,files:r});i=c.workspaces,r=c.files,i.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=rt.MAX_TOTAL_RECENT_ENTRIES),r.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:r}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const i=g=>{const M=this.location(g);for(const A of n)if(v.extUriBiasedIgnorePathCase.isEqual(A,M))return!1;return!0},r=await this.getRecentlyOpened(),c=r.workspaces.filter(i),o=r.files.filter(i);(c.length!==r.workspaces.length||o.length!==r.files.length)&&(await this.saveRecentlyOpened({files:o,workspaces:c}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(n){const i=new l.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o));if(n?.workspaces)for(const o of n.workspaces)i.set(this.location(o),o);const r=new l.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o));if(n?.files)for(const o of n.files)r.set(this.location(o),o);const c=await this.getRecentlyOpenedFromStorage();for(const o of c.workspaces){const g=i.get(this.location(o));g?g.label=g.label??o.label:i.set(this.location(o),o)}for(const o of c.files){const g=r.get(this.location(o));g?g.label=g.label??o.label:r.set(this.location(o),o)}return{workspaces:[...i.values()],files:[...r.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const i=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{n=JSON.parse(i)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}return(0,S.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,S.toStoreData)(n)),-1,1)}location(n){return(0,S.isRecentFolder)(n)?n.folderUri:(0,S.isRecentFile)(n)?n.fileUri:n.workspace.configPath}containsWorkspace(n,i){return!!n.find(r=>(0,S.isRecentWorkspace)(r)&&r.workspace.id===i.id)}containsFolder(n,i){return!!n.find(r=>(0,S.isRecentFolder)(r)&&v.extUriBiasedIgnorePathCase.isEqual(r.folderUri,i))}containsFile(n,i){return!!n.find(r=>v.extUriBiasedIgnorePathCase.isEqual(r.fileUri,i))}async handleWindowsJumpList(){!w.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!w.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const o of y.app.getJumpListSettings().removedItems){const g=o.args;if(g){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(g);M&&i.push(C.URI.parse(M[2]))}}await this.removeRecentlyOpened(i);let r=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const g=(0,S.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:M,description:A}=this.getWindowsJumpListLabel(g,o.label);let _;return C.URI.isUri(g)?_=`--folder-uri "${g.toString()}"`:(r=!0,_=`--file-uri "${g.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:A.substr(0,255),program:process.execPath,args:_,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:r?(0,d.localize)(2,null):(0,d.localize)(3,null),items:c})}n.push({type:"recent"});try{const i=y.app.setJumpList(n);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(n,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(C.URI.isUri(n))return{title:(0,v.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,d.localize)(4,null),description:""};let r=(0,v.basename)(n.configPath);return r.endsWith(m.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-m.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,r),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,D.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;y.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),i=[];let r=0;for(let o=0;o<n.workspaces.length&&r<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const g=this.location(n.workspaces[o]);if(g.scheme===u.Schemas.file){const M=(0,v.originalFSPath)(g);await E.Promises.exists(M)&&(i.push(M),r++)}}const c=[];for(let o=0;o<n.files.length&&r<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const g=this.location(n.files[o]);if(g.scheme===u.Schemas.file){const M=(0,v.originalFSPath)(g);if(rt.COMMON_FILES_FILTER.includes((0,v.basename)(g))||i.includes(M))continue;await E.Promises.exists(M)&&(c.push(M),r++)}}c.reverse().forEach(o=>y.app.addRecentDocument(o)),i.reverse().forEach(o=>y.app.addRecentDocument(o))}};s.MAX_TOTAL_RECENT_ENTRIES=500,s.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",s.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,s.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,s.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,s.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],s=we([te(0,b.ILogService),te(1,h.IWorkspacesManagementMainService),te(2,P.ILifecycleMainService),te(3,p.IApplicationStorageMainService)],s),e.WorkspacesHistoryMainService=s}),define(ee[269],ie([0,1,13,8,23,35,4,7,162,19,27,22,6,209,65,20,38,32,48,74,33,75]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let a=class Ft{constructor(r,c,o,g,M,A,_,G,ae,Q,X){this.updateService=r,this.configurationService=c,this.windowsMainService=o,this.environmentMainService=g,this.telemetryService=M,this.workspacesHistoryMainService=A,this.stateMainService=_,this.lifecycleMainService=G,this.logService=ae,this.nativeHostMainService=Q,this.productService=X,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,m.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(Ft.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,_,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,_,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,_,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(A,_,G)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,_,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const o=this.productService.reportIssueUrl;o&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(o,"openReportIssues"));const g=this.productService.licenseUrl;g&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const A=g.indexOf("?")>0?"&":"?";this.openUrl(`${g}${A}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(g,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&g&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,c){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(Ft.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!D.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=y.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(D.isMacintosh?new y.Menu:null);return}const c=new y.Menu;let o;if(D.isMacintosh){const M=new y.Menu;o=new y.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),c.append(o)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new y.Menu;M.append(new y.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:M});this.setMenuById(M,"File"),c.append(A)}if(this.shouldDrawMenu("Edit")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),c.append(A)}if(this.shouldDrawMenu("Selection")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),c.append(A)}if(this.shouldDrawMenu("View")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:M});this.setMenuById(M,"View"),c.append(A)}if(this.shouldDrawMenu("Go")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),c.append(A)}if(this.shouldDrawMenu("Run")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),c.append(A)}if(this.shouldDrawMenu("Terminal")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),c.append(A)}let g;if(this.shouldDrawMenu("Window")){const M=new y.Menu;g=new y.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(g&&c.append(g),this.shouldDrawMenu("Help")){const M=new y.Menu,A=new y.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),c.append(A)}c.items&&c.items.length>0?y.Menu.setApplicationMenu(c):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const c=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),o=this.getUpdateMenuItems();let g;if(this.shouldDrawMenu("Preferences")){const x=new y.Menu;this.setMenuById(x,"Preferences"),g=new y.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:x})}const M=new y.Menu,A=new y.MenuItem({label:u.localize(12,null),role:"services",submenu:M}),_=new y.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new y.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new y.MenuItem({label:u.localize(15,null),role:"unhide"}),Q=new y.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(x,oe,fe)=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&await this.confirmBeforeQuit(fe)&&this.nativeHostMainService.quit(void 0)}})),X=[c];X.push(...o),g&&X.push(n(),g),X.push(n(),A,n(),_,G,ae,n(),Q),X.forEach(x=>r.append(x))}async confirmBeforeQuit(r){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(r)){const o={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(u.localize(17,null)),(0,R.mnemonicButtonLabel)(u.localize(18,null))],message:u.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:g}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,o);return g===0}return!0}shouldDrawMenu(r){if(!D.isMacintosh&&(0,m.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,c){c.forEach(o=>{if((0,d.isMenubarMenuItemSeparator)(o))r.append(n());else if((0,d.isMenubarMenuItemSubmenu)(o)){const g=new y.Menu,M=new y.MenuItem({label:this.mnemonicLabel(o.label),submenu:g});this.setMenu(g,o.submenu.items),r.append(M)}else(0,d.isMenubarMenuItemRecentAction)(o)?r.append(this.createOpenRecentMenuItem(o)):(0,d.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[o.id]?r.append(new y.MenuItem(this.likeAction(o.id,{label:this.mnemonicLabel(o.label),click:this.fallbackMenuHandlers[o.id]}))):r.append(this.createMenuItem(o.label,o.id,!1,o.checked)):r.append(this.createMenuItem(o.label,o.id,o.enabled!==!1,!!o.checked)):r.append(this.createMenuItem(o.label,o.id,o.enabled!==!1,!!o.checked)))})}setMenuById(r,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(r,this.menubarMenus[c].items)}insertCheckForUpdatesItems(r){const c=this.getUpdateMenuItems();c.length&&(c.forEach(o=>r.append(o)),r.append(n()))}createOpenRecentMenuItem(r){const c=I.URI.revive(r.uri),o=r.id,g=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new y.MenuItem(this.likeAction(o,{label:r.label,click:async(M,A,_)=>{const G=this.isOptionClick(_);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[g],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(r){return!!(r&&(!D.isMacintosh&&(r.ctrlKey||r.shiftKey)||D.isMacintosh&&(r.metaKey||r.altKey)))}isKeyboardEvent(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}createRoleMenuItem(r,c,o){const g={label:this.mnemonicLabel(r),role:o,enabled:!0};return new y.MenuItem(this.withKeybinding(c,g))}setMacWindowMenu(r){const c=new y.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),o=new y.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),g=new y.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(n()),A.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,n(),M,...A,n(),g].forEach(_=>r.append(_))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new y.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,c,o,g){const M=this.mnemonicLabel(r),A=typeof c=="function"?c:(X,x,oe)=>{const fe=X?X.userSettingsLabel:null;let V=c;Array.isArray(c)&&(V=this.isOptionClick(oe)?c[1]:c[0]),fe&&oe.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:fe}):this.runActionInRenderer({type:"commandId",commandId:V})},_=typeof o=="boolean"?o:this.windowsMainService.getWindowCount()>0,G=typeof g=="boolean"?g:!1,ae={label:M,click:A,enabled:_};G&&(ae.type="checkbox",ae.checked=G);let Q;return typeof c=="string"?Q=c:Array.isArray(c)&&(Q=c[0]),D.isMacintosh&&(Q==="editor.action.clipboardCutAction"?ae.role="cut":Q==="editor.action.clipboardCopyAction"?ae.role="copy":Q==="editor.action.clipboardPasteAction"&&(ae.role="paste"),Q==="undo"?ae.click=this.makeContextAwareClickHandler(A,{inDevTools:X=>X.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):Q==="redo"?ae.click=this.makeContextAwareClickHandler(A,{inDevTools:X=>X.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):Q==="editor.action.selectAll"&&(ae.click=this.makeContextAwareClickHandler(A,{inDevTools:X=>X.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(Q,ae))}makeContextAwareClickHandler(r,c){return(o,g,M)=>{const A=y.BrowserWindow.getFocusedWindow();if(!A)return c.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return c.inDevTools(A.webContents.devToolsWebContents);r(o,g||A,M)}}runActionInRenderer(r){let c=y.BrowserWindow.getFocusedWindow();if(!c){const g=this.windowsMainService.getLastActiveWindow();g?.isMinimized()&&(c=g.win)}const o=c?this.windowsMainService.getWindowById(c.id):void 0;if(o){if(this.logService.trace("menubar#runActionInRenderer",r),D.isMacintosh&&!this.environmentMainService.isBuilt&&!o.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const g={id:r.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",k.CancellationToken.None,g)}else{const g={userSettingsLabel:r.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,g)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,c){const o=typeof r=="string"?this.keybindings[r]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const g=c.label.indexOf("[");g>=0?c.label=`${c.label.substr(0,g)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}likeAction(r,c,o=!c.accelerator){o&&(c=this.withKeybinding(r,c));const g=c.click;return c.click=(M,A,_)=>{this.reportMenuActionTelemetry(r),g?.(M,A,_)},c}openUrl(r,c){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:s})}mnemonicLabel(r){return(0,R.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=we([te(0,S.IUpdateService),te(1,w.IConfigurationService),te(2,h.IWindowsMainService),te(3,v.IEnvironmentMainService),te(4,p.ITelemetryService),te(5,l.IWorkspacesHistoryMainService),te(6,b.IStateMainService),te(7,C.ILifecycleMainService),te(8,E.ILogService),te(9,f.INativeHostMainService),te(10,P.IProductService)],a),e.Menubar=a;function n(){return new y.MenuItem({type:"separator"})}}),define(ee[270],ie([0,1,5,22,6,269]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,y.createDecorator)("menubarMainService");let D=class{constructor(u,w,v){this.instantiationService=u,this.lifecycleMainService=w,this.logService=v,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(u,w){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(w,u)}};D=we([te(0,y.IInstantiationService),te(1,t.ILifecycleMainService),te(2,k.ILogService)],D),e.MenubarMainService=D}),define(ee[271],ie([0,1,13,21,25,24,23,3,31,49,35,2,14,9,71,4,34,18,12,7,170,60,19,56,27,15,5,22,6,54,20,61,63,38,74,268,116,263,28,93,75,52,64,37,42]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a,n,i,r,c,o,g,M,A,_,G,ae,Q,X,x,oe,fe,V,j,F,T,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N($){return(0,oe.isWorkspaceIdentifier)($?.workspace)}function J($){return(0,oe.isSingleFolderWorkspaceIdentifier)($?.workspace)}let B=class ft extends C.Disposable{constructor(L,O,U,q,Y,se,H,re,ne,ce,ge,Re,Te,Me,Ae,ve,pe,Se){super(),this.machineId=L,this.initialUserEnv=O,this.logService=U,this.stateMainService=q,this.policyService=Y,this.environmentMainService=se,this.userDataProfilesMainService=H,this.lifecycleMainService=re,this.backupMainService=ne,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=Re,this.instantiationService=Te,this.dialogMainService=Me,this.fileService=Ae,this.productService=ve,this.protocolMainService=pe,this.themeMainService=Se,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new I.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new x.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new C.DisposableStore;if(O.add(I.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const U of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(U));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const U=this.environmentMainService.args,q=O?.remoteAuthority||void 0,Y=!0,se=O?.forceReuseWindow,H=!se;return this.open({...L,cli:U,forceEmpty:Y,forceNewWindow:H,forceReuseWindow:se,remoteAuthority:q})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],U=[],q=[],Y=[],se=[];let H,re=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const Me of ne)J(Me)?L.addMode?O.push(Me):U.push(Me):N(Me)?q.push(Me):Me.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),H.filesToOpenOrCreate.push(Me)):Me.backupPath?se.push({backupFolder:(0,d.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):re++;L.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),L.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&L.waitMarkerFileURI&&(H.filesToWait={paths:(0,R.coalesce)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),q.push(...Y),se.push(...this.backupMainService.getEmptyWindowBackups())):se.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,q,U,se,re,H,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${U.length}, emptyToRestore: ${se.length}, emptyToOpen: ${re})`),ce.length>1)if(ge)ge.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,ve=!0;if(Me){const pe=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Ae=!1,ve=!1)}if(Ae)for(let pe=ce.length-1;pe>=0;pe--){const Se=ce[pe];if(!(Se.openedWorkspace&&Y.some(ke=>Se.openedWorkspace&&ke.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&se.some(ke=>Se.backupPath&&ke.backupFolder===(0,d.basename)(Se.backupPath)))){Se.focus(),ve=!1;break}}ve&&ce[ce.length-1].focus()}const Re=H&&H.filesToDiff.length>0,Te=H&&H.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!Re&&!Te&&!L.noRecentEntry){const Me=[];for(const Ae of ne)N(Ae)&&!Ae.transient?Me.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):J(Ae)?Me.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Me.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const U=L.waitMarkerFileURI;L.context===0&&U&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(U)}catch{}})()}async doOpen(L,O,U,q,Y,se,H){const re=[];let ne;function ce(pe,Se){re.push(pe),Se&&(ne=pe,se=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Re}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&H.length>0){const pe=H[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(pe);Se&&ce(this.doAddFoldersToExistingWindow(Se,H.map(ke=>ke.workspace.uri)))}const Te=U.length+O.length+q.length;if(se&&Te===0){const pe=se.filesToOpenOrCreate[0]||se.filesToDiff[0]||se.filesToMerge[3],Se=this.getWindows().filter(Z=>se&&(0,p.isEqualAuthority)(Z.remoteAuthority,se.remoteAuthority));let ke;pe?.fileUri&&!Re&&((L.context===4||L.context===0||L.context===1)&&(ke=await(0,X.findWindowOnFile)(Se,pe.fileUri,async Z=>Z.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(Z.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(Se))),ke?(0,oe.isWorkspaceIdentifier)(ke.openedWorkspace)?O.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?U.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,ke,se),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:se,forceNewWindow:!0,remoteAuthority:se.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const Me=(0,R.distinct)(O,pe=>pe.workspace.id);if(Me.length>0){const pe=(0,R.coalesce)(Me.map(Se=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(pe.length>0){const Se=pe[0],ke=(0,p.isEqualAuthority)(se?.remoteAuthority,Se.remoteAuthority)?se:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Me){if(pe.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===Se.workspace.id))continue;const ke=Se.remoteAuthority,Z=(0,p.isEqualAuthority)(se?.remoteAuthority,ke)?se:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,Z),!!Z),ge=!0}}const Ae=(0,R.distinct)(U,pe=>p.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Ae.length>0){const pe=(0,R.coalesce)(Ae.map(Se=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(pe.length>0){const Se=pe[0],ke=(0,p.isEqualAuthority)(se?.remoteAuthority,Se.remoteAuthority)?se:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Ae){if(pe.some(ue=>(0,oe.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,Se.workspace.uri)))continue;const ke=Se.remoteAuthority,Z=(0,p.isEqualAuthority)(se?.remoteAuthority,ke)?se:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,Z),!!Z),ge=!0}}const ve=(0,R.distinct)(q,pe=>pe.backupFolder);if(ve.length>0)for(const pe of ve){const Se=pe.remoteAuthority,ke=(0,p.isEqualAuthority)(se?.remoteAuthority,Se)?se:void 0;ce(this.doOpenEmpty(L,!0,Se,ke,pe),!!ke),ge=!0}if(re.length===0||se){se&&!Y&&Y++;const pe=se?se.remoteAuthority:L.remoteAuthority;for(let Se=0;Se<Y;Se++)ce(this.doOpenEmpty(L,ge,pe,se),!!se),ge=!0}return{windows:(0,R.distinct)(re),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,U){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),O.focus();const q={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,q),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const U={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,U),L}doOpenEmpty(L,O,U,q,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:U,filesToOpen:q,forceNewWindow:O});let se;return!O&&typeof L.contextWindowId=="number"&&(se=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:U,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:se,emptyWindowBackupInfo:Y,profile:L.profile})}doOpenFolderOrWorkspace(L,O,U,q,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:q}),!U&&!Y&&typeof L.contextWindowId=="number"&&(Y=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:Y,profile:L.profile})}async getPathsToOpen(L){let O,U=!1,q=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),U=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),U=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),q=!0),!L.addMode&&U){const Y=O.filter(se=>J(se));if(Y.length>1){const se=Y[0].remoteAuthority;if(Y.every(H=>(0,p.isEqualAuthority)(H.remoteAuthority,se))){const H=await this.workspacesManagementMainService.createUntitledWorkspace(Y.map(re=>({uri:re.workspace.uri})));O.push({workspace:H,remoteAuthority:se}),O=O.filter(re=>!J(re))}}}if(L.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Y=await this.doGetPathsFromLastSession();O.unshift(...Y.filter(se=>N(se)||J(se)||se.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},U=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async q=>{const Y=await this.resolveOpenable(q,O);if(Y)return Y.label=q.label,Y;const se=this.resourceFromOpenable(q),H={title:this.productService.nameLong,type:"info",buttons:[(0,v.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:se.scheme===E.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:se.scheme===E.Schemas.file?(0,h.localize)(3,null,(0,v.getPathLabel)(se,{os:P.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,se.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(H,(0,S.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(U)}async doExtractPathsFromCLI(L){const O=[],U={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},q=L["folder-uri"];if(q){const H=await Promise.all(q.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable({folderUri:ne},U)}));O.push(...(0,R.coalesce)(H))}const Y=L["file-uri"];if(Y){const H=await Promise.all(Y.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable((0,oe.hasWorkspaceFileExtension)(re)?{workspaceUri:ne}:{fileUri:ne},U)}));O.push(...(0,R.coalesce)(H))}const se=await Promise.all(L._.map(H=>U.remoteAuthority?this.doResolveRemotePath(H,U):this.doResolveFilePath(H,U)));return O.push(...(0,R.coalesce)(se)),O}cliArgToUri(L){try{const O=m.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const U=await Promise.all(O.map(async q=>{if(q.workspace){const Y=await this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(N(Y))return Y}else if(q.folderUri){const Y=await this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(J(Y))return Y}else if(L!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,R.coalesce)(U)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const U=this.resourceFromOpenable(L);return U.scheme===E.Schemas.file?((0,ae.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(U.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let U=this.resourceFromOpenable(L);const q=(0,_.getRemoteAuthority)(U)||O.remoteAuthority;if(U=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(U)),(0,ae.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Y,line:se,column:H}=(0,u.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:Y}),options:{selection:se?{startLineNumber:se,startColumn:H||1}:void 0},remoteAuthority:q}}return{fileUri:U,remoteAuthority:q}}else if((0,ae.isWorkspaceToOpen)(L))return{workspace:(0,fe.getWorkspaceIdentifier)(U),remoteAuthority:q};return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:q}}resourceFromOpenable(L){return(0,ae.isWorkspaceToOpen)(L)?L.workspaceUri:(0,ae.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let U,q;O.gotoLineMode&&({path:L,line:U,column:q}=(0,u.parseLineAndColumnAware)(L)),L=(0,u.sanitizeFilePath)((0,d.normalize)(L),(0,b.cwd)());try{const Y=await t.Promises.stat(L);if(Y.isFile()){if(!O.forceOpenWorkspaceAsFile){const se=await this.workspacesManagementMainService.resolveLocalWorkspace(m.URI.file(L));if(se)return se.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:se.id,configPath:se.configPath},type:i.FileType.File,exists:!0,remoteAuthority:se.remoteAuthority,transient:se.transient}}return{fileUri:m.URI.file(L),type:i.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:q||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(m.URI.file(L),Y),type:i.FileType.Directory,exists:!0};if(!P.isWindows&&L==="/dev/null")return{fileUri:m.URI.file(L),type:i.FileType.File,exists:!0}}}catch{const se=m.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([se]),O.ignoreFileNotFound)return{fileUri:se,type:i.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const U=L.charCodeAt(0),q=O.remoteAuthority;let Y,se;O.gotoLineMode&&({path:L,line:Y,column:se}=(0,u.parseLineAndColumnAware)(L)),U!==47&&((0,u.isWindowsDriveLetter)(U)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,u.toSlashes)(L)),L=`/${L}`);const H=m.URI.from({scheme:E.Schemas.vscodeRemote,authority:q,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,oe.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:Y?{startLineNumber:Y,startColumn:se||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,fe.getWorkspaceIdentifier)(H),remoteAuthority:q};if(O.gotoLineMode||d.posix.basename(L).indexOf(".")!==-1)return{fileUri:H,options:{selection:Y?{startLineNumber:Y,startColumn:se||1}:void 0},remoteAuthority:q}}return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:q}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),U=O?.openFoldersInNewWindow||"default",q=O?.openFilesInNewWindow||"off";let Y=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(U==="on"||U==="off")&&(Y=U==="on");let se=!1;return L.forceNewWindow||L.forceReuseWindow?se=!!L.forceNewWindow&&!L.forceReuseWindow:(P.isMacintosh?L.context===1&&(se=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(se=!0),!L.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(se=q==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:se}}async openExtensionDevelopmentHostWindow(L,O){const U=(0,X.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(U)return this.lifecycleMainService.reload(U,O.cli),U.focus(),[U];let q=O.cli["folder-uri"]||[],Y=O.cli["file-uri"]||[],se=O.cli._;if(!se.length&&!q.length&&!Y.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=ne?.workspace??ne?.folderUri;ce&&(m.URI.isUri(ce)?ce.scheme===E.Schemas.file?se=[ce.fsPath]:q=[ce.toString()]:ce.configPath.scheme===E.Schemas.file?se=[(0,p.originalFSPath)(ce.configPath)]:Y=[ce.configPath.toString()])}let H=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=m.URI.parse(ne),ge=(0,_.getRemoteAuthority)(ce);ge&&(H?(0,p.isEqualAuthority)(ge,H)||this.logService.error("more than one extension development path authority"):H=ge)}se=se.filter(ne=>{const ce=m.URI.file(ne);return(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(ce),H)}),q=q.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(ce),H):!1}),Y=Y.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,_.getRemoteAuthority)(ce),H):!1}),O.cli._=se,O.cli["folder-uri"]=q,O.cli["file-uri"]=Y;const re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!se.length&&!q.length&&!Y.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:H,profile:O.profile};return this.open(re)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),U={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,d.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:g.default,isInitialStartup:L.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let q;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(q=L.windowToUse||this.getLastActiveWindow(),q&&q.focus()),q){const Y=q.config;!U.extensionDevelopmentPath&&Y?.extensionDevelopmentPath&&(U.extensionDevelopmentPath=Y.extensionDevelopmentPath,U.extensionDevelopmentKind=Y.extensionDevelopmentKind,U["enable-proposed-api"]=Y["enable-proposed-api"],U.verbose=Y.verbose,U["inspect-extensions"]=Y["inspect-extensions"],U["inspect-brk-extensions"]=Y["inspect-brk-extensions"],U.debugId=Y.debugId,U.extensionEnvironment=Y.extensionEnvironment,U["extensions-dir"]=Y["extensions-dir"],U["disable-extensions"]=Y["disable-extensions"])}else{const Y=this.windowsStateHandler.getNewWindowState(U);(0,f.mark)("code/willCreateCodeWindow");const se=q=this.instantiationService.createInstance(Q.CodeWindow,{state:Y,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(se),ft.WINDOWS.push(se),this._onDidOpenWindow.fire(se),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(se.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(se)),(0,w.once)(se.onDidClose)(()=>this.onWindowClosed(se)),(0,w.once)(se.onDidDestroy)(()=>this._onDidDestroyWindow.fire(se)),se.onDidTriggerSystemContextMenu(({x:re,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:se,x:re,y:ne}));const H=(0,S.assertIsDefined)(se.win?.webContents);H.removeAllListeners("devtools-reload-page"),H.on("devtools-reload-page",()=>this.lifecycleMainService.reload(se)),this.lifecycleMainService.registerWindow(se)}return U.windowId=q.id,q.isReady?this.lifecycleMainService.unload(q,4).then(Y=>{Y||this.doOpenInBrowserWindow(q,U,L)}):this.doOpenInBrowserWindow(q,U,L),q}doOpenInBrowserWindow(L,O,U){O.extensionDevelopmentPath||((0,oe.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,fe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=y.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(U=>U.lastFocusTime));return L.find(U=>U.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,U){for(const q of this.getWindows())U&&U.indexOf(q.id)>=0||q.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(U=>U.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=y.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=we([te(2,o.ILogService),te(3,G.IStateMainService),te(4,T.IPolicyService),te(5,n.IEnvironmentMainService),te(6,W.IUserDataProfilesMainService),te(7,c.ILifecycleMainService),te(8,l.IBackupMainService),te(9,s.IConfigurationService),te(10,V.IWorkspacesHistoryMainService),te(11,j.IWorkspacesManagementMainService),te(12,r.IInstantiationService),te(13,a.IDialogMainService),te(14,i.IFileService),te(15,M.IProductService),te(16,A.IProtocolMainService),te(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(ee[272],ie([0,1,60,33,75,52]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(u,w,v,C){this.workspacesManagementMainService=u,this.windowsMainService=w,this.workspacesHistoryMainService=v,this.backupMainService=C,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,w){const v=this.windowsMainService.getWindowById(u);if(v)return this.workspacesManagementMainService.enterWorkspace(v,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(u,w,v){return this.workspacesManagementMainService.createUntitledWorkspace(w,v)}deleteUntitledWorkspace(u,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(u,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}removeRecentlyOpened(u,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=we([te(0,R.IWorkspacesManagementMainService),te(1,t.IWindowsMainService),te(2,k.IWorkspacesHistoryMainService),te(3,y.IBackupMainService)],D),e.WorkspacesMainService=D}),define(ee[273],ie([0,1,13,41,25,17,44,16,31,49,43,35,2,14,9,4,12,7,30,81,129,46,143,102,248,146,60,264,19,69,179,84,117,56,105,177,27,59,111,191,212,192,250,106,193,194,15,204,86,68,5,85,265,226,260,22,6,206,270,65,20,63,256,87,38,253,91,112,32,232,234,73,48,239,240,266,241,267,114,243,244,245,246,251,33,271,252,28,92,75,272,52,249,37,211,42,259,222,55,72,89,254,261,262,8]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a,n,i,r,c,o,g,M,A,_,G,ae,Q,X,x,oe,fe,V,j,F,T,W,N,J,B,$,L,O,U,q,Y,se,H,re,ne,ce,ge,Re,Te,Me,Ae,ve,pe,Se,ke,Z,ue,de,ye,Ce,Fe,Oe,$e,Ne,He,Qe,Be,Ge,K,le,he,me,Ee,Le,Ue,it,Je,je,et,nt,lt,gt,St,Bt,zt,$t,_t,Ht,qt,jt,Vt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends E.Disposable{constructor(be,Pe,De,Ie,We,ze,Ze,tt,_e,Ve,Ke){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=De,this.logService=Ie,this.environmentMainService=We,this.lifecycleMainService=ze,this.configurationService=Ze,this.stateMainService=tt,this.fileService=_e,this.productService=Ve,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const be=_e=>_e?.startsWith(`${d.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);y.session.defaultSession.setPermissionRequestHandler((_e,Ve,Ke,xe)=>be(xe.requestingUrl)?Ke(Pe.has(Ve)):Ke(!1)),y.session.defaultSession.setPermissionCheckHandler((_e,Ve,Ke,xe)=>be(xe.requestingUrl)?Pe.has(Ve):!1);const De=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Ie=_e=>{for(let Ve=_e;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},We=_e=>_e.resourceType==="xhr"||Ie(_e.frame),ze=_e=>{const Ve=_e.frame;if(!Ve||!this.windowsMainService)return!1;const Ke=y.BrowserWindow.getAllWindows();for(const xe of Ke)if(Ve.processId===xe.webContents.mainFrame.processId)return!0;return!1},Ze=(_e,Ve)=>{if(_e.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.windowsMainService)return!1;for(const xe of this.windowsMainService.getWindows())if(xe.win&&Ke.processId===xe.win.webContents.mainFrame.processId)return!0;return!1};y.session.defaultSession.webRequest.onBeforeRequest((_e,Ve)=>{const Ke=p.URI.parse(_e.url);return Ke.scheme===d.Schemas.vscodeWebview&&!Ze(Ke,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ve({cancel:!0})):Ke.scheme===d.Schemas.vscodeFileResource&&!ze(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!De.has(Ke.scheme)?Ve({cancel:!We(_e)}):Ve({cancel:!1})}),y.session.defaultSession.webRequest.onHeadersReceived((_e,Ve)=>{const Ke=_e.responseHeaders,xe=Ke["content-type"]||Ke["Content-Type"];if(xe&&Array.isArray(xe)){const ot=p.URI.parse(_e.url);if(ot.path.endsWith(".svg")&&De.has(ot.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!ot.path.endsWith(d.Schemas.vscodeRemoteResource)&&xe.some(ct=>ct.toLowerCase().includes("image/svg")))return Ve({cancel:!We(_e)})}return Ve({cancel:!1})});const tt=y.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,f.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(De=>this.onUnexpectedError(De)),process.on("uncaughtException",De=>(0,I.onUnexpectedError)(De)),process.on("unhandledRejection",De=>(0,I.onUnexpectedError)(De)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,h.registerContextMenuListener)(),y.app.on("accessibility-support-changed",(De,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),y.app.on("activate",async(De,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),y.app.on("web-contents-created",(De,Ie)=>{Ie.on("will-navigate",We=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Ie.setWindowOpenHandler(({url:We})=>(this.nativeHostMainService?.openExternal(void 0,We),{action:"deny"}))});let be=[],Pe;y.app.on("open-file",(De,Ie)=>{this.logService.trace("app#open-file: ",Ie),De.preventDefault(),be.push((0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:p.URI.file(Ie)}:{fileUri:p.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),y.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",De=>{const Ie=this.windowsMainService?.getWindowByWebContents(De.sender);let We,ze;return Ie?.config?(We=Ie.config,ze={...process.env,...Ie.config.userEnv}):(We=this.environmentMainService.args,ze=process.env),this.resolveShellEnvironment(We,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(De,Ie,We)=>{const ze=this.validateNlsPath([Ie]);if(!ze||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ze,R.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(De,...Ie)=>{const We=this.validateNlsPath(Ie);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",De=>De.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",De=>De.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",De=>De.sender.reload())}validateNlsPath(be){let Pe;for(const De of be)typeof De=="string"&&(typeof Pe!="string"?Pe=De:Pe=(0,f.join)(Pe,De));if(!(typeof Pe!="string"||!(0,f.isAbsolute)(Pe)||!(0,u.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!P.isLinux)))return p.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;P.isWindows&&be&&y.app.setAppUserModelId(be);try{P.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!y.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&y.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Pe=new s.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const De=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${De}`);const{sharedProcess:Ie,sharedProcessReady:We,sharedProcessClient:ze}=this.setupSharedProcess(De),Ze=await this.initServices(De,Ie,We);this.setUpHandlers(Ze),Ze.invokeFunction(_e=>this.initChannels(_e,Pe,ze)),await Ze.invokeFunction(_e=>this.openFirstWindow(_e,Pe)),Ze.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(n.ProxyAuthHandler)),this._register(be.createInstance(Bt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(Z.machineIdKey);return(!be||P.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,m.getMachineId)(),this.stateMainService.setItem(Z.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(Me.SharedProcess,be,this.userEnv)),De=(async()=>{this.logService.trace("Main->SharedProcess#connect");const We=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(We,"main")})(),Ie=(async()=>(await Pe.whenReady(),De))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:De}}async initServices(be,Pe,De){const Ie=new U.ServiceCollection;switch(process.platform){case"win32":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(He.Win32UpdateService));break;case"linux":P.isLinuxSnap?Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Ce.IUpdateService,new L.SyncDescriptor($e.LinuxUpdateService));break;case"darwin":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ie.set(me.IWindowsMainService,new L.SyncDescriptor(Ee.WindowsMainService,[be,this.userEnv],!1));const We=new G.DialogMainService(this.logService);Ie.set(G.IDialogMainService,We),Ie.set(se.ILaunchMainService,new L.SyncDescriptor(se.LaunchMainService,void 0,!1)),Ie.set(_.IDiagnosticsMainService,new L.SyncDescriptor(_.DiagnosticsMainService,void 0,!1)),Ie.set(A.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(De.then(tt=>tt.getChannel("diagnostics"))))),Ie.set(q.IIssueMainService,new L.SyncDescriptor(q.IssueMainService,[this.userEnv])),Ie.set(ae.IEncryptionMainService,new L.SyncDescriptor(Q.EncryptionMainService,[be])),Ie.set(Y.IKeyboardLayoutMainService,new L.SyncDescriptor(Y.KeyboardLayoutMainService)),Ie.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ie.set(g.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ie.set(le.IWebviewManagerService,new L.SyncDescriptor(he.WebviewMainService)),Ie.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ie.set(fe.IExtensionUrlTrustService,new L.SyncDescriptor(V.ExtensionUrlTrustService)),Ie.set(j.IExtensionHostStarter,new L.SyncDescriptor(F.ExtensionHostStarter)),Ie.set(Se.IStorageMainService,new L.SyncDescriptor(Se.StorageMainService)),Ie.set(Se.IApplicationStorageMainService,new L.SyncDescriptor(Se.ApplicationStorageMainService)),P.isWindows?Ie.set(T.IExternalTerminalMainService,new L.SyncDescriptor(W.WindowsExternalTerminalService)):P.isMacintosh?Ie.set(T.IExternalTerminalMainService,new L.SyncDescriptor(W.MacExternalTerminalService)):P.isLinux&&Ie.set(T.IExternalTerminalMainService,new L.SyncDescriptor(W.LinuxExternalTerminalService));const ze=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ie.set(r.IBackupMainService,ze);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,ze,We,this.productService);if(Ie.set(et.IWorkspacesManagementMainService,Ze),Ie.set(it.IWorkspacesService,new L.SyncDescriptor(je.WorkspacesMainService,void 0,!1)),Ie.set(Je.IWorkspacesHistoryMainService,new L.SyncDescriptor(Je.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Qe.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,ye.isInternalTelemetry)(this.productService,this.configurationService),_e=(0,l.getDelayedChannel)(De.then(ct=>ct.getChannel("telemetryAppender"))),Ve=new ue.TelemetryAppenderClient(_e),Ke=(0,ke.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),xe=(0,ye.getPiiPathsFromEnvironment)(this.environmentMainService),ot={appenders:[Ve],commonProperties:Ke,piiPaths:xe,sendErrorTelemetry:!0};Ie.set(Z.ITelemetryService,new L.SyncDescriptor(de.TelemetryService,[ot],!1))}else Ie.set(Z.ITelemetryService,ye.NullTelemetryService);return Ie.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ie.set(Ht.IExtensionsScannerService,new L.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([ze.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ie)}initChannels(be,Pe,De){const Ie=l.ProxyChannel.fromService(be.get(se.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const We=l.ProxyChannel.fromService(be.get(_.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",We);const ze=new gt.PolicyChannel(be.get(lt.IPolicyService));Pe.registerChannel("policy",ze),De.then(Ye=>Ye.registerChannel("policy",ze));const Ze=this.fileService.getProvider(d.Schemas.file);(0,b.assertType)(Ze instanceof $.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),De.then(Ye=>Ye.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const _e=l.ProxyChannel.fromService(be.get(St.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",_e),De.then(Ye=>Ye.registerChannel("userDataProfiles",_e));const Ve=new zt.RequestChannel(be.get($t.IRequestService));De.then(Ye=>Ye.registerChannel("request",Ve));const Ke=new Fe.UpdateChannel(be.get(Ce.IUpdateService));Pe.registerChannel("update",Ke);const xe=l.ProxyChannel.fromService(be.get(q.IIssueMainService));Pe.registerChannel("issue",xe);const ot=l.ProxyChannel.fromService(be.get(ae.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ct=l.ProxyChannel.fromService(be.get(g.ICredentialsMainService));Pe.registerChannel("credentials",ct);const kt=l.ProxyChannel.fromService(be.get(Ae.ISignService));Pe.registerChannel("sign",kt);const Xe=l.ProxyChannel.fromService(be.get(Y.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=be.get(ge.INativeHostMainService);const mt=l.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),De.then(Ye=>Ye.registerChannel("nativeHost",mt));const pt=l.ProxyChannel.fromService(be.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const yt=l.ProxyChannel.fromService(be.get(ce.IMenubarMainService));Pe.registerChannel("menubar",yt);const Mt=l.ProxyChannel.fromService(be.get(Qe.IURLService));Pe.registerChannel("url",Mt);const Dt=l.ProxyChannel.fromService(be.get(fe.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=l.ProxyChannel.fromService(be.get(le.IWebviewManagerService));Pe.registerChannel("webview",wt);const ut=this._register(new pe.StorageDatabaseChannel(this.logService,be.get(Se.IStorageMainService)));Pe.registerChannel("storage",ut),De.then(Ye=>Ye.registerChannel("storage",ut));const bt=this._register(new Vt.ProfileStorageChangesListenerChannel(be.get(Se.IStorageMainService),be.get(St.IUserDataProfilesMainService),this.logService));De.then(Ye=>Ye.registerChannel("profileStorageListener",bt));const vt=l.ProxyChannel.fromService(be.get(T.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const qe=new ne.LogLevelChannel(be.get(re.ILogService),be.get(re.ILoggerService));Pe.registerChannel("logLevel",qe),De.then(Ye=>Ye.registerChannel("logLevel",qe));const st=new ne.LoggerChannel(be.get(re.ILoggerService));Pe.registerChannel("logger",st),De.then(Ye=>Ye.registerChannel("logger",st));const dt=new M.ElectronExtensionHostDebugBroadcastChannel(be.get(me.IWindowsMainService),be.get(St.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",dt);const at=l.ProxyChannel.fromService(be.get(j.IExtensionHostStarter));Pe.registerChannel(j.ipcExtensionHostStarterChannelName,at)}async openFirstWindow(be,Pe){const De=this.windowsMainService=be.get(me.IWindowsMainService),Ie=be.get(Qe.IURLService),We=be.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const ze=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(qe=>{try{return{uri:p.URI.parse(qe),url:qe}}catch{return}}).filter(qe=>{if(!qe||this.shouldBlockURI(qe.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(qe.uri);return st?(ze.push(st),!1):!0}),tt=this,_e=this.environmentMainService,Ve=this.productService,Ke=this.logService;Ie.registerHandler({async handleURL(qe,st){if(Ke.trace("app#handleURL: ",qe.toString(!0),st),qe.scheme===Ve.urlProtocol&&qe.path==="workspace"&&(qe=qe.with({authority:"file",path:p.URI.parse(qe.query).path,query:""})),tt.shouldBlockURI(qe))return!0;let dt=!1;const at=new URLSearchParams(qe.query);at.get("windowId")==="_blank"&&(at.delete("windowId"),qe=qe.with({query:at.toString()}),dt=!0),dt||=P.isMacintosh&&De.getWindowCount()===0;const Ye=at.get("continueOn");Ye!==null&&(_e.continueOn=Ye??void 0,at.delete("continueOn"),qe=qe.with({query:at.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(qe);if(Ke.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await De.open({context:5,cli:{..._e.args},urisToOpen:[Rt],forceNewWindow:dt,gotoLineMode:!0});return Lt.focus(),!0}if(dt){const[Lt]=await De.open({context:5,cli:{..._e.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Te.getRemoteAuthority)(qe)});return await Lt.ready(),Ie.open(qe,st)}return!1}});const xe=this._register(new Le.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),ot=new l.StaticRouter(qe=>xe.getActiveClientId().then(st=>qe===st)),ct=new Be.URLHandlerRouter(ot),kt=Pe.getChannel("urlHandler",ct);Ie.registerHandler(new Be.URLHandlerChannelClient(kt)),this._register(new K.ElectronURLListener(Ze,Ie,De,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,x.isLaunchedFromCli)(process.env)?0:4,yt=Xe._.length,Mt=!!Xe["folder-uri"],Dt=!!Xe["file-uri"],wt=Xe["skip-add-to-recently-opened"]===!0,ut=Xe.wait&&Xe.waitMarkerFilePath?p.URI.file(Xe.waitMarkerFilePath):void 0,bt=Xe.remote||void 0;if(ze.length>0)return De.open({context:pt,cli:Xe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});const vt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!yt&&!Mt&&!Dt){if(Xe["new-window"]||vt)return De.open({context:pt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:bt,profile:vt});if(mt.length)return De.open({context:1,cli:Xe,urisToOpen:mt.map(qe=>(0,Ue.hasWorkspaceFileExtension)(qe)?{workspaceUri:p.URI.file(qe)}:{fileUri:p.URI.file(qe)}),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0})}return De.open({context:pt,cli:Xe,forceNewWindow:Xe["new-window"]||!yt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:bt,profile:vt})}shouldBlockURI(be){return!!(be.authority===d.Schemas.file&&P.isWindows&&y.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,C.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,C.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,C.getPathLabel)(be,{os:P.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===d.Schemas.file){const Pe=p.URI.file(be.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===d.Schemas.vscodeRemote){const Pe=be.path.indexOf(f.posix.sep,1);if(Pe!==-1){const De=be.path.substring(1,Pe),Ie=be.path.substring(Pe),We=p.URI.from({scheme:d.Schemas.vscodeRemote,authority:De,path:Ie,query:be.query,fragment:be.fragment});return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:We}:/:[\d]+$/.test(Ie)?{fileUri:We}:{folderUri:We}}}}}afterWindowOpen(be,Pe){const De=be.get(Z.ITelemetryService),Ie=be.get(Ce.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(De,Pe),this.installMutex(),y.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(We,ze)=>{ze({url:We.url.replace(/^vscode-remote-resource:/,"http:"),method:We.method})}),(Ie instanceof He.Win32UpdateService||Ie instanceof $e.LinuxUpdateService||Ie instanceof Oe.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(P.isWindows&&be)try{const Pe=await new Promise((Ie,We)=>{z(["windows-mutex"],Ie,We)}),De=new Pe.Mutex(be);(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let De=!1;(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>De=!0),this._register(Pe.onDidError(({type:Ie,details:We})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(ze)),be.publicLog2("sharedprocesserror",{type:Ie,reason:We?.reason,code:We?.exitCode,visible:Pe.isVisible(),shuttingdown:De})}))}async resolveShellEnvironment(be,Pe,De){try{return await(0,oe.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ie){const We=(0,D.toErrorMessage)(Ie);De?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",We):this.logService.error(We)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),De=JSON.parse((0,v.stripComments)(Pe)),We=(0,ye.getTelemetryLevel)(this.configurationService)>=1;if(De["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,S.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const ze=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${We},`);ze!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(ze))}}catch(be){this.logService.error(be)}}};Pt=we([te(2,O.IInstantiationService),te(3,re.ILogService),te(4,X.IEnvironmentMainService),te(5,H.ILifecycleMainService),te(6,o.IConfigurationService),te(7,ve.IStateMainService),te(8,J.IFileService),te(9,Re.IProductService),te(10,St.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(ee[274],ie([0,1,37,8,281,2]),function(z,e,y,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends y.AbstractPolicyService{constructor(u){super(),this.productName=u,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(u){await this.throttler.queue(()=>new Promise((w,v)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,u,C=>{for(const E in C){const d=C[E];d===void 0?this.policies.delete(E):this.policies.set(E,d)}this._onDidChange.fire(Object.keys(C)),w()})}catch(C){v(C)}}))}}e.NativePolicyService=D}),define(ee[275],ie([0,1,224,8,17,16,2,12,19,36,111,6,223,282]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let f=class extends D.Disposable{constructor(b,p,S){super(),this.environmentService=p,this.logService=S,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,p){this.logService.trace("RequestService#request (node) - begin",b.url);const{proxyUrl:S,strictSSL:m}=this;let h;try{h=await(0,v.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",a))}const l={...process.env,...h},s=b.agent?b.agent:await(0,E.getProxyAgent)(b.url||"",l,{proxyUrl:S,strictSSL:m});b.agent=s,b.strictSSL=m,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization});try{const a=await this._request(b,p);return this.logService.trace("RequestService#request (node) - success",b.url),a}catch(a){throw this.logService.trace("RequestService#request (node) - error",b.url,a),a}}async getNodeRequest(b){return((0,y.parse)(b.url).protocol==="https:"?await new Promise((m,h)=>{z(["https"],m,h)}):await new Promise((m,h)=>{z(["http"],m,h)})).request}_request(b,p){return t.Promises.withAsyncBody(async(S,m)=>{const h=(0,y.parse)(b.url),l=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),s={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,I.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(s.auth=b.user+":"+b.password);const a=l(s,n=>{const i=(0,I.isNumber)(b.followRedirects)?b.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...b,url:n.headers.location,followRedirects:i-1},p).then(S,m);else{let r=n;n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,d.createGunzip)())),S({res:n,stream:(0,k.streamToBufferReadableStream)(r)})}});a.on("error",m),b.timeout&&a.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&a.write(b.data),a.end(),p.onCancellationRequested(()=>{a.abort(),m(new R.CancellationError)})})}async resolveProxy(b){}};f=we([te(0,u.IConfigurationService),te(1,w.INativeEnvironmentService),te(2,C.ILogService)],f),e.RequestService=f}),define(ee[276],ie([0,1,13,275]),function(z,e,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return y.net.request}class R extends t.RequestService{request(I,u){return super.request({...I||{},getRawRequest:k},u)}}e.RequestMainService=R}),define(ee[283],ie([0,1,13,40,7,24,8,44,16,31,49,35,14,9,71,4,34,26,21,46,83,273,10,19,217,230,27,59,183,15,202,86,68,199,85,22,205,6,208,54,20,61,255,113,237,55,276,87,225,38,229,73,64,42,37,274,210,2,51,242,39,238]),function(z,e,y,t,k,R,D,I,u,w,v,C,E,d,f,P,b,p,S,m,h,l,s,a,n,i,r,c,o,g,M,A,_,G,ae,Q,X,x,oe,fe,V,j,F,T,W,N,J,B,$,L,O,U,q,Y,se,H,re,ne,ce,ge,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Te{main(){try{this.startup()}catch(ve){console.error(ve.message),y.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[ve,pe,Se,ke,Z,ue,de,ye]=this.createServices();try{try{await this.initServices(Se,ye,ke,Z,de)}catch(Ce){throw this.handleStartupDataDirError(Se,de.nameLong,Ce),Ce}await ve.invokeFunction(async Ce=>{const Fe=Ce.get(x.ILogService),Oe=Ce.get(Q.ILifecycleMainService),$e=Ce.get(g.IFileService),Ne=Ce.get(x.ILoggerService),He=await this.claimInstance(Fe,Se,Oe,ve,de,!0);return S.Promises.writeFile(Se.mainLockfile,String(process.pid)).catch(Qe=>{Fe.warn(`Error writing main lockfile: ${Qe.stack}`)}),ue.logger=Ne.createLogger(k.URI.file((0,d.join)(Se.logsPath,"main.log")),{name:"main"}),(0,v.once)(Oe.onWillShutdown)(Qe=>{$e.dispose(),ke.dispose(),Qe.join(S.Promises.unlink(Se.mainLockfile).catch(()=>{}))}),ve.createInstance(l.CodeApplication,He,pe).startup()})}catch(Ce){ve.invokeFunction(this.quit,Ce)}}createServices(){const ve=new ae.ServiceCollection,pe=new ne.DisposableStore;process.once("exit",()=>pe.dispose());const Se={_serviceBrand:void 0,...fe.default};ve.set(V.IProductService,Se);const ke=new r.EnvironmentMainService(this.resolveArgs(),Se),Z=this.patchEnvironment(ke);ve.set(r.IEnvironmentMainService,ke);const ue=new X.BufferLogService,de=pe.add(new x.MultiplexLogService([new x.ConsoleMainLogger((0,x.getLogLevel)(ke)),ue]));ve.set(x.ILogService,de);const ye=new M.FileService(de);ve.set(g.IFileService,ye);const Ce=new A.DiskFileSystemProvider(de);ye.registerProvider(E.Schemas.file,Ce);const Fe=new ge.UriIdentityService(ye);ve.set(ce.IUriIdentityService,Fe),ve.set(x.ILoggerService,new oe.LoggerService(de));const Oe=new O.StateMainService(ke,de,ye);ve.set(L.IStateMainService,Oe);const $e=new Y.UserDataProfilesMainService(Oe,Fe,ke,ye,de);ve.set(Y.IUserDataProfilesMainService,$e);const Ne=P.isWindows&&Se.win32RegValueName?pe.add(new H.NativePolicyService(Se.win32RegValueName)):ke.policyFile?pe.add(new re.FilePolicyService(ke.policyFile,ye,de)):new se.NullPolicyService;ve.set(se.IPolicyService,Ne);const He=new n.ConfigurationService($e.defaultProfile.settingsResource,ye,Ne,de);return ve.set(a.IConfigurationService,He),ve.set(Q.ILifecycleMainService,new _.SyncDescriptor(Q.LifecycleMainService,void 0,!1)),ve.set(N.IRequestService,new _.SyncDescriptor(J.RequestMainService,void 0,!0)),ve.set(q.IThemeMainService,new _.SyncDescriptor(q.ThemeMainService)),ve.set(B.ISignService,new _.SyncDescriptor($.SignService,void 0,!1)),ve.set(T.ITunnelService,new _.SyncDescriptor(W.TunnelService)),ve.set(j.IProtocolMainService,new F.ProtocolMainService(ke,$e,de)),[new G.InstantiationService(ve,!0),Z,ke,He,Oe,ue,Se,$e]}patchEnvironment(ve){const pe={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Se=>{const ke=process.env[Se];typeof ke=="string"&&(pe[Se]=ke)}),Object.assign(process.env,pe),pe}async initServices(ve,pe,Se,ke,Z){await D.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,pe.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?S.Promises.mkdir(ue,{recursive:!0}):void 0)),ke.init(),Se.initialize()]),pe.setEnablement(Z.quality!=="stable"||Se.getValue(Re.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ve,pe,Se,ke,Z,ue){let de;try{(0,f.mark)("code/willStartMainServer"),de=await(0,h.serve)(pe.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),(0,v.once)(Se.onWillShutdown)(()=>de.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,Z.nameLong,ye),ye;let Ce;try{Ce=await(0,h.connect)(pe.mainIPCHandle,"main")}catch(Ne){if(!ue||P.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,s.localize)(0,null,Z.nameShort),(0,s.localize)(1,null),Z.nameLong),Ne;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(He){throw ve.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(ve,pe,Se,ke,Z,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ve.error(Ne),Ce.dispose(),new Error(Ne)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.showStartupWarningDialog((0,s.localize)(2,null,Z.nameShort),(0,s.localize)(3,null),Z.nameLong)},1e4));const Oe=m.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),$e=m.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ke.invokeFunction(async()=>{const Ne=new i.DiagnosticsService(U.NullTelemetryService,Z),He=await $e.getMainDiagnostics(),Qe=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(He,Qe);throw console.log(Be),new u.ExpectedError});throw P.isWindows&&await this.windowsAllowSetForegroundWindow(Oe,ve),ve.trace("Sending env to running instance..."),await Oe.start(pe.args,process.env),Ce.dispose(),Fe&&clearTimeout(Fe),new u.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ve.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(ve,pe,Se){if(Se.code==="EACCES"||Se.code==="EPERM"){const ke=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,h.XDG_RUNTIME_DIR]).map(Z=>(0,C.getPathLabel)(k.URI.file(Z),{os:P.OS,tildify:ve}));this.showStartupWarningDialog((0,s.localize)(4,null),(0,s.localize)(5,null,(0,I.toErrorMessage)(Se),ke.join(`
`)),pe)}}showStartupWarningDialog(ve,pe,Se){y.dialog.showMessageBoxSync({title:Se,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,s.localize)(6,null))],message:ve,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ve,pe){if(P.isWindows){const Se=await ve.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Se);try{(await new Promise((ke,Z)=>{z(["windows-foreground-love"],ke,Z)})).allowSetForegroundWindow(Se)}catch(ke){pe.error(ke)}}}quit(ve,pe){const Se=ve.get(x.ILogService),ke=ve.get(Q.ILifecycleMainService);let Z=0;pe&&(pe.isExpected?pe.message&&Se.trace(pe.message):(Z=1,pe.stack?Se.error(pe.stack):Se.error(`Startup error: ${pe.toString()}`))),ke.kill(Z)}resolveArgs(){const ve=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const pe=(0,o.createWaitMarkerFileSync)(ve.verbose);pe&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",pe),ve.waitMarkerFilePath=pe)}return ve}validatePaths(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const pe=this.doValidatePaths(ve._,ve.goto);ve._=pe}return ve}doValidatePaths(ve,pe){const Se=(0,b.cwd)(),ke=ve.map(de=>{let ye=String(de),Ce;pe&&(Ce=(0,w.parseLineAndColumnAware)(ye),ye=Ce.path),ye&&(ye=this.preparePath(Se,ye));const Fe=(0,w.sanitizeFilePath)(ye,Se),Oe=(0,d.basename)(Fe);return Oe&&!(0,w.isValidBasename)(Oe)?null:pe&&Ce?(Ce.path=Fe,this.toPath(Ce)):Fe}),Z=P.isWindows||P.isMacintosh,ue=(0,R.distinct)(ke,de=>de&&Z?de.toLowerCase():de||"");return(0,R.coalesce)(ue)}preparePath(ve,pe){return P.isWindows&&(pe=(0,p.rtrim)(pe,'"')),pe=(0,p.trim)((0,p.trim)(pe," "),"	"),P.isWindows&&(pe=(0,d.resolve)(ve,pe),pe=(0,p.rtrim)(pe,".")),pe}toPath(ve){const pe=[ve.path];return typeof ve.line=="number"&&pe.push(String(ve.line)),typeof ve.column=="number"&&pe.push(String(ve.column)),pe.join(":")}}new Te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6455bf1608dfa1b955717f66295f0f9200db0f73/core/vs/code/electron-main/main.js.map
