/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","fs","vs/editor/common/languages","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/hash","vs/base/common/normalization","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(J){for(var e=[],u=0,t=J.length;u<t;u++)e[u]=De[J[u]];return e};define(De[76],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(y){return y?y.replace(/\$\((.*?)\)/g,(I,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=u;class t{constructor(I,S,D){this.id=I,this.definition=S,this.description=D,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function C(y,I){const S=["codicon","codicon-"+y];return I&&S.push("codicon-modifier-"+I),S}e.getClassNamesArray=C;var P;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function S(k){if(k instanceof t)return["codicon","codicon-"+k.id];const E=I.exec(k.id);if(!E)return S(t.error);const[,T,_]=E,g=["codicon","codicon-"+T];return _&&g.push("codicon-modifier-"+_.substr(1)),g}y.asClassNameArray=S;function D(k){return S(k).join(" ")}y.asClassName=D;function A(k){return"."+S(k).join(".")}y.asCSSSelector=A})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[77],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function u(y,I){const S=Object.create(null);for(const D of y){const A=I(D);let k=S[A];k||(k=S[A]=[]),k.push(D)}return S}e.groupBy=u;function t(y,I){const S=[],D=[];for(const A of y)I.has(A)||S.push(A);for(const A of I)y.has(A)||D.push(A);return{removed:S,added:D}}e.diffSets=t;function C(y,I){const S=[],D=[];for(const[A,k]of y)I.has(A)||S.push(k);for(const[A,k]of I)y.has(A)||D.push(k);return{removed:S,added:D}}e.diffMaps=C;class P{constructor(){this.map=new Map}add(I,S){let D=this.map.get(I);D||(D=new Set,this.map.set(I,D)),D.add(S)}delete(I,S){const D=this.map.get(I);!D||(D.delete(S),D.size===0&&this.map.delete(I))}forEach(I,S){const D=this.map.get(I);!D||D.forEach(S)}}e.SetMap=P}),define(De[59],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(y){return(I,S,D)=>{let A=null,k=null;if(typeof D.value=="function"?(A="value",k=D.value):typeof D.get=="function"&&(A="get",k=D.get),!k)throw new Error("not supported");D[A]=y(k,S)}}e.createDecorator=u;function t(y,I,S){let D=null,A=null;if(typeof S.value=="function"?(D="value",A=S.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(D="get",A=S.get),!A)throw new Error("not supported");const k=`$memoize$${I}`;S[D]=function(...E){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,E)}),this[k]}}e.memoize=t;function C(y,I,S){return u((D,A)=>{const k=`$debounce$${A}`,E=`$debounce$result$${A}`;return function(...T){this[E]||(this[E]=S?S():void 0),clearTimeout(this[k]),I&&(this[E]=I(this[E],...T),T=[this[E]]),this[k]=setTimeout(()=>{D.apply(this,T),this[E]=S?S():void 0},y)}})}e.debounce=C;function P(y,I,S){return u((D,A)=>{const k=`$throttle$timer$${A}`,E=`$throttle$result$${A}`,T=`$throttle$lastRun$${A}`,_=`$throttle$pending$${A}`;return function(...g){if(this[E]||(this[E]=S?S():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),I&&(this[E]=I(this[E],...g)),this[_])return;const p=this[T]+y;p<=Date.now()?(this[T]=Date.now(),D.apply(this,[this[E]]),this[E]=S?S():void 0):(this[_]=!0,this[k]=setTimeout(()=>{this[_]=!1,this[T]=Date.now(),D.apply(this,[this[E]]),this[E]=S?S():void 0},p-Date.now()))}})}e.throttle=P}),define(De[11],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?f.isErrorNoTelemetry(a)?new f(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(d=>{d(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=u,e.errorHandler=new u;function t(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=t;function C(v){S(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=C;function P(v){S(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=P;function y(v){if(v instanceof Error){const{name:a,message:d}=v,o=v.stacktrace||v.stack;return{$isError:!0,name:a,message:d,stack:o,noTelemetry:f.isErrorNoTelemetry(v)}}return v}e.transformErrorForSerialization=y;const I="Canceled";function S(v){return v instanceof D?!0:v instanceof Error&&v.name===I&&v.message===I}e.isCancellationError=S;class D extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=D;function A(){const v=new Error(I);return v.name=v.message,v}e.canceled=A;function k(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=k;function E(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=E;function T(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function _(v){const a=new Error(`${v} has been disposed`);return a.name="DISPOSED",a}e.disposed=_;function g(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=g;class p extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=p;class m extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=m;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class f extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof f)return a;const d=new f;return d.message=a.message,d.stack=a.stack,d}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class c extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(De[17],Ie([1,0,11]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function C(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=C;function P(oe,le,ge=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!ge(oe[Z],le[Z]))return!1;return!0}e.equals=P;function y(oe,le){const ge=oe.length-1;le<ge&&(oe[le]=oe[ge]),oe.pop()}e.removeFastWithoutKeepingOrder=y;function I(oe,le,ge){return S(oe.length,Z=>ge(oe[Z],le))}e.binarySearch=I;function S(oe,le){let ge=0,Z=oe-1;for(;ge<=Z;){const ae=(ge+Z)/2|0,ne=le(ae);if(ne<0)ge=ae+1;else if(ne>0)Z=ae-1;else return ae}return-(ge+1)}e.binarySearch2=S;function D(oe,le){let ge=0,Z=oe.length;if(Z===0)return 0;for(;ge<Z;){const ae=Math.floor((ge+Z)/2);le(oe[ae])?Z=ae:ge=ae+1}return ge}e.findFirstInSorted=D;function A(oe,le,ge){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ne=[],ie=[];for(const O of le){const j=ge(O,Z);j<0?ae.push(O):j>0?ne.push(O):ie.push(O)}return oe<ae.length?A(oe,ae,ge):oe<ae.length+ie.length?ie[0]:A(oe-(ae.length+ie.length),ne,ge)}e.quickSelect=A;function k(oe,le){const ge=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],ge.push(Z)):Z.push(ae);return ge}e.groupBy=k;function E(oe,le,ge){const Z=[];function ae(O,j,G){if(j===0&&G.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===O?(X.deleteCount+=j,X.toInsert.push(...G)):Z.push({start:O,deleteCount:j,toInsert:G})}let ne=0,ie=0;for(;;){if(ne===oe.length){ae(ne,0,le.slice(ie));break}if(ie===le.length){ae(ne,oe.length-ne,[]);break}const O=oe[ne],j=le[ie],G=ge(O,j);G===0?(ne+=1,ie+=1):G<0?(ae(ne,1,[]),ne+=1):G>0&&(ae(ne,0,[j]),ie+=1)}return Z}e.sortedDiff=E;function T(oe,le,ge){const Z=E(oe,le,ge),ae=[],ne=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:ae,added:ne}}e.delta=T;function _(oe,le,ge){if(ge===0)return[];const Z=oe.slice(0,ge).sort(le);return p(oe,le,Z,ge,oe.length),Z}e.top=_;function g(oe,le,ge,Z,ae){return ge===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const O=oe.length,j=oe.slice(0,ge).sort(le);for(let G=ge,X=Math.min(ge+Z,O);G<O;G=X,X=Math.min(X+Z,O)){if(G>ge&&await new Promise(pe=>setTimeout(pe)),ae&&ae.isCancellationRequested)throw new u.CancellationError;p(oe,le,j,G,X)}return j})().then(ne,ie)})}e.topAsync=g;function p(oe,le,ge,Z,ae){for(const ne=ge.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,ge[ne-1])<0){ge.pop();const O=D(ge,j=>le(ie,j)<0);ge.splice(O,0,ie)}}}function m(oe){return oe.filter(le=>!!le)}e.coalesce=m;function b(oe){let le=0;for(let ge=0;ge<oe.length;ge++)oe[ge]&&(oe[le]=oe[ge],le+=1);oe.length=le}e.coalesceInPlace=b;function f(oe,le,ge){oe.splice(ge,0,oe.splice(le,1)[0])}e.move=f;function c(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=c;function v(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=v;function a(oe,le=ge=>ge){const ge=new Set;return oe.filter(Z=>{const ae=le(Z);return ge.has(ae)?!1:(ge.add(ae),!0)})}e.distinct=a;function d(oe){const le=new Set;return ge=>{const Z=oe(ge);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=d;function o(oe,le){const ge=i(oe,le);if(ge!==-1)return oe[ge]}e.findLast=o;function i(oe,le){for(let ge=oe.length-1;ge>=0;ge--){const Z=oe[ge];if(le(Z))return ge}return-1}e.lastIndex=i;function s(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=s;function l(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=l;function n(oe,le,ge=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ne=Math.min(oe.length,le.length);ae<ne&&ge(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=n;function r(oe){return[].concat(...oe)}e.flatten=r;function h(oe,le){let ge=typeof le=="number"?oe:0;typeof le=="number"?ge=oe:(ge=0,le=oe);const Z=[];if(ge<=le)for(let ae=ge;ae<le;ae++)Z.push(ae);else for(let ae=ge;ae>le;ae--)Z.push(ae);return Z}e.range=h;function w(oe,le,ge){return oe.reduce((Z,ae)=>(Z[le(ae)]=ge?ge(ae):ae,Z),Object.create(null))}e.index=w;function L(oe,le){return oe.push(le),()=>M(oe,le)}e.insert=L;function M(oe,le){const ge=oe.indexOf(le);if(ge>-1)return oe.splice(ge,1),le}e.remove=M;function B(oe,le,ge){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(ge,ae)}e.arrayInsert=B;function R(oe,le){let ge;if(typeof le=="number"){let Z=le;ge=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else ge=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(ge()*(Z+1)),ne=oe[Z];oe[Z]=oe[ae],oe[ae]=ne}}e.shuffle=R;function z(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.unshift(le))}e.pushToStart=z;function H(oe,le){const ge=oe.indexOf(le);ge>-1&&(oe.splice(ge,1),oe.push(le))}e.pushToEnd=H;function N(oe,le){for(const ge of le)oe.push(ge)}e.pushMany=N;function V(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=V;function U(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=U;function F(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=F;function x(oe,le){for(const ge of oe){const Z=le(ge);if(Z!==void 0)return Z}}e.mapFind=x;function $(oe,le,ge){const Z=K(oe,le),ae=oe.length,ne=ge.length;oe.length=ae+ne;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ne]=oe[ie];for(let ie=0;ie<ne;ie++)oe[ie+Z]=ge[ie]}e.insertInto=$;function Q(oe,le,ge,Z){const ae=K(oe,le),ne=oe.splice(ae,ge);return $(oe,ae,Z),ne}e.splice=Q;function K(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var de;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function ge(ae){return ae>0}oe.isGreaterThan=ge;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(de=e.CompareResult||(e.CompareResult={}));function ee(oe,le){return(ge,Z)=>le(oe(ge),oe(Z))}e.compareBy=ee;function he(...oe){return(le,ge)=>{for(const Z of oe){const ae=Z(le,ge);if(!de.isNeitherLessOrGreaterThan(ae))return ae}return de.neitherLessOrGreaterThan}}e.tieBreakComparators=he;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function me(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>0&&(ge=ae)}return ge}e.findMaxBy=me;function be(oe,le){if(oe.length===0)return;let ge=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,ge)>=0&&(ge=ae)}return ge}e.findLastMaxBy=be;function ke(oe,le){return me(oe,(ge,Z)=>-le(ge,Z))}e.findMinBy=ke;class Re{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ge=this.firstIdx;for(;ge<this.items.length&&le(this.items[ge]);)ge++;const Z=ge===this.firstIdx?null:this.items.slice(this.firstIdx,ge);return this.firstIdx=ge,Z}takeFromEndWhile(le){let ge=this.lastIdx;for(;ge>=0&&le(this.items[ge]);)ge--;const Z=ge===this.lastIdx?null:this.items.slice(ge+1,this.lastIdx+1);return this.lastIdx=ge,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const ge=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,ge}}e.ArrayQueue=Re;class ze{constructor(le){this.iterate=le}forEach(le){this.iterate(ge=>(le(ge),!0))}toArray(){const le=[];return this.iterate(ge=>(le.push(ge),!0)),le}filter(le){return new ze(ge=>this.iterate(Z=>le(Z)?ge(Z):!0))}map(le){return new ze(ge=>this.iterate(Z=>ge(le(Z))))}some(le){let ge=!1;return this.iterate(Z=>(ge=le(Z),!ge)),ge}findFirst(le){let ge;return this.iterate(Z=>le(Z)?(ge=Z,!1):!0),ge}findLast(le){let ge;return this.iterate(Z=>(le(Z)&&(ge=Z),!0)),ge}findLastMaxBy(le){let ge,Z=!0;return this.iterate(ae=>((Z||de.isGreaterThan(le(ae,ge)))&&(Z=!1,ge=ae),!0)),ge}}e.CallbackIterable=ze,ze.empty=new ze(oe=>{})}),define(De[48],Ie([1,0,11]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,D){if(!S)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function C(S,D="Unreachable"){throw new Error(D)}e.assertNever=C;function P(S){if(!S)throw new u.BugIndicatingError("Assertion Failed")}e.assert=P;function y(S){if(!S()){debugger;S(),(0,u.onUnexpectedError)(new u.BugIndicatingError("Assertion Failed"))}}e.assertFn=y;function I(S,D){let A=0;for(;A<S.length-1;){const k=S[A],E=S[A+1];if(!D(k,E))return!1;A++}return!0}e.checkAdjacentItems=I}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(t){const C=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(C,arguments)),y}}e.once=u}),define(De[97],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(De[61],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(t){function C(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=C;const P=Object.freeze([]);function y(){return P}t.empty=y;function*I(d){yield d}t.single=I;function S(d){return d||P}t.from=S;function D(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=D;function A(d){return d[Symbol.iterator]().next().value}t.first=A;function k(d,o){for(const i of d)if(o(i))return!0;return!1}t.some=k;function E(d,o){for(const i of d)if(o(i))return i}t.find=E;function*T(d,o){for(const i of d)o(i)&&(yield i)}t.filter=T;function*_(d,o){let i=0;for(const s of d)yield o(s,i++)}t.map=_;function*g(...d){for(const o of d)for(const i of o)yield i}t.concat=g;function*p(d){for(const o of d)for(const i of o)yield i}t.concatNested=p;function m(d,o,i){let s=i;for(const l of d)s=o(s,l);return s}t.reduce=m;function b(d,o){let i=0;for(const s of d)o(s,i++)}t.forEach=b;function*f(d,o,i=d.length){for(o<0&&(o+=d.length),i<0?i+=d.length:i>d.length&&(i=d.length);o<i;o++)yield d[o]}t.slice=f;function c(d,o=Number.POSITIVE_INFINITY){const i=[];if(o===0)return[i,d];const s=d[Symbol.iterator]();for(let l=0;l<o;l++){const n=s.next();if(n.done)return[i,t.empty()];i.push(n.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=c;function v(d){return c(d)[0]}t.collect=v;function a(d,o,i=(s,l)=>s===l){const s=d[Symbol.iterator](),l=o[Symbol.iterator]();for(;;){const n=s.next(),r=l.next();if(n.done!==r.done)return!1;if(n.done)return!0;if(!i(n.value,r.value))return!1}}t.equals=a})(u=e.Iterable||(e.Iterable={}))}),define(De[143],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var t;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(a){a.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(a,d=!1){let o=0;const i=a.length;let s="",l=0,n=16,r=0;function h(H){let N=0,V=0;for(;N<H;){const U=a.charCodeAt(o);if(U>=48&&U<=57)V=V*16+U-48;else if(U>=65&&U<=70)V=V*16+U-65+10;else if(U>=97&&U<=102)V=V*16+U-97+10;else break;o++,N++}return N<H&&(V=-1),V}function w(H){o=H,s="",l=0,n=16,r=0}function L(){const H=o;if(a.charCodeAt(o)===48)o++;else for(o++;o<a.length&&D(a.charCodeAt(o));)o++;if(o<a.length&&a.charCodeAt(o)===46)if(o++,o<a.length&&D(a.charCodeAt(o)))for(o++;o<a.length&&D(a.charCodeAt(o));)o++;else return r=3,a.substring(H,o);let N=o;if(o<a.length&&(a.charCodeAt(o)===69||a.charCodeAt(o)===101))if(o++,(o<a.length&&a.charCodeAt(o)===43||a.charCodeAt(o)===45)&&o++,o<a.length&&D(a.charCodeAt(o))){for(o++;o<a.length&&D(a.charCodeAt(o));)o++;N=o}else r=3;return a.substring(H,N)}function M(){let H="",N=o;for(;;){if(o>=i){H+=a.substring(N,o),r=2;break}const V=a.charCodeAt(o);if(V===34){H+=a.substring(N,o),o++;break}if(V===92){if(H+=a.substring(N,o),o++,o>=i){r=2;break}switch(a.charCodeAt(o++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:{const F=h(4);F>=0?H+=String.fromCharCode(F):r=4;break}default:r=5}N=o;continue}if(V>=0&&V<=31)if(S(V)){H+=a.substring(N,o),r=2;break}else r=6;o++}return H}function B(){if(s="",r=0,l=o,o>=i)return l=i,n=17;let H=a.charCodeAt(o);if(I(H)){do o++,s+=String.fromCharCode(H),H=a.charCodeAt(o);while(I(H));return n=15}if(S(H))return o++,s+=String.fromCharCode(H),H===13&&a.charCodeAt(o)===10&&(o++,s+=`
`),n=14;switch(H){case 123:return o++,n=1;case 125:return o++,n=2;case 91:return o++,n=3;case 93:return o++,n=4;case 58:return o++,n=6;case 44:return o++,n=5;case 34:return o++,s=M(),n=10;case 47:{const N=o-1;if(a.charCodeAt(o+1)===47){for(o+=2;o<i&&!S(a.charCodeAt(o));)o++;return s=a.substring(N,o),n=12}if(a.charCodeAt(o+1)===42){o+=2;const V=i-1;let U=!1;for(;o<V;){if(a.charCodeAt(o)===42&&a.charCodeAt(o+1)===47){o+=2,U=!0;break}o++}return U||(o++,r=1),s=a.substring(N,o),n=13}return s+=String.fromCharCode(H),o++,n=16}case 45:if(s+=String.fromCharCode(H),o++,o===i||!D(a.charCodeAt(o)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=L(),n=11;default:for(;o<i&&R(H);)o++,H=a.charCodeAt(o);if(l!==o){switch(s=a.substring(l,o),s){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return s+=String.fromCharCode(H),o++,n=16}}function R(H){if(I(H)||S(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let H;do H=B();while(H>=12&&H<=15);return H}return{setPosition:w,getPosition:()=>o,scan:d?z:B,getToken:()=>n,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>o-l,getTokenError:()=>r}}e.createScanner=y;function I(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function S(a){return a===10||a===13||a===8232||a===8233}function D(a){return a>=48&&a<=57}var A;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(A||(A={}));function k(a,d){const o=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function r(h,w,L,M){l.value=h,l.offset=w,l.length=L,l.type=M,l.colonOffset=void 0,s=l}try{f(a,{onObjectBegin:(h,w)=>{if(d<=h)throw i;s=void 0,n=d>h,o.push("")},onObjectProperty:(h,w,L)=>{if(d<w||(r(h,w,L,"property"),o[o.length-1]=h,d<=w+L))throw i},onObjectEnd:(h,w)=>{if(d<=h)throw i;s=void 0,o.pop()},onArrayBegin:(h,w)=>{if(d<=h)throw i;s=void 0,o.push(0)},onArrayEnd:(h,w)=>{if(d<=h)throw i;s=void 0,o.pop()},onLiteralValue:(h,w,L)=>{if(d<w||(r(h,w,L,v(h)),d<=w+L))throw i},onSeparator:(h,w,L)=>{if(d<=w)throw i;if(h===":"&&s&&s.type==="property")s.colonOffset=w,n=!1,s=void 0;else if(h===","){const M=o[o.length-1];typeof M=="number"?o[o.length-1]=M+1:(n=!0,o[o.length-1]=""),s=void 0}}})}catch(h){if(h!==i)throw h}return{path:o,previousNode:s,isAtPropertyKey:n,matches:h=>{let w=0;for(let L=0;w<h.length&&L<o.length;L++)if(h[w]===o[L]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.getLocation=k;function E(a,d=[],o=P.DEFAULT){let i=null,s=[];const l=[];function n(h){Array.isArray(s)?s.push(h):i!==null&&(s[i]=h)}return f(a,{onObjectBegin:()=>{const h={};n(h),l.push(s),s=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const h=[];n(h),l.push(s),s=h,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:n,onError:(h,w,L)=>{d.push({error:h,offset:w,length:L})}},o),s[0]}e.parse=E;function T(a,d=[],o=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function l(h){return i.children.push(h),h}f(a,{onObjectBegin:h=>{i=l({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,w,L)=>{i=l({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:w,length:L,parent:i})},onObjectEnd:(h,w)=>{i.length=h+w-i.offset,i=i.parent,s(h+w)},onArrayBegin:(h,w)=>{i=l({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,w)=>{i.length=h+w-i.offset,i=i.parent,s(h+w)},onLiteralValue:(h,w,L)=>{l({type:v(h),offset:w,length:L,parent:i,value:h}),s(w+L)},onSeparator:(h,w,L)=>{i.type==="property"&&(h===":"?i.colonOffset=w:h===","&&s(w))},onError:(h,w,L)=>{d.push({error:h,offset:w,length:L})}},o);const r=i.children[0];return r&&delete r.parent,r}e.parseTree=T;function _(a,d){if(!a)return;let o=a;for(const i of d)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const l of o.children)if(Array.isArray(l.children)&&l.children[0].value===i){o=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}e.findNodeAtLocation=_;function g(a){if(!a.parent||!a.parent.children)return[];const d=g(a.parent);if(a.parent.type==="property"){const o=a.parent.children[0].value;d.push(o)}else if(a.parent.type==="array"){const o=a.parent.children.indexOf(a);o!==-1&&d.push(o)}return d}e.getNodePath=g;function p(a){switch(a.type){case"array":return a.children.map(p);case"object":{const d=Object.create(null);for(const o of a.children){const i=o.children[1];i&&(d[o.children[0].value]=p(i))}return d}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=p;function m(a,d,o=!1){return d>=a.offset&&d<a.offset+a.length||o&&d===a.offset+a.length}e.contains=m;function b(a,d,o=!1){if(m(a,d,o)){const i=a.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=d;s++){const l=b(i[s],d,o);if(l)return l}return a}}e.findNodeAtOffset=b;function f(a,d,o=P.DEFAULT){const i=y(a,!1);function s(ee){return ee?()=>ee(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(ee){return ee?he=>ee(he,i.getTokenOffset(),i.getTokenLength()):()=>!0}const n=s(d.onObjectBegin),r=l(d.onObjectProperty),h=s(d.onObjectEnd),w=s(d.onArrayBegin),L=s(d.onArrayEnd),M=l(d.onLiteralValue),B=l(d.onSeparator),R=s(d.onComment),z=l(d.onError),H=o&&o.disallowComments,N=o&&o.allowTrailingComma;function V(){for(;;){const ee=i.scan();switch(i.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:H||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ee){case 12:case 13:H?U(10):R();break;case 16:U(1);break;case 15:case 14:break;default:return ee}}}function U(ee,he=[],Y=[]){if(z(ee),he.length+Y.length>0){let me=i.getToken();for(;me!==17;){if(he.indexOf(me)!==-1){V();break}else if(Y.indexOf(me)!==-1)break;me=V()}}}function F(ee){const he=i.getTokenValue();return ee?M(he):r(he),V(),!0}function x(){switch(i.getToken()){case 11:{let ee=0;try{ee=JSON.parse(i.getTokenValue()),typeof ee!="number"&&(U(2),ee=0)}catch{U(2)}M(ee);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return V(),!0}function $(){return i.getToken()!==10?(U(3,[],[2,5]),!1):(F(!1),i.getToken()===6?(B(":"),V(),de()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Q(){n(),V();let ee=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ee||U(4,[],[]),B(","),V(),i.getToken()===2&&N)break}else ee&&U(6,[],[]);$()||U(4,[],[2,5]),ee=!0}return h(),i.getToken()!==2?U(7,[2],[]):V(),!0}function K(){w(),V();let ee=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ee||U(4,[],[]),B(","),V(),i.getToken()===4&&N)break}else ee&&U(6,[],[]);de()||U(4,[],[4,5]),ee=!0}return L(),i.getToken()!==4?U(8,[4],[]):V(),!0}function de(){switch(i.getToken()){case 3:return K();case 1:return Q();case 10:return F(!0);default:return x()}}return V(),i.getToken()===17?o.allowEmptyContent?!0:(U(4,[],[]),!1):de()?(i.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=f;function c(a,d){const o=y(a),i=[];let s,l=0,n;do switch(n=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:l!==n&&i.push(a.substring(l,n)),d!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,d)),l=o.getPosition();break}while(s!==17);return i.join("")}e.stripComments=c;function v(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(De[78],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new u(()=>C(this.getValue()))}}e.Lazy=u}),define(De[6],Ie([1,0,60,61]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let P=null;function y(l){P=l}if(e.setDisposableTracker=y,C){const l="__is_disposable_tracked__";y(new class{trackDisposable(n){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[l]||console.log(r)},3e3)}setParent(n,r){if(n&&n!==b.None)try{n[l]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[l]=!0}catch{}}markAsSingleton(n){}})}function I(l){return P?.trackDisposable(l),l}function S(l){P?.markAsDisposed(l)}function D(l,n){P?.setParent(l,n)}function A(l,n){if(!!P)for(const r of l)P.setParent(r,n)}function k(l){return P?.markAsSingleton(l),l}e.markAsSingleton=k;function E(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=E;function T(l){if(t.Iterable.is(l)){const n=[];for(const r of l)if(r)try{r.dispose()}catch(h){n.push(h)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=T;function _(l){for(const n of l)E(n)&&n.dispose();return[]}e.disposeIfDisposable=_;function g(...l){const n=p(()=>T(l));return A(l,n),n}e.combinedDisposable=g;function p(l){const n=I({dispose:(0,u.once)(()=>{S(n),l()})});return n}e.toDisposable=p;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{T(this._toDispose)}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return D(n,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new m,I(this),D(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&D(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&D(n,null),n}}e.MutableDisposable=f;class c{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(n){let r=n;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,S(this))},this}}e.SafeDisposable=v;class a{constructor(){this.references=new Map}acquire(n,...r){let h=this.references.get(n);h||(h={counter:0,object:this.createReferencedObject(n,...r)},this.references.set(n,h));const{object:w}=h,L=(0,u.once)(()=>{--h.counter===0&&(this.destroyReferencedObject(n,h.object),this.references.delete(n))});return h.counter++,{object:w,dispose:L}}}e.ReferenceCollection=a;class d{constructor(n){this.referenceCollection=n}async acquire(n,...r){const h=this.referenceCollection.acquire(n,...r);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(w){throw h.dispose(),w}}}e.AsyncReferenceCollection=d;class o{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=o;function i(l){const n=new m;try{l(n)}finally{n.dispose()}}e.disposeOnReturn=i;class s{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){S(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{T(this._store.values())}finally{this._store.clear()}}has(n){return this._store.has(n)}get(n){return this._store.get(n)}set(n,r,h=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this._store.get(n)?.dispose(),this._store.set(n,r)}deleteAndDispose(n){this._store.get(n)?.dispose(),this._store.delete(n)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(De[62],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(P){this.element=P,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class t{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let P=this._first;for(;P!==u.Undefined;){const y=P.next;P.prev=u.Undefined,P.next=u.Undefined,P=y}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const I=new u(P);if(this._first===u.Undefined)this._first=I,this._last=I;else if(y){const D=this._last;this._last=I,I.prev=D,D.next=I}else{const D=this._first;this._first=I,I.next=D,D.prev=I}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(I))}}shift(){if(this._first!==u.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==u.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==u.Undefined&&P.next!==u.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===u.Undefined&&P.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):P.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):P.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==u.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[144],Ie([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var ge=0;ge<le.length;ge++){var Z=le[ge];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function u(oe,le,ge){return le&&e(oe.prototype,le),ge&&e(oe,ge),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return C(oe,le);var ge=Object.prototype.toString.call(oe).slice(8,-1);if(ge==="Object"&&oe.constructor&&(ge=oe.constructor.name),ge==="Map"||ge==="Set")return Array.from(oe);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return C(oe,le)}}function C(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var ge=0,Z=new Array(le);ge<le;ge++)Z[ge]=oe[ge];return Z}function P(oe,le){var ge=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(ge)return(ge=ge.call(oe)).next.bind(ge);if(Array.isArray(oe)||(ge=t(oe))||le&&oe&&typeof oe.length=="number"){ge&&(oe=ge);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=y();function I(oe){J.defaults=oe}var S=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return E[le]};function _(oe,le){if(le){if(S.test(oe))return oe.replace(D,T)}else if(A.test(oe))return oe.replace(k,T);return oe}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(oe){return oe.replace(g,function(le,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var m=/(^|[^\[])\^/g;function b(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var ge={replace:function(ae,ne){return ne=ne.source||ne,ne=ne.replace(m,"$1"),oe=oe.replace(ae,ne),ge},getRegex:function(){return new RegExp(oe,le)}};return ge}var f=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(oe,le,ge){if(oe){var Z;try{Z=decodeURIComponent(p(ge)).replace(f,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!c.test(ge)&&(ge=s(le,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var a={},d=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(oe,le){a[" "+oe]||(d.test(oe)?a[" "+oe]=oe+"/":a[" "+oe]=h(oe,"/",!0)),oe=a[" "+oe];var ge=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?ge?le:oe.replace(o,"$1")+le:le.charAt(0)==="/"?ge?le:oe.replace(i,"$1")+le:oe+le}var l={exec:function(){}};function n(oe){for(var le=1,ge,Z;le<arguments.length;le++){ge=arguments[le];for(Z in ge)Object.prototype.hasOwnProperty.call(ge,Z)&&(oe[Z]=ge[Z])}return oe}function r(oe,le){var ge=oe.replace(/\|/g,function(ne,ie,O){for(var j=!1,G=ie;--G>=0&&O[G]==="\\";)j=!j;return j?"|":" |"}),Z=ge.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function h(oe,le,ge){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ne=oe.charAt(Z-ae-1);if(ne===le&&!ge)ae++;else if(ne!==le&&ge)ae++;else break}return oe.slice(0,Z-ae)}function w(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var ge=oe.length,Z=0,ae=0;ae<ge;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function L(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,le){if(le<1)return"";for(var ge="";le>1;)le&1&&(ge+=oe),le>>=1,oe+=oe;return ge+oe}function B(oe,le,ge,Z){var ae=le.href,ne=le.title?_(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var O={type:"link",raw:ge,href:ae,title:ne,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,O}return{type:"image",raw:ge,href:ae,title:ne,text:_(ie)}}function R(oe,le){var ge=oe.match(/^(\s+)(?:```)/);if(ge===null)return le;var Z=ge[1];return le.split(`
`).map(function(ae){var ne=ae.match(/^\s+/);if(ne===null)return ae;var ie=ne[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var z=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ne=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:h(ne,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ne=ae[0],ie=R(ne,ae[3]||"");return{type:"code",raw:ne,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ne=ae[2].trim();if(/#$/.test(ne)){var ie=h(ne,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ne=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ne=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ne,ie,O,j,G,X,pe,we,ce,Ce,ye,We,qe=ae[1].trim(),Ze=qe.length>1,Ye={type:"list",raw:"",ordered:Ze,start:Ze?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Ze?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Ze?qe:"[*+-]");for(var Ne=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(We=!1,!(!(ae=Ne.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ae[0],Z=Z.substring(ne.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(j=2,ye=we.trimLeft()):(j=ae[2].search(/[^ ]/),j=j>4?1:j,ye=we.slice(j),j+=ae[1].length),X=!1,!we&&/^ *$/.test(ce)&&(ne+=ce+`
`,Z=Z.substring(ce.length+1),We=!0),!We)for(var at=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,j-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,j-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,j-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],we=Ce,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||at.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=j||!we.trim())ye+=`
`+we.slice(j);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ne+=Ce+`
`,Z=Z.substring(Ce.length+1)}Ye.loose||(pe?Ye.loose=!0:/\n *\n *$/.test(ne)&&(pe=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(O=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ne,task:!!ie,checked:O,loose:!1,text:ye}),Ye.raw+=ne}Ye.items[Ye.items.length-1].raw=ne.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Ve=Ye.items.length;for(G=0;G<Ve;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var fe=Ye.items[G].tokens.filter(function(Le){return Le.type==="space"}),Ae=fe.every(function(Le){for(var Me=Le.raw.split(""),Ke=0,Je=P(Me),st;!(st=Je()).done;){var ot=st.value;if(ot===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&fe.length&&Ae&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ne={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):_(ae[0]);ne.type="paragraph",ne.text=ie,ne.tokens=this.lexer.inline(ie)}return ne}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ne=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ne={type:"table",header:r(ae[1]).map(function(pe){return{text:pe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ae[0];var ie=ne.align.length,O,j,G,X;for(O=0;O<ie;O++)/^ *-+: *$/.test(ne.align[O])?ne.align[O]="right":/^ *:-+: *$/.test(ne.align[O])?ne.align[O]="center":/^ *:-+ *$/.test(ne.align[O])?ne.align[O]="left":ne.align[O]=null;for(ie=ne.rows.length,O=0;O<ie;O++)ne.rows[O]=r(ne.rows[O],ne.header.length).map(function(pe){return{text:pe}});for(ie=ne.header.length,j=0;j<ie;j++)ne.header[j].tokens=this.lexer.inline(ne.header[j].text);for(ie=ne.rows.length,j=0;j<ie;j++)for(X=ne.rows[j],G=0;G<X.length;G++)X[G].tokens=this.lexer.inline(X[G].text);return ne}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ne=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:_(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):_(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ne=ae[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ie=h(ne.slice(0,-1),"\\");if((ne.length-ie.length)%2===0)return}else{var O=w(ae[2],"()");if(O>-1){var j=ae[0].indexOf("!")===0?5:4,G=j+ae[1].length+O;ae[2]=ae[2].substring(0,O),ae[0]=ae[0].substring(0,G).trim(),ae[3]=""}}var X=ae[2],pe="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],pe=we[3])}else pe=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ne)?X=X.slice(1):X=X.slice(1,-1)),B(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var ie=(ne[2]||ne[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var O=ne[0].charAt(0);return{type:"text",raw:O,text:O}}return B(ne,ie,ne[0],this.lexer)}},le.emStrong=function(Z,ae,ne){ne===void 0&&(ne="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ie[1]||ie[2]||"";if(!O||O&&(ne===""||this.rules.inline.punctuation.exec(ne))){var j=ie[0].length-1,G,X,pe=j,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+j);(ie=ce.exec(ae))!=null;)if(G=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!G){if(X=G.length,ie[3]||ie[4]){pe+=X;continue}else if((ie[5]||ie[6])&&j%3&&!((j+X)%3)){we+=X;continue}if(pe-=X,!(pe>0)){if(X=Math.min(X,X+pe+we),Math.min(j,X)%2){var Ce=Z.slice(1,j+ie.index+X);return{type:"em",raw:Z.slice(0,j+ie.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ye=Z.slice(2,j+ie.index+X-1);return{type:"strong",raw:Z.slice(0,j+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ne=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ne),O=/^ /.test(ne)&&/ $/.test(ne);return ie&&O&&(ne=ne.substring(1,ne.length-1)),ne=_(ne,!0),{type:"codespan",raw:ae[0],text:ne}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ne=this.rules.inline.autolink.exec(Z);if(ne){var ie,O;return ne[2]==="@"?(ie=_(this.options.mangle?ae(ne[1]):ne[1]),O="mailto:"+ie):(ie=_(ne[1]),O=ie),{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ne;if(ne=this.rules.inline.url.exec(Z)){var ie,O;if(ne[2]==="@")ie=_(this.options.mangle?ae(ne[0]):ne[0]),O="mailto:"+ie;else{var j;do j=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(j!==ne[0]);ie=_(ne[0]),ne[1]==="www."?O="http://"+ie:O=ie}return{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ne=this.rules.inline.text.exec(Z);if(ne){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):_(ne[0]):ne[0]:ie=_(this.options.smartypants?ae(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ie}}},oe}(),H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=b(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.listItemStart=b(/^( *)(bull) */).replace("bull",H.bullet).getRegex(),H.list=b(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=b(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=b(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.blockquote=b(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=n({},H),H.gfm=n({},H.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.table=b(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.gfm.paragraph=b(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",H.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.pedantic=n({},H.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:b(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=b(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=b(H._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=b(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=b(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=b(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=b(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=b(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=b(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=b(N.reflink).replace("label",N._label).replace("ref",H._label).getRegex(),N.nolink=b(N.nolink).replace("ref",H._label).getRegex(),N.reflinkSearch=b(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=n({},N),N.pedantic=n({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=n({},N.normal,{escape:b(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=b(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=n({},N.gfm,{br:b(N.br).replace("{2,}","*").getRegex(),text:b(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(oe){var le="",ge,Z,ae=oe.length;for(ge=0;ge<ae;ge++)Z=oe.charCodeAt(ge),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var F=function(){function oe(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||J.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:H.normal,inline:N.normal};this.options.pedantic?(Z.block=H.pedantic,Z.inline=N.pedantic):this.options.gfm&&(Z.block=H.gfm,this.options.breaks?Z.inline=N.breaks:Z.inline=N.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ne=new oe(ae);return ne.lex(Z)},oe.lexInline=function(Z,ae){var ne=new oe(ae);return ne.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(pe,we,ce){return we+"    ".repeat(ce.length)});for(var ie,O,j,G;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(ie=pe.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,we=Z.slice(1),ce=void 0;ne.options.extensions.startBlock.forEach(function(Ce){ce=Ce.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(pe=Math.min(pe,ce))}),pe<1/0&&pe>=0&&(j=Z.substring(0,pe+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(j))){O=ae[ae.length-1],G&&O.type==="paragraph"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie),G=j.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]);var ie,O,j,G=Z,X,pe,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)ce.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(pe||(we=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,G,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,U)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,U))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(j=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,We=Z.slice(1),qe=void 0;ne.options.extensions.startInline.forEach(function(Ze){qe=Ze.call({lexer:this},We),typeof qe=="number"&&qe>=0&&(ye=Math.min(ye,qe))}),ye<1/0&&ye>=0&&(j=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(j,V)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),pe=!0,O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},u(oe,null,[{key:"rules",get:function(){return{block:H,inline:N}}}]),oe}(),x=function(){function oe(ge){this.options=ge||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ne){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(Z,ie);O!=null&&O!==Z&&(ne=!0,Z=O)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+_(ie,!0)+'">'+(ne?Z:_(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:_(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ne,ie){if(this.options.headerIds){var O=this.options.headerPrefix+ie.slug(ne);return"<h"+ae+' id="'+O+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ne){var ie=ae?"ol":"ul",O=ae&&ne!==1?' start="'+ne+'"':"";return"<"+ie+O+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ne=ae.header?"th":"td",ie=ae.align?"<"+ne+' align="'+ae.align+'">':"<"+ne+">";return ie+Z+("</"+ne+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ne){if(Z=v(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<a href="'+_(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ne+"</a>",ie},le.image=function(Z,ae,ne){if(Z=v(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<img src="'+Z+'" alt="'+ne+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),$=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ne){return""+ne},le.image=function(Z,ae,ne){return""+ne},le.br=function(){return""},oe}(),Q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ne=Z,ie=0;if(this.seen.hasOwnProperty(ne)){ie=this.seen[Z];do ie++,ne=Z+"-"+ie;while(this.seen.hasOwnProperty(ne))}return ae||(this.seen[Z]=ie,this.seen[ne]=0),ne},le.slug=function(Z,ae){ae===void 0&&(ae={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ae.dryrun)},oe}(),K=function(){function oe(ge){this.options=ge||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $,this.slugger=new Q}oe.parse=function(Z,ae){var ne=new oe(ae);return ne.parse(Z)},oe.parseInline=function(Z,ae){var ne=new oe(ae);return ne.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ne="",ie,O,j,G,X,pe,we,ce,Ce,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve=Z.length;for(ie=0;ie<Ve;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ne+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,p(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",G=ye.header.length,O=0;O<G;O++)we+=this.renderer.tablecell(this.parseInline(ye.header[O].tokens),{header:!0,align:ye.align[O]});for(ce+=this.renderer.tablerow(we),Ce="",G=ye.rows.length,O=0;O<G;O++){for(pe=ye.rows[O],we="",X=pe.length,j=0;j<X;j++)we+=this.renderer.tablecell(this.parseInline(pe[j].tokens),{header:!1,align:ye.align[j]});Ce+=this.renderer.tablerow(we)}ne+=this.renderer.table(ce,Ce);continue}case"blockquote":{Ce=this.parse(ye.tokens),ne+=this.renderer.blockquote(Ce);continue}case"list":{for(We=ye.ordered,qe=ye.start,Ze=ye.loose,G=ye.items.length,Ce="",O=0;O<G;O++)Ne=ye.items[O],at=Ne.checked,re=Ne.task,Ye="",Ne.task&&(se=this.renderer.checkbox(at),Ze?Ne.tokens.length>0&&Ne.tokens[0].type==="paragraph"?(Ne.tokens[0].text=se+" "+Ne.tokens[0].text,Ne.tokens[0].tokens&&Ne.tokens[0].tokens.length>0&&Ne.tokens[0].tokens[0].type==="text"&&(Ne.tokens[0].tokens[0].text=se+" "+Ne.tokens[0].tokens[0].text)):Ne.tokens.unshift({type:"text",text:se}):Ye+=se),Ye+=this.parse(Ne.tokens,Ze),Ce+=this.renderer.listitem(Ye,re,at);ne+=this.renderer.list(Ce,We,qe);continue}case"html":{ne+=this.renderer.html(ye.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ce=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<Ve&&Z[ie+1].type==="text";)ye=Z[++ie],Ce+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ne+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var fe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return ne},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ne="",ie,O,j,G=Z.length;for(ie=0;ie<G;ie++){if(O=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(j=this.options.extensions.renderers[O.type].call({parser:this},O),j!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){ne+=j||"";continue}switch(O.type){case"escape":{ne+=ae.text(O.text);break}case"html":{ne+=ae.html(O.text);break}case"link":{ne+=ae.link(O.href,O.title,this.parseInline(O.tokens,ae));break}case"image":{ne+=ae.image(O.href,O.title,O.text);break}case"strong":{ne+=ae.strong(this.parseInline(O.tokens,ae));break}case"em":{ne+=ae.em(this.parseInline(O.tokens,ae));break}case"codespan":{ne+=ae.codespan(O.text);break}case"br":{ne+=ae.br();break}case"del":{ne+=ae.del(this.parseInline(O.tokens,ae));break}case"text":{ne+=ae.text(O.text);break}default:{var X='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ne},oe}();function de(oe,le,ge){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(ge=le,le=null),le=n({},de.defaults,le||{}),L(le),ge){var Z=le.highlight,ae;try{ae=F.lex(oe,le)}catch(G){return ge(G)}var ne=function(X){var pe;if(!X)try{le.walkTokens&&de.walkTokens(ae,le.walkTokens),pe=K.parse(ae,le)}catch(we){X=we}return le.highlight=Z,X?ge(X):ge(null,pe)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ne();var ie=0;de.walkTokens(ae,function(G){G.type==="code"&&(ie++,setTimeout(function(){Z(G.text,G.lang,function(X,pe){if(X)return ne(X);pe!=null&&pe!==G.text&&(G.text=pe,G.escaped=!0),ie--,ie===0&&ne()})},0))}),ie===0&&ne();return}function O(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+_(G.message+"",!0)+"</pre>";throw G}try{var j=F.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(de.walkTokens(j,le.walkTokens)).then(function(){return K.parse(j,le)}).catch(O);de.walkTokens(j,le.walkTokens)}return K.parse(j,le)}catch(G){O(G)}}de.options=de.setOptions=function(oe){return n(de.defaults,oe),I(de.defaults),de},de.getDefaults=y,de.defaults=J.defaults,de.use=function(){for(var oe=arguments.length,le=new Array(oe),ge=0;ge<oe;ge++)le[ge]=arguments[ge];var Z=n.apply(void 0,[{}].concat(le)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(ie){if(ie.extensions&&(ne=!0,ie.extensions.forEach(function(j){if(!j.name)throw new Error("extension name required");if(j.renderer){var G=ae.renderers?ae.renderers[j.name]:null;G?ae.renderers[j.name]=function(){for(var X=arguments.length,pe=new Array(X),we=0;we<X;we++)pe[we]=arguments[we];var ce=j.renderer.apply(this,pe);return ce===!1&&(ce=G.apply(this,pe)),ce}:ae.renderers[j.name]=j.renderer}if(j.tokenizer){if(!j.level||j.level!=="block"&&j.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[j.level]?ae[j.level].unshift(j.tokenizer):ae[j.level]=[j.tokenizer],j.start&&(j.level==="block"?ae.startBlock?ae.startBlock.push(j.start):ae.startBlock=[j.start]:j.level==="inline"&&(ae.startInline?ae.startInline.push(j.start):ae.startInline=[j.start]))}j.childTokens&&(ae.childTokens[j.name]=j.childTokens)})),ie.renderer&&function(){var j=de.defaults.renderer||new x,G=function(we){var ce=j[we];j[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),We=0;We<Ce;We++)ye[We]=arguments[We];var qe=ie.renderer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.renderer)G(X);Z.renderer=j}(),ie.tokenizer&&function(){var j=de.defaults.tokenizer||new z,G=function(we){var ce=j[we];j[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),We=0;We<Ce;We++)ye[We]=arguments[We];var qe=ie.tokenizer[we].apply(j,ye);return qe===!1&&(qe=ce.apply(j,ye)),qe}};for(var X in ie.tokenizer)G(X);Z.tokenizer=j}(),ie.walkTokens){var O=de.defaults.walkTokens;Z.walkTokens=function(j){var G=[];return G.push(ie.walkTokens.call(this,j)),O&&(G=G.concat(O.call(this,j))),G}}ne&&(Z.extensions=ae),de.setOptions(Z)})},de.walkTokens=function(oe,le){for(var ge=[],Z=function(){var O=ne.value;switch(ge=ge.concat(le.call(de,O)),O.type){case"table":{for(var j=P(O.header),G;!(G=j()).done;){var X=G.value;ge=ge.concat(de.walkTokens(X.tokens,le))}for(var pe=P(O.rows),we;!(we=pe()).done;)for(var ce=we.value,Ce=P(ce),ye;!(ye=Ce()).done;){var We=ye.value;ge=ge.concat(de.walkTokens(We.tokens,le))}break}case"list":{ge=ge.concat(de.walkTokens(O.items,le));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[O.type]?de.defaults.extensions.childTokens[O.type].forEach(function(qe){ge=ge.concat(de.walkTokens(O[qe],le))}):O.tokens&&(ge=ge.concat(de.walkTokens(O.tokens,le)))}},ae=P(oe),ne;!(ne=ae()).done;)Z();return ge},de.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=n({},de.defaults,le||{}),L(le);try{var ge=F.lexInline(oe,le);return le.walkTokens&&de.walkTokens(ge,le.walkTokens),K.parseInline(ge,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+_(Z.message+"",!0)+"</pre>";throw Z}},de.Parser=K,de.parser=K.parse,de.Renderer=x,de.TextRenderer=$,de.Lexer=F,de.lexer=F.lex,de.Tokenizer=z,de.Slugger=Q,de.parse=de;var ee=de.options,he=de.setOptions,Y=de.use,me=de.walkTokens,be=de.parseInline,ke=de,Re=K.parse,ze=F.lex;J.Lexer=F,J.Parser=K,J.Renderer=x,J.Slugger=Q,J.TextRenderer=$,J.Tokenizer=z,J.getDefaults=y,J.lexer=ze,J.marked=de,J.options=ee,J.parse=ke,J.parseInline=be,J.parser=Re,J.setOptions=he,J.use=Y,J.walkTokens=me,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[98],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(I,S,D){return Math.min(Math.max(I,S),D)}e.clamp=u;function t(I,S){return(S+I%S)%S}e.rot=t;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class P{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const D=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=D,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function J(C){const P=[];typeof C=="number"&&P.push("code/timeOrigin",C);function y(S){P.push(S,Date.now())}function I(){const S=[];for(let D=0;D<P.length;D+=2)S.push({name:P[D],startTime:P[D+1]});return S}return{mark:y,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(C+y.startTime)});return P}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function u(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=u(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var t in u)(typeof exports=="object"?exports:J)[t]=u[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function u(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return J[t].call(C.exports,C,C.exports,u),C.l=!0,C.exports}return u.m=J,u.c=e,u.d=function(t,C,P){u.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:P})},u.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},u.t=function(t,C){if(1&C&&(t=u(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(u.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var y in t)u.d(P,y,function(I){return t[I]}.bind(null,y));return P},u.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return u.d(C,"a",C),C},u.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},u.p="",u(u.s=0)}([function(J,e,u){(function(t){var C;e=J.exports=Y,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],S=e.src=[],D=0,A=D++;S[A]="0|[1-9]\\d*";var k=D++;S[k]="[0-9]+";var E=D++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=D++;S[T]="("+S[A]+")\\.("+S[A]+")\\.("+S[A]+")";var _=D++;S[_]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var g=D++;S[g]="(?:"+S[A]+"|"+S[E]+")";var p=D++;S[p]="(?:"+S[k]+"|"+S[E]+")";var m=D++;S[m]="(?:-("+S[g]+"(?:\\."+S[g]+")*))";var b=D++;S[b]="(?:-?("+S[p]+"(?:\\."+S[p]+")*))";var f=D++;S[f]="[0-9A-Za-z-]+";var c=D++;S[c]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var v=D++,a="v?"+S[T]+S[m]+"?"+S[c]+"?";S[v]="^"+a+"$";var d="[v=\\s]*"+S[_]+S[b]+"?"+S[c]+"?",o=D++;S[o]="^"+d+"$";var i=D++;S[i]="((?:<|>)?=?)";var s=D++;S[s]=S[k]+"|x|X|\\*";var l=D++;S[l]=S[A]+"|x|X|\\*";var n=D++;S[n]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[m]+")?"+S[c]+"?)?)?";var r=D++;S[r]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[b]+")?"+S[c]+"?)?)?";var h=D++;S[h]="^"+S[i]+"\\s*"+S[n]+"$";var w=D++;S[w]="^"+S[i]+"\\s*"+S[r]+"$";var L=D++;S[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;S[M]="(?:~>?)";var B=D++;S[B]="(\\s*)"+S[M]+"\\s+",I[B]=new RegExp(S[B],"g");var R=D++;S[R]="^"+S[M]+S[n]+"$";var z=D++;S[z]="^"+S[M]+S[r]+"$";var H=D++;S[H]="(?:\\^)";var N=D++;S[N]="(\\s*)"+S[H]+"\\s+",I[N]=new RegExp(S[N],"g");var V=D++;S[V]="^"+S[H]+S[n]+"$";var U=D++;S[U]="^"+S[H]+S[r]+"$";var F=D++;S[F]="^"+S[i]+"\\s*("+d+")$|^$";var x=D++;S[x]="^"+S[i]+"\\s*("+a+")$|^$";var $=D++;S[$]="(\\s*)"+S[i]+"\\s*("+d+"|"+S[n]+")",I[$]=new RegExp(S[$],"g");var Q=D++;S[Q]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var K=D++;S[K]="^\\s*("+S[r]+")\\s+-\\s+("+S[r]+")\\s*$";var de=D++;S[de]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)C(ee,S[ee]),I[ee]||(I[ee]=new RegExp(S[ee]));function he(ce,Ce){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>P||!(Ce?I[o]:I[v]).test(ce))return null;try{return new Y(ce,Ce)}catch{return null}}function Y(ce,Ce){if(ce instanceof Y){if(ce.loose===Ce)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ce,Ce);C("SemVer",ce,Ce),this.loose=Ce;var ye=ce.trim().match(Ce?I[o]:I[v]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var qe=+We;if(qe>=0&&qe<y)return qe}return We}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=he,e.valid=function(ce,Ce){var ye=he(ce,Ce);return ye?ye.version:null},e.clean=function(ce,Ce){var ye=he(ce.trim().replace(/^[=v]+/,""),Ce);return ye?ye.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return C("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ce=0;do{var ye=this.prerelease[Ce],We=ce.prerelease[Ce];if(C("prerelease compare",Ce,ye,We),ye===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ye===void 0)return-1;if(ye!==We)return be(ye,We)}while(++Ce)},Y.prototype.inc=function(ce,Ce){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ce,ye,We){typeof ye=="string"&&(We=ye,ye=void 0);try{return new Y(ce,ye).inc(Ce,We).version}catch{return null}},e.diff=function(ce,Ce){if(oe(ce,Ce))return null;var ye=he(ce),We=he(Ce);if(ye.prerelease.length||We.prerelease.length){for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return"pre"+qe;return"prerelease"}for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return qe},e.compareIdentifiers=be;var me=/^[0-9]+$/;function be(ce,Ce){var ye=me.test(ce),We=me.test(Ce);return ye&&We&&(ce=+ce,Ce=+Ce),ye&&!We?-1:We&&!ye?1:ce<Ce?-1:ce>Ce?1:0}function ke(ce,Ce,ye){return new Y(ce,ye).compare(new Y(Ce,ye))}function Re(ce,Ce,ye){return ke(ce,Ce,ye)>0}function ze(ce,Ce,ye){return ke(ce,Ce,ye)<0}function oe(ce,Ce,ye){return ke(ce,Ce,ye)===0}function le(ce,Ce,ye){return ke(ce,Ce,ye)!==0}function ge(ce,Ce,ye){return ke(ce,Ce,ye)>=0}function Z(ce,Ce,ye){return ke(ce,Ce,ye)<=0}function ae(ce,Ce,ye,We){var qe;switch(Ce){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce!==ye;break;case"":case"=":case"==":qe=oe(ce,ye,We);break;case"!=":qe=le(ce,ye,We);break;case">":qe=Re(ce,ye,We);break;case">=":qe=ge(ce,ye,We);break;case"<":qe=ze(ce,ye,We);break;case"<=":qe=Z(ce,ye,We);break;default:throw new TypeError("Invalid operator: "+Ce)}return qe}function ne(ce,Ce){if(ce instanceof ne){if(ce.loose===Ce)return ce;ce=ce.value}if(!(this instanceof ne))return new ne(ce,Ce);C("comparator",ce,Ce),this.loose=Ce,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ce,Ce){return be(Ce,ce)},e.major=function(ce,Ce){return new Y(ce,Ce).major},e.minor=function(ce,Ce){return new Y(ce,Ce).minor},e.patch=function(ce,Ce){return new Y(ce,Ce).patch},e.compare=ke,e.compareLoose=function(ce,Ce){return ke(ce,Ce,!0)},e.rcompare=function(ce,Ce,ye){return ke(Ce,ce,ye)},e.sort=function(ce,Ce){return ce.sort(function(ye,We){return e.compare(ye,We,Ce)})},e.rsort=function(ce,Ce){return ce.sort(function(ye,We){return e.rcompare(ye,We,Ce)})},e.gt=Re,e.lt=ze,e.eq=oe,e.neq=le,e.gte=ge,e.lte=Z,e.cmp=ae,e.Comparator=ne;var ie={};function O(ce,Ce){if(ce instanceof O)return ce.loose===Ce?ce:new O(ce.raw,Ce);if(ce instanceof ne)return new O(ce.value,Ce);if(!(this instanceof O))return new O(ce,Ce);if(this.loose=Ce,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function j(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function G(ce,Ce,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve){return((Ce=j(ye)?"":j(We)?">="+ye+".0.0":j(qe)?">="+ye+"."+We+".0":">="+Ce)+" "+(Ne=j(at)?"":j(re)?"<"+(+at+1)+".0.0":j(se)?"<"+at+"."+(+re+1)+".0":Ee?"<="+at+"."+re+"."+se+"-"+Ee:"<="+Ne)).trim()}function X(ce,Ce){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ce))return!1;if(Ce.prerelease.length){for(ye=0;ye<ce.length;ye++)if(C(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var We=ce[ye].semver;if(We.major===Ce.major&&We.minor===Ce.minor&&We.patch===Ce.patch)return!0}return!1}return!0}function pe(ce,Ce,ye){try{Ce=new O(Ce,ye)}catch{return!1}return Ce.test(ce)}function we(ce,Ce,ye,We){var qe,Ze,Ye,Ne,at;switch(ce=new Y(ce,We),Ce=new O(Ce,We),ye){case">":qe=Re,Ze=Z,Ye=ze,Ne=">",at=">=";break;case"<":qe=ze,Ze=ge,Ye=Re,Ne="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ce,Ce,We))return!1;for(var re=0;re<Ce.set.length;++re){var se=Ce.set[re],Ee=null,Ve=null;if(se.forEach(function(fe){fe.semver===ie&&(fe=new ne(">=0.0.0")),Ee=Ee||fe,Ve=Ve||fe,qe(fe.semver,Ee.semver,We)?Ee=fe:Ye(fe.semver,Ve.semver,We)&&(Ve=fe)}),Ee.operator===Ne||Ee.operator===at||(!Ve.operator||Ve.operator===Ne)&&Ze(ce,Ve.semver)||Ve.operator===at&&Ye(ce,Ve.semver))return!1}return!0}ne.prototype.parse=function(ce){var Ce=this.loose?I[F]:I[x],ye=ce.match(Ce);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new Y(ye[2],this.loose):this.semver=ie},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ce){return C("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ce,Ce){if(!(ce instanceof ne))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new O(ce.value,Ce),pe(this.value,ye,Ce);if(ce.operator==="")return ye=new O(this.value,Ce),pe(ce.semver,ye,Ce);var We=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ne=ae(this.semver,"<",ce.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),at=ae(this.semver,">",ce.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return We||qe||Ze&&Ye||Ne||at},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(ce){var Ce=this.loose;ce=ce.trim(),C("range",ce,Ce);var ye=Ce?I[K]:I[Q];ce=ce.replace(ye,G),C("hyphen replace",ce),ce=ce.replace(I[$],"$1$2$3"),C("comparator trim",ce,I[$]),ce=(ce=(ce=ce.replace(I[B],"$1~")).replace(I[N],"$1^")).split(/\s+/).join(" ");var We=Ce?I[F]:I[x],qe=ce.split(" ").map(function(Ze){return function(Ye,Ne){return C("comp",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,Ve){C("caret",Ee,Ve);var fe=Ve?I[U]:I[V];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je){var st;return C("caret",Ee,Ae,Le,Me,Ke,Je),j(Le)?st="":j(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(Ke)?st=Le==="0"?">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+".0 <"+(+Le+1)+".0.0":Je?(C("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+Me+"."+(+Ke+1):">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ke+Je+" <"+(+Le+1)+".0.0"):(C("no pr"),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ke+" <"+Le+"."+Me+"."+(+Ke+1):">="+Le+"."+Me+"."+Ke+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ke+" <"+(+Le+1)+".0.0"),C("caret return",st),st})}(se,re)}).join(" ")}(Ye,Ne),C("caret",Ye),Ye=function(at,re){return at.trim().split(/\s+/).map(function(se){return function(Ee,Ve){var fe=Ve?I[z]:I[R];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je){var st;return C("tilde",Ee,Ae,Le,Me,Ke,Je),j(Le)?st="":j(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":j(Ke)?st=">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":Je?(C("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=">="+Le+"."+Me+"."+Ke+Je+" <"+Le+"."+(+Me+1)+".0"):st=">="+Le+"."+Me+"."+Ke+" <"+Le+"."+(+Me+1)+".0",C("tilde return",st),st})}(se,re)}).join(" ")}(Ye,Ne),C("tildes",Ye),Ye=function(at,re){return C("replaceXRanges",at,re),at.split(/\s+/).map(function(se){return function(Ee,Ve){Ee=Ee.trim();var fe=Ve?I[w]:I[h];return Ee.replace(fe,function(Ae,Le,Me,Ke,Je,st){C("xRange",Ee,Ae,Le,Me,Ke,Je,st);var ot=j(Me),it=ot||j(Ke),lt=it||j(Je);return Le==="="&&lt&&(Le=""),ot?Ae=Le===">"||Le==="<"?"<0.0.0":"*":Le&&lt?(it&&(Ke=0),lt&&(Je=0),Le===">"?(Le=">=",it?(Me=+Me+1,Ke=0,Je=0):lt&&(Ke=+Ke+1,Je=0)):Le==="<="&&(Le="<",it?Me=+Me+1:Ke=+Ke+1),Ae=Le+Me+"."+Ke+"."+Je):it?Ae=">="+Me+".0.0 <"+(+Me+1)+".0.0":lt&&(Ae=">="+Me+"."+Ke+".0 <"+Me+"."+(+Ke+1)+".0"),C("xRange return",Ae),Ae})}(se,re)}).join(" ")}(Ye,Ne),C("xrange",Ye),Ye=function(at,re){return C("replaceStars",at,re),at.trim().replace(I[de],"")}(Ye,Ne),C("stars",Ye),Ye}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Ze){return!!Ze.match(We)})),qe=qe.map(function(Ze){return new ne(Ze,Ce)})},O.prototype.intersects=function(ce,Ce){if(!(ce instanceof O))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(We){return ce.set.some(function(qe){return qe.every(function(Ze){return We.intersects(Ze,Ce)})})})})},e.toComparators=function(ce,Ce){return new O(ce,Ce).set.map(function(ye){return ye.map(function(We){return We.value}).join(" ").trim().split(" ")})},O.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(X(this.set[Ce],ce))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ce,Ce,ye){var We=null,qe=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==-1||(qe=new Y(We=Ye,ye)))}),We},e.minSatisfying=function(ce,Ce,ye){var We=null,qe=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==1||(qe=new Y(We=Ye,ye)))}),We},e.validRange=function(ce,Ce){try{return new O(ce,Ce).range||"*"}catch{return null}},e.ltr=function(ce,Ce,ye){return we(ce,Ce,"<",ye)},e.gtr=function(ce,Ce,ye){return we(ce,Ce,">",ye)},e.outside=we,e.prerelease=function(ce,Ce){var ye=he(ce,Ce);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ce,ye){return ce=new O(ce,ye),Ce=new O(Ce,ye),ce.intersects(Ce)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var Ce=ce.match(I[L]);return Ce==null?null:he((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,u(1))},function(J,e){var u,t,C=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function I(p){if(u===setTimeout)return setTimeout(p,0);if((u===P||!u)&&setTimeout)return u=setTimeout,setTimeout(p,0);try{return u(p,0)}catch{try{return u.call(null,p,0)}catch{return u.call(this,p,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:P}catch{u=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var S,D=[],A=!1,k=-1;function E(){A&&S&&(A=!1,S.length?D=S.concat(D):k=-1,D.length&&T())}function T(){if(!A){var p=I(E);A=!0;for(var m=D.length;m;){for(S=D,D=[];++k<m;)S&&S[k].run();k=-1,m=D.length}S=null,A=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(p)}}function _(p,m){this.fun=p,this.array=m}function g(){}C.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)m[b-1]=arguments[b];D.push(new _(p,m)),D.length!==1||A||I(T)},_.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=g,C.addListener=g,C.once=g,C.off=g,C.removeListener=g,C.removeAllListeners=g,C.emit=g,C.prependListener=g,C.prependOnceListener=g,C.listeners=function(p){return[]},C.binding=function(p){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(p){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(De[99],Ie([1,0,11,6]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(c){const v=c;return v?typeof v.read=="function":!1}e.isReadable=C;function P(c){const v=c;return v?[v.on,v.pause,v.resume,v.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=P;function y(c){const v=c;return v?P(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=y;function I(c,v){return new S(c,v)}e.newWriteableStream=I;class S{constructor(v,a){this.reducer=v,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(a=>a(v))}emitError(v){this.listeners.error.length===0?(0,u.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(a=>a(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,a){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(v,a){if(this.state.destroyed)return;let d;switch(v){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const o=d.indexOf(a);o>=0&&d.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(c,v){const a=[];let d;for(;(d=c.read())!==null;)a.push(d);return v(a)}e.consumeReadable=D;function A(c,v,a){const d=[];let o;for(;(o=c.read())!==null&&d.length<a;)d.push(o);return o===null&&d.length>0?v(d):{read:()=>{if(d.length>0)return d.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return c.read()}}}e.peekReadable=A;function k(c,v){return new Promise((a,d)=>{const o=[];E(c,{onData:i=>{v&&o.push(i)},onError:i=>{v?d(i):a(void 0)},onEnd:()=>{a(v?v(o):void 0)}})})}e.consumeStream=k;function E(c,v){let a=!1;return c.on("error",d=>{a||v.onError(d)}),c.on("end",()=>{a||v.onEnd()}),c.on("data",d=>{a||v.onData(d)}),(0,t.toDisposable)(()=>a=!0)}e.listenStream=E;function T(c,v){return new Promise((a,d)=>{const o=new t.DisposableStore,i=[],s=r=>{if(i.push(r),i.length>v)return o.dispose(),c.pause(),a({stream:c,buffer:i,ended:!1})},l=r=>d(r),n=()=>a({stream:c,buffer:i,ended:!0});o.add((0,t.toDisposable)(()=>c.removeListener("error",l))),c.on("error",l),o.add((0,t.toDisposable)(()=>c.removeListener("end",n))),c.on("end",n),o.add((0,t.toDisposable)(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=T;function _(c,v){const a=I(v);return a.end(c),a}e.toStream=_;function g(){const c=I(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=g;function p(c){let v=!1;return{read:()=>v?null:(v=!0,c)}}e.toReadable=p;function m(c,v,a){const d=I(a);return E(c,{onData:o=>d.write(v.data(o)),onError:o=>d.error(v.error?v.error(o):o),onEnd:()=>d.end()}),d}e.transform=m;function b(c,v,a){let d=!1;return{read:()=>{const o=v.read();return d?o:(d=!0,o!==null?a([c,o]):c)}}}e.prefixedReadable=b;function f(c,v,a){let d=!1;const o=I(a);return E(v,{onData:i=>d?o.write(i):(d=!0,o.write(a([c,i]))),onError:i=>o.error(i),onEnd:()=>{d||(d=!0,o.write(c)),o.end()}}),o}e.prefixedStream=f}),define(De[23],Ie([1,0,99]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,P;class y{static alloc(r){return t?new y(Buffer.allocUnsafe(r)):new y(new Uint8Array(r))}static wrap(r){return t&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new y(r)}static fromString(r,h){return!(h?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(r)):(C||(C=new TextEncoder),new y(C.encode(r)))}static fromByteArray(r){const h=y.alloc(r.length);for(let w=0,L=r.length;w<L;w++)h.buffer[w]=r[w];return h}static concat(r,h){if(typeof h>"u"){h=0;for(let M=0,B=r.length;M<B;M++)h+=r[M].byteLength}const w=y.alloc(h);let L=0;for(let M=0,B=r.length;M<B;M++){const R=r[M];w.set(R,L),L+=R.byteLength}return w}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=y.alloc(this.byteLength);return r.set(this),r}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(r,h){return new y(this.buffer.subarray(r,h))}set(r,h){if(r instanceof y)this.buffer.set(r.buffer,h);else if(r instanceof Uint8Array)this.buffer.set(r,h);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),h);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return D(this.buffer,r)}writeUInt32BE(r,h){A(this.buffer,r,h)}readUInt32LE(r){return k(this.buffer,r)}writeUInt32LE(r,h){E(this.buffer,r,h)}readUInt8(r){return T(this.buffer,r)}writeUInt8(r,h){_(this.buffer,r,h)}}e.VSBuffer=y;function I(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=I;function S(n,r,h){n[h+0]=r&255,r=r>>>8,n[h+1]=r&255}e.writeUInt16LE=S;function D(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=D;function A(n,r,h){n[h+3]=r,r=r>>>8,n[h+2]=r,r=r>>>8,n[h+1]=r,r=r>>>8,n[h]=r}e.writeUInt32BE=A;function k(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=k;function E(n,r,h){n[h+0]=r&255,r=r>>>8,n[h+1]=r&255,r=r>>>8,n[h+2]=r&255,r=r>>>8,n[h+3]=r&255}e.writeUInt32LE=E;function T(n,r){return n[r]}e.readUInt8=T;function _(n,r,h){n[h]=r}e.writeUInt8=_;function g(n){return u.consumeReadable(n,r=>y.concat(r))}e.readableToBuffer=g;function p(n){return u.toReadable(n)}e.bufferToReadable=p;function m(n){return u.consumeStream(n,r=>y.concat(r))}e.streamToBuffer=m;async function b(n){return n.ended?y.concat(n.buffer):y.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=b;function f(n){return u.toStream(n,r=>y.concat(r))}e.bufferToStream=f;function c(n){return u.transform(n,{data:r=>typeof r=="string"?y.fromString(r):y.wrap(r)},r=>y.concat(r))}e.streamToBufferReadableStream=c;function v(n){return u.newWriteableStream(r=>y.concat(r),n)}e.newWriteableBufferStream=v;function a(n,r){return u.prefixedReadable(n,r,h=>y.concat(h))}e.prefixedBufferReadable=a;function d(n,r){return u.prefixedStream(n,r,h=>y.concat(h))}e.prefixedBufferStream=d;function o(n){let r=0,h=0,w=0;const L=new Uint8Array(Math.floor(n.length/4*3)),M=R=>{switch(h){case 3:L[w++]=r|R,h=0;break;case 2:L[w++]=r|R>>>2,r=R<<6,h=3;break;case 1:L[w++]=r|R>>>4,r=R<<4,h=2;break;default:r=R<<2,h=1}};for(let R=0;R<n.length;R++){const z=n.charCodeAt(R);if(z>=65&&z<=90)M(z-65);else if(z>=97&&z<=122)M(z-97+26);else if(z>=48&&z<=57)M(z-48+52);else if(z===43||z===45)M(62);else if(z===47||z===95)M(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${n[R]}`)}}const B=w;for(;h>0;)M(0);return y.wrap(L).slice(0,B)}e.decodeBase64=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:n},r=!0,h=!1){const w=h?s:i;let L="";const M=n.byteLength%3;let B=0;for(;B<n.byteLength-M;B+=3){const R=n[B+0],z=n[B+1],H=n[B+2];L+=w[R>>>2],L+=w[(R<<4|z>>>4)&63],L+=w[(z<<2|H>>>6)&63],L+=w[H&63]}if(M===1){const R=n[B+0];L+=w[R>>>2],L+=w[R<<4&63],r&&(L+="==")}else if(M===2){const R=n[B+0],z=n[B+1];L+=w[R>>>2],L+=w[(R<<4|z>>>4)&63],L+=w[z<<2&63],r&&(L+="=")}return L}e.encodeBase64=l}),define(De[12],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function u(d){return typeof d=="string"}e.isString=u;function t(d){return Array.isArray(d)&&d.every(o=>u(o))}e.isStringArray=t;function C(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=C;function P(d){const o=Object.getPrototypeOf(Uint8Array);return typeof d=="object"&&d instanceof o}e.isTypedArray=P;function y(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=y;function I(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=I;function S(d){return d===!0||d===!1}e.isBoolean=S;function D(d){return typeof d>"u"}e.isUndefined=D;function A(d){return!k(d)}e.isDefined=A;function k(d){return D(d)||d===null}e.isUndefinedOrNull=k;function E(d,o){if(!d)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=E;function T(d){if(k(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=T;function _(...d){const o=[];for(let i=0;i<d.length;i++){const s=d[i];if(k(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);o.push(s)}return o}e.assertAllDefined=_;const g=Object.prototype.hasOwnProperty;function p(d){if(!C(d))return!1;for(const o in d)if(g.call(d,o))return!1;return!0}e.isEmptyObject=p;function m(d){return typeof d=="function"}e.isFunction=m;function b(...d){return d.length>0&&d.every(m)}e.areFunctions=b;function f(d,o){const i=Math.min(d.length,o.length);for(let s=0;s<i;s++)c(d[s],o[s])}e.validateConstraints=f;function c(d,o){if(u(o)){if(typeof d!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(d instanceof o)return}catch{}if(!k(d)&&d.constructor===o||o.length===1&&o.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function v(d){return d===null?void 0:d}e.withNullAsUndefined=v;function a(d){return typeof d>"u"?null:d}e.withUndefinedAsNull=a}),define(De[24],Ie([1,0,12]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const b=Array.isArray(m)?[]:{};return Object.keys(m).forEach(f=>{m[f]&&typeof m[f]=="object"?b[f]=t(m[f]):b[f]=m[f]}),b}e.deepClone=t;function C(m){if(!m||typeof m!="object")return m;const b=[m];for(;b.length>0;){const f=b.shift();Object.freeze(f);for(const c in f)if(P.call(f,c)){const v=f[c];typeof v=="object"&&!Object.isFrozen(v)&&!(0,u.isTypedArray)(v)&&b.push(v)}}return m}e.deepFreeze=C;const P=Object.prototype.hasOwnProperty;function y(m,b){return I(m,b,new Set)}e.cloneAndChange=y;function I(m,b,f){if((0,u.isUndefinedOrNull)(m))return m;const c=b(m);if(typeof c<"u")return c;if(Array.isArray(m)){const v=[];for(const a of m)v.push(I(a,b,f));return v}if((0,u.isObject)(m)){if(f.has(m))throw new Error("Cannot clone recursive data-structure");f.add(m);const v={};for(const a in m)P.call(m,a)&&(v[a]=I(m[a],b,f));return f.delete(m),v}return m}function S(m,b,f=!0){return(0,u.isObject)(m)?((0,u.isObject)(b)&&Object.keys(b).forEach(c=>{c in m?f&&((0,u.isObject)(m[c])&&(0,u.isObject)(b[c])?S(m[c],b[c],f):m[c]=b[c]):m[c]=b[c]}),m):b}e.mixin=S;function D(m,b){if(m===b)return!0;if(m==null||b===null||b===void 0||typeof m!=typeof b||typeof m!="object"||Array.isArray(m)!==Array.isArray(b))return!1;let f,c;if(Array.isArray(m)){if(m.length!==b.length)return!1;for(f=0;f<m.length;f++)if(!D(m[f],b[f]))return!1}else{const v=[];for(c in m)v.push(c);v.sort();const a=[];for(c in b)a.push(c);if(a.sort(),!D(v,a))return!1;for(f=0;f<v.length;f++)if(!D(m[v[f]],b[v[f]]))return!1}return!0}e.equals=D;function A(m){const b=new Set;return JSON.stringify(m,(f,c)=>{if((0,u.isObject)(c)||Array.isArray(c)){if(b.has(c))return"[Circular]";b.add(c)}return c})}e.safeStringify=A;function k(m,b){const f=Object.create(null);return!m||!b||Object.keys(b).forEach(v=>{const a=m[v],d=b[v];D(a,d)||(f[v]=d)}),f}e.distinct=k;function E(m,b){const f=b.toLowerCase(),c=Object.keys(m).find(v=>v.toLowerCase()===f);return c?m[c]:m[b]}e.getCaseInsensitive=E;function T(m,b){const f=Object.create(null);for(const[c,v]of Object.entries(m))b(c,v)&&(f[c]=v);return f}e.filter=T;function _(m){let b=[],f=Object.getPrototypeOf(m);for(;Object.prototype!==f;)b=b.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return b}e.getAllPropertyNames=_;function g(m){const b=[];for(const f of _(m))typeof m[f]=="function"&&b.push(f);return b}e.getAllMethodNames=g;function p(m,b){const f=v=>function(){const a=Array.prototype.slice.call(arguments,0);return b(v,a)},c={};for(const v of m)c[v]=f(v);return c}e.createProxyObject=p}),define(De[100],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function C(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=C}),define(De[31],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return u.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(I){for(let S=0;S<I.length;S++)I[S]=Math.floor(Math.random()*256);return I};const P=new Uint8Array(16),y=[];for(let I=0;I<256;I++)y.push(I.toString(16).padStart(2,"0"));return function(){C(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,D="";return D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+="-",D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D+=y[P[S++]],D}}()}),define(De[101],Ie([1,0,100]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(I){const S=(0,u.toUint8)(I);this._defaultValue=S,this._asciiMap=t._createAsciiMap(S),this._map=new Map}static _createAsciiMap(I){const S=new Uint8Array(256);for(let D=0;D<256;D++)S[D]=I;return S}set(I,S){const D=(0,u.toUint8)(S);I>=0&&I<256?this._asciiMap[I]=D:this._map.set(I,D)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=t;var C;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(C||(C={}));class P{constructor(){this._actual=new t(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(C,P){this.lineNumber=C,this.column=P}with(C=this.lineNumber,P=this.column){return C===this.lineNumber&&P===this.column?this:new u(C,P)}delta(C=0,P=0){return this.with(this.lineNumber+C,this.column+P)}equals(C){return u.equals(this,C)}static equals(C,P){return!C&&!P?!0:!!C&&!!P&&C.lineNumber===P.lineNumber&&C.column===P.column}isBefore(C){return u.isBefore(this,C)}static isBefore(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<P.column}isBeforeOrEqual(C){return u.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<=P.column}static compare(C,P){const y=C.lineNumber|0,I=P.lineNumber|0;if(y===I){const S=C.column|0,D=P.column|0;return S-D}return y-I}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new u(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=u}),define(De[35],Ie([1,0,49]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,I,S){P>I||P===I&&y>S?(this.startLineNumber=I,this.startColumn=S,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=I,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let I,S,D,A;return y.startLineNumber<P.startLineNumber?(I=y.startLineNumber,S=y.startColumn):y.startLineNumber===P.startLineNumber?(I=y.startLineNumber,S=Math.min(y.startColumn,P.startColumn)):(I=P.startLineNumber,S=P.startColumn),y.endLineNumber>P.endLineNumber?(D=y.endLineNumber,A=y.endColumn):y.endLineNumber===P.endLineNumber?(D=y.endLineNumber,A=Math.max(y.endColumn,P.endColumn)):(D=P.endLineNumber,A=P.endColumn),new t(I,S,D,A)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let I=P.startLineNumber,S=P.startColumn,D=P.endLineNumber,A=P.endColumn;const k=y.startLineNumber,E=y.startColumn,T=y.endLineNumber,_=y.endColumn;return I<k?(I=k,S=E):I===k&&(S=Math.max(S,E)),D>T?(D=T,A=_):D===T&&(A=Math.min(A,_)),I>D||I===D&&S>A?null:new t(I,S,D,A)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new u.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new u.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const D=P.startLineNumber|0,A=y.startLineNumber|0;if(D===A){const k=P.startColumn|0,E=y.startColumn|0;if(k===E){const T=P.endLineNumber|0,_=y.endLineNumber|0;if(T===_){const g=P.endColumn|0,p=y.endColumn|0;return g-p}return T-_}return k-E}return D-A}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[145],Ie([1,0,49,35]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(I,S,D,A){super(I,S,D,A),this.selectionStartLineNumber=I,this.selectionStartColumn=S,this.positionLineNumber=D,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return P.selectionsEqual(this,I)}static selectionsEqual(I,S){return I.selectionStartLineNumber===S.selectionStartLineNumber&&I.selectionStartColumn===S.selectionStartColumn&&I.positionLineNumber===S.positionLineNumber&&I.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,S){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,I,S):new P(I,S,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(I,S){return this.getDirection()===0?new P(I,S,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,I,S)}static fromPositions(I,S=I){return new P(I.lineNumber,I.column,S.lineNumber,S.column)}static fromRange(I,S){return S===0?new P(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):new P(I.endLineNumber,I.endColumn,I.startLineNumber,I.startColumn)}static liftSelection(I){return new P(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,S){if(I&&!S||!I&&S)return!1;if(!I&&!S)return!0;if(I.length!==S.length)return!1;for(let D=0,A=I.length;D<A;D++)if(!this.selectionsEqual(I[D],S[D]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,S,D,A,k){return k===0?new P(I,S,D,A):new P(D,A,I,S)}}e.Selection=P}),define(De[146],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[147],Ie([1,0,101]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends u.CharacterClassifier{constructor(I){super(0);for(let S=0,D=I.length;S<D;S++)this.set(I.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function P(y){const I={};return S=>(I.hasOwnProperty(S)||(I[S]=y(S)),I[S])}e.getMapForWordSeparators=P(y=>new C(y))}),define(De[102],Ie([1,0,61,6,62]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(E+="\\"+T);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=P();function y(k){let E=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)E=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),E=new RegExp(k.source,T)}return E.lastIndex=0,E}e.ensureValidWordDefinition=y;const I=new C.LinkedList;I.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(k){const E=I.unshift(k);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function D(k,E,T,_,g){if(g||(g=u.Iterable.first(I)),T.length>g.maxLen){let c=k-g.maxLen/2;return c<0?c=0:_+=c,T=T.substring(c,k+g.maxLen/2),D(k,E,T,_,g)}const p=Date.now(),m=k-1-_;let b=-1,f=null;for(let c=1;!(Date.now()-p>=g.timeBudget);c++){const v=m-g.windowSize*c;E.lastIndex=Math.max(0,v);const a=A(E,T,m,b);if(!a&&f||(f=a,v<=0))break;b=v}if(f){const c={word:f[0],startColumn:_+1+f.index,endColumn:_+1+f.index+f[0].length};return E.lastIndex=0,c}return null}e.getWordAtText=D;function A(k,E,T,_){let g;for(;g=k.exec(E);){const p=g.index||0;if(p<=T&&k.lastIndex>=T)return g;if(_>0&&p>_)return null}return null}}),define(De[148],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let S=0,D=I.notIn.length;S<D;S++)switch(I.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,S){if(I.getTokenCount()===0)return!0;const D=I.findTokenIndexAtOffset(S-2),A=I.getStandardTokenType(D);return this.isOK(A)}_findNeutralCharacterInRange(I,S){for(let D=I;D<=S;D++){const A=String.fromCharCode(D);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class C{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of I)P(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),P(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),P(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),P(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&P(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=C;function P(y,I,S){y.has(I)?y.get(I).push(S):y.set(I,[S])}}),define(De[149],Ie([1,0,101]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class C{constructor(_,g,p){const m=new Uint8Array(_*g);for(let b=0,f=_*g;b<f;b++)m[b]=p;this._data=m,this.rows=_,this.cols=g}get(_,g){return this._data[_*this.cols+g]}set(_,g,p){this._data[_*this.cols+g]=p}}e.Uint8Matrix=C;class P{constructor(_){let g=0,p=0;for(let b=0,f=_.length;b<f;b++){const[c,v,a]=_[b];v>g&&(g=v),c>p&&(p=c),a>p&&(p=a)}g++,p++;const m=new C(p,g,0);for(let b=0,f=_.length;b<f;b++){const[c,v,a]=_[b];m.set(c,v,a)}this._states=m,this._maxCharCode=g}nextState(_,g){return g<0||g>=this._maxCharCode?0:this._states.get(_,g)}}e.StateMachine=P;let y=null;function I(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let D=null;function A(){if(D===null){D=new u.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<T.length;g++)D.set(T.charCodeAt(g),1);const _=".,;:";for(let g=0;g<_.length;g++)D.set(_.charCodeAt(g),2)}return D}class k{static _createLink(_,g,p,m,b){let f=b-1;do{const c=g.charCodeAt(f);if(_.get(c)!==2)break;f--}while(f>m);if(m>0){const c=g.charCodeAt(m-1),v=g.charCodeAt(f);(c===40&&v===41||c===91&&v===93||c===123&&v===125)&&f--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:f+2},url:g.substring(m,f+1)}}static computeLinks(_,g=I()){const p=A(),m=[];for(let b=1,f=_.getLineCount();b<=f;b++){const c=_.getLineContent(b),v=c.length;let a=0,d=0,o=0,i=1,s=!1,l=!1,n=!1,r=!1;for(;a<v;){let h=!1;const w=c.charCodeAt(a);if(i===13){let L;switch(w){case 40:s=!0,L=0;break;case 41:L=s?0:1;break;case 91:n=!0,l=!0,L=0;break;case 93:n=!1,L=l?0:1;break;case 123:r=!0,L=0;break;case 125:L=r?0:1;break;case 39:L=o===39?1:0;break;case 34:L=o===34?1:0;break;case 96:L=o===96?1:0;break;case 42:L=o===42?1:0;break;case 124:L=o===124?1:0;break;case 32:L=n?0:1;break;default:L=p.get(w)}L===1&&(m.push(k._createLink(p,c,b,d,a)),h=!0)}else if(i===12){let L;w===91?(l=!0,L=0):L=p.get(w),L===1?h=!0:i=13}else i=g.nextState(i,w),i===0&&(h=!0);h&&(i=1,s=!1,l=!1,r=!1,d=a+1,o=w),a++}i===13&&m.push(k._createLink(p,c,b,d,v))}return m}}e.LinkComputer=k;function E(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=E}),define(De[103],Ie([1,0,24]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace),this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class A{constructor(c,v){this._findMatchBrand=void 0,this.range=c,this.matches=v}}e.FindMatch=A;var k;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(f){return f&&typeof f.read=="function"}e.isITextSnapshot=E;var T;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var _;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(_=e.ModelConstants||(e.ModelConstants={}));class g{constructor(c,v,a,d,o,i){this.identifier=c,this.range=v,this.text=a,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=o,this._isTracked=i}}e.ValidAnnotatedEditOperation=g;class p{constructor(c,v,a){this.regex=c,this.wordSeparators=v,this.simpleSearch=a}}e.SearchData=p;class m{constructor(c,v,a){this.reverseEdits=c,this.changes=v,this.trimAutoWhitespaceLineNumbers=a}}e.ApplyEditsResult=m;function b(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(De[150],Ie([1,0,17,100]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class C{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,t.toUint32)(S);const A=this.values,k=this.prefixSum,E=D.length;return E===0?!1:(this.values=new Uint32Array(A.length+E),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S),S+E),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,D){return S=(0,t.toUint32)(S),D=(0,t.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,t.toUint32)(S),D=(0,t.toUint32)(D);const A=this.values,k=this.prefixSum;if(S>=A.length)return!1;const E=A.length-S;return D>=E&&(D=E),D===0?!1:(this.values=new Uint32Array(A.length-D),this.values.set(A.subarray(0,S),0),this.values.set(A.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let A=D;A<=S;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let D=0,A=this.values.length-1,k=0,E=0,T=0;for(;D<=A;)if(k=D+(A-D)/2|0,E=this.prefixSum[k],T=E-this.values[k],S<T)A=k-1;else if(S>=E)D=k+1;else break;return new y(k,S-T)}}e.PrefixSumComputer=C;class P{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const D=this._indexBySum[S],A=D>0?this._prefixSum[D-1]:0;return new y(D,S-A)}removeValues(S,D){this._values.splice(S,D),this._invalidate(S)}insertValues(S,D){this._values=(0,u.arrayInsert)(this._values,S,D),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,D=this._values.length;S<D;S++){const A=this._values[S],k=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=k+A;for(let E=0;E<A;E++)this._indexBySum[k+E]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,D){this._values[S]!==D&&(this._values[S]=D,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(S,D){this.index=S,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=y}),define(De[151],Ie([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[152],Ie([1,0,151]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,P=C*24,y=P*7,I=P*30,S=P*365;function D(k,E,T){typeof k!="number"&&(k=k.getTime());const _=Math.round((new Date().getTime()-k)/1e3);if(_<-30)return(0,u.localize)(0,null,D(new Date().getTime()+_*1e3,!1));if(_<30)return(0,u.localize)(1,null);let g;return _<t?(g=_,E?g===1?T?(0,u.localize)(2,null,g):(0,u.localize)(3,null,g):T?(0,u.localize)(4,null,g):(0,u.localize)(5,null,g):g===1?T?(0,u.localize)(6,null,g):(0,u.localize)(7,null,g):T?(0,u.localize)(8,null,g):(0,u.localize)(9,null,g)):_<C?(g=Math.floor(_/t),E?g===1?T?(0,u.localize)(10,null,g):(0,u.localize)(11,null,g):T?(0,u.localize)(12,null,g):(0,u.localize)(13,null,g):g===1?T?(0,u.localize)(14,null,g):(0,u.localize)(15,null,g):T?(0,u.localize)(16,null,g):(0,u.localize)(17,null,g)):_<P?(g=Math.floor(_/C),E?g===1?T?(0,u.localize)(18,null,g):(0,u.localize)(19,null,g):T?(0,u.localize)(20,null,g):(0,u.localize)(21,null,g):g===1?T?(0,u.localize)(22,null,g):(0,u.localize)(23,null,g):T?(0,u.localize)(24,null,g):(0,u.localize)(25,null,g)):_<y?(g=Math.floor(_/P),E?g===1?(0,u.localize)(26,null,g):(0,u.localize)(27,null,g):g===1?(0,u.localize)(28,null,g):(0,u.localize)(29,null,g)):_<I?(g=Math.floor(_/y),E?g===1?T?(0,u.localize)(30,null,g):(0,u.localize)(31,null,g):T?(0,u.localize)(32,null,g):(0,u.localize)(33,null,g):g===1?T?(0,u.localize)(34,null,g):(0,u.localize)(35,null,g):T?(0,u.localize)(36,null,g):(0,u.localize)(37,null,g)):_<S?(g=Math.floor(_/I),E?g===1?T?(0,u.localize)(38,null,g):(0,u.localize)(39,null,g):T?(0,u.localize)(40,null,g):(0,u.localize)(41,null,g):g===1?T?(0,u.localize)(42,null,g):(0,u.localize)(43,null,g):T?(0,u.localize)(44,null,g):(0,u.localize)(45,null,g)):(g=Math.floor(_/S),E?g===1?T?(0,u.localize)(46,null,g):(0,u.localize)(47,null,g):T?(0,u.localize)(48,null,g):(0,u.localize)(49,null,g):g===1?T?(0,u.localize)(50,null,g):(0,u.localize)(51,null,g):T?(0,u.localize)(52,null,g):(0,u.localize)(53,null,g))}e.fromNow=D;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(De[153],Ie([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,12,153]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,E){return E&&(k.stack||k.stacktrace)?C.localize(0,null,I(k),y(k.stack)||y(k.stacktrace)):I(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function I(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function S(k=null,E=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const T=u.coalesce(k),_=S(T[0],E);return T.length>1?C.localize(4,null,_,T.length):_}if(t.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,E);if(T.exception)return P(T.exception,E)}return k.stack?P(k,E):k.message?k.message:C.localize(5,null)}e.toErrorMessage=S;function D(k){const E=k;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=D;function A(k,E){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=E,T}e.createErrorWithActions=A}),define(De[154],Ie([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(De[10],Ie([1,0,154]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,P=!1,y=!1,I=!1,S=!1,D=!1,A=!1,k=!1,E=!1,T,_=e.LANGUAGE_DEFAULT,g,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const b=typeof m?.versions?.electron=="string",f=b&&m?.type==="renderer";if(typeof navigator=="object"&&!f)p=navigator.userAgent,t=p.indexOf("Windows")>=0,C=p.indexOf("Macintosh")>=0,A=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=p.indexOf("Linux")>=0,E=p?.indexOf("Mobi")>=0,S=!0,T=u.getConfiguredDefaultLocale(u.localize(0,null))||e.LANGUAGE_DEFAULT,_=T;else if(typeof m=="object"){t=m.platform==="win32",C=m.platform==="darwin",P=m.platform==="linux",y=P&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,D=b,k=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,_=e.LANGUAGE_DEFAULT;const n=m.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),h=r.availableLanguages["*"];T=r.locale,_=h||e.LANGUAGE_DEFAULT,g=r._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var c;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function v(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let a=0;C?a=1:t?a=3:P&&(a=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=P,e.isLinuxSnap=y,e.isNative=I,e.isElectron=D,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isMobile=E,e.isCI=k,e.platform=a,e.userAgent=p,e.language=_;var d;(function(n){function r(){return e.language}n.value=r;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=h;function w(){return e.language==="en"}n.isDefault=w})(d=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let w=0,L=n.length;w<L;w++){const M=n[w];if(M.id===h.data.vscodeScheduleAsyncWork){n.splice(w,1),M.callback();return}}});let r=0;return h=>{const w=++r;n.push({id:w,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return n=>setTimeout(n)})();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||A?2:t?1:3;let i=!0,s=!1;function l(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,i=new Uint16Array(n.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[36],Ie([1,0,10]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof u.globals.vscode<"u"&&typeof u.globals.vscode.process<"u"){const C=u.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,36]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,P=90,y=122,I=46,S=47,D=92,A=58,k=63;class E extends Error{constructor(c,v,a){let d;typeof v=="string"&&v.indexOf("not ")===0?(d="must not be",v=v.replace(/^not /,"")):d="must be";const o=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${o} ${d} of type ${v}`;i+=`. Received type ${typeof a}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function T(f,c){if(typeof f!="string")throw new E(c,"string",f)}function _(f){return f===S||f===D}function g(f){return f===S}function p(f){return f>=t&&f<=P||f>=C&&f<=y}function m(f,c,v,a){let d="",o=0,i=-1,s=0,l=0;for(let n=0;n<=f.length;++n){if(n<f.length)l=f.charCodeAt(n);else{if(a(l))break;l=S}if(a(l)){if(!(i===n-1||s===1))if(s===2){if(d.length<2||o!==2||d.charCodeAt(d.length-1)!==I||d.charCodeAt(d.length-2)!==I){if(d.length>2){const r=d.lastIndexOf(v);r===-1?(d="",o=0):(d=d.slice(0,r),o=d.length-1-d.lastIndexOf(v)),i=n,s=0;continue}else if(d.length!==0){d="",o=0,i=n,s=0;continue}}c&&(d+=d.length>0?`${v}..`:"..",o=2)}else d.length>0?d+=`${v}${f.slice(i+1,n)}`:d=f.slice(i+1,n),o=n-i-1;i=n,s=0}else l===I&&s!==-1?++s:s=-1}return d}function b(f,c){if(c===null||typeof c!="object")throw new E("pathObject","Object",c);const v=c.dir||c.root,a=c.base||`${c.name||""}${c.ext||""}`;return v?v===c.root?`${v}${a}`:`${v}${f}${a}`:a}e.win32={resolve(...f){let c="",v="",a=!1;for(let d=f.length-1;d>=-1;d--){let o;if(d>=0){if(o=f[d],T(o,"path"),o.length===0)continue}else c.length===0?o=u.cwd():(o=u.env[`=${c}`]||u.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===D)&&(o=`${c}\\`));const i=o.length;let s=0,l="",n=!1;const r=o.charCodeAt(0);if(i===1)_(r)&&(s=1,n=!0);else if(_(r))if(n=!0,_(o.charCodeAt(1))){let h=2,w=h;for(;h<i&&!_(o.charCodeAt(h));)h++;if(h<i&&h!==w){const L=o.slice(w,h);for(w=h;h<i&&_(o.charCodeAt(h));)h++;if(h<i&&h!==w){for(w=h;h<i&&!_(o.charCodeAt(h));)h++;(h===i||h!==w)&&(l=`\\\\${L}\\${o.slice(w,h)}`,s=h)}}}else s=1;else p(r)&&o.charCodeAt(1)===A&&(l=o.slice(0,2),s=2,i>2&&_(o.charCodeAt(2))&&(n=!0,s=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(a){if(c.length>0)break}else if(v=`${o.slice(s)}\\${v}`,a=n,n&&c.length>0)break}return v=m(v,!a,"\\",_),a?`${c}\\${v}`:`${c}${v}`||"."},normalize(f){T(f,"path");const c=f.length;if(c===0)return".";let v=0,a,d=!1;const o=f.charCodeAt(0);if(c===1)return g(o)?"\\":f;if(_(o))if(d=!0,_(f.charCodeAt(1))){let s=2,l=s;for(;s<c&&!_(f.charCodeAt(s));)s++;if(s<c&&s!==l){const n=f.slice(l,s);for(l=s;s<c&&_(f.charCodeAt(s));)s++;if(s<c&&s!==l){for(l=s;s<c&&!_(f.charCodeAt(s));)s++;if(s===c)return`\\\\${n}\\${f.slice(l)}\\`;s!==l&&(a=`\\\\${n}\\${f.slice(l,s)}`,v=s)}}}else v=1;else p(o)&&f.charCodeAt(1)===A&&(a=f.slice(0,2),v=2,c>2&&_(f.charCodeAt(2))&&(d=!0,v=3));let i=v<c?m(f.slice(v),!d,"\\",_):"";return i.length===0&&!d&&(i="."),i.length>0&&_(f.charCodeAt(c-1))&&(i+="\\"),a===void 0?d?`\\${i}`:i:d?`${a}\\${i}`:`${a}${i}`},isAbsolute(f){T(f,"path");const c=f.length;if(c===0)return!1;const v=f.charCodeAt(0);return _(v)||c>2&&p(v)&&f.charCodeAt(1)===A&&_(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,v;for(let o=0;o<f.length;++o){const i=f[o];T(i,"path"),i.length>0&&(c===void 0?c=v=i:c+=`\\${i}`)}if(c===void 0)return".";let a=!0,d=0;if(typeof v=="string"&&_(v.charCodeAt(0))){++d;const o=v.length;o>1&&_(v.charCodeAt(1))&&(++d,o>2&&(_(v.charCodeAt(2))?++d:a=!1))}if(a){for(;d<c.length&&_(c.charCodeAt(d));)d++;d>=2&&(c=`\\${c.slice(d)}`)}return e.win32.normalize(c)},relative(f,c){if(T(f,"from"),T(c,"to"),f===c)return"";const v=e.win32.resolve(f),a=e.win32.resolve(c);if(v===a||(f=v.toLowerCase(),c=a.toLowerCase(),f===c))return"";let d=0;for(;d<f.length&&f.charCodeAt(d)===D;)d++;let o=f.length;for(;o-1>d&&f.charCodeAt(o-1)===D;)o--;const i=o-d;let s=0;for(;s<c.length&&c.charCodeAt(s)===D;)s++;let l=c.length;for(;l-1>s&&c.charCodeAt(l-1)===D;)l--;const n=l-s,r=i<n?i:n;let h=-1,w=0;for(;w<r;w++){const M=f.charCodeAt(d+w);if(M!==c.charCodeAt(s+w))break;M===D&&(h=w)}if(w!==r){if(h===-1)return a}else{if(n>r){if(c.charCodeAt(s+w)===D)return a.slice(s+w+1);if(w===2)return a.slice(s+w)}i>r&&(f.charCodeAt(d+w)===D?h=w:w===2&&(h=3)),h===-1&&(h=0)}let L="";for(w=d+h+1;w<=o;++w)(w===o||f.charCodeAt(w)===D)&&(L+=L.length===0?"..":"\\..");return s+=h,L.length>0?`${L}${a.slice(s,l)}`:(a.charCodeAt(s)===D&&++s,a.slice(s,l))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===D){if(c.charCodeAt(1)===D){const v=c.charCodeAt(2);if(v!==k&&v!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===A&&c.charCodeAt(2)===D)return`\\\\?\\${c}`;return f},dirname(f){T(f,"path");const c=f.length;if(c===0)return".";let v=-1,a=0;const d=f.charCodeAt(0);if(c===1)return _(d)?f:".";if(_(d)){if(v=a=1,_(f.charCodeAt(1))){let s=2,l=s;for(;s<c&&!_(f.charCodeAt(s));)s++;if(s<c&&s!==l){for(l=s;s<c&&_(f.charCodeAt(s));)s++;if(s<c&&s!==l){for(l=s;s<c&&!_(f.charCodeAt(s));)s++;if(s===c)return f;s!==l&&(v=a=s+1)}}}}else p(d)&&f.charCodeAt(1)===A&&(v=c>2&&_(f.charCodeAt(2))?3:2,a=v);let o=-1,i=!0;for(let s=c-1;s>=a;--s)if(_(f.charCodeAt(s))){if(!i){o=s;break}}else i=!1;if(o===-1){if(v===-1)return".";o=v}return f.slice(0,o)},basename(f,c){c!==void 0&&T(c,"ext"),T(f,"path");let v=0,a=-1,d=!0,o;if(f.length>=2&&p(f.charCodeAt(0))&&f.charCodeAt(1)===A&&(v=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let i=c.length-1,s=-1;for(o=f.length-1;o>=v;--o){const l=f.charCodeAt(o);if(_(l)){if(!d){v=o+1;break}}else s===-1&&(d=!1,s=o+1),i>=0&&(l===c.charCodeAt(i)?--i===-1&&(a=o):(i=-1,a=s))}return v===a?a=s:a===-1&&(a=f.length),f.slice(v,a)}for(o=f.length-1;o>=v;--o)if(_(f.charCodeAt(o))){if(!d){v=o+1;break}}else a===-1&&(d=!1,a=o+1);return a===-1?"":f.slice(v,a)},extname(f){T(f,"path");let c=0,v=-1,a=0,d=-1,o=!0,i=0;f.length>=2&&f.charCodeAt(1)===A&&p(f.charCodeAt(0))&&(c=a=2);for(let s=f.length-1;s>=c;--s){const l=f.charCodeAt(s);if(_(l)){if(!o){a=s+1;break}continue}d===-1&&(o=!1,d=s+1),l===I?v===-1?v=s:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||d===-1||i===0||i===1&&v===d-1&&v===a+1?"":f.slice(v,d)},format:b.bind(null,"\\"),parse(f){T(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const v=f.length;let a=0,d=f.charCodeAt(0);if(v===1)return _(d)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(_(d)){if(a=1,_(f.charCodeAt(1))){let h=2,w=h;for(;h<v&&!_(f.charCodeAt(h));)h++;if(h<v&&h!==w){for(w=h;h<v&&_(f.charCodeAt(h));)h++;if(h<v&&h!==w){for(w=h;h<v&&!_(f.charCodeAt(h));)h++;h===v?a=h:h!==w&&(a=h+1)}}}}else if(p(d)&&f.charCodeAt(1)===A){if(v<=2)return c.root=c.dir=f,c;if(a=2,_(f.charCodeAt(2))){if(v===3)return c.root=c.dir=f,c;a=3}}a>0&&(c.root=f.slice(0,a));let o=-1,i=a,s=-1,l=!0,n=f.length-1,r=0;for(;n>=a;--n){if(d=f.charCodeAt(n),_(d)){if(!l){i=n+1;break}continue}s===-1&&(l=!1,s=n+1),d===I?o===-1?o=n:r!==1&&(r=1):o!==-1&&(r=-1)}return s!==-1&&(o===-1||r===0||r===1&&o===s-1&&o===i+1?c.base=c.name=f.slice(i,s):(c.name=f.slice(i,o),c.base=f.slice(i,s),c.ext=f.slice(o,s))),i>0&&i!==a?c.dir=f.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",v=!1;for(let a=f.length-1;a>=-1&&!v;a--){const d=a>=0?f[a]:u.cwd();T(d,"path"),d.length!==0&&(c=`${d}/${c}`,v=d.charCodeAt(0)===S)}return c=m(c,!v,"/",g),v?`/${c}`:c.length>0?c:"."},normalize(f){if(T(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===S,v=f.charCodeAt(f.length-1)===S;return f=m(f,!c,"/",g),f.length===0?c?"/":v?"./":".":(v&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return T(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let c;for(let v=0;v<f.length;++v){const a=f[v];T(a,"path"),a.length>0&&(c===void 0?c=a:c+=`/${a}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(T(f,"from"),T(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const v=1,a=f.length,d=a-v,o=1,i=c.length-o,s=d<i?d:i;let l=-1,n=0;for(;n<s;n++){const h=f.charCodeAt(v+n);if(h!==c.charCodeAt(o+n))break;h===S&&(l=n)}if(n===s)if(i>s){if(c.charCodeAt(o+n)===S)return c.slice(o+n+1);if(n===0)return c.slice(o+n)}else d>s&&(f.charCodeAt(v+n)===S?l=n:n===0&&(l=0));let r="";for(n=v+l+1;n<=a;++n)(n===a||f.charCodeAt(n)===S)&&(r+=r.length===0?"..":"/..");return`${r}${c.slice(o+l)}`},toNamespacedPath(f){return f},dirname(f){if(T(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===S;let v=-1,a=!0;for(let d=f.length-1;d>=1;--d)if(f.charCodeAt(d)===S){if(!a){v=d;break}}else a=!1;return v===-1?c?"/":".":c&&v===1?"//":f.slice(0,v)},basename(f,c){c!==void 0&&T(c,"ext"),T(f,"path");let v=0,a=-1,d=!0,o;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let i=c.length-1,s=-1;for(o=f.length-1;o>=0;--o){const l=f.charCodeAt(o);if(l===S){if(!d){v=o+1;break}}else s===-1&&(d=!1,s=o+1),i>=0&&(l===c.charCodeAt(i)?--i===-1&&(a=o):(i=-1,a=s))}return v===a?a=s:a===-1&&(a=f.length),f.slice(v,a)}for(o=f.length-1;o>=0;--o)if(f.charCodeAt(o)===S){if(!d){v=o+1;break}}else a===-1&&(d=!1,a=o+1);return a===-1?"":f.slice(v,a)},extname(f){T(f,"path");let c=-1,v=0,a=-1,d=!0,o=0;for(let i=f.length-1;i>=0;--i){const s=f.charCodeAt(i);if(s===S){if(!d){v=i+1;break}continue}a===-1&&(d=!1,a=i+1),s===I?c===-1?c=i:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||a===-1||o===0||o===1&&c===a-1&&c===v+1?"":f.slice(c,a)},format:b.bind(null,"/"),parse(f){T(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const v=f.charCodeAt(0)===S;let a;v?(c.root="/",a=1):a=0;let d=-1,o=0,i=-1,s=!0,l=f.length-1,n=0;for(;l>=a;--l){const r=f.charCodeAt(l);if(r===S){if(!s){o=l+1;break}continue}i===-1&&(s=!1,i=l+1),r===I?d===-1?d=l:n!==1&&(n=1):d!==-1&&(n=-1)}if(i!==-1){const r=o===0&&v?1:o;d===-1||n===0||n===1&&d===i-1&&d===o+1?c.base=c.name=f.slice(r,i):(c.name=f.slice(r,d),c.base=f.slice(r,i),c.ext=f.slice(d,i))}return o>0?c.dir=f.slice(0,o-1):v&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[104],Ie([1,0,9]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const k=(0,u.extname)(A),E=t[k.toLowerCase()];return E!==void 0?E:y(A)}e.getMediaOrTextMime=P;function y(A){const k=(0,u.extname)(A);return C[k.toLowerCase()]}e.getMediaMime=y;function I(A){for(const k in C)if(C[k]===A)return k}e.getExtensionForMimeType=I;const S=/^(.+)\/(.+?)(;.+)?$/;function D(A,k){const E=S.exec(A);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:k?void 0:A}e.normalizeMimeType=D}),define(De[105],Ie([1,0,10]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(I,...S){const D=S.reduce((E,T)=>(E[T]=!0,E),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(E=>!D[E]).forEach(E=>{for(let T=0;T<A.length;T++)if(E.search(A[T])!==-1){delete I[E];break}})}e.sanitizeProcessEnvironment=P;function y(I){!I||(delete I.DEBUG,u.isMacintosh&&delete I.DYLD_LIBRARY_PATH,u.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(De[51],Ie([1,0,10]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=u.globals.performance&&typeof u.globals.performance.now=="function";class C{static create(y=!0){return new C(y)}constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=C}),define(De[3],Ie([1,0,11,60,6,62,51]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,S=!1;var D;(function(l){l.None=()=>C.Disposable.None;function n(me){if(S){const{onListenerDidAdd:be}=me,ke=_.create();let Re=0;me.onListenerDidAdd=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function r(me){return(be,ke=null,Re)=>{let ze=!1,oe;return oe=me(le=>{if(!ze)return oe?oe.dispose():ze=!0,be.call(ke,le)},null,Re),ze&&oe.dispose(),oe}}l.once=r;function h(me,be,ke){return z((Re,ze=null,oe)=>me(le=>Re.call(ze,be(le)),null,oe),ke)}l.map=h;function w(me,be,ke){return z((Re,ze=null,oe)=>me(le=>{be(le),Re.call(ze,le)},null,oe),ke)}l.forEach=w;function L(me,be,ke){return z((Re,ze=null,oe)=>me(le=>be(le)&&Re.call(ze,le),null,oe),ke)}l.filter=L;function M(me){return me}l.signal=M;function B(...me){return(be,ke=null,Re)=>(0,C.combinedDisposable)(...me.map(ze=>ze(oe=>be.call(ke,oe),null,Re)))}l.any=B;function R(me,be,ke,Re){let ze=ke;return h(me,oe=>(ze=be(ze,oe),ze),Re)}l.reduce=R;function z(me,be){let ke;const Re={onFirstListenerAdd(){ke=me(ze.fire,ze)},onLastListenerRemove(){ke?.dispose()}};be||n(Re);const ze=new p(Re);return be?.add(ze),ze.event}function H(me,be,ke=100,Re=!1,ze,oe){let le,ge,Z,ae=0;const ne={leakWarningThreshold:ze,onFirstListenerAdd(){le=me(O=>{ae++,ge=be(ge,O),Re&&!Z&&(ie.fire(ge),ge=void 0),clearTimeout(Z),Z=setTimeout(()=>{const j=ge;ge=void 0,Z=void 0,(!Re||ae>1)&&ie.fire(j),ae=0},ke)})},onLastListenerRemove(){le.dispose()}};oe||n(ne);const ie=new p(ne);return oe?.add(ie),ie.event}l.debounce=H;function N(me,be=(Re,ze)=>Re===ze,ke){let Re=!0,ze;return L(me,oe=>{const le=Re||!be(oe,ze);return Re=!1,ze=oe,le},ke)}l.latch=N;function V(me,be,ke){return[l.filter(me,be,ke),l.filter(me,Re=>!be(Re),ke)]}l.split=V;function U(me,be=!1,ke=[]){let Re=ke.slice(),ze=me(ge=>{Re?Re.push(ge):le.fire(ge)});const oe=()=>{Re?.forEach(ge=>le.fire(ge)),Re=null},le=new p({onFirstListenerAdd(){ze||(ze=me(ge=>le.fire(ge)))},onFirstListenerDidAdd(){Re&&(be?setTimeout(oe):oe())},onLastListenerRemove(){ze&&ze.dispose(),ze=null}});return le.event}l.buffer=U;class F{constructor(be){this.event=be,this.disposables=new C.DisposableStore}map(be){return new F(h(this.event,be,this.disposables))}forEach(be){return new F(w(this.event,be,this.disposables))}filter(be){return new F(L(this.event,be,this.disposables))}reduce(be,ke){return new F(R(this.event,be,ke,this.disposables))}latch(){return new F(N(this.event,void 0,this.disposables))}debounce(be,ke=100,Re=!1,ze){return new F(H(this.event,be,ke,Re,ze,this.disposables))}on(be,ke,Re){return this.event(be,ke,Re)}once(be,ke,Re){return r(this.event)(be,ke,Re)}dispose(){this.disposables.dispose()}}function x(me){return new F(me)}l.chain=x;function $(me,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>me.on(be,Re),oe=()=>me.removeListener(be,Re),le=new p({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}l.fromNodeEventEmitter=$;function Q(me,be,ke=Re=>Re){const Re=(...ge)=>le.fire(ke(...ge)),ze=()=>me.addEventListener(be,Re),oe=()=>me.removeEventListener(be,Re),le=new p({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}l.fromDOMEventEmitter=Q;function K(me){return new Promise(be=>r(me)(be))}l.toPromise=K;function de(me,be){return be(void 0),me(ke=>be(ke))}l.runAndSubscribe=de;function ee(me,be){let ke=null;function Re(oe){ke?.dispose(),ke=new C.DisposableStore,be(oe,ke)}Re(void 0);const ze=me(oe=>Re(oe));return(0,C.toDisposable)(()=>{ze.dispose(),ke?.dispose()})}l.runAndSubscribeWithStore=ee;class he{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Re={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||n(Re),this.emitter=new p(Re),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Y(me,be){return new he(me,be).emitter.event}l.fromObservable=Y})(D=e.Event||(e.Event={}));class A{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${A._idPool++}`,A.all.add(this)}start(n){this._stopWatch=new y.StopWatch(!0),this.listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=A,A.all=new Set,A._idPool=0;let k=-1;function E(l){const n=k;return k=l,{dispose(){k=n}}}e.setGlobalLeakWarningThreshold=E;class T{constructor(n,r=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n,r){let h=k;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||r<h)return;this._stacks||(this._stacks=new Map);const w=this._stacks.get(n.value)||0;if(this._stacks.set(n.value,w+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let L,M=0;for(const[B,R]of this._stacks)(!L||M<R)&&(L=B,M=R);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${M}):`),console.warn(L)}return()=>{const L=this._stacks.get(n.value)||0;this._stacks.set(n.value,L-1)}}}class _{static create(){return new _(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(n,r,h){this.callback=n,this.callbackThis=r,this.stack=h,this.subscription=new C.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class p{constructor(n){this._disposed=!1,this._options=n,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const n=Array.from(this._listeners);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(n,r,h)=>{this._listeners||(this._listeners=new P.LinkedList);const w=this._listeners.isEmpty();w&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let L,M;this._leakageMon&&this._listeners.size>=30&&(M=_.create(),L=this._leakageMon.check(M,this._listeners.size+1)),I&&(M=M??_.create());const B=new g(n,r,M),R=this._listeners.push(B);w&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,r);const z=B.subscription.set(()=>{L?.(),this._disposed||(R(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof C.DisposableStore?h.add(z):Array.isArray(h)&&h.push(z),z}),this._event}fire(n){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b);for(const r of this._listeners)this._deliveryQueue.push(this,r,n);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class m{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(n,r,h){this._queue.push(new f(n,r,h))}clear(n){const r=new P.LinkedList;for(const h of this._queue)h.emitter!==n&&r.push(h);this._queue=r}deliver(){for(;this._queue.size>0;){const n=this._queue.shift();try{n.listener.invoke(n.event)}catch(r){(0,u.onUnexpectedError)(r)}}}}e.EventDeliveryQueue=m;class b extends m{clear(n){this._queue.clear()}}class f{constructor(n,r,h){this.emitter=n,this.listener=r,this.event=h}}class c extends p{async fireAsync(n,r,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const w of this._listeners)this._asyncDeliveryQueue.push([w,n]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[w,L]=this._asyncDeliveryQueue.shift(),M=[],B={...L,token:r,waitUntil:R=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");h&&(R=h(R,w.callback)),M.push(R)}};try{w.invoke(B)}catch(R){(0,u.onUnexpectedError)(R);continue}Object.freeze(M),await Promise.allSettled(M).then(R=>{for(const z of R)z.status==="rejected"&&(0,u.onUnexpectedError)(z.reason)})}}}}e.AsyncEmitter=c;class v extends p{constructor(n){super(n),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=n?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}e.PauseableEmitter=v;class a extends v{constructor(n){super(n),this._delay=n.delay??100}fire(n){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(n)}}e.DebounceEmitter=a;class d extends p{constructor(n){super(n),this._queuedEvents=[],this._mergeFn=n?.merge}fire(n){!this.hasListeners()||(this._queuedEvents.push(n),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=d;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const r={event:n,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const h=()=>{this.hasListeners&&this.unhook(r);const w=this.events.indexOf(r);this.events.splice(w,1)};return(0,C.toDisposable)((0,t.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(r=>this.emitter.fire(r))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class i{constructor(){this.buffers=[]}wrapEvent(n){return(r,h,w)=>n(L=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>r.call(h,L)):r.call(h,L)},void 0,w)}bufferEvents(n){const r=[];this.buffers.push(r);const h=n();return this.buffers.pop(),r.forEach(w=>w()),h}}e.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=C.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(De[21],Ie([1,0,3]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,S){const D=setTimeout(I.bind(S),0);return{dispose(){clearTimeout(D)}}});var C;(function(I){function S(D){return D===I.None||D===I.Cancelled||D instanceof P?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}I.isCancellationToken=S,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=C.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=y}),define(De[155],Ie([1,0,21]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new u.CancellationTokenSource,S=this.task(I.token);return this.result={promise:S,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class C{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const S=JSON.stringify(I);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=C;class P{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const S=this.fn(I);return this._map.set(I,S),S}}e.CachedFunction=P}),define(De[156],Ie([1,0,3,6]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const C=y=>({onDidChange:u.Event.None,value:y});e.staticObservableValue=C;class P extends t.Disposable{get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}constructor(I){super(),this._value=I,this.changeEmitter=this._register(new u.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=P}),define(De[8],Ie([1,0,155,78]),function(J,e,u,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function I(fe,...Ae){return Ae.length===0?fe:fe.replace(y,function(Le,Me){const Ke=parseInt(Me,10);return isNaN(Ke)||Ke<0||Ke>=Ae.length?Le:Ae[Ke]})}e.format=I;const S=/{([^}]+)}/g;function D(fe,Ae){return fe.replace(S,(Le,Me)=>Ae[Me]??Le)}e.format2=D;function A(fe){return fe.replace(/[<>&]/g,function(Ae){switch(Ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ae}})}e.escape=A;function k(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function E(fe,Ae){let Le=0;const Me=Ae.charCodeAt(0);for(let Ke=fe.length-1;Ke>=0;Ke--)fe.charCodeAt(Ke)===Me&&Le++;return Le}e.count=E;function T(fe,Ae,Le="\u2026"){return fe.length<=Ae?fe:`${fe.substr(0,Ae)}${Le}`}e.truncate=T;function _(fe,Ae=" "){const Le=g(fe,Ae);return p(Le,Ae)}e.trim=_;function g(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length;if(Le===0||fe.length===0)return fe;let Me=0;for(;fe.indexOf(Ae,Me)===Me;)Me=Me+Le;return fe.substring(Me)}e.ltrim=g;function p(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length,Me=fe.length;if(Le===0||Me===0)return fe;let Ke=Me,Je=-1;for(;Je=fe.lastIndexOf(Ae,Ke-1),!(Je===-1||Je+Le!==Ke);){if(Je===0)return"";Ke=Je}return fe.substring(0,Ke)}e.rtrim=p;function m(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function b(fe){return fe.replace(/\*/g,"")}e.stripWildcards=b;function f(fe,Ae,Le={}){if(!fe)throw new Error("Cannot create regex from empty string");Ae||(fe=k(fe)),Le.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Me="";return Le.global&&(Me+="g"),Le.matchCase||(Me+="i"),Le.multiline&&(Me+="m"),Le.unicode&&(Me+="u"),new RegExp(fe,Me)}e.createRegExp=f;function c(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function v(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function a(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.regExpFlags=a;function d(fe){return fe.split(/\r\n|\r|\n/)}e.splitLines=d;function o(fe){for(let Ae=0,Le=fe.length;Ae<Le;Ae++){const Me=fe.charCodeAt(Ae);if(Me!==32&&Me!==9)return Ae}return-1}e.firstNonWhitespaceIndex=o;function i(fe,Ae=0,Le=fe.length){for(let Me=Ae;Me<Le;Me++){const Ke=fe.charCodeAt(Me);if(Ke!==32&&Ke!==9)return fe.substring(Ae,Me)}return fe.substring(Ae,Le)}e.getLeadingWhitespace=i;function s(fe,Ae=fe.length-1){for(let Le=Ae;Le>=0;Le--){const Me=fe.charCodeAt(Le);if(Me!==32&&Me!==9)return Le}return-1}e.lastNonWhitespaceIndex=s;function l(fe,Ae,Le){const Me=[];let Ke=0;for(const Je of fe.matchAll(Ae)){if(Me.push(fe.slice(Ke,Je.index)),Je.index===void 0)throw new Error("match.index should be defined");Ke=Je.index+Je[0].length,Me.push(Le(Je[0],...Je.slice(1),Je.index,fe,Je.groups))}return Me.push(fe.slice(Ke)),Promise.all(Me).then(Je=>Je.join(""))}e.replaceAsync=l;function n(fe,Ae){return fe<Ae?-1:fe>Ae?1:0}e.compare=n;function r(fe,Ae,Le=0,Me=fe.length,Ke=0,Je=Ae.length){for(;Le<Me&&Ke<Je;Le++,Ke++){const it=fe.charCodeAt(Le),lt=Ae.charCodeAt(Ke);if(it<lt)return-1;if(it>lt)return 1}const st=Me-Le,ot=Je-Ke;return st<ot?-1:st>ot?1:0}e.compareSubstring=r;function h(fe,Ae){return w(fe,Ae,0,fe.length,0,Ae.length)}e.compareIgnoreCase=h;function w(fe,Ae,Le=0,Me=fe.length,Ke=0,Je=Ae.length){for(;Le<Me&&Ke<Je;Le++,Ke++){let it=fe.charCodeAt(Le),lt=Ae.charCodeAt(Ke);if(it===lt)continue;if(it>=128||lt>=128)return r(fe.toLowerCase(),Ae.toLowerCase(),Le,Me,Ke,Je);M(it)&&(it-=32),M(lt)&&(lt-=32);const vt=it-lt;if(vt!==0)return vt}const st=Me-Le,ot=Je-Ke;return st<ot?-1:st>ot?1:0}e.compareSubstringIgnoreCase=w;function L(fe){return fe>=48&&fe<=57}e.isAsciiDigit=L;function M(fe){return fe>=97&&fe<=122}e.isLowerAsciiLetter=M;function B(fe){return fe>=65&&fe<=90}e.isUpperAsciiLetter=B;function R(fe,Ae){return fe.length===Ae.length&&w(fe,Ae)===0}e.equalsIgnoreCase=R;function z(fe,Ae){const Le=Ae.length;return Ae.length>fe.length?!1:w(fe,Ae,0,Le)===0}e.startsWithIgnoreCase=z;function H(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Me)!==Ae.charCodeAt(Me))return Me;return Le}e.commonPrefixLength=H;function N(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;const Ke=fe.length-1,Je=Ae.length-1;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Ke-Me)!==Ae.charCodeAt(Je-Me))return Me;return Le}e.commonSuffixLength=N;function V(fe){return 55296<=fe&&fe<=56319}e.isHighSurrogate=V;function U(fe){return 56320<=fe&&fe<=57343}e.isLowSurrogate=U;function F(fe,Ae){return(fe-55296<<10)+(Ae-56320)+65536}e.computeCodePoint=F;function x(fe,Ae,Le){const Me=fe.charCodeAt(Le);if(V(Me)&&Le+1<Ae){const Ke=fe.charCodeAt(Le+1);if(U(Ke))return F(Me,Ke)}return Me}e.getNextCodePoint=x;function $(fe,Ae){const Le=fe.charCodeAt(Ae-1);if(U(Le)&&Ae>1){const Me=fe.charCodeAt(Ae-2);if(V(Me))return F(Me,Le)}return Le}class Q{get offset(){return this._offset}constructor(Ae,Le=0){this._str=Ae,this._len=Ae.length,this._offset=Le}setOffset(Ae){this._offset=Ae}prevCodePoint(){const Ae=$(this._str,this._offset);return this._offset-=Ae>=65536?2:1,Ae}nextCodePoint(){const Ae=x(this._str,this._len,this._offset);return this._offset+=Ae>=65536?2:1,Ae}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Ae,Le=0){this._iterator=new Q(Ae,Le)}nextGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ke=Ae.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.nextCodePoint());if(We(Ke,st)){Le.setOffset(Je);break}Ke=st}return Le.offset-Me}prevGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ke=Ae.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.prevCodePoint());if(We(st,Ke)){Le.setOffset(Je);break}Ke=st}return Me-Le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function de(fe,Ae){return new K(fe,Ae).nextGraphemeLength()}e.nextCharLength=de;function ee(fe,Ae){return new K(fe,Ae).prevGraphemeLength()}e.prevCharLength=ee;function he(fe,Ae){Ae>0&&U(fe.charCodeAt(Ae))&&Ae--;const Le=Ae+de(fe,Ae);return[Le-ee(fe,Le),Le]}e.getCharContainingOffset=he;function Y(fe){const Ae=new K(fe);let Le=0;for(;!Ae.eol();)Le++,Ae.nextGraphemeLength();return Le}e.charCount=Y;let me;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(fe){return me||(me=be()),me.test(fe)}e.containsRTL=ke;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(fe){return Re.test(fe)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(fe){return e.UNUSUAL_LINE_TERMINATORS.test(fe)}e.containsUnusualLineTerminators=oe;function le(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.isFullWidthCharacter=le;function ge(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.isEmojiImprecise=ge;function Z(fe,Ae){if(fe.length<Ae)return fe;const Le=/\b/g;let Me=0;for(;Le.test(fe)&&!(fe.length-Le.lastIndex<Ae);)Me=Le.lastIndex,Le.lastIndex+=1;return fe.substring(Me).replace(/^\s/,"")}e.lcut=Z;const ae=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function O(fe){return fe&&(fe=fe.replace(ae,""),fe=fe.replace(ne,""),fe=fe.replace(ie,"")),fe}e.removeAnsiEscapeCodes=O,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=j;function G(fe){return j(fe)?fe.substr(1):fe}e.stripUTF8BOM=G;function X(fe,Ae){if(!fe||!Ae||fe.length<Ae.length)return!1;const Le=Ae.length,Me=fe.toLowerCase();let Ke=0,Je=-1;for(;Ke<Le;){const st=Me.indexOf(Ae[Ke],Je+1);if(st<0)return!1;Je=st,Ke++}return!0}e.fuzzyContains=X;function pe(fe,Ae=!1){return fe?(Ae&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.containsUppercaseCharacter=pe;function we(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.uppercaseFirstLetter=we;function ce(fe,Ae=1){if(Ae===0)return"";let Le=-1;do Le=fe.indexOf(`
`,Le+1),Ae--;while(Ae>0&&Le>=0);return Le===-1?fe:(fe[Le-1]==="\r"&&Le--,fe.substr(0,Le))}e.getNLines=ce;function Ce(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.singleLetterHash=Ce;function ye(fe){return Ze.getInstance().getGraphemeBreakType(fe)}e.getGraphemeBreakType=ye;function We(fe,Ae){return fe===0?Ae!==5&&Ae!==7:fe===2&&Ae===3?!1:fe===4||fe===2||fe===3||Ae===4||Ae===2||Ae===3?!0:!(fe===8&&(Ae===8||Ae===9||Ae===11||Ae===12)||(fe===11||fe===9)&&(Ae===9||Ae===10)||(fe===12||fe===10)&&Ae===10||Ae===5||Ae===13||Ae===7||fe===1||fe===13&&Ae===14||fe===6&&Ae===6)}var qe;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ze{static getInstance(){return Ze._INSTANCE||(Ze._INSTANCE=new Ze),Ze._INSTANCE}constructor(){this._data=Ye()}getGraphemeBreakType(Ae){if(Ae<32)return Ae===10?3:Ae===13?2:4;if(Ae<127)return 0;const Le=this._data,Me=Le.length/3;let Ke=1;for(;Ke<=Me;)if(Ae<Le[3*Ke])Ke=2*Ke;else if(Ae>Le[3*Ke+1])Ke=2*Ke+1;else return Le[3*Ke+2];return 0}}Ze._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(fe,Ae){if(fe===0)return 0;const Le=at(fe,Ae);if(Le!==void 0)return Le;const Me=new Q(Ae,fe);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Ne;function at(fe,Ae){const Le=new Q(Ae,fe);let Me=Le.prevCodePoint();for(;re(Me)||Me===65039||Me===8419;){if(Le.offset===0)return;Me=Le.prevCodePoint()}if(!ge(Me))return;let Ke=Le.offset;return Ke>0&&Le.prevCodePoint()===8205&&(Ke=Le.offset),Ke}function re(fe){return 127995<=fe&&fe<=127999}var se;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(se||(se={})),e.noBreakWhitespace="\xA0";class Ee{static getInstance(Ae){return Ee.cache.get(Array.from(Ae))}static getLocales(){return Ee._locales.getValue()}constructor(Ae){this.confusableDictionary=Ae}isAmbiguous(Ae){return this.confusableDictionary.has(Ae)}getPrimaryConfusable(Ae){return this.confusableDictionary.get(Ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ee,C=Ee,Ee.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.cache=new u.LRUCachedFunction(fe=>{function Ae(lt){const vt=new Map;for(let wt=0;wt<lt.length;wt+=2)vt.set(lt[wt],lt[wt+1]);return vt}function Le(lt,vt){const wt=new Map(lt);for(const[ft,Et]of vt)wt.set(ft,Et);return wt}function Me(lt,vt){if(!lt)return vt;const wt=new Map;for(const[ft,Et]of lt)vt.has(ft)&&wt.set(ft,Et);return wt}const Ke=C.ambiguousCharacterData.getValue();let Je=fe.filter(lt=>!lt.startsWith("_")&&lt in Ke);Je.length===0&&(Je=["_default"]);let st;for(const lt of Je){const vt=Ae(Ke[lt]);st=Me(st,vt)}const ot=Ae(Ke._common),it=Le(ot,st);return new Ee(it)}),Ee._locales=new t.Lazy(()=>Object.keys(Ee.ambiguousCharacterData.getValue()).filter(fe=>!fe.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(Ae){return Ve.getData().has(Ae)}static get codePoints(){return Ve.getData()}}e.InvisibleCharacters=Ve,Ve._data=void 0}),define(De[32],Ie([1,0,9,10,8,12]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function I(s){return s.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=I;function S(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function D(s,l=u.posix.sep){if(!s)return"";const n=s.length,r=s.charCodeAt(0);if(y(r)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let w=3;const L=w;for(;w<n&&!y(s.charCodeAt(w));w++);if(L!==w&&!y(s.charCodeAt(w+1))){for(w+=1;w<n;w++)if(y(s.charCodeAt(w)))return s.slice(0,w+1).replace(/[\\/]/g,l)}}return l}else if(m(r)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let h=s.indexOf("://");if(h!==-1){for(h+=3;h<n;h++)if(y(s.charCodeAt(h)))return s.slice(0,h+1)}return""}e.getRoot=D;function A(s){if(!t.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let n=2;const r=n;for(;n<s.length&&(l=s.charCodeAt(n),l!==92);n++);return!(r===n||(l=s.charCodeAt(n+1),isNaN(l)||l===92))}e.isUNC=A;const k=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function _(s,l=t.isWindows){const n=l?k:E;return!(!s||s.length===0||/^\s+$/.test(s)||(n.lastIndex=0,n.test(s))||l&&T.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=_;function g(s,l,n){const r=s===l;return!n||r?r:!s||!l?!1:(0,C.equalsIgnoreCase)(s,l)}e.isEqual=g;function p(s,l,n,r=u.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(n){if(!(0,C.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let w=l.length;return l.charAt(l.length-1)===r&&w--,s.charAt(w)===r}return l.charAt(l.length-1)!==r&&(l+=r),s.indexOf(l)===0}e.isEqualOrParent=p;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function b(s,l){return t.isWindows&&s.endsWith(":")&&(s+=u.sep),(0,u.isAbsolute)(s)||(s=(0,u.join)(l,s)),s=(0,u.normalize)(s),t.isWindows?(s=(0,C.rtrim)(s,u.sep),s.endsWith(":")&&(s+=u.sep)):(s=(0,C.rtrim)(s,u.sep),s||(s=u.sep)),s}e.sanitizeFilePath=b;function f(s){const l=(0,u.normalize)(s);return t.isWindows?s.length>3?!1:c(l)&&(s.length===2||l.charCodeAt(2)===92):l===u.posix.sep}e.isRootOrDriveLetter=f;function c(s,l=t.isWindows){return l?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function v(s){return c(s)?s[0]:void 0}e.getDriveLetter=v;function a(s,l,n){return l.length>s.length?-1:s===l?0:(n&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=a;function d(s){const l=s.split(":");let n,r,h;for(const w of l){const L=Number(w);(0,P.isNumber)(L)?r===void 0?r=L:h===void 0&&(h=L):n=n?[n,w].join(":"):w}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:r!==void 0?r:void 0,column:h!==void 0?h:r!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,l,n=8){let r="";for(let w=0;w<n;w++)r+=o.charAt(Math.floor(Math.random()*o.length));let h;return l?h=`${l}-${r}`:h=r,s?(0,u.join)(s,h):h}e.randomPath=i}),define(De[79],Ie([1,0,8]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return C(m,0)}e.hash=t;function C(m,b){switch(typeof m){case"object":return m===null?P(349,b):Array.isArray(m)?S(m,b):D(m,b);case"string":return I(m,b);case"boolean":return y(m,b);case"number":return P(m,b);case"undefined":return P(937,b);default:return P(617,b)}}e.doHash=C;function P(m,b){return(b<<5)-b+m|0}e.numberHash=P;function y(m,b){return P(m?433:863,b)}function I(m,b){b=P(149417,b);for(let f=0,c=m.length;f<c;f++)b=P(m.charCodeAt(f),b);return b}e.stringHash=I;function S(m,b){return b=P(104579,b),m.reduce((f,c)=>C(c,f),b)}function D(m,b){return b=P(181387,b),Object.keys(m).sort().reduce((f,c)=>(f=I(c,f),C(m[c],f)),b)}class A{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=A;var k;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function E(m,b,f=32){const c=f-b,v=~((1<<c)-1);return(m<<b|(v&m)>>>c)>>>0}function T(m,b=0,f=m.byteLength,c=0){for(let v=0;v<f;v++)m[b+v]=c}function _(m,b,f="0"){for(;m.length<b;)m=f+m;return m}function g(m,b=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):_((m>>>0).toString(16),b/4)}e.toHexString=g;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const f=b.length;if(f===0)return;const c=this._buff;let v=this._buffLen,a=this._leftoverHighSurrogate,d,o;for(a!==0?(d=a,o=-1,a=0):(d=b.charCodeAt(0),o=0);;){let i=d;if(u.isHighSurrogate(d))if(o+1<f){const s=b.charCodeAt(o+1);u.isLowSurrogate(s)?(o++,i=u.computeCodePoint(d,s)):i=65533}else{a=d;break}else u.isLowSurrogate(d)&&(i=65533);if(v=this._push(c,v,i),o++,o<f)d=b.charCodeAt(o);else break}this._buffLen=v,this._leftoverHighSurrogate=a}_push(b,f,c){return c<128?b[f++]=c:c<2048?(b[f++]=192|(c&1984)>>>6,b[f++]=128|(c&63)>>>0):c<65536?(b[f++]=224|(c&61440)>>>12,b[f++]=128|(c&4032)>>>6,b[f++]=128|(c&63)>>>0):(b[f++]=240|(c&1835008)>>>18,b[f++]=128|(c&258048)>>>12,b[f++]=128|(c&4032)>>>6,b[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=p._bigBlock32,f=this._buffDV;for(let n=0;n<64;n+=4)b.setUint32(n,f.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)b.setUint32(n,E(b.getUint32(n-12,!1)^b.getUint32(n-32,!1)^b.getUint32(n-56,!1)^b.getUint32(n-64,!1),1),!1);let c=this._h0,v=this._h1,a=this._h2,d=this._h3,o=this._h4,i,s,l;for(let n=0;n<80;n++)n<20?(i=v&a|~v&d,s=1518500249):n<40?(i=v^a^d,s=1859775393):n<60?(i=v&a|v&d|a&d,s=2400959708):(i=v^a^d,s=3395469782),l=E(c,5)+i+o+s+b.getUint32(n*4,!1)&4294967295,o=d,d=a,a=E(v,30),v=c,c=l;this._h0=this._h0+c&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[26],Ie([1,0,17,8]),function(J,e,u,t){"use strict";var C,P,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(o,i,s){let l=o.get(i);return l===void 0&&(l=s,o.set(i,l)),l}e.getOrSet=I;function S(o){const i=[];return o.forEach((s,l)=>{i.push(`${l} => ${s}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=S;function D(o){const i=[];return o.forEach(s=>{i.push(s)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=D;class A{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=A;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class E{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const l=this._value.charCodeAt(s);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var T;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(T||(T={}));class _{constructor(i,s){this._ignorePathCasing=i,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=_;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(p||(p={}));class m{static forUris(i=()=>!1,s=()=>!1){return new m(new _(i,s))}static forPaths(i=!1){return new m(new E(void 0,!i))}static forStrings(){return new m(new A)}static forConfigKeys(){return new m(new k)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,s){if(s){const l=s.slice(0);(0,u.shuffle)(l);for(const n of l)this.set(n,i)}else{const l=i.slice(0);(0,u.shuffle)(l);for(const n of l)this.set(n[0],n[1])}}set(i,s){const l=this._iter.reset(i);let n;this._root||(this._root=new g,this._root.segment=l.value());const r=[];for(n=this._root;;){const w=l.cmp(n.segment);if(w>0)n.left||(n.left=new g,n.left.segment=l.value()),r.push([-1,n]),n=n.left;else if(w<0)n.right||(n.right=new g,n.right.segment=l.value()),r.push([1,n]),n=n.right;else if(l.hasNext())l.next(),n.mid||(n.mid=new g,n.mid.segment=l.value()),r.push([0,n]),n=n.mid;else break}const h=n.value;n.value=s,n.key=i;for(let w=r.length-1;w>=0;w--){const L=r[w][1];L.updateHeight();const M=L.balanceFactor();if(M<-1||M>1){const B=r[w][0],R=r[w+1][0];if(B===1&&R===1)r[w][1]=L.rotateLeft();else if(B===-1&&R===-1)r[w][1]=L.rotateRight();else if(B===1&&R===-1)L.right=r[w+1][1]=r[w+1][1].rotateRight(),r[w][1]=L.rotateLeft();else if(B===-1&&R===1)L.left=r[w+1][1]=r[w+1][1].rotateLeft(),r[w][1]=L.rotateRight();else throw new Error;if(w>0)switch(r[w-1][0]){case-1:r[w-1][1].left=r[w][1];break;case 1:r[w-1][1].right=r[w][1];break;case 0:r[w-1][1].mid=r[w][1];break}else this._root=r[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let l=this._root;for(;l;){const n=s.cmp(l.segment);if(n>0)l=l.left;else if(n<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const l=this._iter.reset(i),n=[];let r=this._root;for(;r;){const h=l.cmp(r.segment);if(h>0)n.push([-1,r]),r=r.left;else if(h<0)n.push([1,r]),r=r.right;else if(l.hasNext())l.next(),n.push([0,r]),r=r.mid;else break}if(!!r){if(s?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const h=this._min(r.right);if(h.key){const{key:w,value:L,segment:M}=h;this._delete(h.key,!1),r.key=w,r.value=L,r.segment=M}}else{const h=r.left??r.right;if(n.length>0){const[w,L]=n[n.length-1];switch(w){case-1:L.left=h;break;case 0:L.mid=h;break;case 1:L.right=h;break}}else this._root=h}for(let h=n.length-1;h>=0;h--){const w=n[h][1];w.updateHeight();const L=w.balanceFactor();if(L>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),n[h][1]=w.rotateLeft()):L<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),n[h][1]=w.rotateRight()),h>0)switch(n[h-1][0]){case-1:n[h-1][1].left=n[h][1];break;case 1:n[h-1][1].right=n[h][1];break;case 0:n[h-1][1].mid=n[h][1];break}else this._root=n[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let l=this._root,n;for(;l;){const r=s.cmp(l.segment);if(r>0)l=l.left;else if(r<0)l=l.right;else if(s.hasNext())s.next(),n=l.value||n,l=l.mid;else break}return l&&l.value||n}findSuperstr(i){const s=this._iter.reset(i);let l=this._root;for(;l;){const n=s.cmp(l.segment);if(n>0)l=l.left;else if(n<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(i){for(const[s,l]of this)i(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const s=[];return this._dfsEntries(i,s),s[Symbol.iterator]()}_dfsEntries(i,s){!i||(i.left&&this._dfsEntries(i.left,s),i.value&&s.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,s),i.right&&this._dfsEntries(i.right,s))}_isBalanced(){const i=s=>{if(!s)return!0;const l=s.balanceFactor();return l<-1||l>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=m;class b{constructor(i,s){this.uri=i,this.value=s}}class f{constructor(i,s){this[C]="ResourceMap",i instanceof f?(this.map=new Map(i.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=i??f.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new b(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[l,n]of this.map)i(n.value,n.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=f,f.defaultToKey=o=>o.toString();class c{constructor(i,s){this[P]="ResourceSet",!i||typeof i=="function"?this._map=new f(i):(this._map=new f(s),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,s){this._map.forEach((l,n)=>i.call(s,n,n,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var v;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class a{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const l=this._map.get(i);if(!!l)return s!==0&&this.touch(l,s),l.value}set(i,s,l=0){let n=this._map.get(i);if(n)n.value=s,l!==0&&this.touch(n,l);else{switch(n={key:i,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:this.addItemLast(n);break;default:this.addItemLast(n);break}this._map.set(i,n),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const l=this._state;let n=this._head;for(;n;){if(s?i.bind(s)(n.value,n.key,this):i(n.value,n.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const i=this,s=this._state;let l=this._head;const n={[Symbol.iterator](){return n},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:l.key,done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return n}values(){const i=this,s=this._state;let l=this._head;const n={[Symbol.iterator](){return n},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:l.value,done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return n}entries(){const i=this,s=this._state;let l=this._head;const n={[Symbol.iterator](){return n},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:[l.key,l.value],done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return n}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>i;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,l=i.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const l=i.next,n=i.previous;i===this._tail?(n.next=void 0,this._tail=n):(l.previous=n,n.next=l),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const l=i.next,n=i.previous;i===this._head?(l.previous=void 0,this._head=l):(l.previous=n,n.next=l),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,l)=>{i.push([l,s])}),i}fromJSON(i){this.clear();for(const[s,l]of i)this.set(s,l)}}e.LinkedMap=a;class d extends a{constructor(i,s=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(De[106],Ie([1,0,26,8]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ne){return function(ie,O){for(let j=0,G=ne.length;j<G;j++){const X=ne[j](ie,O);if(X)return X}return null}}e.or=C,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ne,ie,O){if(!O||O.length<ie.length)return null;let j;return ne?j=t.startsWithIgnoreCase(O,ie):j=O.indexOf(ie)===0,j?ie.length>0?[{start:0,end:ie.length}]:[]:null}function y(ne,ie){const O=ie.toLowerCase().indexOf(ne.toLowerCase());return O===-1?null:[{start:O,end:O+ne.length}]}e.matchesContiguousSubString=y;function I(ne,ie){return S(ne.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=I;function S(ne,ie,O,j){if(O===ne.length)return[];if(j===ie.length)return null;if(ne[O]===ie[j]){let G=null;return(G=S(ne,ie,O+1,j+1))?m({start:j,end:j+1},G):null}return S(ne,ie,O,j+1)}function D(ne){return 97<=ne&&ne<=122}function A(ne){return 65<=ne&&ne<=90}e.isUpper=A;function k(ne){return 48<=ne&&ne<=57}function E(ne){return ne===32||ne===9||ne===10||ne===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>T.add(ne.charCodeAt(0)));function _(ne){return E(ne)||T.has(ne)}function g(ne,ie){return ne===ie||_(ne)&&_(ie)}function p(ne){return D(ne)||A(ne)||k(ne)}function m(ne,ie){return ie.length===0?ie=[ne]:ne.end===ie[0].start?ie[0].start=ne.start:ie.unshift(ne),ie}function b(ne,ie){for(let O=ie;O<ne.length;O++){const j=ne.charCodeAt(O);if(A(j)||k(j)||O>0&&!p(ne.charCodeAt(O-1)))return O}return ne.length}function f(ne,ie,O,j){if(O===ne.length)return[];if(j===ie.length)return null;if(ne[O]!==ie[j].toLowerCase())return null;{let G=null,X=j+1;for(G=f(ne,ie,O+1,j+1);!G&&(X=b(ie,X))<ie.length;)G=f(ne,ie,O+1,X),X++;return G===null?null:m({start:j,end:j+1},G)}}function c(ne){let ie=0,O=0,j=0,G=0,X=0;for(let ye=0;ye<ne.length;ye++)X=ne.charCodeAt(ye),A(X)&&ie++,D(X)&&O++,p(X)&&j++,k(X)&&G++;const pe=ie/ne.length,we=O/ne.length,ce=j/ne.length,Ce=G/ne.length;return{upperPercent:pe,lowerPercent:we,alphaPercent:ce,numericPercent:Ce}}function v(ne){const{upperPercent:ie,lowerPercent:O}=ne;return O===0&&ie>.6}function a(ne){const{upperPercent:ie,lowerPercent:O,alphaPercent:j,numericPercent:G}=ne;return O>.2&&ie<.8&&j>.6&&G<.2}function d(ne){let ie=0,O=0,j=0,G=0;for(let X=0;X<ne.length;X++)j=ne.charCodeAt(X),A(j)&&ie++,D(j)&&O++,E(j)&&G++;return(ie===0||O===0)&&G===0?ne.length<=30:ie<=5}function o(ne,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!d(ne)||ie.length>60)return null;const O=c(ie);if(!a(O)){if(!v(O))return null;ie=ie.toLowerCase()}let j=null,G=0;for(ne=ne.toLowerCase();G<ie.length&&(j=f(ne,ie,0,G))===null;)G=b(ie,G+1);return j}e.matchesCamelCase=o;function i(ne,ie,O=!1){if(!ie||ie.length===0)return null;let j=null,G=0;for(ne=ne.toLowerCase(),ie=ie.toLowerCase();G<ie.length&&(j=s(ne,ie,0,G,O))===null;)G=l(ie,G+1);return j}e.matchesWords=i;function s(ne,ie,O,j,G){if(O===ne.length)return[];if(j===ie.length)return null;if(g(ne.charCodeAt(O),ie.charCodeAt(j))){let X=null,pe=j+1;if(X=s(ne,ie,O+1,j+1,G),!G)for(;!X&&(pe=l(ie,pe))<ie.length;)X=s(ne,ie,O+1,pe,G),pe++;return X?ne.charCodeAt(O)!==ie.charCodeAt(j)?X:m({start:j,end:j+1},X):null}else return null}function l(ne,ie){for(let O=ie;O<ne.length;O++)if(_(ne.charCodeAt(O))||O>0&&_(ne.charCodeAt(O-1)))return O;return ne.length}const n=C(e.matchesPrefix,o,y),r=C(e.matchesPrefix,o,I),h=new u.LRUCache(1e4);function w(ne,ie,O=!1){if(typeof ne!="string"||typeof ie!="string")return null;let j=h.get(ne);j||(j=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),h.set(ne,j));const G=j.exec(ie);return G?[{start:G.index,end:G.index+G[0].length}]:O?r(ne,ie):n(ne,ie)}e.matchesFuzzy=w;function L(ne,ie){const O=Re(ne,ne.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?B(O):null}e.matchesFuzzy2=L;function M(ne,ie,O,j,G,X){const pe=Math.min(13,ne.length);for(;O<pe;O++){const we=Re(ne,ie,O,j,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=M;function B(ne){if(typeof ne>"u")return[];const ie=[],O=ne[1];for(let j=ne.length-1;j>1;j--){const G=ne[j]+O,X=ie[ie.length-1];X&&X.end===G?X.end=G+1:ie.push({start:G,end:G+1})}return ie}e.createMatches=B;const R=128;function z(){const ne=[],ie=[];for(let O=0;O<=R;O++)ie[O]=0;for(let O=0;O<=R;O++)ne.push(ie.slice(0));return ne}function H(ne){const ie=[];for(let O=0;O<=ne;O++)ie[O]=0;return ie}const N=H(2*R),V=H(2*R),U=z(),F=z(),x=z(),$=!1;function Q(ne,ie,O,j,G){function X(we,ce,Ce=" "){for(;we.length<ce;)we=Ce+we;return we}let pe=` |   |${j.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=O;we++)we===0?pe+=" |":pe+=`${ie[we-1]}|`,pe+=ne[we].slice(0,G+1).map(ce=>X(ce.toString(),3)).join("|")+`
`;return pe}function K(ne,ie,O,j){ne=ne.substr(ie),O=O.substr(j),console.log(Q(F,ne,ne.length,O,O.length)),console.log(Q(x,ne,ne.length,O,O.length)),console.log(Q(U,ne,ne.length,O,O.length))}function de(ne,ie){if(ie<0||ie>=ne.length)return!1;const O=ne.codePointAt(ie);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(O)}}function ee(ne,ie){if(ie<0||ie>=ne.length)return!1;switch(ne.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function he(ne,ie,O){return ie[ne]!==O[ne]}function Y(ne,ie,O,j,G,X,pe=!1){for(;ie<O&&G<X;)ne[ie]===j[G]&&(pe&&(N[ie]=G),ie+=1),G+=1;return ie===O}e.isPatternInWord=Y;var me;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(me||(me={}));var be;(function(ne){ne.Default=[-100,0];function ie(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}ne.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,O){this.firstMatchCanBeWeak=ie,this.boostFullMatch=O}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,ie,O,j,G,X,pe=ke.default){const we=ne.length>R?R:ne.length,ce=j.length>R?R:j.length;if(O>=we||X>=ce||we-O>ce-X||!Y(ie,O,we,G,X,ce,!0))return;ze(we,ce,O,X,ie,G);let Ce=1,ye=1,We=O,qe=X;const Ze=[!1];for(Ce=1,We=O;We<we;Ce++,We++){const se=N[We],Ee=V[We],Ve=We+1<we?V[We+1]:ce;for(ye=se-X+1,qe=se;qe<Ve;ye++,qe++){let fe=Number.MIN_SAFE_INTEGER,Ae=!1;qe<=Ee&&(fe=oe(ne,ie,We,O,j,G,qe,ce,X,U[Ce-1][ye-1]===0,Ze));let Le=0;fe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=fe+F[Ce-1][ye-1]);const Me=qe>se,Ke=Me?F[Ce][ye-1]+(U[Ce][ye-1]>0?-5:0):0,Je=qe>se+1&&U[Ce][ye-1]>0,st=Je?F[Ce][ye-2]+(U[Ce][ye-2]>0?-5:0):0;if(Je&&(!Me||st>=Ke)&&(!Ae||st>=Le))F[Ce][ye]=st,x[Ce][ye]=3,U[Ce][ye]=0;else if(Me&&(!Ae||Ke>=Le))F[Ce][ye]=Ke,x[Ce][ye]=2,U[Ce][ye]=0;else if(Ae)F[Ce][ye]=Le,x[Ce][ye]=1,U[Ce][ye]=U[Ce-1][ye-1]+1;else throw new Error("not possible")}}if($&&K(ne,O,j,X),!Ze[0]&&!pe.firstMatchCanBeWeak)return;Ce--,ye--;const Ye=[F[Ce][ye],X];let Ne=0,at=0;for(;Ce>=1;){let se=ye;do{const Ee=x[Ce][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Ne>1&&ie[O+Ce-1]===G[X+ye-1]&&!he(se+X-1,j,G)&&Ne+1>U[Ce][se]&&(se=ye),se===ye?Ne++:Ne=1,at||(at=se),Ce--,ye=se-1,Ye.push(ye)}ce===we&&pe.boostFullMatch&&(Ye[0]+=2);const re=at-we;return Ye[0]-=re,Ye}e.fuzzyScore=Re;function ze(ne,ie,O,j,G,X){let pe=ne-1,we=ie-1;for(;pe>=O&&we>=j;)G[pe]===X[we]&&(V[pe]=we,pe--),we--}function oe(ne,ie,O,j,G,X,pe,we,ce,Ce,ye){if(ie[O]!==X[pe])return Number.MIN_SAFE_INTEGER;let We=1,qe=!1;return pe===O-j?We=ne[O]===G[pe]?7:5:he(pe,G,X)&&(pe===0||!he(pe-1,G,X))?(We=ne[O]===G[pe]?7:5,qe=!0):de(X,pe)&&(pe===0||!de(X,pe-1))?We=5:(de(X,pe-1)||ee(X,pe-1))&&(We=5,qe=!0),We>1&&O===j&&(ye[0]=!0),qe||(qe=he(pe,G,X)||de(X,pe-1)||ee(X,pe-1)),O===j?pe>ce&&(We-=qe?3:5):Ce?We+=qe?2:0:We+=qe?0:1,pe+1===we&&(We-=qe?3:5),We}function le(ne,ie,O,j,G,X,pe){return Z(ne,ie,O,j,G,X,!0,pe)}e.fuzzyScoreGracefulAggressive=le;function ge(ne,ie,O,j,G,X,pe){return Z(ne,ie,O,j,G,X,!1,pe)}e.fuzzyScoreGraceful=ge;function Z(ne,ie,O,j,G,X,pe,we){let ce=Re(ne,ie,O,j,G,X,we);if(ce&&!pe)return ce;if(ne.length>=3){const Ce=Math.min(7,ne.length-1);for(let ye=O+1;ye<Ce;ye++){const We=ae(ne,ye);if(We){const qe=Re(We,We.toLowerCase(),O,j,G,X,we);qe&&(qe[0]-=3,(!ce||qe[0]>ce[0])&&(ce=qe))}}}return ce}function ae(ne,ie){if(ie+1>=ne.length)return;const O=ne[ie],j=ne[ie+1];if(O!==j)return ne.slice(0,ie)+j+O+ne.slice(ie+2)}}),define(De[157],Ie([1,0,76,106,8]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(u.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${P.source}`,"g");function S(p){return p.replace(I,(m,b)=>b?m:`\\${m}`)}e.escapeIcons=S;const D=new RegExp(`\\\\${P.source}`,"g");function A(p){return p.replace(D,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=A;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function E(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(k,(m,b,f,c)=>f?m:b||c||"")}e.stripIcons=E;function T(p){const m=p.indexOf(e.iconStartMarker);return m===-1?{text:p}:_(p,m)}e.parseLabelWithIcons=T;function _(p,m){const b=[];let f="";function c(n){if(n){f+=n;for(const r of n)b.push(d)}}let v=-1,a="",d=0,o,i,s=m;const l=p.length;for(c(p.substr(0,m));s<l;)o=p[s],i=p[s+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(v=s,c(a),a=e.iconStartMarker,s++):o===")"&&v!==-1?(d+=s-v+1,v=-1,a=""):v!==-1?y.test(o)?a+=o:(c(a),v=-1,a=""):c(o),s++;return c(a),{text:f,iconOffsets:b}}function g(p,m,b=!1){const{text:f,iconOffsets:c}=m;if(!c||c.length===0)return(0,t.matchesFuzzy)(p,f,b);const v=(0,C.ltrim)(f," "),a=f.length-v.length,d=(0,t.matchesFuzzy)(p,v,b);if(d)for(const o of d){const i=c[o.start+a]+a;o.start+=i,o.end+=i}return d}e.matchesFuzzyIconAware=g}),define(De[80],Ie([1,0,26]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new u.LRUCache(1e4);function C(D){return S(D,"NFC",t)}e.normalizeNFC=C;const P=new u.LRUCache(1e4);function y(D){return S(D,"NFD",P)}e.normalizeNFD=y;const I=/[^\u0000-\u0080]/;function S(D,A,k){if(!D)return D;const E=k.get(D);if(E)return E;let T;return I.test(D)?T=D.normalize(A):T=D,k.set(D,T),T}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(A){return y(A).replace(D,"")}}()}),define(De[42],Ie([1,0,8]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const P="error",y="warning",I="warn",S="info",D="ignore";function A(E){return E?u.equalsIgnoreCase(P,E)?C.Error:u.equalsIgnoreCase(y,E)||u.equalsIgnoreCase(I,E)?C.Warning:u.equalsIgnoreCase(S,E)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function k(E){switch(E){case C.Error:return P;case C.Warning:return y;case C.Info:return S;default:return D}}C.toString=k}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,10]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function I(o,i){if(!o.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!C.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,i){return!o&&!i?"file":o}function D(o,i){switch(o){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const A="",k="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{static isUri(i){return i instanceof T?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,s,l,n,r,h=!1){typeof i=="object"?(this.scheme=i.scheme||A,this.authority=i.authority||A,this.path=i.path||A,this.query=i.query||A,this.fragment=i.fragment||A):(this.scheme=S(i,h),this.authority=s||A,this.path=D(this.scheme,l||A),this.query=n||A,this.fragment=r||A,I(this,h))}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:l,path:n,query:r,fragment:h}=i;return s===void 0?s=this.scheme:s===null&&(s=A),l===void 0?l=this.authority:l===null&&(l=A),n===void 0?n=this.path:n===null&&(n=A),r===void 0?r=this.query:r===null&&(r=A),h===void 0?h=this.fragment:h===null&&(h=A),s===this.scheme&&l===this.authority&&n===this.path&&r===this.query&&h===this.fragment?this:new g(s,l,n,r,h)}static parse(i,s=!1){const l=E.exec(i);return l?new g(l[2]||A,d(l[4]||A),d(l[5]||A),d(l[7]||A),d(l[9]||A),s):new g(A,A,A,A,A)}static file(i){let s=A;if(t.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const l=i.indexOf(k,2);l===-1?(s=i.substring(2),i=k):(s=i.substring(2,l),i=i.substring(l)||k)}return new g("file",s,i,A,A)}static from(i){const s=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return I(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&i.scheme==="file"?l=T.file(u.win32.join(f(i,!0),...s)).path:l=u.posix.join(i.path,...s),i.with({path:l})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof T)return i;{const s=new g(i);return s._formatted=i.external,s._fsPath=i._sep===_?i.fsPath:null,s}}else return i}}e.URI=T;const _=t.isWindows?1:void 0;class g extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=_),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(o,i){let s,l=-1;for(let n=0;n<o.length;n++){const r=o.charCodeAt(n);if(r>=97&&r<=122||r>=65&&r<=90||r>=48&&r<=57||r===45||r===46||r===95||r===126||i&&r===47)l!==-1&&(s+=encodeURIComponent(o.substring(l,n)),l=-1),s!==void 0&&(s+=o.charAt(n));else{s===void 0&&(s=o.substr(0,n));const h=p[r];h!==void 0?(l!==-1&&(s+=encodeURIComponent(o.substring(l,n)),l=-1),s+=h):l===-1&&(l=n)}}return l!==-1&&(s+=encodeURIComponent(o.substring(l))),s!==void 0?s:o}function b(o){let i;for(let s=0;s<o.length;s++){const l=o.charCodeAt(s);l===35||l===63?(i===void 0&&(i=o.substr(0,s)),i+=p[l]):i!==void 0&&(i+=o[s])}return i!==void 0?i:o}function f(o,i){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?i?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function c(o,i){const s=i?b:m;let l="",{scheme:n,authority:r,path:h,query:w,fragment:L}=o;if(n&&(l+=n,l+=":"),(r||n==="file")&&(l+=k,l+=k),r){let M=r.indexOf("@");if(M!==-1){const B=r.substr(0,M);r=r.substr(M+1),M=B.indexOf(":"),M===-1?l+=s(B,!1):(l+=s(B.substr(0,M),!1),l+=":",l+=s(B.substr(M+1),!1)),l+="@"}r=r.toLowerCase(),M=r.indexOf(":"),M===-1?l+=s(r,!1):(l+=s(r.substr(0,M),!1),l+=r.substr(M))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const M=h.charCodeAt(1);M>=65&&M<=90&&(h=`/${String.fromCharCode(M+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const M=h.charCodeAt(0);M>=65&&M<=90&&(h=`${String.fromCharCode(M+32)}:${h.substr(2)}`)}l+=s(h,!0)}return w&&(l+="?",l+=s(w,!1)),L&&(l+="#",l+=i?L:m(L,!1)),l}function v(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+v(o.substr(3)):o}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(o){return o.match(a)?o.replace(a,i=>v(i)):o}}),define(De[81],Ie([1,0,23,8,2]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(D){return JSON.stringify(D,I)}e.stringify=P;function y(D){let A=JSON.parse(D);return A=S(A),A}e.parse=y;function I(D,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,t.regExpFlags)(A)}:A}function S(D,A=0){if(!D||A>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return C.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 15:return new Date(D.source)}if(D instanceof u.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let k=0;k<D.length;++k)D[k]=S(D[k],A+1);else for(const k in D)Object.hasOwnProperty.call(D,k)&&(D[k]=S(D[k],A+1))}return D}e.revive=S}),define(De[14],Ie([1,0,10,2]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}setServerRootPath(D){this._remoteResourcesPath=`${D}/${C.vscodeRemoteResource}`}set(D,A,k){this._hosts[D]=A,this._ports[D]=k}setConnectionToken(D,A){this._connectionTokens[D]=A}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)return this._delegate(D);const A=D.authority;let k=this._hosts[A];k&&k.indexOf(":")!==-1&&k.indexOf("[")===-1&&(k=`[${k}]`);const E=this._ports[A],T=this._connectionTokens[A];let _=`path=${encodeURIComponent(D.path)}`;return typeof T=="string"&&(_+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),t.URI.from({scheme:u.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${k}:${E}`,path:this._remoteResourcesPath,query:_})}}e.RemoteAuthorities=new P;class y{asBrowserUri(D,A){const k=this.toUri(D,A);return k.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===C.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${C.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?k.with({scheme:C.vscodeFileResource,authority:k.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(D,A){const k=this.toUri(D,A);return k.scheme===C.vscodeFileResource?k.with({scheme:C.file,authority:k.authority!==y.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(D,A){return t.URI.isUri(D)?D:t.URI.parse(A.toUrl(D))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var I;(function(S){const D=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(D.get("3"));const A="vscode-coi";function k(T){let _;typeof T=="string"?_=new URL(T).searchParams:T instanceof URL?_=T.searchParams:t.URI.isUri(T)&&(_=new URL(T.toString(!0)).searchParams);const g=_?.get(A);if(!!g)return D.get(g)}S.getHeadersFromQuery=k;function E(T,_,g){if(!globalThis.crossOriginIsolated)return;const p=_&&g?"3":g?"2":"1";T instanceof URLSearchParams?T.set(A,p):T[A]=p}S.addSearchParam=E})(I=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,32,14,9,10,8,2]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(T){return(0,I.uriToFsPath)(T,!0)}e.originalFSPath=S;class D{constructor(_){this._ignorePathCasing=_}compare(_,g,p=!1){return _===g?0:(0,y.compare)(this.getComparisonKey(_,p),this.getComparisonKey(g,p))}isEqual(_,g,p=!1){return _===g?!0:!_||!g?!1:this.getComparisonKey(_,p)===this.getComparisonKey(g,p)}getComparisonKey(_,g=!1){return _.with({path:this._ignorePathCasing(_)?_.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(_){return this._ignorePathCasing(_)}isEqualOrParent(_,g,p=!1){if(_.scheme===g.scheme){if(_.scheme===t.Schemas.file)return u.isEqualOrParent(S(_),S(g),this._ignorePathCasing(_))&&_.query===g.query&&(p||_.fragment===g.fragment);if((0,e.isEqualAuthority)(_.authority,g.authority))return u.isEqualOrParent(_.path,g.path,this._ignorePathCasing(_),"/")&&_.query===g.query&&(p||_.fragment===g.fragment)}return!1}joinPath(_,...g){return I.URI.joinPath(_,...g)}basenameOrAuthority(_){return(0,e.basename)(_)||_.authority}basename(_){return C.posix.basename(_.path)}extname(_){return C.posix.extname(_.path)}dirname(_){if(_.path.length===0)return _;let g;return _.scheme===t.Schemas.file?g=I.URI.file(C.dirname(S(_))).path:(g=C.posix.dirname(_.path),_.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${_.toString})) resulted in a relative path`),g="/")),_.with({path:g})}normalizePath(_){if(!_.path.length)return _;let g;return _.scheme===t.Schemas.file?g=I.URI.file(C.normalize(S(_))).path:g=C.posix.normalize(_.path),_.with({path:g})}relativePath(_,g){if(_.scheme!==g.scheme||!(0,e.isEqualAuthority)(_.authority,g.authority))return;if(_.scheme===t.Schemas.file){const b=C.relative(S(_),S(g));return P.isWindows?u.toSlashes(b):b}let p=_.path||"/";const m=g.path||"/";if(this._ignorePathCasing(_)){let b=0;for(const f=Math.min(p.length,m.length);b<f&&!(p.charCodeAt(b)!==m.charCodeAt(b)&&p.charAt(b).toLowerCase()!==m.charAt(b).toLowerCase());b++);p=m.substr(0,b)+p.substr(b)}return C.posix.relative(p,m)}resolvePath(_,g){if(_.scheme===t.Schemas.file){const p=I.URI.file(C.resolve(S(_),g));return _.with({authority:p.authority,path:p.path})}return g=u.toPosixPath(g),_.with({path:C.posix.resolve(_.path,g)})}isAbsolutePath(_){return!!_.path&&_.path[0]==="/"}isEqualAuthority(_,g){return _===g||_!==void 0&&g!==void 0&&(0,y.equalsIgnoreCase)(_,g)}hasTrailingPathSeparator(_,g=C.sep){if(_.scheme===t.Schemas.file){const p=S(_);return p.length>u.getRoot(p).length&&p[p.length-1]===g}else{const p=_.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(_.fsPath)}}removeTrailingPathSeparator(_,g=C.sep){return(0,e.hasTrailingPathSeparator)(_,g)?_.with({path:_.path.substr(0,_.path.length-1)}):_}addTrailingPathSeparator(_,g=C.sep){let p=!1;if(_.scheme===t.Schemas.file){const m=S(_);p=m!==void 0&&m.length===u.getRoot(m).length&&m[m.length-1]===g}else{g="/";const m=_.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(_,g)?_.with({path:_.path+"/"}):_}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(T,_){const g=[];for(let p=0;p<T.length;p++){const m=_(T[p]);T.some((b,f)=>f===p?!1:(0,e.isEqualOrParent)(m,_(b)))||g.push(T[p])}return g}e.distinctParents=A;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function _(g){const p=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,v]=f.split(":");c&&v&&p.set(c,v)});const b=g.path.substring(0,g.path.indexOf(";"));return b&&p.set(T.META_DATA_MIME,b),p}T.parseMetaData=_})(k=e.DataUri||(e.DataUri={}));function E(T,_,g){if(_){let p=T.path;return p&&p[0]!==C.posix.sep&&(p=C.posix.sep+p),T.with({scheme:g,authority:_,path:p})}return T.with({scheme:g})}e.toLocalResource=E}),define(De[18],Ie([1,0,21,11,3,6,22,10]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(he){return!!he&&typeof he.then=="function"}e.isThenable=S;function D(he){const Y=new u.CancellationTokenSource,me=he(Y.token),be=new Promise((ke,Re)=>{const ze=Y.token.onCancellationRequested(()=>{ze.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(me).then(oe=>{ze.dispose(),Y.dispose(),ke(oe)},oe=>{ze.dispose(),Y.dispose(),Re(oe)})});return new class{cancel(){Y.cancel()}then(ke,Re){return be.then(ke,Re)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=D;function A(he,Y,me){return new Promise((be,ke)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(me)});he.then(be,ke).finally(()=>Re.dispose())})}e.raceCancellation=A;function k(he,Y){return new Promise((me,be)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});he.then(me,be).finally(()=>ke.dispose())})}e.raceCancellationError=k;async function E(he){let Y=-1;const me=he.map((ke,Re)=>ke.then(ze=>(Y=Re,ze))),be=await Promise.race(me);return he.forEach((ke,Re)=>{Re!==Y&&ke.cancel()}),be}e.raceCancellablePromises=E;function T(he,Y,me){let be;const ke=setTimeout(()=>{be?.(void 0),me?.()},Y);return Promise.race([he.finally(()=>clearTimeout(ke)),new Promise(Re=>be=Re)])}e.raceTimeout=T;function _(he){return new Promise((Y,me)=>{const be=he();S(be)?be.then(Y,me):Y(be)})}e.asPromise=_;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(me,me).then(be)})}return new Promise((me,be)=>{this.queuedPromise.then(me,be)})}return this.activePromise=Y(),new Promise((me,be)=>{this.activePromise.then(ke=>{this.activePromise=null,me(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=g;class p{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=p;class m{constructor(){this.promiseMap=new Map}queue(Y,me){const ke=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(Y)===ke&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ke),ke}}e.SequencerByKey=m;const b=(he,Y)=>{let me=!0;const be=setTimeout(()=>{me=!1,Y()},he);return{isTriggered:()=>me,dispose:()=>{clearTimeout(be),me=!1}}},f=he=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,he())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,me=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Re)=>{this.doResolve=ke,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?f(be):b(me,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class v{constructor(Y){this.delayer=new c(Y),this.throttler=new g}trigger(Y,me){return this.delayer.trigger(()=>this.throttler.queue(Y),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class a{constructor(){this._isOpen=!1,this._promise=new Promise((Y,me)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class d extends a{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function o(he,Y){return Y?new Promise((me,be)=>{const ke=setTimeout(()=>{Re.dispose(),me()},he),Re=Y.onCancellationRequested(()=>{clearTimeout(ke),Re.dispose(),be(new t.CancellationError)})}):D(me=>o(he,me))}e.timeout=o;function i(he,Y=0){const me=setTimeout(he,Y);return(0,P.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=i;function s(he){const Y=[];let me=0;const be=he.length;function ke(){return me<be?he[me++]():null}function Re(ze){ze!=null&&Y.push(ze);const oe=ke();return oe?oe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=s;function l(he,Y=be=>!!be,me=null){let be=0;const ke=he.length,Re=()=>{if(be>=ke)return Promise.resolve(me);const ze=he[be++];return Promise.resolve(ze()).then(le=>Y(le)?Promise.resolve(le):Re())};return Re()}e.first=l;function n(he,Y=be=>!!be,me=null){if(he.length===0)return Promise.resolve(me);let be=he.length;const ke=()=>{be=-1;for(const Re of he)Re.cancel?.()};return new Promise((Re,ze)=>{for(const oe of he)oe.then(le=>{--be>=0&&Y(le)?(ke(),Re(le)):be===0&&Re(me)}).catch(le=>{--be>=0&&(ke(),ze(le))})})}e.firstParallel=n;class r{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((me,be)=>{this.outstandingPromises.push({factory:Y,c:me,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const me=Y.factory();me.then(Y.c,Y.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=r;class h extends r{constructor(){super(1)}}e.Queue=h;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new x;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,me=y.extUri){const be=me.getComparisonKey(Y);let ke=this.queues.get(be);return ke||(ke=new h,C.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class L{constructor(Y,me){this._token=-1,typeof Y=="function"&&typeof me=="number"&&this.setIfNotSet(Y,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},me)}setIfNotSet(Y,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},me))}}e.TimeoutTimer=L;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setInterval(()=>{Y()},me)}}e.IntervalTimer=M;class B{constructor(Y,me){this.timeoutToken=-1,this.runner=Y,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class R{constructor(Y,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=R;class z extends B{constructor(Y,me){super(Y,me),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class H extends P.Disposable{constructor(Y,me){super(),this.options=Y,this.handler=me,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,I.setTimeout0)(()=>{if(Y)return;const me=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(he,Y)=>{const me=requestIdleCallback(he,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(me))}}}}();class N{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function V(he,Y,me){let be;for(let ke=0;ke<me;ke++)try{return await he()}catch(Re){be=Re,await o(Y)}throw be}e.retry=V;class U{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,me,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:me},me.then(()=>this.donePending(Y),()=>this.donePending(Y)),me}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let me,be;const ke=new Promise((Re,ze)=>{me=Re,be=ze});this._next={run:Y,promise:ke,promiseResolve:me,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=U;class F{constructor(Y,me=()=>Date.now()){this.interval=Y,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class x{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,me)=>{this.completeCallback=Y,this.errorCallback=me})}complete(Y){return new Promise(me=>{this.completeCallback(Y),this.resolved=!0,me()})}error(Y){return new Promise(me=>{this.errorCallback(Y),this.rejected=!0,me()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=x;var $;(function(he){async function Y(be){let ke;const Re=await Promise.all(be.map(ze=>ze.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Re}he.settled=Y;function me(be){return new Promise(async(ke,Re)=>{try{await be(ke,Re)}catch(ze){Re(ze)}})}he.withAsyncBody=me})($=e.Promises||(e.Promises={}));var Q;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(me=>{me.emitMany(Y)})}static fromPromise(Y){return new K(async me=>{me.emitMany(await Y)})}static fromPromises(Y){return new K(async me=>{await Promise.all(Y.map(async be=>me.emitOne(await be)))})}static merge(Y){return new K(async me=>{await Promise.all(Y.map(async be=>{for await(const ke of be)me.emitOne(ke)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const me={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(me)),this.resolve()}catch(be){this.reject(be)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,me){return new K(async be=>{for await(const ke of Y)be.emitOne(me(ke))})}map(Y){return K.map(this,Y)}static filter(Y,me){return new K(async be=>{for await(const ke of Y)me(ke)&&be.emitOne(ke)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,me=>!!me)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const me=[];for await(const be of Y)me.push(be);return me}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class de extends K{constructor(Y,me){super(me),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=de;function ee(he){const Y=new u.CancellationTokenSource,me=he(Y.token);return new de(Y,async be=>{const ke=Y.token.onCancellationRequested(()=>{ke.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of me){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}ke.dispose(),Y.dispose()}catch(Re){ke.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=ee}),define(De[107],Ie([1,0,18,9]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new u.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),P=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(h,w,L=!1){const M=h||"",B=w||"",R=C.value.collator.compare(M,B);return C.value.collatorIsNumeric&&R===0&&M!==B?M<B?-1:1:R}e.compareFileNames=I;function S(h,w){const L=P.value.collator;return h=h||"",w=w||"",v(L,h,w)}e.compareFileNamesDefault=S;function D(h,w){const L=P.value.collator;return h=h||"",w=w||"",i(h,w)||v(L,h,w)}e.compareFileNamesUpper=D;function A(h,w){const L=P.value.collator;return h=h||"",w=w||"",o(h,w)||v(L,h,w)}e.compareFileNamesLower=A;function k(h,w){return h=h||"",w=w||"",h===w?0:h<w?-1:1}e.compareFileNamesUnicode=k;function E(h,w,L=!1){L||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase());const[M,B]=f(h),[R,z]=f(w);return M!==R?M<R?-1:1:B===z?0:B<z?-1:1}e.noIntlCompareFileNames=E;function T(h,w){const[L,M]=f(h),[B,R]=f(w);let z=C.value.collator.compare(M,R);if(z===0){if(C.value.collatorIsNumeric&&M!==R)return M<R?-1:1;if(z=C.value.collator.compare(L,B),C.value.collatorIsNumeric&&z===0&&L!==B)return L<B?-1:1}return z}e.compareFileExtensions=T;function _(h,w){h=h||"",w=w||"";const L=c(h),M=c(w),B=P.value.collator,R=y.value.collator;return v(R,L,M)||v(B,h,w)}e.compareFileExtensionsDefault=_;function g(h,w){h=h||"",w=w||"";const L=c(h),M=c(w),B=P.value.collator,R=y.value.collator;return v(R,L,M)||i(h,w)||v(B,h,w)}e.compareFileExtensionsUpper=g;function p(h,w){h=h||"",w=w||"";const L=c(h),M=c(w),B=P.value.collator,R=y.value.collator;return v(R,L,M)||o(h,w)||v(B,h,w)}e.compareFileExtensionsLower=p;function m(h,w){h=h||"",w=w||"";const L=c(h).toLowerCase(),M=c(w).toLowerCase();return L!==M?L<M?-1:1:h!==w?h<w?-1:1:0}e.compareFileExtensionsUnicode=m;const b=/^(.*?)(\.([^.]*))?$/;function f(h,w=!1){const L=h?b.exec(h):[];let M=[L&&L[1]||"",L&&L[3]||""];return w&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function c(h){const w=h?b.exec(h):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function v(h,w,L){const M=h.compare(w,L);return M!==0?M:w.length!==L.length?w.length<L.length?-1:1:0}function a(h){const w=h.charAt(0);return w.toLocaleUpperCase()!==w}function d(h){const w=h.charAt(0);return w.toLocaleLowerCase()!==w}function o(h,w){return a(h)&&d(w)?-1:d(h)&&a(w)?1:0}function i(h,w){return d(h)&&a(w)?-1:a(h)&&d(w)?1:0}function s(h,w,L=!1){return L||(h=h&&h.toLowerCase(),w=w&&w.toLowerCase()),h===w?0:h<w?-1:1}function l(h,w,L=!1){const M=h.split(t.sep),B=w.split(t.sep),R=M.length-1,z=B.length-1;let H,N;for(let V=0;;V++){if(H=R===V,N=z===V,H&&N)return I(M[V],B[V],L);if(H)return-1;if(N)return 1;const U=s(M[V],B[V],L);if(U!==0)return U}}e.comparePaths=l;function n(h,w,L){const M=h.toLowerCase(),B=w.toLowerCase(),R=r(h,w,L);if(R)return R;const z=M.endsWith(L),H=B.endsWith(L);if(z!==H)return z?-1:1;const N=I(M,B);return N!==0?N:M.localeCompare(B)}e.compareAnything=n;function r(h,w,L){const M=h.toLowerCase(),B=w.toLowerCase(),R=M.startsWith(L),z=B.startsWith(L);if(R!==z)return R?-1:1;if(R&&z){if(M.length<B.length)return-1;if(M.length>B.length)return 1}return 0}e.compareByPrefix=r}),define(De[108],Ie([1,0,107,106,79,9,10,8]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,D=[S,[]];function A(U,F,x,$){if(!U||!F)return D;const Q=U.length,K=F.length;if(Q<K)return D;const de=U.toLowerCase();return k(F,x,K,U,de,Q,$)}e.scoreFuzzy=A;function k(U,F,x,$,Q,K,de){const ee=[],he=[];for(let ke=0;ke<x;ke++){const Re=ke*K,ze=Re-K,oe=ke>0,le=U[ke],ge=F[ke];for(let Z=0;Z<K;Z++){const ae=Z>0,ne=Re+Z,ie=ne-1,O=ze+Z-1,j=ae?ee[ie]:0,G=oe&&ae?ee[O]:0,X=oe&&ae?he[O]:0;let pe;!G&&oe?pe=0:pe=E(le,ge,$,Q,Z,X),pe&&G+pe>=j&&(de||oe||Q.startsWith(F,Z))?(he[ne]=X+1,ee[ne]=G+pe):(he[ne]=S,ee[ne]=j)}}const Y=[];let me=x-1,be=K-1;for(;me>=0&&be>=0;){const ke=me*K+be;he[ke]===S||(Y.push(be),me--),be--}return[ee[x*K-1],Y.reverse()]}function E(U,F,x,$,Q,K){let de=0;if(!T(F,$[Q]))return de;if(de+=1,K>0&&(de+=K*5),U===x[Q]&&(de+=1),Q===0)de+=8;else{const ee=_(x.charCodeAt(Q-1));ee?de+=ee:(0,t.isUpper)(x.charCodeAt(Q))&&K===0&&(de+=2)}return de}function T(U,F){return U===F?!0:U==="/"||U==="\\"?F==="/"||F==="\\":!1}function _(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function p(U,F,x=0,$=0){const Q=F;return Q.values&&Q.values.length>1?m(U,Q.values,x,$):b(U,F,x,$)}e.scoreFuzzy2=p;function m(U,F,x,$){let Q=0;const K=[];for(const de of F){const[ee,he]=b(U,de,x,$);if(typeof ee!="number")return g;Q+=ee,K.push(...he)}return[Q,r(K)]}function b(U,F,x,$){const Q=(0,t.fuzzyScore)(F.original,F.originalLowercase,x,U,U.toLowerCase(),$,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:g}const f=Object.freeze({score:0}),c=1<<18,v=1<<17,a=1<<16;function d(U,F,x,$){const Q=$.values?$.values:[$];return(0,C.hash)({[$.normalized]:{values:Q.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:U,description:F,allowNonContiguousMatches:x}})}function o(U,F,x,$,Q){if(!U||!F.normalized)return f;const K=$.getItemLabel(U);if(!K)return f;const de=$.getItemDescription(U),ee=d(K,de,x,F),he=Q[ee];if(he)return he;const Y=i(K,de,$.getItemPath(U),F,x);return Q[ee]=Y,Y}e.scoreItemFuzzy=o;function i(U,F,x,$,Q){const K=!x||!$.containsPathSeparator;return x&&(y.isLinux?$.pathNormalized===x:(0,I.equalsIgnoreCase)($.pathNormalized,x))?{score:c,labelMatch:[{start:0,end:U.length}],descriptionMatch:F?[{start:0,end:F.length}]:void 0}:$.values&&$.values.length>1?s(U,F,x,$.values,K,Q):l(U,F,x,$,K,Q)}function s(U,F,x,$,Q,K){let de=0;const ee=[],he=[];for(const Y of $){const{score:me,labelMatch:be,descriptionMatch:ke}=l(U,F,x,Y,Q,K);if(me===S)return f;de+=me,be&&ee.push(...be),ke&&he.push(...ke)}return{score:de,labelMatch:r(ee),descriptionMatch:r(he)}}function l(U,F,x,$,Q,K){if(Q||!F){const[de,ee]=A(U,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(de){const he=(0,t.matchesPrefix)($.normalized,U);let Y;return he?(Y=v,Y+=Math.round($.normalized.length/U.length*100)):Y=a,{score:Y+de,labelMatch:he||n(ee)}}}if(F){let de=F;x&&(de=`${F}${P.sep}`);const ee=de.length,he=`${de}${U}`,[Y,me]=A(he,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(Y){const be=n(me),ke=[],Re=[];return be.forEach(ze=>{ze.start<ee&&ze.end>ee?(ke.push({start:0,end:ze.end-ee}),Re.push({start:ze.start,end:ee})):ze.start>=ee?ke.push({start:ze.start-ee,end:ze.end-ee}):Re.push(ze)}),{score:Y,labelMatch:ke,descriptionMatch:Re}}}return f}function n(U){const F=[];if(!U)return F;let x;for(const $ of U)x&&x.end===$?x.end+=1:(x={start:$,end:$+1},F.push(x));return F}function r(U){const F=U.sort((Q,K)=>Q.start-K.start),x=[];let $;for(const Q of F)!$||!h($,Q)?($=Q,x.push(Q)):($.start=Math.min($.start,Q.start),$.end=Math.max($.end,Q.end));return x}function h(U,F){return!(U.end<F.start||F.end<U.start)}function w(U,F,x,$,Q,K){const de=o(U,x,$,Q,K),ee=o(F,x,$,Q,K),he=de.score,Y=ee.score;if((he===c||Y===c)&&he!==Y)return he===c?-1:1;if(he>a||Y>a){if(he!==Y)return he>Y?-1:1;if(he<v&&Y<v){const le=M(de.labelMatch,ee.labelMatch);if(le!==0)return le}const ze=Q.getItemLabel(U)||"",oe=Q.getItemLabel(F)||"";if(ze.length!==oe.length)return ze.length-oe.length}if(he!==Y)return he>Y?-1:1;const me=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,be=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(me&&!be)return-1;if(be&&!me)return 1;const ke=L(U,de,Q),Re=L(F,ee,Q);return ke&&Re&&ke!==Re?Re>ke?-1:1:B(U,F,x,Q)}e.compareItemsByFuzzyScore=w;function L(U,F,x){let $=-1,Q=-1;if(F.descriptionMatch&&F.descriptionMatch.length?$=F.descriptionMatch[0].start:F.labelMatch&&F.labelMatch.length&&($=F.labelMatch[0].start),F.labelMatch&&F.labelMatch.length){if(Q=F.labelMatch[F.labelMatch.length-1].end,F.descriptionMatch&&F.descriptionMatch.length){const K=x.getItemDescription(U);K&&(Q+=K.length)}}else F.descriptionMatch&&F.descriptionMatch.length&&(Q=F.descriptionMatch[F.descriptionMatch.length-1].end);return Q-$}function M(U,F){if(!U&&!F||(!U||!U.length)&&(!F||!F.length))return 0;if(!F||!F.length)return-1;if(!U||!U.length)return 1;const x=U[0].start,Q=U[U.length-1].end-x,K=F[0].start,ee=F[F.length-1].end-K;return Q===ee?0:ee<Q?1:-1}function B(U,F,x,$){const Q=$.getItemLabel(U)||"",K=$.getItemLabel(F)||"",de=$.getItemDescription(U),ee=$.getItemDescription(F),he=Q.length+(de?de.length:0),Y=K.length+(ee?ee.length:0);if(he!==Y)return he-Y;const me=$.getItemPath(U),be=$.getItemPath(F);return me&&be&&me.length!==be.length?me.length-be.length:Q!==K?(0,u.compareAnything)(Q,K,x.normalized):de&&ee&&de!==ee?(0,u.compareAnything)(de,ee,x.normalized):me&&be&&me!==be?(0,u.compareAnything)(me,be,x.normalized):0}function R(U){return U.startsWith('"')&&U.endsWith('"')}const z=" ";function H(U){typeof U!="string"&&(U="");const F=U.toLowerCase(),{pathNormalized:x,normalized:$,normalizedLowercase:Q}=N(U),K=x.indexOf(P.sep)>=0,de=R(U);let ee;const he=U.split(z);if(he.length>1)for(const Y of he){const me=R(Y),{pathNormalized:be,normalized:ke,normalizedLowercase:Re}=N(Y);ke&&(ee||(ee=[]),ee.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Re,expectContiguousMatch:me}))}return{original:U,originalLowercase:F,pathNormalized:x,normalized:$,normalizedLowercase:Q,values:ee,containsPathSeparator:K,expectContiguousMatch:de}}e.prepareQuery=H;function N(U){let F;y.isWindows?F=U.replace(/\//g,P.sep):F=U.replace(/\\/g,P.sep);const x=(0,I.stripWildcards)(F).replace(/\s|"/g,"");return{pathNormalized:F,normalized:x,normalizedLowercase:x.toLowerCase()}}function V(U){return Array.isArray(U)?H(U.map(F=>F.original).join(z)):H(U.original)}e.pieceToQuery=V}),define(De[37],Ie([1,0,17,18,32,26,9,10,8]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",k="[^/\\\\]",E=/\//g;function T(x,$){switch(x){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${$?`|${A}${k}+`:""})*?`}}function _(x,$){if(!x)return[];const Q=[];let K=!1,de=!1,ee="";for(const he of x){switch(he){case $:if(!K&&!de){Q.push(ee),ee="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":de=!0;break;case"]":de=!1;break}ee+=he}return ee&&Q.push(ee),Q}e.splitGlobAware=_;function g(x){if(!x)return"";let $="";const Q=_(x,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))$=".*";else{let K=!1;Q.forEach((de,ee)=>{if(de===e.GLOBSTAR){if(K)return;$+=T(2,ee===Q.length-1)}else{let he=!1,Y="",me=!1,be="";for(const ke of de){if(ke!=="}"&&he){Y+=ke;continue}if(me&&(ke!=="]"||!be)){let Re;ke==="-"?Re=ke:(ke==="^"||ke==="!")&&!be?Re="^":ke===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(ke),be+=Re;continue}switch(ke){case"{":he=!0;continue;case"[":me=!0;continue;case"}":{$+=`(?:${_(Y,",").map(oe=>g(oe)).join("|")})`,he=!1,Y="";break}case"]":{$+="["+be+"]",me=!1,be="";break}case"?":$+=k;continue;case"*":$+=T(1);continue;default:$+=(0,S.escapeRegExpCharacters)(ke)}}ee<Q.length-1&&(Q[ee+1]!==e.GLOBSTAR||ee+2<Q.length)&&($+=A)}K=de===e.GLOBSTAR})}return $}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new P.LRUCache(1e4),d=function(){return!1},o=function(){return null};function i(x,$){if(!x)return o;let Q;typeof x!="string"?Q=x.pattern:Q=x,Q=Q.trim();const K=`${Q}_${!!$.trimForExclusions}`;let de=a.get(K);if(de)return s(de,x);let ee;return p.test(Q)?de=n(Q.substr(4),Q):(ee=m.exec(l(Q,$)))?de=r(ee[1],Q):($.trimForExclusions?f:b).test(Q)?de=h(Q,$):(ee=c.exec(l(Q,$)))?de=w(ee[1].substr(1),Q,!0):(ee=v.exec(l(Q,$)))?de=w(ee[1],Q,!1):de=L(Q),a.set(K,de),s(de,x)}function s(x,$){if(typeof $=="string")return x;const Q=function(K,de){return(0,C.isEqualOrParent)(K,$.base,!I.isLinux)?x(K.substr($.base.length+1),de):null};return Q.allBasenames=x.allBasenames,Q.allPaths=x.allPaths,Q.basenames=x.basenames,Q.patterns=x.patterns,Q}function l(x,$){return $.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function n(x,$){return function(Q,K){return typeof Q=="string"&&Q.endsWith(x)?$:null}}function r(x,$){const Q=`/${x}`,K=`\\${x}`,de=function(he,Y){return typeof he!="string"?null:Y?Y===x?$:null:he===x||he.endsWith(Q)||he.endsWith(K)?$:null},ee=[x];return de.basenames=ee,de.patterns=[$],de.allBasenames=ee,de}function h(x,$){const Q=U(x.slice(1,-1).split(",").map(Y=>i(Y,$)).filter(Y=>Y!==o),x),K=Q.length;if(!K)return o;if(K===1)return Q[0];const de=function(Y,me){for(let be=0,ke=Q.length;be<ke;be++)if(Q[be](Y,me))return x;return null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const he=Q.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function w(x,$,Q){const K=y.sep===y.posix.sep,de=K?x:x.replace(E,y.sep),ee=y.sep+de,he=y.posix.sep+x;let Y;return Q?Y=function(me,be){return typeof me=="string"&&(me===de||me.endsWith(ee)||!K&&(me===x||me.endsWith(he)))?$:null}:Y=function(me,be){return typeof me=="string"&&(me===de||!K&&me===x)?$:null},Y.allPaths=[(Q?"*/":"./")+x],Y}function L(x){try{const $=new RegExp(`^${g(x)}$`);return function(Q){return $.lastIndex=0,typeof Q=="string"&&$.test(Q)?x:null}}catch{return o}}function M(x,$,Q){return!x||typeof $!="string"?!1:B(x)($,void 0,Q)}e.match=M;function B(x,$={}){if(!x)return d;if(typeof x=="string"||R(x)){const Q=i(x,$);if(Q===o)return d;const K=function(de,ee){return!!Q(de,ee)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return N(x,$)}e.parse=B;function R(x){const $=x;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=R;function z(x){return x.allBasenames||[]}e.getBasenameTerms=z;function H(x){return x.allPaths||[]}e.getPathTerms=H;function N(x,$){const Q=U(Object.getOwnPropertyNames(x).map(Y=>V(Y,x[Y],$)).filter(Y=>Y!==o)),K=Q.length;if(!K)return o;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(ke,Re){let ze;for(let oe=0,le=Q.length;oe<le;oe++){const ge=Q[oe](ke,Re);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(ze||(ze=[]),ze.push(ge))}return ze?(async()=>{for(const oe of ze){const le=await oe;if(typeof le=="string")return le}return null})():null},me=Q.find(ke=>!!ke.allBasenames);me&&(Y.allBasenames=me.allBasenames);const be=Q.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return be.length&&(Y.allPaths=be),Y}const de=function(Y,me,be){let ke,Re;for(let ze=0,oe=Q.length;ze<oe;ze++){const le=Q[ze];le.requiresSiblings&&be&&(me||(me=(0,y.basename)(Y)),ke||(ke=me.substr(0,me.length-(0,y.extname)(Y).length)));const ge=le(Y,me,ke,be);if(typeof ge=="string")return ge;(0,t.isThenable)(ge)&&(Re||(Re=[]),Re.push(ge))}return Re?(async()=>{for(const ze of Re){const oe=await ze;if(typeof oe=="string")return oe}return null})():null},ee=Q.find(Y=>!!Y.allBasenames);ee&&(de.allBasenames=ee.allBasenames);const he=Q.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function V(x,$,Q){if($===!1)return o;const K=i(x,Q);if(K===o)return o;if(typeof $=="boolean")return K;if($){const de=$.when;if(typeof de=="string"){const ee=(he,Y,me,be)=>{if(!be||!K(he,Y))return null;const ke=de.replace("$(basename)",me),Re=be(ke);return(0,t.isThenable)(Re)?Re.then(ze=>ze?x:null):Re?x:null};return ee.requiresSiblings=!0,ee}}return K}function U(x,$){const Q=x.filter(Y=>!!Y.basenames);if(Q.length<2)return x;const K=Q.reduce((Y,me)=>{const be=me.basenames;return be?Y.concat(be):Y},[]);let de;if($){de=[];for(let Y=0,me=K.length;Y<me;Y++)de.push($)}else de=Q.reduce((Y,me)=>{const be=me.patterns;return be?Y.concat(be):Y},[]);const ee=function(Y,me){if(typeof Y!="string")return null;if(!me){let ke;for(ke=Y.length;ke>0;ke--){const Re=Y.charCodeAt(ke-1);if(Re===47||Re===92)break}me=Y.substr(ke)}const be=K.indexOf(me);return be!==-1?de[be]:null};ee.basenames=K,ee.patterns=de,ee.allBasenames=K;const he=x.filter(Y=>!Y.basenames);return he.push(ee),he}function F(x,$){return(0,u.equals)(x,$,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=F}),define(De[109],Ie([1,0,11,157,22,8,2]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(m="",b=!1){if(this.value=m,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(m,b=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(f,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,b){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(m,b,f){return this.value+="[",this.value+=this._escape(b,"]"),this.value+="](",this.value+=this._escape(String(m),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(m,b){const f=new RegExp((0,P.escapeRegExpCharacters)(b),"g");return m.replace(f,(c,v)=>m.charAt(v-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=S;function D(p){return A(p)?!p.value:Array.isArray(p)?p.every(D):!0}e.isEmptyMarkdownString=D;function A(p){return p instanceof S?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function k(p,m){return p===m?!0:!p||!m?!1:p.value===m.value&&p.isTrusted===m.isTrusted&&p.supportThemeIcons===m.supportThemeIcons&&p.supportHtml===m.supportHtml&&(p.baseUri===m.baseUri||!!p.baseUri&&!!m.baseUri&&(0,C.isEqual)(y.URI.from(p.baseUri),y.URI.from(m.baseUri)))}e.markdownStringEqual=k;function E(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function T(p){return p.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function _(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=_;function g(p){const m=[],b=p.split("|").map(c=>c.trim());p=b[0];const f=b[1];if(f){const c=/height=(\d+)/.exec(f),v=/width=(\d+)/.exec(f),a=c?c[1]:"",d=v?v[1]:"",o=isFinite(parseInt(d)),i=isFinite(parseInt(a));o&&m.push(`width="${d}"`),i&&m.push(`height="${a}"`)}return{href:p,dimensions:m}}e.parseHrefAndDimensions=g}),define(De[110],Ie([1,0,17,32,9,10,22,8]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(o,i){const{os:s,tildify:l,relative:n}=i;if(n){const w=D(o,n,s);if(typeof w=="string")return w}let r=o.fsPath;if(s===1&&!P.isWindows?r=r.replace(/\//g,"\\"):s!==1&&P.isWindows&&(r=r.replace(/\\/g,"/")),s!==1&&l?.userHome){const w=l.userHome.fsPath;let L;o.scheme!==l.userHome.scheme&&o.path.startsWith(C.posix.sep)?L=l.userHome.with({path:o.path}).fsPath:L=o.fsPath,r=E(L,w,s)}return(s===1?C.win32:C.posix).normalize(A(r,s===1))}e.getPathLabel=S;function D(o,i,s){const l=s===1?C.win32:C.posix,n=s===3?y.extUri:y.extUriIgnorePathCase,r=i.getWorkspace(),h=(0,u.firstOrDefault)(r.folders);if(!h)return;o.scheme!==h.uri.scheme&&o.path.startsWith(C.posix.sep)&&(o=h.uri.with({path:o.path}));const w=i.getWorkspaceFolder(o);if(!w)return;let L;if(n.isEqual(w.uri,o)?L="":L=n.relativePath(w.uri,o)??"",L&&(L=l.normalize(L)),r.folders.length>1&&!i.noPrefix){const M=w.name?w.name:n.basenameOrAuthority(w.uri);L=L?`${M} \u2022 ${L}`:M}return L}function A(o,i=P.isWindows){return(0,t.hasDriveLetter)(o,i)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=A;let k=Object.create(null);function E(o,i,s=P.OS){if(s===1||!o||!i)return o;let l=k.original===i?k.normalized:void 0;l||(l=i,P.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,I.rtrim)(l,C.posix.sep)}${C.posix.sep}`,k={original:i,normalized:l});let n=o;return P.isWindows&&(n=(0,t.toSlashes)(n)),(s===3?n.startsWith(l):(0,I.startsWithIgnoreCase)(n,l))?`~/${n.substr(l.length)}`:o}e.tildify=E;function T(o,i){return o.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const _="\u2026",g="\\\\",p="~";function m(o,i=C.sep){const s=new Array(o.length);let l=!1;for(let n=0;n<o.length;n++){const r=o[n];if(r===""){s[n]=`.${i}`;continue}if(!r){s[n]=r;continue}l=!0;let h="",w=r;w.indexOf(g)===0?(h=w.substr(0,w.indexOf(g)+g.length),w=w.substr(w.indexOf(g)+g.length)):w.indexOf(i)===0?(h=w.substr(0,w.indexOf(i)+i.length),w=w.substr(w.indexOf(i)+i.length)):w.indexOf(p)===0&&(h=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length));const L=w.split(i);for(let M=1;l&&M<=L.length;M++)for(let B=L.length-M;l&&B>=0;B--){l=!1;let R=L.slice(B,B+M).join(i);for(let z=0;!l&&z<o.length;z++)if(z!==n&&o[z]&&o[z].indexOf(R)>-1){const H=B+M===L.length,N=B>0&&o[z].indexOf(i)>-1?i+R:R,V=o[z].endsWith(N);l=!H||V}if(!l){let z="";(L[0].endsWith(":")||h!=="")&&(B===1&&(B=0,M++,R=L[0]+i+R),B>0&&(z=L[0]+i),z=h+z),B>0&&(z=z+_+i),z=z+R,B+M<L.length&&(z=z+i+_),s[n]=z}}l&&(s[n]=r)}return s}e.shorten=m;var b;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function f(o,i=Object.create(null)){const s=[];let l=!1,n="";for(const r of o)if(r==="$"||l&&r==="{")n&&s.push({value:n,type:b.TEXT}),n="",l=!0;else if(r==="}"&&l){const h=i[n];if(typeof h=="string")h.length&&s.push({value:h,type:b.VARIABLE});else if(h){const w=s[s.length-1];(!w||w.type!==b.SEPARATOR)&&s.push({value:h.label,type:b.SEPARATOR})}n="",l=!1}else n+=r;return n&&!l&&s.push({value:n,type:b.TEXT}),s.filter((r,h)=>{if(r.type===b.SEPARATOR){const w=s[h-1],L=s[h+1];return[w,L].every(M=>M&&(M.type===b.VARIABLE||M.type===b.TEXT)&&M.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=f;function c(o,i){return P.isMacintosh||i?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):o.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function v(o,i){return P.isMacintosh||i?o.replace(/\(&&\w\)|&&/g,""):P.isWindows?o.replace(/&&|&/g,s=>s==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function a(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=a;function d(o){const i=o.indexOf("/")!==-1?C.posix:C.win32,s=i.basename(o),l=i.dirname(o);return s.length?{name:s,parentPath:l}:{name:l,parentPath:""}}e.splitName=d}),define(De[111],Ie([1,0,2]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(A){return A.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const E=this._uriTransformer.transformIncoming(k);return E===k?k:t(u.URI.from(E))}transformOutgoing(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:t(u.URI.from(E))}transformOutgoingURI(k){const E=this._uriTransformer.transformOutgoing(k);return E===k?k:u.URI.from(E)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,k,E){if(!A||E>200)return null;if(typeof A=="object"){if(A instanceof u.URI)return k.transformOutgoing(A);for(const T in A)if(Object.hasOwnProperty.call(A,T)){const _=P(A[T],k,E+1);_!==null&&(A[T]=_)}}return null}function y(A,k){const E=P(A,k,0);return E===null?A:E}e.transformOutgoingURIs=y;function I(A,k,E,T){if(!A||T>200)return null;if(typeof A=="object"){if(A.$mid===1)return E?u.URI.revive(k.transformIncoming(A)):k.transformIncoming(A);for(const _ in A)if(Object.hasOwnProperty.call(A,_)){const g=I(A[_],k,E,T+1);g!==null&&(A[_]=g)}}return null}function S(A,k){const E=I(A,k,!1,0);return E===null?A:E}e.transformIncomingURIs=S;function D(A,k){const E=I(A,k,!0,0);return E===null?A:E}e.transformAndReviveIncomingURIs=D}),define(De[29],Ie([1,0,63,82,305,18,32,80,9,10,22,2]),function(J,e,u,t,C,P,y,I,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function T(N,V=E.UNLINK){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return V===E.UNLINK?g(N):_(N)}async function _(N){try{const V=(0,y.randomPath)((0,t.tmpdir)());try{await u.promises.rename(N,V)}catch(U){return U.code==="ENOENT"?void 0:g(N)}g(V).catch(U=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g(N){return(0,C.promisify)(u.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function p(N){if((0,y.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function m(N,V){return c(await(V?b(N):(0,C.promisify)(u.readdir)(N)))}async function b(N){try{return await(0,C.promisify)(u.readdir)(N,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const V=[],U=await m(N);for(const F of U){let x=!1,$=!1,Q=!1;try{const K=await e.Promises.lstat((0,S.join)(N,F));x=K.isFile(),$=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}V.push({name:F,isFile:()=>x,isDirectory:()=>$,isSymbolicLink:()=>Q})}return V}function f(N){return c(u.readdirSync(N))}e.readdirSync=f;function c(N){return N.map(V=>typeof V=="string"?D.isMacintosh?(0,I.normalizeNFC)(V):V:(V.name=D.isMacintosh?(0,I.normalizeNFC)(V.name):V.name,V))}async function v(N){const V=await m(N),U=[];for(const F of V)await d.existsDirectory((0,S.join)(N,F))&&U.push(F);return U}function a(N,V=1e3){return new Promise(U=>{let F=!1;const x=setInterval(()=>{F||(F=!0,u.access(N,$=>{F=!1,$&&(clearInterval(x),U(void 0))}))},V)})}e.whenDeleted=a;var d;(function(N){async function V(x){let $;try{if($=await e.Promises.lstat(x),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(D.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw K}throw Q}}N.stat=V;async function U(x){try{const{stat:$,symbolicLink:Q}=await N.stat(x);return $.isFile()&&Q?.dangling!==!0}catch{}return!1}N.existsFile=U;async function F(x){try{const{stat:$,symbolicLink:Q}=await N.stat(x);return $.isDirectory()&&Q?.dangling!==!0}catch{}return!1}N.existsDirectory=F})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function i(N,V,U){return o.queueFor(k.URI.file(N),A.extUriBiasedIgnorePathCase).queue(()=>{const F=h(U);return new Promise((x,$)=>n(N,V,F,Q=>Q?$(Q):x()))})}let s=!0;function l(N){s=N}e.configureFlushOnWrite=l;function n(N,V,U,F){if(!s)return u.writeFile(N,V,{mode:U.mode,flag:U.flag},F);u.open(N,U.flag,U.mode,(x,$)=>{if(x)return F(x);u.writeFile($,V,Q=>{if(Q)return u.close($,()=>F(Q));u.fdatasync($,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),l(!1)),u.close($,de=>F(de))))})})}function r(N,V,U){const F=h(U);if(!s)return u.writeFileSync(N,V,{mode:F.mode,flag:F.flag});const x=u.openSync(N,F.flag,F.mode);try{u.writeFileSync(x,V);try{u.fdatasyncSync(x)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),l(!1)}}finally{u.closeSync(x)}}e.writeFileSync=r;function h(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function w(N,V){if(N!==V)try{await e.Promises.rename(N,V)}catch(U){if(N.toLowerCase()!==V.toLowerCase()&&U.code==="EXDEV"||N.endsWith("."))await L(N,V,{preserveSymlinks:!1}),await T(N,E.MOVE);else throw U}}async function L(N,V,U){return B(N,V,{root:{source:N,target:V},options:U,handledSourcePaths:new Set})}const M=511;async function B(N,V,U){if(U.handledSourcePaths.has(N))return;U.handledSourcePaths.add(N);const{stat:F,symbolicLink:x}=await d.stat(N);if(x){if(U.options.preserveSymlinks)try{return await H(N,V,U)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(x.dangling)return}return F.isDirectory()?R(N,V,F.mode&M,U):z(N,V,F.mode&M)}async function R(N,V,U,F){await e.Promises.mkdir(V,{recursive:!0,mode:U});const x=await m(N);for(const $ of x)await B((0,S.join)(N,$),(0,S.join)(V,$),F)}async function z(N,V,U){await e.Promises.copyFile(N,V),await e.Promises.chmod(V,U)}async function H(N,V,U){let F=await e.Promises.readlink(N);(0,y.isEqualOrParent)(F,U.root.source,!D.isLinux)&&(F=(0,S.join)(U.root.target,F.substr(U.root.source.length+1))),await e.Promises.symlink(F,V)}e.Promises=new class{get access(){return(0,C.promisify)(u.access)}get stat(){return(0,C.promisify)(u.stat)}get lstat(){return(0,C.promisify)(u.lstat)}get utimes(){return(0,C.promisify)(u.utimes)}get read(){return(N,V,U,F,x)=>new Promise(($,Q)=>{u.read(N,V,U,F,x,(K,de,ee)=>K?Q(K):$({bytesRead:de,buffer:ee}))})}get readFile(){return(0,C.promisify)(u.readFile)}get write(){return(N,V,U,F,x)=>new Promise(($,Q)=>{u.write(N,V,U,F,x,(K,de,ee)=>K?Q(K):$({bytesWritten:de,buffer:ee}))})}get appendFile(){return(0,C.promisify)(u.appendFile)}get fdatasync(){return(0,C.promisify)(u.fdatasync)}get truncate(){return(0,C.promisify)(u.truncate)}get rename(){return(0,C.promisify)(u.rename)}get copyFile(){return(0,C.promisify)(u.copyFile)}get open(){return(0,C.promisify)(u.open)}get close(){return(0,C.promisify)(u.close)}get symlink(){return(0,C.promisify)(u.symlink)}get readlink(){return(0,C.promisify)(u.readlink)}get chmod(){return(0,C.promisify)(u.chmod)}get mkdir(){return(0,C.promisify)(u.mkdir)}get unlink(){return(0,C.promisify)(u.unlink)}get rmdir(){return(0,C.promisify)(u.rmdir)}get realpath(){return(0,C.promisify)(u.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return v}get writeFile(){return i}get rm(){return T}get move(){return w}get copy(){return L}}}),define(De[112],Ie([1,0,63,9,10,8,29]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(E){if(C.isLinux)return E;const T=(0,t.dirname)(E);if(E===T)return E;const _=((0,t.basename)(E)||E).toLowerCase();try{const p=(0,y.readdirSync)(T).filter(m=>m.toLowerCase()===_);if(p.length===1){const m=I(T);if(m)return(0,t.join)(m,p[0])}else if(p.length>1){const m=p.indexOf(_);if(m>=0){const b=I(T);if(b)return(0,t.join)(b,p[m])}}}catch{}return null}e.realcaseSync=I;async function S(E){if(C.isLinux)return E;const T=(0,t.dirname)(E);if(E===T)return E;const _=((0,t.basename)(E)||E).toLowerCase();try{const p=(await y.Promises.readdir(T)).filter(m=>m.toLowerCase()===_);if(p.length===1){const m=await S(T);if(m)return(0,t.join)(m,p[0])}else if(p.length>1){const m=p.indexOf(_);if(m>=0){const b=await S(T);if(b)return(0,t.join)(b,p[m])}}}catch{}return null}e.realcase=S;async function D(E){try{return await y.Promises.realpath(E)}catch{const _=k(E);return await y.Promises.access(_,u.constants.R_OK),_}}e.realpath=D;function A(E){try{return u.realpathSync(E)}catch{const _=k(E);return u.accessSync(_,u.constants.R_OK),_}}e.realpathSync=A;function k(E){return(0,P.rtrim)((0,t.normalize)(E),t.sep)}}),define(De[113],Ie([1,0,9,10,36,105,12,29]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function S(k=C.env){return k.comspec||"cmd.exe"}e.getWindowsShell=S;function D(k){let E=[],T=!1;const _=function(g){if(T){E.push(g);return}(!k.send(g,m=>{if(m&&console.error(m),T=!1,E.length>0){const b=E.slice(0);E=[],b.forEach(f=>_(f))}})||t.isWindows)&&(T=!0)};return{send:_}}e.createQueuedSender=D;var A;(function(k){async function E(T,_,g){if(u.isAbsolute(T))return T;if(_===void 0&&(_=C.cwd()),u.dirname(T)!=="."||(g===void 0&&y.isString(C.env.PATH)&&(g=C.env.PATH.split(u.delimiter)),g===void 0||g.length===0))return u.join(_,T);async function m(b){if(await I.Promises.exists(b)){let f;try{f=await I.Promises.stat(b)}catch(c){c.message.startsWith("EACCES")&&(f=await I.Promises.lstat(b))}return f?!f.isDirectory():!1}return!1}for(const b of g){let f;if(u.isAbsolute(b)?f=u.join(b,T):f=u.join(_,b,T),await m(f))return f;let c=f+".com";if(await m(c)||(c=f+".exe",await m(c)))return c}return u.join(_,T)}k.findExecutable=E})(A=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(J,e,u,t){var C=arguments.length,P=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,u):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,u,t);else for(var I=J.length-1;I>=0;I--)(y=J[I])&&(P=(C<3?y(P):C>3?y(e,u,P):y(e,u))||P);return C>3&&P&&Object.defineProperty(e,u,P),P};define(De[114],Ie([1,0,17,18,23,21,59,11,3,6,81,8,12]),function(J,e,u,t,C,P,y,I,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function _(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function p(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class b{constructor($){this.buffer=$,this.pos=0}read($){const Q=this.buffer.slice(this.pos,this.pos+$);return this.pos+=Q.byteLength,Q}}class f{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var c;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(c||(c={}));function v(x){const $=C.VSBuffer.alloc(4);return $.writeUInt32BE(x,0),$}function a(x){return x.read(4).readUInt32BE(0)}function d(x){const $=C.VSBuffer.alloc(1);return $.writeUInt8(x,0),$}const o={Undefined:d(c.Undefined),String:d(c.String),Buffer:d(c.Buffer),VSBuffer:d(c.VSBuffer),Array:d(c.Array),Object:d(c.Object)},i=typeof Buffer<"u";function s(x,$){if(typeof $>"u")x.write(o.Undefined);else if(typeof $=="string"){const Q=C.VSBuffer.fromString($);x.write(o.String),x.write(v(Q.byteLength)),x.write(Q)}else if(i&&Buffer.isBuffer($)){const Q=C.VSBuffer.wrap($);x.write(o.Buffer),x.write(v(Q.byteLength)),x.write(Q)}else if($ instanceof C.VSBuffer)x.write(o.VSBuffer),x.write(v($.byteLength)),x.write($);else if(Array.isArray($)){x.write(o.Array),x.write(v($.length));for(const Q of $)s(x,Q)}else{const Q=C.VSBuffer.fromString(JSON.stringify($));x.write(o.Object),x.write(v(Q.byteLength)),x.write(Q)}}function l(x){switch(x.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return x.read(a(x)).toString();case c.Buffer:return x.read(a(x)).buffer;case c.VSBuffer:return x.read(a(x));case c.Array:{const Q=a(x),K=[];for(let de=0;de<Q;de++)K.push(l(x));return K}case c.Object:return JSON.parse(x.read(a(x)).toString())}}class n{constructor($,Q,K=null,de=1e3){this.protocol=$,this.ctx=Q,this.logger=K,this.timeoutDelay=de,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel($,Q){this.channels.set($,Q),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const Q=this.send([$.type]);this.logger?.logOutgoing(Q,0,1,p($.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(Q,$.id,1,p($.type),$.data);return}}}send($,Q=void 0){const K=new f;return s(K,$),s(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const Q=new b($),K=l(Q),de=l(Q),ee=K[0];switch(ee){case 100:return this.logger?.logIncoming($.byteLength,K[1],1,`${_(ee)}: ${K[2]}.${K[3]}`,de),this.onPromise({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 102:return this.logger?.logIncoming($.byteLength,K[1],1,`${_(ee)}: ${K[2]}.${K[3]}`,de),this.onEventListen({type:ee,id:K[1],channelName:K[2],name:K[3],arg:de});case 101:return this.logger?.logIncoming($.byteLength,K[1],1,`${_(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]});case 103:return this.logger?.logIncoming($.byteLength,K[1],1,`${_(ee)}`),this.disposeActiveRequest({type:ee,id:K[1]})}}onPromise($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=new P.CancellationTokenSource;let de;try{de=Q.call(this.ctx,$.name,$.arg,K.token)}catch(Y){de=Promise.reject(Y)}const ee=$.id;de.then(Y=>{this.sendResponse({id:ee,data:Y,type:201}),this.activeRequests.delete($.id)},Y=>{Y instanceof Error?this.sendResponse({id:ee,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:ee,data:Y,type:203}),this.activeRequests.delete($.id)});const he=(0,D.toDisposable)(()=>K.cancel());this.activeRequests.set($.id,he)}onEventListen($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=$.id,ee=Q.listen(this.ctx,$.name,$.arg)(he=>this.sendResponse({id:K,data:he,type:204}));this.activeRequests.set($.id,ee)}disposeActiveRequest($){const Q=this.activeRequests.get($.id);Q&&(Q.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let Q=this.pendingRequests.get($.channelName);Q||(Q=[],this.pendingRequests.set($.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:$,timeoutTimer:K})}flushPendingRequests($){const Q=this.pendingRequests.get($);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=n;var r;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor($,Q=null){this.protocol=$,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel($){const Q=this;return{call(K,de,ee){return Q.isDisposed?Promise.reject(new I.CancellationError):Q.requestPromise($,K,de,ee)},listen(K,de){return Q.isDisposed?S.Event.None:Q.requestEvent($,K,de)}}}requestPromise($,Q,K,de=P.CancellationToken.None){const ee=this.lastRequestId++,Y={id:ee,type:100,channelName:$,name:Q,arg:K};if(de.isCancellationRequested)return Promise.reject(new I.CancellationError);let me;return new Promise((ke,Re)=>{if(de.isCancellationRequested)return Re(new I.CancellationError);const ze=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(ee),ke(ae.data);break;case 202:{this.handlers.delete(ee);const ne=new Error(ae.data.message);ne.stack=ae.data.stack,ne.name=ae.data.name,Re(ne);break}case 203:this.handlers.delete(ee),Re(ae.data);break}};this.handlers.set(ee,Z),this.sendRequest(Y)};let oe=null;this.state===m.Idle?ze():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,ze()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:ee,type:101}),Re(new I.CancellationError)},ge=de.onCancellationRequested(le);me=(0,D.combinedDisposable)((0,D.toDisposable)(le),ge),this.activeRequests.add(me)}).finally(()=>{this.activeRequests.delete(me)})}requestEvent($,Q,K){const de=this.lastRequestId++,he={id:de,type:102,channelName:$,name:Q,arg:K};let Y=null;const me=new S.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(me),this.sendRequest(he)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(me),this.sendRequest({id:de,type:103}))}}),be=ke=>me.fire(ke.data);return this.handlers.set(de,be),me.event}sendRequest($){switch($.type){case 100:case 102:{const Q=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(Q,$.id,0,`${_($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Q=this.send([$.type,$.id]);this.logger?.logOutgoing(Q,$.id,0,_($.type));return}}}send($,Q=void 0){const K=new f;return s(K,$),s(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const Q=new b($),K=l(Q),de=l(Q),ee=K[0];switch(ee){case 200:return this.logger?.logIncoming($.byteLength,0,0,p(ee)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,K[1],0,p(ee),de),this.onResponse({type:K[0],id:K[1],data:de})}}onResponse($){if($.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([y.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class w{get connections(){const $=[];return this._connections.forEach(Q=>$.push(Q)),$}constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:Q,onDidClientDisconnect:K})=>{S.Event.once(Q.onMessage)(ee=>{const he=new b(ee),Y=l(he),me=new n(Q,Y),be=new h(Q);this.channels.forEach((Re,ze)=>me.registerChannel(ze,Re));const ke={channelServer:me,channelClient:be,ctx:Y};this._connections.add(ke),this._onDidAddConnection.fire(ke),K(()=>{me.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}getChannel($,Q){const K=this;return{call(de,ee,he){let Y;if((0,E.isFunction)(Q)){const be=(0,u.getRandomElement)(K.connections.filter(Q));Y=be?Promise.resolve(be):S.Event.toPromise(S.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,de,ee);const me=Y.then(be=>be.channelClient.getChannel($));return M(me).call(de,ee,he)},listen(de,ee){if((0,E.isFunction)(Q))return K.getMulticastEvent($,Q,de,ee);const he=Q.routeEvent(K,de,ee).then(Y=>Y.channelClient.getChannel($));return M(he).listen(de,ee)}}}getMulticastEvent($,Q,K,de){const ee=this;let he=new D.DisposableStore;const Y=new S.Emitter({onFirstListenerAdd:()=>{he=new D.DisposableStore;const me=new S.EventMultiplexer,be=new Map,ke=ze=>{const le=ze.channelClient.getChannel($).listen(K,de),ge=me.add(le);be.set(ze,ge)},Re=ze=>{const oe=be.get(ze);!oe||(oe.dispose(),be.delete(ze))};ee.connections.filter(Q).forEach(ke),S.Event.filter(ee.onDidAddConnection,Q)(ke,void 0,he),ee.onDidRemoveConnection(Re,void 0,he),me.event(Y.fire,Y,he),he.add(me)},onLastListenerRemove:()=>{he.dispose()}});return Y.event}registerChannel($,Q){this.channels.set($,Q),this._connections.forEach(K=>{K.channelServer.registerChannel($,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class L{constructor($,Q,K=null){const de=new f;s(de,Q),$.send(de.buffer),this.channelClient=new h($,K),this.channelServer=new n($,Q,K)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,Q){this.channelServer.registerChannel($,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function M(x){return{call($,Q,K){return x.then(de=>de.call($,Q,K))},listen($,Q){const K=new S.Relay;return x.then(de=>K.input=de.listen($,Q)),K.event}}}e.getDelayedChannel=M;function B(x){let $=!1;return{call(Q,K,de){return $?x.call(Q,K,de):(0,t.timeout)(0).then(()=>$=!0).then(()=>x.call(Q,K,de))},listen(Q,K){if($)return x.listen(Q,K);const de=new S.Relay;return(0,t.timeout)(0).then(()=>$=!0).then(()=>de.input=x.listen(Q,K)),de.event}}}e.getNextTickChannel=B;class R{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const Q of $.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=R;var z;(function(x){function $(ee,he){const Y=ee,me=he&&he.disableMarshalling,be=new Map;for(const ke in Y)K(ke)&&be.set(ke,S.Event.buffer(Y[ke],!0));return new class{listen(ke,Re,ze){const oe=be.get(Re);if(oe)return oe;if(de(Re)){const le=Y[Re];if(typeof le=="function")return le.call(Y,ze)}throw new Error(`Event not found: ${Re}`)}call(ke,Re,ze){const oe=Y[Re];if(typeof oe=="function"){if(!me&&Array.isArray(ze))for(let le=0;le<ze.length;le++)ze[le]=(0,A.revive)(ze[le]);return oe.apply(Y,ze)}throw new Error(`Method not found: ${Re}`)}}}x.fromService=$;function Q(ee,he){const Y=he&&he.disableMarshalling;return new Proxy({},{get(me,be){if(typeof be=="string")return he?.properties?.has(be)?he.properties.get(be):de(be)?function(ke){return ee.listen(be,ke)}:K(be)?ee.listen(be):async function(...ke){let Re;he&&!(0,E.isUndefinedOrNull)(he.context)?Re=[he.context,...ke]:Re=ke;const ze=await ee.call(be,Re);return Y?ze:(0,A.revive)(ze)};throw new Error(`Property not found: ${String(be)}`)}})}x.toService=Q;function K(ee){return ee[0]==="o"&&ee[1]==="n"&&k.isUpperAsciiLetter(ee.charCodeAt(2))}function de(ee){return/^onDynamic/.test(ee)&&k.isUpperAsciiLetter(ee.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const $=x.toString();if($!=="[object Object]")return $}return x}function V(x){return Array.isArray(x)?x.map(N):N(x)}function U(x,$,Q,K,de,ee,he){he=V(he);const Y=H[de],me=Y[K%Y.length];let be=[`%c[${x}]%c[${String($).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(ee)?(be=be.concat(he),be.push(")")):be.push(he),console.log.apply(console,be)}e.logWithColors=U;class F{constructor($,Q){this._outgoingPrefix=$,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,Q,K,de,ee){this._totalOutgoing+=$,U(this._outgoingPrefix,this._totalOutgoing,$,Q,K,de,ee)}logIncoming($,Q,K,de,ee){this._totalIncoming+=$,U(this._incomingPrefix,this._totalIncoming,$,Q,K,de,ee)}}e.IPCLogger=F}),define(De[115],Ie([1,0,23,3,6,114]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let l=0;function n(h,w){if(!s.has(h)){const L=String(++l);s.set(h,L)}return s.get(h)}function r(h,w,L,M){if(!i.enableDiagnostics)return;const B=n(h,w);if(M instanceof u.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const R=u.VSBuffer.alloc(M.byteLength);R.set(M),i.records.push({timestamp:Date.now(),id:B,label:w,type:L,buff:R})}else i.records.push({timestamp:Date.now(),id:B,label:w,type:L,data:M})}i.traceSocketEvent=r})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function A(){return D||(D=u.VSBuffer.alloc(0)),D}class k{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return A();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const w=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),w}if(this._chunks[0].byteLength>s){const w=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),w}const n=u.VSBuffer.alloc(s);let r=0,h=0;for(;s>0;){const w=this._chunks[h];if(w.byteLength>s){const L=w.slice(0,s);n.set(L,r),r+=s,l&&(this._chunks[h]=w.slice(s),this._totalLength-=s),s-=s}else n.set(w,r),r+=w.byteLength,l?(this._chunks.shift(),this._totalLength-=w.byteLength):h++,s-=w.byteLength}return n}}e.ChunkStream=k;var E;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(E||(E={}));function T(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var _;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(_=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,l,n,r){this.type=s,this.id=l,this.ack=n,this.data=r,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends C.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const n=this._state.messageType,r=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new g(n,r,h,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=u.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(l,s.data)}_bufferAdd(s,l){const n=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,n}_bufferTake(){const s=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class b extends C.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new g(1,0,0,s))}}e.Protocol=b;class f extends P.IPCClient{static fromSocket(s,l){return new f(new b(s),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,l,n=null){super(s,l,n),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class v{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}length(){let s=0,l=this._first;for(;l;)l=l.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let l=0,n=this._first;for(;n;)s[l++]=n.data,n=n.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new v(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class d{static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<d._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=d._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),l=(1+d._HISTORY_LENGTH)*1e3;let n=0;for(let r=0;r<d._HISTORY_LENGTH;r++)s-this.lastRuns[r]<=l&&n++;return 1-n/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class o{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,l=null,n=d.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.push(this._socket.onClose(r=>this._onSocketClose.fire(r))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new g(5,0,0,A());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new g(7,0,0,A());this._socketWriter.write(s)}sendResume(){const s=new g(8,0,0,A());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,A());this._socketWriter.write(s);const l=this._outgoingUnackMsg.toArray();for(let n=0,r=l.length;n<r;n++)this._socketWriter.write(l[n]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new g(6,0,0,A())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let n=0,r=l.length;n<r;n++)this._socketWriter.write(l[n]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new g(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(s){const l=new g(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime,n=Date.now()-this._socketReader.lastReadTime,r=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&n>=2e4&&r>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:n});return}const h=Math.max(2e4-l,2e4-n,2e4-r,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,A());this._socketWriter.write(s)}_sendKeepAlive(){const s=new g(9,0,0,A());this._socketWriter.write(s)}}e.PersistentProtocol=o}),define(De[116],Ie([1,0,23,11,3,6,9,10,31,114,115]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class E{traceSocketEvent(n,r){A.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,r)}constructor(n,r=""){this._canWrite=!0,this.debugLabel=r,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener),this._closeListener=h=>{this.traceSocketEvent("close",{hadError:h}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(n){const r=h=>{this.traceSocketEvent("read",h),n(u.VSBuffer.wrap(h))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(n){const r=h=>{n({type:0,hadError:h,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(n){const r=()=>{n()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(n){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=E;var T;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var _;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(_||(_={}));class g extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(n,r){this.socket.traceSocketEvent(n,r)}constructor(n,r,h,w){super(),this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:h?.byteLength||0,recordInflateBytes:w}),this._flowManager=this._register(new p(this,r,h,w,this._onData,(L,M)=>this._write(L,M))),this._register(this._flowManager.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new A.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this._onData.event(n)}onClose(n){return this._onClose.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this._flowManager.writeMessage(n)}_write(n,r){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let h=2;n.byteLength<126?h+=0:n.byteLength<2**16?h+=2:h+=8;const w=u.VSBuffer.alloc(h);if(r?w.writeUInt8(194,0):w.writeUInt8(130,0),n.byteLength<126)w.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){w.writeUInt8(126,1);let L=1;w.writeUInt8(n.byteLength>>>8&255,++L),w.writeUInt8(n.byteLength>>>0&255,++L)}else{w.writeUInt8(127,1);let L=1;w.writeUInt8(0,++L),w.writeUInt8(0,++L),w.writeUInt8(0,++L),w.writeUInt8(0,++L),w.writeUInt8(n.byteLength>>>24&255,++L),w.writeUInt8(n.byteLength>>>16&255,++L),w.writeUInt8(n.byteLength>>>8&255,++L),w.writeUInt8(n.byteLength>>>0&255,++L)}this.socket.write(u.VSBuffer.concat([w,n]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(n){if(n.byteLength!==0){for(this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const r=this._incomingData.peek(this._state.readLen),h=r.readUInt8(0),w=(h&128)>>>7,L=(h&64)>>>6,M=r.readUInt8(1),B=(M&128)>>>7,R=M&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(R===126?2:0)+(R===127?8:0),this._state.fin=w,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(w),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const r=this._incomingData.read(this._state.readLen),h=r.readUInt8(1),w=(h&128)>>>7;let L=h&127,M=1;L===126?L=r.readUInt8(++M)*2**8+r.readUInt8(++M):L===127&&(L=r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M));let B=0;w&&(B=r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M)),this._state.state=3,this._state.readLen=L,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const r=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),f(r,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(r,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await C.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class p extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:u.VSBuffer.alloc(0)}constructor(n,r,h,w,L,M){super(),this._tracer=n,this._onData=L,this._writeFn=M,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new C.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,r?(this._zlibInflateStream=this._register(new m(this._tracer,w,h,{windowBits:15})),this._zlibDeflateStream=this._register(new b(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(n){this._writeQueue.push(n),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const n=this._writeQueue.shift();if(this._zlibDeflateStream){const r=await this._deflateMessage(this._zlibDeflateStream,n);this._writeFn(r,!0)}else this._writeFn(n,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(n,r){return new Promise((h,w)=>{n.write(r),n.flush(L=>h(L))})}acceptFrame(n,r,h){this._readQueue.push({data:n,isCompressed:r,isLastFrameOfMessage:h}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const n=this._readQueue.shift();if(this._zlibInflateStream&&n.isCompressed){const r=await this._inflateFrame(this._zlibInflateStream,n.data,n.isLastFrameOfMessage);this._onData.fire(r)}else this._onData.fire(n.data)}this._isProcessingReadQueue=!1}}_inflateFrame(n,r,h){return new Promise((w,L)=>{n.write(r),h&&n.write(u.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>w(M))})}}class m extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?u.VSBuffer.concat(this._recordedInflateBytes):u.VSBuffer.alloc(0)}constructor(n,r,h,w){super(),this._tracer=n,this._recordInflateBytes=r,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(w),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(u.VSBuffer.wrap(L))}),h&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(n){this._recordInflateBytes&&this._recordedInflateBytes.push(n.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",n),this._zlibInflate.write(n.buffer)}flush(n){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const r=u.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,n(r)})}}class b extends P.Disposable{constructor(n,r){super(),this._tracer=n,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",h=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this._onError.fire(h)}),this._zlibDeflate.on("data",h=>{this._tracer.traceSocketEvent("zlibDeflateData",h),this._pendingDeflateData.push(u.VSBuffer.wrap(h))})}write(n){this._tracer.traceSocketEvent("zlibDeflateWrite",n.buffer),this._zlibDeflate.write(n.buffer)}flush(n){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let r=u.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,r=r.slice(0,r.byteLength-4),n(r)})}}function f(l,n){if(n===0)return;const r=l.byteLength>>>2;for(let R=0;R<r;R++){const z=l.readUInt32BE(R*4);l.writeUInt32BE(z^n,R*4)}const h=r*4,w=l.byteLength-h,L=n>>>24&255,M=n>>>16&255,B=n>>>8&255;w>=1&&l.writeUInt8(l.readUInt8(h)^L,h),w>=2&&l.writeUInt8(l.readUInt8(h+1)^M,h+1),w>=3&&l.writeUInt8(l.readUInt8(h+2)^B,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function v(){const l=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):n=(0,y.join)(k().os.tmpdir(),`vscode-ipc-${l}.sock`),d(n),n}e.createRandomIPCHandle=v;function a(l,n,r){const h=k().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${r}-${n}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${r}-${n}.sock`):w=(0,y.join)(l,`${r}-${n}.sock`),d(w),w}e.createStaticIPCHandle=a;function d(l){const n=c[I.platform];typeof n=="number"&&l.length>=n&&console.warn(`WARNING: IPC handle "${l}" is longer than ${n} chars, try a shorter --user-data-dir`)}class o extends D.IPCServer{static toClientConnectionEvent(n){const r=C.Event.fromNodeEventEmitter(n,"connection");return C.Event.map(r,h=>({protocol:new A.Protocol(new E(h,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(h,"close"))}))}constructor(n){super(o.toClientConnectionEvent(n)),this.server=n}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function i(l){return new Promise((n,r)=>{const h=k().net.createServer();h.on("error",r),h.listen(l,()=>{h.removeListener("error",r),n(new o(h))})})}e.serve=i;function s(l,n){return new Promise((r,h)=>{const w=k().net.createConnection(l,()=>{w.removeListener("error",h),r(A.Client.fromSocket(new E(w,`ipc-client${n}`),n))});w.once("error",h)})}e.connect=s}),define(De[158],Ie([1,0,37,9]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(P,y,I,S,D,A){if(Array.isArray(P)){let k=0;for(const E of P){const T=C(E,y,I,S,D,A);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return S?P==="*"?5:P===I?10:0:0;if(P){const{language:k,pattern:E,scheme:T,hasAccessToAllModels:_,notebookType:g}=P;if(!S&&!_)return 0;g&&D&&(y=D);let p=0;if(T)if(T===y.scheme)p=10;else if(T==="*")p=5;else return 0;if(k)if(k===I)p=10;else if(k==="*")p=Math.max(p,5);else return 0;if(g)if(g===A)p=10;else if(g==="*"&&A!==void 0)p=Math.max(p,5);else return 0;if(E){let m;if(typeof E=="string"?m=E:m={...E,base:(0,t.normalize)(E.base)},m===y.fsPath||(0,u.match)(m,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=C}),define(De[159],Ie([1,0,8,49,150]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(I,S,D,A){this._uri=I,this._lines=S,this._eol=D,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const S=I.changes;for(const D of S)this._acceptDeleteRange(D.range),this._acceptInsertText(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,S=this._lines.length,D=new Uint32Array(S);for(let A=0;A<S;A++)D[A]=this._lines[A].length+I;this._lineStarts=new C.PrefixSumComputer(D)}}_setLineText(I,S){this._lines[I]=S,this._lineStarts&&this._lineStarts.setValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,S){if(S.length===0)return;const D=(0,u.splitLines)(S);if(D.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+D[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}D[D.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+D[0]);const A=new Uint32Array(D.length-1);for(let k=1;k<D.length;k++)this._lines.splice(I.lineNumber+k-1,0,D[k]),A[k-1]=D[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,A)}}e.MirrorTextModel=P}),define(De[160],Ie([1,0,8,147,49,35,103]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class S{constructor(b,f,c,v){this.searchString=b,this.isRegex=f,this.matchCase=c,this.wordSeparators=v}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=D(this.searchString):b=this.searchString.indexOf(`
`)>=0;let f=null;try{f=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!f)return null;let c=!this.isRegex&&!b;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new y.SearchData(f,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=S;function D(m){if(!m||m.length===0)return!1;for(let b=0,f=m.length;b<f;b++){const c=m.charCodeAt(b);if(c===10)return!0;if(c===92){if(b++,b>=f)break;const v=m.charCodeAt(b);if(v===110||v===114||v===87)return!0}}return!1}e.isMultilineRegexSource=D;function A(m,b,f){if(!f)return new y.FindMatch(m,null);const c=[];for(let v=0,a=b.length;v<a;v++)c[v]=b[v];return new y.FindMatch(m,c)}e.createFindMatch=A;class k{constructor(b){const f=[];let c=0;for(let v=0,a=b.length;v<a;v++)b.charCodeAt(v)===10&&(f[c++]=v);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(b){const f=this._lineFeedsOffsets;let c=0,v=f.length-1;if(v===-1||b<=f[0])return 0;for(;c<v;){const a=c+((v-c)/2>>0);f[a]>=b?v=a-1:f[a+1]>=b?(c=a,v=a):c=a+1}return c+1}}class E{static findMatches(b,f,c,v,a){const d=f.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(b,c,new p(d.wordSeparators,d.regex),v,a):this._doFindMatchesLineByLine(b,c,d,v,a):[]}static _getMultilineMatchRange(b,f,c,v,a,d){let o,i=0;v?(i=v.findLineFeedCountBeforeOffset(a),o=f+a+i):o=f+a;let s;if(v){const h=v.findLineFeedCountBeforeOffset(a+d.length)-i;s=o+d.length+h}else s=o+d.length;const l=b.getPositionAt(o),n=b.getPositionAt(s);return new P.Range(l.lineNumber,l.column,n.lineNumber,n.column)}static _doFindMatchesMultiline(b,f,c,v,a){const d=b.getOffsetAt(f.getStartPosition()),o=b.getValueInRange(f,1),i=b.getEOL()===`\r
`?new k(o):null,s=[];let l=0,n;for(c.reset(0);n=c.next(o);)if(s[l++]=A(this._getMultilineMatchRange(b,d,o,i,n.index,n[0]),n,v),l>=a)return s;return s}static _doFindMatchesLineByLine(b,f,c,v,a){const d=[];let o=0;if(f.startLineNumber===f.endLineNumber){const s=b.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return o=this._findMatchesInLine(c,s,f.startLineNumber,f.startColumn-1,o,d,v,a),d}const i=b.getLineContent(f.startLineNumber).substring(f.startColumn-1);o=this._findMatchesInLine(c,i,f.startLineNumber,f.startColumn-1,o,d,v,a);for(let s=f.startLineNumber+1;s<f.endLineNumber&&o<a;s++)o=this._findMatchesInLine(c,b.getLineContent(s),s,0,o,d,v,a);if(o<a){const s=b.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);o=this._findMatchesInLine(c,s,f.endLineNumber,0,o,d,v,a)}return d}static _findMatchesInLine(b,f,c,v,a,d,o,i){const s=b.wordSeparators;if(!o&&b.simpleSearch){const r=b.simpleSearch,h=r.length,w=f.length;let L=-h;for(;(L=f.indexOf(r,L+h))!==-1;)if((!s||g(s,f,w,L,h))&&(d[a++]=new y.FindMatch(new P.Range(c,L+1+v,c,L+1+h+v),null),a>=i))return a;return a}const l=new p(b.wordSeparators,b.regex);let n;l.reset(0);do if(n=l.next(f),n&&(d[a++]=A(new P.Range(c,n.index+1+v,c,n.index+1+n[0].length+v),n,o),a>=i))return a;while(n);return a}static findNextMatch(b,f,c,v){const a=f.parseSearchRequest();if(!a)return null;const d=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(b,c,d,v):this._doFindNextMatchLineByLine(b,c,d,v)}static _doFindNextMatchMultiline(b,f,c,v){const a=new C.Position(f.lineNumber,1),d=b.getOffsetAt(a),o=b.getLineCount(),i=b.getValueInRange(new P.Range(a.lineNumber,a.column,o,b.getLineMaxColumn(o)),1),s=b.getEOL()===`\r
`?new k(i):null;c.reset(f.column-1);const l=c.next(i);return l?A(this._getMultilineMatchRange(b,d,i,s,l.index,l[0]),l,v):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(b,new C.Position(1,1),c,v):null}static _doFindNextMatchLineByLine(b,f,c,v){const a=b.getLineCount(),d=f.lineNumber,o=b.getLineContent(d),i=this._findFirstMatchInLine(c,o,d,f.column,v);if(i)return i;for(let s=1;s<=a;s++){const l=(d+s-1)%a,n=b.getLineContent(l+1),r=this._findFirstMatchInLine(c,n,l+1,1,v);if(r)return r}return null}static _findFirstMatchInLine(b,f,c,v,a){b.reset(v-1);const d=b.next(f);return d?A(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,a):null}static findPreviousMatch(b,f,c,v){const a=f.parseSearchRequest();if(!a)return null;const d=new p(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(b,c,d,v):this._doFindPreviousMatchLineByLine(b,c,d,v)}static _doFindPreviousMatchMultiline(b,f,c,v){const a=this._doFindMatchesMultiline(b,new P.Range(1,1,f.lineNumber,f.column),c,v,10*I);if(a.length>0)return a[a.length-1];const d=b.getLineCount();return f.lineNumber!==d||f.column!==b.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(b,new C.Position(d,b.getLineMaxColumn(d)),c,v):null}static _doFindPreviousMatchLineByLine(b,f,c,v){const a=b.getLineCount(),d=f.lineNumber,o=b.getLineContent(d).substring(0,f.column-1),i=this._findLastMatchInLine(c,o,d,v);if(i)return i;for(let s=1;s<=a;s++){const l=(a+d-s-1)%a,n=b.getLineContent(l+1),r=this._findLastMatchInLine(c,n,l+1,v);if(r)return r}return null}static _findLastMatchInLine(b,f,c,v){let a=null,d;for(b.reset(0);d=b.next(f);)a=A(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,v);return a}}e.TextModelSearch=E;function T(m,b,f,c,v){if(c===0)return!0;const a=b.charCodeAt(c-1);if(m.get(a)!==0||a===13||a===10)return!0;if(v>0){const d=b.charCodeAt(c);if(m.get(d)!==0)return!0}return!1}function _(m,b,f,c,v){if(c+v===f)return!0;const a=b.charCodeAt(c+v);if(m.get(a)!==0||a===13||a===10)return!0;if(v>0){const d=b.charCodeAt(c+v-1);if(m.get(d)!==0)return!0}return!1}function g(m,b,f,c,v){return T(m,b,f,c,v)&&_(m,b,f,c,v)}e.isValidMatch=g;class p{constructor(b,f){this._wordSeparators=b,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const f=b.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(c=this._searchRegex.exec(b),!c))return null;const v=c.index,a=c[0].length;if(v===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){u.getNextCodePoint(b,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=v,this._prevMatchLength=a,!this._wordSeparators||g(this._wordSeparators,b,f,v,a))return c}while(c);return null}}e.Searcher=p}),define(De[117],Ie([1,0,23,10]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function P(k){for(let E=0,T=k.length;E<T;E+=4){const _=k[E+0],g=k[E+1],p=k[E+2],m=k[E+3];k[E+0]=m,k[E+1]=p,k[E+2]=g,k[E+3]=_}}function y(k){const E=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(E),u.VSBuffer.wrap(E)}function I(k){const E=k.buffer;if(t.isLittleEndian()||P(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const T=new Uint8Array(E.byteLength);return T.set(E),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function S(k){const E=new Uint32Array(D(k));let T=0;if(E[T++]=k.id,k.type==="full")E[T++]=1,E[T++]=k.data.length,E.set(k.data,T),T+=k.data.length;else{E[T++]=2,E[T++]=k.deltas.length;for(const _ of k.deltas)E[T++]=_.start,E[T++]=_.deleteCount,_.data?(E[T++]=_.data.length,E.set(_.data,T),T+=_.data.length):E[T++]=0}return y(E)}e.encodeSemanticTokensDto=S;function D(k){let E=0;if(E+=1+1,k.type==="full")E+=1+k.data.length;else{E+=1,E+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(E+=T.data.length)}return E}function A(k){const E=I(k);let T=0;const _=E[T++];if(E[T++]===1){const b=E[T++],f=E.subarray(T,T+b);return T+=b,{id:_,type:"full",data:f}}const p=E[T++],m=[];for(let b=0;b<p;b++){const f=E[T++],c=E[T++],v=E[T++];let a;v>0&&(a=E.subarray(T,T+v),T+=v),m[b]={start:f,deleteCount:c,data:a}}return{id:_,type:"delta",deltas:m}}e.decodeSemanticTokensDto=A}),define(De[161],Ie([1,0,3,6]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class C{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,S){return this._map.set(I,S),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===S&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,S){this._factories.get(I)?.dispose();const D=new P(this,I,S);return this._factories.set(I,D),(0,t.toDisposable)(()=>{const A=this._factories.get(I);!A||A!==D||(this._factories.delete(I),A.dispose())})}async getOrCreate(I){const S=this.get(I);if(S)return S;const D=this._factories.get(I);return!D||D.isResolved?null:(await D.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const D=this._factories.get(I);return!!(!D||D.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=C;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(I,S,D){super(),this._registry=I,this._languageId=S,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(De[64],Ie([1,0,76,2,35,161]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(h,w,L){this._tokenBrand=void 0,this.offset=h,this.type=w,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class I{constructor(h,w){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=w}}e.TokenizationResult=I;class S{constructor(h,w){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=w}}e.EncodedTokenizationResult=S;var D;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var A;(function(r){const h=new Map;h.set(0,u.Codicon.symbolMethod),h.set(1,u.Codicon.symbolFunction),h.set(2,u.Codicon.symbolConstructor),h.set(3,u.Codicon.symbolField),h.set(4,u.Codicon.symbolVariable),h.set(5,u.Codicon.symbolClass),h.set(6,u.Codicon.symbolStruct),h.set(7,u.Codicon.symbolInterface),h.set(8,u.Codicon.symbolModule),h.set(9,u.Codicon.symbolProperty),h.set(10,u.Codicon.symbolEvent),h.set(11,u.Codicon.symbolOperator),h.set(12,u.Codicon.symbolUnit),h.set(13,u.Codicon.symbolValue),h.set(15,u.Codicon.symbolEnum),h.set(14,u.Codicon.symbolConstant),h.set(15,u.Codicon.symbolEnum),h.set(16,u.Codicon.symbolEnumMember),h.set(17,u.Codicon.symbolKeyword),h.set(27,u.Codicon.symbolSnippet),h.set(18,u.Codicon.symbolText),h.set(19,u.Codicon.symbolColor),h.set(20,u.Codicon.symbolFile),h.set(21,u.Codicon.symbolReference),h.set(22,u.Codicon.symbolCustomColor),h.set(23,u.Codicon.symbolFolder),h.set(24,u.Codicon.symbolTypeParameter),h.set(25,u.Codicon.account),h.set(26,u.Codicon.issues);function w(B){let R=h.get(B);return R||(console.info("No codicon found for CompletionItemKind "+B),R=u.Codicon.symbolProperty),R}r.toIcon=w;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function M(B,R){let z=L.get(B);return typeof z>"u"&&!R&&(z=9),z}r.fromString=M})(A=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(r){r[r.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(r){return r&&t.URI.isUri(r.uri)&&C.Range.isIRange(r.range)&&(C.Range.isIRange(r.originSelectionRange)||C.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=b;var f;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var c;(function(r){r[r.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var v;(function(r){const h=new Map;h.set(0,u.Codicon.symbolFile),h.set(1,u.Codicon.symbolModule),h.set(2,u.Codicon.symbolNamespace),h.set(3,u.Codicon.symbolPackage),h.set(4,u.Codicon.symbolClass),h.set(5,u.Codicon.symbolMethod),h.set(6,u.Codicon.symbolProperty),h.set(7,u.Codicon.symbolField),h.set(8,u.Codicon.symbolConstructor),h.set(9,u.Codicon.symbolEnum),h.set(10,u.Codicon.symbolInterface),h.set(11,u.Codicon.symbolFunction),h.set(12,u.Codicon.symbolVariable),h.set(13,u.Codicon.symbolConstant),h.set(14,u.Codicon.symbolString),h.set(15,u.Codicon.symbolNumber),h.set(16,u.Codicon.symbolBoolean),h.set(17,u.Codicon.symbolArray),h.set(18,u.Codicon.symbolObject),h.set(19,u.Codicon.symbolKey),h.set(20,u.Codicon.symbolNull),h.set(21,u.Codicon.symbolEnumMember),h.set(22,u.Codicon.symbolStruct),h.set(23,u.Codicon.symbolEvent),h.set(24,u.Codicon.symbolOperator),h.set(25,u.Codicon.symbolTypeParameter);function w(L){let M=h.get(L);return M||(console.info("No codicon found for SymbolKind "+L),M=u.Codicon.symbolProperty),M}r.toIcon=w})(v=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(h){this.value=h}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var d;(function(r){function h(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}r.is=h})(d=e.Command||(e.Command={}));var o;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var l;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var n;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[162],Ie([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[118],Ie([1,0,162,10,102,17,24,146]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=D;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(se,Ee,Ve,fe){this.id=se,this.name=Ee,this.defaultValue=Ve,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}compute(se,Ee,Ve){return Ve}}class E{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=E;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new E(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const Ve=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new E(se,!Ve)}let Ee=!1;for(const Ve in se)if(se.hasOwnProperty(Ve)){const fe=T(re[Ve],se[Ve]);fe.didChange&&(re[Ve]=fe.newValue,Ee=!0)}return new E(re,Ee)}class _{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return this.defaultValue}}class g{constructor(se,Ee,Ve,fe){this.id=se,this.name=Ee,this.defaultValue=Ve,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,Ve){return Ve}}function p(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=p;class m extends g{constructor(se,Ee,Ve,fe=void 0){typeof fe<"u"&&(fe.type="boolean",fe.default=Ve),super(se,Ee,Ve,fe)}validate(se){return p(se,this.defaultValue)}}function b(re,se,Ee,Ve){if(typeof re>"u")return se;let fe=parseInt(re,10);return isNaN(fe)?se:(fe=Math.max(Ee,fe),fe=Math.min(Ve,fe),fe|0)}e.clampedInt=b;class f extends g{static clampedInt(se,Ee,Ve,fe){return b(se,Ee,Ve,fe)}constructor(se,Ee,Ve,fe,Ae,Le=void 0){typeof Le<"u"&&(Le.type="integer",Le.default=Ve,Le.minimum=fe,Le.maximum=Ae),super(se,Ee,Ve,Le),this.minimum=fe,this.maximum=Ae}validate(se){return f.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class c extends g{static clamp(se,Ee,Ve){return se<Ee?Ee:se>Ve?Ve:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const Ve=parseFloat(se);return isNaN(Ve)?Ee:Ve}constructor(se,Ee,Ve,fe,Ae){typeof Ae<"u"&&(Ae.type="number",Ae.default=Ve),super(se,Ee,Ve,Ae),this.validationFn=fe}validate(se){return this.validationFn(c.float(se,this.defaultValue))}}class v extends g{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,Ve,fe=void 0){typeof fe<"u"&&(fe.type="string",fe.default=Ve),super(se,Ee,Ve,fe)}validate(se){return v.string(se,this.defaultValue)}}function a(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=a;class d extends g{constructor(se,Ee,Ve,fe,Ae=void 0){typeof Ae<"u"&&(Ae.type="string",Ae.enum=fe,Ae.default=Ve),super(se,Ee,Ve,Ae),this._allowedValues=fe}validate(se){return a(se,this.defaultValue,this._allowedValues)}}class o extends k{constructor(se,Ee,Ve,fe,Ae,Le,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ae,Me.default=fe),super(se,Ee,Ve,Me),this._allowedValues=Ae,this._convert=Le}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function i(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",tags:["accessibility"],description:u.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,Ve){return Ve===0?se.accessibilitySupport:Ve}}class l extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:u.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:p(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(re){switch(re){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function L(re){switch(re){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class M extends _{constructor(){super(130)}compute(se,Ee,Ve){const fe=["monaco-editor"];return Ee.get(34)&&fe.push(Ee.get(34)),se.extraEditorClassName&&fe.push(se.extraEditorClassName),Ee.get(67)==="default"?fe.push("mouse-default"):Ee.get(67)==="copy"&&fe.push("mouse-copy"),Ee.get(101)&&fe.push("showUnused"),Ee.get(128)&&fe.push("showDeprecated"),fe.join(" ")}}class B extends m{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(se,Ee,Ve){return Ve&&se.emptySelectionClipboard}}class R extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:u.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:u.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:p(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":a(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":a(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(Ee.loop,this.defaultValue.loop)}}}class z extends k{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?z.OFF:se==="true"?z.ON:se:Boolean(se)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class H extends _{constructor(){super(45)}compute(se,Ee,Ve){return se.fontInfo}}class N extends g{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(se){const Ee=c.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ee,6,100)}compute(se,Ee,Ve){return se.fontInfo.fontSize}}class V extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(f.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class U extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ve,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ve,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ve,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ve,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ve,description:u.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:a(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??a(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??a(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??a(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??a(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??a(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:u.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:p(Ee.enabled,this.defaultValue.enabled),delay:f.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:p(Ee.sticky,this.defaultValue.sticky),above:p(Ee.above,this.defaultValue.above)}}}var x;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class $ extends _{constructor(){super(133)}compute(se,Ee,Ve){return $.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,Ve=se.scrollBeyondLastLine?Ee-1:0,fe=(se.viewLineCount+Ve)/(se.pixelRatio*se.height),Ae=Math.floor(se.viewLineCount/fe);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ve,desiredRatio:fe,minimapLineCount:Ae}}static _computeMinimapLayout(se,Ee){const Ve=se.outerWidth,fe=se.outerHeight,Ae=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ae*fe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:fe};const Le=Ee.stableMinimapLayoutInput,Me=Le&&se.outerHeight===Le.outerHeight&&se.lineHeight===Le.lineHeight&&se.typicalHalfwidthCharacterWidth===Le.typicalHalfwidthCharacterWidth&&se.pixelRatio===Le.pixelRatio&&se.scrollBeyondLastLine===Le.scrollBeyondLastLine&&se.minimap.enabled===Le.minimap.enabled&&se.minimap.side===Le.minimap.side&&se.minimap.size===Le.minimap.size&&se.minimap.showSlider===Le.minimap.showSlider&&se.minimap.renderCharacters===Le.minimap.renderCharacters&&se.minimap.maxColumn===Le.minimap.maxColumn&&se.minimap.scale===Le.minimap.scale&&se.verticalScrollbarWidth===Le.verticalScrollbarWidth&&se.isViewportWrapping===Le.isViewportWrapping,Ke=se.lineHeight,Je=se.typicalHalfwidthCharacterWidth,st=se.scrollBeyondLastLine,ot=se.minimap.renderCharacters;let it=Ae>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const lt=se.minimap.maxColumn,vt=se.minimap.size,wt=se.minimap.side,ft=se.verticalScrollbarWidth,Et=se.viewLineCount,Ft=se.remainingWidth,Mt=se.isViewportWrapping,Qe=ot?2:3;let zt=Math.floor(Ae*fe);const Ot=zt/Ae;let Pt=!1,gt=!1,kt=Qe*it,Pe=it/Ae,Oe=1;if(vt==="fill"||vt==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:pt,desiredRatio:St,minimapLineCount:Tt}=$.computeContainedMinimapLineCount({viewLineCount:Et,scrollBeyondLastLine:st,height:fe,lineHeight:Ke,pixelRatio:Ae});if(Et/Tt>1)Pt=!0,gt=!0,it=1,kt=1,Pe=it/Ae;else{let _t=!1,bt=it+1;if(vt==="fit"){const Ct=Math.ceil((Et+pt)*kt);Mt&&Me&&Ft<=Ee.stableFitRemainingWidth?(_t=!0,bt=Ee.stableFitMaxMinimapScale):_t=Ct>zt}if(vt==="fill"||_t){Pt=!0;const Ct=it;kt=Math.min(Ke*Ae,Math.max(1,Math.floor(1/St))),Mt&&Me&&Ft<=Ee.stableFitRemainingWidth&&(bt=Ee.stableFitMaxMinimapScale),it=Math.min(bt,Math.max(1,Math.floor(kt/Qe))),it>Ct&&(Oe=Math.min(2,it/Ct)),Pe=it/Ae/Oe,zt=Math.ceil(Math.max(rt,Et+pt)*kt),Mt?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=it):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(lt*Pe),te=Math.min(_e,Math.max(0,Math.floor((Ft-ft-2)*Pe/(Je+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ae*te);const xe=Fe/Ae;Fe=Math.floor(Fe*Oe);const nt=ot?1:2,Ge=wt==="left"?0:Ve-te-ft;return{renderMinimap:nt,minimapLeft:Ge,minimapWidth:te,minimapHeightIsEditorHeight:Pt,minimapIsSampling:gt,minimapScale:it,minimapLineHeight:kt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:xe,minimapCanvasOuterHeight:Ot}}static computeLayout(se,Ee){const Ve=Ee.outerWidth|0,fe=Ee.outerHeight|0,Ae=Ee.lineHeight|0,Le=Ee.lineNumbersDigitCount|0,Me=Ee.typicalHalfwidthCharacterWidth,Ke=Ee.maxDigitWidth,Je=Ee.pixelRatio,st=Ee.viewLineCount,ot=se.get(125),it=ot==="inherit"?se.get(124):ot,lt=it==="inherit"?se.get(120):it,vt=se.get(123),wt=se.get(2),ft=Ee.isDominatedByLongLines,Et=se.get(51),Ft=se.get(61).renderType!==0,Mt=se.get(62),Qe=se.get(95),zt=se.get(66),Ot=se.get(93),Pt=Ot.verticalScrollbarSize,gt=Ot.verticalHasArrows,kt=Ot.arrowSize,Pe=Ot.horizontalScrollbarSize,Oe=se.get(59),_e=se.get(38),te=se.get(100)!=="never";let Fe;if(typeof Oe=="string"&&/^\d+(\.\d+)?ch$/.test(Oe)){const Ht=parseFloat(Oe.substr(0,Oe.length-2));Fe=f.clampedInt(Ht*Me,0,0,1e3)}else Fe=f.clampedInt(Oe,0,0,1e3);_e&&te&&(Fe+=16);let xe=0;if(Ft){const Ht=Math.max(Le,Mt);xe=Math.round(Ht*Ke)}let nt=0;Et&&(nt=Ae);let Ge=0,rt=Ge+nt,pt=rt+xe,St=pt+Fe;const Tt=Ve-nt-xe-Fe;let It=!1,_t=!1,bt=-1;wt!==2&&(it==="inherit"&&ft?(It=!0,_t=!0):lt==="on"||lt==="bounded"?_t=!0:lt==="wordWrapColumn"&&(bt=vt));const Ct=$._computeMinimapLayout({outerWidth:Ve,outerHeight:fe,lineHeight:Ae,typicalHalfwidthCharacterWidth:Me,pixelRatio:Je,scrollBeyondLastLine:Qe,minimap:zt,verticalScrollbarWidth:Pt,viewLineCount:st,remainingWidth:Tt,isViewportWrapping:_t},Ee.memory||new A);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Ge+=Ct.minimapWidth,rt+=Ct.minimapWidth,pt+=Ct.minimapWidth,St+=Ct.minimapWidth);const en=Tt-Ct.minimapWidth,yt=Math.max(1,Math.floor((en-Pt-2)/Me)),qt=gt?kt:0;return _t&&(bt=Math.max(1,yt),lt==="bounded"&&(bt=Math.min(bt,vt))),{width:Ve,height:fe,glyphMarginLeft:Ge,glyphMarginWidth:nt,lineNumbersLeft:rt,lineNumbersWidth:xe,decorationsLeft:pt,decorationsWidth:Fe,contentLeft:St,contentWidth:en,minimap:Ct,viewportColumn:yt,isWordWrapMinified:It,isViewportWrapping:_t,wrappingColumn:bt,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Pe,overviewRuler:{top:qt,width:Pt,height:fe-2*qt,right:0}}}}e.EditorLayoutInfoComputer=$;class Q extends k{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:u.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:p(se.enabled,this.defaultValue.enabled)}}}class K extends k{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:u.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:u.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:p(Ee.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class de extends k{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:u.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(47,null),u.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),u.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),u.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:u.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:u.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:u.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:a(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:p(Ee.padding,this.defaultValue.padding)}}}class ee extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>c.clamp(se,0,150),{markdownDescription:u.localize(54,null)})}compute(se,Ee,Ve){return se.fontInfo.lineHeight}}class he extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:u.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:u.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)],default:se.size,description:u.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:u.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:u.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:u.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:u.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:p(Ee.enabled,this.defaultValue.enabled),autohide:p(Ee.autohide,this.defaultValue.autohide),size:a(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(Ee.side,this.defaultValue.side,["right","left"]),showSlider:a(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(Ee.scale,1,1,3),maxColumn:f.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class me extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:f.clampedInt(Ee.top,0,0,1e3),bottom:f.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends k{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:u.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:u.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:p(Ee.enabled,this.defaultValue.enabled),cycle:p(Ee.cycle,this.defaultValue.cycle)}}}class ke extends _{constructor(){super(131)}compute(se,Ee,Ve){return se.pixelRatio}}class Re extends k{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(70,null),u.localize(71,null),u.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:u.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:u.localize(74,null)},other:{anyOf:Ee,default:se.other,description:u.localize(75,null)}},default:se,markdownDescription:u.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Je=se?"on":"off";return{comments:Je,strings:Je,other:Je}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:Ve,strings:fe}=se,Ae=["on","inline","off"];let Le,Me,Ke;return typeof Ee=="boolean"?Le=Ee?"on":"off":Le=a(Ee,this.defaultValue.other,Ae),typeof Ve=="boolean"?Me=Ve?"on":"off":Me=a(Ve,this.defaultValue.comments,Ae),typeof fe=="boolean"?Ke=fe?"on":"off":Ke=a(fe,this.defaultValue.strings,Ae),{other:Le,comments:Me,strings:Ke}}}var ze;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(ze=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(77,null),u.localize(78,null),u.localize(79,null),u.localize(80,null)],default:"on",description:u.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,Ve=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ve}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class ge extends k{constructor(){const se=[],Ee={type:"number",description:u.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:u.localize(83,null),format:"color-hex"}}}]},default:se,description:u.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const Ve of se)if(typeof Ve=="number")Ee.push({column:f.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const fe=Ve;Ee.push({column:f.clampedInt(fe.column,0,0,1e4),color:fe.color})}return Ee.sort((Ve,fe)=>Ve.column-fe.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(85,null),u.localize(86,null),u.localize(87,null)],default:"auto",description:u.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(89,null),u.localize(90,null),u.localize(91,null)],default:"auto",description:u.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:u.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:u.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:u.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,Ve=f.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),fe=f.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:p(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:f.clampedInt(Ee.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:fe,verticalSliderSize:f.clampedInt(Ee.verticalSliderSize,fe,0,1e3),scrollByPage:p(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ne extends k{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:u.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:u.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:u.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:u.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:u.localize(102,null)}})}applyUpdate(se,Ee){let Ve=!1;Ee.allowedCharacters&&se&&(y.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},Ve=!0)),Ee.allowedLocales&&se&&(y.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},Ve=!0));const fe=super.applyUpdate(se,Ee);return Ve?new E(fe.newValue,!0):fe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:G(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:p(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:p(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:G(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:G(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const Ve={};for(const[fe,Ae]of Object.entries(se))Ae===!0&&(Ve[fe]=!0);return Ve}}class ie extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:u.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:p(Ee.enabled,this.defaultValue.enabled),mode:a(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends k{constructor(){const se={enabled:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:u.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:u.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:p(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:p(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class j extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(106,null),u.localize(107,null),u.localize(108,null)],default:se.bracketPairs,description:u.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(110,null),u.localize(111,null),u.localize(112,null)],default:se.bracketPairsHorizontal,description:u.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:u.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:u.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(116,null),u.localize(117,null),u.localize(118,null)],default:se.highlightActiveIndentation,description:u.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:G(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:G(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:p(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:p(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:G(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function G(re,se,Ee){const Ve=Ee.indexOf(re);return Ve===-1?se:Ee[Ve]}class X extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(120,null),u.localize(121,null)],default:se.insertMode,description:u.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:u.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:u.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:u.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:u.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:u.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:u.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:u.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:u.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:a(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:p(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:p(Ee.preview,this.defaultValue.preview),previewMode:a(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:p(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(Ee.showMethods,this.defaultValue.showMethods),showFunctions:p(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:p(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:p(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:p(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:p(Ee.showFields,this.defaultValue.showFields),showVariables:p(Ee.showVariables,this.defaultValue.showVariables),showClasses:p(Ee.showClasses,this.defaultValue.showClasses),showStructs:p(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:p(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:p(Ee.showModules,this.defaultValue.showModules),showProperties:p(Ee.showProperties,this.defaultValue.showProperties),showEvents:p(Ee.showEvents,this.defaultValue.showEvents),showOperators:p(Ee.showOperators,this.defaultValue.showOperators),showUnits:p(Ee.showUnits,this.defaultValue.showUnits),showValues:p(Ee.showValues,this.defaultValue.showValues),showConstants:p(Ee.showConstants,this.defaultValue.showConstants),showEnums:p(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:p(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(Ee.showKeywords,this.defaultValue.showKeywords),showWords:p(Ee.showWords,this.defaultValue.showWords),showColors:p(Ee.showColors,this.defaultValue.showColors),showFiles:p(Ee.showFiles,this.defaultValue.showFiles),showReferences:p(Ee.showReferences,this.defaultValue.showReferences),showFolders:p(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:p(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:p(Ee.showUsers,this.defaultValue.showUsers),showIssues:p(Ee.showIssues,this.defaultValue.showIssues)}}}class pe extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends _{constructor(){super(132)}compute(se,Ee,Ve){return Ee.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ce(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends _{constructor(){super(134)}compute(se,Ee,Ve){const fe=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:fe.isWordWrapMinified,isViewportWrapping:fe.isViewportWrapping,wrappingColumn:fe.wrappingColumn}}}class We extends k{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:u.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:p(se.enabled,this.defaultValue.enabled)}}}const qe="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Ye:qe,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(re){return e.editorOptionsRegistry[re.id]=re,re}var at;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(165,null)})),acceptSuggestionOnEnter:Ne(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(166,null),""],markdownDescription:u.localize(167,null)})),accessibilitySupport:Ne(new s),accessibilityPageSize:Ne(new f(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(168,null),tags:["accessibility"]})),ariaLabel:Ne(new v(4,"ariaLabel",u.localize(169,null))),autoClosingBrackets:Ne(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(170,null),u.localize(171,null),""],description:u.localize(172,null)})),autoClosingDelete:Ne(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(173,null),""],description:u.localize(174,null)})),autoClosingOvertype:Ne(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(175,null),""],description:u.localize(176,null)})),autoClosingQuotes:Ne(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(177,null),u.localize(178,null),""],description:u.localize(179,null)})),autoIndent:Ne(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[u.localize(180,null),u.localize(181,null),u.localize(182,null),u.localize(183,null),u.localize(184,null)],description:u.localize(185,null)})),automaticLayout:Ne(new m(10,"automaticLayout",!1)),autoSurround:Ne(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(186,null),u.localize(187,null),u.localize(188,null),""],description:u.localize(189,null)})),bracketPairColorization:Ne(new O),bracketPairGuides:Ne(new j),stickyTabStops:Ne(new m(106,"stickyTabStops",!1,{description:u.localize(190,null)})),codeLens:Ne(new m(14,"codeLens",!0,{description:u.localize(191,null)})),codeLensFontFamily:Ne(new v(15,"codeLensFontFamily","",{description:u.localize(192,null)})),codeLensFontSize:Ne(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(193,null)})),colorDecorators:Ne(new m(17,"colorDecorators",!0,{description:u.localize(194,null)})),columnSelection:Ne(new m(18,"columnSelection",!1,{description:u.localize(195,null)})),comments:Ne(new l),contextmenu:Ne(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new m(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(196,null)})),cursorBlinking:Ne(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:u.localize(197,null)})),cursorSmoothCaretAnimation:Ne(new m(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(198,null)})),cursorStyle:Ne(new o(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:u.localize(199,null)})),cursorSurroundingLines:Ne(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(200,null)})),cursorSurroundingLinesStyle:Ne(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(201,null),u.localize(202,null)],description:u.localize(203,null)})),cursorWidth:Ne(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(204,null)})),disableLayerHinting:Ne(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new m(30,"domReadOnly",!1)),dragAndDrop:Ne(new m(31,"dragAndDrop",!0,{description:u.localize(205,null)})),emptySelectionClipboard:Ne(new B),dropIntoEditor:Ne(new We),stickyScroll:Ne(new K),extraEditorClassName:Ne(new v(34,"extraEditorClassName","")),fastScrollSensitivity:Ne(new c(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:u.localize(206,null)})),find:Ne(new R),fixedOverflowWidgets:Ne(new m(37,"fixedOverflowWidgets",!1)),folding:Ne(new m(38,"folding",!0,{description:u.localize(207,null)})),foldingStrategy:Ne(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(208,null),u.localize(209,null)],description:u.localize(210,null)})),foldingHighlight:Ne(new m(40,"foldingHighlight",!0,{description:u.localize(211,null)})),foldingImportsByDefault:Ne(new m(41,"foldingImportsByDefault",!1,{description:u.localize(212,null)})),foldingMaximumRegions:Ne(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(213,null)})),unfoldOnClickAfterEndOfLine:Ne(new m(43,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(214,null)})),fontFamily:Ne(new v(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(215,null)})),fontInfo:Ne(new H),fontLigatures2:Ne(new z),fontSize:Ne(new N),fontWeight:Ne(new V),formatOnPaste:Ne(new m(49,"formatOnPaste",!1,{description:u.localize(216,null)})),formatOnType:Ne(new m(50,"formatOnType",!1,{description:u.localize(217,null)})),glyphMargin:Ne(new m(51,"glyphMargin",!0,{description:u.localize(218,null)})),gotoLocation:Ne(new U),hideCursorInOverviewRuler:Ne(new m(53,"hideCursorInOverviewRuler",!1,{description:u.localize(219,null)})),hover:Ne(new F),inDiffEditor:Ne(new m(55,"inDiffEditor",!1)),letterSpacing:Ne(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>c.clamp(re,-5,20),{description:u.localize(220,null)})),lightbulb:Ne(new Q),lineDecorationsWidth:Ne(new g(59,"lineDecorationsWidth",10)),lineHeight:Ne(new ee),lineNumbers:Ne(new oe),lineNumbersMinChars:Ne(new f(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new m(63,"linkedEditing",!1,{description:u.localize(221,null)})),links:Ne(new m(64,"links",!0,{description:u.localize(222,null)})),matchBrackets:Ne(new d(65,"matchBrackets","always",["always","near","never"],{description:u.localize(223,null)})),minimap:Ne(new he),mouseStyle:Ne(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new c(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:u.localize(224,null)})),mouseWheelZoom:Ne(new m(69,"mouseWheelZoom",!1,{markdownDescription:u.localize(225,null)})),multiCursorMergeOverlapping:Ne(new m(70,"multiCursorMergeOverlapping",!0,{description:u.localize(226,null)})),multiCursorModifier:Ne(new o(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[u.localize(227,null),u.localize(228,null)],markdownDescription:u.localize(229,null)})),multiCursorPaste:Ne(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(230,null),u.localize(231,null)],markdownDescription:u.localize(232,null)})),occurrencesHighlight:Ne(new m(73,"occurrencesHighlight",!0,{description:u.localize(233,null)})),overviewRulerBorder:Ne(new m(74,"overviewRulerBorder",!0,{description:u.localize(234,null)})),overviewRulerLanes:Ne(new f(75,"overviewRulerLanes",3,0,3)),padding:Ne(new me),parameterHints:Ne(new be),peekWidgetDefaultFocus:Ne(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(235,null),u.localize(236,null)],description:u.localize(237,null)})),definitionLinkOpensInPeek:Ne(new m(79,"definitionLinkOpensInPeek",!1,{description:u.localize(238,null)})),quickSuggestions:Ne(new Re),quickSuggestionsDelay:Ne(new f(81,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(239,null)})),readOnly:Ne(new m(82,"readOnly",!1)),renameOnType:Ne(new m(83,"renameOnType",!1,{description:u.localize(240,null),markdownDeprecationMessage:u.localize(241,null)})),renderControlCharacters:Ne(new m(84,"renderControlCharacters",!0,{description:u.localize(242,null),restricted:!0})),renderFinalNewline:Ne(new m(85,"renderFinalNewline",!0,{description:u.localize(243,null)})),renderLineHighlight:Ne(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(244,null)],description:u.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Ne(new m(87,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(246,null)})),renderValidationDecorations:Ne(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(247,null),u.localize(248,null),u.localize(249,null),""],description:u.localize(250,null)})),revealHorizontalRightPadding:Ne(new f(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new m(91,"roundedSelection",!0,{description:u.localize(251,null)})),rulers:Ne(new ge),scrollbar:Ne(new ae),scrollBeyondLastColumn:Ne(new f(94,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(252,null)})),scrollBeyondLastLine:Ne(new m(95,"scrollBeyondLastLine",!0,{description:u.localize(253,null)})),scrollPredominantAxis:Ne(new m(96,"scrollPredominantAxis",!0,{description:u.localize(254,null)})),selectionClipboard:Ne(new m(97,"selectionClipboard",!0,{description:u.localize(255,null),included:t.isLinux})),selectionHighlight:Ne(new m(98,"selectionHighlight",!0,{description:u.localize(256,null)})),selectOnLineNumbers:Ne(new m(99,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new d(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[u.localize(257,null),u.localize(258,null),u.localize(259,null)],description:u.localize(260,null)})),showUnused:Ne(new m(101,"showUnused",!0,{description:u.localize(261,null)})),showDeprecated:Ne(new m(128,"showDeprecated",!0,{description:u.localize(262,null)})),inlayHints:Ne(new de),snippetSuggestions:Ne(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(263,null),u.localize(264,null),u.localize(265,null),u.localize(266,null)],description:u.localize(267,null)})),smartSelect:Ne(new pe),smoothScrolling:Ne(new m(104,"smoothScrolling",!1,{description:u.localize(268,null)})),stopRenderingLineAfter:Ne(new f(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new X),inlineSuggest:Ne(new ie),suggestFontSize:Ne(new f(109,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new f(110,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new m(111,"suggestOnTriggerCharacters",!0,{description:u.localize(271,null)})),suggestSelection:Ne(new d(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(272,null),u.localize(273,null),u.localize(274,null)],description:u.localize(275,null)})),tabCompletion:Ne(new d(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(276,null),u.localize(277,null),u.localize(278,null)],description:u.localize(279,null)})),tabIndex:Ne(new f(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new ne),unusualLineTerminators:Ne(new d(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(280,null),u.localize(281,null),u.localize(282,null)],description:u.localize(283,null)})),useShadowDOM:Ne(new m(117,"useShadowDOM",!0)),useTabStops:Ne(new m(118,"useTabStops",!0,{description:u.localize(284,null)})),wordSeparators:Ne(new v(119,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:u.localize(285,null)})),wordWrap:Ne(new d(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(286,null),u.localize(287,null),u.localize(288,null),u.localize(289,null)],description:u.localize(290,null)})),wordWrapBreakAfterCharacters:Ne(new v(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new v(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new f(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(291,null)})),wordWrapOverride1:Ne(new d(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new d(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new o(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[u.localize(292,null),u.localize(293,null),u.localize(294,null),u.localize(295,null)],description:u.localize(296,null)})),wrappingStrategy:Ne(new d(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(297,null),u.localize(298,null)],description:u.localize(299,null)})),editorClassName:Ne(new M),pixelRatio:Ne(new ke),tabFocusMode:Ne(new we),layoutInfo:Ne(new $),wrappingInfo:Ne(new ye)}}),define(De[163],Ie([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[164],Ie([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[165],Ie([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[166],Ie([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[167],Ie([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[168],Ie([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[169],Ie([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[170],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[171],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[172],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[173],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[174],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[175],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[176],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[177],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[178],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[179],Ie([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[180],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[181],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[182],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[183],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[184],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[185],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[186],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[187],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[188],Ie([1,0,22,42,165,306]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function S(m){return m=m.trim(),m==="*"||y.test(m)}e.isValidVersionStr=S;function D(m){if(!S(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=m.match(y);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=D;function A(m){if(!m)return null;const b=m.majorBase,f=m.majorMustEqual,c=m.minorBase;let v=m.minorMustEqual;const a=m.patchBase;let d=m.patchMustEqual;m.hasCaret&&(b===0||(v=!1),d=!1);let o=0;if(m.preRelease){const i=I.exec(m.preRelease);if(i){const[,s,l,n]=i;o=Date.UTC(Number(s),Number(l)-1,Number(n))}}return{majorBase:b,majorMustEqual:f,minorBase:c,minorMustEqual:v,patchBase:a,patchMustEqual:d,isMinimum:m.hasGreaterEquals,notBefore:o}}e.normalizeVersion=A;function k(m,b,f){let c;typeof m=="string"?c=A(D(m)):c=m;let v;b instanceof Date?v=b.getTime():typeof b=="string"&&(v=new Date(b).getTime());let a;if(typeof f=="string"?a=A(D(f)):a=f,!c||!a)return!1;const d=c.majorBase,o=c.minorBase,i=c.patchBase;let s=a.majorBase,l=a.minorBase,n=a.patchBase;const r=a.notBefore;let h=a.majorMustEqual,w=a.minorMustEqual,L=a.patchMustEqual;return a.isMinimum?d>s?!0:d<s?!1:o>l?!0:o<l||v&&v<r?!1:i>=n:(d===1&&s===0&&(!h||!w||!L)&&(s=1,l=0,n=0,h=!0,w=!1,L=!1),d<s?!1:d>s?!h:o<l?!1:o>l?!w:i<n?!1:i>n?!L:!(v&&v<r))}e.isValidVersion=k;function E(m,b,f,c,v){const a=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return a.push([t.default.Error,C.localize(0,null)]),a;if(typeof c.name!="string")return a.push([t.default.Error,C.localize(1,null,"name")]),a;if(typeof c.version!="string")return a.push([t.default.Error,C.localize(2,null,"version")]),a;if(!c.engines)return a.push([t.default.Error,C.localize(3,null,"engines")]),a;if(typeof c.engines.vscode!="string")return a.push([t.default.Error,C.localize(4,null,"engines.vscode")]),a;if(typeof c.extensionDependencies<"u"&&!p(c.extensionDependencies))return a.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),a;if(typeof c.activationEvents<"u"){if(!p(c.activationEvents))return a.push([t.default.Error,C.localize(6,null,"activationEvents")]),a;if(typeof c.main>"u"&&typeof c.browser>"u")return a.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),a}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&a.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return a.push([t.default.Error,C.localize(9,null,"main")]),a;{const i=(0,u.joinPath)(f,c.main);(0,u.isEqualOrParent)(i,f)||a.push([t.default.Warning,C.localize(10,null,i.path,f.path)])}if(typeof c.activationEvents>"u")return a.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),a}if(typeof c.browser<"u"){if(typeof c.browser!="string")return a.push([t.default.Error,C.localize(12,null,"browser")]),a;{const i=(0,u.joinPath)(f,c.browser);(0,u.isEqualOrParent)(i,f)||a.push([t.default.Warning,C.localize(13,null,i.path,f.path)])}if(typeof c.activationEvents>"u")return a.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),a}if(!P.valid(c.version))return a.push([t.default.Error,C.localize(15,null)]),a;const d=[];if(!T(m,b,c,v,d))for(const i of d)a.push([t.default.Error,i]);return a}e.validateExtensionManifest=E;function T(m,b,f,c,v){return c||typeof f.main>"u"&&typeof f.browser>"u"?!0:g(m,b,f.engines.vscode,v)}e.isValidExtensionVersion=T;function _(m,b,f){return m==="*"||g(b,f,m)}e.isEngineValid=_;function g(m,b,f,c=[]){const v=A(D(f));if(!v)return c.push(C.localize(16,null,f)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return c.push(C.localize(17,null,f)),!1}else if(!v.majorMustEqual)return c.push(C.localize(18,null,f)),!1;return k(m,b,v)?!0:(c.push(C.localize(19,null,m,f)),!1)}function p(m){if(!Array.isArray(m))return!1;for(let b=0,f=m.length;b<f;b++)if(typeof m[b]!="string")return!1;return!0}}),define(De[119],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(C,P=[],y=!1){this.ctor=C,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=u}),define(De[83],Ie([1,0,119]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function P(I,S,D){S instanceof u.SyncDescriptor||(S=new u.SyncDescriptor(S,[],Boolean(D))),t.push([I,S])}e.registerSingleton=P;function y(){return t}e.getSingletonServiceDescriptors=y}),define(De[189],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(P,y){this.key=P,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=u;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const I=this.lookupOrInsertNode(P),S=this.lookupOrInsertNode(y);I.outgoing.set(S.key,S),S.incoming.set(I.key,I)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const I of this._nodes.values())I.outgoing.delete(y),I.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let I=this._nodes.get(y);return I||(I=new u(y,P),this._nodes.set(y,I)),I}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,I]of this._nodes)P.push(`${y}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const I=new Set([P]),S=this._findCycle(y,I);if(S)return S}}_findCycle(P,y){for(const[I,S]of P.outgoing){if(y.has(I))return[...y,I].join(" -> ");y.add(I);const D=this._findCycle(S,y);if(D)return D;y.delete(I)}}}e.Graph=t}),define(De[4],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function I(S){return S[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=I})(u=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(y,I,S){I[u.DI_TARGET]===I?I[u.DI_DEPENDENCIES].push({id:y,index:S}):(I[u.DI_DEPENDENCIES]=[{id:y,index:S}],I[u.DI_TARGET]=I)}function C(y){if(u.serviceIds.has(y))return u.serviceIds.get(y);const I=function(S,D,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,S,A)};return I.toString=()=>y,u.serviceIds.set(y,I),I}e.createDecorator=C;function P(y){return y}e.refineServiceDecorator=P}),define(De[65],Ie([1,0,12,2,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var I;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function D(m,b){const f=Object.create(null);for(const c in m)A(f,c,m[c],b);return f}e.toValuesTree=D;function A(m,b,f,c){const v=b.split("."),a=v.pop();let d=m;for(let o=0;o<v.length;o++){const i=v[o];let s=d[i];switch(typeof s){case"undefined":s=d[i]=Object.create(null);break;case"object":break;default:c(`Ignoring ${b} as ${v.slice(0,o+1).join(".")} is ${JSON.stringify(s)}`);return}d=s}if(typeof d=="object"&&d!==null)try{d[a]=f}catch{c(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${b} as ${v.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=A;function k(m,b){const f=b.split(".");E(m,f)}e.removeFromValueTree=k;function E(m,b){const f=b.shift();if(b.length===0){delete m[f];return}if(Object.keys(m).indexOf(f)!==-1){const c=m[f];typeof c=="object"&&!Array.isArray(c)&&(E(c,b),Object.keys(c).length===0&&delete m[f])}}function T(m,b,f){function c(d,o){let i=d;for(const s of o){if(typeof i!="object"||i===null)return;i=i[s]}return i}const v=b.split("."),a=c(m,v);return typeof a>"u"?f:a}e.getConfigurationValue=T;function _(m,b,f){Object.keys(b).forEach(c=>{c!=="__proto__"&&(c in m?u.isObject(m[c])&&u.isObject(b[c])?_(m[c],b[c],f):f&&(m[c]=b[c]):m[c]=b[c])})}e.merge=_;function g(m,b,f){const c=m.inspect(b),v=m.inspect(f);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:c.defaultValue}e.getMigratedSettingValue=g;function p(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(De[52],Ie([1,0,10,8,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",u.isMacintosh),P.set("isLinux",u.isLinux),P.set("isWindows",u.isWindows),P.set("isWeb",u.isWeb),P.set("isMacNative",u.isMacintosh&&!u.isWeb),P.set("isEdge",u.isEdge),P.set("isFirefox",u.isFirefox),P.set("isChrome",u.isChrome),P.set("isSafari",u.isSafari);const y=Object.prototype.hasOwnProperty;var I;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return k.INSTANCE}static true(){return E.INSTANCE}static has(R){return T.create(R)}static equals(R,z){return _.create(R,z)}static notEquals(R,z){return m.create(R,z)}static regex(R,z){return o.create(R,z)}static in(R,z){return g.create(R,z)}static notIn(R,z){return p.create(R,z)}static not(R){return b.create(R)}static and(...R){return l.create(R,null)}static or(...R){return n.create(R,null,!0)}static greater(R,z){return c.create(R,z)}static greaterEquals(R,z){return v.create(R,z)}static smaller(R,z){return a.create(R,z)}static smallerEquals(R,z){return d.create(R,z)}static deserialize(R,z=!1){if(!!R)return this._deserializeOrExpression(R,z)}static _deserializeOrExpression(R,z){const H=R.split("||");return n.create(H.map(N=>this._deserializeAndExpression(N,z)),null,!0)}static _deserializeAndExpression(R,z){const H=R.split("&&");return l.create(H.map(N=>this._deserializeOne(N,z)),null)}static _deserializeOne(R,z){if(R=R.trim(),R.indexOf("!=")>=0){const H=R.split("!=");return m.create(H[0].trim(),this._deserializeValue(H[1],z))}if(R.indexOf("==")>=0){const H=R.split("==");return _.create(H[0].trim(),this._deserializeValue(H[1],z))}if(R.indexOf("=~")>=0){const H=R.split("=~");return o.create(H[0].trim(),this._deserializeRegexValue(H[1],z))}if(R.indexOf(" not in ")>=0){const H=R.split(" not in ");return p.create(H[0].trim(),this._deserializeValue(H[1],z))}if(R.indexOf(" in ")>=0){const H=R.split(" in ");return g.create(H[0].trim(),this._deserializeValue(H[1],z))}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const H=R.split(">=");return v.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const H=R.split(">");return c.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const H=R.split("<=");return d.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const H=R.split("<");return a.create(H[0].trim(),H[1].trim())}return/^\!\s*/.test(R)?b.create(R.substr(1).trim()):T.create(R)}static _deserializeValue(R,z){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const H=/^'([^']*)'$/.exec(R);return H?H[1].trim():R}static _deserializeRegexValue(R,z){if((0,t.isFalsyOrWhitespace)(R)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const H=R.indexOf("/"),N=R.lastIndexOf("/");if(H===N||H<0){if(z)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const V=R.slice(H+1,N),U=R[N+1]==="i"?"i":"";try{return new RegExp(V,U)}catch(F){if(z)throw new Error(`bad regexp-value '${R}', parse error: ${F}`);return console.warn(`bad regexp-value '${R}', parse error: ${F}`),null}}}e.ContextKeyExpr=S;function D(B,R){const z=B?B.substituteConstants():void 0,H=R?R.substituteConstants():void 0;return!z&&!H?!0:!z||!H?!1:z.equals(H)}e.expressionsAreEqualWithConstantSubstitution=D;function A(B,R){return B.cmp(R)}class k{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class E{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class T{static create(R,z=null){const H=P.get(R);return typeof H=="boolean"?H?E.INSTANCE:k.INSTANCE:new T(R,z)}constructor(R,z){this.key=R,this.negated=z,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:h(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=P.get(this.key);return typeof R=="boolean"?R?E.INSTANCE:k.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class _{static create(R,z,H=null){if(typeof z=="boolean")return z?T.create(R,H):b.create(R,H);const N=P.get(R);return typeof N=="boolean"?z===(N?"true":"false")?E.INSTANCE:k.INSTANCE:new _(R,z,H)}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:w(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=P.get(this.key);if(typeof R=="boolean"){const z=R?"true":"false";return this.value===z?E.INSTANCE:k.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=_;class g{static create(R,z){return new g(R,z)}constructor(R,z){this.key=R,this.valueKey=z,this.type=10,this.negated=null}cmp(R){return R.type!==this.type?this.type-R.type:w(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const z=R.getValue(this.valueKey),H=R.getValue(this.key);return Array.isArray(z)?z.includes(H):typeof H=="string"&&typeof z=="object"&&z!==null?y.call(z,H):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class p{static create(R,z){return new p(R,z)}constructor(R,z){this.key=R,this.valueKey=z,this.type=11,this._negated=g.create(R,z)}cmp(R){return R.type!==this.type?this.type-R.type:this._negated.cmp(R._negated)}equals(R){return R.type===this.type?this._negated.equals(R._negated):!1}substituteConstants(){return this}evaluate(R){return!this._negated.evaluate(R)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(R){return R.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=p;class m{static create(R,z,H=null){if(typeof z=="boolean")return z?b.create(R,H):T.create(R,H);const N=P.get(R);return typeof N=="boolean"?z===(N?"true":"false")?k.INSTANCE:E.INSTANCE:new m(R,z,H)}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:w(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=P.get(this.key);if(typeof R=="boolean"){const z=R?"true":"false";return this.value===z?k.INSTANCE:E.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class b{static create(R,z=null){const H=P.get(R);return typeof H=="boolean"?H?k.INSTANCE:E.INSTANCE:new b(R,z)}constructor(R,z){this.key=R,this.negated=z,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:h(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=P.get(this.key);return typeof R=="boolean"?R?k.INSTANCE:E.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function f(B,R){if(typeof B=="string"){const z=parseFloat(B);isNaN(z)||(B=z)}return typeof B=="string"||typeof B=="number"?R(B):k.INSTANCE}class c{static create(R,z,H=null){return f(z,N=>new c(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:w(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class v{static create(R,z,H=null){return f(z,N=>new v(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:w(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class a{static create(R,z,H=null){return f(z,N=>new a(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:w(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class d{static create(R,z,H=null){return f(z,N=>new d(R,N,H))}constructor(R,z,H){this.key=R,this.value=z,this.negated=H,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:w(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class o{static create(R,z){return new o(R,z)}constructor(R,z){this.key=R,this.regexp=z,this.type=7,this.negated=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const z=this.regexp?this.regexp.source:"",H=R.regexp?R.regexp.source:"";return z<H?-1:z>H?1:0}equals(R){if(R.type===this.type){const z=this.regexp?this.regexp.source:"",H=R.regexp?R.regexp.source:"";return this.key===R.key&&z===H}return!1}substituteConstants(){return this}evaluate(R){const z=R.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class i{static create(R){return new i(R)}constructor(R){this._actual=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new i(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(B){let R=null;for(let z=0,H=B.length;z<H;z++){const N=B[z].substituteConstants();if(B[z]!==N&&R===null){R=[];for(let V=0;V<z;V++)R[V]=B[V]}R!==null&&(R[z]=N)}return R===null?B:R}class l{static create(R,z){return l._normalizeArr(R,z)}constructor(R,z){this.expr=R,this.negated=z,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const N=A(this.expr[z],R.expr[z]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(R.expr[z]))return!1;return!0}return!1}substituteConstants(){const R=s(this.expr);return R===this.expr?this:l.create(R,this.negated)}evaluate(R){for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].evaluate(R))return!1;return!0}static _normalizeArr(R,z){const H=[];let N=!1;for(const V of R)if(!!V){if(V.type===1){N=!0;continue}if(V.type===0)return k.INSTANCE;if(V.type===6){H.push(...V.expr);continue}H.push(V)}if(H.length===0&&N)return E.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(A);for(let V=1;V<H.length;V++)H[V-1].equals(H[V])&&(H.splice(V,1),V--);if(H.length===1)return H[0];for(;H.length>1;){const V=H[H.length-1];if(V.type!==9)break;H.pop();const U=H.pop(),F=H.length===0,x=n.create(V.expr.map($=>l.create([$,U],null)),null,F);x&&(H.push(x),H.sort(A))}return H.length===1?H[0]:new l(H,z)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const z of this.expr)R.push(...z.keys());return R}map(R){return new l(this.expr.map(z=>z.map(R)),null)}negate(){if(!this.negated){const R=[];for(const z of this.expr)R.push(z.negate());this.negated=n.create(R,this,!0)}return this.negated}}class n{static create(R,z,H){return n._normalizeArr(R,z,H)}constructor(R,z){this.expr=R,this.negated=z,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const N=A(this.expr[z],R.expr[z]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(R.expr[z]))return!1;return!0}return!1}substituteConstants(){const R=s(this.expr);return R===this.expr?this:n.create(R,this.negated,!1)}evaluate(R){for(let z=0,H=this.expr.length;z<H;z++)if(this.expr[z].evaluate(R))return!0;return!1}static _normalizeArr(R,z,H){let N=[],V=!1;if(R){for(let U=0,F=R.length;U<F;U++){const x=R[U];if(!!x){if(x.type===0){V=!0;continue}if(x.type===1)return E.INSTANCE;if(x.type===9){N=N.concat(x.expr);continue}N.push(x)}}if(N.length===0&&V)return k.INSTANCE;N.sort(A)}if(N.length!==0){if(N.length===1)return N[0];for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];if(H){for(let U=0;U<N.length;U++)for(let F=U+1;F<N.length;F++)L(N[U],N[F])&&(N.splice(F,1),F--);if(N.length===1)return N[0]}return new n(N,z)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const z of this.expr)R.push(...z.keys());return R}map(R){return new n(this.expr.map(z=>z.map(R)),null)}negate(){if(!this.negated){const R=[];for(const z of this.expr)R.push(z.negate());for(;R.length>1;){const z=R.shift(),H=R.shift(),N=[];for(const U of M(z))for(const F of M(H))N.push(l.create([U,F],null));const V=R.length===0;R.unshift(n.create(N,null,V))}this.negated=R[0]}return this.negated}}class r extends T{static all(){return r._info.values()}constructor(R,z,H){super(R,null),this._defaultValue=z,typeof H=="object"?r._info.push({...H,key:R}):H!==!0&&r._info.push({key:R,description:H,type:z!=null?typeof z:void 0})}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return _.create(this.key,R)}notEqualsTo(R){return m.create(this.key,R)}}e.RawContextKey=r,r._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(B,R){return B<R?-1:B>R?1:0}function w(B,R,z,H){return B<z?-1:B>z?1:R<H?-1:R>H?1:0}function L(B,R){if(R.type===6&&B.type!==9&&B.type!==6){for(const N of R.expr)if(B.equals(N))return!0}const z=B.negate(),H=M(z).concat(M(R));H.sort(A);for(let N=0;N<H.length;N++){const U=H[N].negate();for(let F=N+1;F<H.length;F++){const x=H[F];if(U.equals(x))return!0}}return!1}e.implies=L;function M(B){return B.type===9?B.expr:[B]}}),define(De[190],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(De[120],Ie([1,0,164,4]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function P(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(m,b){switch(m){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function I(m,b){return b==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function S(m,b,f){return I(b,f)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===f?!0:D(f).includes(m)}e.isTargetPlatformCompatible=S;function D(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function A(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=A;var k;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var E;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var T;(function(m){m.Install="install",m.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var _;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(b,f){super(b),this.code=f,this.name=f}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[191],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(De[192],Ie([1,0,44,14,9,10,105,29,113,166,191]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=D.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends E{openTerminal(c,v){return this.spawnTerminal(u,c,S.getWindowsShell(),v)}spawnTerminal(c,v,a,d){const o=v.windowsExec||T.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const i=C.basename(o).toLowerCase();if(i==="cmder"||i==="cmder.exe")return c.spawn(o,d?[d]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return o.indexOf(" ")>=0&&s.push('""'),s.push(o),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((l,n)=>{const r=p(process),h=c.spawn(a,s,{cwd:d,env:r});h.on("error",n),h.on("exit",()=>l())})}runInTerminal(c,v,a,d,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:T.getDefaultTerminalWindows();return new Promise((s,l)=>{const n=`"${v} - ${k}"`,r=`""${a.join('" "')}" & pause"`,h=["/c","start",n,"/wait",i,"/c",r],w=Object.assign({},p(process),d);Object.keys(w).filter(B=>w[B]===null).forEach(B=>delete w[B]);const L={cwd:v,env:w,windowsVerbatimArguments:!0};u.spawn(T.CMD,h,L).on("error",B=>{l(m(B))}),s(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class _ extends E{openTerminal(c,v){return this.spawnTerminal(u,c,v)}runInTerminal(c,v,a,d,o){const i=o.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{if(i===A.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const n=i===A.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`,J).fsPath,"-t",c||k,"-w",v];for(const M of a)h.push("-a"),h.push(M);if(d){const M=Object.assign({},p(process),d);for(const B in M){const R=M[B];R===null?(h.push("-u"),h.push(B)):(h.push("-e"),h.push(`${B}=${R}`))}}let w="";const L=u.spawn(_.OSASCRIPT,h);L.on("error",M=>{l(m(M))}),L.stderr.on("data",M=>{w+=M.toString()}),L.on("exit",M=>{if(M===0)s(void 0);else if(w){const B=w.split(`
`,1);l(new Error(B[0]))}else l(new Error(D.localize(1,null,n,M)))})}else l(new Error(D.localize(2,null,i)))})}spawnTerminal(c,v,a){const d=v.osxExec||A.DEFAULT_TERMINAL_OSX;return new Promise((o,i)=>{const s=["-a",d];a&&s.push(a);const l=p(process),n=c.spawn("/usr/bin/open",s,{cwd:a,env:l});n.on("error",i),n.on("exit",()=>o())})}}e.MacExternalTerminalService=_,_.OSASCRIPT="/usr/bin/osascript";class g extends E{openTerminal(c,v){return this.spawnTerminal(u,c,v)}runInTerminal(c,v,a,d,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{const n=[];i.then(r=>{r.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const h=`${b(a)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;n.push(`''${h}''`);const w=Object.assign({},p(process),d);Object.keys(w).filter(R=>w[R]===null).forEach(R=>delete w[R]);const L={cwd:v,env:w};let M="";const B=u.spawn(r,n,L);B.on("error",R=>{l(m(R))}),B.stderr.on("data",R=>{M+=R.toString()}),B.on("exit",R=>{if(R===0)s(void 0);else if(M){const z=M.split(`
`,1);l(new Error(z[0]))}else l(new Error(D.localize(4,null,r,R)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await I.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{c?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,v,a){const d=v.linuxExec?Promise.resolve(v.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{d.then(s=>{const l=p(process),n=c.spawn(s,[],{cwd:a,env:l});n.on("error",i),n.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=D.localize(3,null);function p(f){const c={...f.env};return(0,y.sanitizeProcessEnvironment)(c),c}function m(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(D.localize(5,null,f.path)):f}function b(f){let c="";for(const v of f)v.indexOf(" ")>=0?c+='"'+v+'"':c+=v,c+=" ";return c}}),define(De[38],Ie([1,0,26,9,8,12,2,167,4]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function D(U){return U.create===!0}e.isFileOpenForWriteOptions=D;var A;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var k;(function(U){U[U.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var E;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=T;function _(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=_;function g(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=g;function p(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function m(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=m;function b(U){return T(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var f;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(F,x){super(F),this.code=x}}e.FileSystemProviderError=c;function v(U,F){const x=new c(U.toString(),F);return d(x,F),x}e.createFileSystemProviderError=v;function a(U){return U||v((0,I.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=a;function d(U,F){return U.name=F?`${F} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=d;function o(U){if(!U)return f.Unknown;if(U instanceof c)return U.code;const F=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!F)return f.Unknown;switch(F[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=o;function i(U){if(U instanceof w)return U.fileOperationResult;switch(o(U)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(F,x,$){this.resource=F,this.operation=x,this.target=$}isOperation(F){return this.operation===F}}e.FileOperationEvent=l;var n;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class r{constructor(F,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=F;const $=new Map;for(const Q of F){const K=$.get(Q.type);switch(K?K.push([Q.resource,Q]):$.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of $)switch(Q){case 1:this.added=u.TernarySearchTree.forUris(()=>x),this.added.fill(K);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>x),this.updated.fill(K);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>x),this.deleted.fill(K);break}}contains(F,...x){return this.doContains(F,{includeChildren:!1},...x)}affects(F,...x){return this.doContains(F,{includeChildren:!0},...x)}doContains(F,x,...$){if(!F)return!1;const Q=$.length>0;return!!((!Q||$.includes(1))&&(this.added?.get(F)||x.includeChildren&&this.added?.findSuperstr(F))||(!Q||$.includes(0))&&(this.updated?.get(F)||x.includeChildren&&this.updated?.findSuperstr(F))||(!Q||$.includes(2))&&(this.deleted?.findSubstr(F)||x.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=r;function h(U,F,x){return!U||!F||U===F||F.length>U.length?!1:(F.charAt(F.length-1)!==t.sep&&(F+=t.sep),x?(0,C.startsWithIgnoreCase)(U,F):U.indexOf(F)===0)}e.isParent=h;class w extends Error{constructor(F,x,$){super(F),this.fileOperationResult=x,this.options=$}}e.FileOperationError=w;class L extends w{constructor(F,x,$){super(F,2,$),this.stat=x}}e.NotModifiedSinceFileOperationError=L;var M;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=R;async function z(U,F){if(!F.hasProvider(y.URI.from({scheme:U.scheme})))return new Promise(x=>{const $=F.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===U.scheme&&Q.added&&($.dispose(),x())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(F){return(0,P.isNumber)(F)||(F=0),F<H.KB?(0,I.localize)(1,null,F.toFixed(0)):F<H.MB?(0,I.localize)(2,null,(F/H.KB).toFixed(2)):F<H.GB?(0,I.localize)(3,null,(F/H.MB).toFixed(2)):F<H.TB?(0,I.localize)(4,null,(F/H.GB).toFixed(2)):(0,I.localize)(5,null,(F/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var N;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function V(U){return{maxFileSize:U===0?300*H.MB:16*H.GB,maxHeapSize:U===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=V}),define(De[84],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...C){this._entries=new Map;for(const[P,y]of C)this.set(P,y)}set(C,P){const y=this._entries.get(C);return this._entries.set(C,P),y}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=u}),define(De[193],Ie([1,0,18,11,6,119,189,4,84,62]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class k extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class E{constructor(p=new S.ServiceCollection,m=!1,b,f=A){this._services=p,this._strict=m,this._parent=b,this._enableTracing=f,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=f?b?._globalGraph??new y.Graph(c=>c):void 0}createChild(p){return new E(p,this._strict,this,this._enableTracing)}invokeFunction(p,...m){const b=_.traceInvocation(this._enableTracing,p);let f=!1;try{return p({get:v=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(v,b);if(!a)throw new Error(`[invokeFunction] unknown service '${v}'`);return a}},...m)}finally{f=!0,b.stop()}}createInstance(p,...m){let b,f;return p instanceof P.SyncDescriptor?(b=_.traceCreation(this._enableTracing,p.ctor),f=this._createInstance(p.ctor,p.staticArguments.concat(m),b)):(b=_.traceCreation(this._enableTracing,p),f=this._createInstance(p,m,b)),b.stop(),f}_createInstance(p,m=[],b){const f=I._util.getServiceDependencies(p).sort((a,d)=>a.index-d.index),c=[];for(const a of f){const d=this._getOrCreateServiceInstance(a.id,b);d||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${a.id}.`,!1),c.push(d)}const v=f.length>0?f[0].index:m.length;if(m.length!==v){console.trace(`[createInstance] First service dependency of ${p.name} at position ${v+1} conflicts with ${m.length} static arguments`);const a=v-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,v)}return Reflect.construct(p,m.concat(c))}_setServiceInstance(p,m){if(this._services.get(p)instanceof P.SyncDescriptor)this._services.set(p,m);else if(this._parent)this._parent._setServiceInstance(p,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const m=this._services.get(p);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):m}_getOrCreateServiceInstance(p,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const b=this._getServiceInstanceOrDescriptor(p);return b instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,b,m.branch(p,!0)):(m.branch(p,!1),b)}_safeCreateAndCacheServiceInstance(p,m,b){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,m,b)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,m,b){const f=new y.Graph(a=>a.id.toString());let c=0;const v=[{id:p,desc:m,_trace:b}];for(;v.length;){const a=v.pop();if(f.lookupOrInsertNode(a),c++>1e3)throw new k(f);for(const d of I._util.getServiceDependencies(a.desc.ctor)){const o=this._getServiceInstanceOrDescriptor(d.id);if(o||this._throwIfStrict(`[createInstance] ${p} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(a.id),String(d.id)),o instanceof P.SyncDescriptor){const i={id:d.id,desc:o,_trace:a._trace.branch(d.id,!0)};f.insertEdge(a,i),v.push(i)}}}for(;;){const a=f.roots();if(a.length===0){if(!f.isEmpty())throw new k(f);break}for(const{data:d}of a){if(this._getServiceInstanceOrDescriptor(d.id)instanceof P.SyncDescriptor){const i=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,i)}f.removeNode(d)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,m,b=[],f,c){if(this._services.get(p)instanceof P.SyncDescriptor)return this._createServiceInstance(p,m,b,f,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,m,b,f,c);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(p,m,b=[],f,c){if(f){const v=new E(void 0,this._strict,this,this._enableTracing);v._globalGraphImplicitDependency=String(p);const a=new Map,d=new u.IdleValue(()=>{const o=v._createInstance(m,b,c);for(const[i,s]of a){const l=o[i];if(typeof l=="function")for(const n of s)l.apply(o,n)}return a.clear(),o});return new Proxy(Object.create(null),{get(o,i){if(!d.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let n=a.get(i);return n||(n=new D.LinkedList,a.set(i,n)),(h,w,L)=>{const M=n.push([h,w,L]);return(0,C.toDisposable)(M)}}if(i in o)return o[i];const s=d.value;let l=s[i];return typeof l!="function"||(l=l.bind(s),o[i]=l),l},set(o,i,s){return d.value[i]=s,!0}})}else return this._createInstance(m,b,c)}_throwIfStrict(p,m){if(m&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=E;var T;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(T||(T={}));class _{static traceInvocation(p,m){return p?new _(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):_._None}static traceCreation(p,m){return p?new _(0,m.name):_._None}constructor(p,m){this.type=p,this.name=m,this._start=Date.now(),this._dep=[]}branch(p,m){const b=new _(2,p.toString());return this._dep.push([p,m,b]),b}stop(){const p=Date.now()-this._start;_._totals+=p;let m=!1;function b(c,v){const a=[],d=new Array(c+1).join("	");for(const[o,i,s]of v._dep)if(i&&s){m=!0,a.push(`${d}CREATES -> ${o}`);const l=b(c+1,s);l&&a.push(l)}else a.push(`${d}uses -> ${o}`);return a.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(p>2||m)&&_.all.add(f.join(`
`))}}e.Trace=_,_.all=new Set,_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(De[13],Ie([1,0,50,3,6,26,10,2,4]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function D(){return new Date().toISOString()}var A;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(A=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=A.Info;function k(l,n,r){switch(n){case A.Trace:l.trace(r);break;case A.Debug:l.debug(r);break;case A.Info:l.info(r);break;case A.Warning:l.warn(r);break;case A.Error:l.error(r);break;case A.Critical:l.critical(r);break;default:throw new Error("Invalid log level")}}e.log=k;function E(l){let n="";for(let r=0;r<l.length;r++){let h=l[r];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}n+=(r>0?" ":"")+h}return n}e.format=E;class T extends C.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class _ extends T{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(A.Trace)&&this.log(A.Trace,E([n,...r]))}debug(n,...r){this.checkLogLevel(A.Debug)&&this.log(A.Debug,E([n,...r]))}info(n,...r){this.checkLogLevel(A.Info)&&this.log(A.Info,E([n,...r]))}warn(n,...r){this.checkLogLevel(A.Warning)&&this.log(A.Warning,E([n,...r]))}error(n,...r){if(this.checkLogLevel(A.Error))if(n instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=n.stack,this.log(A.Error,E(h))}else this.log(A.Error,E([n,...r]))}critical(n,...r){this.checkLogLevel(A.Critical)&&this.log(A.Critical,E([n,...r]))}flush(){}}e.AbstractMessageLogger=_;class g extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!y.isWindows}trace(n,...r){this.getLevel()<=A.Trace&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}debug(n,...r){this.getLevel()<=A.Debug&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}info(n,...r){this.getLevel()<=A.Info&&(this.useColors?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}warn(n,...r){this.getLevel()<=A.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,n,...r):console.warn(`[main ${D()}]`,n,...r))}error(n,...r){this.getLevel()<=A.Error&&(this.useColors?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,n,...r):console.error(`[main ${D()}]`,n,...r))}critical(n,...r){this.getLevel()<=A.Critical&&(this.useColors?console.error(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.error(`[main ${D()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class p extends T{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.getLevel()<=A.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=A.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=A.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=A.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=A.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=A.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=p;class m extends T{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=A.Trace&&this.adapter.log(A.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=A.Debug&&this.adapter.log(A.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=A.Info&&this.adapter.log(A.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=A.Warning&&this.adapter.log(A.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=A.Error&&this.adapter.log(A.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=A.Critical&&this.adapter.log(A.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,u.toErrorMessage)(n,this.getLevel()<=A.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class b extends T{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const h of this.logServices)h.trace(n,...r)}debug(n,...r){for(const h of this.logServices)h.debug(n,...r)}info(n,...r){for(const h of this.logServices)h.info(n,...r)}warn(n,...r){for(const h of this.logServices)h.warn(n,...r)}error(n,...r){for(const h of this.logServices)h.error(n,...r)}critical(n,...r){for(const h of this.logServices)h.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=b;class f extends C.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}e.LogService=f;class c extends C.Disposable{constructor(n,r){super(),this.logLevel=n,this.loggerItems=new P.ResourceMap,this._register(r(h=>this.setLevel(h)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:n})=>n)}getLogger(n){return this.loggerItems.get(n)?.logger}createLogger(n,r,h){let w=this.loggerItems.get(n)?.logger;return w||(h=r?.always?A.Trace:h,w=this.doCreateLogger(n,h??this.logLevel,r),this.loggerItems.set(n,{logger:w,logLevel:h})),w}setLevel(n,r){const h=I.URI.isUri(n)?n:void 0,w=h?r:n;if(h){const L=this.loggerItems.get(h);L&&L.logLevel!==w&&(L.logLevel=w,L.logger.setLevel(w))}else this.logLevel=w,this.loggerItems.forEach(({logLevel:L,logger:M})=>{L===void 0&&M.setLevel(this.logLevel)})}getLogLevel(n){return this.loggerItems.get(n)?.logLevel}dispose(){this.loggerItems.forEach(({logger:n})=>n.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=c;class v{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return A.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogger=v;class a extends v{}e.NullLogService=a;class d extends c{constructor(){super(A.Info,t.Event.None)}doCreateLogger(n,r,h){return new v}}e.NullLoggerService=d;function o(l){if(l.verbose)return A.Trace;if(typeof l.logLevel=="string"){const n=i(l.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function i(l){switch(l){case"trace":return A.Trace;case"debug":return A.Debug;case"info":return A.Info;case"warn":return A.Warning;case"error":return A.Error;case"critical":return A.Critical;case"off":return A.Off}}e.parseLogLevel=i;function s(l){switch(l){case A.Trace:return"trace";case A.Debug:return"debug";case A.Info:return"info";case A.Warning:return"warn";case A.Error:return"error";case A.Critical:return"critical";case A.Off:return"off"}}e.LogLevelToString=s}),define(De[194],Ie([1,0,38,13]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function C(I,S,D,A,k){try{const E=await new Promise((_,g)=>{J(["spdlog"],_,g)});E.setFlushOn(t.LogLevel.Trace);const T=await E.createAsyncRotatingLogger(I,S,D,A);return k?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(E){console.error(E)}return null}function P(I,S,D){switch(S){case t.LogLevel.Trace:I.trace(D);break;case t.LogLevel.Debug:I.debug(D);break;case t.LogLevel.Info:I.info(D);break;case t.LogLevel.Warning:I.warn(D);break;case t.LogLevel.Error:I.error(D);break;case t.LogLevel.Critical:I.critical(D);break;default:throw new Error("Invalid log level")}}class y extends t.AbstractMessageLogger{constructor(S,D,A,k,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(S,D,A,k),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(S,D,A,k){const E=A?6:1,T=30/E*u.ByteSize.MB,_=await C(S,D,T,E,k);if(_){this._logger=_,this._logger.setLevel(this.getLevel());for(const{level:g,message:p}of this.buffer)P(this._logger,g,p);this.buffer=[]}}log(S,D){this._logger?P(this._logger,S,D):this.getLevel()<=S&&this.buffer.push({level:S,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(De[121],Ie([1,0,42,168,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function D(_,g){return g-_}S.compare=D;const A=Object.create(null);A[S.Error]=(0,t.localize)(0,null),A[S.Warning]=(0,t.localize)(1,null),A[S.Info]=(0,t.localize)(2,null);function k(_){return A[_]||""}S.toString=k;function E(_){switch(_){case u.default.Error:return S.Error;case u.default.Warning:return S.Warning;case u.default.Info:return S.Info;case u.default.Ignore:return S.Hint}}S.fromSeverity=E;function T(_){switch(_){case S.Error:return u.default.Error;case S.Warning:return u.default.Warning;case S.Info:return u.default.Info;case S.Hint:return u.default.Ignore}}S.toSeverity=T}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(S){const D="";function A(E){return k(E,!0)}S.makeKey=A;function k(E,T){const _=[D];return E.source?_.push(E.source.replace("\xA6","\\\xA6")):_.push(D),E.code?typeof E.code=="string"?_.push(E.code.replace("\xA6","\\\xA6")):_.push(E.code.value.replace("\xA6","\\\xA6")):_.push(D),E.severity!==void 0&&E.severity!==null?_.push(y.toString(E.severity)):_.push(D),E.message&&T?_.push(E.message.replace("\xA6","\\\xA6")):_.push(D),E.startLineNumber!==void 0&&E.startLineNumber!==null?_.push(E.startLineNumber.toString()):_.push(D),E.startColumn!==void 0&&E.startColumn!==null?_.push(E.startColumn.toString()):_.push(D),E.endLineNumber!==void 0&&E.endLineNumber!==null?_.push(E.endLineNumber.toString()):_.push(D),E.endColumn!==void 0&&E.endColumn!==null?_.push(E.endColumn.toString()):_.push(D),_.push(D),_.join("\xA6")}S.makeKeyOptionalMessage=k})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(De[195],Ie([1,0,3,42,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,C.createDecorator)("notificationService");var P;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new S,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=I;class S{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=S}),define(De[122],Ie([1,0,6,8,2,4]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(A){return{resolved:A,dispose(){}}}});function y(A,k){return C.URI.isUri(A)?(0,t.equalsIgnoreCase)(A.scheme,k):(0,t.startsWithIgnoreCase)(A,k+":")}e.matchesScheme=y;function I(A,...k){return k.some(E=>y(A,E))}e.matchesSomeScheme=I;function S(A,k){return A.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=S;function D(A){let k;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(A.fragment);return E&&(k={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},A=A.with({fragment:""})),{selection:k,uri:A}}e.extractSelection=D}),define(De[196],Ie([1,0,14,10,36,22]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const I=t.globals.vscode.context.configuration();if(I)y=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const I=(0,P.dirname)(u.FileAccess.asFileUri("",J));if(y=J.__$__nodeRequire((0,P.joinPath)(I,"product.json").fsPath),C.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),!y.version){const S=J.__$__nodeRequire((0,P.joinPath)(I,"package.json").fsPath);Object.assign(y,{version:S.version})}}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(De[197],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(J,e){return function(u,t){e(u,t,J)}};define(De[123],Ie([1,0,18,21,6,4]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{get value(){return this._value}constructor(k){this.callback=k}report(k){this._value=k,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let S=class extends C.Disposable{constructor(k,E){super(),this.deferred=new u.DeferredPromise,E.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=je([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class D extends C.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const E=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:T.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,12]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(y,I){u.ok(t.isString(y)),u.ok(t.isObject(I)),u.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,I)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new C}),define(De[124],Ie([1,0,3,43]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,D){this.schemasById[C(S)]=D,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(De[125],Ie([1,0,17,3,12,163,65,124,43]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=S.Registry.as(I.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,d=!0){this.registerConfigurations([a],d)}registerConfigurations(a,d=!0){const o=this.doRegisterConfigurations(a,d);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(a){const d=this.doDeregisterConfigurations(a);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:a,remove:d}){const o=[];o.push(...this.doDeregisterConfigurations(d)),o.push(...this.doRegisterConfigurations(a,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(o)})}registerDefaultConfigurations(a){const d=[],o=[];for(const{overrides:i,source:s}of a)for(const l in i)if(d.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const n=this.configurationDefaultsOverrides.get(l),r=n?.valuesSources??new Map;if(s)for(const M of Object.keys(i[l]))r.set(M,s);const h={...n?.value||{},...i[l]};this.configurationDefaultsOverrides.set(l,{source:s,value:h,valuesSources:r});const w=(0,y.getLanguageTagSettingPlainKey)(l),L={type:"object",default:h,description:P.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:C.isString(s)?void 0:s,defaultValueSource:s};o.push(...g(l)),this.configurationProperties[l]=L,this.defaultLanguageConfigurationOverridesNode.properties[l]=L}else{this.configurationDefaultsOverrides.set(l,{value:i[l],source:s});const n=this.configurationProperties[l];n&&(this.updatePropertyDefaultValue(l,n),this.updateSchema(l,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const d=[];for(const{overrides:o,source:i}of a)for(const s in o){const l=this.configurationDefaultsOverrides.get(s),n=C.isString(i)?i:i?.id,r=C.isString(l?.source)?l?.source:l?.source?.id;if(n===r)if(d.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const h=this.configurationProperties[s];h&&(this.updatePropertyDefaultValue(s,h),this.updateSchema(s,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const d of a)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,d){const o=[];return a.forEach(i=>{o.push(...this.validateAndRegisterProperties(i,d,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),o}doDeregisterConfigurations(a){const d=[],o=i=>{if(i.properties)for(const s in i.properties){d.push(s);const l=this.configurationProperties[s];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>o(s))};for(const i of a){o(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return d}validateAndRegisterProperties(a,d=!0,o,i,s=3){s=C.isUndefinedOrNull(a.scope)?s:a.scope;const l=[],n=a.properties;if(n)for(const h in n){const w=n[h];if(d&&f(h,w)){delete n[h];continue}if(w.source=o,w.defaultDefaultValue=n[h].default,this.updatePropertyDefaultValue(h,w),e.OVERRIDE_PROPERTY_REGEX.test(h)?w.scope=void 0:(w.scope=C.isUndefinedOrNull(w.scope)?s:w.scope,w.restricted=C.isUndefinedOrNull(w.restricted)?!!i?.includes(h):w.restricted),n[h].hasOwnProperty("included")&&!n[h].included){this.excludedConfigurationProperties[h]=n[h],delete n[h];continue}else this.configurationProperties[h]=n[h],n[h].policy?.name&&this.policyConfigurations.set(n[h].policy.name,h);!n[h].deprecationMessage&&n[h].markdownDeprecationMessage&&(n[h].deprecationMessage=n[h].markdownDeprecationMessage),l.push(h)}const r=a.allOf;if(r)for(const h of r)l.push(...this.validateAndRegisterProperties(h,d,o,i,s));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const d=o=>{const i=o.properties;if(i)for(const l in i)this.updateSchema(l,i[l]);o.allOf?.forEach(d)};d(a)}updateSchema(a,d){switch(e.allSettings.properties[a]=d,d.scope){case 1:e.applicationSettings.properties[a]=d;break;case 2:e.machineSettings.properties[a]=d;break;case 6:e.machineOverridableSettings.properties[a]=d;break;case 3:e.windowSettings.properties[a]=d;break;case 4:e.resourceSettings.properties[a]=d;break;case 5:e.resourceSettings.properties[a]=d,this.resourceLanguageSettingsSchema.properties[a]=d;break}}removeFromSchema(a,d){switch(delete e.allSettings.properties[a],d.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const d=`[${a}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,o),e.allSettings.properties[d]=o,e.applicationSettings.properties[d]=o,e.machineSettings.properties[d]=o,e.machineOverridableSettings.properties[d]=o,e.windowSettings.properties[d]=o,e.resourceSettings.properties[d]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,d){const o=this.configurationDefaultsOverrides.get(a);let i=o?.value,s=o?.source;C.isUndefined(i)&&(i=d.defaultDefaultValue,s=void 0),C.isUndefined(i)&&(i=m(d.type)),d.default=i,d.defaultValueSource=s}}const T="\\[([^\\]]+)\\]",_=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(v){const a=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let d=_.exec(v);for(;d?.length;){const o=d[1].trim();o&&a.push(o),d=_.exec(v)}}return(0,u.distinct)(a)}e.overrideIdentifiersFromKey=g;function p(v){return v.reduce((a,d)=>`${a}[${d}]`,"")}e.keyFromOverrideIdentifiers=p;function m(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const b=new E;S.Registry.add(e.Extensions.Configuration,b);function f(v,a){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?P.localize(7,null,v):b.getConfigurationProperties()[v]!==void 0?P.localize(8,null,v):a.policy?.name&&b.getPolicyConfigurations().get(a.policy?.name)!==void 0?P.localize(9,null,v,a.policy?.name,b.getPolicyConfigurations().get(a.policy?.name)):null:P.localize(6,null)}e.validateProperty=f;function c(){const v=[],a=b.getConfigurationProperties();for(const d of Object.keys(a))v.push([d,a[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=c}),define(De[198],Ie([1,0,17,3,143,6,26,24,12,2,65,125,43]),function(J,e,u,t,C,P,y,I,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(d={},o=[],i=[],s){this._contents=d,this._keys=o,this._overrides=i,this.raw=s,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const d=this.raw.map(o=>{if(o instanceof T)return o;const i=new _("");return i.parseRaw(o),i.configurationModel});this._rawConfiguration=d.reduce((o,i)=>i===o?i:o.merge(i),d[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(d){return d?(0,A.getConfigurationValue)(this.contents,d):this.contents}inspect(d,o){const i=this.rawConfiguration.getValue(d),s=o?this.rawConfiguration.getOverrideValue(d,o):void 0,l=o?this.rawConfiguration.override(o).getValue(d):i;return{value:i,override:s,merged:l}}getOverrideValue(d,o){const i=this.getContentsForOverrideIdentifer(o);return i?d?(0,A.getConfigurationValue)(i,d):i:void 0}getKeysForOverrideIdentifier(d){const o=[];for(const i of this.overrides)i.identifiers.includes(d)&&o.push(...i.keys);return u.distinct(o)}getAllOverrideIdentifiers(){const d=[];for(const o of this.overrides)d.push(...o.identifiers);return u.distinct(d)}override(d){let o=this.overrideConfigurations.get(d);return o||(o=this.createOverrideConfigurationModel(d),this.overrideConfigurations.set(d,o)),o}merge(...d){const o=I.deepClone(this.contents),i=I.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const n of d)if(l.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.mergeContents(o,n.contents);for(const r of n.overrides){const[h]=i.filter(w=>u.equals(w.identifiers,r.identifiers));h?(this.mergeContents(h.contents,r.contents),h.keys.push(...r.keys),h.keys=u.distinct(h.keys)):i.push(I.deepClone(r))}for(const r of n.keys)s.indexOf(r)===-1&&s.push(r)}return new T(o,s,i,l.every(n=>n instanceof T)?void 0:l)}freeze(){return this.frozen=!0,this}clone(){return new T(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(d){const o=this.getContentsForOverrideIdentifer(d);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const i={};for(const s of u.distinct([...Object.keys(this.contents),...Object.keys(o)])){let l=this.contents[s];const n=o[s];n&&(typeof l=="object"&&typeof n=="object"?(l=I.deepClone(l),this.mergeContents(l,n)):l=n),i[s]=l}return new T(i,this.keys,this.overrides)}mergeContents(d,o){for(const i of Object.keys(o)){if(i in d&&S.isObject(d[i])&&S.isObject(o[i])){this.mergeContents(d[i],o[i]);continue}d[i]=I.deepClone(o[i])}}checkAndFreeze(d){return this.frozen&&!Object.isFrozen(d)?I.deepFreeze(d):d}getContentsForOverrideIdentifer(d){let o=null,i=null;const s=l=>{l&&(i?this.mergeContents(i,l):i=I.deepClone(l))};for(const l of this.overrides)u.equals(l.identifiers,[d])?o=l.contents:l.identifiers.includes(d)&&s(l.contents);return s(o),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(d,o){this.addKey(d),(0,A.addToValueTree)(this.contents,d,o,i=>{throw new Error(i)})}removeValue(d){this.removeKey(d)&&(0,A.removeFromValueTree)(this.contents,d)}addKey(d){let o=this.keys.length;for(let i=0;i<o;i++)d.indexOf(this.keys[i])===0&&(o=i);this.keys.splice(o,1,d)}removeKey(d){const o=this.keys.indexOf(d);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=T;class _{constructor(d){this._name=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(d,o){if(!S.isUndefinedOrNull(d)){const i=this.doParseContent(d);this.parseRaw(i,o)}}reparse(d){this._raw&&this.parseRaw(this._raw,d)}parseRaw(d,o){this._raw=d;const{contents:i,keys:s,overrides:l,restricted:n,hasExcludedProperties:r}=this.doParseRaw(d,o);this._configurationModel=new T(i,s,l,r?[d]:void 0),this._restrictedConfigurations=n||[]}doParseContent(d){let o={},i=null,s=[];const l=[],n=[];function r(w){Array.isArray(s)?s.push(w):i!==null&&(s[i]=w)}const h={onObjectBegin:()=>{const w={};r(w),l.push(s),s=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const w=[];r(w),l.push(s),s=w,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:r,onError:(w,L,M)=>{n.push({error:w,offset:L,length:M})}};if(d)try{C.visit(d,h),o=s[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return o}doParseRaw(d,o){const i=E.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),s=this.filter(d,i,!0,o);d=s.raw;const l=(0,A.toValuesTree)(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),n=Object.keys(d),r=this.toOverrides(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:l,keys:n,overrides:r,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(d,o,i,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:d,restricted:[],hasExcludedProperties:l};const n={},r=[];for(const h in d)if(k.OVERRIDE_PROPERTY_REGEX.test(h)&&i){const w=this.filter(d[h],o,!1,s);n[h]=w.raw,l=l||w.hasExcludedProperties,r.push(...w.restricted)}else{const w=o[h],L=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&r.push(h),(L===void 0||s.scopes===void 0||s.scopes.includes(L))&&!(s.skipRestricted&&w?.restricted)?n[h]=d[h]:l=!0}return{raw:n,restricted:r,hasExcludedProperties:l}}toOverrides(d,o){const i=[];for(const s of Object.keys(d))if(k.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const n in d[s])l[n]=d[s][n];i.push({identifiers:(0,k.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,A.toValuesTree)(l,o)})}return i}}e.ConfigurationModelParser=_;class g extends P.Disposable{constructor(d,o,i,s){super(),this.userSettingsResource=d,this.scopes=o,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new _(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&i.isEqual(l.resource,d)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const d=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(d.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class p{constructor(d,o,i,s,l,n,r,h,w,L,M,B,R){this.key=d,this.overrides=o,this.value=i,this.overrideIdentifiers=s,this.defaultConfiguration=l,this.policyConfiguration=n,this.applicationConfiguration=r,this.userConfiguration=h,this.localUserConfiguration=w,this.remoteUserConfiguration=L,this.workspaceConfiguration=M,this.folderConfigurationModel=B,this.memoryInspectValue=R}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class m{constructor(d,o,i,s,l=new T,n=new T,r=new y.ResourceMap,h=new T,w=new y.ResourceMap,L=!0){this._defaultConfiguration=d,this._policyConfiguration=o,this._applicationConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=l,this._workspaceConfiguration=n,this._folderConfigurations=r,this._memoryConfiguration=h,this._memoryConfigurationByResource=w,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(d,o,i){return this.getConsolidatedConfigurationModel(d,o,i).getValue(d)}updateValue(d,o,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new T,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,o===void 0?s.removeValue(d):s.setValue(d,o),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(d,o,i){const s=this.getConsolidatedConfigurationModel(d,o,i),l=u.distinct(s.overrides.map(h=>h.identifiers).flat()).filter(h=>s.getOverrideValue(d,h)!==void 0),n=this.getFolderConfigurationModelForResource(o.resource,i),r=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration;return new p(d,o,s.getValue(d),l.length?l:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),i?this._workspaceConfiguration.freeze():void 0,n?n.freeze():void 0,r.inspect(d,o.overrideIdentifier))}keys(d){const o=this.getFolderConfigurationModelForResource(void 0,d);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(d){this._defaultConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(d){this._policyConfiguration=d}updateApplicationConfiguration(d){this._applicationConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(d){this._localUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(d){this._remoteUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(d){this._workspaceConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(d,o){this._folderConfigurations.set(d,o),this._foldersConsolidatedConfigurations.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this._foldersConsolidatedConfigurations.delete(d)}compareAndUpdateDefaultConfiguration(d,o){const i=[];if(!o){const{added:s,updated:l,removed:n}=c(this._defaultConfiguration,d);o=[...s,...l,...n]}for(const s of o)for(const l of(0,k.overrideIdentifiersFromKey)(s)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(l),r=d.getKeysForOverrideIdentifier(l),h=[...r.filter(w=>n.indexOf(w)===-1),...n.filter(w=>r.indexOf(w)===-1),...n.filter(w=>!I.equals(this._defaultConfiguration.override(l).getValue(w),d.override(l).getValue(w)))];i.push([l,h])}return this.updateDefaultConfiguration(d),{keys:o,overrides:i}}compareAndUpdatePolicyConfiguration(d){const{added:o,updated:i,removed:s}=c(this._policyConfiguration,d),l=[...o,...i,...s];return l.length&&this.updatePolicyConfiguration(d),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:o,updated:i,removed:s,overrides:l}=c(this.applicationConfiguration,d),n=[...o,...i,...s];return n.length&&this.updateApplicationConfiguration(d),{keys:n,overrides:l}}compareAndUpdateLocalUserConfiguration(d){const{added:o,updated:i,removed:s,overrides:l}=c(this.localUserConfiguration,d),n=[...o,...i,...s];return n.length&&this.updateLocalUserConfiguration(d),{keys:n,overrides:l}}compareAndUpdateRemoteUserConfiguration(d){const{added:o,updated:i,removed:s,overrides:l}=c(this.remoteUserConfiguration,d),n=[...o,...i,...s];return n.length&&this.updateRemoteUserConfiguration(d),{keys:n,overrides:l}}compareAndUpdateWorkspaceConfiguration(d){const{added:o,updated:i,removed:s,overrides:l}=c(this.workspaceConfiguration,d),n=[...o,...i,...s];return n.length&&this.updateWorkspaceConfiguration(d),{keys:n,overrides:l}}compareAndUpdateFolderConfiguration(d,o){const i=this.folderConfigurations.get(d),{added:s,updated:l,removed:n,overrides:r}=c(i,o),h=[...s,...l,...n];return(h.length||!i)&&this.updateFolderConfiguration(d,o),{keys:h,overrides:r}}compareAndDeleteFolderConfiguration(d){const o=this.folderConfigurations.get(d);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:i,updated:s,removed:l,overrides:n}=c(o,void 0);return{keys:[...i,...s,...l],overrides:n}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(d,o,i){let s=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier&&(s=s.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(d)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:d},o){let i=this.getWorkspaceConsolidatedConfiguration();if(o&&d){const s=o.getFolder(d);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const l=this._memoryConfigurationByResource.get(d);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(d){let o=this._foldersConsolidatedConfigurations.get(d);if(!o){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(d);s?(o=i.merge(s),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(d,o)):o=i}return o}getFolderConfigurationModelForResource(d,o){if(o&&d){const i=o.getFolder(d);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((d,o)=>{const{contents:i,overrides:s,keys:l}=this._folderConfigurations.get(o);return d.push([o,{contents:i,overrides:s,keys:l}]),d},[])}}allKeys(){const d=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>d.add(o)),this.userConfiguration.freeze().keys.forEach(o=>d.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>d.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(i=>d.add(i))),[...d.values()]}allOverrideIdentifiers(){const d=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>d.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>d.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>d.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(i=>d.add(i))),[...d.values()]}getAllKeysForOverrideIdentifier(d){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(d).forEach(i=>o.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(i=>o.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(d).forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(d).forEach(s=>o.add(s))),[...o.values()]}static parse(d){const o=this.parseConfigurationModel(d.defaults),i=this.parseConfigurationModel(d.policy),s=this.parseConfigurationModel(d.application),l=this.parseConfigurationModel(d.user),n=this.parseConfigurationModel(d.workspace),r=d.folders.reduce((h,w)=>(h.set(D.URI.revive(w[0]),this.parseConfigurationModel(w[1])),h),new y.ResourceMap);return new m(o,i,s,l,new T,n,r,new T,new y.ResourceMap,!1)}static parseConfigurationModel(d){return new T(d.contents,d.keys,d.overrides).freeze()}}e.Configuration=m;function b(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const d=new Set,o=new Map;for(const s of a)s.keys.forEach(l=>d.add(l)),s.overrides.forEach(([l,n])=>{const r=(0,y.getOrSet)(o,l,new Set);n.forEach(h=>r.add(h))});const i=[];return o.forEach((s,l)=>i.push([l,[...s.values()]])),{keys:[...d.values()],overrides:i}}e.mergeChanges=b;class f{constructor(d,o,i,s){this.change=d,this.previous=o,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;d.keys.forEach(r=>l.add(r)),d.overrides.forEach(([,r])=>r.forEach(h=>l.add(h))),this.affectedKeys=[...l.values()];const n=new T;this.affectedKeys.forEach(r=>n.setValue(r,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(d,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,d)){if(o){const i=this.previousConfiguration?this.previousConfiguration.getValue(d,o,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(d,o,this.currentWorkspace);return!I.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(d,o){let i=(0,A.toValuesTree)({[o]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(d=d[s],!d)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=f;function c(a,d){const{added:o,removed:i,updated:s}=v(d?.rawConfiguration,a?.rawConfiguration),l=[],n=a?.getAllOverrideIdentifiers()||[],r=d?.getAllOverrideIdentifiers()||[];if(d){const h=r.filter(w=>!n.includes(w));for(const w of h)l.push([w,d.getKeysForOverrideIdentifier(w)])}if(a){const h=n.filter(w=>!r.includes(w));for(const w of h)l.push([w,a.getKeysForOverrideIdentifier(w)])}if(d&&a){for(const h of n)if(r.includes(h)){const w=v({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:d.getOverrideValue(void 0,h)||{},keys:d.getKeysForOverrideIdentifier(h)});l.push([h,[...w.added,...w.removed,...w.updated]])}}return{added:o,removed:i,updated:s,overrides:l}}function v(a,d){const o=a?d?a.keys.filter(l=>d.keys.indexOf(l)===-1):[...a.keys]:[],i=d?a?d.keys.filter(l=>a.keys.indexOf(l)===-1):[...d.keys]:[],s=[];if(a&&d){for(const l of d.keys)if(a.keys.indexOf(l)!==-1){const n=(0,A.getConfigurationValue)(d.contents,l),r=(0,A.getConfigurationValue)(a.contents,l);I.equals(n,r)||s.push(l)}}return{added:o,removed:i,updated:s}}}),define(De[126],Ie([1,0,11,4]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends u.ErrorNoTelemetry{static isTemporarilyNotAvailable(I){return I instanceof P&&I._code===C.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof P&&I._code===C.NoResolverFound}static isHandled(I){return I instanceof P&&I.isHandled}constructor(I,S=C.Unknown,D){super(I),this._message=I,this._code=S,this._detail=D,this.isHandled=S===C.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(De[85],Ie([1,0,14]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===u.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function C(D){if(!D)return;const A=D.indexOf("+");return A<0?D:D.substr(0,A)}e.getRemoteName=C;function P(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(D){const{host:A,port:k}=S(D);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.parseAuthorityWithPort=y;function I(D,A){let{host:k,port:E}=S(D);return typeof E>"u"&&(E=A),{host:k,port:E}}e.parseAuthorityWithOptionalPort=I;function S(D){const A=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const E=D.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:D,port:void 0}}}),define(De[27],Ie([1,0,8,4,85]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(_){if(typeof _=="object"&&_!==null&&_.supported!==!0)return _.description}e.getWorkspaceSupportTypeMessage=P;function y(_){return _&&typeof _=="object"&&typeof _.id=="string"&&(!_.uuid||typeof _.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(_){_[_.System=0]="System",_[_.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var S;(function(_){_.WIN32_X64="win32-x64",_.WIN32_IA32="win32-ia32",_.WIN32_ARM64="win32-arm64",_.LINUX_X64="linux-x64",_.LINUX_ARM64="linux-arm64",_.LINUX_ARMHF="linux-armhf",_.ALPINE_X64="alpine-x64",_.ALPINE_ARM64="alpine-arm64",_.DARWIN_X64="darwin-x64",_.DARWIN_ARM64="darwin-arm64",_.WEB="web",_.UNIVERSAL="universal",_.UNKNOWN="unknown",_.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,p){if(typeof g>"u"||g===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof g=="string"||typeof p=="string"){const m=typeof g=="string"?g:g.value,b=typeof p=="string"?p:p.value;return u.equalsIgnoreCase(m,b)}return g._lower===p._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=D;function A(_){return k(_)}e.isApplicationScopedExtension=A;function k(_){return _.contributes&&_.contributes.localizations?_.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function E(_){return _.contributes&&_.contributes.authentication?_.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function T(_,g){if(g){const p=`onResolveRemoteAuthority:${(0,C.getRemoteName)(g)}`;return _.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[199],Ie([1,0,8,120,27,10,2,11,36]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(d,o){return d.uuid&&o.uuid?d.uuid===o.uuid:d.id===o.id?!0:(0,u.compareIgnoreCase)(d.id,o.id)===0}e.areSameExtensions=D;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(o){const i=o.manifest?o.manifest.version:o.version,s=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new k(o.identifier,i,s)}static parse(o){const i=A.exec(o);return i&&i[1]&&i[2]?new k({id:i[1]},i[2],i[4]||void 0):null}constructor(o,i,s="undefined"){this.version=i,this.targetPlatform=s,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof k?D(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=k;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(d){const o=E.exec(d);return o&&o[1]?[g(o[1]),o[2]]:[g(d),void 0]}e.getIdAndVersion=T;function _(d,o){return`${d}.${o}`}e.getExtensionId=_;function g(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function p(d,o){return g(_(d,o))}e.getGalleryExtensionId=p;function m(d,o){const i=[],s=l=>{for(const n of i)if(n.some(r=>D(o(r),o(l))))return n;return null};for(const l of d){const n=s(l);n?n.push(l):i.push([l])}return i}e.groupByExtension=m;function b(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function f(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function c(d,o){const i=[],s=o.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&i.every(n=>!D(n.identifier,{id:l}))){const n=d.filter(r=>D(r.identifier,{id:l}));n.length===1&&(i.push(n[0]),s.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=c;async function v(d,o){if(!P.isLinux)return!1;let i;try{i=(await d.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await d.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){o.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(l))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=v;async function a(d,o){const i=await v(d,o),s=(0,t.getTargetPlatform)(i?"alpine":P.platform,S.arch);return o.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=a}),define(De[200],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((C,P)=>J(["vsda"],C,P))}async createNewMessage(C){try{const P=await this.vsda(),y=new P.validator;if(y){const I=String(u._nextId++);return this.validators.set(I,y),{id:I,data:y.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,P){if(!C.id)return!0;const y=this.validators.get(C.id);if(!y)return!1;this.validators.delete(C.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(C){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(C)}catch{}return C}}e.SignService=u,u._nextId=1}),define(De[201],Ie([1,0,10,36,2,31]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(D){if(u.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function I(D,A,k,E,T,_,g,p,m,b){const f=Object.create(null);f["common.machineId"]=g,f.sessionID=(0,P.generateUuid)()+Date.now(),f.commitHash=T,f.version=_,f["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,u.PlatformToString)(u.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=E,f["common.product"]=b||"desktop",p&&(f["common.msftInternal"]=p);let c=0;const v=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),u.isLinuxSnap&&(f["common.snap"]="true");const a=y(k);a&&(f["common.platformDetail"]=a);try{const d=await D.readFile(C.URI.file(m));f["common.source"]=d.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=I;function S(D){const A=t.env.USERDNSDOMAIN;if(!A)return!1;const k=A.toLowerCase();return D.some(E=>k===E)}e.verifyMicrosoftInternalDomain=S}),define(De[202],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,u.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,u.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[203],Ie([1,0,24,156,12,65,201,202]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,s){return Promise.resolve(void 0)}publicLog2(i,s){return this.publicLog(i,s)}publicLogError(i,s){return Promise.resolve(void 0)}publicLogError2(i,s){return this.publicLogError(i,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class D{async publicLog(i,s,l){}async publicLogError(i,s,l){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(o,i){return i.onDidChangeConfiguration(s=>{s.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(s.source),configurationKeys:m(s.sourceConfig)})})}e.configurationTelemetry=A;function k(o,i){return!(i.disableTelemetry||!o.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=k;function E(o){const i=o.getValue(I.TELEMETRY_SETTING_ID),s=o.getValue("telemetry.enableCrashReporter");if(o.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function T(o){const i={},s={},l={};p(o,l);for(let n in l){n=n.length>150?n.substr(n.length-149):n;const r=l[n];typeof r=="number"?s[n]=r:typeof r=="boolean"?s[n]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${r.length}`),i[n]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[n]=r)}return{properties:i,measurements:s}}e.validateTelemetryData=T;const _=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function g(o){if(!o)return"none";for(const i of _)if(o.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=g;function p(o,i,s=0,l){if(!!o)for(const n of Object.getOwnPropertyNames(o)){const r=o[n],h=l?l+n:n;Array.isArray(r)?i[h]=(0,u.safeStringify)(r):r instanceof Date?i[h]=r.toISOString():(0,C.isObject)(r)?s<2?p(r,i,s+1,h+"."):i[h]=(0,u.safeStringify)(r):i[h]=r}}function m(o){if(!o)return[];const i=[];return b(i,"",o),i}function b(o,i,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(l=>b(o,i?`${i}.${l}`:l,s[l])):o.push(i)}function f(o,i){const s=o.msftInternalDomains||[],l=i.getValue("telemetry.internalTesting");return(0,y.verifyMicrosoftInternalDomain)(s)||l}e.isInternalTelemetry=f;function c(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=c;function v(o,i){let s=o;const l=[];for(const w of i)for(;;){const L=w.exec(o);if(!L)break;l.push([L.index,w.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(s="";;){const w=r.exec(o);if(!w)break;!n.test(w[0])&&l.every(([L,M])=>w.index<L||w.index>=M)&&(s+=o.substring(h,w.index)+"<REDACTED: user-file-path>",h=r.lastIndex)}return h<o.length&&(s+=o.substr(h)),s}function a(o){if(!o)return o;const i=o.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of s)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return o}function d(o,i){return(0,u.cloneAndChange)(o,s=>{if(typeof s=="string"){let l=s;l=v(l,i);for(const n of i)l=l.replace(n,"");return l=a(l),l}})}e.cleanData=d}),define(De[204],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,P,y=5){const I=P(S=>{const D=typeof S=="string"?S:S.data;let A=this._terminalBufferMap.get(C);if(A){A.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(C),y);A={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),I.dispose()}},this._terminalBufferMap.set(C,A)});return I}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const P=this._terminalBufferMap.get(C);P&&(this._terminalBufferMap.delete(C),this._callback(C,P.data.join("")))}}e.TerminalDataBufferer=u}),define(De[205],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(u=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===u.HIGH_CONTRAST_DARK||P===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(P){return P===u.DARK||P===u.HIGH_CONTRAST_DARK}e.isDark=C}),define(De[86],Ie([1,0,76,3,6,4,43,205]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var S;(function(p){function m(b){return b&&typeof b=="object"&&typeof b.id=="string"}p.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function D(p){return{id:p}}e.themeColorFromId=D;var A;(function(p){function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||S.isThemeColor(i.color))}p.isThemeIcon=m;const b=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function f(i){const s=b.exec(i);if(!s)return;const[,l]=s;return{id:l}}p.fromString=f;function c(i){return{id:i}}p.fromId=c;function v(i,s){let l=i.id;const n=l.lastIndexOf("~");return n!==-1&&(l=l.substring(0,n)),s&&(l=`${l}~${s}`),{id:l}}p.modify=v;function a(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}p.getModifier=a;function d(i,s){return i.id===s.id&&i.color?.id===s.color?.id}p.isEqual=d;function o(i,s){return{id:i.id,color:s?D(s):void 0}}p.asThemeIcon=o,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function k(p){switch(p){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,C.toDisposable)(()=>{const b=this.themingParticipants.indexOf(m);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new E;y.Registry.add(e.Extensions.ThemingContribution,T);function _(p){return T.onColorThemeChange(p)}e.registerThemingParticipant=_;class g extends C.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,b){let f=this.theme.getColor(m);return f&&b&&(f=b(f,this.theme)),f?f.toString():null}}e.Themable=g}),define(De[127],Ie([1,0,3,10,4,13]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var y;(function(g){g.Http="http",g.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=k;function E(g,p){return p?p!==1&&g<1024:!t.isWindows&&g<1024}e.isPortPrivileged=E;class T{constructor(p,m,b){this.remoteAddress=p,this.localAddress=m,this._dispose=b,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let _=class{constructor(p){this.logService=p,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],m=Array.from(this._tunnels.values());for(const b of m){const f=Array.from(b.values());for(const c of f){const v=await c.value;v&&p.push(v)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:m}of p.values())await m.then(b=>b?.dispose());p.clear()}this._tunnels.clear()}setEnvironmentTunnel(p,m,b,f,c){this.addTunnelToMap(p,m,Promise.resolve({tunnelRemoteHost:p,tunnelRemotePort:m,localAddress:b,privacy:f,protocol:c,dispose:()=>Promise.resolve()}))}openTunnel(p,m,b,f,c=!1,v,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${b} on local port ${f}.`),!p)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(b)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(p,m,b,f,c,v,a);return d?d.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(o);return(o.tunnelRemoteHost!==m||o.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const m=this._tunnels.get(p.tunnelRemoteHost);if(m){const b=m.get(p.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,b))}}}}async tryDisposeTunnel(p,m,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${m}.`);const f=b.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(m),f}}async closeTunnel(p,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${m} `);const b=this._tunnels.get(p);if(b&&b.has(m)){const f=b.get(m);f.refcount=0,await this.tryDisposeTunnel(p,m,f)}}addTunnelToMap(p,m,b){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(m,{refcount:1,value:b})}async removeEmptyTunnelFromMap(p,m){const b=this._tunnels.get(p);b&&(await b.get(m)||b.delete(m),b.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,m){const b=[p];A(p)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):k(p)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const f=b.map(c=>this._tunnels.get(c));for(const c of f){const v=c?.get(m);if(v)return v}}canTunnel(p){return!!D(p)}doIsPortPrivileged(p,m,b,f){if(m)return!1;if(b){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(c?.length===4){const v=parseInt(c[1]),a=parseInt(c[2]);if(v>10||v===10&&a>=14)return!1}}return p<1024}createWithProvider(p,m,b,f,c,v,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${b} on local port ${f}.`);const d=b;this._factoryInProgress.add(d);const o=f===void 0?b:f,i={elevationRequired:c?this.isPortPrivileged(o):!1},s={remoteAddress:{host:m,port:b},localAddressPort:f,privacy:v,public:v?v!==I.Private:void 0,protocol:a},l=p.forwardPort(s,i);return l?(this.addTunnelToMap(m,b,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),l}};_=je([$e(0,P.ILogService)],_),e.AbstractTunnelService=_}),define(De[206],Ie([1,0,14]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==u.Schemas.file&&S.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=t;function C(S){if(S.folders.length)return S.folders.every(D=>t(D.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=C;function P(S){return C(S)?.scheme}e.getVirtualWorkspaceScheme=P;function y(S){return C(S)?.authority}e.getVirtualWorkspaceAuthority=y;function I(S){return C(S)!==void 0}e.isVirtualWorkspace=I}),define(De[45],Ie([1,0,169,9,26,22,2,4,14]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function D(d){const o=d;return typeof o?.id=="string"&&y.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=D,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function A(d,o){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,t.basename)(d)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=d;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=A;function k(d){const o=d;return typeof o?.id=="string"&&y.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=k;function E(d){const o=d;if(o?.uri)return{id:o.id,uri:y.URI.revive(o.uri)};const i=d;if(i?.configPath)return{id:i.id,configPath:y.URI.revive(i.configPath)};if(d?.id)return{id:d.id}}e.reviveIdentifier=E;var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function _(d){const o=d;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=_;function g(d){const o=d;return!!(o&&typeof o=="object"&&y.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=g;class p{constructor(o,i,s,l,n){this._id=o,this._transient=s,this._configuration=l,this._ignorePathCasing=n,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class m{constructor(o,i){this.raw=i,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function b(d){return new m({uri:d,index:0,name:(0,P.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(d,o){return P.extUriBiasedIgnorePathCase.isEqualOrParent(d,o.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function c(d){let o;return y.URI.isUri(d)?o=d:o=d.configuration,o?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=c;function v(d,o){return!f(d,o)&&!c(d)}e.isSavedWorkspace=v;function a(d){return(typeof d=="string"?(0,t.extname)(d):(0,P.extname)(d))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(De[87],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const P=this._idPool++;return this._data.set(P,C),this.logDebugInfo(),P}get(C,P){return this._data.has(C)?this._data.get(C)[P]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(De[46],Ie([1,0,14,22,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const S=this._providerInfo.get(I.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(I,S){S===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,S)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(De[25],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(De[207],Ie([1,0,18]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,I,S){this._deferredPromises=new Map,this._id=y,this._shared=I,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of D.values())A.complete()}catch(A){for(const k of D.values())k.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,I){let S=this._value[y];return typeof S>"u"&&(S=I),S}update(y,I){this._value[y]=I;const S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const D=new u.DeferredPromise;return this._deferredPromises.set(y,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class C extends t{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,I){super(y.identifier.value,!0,I),this._extension=y}}e.ExtensionGlobalMemento=C}),define(De[208],Ie([1,0,3,2]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,I,S,D){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(I.value,S,D);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(y,I){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(I)}$acceptModelSaved(y){const I=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(I.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(De[16],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[209],Ie([1,0,27,3]),function(J,e,u,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(I,S){C.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(I.identifier),tt(this,C,S,"f"),Be(this,C,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(I){return Be(this,C,"f").get(this._id,I)}store(I,S){return Be(this,C,"f").store(this._id,I,S)}delete(I){return Be(this,C,"f").delete(this._id,I)}}e.ExtensionSecrets=P,C=new WeakMap}),define(De[53],Ie([1,0,4,127,3,16]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(S){function D(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=D;function A(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=A})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let I=class{constructor(D){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,A){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,A){return{dispose:()=>{}}}async $providePortAttributes(D,A,k,E,T){return[]}async $forwardPort(D,A){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=je([$e(0,P.IExtHostRpcService)],I),e.ExtHostTunnelService=I}),define(De[54],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(De[210],Ie([1,0,23]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let D=this.buffers.indexOf(S);return D<0&&(D=this.buffers.length,this.buffers.push(S)),D}}function C(I,S){if(S.serializeBuffersForPostMessage){const D=new t,A=(T,_)=>{if(_ instanceof ArrayBuffer){const g=D.add(_);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(_)){const g=P(_);if(g){const p=D.add(_.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:g,byteLength:_.byteLength,byteOffset:_.byteOffset}}}}return _},k=JSON.stringify(I,A),E=D.buffers.map(T=>{const _=new Uint8Array(T);return u.VSBuffer.wrap(_)});return{message:k,buffers:E}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=C;function P(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(I,S){const D=S.map(E=>{const T=new ArrayBuffer(E.byteLength);return new Uint8Array(T).set(E.buffer),T}),A=S.length?(E,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const _=T,{index:g}=_,p=D[g];if(_.view)switch(_.view.type){case 1:return new Int8Array(p,_.view.byteOffset,_.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,_.view.byteOffset,_.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,_.view.byteOffset,_.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,_.view.byteOffset,_.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,_.view.byteOffset,_.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,_.view.byteOffset,_.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,_.view.byteOffset,_.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,_.view.byteOffset,_.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,_.view.byteOffset,_.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,_.view.byteOffset,_.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,_.view.byteOffset,_.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return T}:void 0;return{message:JSON.parse(I,A),arrayBuffers:D}}e.deserializeWebviewMessage=y}),define(De[211],Ie([1,0,111]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function C(P){return new u.URITransformer(t(P))}e.createURITransformer=C}),define(De[128],Ie([1,0,179,12,2,6,4,43,38,14]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var A;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(A=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var k;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(k=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(x){const $=x;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=E;function T(x,$,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===$&&x.matches(K.input))return K.getViewState()}e.findViewStateForEditor=T;function _(x){if(s(x))return!1;const $=x;return C.URI.isUri($?.resource)}e.isResourceEditorInput=_;function g(x){if(s(x))return!1;const $=x;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=g;function p(x){if(s(x)||g(x))return!1;const $=x;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function m(x){if(s(x))return!1;const $=x;return $?$.resource===void 0||$.resource.scheme===D.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;const b=/Untitled-\d+/;function f(x){return x.scheme===D.Schemas.untitled&&x.path.length>1&&!b.test(x.path)}e.isUntitledWithAssociatedResource=f;function c(x){if(s(x))return!1;const $=x;return C.URI.isUri($?.base?.resource)&&C.URI.isUri($?.input1?.resource)&&C.URI.isUri($?.input2?.resource)&&C.URI.isUri($?.result?.resource)}e.isResourceMergeEditorInput=c;var v;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var a;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class d{constructor(){this.mapIdToSaveSource=new Map}registerSource($,Q){let K=this.mapIdToSaveSource.get($);return K||(K={source:$,label:Q},this.mapIdToSaveSource.set($,K)),K.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new d;var o;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends P.Disposable{}e.AbstractEditorInput=i;function s(x){return x instanceof i}e.isEditorInput=s;function l(x){const $=x;return C.URI.isUri($?.preferredResource)}function n(x){const $=x;return s($?.primary)&&s($?.secondary)}e.isSideBySideEditorInput=n;function r(x){const $=x;return s($?.modified)&&s($?.original)}e.isDiffEditorInput=r;function h(x){return s(x?.editor)}e.isEditorInputWithOptions=h;function w(x){const $=x;return h(x)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=w;function L(x){const $=x;return typeof $?.groupId=="number"&&s($.editor)}e.isEditorIdentifier=L;var M;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var B;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var R;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(R=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri($,Q){if(!$)return;if(c($))return e.EditorResourceAccessor.getOriginalUri($.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors($);if(de&&ee){if(Q?.supportSideBySide===R.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===R.ANY)return this.getOriginalUri(de,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===R.PRIMARY?de:ee}}if(g($)||p($)||c($))return;const K=l($)?$.preferredResource:$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors($){return n($)||p($)?{primary:$.primary,secondary:$.secondary}:r($)||g($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,Q){if(!$)return;if(c($))return e.EditorResourceAccessor.getCanonicalUri($.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:ee}=this.getSideEditors($);if(de&&ee){if(Q?.supportSideBySide===R.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===R.ANY)return this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===R.PRIMARY?de:ee}}if(g($)||p($)||c($))return;const K=$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri($,Q){if(Array.isArray(Q)){if(Q.some(K=>$.scheme===K))return $}else if(Q===$.scheme)return $}}e.EditorResourceAccessor=new z;var H;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(H=e.CloseDirection||(e.CloseDirection={}));class N{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const Q=this.instantiationService=$.get(y.IInstantiationService);for(const[K,de]of this.editorSerializerConstructors)this.createEditorSerializer(K,de,Q);this.editorSerializerConstructors.clear()}createEditorSerializer($,Q,K){const de=K.createInstance(Q);this.editorSerializerInstances.set($,de)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,Q){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,Q,this.instantiationService):this.editorSerializerConstructors.set($,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}I.Registry.add(e.EditorExtensions.EditorFactory,new N);async function V(x,$){return!x||!x.length?[]:await Promise.all(x.map(async Q=>{const K=C.URI.revive(Q.fileUri);if(!K||!await $.canHandleResource(K))return;let ee=Q.exists,he=Q.type;if(typeof ee!="boolean"||typeof he!="number")try{he=(await $.stat(K)).isDirectory?S.FileType.Directory:S.FileType.Unknown,ee=!0}catch{ee=!1}if(!ee&&Q.openOnlyIfExists||he===S.FileType.Directory)return;const Y={...Q.options,pinned:!0};return ee?{resource:K,options:Y}:{resource:K,options:Y,forceUntitled:!0}}))}e.pathsToEditors=V;var U;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function F(x){const $=x;if(!$)return!1;const Q=$;if(Q.modified)return F(Q.modified);const K=$;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=F}),define(De[88],Ie([1,0,14,2]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(I,S){return I.scheme===u.Schemas.http||I.scheme===u.Schemas.https?I:(S&&S.authority&&S.isRemote&&I.scheme===u.Schemas.file&&(I=t.URI.from({scheme:u.Schemas.vscodeRemote,authority:S.authority,path:I.path})),t.URI.from({scheme:u.Schemas.https,authority:`${I.scheme}+${P(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=C;function P(I){return I.replace(/./g,S=>{const D=S.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?S:"-"+D.toString(16).padStart(4,"0")})}function y(I){return I.replace(/-([0-9a-f]{4})/g,(S,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=y}),define(De[212],Ie([1,0,3,6,88]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(I,S,D){this._proxy=I,this._editors=S,this._remoteInfo=D,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const A=S.getVisibleTextEditors();for(const k of this._insets.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,S,D,A,k){let E;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===I){E=f;break}if(!E)throw new Error("not a visible editor");const T=this,_=this._handlePool++,g=new u.Emitter,p=new u.Emitter,m=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,C.asWebviewUri)(f,T._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(f){this._options=f,T._proxy.$setOptions(_,f)}get options(){return this._options}set html(f){this._html=f,T._proxy.$setHtml(_,f)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(f){return T._proxy.$postMessage(_,f)}},b=new class{constructor(){this.editor=I,this.line=S,this.height=D,this.webview=m,this.onDidDispose=p.event}dispose(){T._insets.has(_)&&(T._insets.delete(_),T._proxy.$disposeEditorInset(_),p.fire(),p.dispose(),g.dispose())}};return this._proxy.$createEditorInset(_,E.id,E.value.document.uri,S+1,D,A||{},k.identifier,k.extensionLocation),this._insets.set(_,{editor:I,inset:b,onDidReceiveMessage:g}),b}$onDidDispose(I){const S=this._insets.get(I);S&&S.inset.dispose()}$onDidReceiveMessage(I,S){this._insets.get(I)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=P}),define(De[129],Ie([1,0,3,18,180]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,S,D,A){const k={command:I};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof A=="number"){const E=setTimeout(()=>{clearTimeout(E);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const _={type:"response",seq:0,request_seq:k.seq,success:!1,command:I,message:(0,C.localize)(0,null,A,I)};T(_)}},A)}return D&&this.pendingRequests.set(k.seq,D),k.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,S){return I.type!=="event"||S.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback?.(I);break;case"request":this.requestCallback?.(I);break;case"response":{const S=I,D=this.pendingRequests.get(S.request_seq);D&&(this.pendingRequests.delete(S.request_seq),D(S));break}}}}internalSend(I,S){S.type=I,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((S,D)=>I.set(D,S)),await(0,t.timeout)(500),I.forEach((S,D)=>{S({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[213],Ie([1,0,181,52,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const P=E=>u.localize(51,null,E);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var y;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(y=e.State||(e.State={}));function I(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=I;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var A;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(A=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,C.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[214],Ie([1,0,8,2,9,24,14]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function S(o,i,s){return o.replace(I,function(l,n){return i&&n.length>0&&n[0]!=="_"?l:s&&s.hasOwnProperty(n)?s[n]:l})}e.formatPII=S;function D(o){const i={};for(const s of Object.keys(o))s.startsWith("!")||(i[s]=o[s]);return i}e.filterExceptionsFromTelemetry=D;function A(o){return o.configuration.request==="attach"&&!k(o)&&(!o.parentSession||A(o.parentSession))}e.isSessionAttach=A;function k(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(i,"extensionhost")||(0,u.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?k(o.parentSession):void 0}e.getExtensionHostDebugSession=k;function E(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=E;function T(o,i,s){let l,n=0;const r=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=r.exec(o);){const w=h.index+1,L=w+h[0].length;if(w<=i&&L>=s){l=h[0],n=w;break}}if(l){const w=/\w+/g;let L=null;for(;(L=w.exec(l))&&!(L.index+1+n+L[0].length>=s););L&&(l=l.substring(0,w.lastIndex))}return l?{start:n,end:n+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const _=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(o){return!!(o&&o.match(_))}e.isUri=g;function p(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(g(o.path))return t.URI.parse(o.path);if((0,C.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function m(o){if(typeof o.path=="object"){const i=t.URI.revive(o.path);if(i)return i.scheme===y.Schemas.file?i.fsPath:i.toString()}return o.path}function b(o,i){const s=i?p:m,l=(0,P.deepClone)(o);return c(l,(n,r)=>{n&&r&&(r.path=s(r))}),l}e.convertToDAPaths=b;function f(o,i){const s=i?p:m,l=(0,P.deepClone)(o);return c(l,(n,r)=>{!n&&r&&(r.path=s(r))}),l}e.convertToVSCPaths=f;function c(o,i){switch(o.type){case"event":{const s=o;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=o;switch(s.command){case"setBreakpoints":i(!0,s.arguments.source);break;case"breakpointLocations":i(!0,s.arguments.source);break;case"source":i(!0,s.arguments.source);break;case"gotoTargets":i(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(l=>i(!1,l));break;default:break}break}case"response":{const s=o;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(l=>i(!1,l.source));break;case"loadedSources":s.body.sources.forEach(l=>i(!1,l));break;case"scopes":s.body.scopes.forEach(l=>i(!1,l.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(l=>i(!1,l.source));break;case"setBreakpoints":s.body.breakpoints.forEach(l=>i(!1,l.source));break;case"disassemble":s.body?.instructions.forEach(n=>i(!1,n.location));break;default:break}break}}}function v(o){return o.filter(i=>!i.presentation?.hidden).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):a(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:a(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=v;function a(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function d(o,i){const s=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(s!=="none"&&(await i.saveAll(),s==="allEditorsInActiveGroup")){const l=i.activeEditorPane;l&&l.input.resource?.scheme===y.Schemas.untitled&&await i.save({editor:l.input,groupId:l.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(De[215],Ie([1,0,44,216,24,9,10,8,29,182,129]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends A.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(m,b){this.outputStream=b,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,m.on("data",f=>this.handleData(f))}sendMessage(m){if(this.outputStream){const b=JSON.stringify(m);this.outputStream.write(`Content-Length: ${Buffer.byteLength(b,"utf8")}${k.TWO_CRLF}${b}`,"utf8")}}handleData(m){for(this.rawData=Buffer.concat([this.rawData,m]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const b=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,b.length>0)try{this.acceptMessage(JSON.parse(b))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+b))}continue}}else{const b=this.rawData.indexOf(k.TWO_CRLF);if(b!==-1){const c=this.rawData.toString("utf8",0,b).split(k.HEADER_LINESEPARATOR);for(const v of c){const a=v.split(k.HEADER_FIELDSEPARATOR);a[0]==="Content-Length"&&(this.contentLength=Number(a[1]))}this.rawData=this.rawData.slice(b+k.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=k,k.TWO_CRLF=`\r
\r
`,k.HEADER_LINESEPARATOR=/\r?\n/,k.HEADER_FIELDSEPARATOR=/: */;class E extends k{startSession(){return new Promise((m,b)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),m(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):b(new Error("connection closed"))}),this.socket.on("error",c=>{f?this._onError.fire(c):b(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class T extends E{constructor(m){super(),this.adapterServer=m}createConnection(m){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",m)}}e.SocketDebugAdapter=T;class _ extends E{constructor(m){super(),this.adapterServer=m}createConnection(m){return t.createConnection(this.adapterServer.path,m)}}e.NamedPipeDebugAdapter=_;class g extends k{constructor(m,b){super(),this.adapterExecutable=m,this.debugType=b}async startSession(){const m=this.adapterExecutable.command,b=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(m)if(P.isAbsolute(m)){if(!await S.Promises.exists(m))throw new Error(D.localize(0,null,m))}else m.indexOf("/")<0&&m.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let c=process.env;if(f.env&&Object.keys(f.env).length>0&&(c=C.mixin(C.deepClone(process.env),f.env)),m==="node")if(Array.isArray(b)&&b.length>0){const v=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,a={env:c,execArgv:v?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(a.cwd=f.cwd);const d=u.fork(b[0],b.slice(1),a);if(!d.pid)throw new Error(D.localize(2,null,b[0]));this.serverProcess=d}else throw new Error(D.localize(3,null));else{const v={env:c};f.cwd&&(v.cwd=f.cwd),this.serverProcess=u.spawn(m,b,v)}this.serverProcess.on("error",v=>{this._onError.fire(v)}),this.serverProcess.on("exit",(v,a)=>{this._onExit.fire(v)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",v=>{this._onError.fire(v)}),this.serverProcess.stdin.on("error",v=>{this._onError.fire(v)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((m,b)=>{const f=u.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,v,a){if(c)return b(c)});f.on("exit",m),f.on("error",b)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(m,b){if(!m)return;const f=Object.create(null);m.runtime&&(m.runtime.indexOf("./")===0?f.runtime=P.join(b,m.runtime):f.runtime=m.runtime),m.runtimeArgs&&(f.runtimeArgs=m.runtimeArgs),m.program&&(P.isAbsolute(m.program)?f.program=m.program:f.program=P.join(b,m.program)),m.args&&(f.args=m.args);const c=m;return c.win&&(f.win=g.extract(c.win,b)),c.winx86&&(f.winx86=g.extract(c.winx86,b)),c.windows&&(f.windows=g.extract(c.windows,b)),c.osx&&(f.osx=g.extract(c.osx,b)),c.linux&&(f.linux=g.extract(c.linux,b)),f}static platformAdapterExecutable(m,b){let f=Object.create(null);b=b.toLowerCase();for(const i of m)if(i.contributes){const s=i.contributes.debuggers;s&&s.length>0&&s.filter(l=>typeof l.type=="string"&&I.equalsIgnoreCase(l.type,b)).forEach(l=>{const n=g.extract(l,i.extensionLocation.fsPath);f=C.mixin(f,n,i.isBuiltin)})}let c;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=f.winx86||f.win||f.windows:y.isWindows?c=f.win||f.windows:y.isMacintosh?c=f.osx:y.isLinux&&(c=f.linux),c=c||f;const v=c.program||f.program,a=c.args||f.args,d=c.runtime||f.runtime,o=c.runtimeArgs||f.runtimeArgs;if(d)return{type:"executable",command:d,args:(o||[]).concat(typeof v=="string"?[v]:[]).concat(a||[])};if(v)return{type:"executable",command:v,args:a||[]}}}e.ExecutableDebugAdapter=g}),define(De[217],Ie([1,0,44,32,10]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(D,A){return new Promise((k,E)=>{let T="";const _=u.spawn(D,A);_.pid&&_.stdout.on("data",g=>{T+=g.toString()}),_.on("error",g=>{E(g)}),_.on("close",g=>{k(T)})})}async function y(D){if(D)if(C.isWindows){const A=await new Promise((k,E)=>{J(["windows-process-tree"],k,E)});return new Promise(k=>{A.getProcessTree(D,E=>{k(!!E&&E.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(D)]).then(A=>{const k=A.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var I;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(I||(I={}));function S(D,A,k,E,T){D=D.trim().toLowerCase();let _;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?_=1:D.indexOf("cmd.exe")>=0?_=0:D.indexOf("bash")>=0?_=2:C.isWindows?_=0:_=2;let g,p=" ";switch(_){case 1:if(g=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),E){const m=(0,t.getDriveLetter)(E);m&&(p+=`${m}:; `),p+=`cd ${g(E)}; `}if(T)for(const m in T){const b=T[m];b===null?p+=`Remove-Item env:${m}; `:p+=`\${env:${m}}='${b}'; `}if(A.length>0){const m=A.shift(),b=k?m:g(m);p+=b[0]==="'"?`& ${b} `:`${b} `;for(const f of A)p+=f==="<"||f===">"||k?f:g(f),p+=" "}break;case 0:if(g=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(b=>m.includes(b))||m.length===0?`"${m}"`:m),E){const m=(0,t.getDriveLetter)(E);m&&(p+=`${m}: && `),p+=`cd ${g(E)} && `}if(T){p+='cmd /C "';for(const m in T){let b=T[m];b===null?p+=`set "${m}=" && `:(b=b.replace(/[&^|<>]/g,f=>`^${f}`),p+=`set "${m}=${b}" && `)}}for(const m of A)p+=m==="<"||m===">"||k?m:g(m),p+=" ";T&&(p+='"');break;case 2:{g=b=>(b=b.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),b.length===0?'""':b);const m=b=>/[^\w@%\/+=,.:^-]/.test(b)?`'${b.replace(/'/g,"'\\''")}'`:b;if(E&&(p+=`cd ${g(E)} ; `),T){p+="/usr/bin/env";for(const b in T){const f=T[b];f===null?p+=` -u ${m(b)}`:p+=` ${m(`${b}=${f}`)}`}p+=" "}for(const b of A)p+=b==="<"||b===">"||k?b:g(b),p+=" ";break}}return p}e.prepareCommand=S}),define(De[89],Ie([1,0,23,37,61,104,14,9,10,52]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var A;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(A=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var _;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(_=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var b;(function(V){V.scheme=y.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],F=new RegExp(`^[${U.join("")}]+`),x=7;function $(Y,me){const be=me.toString(x),Re=`${be.length<U.length?U[be.length-1]:"z"}${be}s${(0,u.encodeBase64)(u.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:V.scheme,fragment:Re})}V.generate=$;function Q(Y){if(Y.scheme!==V.scheme)return;const me=Y.fragment.indexOf("s");if(me<0)return;const be=parseInt(Y.fragment.substring(0,me).replace(F,""),x),ke=(0,u.decodeBase64)(Y.fragment.substring(me+1)).toString();if(!isNaN(be))return{handle:be,notebook:Y.with({scheme:ke,fragment:null})}}V.parse=Q;function K(Y,me){return Y.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${Y.scheme!==y.Schemas.file?Y.scheme:""}`})}V.generateCellOutputUri=K;function de(Y){if(Y.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!me)return;const be=me[1]&&me[1]!==""?me[1]:void 0,ke=me[2];return{outputId:be,notebook:Y.with({scheme:ke||y.Schemas.file,fragment:null})}}V.parseCellOutputUri=de;function ee(Y,me,be){return V.generate(Y,me).with({scheme:be})}V.generateCellPropertyUri=ee;function he(Y,me){if(Y.scheme===me)return V.parse(Y.with({scheme:V.scheme}))}V.parseCellPropertyUri=he})(b=e.CellUri||(e.CellUri={}));const f=V=>S.isWindows?V.replace(/\//g,"\\"):V;class c{constructor(U=[],F=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=F,this.order=[...new Set(U)].map(x=>({pattern:x,matches:t.parse(f(x))}))}sort(U){const F=new Map(C.Iterable.map(U,$=>[$,f($)]));let x=[];for(const{matches:$}of this.order)for(const[Q,K]of F)if($(K)){x.push(Q),F.delete(Q);break}return F.size&&(x=x.concat([...F.keys()].sort(($,Q)=>this.defaultOrder.indexOf($)-this.defaultOrder.indexOf(Q)))),x}prioritize(U,F){const x=this.findIndex(U);if(x===-1){this.order.unshift({pattern:U,matches:t.parse(f(U))});return}const $=new Set(F.map(K=>this.findIndex(K,x)));$.delete(-1);const Q=Array.from($).sort();this.order.splice(x+1,0,...Q.map(K=>this.order[K]));for(let K=Q.length-1;K>=0;K--)this.order.splice(Q[K],1)}toArray(){return this.order.map(U=>U.pattern)}findIndex(U,F=this.order.length){const x=f(U);for(let $=0;$<F;$++)if(this.order[$].matches(x))return $;return-1}}e.MimeTypeDisplayOrder=c;function v(V,U,F,x=($,Q)=>$===Q){const $=[];function Q(ee,he,Y){if(he===0&&Y.length===0)return;const me=$[$.length-1];me&&me.start+me.deleteCount===ee?(me.deleteCount+=he,me.toInsert.push(...Y)):$.push({start:ee,deleteCount:he,toInsert:Y})}let K=0,de=0;for(;;){if(K===V.length){Q(K,0,U.slice(de));break}if(de===U.length){Q(K,V.length-K,[]);break}const ee=V[K],he=U[de];if(x(ee,he)){K+=1,de+=1;continue}F(he)?(Q(K,1,[]),K+=1):(Q(K,0,[he]),de+=1)}return $}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(V){V.default="default",V.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(V){const U=V;return!!((typeof U.include=="string"||t.isRelativePattern(U.include))&&(typeof U.exclude=="string"||t.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=d;function o(V,U,F){if(Array.isArray(V.viewType)&&V.viewType.indexOf(U)>=0||V.viewType===U)return!0;if(V.filenamePattern){const x=d(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,$=d(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(t.match(x,(0,I.basename)(F.fsPath).toLowerCase()))return!($&&t.match($,(0,I.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(U){return`${s._prefix}${U}`}static parse(U){if(U.startsWith(s._prefix))return U.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/";function l(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}e.isTextStreamMime=l;const n=new TextDecoder;function r(V){const U=[];let F=!1;for(const x of V)(U.length===0||F)&&(U.push(x),F=!0);return M(U),N(u.VSBuffer.concat(U.map(x=>u.VSBuffer.wrap(x))))}e.compressOutputItemStreams=r;const h=`${String.fromCharCode(27)}[A`,w=h.split("").map(V=>V.charCodeAt(0)),L=10;function M(V){V.forEach((U,F)=>{if(F===0||U.length<h.length)return;const x=V[F-1],$=U.subarray(0,h.length);if($[0]===w[0]&&$[1]===w[1]&&$[2]===w[2]){const Q=x.lastIndexOf(L);if(Q===-1)return;V[F-1]=x.subarray(0,Q),V[F]=U.subarray(h.length)}})}function B(V){let U=V;do V=U,U=V.replace(/[^\n]\x08/gm,"");while(U.length<V.length);return V}function R(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const U=V.match(/^(.*)\r+/m)[1];let F=V.match(/\r+(.*)$/m)[1];F=F+U.slice(F.length,U.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,F)}return V}const z="\b".charCodeAt(0),H="\r".charCodeAt(0);function N(V){return!V.buffer.includes(z)&&!V.buffer.includes(H)?V:u.VSBuffer.fromString(R(B(n.decode(V.buffer))))}}),define(De[218],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(De[219],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=u;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function C(y){return Array.from(y.entries()).map(I=>[I[0],u(I[1].map)])}e.serializeEnvironmentVariableCollections=C;function P(y){return new Map(y.map(I=>[I[0],{map:t(I[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class C{static fromExtHostTestItem(y,I,S=y.parent){if(y._isRoot)return new C([I]);const D=[y.id];for(let A=S;A&&A.id!==I;A=A.parent)D.push(A.id);return D.push(I),new C(D.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const I=y.indexOf("\0");return I===-1?y:y.slice(0,I)}static fromString(y){return new C(y.split("\0"))}static join(y,I){return new C([...y.path,I])}static joinToString(y,I){return y.toString()+"\0"+I}static parentId(y){const I=y.lastIndexOf("\0");return I===-1?void 0:y.slice(0,I)}static compare(y,I){return y===I?0:I.startsWith(y+"\0")?2:y.startsWith(I+"\0")?3:1}constructor(y,I=y.length){if(this.path=y,this.viewEnd=I,y.length===0||I<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new C(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new C(this.path,y)}compare(y){if(typeof y=="string")return C.compare(this.toString(),y);for(let I=0;I<y.viewEnd&&I<this.viewEnd;I++)if(y.path[I]!==this.path[I])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=C}),define(De[66],Ie([1,0,2,35,55]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var y;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(n){n.serialize=r=>({range:r.range.toJSON(),uri:r.uri.toJSON()}),n.deserialize=r=>({range:t.Range.lift(r.range),uri:u.URI.revive(r.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var S;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var D;(function(n){n.serialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,location:r.location&&I.serialize(r.location)}),n.deserialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,location:r.location&&I.deserialize(r.location)})})(D=e.ITestErrorMessage||(e.ITestErrorMessage={}));const A=(n,r)=>`${r?"s":"e"}${n}`;e.getMarkId=A;var k;(function(n){n.serialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&I.serialize(r.location)}),n.deserialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&I.deserialize(r.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(n){n.serialize=r=>r.type===0?D.serialize(r):k.serialize(r),n.deserialize=r=>r.type===0?D.deserialize(r):k.deserialize(r)})(E=e.ITestMessage||(e.ITestMessage={}));var T;(function(n){n.serializeWithoutMessages=r=>({state:r.state,duration:r.duration,messages:[]}),n.serialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(E.serialize)}),n.deserialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(E.deserialize)})})(T=e.ITestTaskState||(e.ITestTaskState={}));const _="\0",g=(n,r)=>n+_+r;e.namespaceTestTag=g;const p=n=>{const r=n.indexOf(_);return{ctrlId:n.slice(0,r),tagId:n.slice(r+1)}};e.denamespaceTestTag=p;var m;(function(n){n.serialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?.toJSON(),range:r.range?.toJSON()||null,description:r.description,error:r.error,sortText:r.sortText}),n.deserialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?u.URI.revive(r.uri):void 0,range:r.range?t.Range.lift(r.range):null,description:r.description,error:r.error,sortText:r.sortText})})(m=e.ITestItem||(e.ITestItem={}));var b;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(n){n.serialize=r=>({expand:r.expand,item:m.serialize(r.item)}),n.deserialize=r=>({controllerId:C.TestId.root(r.item.extId),expand:r.expand,item:m.deserialize(r.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var c;(function(n){n.serialize=r=>{let h;return r.item&&(h={},r.item.label!==void 0&&(h.label=r.item.label),r.item.tags!==void 0&&(h.tags=r.item.tags),r.item.busy!==void 0&&(h.busy=r.item.busy),r.item.uri!==void 0&&(h.uri=r.item.uri?.toJSON()),r.item.range!==void 0&&(h.range=r.item.range?.toJSON()),r.item.description!==void 0&&(h.description=r.item.description),r.item.error!==void 0&&(h.error=r.item.error),r.item.sortText!==void 0&&(h.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:h}},n.deserialize=r=>{let h;return r.item&&(h={},r.item.label!==void 0&&(h.label=r.item.label),r.item.tags!==void 0&&(h.tags=r.item.tags),r.item.busy!==void 0&&(h.busy=r.item.busy),r.item.range!==void 0&&(h.range=r.item.range?t.Range.lift(r.item.range):null),r.item.description!==void 0&&(h.description=r.item.description),r.item.error!==void 0&&(h.error=r.item.error),r.item.sortText!==void 0&&(h.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:h}}})(c=e.ITestItemUpdate||(e.ITestItemUpdate={}));const v=(n,r)=>{r.expand!==void 0&&(n.expand=r.expand),r.item!==void 0&&(n.item=n.item?Object.assign(n.item,r.item):r.item)};e.applyTestItemUpdate=v;var a;(function(n){n.serializeWithoutMessages=r=>({...f.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(T.serializeWithoutMessages),retired:r.retired}),n.serialize=r=>({...f.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(T.serialize),retired:r.retired}),n.deserialize=r=>({...f.deserialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(T.deserialize),retired:!0})})(a=e.TestResultItem||(e.TestResultItem={}));var d;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(d=e.DetailType||(e.DetailType={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var i;(function(n){n.deserialize=r=>r.op===0?{op:r.op,item:f.deserialize(r.item)}:r.op===1?{op:r.op,item:c.deserialize(r.item)}:r.op===2?{op:r.op,uri:u.URI.revive(r.uri),docv:r.docv}:r,n.serialize=r=>r.op===0?{op:r.op,item:f.serialize(r.item)}:r.op===1?{op:r.op,item:c.serialize(r.item)}:r})(i=e.TestsDiffOp||(e.TestsDiffOp={}));class s{add(r){}update(r){}remove(r,h){}complete(){}}e.IncrementalChangeCollector=s;class l{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(r){const h=this.createChangeCollector();for(const w of r)switch(w.op){case 0:{const L=f.deserialize(w.item),M=C.TestId.parentId(L.item.extId)?.toString();if(M){if(this.items.has(M)){const B=this.items.get(M);B.children.add(L.item.extId);const R=this.createItem(L,B);this.items.set(L.item.extId,R),h.add(R)}}else{const B=this.createItem(L);this.roots.add(B),this.items.set(L.item.extId,B),h.add(B)}L.expand===2&&this.busyControllerCount++;break}case 1:{const L=c.deserialize(w.item),M=this.items.get(L.extId);if(!M)break;L.expand!==void 0&&(M.expand===2&&this.busyControllerCount--,L.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(M,L),h.update(M);break}case 3:{const L=this.items.get(w.itemId);if(!L)break;const M=C.TestId.parentId(L.item.extId)?.toString();M?this.items.get(M).children.delete(L.item.extId):this.roots.delete(L);const B=[[w.itemId]];for(;B.length;)for(const R of B.pop()){const z=this.items.get(R);z&&(B.push(z.children),this.items.delete(R),h.remove(z,z!==L),z.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this._tags.set(w.tag.id,w.tag);break;case 7:this._tags.delete(w.id);break}h.complete()}retireTest(r){}updatePendingRoots(r){this.pendingRootCount+=r}createChangeCollector(){return new s}}e.AbstractIncrementalTestCollection=l}),define(De[90],Ie([1,0,18,3,6,48,66,55]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(m,b)=>m===b,A={range:(m,b)=>m===b?!0:!m||!b?!1:m.equalsRange(b),busy:D,label:D,description:D,error:D,tags:(m,b)=>!(m.length!==b.length||m.some(f=>!b.includes(f)))},k=(m,b)=>{let f;for(const[c,v]of Object.entries(A))v(m[c],b[c])||(f?f[c]=b[c]:f={[c]:b[c]});return f};class E extends C.Disposable{get root(){return this.options.root}constructor(b){super(),this.options=b,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(b){this._resolveHandler=b;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const b=this.diff;return this.diff=[],b}pushDiff(b){switch(b.op){case 2:{for(const f of this.diff)if(f.op===2&&f.uri===b.uri){f.docv=b.docv;return}break}case 1:{const f=this.diff[this.diff.length-1];if(f){if(f.op===1&&f.item.extId===b.item.extId){(0,y.applyTestItemUpdate)(f.item,b.item);return}if(f.op===0&&f.item.item.extId===b.item.extId){(0,y.applyTestItemUpdate)(f.item,b.item);return}}break}}this.diff.push(b),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(b,f){const c=this.tree.get(b);if(!!c){if((c.expandLevels===void 0||f>c.expandLevels)&&(c.expandLevels=f),c.expand===1){const v=this.resolveChildren(c);return v.isOpen()?this.expandChildren(c,f-1):v.wait().then(()=>this.expandChildren(c,f-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,f-1)):this.expandChildren(c,f-1)}}dispose(){for(const b of this.tree.values())this.options.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(b,f){switch(f.op){case 3:this.removeItem(I.TestId.joinToString(b.fullId,f.id));break;case 0:this.upsertItem(f.item,b);break;case 5:for(const c of f.ops)this.onTestItemEvent(b,c);break;case 1:this.diffTagRefs(f.new,f.old,b.fullId.toString());break;case 2:this.updateExpandability(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:f.update}});break;case 6:this.documentSynced(b.actual.uri);break;default:(0,P.assertNever)(f)}}documentSynced(b){b&&this.pushDiff({op:2,uri:b,docv:this.options.getDocumentVersion(b)})}upsertItem(b,f){const c=I.TestId.fromExtHostTestItem(b,this.root.id,f?.actual),v=this.options.getApiFor(b);v.parent&&v.parent!==f?.actual&&this.options.getChildren(v.parent).delete(b.id);let a=this.tree.get(c.toString());if(!a){a={fullId:c,actual:b,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},b.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(b,f),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(b)}}),this.connectItemAndChildren(b,a,f);return}if(a.actual===b){this.connectItem(b,a,f);return}const d=this.options.getChildren(a.actual),o=a.actual,i=k(this.options.toITestItem(o),this.options.toITestItem(b));this.options.getApiFor(o).listener=void 0,a.actual=b,a.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(b.tags,o.tags,c.toString()),delete i.tags),this.onTestItemEvent(a,{op:4,update:i})),this.connectItemAndChildren(b,a,f);for(const[s,l]of d)this.options.getChildren(b).get(l.id)||this.removeItem(I.TestId.joinToString(c,l.id));this.documentSynced(a.actual.uri)}diffTagRefs(b,f,c){const v=new Set(f.map(a=>a.id));for(const a of b)v.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:c,item:{tags:b.map(a=>(0,y.namespaceTestTag)(this.options.controllerId,a.id))}}}),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(b){const f=this.tags.get(b.id);f?f.refCount++:(this.tags.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,b.id)}}))}decrementTagRefs(b){const f=this.tags.get(b);f&&!--f.refCount&&(this.tags.delete(b),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,b)}))}setItemParent(b,f){this.options.getApiFor(b).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(b,f,c){this.setItemParent(b,c);const v=this.options.getApiFor(b);v.parent=c?.actual,v.listener=a=>this.onTestItemEvent(f,a),this.updateExpandability(f)}connectItemAndChildren(b,f,c){this.connectItem(b,f,c);for(const[v,a]of this.options.getChildren(b))this.upsertItem(a,f)}updateExpandability(b){let f;this._resolveHandler?b.resolveBarrier?f=b.resolveBarrier.isOpen()?3:2:f=b.actual.canResolveChildren?1:0:f=0,f!==b.expand&&(b.expand=f,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:f}}),f===1&&b.expandLevels!==void 0&&this.resolveChildren(b))}expandChildren(b,f){if(f<0)return;const c=[];for(const[v,a]of this.options.getChildren(b.actual)){const d=this.expand(I.TestId.joinToString(b.fullId,a.id),f);(0,u.isThenable)(d)&&c.push(d)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this._resolveHandler){const a=new u.Barrier;return a.open(),a}b.expand=2,this.pushExpandStateUpdate(b);const f=b.resolveBarrier=new u.Barrier,c=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let v;try{v=this._resolveHandler(b.actual===this.root?void 0:b.actual)}catch(a){c(a)}return(0,u.isThenable)(v)?v.catch(c).then(()=>{f.open(),this.updateExpandability(b)}):(f.open(),this.updateExpandability(b)),b.resolveBarrier}pushExpandStateUpdate(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}removeItem(b){const f=this.tree.get(b);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const c=[f];for(;c.length;){const v=c.pop();if(!!v){this.options.getApiFor(v.actual).listener=void 0;for(const a of v.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(v.fullId.toString());for(const[a,d]of this.options.getChildren(v.actual))c.push(this.tree.get(I.TestId.joinToString(v.fullId,d.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.diffOpEmitter.fire(b)}}e.TestItemCollection=E;class T extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=T;class _ extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=_;class g extends Error{constructor(b,f,c){super(`TestItem with ID "${b}" is from controller "${f}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=g;const p=(m,b,f)=>{let c=new Map;return{get size(){return c.size},forEach(v,a){for(const d of c.values())v.call(a,d,this)},[Symbol.iterator](){return c.entries()},replace(v){const a=new Map,d=new Set(c.keys()),o={op:5,ops:[]};for(const i of v){if(!(i instanceof f))throw new _(i.id);const s=b(i).controllerId;if(s!==m.controllerId)throw new g(i.id,s,m.controllerId);if(a.has(i.id))throw new T(i.id);a.set(i.id,i),d.delete(i.id),o.ops.push({op:0,item:i})}for(const i of d.keys())o.ops.push({op:3,id:i});m.listener?.(o),c=a},add(v){if(!(v instanceof f))throw new _(v.id);c.set(v.id,v),m.listener?.({op:0,item:v})},delete(v){c.delete(v)&&m.listener?.({op:3,id:v})},get(v){return c.get(v)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=p}),define(De[130],Ie([1,0,90]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,C=(y,I)=>{const S={controllerId:I};return t.set(y,S),S};e.createPrivateApiFor=C;const P=y=>{const I=t.get(y);if(!I)throw new u.InvalidTestItemError(y?.id||"<unknown>");return I};e.getPrivateApiFor=P}),define(De[220],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,u.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class C extends Error{constructor(y,I){super(I),this.variable=y}}e.VariableError=C}),define(De[221],Ie([1,0,9,36,12,24,10,110,185,220,8]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,_,g,p){this._contributedVariables=new Map,this._context=T,this._labelService=_,this._userHomePromise=g,p&&(this._envVariablesPromise=p.then(m=>this.prepareEnv(m)))}prepareEnv(T){if(y.isWindows){const _=Object.create(null);return Object.keys(T).forEach(g=>{_[g.toLowerCase()]=T[g]}),_}return T}resolveWithEnvironment(T,_,g){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},_?_.uri:void 0,g)}async resolveAsync(T,_){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,T?T.uri:void 0,_)}async resolveAnyBase(T,_,g,p){const m=P.deepClone(_);y.isWindows&&m.windows?Object.keys(m.windows).forEach(f=>m[f]=m.windows[f]):y.isMacintosh&&m.osx?Object.keys(m.osx).forEach(f=>m[f]=m.osx[f]):y.isLinux&&m.linux&&Object.keys(m.linux).forEach(f=>m[f]=m.linux[f]),delete m.windows,delete m.osx,delete m.linux;const b={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(b,T?T.uri:void 0,m,g,p)}async resolveAnyAsync(T,_,g){return this.resolveAnyBase(T,_,g)}async resolveAnyMap(T,_,g){const p=new Map;return{newConfig:await this.resolveAnyBase(T,_,g,p),resolvedVariables:p}}resolveWithInteractionReplace(T,_,g,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,_,g,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,_){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,_)}async recursiveResolve(T,_,g,p,m){if(C.isString(g))return this.resolveString(T,_,g,p,m);if(Array.isArray(g))return Promise.all(g.map(b=>this.recursiveResolve(T,_,b,p,m)));if(C.isObject(g)){const b=Object.create(null),f=await Promise.all(Object.keys(g).map(async c=>[await this.resolveString(T,_,c,p,m),await this.recursiveResolve(T,_,g[c],p,m)]));for(const[c,v]of f)b[c]=v;return b}return g}resolveString(T,_,g,p,m){return(0,A.replaceAsync)(g,k.VARIABLE_REGEXP,async(b,f)=>{if(f.includes(k.VARIABLE_LHS))return b;let c=await this.evaluateSingleVariable(T,b,f,_,p);return m?.set(f,c),c!==b&&C.isString(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.resolveString(T,_,c,p,m)),c})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,_,g,p,m){let b;const f=g.split(":");f.length>1&&(g=f[0],b=f[1]);const c=d=>{const o=this._context.getFilePath();if(o)return o;throw new D.VariableError(d,(0,S.localize)(0,null,_))},v=d=>{const o=c(d);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new D.VariableError(d,(0,S.localize)(1,null,_,u.basename(o)))},a=d=>{if(b){const o=this._context.getFolderUri(b);if(o)return o;throw new D.VariableError(d,(0,S.localize)(2,null,_,b))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new D.VariableError(d,(0,S.localize)(3,null,_)):new D.VariableError(d,(0,S.localize)(4,null,_))};switch(g){case"env":if(b){if(T.env){const d=T.env[y.isWindows?b.toLowerCase():b];if(C.isString(d))return d}return""}throw new D.VariableError(D.VariableKind.Env,(0,S.localize)(5,null,_));case"config":if(b){const d=this._context.getConfigurationValue(p,b);if(C.isUndefinedOrNull(d))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(6,null,_,b));if(C.isObject(d))throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(7,null,_,b));return d}throw new D.VariableError(D.VariableKind.Config,(0,S.localize)(8,null,_));case"command":return this.resolveFromMap(D.VariableKind.Command,_,b,m,"command");case"input":return this.resolveFromMap(D.VariableKind.Input,_,b,m,"input");case"extensionInstallFolder":if(b){const d=await this._context.getExtension(b);if(!d)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,_,b));return this.fsPath(d.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,_));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(a(D.VariableKind.WorkspaceFolder)));case"cwd":return p||b?(0,I.normalizeDriveLetter)(this.fsPath(a(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(a(D.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,S.localize)(11,null,_))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new D.VariableError(D.VariableKind.LineNumber,(0,S.localize)(12,null,_))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new D.VariableError(D.VariableKind.SelectedText,(0,S.localize)(13,null,_))}case"file":return c(D.VariableKind.File);case"fileWorkspaceFolder":return v(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return p||b?u.relative(this.fsPath(a(D.VariableKind.RelativeFile)),c(D.VariableKind.RelativeFile)):c(D.VariableKind.RelativeFile);case"relativeFileDirname":{const d=u.dirname(c(D.VariableKind.RelativeFileDirname));if(p||b){const o=u.relative(this.fsPath(a(D.VariableKind.RelativeFileDirname)),d);return o.length===0?".":o}return d}case"fileDirname":return u.dirname(c(D.VariableKind.FileDirname));case"fileExtname":return u.extname(c(D.VariableKind.FileExtname));case"fileBasename":return u.basename(c(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=u.basename(c(D.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-u.extname(d).length)}case"fileDirnameBasename":return u.basename(u.dirname(c(D.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||_}case"execInstallFolder":{const d=this._context.getAppRoot();return d||_}case"pathSeparator":return u.sep;default:try{const d=b?`${g}:${b}`:g;return this.resolveFromMap(D.VariableKind.Unknown,_,d,m,void 0)}catch{return _}}}}resolveFromMap(T,_,g,p,m){if(g&&p){const b=m===void 0?p[g]:p[m+":"+g];if(typeof b=="string")return b;throw new D.VariableError(T,(0,S.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[131],Ie([1,0,4,128]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var C;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var P;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var I;(function(_){_[_.MAXIMIZE=0]="MAXIMIZE",_[_.EVEN=1]="EVEN",_[_.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function D(_){const g=_;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=D;var A;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function E(_){const g=_;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=E;function T(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[222],Ie([1,0,4,131]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=C}),define(De[223],Ie([1,0,4,190]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(t.IEnvironmentService)}),define(De[224],Ie([1,0,27,3,9]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class y{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let E of k.activationEvents)E==="onUri"&&(E=`onUri:${u.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,E){this._extensionDescriptions=D(this._extensionDescriptions,E),this._extensionDescriptions=this._extensionDescriptions.concat(k);const T=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=D(this._extensionDescriptions,T.map(_=>_.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(k){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,b){this.addNode(m),this.addNode(b),this._arcs.has(m)?this._arcs.get(m).push(b):this._arcs.set(m,[b])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,b){const f=E.getArcs(m);for(let c=0;c<f.length;c++)if(!b.has(f[c]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const m of k){const b=u.ExtensionIdentifier.toKey(m.identifier);if(T.set(b,m),m.extensionDependencies)for(const f of m.extensionDependencies){const c=u.ExtensionIdentifier.toKey(f);E.addArc(b,c)}}const _=new Set;E.getNodes().filter(m=>E.getArcs(m).length===0).forEach(m=>_.add(m));const g=E.getNodes().filter(m=>!_.has(m));let p;do{p=!1;for(let m=0;m<g.length;m++){const b=g[m];E.hasOnlyGoodArcs(b,_)&&(g.splice(m,1),m--,_.add(b),p=!0)}}while(p);return g.map(m=>T.get(m))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const E=this._activationMap.get(k);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const E=this._extensionsMap.get(u.ExtensionIdentifier.toKey(k));return E||void 0}getExtensionDescriptionByUUID(k){for(const E of this._extensionsArr)if(E.uuid===k)return E}getExtensionDescriptionByIdOrUUID(k,E){return this.getExtensionDescription(k)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=y;var I;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(I||(I={}));function S(A,k){const E=A.isBuiltin?0:A.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(E!==T)return E-T;const _=C.posix.basename(A.extensionLocation.path),g=C.posix.basename(k.extensionLocation.path);return _<g?-1:_>g?1:0}function D(A,k){const E=new Set;return k.forEach(T=>E.add(u.ExtensionIdentifier.toKey(T))),A.filter(T=>!E.has(u.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[225],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var u;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(u=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class C{constructor(){this.type=2}serialize(k){k[C.ENV_KEY]="1"}}e.SocketExtHostConnection=C,C.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(A){delete A[t.ENV_KEY],delete A[C.ENV_KEY],delete A[P.ENV_KEY]}function I(A,k){y(k),A.serialize(k)}e.writeExtHostConnection=I;function S(A){if(A[t.ENV_KEY])return D(A,new t(A[t.ENV_KEY]));if(A[C.ENV_KEY])return D(A,new C);if(A[P.ENV_KEY])return D(A,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function D(A,k){return y(A),k}}),define(De[91],Ie([1,0,23]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var C;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(D){const A=u.VSBuffer.alloc(1);switch(D){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.createMessageOfType=y;function I(D,A){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.isMessageOfType=I;var S;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[92],Ie([1,0,4,3,13,25,91,85,203,24,2]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class{constructor(g,p){this.initData=g,this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=p.createLogger(A.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(g,p){const m=this.getTelemetryDetails(),b=new E(p,g,this._outputLogger,this.getBuiltInCommonProperties(g),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled});return this._telemetryLoggers.set(g.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(g,p){this._level=g,this._productConfig=p||{usage:!0,error:!0}}getBuiltInCommonProperties(g){const p={};switch(p["common.extname"]=g.name,p["common.extversion"]=g.version,p["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,p["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,p["common.vscodeversion"]=this.initData.version,p["common.isnewappinstall"]=T(this.initData.telemetryInfo.firstSessionDate),p["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case y.UIKind.Web:p["common.uikind"]="web";break;case y.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,I.getRemoteName)((0,S.cleanRemoteAuthority)(this.initData.remote.authority)),p}$onDidChangeTelemetryLevel(g){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=g;const p=this.getTelemetryDetails();this._telemetryLoggers.forEach(m=>{m.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(g,p){const m=this._telemetryLoggers.get(g.value);return m?(m.logError(p),!0):!1}};k=je([$e(0,P.IExtHostInitDataService),$e(1,C.ILoggerService)],k),e.ExtHostTelemetry=k;class E{constructor(g,p,m,b,f){this._extension=p,this._logger=m,this._commonProperties=b,this._onDidChangeEnableStates=new t.Emitter,this._appender=g,this._telemetryEnablements={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(g,p){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:g,isErrorsEnabled:p},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(g){return this._appender.ignoreBuiltInCommonProperties||(g=(0,D.mixin)(g,this._commonProperties)),this._appender.additionalCommonProperties&&(g=(0,D.mixin)(g,this._appender.additionalCommonProperties)),g=(0,S.cleanData)(g,[]),g}logEvent(g,p){g=this._extension.identifier.value+"/"+g,p=this.mixInCommonPropsAndCleanData(p||{}),this._appender.logEvent(g,p),this._logger.trace(g,p)}logUsage(g,p){!this._telemetryEnablements.isUsageEnabled||this.logEvent(g,p)}logError(g,p){!this._telemetryEnablements.isErrorsEnabled||(typeof g=="string"?this.logEvent(g,p):this._appender.logException(g,p))}get apiTelemetryLogger(){if(!this._apiObject){const g=this,p={logUsage:g.logUsage.bind(g),get isUsageEnabled(){return g._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return g._telemetryEnablements.isErrorsEnabled},logError:g.logError.bind(g),dispose:g.dispose.bind(g),onDidChangeEnableStates:g._onDidChangeEnableStates.event.bind(g)};this._apiObject=Object.freeze(p)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=E;function T(_){const g=Date.now()-new Date(_).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.isNewAppInstall=T,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(De[28],Ie([1,0,3,2,4,27,199]),function(J,e,u,t,C,P,y){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class S{constructor(l){this.affinity=l,this.kind=1}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class D{constructor(){this.kind=2,this.affinity=0}equals(l){return this.kind===l.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=D;class A{constructor(){this.kind=3,this.affinity=0}equals(l){return this.kind===l.kind}asString(){return"Remote"}}e.RemoteRunningLocation=A;class k{constructor(l){this.dependency=l}}e.MissingExtensionDependency=k;var E;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class _{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(l,n){const r=[],h=[],w=[],L=[],M=m(this._allExtensions),B=m(l),R=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this._allExtensions){const U=B.get(P.ExtensionIdentifier.toKey(V.identifier));if(!U){r.push(V.identifier),M.delete(P.ExtensionIdentifier.toKey(V.identifier));continue}if(!R(V,U)){r.push(V.identifier),M.delete(P.ExtensionIdentifier.toKey(V.identifier));continue}}for(const V of l){const U=M.get(P.ExtensionIdentifier.toKey(V.identifier));if(!U){h.push(V);continue}if(!R(U,V)){r.push(U.identifier),M.delete(P.ExtensionIdentifier.toKey(U.identifier));continue}}const z=p(this._myExtensions),H=p(n);for(const V of this._myExtensions)H.has(P.ExtensionIdentifier.toKey(V))||w.push(V);for(const V of n)z.has(P.ExtensionIdentifier.toKey(V))||L.push(V);const N={toRemove:r,toAdd:h,myToRemove:w,myToAdd:L};return this.delta(N),N}delta(l){const{toRemove:n,toAdd:r,myToRemove:h,myToAdd:w}=l,L=p(n),M=p(h);for(let B=0;B<this._allExtensions.length;B++)L.has(P.ExtensionIdentifier.toKey(this._allExtensions[B].identifier))&&(this._allExtensions.splice(B,1),B--);for(let B=0;B<this._myExtensions.length;B++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[B]))&&(this._myExtensions.splice(B,1),B--);for(const B of r)this._allExtensions.push(B);for(const B of w)this._myExtensions.push(B)}containsExtension(l){for(const n of this._myExtensions)if(P.ExtensionIdentifier.equals(n,l))return!0;return!1}}e.ExtensionHostExtensions=_;class g{constructor(l){if(this[I]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,l)for(const n of l)this.add(n)}get size(){return this._map.size}add(l){return this._map.set(this._toKey(l),l),this}clear(){this._map.clear()}delete(l){return this._map.delete(this._toKey(l))}has(l){return this._map.has(this._toKey(l))}forEach(l,n){this._map.forEach(r=>l.call(n,r,r,this))}*entries(){for(const[l,n]of this._map)yield[n,n]}keys(){return this._map.values()}values(){return this._map.values()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=g;function p(s){const l=new Set;for(const n of s)l.add(P.ExtensionIdentifier.toKey(n));return l}e.extensionIdentifiersArrayToSet=p;function m(s){const l=new Map;for(const n of s)l.set(P.ExtensionIdentifier.toKey(n.identifier),n);return l}function b(s,l){return s.enabledApiProposals?s.enabledApiProposals.includes(l):!1}e.isProposedApiEnabled=b;function f(s,l){if(!b(s,l))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=f;class c{constructor(l,n,r,h){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=h}}e.ActivationTimes=c;class v{constructor(l,n){this.description=l,this.value=n}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var a;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(a=e.ActivationKind||(e.ActivationKind={}));function d(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function o(s,l){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!l,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=o;class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l,n){return Promise.resolve(0)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(l,n){return Promise.resolve()}}e.NullExtensionService=i}),define(De[226],Ie([1,0,11,27,28,13,18]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class I{constructor(p,m,b,f){this.startup=p,this.codeLoadingTime=m,this.activateCallTime=b,this.activateResolvedTime=f}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class S{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,m){return p===-1||m===-1?-1:m-p}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class D{constructor(p,m,b,f,c,v){this.activationFailed=p,this.activationFailedError=m,this.activationTimes=b,this.module=f,this.exports=c,this.subscriptions=v}}e.ActivatedExtension=D;class A extends D{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class k extends D{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class E extends D{constructor(p){super(!0,p,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let T=class{constructor(p,m,b,f,c){this._logService=c,this._registry=p,this._resolvedExtensionsSet=new Set,m.forEach(v=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(v))),this._externalExtensionsMap=new Map,b.forEach(v=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(v),v)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[p,m]of this._operations)m.dispose()}isActivated(p){const m=this._operations.get(t.ExtensionIdentifier.toKey(p));return Boolean(m&&m.value)}getActivatedExtension(p){const m=this._operations.get(t.ExtensionIdentifier.toKey(p));if(!m||!m.value)throw new Error(`Extension '${p.value}' is not known or not activated`);return m.value}async activateByEvent(p,m){if(this._alreadyActivatedEvents[p])return;const b=this._registry.getExtensionDescriptionsForActivationEvent(p);await this._activateExtensions(b.map(f=>({id:f.identifier,reason:{startup:m,extensionId:f.identifier,activationEvent:p}}))),this._alreadyActivatedEvents[p]=!0}activateById(p,m){const b=this._registry.getExtensionDescription(p);if(!b)throw new Error(`Extension '${p}' is not known`);return this._activateExtensions([{id:b.identifier,reason:m}])}async _activateExtensions(p){const m=p.filter(b=>!this.isActivated(b.id)).map(b=>this._handleActivationRequest(b));await Promise.all(m.map(b=>b.wait()))}_handleActivationRequest(p){if(this._operations.has(t.ExtensionIdentifier.toKey(p.id)))return this._operations.get(t.ExtensionIdentifier.toKey(p.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(p.id)))return this._createAndSaveOperation(p,null,[],null);const m=this._registry.getExtensionDescription(p.id);if(!m){const c=new Error(`Cannot activate unknown extension '${p.id.value}'`),v=this._createAndSaveOperation(p,null,[],new E(c));return this._host.onExtensionActivationError(p.id,c,new C.MissingExtensionDependency(p.id.value)),v}const b=[],f=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const c of f){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(c)))continue;const v=this._operations.get(t.ExtensionIdentifier.toKey(c));if(v){b.push(v);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(c))){b.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(c)),reason:p.reason}));continue}const a=this._registry.getExtensionDescription(c);if(a){if(!a.main&&!a.browser)continue;b.push(this._handleActivationRequest({id:a.identifier,reason:p.reason}));continue}const d=m.displayName||m.identifier.value,o=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${c}'`),i=this._createAndSaveOperation(p,m.displayName,[],new E(o));return this._host.onExtensionActivationError(m.identifier,o,new C.MissingExtensionDependency(c)),i}return this._createAndSaveOperation(p,m.displayName,b,null)}_createAndSaveOperation(p,m,b,f){const c=new _(p.id,m,p.reason,b,f,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(p.id),c),c}};T=je([$e(4,P.ILogService)],T),e.ExtensionsActivator=T;let _=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(p,m,b,f,c,v,a){this._id=p,this._displayName=m,this._reason=b,this._deps=f,this._value=c,this._host=v,this._logService=a,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let p=0;p<this._deps.length;p++){const m=this._deps[p];if(m.value&&!m.value.activationFailed){this._deps.splice(p,1),p--;continue}if(m.value&&m.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);b.detail=m.value.activationFailedError,this._value=new E(b),this._host.onExtensionActivationError(this._id,b,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(p=>p.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(p){const m=new Error;if(p&&p.name&&(m.name=p.name),p&&p.message?m.message=`Activating extension '${this._id.value}' failed: ${p.message}.`:m.message=`Activating extension '${this._id.value}' failed: ${p}.`,p&&p.stack&&(m.stack=p.stack),this._value=new E(m),this._isDisposed&&u.isCancellationError(p))return;this._host.onExtensionActivationError(this._id,m,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(p)}}};_=je([$e(6,P.ILogService)],_)}),define(De[227],Ie([1,0,13,25,28]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends u.LogService{constructor(I,S){super(I.createLogger(S.logFile,{name:C.ExtensionHostLogFileName}))}};P=je([$e(0,u.ILoggerService),$e(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[7],Ie([1,0,17,11,109,26,104,8,12,2,31,38,126,89,28]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_){"use strict";var g,p,m,b,f,c,v,a,d,o,i,s,l,n,r,h,w,L,M,B,R,z,H;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function N(q){return Object.assign(q,{apply:function(){const ue=arguments.length===1?[]:arguments[1];return Reflect.construct(q,ue,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(q,[]);{const[ue,...Te]=arguments;return Reflect.construct(q,Te,ue.constructor)}}})}let V=c=class{static from(...W){let ue=W;return new c(function(){if(ue){for(const Te of ue)Te&&typeof Te.dispose=="function"&&Te.dispose();ue=void 0}})}constructor(W){g.set(this,void 0),tt(this,g,W,"f")}dispose(){typeof Be(this,g,"f")=="function"&&(Be(this,g,"f").call(this),tt(this,g,void 0,"f"))}};g=new WeakMap,V=c=je([N],V),e.Disposable=V;let U=v=class{static Min(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isBefore(ue)&&(ue=Xe)}return ue}static Max(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isAfter(ue)&&(ue=Xe)}return ue}static isPosition(W){if(!W)return!1;if(W instanceof v)return!0;const{line:ue,character:Te}=W;return typeof ue=="number"&&typeof Te=="number"}static of(W){if(W instanceof v)return W;if(this.isPosition(W))return new v(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=ue}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ue=0){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,ue=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&ue===0?this:new v(this.line+Te,this.character+ue)}with(W,ue=this.character){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,ue=typeof W.character=="number"?W.character:this.character),Te===this.line&&ue===this.character?this:new v(Te,ue)}toJSON(){return{line:this.line,character:this.character}}};U=v=je([N],U),e.Position=U;let F=a=class{static isRange(W){return W instanceof a?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof a)return W;if(this.isRange(W))return new a(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new U(W,ue),ut=new U(Te,Xe)):U.isPosition(W)&&U.isPosition(ue)&&(et=U.of(W),ut=U.of(ue)),!et||!ut)throw new Error("Invalid arguments");et.isBefore(ut)?(this._start=et,this._end=ut):(this._start=ut,this._end=et)}contains(W){return a.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ue=U.Max(W.start,this._start),Te=U.Min(W.end,this._end);if(!ue.isAfter(Te))return new a(ue,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ue=U.Min(W.start,this._start),Te=U.Max(W.end,this.end);return new a(ue,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ue=this.end){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return W?U.isPosition(W)?Te=W:(Te=W.start||this.start,ue=W.end||this.end):Te=this.start,Te.isEqual(this._start)&&ue.isEqual(this.end)?this:new a(Te,ue)}toJSON(){return[this.start,this.end]}};F=a=je([N],F),e.Range=F;let x=d=class extends F{static isSelection(W){return W instanceof d?!0:W?F.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new U(W,ue),ut=new U(Te,Xe)):U.isPosition(W)&&U.isPosition(ue)&&(et=U.of(W),ut=U.of(ue)),!et||!ut)throw new Error("Invalid arguments");super(et,ut),this._anchor=et,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=d=je([N],x),e.Selection=x;class ${constructor(W,ue,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ue),this.connectionToken=Te}}e.ResolvedAuthority=$;class Q extends Error{static NotAvailable(W,ue){return new Q(W,E.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(W){return new Q(W,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ue=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=ue,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var de;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(de=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=o=class{static isTextEdit(W){return W instanceof o?!0:W?F.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ue){return new o(W,ue)}static insert(W,ue){return o.replace(new F(W,W),ue)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const ue=new o(new F(new U(0,0),new U(0,0)),"");return ue.newEol=W,ue}get range(){return this._range}set range(W){if(W&&!F.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}constructor(W,ue){this._range=W,this._newText=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=o=je([N],ee),e.TextEdit=ee;let he=i=class{static isNotebookCellEdit(W){return W instanceof i?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ue){return new i(W,ue)}static insertCells(W,ue){return new i(new Vt(W,W),ue)}static deleteCells(W){return new i(W,[])}static updateCellMetadata(W,ue){const Te=new i(new Vt(W,W),[]);return Te.newCellMetadata=ue,Te}static updateNotebookMetadata(W){const ue=new i(new Vt(0,0),[]);return ue.newNotebookMetadata=W,ue}constructor(W,ue){this.range=W,this.newCells=ue}};he=i=je([N],he),e.NotebookEdit=he;class Y{static isSnippetTextEdit(W){return W instanceof Y?!0:W?F.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,ue){return new Y(W,ue)}static insert(W,ue){return Y.replace(new F(W,W),ue)}constructor(W,ue){this.range=W,this.snippet=ue}}e.SnippetTextEdit=Y;var me;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(me=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ue,Te,Xe){this._edits.push({_type:1,from:W,to:ue,options:Te,metadata:Xe})}createFile(W,ue,Te){this._edits.push({_type:1,from:void 0,to:W,options:ue,metadata:Te})}deleteFile(W,ue,Te){this._edits.push({_type:1,from:W,to:void 0,options:ue,metadata:Te})}replaceNotebookMetadata(W,ue,Te){this._edits.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(W,ue,Te,Xe){const et=ue.start,ut=ue.end;(et!==ut||Te.length>0)&&this._edits.push({_type:5,uri:W,index:et,count:ut-et,cells:Te,metadata:Xe})}replaceNotebookCellMetadata(W,ue,Te,Xe){this._edits.push({_type:3,metadata:Xe,uri:W,edit:{editType:8,index:ue,metadata:Te}})}replace(W,ue,Te,Xe){this._edits.push({_type:2,uri:W,edit:new ee(ue,Te),metadata:Xe})}insert(W,ue,Te,Xe){this.replace(W,new F(ue,ue),Te,Xe)}delete(W,ue,Te){this.replace(W,ue,"",Te)}has(W){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===W.toString())}set(W,ue){if(ue)for(const Te of ue){if(!Te)continue;let Xe,et;Array.isArray(Te)?(Xe=Te[0],et=Te[1]):Xe=Te,he.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.replaceNotebookCellMetadata(W,Xe.range.start,Xe.newCellMetadata,et):Xe.newNotebookMetadata?this.replaceNotebookMetadata(W,Xe.newNotebookMetadata,et):this.replaceNotebookCells(W,Xe.range,Xe.newCells,et):Y.isSnippetTextEdit(Xe)?this._edits.push({_type:6,uri:W,range:Xe.range,edit:Xe.snippet,metadata:et}):this._edits.push({_type:2,uri:W,edit:Xe,metadata:et})}else{for(let Te=0;Te<this._edits.length;Te++){const Xe=this._edits[Te];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===W.toString()&&(this._edits[Te]=void 0);break}}(0,u.coalesceInPlace)(this._edits)}}get(W){const ue=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===W.toString()&&ue.push(Te.edit);return ue}entries(){const W=new P.ResourceMap;for(const ue of this._edits)if(ue._type===2){let Te=W.get(ue.uri);Te||(Te=[ue.uri,[]],W.set(ue.uri,Te)),Te[1].push(ue.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=je([N],be),e.WorkspaceEdit=be;let ke=s=class{static isSnippetString(W){return W instanceof s?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=s._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ue=this._tabstop++){if(typeof W=="function"){const Te=new s;Te._tabstop=this._tabstop,W(Te),this._tabstop=Te._tabstop,W=Te.value}else W=s._escape(W);return this.value+="${",this.value+=ue,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ue=this._tabstop++){const Te=W.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,ue){if(typeof ue=="function"){const Te=new s;Te._tabstop=this._tabstop,ue(Te),this._tabstop=Te._tabstop,ue=Te.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};ke=s=je([N],ke),e.SnippetString=ke;var Re;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var ze;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ze=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=l=class{static isLocation(W){return W instanceof l?!0:W?F.isRange(W.range)&&D.URI.isUri(W.uri):!1}constructor(W,ue){if(this.uri=W,ue)if(F.isRange(ue))this.range=F.of(ue);else if(U.isPosition(ue))this.range=new F(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};oe=l=je([N],oe),e.Location=oe;let le=class{static is(W){return W?typeof W.message=="string"&&W.location&&F.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}constructor(W,ue){this.location=W,this.message=ue}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.location.range.isEqual(ue.location.range)&&W.location.uri.toString()===ue.location.uri.toString()}};le=je([N],le),e.DiagnosticRelatedInformation=le;let ge=class{constructor(W,ue,Te=ze.Error){if(!F.isRange(W))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=W,this.message=ue,this.severity=Te}toJSON(){return{severity:ze[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.severity===ue.severity&&W.code===ue.code&&W.severity===ue.severity&&W.source===ue.source&&W.range.isEqual(ue.range)&&(0,u.equals)(W.tags,ue.tags)&&(0,u.equals)(W.relatedInformation,ue.relatedInformation,le.isEqual)}};ge=je([N],ge),e.Diagnostic=ge;let Z=class{constructor(W,ue){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ue}};Z=je([N],Z),e.Hover=Z;var ae;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(W,ue=ae.Text){this.range=W,this.kind=ue}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ne=je([N],ne),e.DocumentHighlight=ne;var ie;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var O;(function(q){q[q.Deprecated=1]="Deprecated"})(O=e.SymbolTag||(e.SymbolTag={}));let j=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ue,Te,Xe,et){this.name=W,this.kind=ue,this.containerName=et,typeof Te=="string"&&(this.containerName=Te),Xe instanceof oe?this.location=Xe:Te instanceof F&&(this.location=new oe(Xe,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};j=n=je([N],j),e.SymbolInformation=j;let G=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(r.validate)}constructor(W,ue,Te,Xe,et){this.name=W,this.detail=ue,this.kind=Te,this.range=Xe,this.selectionRange=et,this.children=[],r.validate(this)}};G=r=je([N],G),e.DocumentSymbol=G;var X;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,ue){this.title=W,this.kind=ue}};pe=je([N],pe),e.CodeAction=pe;let we=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.sep)}};we.sep=".",we=h=je([N],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ce=class{constructor(W,ue){if(this.range=W,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=je([N],ce),e.SelectionRange=ce;class Ce{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.CallHierarchyItem=Ce;class ye{constructor(W,ue){this.fromRanges=ue,this.from=W}}e.CallHierarchyIncomingCall=ye;class We{constructor(W,ue){this.fromRanges=ue,this.to=W}}e.CallHierarchyOutgoingCall=We;var qe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,ue){this.range=W,this.command=ue}get isResolved(){return!!this.command}};Ze=je([N],Ze),e.CodeLens=Ze;let Ye=w=class{static isMarkdownString(W){return W instanceof w?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ue=!1){p.set(this,void 0),tt(this,p,new C.MarkdownString(W,{supportThemeIcons:ue}),"f")}get value(){return Be(this,p,"f").value}set value(W){Be(this,p,"f").value=W}get isTrusted(){return Be(this,p,"f").isTrusted}set isTrusted(W){Be(this,p,"f").isTrusted=W}get supportThemeIcons(){return Be(this,p,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,p,"f").supportThemeIcons=W}get supportHtml(){return Be(this,p,"f").supportHtml}set supportHtml(W){Be(this,p,"f").supportHtml=W}get baseUri(){return Be(this,p,"f").baseUri}set baseUri(W){Be(this,p,"f").baseUri=W}appendText(W){return Be(this,p,"f").appendText(W),this}appendMarkdown(W){return Be(this,p,"f").appendMarkdown(W),this}appendCodeblock(W,ue){return Be(this,p,"f").appendCodeblock(ue??"",W),this}};p=new WeakMap,Ye=w=je([N],Ye),e.MarkdownString=Ye;let Ne=class{constructor(W,ue){this.label=W,this.documentation=ue}};Ne=je([N],Ne),e.ParameterInformation=Ne;let at=class{constructor(W,ue){this.label=W,this.documentation=ue,this.parameters=[]}};at=je([N],at),e.SignatureInformation=at;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=je([N],re),e.SignatureHelp=re;var se;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Ve=class{constructor(W){this.value=W}};Ve=je([N],Ve),e.InlayHintLabelPart=Ve;let fe=class{constructor(W,ue,Te){this.position=W,this.label=ue,this.kind=Te}};fe=je([N],fe),e.InlayHint=fe;var Ae;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Me;(function(q){q[q.Deprecated=1]="Deprecated"})(Me=e.CompletionItemTag||(e.CompletionItemTag={}));let Ke=class{constructor(W,ue){this.label=W,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ke=je([N],Ke),e.CompletionItem=Ke;let Je=class{constructor(W=[],ue=!1){this.items=W,this.isIncomplete=ue}};Je=je([N],Je),e.CompletionList=Je;let st=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};st=je([N],st),e.InlineSuggestion=st;let ot=class{constructor(W){this.commands=void 0,this.items=W}};ot=je([N],ot),e.InlineSuggestionList=ot;let it=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};it=je([N],it),e.InlineSuggestionNew=it;let lt=class{constructor(W,ue){this.items=W,this.commands=ue}};lt=je([N],lt),e.InlineSuggestionsNew=lt;var vt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(vt=e.ViewColumn||(e.ViewColumn={}));var wt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(wt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Et;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function W(ue){switch(ue){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ot=class{constructor(W,ue){if(ue&&!D.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=ue}};Ot=je([N],Ot),e.DocumentLink=Ot;let Pt=class{constructor(W,ue,Te,Xe){this.red=W,this.green=ue,this.blue=Te,this.alpha=Xe}};Pt=je([N],Pt),e.Color=Pt;let gt=class{constructor(W,ue){if(ue&&!(ue instanceof Pt))throw(0,t.illegalArgument)("color");if(!F.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=ue}};gt=je([N],gt),e.ColorInformation=gt;let kt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};kt=je([N],kt),e.ColorPresentation=kt;var Pe;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Pe=e.ColorFormat||(e.ColorFormat={}));var Oe;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Oe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class te{constructor(W,ue,Te){if(this.startIndex=W,this.length=ue,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=te;var Fe;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Fe=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=xe;var nt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var Ge;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ge=e.TaskPanelKind||(e.TaskPanelKind={}));let rt=L=class{static from(W){switch(W){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(W,ue){if(this.label=ue,typeof W!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=W}get id(){return this._id}};rt.Clean=new L("clean","Clean"),rt.Build=new L("build","Build"),rt.Rebuild=new L("rebuild","Rebuild"),rt.Test=new L("test","Test"),rt=L=je([N],rt),e.TaskGroup=rt;function pt(q){let W="";for(let ue=0;ue<q.length;ue++)W+=q[ue].replace(/,/g,",,")+",";return W}let St=class{constructor(W,ue,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Te):this._options=ue)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ue of this._args)W.push(ue);return pt(W)}};St=je([N],St),e.ProcessExecution=St;let Tt=class{constructor(W,ue,Te){if(this._args=[],Array.isArray(ue)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=ue,this._options=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ue of this._args)W.push(typeof ue=="string"?ue:ue.value);return pt(W)}};Tt=je([N],Tt),e.ShellExecution=Tt;var It;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class bt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=bt;let Ct=M=class{constructor(W,ue,Te,Xe,et,ut){this.__deprecated=!1,this._definition=this.definition=W;let ht;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Te,this.execution=Xe,ht=et,this.__deprecated=!0):ue===_t.Global||ue===_t.Workspace?(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ht=ut):(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof St?this._definition={type:M.ProcessType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:M.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:M.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:M.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ue=this._definition.type;(M.EmptyType===ue||M.ProcessType===ue||M.ShellType===ue||M.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};Ct.ExtensionCallbackType="customExecution",Ct.ProcessType="process",Ct.ShellType="shell",Ct.EmptyType="$empty",Ct=M=je([N],Ct),e.Task=Ct;var en;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(en=e.ProgressLocation||(e.ProgressLocation={}));var yt;(function(q){function W(ue){const Te=ue;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}q.isViewBadge=W})(yt=e.ViewBadge||(e.ViewBadge={}));let qt=B=class{static isTreeItem(W,ue){if(W instanceof B)return!0;const Te=W;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Xe=Te.iconPath;if(!Xe||!(0,S.isString)(Xe.light)&&!D.URI.isUri(Xe.light)&&!(0,S.isString)(Xe.dark)&&!D.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof Ye))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Ht.None&&Te.collapsibleState>Ht.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,_.checkProposedApiEnabled)(ue,"treeItemCheckbox");const Xe=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,et=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==tn.Checked&&Xe!==tn.Unchecked||et!==void 0&&!(0,S.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,ue=Ht.None){this.collapsibleState=ue,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};qt=B=je([N],qt),e.TreeItem=qt;var Ht;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var tn;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(tn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let un=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,ue){this.value=W,this.id=ue??(0,A.generateUuid)()}};un=je([N],un),e.DataTransferItem=un;let At=class{constructor(W){m.set(this,new Map);for(const[ue,Te]of W??[]){const Xe=Be(this,m,"f").get(ue);Xe?Xe.push(Te):Be(this,m,"f").set(ue,[Te])}}get(W){return Be(this,m,"f").get(W)?.[0]}set(W,ue){Be(this,m,"f").set(W,[ue])}forEach(W,ue){for(const[Te,Xe]of Be(this,m,"f"))for(const et of Xe)W.call(ue,et,Te,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[W,ue]of Be(this,m,"f"))for(const Te of ue)yield[W,Te]}};At=je([N],At),e.DataTransfer=At;let nn=class{constructor(W){this.insertText=W}};nn=je([N],nn),e.DocumentDropEdit=nn;let dn=class{constructor(W){this.insertText=W}};dn=je([N],dn),e.DocumentPasteEdit=dn;let Ut=class{constructor(W,ue){this.id=W,this.color=ue}};Ut=je([N],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let Jt=class{constructor(W){this.id=W}};Jt=je([N],Jt),e.ThemeColor=Jt;var dt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(dt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let hn=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=D.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,ue){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=D.URI.file(W):D.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};hn=je([N],hn),e.RelativePattern=hn;let Nt=class{constructor(W,ue,Te,Xe){this.enabled=typeof W=="boolean"?W:!0,typeof ue=="string"&&(this.condition=ue),typeof Te=="string"&&(this.hitCondition=Te),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Nt=je([N],Nt),e.Breakpoint=Nt;let Gt=class extends Nt{constructor(W,ue,Te,Xe,et){if(super(ue,Te,Xe,et),W===null)throw(0,t.illegalArgument)("location");this.location=W}};Gt=je([N],Gt),e.SourceBreakpoint=Gt;let rn=class extends Nt{constructor(W,ue,Te,Xe,et){super(ue,Te,Xe,et),this.functionName=W}};rn=je([N],rn),e.FunctionBreakpoint=rn;let fn=class extends Nt{constructor(W,ue,Te,Xe,et,ut,ht){if(super(Xe,et,ut,ht),!ue)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=ue,this.canPersist=Te}};fn=je([N],fn),e.DataBreakpoint=fn;let sn=class{constructor(W,ue,Te){this.command=W,this.args=ue||[],this.options=Te}};sn=je([N],sn),e.DebugAdapterExecutable=sn;let mn=class{constructor(W,ue){this.port=W,this.host=ue}};mn=je([N],mn),e.DebugAdapterServer=mn;let on=class{constructor(W){this.path=W}};on=je([N],on),e.DebugAdapterNamedPipeServer=on;let Zt=class{constructor(W){this.implementation=W}};Zt=je([N],Zt),e.DebugAdapterInlineImplementation=Zt;let gn=class{constructor(W,ue){this.range=W,this.expression=ue}};gn=je([N],gn),e.EvaluatableExpression=gn;var pn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(pn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var vn;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(vn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let bn=class{constructor(W,ue){this.range=W,this.text=ue}};bn=je([N],bn),e.InlineValueText=bn;let wn=class{constructor(W,ue,Te=!0){this.range=W,this.variableName=ue,this.caseSensitiveLookup=Te}};wn=je([N],wn),e.InlineValueVariableLookup=wn;let Kt=class{constructor(W,ue){this.range=W,this.expression=ue}};Kt=je([N],Kt),e.InlineValueEvaluatableExpression=Kt;let En=class{constructor(W,ue){this.frameId=W,this.stoppedLocation=ue}};En=je([N],En),e.InlineValueContext=En;var Fn;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let Sn=R=class extends Error{static FileExists(W){return new R(W,k.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(W){return new R(W,k.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(W){return new R(W,k.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(W){return new R(W,k.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(W){return new R(W,k.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(W){return new R(W,k.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(W,ue=k.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Sn=R=je([N],Sn),e.FileSystemError=Sn;let _n=class{constructor(W,ue,Te){this.start=W,this.end=ue,this.kind=Te}};_n=je([N],_n),e.FoldingRange=_n;var yn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(yn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Tn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Tn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Pn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Pn=e.CommentMode||(e.CommentMode={}));var He;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(He=e.CommentThreadState||(e.CommentThreadState={}));class xt{constructor(W,ue=[]){this.tokenTypes=W,this.tokenModifiers=ue}}e.SemanticTokensLegend=xt;function An(q){return typeof q>"u"||(0,S.isStringArray)(q)}class mt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ue=0,Te=W.tokenTypes.length;ue<Te;ue++)this._tokenTypeStrToInt.set(W.tokenTypes[ue],ue);for(let ue=0,Te=W.tokenModifiers.length;ue<Te;ue++)this._tokenModifierStrToInt.set(W.tokenModifiers[ue],ue)}}push(W,ue,Te,Xe,et){if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(W,ue,Te,Xe,et);if(F.isRange(W)&&typeof ue=="string"&&An(Te))return this._push(W,ue,Te);throw(0,t.illegalArgument)()}_push(W,ue,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const Xe=W.start.line,et=W.start.character,ut=W.end.character-W.start.character,ht=this._tokenTypeStrToInt.get(ue);let Lt=0;if(Te)for(const Wt of Te){if(!this._tokenModifierStrToInt.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Wt);Lt|=1<<$t>>>0}this._pushEncoded(Xe,et,ut,ht,Lt)}_pushEncoded(W,ue,Te,Xe,et){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Lt=this._data.length/5|0;let Wt=0,$t=0;for(let jt=0;jt<Lt;jt++){let Qt=this._data[5*jt],In=this._data[5*jt+1];Qt===0?(Qt=Wt,In+=$t):Qt+=Wt,this._data[5*jt]=Qt,this._data[5*jt+1]=In,Wt=Qt,$t=In}}let ut=W,ht=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=et,this._prevLine=W,this._prevChar=ue}static _sortAndDeltaEncode(W){const ue=[],Te=W.length/5|0;for(let ht=0;ht<Te;ht++)ue[ht]=ht;ue.sort((ht,Lt)=>{const Wt=W[5*ht],$t=W[5*Lt];if(Wt===$t){const jt=W[5*ht+1],Qt=W[5*Lt+1];return jt-Qt}return Wt-$t});const Xe=new Uint32Array(W.length);let et=0,ut=0;for(let ht=0;ht<Te;ht++){const Lt=5*ue[ht],Wt=W[Lt+0],$t=W[Lt+1],jt=W[Lt+2],Qt=W[Lt+3],In=W[Lt+4],Jn=Wt-et,Di=Jn===0?$t-ut:$t,kn=5*ht;Xe[kn+0]=Jn,Xe[kn+1]=Di,Xe[kn+2]=jt,Xe[kn+3]=Qt,Xe[kn+4]=In,et=Wt,ut=$t}return Xe}build(W){return this._dataIsSortedAndDeltaEncoded?new Cn(new Uint32Array(this._data),W):new Cn(mt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=mt;class Cn{constructor(W,ue){this.resultId=ue,this.data=W}}e.SemanticTokens=Cn;class Mn{constructor(W,ue,Te){this.start=W,this.deleteCount=ue,this.data=Te}}e.SemanticTokensEdit=Mn;class Rn{constructor(W,ue){this.resultId=ue,this.edits=W}}e.SemanticTokensEdits=Rn;var Un;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Un=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Ut("arrow-left")},Xt=je([N],Xt),e.QuickInputButtons=Xt;var Bn;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(Bn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Wn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Wn=e.ExtensionKind||(e.ExtensionKind={}));class Ln{static validate(W){if(W.badge){let ue=(0,I.nextCharLength)(W.badge,0);if(ue<W.badge.length&&(ue+=(0,I.nextCharLength)(W.badge,ue)),W.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ue,Te){this.badge=W,this.tooltip=ue,this.color=Te}}e.FileDecoration=Ln;let Dn=class{constructor(W){this.kind=W}};Dn=je([N],Dn),e.ColorTheme=Dn;var Hn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(Hn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");W<=ue?(this._start=W,this._end=ue):(this._start=ue,this._end=W)}with(W){let ue=this._start,Te=this._end;return W.start!==void 0&&(ue=W.start),W.end!==void 0&&(Te=W.end),ue===this._start&&Te===this._end?this:new Vt(ue,Te)}}e.NotebookRange=Vt;class an{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ue=>an.isNotebookCellData(ue))}static isNotebookCellData(W){return!0}constructor(W,ue,Te,Xe,et,ut,ht){this.kind=W,this.value=ue,this.languageId=Te,this.mime=Xe,this.outputs=et??[],this.metadata=ut,this.executionSummary=ht,an.validate(this)}}e.NotebookCellData=an;class $n{constructor(W){this.cells=W}}e.NotebookData=$n;class Bt{static isNotebookCellOutputItem(W){return W instanceof Bt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ue={name:W.name,message:W.message,stack:W.stack};return Bt.json(ue,"application/vnd.code.notebook.error")}static stdout(W){return Bt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Bt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ue="application/octet-stream"){return new Bt(W,ue)}static text(W,ue=y.Mimes.text){const Te=Be(Bt,b,"f",f).encode(String(W));return new Bt(Te,ue)}static json(W,ue="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return Bt.text(Te,ue)}constructor(W,ue){this.data=W,this.mime=ue;const Te=(0,y.normalizeMimeType)(ue,!0);if(!Te)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Bt,b=Bt,f={value:new TextEncoder};class ve{static isNotebookCellOutput(W){return W instanceof ve?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ue=!1){const Te=new Set,Xe=new Set;for(let et=0;et<W.length;et++){const ut=W[et],ht=(0,y.normalizeMimeType)(ut.mime);if(!Te.has(ht)||(0,T.isTextStreamMime)(ht)){Te.add(ht);continue}Xe.add(et),ue&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Xe.size===0?W:W.filter((et,ut)=>!Xe.has(ut))}constructor(W,ue,Te){this.items=ve.ensureUniqueMimeTypes(W,!0),typeof ue=="string"?(this.id=ue,this.metadata=Te):(this.id=(0,A.generateUuid)(),this.metadata=ue??Te)}}e.NotebookCellOutput=ve;var Se;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Se=e.NotebookCellKind||(e.NotebookCellKind={}));var Ue;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Ue=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ct;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ct=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Dt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Rt{constructor(W,ue){this.text=W,this.alignment=ue}}e.NotebookCellStatusBarItem=Rt;var ni;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(ni=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ii;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(ii=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ri{constructor(W,ue=[]){this.uri=W,this.provides=(0,u.asArray)(ue)}}e.NotebookRendererScript=ri;let xn=class{constructor(W,ue){this.label=W,this.timestamp=ue}};xn=je([N],xn),e.TimelineItem=xn;var si;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(W,ue){this.ranges=W,this.wordPattern=ue}}e.LinkedEditingRanges=ci;class li{constructor(W,ue){this._port=W,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=li;var ui;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vn=class{constructor(W=void 0,ue=void 0,Te=void 0){this.include=W,this.exclude=ue,this.profile=Te}};Vn=je([N],Vn),e.TestRunRequest=Vn;let jn=z=class{static diff(W,ue,Te){const Xe=new z(W);return Xe.expectedOutput=ue,Xe.actualOutput=Te,Xe}constructor(W){this.message=W}};jn=z=je([N],jn),e.TestMessage=jn;let qn=class{constructor(W){this.id=W}};qn=je([N],qn),e.TestTag=qn;let cn=class{constructor(W,ue){this.covered=W,this.total=ue}};cn=je([N],cn),e.CoveredCount=cn;let Gn=H=class{static fromDetails(W,ue){const Te=new cn(0,0),Xe=new cn(0,0),et=new cn(0,0);for(const ht of ue)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const Lt of ht.branches)Xe.total+=1,Xe.covered+=Lt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ut=new H(W,Te,Xe.total>0?Xe:void 0,et.total>0?et:void 0);return ut.detailedCoverage=ue,ut}constructor(W,ue,Te,Xe){this.uri=W,this.statementCoverage=ue,this.branchCoverage=Te,this.functionCoverage=Xe}};Gn=H=je([N],Gn),e.FileCoverage=Gn;let Kn=class{constructor(W,ue,Te=[]){this.executionCount=W,this.location=ue,this.branches=Te}};Kn=je([N],Kn),e.StatementCoverage=Kn;let Xn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Xn=je([N],Xn),e.BranchCoverage=Xn;let Qn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Qn=je([N],Qn),e.FunctionCoverage=Qn;var hi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.TypeHierarchyItem=gi;class pi{constructor(W){this.uri=W}}e.TextTabInput=pi;class vi{constructor(W,ue){this.original=W,this.modified=ue}}e.TextDiffTabInput=vi;class bi{constructor(W,ue,Te,Xe){this.base=W,this.input1=ue,this.input2=Te,this.result=Xe}}e.TextMergeTabInput=bi;class wi{constructor(W,ue){this.uri=W,this.viewType=ue}}e.CustomEditorTabInput=wi;class Ei{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ei;class Si{constructor(W,ue){this.uri=W,this.notebookType=ue}}e.NotebookEditorTabInput=Si;class _i{constructor(W,ue,Te){this.original=W,this.modified=ue,this.notebookType=Te}}e.NotebookDiffEditorTabInput=_i;class yi{constructor(){}}e.TerminalEditorTabInput=yi;class Ci{constructor(W,ue){this.uri=W,this.inputBoxUri=ue}}e.InteractiveWindowInput=Ci}),define(De[132],Ie([1,0,48,14,8,159,102,7,17]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function A(_,g){g?D.set(_,g):D.delete(_)}e.setWordDefinitionFor=A;function k(_){return D.get(_)}e.getWordDefinitionFor=k;class E extends P.MirrorTextModel{constructor(g,p,m,b,f,c,v,a){super(p,m,b,f),this._proxy=g,this._languageId=c,this._isDirty=v,this.notebook=a,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,S.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},save(){return g._save()},getText(p){return p?g._getTextInRange(p):g.getText()},get eol(){return g._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(p){return g._lineAt(p)},offsetAt(p){return g._offsetAt(p)},positionAt(p){return g._positionAt(p)},validateRange(p){return g._validateRange(p)},validatePosition(p){return g._validatePosition(p)},getWordRangeAtPosition(p,m){return g._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,u.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,u.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const p=this._validateRange(g);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,b=p.start.line,f=p.end.line,c=[];c.push(this._lines[b].substring(p.start.character));for(let v=b+1;v<f;v++)c.push(this._lines[v]);return c.push(this._lines[f].substring(0,p.end.character)),c.join(m)}_lineAt(g){let p;if(g instanceof I.Position?p=g.line:typeof g=="number"&&(p=g),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new T(p,this._lines[p],p===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(g),m=this._lines[p.index].length;return new I.Position(p.index,Math.min(p.remainder,m))}_validateRange(g){if(!(g instanceof I.Range))throw new Error("Invalid argument");const p=this._validatePosition(g.start),m=this._validatePosition(g.end);return p===g.start&&m===g.end?g:new I.Range(p.line,p.character,m.line,m.character)}_validatePosition(g){if(!(g instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:p,character:m}=g,b=!1;if(p<0)p=0,m=0,b=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,b=!0;else{const f=this._lines[p].length;m<0?(m=0,b=!0):m>f&&(m=f,b=!0)}return b?new I.Position(p,m):g}_getWordRangeAtPosition(g,p){const m=this._validatePosition(g);if(!p)p=k(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const b=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(p),this._lines[m.line],0);if(b)return new I.Range(m.line,b.startColumn-1,m.line,b.endColumn-1)}}e.ExtHostDocumentData=E;class T{constructor(g,p,m){this._line=g,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[228],Ie([1,0,7,16,3]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(I){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let S;switch(I){case"light":S=u.ColorThemeKind.Light;break;case"hcDark":S=u.ColorThemeKind.HighContrast;break;case"hcLight":S=u.ColorThemeKind.HighContrastLight;break;default:S=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[15],Ie([1,0,17,23,109,26,144,81,24,12,2,35,64,121,130,128,89,55,66,222,7,60]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Pe){function Oe(te){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:nt,positionColumn:Ge}=te,rt=new c.Position(Fe-1,xe-1),pt=new c.Position(nt-1,Ge-1);return new c.Selection(rt,pt)}Pe.to=Oe;function _e(te){const{anchor:Fe,active:xe}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Pe.from=_e})(a=e.Selection||(e.Selection={}));var d;(function(Pe){function Oe(te){if(!te)return;const{start:Fe,end:xe}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Pe.from=Oe;function _e(te){if(!te)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:nt,endColumn:Ge}=te;return new c.Range(Fe-1,xe-1,nt-1,Ge-1)}Pe.to=_e})(d=e.Range||(e.Range={}));var o;(function(Pe){function Oe(_e){switch(_e){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Pe.to=Oe})(o=e.TokenType||(e.TokenType={}));var i;(function(Pe){function Oe(te){return new c.Position(te.lineNumber-1,te.column-1)}Pe.to=Oe;function _e(te){return{lineNumber:te.line+1,column:te.character+1}}Pe.from=_e})(i=e.Position||(e.Position={}));var s;(function(Pe){function Oe(Fe,xe){return(0,u.coalesce)((0,u.asArray)(Fe).map(nt=>_e(nt,xe)))}Pe.from=Oe;function _e(Fe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,xe),pattern:Ee.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function te(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var l;(function(Pe){function Oe(te){switch(te){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Pe.to=_e})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(Pe){function Oe(te){let Fe;return te.code&&((0,D.isString)(te.code)||(0,D.isNumber)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...d.from(te.range),message:te.message,source:te.source,code:Fe,severity:h.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(r.from),tags:Array.isArray(te.tags)?(0,u.coalesce)(te.tags.map(l.from)):void 0}}Pe.from=Oe;function _e(te){const Fe=new c.Diagnostic(d.to(te),te.message,h.to(te.severity));return Fe.source=te.source,Fe.code=(0,D.isString)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(r.to),Fe.tags=te.tags&&(0,u.coalesce)(te.tags.map(l.to)),Fe}Pe.to=_e})(n=e.Diagnostic||(e.Diagnostic={}));var r;(function(Pe){function Oe(te){return{...d.from(te.location.range),message:te.message,resource:te.location.uri}}Pe.from=Oe;function _e(te){return new c.DiagnosticRelatedInformation(new c.Location(te.resource,d.to(te)),te.message)}Pe.to=_e})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Pe){function Oe(te){switch(te){case c.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Pe.from=Oe;function _e(te){switch(te){case T.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Pe.to=_e})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var w;(function(Pe){function Oe(te){return typeof te=="number"&&te>=c.ViewColumn.One?te-1:te===c.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Pe.from=Oe;function _e(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=_e})(w=e.ViewColumn||(e.ViewColumn={}));function L(Pe){return typeof Pe.range<"u"}function M(Pe){return Pe.length===0?!0:!!L(Pe[0])}e.isDecorationOptionsArr=M;var B;(function(Pe){function Oe(Ge){return Ge.map(Pe.from)}Pe.fromMany=Oe;function _e(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function te(Ge){let rt;if(_e(Ge)){const{language:It,value:_t}=Ge;rt={value:"```"+It+`
`+_t+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const pt=Object.create(null);rt.uris=pt;const St=It=>{try{let _t=A.URI.parse(It,!0);_t=_t.with({query:Fe(_t.query,pt)}),pt[It]=_t}catch{}return""},Tt=new y.marked.Renderer;return Tt.link=St,Tt.image=It=>typeof It=="string"?St(C.parseHrefAndDimensions(It).href):"",(0,y.marked)(rt.value,{renderer:Tt}),rt}Pe.from=te;function Fe(Ge,rt){if(!Ge)return Ge;let pt;try{pt=(0,I.parse)(Ge)}catch{}if(!pt)return Ge;let St=!1;return pt=(0,S.cloneAndChange)(pt,Tt=>{if(A.URI.isUri(Tt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[It]=Tt,St=!0,It}else return}),St?JSON.stringify(pt):Ge}function xe(Ge){const rt=new c.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt.supportHtml=Ge.supportHtml,rt.baseUri=Ge.baseUri?A.URI.from(Ge.baseUri):void 0,rt}Pe.to=xe;function nt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Pe.from(Ge)}Pe.fromStrict=nt})(B=e.MarkdownString||(e.MarkdownString={}));function R(Pe){return M(Pe)?Pe.map(Oe=>({range:d.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?B.fromMany(Oe.hoverMessage):Oe.hoverMessage?B.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Pe.map(Oe=>({range:d.from(Oe)}))}e.fromRangeOrRangeWithMessage=R;function z(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?A.URI.file(Pe):Pe}e.pathOrURIToURI=z;var H;(function(Pe){function Oe(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?z(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Pe.from=Oe})(H=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Pe){function Oe(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Pe.from=Oe})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Pe){function Oe(_e){if(typeof _e>"u")return _e;switch(_e){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Oe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(Pe){function Oe(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?V.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?N.from(_e.light):void 0,dark:_e.dark?N.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Pe.from=Oe})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(Pe){function Oe(te){return{text:te.newText,eol:te.newEol&&Ye.from(te.newEol),range:d.from(te.range)}}Pe.from=Oe;function _e(te){const Fe=new c.TextEdit(d.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:Ye.to(te.eol),Fe}Pe.to=_e})(F=e.TextEdit||(e.TextEdit={}));var x;(function(Pe){function Oe(te,Fe){const xe={edits:[]};if(te instanceof c.WorkspaceEdit){const nt=new P.ResourceSet;for(const Ge of te._allEntries())Ge._type===1&&A.URI.isUri(Ge.to)&&Ge.from===void 0&&nt.add(Ge.to);for(const Ge of te._allEntries())Ge._type===1?xe.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?xe.edits.push({resource:Ge.uri,textEdit:F.from(Ge.edit),versionId:nt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?xe.edits.push({resource:Ge.uri,textEdit:{range:d.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:nt.has(Ge.uri)?void 0:Fe?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&xe.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Je.from)}})}return xe}Pe.from=Oe;function _e(te){const Fe=new c.WorkspaceEdit;for(const xe of te.edits)xe.textEdit?Fe.replace(A.URI.revive(xe.resource),d.to(xe.textEdit.range),xe.textEdit.text):Fe.renameFile(A.URI.revive(xe.oldResource),A.URI.revive(xe.newResource),xe.options);return Fe}Pe.to=_e})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(Pe){const Oe=Object.create(null);Oe[c.SymbolKind.File]=0,Oe[c.SymbolKind.Module]=1,Oe[c.SymbolKind.Namespace]=2,Oe[c.SymbolKind.Package]=3,Oe[c.SymbolKind.Class]=4,Oe[c.SymbolKind.Method]=5,Oe[c.SymbolKind.Property]=6,Oe[c.SymbolKind.Field]=7,Oe[c.SymbolKind.Constructor]=8,Oe[c.SymbolKind.Enum]=9,Oe[c.SymbolKind.Interface]=10,Oe[c.SymbolKind.Function]=11,Oe[c.SymbolKind.Variable]=12,Oe[c.SymbolKind.Constant]=13,Oe[c.SymbolKind.String]=14,Oe[c.SymbolKind.Number]=15,Oe[c.SymbolKind.Boolean]=16,Oe[c.SymbolKind.Array]=17,Oe[c.SymbolKind.Object]=18,Oe[c.SymbolKind.Key]=19,Oe[c.SymbolKind.Null]=20,Oe[c.SymbolKind.EnumMember]=21,Oe[c.SymbolKind.Struct]=22,Oe[c.SymbolKind.Event]=23,Oe[c.SymbolKind.Operator]=24,Oe[c.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Pe.from=_e;function te(Fe){for(const xe in Oe)if(Oe[xe]===Fe)return Number(xe);return c.SymbolKind.Property}Pe.to=te})($=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Pe){function Oe(te){switch(te){case c.SymbolTag.Deprecated:return 1}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.SymbolTag.Deprecated}}Pe.to=_e})(Q=e.SymbolTag||(e.SymbolTag={}));var K;(function(Pe){function Oe(te){return{name:te.name,kind:$.from(te.kind),tags:te.tags&&te.tags.map(Q.from),containerName:te.containerName,location:me.from(te.location)}}Pe.from=Oe;function _e(te){const Fe=new c.SymbolInformation(te.name,$.to(te.kind),te.containerName,me.to(te.location));return Fe.tags=te.tags&&te.tags.map(Q.to),Fe}Pe.to=_e})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Pe){function Oe(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:d.from(te.range),selectionRange:d.from(te.selectionRange),kind:$.from(te.kind),tags:te.tags?.map(Q.from)??[]};return te.children&&(Fe.children=te.children.map(Oe)),Fe}Pe.from=Oe;function _e(te){const Fe=new c.DocumentSymbol(te.name,te.detail,$.to(te.kind),d.to(te.range),d.to(te.selectionRange));return(0,u.isNonEmptyArray)(te.tags)&&(Fe.tags=te.tags.map(Q.to)),te.children&&(Fe.children=te.children.map(_e)),Fe}Pe.to=_e})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ee;(function(Pe){function Oe(te){const Fe=new c.CallHierarchyItem($.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Oe;function _e(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:te.name,detail:te.detail,kind:$.from(te.kind),uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Pe.from=_e})(ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(Pe){function Oe(_e){return new c.CallHierarchyIncomingCall(ee.to(_e.from),_e.fromRanges.map(te=>d.to(te)))}Pe.to=Oe})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Pe){function Oe(_e){return new c.CallHierarchyOutgoingCall(ee.to(_e.to),_e.fromRanges.map(te=>d.to(te)))}Pe.to=Oe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var me;(function(Pe){function Oe(te){return{range:te.range&&d.from(te.range),uri:te.uri}}Pe.from=Oe;function _e(te){return new c.Location(A.URI.revive(te.uri),d.to(te.range))}Pe.to=_e})(me=e.location||(e.location={}));var be;(function(Pe){function Oe(te){const Fe=te,xe=te;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:d.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Pe.from=Oe;function _e(te){return{targetUri:A.URI.revive(te.uri),targetRange:d.to(te.range),targetSelectionRange:te.targetSelectionRange?d.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?d.to(te.originSelectionRange):void 0}}Pe.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Pe){function Oe(te){return{range:d.from(te.range),contents:B.fromMany(te.contents)}}Pe.from=Oe;function _e(te){return new c.Hover(te.contents.map(B.to),d.to(te.range))}Pe.to=_e})(ke=e.Hover||(e.Hover={}));var Re;(function(Pe){function Oe(te){return{range:d.from(te.range),expression:te.expression}}Pe.from=Oe;function _e(te){return new c.EvaluatableExpression(d.to(te.range),te.expression)}Pe.to=_e})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ze;(function(Pe){function Oe(te){if(te instanceof c.InlineValueText)return{type:"text",range:d.from(te.range),text:te.text};if(te instanceof c.InlineValueVariableLookup)return{type:"variable",range:d.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Oe;function _e(te){switch(te.type){case"text":return{range:d.to(te.range),text:te.text};case"variable":return{range:d.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:d.to(te.range),expression:te.expression}}}Pe.to=_e})(ze=e.InlineValue||(e.InlineValue={}));var oe;(function(Pe){function Oe(te){return{frameId:te.frameId,stoppedLocation:d.from(te.stoppedLocation)}}Pe.from=Oe;function _e(te){return new c.InlineValueContext(te.frameId,d.to(te.stoppedLocation))}Pe.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Pe){function Oe(te){return{range:d.from(te.range),kind:te.kind}}Pe.from=Oe;function _e(te){return new c.DocumentHighlight(d.to(te.range),te.kind)}Pe.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(Pe){function Oe(_e){switch(_e){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Pe.to=Oe})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Oe(_e){return{triggerKind:ge.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Pe.to=Oe})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Pe){function Oe(te){switch(te){case c.CompletionItemTag.Deprecated:return 1}}Pe.from=Oe;function _e(te){switch(te){case 1:return c.CompletionItemTag.Deprecated}}Pe.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Pe){const Oe=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function _e(xe){return Oe.get(xe)??9}Pe.from=_e;const te=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Fe(xe){return te.get(xe)??c.CompletionItemKind.Property}Pe.to=Fe})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Pe){function Oe(_e,te){const Fe=new c.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ne.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=C.isMarkdownString(_e.documentation)?B.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,k.Range.isIRange(_e.range)?Fe.range=d.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:d.to(_e.range.insert),replacing:d.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new c.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof c.Range?new c.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(xe=>F.to(xe))),Fe.command=te&&_e.command?te.fromInternal(_e.command):void 0,Fe}Pe.to=Oe})(ie=e.CompletionItem||(e.CompletionItem={}));var O;(function(Pe){function Oe(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:B.fromStrict(te.documentation)}}Pe.from=Oe;function _e(te){return{label:te.label,documentation:C.isMarkdownString(te.documentation)?B.to(te.documentation):te.documentation}}Pe.to=_e})(O=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(Pe){function Oe(te){return{label:te.label,documentation:B.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(O.from):[],activeParameter:te.activeParameter}}Pe.from=Oe;function _e(te){return{label:te.label,documentation:C.isMarkdownString(te.documentation)?B.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(O.to):[],activeParameter:te.activeParameter}}Pe.to=_e})(j=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Pe){function Oe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.from):[]}}Pe.from=Oe;function _e(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.to):[]}}Pe.to=_e})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Oe(_e,te){const Fe=new c.InlayHint(i.to(te.position),typeof te.label=="string"?te.label:te.label.map(pe.to.bind(void 0,_e)),te.kind&&we.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(F.to),Fe.tooltip=C.isMarkdownString(te.tooltip)?B.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Pe.to=Oe})(X=e.InlayHint||(e.InlayHint={}));var pe;(function(Pe){function Oe(_e,te){const Fe=new c.InlayHintLabelPart(te.label);return Fe.tooltip=C.isMarkdownString(te.tooltip)?B.to(te.tooltip):te.tooltip,E.Command.is(te.command)&&(Fe.command=_e.fromInternal(te.command)),te.location&&(Fe.location=me.to(te.location)),Fe}Pe.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Pe){function Oe(te){return te}Pe.from=Oe;function _e(te){return te}Pe.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Pe){function Oe(te){return{range:d.from(te.range),url:te.target,tooltip:te.tooltip}}Pe.from=Oe;function _e(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?A.URI.parse(te.url,!0):A.URI.revive(te.url)}catch{}return new c.DocumentLink(d.to(te.range),Fe)}Pe.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Pe){function Oe(te){const Fe=new c.ColorPresentation(te.label);return te.textEdit&&(Fe.textEdit=F.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(xe=>F.to(xe))),Fe}Pe.to=Oe;function _e(te){return{label:te.label,textEdit:te.textEdit?F.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>F.from(Fe)):void 0}}Pe.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Pe){function Oe(te){return new c.Color(te[0],te[1],te[2],te[3])}Pe.to=Oe;function _e(te){return[te.red,te.green,te.blue,te.alpha]}Pe.from=_e})(ye=e.Color||(e.Color={}));var We;(function(Pe){function Oe(te){return{range:d.from(te.range)}}Pe.from=Oe;function _e(te){return new c.SelectionRange(d.to(te.range))}Pe.to=_e})(We=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Pe){function Oe(_e){switch(_e){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Pe.to=Oe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Pe){function Oe(te){switch(te){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Oe;function _e(te){switch(te){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Pe.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Oe(te){if(te===c.EndOfLine.CRLF)return 1;if(te===c.EndOfLine.LF)return 0}Pe.from=Oe;function _e(te){if(te===1)return c.EndOfLine.CRLF;if(te===0)return c.EndOfLine.LF}Pe.to=_e})(Ye=e.EndOfLine||(e.EndOfLine={}));var Ne;(function(Pe){function Oe(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Oe})(Ne=e.ProgressLocation||(e.ProgressLocation={}));var at;(function(Pe){function Oe(_e){const te={start:_e.start+1,end:_e.end+1};return _e.kind&&(te.kind=re.from(_e.kind)),te}Pe.from=Oe})(at=e.FoldingRange||(e.FoldingRange={}));var re;(function(Pe){function Oe(_e){if(_e)switch(_e){case c.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Pe.from=Oe})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Pe){function Oe(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?d.from(_e.selection):void 0,override:typeof _e.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Oe})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Pe){function Oe(xe){return xe instanceof c.RelativePattern?xe.toJSON():typeof xe=="string"?xe:_e(xe)||te(xe)?new c.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Pe.from=Oe;function _e(xe){const nt=xe;return nt?A.URI.isUri(nt.baseUri)&&typeof nt.pattern=="string":!1}function te(xe){const nt=xe;return nt?typeof nt.base=="string"&&typeof nt.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new c.RelativePattern(A.URI.revive(xe.baseUri),xe.pattern)}Pe.to=Fe})(Ee=e.GlobPattern||(e.GlobPattern={}));var Ve;(function(Pe){function Oe(_e){if(_e){if(Array.isArray(_e))return _e.map(Oe);if(typeof _e=="string")return _e;{const te=_e;return{language:te.language,scheme:te.scheme,pattern:Ee.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Pe.from=Oe})(Ve=e.LanguageSelector||(e.LanguageSelector={}));var fe;(function(Pe){function Oe(te){return{start:te.start,end:te.end}}Pe.from=Oe;function _e(te){return new c.NotebookRange(te.start,te.end)}Pe.to=_e})(fe=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Pe){function Oe(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Pe.to=Oe;function _e(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Pe.from=_e})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Pe){function Oe(_e){if(_e===p.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(_e===p.NotebookCellExecutionState.Pending)return;if(_e===p.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Pe.to=Oe})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(Pe){function Oe(te){switch(te){case c.NotebookCellKind.Markup:return p.CellKind.Markup;case c.NotebookCellKind.Code:default:return p.CellKind.Code}}Pe.from=Oe;function _e(te){switch(te){case p.CellKind.Markup:return c.NotebookCellKind.Markup;case p.CellKind.Code:default:return c.NotebookCellKind.Code}}Pe.to=_e})(Me=e.NotebookCellKind||(e.NotebookCellKind={}));var Ke;(function(Pe){function Oe(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const xe of te.cells)c.NotebookCellData.validate(xe),Fe.cells.push(Je.from(xe));return Fe}Pe.from=Oe;function _e(te){const Fe=new c.NotebookData(te.cells.map(Je.to));return(0,D.isEmptyObject)(te.metadata)||(Fe.metadata=te.metadata),Fe}Pe.to=_e})(Ke=e.NotebookData||(e.NotebookData={}));var Je;(function(Pe){function Oe(te){return{cellKind:Me.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ae.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(ot.from):[]}}Pe.from=Oe;function _e(te){return new c.NotebookCellData(Me.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(ot.to):void 0,te.metadata,te.internalMetadata?Ae.to(te.internalMetadata):void 0)}Pe.to=_e})(Je=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Pe){function Oe(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Pe.from=Oe;function _e(te){return new c.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Pe.to=_e})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(Pe){function Oe(te){return{outputId:te.id,items:te.items.map(st.from),metadata:te.metadata}}Pe.from=Oe;function _e(te){const Fe=te.items.map(st.to);return new c.NotebookCellOutput(Fe,te.outputId,te.metadata)}Pe.to=_e})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Pe){function Oe(Fe){return te(Fe)?{include:(0,D.withNullAsUndefined)(Ee.from(Fe.include)),exclude:(0,D.withNullAsUndefined)(Ee.from(Fe.exclude))}:(0,D.withNullAsUndefined)(Ee.from(Fe))}Pe.from=Oe;function _e(Fe){return te(Fe)?{include:Ee.to(Fe.include),exclude:Ee.to(Fe.exclude)}:Ee.to(Fe)}Pe.to=_e;function te(Fe){const xe=Fe;return xe?!(0,D.isUndefinedOrNull)(xe.include)&&!(0,D.isUndefinedOrNull)(xe.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Pe){function Oe(_e,te,Fe){const xe=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(xe,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Pe.from=Oe})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var vt;(function(Pe){function Oe(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{},cellContentMetadata:_e?.cellContentMetadata??{}}}Pe.from=Oe})(vt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var wt;(function(Pe){function Oe(te){return{uri:te.uri,provides:te.provides}}Pe.from=Oe;function _e(te){return new c.NotebookRendererScript(A.URI.revive(te.uri),te.provides)}Pe.to=_e})(wt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Pe){function Oe(te){return{message:B.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:d.from(te.location.range),uri:te.location.uri}}}Pe.from=Oe;function _e(te){const Fe=new c.TestMessage(typeof te.message=="string"?te.message:B.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.location=te.location?me.to(te.location):void 0,Fe}Pe.to=_e})(ft=e.TestMessage||(e.TestMessage={}));var Et;(function(Pe){Pe.namespace=b.namespaceTestTag,Pe.denamespace=b.denamespaceTestTag})(Et=e.TestTag||(e.TestTag={}));var Ft;(function(Pe){function Oe(te){const Fe=(0,_.getPrivateApiFor)(te).controllerId;return{extId:m.TestId.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:A.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(xe=>Et.namespace(Fe,xe.id)),range:k.Range.lift(d.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&B.fromStrict(te.error)||null}}Pe.from=Oe;function _e(te){return{parent:void 0,error:void 0,id:m.TestId.fromString(te.extId).localId,label:te.label,uri:A.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:xe}=Et.denamespace(Fe);return new c.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Pe.toPlain=_e})(Ft=e.TestItem||(e.TestItem={})),function(Pe){function Oe(te){return{id:te.id}}Pe.from=Oe;function _e(te){return new c.TestTag(te.id)}Pe.to=_e}(Et=e.TestTag||(e.TestTag={}));var Mt;(function(Pe){const Oe=(te,Fe)=>{const xe=[];for(const[Ge,rt]of Fe)m.TestId.compare(rt.item.extId,Ge)===2&&(Fe.delete(Ge),xe.push(rt));const nt={...Ft.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(rt=>rt.type===0).map(ft.to)})),children:xe.map(Ge=>Oe(Ge,Fe))};for(const Ge of nt.children)Ge.parent=nt;return nt};function _e(te){const Fe=[],xe=new Map;for(const nt of te.items){xe.set(nt.item.extId,nt);const Ge=m.TestId.root(nt.item.extId);te.request.targets.some(rt=>rt.controllerId===Ge&&rt.testIds.includes(nt.item.extId))&&Fe.push(nt)}return{completedAt:te.completedAt,results:Fe.map(nt=>Oe(nt,xe))}}Pe.to=_e})(Mt=e.TestResults||(e.TestResults={}));var Qe;(function(Pe){function Oe(xe){return{covered:xe.covered,total:xe.covered}}function _e(xe){return"line"in xe?i.from(xe):d.from(xe)}function te(xe){return"branches"in xe?{count:xe.executionCount,location:_e(xe.location),type:1,branches:xe.branches.length?xe.branches.map(nt=>({count:nt.executionCount,location:nt.location&&_e(nt.location)})):void 0}:{type:0,count:xe.executionCount,location:_e(xe.location)}}Pe.fromDetailed=te;function Fe(xe){return{uri:xe.uri,statement:Oe(xe.statementCoverage),branch:xe.branchCoverage&&Oe(xe.branchCoverage),function:xe.functionCoverage&&Oe(xe.functionCoverage),details:xe.detailedCoverage?.map(te)}}Pe.fromFile=Fe})(Qe=e.TestCoverage||(e.TestCoverage={}));var zt;(function(Pe){function Oe(_e){switch(_e){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Pe.to=Oe})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ot;(function(Pe){function Oe(te){const Fe=new c.TypeHierarchyItem($.to(te.kind),te.name,te.detail||"",A.URI.revive(te.uri),d.to(te.range),d.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Pe.to=Oe;function _e(te,Fe,xe){if(Fe=Fe??te._sessionId,xe=xe??te._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:$.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:d.from(te.range),selectionRange:d.from(te.selectionRange),tags:te.tags?.map(Q.from)}}Pe.from=_e})(Ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Pt;(function(Pe){function Oe(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Pe.from=Oe})(Pt=e.ViewBadge||(e.ViewBadge={}));var gt;(function(Pe){function Oe(_e,te){const Fe=_e.fileData;return Fe?new class extends c.DataTransferItem{asFile(){return{name:Fe.name,uri:A.URI.revive(Fe.uri),data:(0,v.once)(()=>te())}}}("",_e.id):new c.DataTransferItem(_e.asString)}Pe.toDataTransferItem=Oe})(gt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(Pe){function Oe(te,Fe){const xe=te.items.map(([nt,Ge])=>[nt,gt.toDataTransferItem(Ge,()=>Fe(Ge.id))]);return new c.DataTransfer(xe)}Pe.toDataTransfer=Oe;async function _e(te){const Fe={items:[]},xe=[];return te.forEach((nt,Ge)=>{xe.push((async()=>{const rt=await nt.asString(),pt=nt.asFile();Fe.items.push([Ge,{id:nt.id,asString:rt,fileData:pt?{name:pt.name,uri:pt.uri}:void 0}])})())}),await Promise.all(xe),Fe}Pe.toDataTransferDTO=_e})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(De[229],Ie([1,0,2,11,7,15,62]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(D,A,k,E={timeout:1500,errors:3}){this._logService=D,this._documents=A,this._mainThreadBulkEdits=k,this._thresholds=E,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(A,k,E)=>{const _={dispose:this._callbacks.push([A,k,D])};return Array.isArray(E)&&E.push(_),_}}async $participateInSave(D,A){const k=u.URI.revive(D);let E=!1;const T=setTimeout(()=>E=!0,this._thresholds.timeout),_=[];try{for(const g of[...this._callbacks]){if(E)break;const p=this._documents.getDocument(k),m=await this._deliverEventAsyncAndBlameBadListeners(g,{document:p,reason:P.TextDocumentSaveReason.to(A)});_.push(m)}}finally{clearTimeout(T)}return _}_deliverEventAsyncAndBlameBadListeners([D,A,k],E){const T=this._badListeners.get(D);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,D,A,E).then(()=>!0,_=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(_),!(_ instanceof Error)||_.message!=="concurrent_edits"){const g=this._badListeners.get(D);this._badListeners.set(D,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,A,k,E){const T=[],_=Date.now(),{document:g,reason:p}=E,{version:m}=g,b=Object.freeze({document:g,reason:p,waitUntil(f){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(f))}});try{A.apply(k,[b])}catch(f){return Promise.reject(f)}return Object.freeze(T),new Promise((f,c)=>{const v=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-_}ms`),clearTimeout(v),f(a)}).catch(a=>{clearTimeout(v),c(a)})}).then(f=>{const c={edits:[]};for(const v of f)if(Array.isArray(v)&&v.every(a=>a instanceof C.TextEdit))for(const{newText:a,newEol:d,range:o}of v)c.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:o&&P.Range.from(o),text:a,eol:d&&P.EndOfLine.from(d)}});if(c.edits.length!==0)return m===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(De[230],Ie([1,0,14,2,15,7,89]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(k,E,T,_){this.start=k,this.deletedCount=E,this.deletedItems=T,this.items=_}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(k,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,E,T){this.notebook=k,this._extHostDocument=E,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return k._mime},set mime(_){k._mime=_},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(C.NotebookCellOutput.to)}setOutputItems(k,E,T){const _=T.map(C.NotebookCellOutputItem.to),g=this._outputs.find(p=>p.id===k);if(g&&(E||(g.items.length=0),g.items.push(..._),g.items.length>1&&g.items.every(p=>y.isTextStreamMime(p.mime)))){const p=new Map,m=[];g.items.forEach(b=>{let f;p.has(b.mime)?f=p.get(b.mime):(f=[],p.set(b.mime,f),m.push(b.mime)),f.push(b.data)}),g.items.length=0,m.forEach(b=>{const f=y.compressOutputItemStreams(p.get(b));g.items.push({mime:b,data:f.buffer})})}}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=S;class D{constructor(k,E,T,_,g){this._proxy=k,this._textDocumentsAndEditors=E,this._textDocuments=T,this.uri=_,this.handle=D._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=g.viewType,this._metadata=Object.freeze(g.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,g.cells]],!0,void 0),this._versionId=g.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,E={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===u.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(g=>g.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(E)}return this._notebook}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,E,T){this._versionId=k.versionId,this._isDirty=E,this.acceptDocumentPropertiesChanged({metadata:T});const _={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},g=[];for(const m of k.rawEvents)m.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1,_.contentChanges):m.kind===y.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx,_.contentChanges):m.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(m.index,m.outputs),g.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems),g.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(m.index,m.language),g.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document})):m.kind===y.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document}):m.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(m.index,m.mime):m.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(m.index,m.metadata),g.push({cell:this._cells[m.index].apiCell,metadata:this._cells[m.index].apiCell.metadata})):m.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(m.index,m.internalMetadata),g.push({cell:this._cells[m.index].apiCell,executionSummary:this._cells[m.index].apiCell.executionSummary}));const p=new Map;for(let m=0;m<g.length;m++){const b=g[m],f=p.get(b.cell);if(f===void 0){const c=_.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});p.set(b.cell,c-1)}else _.cellChanges[f]={..._.cellChanges[f],...b}}return Object.freeze(_),Object.freeze(_.cellChanges),Object.freeze(_.contentChanges),_}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let E=k.start|0,T=k.end|0;return E<0&&(E=0),T>this._cells.length&&(T=this._cells.length),k.with({start:E,end:T})}_getCells(k){k=this._validateRange(k);const E=[];for(let T=k.start;T<k.end;T++)E.push(this._cells[T]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,E,T){if(this._disposed)return;const _=[],g=[],p=[];if(k.reverse().forEach(m=>{const f=m[2].map(a=>{const d=new S(this,this._textDocumentsAndEditors,a);return E||g.push(S.asModelAddData(this.apiNotebook,a)),d}),c=new I(m[0],m[1],[],f),v=this._cells.splice(m[0],m[1],...f);for(const a of v)p.push(a.uri),c.deletedItems.push(a.apiCell);_.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:p}),T)for(const m of _)T.push(m.asApiEvent())}_moveCell(k,E,T){const _=this._cells.splice(k,1);this._cells.splice(E,0,..._);const g=[new I(k,1,_.map(p=>p.apiCell),[]),new I(E,0,[],_)];for(const p of g)T.push(p.asApiEvent())}_setCellOutputs(k,E){this._cells[k].setOutputs(E)}_setCellOutputItems(k,E,T,_){this._cells[k].setOutputItems(E,T,_)}_changeCellLanguage(k,E){const T=this._cells[k];T.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelLanguageChanged(T.uri,E)}_changeCellMime(k,E){const T=this._cells[k];T.apiCell.mime=E}_changeCellMetadata(k,E){this._cells[k].setMetadata(E)}_changeCellInternalMetadata(k,E){this._cells[k].setInternalMetadata(E)}getCellFromApiCell(k){return this._cells.find(E=>E.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(E=>E.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=D,D._handlePool=0}),define(De[133],Ie([1,0,11,15,7]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(I,S,D,A,k,E){this.id=I,this._proxy=S,this.notebookData=D,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=A,this._viewColumn=E}get apiEditor(){if(!this._editor){const I=this;this._editor={get document(){return I.notebookData.apiNotebook},get notebook(){return I.notebookData.apiNotebook},get selection(){return I._selections[0]},set selection(S){this.selections=[S]},get selections(){return I._selections},set selections(S){if(!Array.isArray(S)||!S.every(C.NotebookRange.isNotebookRange))throw(0,u.illegalArgument)("selections");I._selections=S,I._trySetSelections(S)},get visibleRanges(){return I._visibleRanges},revealRange(S,D){I._proxy.$tryRevealRange(I.id,t.NotebookRange.from(S),D??C.NotebookEditorRevealType.Default)},get viewColumn(){return I._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(I){this._visible=I}_acceptVisibleRanges(I){this._visibleRanges=I}_acceptSelections(I){this._selections=I}_trySetSelections(I){this._proxy.$trySetSelections(this.id,I.map(t.NotebookRange.from))}_acceptViewColumn(I){this._viewColumn=I}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[231],Ie([1,0,3,13,15]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(I,S){this._logService=I,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(I,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,S);const D=this._notebooksAndEditors.getEditorById(I);S.visibleRanges&&D._acceptVisibleRanges(S.visibleRanges.ranges.map(C.NotebookRange.to)),S.selections&&D._acceptSelections(S.selections.selections.map(C.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const S in I)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(C.ViewColumn.to(I[S]))}};P=je([$e(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[232],Ie([1,0,15,123,172,21,59,11]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}async withProgress(E,T,_){const g=this._handles++,{title:p,location:m,cancellable:b}=T,f={label:(0,C.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(g,{location:u.ProgressLocation.from(m),title:p,source:f,cancellable:b},E.isUnderDevelopment?void 0:E.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(g,_,!!b)}_withProgress(E,T,_){let g;_&&(g=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,g));const p=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),g?.dispose()};let m;try{m=T(new A(this._proxy,E),_&&g?g.token:P.CancellationToken.None)}catch(b){throw p(E),b}return m.then(b=>p(E),b=>p(E)),m}$acceptProgressCanceled(E){const T=this._mapHandleToCancellationSource.get(E);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=S;function D(k,E){return k.message=E.message,typeof E.increment=="number"&&(typeof k.increment=="number"?k.increment+=E.increment:k.increment=E.increment),k}class A extends t.Progress{constructor(E,T){super(_=>this.throttledReport(_)),this._proxy=E,this._handle=T}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}je([(0,y.throttle)(100,(k,E)=>D(k,E),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(De[134],Ie([1,0,35,130,55,90,66,15,2]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(f,c,v,a)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(o){if(!v(d,o)){const i=d;d=o,f.listener?.(a(o,i))}}}},A=(f,c)=>f===c,k={range:(f,c)=>f===c?!0:!f||!c?!1:f.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(f,c)=>!(f.length!==c.length||f.some(v=>!c.find(a=>v.id===a.id)))},E=f=>c=>({op:4,update:f(c)}),T=(f,c)=>({range:(()=>{let v;const a=E(d=>({range:u.Range.lift(I.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return v},set(d){f.listener?.({op:6}),k.range(v,d)||(v=d,f.listener?.(a(d)))}}})(),label:D(f,c,k.label,E(v=>({label:v}))),description:D(f,void 0,k.description,E(v=>({description:v}))),sortText:D(f,void 0,k.sortText,E(v=>({sortText:v}))),canResolveChildren:D(f,!1,k.canResolveChildren,v=>({op:2,state:v})),busy:D(f,!1,k.busy,E(v=>({busy:v}))),error:D(f,void 0,k.error,E(v=>({error:I.MarkdownString.fromStrict(v)||null}))),tags:D(f,[],k.tags,(v,a)=>({op:1,new:v.map(I.TestTag.from),old:a.map(I.TestTag.from)}))}),_=f=>{const c=C.TestId.fromString(f.extId),v=new p(c.controllerId,c.localId,f.label,S.URI.revive(f.uri)||void 0);return v.range=I.Range.to(f.range||void 0),v.description=f.description||void 0,v.sortText=f.sortText||void 0,v.tags=f.tags.map(a=>I.TestTag.to({id:(0,y.denamespaceTestTag)(a).tagId})),v},g=f=>{let c;for(const v of f.tests){const a=_(v.item);(0,t.getPrivateApiFor)(a).parent=c,c=a}return c};e.toItemFromContext=g;class p{constructor(c,v,a,d){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const o=(0,t.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof m?void 0:o.parent}},children:{value:(0,P.createTestItemChildren)(o,t.getPrivateApiFor,p),enumerable:!0,writable:!1},...T(o,a)})}}e.TestItemImpl=p;class m extends p{constructor(c,v){super(c,c,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class b extends P.TestItemCollection{constructor(c,v,a){super({controllerId:c,getDocumentVersion:d=>d&&a.getDocument(d)?.version,getApiFor:t.getPrivateApiFor,getChildren:d=>d.children,root:new m(c,v),toITestItem:I.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(De[135],Ie([1,0,48,11,97,15,7]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(E,T,_){const g=I._Keys.nextId();E.$registerTextEditorDecorationType(T.identifier,g,P.DecorationRenderOptions.from(_)),this.value=Object.freeze({key:g,dispose(){E.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=I,I._Keys=new C.IdGenerator("TextEditorDecorationType");class S{constructor(E,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=E,this._documentVersionId=E.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(E,T){this._throwIfFinalized();let _=null;if(E instanceof y.Position)_=new y.Range(E,E);else if(E instanceof y.Range)_=E;else throw new Error("Unrecognized location");this._pushEdit(_,T,!1)}insert(E,T){this._throwIfFinalized(),this._pushEdit(new y.Range(E,E),T,!0)}delete(E){this._throwIfFinalized();let T=null;if(E instanceof y.Range)T=E;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(E,T,_){const g=this._document.validateRange(E);this._collectedEdits.push({range:g,text:T,forceMoveMarkers:_})}setEndOfLine(E){if(this._throwIfFinalized(),E!==y.EndOfLine.LF&&E!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=E}}e.TextEditorEdit=S;class D{constructor(E,T,_,g){this._proxy=E,this._id=T,this._accept(_),this._logService=g;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(E){this._tabSize=E.tabSize,this._insertSpaces=E.insertSpaces,this._cursorStyle=E.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(E.lineNumbers)}_validateTabSize(E){if(E==="auto")return"auto";if(typeof E=="number"){const T=Math.floor(E);return T>0?T:null}if(typeof E=="string"){const T=parseInt(E,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(E){const T=this._validateTabSize(E);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}_setInsertSpaces(E){const T=this._validateInsertSpaces(E);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(E){this._cursorStyle!==E&&(this._cursorStyle=E,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:E})))}_setLineNumbers(E){this._lineNumbers!==E&&(this._lineNumbers=E,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(E)})))}assign(E){const T={};let _=!1;if(typeof E.tabSize<"u"){const g=this._validateTabSize(E.tabSize);g==="auto"?(_=!0,T.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,_=!0,T.tabSize=g)}if(typeof E.insertSpaces<"u"){const g=this._validateInsertSpaces(E.insertSpaces);g==="auto"?(_=!0,T.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,_=!0,T.insertSpaces=g)}typeof E.cursorStyle<"u"&&this._cursorStyle!==E.cursorStyle&&(this._cursorStyle=E.cursorStyle,_=!0,T.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this._lineNumbers!==E.lineNumbers&&(this._lineNumbers=E.lineNumbers,_=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(E.lineNumbers)),_&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(E,T){T.catch(_=>{this._logService.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this._logService.warn(_)})}}e.ExtHostTextEditorOptions=D;class A{constructor(E,T,_,g,p,m,b,f){this.id=E,this._proxy=T,this._logService=_,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new D(this._proxy,this.id,m,_),this._visibleRanges=b,this._viewColumn=f;const c=this;this.value=Object.freeze({get document(){return g.getValue()},set document(v){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(v){if(!(v instanceof y.Selection))throw(0,t.illegalArgument)("selection");c._selections=[v],c._trySetSelection()},get selections(){return c._selections},set selections(v){if(!Array.isArray(v)||v.some(a=>!(a instanceof y.Selection)))throw(0,t.illegalArgument)("selections");c._selections=v,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(v){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(v){c._disposed||c._options.assign(v)},get viewColumn(){return c._viewColumn},set viewColumn(v){throw(0,t.readonly)("viewColumn")},edit(v,a={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new S(g.getValue(),a);return v(d),c._applyEdit(d)},insertSnippet(v,a,d={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!a||Array.isArray(a)&&a.length===0)o=c._selections.map(i=>P.Range.from(i));else if(a instanceof y.Position){const{lineNumber:i,column:s}=P.Position.from(a);o=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(a instanceof y.Range)o=[P.Range.from(a)];else{o=[];for(const i of a)if(i instanceof y.Range)o.push(P.Range.from(i));else{const{lineNumber:s,column:l}=P.Position.from(i);o.push({startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l})}}return T.$tryInsertSnippet(E,g.getValue().version,v.value,o,d)},setDecorations(v,a){const d=a.length===0;d&&!c._hasDecorationsForKey.has(v.key)||(d?c._hasDecorationsForKey.delete(v.key):c._hasDecorationsForKey.add(v.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(a))return T.$trySetDecorations(E,v.key,P.fromRangeOrRangeWithMessage(a));{const o=new Array(4*a.length);for(let i=0,s=a.length;i<s;i++){const l=a[i];o[4*i]=l.start.line+1,o[4*i+1]=l.start.character+1,o[4*i+2]=l.end.line+1,o[4*i+3]=l.end.character+1}return T.$trySetDecorationsFast(E,v.key,o)}}))},revealRange(v,a){c._runOnProxy(()=>T.$tryRevealRange(E,P.Range.from(v),a||y.TextEditorRevealType.Default))},show(v){T.$tryShowEditor(E,P.ViewColumn.from(v))},hide(){T.$tryHideEditor(E)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(E){(0,u.ok)(!this._disposed),this._options._accept(E)}_acceptVisibleRanges(E){(0,u.ok)(!this._disposed),this._visibleRanges=E}_acceptViewColumn(E){(0,u.ok)(!this._disposed),this._viewColumn=E}_acceptSelections(E){(0,u.ok)(!this._disposed),this._selections=E}async _trySetSelection(){const E=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,E)),this.value}_applyEdit(E){const T=E.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const _=T.edits.map(p=>p.range);_.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=_.length-1;p<m;p++){const b=_[p].end;if(_[p+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=T.edits.map(p=>({range:P.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,g,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(E){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=A}),define(De[233],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[234],Ie([1,0,186,11,42,120,124,43,27,233,197]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=I.Registry.as(y.Extensions.JSONContribution);class E{constructor(c,v,a){this._messageHandler=c,this._extension=v,this._extensionPointId=a}_msg(c,v){this._messageHandler({type:c,message:v,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(C.default.Error,c)}warn(c){this._msg(C.default.Warning,c)}info(c){this._msg(C.default.Info,c)}}e.ExtensionMessageCollector=E;class T{static _toSet(c){const v=new Set;for(let a=0,d=c.length;a<d;a++)v.add(S.ExtensionIdentifier.toKey(c[a].description.identifier));return v}static compute(c,v){if(!c||!c.length)return new T(v,[]);if(!v||!v.length)return new T([],c);const a=this._toSet(c),d=this._toSet(v),o=v.filter(s=>!a.has(S.ExtensionIdentifier.toKey(s.description.identifier))),i=c.filter(s=>!d.has(S.ExtensionIdentifier.toKey(s.description.identifier)));return new T(o,i)}constructor(c,v){this.added=c,this.removed=v}}e.ExtensionPointUserDelta=T;class _{constructor(c,v){this.name=c,this.defaultExtensionKind=v,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=T.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,t.onUnexpectedError)(c)}}}e.ExtensionPoint=_;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(31,null)},{label:"onUri",body:"onUri",description:u.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(36,null)},{label:"onRenderer",description:u.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(39,null)},{label:"*",description:u.localize(40,null),body:"*"}]}},badges:{type:"array",description:u.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(42,null)},href:{type:"string",description:u.localize(43,null)},description:{type:"string",description:u.localize(44,null)}}}},markdown:{type:"string",description:u.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(49,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(50,null)},{body:["workspace"],description:u.localize(51,null)},{body:["ui","workspace"],description:u.localize(52,null)},{body:["workspace","ui"],description:u.localize(53,null)},{body:[],description:u.localize(54,null)}]},capabilities:{description:u.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(58,null),u.localize(59,null),u.localize(60,null)]},description:{type:"string",markdownDescription:u.localize(61,null)}}},untrustedWorkspaces:{description:u.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(64,null),u.localize(65,null),u.localize(66,null)]},restrictedConfigurations:{description:u.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(68,null)}}}}},sponsor:{description:u.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(71,null),type:"string"},"vscode:uninstall":{description:u.localize(72,null),type:"string"}}},icon:{type:"string",description:u.localize(73,null)},l10n:{type:"string",description:u.localize(74,null)}}};class m{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const v=new _(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,v),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,k.registerSchema(p,e.schema),v}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=m;const b={ExtensionsRegistry:"ExtensionsRegistry"};I.Registry.add(b.ExtensionsRegistry,new m),e.ExtensionsRegistry=I.Registry.as(b.ExtensionsRegistry),k.registerSchema(p,e.schema),k.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(De[235],Ie([1,0,183,12,24,234,52,3]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var D;(function(E){function T(_,g,p){if(!_)return;const m=t.isString(_.type)?_.type:void 0;if(!m||m.length===0){p.error(u.localize(3,null));return}const b=[];if(Array.isArray(_.required))for(const f of _.required)t.isString(f)&&b.push(f);return{extensionId:g.value,taskType:m,required:b,properties:_.properties?C.deepClone(_.properties):{},when:_.when?y.ContextKeyExpr.deserialize(_.when):void 0}}E.from=T})(D||(D={}));const A=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:S}});class k{constructor(){this._onDefinitionsChanged=new I.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,_)=>{A.setHandler((g,p)=>{this._schema=void 0;try{for(const m of p.removed){const b=m.value;for(const f of b)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(const m of p.added){const b=m.value;for(const f of b){const c=D.from(f,m.description.identifier,m.collector);c&&(this.taskTypes[c.taskType]=c)}}(p.removed.length>0||p.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const _ of this.all()){const g={type:"object",additionalProperties:!1};_.required.length>0&&(g.required=_.required.slice(0)),_.properties!==void 0?g.properties=C.deepClone(_.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[_.taskType]},T.push(g)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(De[236],Ie([1,0,184,12,22,24,52,235]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var S;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function V(U){if(!U)return N.Strong;switch(U.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=V}(S=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A=e.RevealKind||(e.RevealKind={})),function(N){function V(U){switch(U.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=V}(A=e.RevealKind||(e.RevealKind={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function V(U){switch(U.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=V}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(N){function V(U){switch(U.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=V}(E=e.PanelKind||(e.PanelKind={}));var T;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var _;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(_=e.RuntimeType||(e.RuntimeType={})),function(N){function V(F){switch(F.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=V;function U(F){switch(F){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=U}(_=e.RuntimeType||(e.RuntimeType={}));var g;(function(N){function V(U){return t.isString(U)?U:U.value}N.value=V})(g=e.CommandString||(e.CommandString={}));var p;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function V(F){return F===N.Clean._id||F===N.Build._id||F===N.Rebuild._id||F===N.Test._id}N.is=V;function U(F){if(F!==void 0)return t.isString(F)?V(F)?{_id:F,isDefault:!1}:void 0:F}N.from=U})(p=e.TaskGroup||(e.TaskGroup={}));var m;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(m=e.TaskScope||(e.TaskScope={}));var b;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function V(U){switch(U){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=V})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(N){N.parallel="parallel",N.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var c;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class a{constructor(V,U,F,x,$,Q){this._label="",this._id=V,U&&(this._label=U),F&&(this.type=F),this.runOptions=x,this.configurationProperties=$,this._source=Q}getDefinition(V){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const V={folder:this.getFolderId(),id:this._id};return JSON.stringify(V)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,U=!1){if(V===void 0)return!1;if(t.isString(V))return V===this._label||V===this.configurationProperties.identifier||U&&V===this._id;const F=this.getDefinition(!0);return F!==void 0&&F._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),V&&(this._taskLoadMessages=this._taskLoadMessages.concat(V))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=a;class d extends a{constructor(V,U,F,x,$,Q,K,de){super(V,F,void 0,K,de,U),this.command={},this._source=U,this.hasDefinedMatchers=Q,$&&(this.command=$)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case _.Shell:U="shell";break;case _.Process:U="process";break;case _.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(V){return V instanceof d}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let U=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(U+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:U};return JSON.stringify(F)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(V){return new d(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.CustomTask=d;class o extends a{constructor(V,U,F,x,$,Q,K){super(V,F,x,Q,K,U),this._source=U,this.configures=$}static is(V){return V instanceof o}fromObject(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const V=this.getFolderId();if(!V)return;let U=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(U+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:V,id:U};return JSON.stringify(F)}}e.ConfiguringTask=o;class i extends a{constructor(V,U,F,x,$,Q,K,de,ee){super(V,F,x,de,ee,U),this.defines=$,this.hasDefinedMatchers=K,this.command=Q,this.icon=ee.icon,this.hide=ee.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof i}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.getFolderId(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(V){return new i(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.ContributedTask=i;class s extends a{constructor(V,U,F,x,$,Q){super(V,F,x,$,Q,U),this._source=U}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(V){return new s(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.InMemoryTask=s;var l;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(l=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(l=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(V){this._order=new Map;for(let U=0;U<V.length;U++)this._order.set(V[U].uri.toString(),U)}compare(V,U){const F=V.getWorkspaceFolder(),x=U.getWorkspaceFolder();if(F&&x){let $=this._order.get(F.uri.toString());$=$===void 0?0:$+1;let Q=this._order.get(x.uri.toString());return Q=Q===void 0?0:Q+1,$===Q?V._label.localeCompare(U._label):$-Q}else return!F&&x?-1:F&&!x?1:0}}e.TaskSorter=r;var h;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(N){N.SingleRun="singleRun",N.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var L;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(N){function V(U,F,x,$,Q){if(F){const K={kind:U,taskId:F._id,taskName:F.configurationProperties.name,runType:F.configurationProperties.isBackground?"background":"singleRun",group:F.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:F};return U==="start"?(K.terminalId=x,K.resolvedVariables=$):U==="processStarted"?K.processId=x:U==="processEnded"&&(K.exitCode=x),Object.freeze(K)}else return Object.freeze({kind:"changed"})}N.create=V})(M=e.TaskEvent||(e.TaskEvent={}));var B;(function(N){function V(F){const x=Object.keys(F).sort();let $="";for(const Q of x){let K=F[Q];K instanceof Object?K=V(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),$+=Q+","+K+","}return $}function U(F){const $={_key:V(F),type:F.taskType};return Object.assign($,F),$}N.create=U})(B=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var R;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(R=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var H;(function(N){function V(U,F){const x=I.TaskDefinitionRegistry.get(U.type);if(x===void 0){const de=P.deepClone(U);return delete de._key,B.create(de)}const $=Object.create(null);$.type=x.taskType;const Q=new Set;x.required.forEach(de=>Q.add(de));const K=x.properties;for(const de of Object.keys(K)){const ee=U[de];if(ee!=null)$[de]=ee;else if(Q.has(de)){const he=K[de];if(he.default!==void 0)$[de]=P.deepClone(he.default);else switch(he.type){case"boolean":$[de]=!1;break;case"number":case"integer":$[de]=0;break;case"string":$[de]="";break;default:F.error(u.localize(2,null,JSON.stringify(U,void 0,0),de));return}}}return B.create($)}N.createTaskIdentifier=V})(H=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[237],Ie([1,0,11]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,I)=>{this._actualOk=y,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,u.onUnexpectedError)(y))}then(y,I){return this._ensureActual().then(y,I)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class C extends t{constructor(){super(),this._hasErr=!0,this._err=new u.CancellationError}}e.CanceledLazyPromise=C}),define(De[56],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const t=[];function C(I){const S=new u(I);return t[S.nid]=S,S}e.createProxyIdentifier=C;function P(I){return t[I].sid}e.getStringIdentifierForProxy=P;class y{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=y}),define(De[5],Ie([1,0,56]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var P;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var I;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(I=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(p){return p._id=k._n++,p}}e.IdObject=k,k._n=0;var E;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.command="m",g.kindModifier="n"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,u.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,u.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,u.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,u.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,u.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,u.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,u.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,u.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,u.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,u.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,u.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,u.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,u.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,u.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,u.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,u.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,u.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,u.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,u.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,u.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,u.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,u.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,u.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,u.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,u.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,u.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,u.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,u.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,u.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,u.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,u.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,u.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,u.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,u.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,u.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,u.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,u.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,u.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,u.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,u.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,u.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,u.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,u.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,u.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,u.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,u.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,u.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,u.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,u.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,u.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,u.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,u.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,u.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,u.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,u.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,u.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,u.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,u.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,u.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,u.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,u.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,u.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,u.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,u.createProxyIdentifier)("ExtHostLocalization")}}),define(De[67],Ie([1,0,4,13,5,16]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(C.MainContext.MainThreadTelemetry)}report(S,D,A){const k=this.getUsageKey(S,D);this._reportedUsages.has(k)||(this._reportedUsages.add(k),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:S}))}getUsageKey(S,D){return`${S}-${D.identifier.value}`}};y=je([$e(0,P.IExtHostRpcService),$e(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(I,S,D){}})}),define(De[238],Ie([1,0,3,5,7,27]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,D,A,k={}){const E=P.ExtensionIdentifier.toKey(S.identifier),T=this._inFlightRequests.get(E)||[],_=[...A].sort().join(" ");let g=T.find(p=>p.providerId===D&&p.scopes===_);if(g)return g.result;{const p=this._getSession(S,E,D,A,k);g={providerId:D,scopes:_,result:p},T.push(g),this._inFlightRequests.set(E,T);try{await p}finally{const m=T.findIndex(b=>b.providerId===D&&b.scopes===_);m>-1&&(T.splice(m),this._inFlightRequests.set(E,T))}return p}}async _getSession(S,D,A,k,E={}){await this._proxy.$ensureProvider(A);const T=S.displayName||S.name;return this._proxy.$getSession(A,k,D,T,E)}async removeSession(S,D){const A=this._authenticationProviders.get(S);return A?A.provider.removeSession(D):this._proxy.$removeSession(S,D)}registerAuthenticationProvider(S,D,A,k){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:D,provider:A,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===S)||this._providers.push({id:S,label:D});const E=A.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(S,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,D,k?.supportsMultipleAccounts??!1),new C.Disposable(()=>{E.dispose(),this._authenticationProviders.delete(S);const T=this._providers.findIndex(_=>_.id===S);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,D){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,D){return this._onDidChangeSessions.fire({provider:{id:S,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(De[239],Ie([1,0,5,16,15]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(I,S){this._proxy=I.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:D=>S.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(I,S,D){const A=C.WorkspaceEdit.from(I,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,D?.isRefactoring??!1)}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(De[240],Ie([1,0,5]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(I){return y.$writeText(I)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[39],Ie([1,0,12,7,15,24,5,17,13,81,35,49,2,6,4,16,134,23,56,50]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f){"use strict";var c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(n,r){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,v.set(this,void 0),tt(this,c,n.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=r,tt(this,v,n.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const w=this._apiCommands.get(h);return w?.result===i.Void?w:void 0},r),this._argumentProcessors=[{processArgument(h){return(0,D.revive)(h)}},{processArgument(h){return(0,P.cloneAndChange)(h,function(w){if(A.Range.isIRange(w))return C.Range.to(w);if(k.Position.isIPosition(w))return C.Position.to(w);if(A.Range.isIRange(w.range)&&E.URI.isUri(w.uri))return C.location.to(w);if(w instanceof m.VSBuffer)return w.buffer.buffer;if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const r=this.registerCommand(!1,n.id,async(...h)=>{const w=n.args.map((M,B)=>{if(!M.validate(h[B]))throw new Error(`Invalid argument '${M.name}' when running '${n.id}', received: ${h[B]}`);return M.convert(h[B])}),L=await this.executeCommand(n.internalId,...w);return n.result.convert(L,h,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new t.Disposable(()=>{r.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,r,h,w,L,M){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:h,thisArg:w,description:L,extension:M}),n&&Be(this,c,"f").$registerCommand(r),new t.Disposable(()=>{this._commands.delete(r)&&n&&Be(this,c,"f").$unregisterCommand(r)})}executeCommand(n,...r){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,r,!0)}async _doExecuteCommand(n,r,h){if(this._commands.has(n))return Be(this,c,"f").$fireCommandActivationEvent(n),this._executeContributedCommand(n,r,!1);{let w=!1;const L=(0,P.cloneAndChange)(r,function(M){if(M instanceof t.Position)return C.Position.from(M);if(M instanceof t.Range)return C.Range.from(M);if(M instanceof t.Location)return C.location.from(M);if(t.NotebookRange.isNotebookRange(M))return C.NotebookRange.from(M);if(M instanceof ArrayBuffer)return w=!0,m.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return w=!0,m.VSBuffer.wrap(M);if(M instanceof m.VSBuffer)return w=!0,M;if(!Array.isArray(M))return M});try{const M=await Be(this,c,"f").$executeCommand(n,w?new b.SerializableObjectWithBuffers(L):L,h);return(0,D.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(n,r,!1);throw M}}}async _executeContributedCommand(n,r,h){const w=this._commands.get(n);if(!w)throw new Error("Unknown command");this._reportTelemetry(w,n);const{callback:L,thisArg:M,description:B}=w;if(B)for(let R=0;R<B.args.length;R++)try{(0,u.validateConstraint)(r[R],B.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${B.args[R].name}' - ${B.args[R].description}`)}try{return await L.apply(M,r)}catch(R){if(n===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...r);z&&(n=z.command)}throw this._logService.error(R,n,w.extension?.identifier),h?new class extends Error{constructor(){super((0,f.toErrorMessage)(R)),this.id=n,this.source=w.extension?.displayName??w.extension?.name}}:R}}_reportTelemetry(n,r){!n.extension||n.extension.isBuiltin||Be(this,v,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:r})}$executeContributedCommand(n,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(r=r.map(h=>this._argumentProcessors.reduce((w,L)=>L.processArgument(w),h)),this._executeContributedCommand(n,r,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),Be(this,c,"f").$getCommands().then(r=>(n&&(r=r.filter(h=>h[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[r,h]of this._commands){const{description:w}=h;w&&(n[r]=w)}return Promise.resolve(n)}};c=new WeakMap,v=new WeakMap,a=je([$e(0,g.IExtHostRpcService),$e(1,S.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,_.createDecorator)("IExtHostCommands");class d{constructor(n,r,h){this._commands=n,this._lookupApiCommand=r,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,r){if(!n)return;const h={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return h;const w=this._lookupApiCommand(n.command);if(w)h.id=w.internalId,h.arguments=w.args.map((L,M)=>L.convert(n.arguments&&n.arguments[M]));else if((0,I.isNonEmptyArray)(n.arguments)){const L=++this._cachIdPool;this._cache.set(L,n),r.add((0,T.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),h.$ident=L,h.id=this.delegatingCommandId,h.arguments=[L],this._logService.trace("CommandsConverter#CREATE",n.command,L)}return h}fromInternal(n){return typeof n.$ident=="number"?this._cache.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const r=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class o{constructor(n,r,h,w){this.name=n,this.description=r,this.validate=h,this.convert=w}optional(){return new o(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,r){return new o(n??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",l=>E.URI.isUri(l),l=>l),o.Position=new o("position","A position in a text document",l=>t.Position.isPosition(l),C.Position.from),o.Range=new o("range","A range in a text document",l=>t.Range.isRange(l),C.Range.from),o.Selection=new o("selection","A selection in a text document",l=>t.Selection.isSelection(l),C.Selection.from),o.Number=new o("number","",l=>typeof l=="number",l=>l),o.String=new o("string","",l=>typeof l=="string",l=>l),o.CallHierarchyItem=new o("item","A call hierarchy item",l=>l instanceof t.CallHierarchyItem,C.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",l=>l instanceof t.TypeHierarchyItem,C.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",l=>l instanceof p.TestItemImpl,C.TestItem.from);class i{constructor(n,r){this.description=n,this.convert=r}}e.ApiCommandResult=i,i.Void=new i("no result",l=>l);class s{constructor(n,r,h,w,L){this.id=n,this.internalId=r,this.description=h,this.args=w,this.result=L}}e.ApiCommand=s}),define(De[241],Ie([1,0,2,15,7,64,39,17,117,122,14]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(g,p)=>{if((0,I.isFalsyOrEmpty)(g))return;class m extends C.SymbolInformation{static to(f){const c=new m(f.name,t.SymbolKind.to(f.kind),f.containerName||"",new C.Location(p[0],t.Range.to(f.range)));return c.detail=f.detail,c.range=c.location.range,c.selectionRange=t.Range.to(f.selectionRange),c.children=f.children?f.children.map(m.to):[],c}}return g.map(m.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",g=>typeof g=="string",g=>g),new y.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",g=>Array.isArray(g)&&g.every(p=>C.Position.isPosition(p)),g=>g.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",g=>g.map(p=>{let m;for(const b of p.reverse())m=new C.SelectionRange(t.Range.to(b),m);return m}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",g=>g.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",g=>{if(!!g)return{range:t.Range.to(g.range),placeholder:g.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",g=>{if(!!g){if(g.rejectReason)throw new Error(g.rejectReason);return t.WorkspaceEdit.to(g)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",g=>g.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new C.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const p=(0,S.decodeSemanticTokensDto)(g);if(p.type==="full")return new C.SemanticTokens(p.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new C.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const p=(0,S.decodeSemanticTokensDto)(g);if(p.type==="full")return new C.SemanticTokens(p.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(g,p,m)=>{if(!g)return new C.CompletionList([]);const b=g.suggestions.map(f=>t.CompletionItem.to(f,m));return new C.CompletionList(b,g.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",g=>{if(g)return t.SignatureHelp.to(g)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(g,p,m)=>T(b=>new C.CodeLens(t.Range.to(b.range),b.command&&m.fromInternal(b.command)))(g))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",g=>C.Range.isRange(g),g=>C.Selection.isSelection(g)?t.Selection.from(g):t.Range.from(g)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(g,p,m)=>T(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(b.command)}else{const f=new C.CodeAction(b.title,b.kind?new C.CodeActionKind(b.kind):void 0);return b.edit&&(f.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(f.command=m.fromInternal(b.command)),f.isPreferred=b.isPreferred,f}})(g))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",g=>g?g.map(p=>new C.ColorInformation(t.Range.to(p.range),t.Color.to(p.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",g=>g instanceof C.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",g=>!0,g=>({uri:g.uri,range:t.Range.from(g.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",g=>g?g.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(g,p,m)=>g.map(t.InlayHint.to.bind(void 0,m)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(g=>({viewType:g.viewType,displayName:g.displayName,options:{transientOutputs:g.options.transientOutputs,transientCellMetadata:g.options.transientCellMetadata,transientDocumentMetadata:g.options.transientDocumentMetadata},filenamePattern:g.filenamePattern.map(p=>t.NotebookExclusiveDocumentPattern.to(p))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",g=>g.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",g=>u.URI.isUri(g)||typeof g=="string"&&(0,D.matchesSomeScheme)(g,A.Schemas.http,A.Schemas.https),g=>g),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[t.ViewColumn.from(g),void 0]:[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[t.ViewColumn.from(g),void 0]:[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="object",g=>g&&[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class E{static register(p){k.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=E;function T(g){return p=>{if(Array.isArray(p))return p.map(g)}}function _(g){if(!Array.isArray(g))return;const p=[];for(const m of g)P.isLocationLink(m)?p.push(t.DefinitionLink.to(m)):p.push(t.location.to(m));return p}}),define(De[242],Ie([1,0,18,59,3,6,2,64,27,15,7,28,5]),function(J,e,u,t,C,P,y,I,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(_,g,p){const m=_.getProxy(E.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const n=this._commentControllers.get(l.handle);return n?n.value:l}else if(l&&l.$mid===7){const n=this._commentControllers.get(l.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.commentThreadHandle);return r?r.value:l}else if(l&&l.$mid===8){const n=this._commentControllers.get(l.thread.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.thread.commentThreadHandle);return r?{thread:r.value,text:l.text}:l}else if(l&&l.$mid===9){const n=this._commentControllers.get(l.thread.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.thread.commentThreadHandle);if(!r)return l;const h=l.commentUniqueId,w=r.getCommentByUniqueId(h);return w||l}else if(l&&l.$mid===10){const n=this._commentControllers.get(l.thread.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.thread.commentThreadHandle);if(!r)return l;const h=l.text,w=l.commentUniqueId,L=r.getCommentByUniqueId(w);return L?(typeof L.body=="string"?L.body=h:L.body.value=h,L):l}return l}})}createCommentController(l,n,r){const h=b.handlePool++,w=new c(l,h,n,r);this._commentControllers.set(w.handle,w);const L=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(l.identifier))||[];return L.push(w),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(l.identifier),L),w.value}$createCommentThreadTemplate(l,n,r){const h=this._commentControllers.get(l);!h||h.$createCommentThreadTemplate(n,r)}async $updateCommentThreadTemplate(l,n,r){const h=this._commentControllers.get(l);!h||h.$updateCommentThreadTemplate(n,r)}$deleteCommentThread(l,n){this._commentControllers.get(l)?.$deleteCommentThread(n)}$provideCommentingRanges(l,n,r){const h=this._commentControllers.get(l);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=p.getDocument(y.URI.revive(n));return(0,u.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(w,r)).then(L=>L?L.map(M=>D.Range.from(M)):void 0)}$toggleReaction(l,n,r,h,w){const L=this._commentControllers.get(l);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const M=L.getCommentThread(n);if(M){const B=M.getCommentByUniqueId(h.uniqueIdInThread);if(L!==void 0&&B&&L.reactionHandler)return L.reactionHandler(B,d(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class f{set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(l){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=l,this.modifications.state=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(l,n,r,h,w,L,M,B){this._commentControllerHandle=n,this._id=r,this._uri=h,this._range=w,this._comments=L,this.extensionDescription=M,this._isTemplate=B,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${l}.${this.handle}`),m.$createCommentThread(n,this.handle,this._id,this._uri,D.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{m.$deleteCommentThread(n,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(z){R.range=z},get comments(){return R.comments},set comments(z){R.comments=z},get collapsibleState(){return R.collapsibleState},set collapsibleState(z){R.collapsibleState=z},get canReply(){return R.canReply},set canReply(z){R.canReply=z},get contextValue(){return R.contextValue},set contextValue(z){R.contextValue=z},get label(){return R.label},set label(z){R.label=z},get state(){return R.state},set state(z){R.state=z},dispose:()=>{R.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const l=r=>Object.prototype.hasOwnProperty.call(this.modifications,r),n={};l("range")&&(n.range=D.Range.from(this._range)),l("label")&&(n.label=this.label),l("contextValue")&&(n.contextValue=this.contextValue??null),l("comments")&&(n.comments=this._comments.map(r=>v(this,r,this._commentsMap))),l("collapsibleState")&&(n.collapseState=o(this._collapseState)),l("canReply")&&(n.canReply=this.canReply),l("state")&&(n.state=i(this._state)),l("isTemplate")&&(n.isTemplate=this._isTemplate),this.modifications={},m.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,n)}getCommentByUniqueId(l){for(const n of this._commentsMap){const r=n[0],h=n[1];if(l===h)return r}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose())}}f._handlePool=0,je([(0,t.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(l){this._commentingRangeProvider=l,m.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,m.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(l,n,r,h){this._extension=l,this._handle=n,this._id=r,this._label=h,this._threads=new Map,m.$registerCommentController(this.handle,r,h);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(L){w.options=L},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(L){w.commentingRangeProvider=L},get reactionHandler(){return w.reactionHandler},set reactionHandler(L){w.reactionHandler=L},createCommentThread(L,M,B){return w.createCommentThread(L,M,B).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(l,n,r,h){if(typeof l=="string"){const w=new f(this.id,this.handle,l,n,r,h,this._extension,!1);return this._threads.set(w.handle,w),w}else{const w=new f(this.id,this.handle,void 0,l,n,r,this._extension,!1);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(l,n){const r=new f(this.id,this.handle,void 0,y.URI.revive(l),D.Range.to(n),[],this._extension,!0);return r.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(r.handle,r),r}$updateCommentThreadTemplate(l,n){const r=this._threads.get(l);r&&(r.range=D.Range.to(n))}$deleteCommentThread(l){this._threads.get(l)?.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._localDisposables.forEach(l=>l.dispose())}}function v(s,l,n){let r=n.get(l);r||(r=++s.commentHandle,n.set(l,r));const h=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:r,body:typeof l.body=="string"?l.body:D.MarkdownString.from(l.body),userName:l.author.name,userIconPath:h,label:l.label,commentReactions:l.reactions?l.reactions.map(w=>a(w)):void 0,timestamp:l.timestamp?.toJSON()}}function a(s){return{label:s.label,iconPath:s.iconPath?D.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function d(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?y.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function o(s){if(s!==void 0)switch(s){case A.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}function i(s){if(s!==void 0)switch(s){case A.CommentThreadState.Unresolved:return I.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return I.CommentThreadState.Resolved}return I.CommentThreadState.Unresolved}return new b}e.createExtHostComments=T}),define(De[243],Ie([1,0,24,5,25,16]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(A,k){this._mainThreadConsole=A.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,k){const E=this,T=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){E._handleConsoleCall(A,k,T,arguments)}})}_handleConsoleCall(A,k,E,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:S(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,E,T)}};y=je([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const I=1e5;function S(D,A){const k=[];if(D.length)for(let E=0;E<D.length;E++){let T=D[E];if(typeof T>"u")T="undefined";else if(T instanceof Error){const _=T;_.stack?T=_.stack:T=_.toString()}k.push(T)}if(A){const E=new Error().stack;E&&k.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,u.safeStringify)(k);return E.length>I?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(De[136],Ie([1,0,2,5,7,4,16,13,17,8,9]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class On{constructor(T,_){this._logService=_,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,_){const g=On._handlePool++;this._provider.set(g,{provider:T,extensionId:_}),this._proxy.$registerDecorationProvider(g,_.value);const p=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(g,null);return}const b=(0,S.asArray)(m);if(b.length<=On._maxEventSize){this._proxy.$onDidChange(g,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",_.value,b.length);const f=b.map(a=>({uri:a,rank:(0,D.count)(a.path,"/")})),c=(0,S.groupBy)(f,(a,d)=>a.rank-d.rank||(0,D.compare)(a.uri.path,d.uri.path)),v=[];e:for(const a of c){let d;for(const o of a){const i=(0,A.dirname)(o.uri.path);if(d!==i&&(d=i,v.push(o.uri)>=On._maxEventSize))break e}}this._proxy.$onDidChange(g,v)});return new C.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(T,_,g){if(!this._provider.has(T))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:b}=this._provider.get(T);return await Promise.all(_.map(async f=>{try{const{uri:c,id:v}=f,a=await Promise.resolve(m.provideFileDecoration(u.URI.revive(c),g));if(!a)return;try{C.FileDecoration.validate(a),p[v]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${b.value}': ${d}`)}}catch(c){this._logService.error(c)}})),p}};k._handlePool=0,k._maxEventSize=250,k=je([$e(0,y.IExtHostRpcService),$e(1,I.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[244],Ie([1,0,170,121,2,5,7,15,3,13,26,46]),function(J,e,u,t,C,P,y,I,S,D,A,k){"use strict";var E,T,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(b,f,c,v,a,d){this._name=b,this._owner=f,this._maxDiagnosticsPerFile=c,E.set(this,void 0),T.set(this,void 0),_.set(this,void 0),this._isDisposed=!1,tt(this,_,new A.ResourceMap(o=>v.getComparisonKey(o)),"f"),tt(this,E,a,"f"),tt(this,T,d,"f")}dispose(){this._isDisposed||(Be(this,T,"f").fire([...Be(this,_,"f").keys()]),Be(this,E,"f")?.$clear(this._owner),Be(this,_,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,f){if(!b){this.clear();return}this._checkDisposed();let c=[];if(C.URI.isUri(b)){if(!f){this.delete(b);return}Be(this,_,"f").set(b,f.slice()),c=[b]}else if(Array.isArray(b)){c=[];let a;b=[...b].sort(g._compareIndexedTuplesByUri);for(const d of b){const[o,i]=d;if((!a||o.toString()!==a.toString())&&(a&&Be(this,_,"f").get(a).length===0&&Be(this,_,"f").delete(a),a=o,c.push(o),Be(this,_,"f").set(o,[])),i)Be(this,_,"f").get(o)?.push(...i);else{const s=Be(this,_,"f").get(o);s&&(s.length=0)}}}if(Be(this,T,"f").fire(c),!Be(this,E,"f"))return;const v=[];for(const a of c){let d=[];const o=Be(this,_,"f").get(a);if(o)if(o.length>this._maxDiagnosticsPerFile){d=[];const i=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const l of o)if(l.severity===i[s]&&d.push(I.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;d.push({severity:t.MarkerSeverity.Info,message:(0,u.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=o.map(i=>I.Diagnostic.from(i));v.push([a,d])}Be(this,E,"f").$changeMany(this._owner,v)}delete(b){this._checkDisposed(),Be(this,T,"f").fire([b]),Be(this,_,"f").delete(b),Be(this,E,"f")?.$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Be(this,T,"f").fire([...Be(this,_,"f").keys()]),Be(this,_,"f").clear(),Be(this,E,"f")?.$clear(this._owner)}forEach(b,f){this._checkDisposed();for(const[c,v]of this)b.call(f,c,v,this)}*[(E=new WeakMap,T=new WeakMap,_=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const b of Be(this,_,"f").keys())yield[b,this.get(b)]}get(b){this._checkDisposed();const f=Be(this,_,"f").get(b);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Be(this,_,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,f){return b[0].toString()<f[0].toString()?-1:b[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=g;let p=class ln{static _mapper(b){const f=new A.ResourceMap;for(const c of b)f.set(c,c);return{uris:Object.freeze(Array.from(f.values()))}}constructor(b,f,c){this._logService=f,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ln._mapper),this._proxy=b.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,f){const{_collections:c,_proxy:v,_onDidChangeDiagnostics:a,_logService:d,_fileSystemInfoService:o}=this,i=new class{$changeMany(n,r){v.$changeMany(n,r),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,n,r.length===0?"CLEARING":r)}$clear(n){v.$clear(n),d.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,n)}dispose(){v.dispose()}};let s;if(!f)f="_generated_diagnostic_collection_name_#"+ln._idPool++,s=f;else if(!c.has(f))s=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do s=f+ln._idPool++;while(c.has(s))}return new class extends g{constructor(){super(f,s,ln._maxDiagnosticsPerFile,o.extUri,i,a),c.set(s,this)}dispose(){super.dispose(),c.delete(s)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const f=new Map,c=[];for(const v of this._collections.values())v.forEach((a,d)=>{let o=f.get(a.toString());typeof o>"u"&&(o=c.length,f.set(a.toString(),o),c.push([a,[]])),c[o][1]=c[o][1].concat(...d)});return c}}_getDiagnostics(b){let f=[];for(const c of this._collections.values())c.has(b)&&(f=f.concat(c.get(b)));return f}$acceptMarkersChange(b){if(!this._mirrorCollection){const f="_generated_mirror",c=new g(f,f,ln._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,c),this._mirrorCollection=c}for(const[f,c]of b)this._mirrorCollection.set(C.URI.revive(f),c.map(I.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=je([$e(1,D.ILogService),$e(2,k.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(De[245],Ie([1,0,2,5]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(I=>I?I.map(S=>u.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(I=>I?u.URI.revive(I):void 0)}}e.ExtHostDialogs=C}),define(De[246],Ie([1,0,11,2,7,5,14,21,8]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(k,E,T){this._documentsAndEditors=E,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,E){if(Object.keys(y.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=D._handlePool++;this._documentContentProviders.set(T,E),this._proxy.$registerTextContentProvider(T,k);let _;return typeof E.onDidChange=="function"&&(_=E.onDidChange(g=>{if(g.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(T,g).then(p=>{if(!p&&typeof p!="string")return;const m=this._documentsAndEditors.getDocument(g);if(!m)return;const b=(0,S.splitLines)(p);if(!m.equalLines(b))return this._proxy.$onVirtualDocumentChange(g,p)},u.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),_&&(_.dispose(),_=void 0)})}$provideTextDocumentContent(k,E){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(E),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(De[247],Ie([1,0,3,6,2,5,132,15,12,24,7]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,_){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=_,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const p of g)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const p of g)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const _=this._documentsAndEditors.getDocument(T);if(_)return _}getDocument(T){const _=this.getDocumentData(T);if(!_?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return _.document}ensureDocumentData(T){const _=this._documentsAndEditors.getDocument(T);if(_)return Promise.resolve(_);let g=this._documentLoader.get(T.toString());return g||(g=this._proxy.$tryOpenDocument(T).then(p=>{this._documentLoader.delete(T.toString());const m=C.URI.revive(p);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(m))},p=>(this._documentLoader.delete(T.toString()),Promise.reject(p))),this._documentLoader.set(T.toString(),g)),g}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(_=>C.URI.revive(_))}$acceptModelLanguageChanged(T,_){const g=C.URI.revive(T),p=this._documentsAndEditors.getDocument(g);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(_),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(T){const _=C.URI.revive(T),g=this._documentsAndEditors.getDocument(_);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(T,_){const g=C.URI.revive(T),p=this._documentsAndEditors.getDocument(g);if(!p)throw new Error("unknown document");p._acceptIsDirty(_),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,_,g){const p=C.URI.revive(T),m=this._documentsAndEditors.getDocument(p);if(!m)throw new Error("unknown document");m._acceptIsDirty(g),m.onEvents(_);let b;_.isUndoing?b=A.TextDocumentChangeReason.Undo:_.isRedoing&&(b=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:m.document,contentChanges:_.changes.map(f=>({range:I.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:b}))}setWordDefinitionFor(T,_){(0,y.setWordDefinitionFor)(T,_)}}e.ExtHostDocuments=k}),define(De[57],Ie([1,0,48,3,6,2,4,5,132,16,135,15,13,26,14,61,78]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let b=class{constructor(c,v){this._extHostRpc=c,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const v=[],a=[],d=[];if(c.removedDocuments)for(const o of c.removedDocuments){const i=P.URI.revive(o),s=this._documents.get(i);s?.unref()&&(this._documents.delete(i),v.push(s.value))}if(c.addedDocuments)for(const o of c.addedDocuments){const i=P.URI.revive(o.uri);let s=this._documents.get(i);if(s&&i.scheme!==_.Schemas.vscodeNotebookCell&&i.scheme!==_.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new m(new S.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,s),a.push(s.value)),s.ref()}if(c.removedEditors)for(const o of c.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&d.push(i)}if(c.addedEditors)for(const o of c.addedEditors){const i=P.URI.revive(o.documentUri);u.ok(this._documents.has(i),`document '${i}' does not exist`),u.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const s=this._documents.get(i).value,l=new A.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>s.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(n=>k.Range.to(n)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,l)}c.newActiveEditor!==void 0&&(u.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,C.dispose)(v),(0,C.dispose)(d),c.removedDocuments&&this._onDidRemoveDocuments.fire(v),c.addedDocuments&&this._onDidAddDocuments.fire(a),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return c?v:v?.value}allEditors(){return[...this._editors.values()]}};b=je([$e(0,D.IExtHostRpcService),$e(1,E.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[58],Ie([1,0,15,5,2,3,4,7,16,12,77]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class k{constructor(p,m,b){this._activeTabIdGetter=b,this._parentGroup=m,this.acceptDtoUpdate(p)}get apiObject(){if(!this._apiObject){const p=this,m={get isActive(){return p._dto.id===p._activeTabIdGetter()},get label(){return p._dto.label},get input(){return p._input},get isDirty(){return p._dto.isDirty},get isPinned(){return p._dto.isPinned},get isPreview(){return p._dto.isPreview},get group(){return p._parentGroup.apiObject}};this._apiObject=Object.freeze(m)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(p){this._dto=p,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new I.TextTabInput(C.URI.revive(this._dto.input.uri));case 2:return new I.TextDiffTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified));case 3:return new I.TextMergeTabInput(C.URI.revive(this._dto.input.base),C.URI.revive(this._dto.input.input1),C.URI.revive(this._dto.input.input2),C.URI.revive(this._dto.input.result));case 6:return new I.CustomEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new I.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new I.NotebookEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new I.NotebookDiffEditorTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new I.TerminalEditorTabInput;case 9:return new I.InteractiveWindowInput(C.URI.revive(this._dto.input.uri),C.URI.revive(this._dto.input.inputBoxUri));default:return}}}class E{constructor(p,m){this._tabs=[],this._activeTabId="",this._dto=p,this._activeGroupIdGetter=m;for(const b of p.tabs)b.isActive&&(this._activeTabId=b.id),this._tabs.push(new k(b,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const p=this,m={get isActive(){return p._dto.groupId===p._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(p._dto.viewColumn)},get activeTab(){return p._tabs.find(b=>b.tabId===p._activeTabId)?.apiObject},get tabs(){return Object.freeze(p._tabs.map(b=>b.apiObject))}};this._apiObject=Object.freeze(m)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(p){this._dto=p}acceptTabOperation(p){if(p.kind===0){const b=new k(p.tabDto,this,()=>this.activeTabId());return this._tabs.splice(p.index,0,b),p.tabDto.isActive&&(this._activeTabId=b.tabId),b}else if(p.kind===1){const b=this._tabs.splice(p.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${p.index} which does not exist`);return b.tabId===this._activeTabId&&(this._activeTabId=""),b}else if(p.kind===3){if(p.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this._tabs.splice(p.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${p.oldIndex} which does not exist`);return this._tabs.splice(p.index,0,b),b}const m=this._tabs.find(b=>b.tabId===p.tabDto.id);if(!m)throw new Error("INVALID tab");return p.tabDto.isActive?this._activeTabId=p.tabDto.id:this._activeTabId===p.tabDto.id&&!p.tabDto.isActive&&(this._activeTabId=""),m.acceptDtoUpdate(p.tabDto),m}activeTabId(){return this._activeTabId}}let T=class{constructor(p){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=p.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const p=this,m={onDidChangeTabGroups:p._onDidChangeTabGroups.event,onDidChangeTabs:p._onDidChangeTabs.event,get all(){return Object.freeze(p._extHostTabGroups.map(b=>b.apiObject))},get activeTabGroup(){const b=p._activeGroupId;return(0,D.assertIsDefined)(p._extHostTabGroups.find(c=>c.groupId===b)?.apiObject)},close:async(b,f)=>{const c=Array.isArray(b)?b:[b];return c.length?_(c[0])?this._closeGroups(c,f):this._closeTabs(c,f):!0}};this._apiObject=Object.freeze(m)}return this._apiObject}$acceptEditorTabModel(p){const m=new Set(this._extHostTabGroups.map(o=>o.groupId)),b=new Set(p.map(o=>o.groupId)),f=(0,A.diffSets)(m,b),c=this._extHostTabGroups.filter(o=>f.removed.includes(o.groupId)).map(o=>o.apiObject),v=[],a=[];this._extHostTabGroups=p.map(o=>{const i=new E(o,()=>this._activeGroupId);return f.added.includes(i.groupId)?v.push(i.apiObject):a.push(i.apiObject),i});const d=(0,D.assertIsDefined)(p.find(o=>o.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:v,closed:c,changed:a}))}$acceptTabGroupUpdate(p){const m=this._extHostTabGroups.find(b=>b.groupId===p.groupId);if(!m)throw new Error("Update Group IPC call received before group creation.");m.acceptGroupDtoUpdate(p),p.isActive&&(this._activeGroupId=p.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[m.apiObject],opened:[],closed:[]}))}$acceptTabOperation(p){const m=this._extHostTabGroups.find(f=>f.groupId===p.groupId);if(!m)throw new Error("Update Tabs IPC call received before group creation.");const b=m.acceptTabOperation(p);switch(p.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}_findExtHostTabFromApi(p){for(const m of this._extHostTabGroups)for(const b of m.tabs)if(b.apiObject===p)return b}_findExtHostTabGroupFromApi(p){return this._extHostTabGroups.find(m=>m.apiObject===p)}async _closeTabs(p,m){const b=[];for(const f of p){const c=this._findExtHostTabFromApi(f);if(!c)throw new Error("Tab close: Invalid tab not found!");b.push(c.tabId)}return this._proxy.$closeTab(b,m)}async _closeGroups(p,m){const b=[];for(const f of p){const c=this._findExtHostTabGroupFromApi(f);if(!c)throw new Error("Group close: Invalid group not found!");b.push(c.groupId)}return this._proxy.$closeGroup(b,m)}};T=je([$e(0,S.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function _(g){return g.tabs!==void 0}}),define(De[248],Ie([1,0,2,5,6,7,15,149,8,23,28]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(_){this._stateMachine=void 0,this._schemes.push(_)}delete(_){const g=this._schemes.indexOf(_);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const _=this._schemes.sort(),g=[];let p,m,b=14,f=14;for(const c of _){let v=p?(0,S.commonPrefixLength)(p,c):0;for(v===0?m=1:m=f;v<c.length;v++)v+1===c.length?(b=f,f=9):f+=1,g.push([m,c.toUpperCase().charCodeAt(v),f]),g.push([m,c.toLowerCase().charCodeAt(v),f]),m=f;p=c,f=b}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new I.StateMachine(g)}}provideDocumentLinks(_){this._initStateMachine();const g=[],p=I.LinkComputer.computeLinks({getLineContent(m){return _.lineAt(m-1).text},getLineCount(){return _.lineCount}},this._stateMachine);for(const m of p){const b=y.DocumentLink.to(m);b.target&&g.push(b)}return g}}class E{constructor(_,g){this._extHostLanguageFeatures=g,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=_.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(_,g,p,m={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(_,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(b,p);let f=2;m.isCaseSensitive&&(f+=1024),m.isReadonly&&(f+=2048),typeof p.copy=="function"&&(f+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,A.checkProposedApiEnabled)(_,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(b,g,f).catch(v=>{console.error(`FAILED to register filesystem provider of ${_.identifier.value}-extension for the scheme ${g}`),console.error(v)});const c=p.onDidChangeFile(v=>{const a=[];for(const d of v){const{uri:o,type:i}=d;if(o.scheme!==g)continue;let s;switch(i){case P.FileChangeType.Changed:s=0;break;case P.FileChangeType.Created:s=1;break;case P.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:o,type:s})}this._proxy.$onFileSystemChange(b,a)});return(0,C.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(_){const{type:g,ctime:p,mtime:m,size:b,permissions:f}=_;return{type:g,ctime:p,mtime:m,size:b,permissions:f}}$stat(_,g){return Promise.resolve(this._getFsProvider(_).stat(u.URI.revive(g))).then(p=>E._asIStat(p))}$readdir(_,g){return Promise.resolve(this._getFsProvider(_).readDirectory(u.URI.revive(g)))}$readFile(_,g){return Promise.resolve(this._getFsProvider(_).readFile(u.URI.revive(g))).then(p=>D.VSBuffer.wrap(p))}$writeFile(_,g,p,m){return Promise.resolve(this._getFsProvider(_).writeFile(u.URI.revive(g),p.buffer,m))}$delete(_,g,p){return Promise.resolve(this._getFsProvider(_).delete(u.URI.revive(g),p))}$rename(_,g,p,m){return Promise.resolve(this._getFsProvider(_).rename(u.URI.revive(g),u.URI.revive(p),m))}$copy(_,g,p,m){const b=this._getFsProvider(_);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(u.URI.revive(g),u.URI.revive(p),m))}$mkdir(_,g){return Promise.resolve(this._getFsProvider(_).createDirectory(u.URI.revive(g)))}$watch(_,g,p,m){const b=this._getFsProvider(_).watch(u.URI.revive(p),m);this._watches.set(g,b)}$unwatch(_,g){const p=this._watches.get(g);p&&(p.dispose(),this._watches.delete(g))}$open(_,g,p){const m=this._getFsProvider(_);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(u.URI.revive(g),p))}$close(_,g){const p=this._getFsProvider(_);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(g))}$read(_,g,p,m){const b=this._getFsProvider(_);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const f=D.VSBuffer.alloc(m);return Promise.resolve(b.read(g,p,f.buffer,0,m)).then(c=>f.slice(0,c))}$write(_,g,p,m){const b=this._getFsProvider(_);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(g,p,m.buffer,0,m.byteLength))}_getFsProvider(_){const g=this._fsProvider.get(_);if(!g){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return g}}e.ExtHostFileSystem=E}),define(De[68],Ie([1,0,5,38,7,23,4,16,46,6]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Yt{constructor(E,T){this._fileSystemProvider=new Map,this._proxy=E.getProxy(u.MainContext.MainThreadFileSystem);const _=this;this.value=Object.freeze({async stat(g){try{const p=_._fileSystemProvider.get(g.scheme);if(!p)return await _._proxy.$stat(g);await _._proxy.$ensureActivation(g.scheme);const m=await p.stat(g);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions}}catch(p){Yt._handleError(p)}},async readDirectory(g){try{const p=_._fileSystemProvider.get(g.scheme);return p?(await _._proxy.$ensureActivation(g.scheme),(await p.readDirectory(g)).slice()):await _._proxy.$readdir(g)}catch(p){return Yt._handleError(p)}},async createDirectory(g){try{return await _._proxy.$mkdir(g)}catch(p){return Yt._handleError(p)}},async readFile(g){try{const p=_._fileSystemProvider.get(g.scheme);return p?(await _._proxy.$ensureActivation(g.scheme),(await p.readFile(g)).slice()):(await _._proxy.$readFile(g)).buffer}catch(p){return Yt._handleError(p)}},async writeFile(g,p){try{return await _._proxy.$writeFile(g,P.VSBuffer.wrap(p))}catch(m){return Yt._handleError(m)}},async delete(g,p){try{const m=_._fileSystemProvider.get(g.scheme);return m?(await _._proxy.$ensureActivation(g.scheme),await m.delete(g,{recursive:!1,...p})):await _._proxy.$delete(g,{recursive:!1,useTrash:!1,...p})}catch(m){return Yt._handleError(m)}},async rename(g,p,m){try{return await _._proxy.$rename(g,p,{overwrite:!1,...m})}catch(b){return Yt._handleError(b)}},async copy(g,p,m){try{return await _._proxy.$copy(g,p,{overwrite:!1,...m})}catch(b){return Yt._handleError(b)}},isWritableFileSystem(g){const p=T.getCapabilities(g);if(typeof p=="number")return!(p&2048)}})}static _handleError(E){if(E instanceof C.FileSystemError)throw E;if(!(E instanceof Error))throw new C.FileSystemError(String(E));if(E.name==="ENOPRO")throw C.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(E.message);default:throw new C.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,T){return this._fileSystemProvider.set(E,T),(0,D.toDisposable)(()=>this._fileSystemProvider.delete(E))}};A=je([$e(0,I.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(De[249],Ie([1,0,3,37,2,5,15,7]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(k,E,T,_,g,p,m,b){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const f=this.ensureWatching(k,T,g);this._config=0,p&&(this._config+=1),m&&(this._config+=2),b&&(this._config+=4);const c=(0,t.parse)(g),v=typeof g=="string",a=_(d=>{if(!p)for(const o of d.created){const i=C.URI.revive(o);c(i.fsPath)&&(!v||E.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!m)for(const o of d.changed){const i=C.URI.revive(o);c(i.fsPath)&&(!v||E.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!b)for(const o of d.deleted){const i=C.URI.revive(o);c(i.fsPath)&&(!v||E.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=I.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}ensureWatching(k,E,T){const _=I.Disposable.from();if(typeof T=="string")return _;const g=k.getProxy(P.MainContext.MainThreadFileSystem);let p=!1;(T.pattern.includes(t.GLOBSTAR)||T.pattern.includes(t.GLOB_SPLIT))&&(p=!0);const m=Math.random();return g.$watch(E.identifier.value,m,T.baseUri,{recursive:p,excludes:[]}),I.Disposable.from({dispose:()=>g.$unwatch(m)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(k,E,T){this._mainContext=k,this._logService=E,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,E,T,_,g,p){return new S(this._mainContext,k,E,this._onFileSystemEvent.event,y.GlobPattern.from(T),_,g,p)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,E){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(T=>({oldUri:C.URI.revive(T.source),newUri:C.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(T=>C.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:E.map(T=>C.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,E){return(T,_,g)=>{const p=function(b){T.call(_,b)};return p.extension=k,E.event(p,void 0,g)}}async $onWillRunFileOperation(k,E,T,_){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(g=>({oldUri:C.URI.revive(g.source),newUri:C.URI.revive(g.target)}))},T,_);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(g=>C.URI.revive(g.target))},T,_);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(g=>C.URI.revive(g.target))},T,_)}}async _fireWillEvent(k,E,T,_){const g=new Set,p=[];if(await k.fireAsync(E,_,async(b,f)=>{const c=Date.now(),v=await Promise.resolve(b);v instanceof I.WorkspaceEdit&&(p.push([f.extension,v]),g.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-c>T&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),_.isCancellationRequested||p.length===0)return;const m={edits:[]};for(const[,b]of p){const{edits:f}=y.WorkspaceEdit.from(b,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=D}),define(De[250],Ie([1,0,2,39]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(y,I,S,D,A){this._extHostNotebooks=I,this._textDocumentsAndEditors=S,this._commands=D;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(E.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:u.URI.revive(E.notebookUri),inputUri:u.URI.revive(E.inputUri),notebookEditor:T.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:u.URI.revive(E.notebookUri),inputUri:u.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(y,I,S,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:S,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=C}),define(De[251],Ie([1,0,6,5]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,y),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=C}),define(De[252],Ie([1,0,2,24,15,7,64,5,8,35,17,12,145,21,6,117,97,87,51,11,18,28]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentSymbols(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentSymbols(G,j);if(!(0,A.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(C.DocumentSymbol.from):a._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((X,pe)=>{let we=X.location.range.start.compareTo(pe.location.range.start);return we===0&&(we=pe.location.range.end.compareTo(X.location.range.end)),we});const j=[],G=[];for(const X of O){const pe={name:X.name||"!!MISSING: name!!",kind:C.SymbolKind.from(X.kind),tags:X.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:C.Range.from(X.location.range),selectionRange:C.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(pe),j.push(pe);break}const we=G[G.length-1];if(D.Range.containsRange(we.range,pe.range)&&!D.Range.equalsRange(we.range,pe.range)){we.children?.push(pe),G.push(pe);break}G.pop()}}return j}}class d{constructor(O,j,G){this._documents=O,this._commands=j,this._provider=G,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideCodeLenses(G,j);if(!X||j.isCancellationRequested)return;const pe=this._cache.add(X),we=new _.DisposableStore;this._disposables.set(pe,we);const ce={cacheId:pe,lenses:[]};for(let Ce=0;Ce<X.length;Ce++)ce.lenses.push({cacheId:[pe,Ce],range:C.Range.from(X[Ce].range),command:this._commands.toInternal(X[Ce].command,we)});return ce}async resolveCodeLens(O,j){const G=O.cacheId&&this._cache.get(...O.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,j),X||(X=G),j.isCancellationRequested)return;const pe=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!pe)return O.command=this._commands.toInternal(X.command??d._badCmd,pe),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(ie){return Array.isArray(ie)?ie.map(C.DefinitionLink.from):ie?[C.DefinitionLink.from(ie)]:[]}class i{constructor(O,j){this._documents=O,this._provider=j}async provideDefinition(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideDefinition(X,pe,G);return o(we)}}class s{constructor(O,j){this._documents=O,this._provider=j}async provideDeclaration(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideDeclaration(X,pe,G);return o(we)}}class l{constructor(O,j){this._documents=O,this._provider=j}async provideImplementation(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideImplementation(X,pe,G);return o(we)}}class n{constructor(O,j){this._documents=O,this._provider=j}async provideTypeDefinition(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideTypeDefinition(X,pe,G);return o(we)}}class r{constructor(O,j){this._documents=O,this._provider=j}async provideHover(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideHover(X,pe,G);if(!(!we||(0,A.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(pe)),we.range||(we.range=new P.Range(pe,pe)),C.Hover.from(we)}}class h{constructor(O,j){this._documents=O,this._provider=j}async provideEvaluatableExpression(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideEvaluatableExpression(X,pe,G);if(we)return C.EvaluatableExpression.from(we)}}class w{constructor(O,j){this._documents=O,this._provider=j}async provideInlineValues(O,j,G,X){const pe=this._documents.getDocument(O),we=await this._provider.provideInlineValues(pe,C.Range.to(j),C.InlineValueContext.to(G),X);if(Array.isArray(we))return we.map(ce=>C.InlineValue.from(ce))}}class L{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentHighlights(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideDocumentHighlights(X,pe,G);if(Array.isArray(we))return we.map(C.DocumentHighlight.from)}}class M{constructor(O,j){this._documents=O,this._provider=j}async provideLinkedEditingRanges(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.provideLinkedEditingRanges(X,pe,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,A.coalesce)(we.ranges.map(C.Range.from)),wordPattern:we.wordPattern}}}class B{constructor(O,j){this._documents=O,this._provider=j}async provideReferences(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=await this._provider.provideReferences(pe,we,G,X);if(Array.isArray(ce))return ce.map(C.location.from)}}class R{constructor(O,j,G,X,pe,we,ce){this._documents=O,this._commands=j,this._diagnostics=G,this._provider=X,this._logService=pe,this._extension=we,this._apiDeprecation=ce,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,j,G,X){const pe=this._documents.getDocument(O),we=E.Selection.isISelection(j)?C.Selection.to(j):C.Range.to(j),ce=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(we.intersection(Ye.range)&&ce.push(Ye)>R._maxCodeActionsPerFile)break;const Ce={diagnostics:ce,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},ye=await this._provider.provideCodeActions(pe,we,Ce,X);if(!(0,A.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const We=this._cache.add(ye),qe=new _.DisposableStore;this._disposables.set(We,qe);const Ze=[];for(let Ye=0;Ye<ye.length;Ye++){const Ne=ye[Ye];!Ne||(R._isCommand(Ne)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Ne.title,command:this._commands.toInternal(Ne,qe)})):(Ce.only&&(Ne.kind?Ce.only.contains(Ne.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ne.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[We,Ye],title:Ne.title,command:Ne.command&&this._commands.toInternal(Ne.command,qe),diagnostics:Ne.diagnostics&&Ne.diagnostics.map(C.Diagnostic.from),edit:Ne.edit&&C.WorkspaceEdit.from(Ne.edit,void 0),kind:Ne.kind&&Ne.kind.value,isPreferred:Ne.isPreferred,disabled:Ne.disabled?.reason})))}return{cacheId:We,actions:Ze}}async resolveCodeAction(O,j){const[G,X]=O,pe=this._cache.get(G,X);if(!pe||R._isCommand(pe)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(pe,j)??pe;return we?.edit?C.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}R._maxCodeActionsPerFile=1e3;class z{constructor(O,j,G,X){this._proxy=O,this._documents=j,this._provider=G,this._handle=X}async prepareDocumentPaste(O,j,G,X){if(!this._provider.prepareDocumentPaste)return;const pe=this._documents.getDocument(O),we=j.map(Ce=>C.Range.to(Ce)),ce=C.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this._provider.prepareDocumentPaste(pe,we,ce,X),C.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(O,j,G,X,pe){const we=this._documents.getDocument(j),ce=G.map(We=>C.Range.to(We)),Ce=C.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolvePasteFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ce,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class H{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentFormattingEdits(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideDocumentFormattingEdits(X,j,G);if(Array.isArray(pe))return pe.map(C.TextEdit.from)}}class N{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeFormattingEdits(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Range.to(j),ce=await this._provider.provideDocumentRangeFormattingEdits(pe,we,G,X);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class V{constructor(O,j){this._documents=O,this._provider=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,j,G,X,pe){const we=this._documents.getDocument(O),ce=C.Position.to(j),Ce=await this._provider.provideOnTypeFormattingEdits(we,ce,G,X,pe);if(Array.isArray(Ce))return Ce.map(C.TextEdit.from)}}class U{constructor(O,j){this._provider=O,this._logService=j,this._cache=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,j){const G=await this._provider.provideWorkspaceSymbols(O,j);if(!(0,A.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),pe={cacheId:X,symbols:[]};for(let we=0;we<G.length;we++){const ce=G[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}pe.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[X,we]})}return pe}async resolveWorkspaceSymbol(O,j){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this._cache.get(...O.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,j);return X&&(0,t.mixin)(O,C.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class F{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,j,G){this._documents=O,this._provider=j,this._logService=G}async provideRenameEdits(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j);try{const ce=await this._provider.provideRenameEdits(pe,we,G,X);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Ce=F._asMessage(ce);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,j,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(O),pe=C.Position.to(j);try{const we=await this._provider.prepareRename(X,pe,G);let ce,Ce;if(P.Range.isRange(we)?(ce=we,Ce=X.getText(we)):(0,k.isObject)(we)&&(ce=we.range,Ce=we.placeholder),!ce||!Ce)return;if(ce.start.line>pe.line||ce.end.line<pe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Ce}}catch(we){const ce=F._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class x{constructor(O,j){this.resultId=O,this.tokens=j}}class ${constructor(O,j){this._documents=O,this._provider=j,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,j,G){const X=this._documents.getDocument(O),pe=j!==0?this._previousResults.get(j):null;let we=typeof pe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,pe.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return pe&&this._previousResults.delete(j),we?(we=$._fixProvidedSemanticTokens(we),this._send($._convertToEdits(pe,we),we)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return $._isSemanticTokens(O)?$._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):$._isSemanticTokensEdits(O)?$._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(j=>new P.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const j of O.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,j){if(!$._isSemanticTokens(j)||!O||!O.tokens)return j;const G=O.tokens,X=G.length,pe=j.data,we=pe.length;let ce=0;const Ce=Math.min(X,we);for(;ce<Ce&&G[ce]===pe[ce];)ce++;if(ce===X&&ce===we)return new P.SemanticTokensEdits([],j.resultId);let ye=0;const We=Ce-ce;for(;ye<We&&G[X-ye-1]===pe[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:X-ce-ye,data:pe.subarray(ce,we-ye)}],j.resultId)}_send(O,j){if($._isSemanticTokens(O)){const G=this._nextResultId++;return this._previousResults.set(G,new x(O.resultId,O.data)),(0,g.encodeSemanticTokensDto)({id:G,type:"full",data:O.data})}if($._isSemanticTokensEdits(O)){const G=this._nextResultId++;return $._isSemanticTokens(j)?this._previousResults.set(G,new x(j.resultId,j.data)):this._previousResults.set(G,new x(O.resultId)),(0,g.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(O.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class Q{constructor(O,j){this._documents=O,this._provider=j}async provideDocumentRangeSemanticTokens(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideDocumentRangeSemanticTokens(X,C.Range.to(j),G);return pe?this._send(pe):null}_send(O){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=Q;class K{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,j,G,X,pe){this._documents=O,this._commands=j,this._provider=G,this._apiDeprecation=X,this._extension=pe,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=pe.getWordRangeAtPosition(we)||new P.Range(we,we),Ce=ce.with({end:we}),ye=new b.StopWatch(!0),We=await this._provider.provideCompletionItems(pe,we,X,C.CompletionContext.to(G));if(!We||X.isCancellationRequested)return;const qe=Array.isArray(We)?new P.CompletionList(We):We,Ze=K.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),Ye=new _.DisposableStore;this._disposables.set(Ze,Ye);const Ne=[],at={x:Ze,b:Ne,a:{replace:C.Range.from(ce),insert:C.Range.from(Ce)},c:qe.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<qe.items.length;re++){const se=qe.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ce,ce);Ne.push(Ee)}return at}async resolveCompletionItem(O,j){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveCompletionItem(G,j);if(!!X)return this._convertCompletionItem(X,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,j,G,X){const pe=this._disposables.get(j[0]);if(!pe)throw Error("DisposableStore is missing...");const we={x:j,a:O.label,b:O.kind!==void 0?C.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(C.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:C.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(O.command,pe)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=O.textEdit.newText):typeof O.insertText=="string"?we.h=O.insertText:O.insertText instanceof P.SnippetString&&(we.h=O.insertText.value,we.i|=4);let ce;return O.textEdit?ce=O.textEdit.range:O.range&&(ce=O.range),P.Range.isRange(ce)?we.j=C.Range.from(ce):ce&&(!G?.isEqual(ce.inserting)||!X?.isEqual(ce.replacing))&&(we.j={insert:C.Range.from(ce.inserting),replace:C.Range.from(ce.replacing)}),we}}class de{async provideInlineCompletions(O,j,G,X){}disposeCompletions(O){}handleDidShowCompletionItem(O,j){}}class ee extends de{constructor(O,j,G,X){super(),this._extension=O,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this._isAdditionsProposedApiEnabled=(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new _.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new _.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,j){const G=this._references.get(O)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class he extends de{constructor(O,j,G,X){super(),this.extension=O,this._documents=j,this._provider=G,this._commands=X,this._references=new Y,this.isAdditionProposedApiEnabled=(0,v.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=await this._provider.provideInlineCompletionItems(pe,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Ne;Ze.command&&(We||(We=new _.DisposableStore),Ne=this._commands.toInternal(Ze.command,We));const at=Ze.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Ne,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new _.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,j){const G=this._references.get(O)?.items[j];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class Y{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const j=this._idPool++;return this._references.set(j,O),j}disposeReferenceId(O){const j=this._references.get(O);return this._references.delete(O),j}get(O){return this._references.get(O)}}class me{constructor(O,j){this._documents=O,this._provider=j,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(O,j,G,X){const pe=this._documents.getDocument(O),we=C.Position.to(j),ce=this.reviveContext(G),Ce=await this._provider.provideSignatureHelp(pe,we,X,ce);if(Ce){const ye=this._cache.add([Ce]);return{...C.SignatureHelp.from(Ce),id:ye}}}reviveContext(O){let j;if(O.activeSignatureHelp){const G=C.SignatureHelp.to(O.activeSignatureHelp),X=this._cache.get(O.activeSignatureHelp.id,0);X?(j=X,j.activeSignature=G.activeSignature,j.activeParameter=G.activeParameter):j=G}return{...O,activeSignatureHelp:j}}releaseSignatureHelp(O){this._cache.delete(O)}}class be{constructor(O,j,G,X,pe){this._documents=O,this._commands=j,this._provider=G,this._logService=X,this._extension=pe,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,j,G){const X=this._documents.getDocument(O),pe=C.Range.to(j),we=await this._provider.provideInlayHints(X,pe,G);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${j}`);return}if(G.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new _.DisposableStore);const Ce={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],pe)&&Ce.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${j}`),Ce}async resolveInlayHint(O,j){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveInlayHint(G,j);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,j){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(j&&!j.contains(O.position))}_convertInlayHint(O,j){const G=this._disposables.get(j[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:j,tooltip:C.MarkdownString.fromStrict(O.tooltip),position:C.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(C.TextEdit.from),kind:O.kind&&C.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?X.label=O.label:X.label=O.label.map(pe=>{const we={label:pe.value};return we.tooltip=C.MarkdownString.fromStrict(pe.tooltip),P.Location.isLocation(pe.location)&&(we.location=C.location.from(pe.location)),pe.command&&(we.command=this._commands.toInternal(pe.command,G)),we}),X}}class ke{constructor(O,j){this._documents=O,this._provider=j,this._cache=new m.Cache("DocumentLink")}async provideLinks(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentLinks(G,j);if(!(!Array.isArray(X)||X.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(C.DocumentLink.from)};{const pe=this._cache.add(X),we={links:[],cacheId:pe};for(let ce=0;ce<X.length;ce++){if(!ke._validateLink(X[ce]))continue;const Ce=C.DocumentLink.from(X[ce]);Ce.cacheId=[pe,ce],we.links.push(Ce)}return we}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,j){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveDocumentLink(G,j);if(!(!X||!ke._validateLink(X)))return C.DocumentLink.from(X)}releaseLinks(O){this._cache.delete(O)}}class Re{constructor(O,j){this._documents=O,this._provider=j}async provideColors(O,j){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentColors(G,j);return Array.isArray(X)?X.map(we=>({color:C.Color.from(we.color),range:C.Range.from(we.range)})):[]}async provideColorPresentations(O,j,G){const X=this._documents.getDocument(O),pe=C.Range.to(j.range),we=C.Color.to(j.color),ce=await this._provider.provideColorPresentations(we,{document:X,range:pe},G);if(!!Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ze{constructor(O,j){this._documents=O,this._provider=j}async provideFoldingRanges(O,j,G){const X=this._documents.getDocument(O),pe=await this._provider.provideFoldingRanges(X,j,G);if(!!Array.isArray(pe))return pe.map(C.FoldingRange.from)}}class oe{constructor(O,j,G){this._documents=O,this._provider=j,this._logService=G}async provideSelectionRanges(O,j,G){const X=this._documents.getDocument(O),pe=j.map(C.Position.to),we=await this._provider.provideSelectionRanges(X,pe,G);if(!(0,A.isNonEmptyArray)(we))return[];if(we.length!==pe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ce=0;Ce<pe.length;Ce++){const ye=[];ce.push(ye);let We=pe[Ce],qe=we[Ce];for(;;){if(!qe.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(C.SelectionRange.from(qe)),!qe.parent)break;We=qe.range,qe=qe.parent}}return ce}}class le{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.prepareCallHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!pe)return pe.map(we=>({from:this._cacheAndConvertItem(O,we.from),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing call hierarchy item");const pe=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!pe)return pe.map(we=>({to:this._cacheAndConvertItem(O,we.to),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const G=this._cache.get(O),X=C.CallHierarchyItem.from(j,O,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class ge{constructor(O,j){this._documents=O,this._provider=j,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(O,j,G){const X=this._documents.getDocument(O),pe=C.Position.to(j),we=await this._provider.prepareTypeHierarchy(X,pe,G);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(O,we))}async provideSubtypes(O,j,G){const X=this._itemFromCache(O,j);if(!X)throw new Error("missing type hierarchy item");const pe=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!pe)return pe.map(we=>this._cacheAndConvertItem(O,we))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,j){const G=this._cache.get(O),X=C.TypeHierarchyItem.from(j,O,G.size.toString(36));return G.set(X._itemId,j),X}_itemFromCache(O,j){return this._cache.get(O)?.get(j)}}class Z{constructor(O,j,G,X){this._proxy=O,this._documents=j,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(O,j,G,X,pe){const we=this._documents.getDocument(j),ce=C.Position.to(G),Ce=C.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ce,pe);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ae{constructor(O,j){this.adapter=O,this.extension=j}}class ne{constructor(O,j,G,X,pe,we,ce,Ce){this._uriTransformer=j,this._documents=G,this._commands=X,this._diagnostics=pe,this._logService=we,this._apiDeprecation=ce,this._extensionTelemetry=Ce,this._adapter=new Map,this._proxy=O.getProxy(I.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(O){return C.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ne._handlePool++}async _withAdapter(O,j,G,X,pe,we=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof j))return X;const Ce=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const ye=G(ce.adapter,ce.extension);return Promise.resolve(ye).catch(We=>{(0,f.isCancellationError)(We)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(We),this._extensionTelemetry.onExtensionError(ce.extension.identifier,We))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(pe)?(0,c.raceCancellationError)(ye,pe):ye}_addNewAdapter(O,j){const G=this._nextHandle();return this._adapter.set(G,new ae(O,j)),G}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,j,G,X){const pe=this._addNewAdapter(new a(this._documents,G),O),we=X&&X.label||ne._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(pe,this._transformDocumentSelector(j),we),this._createDisposable(pe)}$provideDocumentSymbols(O,j,G){return this._withAdapter(O,a,X=>X.provideDocumentSymbols(u.URI.revive(j),G),void 0,G)}registerCodeLensProvider(O,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new d(this._documents,this._commands.converter,G),O)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(O,j,G){return this._withAdapter(O,d,X=>X.provideCodeLenses(u.URI.revive(j),G),void 0,G)}$resolveCodeLens(O,j,G){return this._withAdapter(O,d,X=>X.resolveCodeLens(j,G),void 0,void 0)}$releaseCodeLenses(O,j){this._withAdapter(O,d,G=>Promise.resolve(G.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(O,j,G){const X=this._addNewAdapter(new i(this._documents,G),O);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDefinition(O,j,G,X){return this._withAdapter(O,i,pe=>pe.provideDefinition(u.URI.revive(j),G,X),[],X)}registerDeclarationProvider(O,j,G){const X=this._addNewAdapter(new s(this._documents,G),O);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDeclaration(O,j,G,X){return this._withAdapter(O,s,pe=>pe.provideDeclaration(u.URI.revive(j),G,X),[],X)}registerImplementationProvider(O,j,G){const X=this._addNewAdapter(new l(this._documents,G),O);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideImplementation(O,j,G,X){return this._withAdapter(O,l,pe=>pe.provideImplementation(u.URI.revive(j),G,X),[],X)}registerTypeDefinitionProvider(O,j,G){const X=this._addNewAdapter(new n(this._documents,G),O);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideTypeDefinition(O,j,G,X){return this._withAdapter(O,n,pe=>pe.provideTypeDefinition(u.URI.revive(j),G,X),[],X)}registerHoverProvider(O,j,G,X){const pe=this._addNewAdapter(new r(this._documents,G),O);return this._proxy.$registerHoverProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideHover(O,j,G,X){return this._withAdapter(O,r,pe=>pe.provideHover(u.URI.revive(j),G,X),void 0,X)}registerEvaluatableExpressionProvider(O,j,G,X){const pe=this._addNewAdapter(new h(this._documents,G),O);return this._proxy.$registerEvaluatableExpressionProvider(pe,this._transformDocumentSelector(j)),this._createDisposable(pe)}$provideEvaluatableExpression(O,j,G,X){return this._withAdapter(O,h,pe=>pe.provideEvaluatableExpression(u.URI.revive(j),G,X),void 0,X)}registerInlineValuesProvider(O,j,G,X){const pe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new w(this._documents,G),O);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(j),pe);let ce=this._createDisposable(we);if(pe!==void 0){const Ce=G.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(pe));ce=P.Disposable.from(ce,Ce)}return ce}$provideInlineValues(O,j,G,X,pe){return this._withAdapter(O,w,we=>we.provideInlineValues(u.URI.revive(j),G,X,pe),void 0,pe)}registerDocumentHighlightProvider(O,j,G){const X=this._addNewAdapter(new L(this._documents,G),O);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentHighlights(O,j,G,X){return this._withAdapter(O,L,pe=>pe.provideDocumentHighlights(u.URI.revive(j),G,X),void 0,X)}registerLinkedEditingRangeProvider(O,j,G){const X=this._addNewAdapter(new M(this._documents,G),O);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideLinkedEditingRanges(O,j,G,X){return this._withAdapter(O,M,async pe=>{const we=await pe.provideLinkedEditingRanges(u.URI.revive(j),G,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ne._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(O,j,G){const X=this._addNewAdapter(new B(this._documents,G),O);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideReferences(O,j,G,X,pe){return this._withAdapter(O,B,we=>we.provideReferences(u.URI.revive(j),G,X,pe),void 0,pe)}registerCodeActionProvider(O,j,G,X){const pe=new _.DisposableStore,we=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,G,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(j),{providedKinds:X?.providedCodeActionKinds?.map(ce=>ce.value),documentation:X?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,pe)}))},ne._extLabel(O),Boolean(G.resolveCodeAction)),pe.add(this._createDisposable(we)),pe}$provideCodeActions(O,j,G,X,pe){return this._withAdapter(O,R,we=>we.provideCodeActions(u.URI.revive(j),G,X,pe),void 0,pe)}$resolveCodeAction(O,j,G){return this._withAdapter(O,R,X=>X.resolveCodeAction(j,G),void 0,void 0)}$releaseCodeActions(O,j){this._withAdapter(O,R,G=>Promise.resolve(G.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(O,j,G){const X=this._addNewAdapter(new H(this._documents,G),O);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(j),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentFormattingEdits(O,j,G,X){return this._withAdapter(O,H,pe=>pe.provideDocumentFormattingEdits(u.URI.revive(j),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(O,j,G){const X=this._addNewAdapter(new N(this._documents,G),O);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(j),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(O,j,G,X,pe){return this._withAdapter(O,N,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive(j),G,X,pe),void 0,pe)}registerOnTypeFormattingEditProvider(O,j,G,X){const pe=this._addNewAdapter(new V(this._documents,G),O);return this._proxy.$registerOnTypeFormattingSupport(pe,this._transformDocumentSelector(j),X,O.identifier),this._createDisposable(pe)}$provideOnTypeFormattingEdits(O,j,G,X,pe,we){return this._withAdapter(O,V,ce=>ce.provideOnTypeFormattingEdits(u.URI.revive(j),G,X,pe,we),void 0,we)}registerWorkspaceSymbolProvider(O,j){const G=this._addNewAdapter(new U(j,this._logService),O);return this._proxy.$registerNavigateTypeSupport(G,typeof j.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(O,j,G){return this._withAdapter(O,U,X=>X.provideWorkspaceSymbols(j,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,j,G){return this._withAdapter(O,U,X=>X.resolveWorkspaceSymbol(j,G),void 0,void 0)}$releaseWorkspaceSymbols(O,j){this._withAdapter(O,U,G=>G.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(O,j,G){const X=this._addNewAdapter(new F(this._documents,G,this._logService),O);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(j),F.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(O,j,G,X,pe){return this._withAdapter(O,F,we=>we.provideRenameEdits(u.URI.revive(j),G,X,pe),void 0,pe)}$resolveRenameLocation(O,j,G,X){return this._withAdapter(O,F,pe=>pe.resolveRenameLocation(u.URI.revive(j),G,X),void 0,X)}registerDocumentSemanticTokensProvider(O,j,G,X){const pe=this._addNewAdapter(new $(this._documents,G),O),we=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(pe,this._transformDocumentSelector(j),X,we);let ce=this._createDisposable(pe);if(we){const Ce=G.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ce)}return ce}$provideDocumentSemanticTokens(O,j,G,X){return this._withAdapter(O,$,pe=>pe.provideDocumentSemanticTokens(u.URI.revive(j),G,X),null,X)}$releaseDocumentSemanticTokens(O,j){this._withAdapter(O,$,G=>G.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,j,G,X){const pe=this._addNewAdapter(new Q(this._documents,G),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(pe,this._transformDocumentSelector(j),X),this._createDisposable(pe)}$provideDocumentRangeSemanticTokens(O,j,G,X){return this._withAdapter(O,Q,pe=>pe.provideDocumentRangeSemanticTokens(u.URI.revive(j),G,X),null,X)}registerCompletionItemProvider(O,j,G,X){const pe=this._addNewAdapter(new K(this._documents,this._commands.converter,G,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(pe,this._transformDocumentSelector(j),X,K.supportsResolving(G),`${O.identifier.value}(${X.join("")})`),this._createDisposable(pe)}$provideCompletionItems(O,j,G,X,pe){return this._withAdapter(O,K,we=>we.provideCompletionItems(u.URI.revive(j),G,X,pe),void 0,pe)}$resolveCompletionItem(O,j,G){return this._withAdapter(O,K,X=>X.resolveCompletionItem(j,G),void 0,G)}$releaseCompletionItems(O,j){this._withAdapter(O,K,G=>G.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(O,j,G){const X=new ee(O,this._documents,G,this._commands.converter),pe=this._addNewAdapter(X,O);return this._proxy.$registerInlineCompletionsSupport(pe,this._transformDocumentSelector(j),X.supportsHandleDidShowCompletionItem),this._createDisposable(pe)}registerInlineCompletionsProviderNew(O,j,G){const X=this._addNewAdapter(new he(O,this._documents,G,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(j),!0),this._createDisposable(X)}$provideInlineCompletions(O,j,G,X,pe){return this._withAdapter(O,de,we=>we.provideInlineCompletions(u.URI.revive(j),G,X,pe),void 0,pe)}$handleInlineCompletionDidShow(O,j,G){this._withAdapter(O,de,async X=>{X.handleDidShowCompletionItem(j,G)},void 0,void 0)}$freeInlineCompletionsList(O,j){this._withAdapter(O,de,async G=>{G.disposeCompletions(j)},void 0,void 0)}registerSignatureHelpProvider(O,j,G,X){const pe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new me(this._documents,G),O);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(j),pe),this._createDisposable(we)}$provideSignatureHelp(O,j,G,X,pe){return this._withAdapter(O,me,we=>we.provideSignatureHelp(u.URI.revive(j),G,X,pe),void 0,pe)}$releaseSignatureHelp(O,j){this._withAdapter(O,me,G=>G.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(O,j,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,pe=this._addNewAdapter(new be(this._documents,this._commands.converter,G,this._logService,O),O);this._proxy.$registerInlayHintsProvider(pe,this._transformDocumentSelector(j),typeof G.resolveInlayHint=="function",X,ne._extLabel(O));let we=this._createDisposable(pe);if(X!==void 0){const ce=G.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(O,j,G,X){return this._withAdapter(O,be,pe=>pe.provideInlayHints(u.URI.revive(j),G,X),void 0,X)}$resolveInlayHint(O,j,G){return this._withAdapter(O,be,X=>X.resolveInlayHint(j,G),void 0,G)}$releaseInlayHints(O,j){this._withAdapter(O,be,G=>G.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(O,j,G){const X=this._addNewAdapter(new ke(this._documents,G),O);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(j),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(O,j,G){return this._withAdapter(O,ke,X=>X.provideLinks(u.URI.revive(j),G),void 0,G,j.scheme==="output")}$resolveDocumentLink(O,j,G){return this._withAdapter(O,ke,X=>X.resolveLink(j,G),void 0,void 0,!0)}$releaseDocumentLinks(O,j){this._withAdapter(O,ke,G=>G.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(O,j,G){const X=this._addNewAdapter(new Re(this._documents,G),O);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentColors(O,j,G){return this._withAdapter(O,Re,X=>X.provideColors(u.URI.revive(j),G),[],G)}$provideColorPresentations(O,j,G,X){return this._withAdapter(O,Re,pe=>pe.provideColorPresentations(u.URI.revive(j),G,X),void 0,X)}registerFoldingRangeProvider(O,j,G){const X=this._nextHandle(),pe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new ze(this._documents,G),O)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(j),pe);let we=this._createDisposable(X);if(pe!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(pe));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(O,j,G,X){return this._withAdapter(O,ze,pe=>pe.provideFoldingRanges(u.URI.revive(j),G,X),void 0,X)}registerSelectionRangeProvider(O,j,G){const X=this._addNewAdapter(new oe(this._documents,G,this._logService),O);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideSelectionRanges(O,j,G,X){return this._withAdapter(O,oe,pe=>pe.provideSelectionRanges(u.URI.revive(j),G,X),[],X)}registerCallHierarchyProvider(O,j,G){const X=this._addNewAdapter(new le(this._documents,G),O);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareCallHierarchy(O,j,G,X){return this._withAdapter(O,le,pe=>Promise.resolve(pe.prepareSession(u.URI.revive(j),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(O,j,G,X){return this._withAdapter(O,le,pe=>pe.provideCallsTo(j,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(O,j,G,X){return this._withAdapter(O,le,pe=>pe.provideCallsFrom(j,G,X),void 0,X)}$releaseCallHierarchy(O,j){this._withAdapter(O,le,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(O,j,G){const X=this._addNewAdapter(new ge(this._documents,G),O);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$prepareTypeHierarchy(O,j,G,X){return this._withAdapter(O,ge,pe=>Promise.resolve(pe.prepareSession(u.URI.revive(j),G,X)),void 0,X)}$provideTypeHierarchySupertypes(O,j,G,X){return this._withAdapter(O,ge,pe=>pe.provideSupertypes(j,G,X),void 0,X)}$provideTypeHierarchySubtypes(O,j,G,X){return this._withAdapter(O,ge,pe=>pe.provideSubtypes(j,G,X),void 0,X)}$releaseTypeHierarchy(O,j){this._withAdapter(O,ge,G=>Promise.resolve(G.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(O,j,G){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,G,X),O)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(j)),this._createDisposable(X)}$provideDocumentOnDropEdits(O,j,G,X,pe,we){return this._withAdapter(O,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(j,u.URI.revive(G),X,pe,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,j,G,X){const pe=this._nextHandle();return this._adapter.set(pe,new ae(new z(this._proxy,this._documents,G,pe),O)),this._proxy.$registerPasteEditProvider(pe,this._transformDocumentSelector(j),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(pe)}$prepareDocumentPaste(O,j,G,X,pe){return this._withAdapter(O,z,we=>we.prepareDocumentPaste(u.URI.revive(j),G,X,pe),void 0,pe)}$providePasteEdits(O,j,G,X,pe,we){return this._withAdapter(O,z,ce=>ce.providePasteEdits(j,u.URI.revive(G),X,pe,we),void 0,we)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ne._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ne._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ne._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ne._serializeRegExp(O.beforeText),afterText:O.afterText?ne._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ne._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ne._serializeOnEnterRule)}setLanguageConfiguration(O,j,G){const{wordPattern:X}=G;if(X&&(0,S.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(j,X):this._documents.setWordDefinitionFor(j,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const pe=this._nextHandle(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ne._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?ne._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ne._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(pe,j,we),this._createDisposable(pe)}$setWordDefinitions(O){for(const j of O)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(De[253],Ie([1,0,5,15,7,42,18,6]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(A,k,E,T){this._documents=k,this._commands=E,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,k){await this._proxy.$changeLanguage(A,k);const E=this._documents.getDocumentData(A);if(!E)throw new Error(`document '${A.toString()}' NOT found`);return E.document}async tokenAtPosition(A,k){const E=A.version,T=t.Position.from(k),_=await this._proxy.$tokensAtPosition(A.uri,T),g={type:C.StandardTokenType.Other,range:A.getWordRangeAtPosition(k)??new C.Range(k.line,k.character,k.line,k.character)};if(!_)return g;const p={range:t.Range.to(_.range),type:t.TokenType.to(_.type)};return!p.range.contains(k)||E!==A.version?g:p}createLanguageStatusItem(A,k,E){const T=this._handlePool++,_=this._proxy,g=this._ids,p=`${A.identifier.value}/${k}`;if(g.has(p))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);g.add(p);const m={selector:E,id:k,name:A.displayName??A.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const f=new I.DisposableStore,c=()=>{b?.dispose(),b=(0,y.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(T,{id:p,name:m.name??A.displayName??A.name,source:A.displayName??A.name,selector:t.DocumentSelector.from(m.selector,this._uriTransformer),label:m.text,detail:m.detail??"",severity:m.severity===C.LanguageStatusSeverity.Error?P.default.Error:m.severity===C.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:m.command&&this._commands.toInternal(m.command,f),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},v={dispose(){f.dispose(),b?.dispose(),_.$removeLanguageStatus(T),g.delete(p)},get id(){return m.id},get name(){return m.name},set name(a){m.name=a,c()},get selector(){return m.selector},set selector(a){m.selector=a,c()},get text(){return m.text},set text(a){m.text=a,c()},get detail(){return m.detail},set detail(a){m.detail=a,c()},get severity(){return m.severity},set severity(a){m.severity=a,c()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(a){m.accessibilityInformation=a,c()},get command(){return m.command},set command(a){m.command=a,c()},get busy(){return m.busy},set busy(a){m.busy=a,c()}};return c(),v}}e.ExtHostLanguages=S}),define(De[93],Ie([1,0,10,8,2,4,13,5,25,16]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(E,T,_){this.logService=_,this.bundleCache=new Map,this._proxy=T.getProxy(I.MainContext.MainThreadLocalization),this.currentLanguage=E.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===u.LANGUAGE_DEFAULT}getMessage(E,T){const{message:_,args:g,comment:p}=T;if(this.isDefaultLanguage)return(0,t.format2)(_,g??{});let m=_;p&&p.length>0&&(m+=`/${Array.isArray(p)?p.join():p}`);const b=this.bundleCache.get(E)?.contents[m];return b||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${m}`),(0,t.format2)(b??m,g??{})}getBundle(E){return this.bundleCache.get(E)?.contents}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(this.isDefaultLanguage||!E.l10n&&!E.isBuiltin||this.bundleCache.has(E.identifier.value))return;let T;const _=await this.getBundleLocation(E);if(!_){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const g=await this._proxy.$fetchBundleContents(_),p=JSON.parse(g);T=E.isBuiltin?p.contents?.bundle:p}catch(g){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${_}: ${g.message}`);return}T&&this.bundleCache.set(E.identifier.value,{contents:T,uri:_})}async getBundleLocation(E){if(E.isBuiltin){const T=await this._proxy.$fetchBuiltInBundleUri(E.identifier.value);return C.URI.revive(T)}return E.l10n?C.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};A=je([$e(0,S.IExtHostInitDataService),$e(1,D.IExtHostRpcService),$e(2,y.ILogService)],A),e.ExtHostLocalizationService=A,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(De[137],Ie([1,0,13,5,25,16,2,3,12]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends u.AbstractLoggerService{constructor(E,T){super(T.logLevel,I.Event.None),this._proxy=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,T){T?this.setLevel(y.URI.revive(T),E):(0,S.isUndefined)(E)||this.setLevel(E)}doCreateLogger(E,T,_){return new A(this._proxy,E,T,_)}};D=je([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class A extends u.AbstractMessageLogger{constructor(E,T,_,g){super(g?.always),this.proxy=E,this.file=T,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(T,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,T){const _=[[E,T]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(E){this.proxy.$log(this.file,E)}}}),define(De[254],Ie([1,0,5,13,28]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(I){return I&&I.title}let y=class{constructor(S,D){this._logService=D,this._proxy=S.getProxy(u.MainContext.MainThreadMessageService)}showMessage(S,D,A,k,E){const T={source:{identifier:S.identifier,label:S.displayName||S.name}};let _;typeof k=="string"||P(k)?_=[k,...E]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,_=E),T.useCustom&&(0,C.checkProposedApiEnabled)(S,"resolvers");const g=[];for(let p=0;p<_.length;p++){const m=_[p];if(typeof m=="string")g.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){const{title:b,isCloseAffordance:f}=m;g.push({title:b,isCloseAffordance:!!f,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(D,A,T,g).then(p=>{if(typeof p=="number")return _[p]})}};y=je([$e(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(De[255],Ie([1,0,23,3,6,26,8,12,2,87,5,39,15,7,56,230,133]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}constructor(f,c,v,a){this._textDocumentsAndEditors=v,this._textDocuments=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new D.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=f.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===12){const o=d.notebookEditor?.notebookUri,i=d.cell.handle,l=this._documents.get(o)?.getCell(i);if(l)return l.apiCell}if(d&&d.$mid===13){const o=d.uri,i=this._documents.get(o);if(i)return i.apiNotebook}return d}}),m._registerApiCommands(c)}getEditorById(f){const c=this._editors.get(f);if(!c)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(f){for(const[c,v]of this._editors)if(v.apiEditor===f)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,c){const v=this._documents.get(f);if(!v&&!c)throw new Error(`NO notebook document for '${f}'`);return v}_getProviderData(f){const c=this._notebookContentProviders.get(f);if(!c)throw new Error(`NO provider for '${f}'`);return c}registerNotebookContentProvider(f,c,v,a,d){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);return this._notebookContentProviders.set(c,{extension:f,provider:v}),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},c,E.NotebookDocumentContentOptions.from(a),m._convertNotebookRegistrationData(f,d)),new T.Disposable(()=>{this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(f,c){if(!c)return;const v=c.filenamePattern.map(a=>E.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(c.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:c.displayName,filenamePattern:v,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,c,v){const a=m._notebookStatusBarItemProviderHandlePool++,d=typeof v.onDidChangeCellStatusBarItems=="function"?m._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,d,c);let o;return d!==void 0&&(o=v.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(d))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,d),o?.dispose()})}async createNotebookDocument(f){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&E.NotebookData.from(f.content)});return S.URI.revive(c)}async openNotebookDocument(f){const c=this._documents.get(f);if(c)return c.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(f),a=this._documents.get(S.URI.revive(v));return(0,I.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(f,c){S.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let v;typeof c=="object"?v={position:E.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(E.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:v={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,v),d=a&&this._editors.get(a)?.apiEditor;if(d)return d;throw a?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,c,v,a){const d=this._notebookStatusBarItemProviders.get(f),o=S.URI.revive(c),i=this._documents.get(o);if(!i||!d)return;const s=i.getCellFromIndex(v);if(!s)return;const l=await d.provideCellStatusBarItems(s.apiCell,a);if(!l)return;const n=new C.DisposableStore,r=this._statusBarCache.add([n]),w=(Array.isArray(l)?l:[l]).map(L=>E.NotebookStatusBarItem.from(L,this._commandsConverter,n));return{cacheId:r,items:w}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,c,v,a,d){if((0,y.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,v),this._notebookProxy.$registerNotebookSerializer(o,{id:f.identifier,location:f.extensionLocation},c,E.NotebookDocumentContentOptions.from(a),m._convertNotebookRegistrationData(f,d)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(f,c,v){const a=this._notebookSerializer.get(f);if(!a)throw new Error("NO serializer found");const d=await a.deserializeNotebook(c.buffer,v);return new _.SerializableObjectWithBuffers(E.NotebookData.from(d))}async $notebookToData(f,c,v){const a=this._notebookSerializer.get(f);if(!a)throw new Error("NO serializer found");const d=await a.serializeNotebook(E.NotebookData.to(c.value),v);return u.VSBuffer.wrap(d)}async $openNotebook(f,c,v,a,d){const{provider:o}=this._getProviderData(f),i=await o.openNotebook(S.URI.revive(c),{backupId:v,untitledDocumentData:a?.buffer},d);return new _.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(E.NotebookCellData.from)})}_createExtHostEditor(f,c,v){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const a=new p.ExtHostNotebookEditor(c,this._notebookEditorsProxy,f,v.visibleRanges.map(E.NotebookRange.to),v.selections.map(E.NotebookRange.to),typeof v.viewColumn=="number"?E.ViewColumn.to(v.viewColumn):void 0);this._editors.set(c,a)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const v of f.value.removedDocuments){const a=S.URI.revive(v),d=this._documents.get(a);d&&(d.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(d.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===a.toString()&&this._editors.delete(o.id)}if(f.value.addedDocuments){const v=[];for(const a of f.value.addedDocuments){const d=S.URI.revive(a.uri);if(this._documents.has(d))throw new Error(`adding EXISTING notebook ${d} `);const o=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,d,a);v.push(...a.cells.map(i=>g.ExtHostCell.asModelAddData(o.apiNotebook,i))),this._documents.get(d)?.dispose(),this._documents.set(d,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(f.value.addedEditors)for(const v of f.value.addedEditors){if(this._editors.has(v.id))return;const a=S.URI.revive(v.documentUri),d=this._documents.get(a);d&&this._createExtHostEditor(d,v.id,v)}const c=[];if(f.value.removedEditors)for(const v of f.value.removedEditors){const a=this._editors.get(v);a&&(this._editors.delete(v),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),c.push(a))}if(f.value.visibleEditors){this._visibleNotebookEditors=f.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const v=new Set;this._visibleNotebookEditors.forEach(a=>v.add(a.id));for(const a of this._editors.values()){const d=v.has(a.id);a._acceptVisibility(d)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this._activeNotebookEditor=void 0:f.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(f){const c=k.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new k.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>u.VSBuffer.wrap(d))],new k.ApiCommandResult("Notebook Data",d=>E.NotebookData.to(d.value))),a=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new _.SerializableObjectWithBuffers(E.NotebookData.from(d)))],new k.ApiCommandResult("Bytes",d=>d.buffer));f.registerApiCommand(v),f.registerApiCommand(a)}}e.ExtHostNotebookController=m,m._notebookStatusBarItemProviderHandlePool=0}),define(De[256],Ie([1,0,17,18,21,3,6,26,2,27,13,5,39,15,7,88,218,28,56]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(i,s,l,n,r){this._initData=s,this._extHostNotebook=l,this._commands=n,this._logService=r,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(k.MainContext.MainThreadNotebookKernels);const h=new E.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const L=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:L}}else if(w&&"notebookEditor"in w){const L=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return w})],E.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(i,s,l,n,r,h){for(const K of this._kernelData.values())if(K.controller.id===s&&D.ExtensionIdentifier.equals(i.identifier,K.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const w=this._handlePool++,L=this;this._logService.trace(`NotebookController[${w}], CREATED by ${i.identifier.value}, ${s}`);const M=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${i.identifier}'`);let B=!1;const R=new y.DisposableStore,z=new P.Emitter,H=new P.Emitter,N={id:d(i.identifier,s),notebookType:l,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:n||i.identifier.value,preloads:h?h.map(T.NotebookRendererScript.from):[]};let V=r??M,U;this._proxy.$addKernel(w,N).catch(K=>{console.log(K),B=!0});let F=0;const x=()=>{if(B)return;const K=++F;Promise.resolve().then(()=>{K===F&&this._proxy.$updateKernel(w,N)})},$=new I.ResourceMap,Q={get id(){return s},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(K){N.label=K??i.displayName??i.name,x()},get detail(){return N.detail??""},set detail(K){N.detail=K,x()},get description(){return N.description??""},set description(K){N.description=K,x()},get kind(){return(0,m.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind??""},set kind(K){(0,m.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind=K,x()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(K){N.supportedLanguages=K,x()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(K){N.supportsExecutionOrder=K,x()},get rendererScripts(){return N.preloads?N.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(K){V=K??M},get interruptHandler(){return U},set interruptHandler(K){U=K,N.supportsInterrupt=Boolean(K),x()},createNotebookCellExecution(K){if(B)throw new Error("notebook controller is DISPOSED");if(!$.has(K.notebook.uri))throw L._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return L._createNotebookCellExecution(K,d(i.identifier,this.id))},dispose:()=>{B||(this._logService.trace(`NotebookController[${w}], DISPOSED`),B=!0,this._kernelData.delete(w),R.dispose(),z.dispose(),H.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(K,de){de===_.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(i,"notebookControllerAffinityHidden"),L._proxy.$updateNotebookPriority(w,K.uri,de)},onDidReceiveMessage:H.event,postMessage(K,de){return(0,m.checkProposedApiEnabled)(i,"notebookMessaging"),L._proxy.$postMessage(w,de&&L._extHostNotebook.getIdByEditor(de),K)},asWebviewUri(K){return(0,m.checkProposedApiEnabled)(i,"notebookMessaging"),(0,g.asWebviewUri)(K,L._initData.remote)}};return this._kernelData.set(w,{extensionId:i.identifier,controller:Q,onDidReceiveMessage:H,onDidChangeSelection:z,associatedNotebooks:$}),Q}getIdByController(i){for(const[s,l]of this._kernelData)if(l.controller===i)return d(l.extensionId,i.id);return null}$acceptNotebookAssociation(i,s,l){const n=this._kernelData.get(i);if(n){const r=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));l?n.associatedNotebooks.set(r.uri,!0):n.associatedNotebooks.delete(r.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,r.uri.toString(),l),n.onDidChangeSelection.fire({selected:l,notebook:r.apiNotebook})}}async $executeCells(i,s,l){const n=this._kernelData.get(i);if(!n)return;const r=this._extHostNotebook.getNotebookDocument(S.URI.revive(s)),h=[];for(const w of l){const L=r.getCell(w);L&&h.push(L.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,r.uri.toString(),h.length),await n.controller.executeHandler.call(n.controller,h,r.apiNotebook,n.controller)}catch(w){this._logService.error(`NotebookController[${i}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(i,s,l){const n=this._kernelData.get(i);if(!n)return;const r=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,r.apiNotebook);else for(const h of l){const w=r.getCell(h);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,s,l){const n=this._kernelData.get(i);if(!n)return;const r=this._extHostNotebook.getEditorById(s);n.onDidReceiveMessage.fire(Object.freeze({editor:r.apiEditor,message:l}))}$cellExecutionChanged(i,s,l){const r=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)).getCell(s);if(r){const h=l?T.NotebookCellExecutionState.to(l):_.NotebookCellExecutionState.Idle;h!==void 0&&this._onDidChangeCellExecutionState.fire({cell:r.apiCell,state:h})}}_createNotebookCellExecution(i,s){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const r=new v(s,n,this._proxy);this._activeExecutions.set(n.uri,r);const h=r.onDidChangeState(()=>{r.state===c.Resolved&&(r.dispose(),h.dispose(),this._activeExecutions.delete(n.uri))});return r.asApiObject()}};f=je([$e(4,A.ILogService)],f),e.ExtHostNotebookKernels=f;var c;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(c||(c={}));class v extends y.Disposable{get state(){return this._state}constructor(i,s,l){super(),this._cell=s,this._proxy=l,this._handle=v.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new a(10,n=>this.update(n)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const s=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let s=this._cell;if(i&&(s=this._cell.notebook.getCellFromApiCell(i)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(i){return i.map(s=>{const l=_.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return l===s.items?T.NotebookCellOutput.from(s):T.NotebookCellOutput.from({items:l,id:s.id,metadata:s.metadata})})}async updateOutputs(i,s,l){const n=this.cellIndexToHandle(s),r=this.validateAndConvertOutputs((0,u.asArray)(i));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,cellHandle:n,append:l,outputs:r})}async updateOutputItems(i,s,l){return i=_.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(i),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:s.id,append:l})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(l){i._executionOrder=l,i.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(l){if(i._state===c.Resolved||i._state===c.Started)throw new Error("Cannot call start again");i._state=c.Started,i._onDidChangeState.fire(),i.update({editType:p.CellExecutionUpdateType.ExecutionState,runStartTime:l})},end(l,n){if(i._state===c.Resolved)throw new Error("Cannot call resolve twice");i._state=c.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new b.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:l}))},clearOutput(l){return i.verifyStateForOutput(),i.updateOutputs([],l,!1)},appendOutput(l,n){return i.verifyStateForOutput(),i.updateOutputs(l,n,!0)},replaceOutput(l,n){return i.verifyStateForOutput(),i.updateOutputs(l,n,!1)},appendOutputItems(l,n){return i.verifyStateForOutput(),i.updateOutputItems(l,n,!0)},replaceOutputItems(l,n){return i.verifyStateForOutput(),i.updateOutputItems(l,n,!1)}})}}v.HANDLE=0;class a{constructor(i,s){this.delay=i,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>i.complete())}}function d(o,i){return`${o.value}/${i}`}e.createKernelId=d}),define(De[257],Ie([1,0,3,5,133]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(I,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,S,D){const A=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(S)?.fire({editor:A.apiEditor,message:D})}createRendererMessaging(I,S){if(!I.contributes?.notebookRenderer?.some(A=>A.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(A,k,E)=>this.getOrCreateEmitterFor(S).event(A,k,E),postMessage:(A,k)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const E=k&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(E?.id,S,A)}}}getOrCreateEmitterFor(I){let S=this._rendererMessageEmitters.get(I);return S||(S=new u.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,S),S)}}e.ExtHostNotebookRenderers=P}),define(De[258],Ie([1,0,21,3,6,5,2,7,11,17,42,86]),function(J,e,u,t,C,P,y,I,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(T,_,g){const p=T.getProxy(P.MainContext.MainThreadQuickOpen);class m{constructor(s,l){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=l}showQuickPick(s,l,n=u.CancellationToken.None){this._onDidSelectItem=void 0;const r=Promise.resolve(s),h=++this._instances,w=p.$show(h,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},n),L={},M=w.then(()=>L);return Promise.race([M,r]).then(B=>{if(B!==L)return r.then(R=>{const z=[];for(let H=0;H<R.length;H++){const N=R[H];typeof N=="string"?z.push({label:N,handle:H}):N.kind===I.QuickPickItemKind.Separator?z.push({type:"separator",label:N.label}):z.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:H})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{l.onDidSelectItem(R[H])}),p.$setItems(h,z),w.then(H=>{if(typeof H=="number")return R[H];if(Array.isArray(H))return H.map(N=>R[N])})})}).then(void 0,B=>{if(!(0,S.isCancellationError)(B))return p.$setError(h,B),Promise.reject(B)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,l=u.CancellationToken.None){return this._validateInput=s?.validateInput,p.$input(s,typeof this._validateInput=="function",l).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(s){if(!this._validateInput)return;const l=await this._validateInput(s);if(!l||typeof l=="string")return l;let n;switch(l.severity){case I.InputBoxValidationSeverity.Info:n=A.default.Info;break;case I.InputBoxValidationSeverity.Warning:n=A.default.Warning;break;case I.InputBoxValidationSeverity.Error:n=A.default.Error;break;default:n=l.message?A.default.Error:A.default.Ignore;break}return{content:l.message,severity:n}}async showWorkspaceFolderPick(s,l=u.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!n)return;const r=await this._workspace.getWorkspaceFolders2();if(!!r)return r.find(h=>h.uri.toString()===n.uri.toString())}createQuickPick(s){const l=new d(s,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(s){const l=new o(s,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(s,l){this._sessions.get(s)?._fireDidChangeValue(l)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,l){const n=this._sessions.get(s);n instanceof d&&n._fireDidChangeActive(l)}$onDidChangeSelection(s,l){const n=this._sessions.get(s);n instanceof d&&n._fireDidChangeSelection(l)}$onDidTriggerButton(s,l){this._sessions.get(s)?._fireDidTriggerButton(l)}$onDidTriggerItemButton(s,l,n){const r=this._sessions.get(s);r instanceof d&&r._fireDidTriggerItemButton(l,n)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class b{constructor(s,l){this._extensionId=s,this._onDidDispose=l,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((l,n)=>{const r=l===I.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(r,l)}),this.update({buttons:s.map((l,n)=>({...a(l),tooltip:l.tooltip,handle:l===I.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const l=this._handlesToButtons.get(s);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(s){if(!this._disposed){for(const l of Object.keys(s)){const n=s[l];this._pendingUpdate[l]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function f(i){if(i instanceof I.ThemeIcon)return{id:i.id};const s=v(i),l=c(i);return{dark:typeof s=="string"?y.URI.file(s):s,light:typeof l=="string"?y.URI.file(l):l}}function c(i){return typeof i=="object"&&"light"in i?i.light:i}function v(i){return typeof i=="object"&&"dark"in i?i.dark:i}function a(i){const s=f(i.iconPath);let l,n;return"id"in s?n=k.ThemeIcon.asClassName(s):l=s,{iconPath:l,iconClass:n}}class d extends b{constructor(s,l){super(s.identifier,l),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((n,r)=>{this._handlesToItems.set(r,n),this._itemsToHandles.set(n,r)});const l=[];for(let n=0;n<s.length;n++){const r=s[n];r.kind===I.QuickPickItemKind.Separator?l.push({type:"separator",label:r.label}):l.push({handle:n,label:r.label,description:r.description,detail:r.detail,picked:r.picked,alwaysShow:r.alwaysShow,buttons:r.buttons?.map((h,w)=>({...a(h),tooltip:h.tooltip,handle:w}))})}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(s){const l=(0,D.coalesce)(s.map(n=>this._handlesToItems.get(n)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(s){const l=(0,D.coalesce)(s.map(n=>this._handlesToItems.get(n)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(s,l){const n=this._handlesToItems.get(s);if(!n||!n.buttons||!n.buttons.length)return;const r=n.buttons[l];r&&this._onDidTriggerItemButtonEmitter.fire({button:r,item:n})}}class o extends b{constructor(s,l){super(s.identifier,l),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:A.default.Error}):this.update({validationMessage:s.message,severity:s.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new m(_,g)}e.createExtHostQuickOpen=E});var Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u};define(De[259],Ie([1,0,2,3,59,6,18,5,17,107,13,27,86,15,28]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_){"use strict";var g,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(r){if(r)return typeof r.iconPath=="string"?u.URI.file(r.iconPath):u.URI.isUri(r.iconPath)||E.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function b(r,h){if(!r.iconPath&&!h.iconPath)return 0;if(r.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof r.iconPath=="string"?r.iconPath:u.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,L=typeof h.iconPath=="string"?h.iconPath:u.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,D.comparePaths)(w,L)}function f(r,h){let w=0;if(r.strikeThrough!==h.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==h.faded)return r.faded?1:-1;if(r.tooltip!==h.tooltip)return(r.tooltip||"").localeCompare(h.tooltip||"");if(w=b(r,h),w!==0)return w;if(r.light&&h.light)w=b(r.light,h.light);else{if(r.light)return 1;if(h.light)return-1}if(w!==0)return w;if(r.dark&&h.dark)w=b(r.dark,h.dark);else{if(r.dark)return 1;if(h.dark)return-1}return w}function c(r,h){if(r.command!==h.command)return r.command<h.command?-1:1;if(r.title!==h.title)return r.title<h.title?-1:1;if(r.tooltip!==h.tooltip){if(r.tooltip!==void 0&&h.tooltip!==void 0)return r.tooltip<h.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(r.arguments===h.arguments)return 0;if(r.arguments)if(h.arguments){if(r.arguments.length!==h.arguments.length)return r.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<r.arguments.length;w++){const L=r.arguments[w],M=h.arguments[w];if(L!==M)return L<M?-1:1}return 0}function v(r,h){let w=(0,D.comparePaths)(r.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(r.command&&h.command)w=c(r.command,h.command);else{if(r.command)return 1;if(h.command)return-1}if(w!==0)return w;if(r.decorations&&h.decorations)w=f(r.decorations,h.decorations);else{if(r.decorations)return 1;if(h.decorations)return-1}return w}function a(r,h){for(let w=0;w<r.length;w++)if(r[w]!==h[w])return!1;return!0}function d(r,h){return r.command===h.command&&r.title===h.title&&r.tooltip===h.tooltip&&(r.arguments&&h.arguments?a(r.arguments,h.arguments):r.arguments===h.arguments)}function o(r,h){return(0,S.equals)(r,h,d)}class i{get value(){return this._value}set value(h){h=h??"",Be(this,g,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Be(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Be(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Be(this,g,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Be(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}constructor(h,w,L){this._extension=h,this._sourceControlHandle=L,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,g,w,"f")}showValidationMessage(h,w){(0,_.checkProposedApiEnabled)(this._extension,"scmValidation"),Be(this,g,"f").$showValidationMessage(this._sourceControlHandle,h,w)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,g=new WeakMap;class s{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}constructor(h,w,L,M,B){this._proxy=h,this._commands=w,this._sourceControlHandle=L,this._id=M,this._label=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,w){const L=this._resourceStatesCommandsMap.get(h);return L?(0,y.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(v),L=(0,S.sortedDiff)(this._resourceSnapshot,h,v).map(R=>{const z=R.toInsert.map(H=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,H);const V=H.resourceUri;let U;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const me=new P.DisposableStore;U=this._commands.converter.toInternal(H.command,me),this._resourceStatesDisposablesMap.set(N,me)}else this._resourceStatesCommandsMap.set(N,H.command);const F=m(H.decorations),x=H.decorations&&m(H.decorations.light)||F,$=H.decorations&&m(H.decorations.dark)||F,Q=[x,$],K=H.decorations&&H.decorations.tooltip||"",de=H.decorations&&!!H.decorations.strikeThrough,ee=H.decorations&&!!H.decorations.faded,he=H.contextValue||"";return{rawResource:[N,V,Q,K,de,ee,he,U],handle:N}});return{start:R.start,deleteCount:R.deleteCount,toInsert:z}}),M=L.map(({start:R,deleteCount:z,toInsert:H})=>[R,z,H.map(N=>N.rawResource)]),B=L.reverse();for(const{start:R,deleteCount:z,toInsert:H}of B){const N=H.map(U=>U.handle),V=this._handlesSnapshot.splice(R,z,...N);for(const U of V)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=h,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class l{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Be(this,p,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Be(this,p,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Be(this,p,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=h;const w=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Be(this,p,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,_.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=h;const w=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(L=>L.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Be(this,p,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&o(this._statusBarCommands,h))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=h;const w=(h||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Be(this,p,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}constructor(h,w,L,M,B,R){this._extension=h,this._commands=L,this._id=M,this._label=B,this._rootUri=R,p.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=l._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,p,w,"f"),this._inputBox=new i(h,Be(this,p,"f"),this.handle),Be(this,p,"f").$registerSourceControl(this.handle,M,B,R)}createResourceGroup(h,w){const L=new s(Be(this,p,"f"),this._commands,this.handle,h,w),M=t.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,M),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const h=[],w=[];for(const[L,M]of this.createdResourceGroups){M.dispose();const B=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),B.dispose(),this._groups.delete(L.handle),Be(this,p,"f").$unregisterGroup(this.handle,L.handle)}),h.push([L.handle,L.id,L.label,L.features]);const R=L._takeResourceStateSnapshot();R.length>0&&w.push([L.handle,R]),this._groups.set(L.handle,L)}Be(this,p,"f").$registerGroups(this.handle,h,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(w=>{const L=w._takeResourceStateSnapshot();L.length!==0&&h.push([w.handle,L])}),h.length>0&&Be(this,p,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Be(this,p,"f").$unregisterSourceControl(this.handle)}}p=new WeakMap,l._handlePool=0,je([(0,C.debounce)(100)],l.prototype,"eventuallyAddResourceGroups",null),je([(0,C.debounce)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let n=class Zn{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(h,w,L){this._commands=w,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=h.getProxy(I.MainContext.MainThreadSCM),this._telemetry=h.getProxy(I.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const B=this._sourceControls.get(M.sourceControlHandle);if(!B)return M;const R=B.getResourceGroup(M.groupHandle);return R?R.getResourceState(M.handle):M}else if(M&&M.$mid===4){const B=this._sourceControls.get(M.sourceControlHandle);return B?B.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const B=this._sourceControls.get(M.handle);return B||M}return M}})}createSourceControl(h,w,L,M){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,L,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const B=Zn._handlePool++,R=new l(h,this._proxy,this._commands,w,L,M);this._sourceControls.set(B,R);const z=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier))||[];return z.push(R),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(h.identifier),z),R}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier)),L=w&&w[w.length-1];return L&&L.inputBox}$provideOriginalResource(h,w,L){const M=u.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,M.toString());const B=this._sourceControls.get(h);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>B.quickDiffProvider.provideOriginalResource(M,L)).then(R=>R||null)}$onInputBoxValueChange(h,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const L=this._sourceControls.get(h);return L&&L.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,L,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,w,L);const B=this._sourceControls.get(h);if(!B)return Promise.resolve(void 0);const R=B.getResourceGroup(w);return R?R.$executeResourceCommand(L,M):Promise.resolve(void 0)}$validateInput(h,w,L){this.logService.trace("ExtHostSCM#$validateInput",h);const M=this._sourceControls.get(h);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>M.inputBox.validateInput(w,L)).then(B=>{if(!B)return Promise.resolve(void 0);const R=T.MarkdownString.fromStrict(B.message);return R?Promise.resolve([R,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};n._handlePool=0,n=je([$e(2,A.ILogService)],n),e.ExtHostSCM=n}),define(De[94],Ie([1,0,5,3,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,S){return this._proxy.$getPassword(I,S)}store(I,S,D){return this._proxy.$setPassword(I,S,D)}delete(I,S){return this._proxy.$deletePassword(I,S)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[260],Ie([1,0,7,5,173,6,15,12]),function(J,e,u,t,C,P,y,I){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(_,g,p,m,b=u.StatusBarAlignment.Left,f){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,S,_,"f"),tt(this,D,g,"f"),this._entryId=A.ID_GEN++,this._extension=p,this._id=m,this._alignment=b,this._priority=this.validatePriority(f)}validatePriority(_){if(!!(0,I.isNumber)(_))return _===Number.POSITIVE_INFINITY?Number.MAX_VALUE:_===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:_}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(_){this._text=_,this.update()}set name(_){this._name=_,this.update()}set tooltip(_){this._tooltip=_,this.update()}set color(_){this._color=_,this.update()}set backgroundColor(_){_&&!A.ALLOWED_BACKGROUND_COLORS.has(_.id)&&(_=void 0),this._backgroundColor=_,this.update()}set command(_){this._command?.fromApi!==_&&(this._internalCommandRegistration.clear(),typeof _=="string"?this._command={fromApi:_,internal:Be(this,D,"f").toInternal({title:"",command:_},this._internalCommandRegistration)}:_?this._command={fromApi:_,internal:Be(this,D,"f").toInternal(_,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(_){this._accessibilityInformation=_,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let _;this._extension?this._id?_=`${this._extension.identifier.value}.${this._id}`:_=this._extension.identifier.value:_=this._id;let g;this._name?g=this._name:g=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const m=y.MarkdownString.fromStrict(this._tooltip);Be(this,S,"f").$setEntry(this._entryId,_,g,this._text,m,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,S=new WeakMap,D=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(_){this._messages=[],this._item=_.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(_){const g={message:_};return this._messages.unshift(g),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(g);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(_,g){this._proxy=_.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(_,g,p,m){return new A(this._proxy,this._commands,_,g,p,m)}setStatusBarMessage(_,g){const p=this._statusMessage.setMessage(_);let m;return typeof g=="number"?m=setTimeout(()=>p.dispose(),g):typeof g<"u"&&g.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=E}),define(De[95],Ie([1,0,5,3,4]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,S){this._proxy.$registerExtensionStorageKeysToSync(I,S)}initializeExtensionStorage(I,S,D){return this._proxy.$initializeExtensionStorage(I,S).then(A=>A||D)}setValue(I,S,D){return this._proxy.$setValue(I,S,D)}$acceptValue(I,S,D){this._onDidChangeStorage.fire({shared:I,key:S,value:D})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(De[69],Ie([1,0,4,25,13,68,2]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let I=class{constructor(D,A,k){this._logService=A,this._extHostFileSystem=k,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(E=>this._value=E)}async _getWorkspaceStorageURI(D){return y.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,A=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this._value)return y.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return y.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=je([$e(0,t.IExtHostInitDataService),$e(1,C.ILogService),$e(2,P.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(De[40],Ie([1,0,3,5,4,2,16,6,7,174,11,219,21,31,204,86,12,18,15]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class f{constructor(n,r,h,w){this._proxy=n,this._id=r,this._creationOptions=h,this._name=w,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(M=>this._pidPromiseComplete=M);const L=this;this.value={get name(){return L._name||""},get processId(){return L._pidPromise},get creationOptions(){return L._creationOptions},get exitStatus(){return L._exitStatus},get state(){return L._state},sendText(M,B=!0){L._checkDisposed(),L._proxy.$sendText(L._id,M,B)},show(M){L._checkDisposed(),L._proxy.$show(L._id,M)},hide(){L._checkDisposed(),L._proxy.$hide(L._id)},dispose(){L._disposed||(L._disposed=!0,L._proxy.$dispose(L._id))},get dimensions(){if(!(L._cols===void 0||L._rows===void 0))return{columns:L._cols,rows:L._rows}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,p.withNullAsUndefined)(n.shellPath),shellArgs:(0,p.withNullAsUndefined)(n.shellArgs),cwd:(0,p.withNullAsUndefined)(n.cwd),env:(0,p.withNullAsUndefined)(n.env),icon:(0,p.withNullAsUndefined)(i(n.iconPath)),color:g.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,p.withNullAsUndefined)(n.message),strictEnv:(0,p.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this._serializeParentTerminal(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,p.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:g.ThemeColor.isThemeColor(w)?w.id:void 0,location:this._serializeParentTerminal(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,r){this._exitStatus=Object.freeze({code:n,reason:r})}setDimensions(n,r){return n===this._cols&&r===this._rows||n===0||r===0?!1:(this._cols=n,this._rows=r,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=f;class c{get onProcessReady(){return this._onProcessReady.event}constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,r){this._pty.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose?.((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions?.(r=>{r&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this._pty.onDidChangeName?.(r=>{this._onDidChangeProperty.fire({type:"title",value:r})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let v=1,a=class extends I.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(n,r){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new u.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=r.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new _.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[h,w]of this._terminalProcesses)w.shutdown(!0)}})}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,r){const h=new f(this._proxy,(0,T.generateUuid)(),n,n.name),w=new c(n.pty);return h.createExtensionTerminal(n.location,this._serializeParentTerminal(n,r).resolvedExtHostIdentifier,i(n.iconPath),s(n.color)).then(L=>{const M=this._setupExtHostProcessListeners(L,w);this._terminalProcessDisposables[L]=M}),this._terminals.push(h),h.value}_serializeParentTerminal(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const h=n.location.parentTerminal;if(h){const w=this._terminals.find(L=>L.value===h);w&&(r.resolvedExtHostIdentifier=w._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const w=new c(r),L=this._setupExtHostProcessListeners(n,w);this._terminalProcessDisposables[n]=L}async $acceptActiveTerminalChanged(n){const r=this._activeTerminal;if(n===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(n);h&&(this._activeTerminal=h,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,r){const h=this._getTerminalById(n);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:r})}async $acceptTerminalDimensions(n,r,h){const w=this._getTerminalById(n);w&&w.setDimensions(r,h)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,h){this._terminalProcesses.get(n)?.resize(r,h)}async $acceptTerminalTitleChange(n,r){const h=this._getTerminalById(n);h&&(h.name=r)}async $acceptTerminalClosed(n,r,h){const w=this._getTerminalObjectIndexById(this._terminals,n);if(w!==null){const L=this._terminals.splice(w,1)[0];L.setExitStatus(r,h),this._onDidCloseTerminal.fire(L.value)}}$acceptTerminalOpened(n,r,h,w){if(r){const B=this._getTerminalObjectIndexById(this._terminals,r);if(B!==null){this._terminals[B]._id=n,this._onDidOpenTerminal.fire(this.terminals[B]),this._terminals[B].isOpen=!0;return}}const L={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:P.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},M=new f(this._proxy,n,L,h);this._terminals.push(M),this._onDidOpenTerminal.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,r){this._getTerminalById(n)?._setProcessId(r)}async $startExtensionTerminal(n,r){const h=this._getTerminalById(n);if(!h)return{message:(0,D.localize)(0,null,n)};h.isOpen||await new Promise(L=>{const M=this.onDidOpenTerminal(async B=>{B===h.value&&(M.dispose(),L())})});const w=this._terminalProcesses.get(n);w?w.startSendingEvents(r):this._extensionTerminalAwaitingStart[n]={initialDimensions:r}}_setupExtHostProcessListeners(n,r){const h=new I.DisposableStore;h.add(r.onProcessReady(L=>this._proxy.$sendProcessReady(n,L.pid,L.cwd))),h.add(r.onDidChangeProperty(L=>this._proxy.$sendProcessProperty(n,L))),this._bufferer.startBuffering(n,r.onProcessData),h.add(r.onProcessExit(L=>this._onProcessExit(n,L))),this._terminalProcesses.set(n,r);const w=this._extensionTerminalAwaitingStart[n];return w&&r instanceof c&&(r.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),h}$acceptProcessAckDataEvent(n,r){this._terminalProcesses.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this._terminalProcesses.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this._getTerminalById(n);r?.setInteractedWith()&&this._onDidChangeTerminalState.fire(r.value)}$acceptProcessResize(n,r,h){try{this._terminalProcesses.get(n)?.resize(r,h)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(n,r){this._terminalProcesses.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(r=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(r=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,r,h){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,h),this._proxy.$registerProfileProvider(r,n.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(n,r){const h=new E.CancellationTokenSource().token;let w=await this._profileProviders.get(n)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,r);return}this.createTerminalFromOptions(w.options,r)}}async $provideLinks(n,r){const h=this._getTerminalById(n);if(!h)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const L=new E.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,L);const M=[],B={terminal:h.value,line:r},R=[];for(const N of this._linkProviders)R.push(m.Promises.withAsyncBody(async V=>{L.token.onCancellationRequested(()=>V({provider:N,links:[]}));const U=await N.provideTerminalLinks(B,L.token)||[];L.token.isCancellationRequested||V({provider:N,links:U})}));const z=await Promise.all(R);if(L.token.isCancellationRequested)return[];const H=new Map;for(const N of z)N&&N.links.length>0&&M.push(...N.links.map(V=>{const U={id:v++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return H.set(U.id,{provider:N.provider,link:V}),U}));return this._terminalLinkCache.set(n,H),M}$activateLink(n,r){const h=this._terminalLinkCache.get(n)?.get(r);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(n,r){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const h=this._terminalProcessDisposables[n];h&&(h.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,r)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,r){const h=this._getTerminalObjectIndexById(n,r);return h!==null?n[h]:null}_getTerminalObjectIndexById(n,r){let h=null;return n.some((w,L)=>w._id===r?(h=L,!0):!1),h}getEnvironmentVariableCollection(n){let r=this._environmentVariableCollections.get(n.identifier.value);return r||(r=new d,this._setEnvironmentVariableCollection(n.identifier.value,r)),r}_syncEnvironmentVariableCollection(n,r){const h=(0,k.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(n,r.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const h=r[0],w=new d(r[1]);this._setEnvironmentVariableCollection(h,w)})}$acceptDefaultProfile(n,r){const h=this._defaultProfile;this._defaultProfile=n,this._defaultAutomationProfile=r,h?.path!==n.path&&this._onDidChangeShell.fire(n.path)}_setEnvironmentVariableCollection(n,r){this._environmentVariableCollections.set(n,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,r)})}};a=je([$e(1,y.IExtHostRpcService)],a),e.BaseExtHostTerminalService=a;class d{get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,r){this._setIfDiffers(n,{value:r,type:S.EnvironmentVariableMutatorType.Replace})}append(n,r){this._setIfDiffers(n,{value:r,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,r){this._setIfDiffers(n,{value:r,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,r){const h=this.map.get(n);(!h||h.value!==r.value||h.type!==r.type)&&(this.map.set(n,r),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((h,w)=>n.call(r,w,h,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let o=class extends a{constructor(n){super(!1,n)}createTerminal(n,r,h){throw new A.NotSupportedError}createTerminalFromOptions(n,r){throw new A.NotSupportedError}};o=je([$e(0,y.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function i(l){if(!(!l||typeof l=="string"))return"id"in l?{id:l.id,color:l.color}:l}function s(l){return g.ThemeColor.isThemeColor(l)?l:void 0}});var Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u};define(De[261],Ie([1,0,17,23,21,3,60,79,6,24,12,31,5,16,134,15,7,55,90,66]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f){"use strict";var c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(B,R,z){this.editors=z,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(E.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new o(this.proxy),R.registerArgumentProcessor({processArgument:H=>{if(H?.$mid!==14)return H;const N=H,V=N.tests[N.tests.length-1].item.extId;return this.controllers.get(m.TestId.root(V))?.collection.tree.get(V)?.actual??(0,_.toItemFromContext)(H)}})}createTestController(B,R,z){if(this.controllers.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const H=new S.DisposableStore,N=H.add(new _.ExtHostTestItemCollection(B,R,this.editors));N.root.label=R;const V=new Map,U=this.proxy,F={items:N.root.children,get label(){return R},set label($){R=$,N.root.label=$,U.$updateController(B,{label:R})},get refreshHandler(){return z},set refreshHandler($){z=$,U.$updateController(B,{canRefresh:!!$})},get id(){return B},createRunProfile:($,Q,K,de,ee)=>{let he=(0,I.hash)($);for(;V.has(he);)he++;return new w(this.proxy,V,B,he,$,Q,K,de,ee)},createTestItem($,Q,K){return new _.TestItemImpl(B,$,Q,K)},createTestRun:($,Q,K=!0)=>this.runTracker.createTestRun(B,N,$,Q,K),set resolveHandler($){N.resolveHandler=$},get resolveHandler(){return N.resolveHandler},dispose:()=>{H.dispose()}};U.$registerTestController(B,R,!!z),H.add((0,S.toDisposable)(()=>U.$unregisterTestController(B)));const x={controller:F,collection:N,profiles:V};return this.controllers.set(B,x),H.add((0,S.toDisposable)(()=>this.controllers.delete(B))),H.add(N.onDidGenerateDiff($=>U.$publishDiff(B,$.map(f.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(B,R=C.CancellationToken.None){const z=i(B);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(z.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(N=>m.TestId.fromExtHostTestItem(N,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:L[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:B.exclude?.map(N=>N.id)},R)}$syncTests(){for(const{collection:B}of this.controllers.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,R,z){return(0,u.mapFind)(this.runTracker.trackers,N=>N.id===B?N.getCoverage(R):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(B,R,z,H){return(0,u.mapFind)(this.runTracker.trackers,V=>V.id===B?V.getCoverage(R):void 0)?.resolveFileCoverage(z,H)??Promise.resolve([])}$configureRunProfile(B,R){this.controllers.get(B)?.profiles.get(R)?.configureHandler?.()}async $refreshTests(B,R){await this.controllers.get(B)?.controller.refreshHandler?.(R)}$publishTestResults(B){this.results=Object.freeze(B.map(R=>(0,D.deepFreeze)(g.TestResults.to(R))).concat(this.results).sort((R,z)=>z.completedAt-R.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,R){const z=this.controllers.get(m.TestId.fromString(B).controllerId)?.collection;z&&(await z.expand(B,R<0?1/0:R),z.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(f.TestsDiffOp.deserialize))}async $runControllerTests(B,R){return Promise.all(B.map(z=>this.runControllerTestRequest(z,R)))}async runControllerTestRequest(B,R){const z=this.controllers.get(B.controllerId);if(!z)return{};const{collection:H,profiles:N}=z,V=N.get(B.profileId);if(!V)return{};const U=B.testIds.map(Q=>H.tree.get(Q)).filter(A.isDefined),F=B.excludeExtIds.map(Q=>z.collection.tree.get(Q)).filter(A.isDefined).filter(Q=>U.some(K=>K.fullId.compare(Q.fullId)===2));if(!U.length)return{};const x=new p.TestRunRequest(U.some(Q=>Q.actual instanceof _.TestItemRootImpl)?void 0:U.map(Q=>Q.actual),F.map(Q=>Q.actual),V),$=this.runTracker.prepareForMainThreadTestRun(x,s.fromInternal(B,z.collection),R);try{return await V.runHandler(x,R),{}}catch(Q){return{error:String(Q)}}finally{$.isRunning&&!R.isCancellationRequested&&await P.Event.toPromise($.onEnd),$.dispose()}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}};a=je([$e(0,T.IExtHostRpcService)],a),e.ExtHostTesting=a;class d extends S.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(B,R,z){super(),this.dto=B,this.proxy=R,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}getCoverage(B){return this.tasks.get(B)?.coverage}createRun(B){const R=this.dto.id,z=this.dto.controllerId,H=(0,k.generateUuid)(),N=new l(this.proxy,R,H),V=$=>(Q,...K)=>{if(F){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),$(Q,...K))},U=($,Q)=>{const K=Q instanceof Array?Q.map(g.TestMessage.from):[g.TestMessage.from(Q)];if($.uri&&$.range){const de={range:g.Range.from($.range),uri:$.uri};for(const ee of K)ee.location=ee.location||de}this.proxy.$appendTestMessagesInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),K)};let F=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,get coverageProvider(){return N.coverageProvider},set coverageProvider($){N.coverageProvider=$},enqueued:V($=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),1)}),skipped:V($=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),5)}),started:V($=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),2)}),errored:V(($,Q,K)=>{U($,Q),this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),6,K)}),failed:V(($,Q,K)=>{U($,Q),this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,z).toString(),4,K)}),passed:V(($,Q)=>{this.proxy.$updateTestStateInRun(R,H,m.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,Q)}),appendOutput:($,Q,K)=>{F||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(R,H,t.VSBuffer.fromString($),Q&&g.location.from(Q),K&&m.TestId.fromExtHostTestItem(K,z).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(R,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:x,coverage:N}),this.proxy.$startedTestRunTask(R,{id:H,name:B,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(B){if(!(B instanceof _.TestItemImpl))throw new b.InvalidTestItemError(B.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const R=[],z=this.dto.colllection.root;for(;;){const H=g.TestItem.from(B);if(R.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),B===z))break;B=B.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,R)}}class o{get trackers(){return this.tracked.values()}constructor(B){this.proxy=B,this.tracked=new Map}prepareForMainThreadTestRun(B,R,z){return this.getTracker(B,R,z)}cancelRunById(B){for(const R of this.tracked.values())if(R.id===B){R.dispose();return}}cancelAllRuns(){for(const B of this.tracked.values())B.dispose()}createTestRun(B,R,z,H,N){const V=this.tracked.get(z);if(V)return V.createRun(H);const U=s.fromPublic(B,R,z,N),F=i(z);this.proxy.$startedExtensionTestRun({controllerId:B,profile:F&&{group:L[F.kind],id:F.profileId},exclude:z.exclude?.map($=>m.TestId.fromExtHostTestItem($,R.root.id).toString())??[],id:U.id,include:z.include?.map($=>m.TestId.fromExtHostTestItem($,R.root.id).toString())??[R.root.id],persist:N});const x=this.getTracker(z,U);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),x.createRun(H)}getTracker(B,R,z){const H=new d(R,this.proxy,z);return this.tracked.set(B,H),H.onEnd(()=>this.tracked.delete(B)),H}}e.TestRunCoordinator=o;const i=M=>{if(!!M.profile){if(!(M.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class s{static fromPublic(B,R,z,H){return new s(B,(0,k.generateUuid)(),z.include?.map(N=>m.TestId.fromExtHostTestItem(N,B).toString())??[B],z.exclude?.map(N=>m.TestId.fromExtHostTestItem(N,B).toString())??[],H,R)}static fromInternal(B,R){return new s(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,R)}constructor(B,R,z,H,N,V){this.controllerId=B,this.id=R,this.isPersisted=N,this.colllection=V,this.includePrefix=z.map(U=>U+"\0"),this.excludePrefix=H.map(U=>U+"\0")}isIncluded(B){const R=m.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(R===z||R.startsWith(z))return!1;for(const z of this.includePrefix)if(R===z||R.startsWith(z))return!0;return!1}}e.TestRunDto=s;class l{set coverageProvider(B){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!B||(this._coverageProvider=B,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(B,R,z){this.proxy=B,this.runId=R,this.taskId=z}async provideFileCoverage(B){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(R){throw this.fileCoverage=void 0,R}}async resolveFileCoverage(B,R){const z=await this.fileCoverage;let H=z?.[B];return!this._coverageProvider||!z||!H?[]:(H.detailedCoverage||(H=z[B]=await this._coverageProvider.resolveFileCoverage?.(H,R)??H),H.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class n extends f.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(B){super(),this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(B){this.added.add(B)}update(B){Object.assign(B.revived,g.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}this.updated.delete(B);const R=m.TestId.parentId(B.item.extId);if(R&&this.alreadyRemoved.has(R.toString())){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:R,removed:z}=this;return{get added(){return[...B].map(H=>H.revived)},get updated(){return[...R].map(H=>H.revived)},get removed(){return[...z].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class r extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,R){return{...B,revived:g.TestItem.toPlain(B.item),depth:R?R.depth+1:0,children:new Set}}createChangeCollector(){return new n(this.changeEmitter)}}e.MirroredTestCollection=r;class h{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(R=>R.revived)},dispose:(0,y.once)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new r;return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}class w{get label(){return this._label}set label(B){B!==this._label&&(this._label=B,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get isDefault(){return this._isDefault}set isDefault(B){B!==this._isDefault&&(this._isDefault=B,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?g.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,R,z,H,N,V,U,F=!1,x=void 0){this.controllerId=z,this.profileId=H,this._label=N,this.kind=V,this.runHandler=U,this._isDefault=F,this._tag=x,c.set(this,void 0),v.set(this,void 0),tt(this,c,B,"f"),tt(this,v,R,"f"),R.set(H,this);const $=L[V];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Be(this,c,"f").$publishTestRunProfile({profileId:H,controllerId:z,tag:x?g.TestTag.namespace(this.controllerId,x.id):null,label:N,group:$,isDefault:F,hasConfigurationHandler:!1})}dispose(){Be(this,v,"f")?.delete(this.profileId)&&(tt(this,v,void 0,"f"),Be(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=w,c=new WeakMap,v=new WeakMap;const L={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(De[262],Ie([1,0,17,3,5,135,15,7]),function(J,e,u,t,C,P,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(A,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(E=>this._onDidChangeVisibleTextEditors.fire(E)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(E=>this._onDidChangeActiveTextEditor.fire(E))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const k=this._extHostDocumentsAndEditors.allEditors();return A?k:k.map(E=>E.value)}async showTextDocument(A,k,E){let T;typeof k=="number"?T={position:y.ViewColumn.from(k),preserveFocus:E}:typeof k=="object"?T={position:y.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?y.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const _=await this._proxy.$tryShowTextDocument(A.uri,T),g=_&&this._extHostDocumentsAndEditors.getEditor(_);if(g)return g.value;throw _?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new P.TextEditorDecorationType(this._proxy,A,k).value}$acceptEditorPropertiesChanged(A,k){const E=this._extHostDocumentsAndEditors.getEditor(A);if(!E)throw new Error("unknown text editor");if(k.options&&E._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(y.Selection.to);E._acceptSelections(T)}if(k.visibleRanges){const T=u.coalesce(k.visibleRanges.map(y.Range.to));E._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:E.value,options:{...k.options,lineNumbers:y.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=I.TextEditorSelectionChangeKind.fromValue(k.selections.source),_=k.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:E.value,selections:_,kind:T})}if(k.visibleRanges){const T=u.coalesce(k.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:E.value,visibleRanges:T})}}$acceptEditorPositionData(A){for(const k in A){const E=this._extHostDocumentsAndEditors.getEditor(k);if(!E)throw new Error("Unknown text editor");const T=y.ViewColumn.to(A[k]);E.value.viewColumn!==T&&(E._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:E.value,viewColumn:T}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=S}),define(De[263],Ie([1,0,2,4,5,6,7,15,12]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class D{constructor(E,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===11){const g=_.uri===void 0?void 0:u.URI.revive(_.uri);return this._itemsBySourceAndUriMap.get(_.source)?.get(A(g))?.get(_.handle)}return _}})}async $getTimeline(E,T,_,g){return this._providers.get(E)?.provideTimeline(u.URI.revive(T),_,g)}registerTimelineProvider(E,T,_,g){const p=new P.DisposableStore,m=this.convertTimelineItem(T.id,g,p).bind(this);let b;T.onDidChange&&(b=T.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:T.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:E,onDidChange:void 0,async provideTimeline(c,v,a){v?.resetCache&&(p.clear(),f.get(T.id)?.clear());const d=await T.provideTimeline(c,v,a);if(d==null)return;const o=m(c,v);return{...d,source:T.id,items:d.items.map(o)}},dispose(){for(const c of f.values())c.get(T.id)?.clear();b?.dispose(),p.dispose()}})}convertTimelineItem(E,T,_){return(g,p)=>{let m;if(p?.cacheResults){let b=this._itemsBySourceAndUriMap.get(E);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(E,b));const f=A(g);m=b.get(f),m===void 0&&(m=new Map,b.set(f,m))}return b=>{const{iconPath:f,...c}=b,v=`${E}|${b.id??b.timestamp}`;m?.set(v,b);let a,d,o;b.iconPath&&(f instanceof y.ThemeIcon?o={id:f.id,color:f.color}:u.URI.isUri(f)?(a=f,d=f):{light:a,dark:d}=f);let i;return y.MarkdownString.isMarkdownString(c.tooltip)?i=I.MarkdownString.from(c.tooltip):(0,S.isString)(c.tooltip)?i=c.tooltip:y.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=I.MarkdownString.from(c.detail)):(0,S.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=c.detail),{...c,id:c.id??void 0,handle:v,source:E,command:b.command?T.toInternal(b.command,_):void 0,icon:a,iconDark:d,themeIcon:o,tooltip:i,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(E){if(this._providers.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this._proxy.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this._providers.set(E.id,E),(0,P.toDisposable)(()=>{for(const _ of this._itemsBySourceAndUriMap.values())_.get(E.id)?.clear();this._providers.delete(E.id),this._proxy.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=D;function A(k){return k?.toString()}}),define(De[264],Ie([1,0,6,14,2,5]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,D,A,k){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const E=k.schemes.find(T=>!y.supportedSchemes.has(T));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,A),this._proxy.$registerUriOpener(D,k.schemes,S,k.label),(0,u.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(S,D,A){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const E=C.URI.revive(D);return k.canOpenExternalUri(E,A)}async $openUri(S,D,A){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(C.URI.revive(D.resolvedUri),{sourceUri:C.URI.revive(D.sourceUri)},A)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[265],Ie([1,0,5,2,6,11,27]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(D,A){if(this.handles.has(y.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const k=I.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(D)),this.handlers.set(k,A),this._proxy.$registerUriHandler(k,D),(0,C.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(D)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(D,A){const k=this.handlers.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(A))}catch(E){(0,P.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[70],Ie([1,0,3,14,2,188,210,88,5]),function(J,e,u,t,C,P,y,I,S){"use strict";var D,A,k,E,T,_,g,p,m,b,f,c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(w,L,M,B,R,z,H){D.set(this,void 0),A.set(this,void 0),k.set(this,void 0),E.set(this,void 0),T.set(this,void 0),_.set(this,void 0),g.set(this,""),p.set(this,void 0),m.set(this,!1),b.set(this,!1),f.set(this,void 0),c.set(this,void 0),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,v.set(this,new u.Emitter),this._onDidDispose=Be(this,v,"f").event,tt(this,D,w,"f"),tt(this,A,L,"f"),tt(this,p,M,"f"),tt(this,E,B,"f"),tt(this,T,R,"f"),tt(this,_,z,"f"),tt(this,f,d(z),"f"),tt(this,c,o(z),"f"),tt(this,k,H,"f")}dispose(){tt(this,m,!0,"f"),Be(this,v,"f").fire(),Be(this,v,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return tt(this,b,!0,"f"),(0,I.asWebviewUri)(w,Be(this,E,"f"))}get cspSource(){const w=Be(this,_,"f").extensionLocation;if(w.scheme===t.Schemas.https||w.scheme===t.Schemas.http){let L=w.toString();return L.endsWith("/")||(L+="/"),L+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,g,"f")}set html(w){this.assertNotDisposed(),Be(this,g,"f")!==w&&(tt(this,g,w,"f"),Be(this,c,"f")&&!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(tt(this,b,!0,"f"),Be(this,k,"f").report("Webview vscode-resource: uris",Be(this,_,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,A,"f").$setHtml(Be(this,D,"f"),this.rewriteOldResourceUrlsIfNeeded(w)))}get options(){return this.assertNotDisposed(),Be(this,p,"f")}set options(w){this.assertNotDisposed(),Be(this,A,"f").$setOptions(Be(this,D,"f"),l(Be(this,_,"f"),Be(this,T,"f"),w)),tt(this,p,w,"f")}async postMessage(w){if(Be(this,m,"f"))return!1;const L=(0,y.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Be(this,f,"f")});return Be(this,A,"f").$postMessage(Be(this,D,"f"),L.message,...L.buffers)}assertNotDisposed(){if(Be(this,m,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(w){if(!Be(this,c,"f"))return w;const L=Be(this,_,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,M=Be(this,_,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Be(this,_,"f").extensionLocation.authority:void 0;return w.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(B,R,z,H,N,V)=>{const U=C.URI.from({scheme:H||"file",path:decodeURIComponent(N)}),F=(0,I.asWebviewUri)(U,{isRemote:L,authority:M}).toString();return`${R}${F}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(B,R,z,H,N,V)=>{const U=C.URI.from({scheme:H||"file",path:decodeURIComponent(N)}),F=(0,I.asWebviewUri)(U,{isRemote:L,authority:M}).toString();return`${R}${F}${V}`})}}e.ExtHostWebview=a,D=new WeakMap,A=new WeakMap,k=new WeakMap,E=new WeakMap,T=new WeakMap,_=new WeakMap,g=new WeakMap,p=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,c=new WeakMap,v=new WeakMap;function d(h){try{const w=(0,P.normalizeVersion)((0,P.parseVersion)(h.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=d;function o(h){try{const w=(0,P.normalizeVersion)((0,P.parseVersion)(h.engines.vscode));return w?w.majorBase<1||w.majorBase===1&&w.minorBase<60:!1}catch{return!1}}class i{constructor(w,L,M,B,R){this.remoteInfo=L,this.workspace=M,this._logService=B,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=w.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(w,L,M){const B=this.getWebview(w);if(B){const{message:R}=(0,y.deserializeWebviewMessage)(L,M.value);B._onMessageEmitter.fire(R)}}$onMissingCsp(w,L){this._logService.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,L,M){const B=new a(w,this._webviewProxy,n(L),this.remoteInfo,this.workspace,M,this._deprecationService);return this._webviews.set(w,B),B._onDidDispose(()=>{this._webviews.delete(w)}),B}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=i;function s(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=s;function l(h,w,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||r(h,w)}}e.serializeWebviewOptions=l;function n(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(w=>C.URI.from(w))}}e.reviveOptions=n;function r(h,w){return[...(w?.getWorkspaceFolders()||[]).map(L=>L.uri),h.extensionLocation]}}),define(De[266],Ie([1,0,21,79,6,14,22,2,15,70,87,5,7]),function(J,e,u,t,C,P,y,I,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(d,o){this.document=d,this._storagePath=o,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(d){return this._edits.add([d])}async undo(d,o){await this.getEdit(d).undo(),o||this.disposeBackup()}async redo(d,o){await this.getEdit(d).redo(),o||this.disposeBackup()}disposeEdits(d){for(const o of d)this._edits.delete(o)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const d=v(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,d)}updateBackup(d){this._backup?.delete(),this._backup=d}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(d){const o=this._edits.get(d,0);if(!o)throw new Error("No edit found");return o}}class _{constructor(){this._documents=new Map}get(d,o){return this._documents.get(this.key(d,o))}add(d,o,i){const s=this.key(d,o.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${d} resource:${o.uri}`);const l=new T(o,i);return this._documents.set(s,l),l}delete(d,o){const i=this.key(d,o.uri);this._documents.delete(i)}key(d,o){return`${d}@@@${o}`}}var g;(function(a){a[a.Text=0]="Text",a[a.Custom=1]="Custom"})(g||(g={}));class p{constructor(){this._providers=new Map}addTextProvider(d,o,i){return this.add(0,d,o,i)}addCustomProvider(d,o,i){return this.add(1,d,o,i)}get(d){return this._providers.get(d)}add(d,o,i,s){if(this._providers.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this._providers.set(o,{type:d,extension:i,provider:s}),new E.Disposable(()=>this._providers.delete(o))}}class m{constructor(d,o,i,s,l){this._extHostDocuments=o,this._extensionStoragePaths=i,this._extHostWebview=s,this._extHostWebviewPanels=l,this._editorProviders=new p,this._documents=new _,this._proxy=d.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,o,i,s){const l=new C.DisposableStore;return f(i)?(l.add(this._editorProviders.addTextProvider(o,d,i)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(d),o,s.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(d))):(l.add(this._editorProviders.addCustomProvider(o,d,i)),b(i)&&l.add(i.onDidChangeCustomDocument(n=>{const r=this.getCustomDocumentEntry(o,n.document.uri);if(c(n)){const h=r.addEdit(n);this._proxy.$onDidEdit(n.document.uri,o,h,n.label)}else this._proxy.$onContentChange(n.document.uri,o)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(d),o,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(d))),E.Disposable.from(l,new E.Disposable(()=>{this._proxy.$unregisterEditorProvider(o)}))}async $createCustomDocument(d,o,i,s,l){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${o}'`);const r=I.URI.revive(d),h=await n.provider.openCustomDocument(r,{backupId:i,untitledDocumentData:s?.buffer},l);let w;return b(n.provider)&&this._extensionStoragePaths&&(w=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(o,h,w),{editable:b(n.provider)}}async $disposeCustomDocument(d,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${o}'`);const s=I.URI.revive(d),{document:l}=this.getCustomDocumentEntry(o,s);this._documents.delete(o,l),l.dispose()}async $resolveWebviewEditor(d,o,i,s,l,n){const r=this._editorProviders.get(i);if(!r)throw new Error(`No provider found for '${i}'`);const h=S.ViewColumn.to(l),w=this._extHostWebview.createNewWebview(o,s.contentOptions,r.extension),L=this._extHostWebviewPanels.createNewWebviewPanel(o,i,s.title,h,s.options,w,!0),M=I.URI.revive(d);switch(r.type){case 1:{const{document:B}=this.getCustomDocumentEntry(i,M);return r.provider.resolveCustomEditor(B,L,n)}case 0:{const B=this._extHostDocuments.getDocument(M);return r.provider.resolveCustomTextEditor(B,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,o,i){this.getCustomDocumentEntry(o,d).disposeEdits(i)}async $onMoveCustomEditor(d,o,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const l=this._extHostWebviewPanels.getWebviewPanel(d);if(!l)throw new Error("No webview found");const n=I.URI.revive(o),r=this._extHostDocuments.getDocument(n);await s.provider.moveCustomTextEditor(r,l,u.CancellationToken.None)}async $undo(d,o,i,s){return this.getCustomDocumentEntry(o,d).undo(i,s)}async $redo(d,o,i,s){return this.getCustomDocumentEntry(o,d).redo(i,s)}async $revert(d,o,i){const s=this.getCustomDocumentEntry(o,d);await this.getCustomEditorProvider(o).revertCustomDocument(s.document,i),s.disposeBackup()}async $onSave(d,o,i){const s=this.getCustomDocumentEntry(o,d);await this.getCustomEditorProvider(o).saveCustomDocument(s.document,i),s.disposeBackup()}async $onSaveAs(d,o,i,s){const l=this.getCustomDocumentEntry(o,d);return this.getCustomEditorProvider(o).saveCustomDocumentAs(l.document,I.URI.revive(i),s)}async $backup(d,o,i){const s=this.getCustomDocumentEntry(o,d),n=await this.getCustomEditorProvider(o).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},i);return s.updateBackup(n),n.id}getCustomDocumentEntry(d,o){const i=this._documents.get(d,I.URI.revive(o));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(d){const i=this._editorProviders.get(d)?.provider;if(!i||!b(i))throw new Error("Custom document is not editable");return i}}e.ExtHostCustomEditors=m;function b(a){return!!a.onDidChangeCustomDocument}function f(a){return typeof a.resolveCustomTextEditor=="function"}function c(a){return typeof a.undo=="function"&&typeof a.redo=="function"}function v(a){const d=a.scheme===P.Schemas.file||a.scheme===P.Schemas.untitled?a.fsPath:a.toString();return(0,t.hash)(d)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[267],Ie([1,0,3,6,2,31,15,70,5,7]),function(J,e,u,t,C,P,y,I,S,D){"use strict";var A,k,E,T,_,g,p,m,b,f,c,v,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends t.Disposable{constructor(l,n,r,h){super(),A.set(this,void 0),k.set(this,void 0),E.set(this,void 0),T.set(this,void 0),_.set(this,void 0),g.set(this,void 0),p.set(this,void 0),m.set(this,void 0),b.set(this,!0),f.set(this,void 0),c.set(this,!1),v.set(this,this._register(new u.Emitter)),this.onDidDispose=Be(this,v,"f").event,a.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Be(this,a,"f").event,tt(this,A,l,"f"),tt(this,k,n,"f"),tt(this,T,r,"f"),tt(this,E,h.viewType,"f"),tt(this,_,h.panelOptions,"f"),tt(this,m,h.viewColumn,"f"),tt(this,g,h.title,"f"),tt(this,f,h.active,"f")}dispose(){Be(this,c,"f")||(tt(this,c,!0,"f"),Be(this,v,"f").fire(),Be(this,k,"f").$disposeWebview(Be(this,A,"f")),Be(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,T,"f")}get viewType(){return this.assertNotDisposed(),Be(this,E,"f")}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(l){this.assertNotDisposed(),Be(this,g,"f")!==l&&(tt(this,g,l,"f"),Be(this,k,"f").$setTitle(Be(this,A,"f"),l))}get iconPath(){return this.assertNotDisposed(),Be(this,p,"f")}set iconPath(l){this.assertNotDisposed(),Be(this,p,"f")!==l&&(tt(this,p,l,"f"),Be(this,k,"f").$setIconPath(Be(this,A,"f"),C.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Be(this,_,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,m,"f")=="number"&&Be(this,m,"f")<0))return Be(this,m,"f")}get active(){return this.assertNotDisposed(),Be(this,f,"f")}get visible(){return this.assertNotDisposed(),Be(this,b,"f")}_updateViewState(l){Be(this,c,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(tt(this,f,l.active,"f"),tt(this,b,l.visible,"f"),tt(this,m,l.viewColumn,"f"),Be(this,a,"f").fire({webviewPanel:this}))}reveal(l,n){this.assertNotDisposed(),Be(this,k,"f").$reveal(Be(this,A,"f"),{viewColumn:typeof l>"u"?void 0:y.ViewColumn.from(l),preserveFocus:!!n})}assertNotDisposed(){if(Be(this,c,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,E=new WeakMap,T=new WeakMap,_=new WeakMap,g=new WeakMap,p=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,c=new WeakMap,v=new WeakMap,a=new WeakMap;class o{static newHandle(){return(0,P.generateUuid)()}constructor(l,n,r){this.webviews=n,this.workspace=r,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(l,n,r,h,w={}){const L=typeof h=="object"?h.viewColumn:h,M={viewColumn:y.ViewColumn.from(L),preserveFocus:typeof h=="object"&&!!h.preserveFocus},B=(0,I.shouldSerializeBuffersForPostMessage)(l),R=o.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(l),R,n,{title:r,panelOptions:i(w),webviewOptions:(0,I.serializeWebviewOptions)(l,this.workspace,w),serializeBuffersForPostMessage:B},M);const z=this.webviews.createNewWebview(R,w,l);return this.createNewWebviewPanel(R,n,r,L,w,z,!0)}$onDidChangeWebviewPanelViewStates(l){const n=Object.keys(l);n.sort((r,h)=>{const w=l[r],L=l[h];return w.active?1:L.active?-1:+w.visible-+L.visible});for(const r of n){const h=this.getWebviewPanel(r);if(!h)continue;const w=l[r];h._updateViewState({active:w.active,visible:w.visible,viewColumn:y.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,n,r){if(this._serializers.has(n))throw new Error(`Serializer for '${n}' already registered`);return this._serializers.set(n,{serializer:r,extension:l}),this._proxy.$registerSerializer(n,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(l)}),new D.Disposable(()=>{this._serializers.delete(n),this._proxy.$unregisterSerializer(n)})}async $deserializeWebviewPanel(l,n,r,h){const w=this._serializers.get(n);if(!w)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:M}=w,B=this.webviews.createNewWebview(l,r.webviewOptions,M),R=this.createNewWebviewPanel(l,n,r.title,h,r.panelOptions,B,r.active);await L.deserializeWebviewPanel(R,r.state)}createNewWebviewPanel(l,n,r,h,w,L,M){const B=new d(l,this._proxy,L,{viewType:n,title:r,viewColumn:h,panelOptions:w,active:M});return this._webviewPanels.set(l,B),B}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=o;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[268],Ie([1,0,3,6,70,15,5,7]),function(J,e,u,t,C,P,y,I){"use strict";var S,D,A,k,E,T,_,g,p,m,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends t.Disposable{constructor(a,d,o,i,s,l,n){super(),S.set(this,void 0),D.set(this,void 0),A.set(this,void 0),k.set(this,void 0),E.set(this,!1),T.set(this,void 0),_.set(this,void 0),g.set(this,void 0),p.set(this,void 0),m.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Be(this,m,"f").event,b.set(this,this._register(new u.Emitter)),this.onDidDispose=Be(this,b,"f").event,tt(this,A,o,"f"),tt(this,_,i,"f"),tt(this,S,a,"f"),tt(this,D,d,"f"),tt(this,k,s,"f"),tt(this,T,n,"f")}dispose(){Be(this,E,"f")||(tt(this,E,!0,"f"),Be(this,b,"f").fire(),Be(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,_,"f")}set title(a){this.assertNotDisposed(),Be(this,_,"f")!==a&&(tt(this,_,a,"f"),Be(this,D,"f").$setWebviewViewTitle(Be(this,S,"f"),a))}get description(){return this.assertNotDisposed(),Be(this,g,"f")}set description(a){this.assertNotDisposed(),Be(this,g,"f")!==a&&(tt(this,g,a,"f"),Be(this,D,"f").$setWebviewViewDescription(Be(this,S,"f"),a))}get visible(){return Be(this,T,"f")}get webview(){return Be(this,k,"f")}get viewType(){return Be(this,A,"f")}_setVisible(a){a===Be(this,T,"f")||Be(this,E,"f")||(tt(this,T,a,"f"),Be(this,m,"f").fire())}get badge(){return this.assertNotDisposed(),Be(this,p,"f")}set badge(a){this.assertNotDisposed(),!(a?.value===Be(this,p,"f")?.value&&a?.tooltip===Be(this,p,"f")?.tooltip)&&(tt(this,p,P.ViewBadge.from(a),"f"),Be(this,D,"f").$setWebviewViewBadge(Be(this,S,"f"),a))}show(a){this.assertNotDisposed(),Be(this,D,"f").$show(Be(this,S,"f"),!!a)}assertNotDisposed(){if(Be(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,D=new WeakMap,A=new WeakMap,k=new WeakMap,E=new WeakMap,T=new WeakMap,_=new WeakMap,g=new WeakMap,p=new WeakMap,m=new WeakMap,b=new WeakMap;class c{constructor(a,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,d,o,i){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:o,extension:a}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(a),d,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(a)}),new I.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(a,d,o,i,s){const l=this._viewProviders.get(d);if(!l)throw new Error(`No view provider found for '${d}'`);const{provider:n,extension:r}=l,h=this._extHostWebview.createNewWebview(a,{},r),w=new f(a,this._proxy,d,o,h,r,!0);this._webviewViews.set(a,w),await n.resolveWebviewView(w,{state:i},s)}async $onDidChangeWebviewViewVisibility(a,d){this.getWebviewView(a)._setVisible(d)}async $disposeWebviewView(a){const d=this.getWebviewView(a);this._webviewViews.delete(a),d.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const d=this._webviewViews.get(a);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=c}),define(De[138],Ie([1,0,3,5,2,14,8,4,16]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class ei{get state(){return this._state}constructor(k){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ei.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,E){let T;if(typeof k=="string"){T=k;try{k=C.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,y.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,E)}async asExternalUri(k,E){if((0,y.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,E);return C.URI.from(T)}};D.InitialState={focused:!0},D=je([$e(0,S.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(De[269],Ie([1,0,116,270,63,39,2,13,45]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(E,T,_){this._commands=E,this.logService=T,this._ipcHandlePath=_,this._server=t.createServer((g,p)=>this.onRequest(g,p)),this.setup().catch(g=>(T.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,T){const _=(p,m)=>{T.writeHead(p,{"content-type":"application/json"}),T.end(JSON.stringify(m||null),b=>b&&this.logService.error(b))},g=[];E.setEncoding("utf8"),E.on("data",p=>g.push(p)),E.on("end",async()=>{try{const p=JSON.parse(g.join(""));let m;switch(p.type){case"open":m=await this.open(p);break;case"openExternal":m=await this.openExternal(p);break;case"status":m=await this.getStatus(p);break;case"extensionManagement":m=await this.manageExtensions(p);break;default:_(404,`Unknown message type: ${p.type}`);break}_(200,m)}catch(p){const m=p instanceof Error?p.message:JSON.stringify(p);_(500,m),this.logService.error("Error while processing pipe request",p)}})}async open(E){const{fileURIs:T,folderURIs:_,forceNewWindow:g,diffMode:p,mergeMode:m,addMode:b,forceReuseWindow:f,gotoLineMode:c,waitMarkerFilePath:v,remoteAuthority:a}=E,d=[];if(Array.isArray(_))for(const l of _)try{d.push({folderUri:y.URI.parse(l)})}catch{}if(Array.isArray(T))for(const l of T)try{(0,S.hasWorkspaceFileExtension)(l)?d.push({workspaceUri:y.URI.parse(l)}):d.push({fileUri:y.URI.parse(l)})}catch{}const o=v?y.URI.file(v):void 0,s={forceNewWindow:g,diffMode:p,mergeMode:m,addMode:b,gotoLineMode:c,forceReuseWindow:f,preferNewWindow:!f&&!o&&!b,waitMarkerFileURI:o,remoteAuthority:a};return this._commands.executeCommand("_remoteCLI.windowOpen",d,s),""}async openExternal(E){for(const T of E.uris){const _=y.URI.parse(T),g=_.scheme==="file"?_:T;await this._commands.executeCommand("_remoteCLI.openExternal",g)}}async manageExtensions(E){const T=g=>g?.map(p=>/\.vsix$/i.test(p)?y.URI.parse(p):p),_={list:E.list,install:T(E.install),uninstall:T(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",_)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let A=class extends D{constructor(E,T){super(E,T,(0,u.createRandomIPCHandle)())}};A=je([$e(0,P.IExtHostCommands),$e(1,I.ILogService)],A),e.CLIServer=A}),define(De[271],Ie([1,0,243,25,16]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends u.AbstractExtHostConsoleForwarder{constructor(S,D){super(S,D),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,D,A){const k=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),D.apply(console,A),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,D){const A=process[S],k=A.write;let E="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(T,_,g)=>{if(!this._isMakingConsoleCall){E+=T.toString(_);const p=E.length>P?E.length:E.lastIndexOf(`
`);p!==-1&&(console[D](E.slice(0,p)),E=E.slice(p+1))}k.call(A,T,_,g)}})}};y=je([$e(0,C.IExtHostRpcService),$e(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(De[272],Ie([1,0,9,82,31,39,6,5,2,16]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=class extends y.Disposable{constructor(E,T){super();const _=E.getProxy(I.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async g=>{const p=S.URI.file((0,u.join)((0,t.tmpdir)(),(0,C.generateUuid)()));return await _.$download(g,p),p})}};A=je([$e(0,D.IExtHostRpcService),$e(1,P.IExtHostCommands)],A),e.ExtHostDownloadService=A}),define(De[273],Ie([1,0,137,14,194,31]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends u.ExtHostLoggerService{doCreateLogger(S,D,A){return S.scheme===t.Schemas.file?new C.SpdLogLogger(A?.name||(0,P.generateUuid)(),S.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,D):super.doCreateLogger(S,D,A)}}e.ExtHostLoggerService=y}),define(De[274],Ie([1,0,63,9,2,69,6,14,18,29]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const d=await super._getWorkspaceStorageURI(a);if(d.scheme!==I.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const o=d.fsPath;let i=0;do{let s;i===0?s=o:s=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${i}`:`${o}-${i}`,await k(s);const l=t.join(s,"vscode.lock"),n=await g(this._logService,l,!1);if(n)return this._workspaceStorageLock=n,process.on("exit",()=>{n.dispose()}),C.URI.file(s);i++}while(i<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function k(v){try{await D.Promises.stat(v);return}catch{}try{await D.Promises.mkdir(v,{recursive:!0})}catch{}}const E=1e3,T=10*60*1e3;class _ extends y.Disposable{constructor(a,d){super(),this.logService=a,this.filename=d,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await p(a,d);(!o||o.pid!==process.pid)&&(a.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(d,new Date,new Date)}catch(i){a.error(i),a.info(`Lock '${d}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+a};await D.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function g(v,a,d){try{const i={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(a,JSON.stringify(i),{flag:"wx"})}catch(i){v.error(i)}const o=await p(v,a);return!o||o.pid!==process.pid?d?(v.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(v.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),f(v,a)):(v.info(`Lock '${a}': Lock acquired.`),new _(v,a))}async function p(v,a){let d;try{d=await D.Promises.readFile(a)}catch(o){return v.error(o),null}try{return JSON.parse(String(d))}catch(o){return v.error(o),null}}async function m(v,a){let d;try{d=await D.Promises.stat(a)}catch(o){return v.error(o),0}return d.mtime.getTime()}function b(v){try{return process.kill(v,0),!0}catch{return!1}}async function f(v,a){const d=await p(v,a);if(!d)return v.info(`Lock '${a}': Could not read pid of lock holder.`),c(v,a);if(d.willReleaseAt){let n=d.willReleaseAt-Date.now();if(n<5e3){for(n>0?v.info(`Lock '${a}': The lockfile is scheduled to be released in ${n} ms.`):v.info(`Lock '${a}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await m(v,a)===0)return c(v,a);n=d.willReleaseAt-Date.now()}return c(v,a)}}if(!b(d.pid))return v.info(`Lock '${a}': The pid ${d.pid} appears to be gone.`),c(v,a);const o=await m(v,a),i=Date.now()-o;if(i<=T)return v.info(`Lock '${a}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;v.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const s=await m(v,a),l=Date.now()-s;return l<=T?(v.info(`Lock '${a}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(v.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),c(v,a))}async function c(v,a){v.info(`Lock '${a}': Deleting a stale lock.`);try{await D.Promises.unlink(a)}catch{}return g(v,a,!0)}}),define(De[275],Ie([1,0,31,16,40]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends C.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,S,D){return this.createTerminalFromOptions({name:I,shellPath:S,shellArgs:D})}createTerminalFromOptions(I,S){const D=new C.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),I,I.name);return this._terminals.push(D),D.create(I,this._serializeParentTerminal(I,S)),D.value}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[276],Ie([1,0,5,16,178,6,25,2,44,22,29,7,10,53,3,127,98,13]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b extends g.DisposableTunnel{}function f(n){const r=n.trim().split(`
`),h=[];return r.forEach(L=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);M&&M.length>=3&&h.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),h.reduce((L,M)=>(L[M.socket]=M,L),{})}e.getSockets=f;function c(...n){const r=[].concat(...n.map(a));return[...new Map(r.filter(h=>h.st==="0A").map(h=>{const w=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:v(w[0]),port:parseInt(w[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=c;function v(n){let r="";if(n.length===8)for(let h=n.length-2;h>=0;h-=2)r+=parseInt(n.substr(h,2),16),h!==0&&(r+=".");else for(let h=n.length-4;h>=0;h-=4)r+=parseInt(n.substr(h,4),16).toString(16),h!==0&&(r+=":");return r}e.parseIpAddress=v;function a(n){const r=n.trim().split(`
`),h=r.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return r.map(L=>L.trim().split(/\s+/).reduce((M,B,R)=>(M[h[R]||R]=B,M),{}))}e.loadConnectionTable=a;function d(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function o(n){const r=n.trim().split(`
`),h=[];return r.forEach(w=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);L&&L.length>=4&&h.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),h}e.getRootProcesses=o;async function i(n,r,h){const w=h.reduce((M,B)=>(M[B.pid]=B,M),{}),L=[];return n.forEach(({socket:M,ip:B,port:R})=>{const z=r[M]?r[M].pid:void 0,H=z?w[z]?.cmd:void 0;z&&H&&!d(H)&&L.push({host:B,port:R,detail:H,pid:z})}),L}e.findPorts=i;function s(n,r,h){const w=new Map,L=o(r);for(const M of n){const B=h.get(M.port);if(B){w.set(M.port,B);continue}const R=L.find(z=>z.cmd.includes(`${M.port}`));if(R){let z=R,H;do H=L.find(N=>N.ppid===z.pid),H&&(z=H);while(H);w.set(M.port,{host:M.ip,port:M.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else w.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=s;let l=class extends P.Disposable{constructor(r,h,w){super(),this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new _.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=r.getProxy(u.MainContext.MainThreadTunnelService),E.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(r,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(h,r.displayName);if(w){const L=new b(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(L),L}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(r){return Math.max(r*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(r,h){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:r,provider:h}),this._proxy.$registerPortsAttributesProvider(r,w),new k.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(r,h,w,L,M){const B=[];for(const z of r){const H=this._portAttributesProviders.get(z);if(!H)return[];B.push(...await Promise.all(h.map(async N=>H.provider.providePortAttributes(N,w,L,M))))}const R=B.filter(z=>!!z);return R.length>0?R.map(z=>({autoForwardAction:z.autoForwardAction,port:z.port})):[]}async $registerCandidateFinder(r){if(r&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=r;const h=new p.MovingAverage;let w;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),M=(await this.findCandidatePorts()).filter(R=>(0,g.isLocalhost)(R.host)||(0,g.isAllInterfaces)(R.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(R=>R.port).join(", ")}`);const B=new Date().getTime()-L;h.update(B),(!w||JSON.stringify(w)!==JSON.stringify(M))&&(w=M,await this._proxy.$onFoundNewCandidates(w)),await new Promise(R=>setTimeout(()=>R(),this.calculateDelay(h.value)))}}async setTunnelFactory(r){if(r){if(r.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this._showCandidatePort=r.showCandidatePort,this._proxy.$setCandidateFilter()),r.tunnelFactory){this._forwardPortProvider=r.tunnelFactory;let h=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]);const w=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(r,h){if(this._extensionTunnels.has(r.host)){const w=this._extensionTunnels.get(r.host);w.has(r.port)&&(h&&w.get(r.port).disposeListener.dispose(),await w.get(r.port).tunnel.dispose(),w.delete(r.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(r,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(r,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const L=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(r.remoteAddress.host)||this._extensionTunnels.set(r.remoteAddress.host,new Map);const M=this._register(L.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(L.remoteAddress))));return this._extensionTunnels.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:L,disposeListener:M}),T.TunnelDtoConverter.fromApiTunnel(L)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(r){const h=await Promise.all(r.map(L=>this._showCandidatePort(L.host,L.port,L.detail??""))),w=r.filter((L,M)=>h[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(L=>L.port).join(", ")} to ${w.map(L=>L.port).join(", ")}`),w}async findCandidatePorts(){let r="",h="";try{r=await A.Promises.readFile("/proc/net/tcp","utf8"),h=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=c(r,h),L=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,x,$)=>{U(x)})}),M=f(L),B=await A.Promises.readdir("/proc"),R=[];for(const U of B)try{const F=Number(U),x=D.joinPath(I.URI.file("/proc"),U);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(F)){const Q=await A.Promises.readlink(D.joinPath(x,"cwd").fsPath),K=await A.Promises.readFile(D.joinPath(x,"cmdline").fsPath,"utf8");R.push({pid:F,cwd:Q,cmd:K})}}catch{}const z=[],H=w.filter(U=>{const F=M[U.socket];return F||z.push(U),F}),N=i(H,M,R);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const U=await new Promise(F=>{(0,S.exec)("ps -F -A -l | grep root",(x,$,Q)=>{F($)})});this._foundRootPorts=s(z,U,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return N.then(U=>V?U.concat(V):U)}};l=je([$e(0,t.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,m.ILogService)],l),e.ExtHostTunnelService=l}),define(De[277],Ie([1,0,18,23,21,11,3,6,111,237,56]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(w,L){try{return JSON.stringify(w,L)}catch{return"null"}}const T="$$ref$$",_={[T]:-1};class g{constructor(L,M){this.jsonString=L,this.referencedBuffers=M}}function p(w,L=null,M=!1){const B=[];return{jsonString:(M?E:JSON.stringify)(w,(z,H)=>{if(typeof H>"u")return _;if(typeof H=="object"){if(H instanceof t.VSBuffer){const N=B.push(H)-1;return{[T]:N}}if(L)return L(z,H)}return H}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=p;function m(w,L,M){return JSON.parse(w,(B,R)=>{if(R){const z=R[T];if(typeof z=="number")return L[z];if(M&&R.$mid===1)return M.transformIncoming(R)}return R})}e.parseJsonAndRestoreBufferRefs=m;function b(w,L){return JSON.stringify(w,L)}function f(w){return w?(L,M)=>M&&M.$mid===1?w.transformOutgoing(M):M:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},d=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends I.Disposable{constructor(L,M=null,B=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=M,this._uriTransformer=B,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let R=0,z=A.ProxyIdentifier.count;R<z;R++)this._locals[R]=null,this._proxies[R]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(R=>this._receiveOneMessage(R))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,S.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:M,sid:B}=L;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,B)),this._proxies[M]}_createProxy(L,M){const B={get:(R,z)=>(typeof z=="string"&&!R[z]&&z.charCodeAt(0)===36&&(R[z]=(...H)=>this._remoteCall(L,z,H)),z===o?M:R[z])};return new Proxy(Object.create(null),B)}set(L,M){return this._locals[L.nid]=M,M}assertRegistered(L){for(let M=0,B=L.length;M<B;M++){const R=L[M];if(!this._locals[R.nid])throw new Error(`Missing proxy instance ${R.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const M=L.byteLength,B=s.read(L,0),R=B.readUInt8(),z=B.readUInt32();switch(R){case 1:case 2:{let{rpcId:H,method:N,args:V}=n.deserializeRequestJSONArgs(B);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(M,z,H,N,V,R===2);break}case 3:case 4:{let{rpcId:H,method:N,args:V}=n.deserializeRequestMixedArgs(B);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(M,z,H,N,V,R===4);break}case 5:{this._logger?.logIncoming(M,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(M,z);break}case 7:{this._receiveReply(M,z,void 0);break}case 9:{let H=n.deserializeReplyOKJSON(B);this._uriTransformer&&(H=(0,S.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReply(M,z,H);break}case 10:{const H=n.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(M,z,H);break}case 8:{const H=n.deserializeReplyOKVSBuffer(B);this._receiveReply(M,z,H);break}case 11:{let H=n.deserializeReplyErrError(B);this._uriTransformer&&(H=(0,S.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReplyErr(M,z,H);break}case 12:{this._receiveReplyErr(M,z,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,M,B,R,z,H){this._logger?.logIncoming(L,M,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(B)}.${R}(`,z);const N=String(M);let V,U;if(H){const x=new C.CancellationTokenSource;z.push(x.token),V=this._invokeHandler(B,R,z),U=()=>x.cancel()}else V=this._invokeHandler(B,R,z),U=a;this._cancelInvokedHandlers[N]=U;const F=n.serializeAcknowledged(M);this._logger?.logOutgoing(F.byteLength,M,1,"ack"),this._protocol.send(F),V.then(x=>{delete this._cancelInvokedHandlers[N];const $=n.serializeReplyOK(M,x,this._uriReplacer);this._logger?.logOutgoing($.byteLength,M,1,"reply:",x),this._protocol.send($)},x=>{delete this._cancelInvokedHandlers[N];const $=n.serializeReplyErr(M,x);this._logger?.logOutgoing($.byteLength,M,1,"replyErr:",x),this._protocol.send($)})}_receiveCancel(L,M){this._logger?.logIncoming(L,M,1,"receiveCancel");const B=String(M);this._cancelInvokedHandlers[B]?.()}_receiveReply(L,M,B){this._logger?.logIncoming(L,M,0,"receiveReply:",B);const R=String(M);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const z=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R],z.resolveOk(B)}_receiveReplyErr(L,M,B){this._logger?.logIncoming(L,M,0,"receiveReplyErr:",B);const R=String(M);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const z=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R];let H;B&&(B.$isError?(H=new Error,H.name=B.name,H.message=B.message,H.stack=B.stack):H=B),z.resolveErr(H)}_invokeHandler(L,M,B){try{return Promise.resolve(this._doInvokeHandler(L,M,B))}catch(R){return Promise.reject(R)}}_doInvokeHandler(L,M,B){const R=this._locals[L];if(!R)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(L));const z=R[M];if(typeof z!="function")throw new Error("Unknown method "+M+" on actor "+(0,A.getStringIdentifierForProxy)(L));return z.apply(R,B)}_remoteCall(L,M,B){if(this._isDisposed)return new D.CanceledLazyPromise;let R=null;if(B.length>0&&C.CancellationToken.isCancellationToken(B[B.length-1])&&(R=B.pop()),R&&R.isCancellationRequested)return Promise.reject(P.canceled());const z=n.serializeRequestArguments(B,this._uriReplacer),H=++this._lastMessageId,N=String(H),V=new D.LazyPromise;R&&R.onCancellationRequested(()=>{const F=n.serializeCancel(H);this._logger?.logOutgoing(F.byteLength,H,0,"cancel"),this._protocol.send(n.serializeCancel(H))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(H);const U=n.serializeRequest(H,L,M,z,!!R);return this._logger?.logOutgoing(U.byteLength,H,0,`request: ${(0,A.getStringIdentifierForProxy)(L)}.${M}(`,B),this._protocol.send(U),V}}e.RPCProtocol=i,k=d,i.UNRESPONSIVE_TIME=3*1e3;class s{static alloc(L,M,B){const R=new s(t.VSBuffer.alloc(B+1+4),0);return R.writeUInt8(L),R.writeUInt32(M),R}static read(L,M){return new s(L,M)}get buffer(){return this._buff}constructor(L,M){this._buff=L,this._offset=M}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,B}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,B}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,M}static sizeMixedArray(L){let M=0;M+=1;for(let B=0,R=L.length;B<R;B++){const z=L[B];switch(M+=1,z.type){case 1:M+=this.sizeLongString(z.value);break;case 2:M+=this.sizeVSBuffer(z.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(z.value);for(let H=0;H<z.buffers.length;++H)M+=this.sizeVSBuffer(z.buffers[H]);break;case 4:break}}return M}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let M=0,B=L.length;M<B;M++){const R=L[M];switch(R.type){case 1:this.writeUInt8(1),this.writeLongString(R.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R.value);break;case 3:this.writeUInt8(3),this.writeUInt32(R.buffers.length),this.writeLongString(R.value);for(let z=0;z<R.buffers.length;++z)this.writeBuffer(R.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(L);for(let B=0;B<L;B++)switch(this.readUInt8()){case 1:M[B]=this.readLongString();break;case 2:M[B]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),H=this.readLongString(),N=[];for(let V=0;V<z;++V)N.push(this.readVSBuffer());M[B]=new A.SerializableObjectWithBuffers(m(H,N,null));break}case 4:M[B]=void 0;break}return M}}s.sizeUInt32=4;var l;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(l||(l={}));class n{static _useMixedArgSerialization(L){for(let M=0,B=L.length;M<B;M++)if(L[M]instanceof t.VSBuffer||L[M]instanceof A.SerializableObjectWithBuffers||typeof L[M]>"u")return!0;return!1}static serializeRequestArguments(L,M){if(this._useMixedArgSerialization(L)){const B=[];for(let R=0,z=L.length;R<z;R++){const H=L[R];if(H instanceof t.VSBuffer)B[R]={type:2,value:H};else if(typeof H>"u")B[R]={type:4};else if(H instanceof A.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=p(H.value,M);B[R]={type:3,value:t.VSBuffer.fromString(N),buffers:V}}else B[R]={type:1,value:t.VSBuffer.fromString(b(H,M))}}return{type:1,args:B}}return{type:0,args:b(L,M)}}static serializeRequest(L,M,B,R,z){switch(R.type){case 0:return this._requestJSONArgs(L,M,B,R.args,z);case 1:return this._requestMixedArgs(L,M,B,R.args,z)}}static _requestJSONArgs(L,M,B,R,z){const H=t.VSBuffer.fromString(B),N=t.VSBuffer.fromString(R);let V=0;V+=s.sizeUInt8(),V+=s.sizeShortString(H),V+=s.sizeLongString(N);const U=s.alloc(z?2:1,L,V);return U.writeUInt8(M),U.writeShortString(H),U.writeLongString(N),U.buffer}static deserializeRequestJSONArgs(L){const M=L.readUInt8(),B=L.readShortString(),R=L.readLongString();return{rpcId:M,method:B,args:JSON.parse(R)}}static _requestMixedArgs(L,M,B,R,z){const H=t.VSBuffer.fromString(B);let N=0;N+=s.sizeUInt8(),N+=s.sizeShortString(H),N+=s.sizeMixedArray(R);const V=s.alloc(z?4:3,L,N);return V.writeUInt8(M),V.writeShortString(H),V.writeMixedArray(R),V.buffer}static deserializeRequestMixedArgs(L){const M=L.readUInt8(),B=L.readShortString(),R=L.readMixedArray(),z=new Array(R.length);for(let H=0,N=R.length;H<N;H++){const V=R[H];typeof V=="string"?z[H]=JSON.parse(V):z[H]=V}return{rpcId:M,method:B,args:z}}static serializeAcknowledged(L){return s.alloc(5,L,0).buffer}static serializeCancel(L){return s.alloc(6,L,0).buffer}static serializeReplyOK(L,M,B){if(typeof M>"u")return this._serializeReplyOKEmpty(L);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(L,M);if(M instanceof A.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:z}=p(M.value,B,!0);return this._serializeReplyOKJSONWithBuffers(L,R,z)}else return this._serializeReplyOKJSON(L,E(M,B))}static _serializeReplyOKEmpty(L){return s.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,M){let B=0;B+=s.sizeVSBuffer(M);const R=s.alloc(8,L,B);return R.writeVSBuffer(M),R.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,M){const B=t.VSBuffer.fromString(M);let R=0;R+=s.sizeLongString(B);const z=s.alloc(9,L,R);return z.writeLongString(B),z.buffer}static _serializeReplyOKJSONWithBuffers(L,M,B){const R=t.VSBuffer.fromString(M);let z=0;z+=s.sizeUInt32,z+=s.sizeLongString(R);for(const N of B)z+=s.sizeVSBuffer(N);const H=s.alloc(10,L,z);H.writeUInt32(B.length),H.writeLongString(R);for(const N of B)H.writeBuffer(N);return H.buffer}static deserializeReplyOKJSON(L){const M=L.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(L,M){const B=L.readUInt32(),R=L.readLongString(),z=[];for(let H=0;H<B;++H)z.push(L.readVSBuffer());return new A.SerializableObjectWithBuffers(m(R,z,M))}static serializeReplyErr(L,M){const B=M?E(P.transformErrorForSerialization(M),null):void 0;if(typeof B!="string")return this._serializeReplyErrEmpty(L);const R=t.VSBuffer.fromString(B);let z=0;z+=s.sizeLongString(R);const H=s.alloc(11,L,z);return H.writeLongString(R),H.buffer}static deserializeReplyErrError(L){const M=L.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(L){return s.alloc(12,L,0).buffer}}var r;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var h;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(h||(h={}))}),define(De[278],Ie([1,0,3,43,52,4,38,11,18]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(_){this.channels.has(_.id)||(this.channels.set(_.id,_),this._onDidRegisterChannel.fire(_.id))}getChannels(){const _=[];return this.channels.forEach(g=>_.push(g)),_}getChannel(_){return this.channels.get(_)}removeChannel(_){this.channels.delete(_),this._onDidRemoveChannel.fire(_)}}t.Registry.add(e.Extensions.OutputChannels,new A);function k(T,_,g,p,m){return(0,S.createCancelablePromise)(async b=>{await(0,y.whenProviderRegistered)(g,p);const f=t.Registry.as(e.Extensions.OutputChannels);try{await E(g,1,p,m,b),f.registerChannel({id:T,label:_,file:g,log:!0})}catch(c){(0,I.isCancellationError)(c)||m.error("Error while registering log channel",g.toString(),(0,I.getErrorMessage)(c))}})}e.registerLogChannel=k;async function E(T,_,g,p,m){if(!await g.exists(T)){if(m.isCancellationRequested)throw new I.CancellationError;if(_>10)throw new Error("Timed out while waiting for file to be created");p.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,S.timeout)(1e3,m),await E(T,_+1,g,p,m)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new C.RawContextKey("activeOutputChannel","")}),define(De[139],Ie([1,0,5,4,16,27,13,278,68,25,46,152,23,12,38,3,6,28]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class b extends y.AbstractMessageLogger{get disposed(){return this._disposed}constructor(a,d,o,i,s){super(),this.id=a,this.name=d,this.logger=o,this.proxy=i,this.extension=s,this.offset=0,this._disposed=!1,this.visible=!1,this._register(o.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.logger.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const a=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,a)}replace(a){const d=this.offset;this.info(a),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,d),this.visible&&this.logger.flush()}show(a,d){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof a=="boolean"?a:d))}hide(){this.proxy.$close(this.id)}log(a,d){this.offset+=E.VSBuffer.fromString(d).byteLength,(0,y.log)(this.logger,a,d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class f extends b{appendLine(a){this.append(a)}}let c=class{constructor(a,d,o,i,s,l){this.initData=d,this.extHostFileSystem=o,this.extHostFileSystemInfo=i,this.loggerService=s,this.logService=l,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=a.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(d.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.visibleChannelId=a;for(const[d,o]of this.channels)o.visible=d===this.visibleChannelId}createOutputChannel(a,d,o){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const i=typeof d=="object"&&d.log;i&&(0,m.checkProposedApiEnabled)(o,"extensionLog");const s=(0,T.isString)(d)?d:void 0;if((0,T.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.getDefaultLogLevel(o),n=i?this.doCreateLogOutputChannel(a,l,o):this.doCreateOutputChannel(a,s,o);return n.then(r=>{this.channels.set(r.id,r),r.visible=r.id===this.visibleChannelId}),i?this.createExtHostLogOutputChannel(a,l,n):this.createExtHostOutputChannel(a,n)}async doCreateOutputChannel(a,d,o){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const i=await this.outputDirectoryPromise,s=this.extHostFileSystemInfo.extUri.joinPath(i,`${this.namePool++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),n=await this.proxy.$register(a,s,!1,d,o.identifier.value);return new b(n,a,l,this.proxy,o)}async doCreateLogOutputChannel(a,d,o){const i=await this.createExtensionLogDirectory(o),s=this.extHostFileSystemInfo.extUri.joinPath(i,`${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(s,{name:a},d),n=await this.proxy.$register(a,s,!0,void 0,o.identifier.value);return new f(n,a,l,this.proxy,o)}getDefaultLogLevel(a){let d;const o=this.initData.environment.extensionLogLevel?.find(([i])=>P.ExtensionIdentifier.equals(a.identifier,i))?.[1];return o&&(d=(0,y.parseLogLevel)(o)),d??this.logService.getLevel()}createExtensionLogDirectory(a){let d=this.extensionLogDirectoryPromise.get(a.identifier.value);if(!d){const o=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,a.identifier.value);this.extensionLogDirectoryPromise.set(a.identifier.value,d=(async()=>{try{await this.extHostFileSystem.value.createDirectory(o)}catch(i){if((0,_.toFileSystemProviderErrorCode)(i)!==_.FileSystemProviderErrorCode.FileExists)throw i}return o})())}return d}createExtHostOutputChannel(a,d){let o=!1;const i=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return a},append(s){i(),d.then(l=>l.append(s))},appendLine(s){i(),d.then(l=>l.appendLine(s))},clear(){i(),d.then(s=>s.clear())},replace(s){i(),d.then(l=>l.replace(s))},show(s,l){i(),d.then(n=>n.show(s,l))},hide(){i(),d.then(s=>s.hide())},dispose(){o=!0,d.then(s=>s.dispose())}}}createExtHostLogOutputChannel(a,d,o){const i=new p.DisposableStore,s=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},l=i.add(new g.Emitter);return o.then(n=>{i.add(n),i.add(n.onDidChangeLogLevel(r=>{d=r,l.fire(r)}))}),{...this.createExtHostOutputChannel(a,o),get logLevel(){return d},onDidChangeLogLevel:l.event,trace(n,...r){s(),o.then(h=>h.trace(n,...r))},debug(n,...r){s(),o.then(h=>h.debug(n,...r))},info(n,...r){s(),o.then(h=>h.info(n,...r))},warn(n,...r){s(),o.then(h=>h.warn(n,...r))},error(n,...r){s(),o.then(h=>h.error(n,...r))},dispose(){i.dispose()}}}};c=je([$e(0,C.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,S.IExtHostConsumerFileSystem),$e(3,A.IExtHostFileSystemInfo),$e(4,y.ILoggerService),$e(5,y.ILogService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(De[279],Ie([1,0,4]),function(J,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(De[280],Ie([1,0,32,14,9,10,22,2,4,206,45,223,279]),function(J,e,u,t,C,P,y,I,S,D,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let T=class ti{constructor(g,p,m,b){this.localUserHome=g,this.remoteAgentService=p,this.environmentService=m,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome??g})()}hasValidBasename(g,p,m){return typeof p=="string"||typeof p>"u"?this.resolveOS.then(b=>this.doHasValidBasename(g,b,p)):this.doHasValidBasename(g,p,m)}doHasValidBasename(g,p,m){return g.scheme===t.Schemas.file||g.scheme===t.Schemas.vscodeRemote?(0,u.isValidBasename)(m??(0,y.basename)(g),p===1):!0}get defaultUriScheme(){return ti.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,p){if(g.remoteAuthority)return t.Schemas.vscodeRemote;const m=(0,D.getVirtualWorkspaceScheme)(p.getWorkspace());if(m)return m;const b=p.getWorkspace().folders[0];if(b)return b.uri.scheme;const f=p.getWorkspace().configuration;return f?f.scheme:t.Schemas.file}userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?C.win32:C.posix)}async fileURI(g){let p="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const b=g.indexOf("/",2);b===-1?(p=g.substring(2),g="/"):(p=g.substring(2,b),g=g.substring(b)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:p,path:g,query:"",fragment:""})}};T=je([$e(1,E.IRemoteAgentService),$e(2,k.IWorkbenchEnvironmentService),$e(3,A.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[71],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(y,I){this.line=y,this.character=I}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,I){return new u(0,0)}with(y){return new u(0,0)}}e.Position=u;class t{constructor(y,I,S,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(y,I),this.end=new u(S,D)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var C;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,37,24,32,8,4,9,11,71,18]),function(J,e,u,t,C,P,y,I,S,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",T=" characters skipped \u27EB",_=(E.length+T.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var g;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function m(K){return!!K.preview}e.resultIsMatch=m;function b(K){return!!K.resource}e.isFileMatch=b;function f(K){return!!K.message}e.isProgressMessage=f;var c;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=v;class a{constructor(de,ee,he){this.ranges=ee;const Y=Array.isArray(ee)?ee:[ee];if(he&&he.matchLines===1&&d(Y)){de=(0,y.getNLines)(de,he.matchLines);let me="",be=0,ke=0;const Re=Math.floor(he.charsPerLine/5),ze=[];for(const oe of Y){const le=Math.max(oe.startColumn-Re,0),ge=oe.startColumn+he.charsPerLine;if(le>ke+Re+_){const Z=E+(le-ke)+T;me+=Z+de.slice(le,ge),be+=le-(ke+Z.length)}else me+=de.slice(ke,ge);ze.push(new i(0,oe.startColumn-be,oe.endColumn-be)),ke=ge}this.preview={text:me,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const me=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:de,matches:(0,u.mapArrayOrNot)(ee,be=>new o(be.startLineNumber-me,be.startColumn,be.endLineNumber-me,be.endColumn))}}}}e.TextSearchMatch=a;function d(K){const de=K[0].startLineNumber;for(const ee of K)if(ee.startLineNumber!==de||ee.endLineNumber!==de)return!1;return!0}class o{constructor(de,ee,he,Y){this.startLineNumber=de,this.startColumn=ee,this.endLineNumber=he,this.endColumn=Y}}e.SearchRange=o;class i extends o{constructor(de,ee,he){super(de,ee,de,he)}}e.OneLineRange=i;var s;(function(K){K.List="list",K.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var l;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function n(K,de=!0){const ee=K&&K.files&&K.files.exclude,he=de&&K&&K.search&&K.search.exclude;if(!ee&&!he)return;if(!ee||!he)return ee||he;let Y=Object.create(null);return Y=C.mixin(Y,C.deepClone(ee)),Y=C.mixin(Y,C.deepClone(he),!0),Y}e.getExcludes=n;function r(K,de){return K.excludePattern&&t.match(K.excludePattern,de)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,de)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ee=>{const he=ee.folder.fsPath;if(P.isEqualOrParent(de,he)){const Y=S.relative(he,de);return!ee.includePattern||!!t.match(ee.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var h;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(de,ee){super(de),this.code=ee}}e.SearchError=w;function L(K){const de=K.message;if((0,D.isCancellationError)(K))return new w(de,h.canceled);try{const ee=JSON.parse(de);return new w(ee.message,ee.code)}catch{return new w(de,h.other)}}e.deserializeSearchError=L;function M(K){const de={message:K.message,code:K.code};return new Error(JSON.stringify(de))}e.serializeSearchError=M;function B(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=B;function R(K){return K.type==="success"}e.isSerializedSearchSuccess=R;function z(K){return!!K.path}e.isSerializedFileMatch=z;function H(K,de){const ee=K.searchPath?K.searchPath:K.relativePath;return(0,y.fuzzyContains)(ee,de)}e.isFilePatternMatch=H;class N{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function V(K,de){const ee={...K||{},...de||{}};return Object.keys(ee).filter(he=>{const Y=ee[he];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=V;class U{constructor(de,ee){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...ee.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=de.includePattern;ee.includePattern&&(he?he={...he,...ee.includePattern}:he=ee.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(de,ee,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,he))}includedInQuerySync(de,ee,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,ee,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,ee,he))}includedInQuery(de,ee,he){const Y=this._parsedExcludeExpression(de,ee,he),me=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,ee,he):!0;return(0,k.isThenable)(Y)?Y.then(be=>be?!1:me()):me()}hasSiblingExcludeClauses(){return F(this._excludeExpression)}}e.QueryGlobTester=U;function F(K){for(const de in K)if(typeof K[de]!="boolean")return!0;return!1}function x(K){if(!K)return;let de;return ee=>(de||(de=(K()||Promise.resolve([])).then(he=>he?Q(he):{})),de.then(he=>!!he[ee]))}e.hasSiblingPromiseFn=x;function $(K){if(!K)return;let de;return ee=>{if(!de){const he=K();de=he?Q(he):{}}return!!de[ee]}}e.hasSiblingFn=$;function Q(K){const de={};for(const ee of K)de[ee]=!0;return de}}),define(De[33],Ie([1,0,17,18,21,3,6,26,14,98,22,8,12,2,176,4,13,195,45,46,25,16,15,7,54,30,5]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c,v,a,d,o,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(R,z,H){return new A.ExtUri(N=>w(N,H)).isEqual(R,z)}function n(R,z,H){return l(R.uri,z.uri,H)?0:(0,k.compare)(R.uri.toString(),z.uri.toString())}function r(R,z,H){return R.index!==z.index?R.index<z.index?-1:1:l(R.uri,z.uri,H)?(0,k.compare)(R.name,z.name):(0,k.compare)(R.uri.toString(),z.uri.toString())}function h(R,z,H,N){const V=R.slice(0).sort((F,x)=>H(F,x,N)),U=z.slice(0).sort((F,x)=>H(F,x,N));return(0,u.delta)(V,U,(F,x)=>H(F,x,N))}function w(R,z){const H=z.getCapabilities(R.scheme);return!(H&&H&1024)}class L extends b.Workspace{static toExtHostWorkspace(z,H,N,V){if(!z)return{workspace:null,added:[],removed:[]};const{id:U,name:F,folders:x,configuration:$,transient:Q,isUntitled:K}=z,de=[],ee=H;H?x.forEach((be,ke)=>{const Re=T.URI.revive(be.uri),ze=L._findFolder(N||H,Re,V);ze?(ze.name=be.name,ze.index=be.index,de.push(ze)):de.push({uri:Re,name:be.name,index:ke})}):de.push(...x.map(({uri:be,name:ke,index:Re})=>({uri:T.URI.revive(be),name:ke,index:Re}))),de.sort((be,ke)=>be.index<ke.index?-1:1);const he=new L(U,F,de,!!Q,$?T.URI.revive($):null,!!K,be=>w(be,V)),{added:Y,removed:me}=h(ee?ee.workspaceFolders:[],he.workspaceFolders,n,V);return{workspace:he,added:Y,removed:me}}static _findFolder(z,H,N){for(let V=0;V<z.folders.length;V++){const U=z.workspaceFolders[V];if(l(U.uri,H,N))return U}}constructor(z,H,N,V,U,F,x){super(z,N.map($=>new b.WorkspaceFolder($)),V,U,x),this._name=H,this._isUntitled=F,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(x),N.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,H){return H&&this._structure.get(z)&&(z=(0,A.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let M=class{constructor(z,H,N,V,U){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=V,this._extHostFileSystemInfo=N,this._uriTransformerService=U,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=z.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(s.MainContext.MainThreadMessageService);const F=H.workspace;this._confirmedWorkspace=F?new L(F.id,F.name,[],!!F.transient,F.configuration?T.URI.revive(F.configuration):null,!!F.isUntitled,x=>w(x,N)):void 0}$initializeWorkspace(z,H){this._trusted=H,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:S.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,H,N,...V){const U=[];if(Array.isArray(V)&&V.forEach(K=>{T.URI.isUri(K.uri)&&!U.some(de=>l(de.uri,K.uri,this._extHostFileSystemInfo))&&U.push({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[H,N].some(K=>typeof K!="number"||K<0)||N===0&&U.length===0)return!1;const F=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+N>F.length)return!1;const x=F.slice(0);x.splice(H,N,...U.map(K=>({uri:K.uri,name:K.name||(0,A.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<x.length;K++){const de=x[K];if(x.some((ee,he)=>he!==K&&l(de.uri,ee.uri,this._extHostFileSystemInfo)))return!1}x.forEach((K,de)=>K.index=de);const{added:$,removed:Q}=h(F,x,r,this._extHostFileSystemInfo);if($.length===0&&Q.length===0)return!1;if(this._proxy){const K=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(K,H,N,U).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const ee={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(m.Severity.Error,(0,_.localize)(0,null,K,de.toString()),ee,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(z,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async getWorkspaceFolder2(z,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,H){let N,V="";if(typeof z=="string"?(N=T.URI.file(z),V=z):typeof z<"u"&&(N=z,V=z.fsPath),!N)return V;const U=this.getWorkspaceFolder(N,!0);if(!U)return V;typeof H>"u"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let F=(0,A.relativePath)(U.uri,N);return H&&U.name&&(F=`${U.name}/${F}`),F}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=L.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:H,added:N,removed:V}=L.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:V}))}findFiles(z,H,N,V,U=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let F;if(H===null?F=!1:H&&(typeof H=="string"?F=H:F=H.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:$}=B(a.GlobPattern.from(z));return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(x),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(F),(0,E.withUndefinedAsNull)(N),U).then(Q=>Array.isArray(Q)?Q.map(K=>T.URI.revive(K)):[])}async findTextInFiles(z,H,N,V,U=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const F=this._requestIdProvider.getNext(),x=typeof H.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:$,folder:Q}=B(a.GlobPattern.from(H.include)),K=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,de={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof H.useParentIgnoreFiles=="boolean"?!H.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:x,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:$,excludePattern:K},ee=!1;if(this._activeSearchCallbacks[F]=he=>{if(ee)return;const Y=T.URI.revive(he.resource);he.results.forEach(me=>{(0,i.resultIsMatch)(me)?N({uri:Y,preview:{text:me.preview.text,matches:(0,u.mapArrayOrNot)(me.preview.matches,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,u.mapArrayOrNot)(me.ranges,be=>new d.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:Y,text:me.text,lineNumber:me.lineNumber})})},U.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch(z,(0,E.withUndefinedAsNull)(Q),de,F,U);return delete this._activeSearchCallbacks[F],he||{}}catch(he){throw delete this._activeSearchCallbacks[F],he}}$handleTextSearchResult(z,H){this._activeSearchCallbacks[H]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,H){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,H);const N=this._uriTransformerService.transformOutgoingScheme(z),V=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(V,N),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(z,H){this._logService.info("Getting edit session identifier for workspaceFolder",z);const N=await this.resolveWorkspaceFolder(T.URI.revive(z));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const V=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!V),!V)return;const U=await V.provideEditSessionIdentity(N,H);if(this._logService.info("Provider returned edit session identifier: ",U),!!U)return U}};M=je([$e(0,v.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,f.IExtHostFileSystemInfo),$e(3,p.ILogService),$e(4,o.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function B(R){let z,H;return R&&(typeof R=="string"?z=R:(z=R.pattern,H=T.URI.revive(R.baseUri))),{includePattern:z,folder:H}}}),define(De[34],Ie([1,0,24,3,33,5,7,198,125,12,18,4,16,13,2]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(d,o){if(o){const i=o.split(".");let s=d;for(let l=0;s&&l<i.length;l++)s=s[i[l]];return s}}function p(d){return d instanceof _.URI}function m(d){return d&&d.uri instanceof _.URI&&d.languageId&&typeof d.languageId=="string"}function b(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function f(d){return d&&d.uri instanceof _.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(p(d))return{resource:d};if(m(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(b(d))return{overrideIdentifier:d.languageId};if(f(d))return{resource:d.uri};if(d===null)return{resource:null}}let v=class{constructor(o,i,s){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new a(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,i))}};v=je([$e(0,E.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,T.ILogService)],v),e.ExtHostConfiguration=v;class a{constructor(o,i,s,l){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=l,this._extHostWorkspace=i,this._configuration=I.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(o,i,s){const l=c(i)||{},n=this._toReadonlyValue(o?g(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,l,s?.identifier);function r(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof g(n,w)<"u"},get:(w,L)=>{this._validateConfigurationAccess(o?`${o}.${w}`:w,l,s?.identifier);let M=g(n,w);if(typeof M>"u")M=L;else{let B;const R=(z,H)=>{let N;const V=()=>{B=B||(0,u.deepClone)(n),N=N||g(B,H)};return(0,D.isObject)(z)?new Proxy(z,{get:(U,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return V(),()=>N;if(B)return N=N||g(B,H),N[F];const x=U[F];return typeof F=="string"?R(x,`${H}.${F}`):x},set:(U,F,x)=>(V(),N&&(N[F]=x),!0),deleteProperty:(U,F)=>(V(),N&&delete N[F],!0),defineProperty:(U,F,x)=>(V(),N&&Object.defineProperty(N,F,x),!0)}):z};M=R(M,w)}return M},update:(w,L,M,B)=>{w=o?`${o}.${w}`:w;const R=r(M);return L!==void 0?this._proxy.$updateConfigurationOption(R,w,L,l,B):this._proxy.$removeConfigurationOption(R,w,l,B)},inspect:w=>{w=o?`${o}.${w}`:w;const L=this._configuration.inspect(w,l,this._extHostWorkspace.workspace);if(L)return{key:w,defaultValue:(0,u.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,u.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,u.deepClone)(L.workspace?.value),workspaceFolderValue:(0,u.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,u.deepClone)(L.default?.override),globalLanguageValue:(0,u.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,u.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,u.deepClone)(L.workspaceFolder?.override),languageIds:(0,u.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,u.mixin)(h,n,!1),Object.freeze(h)}_toReadonlyValue(o){const i=s=>(0,D.isObject)(s)?new Proxy(s,{get:(l,n)=>i(l[n]),set:(l,n,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(l,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(l,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(o)}_validateConfigurationAccess(o,i,s){const l=S.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),n=s?`[${s.value}] `:"";if(l===4){typeof i?.resource>"u"&&this._logService.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this._logService.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const s=new I.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,n)=>s.affectsConfiguration(l,c(n))})}_toMap(o){return o.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[72],Ie([1,0,2,18,3,5,7,33,57,34,21,40,16,25,4,14,10,13,67,236,11]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(H){function N(U){if(U!=null)return U}H.from=N;function V(U){if(U!=null)return U}H.to=V})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(H){function N(U){if(U!=null)return U}H.from=N;function V(U){if(U!=null)return U}H.to=V})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(H){function N(U){if(U!=null)return U}H.from=N;function V(U){if(U!=null)return U}H.to=V})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(H){function N(F){if(F){const x=F;return x&&!!x.process}else return!1}H.is=N;function V(F){if(F==null)return;const x={process:F.process,args:F.args};return F.options&&(x.options=o.from(F.options)),x}H.from=V;function U(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}H.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(H){function N(U){if(U!=null)return U}H.from=N;function V(U){if(U!=null)return U}H.to=V})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(H){function N(F){if(F){const x=F;return x&&(!!x.commandLine||!!x.command)}else return!1}H.is=N;function V(F){if(F==null)return;const x={};return F.commandLine!==void 0?x.commandLine=F.commandLine:(x.command=F.command,x.args=F.args),F.options&&(x.options=s.from(F.options)),x}H.from=V;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}H.to=U})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var n;(function(H){function N(F){if(F){const x=F;return x&&x.customExecution==="customExecution"}else return!1}H.is=N;function V(F){return{customExecution:"customExecution"}}H.from=V;function U(F,x){return x.get(F)}H.to=U})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(H){function N(V,U){let F;return V.scope!==void 0&&typeof V.scope!="number"?F=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=f.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:F}}H.from=N})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(H){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}H.from=N})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(H){function N(F,x){if(F==null)return[];const $=[];for(const Q of F){const K=V(Q,x);K&&$.push(K)}return $}H.fromMany=N;function V(F,x){if(F==null)return;let $;F.execution instanceof y.ProcessExecution?$=i.from(F.execution):F.execution instanceof y.ShellExecution?$=l.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&($=n.from(F.execution));const Q=a.from(F.definition);let K;return F.scope?typeof F.scope=="number"?K=F.scope:K=F.scope.uri:K=y.TaskScope.Workspace,!Q||!K?void 0:{_id:F._id,definition:Q,name:F.name,source:{extensionId:x.identifier.value,label:F.source,scope:K},execution:$,isBackground:F.isBackground,group:h.from(F.group),presentationOptions:d.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}H.from=V;async function U(F,x,$){if(F==null)return;let Q;i.is(F.execution)?Q=i.to(F.execution):l.is(F.execution)?Q=l.to(F.execution):n.is(F.execution)&&(Q=n.to(F._id,$));const K=a.to(F.definition);let de;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?de=F.source.scope:de=await x.resolveWorkspaceFolder(u.URI.revive(F.source.scope)):de=y.TaskScope.Workspace),!K||!de)return;const ee=new y.Task(K,de,F.name,F.source.label,Q,F.problemMatchers);return F.isBackground!==void 0&&(ee.isBackground=F.isBackground),F.group!==void 0&&(ee.group=y.TaskGroup.from(F.group._id),ee.group&&F.group.isDefault&&(ee.group=new y.TaskGroup(ee.group.id,ee.group.label),F.group.isDefault===!0&&(ee.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ee.presentationOptions=d.to(F.presentationOptions)),F._id&&(ee._id=F._id),F.detail&&(ee.detail=F.detail),ee}H.to=U})(w=e.TaskDTO||(e.TaskDTO={}));var L;(function(H){function N(U){return U}H.from=N;function V(U){if(!!U)return Object.assign(Object.create(null),U)}H.to=V})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(N,V,U){this._id=V,this._task=U,v.set(this,void 0),tt(this,v,N,"f")}get task(){return this._task}terminate(){Be(this,v,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}v=new WeakMap;var B;(function(H){function N(V){return{id:V._id,task:void 0}}H.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let R=class{constructor(N,V,U,F,x,$,Q,K){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=x,this._terminalService=$,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,U){if(!U)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:V,provider:U,extension:N}),this._proxy.$registerTaskProvider(F,V),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(L.from(N)).then(async V=>{const U=[];for(const F of V){const x=await w.to(F,this._workspaceProvider,this._providedCustomExecutions2);x&&U.push(x)}return U})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,U){const F=this._providedCustomExecutions2.get(N.id);F&&(this._activeCustomExecutions2.set(N.id,F),this._terminalService.attachPtyToTerminal(V,await F.callback(U))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));const F=[],x=(0,t.asPromise)(()=>U.provider.provideTasks(A.CancellationToken.None)).then($=>this.provideTasksInternal(V,F,U,$));return new Promise($=>{x.then(Q=>{Promise.all(F).then(()=>{$(Q)})})})}async $resolveTask(N,V){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));if(V.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await w.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const x=await U.provider.resolveTask(F,A.CancellationToken.None);if(!x)return;this.checkDeprecation(x,U);const $=w.from(x,U.extension);if(!$)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is($.execution)&&await this.addCustomExecution($,x,!0),await this.resolveTaskInternal($)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,U){const F=await this._proxy.$createTaskId(N);!U&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,V.execution)),this._providedCustomExecutions2.set(F,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const x=this._taskExecutionPromises.get(N);if(!x)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return x}const U=this._taskExecutionPromises.get(N.id);if(U)return U;const F=new Promise((x,$)=>{function Q(K,de,ee){ee?x(new M(K,de.id,ee)):$("Unexpected: Task does not exist.")}V?Q(this,N,V):w.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>Q(this,N,K))});return this._taskExecutionPromises.set(N.id,F),F.then(x=>(this._taskExecutions.set(N.id,x),x),x=>Promise.reject(x))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const U=this._notProvidedCustomExecutions.values();let F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};R=je([$e(0,E.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,m.ILogService),$e(7,b.IExtHostApiDeprecationService)],R),e.ExtHostTaskBase=R;let z=class extends R{constructor(N,V,U,F,x,$,Q,K){super(N,V,U,F,x,$,Q,K),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const U=w.from(V,N);if(U===void 0)throw new Error("Task is not valid");if(n.is(U.execution))await this.addCustomExecution(U,V,!1);else throw new c.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),V);return this._proxy.$executeTask(U).catch(x=>{throw new Error(x)}),F}provideTasksInternal(N,V,U,F){const x=[];if(F)for(const $ of F){this.checkDeprecation($,U),(!$.definition||!N[$.definition.type])&&this._logService.warn(`The task [${$.source}, ${$.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=w.from($,U.extension);Q&&n.is(Q.execution)?(x.push(Q),V.push(this.addCustomExecution(Q,$,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:U.extension}}async resolveTaskInternal(N){if(n.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,U){}};z=je([$e(0,E.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,m.ILogService),$e(7,b.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,_.createDecorator)("IExtHostTask")}),define(De[281],Ie([1,0,9,21,50,37,22,51,30]),function(J,e,u,t,C,P,y,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(E,T,_){this.config=E,this.provider=T,this.sessionToken=_,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=E.filePattern,this.includePattern=E.includePattern&&P.parse(E.includePattern),this.maxResults=E.maxResults||void 0,this.exists=E.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=E.excludePattern&&P.parse(E.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(E=>E.cancel()),this.activeCancellationTokens=new Set}search(E){const T=this.config.folderQueries||[];return new Promise((_,g)=>{const p=m=>{this.resultCount++,E(m)};if(this.isCanceled)return _({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const b=m.toString(),f=u.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,f)||this.matchFile(p,{base:m,basename:f})}),Promise.all(T.map(m=>this.searchInFolder(m,p))).then(m=>{_({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{g(new Error((0,C.toErrorMessage)(m)))})})}async searchInFolder(E,T){const _=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(E),p=this.initDirectoryTree(),m=new S.QueryGlobTester(this.config,E),b=!m.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(_),f=I.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,_.token),v=f.elapsed(),a=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(d=>{const o=u.posix.relative(E.folder.path,d.path);if(b){const i=u.basename(d.path);this.matchFile(T,{base:E.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(p,E.folder,o,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,m,T),{providerTime:v,postProcessTime:a.elapsed()})}finally{_.dispose(),this.activeCancellationTokens.delete(_)}}getSearchOptionsForFolder(E){const T=(0,S.resolvePatternsForProvider)(this.config.includePattern,E.includePattern),_=(0,S.resolvePatternsForProvider)(this.config.excludePattern,E.excludePattern);return{folder:E.folder,excludes:_,includes:T,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}addDirectoryEntries({pathToEntries:E},T,_,g){if(_===this.filePattern){const m=u.basename(this.filePattern);this.matchFile(g,{base:T,relativePath:this.filePattern,basename:m})}function p(m){const b=u.basename(m),f=u.dirname(m);let c=E[f];c||(c=E[f]=[],p(f)),c.push({base:T,relativePath:m,basename:b})}p(_)}matchDirectoryTree({rootEntries:E,pathToEntries:T},_,g){const p=this,m=this.filePattern;function b(f){const c=(0,S.hasSiblingFn)(()=>f.map(v=>v.basename));for(let v=0,a=f.length;v<a;v++){const d=f[v],{relativePath:o,basename:i}=d;if(_.matchesExcludesSync(o,i,m!==i?c:void 0))continue;const s=T[o];if(s)b(s);else{if(o===m)continue;p.matchFile(g,d)}if(p.isLimitHit)break}}b(E)}matchFile(E,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||E(T))}}class A{constructor(){this.sessions=new Map}fileSearch(E,T,_,g){const p=this.getSessionTokenSource(E.cacheKey),m=new D(E,T,p&&p.token);let b=0;const f=c=>{b+=c.length,_(c.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(m,A.BATCH_SIZE,f,g).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:c.stats}}))}clearCache(E){this.getSessionTokenSource(E)?.cancel()}getSessionTokenSource(E){if(!!E)return this.sessions.has(E)||this.sessions.set(E,new t.CancellationTokenSource),this.sessions.get(E)}rawMatchToSearchItem(E){return E.relativePath?{resource:y.joinPath(E.base,E.relativePath)}:{resource:E.base}}doSearch(E,T,_,g){g.onCancellationRequested(()=>{E.cancel()});const p=b=>{b&&(m.push(b),T>0&&m.length>=T&&(_(m),m=[]))};let m=[];return E.search(p).then(b=>(m.length&&_(m),b),b=>(m.length&&_(m),Promise.reject(b)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(De[282],Ie([1,0,17,77,37,110,26,14,9,22,8,12,2,160,187,65,13,45,131,280,30]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(h,w,L,M,B){this.configurationService=h,this.workspaceContextService=w,this.editorGroupsService=L,this.logService=M,this.pathService=B}text(h,w,L={}){h=this.getContentPattern(h,L);const M=this.configurationService.getValue(),B=w&&w.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(w?.map(m.toWorkspaceFolder),L),type:2,contentPattern:h,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:M.search.usePCRE2||B||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(h,w){const L=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const M={...h,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(h,w)&&(M.isCaseSensitive=!0),this.isMultiline(h)&&(M.isMultiline=!0),M}file(h,w={}){return{...this.commonQuery(h,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(h,w){return h?(h=Array.isArray(h)?h.map(s):s(h),w?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],w={}){const L=this.handleIncludeExclude(w.includePattern,w.expandPatterns),M=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),B=h.length>1,R=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,w,M)):h.map(N=>this.getFolderQueryForRoot(N,w,M,B))).filter(N=>!!N),z={_reason:w._reason,folderQueries:R,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:M.pattern,includePattern:L.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const N=u.coalesce(u.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(x=>x.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const V=N.filter(F=>(0,c.pathIncludedInQuery)(z,F.fsPath)),U=this.commonQueryFromFileList(V);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...z,...U}}const H=w.extraFileResources&&w.extraFileResources.filter(N=>(0,c.pathIncludedInQuery)(z,N.fsPath));return z.extraFileResources=H&&H.length?H:void 0,z}commonQueryFromFileList(h){const w=[],L=new y.ResourceMap,M={};let B=!1;return h.forEach(R=>{if(R.scheme===I.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(R)){const H=this.workspaceContextService.getWorkspaceFolder(R)?.uri??R.with({path:S.dirname(R.fsPath)});let N=L.get(H);N||(B=!0,N={folder:H,includePattern:{}},w.push(N),L.set(H,N));const V=S.relative(H.fsPath,R.fsPath);(0,k.assertIsDefined)(N.includePattern)[V.replace(/\\/g,"/")]=!0}else R.fsPath&&(B=!0,M[R.fsPath]=!0)}),{folderQueries:w,includePattern:M,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(h,w){if(w.isSmartCase){if(h.isRegExp){if(A.containsUppercaseCharacter(h.pattern,!0))return!0}else if(A.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,T.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const w=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),M=(Array.isArray(h)?h:o(h)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,P.untildify)(U,F.scheme===I.Schemas.file?F.fsPath:F.path):U}),B=t.groupBy(M,U=>w(U)?"searchPaths":"exprSegments"),R=(B.exprSegments||[]).map(U=>A.rtrim(U,"/")).map(U=>A.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),i(U))),z={},H=this.expandSearchPathPatterns(B.searchPaths||[]);H&&H.length&&(z.searchPaths=H);const N=u.flatten(R),V=d(...N);return V&&(z.pattern=V),z}getExcludesForFolder(h,w){return w.disregardExcludeSettings?void 0:(0,c.getExcludes)(h,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const w=u.flatten(h.map(M=>{let{pathPortion:B,globPortion:R}=a(M);R&&(R=l(R));const z=this.expandOneSearchPath(B);return u.flatten(z.map(H=>this.resolveOneSearchPathPattern(H,R)))})),L=new Map;return w.forEach(M=>{const B=M.searchPath.toString(),R=L.get(B);R?M.pattern&&(R.pattern=R.pattern||{},R.pattern[M.pattern]=!0):L.set(B,{searchPath:M.searchPath,pattern:M.pattern?d(M.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==I.Schemas.file?[{searchPath:w[0].uri.with({path:h})}]:[{searchPath:E.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=s(h),h.startsWith("../")||h===".."){const M=S.posix.resolve(w.path,h);return[{searchPath:w.with({path:M})}]}const L=l(h);return[{searchPath:w,pattern:L}]}else{if(h==="./"||h===".\\")return[];{const w=h.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(B=>{const R=w.match(new RegExp(`^${A.escapeRegExpCharacters(B.name)}(?:/(.*)|$)`));return R?{match:R,folder:B}:null}).filter(k.isDefined);if(M.length)return M.map(B=>{const R=B.match[1];return{searchPath:B.folder.uri,pattern:R&&l(R)}});{const B=h.match(/\.[\/\\](.+)[\/\\]?/),R=B?B[1]:h,z=_.localize(0,null,R);throw new Error(z)}}}}resolveOneSearchPathPattern(h,w){const L=h.pattern&&w?`${h.pattern}/${w}`:h.pattern||w,M=[{searchPath:h.searchPath,pattern:L}];return L&&!L.endsWith("**")&&M.push({searchPath:h.searchPath,pattern:L+"/**"}),M}getFolderQueryForSearchPath(h,w,L){const M=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(h.searchPath),w,L,!1);return M?{...M,includePattern:h.pattern}:null}getFolderQueryForRoot(h,w,L,M){let B;const R=E.URI.isUri(h)?h:h.uri;if(L.searchPaths){const U=L.searchPaths.filter(F=>(0,D.isEqual)(F.searchPath,R))[0];if(U&&!U.pattern)return null;U&&(B=U.pattern)}const z=this.configurationService.getValue({resource:R}),N={...this.getExcludesForFolder(z,w)||{},...B||{}},V=E.URI.isUri(h)?(0,D.basename)(h):h.name;return{folder:R,folderName:M?V:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!z.search.followSymlinks}}};v=je([$e(0,g.IConfigurationService),$e(1,m.IWorkspaceContextService),$e(2,b.IEditorGroupsService),$e(3,p.ILogService),$e(4,f.IPathService)],v),e.QueryBuilder=v;function a(r){const h=r.match(/[\*\{\}\(\)\[\]\?]/);if(h){const w=h.index,L=r.substr(0,w).match(/[/|\\][^/\\]*$/);if(L){let M=r.substr(0,L.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:r.substr((L.index||0)+1)}}}return{pathPortion:r}}function d(...r){return r.length?r.reduce((h,w)=>(h[w]=!0,h),Object.create(null)):void 0}function o(r){return C.splitGlobAware(r,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(r){return[`**/${r}/**`,`**/${r}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function s(r){return r.replace(/\\/g,"/")}function l(r){return s(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(r,h){r=u.distinct(r,M=>M.toString());const w=[],L=h.getWorkspace();return r&&r.forEach(M=>{let B;if(h.getWorkbenchState()===2)B=(0,D.relativePath)(L.folders[0].uri,M),B&&B!=="."&&(B="./"+B);else{const R=h.getWorkspaceFolder(M);if(R){const z=R.name;if(L.folders.filter(N=>N.name===z).length===1){const N=(0,D.relativePath)(R.uri,M);N===""?B=`./${R.name}`:B=`./${R.name}/${N}`}else B=M.fsPath}}B&&w.push(B)}),w}e.resolveResourcesForSearchIncludes=n}),define(De[283],Ie([1,0,22,2,21,11,4,282,30,45]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function k(g,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const b=[],f=[];for(const i of m)if(/^workspaceContains:/.test(i)){const s=i.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||g.forceUsingSearch?f.push(s):b.push(s)}if(b.length===0&&f.length===0)return Promise.resolve(void 0);let c;const v=new Promise((i,s)=>{c=i}),a=i=>c({activationEvent:i}),d=Promise.all(b.map(i=>E(g,i,a))).then(()=>{}),o=T(g,p.identifier,f,a);return Promise.all([d,o]).then(()=>{c(void 0)}),v}e.checkActivateWorkspaceContainsExtension=k;async function E(g,p,m){for(const b of g.folders)if(await g.exists(u.joinPath(t.URI.revive(b),p))){m(`workspaceContains:${p}`);return}}async function T(g,p,m,b){if(m.length===0)return Promise.resolve(void 0);const f=new C.CancellationTokenSource,c=g.checkExists(g.folders,m,f.token),v=setTimeout(async()=>{f.cancel(),g.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},A);let a=!1;try{a=await c}catch(d){P.isCancellationError(d)||P.onUnexpectedError(d)}f.dispose(),clearTimeout(v),a&&b(`workspaceContains:${m.join(",")}`)}function _(g,p,m,b){const f=g.get(y.IInstantiationService),c=g.get(S.ISearchService),a=f.createInstance(I.QueryBuilder).file(p.map(d=>(0,D.toWorkspaceFolder)(t.URI.revive(d))),{_reason:"checkExists",includePattern:m,exists:!0});return c.fileSearch(a,b).then(d=>!!d.limitHit,d=>P.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=_});var tt=this&&this.__classPrivateFieldSet||function(J,e,u,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,u):C?C.value=u:e.set(J,u),u},Be=this&&this.__classPrivateFieldGet||function(J,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(J):t?t.value:e.get(J)};define(De[41],Ie([1,0,171,9,73,22,18,6,26,2,13,5,34,226,95,33,28,224,11,27,23,207,7,126,4,25,69,16,84,53,40,3,283,94,209,14,93]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c,v,a,d,o,i,s,l,n,r,h,w,L,M,B,R,z){"use strict";var H,N,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let U=class Nn extends I.Disposable{constructor(ee,he,Y,me,be,ke,Re,ze,oe,le,ge){super(),this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=me,this._extHostConfiguration=be,this._logService=ke,this._extHostTunnelService=oe,this._extHostTerminalService=le,this._extHostLocalizationService=ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new m.ExtensionDescriptionRegistry(this._initData.allExtensions);const Z=(0,p.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new m.ExtensionDescriptionRegistry($(this._globalRegistry,Z)),this._storage=new _.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=ze,this._instaService=ee.createChild(new n.ServiceCollection([_.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let ae=[],ne=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(O=>!O.main&&!O.browser).map(O=>O.identifier),ne=this._initData.allExtensions.filter(O=>!Z.has(f.ExtensionIdentifier.toKey(O.identifier.value))).filter(O=>(O.main||O.browser)&&O.api==="none").map(O=>O.identifier));const ie=(0,p.extensionIdentifiersArrayToSet)(ne);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ae,ne,{onExtensionActivationError:(O,j,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(O,b.transformErrorForSerialization(j),G)},actualActivateExtension:async(O,j)=>{if(ie.has(f.ExtensionIdentifier.toKey(O)))return await this._mainThreadExtensionsProxy.$activateExtension(O,j),new T.HostExtension;const G=this._myRegistry.getExtensionDescription(O);return this._activateExtension(G,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ee){b.onUnexpectedError(ee)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ee=[];try{ee=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(ee)}terminate(ee,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ee}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),b.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(ee){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ee):!1}async getExtension(ee){const he=await this._mainThreadExtensionsProxy.$getExtension(ee);let Y;if(he?.browserNlsBundleUris){Y={};for(const me of Object.keys(he.browserNlsBundleUris))Y[me]=D.URI.revive(he.browserNlsBundleUris[me])}return he&&{...he,identifier:new f.ExtensionIdentifier(he.identifier.value),extensionLocation:D.URI.revive(he.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(ee,he){return this._activator.activateByEvent(ee,he)}_activateById(ee,he){return this._activator.activateById(ee,he)}activateByIdWithErrors(ee,he){return this._activateById(ee,he).then(()=>{const Y=this._activator.getActivatedExtension(ee);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ee=>this._myRegistry)}getExtensionExports(ee){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ee).exports:null}async _realPathExtensionUri(ee){if(ee.scheme!==R.Schemas.file)return ee;const he=await this._hostUtils.realpath(ee.fsPath);return D.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ee=>new K(ee))),this._extensionPathIndex}async _createExtensionPathIndex(ee){const he=S.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ee.map(async Y=>{if(this._getEntryPoint(Y)){const me=await this._realPathExtensionUri(Y.extensionLocation);he.set(me,Y)}})),he}_deactivate(ee){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ee))return he;const Y=this._activator.getActivatedExtension(ee);if(!Y)return he;try{typeof Y.module.deactivate=="function"&&(he=Promise.resolve(Y.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${ee.value}':`),this._logService.error(me)}try{(0,I.dispose)(Y.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this._logService.error(me)}return he}async _activateExtension(ee,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier),this._doActivateExtension(ee,he).then(Y=>{const me=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ee.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,he),this._logExtensionActivationTimes(ee,he,"success",me),Y},Y=>{throw this._logExtensionActivationTimes(ee,he,"failure"),Y})}_logExtensionActivationTimes(ee,he,Y,me){const be=F(ee,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...me||{},outcome:Y})}_doActivateExtension(ee,he){const Y=F(ee,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const me=this._getEntryPoint(ee);if(!me)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${ee.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const be=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(ee,(0,P.joinPath)(ee.extensionLocation,me),be),this._loadExtensionContext(ee)]).then(ke=>(C.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Nn._callActivate(this._logService,ee.identifier,ke[0],ke[1],be))).then(ke=>(C.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),ke))}_loadExtensionContext(ee){const he=new v.ExtensionGlobalMemento(ee,this._storage),Y=new v.ExtensionMemento(ee.identifier.value,!1,this._storage),me=new B.ExtensionSecrets(ee,this._secretState),be=ee.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,ke=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([he.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let ze,oe;const le=(0,p.isProposedApiEnabled)(ee,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:Y,secrets:me,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(ge){return t.join(ee.extensionLocation.fsPath,ge)},get storagePath(){return Re._storagePath.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(ee).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,ee.identifier.value)},get logUri(){return D.URI.joinPath(Re._initData.logsLocation,ee.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(ee)},get globalStorageUri(){return Re._storagePath.globalValue(ee)},get extensionMode(){return be},get extension(){return ze===void 0&&(ze=new x(Re,ee.identifier,ee,ke,!1)),ze},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(ee,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!oe){if(!le)return;const ge=w.Event.buffer(w.Event.fromDOMEventEmitter(le,"message",Z=>Z.data));le.start(),oe={onDidReceiveMessage:ge,postMessage:le.postMessage.bind(le)}}return oe}})})}static _callActivate(ee,he,Y,me,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(ee,he,Y,me,be).then(ke=>new T.ActivatedExtension(!1,null,be.build(),Y,ke,me.subscriptions))}static _callActivateOptional(ee,he,Y,me,be){if(typeof Y.activate=="function")try{be.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${he.value}`);const ke=typeof global=="object"?global:self,Re=Y.activate.apply(ke,[me]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(ze=>(be.activateResolveStop(),ze))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Y)}_activateOneStartupFinished(ee,he){this._activateById(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:he}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const ee of this._myRegistry.getAllExtensionDescriptions())if(ee.activationEvents)for(const he of ee.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(ee,he)}_handleEagerExtensions(){const ee=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(he),me=Promise.all([ee,Y]).then(()=>{});return Promise.race([me,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),me}_handleWorkspaceContainsEagerExtensions(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(ee,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ee,he){if(this.isActivated(he.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:ee.map(ke=>ke.uri),forceUsingSearch:Y,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Re,ze)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Re,ze)},be=await(0,L.checkActivateWorkspaceContainsExtension)(me,he);if(!!be)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:be.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ee){throw console.error(ee),ee}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:he}=this._initData.environment;if(!ee||!he)throw new Error(u.localize(0,null));const Y=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(u.localize(1,null,he.toString()));return new Promise((me,be)=>{const ke=(oe,le)=>{oe?be(oe):me(typeof le=="number"&&le>0?1:0)},Re=(0,P.originalFSPath)(he),ze=Y.run(Re,ke);ze&&ze.then&&ze.then(()=>{me(0)}).catch(oe=>{be(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,he){return this._resolvers[ee]=he,(0,I.toDisposable)(()=>{delete this._resolvers[ee]})}async _activateAndGetResolver(ee){const he=ee.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const Y=ee.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(ee,he){this._logService.info(`$resolveAuthority invoked for authority (${Q(ee)})`);const{authorityPrefix:Y,resolver:me}=await this._activateAndGetResolver(ee);if(!me)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(me)),C.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await me.resolve(ee,{resolveAttempt:he});C.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ke={authority:ee,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(C.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(ee,he){this._logService.info(`$getCanonicalURI invoked for authority (${Q(ee)})`);const{resolver:Y}=await this._activateAndGetResolver(ee);if(!Y)return null;const me=D.URI.revive(he);if(typeof Y.getCanonicalURI>"u")return me;const be=await(0,y.asPromise)(()=>Y.getCanonicalURI(me));return be||me}static _applyExtensionsDelta(ee,he,Y){const me=new m.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());me.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,p.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(f.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(f.ExtensionIdentifier.toKey(Re));const ke=$(me,be);return{globalRegistry:me,myExtensions:ke}}$startExtensionHost(ee){ee.toAdd.forEach(me=>me.extensionLocation=D.URI.revive(me.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Nn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(ee,he){return he===1?this._activateByEvent(ee,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(ee,!1))}async $activate(ee,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ee)?(await this._activateById(ee,he),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(ke=>ke.extensionLocation=D.URI.revive(ke.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Nn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee),me=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const he=c.VSBuffer.alloc(ee),Y=Math.random()%256;for(let me=0;me<ee;me++)he.writeUInt8(Y,me);return he}async $updateRemoteConnectionData(ee){this._remoteConnectionData=ee,this._onDidChangeRemoteConnectionData.fire()}};U=je([$e(0,o.IInstantiationService),$e(1,e.IHostUtils),$e(2,l.IExtHostRpcService),$e(3,g.IExtHostWorkspace),$e(4,E.IExtHostConfiguration),$e(5,A.ILogService),$e(6,i.IExtHostInitDataService),$e(7,s.IExtensionStoragePaths),$e(8,r.IExtHostTunnelService),$e(9,h.IExtHostTerminalService),$e(10,z.IExtHostLocalizationService)],U),e.AbstractExtHostExtensionService=U;function F(de,ee){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class x{constructor(ee,he,Y,me,be){H.set(this,void 0),N.set(this,void 0),V.set(this,void 0),tt(this,H,ee,"f"),tt(this,N,he,"f"),tt(this,V,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=me,this.isFromDifferentExtensionHost=be}get isActive(){return Be(this,H,"f").isActivated(Be(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,H,"f").getExtensionExports(Be(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,H,"f").activateByIdWithErrors(Be(this,V,"f"),{startup:!1,extensionId:Be(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=x,H=new WeakMap,N=new WeakMap,V=new WeakMap;function $(de,ee){return de.getAllExtensionDescriptions().filter(he=>ee.has(f.ExtensionIdentifier.toKey(he.identifier)))}function Q(de){const ee=de.indexOf("+");return ee===-1?de:de.substring(0,ee)}class K{constructor(ee){this._searchTree=ee}setSearchTree(ee){this._searchTree=ee}findSubstr(ee){return this._searchTree.findSubstr(ee)}forEach(ee){return this._searchTree.forEach(ee)}}e.ExtensionPaths=K}),define(De[284],Ie([1,0,73,2,5,34,28,27,16,25,4,41,36,13,8]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(v,a,d,o,i,s,l){this._apiFactory=v,this._extensionRegistry=a,this._instaService=d,this._extHostConfiguration=o,this._extHostExtensionService=i,this._initData=s,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,a,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(b,a)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,a,this._initData.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const a of v.nodeModuleName)this._factories.set(a,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(a=>v.alternativeModuleName(a))}};g=je([$e(2,A.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,D.IExtHostInitDataService),$e(6,T.ILogService)],g),e.RequireInterceptor=g;let p=class Yn{constructor(v){if(v.environment.appRoot&&Yn.aliased.size){const a=(0,_.escapeRegExpCharacters)(this.forceForwardSlashes(v.environment.appRoot.fsPath)),d="[a-z0-9_.-]",o=`@${d}+\\/${d}+|${d}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${i}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(v){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(v));if(!a)return;const[,d,o,i]=a,s=Yn.aliased.get(o);if(s!==void 0)return console.warn(`${o} as been renamed to ${s}, please update your imports`),d+s+i}forceForwardSlashes(v){return v.replace(/\\/g,"/")}};p.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),p=je([$e(0,D.IExtHostInitDataService)],p);class m{constructor(v,a,d,o,i){this._apiFactory=v,this._extensionPaths=a,this._extensionRegistry=d,this._configProvider=o,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,a){const d=this._extensionPaths.findSubstr(a);if(d){let o=this._extApiImpl.get(I.ExtensionIdentifier.toKey(d.identifier));return o||(o=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(d.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((i,s)=>o+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(v,a,d){this._extensionPaths=v,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(C.MainContext.MainThreadTelemetry);const{environment:o}=d,i=a.getProxy(C.MainContext.MainThreadKeytar);if(o.appRoot){let s=o.appRoot.fsPath;E.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,l)=>i.$getPassword(s,l),setPassword:(s,l,n)=>i.$setPassword(s,l,n),deletePassword:(s,l)=>i.$deletePassword(s,l),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(v,a){const d=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(v){const a=v.length;if(a<=7||!this.alternativeNames)return;const d=a-7;if((v.charAt(d)==="/"||v.charAt(d)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}};b=je([$e(1,S.IExtHostRpcService),$e(2,D.IExtHostInitDataService)],b);let f=class{constructor(v,a,d){this._extensionPaths=v,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(C.MainContext.MainThreadTelemetry);const o=d.getProxy(C.MainContext.MainThreadWindow);this._impl=(i,s)=>{const l=t.URI.parse(i);return s?this.callOriginal(i,s):l.scheme==="http"||l.scheme==="https"?o.$openUri(l,i,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?o.$openUri(l,i,{}):this.callOriginal(i,s)}}load(v,a,d){const o=this._extensionPaths.findSubstr(a);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=d(v),this._impl}callOriginal(v,a){return this.sendNoForwardTelemetry(),this._original(v,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=je([$e(2,S.IExtHostRpcService)],f)}),define(De[47],Ie([1,0,78,6,9,36,4,57,58,41,7,33,221,34]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class _ extends E.AbstractVariableResolverService{constructor(m,b,f,c,v,a,d){function o(){if(f){const i=f.activeEditor();if(i)return i.document.uri;const s=c.tabGroups.all.find(l=>l.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof A.TextDiffTabInput||s.input instanceof A.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof A.TextTabInput||s.input instanceof A.NotebookEditorTabInput||s.input instanceof A.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:i=>{const s=a.folders.filter(l=>l.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>a.folders.length,getConfigurationValue:(i,s)=>v.getConfiguration(void 0,i).get(s),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=o();if(i)return C.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const i=o();if(i){const s=b.getWorkspaceFolder(i);if(s)return C.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(f){const i=f.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(f){const i=f.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>m.getExtension(i)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(P.env))}}let g=class extends t.Disposable{constructor(m,b,f,c,v){super(),this.extensionService=m,this.workspaceService=b,this.editorService=f,this.configurationService=c,this.editorTabs=v,this._resolver=new u.Lazy(async()=>{const a=await this.configurationService.getConfigProvider(),o={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{o.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new _(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,a,o,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};g=je([$e(0,D.IExtHostExtensionService),$e(1,k.IExtHostWorkspace),$e(2,I.IExtHostDocumentsAndEditors),$e(3,T.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs)],g),e.ExtHostVariableResolverProviderService=g}),define(De[74],Ie([1,0,18,3,12,2,4,5,58,41,16,7,33,129,214,34,47]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let m=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(o,i,s,l,n,r){this._workspaceService=i,this._extensionService=s,this._configurationService=l,this._editorTabs=n,this._variableResolver=r,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=o.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(w=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}asDebugSourceUri(o,i){const s=o;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let l=`debug:${encodeURIComponent(s.path||"")}`,n="?";return i&&(l+=`${n}session=${encodeURIComponent(i.id)}`,n="&"),l+=`${n}ref=${s.sourceReference}`,P.URI.parse(l)}else{if(s.path)return P.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const i=[];for(const s of o.getAllExtensionDescriptions())if(s.contributes){const l=s.contributes.debuggers;if(l&&l.length>0)for(const n of l)(0,_.isDebuggerMainContribution)(n)&&i.push(n.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(i=>o.push(i)),o}addBreakpoints(o){this.startBreakpoints();const i=o.filter(n=>{const r=n.id;return this._breakpoints.has(r)?!1:(this._breakpoints.set(r,n),!0)});this.fireBreakpointChanges(i,[],[]);const s=[],l=new Map;for(const n of i)if(n instanceof k.SourceBreakpoint){let r=l.get(n.location.uri.toString());r||(r={type:"sourceMulti",uri:n.location.uri,lines:[]},l.set(n.location.uri.toString(),r),s.push(r)),r.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof k.FunctionBreakpoint&&s.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(o){this.startBreakpoints();const i=o.filter(r=>this._breakpoints.delete(r.id));this.fireBreakpointChanges([],i,[]);const s=i.filter(r=>r instanceof k.SourceBreakpoint).map(r=>r.id),l=i.filter(r=>r instanceof k.FunctionBreakpoint).map(r=>r.id),n=i.filter(r=>r instanceof k.DataBreakpoint).map(r=>r.id);return this._debugServiceProxy.$unregisterBreakpoints(s,l,n)}startDebugging(o,i,s){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,i,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,i,s){if(!i)return new k.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:l,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,s,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,l),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(n=>n.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(o,i,s){if(!s)return new k.Disposable(()=>{});if(!this.definesDebugType(o,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:l,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,l),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(n=>n.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(o,i){if(!i)return new k.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:s,factory:i}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==i)})}async $runInTerminal(o,i){return Promise.resolve(void 0)}async $substituteVariables(o,i){let s;const l=await this.getFolder(o);return l&&(s={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,i)}createDebugAdapter(o,i){if(o.type==="implementation")return new v(o.implementation)}createSignService(){}async $startDASession(o,i){const s=this,l=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const r=this.convertToDto(n),h=this.createDebugAdapter(r,l);if(!h)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const w=h;return this._debugAdapters.set(o,w),this.getDebugAdapterTrackers(l).then(L=>(L&&this._debugAdaptersTrackers.set(o,L),w.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const B=M,R={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(B.arguments.value);R.body={signature:z},w.sendResponse(R)}else throw new Error("no signer")}catch(z){R.success=!1,R.message=z.message,w.sendResponse(R)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(M),M=(0,_.convertToVSCPaths)(M,!0),s._debugServiceProxy.$acceptDAMessage(o,M)}),w.onError(M=>{L&&L.onError&&L.onError(M),this._debugServiceProxy.$acceptDAError(o,M.name,M.message,M.stack)}),w.onExit(M=>{L&&L.onExit&&L.onExit((0,C.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,C.withNullAsUndefined)(M),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),w.startSession()))})}$sendDAMessage(o,i){i=(0,_.convertToDAPaths)(i,!1);const s=this._debugAdaptersTrackers.get(o);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(i),this._debugAdapters.get(o)?.sendMessage(i)}$stopDASession(o){const i=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),i&&i.onWillStopSession&&i.onWillStopSession();const s=this._debugAdapters.get(o);return this._debugAdapters.delete(o),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const i=[],s=[],l=[];if(o.added)for(const n of o.added){const r=n.id;if(r&&!this._breakpoints.has(r)){let h;if(n.type==="function")h=new k.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")h=new k.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const w=P.URI.revive(n.uri);h=new k.SourceBreakpoint(new k.Location(w,new k.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}h._id=r,this._breakpoints.set(r,h),i.push(h)}}if(o.removed)for(const n of o.removed){const r=this._breakpoints.get(n);r&&(this._breakpoints.delete(n),s.push(r))}if(o.changed){for(const n of o.changed)if(n.id){const r=this._breakpoints.get(n.id);if(r){if(r instanceof k.FunctionBreakpoint&&n.type==="function"){const h=r;h.enabled=n.enabled,h.condition=n.condition,h.hitCondition=n.hitCondition,h.logMessage=n.logMessage,h.functionName=n.functionName}else if(r instanceof k.SourceBreakpoint&&n.type==="source"){const h=r;h.enabled=n.enabled,h.condition=n.condition,h.hitCondition=n.hitCondition,h.logMessage=n.logMessage,h.location=new k.Location(P.URI.revive(n.uri),new k.Position(n.line,n.character))}l.push(r)}}}this.fireBreakpointChanges(i,s,l)}$provideDebugConfigurations(o,i,s){return(0,u.asPromise)(async()=>{const l=this.getConfigProviderByHandle(o);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.getFolder(i);return l.provideDebugConfigurations(n,s)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(o,i,s,l){return(0,u.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.getFolder(i);return n.resolveDebugConfiguration(r,s,l)})}$resolveDebugConfigurationWithSubstitutedVariables(o,i,s,l){return(0,u.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.getFolder(i);return n.resolveDebugConfigurationWithSubstitutedVariables(r,s,l)})}async $provideDebugAdapter(o,i){const s=this.getAdapterDescriptorFactoryByHandle(o);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(i);return this.getAdapterDescriptor(s,l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(n)})}async $acceptDebugSessionStarted(o){const i=await this.getSession(o);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(o){const i=await this.getSession(o);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,i){(await this.getSession(o))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(o,i){const l={session:await this.getSession(o),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const i=this._adapterFactories.filter(s=>s.type===o);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(o){const i=this._adapterFactories.filter(s=>s.handle===o);if(i.length>0)return i[0].factory}getConfigProviderByHandle(o){const i=this._configProviders.filter(s=>s.handle===o);if(i.length>0)return i[0].provider}definesDebugType(o,i){if(o.contributes){const s=o.contributes.debuggers;if(s&&s.length>0){for(const l of s)if(l.label&&l.type&&l.type===i)return!0}}return!1}getDebugAdapterTrackers(o){const s=o.configuration.type,l=this._trackerFactories.filter(n=>n.type===s||n.type==="*").map(n=>(0,u.asPromise)(()=>n.factory.createDebugAdapterTracker(o)).then(r=>r,r=>null));return Promise.race([Promise.all(l).then(n=>{const r=n.filter(h=>!!h);if(r.length>0)return new c(r)}),new Promise((n,r)=>{const h=setTimeout(()=>{clearTimeout(h),r(new Error("timeout"))},1e3)})]).catch(n=>{})}async getAdapterDescriptor(o,i){const s=i.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new k.DebugAdapterServer(s));if(o){const n=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>o.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,n))).then(r=>{if(r)return r})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,l))}daExecutableFromPackage(o,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,i,s){(o.length>0||i.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:i,changed:s}))}async getSession(o){if(o)if(typeof o=="string"){const i=this._debugSessions.get(o);if(i)return i}else{let i=this._debugSessions.get(o.id);if(!i){const s=await this.getFolder(o.folderUri),l=o.parent?this._debugSessions.get(o.parent):void 0;i=new b(this._debugServiceProxy,o.id,o.type,o.name,s,o.configuration,l),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(o){if(o){const i=P.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};m=je([$e(0,A.IExtHostRpcService),$e(1,E.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,g.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs),$e(5,p.IExtHostVariableResolverProvider)],m),e.ExtHostDebugServiceBase=m;class b{constructor(o,i,s,l,n,r,h){this._debugServiceProxy=o,this._id=i,this._type=s,this._name=l,this._workspaceFolder=n,this._configuration=r,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,i)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=b;class f{constructor(o){this.value=Object.freeze({append(i){o.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=f;class c{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(i=>i.onError?i.onError(o):void 0)}onExit(o,i){this.trackers.forEach(s=>s.onExit?s.onExit(o,i):void 0)}}class v extends T.AbstractDebugAdapter{constructor(o){super(),this.implementation=o,o.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends m{constructor(o,i,s,l,n,r){super(o,i,s,l,n,r)}};a=je([$e(0,A.IExtHostRpcService),$e(1,E.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,g.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs),$e(5,p.IExtHostVariableResolverProvider)],a),e.WorkerExtHostDebugService=a}),define(De[285],Ie([1,0,11,73,2,5,277,13,83,84,25,193,16,54,41,92]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{static async installEarlyHandler(f){const c=f.get(I.ILogService),a=f.get(E.IExtHostRpcService).getProxy(P.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(d=>{c.error(d);const o=u.transformErrorForSerialization(d);a.$onUnexpectedError(o)})}static async installFullHandler(f){const c=f.get(I.ILogService),v=f.get(E.IExtHostRpcService),a=f.get(_.IExtHostExtensionService),d=f.get(g.IExtHostTelemetry),o=v.getProxy(P.MainContext.MainThreadExtensionService),i=v.getProxy(P.MainContext.MainThreadErrors),s=await a.getExtensionPathIndex(),l=new WeakMap;Error.prepareStackTrace=(n,r)=>{let h="",w,L;for(const M of r)h+=`
	at ${M.toString()}`,L=M.getFileName(),!w&&L&&(w=s.findSubstr(C.URI.file(L)));return l.set(n,w?.identifier),`${n.name||"Error"}: ${n.message||""}${h}`},u.setUnexpectedErrorHandler(n=>{c.error(n);const r=u.transformErrorForSerialization(n),h=l.get(n);if(!h){i.$onUnexpectedError(r);return}o.$onExtensionRuntimeError(h,r);const w=d.onExtensionError(h,n);c.trace("forwarded error to extension?",w,h)})}}Error.stackTraceLimit=100;class m{constructor(f,c,v,a,d){this._hostUtils=v,this._rpcProtocol=new y.RPCProtocol(f,null,a),c=m._transform(c,this._rpcProtocol);const o=new D.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());o.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...c,messagePorts:d}),o.set(E.IExtHostRpcService,new E.ExtHostRpcService(this._rpcProtocol)),o.set(T.IURITransformerService,new T.URITransformerService(a)),o.set(_.IHostUtils,v);const i=new k.InstantiationService(o,!0);i.invokeFunction(p.installEarlyHandler),this._logService=i.invokeFunction(s=>s.get(I.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",c),this._extensionService=i.invokeFunction(s=>s.get(_.IExtHostExtensionService)),this._extensionService.initialize(),i.invokeFunction(p.installFullHandler)}async asBrowserUri(f){const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,c){f.allExtensions.forEach(a=>{a.extensionLocation=C.URI.revive(c.transformIncomingURIs(a.extensionLocation));const d={};a.browserNlsBundleUris&&(Object.keys(a.browserNlsBundleUris).forEach(o=>d[o]=C.URI.revive(c.transformIncomingURIs(a.browserNlsBundleUris[o]))),a.browserNlsBundleUris=d)}),f.environment.appRoot=C.URI.revive(c.transformIncomingURIs(f.environment.appRoot));const v=f.environment.extensionDevelopmentLocationURI;return v&&(f.environment.extensionDevelopmentLocationURI=v.map(a=>C.URI.revive(c.transformIncomingURIs(a)))),f.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(f.environment.workspaceStorageHome)),f.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=C.URI.revive(c.transformIncomingURIs(f.logsLocation)),f.logFile=C.URI.revive(c.transformIncomingURIs(f.logFile)),f.workspace=c.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=m}),define(De[286],Ie([1,0,18,10,177,192,200,74,58,41,16,40,7,47,33,215,217,34]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let b=class extends I.ExtHostDebugServiceBase{constructor(d,o,i,s,l,n,r){super(d,o,i,s,n,r),this._terminalService=l,this._integratedTerminalInstances=new v}createDebugAdapter(d,o){switch(d.type){case"server":return new g.SocketDebugAdapter(d);case"pipeServer":return new g.NamedPipeDebugAdapter(d);case"executable":return new g.ExecutableDebugAdapter(d,o.type)}return super.createDebugAdapter(d,o)}daExecutableFromPackage(d,o){const i=g.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),d.type);if(i)return new E.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new y.SignService}async $runInTerminal(d,o){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(z=>{this._integratedTerminalInstances.onTerminalClosed(z)}));const i=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),l=this._terminalService.getDefaultShellArgs(!0),n=d.title||C.localize(0,null),r=JSON.stringify({shell:s,shellArgs:l});let h=await this._integratedTerminalInstances.checkout(r,n),w,L=!1;if(h)w=d.cwd;else{const z={shellPath:s,shellArgs:l,cwd:d.cwd,name:n,iconPath:new E.ThemeIcon("debug")};L=!0,h=this._terminalService.createTerminalFromOptions(z,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,r)}h.show(!0);const M=await h.processId;L?await new Promise(z=>setTimeout(z,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?h.sendText("cls"):s.indexOf("bash")>=0?h.sendText("clear"):t.isWindows?h.sendText("cls"):h.sendText("clear"));const B=(0,p.prepareCommand)(s,d.args,!!d.argsCanBeInterpretedByShell,w,d.env);h.sendText(B);const R=this.onDidTerminateDebugSession(z=>{z.id===o&&(this._integratedTerminalInstances.free(h),R.dispose())});return M}else if(d.kind==="external")return c(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,o)}};b=je([$e(0,A.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,D.IExtHostExtensionService),$e(3,m.IExtHostConfiguration),$e(4,k.IExtHostTerminalService),$e(5,S.IExtHostEditorTabs),$e(6,T.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let f;function c(a,d){if(!f)if(t.isWindows)f=new P.WindowsExternalTerminalService;else if(t.isMacintosh)f=new P.MacExternalTerminalService;else if(t.isLinux)f=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=d.getConfiguration("terminal");return f.runInTerminal(a.title,a.cwd,a.args,a.env||{},o.external||{})}e.runInExternalTerminal=c;class v{constructor(){this._terminalInstances=new Map}async checkout(d,o){const s=[...this._terminalInstances.entries()].map(([l,n])=>(0,u.createCancelablePromise)(async r=>{if(l.name!==o||n.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await l.processId))return null;const h=Date.now();return n.lastUsedAt+v.minUseDelay>h||r.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=h,l)}));return await(0,u.firstParallel)(s,l=>!!l)}insert(d,o){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:o})}free(d){const o=this._terminalInstances.get(d);o&&(o.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}v.minUseDelay=1e3}),define(De[287],Ie([1,0,9,2,113,33,57,34,45,40,16,25,72,14,13,67,22,82,47]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends E.ExtHostTaskBase{constructor(v,a,d,o,i,s,l,n,r){super(v,a,d,o,i,s,l,n),this.workspaceService=d,this.variableResolver=r,a.remote.isRemote&&a.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:a.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(v,a){const d=a;if(!a.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const o=E.TaskHandleDTO.from(d,this.workspaceService),i=await this._proxy.$getTaskExecution(o);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(i,a);return this._proxy.$executeTask(o).catch(()=>{}),s}else{const o=E.TaskDTO.from(a,v);if(o===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(o.execution)&&await this.addCustomExecution(o,a,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(o),a);return this._proxy.$executeTask(o).catch(()=>{}),i}}provideTasksInternal(v,a,d,o){const i=[];if(o)for(const s of o){this.checkDeprecation(s,d),(!s.definition||!v[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const l=E.TaskDTO.from(s,d.extension);l&&(i.push(l),E.CustomExecutionDTO.is(l.execution)&&a.push(this.addCustomExecution(l,s,!0)))}return{tasks:i,extension:d.extension}}async resolveTaskInternal(v){return v}async getAFolder(v){let a=v&&v.length>0?v[0]:void 0;if(!a){const d=t.URI.file((0,m.homedir)());a=new S.WorkspaceFolder({uri:d,name:p.basename(d),index:0})}return{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(v,a){const d=t.URI.revive(v),o={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(d),s=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.variableResolver.getResolver(),n=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(s);for(const r of a.variables)o.variables[r]=await l.resolveAsync(n,r);if(a.process!==void 0){let r;if(a.process.path!==void 0){r=a.process.path.split(u.delimiter);for(let h=0;h<r.length;h++)r[h]=await l.resolveAsync(n,r[h])}o.process=await C.win32.findExecutable(await l.resolveAsync(n,a.process.name),a.process.cwd!==void 0?await l.resolveAsync(n,a.process.cwd):void 0,r)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(v,a,d){return C.win32.findExecutable(v,a,d)}};f=je([$e(0,A.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,I.IExtHostConfiguration),$e(5,D.IExtHostTerminalService),$e(6,_.ILogService),$e(7,g.IExtHostApiDeprecationService),$e(8,b.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(De[288],Ie([1,0,82,47]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class C extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=C}),define(De[140],Ie([1,0,17,18,21,50,14,9,22,2,30]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(b,f,c,v){this.query=b,this.provider=f,this.fileUtils=c,this.processType=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,f){const c=this.query.folderQueries||[],v=new C.CancellationTokenSource;return f.onCancellationRequested(()=>v.cancel()),new Promise((a,d)=>{this.collector=new T(b);let o=!1;const i=(s,l)=>{if(!o&&!this.isLimitHit){const n=this.resultSize(s);g(s)&&typeof this.query.maxResults=="number"&&this.resultCount+n>this.query.maxResults&&(this.isLimitHit=!0,o=!0,v.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const r=this.resultSize(s);this.resultCount+=r,(r>0||!g(s))&&this.collector.add(s,l)}};Promise.all(c.map((s,l)=>this.searchInFolder(s,n=>i(n,l),v.token))).then(s=>{v.dispose(),this.collector.flush();const l=s.some(n=>!!n&&!!n.limitHit);a({limitHit:this.isLimitHit||l,messages:(0,u.flatten)(s.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.processType}})},s=>{v.dispose();const l=(0,P.toErrorMessage)(s);d(new Error(l))})})}resultSize(b){return g(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,f){const c=Array.isArray(b.ranges)?b.ranges:[b.ranges],v=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:c.slice(0,f),preview:{matches:v.slice(0,f),text:b.preview.text},uri:b.uri}}async searchInFolder(b,f,c){const v=new A.QueryGlobTester(this.query,b),a=[],d={report:s=>{if(!this.validateProviderResult(s))return;const l=b.folder.scheme===y.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(s.uri))):void 0,n=S.relativePath(b.folder,s.uri);if(n){const r=v.includedInQuery(n,I.basename(n),l);(0,t.isThenable)(r)?a.push(r.then(h=>{h&&f(s)})):r&&f(s)}}},o=this.getSearchOptionsForFolder(b),i=await this.provider.provideTextSearchResults(E(this.query.contentPattern),o,d,c);return a.length&&await Promise.all(a),i}validateProviderResult(b){if(g(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const f=(0,A.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),c=(0,A.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),v={folder:D.URI.from(b.folder),excludes:c,includes:f,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return v.usePCRE2=this.query.usePCRE2,v}}e.TextSearchManager=k;function E(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class T{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,f=>this.sendItems(f))}add(b,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!S.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(_(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=T;function _(m){return g(m)?{preview:{matches:(0,u.mapArrayOrNot)(m.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:m.preview.text},ranges:(0,u.mapArrayOrNot)(m.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function g(m){return!!m.preview}e.extensionResultIsMatch=g;class p{constructor(b,f){this.maxBatchSize=b,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,f){!b||this.addItemToBatch(b,f)}addItems(b,f){!b||this.addItemsToBatch(b,f)}addItemToBatch(b,f){this.batch.push(b),this.batchSize+=f,this.onUpdate()}addItemsToBatch(b,f){this.batch=this.batch.concat(b),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(De[75],Ie([1,0,6,5,4,281,16,54,13,2,140]),function(J,e,u,t,C,P,y,I,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let k=class{constructor(g,p,m){this.extHostRpc=g,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,p){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(g)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(g,p){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(g)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(g,p,m,b){const f=E(m),c=this._fileSearchProvider.get(g);if(c)return this._fileSearchManager.fileSearch(f,c,v=>{this._proxy.$handleFileMatch(g,p,v.map(a=>a.resource))},b);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,p,m,b){const f=this._textSearchProvider.get(g);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const c=E(m);return this.createTextSearchManager(c,f).search(a=>this._proxy.$handleTextMatch(g,p,a),b)}$enableExtensionHostSearch(){}createTextSearchManager(g,p){return new A.TextSearchManager(g,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m},"textSearchProvider")}};k=je([$e(0,y.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,S.ILogService)],k),e.ExtHostSearch=k;function E(_){return{..._,folderQueries:_.folderQueries&&_.folderQueries.map(T),extraFileResources:_.extraFileResources&&_.extraFileResources.map(g=>D.URI.revive(g))}}e.reviveQuery=E;function T(_){return{..._,folder:D.URI.revive(_.folder)}}}),define(De[289],Ie([1,0,83,139,33,136,34,39,57,40,72,74,75,95,53,67,138,68,46,94,92,58,137,13,227,47,93]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c,v,a,d,o,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,u.registerSingleton)(d.ILoggerService,a.ExtHostLoggerService,1),(0,u.registerSingleton)(d.ILogService,o.ExtHostLogService,1),(0,u.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService,!1),(0,u.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands,!1),(0,u.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,u.registerSingleton)(m.IExtHostConsumerFileSystem,m.ExtHostConsumerFileSystem,!1),(0,u.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,!1),(0,u.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,u.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,!1),(0,u.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,!1),(0,u.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,u.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,!1),(0,u.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,u.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,!1),(0,u.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,!1),(0,u.registerSingleton)(_.IExtHostTunnelService,_.ExtHostTunnelService,!1),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow,!1),(0,u.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,!1),(0,u.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState,!1),(0,u.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,u.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,!1),(0,u.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,!1)}),define(De[96],Ie([1,0,17,13,30,71]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=y;function I(k,E,T,_){const g=(0,u.mapArrayOrNot)(T,S),p=new C.TextSearchMatch(E,g,_),m=p.preview.matches;return{ranges:(0,u.mapArrayOrNot)(g,D),uri:k,preview:{text:p.preview.text,matches:(0,u.mapArrayOrNot)(m,D)}}}e.createTextSearchResult=I;function S(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function D(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let A=class{constructor(E,T){this.prefix=E,this.logService=T}appendLine(E){this.logService.debug(`${this.prefix}#search`,E)}};A=je([$e(1,t.ILogService)],A),e.OutputChannel=A}),define(De[290],Ie([1,0,44,9,80,32,10,8,96,291]),function(J,e,u,t,C,P,y,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const A=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(f,c,v,a){const d=E(f,c,v,a),o=c.folder.fsPath;return{cmd:u.spawn(A,d.args,{cwd:o}),rgDiskPath:A,siblingClauses:d.siblingClauses,rgArgs:d,cwd:o}}e.spawnRipgrepCmd=k;function E(f,c,v,a){const d=["--files","--hidden","--case-sensitive"];_([c],v,!1).forEach(i=>{const s=(0,S.anchorGlob)(i);if(d.push("-g",s),y.isMacintosh){const l=(0,C.normalizeNFD)(s);l!==s&&d.push("-g",l)}});const o=T([c],a,void 0,!1);return o.globArgs.forEach(i=>{const s=`!${(0,S.anchorGlob)(i)}`;if(d.push("-g",s),y.isMacintosh){const l=(0,C.normalizeNFD)(s);l!==s&&d.push("-g",l)}}),c.disregardIgnoreFiles!==!1?d.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),c.ignoreSymlinks||d.push("--follow"),f.exists&&d.push("--quiet"),d.push("--no-config"),c.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:o.siblingClauses}}function T(f,c,v,a=!0){const d=[];let o={};return f.forEach(i=>{const s=Object.assign({},i.excludePattern||{},c||{}),l=g(s,a?i.folder.fsPath:void 0,v);d.push(...l.globArgs),l.siblingClauses&&(o=Object.assign(o,l.siblingClauses))}),{globArgs:d,siblingClauses:o}}e.foldersToRgExcludeGlobs=T;function _(f,c,v=!0){const a=[];return f.forEach(d=>{const o=Object.assign({},c||{},d.includePattern||{}),i=g(o,v?d.folder.fsPath:void 0);a.push(...i.globArgs)}),a}e.foldersToIncludeGlobs=_;function g(f,c,v){const a=[],d={};return Object.keys(f).forEach(o=>{if(v&&v.has(o)||!o)return;const i=f[o];o=m(c?p(c,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),a.push(b(o))):i&&i.when&&(d[o]=i)}),{globArgs:a,siblingClauses:d}}function p(f,c){return t.isAbsolute(c)?c:t.join(f,c)}e.getAbsoluteGlob=p;function m(f){return f=I.rtrim(f,"\\"),I.rtrim(f,"/")}function b(f){return P.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=b}),define(De[292],Ie([1,0,44,63,9,293,17,50,37,80,32,10,51,8,12,29,30,290,108]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(o=>o())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&S.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&S.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(s=>{const l=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),n=s.folder.fsPath;i.folderQueries.map(r=>r.folder.fsPath).filter(r=>r!==n).forEach(r=>{(0,A.isEqualOrParent)(r,n)&&(l[C.relative(n,r)]=!0)}),this.folderExcludePatterns.set(n,new a(l,n))})}cancel(){this.isCanceled=!0,f.forEach(i=>i())}walk(i,s,l,n,r){if(this.fileWalkSW=E.StopWatch.create(!1),this.isCanceled)return r(null,this.isLimitHit);s.forEach(h=>{const w=C.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,w)||this.matchFile(l,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=E.StopWatch.create(!1),this.parallel(i,(h,w)=>{this.call(this.cmdTraversal,this,h,l,n,L=>{if(L){const M=(0,I.toErrorMessage)(L);console.error(M),this.errors.push(M),w(L,void 0)}else w(null,void 0)})},(h,w)=>{this.fileWalkSW.stop();const L=h?y.coalesce(h)[0]:null;r(L,this.isLimitHit)})}parallel(i,s,l){const n=new Array(i.length),r=new Array(i.length);let h=!1,w=0;if(i.length===0)return l(null,[]);i.forEach((L,M)=>{s(L,(B,R)=>{if(B?(h=!0,n[M]=null,r[M]=B):(n[M]=R,r[M]=null),++w===i.length)return l(h?r:null,n)})})}call(i,s,...l){try{i.apply(s,l)}catch(n){l[l.length-1](n)}}cmdTraversal(i,s,l,n){const r=i.folder.fsPath,h=k.isMacintosh,w=()=>z&&z.kill();f.add(w);let L=U=>{f.delete(w),L=()=>{},n(U)},M="";const B=this.initDirectoryTree(),R=(0,m.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),z=R.cmd,H=!Object.keys(R.siblingClauses).length,N=R.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let V=`${R.rgDiskPath} ${N}
 - cwd: ${R.cwd}`;R.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(R.rgArgs.siblingClauses)}`),l({message:V}),this.cmdResultCount=0,this.collectStdout(z,"utf8",l,(U,F,x)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const Q=(M+(h?D.normalizeNFC(F||""):F)).split(`
`);if(x){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else M=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,H){for(const K of Q)if(this.matchFile(s,{base:r,relativePath:K,searchPath:this.getSearchPath(i,K)}),this.isLimitHit){w();break}(x||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,B,r,Q,s),x&&(this.matchDirectoryTree(B,r,s),L())})}spawnFindCmd(i){const s=this.folderExcludePatterns.get(i.folder.fsPath),l=s.getBasenameTerms(),n=s.getPathTerms(),r=["-L","."];if(l.length||n.length){r.push("-not","(","(");for(const h of l)r.push("-name",h),r.push("-o");for(const h of n)r.push("-path",h),r.push("-o");r.pop(),r.push(")","-prune",")")}return r.push("-type","f"),u.spawn("find",r,{cwd:i.folder.fsPath})}readStdout(i,s,l){let n="";this.collectStdout(i,s,()=>{},(r,h,w)=>{if(r){l(r);return}n+=h,w&&l(null,n)})}collectStdout(i,s,l,n){let r=(L,M,B)=>{(L||B)&&(r=()=>{},this.cmdSW?.stop()),n(L,M,B)},h=!1;i.stdout?(this.forwardData(i.stdout,s,r),i.stdout.once("data",()=>h=!0)):l({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):l({message:"stderr is null"}),i.on("error",L=>{r(L)}),i.on("close",L=>{let M;!h&&(M=this.decodeData(w,s))&&d(M)?r(new Error(`command failed with error code ${L}: ${this.decodeData(w,s)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),r(null,"",!0))})}forwardData(i,s,l){const n=new P.StringDecoder(s);return i.on("data",r=>{l(null,n.write(r))}),n}collectData(i){const s=[];return i.on("data",l=>{s.push(l)}),s}decodeData(i,s){const l=new P.StringDecoder(s);return i.map(n=>l.write(n)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:s},l,n,r){n.indexOf(this.filePattern)!==-1&&this.matchFile(r,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const h=w=>{const L=C.basename(w),M=C.dirname(w);let B=s[M];B||(B=s[M]=[],h(M)),B.push({base:l,relativePath:w,basename:L,searchPath:this.getSearchPath(i,w)})};n.forEach(h)}matchDirectoryTree({rootEntries:i,pathToEntries:s},l,n){const r=this,h=this.folderExcludePatterns.get(l),w=this.filePattern;function L(M){r.directoriesWalked++;const B=(0,p.hasSiblingFn)(()=>M.map(R=>R.basename));for(let R=0,z=M.length;R<z;R++){const H=M[R],{relativePath:N,basename:V}=H;if(h.test(N,V,w!==V?B:void 0))continue;const U=s[N];if(U)L(U);else{if(r.filesWalked++,N===w)continue;r.matchFile(n,H)}if(r.isLimitHit)break}}L(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,s,l,n,r){const h=i.folder,w=(0,p.hasSiblingFn)(()=>l);this.parallel(l,(L,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const B=s?[s,L].join(C.sep):L;if(this.folderExcludePatterns.get(i.folder.fsPath).test(B,L,this.config.filePattern!==L?w:void 0))return M(null);const R=[h.fsPath,B].join(C.sep);t.lstat(R,(z,H)=>{if(z||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(R,H,(N,V)=>N||this.isCanceled||this.isLimitHit?M(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(R,H,(U,F)=>U||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?M(null):(this.walkedPaths[F]=!0,g.Promises.readdir(R).then(x=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(i,B,x,n,$=>M($||null))},x=>{M(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&_.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(n,{base:h.fsPath,relativePath:B,searchPath:this.getSearchPath(i,B)}),M(null,void 0)))})},L=>{const M=L&&y.coalesce(L);return r(M&&M.length>0?M[0]:void 0)})}matchFile(i,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,C.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(s))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,p.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,s,l){return s.isSymbolicLink()?t.stat(i,l):l(null,s)}realPathIfNeeded(i,s,l){return s.isSymbolicLink()?t.realpath(i,(n,r)=>n?l(n):l(null,r)):l(null,i)}getSearchPath(i,s){return i.folderName?C.join(i.folderName,s):s}}e.FileWalker=c;class v{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,s,l){this.walker.walk(this.folderQueries,this.extraFiles,i,s,(n,r)=>{l(n,{limitHit:r,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class a{constructor(i,s){this.expression=i,this.root=s,this.init(i)}init(i){let s,l;Object.keys(i).filter(n=>i[n]).forEach(n=>{C.isAbsolute(n)?(s=s||S.getEmptyExpression(),s[n]=i[n]):(l=l||S.getEmptyExpression(),l[n]=i[n])}),this.absoluteParsedExpr=s&&S.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=l&&S.parse(l,{trimForExclusions:!0})}test(i,s,l){return this.relativeParsedExpr&&this.relativeParsedExpr(i,s,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,i),s,l)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getPathTerms(this.relativeParsedExpr)),i}}function d(o){const i=o.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return T.uppercaseFirstLetter(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=d}),define(De[294],Ie([1,0,99,23]),function(J,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===o)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,I=512*8,S=512*128;var D;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class A extends Error{constructor(i,s){super(i),this.decodeStreamErrorKind=s}}e.DecodeStreamError=A;class k{static async create(i){let s;if(i!==e.UTF8)s=(await new Promise((n,r)=>{J(["@vscode/iconv-lite-umd"],n,r)})).getDecoder(g(i));else{const l=new TextDecoder;s={write(n){return l.decode(n,{stream:!0})},end(){return l.decode()}}}return new k(s)}constructor(i){this.iconvLiteDecoder=i}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function E(o,i){const s=i.minBytesRequiredForDetection??i.guessEncoding?I:y;return new Promise((l,n)=>{const r=(0,u.newWriteableStream)(R=>R.join("")),h=[];let w=0,L,M;const B=async()=>{try{const R=await d({buffer:t.VSBuffer.concat(h),bytesRead:w},i.guessEncoding);if(R.seemsBinary&&i.acceptTextOnly)throw new A("Stream is binary but only text is accepted for decoding",1);R.encoding=await i.overwriteEncoding(R.encoding),L=await k.create(R.encoding);const z=L.write(t.VSBuffer.concat(h).buffer);r.write(z),h.length=0,w=0,l({stream:r,detected:R})}catch(R){M?.dispose(),r.destroy(),n(R)}};M=(0,u.listenStream)(o,{onData:async R=>{L?r.write(L.write(R.buffer)):(h.push(R),w+=R.byteLength,w>=s&&(o.pause(),await B(),setTimeout(()=>o.resume())))},onError:R=>r.error(R),onEnd:async()=>{L||await B(),r.end(L?.end())}})})}e.toDecodeStream=E;async function T(o,i,s){const n=(await new Promise((w,L)=>{J(["@vscode/iconv-lite-umd"],w,L)})).getEncoder(g(i),s);let r=!1,h=!1;return{read(){if(h)return null;const w=o.read();if(typeof w!="string"){if(h=!0,!r&&s?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=n.end();return L&&L.length>0?(r=!0,t.VSBuffer.wrap(L)):null}return r=!0,t.VSBuffer.wrap(n.write(w))}}}e.toEncodeReadable=T;async function _(o){return(await new Promise((s,l)=>{J(["@vscode/iconv-lite-umd"],s,l)})).encodingExists(g(o))}e.encodingExists=_;function g(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=g;function p(o,i){if(!o||i<e.UTF16be_BOM.length)return null;const s=o.readUInt8(0),l=o.readUInt8(1);if(s===e.UTF16be_BOM[0]&&l===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&l===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const n=o.readUInt8(2);return s===e.UTF8_BOM[0]&&l===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=p;const m=["ascii","utf-16","utf-32"];async function b(o){const i=await new Promise((h,w)=>{J(["jschardet"],h,w)}),s=o.slice(0,S),l=v(s.buffer),n=i.detect(l);if(!n||!n.encoding)return null;const r=n.encoding.toLowerCase();return 0<=m.indexOf(r)?null:c(n.encoding)}const f={ibm866:"cp866",big5:"cp950"};function c(o){const i=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[i]||i}function v(o){let i="";for(let s=0;s<o.length;s++)i+=String.fromCharCode(o[s]);return i}function a(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=o.match(/windows(\d+)/);return i?"windows-"+i[1]:o}}}e.toCanonicalName=a;function d({buffer:o,bytesRead:i},s){let l=p(o,i),n=!1;if(l!==e.UTF16be&&l!==e.UTF16le&&o){let r=!0,h=!0,w=!1;for(let L=0;L<i&&L<P;L++){const M=L%2===1,B=o.readUInt8(L)===0;if(B&&(w=!0),r&&(M&&!B||!M&&B)&&(r=!1),h&&(M&&B||!M&&!B)&&(h=!1),B&&!r&&!h)break}w&&(r?l=e.UTF16le:h?l=e.UTF16be:n=!0)}return s&&!n&&!l&&o?b(o.slice(0,i)).then(r=>({seemsBinary:!1,encoding:r})):{seemsBinary:n,encoding:l}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[141],Ie([1,0,294,29,140]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends C.TextSearchManager{constructor(I,S,D=t,A="searchProcess"){super(I,S,{readdir:k=>D.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,u.toCanonicalName)(k)},A)}}e.NativeTextSearchManager=P}),define(De[295],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(C){if(C&&this._dragOperations.has(C)){const P=this._dragOperations.get(C);return this._dragOperations.delete(C),P}}addDragOperationTransfer(C,P){this._dragOperations.set(C,P)}getRenderedTreeElement(C){if(this._renderedElements.has(C))return this._renderedElements.get(C)}addRenderedTreeItemElement(C,P){this._renderedElements.set(C,P)}removeRenderedTreeItemElement(C){this._renderedElements.has(C)&&this._renderedElements.delete(C)}}e.TreeviewsService=u}),define(De[296],Ie([1,0,175,7,22,2,3,6,18,7,12,17,15,21,295,28]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(f,c){if((0,A.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let v;return Array.isArray(f.highlights)&&(v=f.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),v=v.length?v:void 0),{label:f.label,highlights:v}}}class m{constructor(c,v,a){this._proxy=c,this.commands=v,this.logService=a,this.treeViews=new Map,this.treeDragAndDropService=new _.TreeviewsService;function d(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}v.registerArgumentProcessor({processArgument:o=>d(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(i=>d(i)?this.convertArgument(i):i):o})}registerTreeDataProvider(c,v,a){const d=this.createTreeView(c,{treeDataProvider:v},a);return{dispose:()=>d.dispose()}}createTreeView(c,v,a){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=v.dragAndDropController?.dropMimeTypes??[],o=v.dragAndDropController?.dragMimeTypes??[],i=!!v.dragAndDropController?.handleDrag,s=!!v.dragAndDropController?.handleDrop,l=this.createExtHostTreeView(c,v,a),n=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany,dropMimeTypes:d,dragMimeTypes:o,hasHandleDrag:i,hasHandleDrop:s});return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,g.checkProposedApiEnabled)(a,"treeItemCheckbox"),l.onDidChangeCheckboxState},get message(){return l.message},set message(r){l.message=r},get title(){return l.title},set title(r){l.title=r},get description(){return l.description},set description(r){l.description=r},get badge(){return l.badge},set badge(r){r!==void 0&&D.ViewBadge.isViewBadge(r)?l.badge={value:Math.floor(Math.abs(r.value)),tooltip:r.tooltip}:r===void 0&&(l.badge=void 0)},reveal:(r,h)=>l.reveal(r,h),dispose:async()=>{await n,this.treeViews.delete(c),l.dispose()}}}$getChildren(c,v){const a=this.treeViews.get(c);return a?a.getChildren(v):Promise.reject(new Error((0,u.localize)(0,null,c)))}async $handleDrop(c,v,a,d,o,i,s,l){const n=this.treeViews.get(c);if(!n)return Promise.reject(new Error((0,u.localize)(1,null,c)));const r=E.DataTransfer.toDataTransfer(a,async h=>(await this._proxy.$resolveDropFileData(c,v,h)).buffer);return s===c&&l&&await this.addAdditionalTransferItems(r,n,l,o,i),n.onDrop(r,d,o)}async addAdditionalTransferItems(c,v,a,d,o){const i=this.treeDragAndDropService.removeDragOperationTransfer(o);if(i)(await i)?.forEach((s,l)=>{s&&c.set(l,s)});else if(o&&v.handleDrag){const s=v.handleDrag(a,c,d);this.treeDragAndDropService.addDragOperationTransfer(o,s),await s}return c}async $handleDrag(c,v,a,d){const o=this.treeViews.get(c);if(!o)return Promise.reject(new Error((0,u.localize)(2,null,c)));const i=await this.addAdditionalTransferItems(new t.DataTransfer,o,v,d,a);if(!!i)return E.DataTransfer.toDataTransferDTO(i)}async $hasResolve(c){const v=this.treeViews.get(c);if(!v)throw new Error((0,u.localize)(3,null,c));return v.hasResolve}$resolve(c,v,a){const d=this.treeViews.get(c);if(!d)throw new Error((0,u.localize)(4,null,c));return d.resolveTreeItem(v,a)}$setExpanded(c,v,a){const d=this.treeViews.get(c);if(!d)throw new Error((0,u.localize)(5,null,c));d.setExpanded(v,a)}$setSelection(c,v){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(6,null,c));a.setSelection(v)}$setFocus(c,v){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(7,null,c));a.setFocus(v)}$setVisible(c,v){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(8,null,c));a.setVisible(v)}$changeCheckboxState(c,v){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(9,null,c));a.setCheckboxState(v)}createExtHostTreeView(c,v,a){const d=new b(c,v,this._proxy,this.commands.converter,this.logService,a);return this.treeViews.set(c,d),d}convertArgument(c){const v=this.treeViews.get(c.$treeViewId);return v&&"$treeItemHandle"in c?v.getExtensionElement(c.$treeItemHandle):v&&"$focusedTreeItem"in c&&c.$focusedTreeItem?v.focusedElement:null}}e.ExtHostTreeViews=m;class b extends I.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,A.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(c,v,a,d,o,i){if(super(),this.viewId=c,this.proxy=a,this.commands=d,this.logService=o,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,i.contributes&&i.contributes.views)for(const n in i.contributes.views)for(const r of i.contributes.views[n])r.id===c&&(this._title=r.name);this.dataProvider=v.treeDataProvider,this.dndController=v.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let s,l;this._register(y.Event.debounce(this._onDidChangeData.event,(n,r)=>(n||(n={message:!1,elements:[]}),r.element!==!1&&(s||(s=new Promise(h=>l=h),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(r.element)?n.elements.push(...r.element):n.elements.push(r.element)),r.message&&(n.message=!0),n),200,!0)(({message:n,elements:r})=>{r.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=l;return s=null,this.refresh(r).then(()=>h())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(c){const v=c?this.getExtensionElement(c):void 0;if(c&&!v)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let a=this.getChildrenNodes(c);return a||(a=await this.fetchChildrenNodes(v)),a?a.map(d=>d.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,v){v=v||{select:!0,focus:!1};const a=(0,A.isUndefinedOrNull)(v.select)?!0:v.select,d=(0,A.isUndefinedOrNull)(v.focus)?!1:v.focus,o=(0,A.isUndefinedOrNull)(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(i=>this.resolveTreeNode(c,i[i.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:i.map(l=>l.item)},{select:a,focus:d,expand:o})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:a,focus:d,expand:o})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=E.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,v){const a=this.getExtensionElement(c);a&&(v?this._onDidExpandElement.fire(Object.freeze({element:a})):this._onDidCollapseElement.fire(Object.freeze({element:a})))}setSelection(c){(0,k.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const v=(await Promise.all(c.map(async a=>{const d=this.getExtensionElement(a.treeItemHandle);return d?{extensionItem:d,treeItem:await this.dataProvider.getTreeItem(d),newState:a.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);v.forEach(a=>{a.treeItem.checkboxState=a.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:v.map(a=>[a.extensionItem,a.newState])})}async handleDrag(c,v,a){const d=[];for(const o of c){const i=this.getExtensionElement(o);i&&d.push(i)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,v,a),v}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,v,a){const d=v?this.getExtensionElement(v):void 0;if(!(!d&&v||!this.dndController?.handleDrop))return(0,S.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,c,a):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,v){if(!this.dataProvider.resolveTreeItem)return;const a=this.elements.get(c);if(a){const d=this.nodes.get(a);if(d){const o=await this.dataProvider.resolveTreeItem(d.extensionItem,a,v)??d.extensionItem;return this.validateTreeItem(o),d.item.tooltip=this.getTooltip(o.tooltip),d.item.command=this.getCommand(d.disposableStore,o.command),d.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(v=>v?this.resolveUnknownParentChain(v).then(a=>this.resolveTreeNode(v,a[a.length-1]).then(d=>(a.push(d),a))):Promise.resolve([]))}resolveParent(c){const v=this.nodes.get(c);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,v){const a=this.nodes.get(c);return a?Promise.resolve(a):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(d=>this.createHandle(c,d,v,!0)).then(d=>this.getChildren(v?v.item.handle:void 0).then(()=>{const o=this.getExtensionElement(d);if(o){const i=this.nodes.get(o);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(c){if(c){let v;if(typeof c=="string"){const a=this.getExtensionElement(c);v=a?this.nodes.get(a):void 0}else v=c;return v&&v.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const v=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const a=c?this.nodes.get(c):void 0,d=await this.dataProvider.getChildren(c);if(v.token.isCancellationRequested)return;const o=await Promise.all((0,k.coalesce)(d||[]).map(async i=>{const s=await this.dataProvider.getTreeItem(i);return s&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(i,s,a):null}));return v.token.isCancellationRequested?void 0:(0,k.coalesce)(o)}finally{v.dispose()}}refresh(c){if(c.some(a=>!a))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const a=this.getHandlesToRefresh(c);if(a.length)return this.refreshHandles(a)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const v=new Set,a=c.map(o=>this.nodes.get(o));for(const o of a)if(o&&!v.has(o.item.handle)){let i=o;for(;i&&i.parent&&a.findIndex(s=>i&&i.parent&&s&&s.item.handle===i.parent.item.handle)===-1;){const s=this.elements.get(i.parent.item.handle);i=s?this.nodes.get(s):void 0}i&&!i.parent&&v.add(o.item.handle)}const d=[];return v.forEach(o=>{const i=this.elements.get(o);if(i){const s=this.nodes.get(i);s&&(!s.parent||!v.has(s.parent.item.handle))&&d.push(o)}}),d}refreshHandles(c){const v={};return Promise.all(c.map(a=>this.refreshNode(a).then(d=>{d&&(v[a]=d.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(c){const v=this.getExtensionElement(c);if(v){const a=this.nodes.get(v);if(a)return this.clearChildren(v),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(d=>{if(d){const o=this.createTreeNode(v,d,a.parent);return this.updateNodeCache(v,o,a,a.parent),a.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,v,a){const d=this.createTreeNode(c,v,a);if(v.id&&this.elements.has(d.item.handle))throw new Error((0,u.localize)(10,null,v.id));return this.addNodeToCache(c,d),this.addNodeToParentCache(d,a),d}getTooltip(c){return D.MarkdownString.isMarkdownString(c)?E.MarkdownString.from(c):c}getCommand(c,v){return v?{...this.commands.toInternal(v,c),originalId:v.command}:void 0}getCheckbox(c){if(!c.checkboxState)return;let v,a;return typeof c.checkboxState=="number"?v=c.checkboxState:(v=c.checkboxState.state,a=c.checkboxState.tooltip),{isChecked:v===D.TreeItemCheckboxState.Checked,tooltip:a}}validateTreeItem(c){if(!D.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,v,a){this.validateTreeItem(v);const d=new I.DisposableStore,o=this.createHandle(c,v,a),i=this.getLightIconPath(v);return{item:{handle:o,parentHandle:a?a.item.handle:void 0,label:p(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(d,v.command),contextValue:v.contextValue,icon:i,iconDark:this.getDarkIconPath(v)||i,themeIcon:this.getThemeIcon(v),collapsibleState:(0,A.isUndefinedOrNull)(v.collapsibleState)?D.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation,checkbox:this.getCheckbox(v)},extensionItem:v,parent:a,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(c){return c.iconPath instanceof D.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:v,label:a,resourceUri:d},o,i){if(v)return`${b.ID_HANDLE_PREFIX}/${v}`;const s=p(a,this.extension),l=o?o.item.handle:b.LABEL_HANDLE_PREFIX;let n=s?s.label:d?(0,C.basename)(d):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const r=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,h=this.getChildrenNodes(o)||[];let w,L=0;do{if(w=`${l}/${L}:${n}`,i||!this.elements.has(w)||r===w)break;L++}while(L<=h.length);return w}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof D.ThemeIcon))return typeof c.iconPath=="string"||P.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof D.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return P.URI.isUri(c)?c:P.URI.file(c)}addNodeToCache(c,v){this.elements.set(v.item.handle,c),this.nodes.set(c,v)}updateNodeCache(c,v,a,d){this.elements.delete(v.item.handle),this.nodes.delete(c),v.item.handle!==a.item.handle&&this.elements.delete(a.item.handle),this.addNodeToCache(c,v);const o=this.getChildrenNodes(d)||[],i=o.filter(s=>s.item.handle===a.item.handle)[0];i&&o.splice(o.indexOf(i),1,v)}addNodeToParentCache(c,v){v?(v.children||(v.children=[]),v.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const v=this.nodes.get(c);if(v){if(v.children)for(const a of v.children){const d=this.elements.get(a.item.handle);d&&this.clear(d)}v.children=void 0}}else this.clearAll()}clear(c){const v=this.nodes.get(c);if(v){if(v.children)for(const a of v.children){const d=this.elements.get(a.item.handle);d&&this.clear(d)}this.nodes.delete(c),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(De[297],Ie([1,0,21,11,3,42,2,118,103,148,158,38,5,91,241,240,39,242,34,244,245,246,229,247,57,41,248,249,252,253,254,139,232,258,259,260,95,40,262,296,15,7,265,70,138,33,212,251,85,136,72,74,75,13,54,16,25,255,228,53,67,238,263,69,68,268,266,267,239,46,261,264,94,58,92,256,71,257,14,122,231,208,250,6,28,213,93]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c,v,a,d,o,i,s,l,n,r,h,w,L,M,B,R,z,H,N,V,U,F,x,$,Q,K,de,ee,he,Y,me,be,ke,Re,ze,oe,le,ge,Z,ae,ne,ie,O,j,G,X,pe,we,ce,Ce,ye,We,qe,Ze,Ye,Ne,at,re,se,Ee,Ve,fe,Ae,Le,Me,Ke,Je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function st(ot){const it=ot.get(le.IExtHostInitDataService),lt=ot.get(Ce.IExtHostFileSystemInfo),vt=ot.get(G.IExtHostConsumerFileSystem),wt=ot.get(i.IExtHostExtensionService),ft=ot.get(K.IExtHostWorkspace),Et=ot.get(Ye.IExtHostTelemetry),Ft=ot.get(b.IExtHostConfiguration),Mt=ot.get(ze.IURITransformerService),Qe=ot.get(oe.IExtHostRpcService),zt=ot.get(z.IExtHostStorage),Ot=ot.get(j.IExtensionStoragePaths),Pt=ot.get(Re.ILoggerService),gt=ot.get(Re.ILogService),kt=ot.get(ae.IExtHostTunnelService),Pe=ot.get(ne.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),_e=ot.get(qe.IExtHostSecretState),te=ot.get(Ze.IExtHostEditorTabs);Qe.set(E.ExtHostContext.ExtHostFileSystemInfo,lt),Qe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Pt),Qe.set(E.ExtHostContext.ExtHostWorkspace,ft),Qe.set(E.ExtHostContext.ExtHostConfiguration,Ft),Qe.set(E.ExtHostContext.ExtHostExtensionService,wt),Qe.set(E.ExtHostContext.ExtHostStorage,zt),Qe.set(E.ExtHostContext.ExtHostTunnelService,kt),Qe.set(E.ExtHostContext.ExtHostWindow,Oe),Qe.set(E.ExtHostContext.ExtHostSecretState,_e),Qe.set(E.ExtHostContext.ExtHostTelemetry,Et),Qe.set(E.ExtHostContext.ExtHostEditorTabs,te);const Fe=Qe.set(E.ExtHostContext.ExtHostDecorations,ot.get(Y.IExtHostDecorations)),xe=Qe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(o.IExtHostDocumentsAndEditors)),nt=Qe.set(E.ExtHostContext.ExtHostCommands,ot.get(p.IExtHostCommands)),Ge=Qe.set(E.ExtHostContext.ExtHostTerminalService,ot.get(H.IExtHostTerminalService)),rt=Qe.set(E.ExtHostContext.ExtHostDebugService,ot.get(be.IExtHostDebugService)),pt=Qe.set(E.ExtHostContext.ExtHostSearch,ot.get(ke.IExtHostSearch)),St=Qe.set(E.ExtHostContext.ExtHostTask,ot.get(me.IExtHostTask)),Tt=Qe.set(E.ExtHostContext.ExtHostOutputService,ot.get(w.IExtHostOutputService)),It=Qe.set(E.ExtHostContext.ExtHostLocalization,ot.get(Je.IExtHostLocalizationService)),_t=Qe.set(E.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(Qe)),bt=Qe.set(E.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Qe,xe)),Ct=Qe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Qe,xe,gt)),en=Qe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(gt,bt,Qe.getProxy(E.MainContext.MainThreadBulkEdits))),yt=Qe.set(E.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(Qe,nt,xe,bt)),qt=Qe.set(E.ExtHostContext.ExtHostNotebookDocuments,new fe.ExtHostNotebookDocuments(yt)),Ht=Qe.set(E.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(gt,yt)),tn=Qe.set(E.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(Qe,it,yt,nt,gt)),un=Qe.set(E.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Qe,yt)),At=Qe.set(E.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Qe,xe)),nn=Qe.set(E.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(Qe.getProxy(E.MainContext.MainThreadTreeViews),nt,gt)),dn=Qe.set(E.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Qe.getProxy(E.MainContext.MainThreadEditorInsets),At,it.remote)),Ut=Qe.set(E.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Qe,gt,lt)),Jt=Qe.set(E.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Qe,bt,nt.converter,Mt)),dt=Qe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Qe,Mt,bt,nt,Ut,gt,Pe,Et)),hn=Qe.set(E.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Qe,dt)),Nt=Qe.set(E.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(Qe,gt,xe)),Gt=Qe.set(E.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Qe,ft,nt)),rn=Qe.set(E.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(Qe,nt,gt)),fn=Qe.set(E.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Qe,nt,bt)),sn=Qe.set(E.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Qe.getProxy(E.MainContext.MainThreadProgress))),mn=Qe.set(E.ExtHostContext.ExtHosLabelService,new ee.ExtHostLabelService(Qe)),on=Qe.set(E.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Qe)),Zt=Qe.set(E.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Qe)),gn=Qe.set(E.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Qe,nt)),pn=Qe.set(E.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(Qe,it.remote,ft,gt,Pe)),vn=Qe.set(E.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Qe,pn,ft)),bn=Qe.set(E.ExtHostContext.ExtHostCustomEditors,new pe.ExtHostCustomEditors(Qe,bt,Ot,pn,vn)),wn=Qe.set(E.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Qe,pn)),Kt=Qe.set(E.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Qe,nt,xe)),En=Qe.set(E.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Qe));Qe.set(E.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Qe,yt,xe,nt,gt));const Fn=Object.values(E.ExtHostContext);Qe.assertRegistered(Fn);const Sn=new ce.ExtHostBulkEdits(Qe,xe),_n=new g.ExtHostClipboard(Qe),yn=new h.ExtHostMessageService(Qe,gt),Tn=new c.ExtHostDialogs(Qe),Pn=new R.ExtHostStatusBar(Qe,nt.converter);return _.ExtHostApiCommands.register(nt),function(He,xt,An){const mt=function(){let ve=!He.isUnderDevelopment;function Se(){ve||(gt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Se();else{const Dt=ct;typeof Dt.scheme>"u"&&Se(),typeof Dt.exclusive=="boolean"&&(0,Me.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return ct}}(),Cn={getSession(ve,Se,Ue){return Zt.getSession(He,ve,Se,Ue)},async hasSession(ve,Se){return(0,Me.checkProposedApiEnabled)(He,"authSession"),!!await Zt.getSession(He,ve,Se,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ve,Se,Ue,ct){return Zt.registerAuthenticationProvider(ve,Se,Ue,ct)}},Mn={registerCommand(ve,Se,Ue){return nt.registerCommand(!0,ve,Se,Ue,void 0,He)},registerTextEditorCommand(ve,Se,Ue){return nt.registerCommand(!0,ve,(...ct)=>{const Dt=At.getActiveTextEditor();if(!Dt){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}return Dt.edit(Rt=>{Se.apply(Ue,[Dt,Rt,...ct])}).then(Rt=>{Rt||gt.warn("Edits from command "+ve+" were not applied.")},Rt=>{gt.warn("An error occurred while running command "+ve,Rt)})},void 0,void 0,He)},registerDiffInformationCommand:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"diffCommand"),nt.registerCommand(!0,ve,async(...ct)=>{const Dt=xe.activeEditor(!0);if(!Dt){gt.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);Se.apply(Ue,[Rt,...ct])},void 0,void 0,He)),executeCommand(ve,...Se){return nt.executeCommand(ve,...Se)},getCommands(ve=!1){return nt.getCommands(ve)}},Rn={get machineId(){return it.telemetryInfo.machineId},get sessionId(){return it.telemetryInfo.sessionId},get language(){return it.environment.appLanguage},get appName(){return it.environment.appName},get appRoot(){return it.environment.appRoot?.fsPath??""},get appHost(){return it.environment.appHost},get uriScheme(){return it.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return Ge.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.checkProposedApiEnabled)(He,"envShellEvent"),Ge.onDidChangeShell},get isTelemetryEnabled(){return Et.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Et.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Et.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Et.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.isNewAppInstall)(it.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Et.instantiateLogger(He,ve)},openExternal(ve,Se){return Oe.openUri(ve,{allowTunneling:!!it.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===it.environment.appUriScheme)return _t.createAppUri(ve);try{return await Oe.asExternalUri(ve,{allowTunneling:!!it.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(ve,se.Schemas.http)||(0,Ee.matchesScheme)(ve,se.Schemas.https))return ve;throw Se}},get remoteName(){return(0,he.getRemoteName)(it.remote.authority)},get remoteAuthority(){return(0,Me.checkProposedApiEnabled)(He,"resolvers"),it.remote.authority},get uiKind(){return it.uiKind},get logLevel(){return(0,Me.checkProposedApiEnabled)(He,"extensionLog"),gt.getLevel()},get onDidChangeLogLevel(){return(0,Me.checkProposedApiEnabled)(He,"extensionLog"),gt.onDidChangeLogLevel}};it.environment.extensionTestsLocationURI||Object.freeze(Rn);const Un={createTestController(ve,Se,Ue){return Kt.createTestController(ve,Se,Ue)},createTestObserver(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.createTestObserver()},runTests(ve){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.runTests(ve)},get onDidChangeTestResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Kt.results}},Xt=it.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Bn={getExtension(ve,Se){(0,Me.isProposedApiEnabled)(He,"extensionsAny")||(Se=!1);const Ue=xt.mine.getExtensionDescription(ve);if(Ue)return new i.Extension(wt,He.identifier,Ue,Xt,!1);if(Se){const ct=xt.all.getExtensionDescription(ve);if(ct)return new i.Extension(wt,He.identifier,ct,Xt,!0)}},get all(){const ve=[];for(const Se of xt.mine.getAllExtensionDescriptions())ve.push(new i.Extension(wt,He.identifier,Se,Xt,!1));return ve},get allAcrossExtensionHosts(){(0,Me.checkProposedApiEnabled)(He,"extensionsAny");const ve=new Me.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of xt.all.getAllExtensionDescriptions()){const ct=!ve.has(Ue.identifier);Se.push(new i.Extension(wt,He.identifier,Ue,Xt,ct))}return Se},get onDidChange(){return(0,Me.isProposedApiEnabled)(He,"extensionsAny")?C.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},zn={createDiagnosticCollection(ve){return Ut.createDiagnosticCollection(He.identifier,ve)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:ve=>Ut.getDiagnostics(ve),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(ve,Se){return Jt.changeLanguage(ve.uri,Se)},match(ve,Se){const Ue=bt.getDocumentData(Se.uri)?.notebook;return(0,A.score)(U.LanguageSelector.from(ve),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(ve,Se,Ue){return dt.registerCodeActionProvider(He,mt(ve),Se,Ue)},registerDocumentPasteEditProvider(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,mt(ve),Se,Ue)},registerCodeLensProvider(ve,Se){return dt.registerCodeLensProvider(He,mt(ve),Se)},registerDefinitionProvider(ve,Se){return dt.registerDefinitionProvider(He,mt(ve),Se)},registerDeclarationProvider(ve,Se){return dt.registerDeclarationProvider(He,mt(ve),Se)},registerImplementationProvider(ve,Se){return dt.registerImplementationProvider(He,mt(ve),Se)},registerTypeDefinitionProvider(ve,Se){return dt.registerTypeDefinitionProvider(He,mt(ve),Se)},registerHoverProvider(ve,Se){return dt.registerHoverProvider(He,mt(ve),Se,He.identifier)},registerEvaluatableExpressionProvider(ve,Se){return dt.registerEvaluatableExpressionProvider(He,mt(ve),Se,He.identifier)},registerInlineValuesProvider(ve,Se){return dt.registerInlineValuesProvider(He,mt(ve),Se,He.identifier)},registerDocumentHighlightProvider(ve,Se){return dt.registerDocumentHighlightProvider(He,mt(ve),Se)},registerLinkedEditingRangeProvider(ve,Se){return dt.registerLinkedEditingRangeProvider(He,mt(ve),Se)},registerReferenceProvider(ve,Se){return dt.registerReferenceProvider(He,mt(ve),Se)},registerRenameProvider(ve,Se){return dt.registerRenameProvider(He,mt(ve),Se)},registerDocumentSymbolProvider(ve,Se,Ue){return dt.registerDocumentSymbolProvider(He,mt(ve),Se,Ue)},registerWorkspaceSymbolProvider(ve){return dt.registerWorkspaceSymbolProvider(He,ve)},registerDocumentFormattingEditProvider(ve,Se){return dt.registerDocumentFormattingEditProvider(He,mt(ve),Se)},registerDocumentRangeFormattingEditProvider(ve,Se){return dt.registerDocumentRangeFormattingEditProvider(He,mt(ve),Se)},registerOnTypeFormattingEditProvider(ve,Se,Ue,...ct){return dt.registerOnTypeFormattingEditProvider(He,mt(ve),Se,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentSemanticTokensProvider(He,mt(ve),Se,Ue)},registerDocumentRangeSemanticTokensProvider(ve,Se,Ue){return dt.registerDocumentRangeSemanticTokensProvider(He,mt(ve),Se,Ue)},registerSignatureHelpProvider(ve,Se,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider(He,mt(ve),Se,Ue):dt.registerSignatureHelpProvider(He,mt(ve),Se,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(ve,Se,...Ue){return dt.registerCompletionItemProvider(He,mt(ve),Se,Ue)},registerInlineCompletionItemProvider(ve,Se){return Se.handleDidShowCompletionItem&&(0,Me.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,mt(ve),Se)},registerInlineCompletionItemProviderNew(ve,Se){if((0,Me.checkProposedApiEnabled)(He,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,Me.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,mt(ve),Se)},registerDocumentLinkProvider(ve,Se){return dt.registerDocumentLinkProvider(He,mt(ve),Se)},registerColorProvider(ve,Se){return dt.registerColorProvider(He,mt(ve),Se)},registerFoldingRangeProvider(ve,Se){return dt.registerFoldingRangeProvider(He,mt(ve),Se)},registerSelectionRangeProvider(ve,Se){return dt.registerSelectionRangeProvider(He,ve,Se)},registerCallHierarchyProvider(ve,Se){return dt.registerCallHierarchyProvider(He,ve,Se)},registerTypeHierarchyProvider(ve,Se){return dt.registerTypeHierarchyProvider(He,ve,Se)},setLanguageConfiguration:(ve,Se)=>dt.setLanguageConfiguration(He,ve,Se),getTokenInformationAtPosition(ve,Se){return(0,Me.checkProposedApiEnabled)(He,"tokenInformation"),Jt.tokenAtPosition(ve,Se)},registerInlayHintsProvider(ve,Se){return dt.registerInlayHintsProvider(He,ve,Se)},createLanguageStatusItem(ve,Se){return Jt.createLanguageStatusItem(He,ve,Se)},registerDocumentDropEditProvider(ve,Se){return dt.registerDocumentOnDropEditProvider(He,ve,Se)}},Wn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ge.activeTerminal},get terminals(){return Ge.terminals},async showTextDocument(ve,Se,Ue){const ct=await(y.URI.isUri(ve)?Promise.resolve(Ln.openTextDocument(ve)):Promise.resolve(ve));return At.showTextDocument(ct,Se,Ue)},createTextEditorDecorationType(ve){return At.createTextEditorDecorationType(He,ve)},onDidChangeActiveTextEditor(ve,Se,Ue){return At.onDidChangeActiveTextEditor(ve,Se,Ue)},onDidChangeVisibleTextEditors(ve,Se,Ue){return At.onDidChangeVisibleTextEditors(ve,Se,Ue)},onDidChangeTextEditorSelection(ve,Se,Ue){return At.onDidChangeTextEditorSelection(ve,Se,Ue)},onDidChangeTextEditorOptions(ve,Se,Ue){return At.onDidChangeTextEditorOptions(ve,Se,Ue)},onDidChangeTextEditorVisibleRanges(ve,Se,Ue){return At.onDidChangeTextEditorVisibleRanges(ve,Se,Ue)},onDidChangeTextEditorViewColumn(ve,Se,Ue){return At.onDidChangeTextEditorViewColumn(ve,Se,Ue)},onDidCloseTerminal(ve,Se,Ue){return Ge.onDidCloseTerminal(ve,Se,Ue)},onDidOpenTerminal(ve,Se,Ue){return Ge.onDidOpenTerminal(ve,Se,Ue)},onDidChangeActiveTerminal(ve,Se,Ue){return Ge.onDidChangeActiveTerminal(ve,Se,Ue)},onDidChangeTerminalDimensions(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDimensions"),Ge.onDidChangeTerminalDimensions(ve,Se,Ue)},onDidChangeTerminalState(ve,Se,Ue){return Ge.onDidChangeTerminalState(ve,Se,Ue)},onDidWriteTerminalData(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ge.onDidWriteTerminalData(ve,Se,Ue)},get state(){return Oe.state},onDidChangeWindowState(ve,Se,Ue){return Oe.onDidChangeWindowState(ve,Se,Ue)},showInformationMessage(ve,...Se){return yn.showMessage(He,P.default.Info,ve,Se[0],Se.slice(1))},showWarningMessage(ve,...Se){return yn.showMessage(He,P.default.Warning,ve,Se[0],Se.slice(1))},showErrorMessage(ve,...Se){return yn.showMessage(He,P.default.Error,ve,Se[0],Se.slice(1))},showQuickPick(ve,Se,Ue){return Gt.showQuickPick(ve,Se,Ue)},showWorkspaceFolderPick(ve){return Gt.showWorkspaceFolderPick(ve)},showInputBox(ve,Se){return Gt.showInput(ve,Se)},showOpenDialog(ve){return Tn.showOpenDialog(ve)},showSaveDialog(ve){return Tn.showSaveDialog(ve)},createStatusBarItem(ve,Se,Ue){let ct,Dt,Rt;return typeof ve=="string"?(ct=ve,Dt=Se,Rt=Ue):(Dt=ve,Rt=Se),Pn.createStatusBarEntry(He,ct,Dt,Rt)},setStatusBarMessage(ve,Se){return Pn.setStatusBarMessage(ve,Se)},withScmProgress(ve){return Pe.report("window.withScmProgress",He,"Use 'withProgress' instead."),sn.withProgress(He,{location:F.ProgressLocation.SourceControl},(Se,Ue)=>ve({report(ct){}}))},withProgress(ve,Se){return sn.withProgress(He,ve,Se)},createOutputChannel(ve,Se){return Tt.createOutputChannel(ve,Se,He)},createWebviewPanel(ve,Se,Ue,ct){return vn.createWebviewPanel(He,ve,Se,Ue,ct)},createWebviewTextEditorInset(ve,Se,Ue,ct){return(0,Me.checkProposedApiEnabled)(He,"editorInsets"),dn.createWebviewEditorInset(ve,Se,Ue,ct,He)},createTerminal(ve,Se,Ue){return typeof ve=="object"?"pty"in ve?Ge.createExtensionTerminal(ve):Ge.createTerminalFromOptions(ve):Ge.createTerminal(ve,Se,Ue)},registerTerminalLinkProvider(ve){return Ge.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,Se){return Ge.registerProfileProvider(He,ve,Se)},registerTreeDataProvider(ve,Se){return nn.registerTreeDataProvider(ve,Se,He)},createTreeView(ve,Se){return nn.createTreeView(ve,Se,He)},registerWebviewPanelSerializer:(ve,Se)=>vn.registerWebviewPanelSerializer(He,ve,Se),registerCustomEditorProvider:(ve,Se,Ue={})=>bn.registerCustomEditorProvider(He,ve,Se,Ue),registerFileDecorationProvider(ve){return Fe.registerFileDecorationProvider(ve,He.identifier)},registerUriHandler(ve){return _t.registerUriHandler(He.identifier,ve)},createQuickPick(){return Gt.createQuickPick(He)},createInputBox(){return Gt.createInputBox(He)},get activeColorTheme(){return on.activeColorTheme},onDidChangeActiveColorTheme(ve,Se,Ue){return on.onDidChangeActiveColorTheme(ve,Se,Ue)},registerWebviewViewProvider(ve,Se,Ue){return wn.registerWebviewViewProvider(He,ve,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,Se,Ue){return yt.onDidChangeActiveNotebookEditor(ve,Se,Ue)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,Se,Ue){return Ht.onDidChangeNotebookEditorSelection(ve,Se,Ue)},onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue){return Ht.onDidChangeNotebookEditorVisibleRanges(ve,Se,Ue)},showNotebookDocument(ve,Se){return y.URI.isUri(ve)&&Pe.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),yt.showNotebookDocument(ve,Se)},registerExternalUriOpener(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"externalUriOpener"),En.registerExternalUriOpener(He.identifier,ve,Se,Ue)},get tabGroups(){return te.tabGroups}},Ln={get rootPath(){return Pe.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ve){throw t.readonly()},getWorkspaceFolder(ve){return ft.getWorkspaceFolder(ve)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ve){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ve){throw t.readonly()},updateWorkspaceFolders:(ve,Se,...Ue)=>ft.updateWorkspaceFolders(He,ve,Se||0,...Ue),onDidChangeWorkspaceFolders:function(ve,Se,Ue){return ft.onDidChangeWorkspace(ve,Se,Ue)},asRelativePath:(ve,Se)=>ft.getRelativePath(ve,Se),findFiles:(ve,Se,Ue,ct)=>ft.findFiles(ve,Se,Ue,He.identifier,ct),findTextInFiles:(ve,Se,Ue,ct)=>{(0,Me.checkProposedApiEnabled)(He,"findTextInFiles");let Dt,Rt;return typeof Se=="object"?(Dt=Se,Rt=Ue):(Dt={},Rt=Se,ct=Ue),ft.findTextInFiles(ve,Dt||{},Rt,He.identifier,ct)},saveAll:ve=>ft.saveAll(ve),applyEdit(ve,Se){return Sn.applyWorkspaceEdit(ve,He,Se)},createFileSystemWatcher:(ve,Se,Ue,ct)=>Nt.createFileSystemWatcher(ft,He,ve,Se,Ue,ct),get textDocuments(){return bt.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw t.readonly()},openTextDocument(ve){let Se;const Ue=ve;if(typeof ve=="string")Se=Promise.resolve(y.URI.file(ve));else if(y.URI.isUri(ve))Se=Promise.resolve(ve);else if(!Ue||typeof Ue=="object")Se=bt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ct=>bt.ensureDocumentData(ct).then(Dt=>Dt.document))},onDidOpenTextDocument:(ve,Se,Ue)=>bt.onDidAddDocument(ve,Se,Ue),onDidCloseTextDocument:(ve,Se,Ue)=>bt.onDidRemoveDocument(ve,Se,Ue),onDidChangeTextDocument:(ve,Se,Ue)=>bt.onDidChangeDocument(ve,Se,Ue),onDidSaveTextDocument:(ve,Se,Ue)=>bt.onDidSaveDocument(ve,Se,Ue),onWillSaveTextDocument:(ve,Se,Ue)=>en.getOnWillSaveTextDocumentEvent(He)(ve,Se,Ue),get notebookDocuments(){return yt.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,Se){let Ue;if(y.URI.isUri(ve))Ue=ve,await yt.openNotebookDocument(ve);else if(typeof ve=="string")Ue=y.URI.revive(await yt.createNotebookDocument({viewType:ve,content:Se}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ve,Se,Ue){return qt.onDidSaveNotebookDocument(ve,Se,Ue)},onDidChangeNotebookDocument(ve,Se,Ue){return qt.onDidChangeNotebookDocument(ve,Se,Ue)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ve,Se,Ue,ct){return yt.registerNotebookSerializer(He,ve,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(ve,Se,Ue,ct)=>((0,Me.checkProposedApiEnabled)(He,"notebookContentProvider"),Pe.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),yt.registerNotebookContentProvider(He,ve,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(ve,Se,Ue)=>An.onDidChangeConfiguration(ve,Se,Ue),getConfiguration(ve,Se){return Se=arguments.length===1?void 0:Se,An.getConfiguration(ve,Se,He)},registerTextDocumentContentProvider(ve,Se){return Ct.registerTextDocumentContentProvider(ve,Se)},registerTaskProvider:(ve,Se)=>(Pe.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(He,ve,Se)),registerFileSystemProvider(ve,Se,Ue){return(0,Le.combinedDisposable)(hn.registerFileSystemProvider(He,ve,Se,Ue),vt.addFileSystemProvider(ve,Se))},get fs(){return vt.value},registerFileSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"fileSearchProvider"),pt.registerFileSearchProvider(ve,Se)),registerTextSearchProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"textSearchProvider"),pt.registerTextSearchProvider(ve,Se)),registerRemoteAuthorityResolver:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),wt.registerRemoteAuthorityResolver(ve,Se)),registerResourceLabelFormatter:ve=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),mn.$registerResourceLabelFormatter(ve)),onDidCreateFiles:(ve,Se,Ue)=>Nt.onDidCreateFile(ve,Se,Ue),onDidDeleteFiles:(ve,Se,Ue)=>Nt.onDidDeleteFile(ve,Se,Ue),onDidRenameFiles:(ve,Se,Ue)=>Nt.onDidRenameFile(ve,Se,Ue),onWillCreateFiles:(ve,Se,Ue)=>Nt.getOnWillCreateFileEvent(He)(ve,Se,Ue),onWillDeleteFiles:(ve,Se,Ue)=>Nt.getOnWillDeleteFileEvent(He)(ve,Se,Ue),onWillRenameFiles:(ve,Se,Ue)=>Nt.getOnWillRenameFileEvent(He)(ve,Se,Ue),openTunnel:ve=>((0,Me.checkProposedApiEnabled)(He,"tunnels"),kt.openTunnel(He,ve).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Me.checkProposedApiEnabled)(He,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ve,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"tunnels"),kt.onDidChangeTunnels(ve,Se,Ue)),registerPortAttributesProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"portsAttributes"),kt.registerPortsAttributesProvider(ve,Se)),registerTimelineProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"timeline"),gn.registerTimelineProvider(ve,Se,He.identifier,nt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ve=>((0,Me.checkProposedApiEnabled)(He,"workspaceTrust"),ft.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,Se,Ue)=>ft.onDidGrantWorkspaceTrust(ve,Se,Ue),registerEditSessionIdentityProvider:(ve,Se)=>((0,Me.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ve,Se))},Dn={get inputBox(){return Pe.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),rn.getLastInputBox(He)},createSourceControl(ve,Se,Ue){return rn.createSourceControl(He,ve,Se,Ue)}},Hn={createCommentController(ve,Se){return fn.createCommentController(He,ve,Se)}},Vt={get activeDebugSession(){return rt.activeDebugSession},get activeDebugConsole(){return rt.activeDebugConsole},get breakpoints(){return rt.breakpoints},onDidStartDebugSession(ve,Se,Ue){return rt.onDidStartDebugSession(ve,Se,Ue)},onDidTerminateDebugSession(ve,Se,Ue){return rt.onDidTerminateDebugSession(ve,Se,Ue)},onDidChangeActiveDebugSession(ve,Se,Ue){return rt.onDidChangeActiveDebugSession(ve,Se,Ue)},onDidReceiveDebugSessionCustomEvent(ve,Se,Ue){return rt.onDidReceiveDebugSessionCustomEvent(ve,Se,Ue)},onDidChangeBreakpoints(ve,Se,Ue){return rt.onDidChangeBreakpoints(ve,Se,Ue)},registerDebugConfigurationProvider(ve,Se,Ue){return rt.registerDebugConfigurationProvider(ve,Se,Ue||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,Se){return rt.registerDebugAdapterDescriptorFactory(He,ve,Se)},registerDebugAdapterTrackerFactory(ve,Se){return rt.registerDebugAdapterTrackerFactory(ve,Se)},startDebugging(ve,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?rt.startDebugging(ve,Se,{parentSession:Ue}):rt.startDebugging(ve,Se,Ue||{})},stopDebugging(ve){return rt.stopDebugging(ve)},addBreakpoints(ve){return rt.addBreakpoints(ve)},removeBreakpoints(ve){return rt.removeBreakpoints(ve)},asDebugSourceUri(ve,Se){return rt.asDebugSourceUri(ve,Se)}},an={registerTaskProvider:(ve,Se)=>St.registerTaskProvider(He,ve,Se),fetchTasks:ve=>St.fetchTasks(ve),executeTask:ve=>St.executeTask(He,ve),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ve,Se,Ue)=>St.onDidStartTask(ve,Se,Ue),onDidEndTask:(ve,Se,Ue)=>St.onDidEndTask(ve,Se,Ue),onDidStartTaskProcess:(ve,Se,Ue)=>St.onDidStartTaskProcess(ve,Se,Ue),onDidEndTaskProcess:(ve,Se,Ue)=>St.onDidEndTaskProcess(ve,Se,Ue)},$n={createNotebookController(ve,Se,Ue,ct,Dt){return tn.createNotebookController(He,ve,Se,Ue,ct,(0,Me.isProposedApiEnabled)(He,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ve,Se)=>yt.registerNotebookCellStatusBarItemProvider(He,ve,Se),createRendererMessaging(ve){return un.createRendererMessaging(He,ve)},onDidChangeNotebookCellExecutionState(ve,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"notebookCellExecutionState"),tn.onDidChangeNotebookCellExecutionState(ve,Se,Ue)}},Bt={t(...ve){if(typeof ve[0]=="string"){const Se=ve.shift(),Ue=!ve||typeof ve[0]!="object"?ve:ve[0];return It.getMessage(He.identifier.value,{message:Se,args:Ue})}return It.getMessage(He.identifier.value,ve[0])},get bundle(){return It.getBundle(He.identifier.value)},get uri(){return It.getBundleUri(He.identifier.value)}};return{version:it.version,authentication:Cn,commands:Mn,comments:Hn,debug:Vt,env:Rn,extensions:Bn,l10n:Bt,languages:zn,notebooks:$n,scm:Dn,tasks:an,tests:Un,window:Wn,workspace:Ln,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:C.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestionList,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:D.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,SnippetTextEdit:F.SnippetTextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItem2:F.TreeItem,TreeItemCheckboxState:F.TreeItemCheckboxState,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:T.UIKind,Uri:y.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,DocumentDropEdit:F.DocumentDropEdit,DocumentPasteEdit:F.DocumentPasteEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,NotebookControllerAffinity2:F.NotebookControllerAffinity2,NotebookEdit:F.NotebookEdit,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:at.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputTextMerge:F.TextMergeTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput,TabInputInteractiveWindow:F.InteractiveWindowInput,TerminalExitReason:F.TerminalExitReason,LogLevel:Re.LogLevel}}}e.createApiFactoryAndRegisterActors=st}),define(De[298],Ie([1,0,270,307,308,2,309]),function(J,e,u,t,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(k,E,T,_,g,p){const m=p.environment.useHostProxy,b=typeof m=="boolean"?m:!p.remote.isRemote,f=(0,y.createProxyResolver)({resolveProxy:v=>k.resolveProxy(v),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(v,a,...d)=>{switch(v){case y.LogLevel.Trace:_.trace(a,...d);break;case y.LogLevel.Debug:_.debug(a,...d);break;case y.LogLevel.Info:_.info(a,...d);break;case y.LogLevel.Warning:_.warn(a,...d);break;case y.LogLevel.Error:_.error(a,...d);break;case y.LogLevel.Critical:_.critical(a,...d);break;case y.LogLevel.Off:break;default:o(v,a,d);break}function o(i,s,...l){_.error("Unknown log level",i),_.error(s,...l)}},getLogLevel:()=>_.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),c=S(E,f);return A(T,c)}e.connectProxyResolver=I;function S(k,E){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(g=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const _={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(g=>{_.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,y.createHttpPatch)(u,E,{config:"off"},_,!0)),on:Object.assign({},u,(0,y.createHttpPatch)(u,E,{config:"on"},_,!0)),override:Object.assign({},u,(0,y.createHttpPatch)(u,E,{config:"override"},_,!0)),onRequest:Object.assign({},u,(0,y.createHttpPatch)(u,E,T,_,!0)),default:Object.assign(u,(0,y.createHttpPatch)(u,E,T,_,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"off"},_,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"on"},_,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,E,{config:"override"},_,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,E,T,_,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,E,T,_,!1))},tls:Object.assign(C,(0,y.createTlsPatch)(C))}}const D=new Map;function A(k,E){return k.getExtensionPathIndex().then(T=>{const _=J.__$__nodeRequire("module"),g=_._load;_._load=function(m,b,f){if(m==="tls")return E.tls;if(m!=="http"&&m!=="https")return g.apply(this,arguments);const c=E[m],v=T.findSubstr(P.URI.file(b.filename));let a=D.get(v);if(a||D.set(v,a={}),!a[m]){const d=c.default;a[m]={...d}}return a[m]}})}}),define(De[299],Ie([1,0,73,297,284,298,41,272,2,14,7,269,112,271]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class _ extends C.RequireInterceptor{_installInterceptor(){const m=this,b=J.__$__nodeRequire("module"),f=b._load;b._load=function(d,o,i){return d=v(d),m._factories.has(d)?m._factories.get(d).load(d,S.URI.file((0,E.realpathSync)(o.filename)),s=>f.apply(this,[s,o,i])):f.apply(this,arguments)};const c=b._resolveLookupPaths;b._resolveLookupPaths=(a,d)=>c.call(this,v(a),d);const v=a=>{for(const d of m._alternatives){const o=d(a);if(o){a=o;break}}return a}}}class g extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const m=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(I.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(_,m,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(m){return m.main}async _loadCommonJSModule(m,b,f){if(b.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let c=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();const v=m?.identifier.value;m&&await this._extHostLocalizationService.initializeLocalizedMessages(m);try{v&&u.mark(`code/extHost/willLoadExtensionCode/${v}`),c=J.__$__nodeRequire(b.fsPath)}finally{v&&u.mark(`code/extHost/didLoadExtensionCode/${v}`),f.codeLoadingStop()}return c}async $setRemoteEnvironment(m){if(!!this._initData.remote.isRemote)for(const b in m){const f=m[b];f===null?delete process.env[b]:process.env[b]=f}}}e.ExtHostExtensionService=g}),define(De[142],Ie([1,0,44,310,293,17,77,37,9,8,2,30,71,311,291,96]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const p=_.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(h){this.outputChannel=h}provideTextSearchResults(h,w,L,M){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((B,R)=>{M.onCancellationRequested(()=>$());const z=d(h,w),H=w.folder.fsPath,N=z.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${p} ${N}
 - cwd: ${H}`);let V=u.spawn(p,z,{cwd:H});V.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),R((0,k.serializeSearchError)(new k.SearchError(he&&he.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const F=new c(w.maxResults,H,w.previewOptions);F.on("result",he=>{U=!0,K="",L.report(he)});let x=!1;const $=()=>{x=!0,V?.kill(),F?.cancel()};let Q=!1;F.on("hitLimit",()=>{Q=!0,$()});let K="";V.stdout.on("data",he=>{F.handleData(he),U||(K+=he)});let de=!1;V.stdout.once("data",()=>de=!0);let ee="";V.stderr.on("data",he=>{const Y=he.toString();this.outputChannel.appendLine(Y),ee.length+Y.length<1e6&&(ee+=Y)}),V.on("close",()=>{if(this.outputChannel.appendLine(de?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),x)B({limitHit:Q});else{F.flush(),V=null;let he;ee&&!de&&(he=b(ee))?R((0,k.serializeSearchError)(new k.SearchError(he.message,he.code))):B({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=m;function b(r){const h=r.split(`
`),w=h[0].trim();if(h.some(M=>M.startsWith("regex parse error")))return new k.SearchError(f(h),k.SearchErrorCode.regexParseError);const L=w.match(/grep config error: unknown encoding: (.*)/);if(L)return new k.SearchError(`Unknown encoding: ${L[1]}`,k.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(w,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function f(r){const h=["Regex parse error"],w=r.filter(L=>L.startsWith("PCRE2:"));if(w.length>=1){const L=w[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const M=L.split(":")[1];h.push(":"+M)}}return h.join("")}e.buildRegexParseError=f;class c extends t.EventEmitter{constructor(h,w,L){super(),this.maxResults=h,this.rootFolder=w,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,w){return super.on(h,w),this}handleData(h){if(this.isDone)return;const w=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(w)}handleDecodedData(h){let w=h.indexOf(`
`);const L=this.remainder+h;if(w>=0)w+=this.remainder.length;else{this.remainder=L;return}let M=0;for(;w>=0;)this.handleLine(L.substring(M,w).trim()),M=w+1,w=L.indexOf(`
`,M);this.remainder=L.substring(M)}handleLine(h){if(this.isDone||!h)return;let w;try{w=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(w.type==="match"){const L=v(w.data.path),M=A.URI.file(S.join(this.rootFolder,L)),B=this.createTextSearchMatch(w.data,M);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const L=v(w.data.path),M=A.URI.file(S.join(this.rootFolder,L));this.createTextSearchContext(w.data,M).forEach(R=>this.onResult(R))}}createTextSearchMatch(h,w){const L=h.line_number-1,M=v(h.lines),B=Buffer.from(M);let R=0,z=0,H=L;h.submatches.length===0&&h.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.coalesce)(h.submatches.map((V,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const F=v(V.match),x=B.slice(R,V.start).toString(),$=a(x),Q=$.numLines>0?$.lastLineLength:$.lastLineLength+z,K=a(F),de=$.numLines+H,ee=K.numLines+de,he=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return R=V.end,z=he,H=ee,new E.Range(de,Q,ee,he)}));return(0,g.createTextSearchResult)(w,M,N,this.previewOptions)}createTextSearchContext(h,w){const L=v(h.lines),M=h.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((B,R)=>({text:B,uri:w,lineNumber:M+R}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=c;function v(r){return r.bytes?Buffer.from(r.bytes,"base64").toString():r.text}function a(r){const h=/\n/g;let w=0,L=-1,M;for(;M=h.exec(r);)w++,L=M.index;const B=L>=0?r.length-L-1:r.length;return{numLines:w,lastLineLength:B}}function d(r,h){const w=["--hidden"];w.push(r.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:M}=(0,y.groupBy)(h.includes,R=>R.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const R=new Set;M.forEach(z=>{R.add(z)}),w.push("-g","!*"),R.forEach(z=>{o(z).map(g.anchorGlob).forEach(H=>{w.push("-g",H)})})}L&&L.length&&L.forEach(R=>{w.push("-g",R)}),h.excludes.map(g.anchorGlob).forEach(R=>w.push("-g",`!${R}`)),h.maxFileSize&&w.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),h.followSymlinks&&w.push("--follow"),h.encoding&&h.encoding!=="utf8"&&w.push("--encoding",h.encoding),r.pattern==="--"&&(r.isRegExp=!0,r.pattern="\\-\\-"),r.isMultiline&&!r.isRegExp&&(r.pattern=(0,D.escapeRegExpCharacters)(r.pattern),r.isRegExp=!0),h.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),r.isRegExp&&(r.pattern=i(r.pattern),w.push("--engine","auto"));let B;if(r.isWordMatch){const z=(0,D.createRegExp)(r.pattern,!!r.isRegExp,{wholeWord:r.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",z)}else if(r.isRegExp){let R=l(r.pattern);R=n(R),w.push("--regexp",R)}else B=r.pattern,w.push("--fixed-strings");return w.push("--no-config"),h.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),r.isMultiline&&w.push("--multiline"),h.beforeContext&&w.push("--before-context",h.beforeContext+""),h.afterContext&&w.push("--after-context",h.afterContext+""),w.push("--"),B&&w.push(B),w.push("."),w}function o(r){const h=(0,I.splitGlobAware)(r,"/");return h.map((w,L)=>h.slice(0,L+1).join("/"))}e.spreadGlobComponents=o;function i(r){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;r.match(h);)r=r.replace(h,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;r.match(w);)r=r.replace(w,"$1\\x{$2}");return r}e.unicodeEscapesToPCRE2=i;const s=r=>r.type==="Assertion"&&r.kind==="lookbehind";function l(r){let h;try{h=new T.RegExpParser().parsePattern(r)}catch{return r}let w="",L=0;const M=(z,H,N)=>{w+=r.slice(L,z)+N,L=H},B=[];return new T.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const H=B[0];if(!H)M(z.start,z.end,"\\r?\\n");else if(!B.some(s))if(H.type==="CharacterClass")if(H.negate){const N=r.slice(H.start+2,z.start)+r.slice(z.end,H.end-1);H.parent?.type==="Quantifier"?M(H.start,H.end,N?`[^${N}]`:"."):M(H.start,H.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=r.slice(H.start+1,z.start)+r.slice(z.end,H.end-1);M(H.start,H.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else H.type==="Quantifier"&&M(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){B.unshift(z)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(z){B.unshift(z)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(z){B.unshift(z)},onCharacterClassLeave(){B.shift()},onAssertionEnter(z){s(z)&&B.push(z)},onAssertionLeave(z){B[0]===z&&B.shift()}}).visit(h),w+=r.slice(L),w}e.fixRegexNewline=l;function n(r){return r.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(De[300],Ie([1,0,21,142,123,14]),function(J,e,u,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,A,k,E){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===P.Schemas.vscodeUserData){const _={...A,folder:A.folder.with({scheme:P.Schemas.file})},g=new C.Progress(p=>k.report({...p,uri:p.uri.with({scheme:A.folder.scheme})}));return this.withToken(E,p=>T.provideTextSearchResults(D,_,g,p))}else return this.withToken(E,_=>T.provideTextSearchResults(D,A,k,_))}async withToken(D,A){const k=I(D);this.inProgress.add(k);const E=await A(k.token);return this.inProgress.delete(k),E}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=y;function I(S){const D=new u.CancellationTokenSource;return S.onCancellationRequested(()=>D.cancel()),D}}),define(De[301],Ie([1,0,29,142,141]),function(J,e,u,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(S){this.query=S}search(S,D,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){A({message:T})}},E=new C.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),u);return new Promise((T,_)=>E.search(g=>{D(g.map(y))},S).then(g=>T({limitHit:g.limitHit,type:"success",stats:g.stats}),_))}}e.TextSearchEngineAdapter=P;function y(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((S,D)=>{if(D.ranges){const A=D;return S+(Array.isArray(A.ranges)?A.ranges.length:1)}else return S+1},0)}}}),define(De[302],Ie([1,0,17,18,11,3,108,9,51,2,38,30,292,301]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class _{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let v;const a=m(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{v=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(E.Engine,a,i=>d.fire(i),o)),v.then(o=>d.fire(o),o=>d.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{v.cancel()}});return d.event}textSearch(c){let v;const a=m(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{v=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(a,i=>d.fire(i),o)),v.then(o=>d.fire(o),o=>d.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{v.cancel()}});return d.event}ripgrepTextSearch(c,v,a){return c.maxFileSize=(0,A.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(c).search(a,v,v)}doFileSearch(c,v,a){return this.doFileSearchWithEngine(E.Engine,c,v,a)}doFileSearchWithEngine(c,v,a,d,o=_.BATCH_SIZE){let i=0;const s=n=>{Array.isArray(n)?(i+=n.length,a(n.map(r=>this.rawMatchToSearchItem(r)))):n.relativePath?(i++,a(this.rawMatchToSearchItem(n))):a(n)};if(v.sortByScore){let n=this.trySortedSearchFromCache(v,s,d);if(!n){const r=v.maxResults?Object.assign({},v,{maxResults:null}):v,h=new c(r);n=this.doSortedSearch(h,v,a,s,d)}return new Promise((r,h)=>{n.then(([w,L])=>{const M=L.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(M,a,o),r(w)},h)})}const l=new c(v);return this.doSearch(l,s,o,d).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,I.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,v,a,d,o){const i=new P.Emitter;let s=(0,t.createCancelablePromise)(n=>{let r=[];const h=w=>{Array.isArray(w)?r=w:(d(w),i.fire(w))};return this.doSearch(c,h,-1,n).then(w=>[w,r])}),l;if(v.cacheKey){l=this.getOrCreateCache(v.cacheKey);const n={promise:s,event:i.event,resolved:!1};l.resultsToSearchCache[v.filePattern||""]=n,s.then(()=>{n.resolved=!0},r=>{delete l.resultsToSearchCache[v.filePattern||""]}),s=this.preventCancellation(s)}return s.then(([n,r])=>{const h=l?l.scorerCache:Object.create(null),w=(typeof v.maxResults!="number"||v.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(v,r,h,o).then(L=>{const M=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:v.folderQueries.length,resultCount:L.length},messages:n.messages,limitHit:n.limitHit||typeof v.maxResults=="number"&&r.length>v.maxResults},L]})})}getOrCreateCache(c){const v=this.caches[c];return v||(this.caches[c]=new g)}trySortedSearchFromCache(c,v,a){const d=c.cacheKey&&this.caches[c.cacheKey];if(!d)return;const o=this.getResultsFromCache(d,c.filePattern||"",v,a);if(o)return o.then(([i,s,l])=>{const n=S.StopWatch.create(!1);return this.sortResults(c,s,d.scorerCache,a).then(r=>{const h=n.elapsed(),w={fromCache:!0,detailStats:l,type:this.processType,resultCount:s.length,sortingTime:h};return[{type:"success",limitHit:i.limitHit||typeof c.maxResults=="number"&&s.length>c.maxResults,stats:w},r]})})}sortResults(c,v,a,d){const o=(0,y.prepareQuery)(c.filePattern||""),i=(l,n)=>(0,y.compareItemsByFuzzyScore)(l,n,o,!0,p,a),s=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return u.topAsync(v,i,s,1e4,d)}sendProgress(c,v,a){if(a&&a>0)for(let d=0;d<c.length;d+=a)v(c.slice(d,d+a));else v(c)}getResultsFromCache(c,v,a,d){const o=S.StopWatch.create(!1),i=v.indexOf(I.sep)>=0;let s;for(const h in c.resultsToSearchCache)if(v.startsWith(h)){if(i&&h.indexOf(I.sep)<0&&h!=="")continue;const w=c.resultsToSearchCache[h];s={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!s)return null;const l=o.elapsed(),n=S.StopWatch.create(!1),r=s.event(a);return d&&d.onCancellationRequested(()=>{r.dispose()}),s.promise.then(([h,w])=>{if(d&&d.isCancellationRequested)throw(0,C.canceled)();const L=[],M=(0,y.prepareQuery)(v).normalizedLowercase;for(const B of w)!(0,k.isFilePatternMatch)(B,M)||L.push(B);return[h,L,{cacheWasResolved:s.resolved,cacheLookupTime:l,cacheFilterTime:n.elapsed(),cacheEntryCount:w.length}]})}doSearch(c,v,a,d){return new Promise((o,i)=>{let s=[];d?.onCancellationRequested(()=>c.cancel()),c.search(l=>{l&&(a?(s.push(l),a>0&&s.length>=a&&(v(s),s=[])):v(l))},l=>{v(l)},(l,n)=>{s.length&&v(s),l?i(l):o(n)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(v,a){return c.then(v,a)}catch(v){return this.then(void 0,v)}finally(v){return c.finally(v)}}}}e.SearchService=_,_.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(f){return(0,I.basename)(f.relativePath)}getItemDescription(f){return(0,I.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(c=>D.URI.revive(c))}}function b(f){return{...f,folder:D.URI.revive(f.folder)}}}),define(De[303],Ie([1,0,6,14,2,29,13,25,16,75,54,30,302,300,96,141]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let p=class extends D.ExtHostSearch{constructor(b,f,c,v){super(b,c,v),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new _.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(a)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new _.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(t.Schemas.file,new E.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,f){const c=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(b,f,c,v){const a=(0,D.reviveQuery)(c);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,f,a,v):super.$provideFileSearchResults(b,f,c,v)}doInternalFileSearch(b,f,c,v){const a=d=>{if((0,k.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(b,f,d.map(o=>C.URI.file(o.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,a,v)}$clearCache(b){return this._internalFileSearchProvider?.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,f){return new g.NativeTextSearchManager(b,f,void 0,"textSearchProvider")}};p=je([$e(0,S.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,A.IURITransformerService),$e(3,y.ILogService)],p),e.NativeExtHostSearch=p}),define(De[304],Ie([1,0,83,275,287,286,303,299,276,74,41,75,72,40,53,69,274,273,13,288,47]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(A.IExtHostExtensionService,I.ExtHostExtensionService,!1),(0,u.registerSingleton)(b.ILoggerService,m.ExtHostLoggerService,1),(0,u.registerSingleton)(g.IExtensionStoragePaths,p.ExtensionStoragePaths,!1),(0,u.registerSingleton)(D.IExtHostDebugService,P.ExtHostDebugService,!1),(0,u.registerSingleton)(k.IExtHostSearch,y.NativeExtHostSearch,!1),(0,u.registerSingleton)(E.IExtHostTask,C.ExtHostTask,!1),(0,u.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,u.registerSingleton)(_.IExtHostTunnelService,S.ExtHostTunnelService,!1),(0,u.registerSingleton)(c.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService,!1)}),define(De[312],Ie([1,0,216,313,73,11,115,116,196,91,285,23,29,112,18,118,211,225,289,304]),function(J,e,u,t,C,P,y,I,S,D,A,k,E,T,_,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const b=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=J.__$__nodeRequire("module"),l=s._load;s._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const f=process.exit.bind(process);function c(s){process.exit=function(l){if(s)f(l);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let v=function(s){f()};function a(){const s=(0,m.readExtHostConnection)(process.env);if(s.type===3)return new Promise((l,n)=>{const r=h=>{const w=h[0],L=new y.BufferedEmitter;w.on("message",M=>L.fire(k.VSBuffer.wrap(M.data))),w.on("close",()=>{v("renderer closed the MessagePort")}),w.start(),l({onMessage:L.event,send:M=>w.postMessage(M.buffer)})};if(global.vscodePorts){const h=global.vscodePorts;delete global.vscodePorts,r(h)}else global.vscodePortsCallback=r});if(s.type===2)return new Promise((l,n)=>{let r=null;const h=setTimeout(()=>{v("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,L=3e5,M=new _.ProcessTimeRunOnceScheduler(()=>v("renderer disconnected for too long (1)"),w),B=new _.ProcessTimeRunOnceScheduler(()=>v("renderer disconnected for too long (2)"),L);process.on("message",(z,H)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){H.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from(z.initialDataChunk,"base64"));let V;if(z.skipWebSocketFrames)V=new I.NodeSocket(H,"extHost-socket");else{const U=k.VSBuffer.wrap(Buffer.from(z.inflateBytes,"base64"));V=new I.WebSocketNodeSocket(new I.NodeSocket(H,"extHost-socket"),z.permessageDeflate,U,!1)}r?(M.cancel(),B.cancel(),r.beginAcceptReconnection(V,N),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(h),r=new y.PersistentProtocol(V,N),r.sendResume(),r.onDidDispose(()=>v("renderer disconnected")),l(r),r.onSocketClose(()=>{M.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(B.isScheduled())return;M.isScheduled()&&B.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(R)});{const l=s.pipeName;return new Promise((n,r)=>{const h=u.createConnection(l,()=>{h.removeListener("error",r);const w=new y.PersistentProtocol(new I.NodeSocket(h,"extHost-renderer"));w.sendResume(),n(w)});h.once("error",r),h.on("close",()=>{v("renderer closed the socket")})})}}async function d(){const s=await a();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(l=>{(0,D.isMessageOfType)(l,2)?(this._terminating=!0,v("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||s.send(l)}async drain(){if(s.drain)return s.drain()}}}function o(s){return new Promise(l=>{const n=s.onMessage(r=>{n.dispose();const h=JSON.parse(r.toString()),w=h.commit,L=S.default.commit;if(w&&L&&w!==L&&f(55),h.parentPid){let M=0;setInterval(function(){try{process.kill(h.parentPid,0),M=0}catch(R){R&&R.code==="EPERM"?(M++,M>=3&&v(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${R.message} (code: ${R.code}) (errno: ${R.errno})`)):v(`parent process ${h.parentPid} does not exist anymore: ${R.message} (code: ${R.code}) (errno: ${R.errno})`)}},1e3);let B;try{B=J.__$__nodeRequire("native-watchdog"),B.start(h.parentPid)}catch(R){(0,P.onUnexpectedError)(R)}}s.send((0,D.createMessageOfType)(0)),l({protocol:s,initData:h})});s.send((0,D.createMessageOfType)(1))})}async function i(){const s=[];process.on("unhandledRejection",(M,B)=>{s.push(B),setTimeout(()=>{const R=s.indexOf(B);R>=0&&B.catch(z=>{s.splice(R,1),(0,P.isCancellationError)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const B=s.indexOf(M);B>=0&&s.splice(B,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),C.mark("code/extHost/willConnectToRenderer");const l=await d();C.mark("code/extHost/didConnectToRenderer");const n=await o(l);C.mark("code/extHost/didWaitForInitData");const{initData:r}=n;c(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,g.boolean)(b.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(B){f(B)}exists(B){return E.Promises.exists(B)}realpath(B){return(0,T.realpath)(B)}};let w=null;r.remote.authority&&b.transformURIs&&(w=(0,p.createURITransformer)(r.remote.authority));const L=new A.ExtensionHostMain(n.protocol,r,h,w);v=M=>L.terminate(M)}e.startExtensionHostProcess=i,i().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6455bf1608dfa1b955717f66295f0f9200db0f73/core/vs/workbench/api/node/extensionHostProcess.js.map
