/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ne){for(var e=[],r=0,D=ne.length;r<D;r++)e[r]=Ie[ne[r]];return e};define(Ie[76],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(_,A){const y=Object.create(null);for(const P of _){const R=A(P);let E=y[R];E||(E=y[R]=[]),E.push(P)}return y}e.groupBy=r;function D(_,A){const y=[],P=[];for(const R of _)A.has(R)||y.push(R);for(const R of A)_.has(R)||P.push(R);return{removed:y,added:P}}e.diffSets=D;function b(_,A){const y=[],P=[];for(const[R,E]of _)A.has(R)||y.push(E);for(const[R,E]of A)_.has(R)||P.push(E);return{removed:y,added:P}}e.diffMaps=b;class N{constructor(){this.map=new Map}add(A,y){let P=this.map.get(A);P||(P=new Set,this.map.set(A,P)),P.add(y)}delete(A,y){const P=this.map.get(A);!P||(P.delete(y),P.size===0&&this.map.delete(A))}forEach(A,y){const P=this.map.get(A);!P||P.forEach(y)}}e.SetMap=N}),define(Ie[57],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(_){return(A,y,P)=>{let R=null,E=null;if(typeof P.value=="function"?(R="value",E=P.value):typeof P.get=="function"&&(R="get",E=P.get),!E)throw new Error("not supported");P[R]=_(E,y)}}e.createDecorator=r;function D(_,A,y){let P=null,R=null;if(typeof y.value=="function"?(P="value",R=y.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",R=y.get),!R)throw new Error("not supported");const E=`$memoize$${A}`;y[P]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[E]}}e.memoize=D;function b(_,A,y){return r((P,R)=>{const E=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...I){this[m]||(this[m]=y?y():void 0),clearTimeout(this[E]),A&&(this[m]=A(this[m],...I),I=[this[m]]),this[E]=setTimeout(()=>{P.apply(this,I),this[m]=y?y():void 0},_)}})}e.debounce=b;function N(_,A,y){return r((P,R)=>{const E=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,I=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...l){if(this[m]||(this[m]=y?y():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...l)),this[g])return;const c=this[I]+_;c<=Date.now()?(this[I]=Date.now(),P.apply(this,[this[m]]),this[m]=y?y():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[I]=Date.now(),P.apply(this,[this[m]]),this[m]=y?y():void 0},c-Date.now()))}})}e.throttle=N}),define(Ie[77],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ie[105],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function _(s,u=!1){let n=0;const i=s.length;let o="",a=0,t=16,d=0;function p(M){let O=0,H=0;for(;O<M;){const $=s.charCodeAt(n);if($>=48&&$<=57)H=H*16+$-48;else if($>=65&&$<=70)H=H*16+$-65+10;else if($>=97&&$<=102)H=H*16+$-97+10;else break;n++,O++}return O<M&&(H=-1),H}function w(M){n=M,o="",a=0,t=16,d=0}function F(){const M=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&P(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&P(s.charCodeAt(n)))for(n++;n<s.length&&P(s.charCodeAt(n));)n++;else return d=3,s.substring(M,n);let O=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&P(s.charCodeAt(n))){for(n++;n<s.length&&P(s.charCodeAt(n));)n++;O=n}else d=3;return s.substring(M,O)}function j(){let M="",O=n;for(;;){if(n>=i){M+=s.substring(O,n),d=2;break}const H=s.charCodeAt(n);if(H===34){M+=s.substring(O,n),n++;break}if(H===92){if(M+=s.substring(O,n),n++,n>=i){d=2;break}switch(s.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const z=p(4);z>=0?M+=String.fromCharCode(z):d=4;break}default:d=5}O=n;continue}if(H>=0&&H<=31)if(y(H)){M+=s.substring(O,n),d=2;break}else d=6;n++}return M}function U(){if(o="",d=0,a=n,n>=i)return a=i,t=17;let M=s.charCodeAt(n);if(A(M)){do n++,o+=String.fromCharCode(M),M=s.charCodeAt(n);while(A(M));return t=15}if(y(M))return n++,o+=String.fromCharCode(M),M===13&&s.charCodeAt(n)===10&&(n++,o+=`
`),t=14;switch(M){case 123:return n++,t=1;case 125:return n++,t=2;case 91:return n++,t=3;case 93:return n++,t=4;case 58:return n++,t=6;case 44:return n++,t=5;case 34:return n++,o=j(),t=10;case 47:{const O=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!y(s.charCodeAt(n));)n++;return o=s.substring(O,n),t=12}if(s.charCodeAt(n+1)===42){n+=2;const H=i-1;let $=!1;for(;n<H;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,$=!0;break}n++}return $||(n++,d=1),o=s.substring(O,n),t=13}return o+=String.fromCharCode(M),n++,t=16}case 45:if(o+=String.fromCharCode(M),n++,n===i||!P(s.charCodeAt(n)))return t=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=F(),t=11;default:for(;n<i&&C(M);)n++,M=s.charCodeAt(n);if(a!==n){switch(o=s.substring(a,n),o){case"true":return t=8;case"false":return t=9;case"null":return t=7}return t=16}return o+=String.fromCharCode(M),n++,t=16}}function C(M){if(A(M)||y(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let M;do M=U();while(M>=12&&M<=15);return M}return{setPosition:w,getPosition:()=>n,scan:u?W:U,getToken:()=>t,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>d}}e.createScanner=_;function A(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function y(s){return s===10||s===13||s===8232||s===8233}function P(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function E(s,u){const n=[],i=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let t=!1;function d(p,w,F,j){a.value=p,a.offset=w,a.length=F,a.type=j,a.colonOffset=void 0,o=a}try{S(s,{onObjectBegin:(p,w)=>{if(u<=p)throw i;o=void 0,t=u>p,n.push("")},onObjectProperty:(p,w,F)=>{if(u<w||(d(p,w,F,"property"),n[n.length-1]=p,u<=w+F))throw i},onObjectEnd:(p,w)=>{if(u<=p)throw i;o=void 0,n.pop()},onArrayBegin:(p,w)=>{if(u<=p)throw i;o=void 0,n.push(0)},onArrayEnd:(p,w)=>{if(u<=p)throw i;o=void 0,n.pop()},onLiteralValue:(p,w,F)=>{if(u<w||(d(p,w,F,T(p)),u<=w+F))throw i},onSeparator:(p,w,F)=>{if(u<=w)throw i;if(p===":"&&o&&o.type==="property")o.colonOffset=w,t=!1,o=void 0;else if(p===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(t=!0,n[n.length-1]=""),o=void 0}}})}catch(p){if(p!==i)throw p}return{path:n,previousNode:o,isAtPropertyKey:t,matches:p=>{let w=0;for(let F=0;w<p.length&&F<n.length;F++)if(p[w]===n[F]||p[w]==="*")w++;else if(p[w]!=="**")return!1;return w===p.length}}}e.getLocation=E;function m(s,u=[],n=N.DEFAULT){let i=null,o=[];const a=[];function t(p){Array.isArray(o)?o.push(p):i!==null&&(o[i]=p)}return S(s,{onObjectBegin:()=>{const p={};t(p),a.push(o),o=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const p=[];t(p),a.push(o),o=p,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:t,onError:(p,w,F)=>{u.push({error:p,offset:w,length:F})}},n),o[0]}e.parse=m;function I(s,u=[],n=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function a(p){return i.children.push(p),p}S(s,{onObjectBegin:p=>{i=a({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,w,F)=>{i=a({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:w,length:F,parent:i})},onObjectEnd:(p,w)=>{i.length=p+w-i.offset,i=i.parent,o(p+w)},onArrayBegin:(p,w)=>{i=a({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,w)=>{i.length=p+w-i.offset,i=i.parent,o(p+w)},onLiteralValue:(p,w,F)=>{a({type:T(p),offset:w,length:F,parent:i,value:p}),o(w+F)},onSeparator:(p,w,F)=>{i.type==="property"&&(p===":"?i.colonOffset=w:p===","&&o(w))},onError:(p,w,F)=>{u.push({error:p,offset:w,length:F})}},n);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=I;function g(s,u){if(!s)return;let n=s;for(const i of u)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],o=!0;break}if(!o)return}else{const o=i;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=g;function l(s){if(!s.parent||!s.parent.children)return[];const u=l(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;u.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&u.push(n)}return u}e.getNodePath=l;function c(s){switch(s.type){case"array":return s.children.map(c);case"object":{const u=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(u[n.children[0].value]=c(i))}return u}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=c;function f(s,u,n=!1){return u>=s.offset&&u<s.offset+s.length||n&&u===s.offset+s.length}e.contains=f;function v(s,u,n=!1){if(f(s,u,n)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=u;o++){const a=v(i[o],u,n);if(a)return a}return s}}e.findNodeAtOffset=v;function S(s,u,n=N.DEFAULT){const i=_(s,!1);function o(le){return le?()=>le(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(le){return le?fe=>le(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const t=o(u.onObjectBegin),d=a(u.onObjectProperty),p=o(u.onObjectEnd),w=o(u.onArrayBegin),F=o(u.onArrayEnd),j=a(u.onLiteralValue),U=a(u.onSeparator),C=o(u.onComment),W=a(u.onError),M=n&&n.disallowComments,O=n&&n.allowTrailingComma;function H(){for(;;){const le=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:M||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(le){case 12:case 13:M?$(10):C();break;case 16:$(1);break;case 15:case 14:break;default:return le}}}function $(le,fe=[],Q=[]){if(W(le),fe.length+Q.length>0){let pe=i.getToken();for(;pe!==17;){if(fe.indexOf(pe)!==-1){H();break}else if(Q.indexOf(pe)!==-1)break;pe=H()}}}function z(le){const fe=i.getTokenValue();return le?j(fe):d(fe),H(),!0}function G(){switch(i.getToken()){case 11:{let le=0;try{le=JSON.parse(i.getTokenValue()),typeof le!="number"&&($(2),le=0)}catch{$(2)}j(le);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return H(),!0}function te(){return i.getToken()!==10?($(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(U(":"),H(),be()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function he(){t(),H();let le=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(le||$(4,[],[]),U(","),H(),i.getToken()===2&&O)break}else le&&$(6,[],[]);te()||$(4,[],[2,5]),le=!0}return p(),i.getToken()!==2?$(7,[2],[]):H(),!0}function re(){w(),H();let le=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(le||$(4,[],[]),U(","),H(),i.getToken()===4&&O)break}else le&&$(6,[],[]);be()||$(4,[],[4,5]),le=!0}return F(),i.getToken()!==4?$(8,[4],[]):H(),!0}function be(){switch(i.getToken()){case 3:return re();case 1:return he();case 10:return z(!0);default:return G()}}return H(),i.getToken()===17?n.allowEmptyContent?!0:($(4,[],[]),!1):be()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=S;function h(s,u){const n=_(s),i=[];let o,a=0,t;do switch(t=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:a!==t&&i.push(s.substring(a,t)),u!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,u)),a=n.getPosition();break}while(o!==17);return i.join("")}e.stripComments=h;function T(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=T}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[106],Ce([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(ke,ye){for(var De=0;De<ye.length;De++){var ae=ye[De];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function r(ke,ye,De){return ye&&e(ke.prototype,ye),De&&e(ke,De),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function D(ke,ye){if(!!ke){if(typeof ke=="string")return b(ke,ye);var De=Object.prototype.toString.call(ke).slice(8,-1);if(De==="Object"&&ke.constructor&&(De=ke.constructor.name),De==="Map"||De==="Set")return Array.from(ke);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return b(ke,ye)}}function b(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var De=0,ae=new Array(ye);De<ye;De++)ae[De]=ke[De];return ae}function N(ke,ye){var De=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(De)return(De=De.call(ke)).next.bind(De);if(Array.isArray(ke)||(De=D(ke))||ye&&ke&&typeof ke.length=="number"){De&&(ke=De);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=_();function A(ke){ne.defaults=ke}var y=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(ye){return m[ye]};function g(ke,ye){if(ye){if(y.test(ke))return ke.replace(P,I)}else if(R.test(ke))return ke.replace(E,I);return ke}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(ke){return ke.replace(l,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var De={replace:function(ue,ee){return ee=ee.source||ee,ee=ee.replace(f,"$1"),ke=ke.replace(ue,ee),De},getRegex:function(){return new RegExp(ke,ye)}};return De}var S=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function T(ke,ye,De){if(ke){var ae;try{ae=decodeURIComponent(c(De)).replace(S,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!h.test(De)&&(De=o(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var s={},u=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ke,ye){s[" "+ke]||(u.test(ke)?s[" "+ke]=ke+"/":s[" "+ke]=p(ke,"/",!0)),ke=s[" "+ke];var De=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:ke.replace(n,"$1")+ye:ye.charAt(0)==="/"?De?ye:ke.replace(i,"$1")+ye:ke+ye}var a={exec:function(){}};function t(ke){for(var ye=1,De,ae;ye<arguments.length;ye++){De=arguments[ye];for(ae in De)Object.prototype.hasOwnProperty.call(De,ae)&&(ke[ae]=De[ae])}return ke}function d(ke,ye){var De=ke.replace(/\|/g,function(ee,Z,k){for(var B=!1,V=Z;--V>=0&&k[V]==="\\";)B=!B;return B?"|":" |"}),ae=De.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function p(ke,ye,De){var ae=ke.length;if(ae===0)return"";for(var ue=0;ue<ae;){var ee=ke.charAt(ae-ue-1);if(ee===ye&&!De)ue++;else if(ee!==ye&&De)ue++;else break}return ke.slice(0,ae-ue)}function w(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var De=ke.length,ae=0,ue=0;ue<De;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])ae++;else if(ke[ue]===ye[1]&&(ae--,ae<0))return ue;return-1}function F(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(ke,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=ke),ye>>=1,ke+=ke;return De+ke}function U(ke,ye,De,ae){var ue=ye.href,ee=ye.title?g(ye.title):null,Z=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var k={type:"link",raw:De,href:ue,title:ee,text:Z,tokens:ae.inlineTokens(Z)};return ae.state.inLink=!1,k}return{type:"image",raw:De,href:ue,title:ee,text:g(Z)}}function C(ke,ye){var De=ke.match(/^(\s+)(?:```)/);if(De===null)return ye;var ae=De[1];return ye.split(`
`).map(function(ue){var ee=ue.match(/^\s+/);if(ee===null)return ue;var Z=ee[0];return Z.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var W=function(){function ke(De){this.options=De||ne.defaults}var ye=ke.prototype;return ye.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ye.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:p(ee,`
`)}}},ye.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var ee=ue[0],Z=C(ee,ue[3]||"");return{type:"code",raw:ee,lang:ue[2]?ue[2].trim():ue[2],text:Z}}},ye.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var ee=ue[2].trim();if(/#$/.test(ee)){var Z=p(ee,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(ee=Z.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ye.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var ee=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ye.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var ee,Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze=ue[1].trim(),Je=ze.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+ze.slice(0,-1):"",loose:!1,items:[]};ze=Je?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=Je?ze:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ue=Pe.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=ue[0],ae=ae.substring(ee.length),ce=ue[2].split(`
`,1)[0],J=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ve=ce.trimLeft()):(B=ue[2].search(/[^ ]/),B=B>4?1:B,ve=ce.slice(B),B+=ue[1].length),q=!1,!ce&&/^ *$/.test(J)&&(ee+=J+`
`,ae=ae.substring(J.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),X=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Y=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),me=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");ae&&(Ee=ae.split(`
`,1)[0],ce=Ee,this.options.pedantic&&(ce=ce.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Y.test(ce)||me.test(ce)||nt.test(ce)||X.test(ae)));){if(ce.search(/[^ ]/)>=B||!ce.trim())ve+=`
`+ce.slice(B);else if(!q)ve+=`
`+ce;else break;!q&&!ce.trim()&&(q=!0),ee+=Ee+`
`,ae=ae.substring(Ee.length+1)}Ge.loose||(oe?Ge.loose=!0:/\n *\n *$/.test(ee)&&(oe=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(ve),Z&&(k=Z[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ee,task:!!Z,checked:k,loose:!1,text:ve}),Ge.raw+=ee}Ge.items[Ge.items.length-1].raw=ee.trimRight(),Ge.items[Ge.items.length-1].text=ve.trimRight(),Ge.raw=Ge.raw.trimRight();var Be=Ge.items.length;for(V=0;V<Be;V++){this.lexer.state.top=!1,Ge.items[V].tokens=this.lexer.blockTokens(Ge.items[V].text,[]);var je=Ge.items[V].tokens.filter(function(Ke){return Ke.type==="space"}),et=je.every(function(Ke){for(var Ve=Ke.raw.split(""),it=0,st=N(Ve),ct;!(ct=st()).done;){var at=ct.value;if(at===`
`&&(it+=1),it>1)return!0}return!1});!Ge.loose&&je.length&&et&&(Ge.loose=!0,Ge.items[V].loose=!0)}return Ge}},ye.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(ue[0]):g(ue[0]);ee.type="paragraph",ee.text=Z,ee.tokens=this.lexer.inline(Z)}return ee}},ye.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var ee={type:"table",header:d(ue[1]).map(function(oe){return{text:oe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ue[0];var Z=ee.align.length,k,B,V,q;for(k=0;k<Z;k++)/^ *-+: *$/.test(ee.align[k])?ee.align[k]="right":/^ *:-+: *$/.test(ee.align[k])?ee.align[k]="center":/^ *:-+ *$/.test(ee.align[k])?ee.align[k]="left":ee.align[k]=null;for(Z=ee.rows.length,k=0;k<Z;k++)ee.rows[k]=d(ee.rows[k],ee.header.length).map(function(oe){return{text:oe}});for(Z=ee.header.length,B=0;B<Z;B++)ee.header[B].tokens=this.lexer.inline(ee.header[B].text);for(Z=ee.rows.length,B=0;B<Z;B++)for(q=ee.rows[B],V=0;V<q.length;V++)q[V].tokens=this.lexer.inline(q[V].text);return ee}}},ye.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ye.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var ee=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:ee,tokens:this.lexer.inline(ee)}}},ye.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ye.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:g(ue[1])}},ye.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):g(ue[0]):ue[0]}},ye.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var Z=p(ee.slice(0,-1),"\\");if((ee.length-Z.length)%2===0)return}else{var k=w(ue[2],"()");if(k>-1){var B=ue[0].indexOf("!")===0?5:4,V=B+ue[1].length+k;ue[2]=ue[2].substring(0,k),ue[0]=ue[0].substring(0,V).trim(),ue[3]=""}}var q=ue[2],oe="";if(this.options.pedantic){var ce=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);ce&&(q=ce[1],oe=ce[3])}else oe=ue[3]?ue[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(ee)?q=q.slice(1):q=q.slice(1,-1)),U(ue,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ae,ue){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var Z=(ee[2]||ee[1]).replace(/\s+/g," ");if(Z=ue[Z.toLowerCase()],!Z||!Z.href){var k=ee[0].charAt(0);return{type:"text",raw:k,text:k}}return U(ee,Z,ee[0],this.lexer)}},ye.emStrong=function(ae,ue,ee){ee===void 0&&(ee="");var Z=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Z&&!(Z[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=Z[1]||Z[2]||"";if(!k||k&&(ee===""||this.rules.inline.punctuation.exec(ee))){var B=Z[0].length-1,V,q,oe=B,ce=0,J=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,ue=ue.slice(-1*ae.length+B);(Z=J.exec(ue))!=null;)if(V=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!V){if(q=V.length,Z[3]||Z[4]){oe+=q;continue}else if((Z[5]||Z[6])&&B%3&&!((B+q)%3)){ce+=q;continue}if(oe-=q,!(oe>0)){if(q=Math.min(q,q+oe+ce),Math.min(B,q)%2){var Ee=ae.slice(1,B+Z.index+q);return{type:"em",raw:ae.slice(0,B+Z.index+q+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=ae.slice(2,B+Z.index+q-1);return{type:"strong",raw:ae.slice(0,B+Z.index+q+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ye.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var ee=ue[2].replace(/\n/g," "),Z=/[^ ]/.test(ee),k=/^ /.test(ee)&&/ $/.test(ee);return Z&&k&&(ee=ee.substring(1,ee.length-1)),ee=g(ee,!0),{type:"codespan",raw:ue[0],text:ee}}},ye.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ye.autolink=function(ae,ue){var ee=this.rules.inline.autolink.exec(ae);if(ee){var Z,k;return ee[2]==="@"?(Z=g(this.options.mangle?ue(ee[1]):ee[1]),k="mailto:"+Z):(Z=g(ee[1]),k=Z),{type:"link",raw:ee[0],text:Z,href:k,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(ae,ue){var ee;if(ee=this.rules.inline.url.exec(ae)){var Z,k;if(ee[2]==="@")Z=g(this.options.mangle?ue(ee[0]):ee[0]),k="mailto:"+Z;else{var B;do B=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(B!==ee[0]);Z=g(ee[0]),ee[1]==="www."?k="http://"+Z:k=Z}return{type:"link",raw:ee[0],text:Z,href:k,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(ae,ue){var ee=this.rules.inline.text.exec(ae);if(ee){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):g(ee[0]):ee[0]:Z=g(this.options.smartypants?ue(ee[0]):ee[0]),{type:"text",raw:ee[0],text:Z}}},ke}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=v(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=v(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=v(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=v(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=v(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=v(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=t({},M),M.gfm=t({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=v(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=v(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=t({},M.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:v(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=v(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=v(M._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=v(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=v(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=v(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=v(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=v(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=v(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=v(O.reflink).replace("label",O._label).replace("ref",M._label).getRegex(),O.nolink=v(O.nolink).replace("ref",M._label).getRegex(),O.reflinkSearch=v(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=t({},O),O.pedantic=t({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=t({},O.normal,{escape:v(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=v(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=t({},O.gfm,{br:v(O.br).replace("{2,}","*").getRegex(),text:v(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function H(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(ke){var ye="",De,ae,ue=ke.length;for(De=0;De<ue;De++)ae=ke.charCodeAt(De),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var z=function(){function ke(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ne.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:M.normal,inline:O.normal};this.options.pedantic?(ae.block=M.pedantic,ae.inline=O.pedantic):this.options.gfm&&(ae.block=M.gfm,this.options.breaks?ae.inline=O.breaks:ae.inline=O.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ue){var ee=new ke(ue);return ee.lex(ae)},ke.lexInline=function(ae,ue){var ee=new ke(ue);return ee.inlineTokens(ae)};var ye=ke.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(oe,ce,J){return ce+"    ".repeat(J.length)});for(var Z,k,B,V;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(Z=oe.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.space(ae)){ae=ae.substring(Z.raw.length),Z.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(Z);continue}if(Z=this.tokenizer.code(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z);continue}if(Z=this.tokenizer.fences(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.heading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.hr(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.blockquote(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.list(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.html(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.def(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.lheading(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,ce=ae.slice(1),J=void 0;ee.options.extensions.startBlock.forEach(function(Ee){J=Ee.call({lexer:this},ce),typeof J=="number"&&J>=0&&(oe=Math.min(oe,J))}),oe<1/0&&oe>=0&&(B=ae.substring(0,oe+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(B))){k=ue[ue.length-1],V&&k.type==="paragraph"?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z),V=B.length!==ae.length,ae=ae.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&k.type==="text"?(k.raw+=`
`+Z.raw,k.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):ue.push(Z);continue}if(ae){var q="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,ue},ye.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},ye.inlineTokens=function(ae,ue){var ee=this;ue===void 0&&(ue=[]);var Z,k,B,V=ae,q,oe,ce;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)J.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,q.index)+"["+j("a",q[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,q.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(oe||(ce=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(Z=ve.call({lexer:ee},ae,ue))?(ae=ae.substring(Z.raw.length),ue.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.tag(ae)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&Z.type==="text"&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.link(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Z.raw.length),k=ue[ue.length-1],k&&Z.type==="text"&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(Z=this.tokenizer.emStrong(ae,V,ce)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.codespan(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.br(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.del(ae)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.autolink(ae,$)){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(ae,$))){ae=ae.substring(Z.raw.length),ue.push(Z);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ne=ae.slice(1),ze=void 0;ee.options.extensions.startInline.forEach(function(Je){ze=Je.call({lexer:this},Ne),typeof ze=="number"&&ze>=0&&(ve=Math.min(ve,ze))}),ve<1/0&&ve>=0&&(B=ae.substring(0,ve+1))}(),Z=this.tokenizer.inlineText(B,H)){ae=ae.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(ce=Z.raw.slice(-1)),oe=!0,k=ue[ue.length-1],k&&k.type==="text"?(k.raw+=Z.raw,k.text+=Z.text):ue.push(Z);continue}if(ae){var Ee="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},r(ke,null,[{key:"rules",get:function(){return{block:M,inline:O}}}]),ke}(),G=function(){function ke(De){this.options=De||ne.defaults}var ye=ke.prototype;return ye.code=function(ae,ue,ee){var Z=(ue||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(ae,Z);k!=null&&k!==ae&&(ee=!0,ae=k)}return ae=ae.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+g(Z,!0)+'">'+(ee?ae:g(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:g(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,ue,ee,Z){if(this.options.headerIds){var k=this.options.headerPrefix+Z.slug(ee);return"<h"+ue+' id="'+k+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,ue,ee){var Z=ue?"ol":"ul",k=ue&&ee!==1?' start="'+ee+'"':"";return"<"+Z+k+`>
`+ae+"</"+Z+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,ue){var ee=ue.header?"th":"td",Z=ue.align?"<"+ee+' align="'+ue.align+'">':"<"+ee+">";return Z+ae+("</"+ee+`>
`)},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,ue,ee){if(ae=T(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<a href="'+g(ae)+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=">"+ee+"</a>",Z},ye.image=function(ae,ue,ee){if(ae=T(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var Z='<img src="'+ae+'" alt="'+ee+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(ae){return ae},ke}(),te=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,ue,ee){return""+ee},ye.image=function(ae,ue,ee){return""+ee},ye.br=function(){return""},ke}(),he=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,ue){var ee=ae,Z=0;if(this.seen.hasOwnProperty(ee)){Z=this.seen[ae];do Z++,ee=ae+"-"+Z;while(this.seen.hasOwnProperty(ee))}return ue||(this.seen[ae]=Z,this.seen[ee]=0),ee},ye.slug=function(ae,ue){ue===void 0&&(ue={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,ue.dryrun)},ke}(),re=function(){function ke(De){this.options=De||ne.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new he}ke.parse=function(ae,ue){var ee=new ke(ue);return ee.parse(ae)},ke.parseInline=function(ae,ue){var ee=new ke(ue);return ee.parseInline(ae)};var ye=ke.prototype;return ye.parse=function(ae,ue){ue===void 0&&(ue=!0);var ee="",Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Be=ae.length;for(Z=0;Z<Be;Z++){if(ve=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(me=this.options.extensions.renderers[ve.type].call({parser:this},ve),me!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){ee+=me||"";continue}switch(ve.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,c(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(J="",ce="",V=ve.header.length,k=0;k<V;k++)ce+=this.renderer.tablecell(this.parseInline(ve.header[k].tokens),{header:!0,align:ve.align[k]});for(J+=this.renderer.tablerow(ce),Ee="",V=ve.rows.length,k=0;k<V;k++){for(oe=ve.rows[k],ce="",q=oe.length,B=0;B<q;B++)ce+=this.renderer.tablecell(this.parseInline(oe[B].tokens),{header:!1,align:ve.align[B]});Ee+=this.renderer.tablerow(ce)}ee+=this.renderer.table(J,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),ee+=this.renderer.blockquote(Ee);continue}case"list":{for(Ne=ve.ordered,ze=ve.start,Je=ve.loose,V=ve.items.length,Ee="",k=0;k<V;k++)Pe=ve.items[k],nt=Pe.checked,X=Pe.task,Ge="",Pe.task&&(Y=this.renderer.checkbox(nt),Je?Pe.tokens.length>0&&Pe.tokens[0].type==="paragraph"?(Pe.tokens[0].text=Y+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=Y+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:Y}):Ge+=Y),Ge+=this.parse(Pe.tokens,Je),Ee+=this.renderer.listitem(Ge,X,nt);ee+=this.renderer.list(Ee,Ne,ze);continue}case"html":{ee+=this.renderer.html(ve.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;Z+1<Be&&ae[Z+1].type==="text";)ve=ae[++Z],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);ee+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var je='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ee},ye.parseInline=function(ae,ue){ue=ue||this.renderer;var ee="",Z,k,B,V=ae.length;for(Z=0;Z<V;Z++){if(k=ae[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(B=this.options.extensions.renderers[k.type].call({parser:this},k),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){ee+=B||"";continue}switch(k.type){case"escape":{ee+=ue.text(k.text);break}case"html":{ee+=ue.html(k.text);break}case"link":{ee+=ue.link(k.href,k.title,this.parseInline(k.tokens,ue));break}case"image":{ee+=ue.image(k.href,k.title,k.text);break}case"strong":{ee+=ue.strong(this.parseInline(k.tokens,ue));break}case"em":{ee+=ue.em(this.parseInline(k.tokens,ue));break}case"codespan":{ee+=ue.codespan(k.text);break}case"br":{ee+=ue.br();break}case"del":{ee+=ue.del(this.parseInline(k.tokens,ue));break}case"text":{ee+=ue.text(k.text);break}default:{var q='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return ee},ke}();function be(ke,ye,De){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=t({},be.defaults,ye||{}),F(ye),De){var ae=ye.highlight,ue;try{ue=z.lex(ke,ye)}catch(V){return De(V)}var ee=function(q){var oe;if(!q)try{ye.walkTokens&&be.walkTokens(ue,ye.walkTokens),oe=re.parse(ue,ye)}catch(ce){q=ce}return ye.highlight=ae,q?De(q):De(null,oe)};if(!ae||ae.length<3||(delete ye.highlight,!ue.length))return ee();var Z=0;be.walkTokens(ue,function(V){V.type==="code"&&(Z++,setTimeout(function(){ae(V.text,V.lang,function(q,oe){if(q)return ee(q);oe!=null&&oe!==V.text&&(V.text=oe,V.escaped=!0),Z--,Z===0&&ee()})},0))}),Z===0&&ee();return}function k(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+g(V.message+"",!0)+"</pre>";throw V}try{var B=z.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(be.walkTokens(B,ye.walkTokens)).then(function(){return re.parse(B,ye)}).catch(k);be.walkTokens(B,ye.walkTokens)}return re.parse(B,ye)}catch(V){k(V)}}be.options=be.setOptions=function(ke){return t(be.defaults,ke),A(be.defaults),be},be.getDefaults=_,be.defaults=ne.defaults,be.use=function(){for(var ke=arguments.length,ye=new Array(ke),De=0;De<ke;De++)ye[De]=arguments[De];var ae=t.apply(void 0,[{}].concat(ye)),ue=be.defaults.extensions||{renderers:{},childTokens:{}},ee;ye.forEach(function(Z){if(Z.extensions&&(ee=!0,Z.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var V=ue.renderers?ue.renderers[B.name]:null;V?ue.renderers[B.name]=function(){for(var q=arguments.length,oe=new Array(q),ce=0;ce<q;ce++)oe[ce]=arguments[ce];var J=B.renderer.apply(this,oe);return J===!1&&(J=V.apply(this,oe)),J}:ue.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[B.level]?ue[B.level].unshift(B.tokenizer):ue[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ue.startBlock?ue.startBlock.push(B.start):ue.startBlock=[B.start]:B.level==="inline"&&(ue.startInline?ue.startInline.push(B.start):ue.startInline=[B.start]))}B.childTokens&&(ue.childTokens[B.name]=B.childTokens)})),Z.renderer&&function(){var B=be.defaults.renderer||new G,V=function(ce){var J=B[ce];B[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.renderer[ce].apply(B,ve);return ze===!1&&(ze=J.apply(B,ve)),ze}};for(var q in Z.renderer)V(q);ae.renderer=B}(),Z.tokenizer&&function(){var B=be.defaults.tokenizer||new W,V=function(ce){var J=B[ce];B[ce]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Ne=0;Ne<Ee;Ne++)ve[Ne]=arguments[Ne];var ze=Z.tokenizer[ce].apply(B,ve);return ze===!1&&(ze=J.apply(B,ve)),ze}};for(var q in Z.tokenizer)V(q);ae.tokenizer=B}(),Z.walkTokens){var k=be.defaults.walkTokens;ae.walkTokens=function(B){var V=[];return V.push(Z.walkTokens.call(this,B)),k&&(V=V.concat(k.call(this,B))),V}}ee&&(ae.extensions=ue),be.setOptions(ae)})},be.walkTokens=function(ke,ye){for(var De=[],ae=function(){var k=ee.value;switch(De=De.concat(ye.call(be,k)),k.type){case"table":{for(var B=N(k.header),V;!(V=B()).done;){var q=V.value;De=De.concat(be.walkTokens(q.tokens,ye))}for(var oe=N(k.rows),ce;!(ce=oe()).done;)for(var J=ce.value,Ee=N(J),ve;!(ve=Ee()).done;){var Ne=ve.value;De=De.concat(be.walkTokens(Ne.tokens,ye))}break}case"list":{De=De.concat(be.walkTokens(k.items,ye));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[k.type]?be.defaults.extensions.childTokens[k.type].forEach(function(ze){De=De.concat(be.walkTokens(k[ze],ye))}):k.tokens&&(De=De.concat(be.walkTokens(k.tokens,ye)))}},ue=N(ke),ee;!(ee=ue()).done;)ae();return De},be.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=t({},be.defaults,ye||{}),F(ye);try{var De=z.lexInline(ke,ye);return ye.walkTokens&&be.walkTokens(De,ye.walkTokens),re.parseInline(De,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+g(ae.message+"",!0)+"</pre>";throw ae}},be.Parser=re,be.parser=re.parse,be.Renderer=G,be.TextRenderer=te,be.Lexer=z,be.lexer=z.lex,be.Tokenizer=W,be.Slugger=he,be.parse=be;var le=be.options,fe=be.setOptions,Q=be.use,pe=be.walkTokens,Se=be.parseInline,Fe=be,Ue=re.parse,Xe=z.lex;ne.Lexer=z,ne.Parser=re,ne.Renderer=G,ne.Slugger=he,ne.TextRenderer=te,ne.Tokenizer=W,ne.getDefaults=_,ne.lexer=Xe,ne.marked=be,ne.options=le,ne.parse=Fe,ne.parseInline=Se,ne.parser=Ue,ne.setOptions=fe,ne.use=Q,ne.walkTokens=pe,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Ie[107],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,y,P){return Math.min(Math.max(A,y),P)}e.clamp=r;function D(A,y){return(y+A%y)%y}e.rot=D;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class N{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class _{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const P=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ne(b){const N=[];typeof b=="number"&&N.push("code/timeOrigin",b);function _(y){N.push(y,Date.now())}function A(){const y=[];for(let P=0;P<N.length;P+=2)y.push({name:N[P],startTime:N[P+1]});return y}return{mark:_,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const _ of performance.getEntriesByType("mark"))N.push({name:_.name,startTime:Math.round(b+_.startTime)});return N}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function r(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=r(D))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var D in r)(typeof exports=="object"?exports:ne)[D]=r[D]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function r(D){if(e[D])return e[D].exports;var b=e[D]={i:D,l:!1,exports:{}};return ne[D].call(b.exports,b,b.exports,r),b.l=!0,b.exports}return r.m=ne,r.c=e,r.d=function(D,b,N){r.o(D,b)||Object.defineProperty(D,b,{enumerable:!0,get:N})},r.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},r.t=function(D,b){if(1&b&&(D=r(D)),8&b||4&b&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(r.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&b&&typeof D!="string")for(var _ in D)r.d(N,_,function(A){return D[A]}.bind(null,_));return N},r.n=function(D){var b=D&&D.__esModule?function(){return D.default}:function(){return D};return r.d(b,"a",b),b},r.o=function(D,b){return Object.prototype.hasOwnProperty.call(D,b)},r.p="",r(r.s=0)}([function(ne,e,r){(function(D){var b;e=ne.exports=Q,b=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],P=0,R=P++;y[R]="0|[1-9]\\d*";var E=P++;y[E]="[0-9]+";var m=P++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=P++;y[I]="("+y[R]+")\\.("+y[R]+")\\.("+y[R]+")";var g=P++;y[g]="("+y[E]+")\\.("+y[E]+")\\.("+y[E]+")";var l=P++;y[l]="(?:"+y[R]+"|"+y[m]+")";var c=P++;y[c]="(?:"+y[E]+"|"+y[m]+")";var f=P++;y[f]="(?:-("+y[l]+"(?:\\."+y[l]+")*))";var v=P++;y[v]="(?:-?("+y[c]+"(?:\\."+y[c]+")*))";var S=P++;y[S]="[0-9A-Za-z-]+";var h=P++;y[h]="(?:\\+("+y[S]+"(?:\\."+y[S]+")*))";var T=P++,s="v?"+y[I]+y[f]+"?"+y[h]+"?";y[T]="^"+s+"$";var u="[v=\\s]*"+y[g]+y[v]+"?"+y[h]+"?",n=P++;y[n]="^"+u+"$";var i=P++;y[i]="((?:<|>)?=?)";var o=P++;y[o]=y[E]+"|x|X|\\*";var a=P++;y[a]=y[R]+"|x|X|\\*";var t=P++;y[t]="[v=\\s]*("+y[a]+")(?:\\.("+y[a]+")(?:\\.("+y[a]+")(?:"+y[f]+")?"+y[h]+"?)?)?";var d=P++;y[d]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[v]+")?"+y[h]+"?)?)?";var p=P++;y[p]="^"+y[i]+"\\s*"+y[t]+"$";var w=P++;y[w]="^"+y[i]+"\\s*"+y[d]+"$";var F=P++;y[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=P++;y[j]="(?:~>?)";var U=P++;y[U]="(\\s*)"+y[j]+"\\s+",A[U]=new RegExp(y[U],"g");var C=P++;y[C]="^"+y[j]+y[t]+"$";var W=P++;y[W]="^"+y[j]+y[d]+"$";var M=P++;y[M]="(?:\\^)";var O=P++;y[O]="(\\s*)"+y[M]+"\\s+",A[O]=new RegExp(y[O],"g");var H=P++;y[H]="^"+y[M]+y[t]+"$";var $=P++;y[$]="^"+y[M]+y[d]+"$";var z=P++;y[z]="^"+y[i]+"\\s*("+u+")$|^$";var G=P++;y[G]="^"+y[i]+"\\s*("+s+")$|^$";var te=P++;y[te]="(\\s*)"+y[i]+"\\s*("+u+"|"+y[t]+")",A[te]=new RegExp(y[te],"g");var he=P++;y[he]="^\\s*("+y[t]+")\\s+-\\s+("+y[t]+")\\s*$";var re=P++;y[re]="^\\s*("+y[d]+")\\s+-\\s+("+y[d]+")\\s*$";var be=P++;y[be]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)b(le,y[le]),A[le]||(A[le]=new RegExp(y[le]));function fe(J,Ee){if(J instanceof Q)return J;if(typeof J!="string"||J.length>N||!(Ee?A[n]:A[T]).test(J))return null;try{return new Q(J,Ee)}catch{return null}}function Q(J,Ee){if(J instanceof Q){if(J.loose===Ee)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Q))return new Q(J,Ee);b("SemVer",J,Ee),this.loose=Ee;var ve=J.trim().match(Ee?A[n]:A[T]);if(!ve)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var ze=+Ne;if(ze>=0&&ze<_)return ze}return Ne}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=fe,e.valid=function(J,Ee){var ve=fe(J,Ee);return ve?ve.version:null},e.clean=function(J,Ee){var ve=fe(J.trim().replace(/^[=v]+/,""),Ee);return ve?ve.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return b("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),Se(this.major,J.major)||Se(this.minor,J.minor)||Se(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var Ee=0;do{var ve=this.prerelease[Ee],Ne=J.prerelease[Ee];if(b("prerelease compare",Ee,ve,Ne),ve===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ne)return Se(ve,Ne)}while(++Ee)},Q.prototype.inc=function(J,Ee){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,Ee,ve,Ne){typeof ve=="string"&&(Ne=ve,ve=void 0);try{return new Q(J,ve).inc(Ee,Ne).version}catch{return null}},e.diff=function(J,Ee){if(ke(J,Ee))return null;var ve=fe(J),Ne=fe(Ee);if(ve.prerelease.length||Ne.prerelease.length){for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return"pre"+ze;return"prerelease"}for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ne[ze])return ze},e.compareIdentifiers=Se;var pe=/^[0-9]+$/;function Se(J,Ee){var ve=pe.test(J),Ne=pe.test(Ee);return ve&&Ne&&(J=+J,Ee=+Ee),ve&&!Ne?-1:Ne&&!ve?1:J<Ee?-1:J>Ee?1:0}function Fe(J,Ee,ve){return new Q(J,ve).compare(new Q(Ee,ve))}function Ue(J,Ee,ve){return Fe(J,Ee,ve)>0}function Xe(J,Ee,ve){return Fe(J,Ee,ve)<0}function ke(J,Ee,ve){return Fe(J,Ee,ve)===0}function ye(J,Ee,ve){return Fe(J,Ee,ve)!==0}function De(J,Ee,ve){return Fe(J,Ee,ve)>=0}function ae(J,Ee,ve){return Fe(J,Ee,ve)<=0}function ue(J,Ee,ve,Ne){var ze;switch(Ee){case"===":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J===ve;break;case"!==":typeof J=="object"&&(J=J.version),typeof ve=="object"&&(ve=ve.version),ze=J!==ve;break;case"":case"=":case"==":ze=ke(J,ve,Ne);break;case"!=":ze=ye(J,ve,Ne);break;case">":ze=Ue(J,ve,Ne);break;case">=":ze=De(J,ve,Ne);break;case"<":ze=Xe(J,ve,Ne);break;case"<=":ze=ae(J,ve,Ne);break;default:throw new TypeError("Invalid operator: "+Ee)}return ze}function ee(J,Ee){if(J instanceof ee){if(J.loose===Ee)return J;J=J.value}if(!(this instanceof ee))return new ee(J,Ee);b("comparator",J,Ee),this.loose=Ee,this.parse(J),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(J,Ee){return Se(Ee,J)},e.major=function(J,Ee){return new Q(J,Ee).major},e.minor=function(J,Ee){return new Q(J,Ee).minor},e.patch=function(J,Ee){return new Q(J,Ee).patch},e.compare=Fe,e.compareLoose=function(J,Ee){return Fe(J,Ee,!0)},e.rcompare=function(J,Ee,ve){return Fe(Ee,J,ve)},e.sort=function(J,Ee){return J.sort(function(ve,Ne){return e.compare(ve,Ne,Ee)})},e.rsort=function(J,Ee){return J.sort(function(ve,Ne){return e.rcompare(ve,Ne,Ee)})},e.gt=Ue,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=De,e.lte=ae,e.cmp=ue,e.Comparator=ee;var Z={};function k(J,Ee){if(J instanceof k)return J.loose===Ee?J:new k(J.raw,Ee);if(J instanceof ee)return new k(J.value,Ee);if(!(this instanceof k))return new k(J,Ee);if(this.loose=Ee,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function B(J){return!J||J.toLowerCase()==="x"||J==="*"}function V(J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Be){return((Ee=B(ve)?"":B(Ne)?">="+ve+".0.0":B(ze)?">="+ve+"."+Ne+".0":">="+Ee)+" "+(Pe=B(nt)?"":B(X)?"<"+(+nt+1)+".0.0":B(Y)?"<"+nt+"."+(+X+1)+".0":me?"<="+nt+"."+X+"."+Y+"-"+me:"<="+Pe)).trim()}function q(J,Ee){for(var ve=0;ve<J.length;ve++)if(!J[ve].test(Ee))return!1;if(Ee.prerelease.length){for(ve=0;ve<J.length;ve++)if(b(J[ve].semver),J[ve].semver!==Z&&J[ve].semver.prerelease.length>0){var Ne=J[ve].semver;if(Ne.major===Ee.major&&Ne.minor===Ee.minor&&Ne.patch===Ee.patch)return!0}return!1}return!0}function oe(J,Ee,ve){try{Ee=new k(Ee,ve)}catch{return!1}return Ee.test(J)}function ce(J,Ee,ve,Ne){var ze,Je,Ge,Pe,nt;switch(J=new Q(J,Ne),Ee=new k(Ee,Ne),ve){case">":ze=Ue,Je=ae,Ge=Xe,Pe=">",nt=">=";break;case"<":ze=Xe,Je=De,Ge=Ue,Pe="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(oe(J,Ee,Ne))return!1;for(var X=0;X<Ee.set.length;++X){var Y=Ee.set[X],me=null,Be=null;if(Y.forEach(function(je){je.semver===Z&&(je=new ee(">=0.0.0")),me=me||je,Be=Be||je,ze(je.semver,me.semver,Ne)?me=je:Ge(je.semver,Be.semver,Ne)&&(Be=je)}),me.operator===Pe||me.operator===nt||(!Be.operator||Be.operator===Pe)&&Je(J,Be.semver)||Be.operator===nt&&Ge(J,Be.semver))return!1}return!0}ee.prototype.parse=function(J){var Ee=this.loose?A[z]:A[G],ve=J.match(Ee);if(!ve)throw new TypeError("Invalid comparator: "+J);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Q(ve[2],this.loose):this.semver=Z},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(J){return b("Comparator.test",J,this.loose),this.semver===Z||(typeof J=="string"&&(J=new Q(J,this.loose)),ue(J,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(J,Ee){if(!(J instanceof ee))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new k(J.value,Ee),oe(this.value,ve,Ee);if(J.operator==="")return ve=new k(this.value,Ee),oe(J.semver,ve,Ee);var Ne=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Je=this.semver.version===J.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Pe=ue(this.semver,"<",J.semver,Ee)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),nt=ue(this.semver,">",J.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ne||ze||Je&&Ge||Pe||nt},e.Range=k,k.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},k.prototype.toString=function(){return this.range},k.prototype.parseRange=function(J){var Ee=this.loose;J=J.trim(),b("range",J,Ee);var ve=Ee?A[re]:A[he];J=J.replace(ve,V),b("hyphen replace",J),J=J.replace(A[te],"$1$2$3"),b("comparator trim",J,A[te]),J=(J=(J=J.replace(A[U],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var Ne=Ee?A[z]:A[G],ze=J.split(" ").map(function(Je){return function(Ge,Pe){return b("comp",Ge),Ge=function(nt,X){return nt.trim().split(/\s+/).map(function(Y){return function(me,Be){b("caret",me,Be);var je=Be?A[$]:A[H];return me.replace(je,function(et,Ke,Ve,it,st){var ct;return b("caret",me,et,Ke,Ve,it,st),B(Ke)?ct="":B(Ve)?ct=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?ct=Ke==="0"?">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+".0 <"+(+Ke+1)+".0.0":st?(b("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),ct=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+st+" <"+(+Ke+1)+".0.0"):(b("no pr"),ct=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+" <"+(+Ke+1)+".0.0"),b("caret return",ct),ct})}(Y,X)}).join(" ")}(Ge,Pe),b("caret",Ge),Ge=function(nt,X){return nt.trim().split(/\s+/).map(function(Y){return function(me,Be){var je=Be?A[W]:A[C];return me.replace(je,function(et,Ke,Ve,it,st){var ct;return b("tilde",me,et,Ke,Ve,it,st),B(Ke)?ct="":B(Ve)?ct=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?ct=">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":st?(b("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),ct=">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0"):ct=">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0",b("tilde return",ct),ct})}(Y,X)}).join(" ")}(Ge,Pe),b("tildes",Ge),Ge=function(nt,X){return b("replaceXRanges",nt,X),nt.split(/\s+/).map(function(Y){return function(me,Be){me=me.trim();var je=Be?A[w]:A[p];return me.replace(je,function(et,Ke,Ve,it,st,ct){b("xRange",me,et,Ke,Ve,it,st,ct);var at=B(Ve),rt=at||B(it),_t=rt||B(st);return Ke==="="&&_t&&(Ke=""),at?et=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&_t?(rt&&(it=0),_t&&(st=0),Ke===">"?(Ke=">=",rt?(Ve=+Ve+1,it=0,st=0):_t&&(it=+it+1,st=0)):Ke==="<="&&(Ke="<",rt?Ve=+Ve+1:it=+it+1),et=Ke+Ve+"."+it+"."+st):rt?et=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":_t&&(et=">="+Ve+"."+it+".0 <"+Ve+"."+(+it+1)+".0"),b("xRange return",et),et})}(Y,X)}).join(" ")}(Ge,Pe),b("xrange",Ge),Ge=function(nt,X){return b("replaceStars",nt,X),nt.trim().replace(A[be],"")}(Ge,Pe),b("stars",Ge),Ge}(Je,Ee)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(Je){return!!Je.match(Ne)})),ze=ze.map(function(Je){return new ee(Je,Ee)})},k.prototype.intersects=function(J,Ee){if(!(J instanceof k))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ne){return J.set.some(function(ze){return ze.every(function(Je){return Ne.intersects(Je,Ee)})})})})},e.toComparators=function(J,Ee){return new k(J,Ee).set.map(function(ve){return ve.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},k.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(q(this.set[Ee],J))return!0;return!1},e.satisfies=oe,e.maxSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new k(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==-1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.minSatisfying=function(J,Ee,ve){var Ne=null,ze=null;try{var Je=new k(Ee,ve)}catch{return null}return J.forEach(function(Ge){Je.test(Ge)&&(Ne&&ze.compare(Ge)!==1||(ze=new Q(Ne=Ge,ve)))}),Ne},e.validRange=function(J,Ee){try{return new k(J,Ee).range||"*"}catch{return null}},e.ltr=function(J,Ee,ve){return ce(J,Ee,"<",ve)},e.gtr=function(J,Ee,ve){return ce(J,Ee,">",ve)},e.outside=ce,e.prerelease=function(J,Ee){var ve=fe(J,Ee);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(J,Ee,ve){return J=new k(J,ve),Ee=new k(Ee,ve),J.intersects(Ee)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var Ee=J.match(A[F]);return Ee==null?null:fe((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,r(1))},function(ne,e){var r,D,b=ne.exports={};function N(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function A(c){if(r===setTimeout)return setTimeout(c,0);if((r===N||!r)&&setTimeout)return r=setTimeout,setTimeout(c,0);try{return r(c,0)}catch{try{return r.call(null,c,0)}catch{return r.call(this,c,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:N}catch{r=N}try{D=typeof clearTimeout=="function"?clearTimeout:_}catch{D=_}})();var y,P=[],R=!1,E=-1;function m(){R&&y&&(R=!1,y.length?P=y.concat(P):E=-1,P.length&&I())}function I(){if(!R){var c=A(m);R=!0;for(var f=P.length;f;){for(y=P,P=[];++E<f;)y&&y[E].run();E=-1,f=P.length}y=null,R=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===_||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch{try{return D.call(null,v)}catch{return D.call(this,v)}}}(c)}}function g(c,f){this.fun=c,this.array=f}function l(){}b.nextTick=function(c){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];P.push(new g(c,f)),P.length!==1||R||A(I)},g.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=l,b.addListener=l,b.once=l,b.off=l,b.removeListener=l,b.removeAllListeners=l,b.emit=l,b.prependListener=l,b.prependOnceListener=l,b.listeners=function(c){return[]},b.binding=function(c){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(c){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Ie[108],Ce([1,0,12,7]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(h){const T=h;return T?typeof T.read=="function":!1}e.isReadable=b;function N(h){const T=h;return T?[T.on,T.pause,T.resume,T.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=N;function _(h){const T=h;return T?N(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(h,T){return new y(h,T)}e.newWriteableStream=A;class y{constructor(T,s){this.reducer=T,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(T){if(!this.state.destroyed){if(this.state.flowing)this.emitData(T);else if(this.buffer.data.push(T),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(T){this.state.destroyed||(this.state.flowing?this.emitError(T):this.buffer.error.push(T))}end(T){this.state.destroyed||(typeof T<"u"&&this.write(T),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(T){this.listeners.data.slice(0).forEach(s=>s(T))}emitError(T){this.listeners.error.length===0?(0,r.onUnexpectedError)(T):this.listeners.error.slice(0).forEach(s=>s(T))}emitEnd(){this.listeners.end.slice(0).forEach(T=>T())}on(T,s){if(!this.state.destroyed)switch(T){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(T,s){if(this.state.destroyed)return;let u;switch(T){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const n=u.indexOf(s);n>=0&&u.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const T=this.reducer(this.buffer.data);this.emitData(T),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const T of this.buffer.error)this.emitError(T);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(h,T){const s=[];let u;for(;(u=h.read())!==null;)s.push(u);return T(s)}e.consumeReadable=P;function R(h,T,s){const u=[];let n;for(;(n=h.read())!==null&&u.length<s;)u.push(n);return n===null&&u.length>0?T(u):{read:()=>{if(u.length>0)return u.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return h.read()}}}e.peekReadable=R;function E(h,T){return new Promise((s,u)=>{const n=[];m(h,{onData:i=>{T&&n.push(i)},onError:i=>{T?u(i):s(void 0)},onEnd:()=>{s(T?T(n):void 0)}})})}e.consumeStream=E;function m(h,T){let s=!1;return h.on("error",u=>{s||T.onError(u)}),h.on("end",()=>{s||T.onEnd()}),h.on("data",u=>{s||T.onData(u)}),(0,D.toDisposable)(()=>s=!0)}e.listenStream=m;function I(h,T){return new Promise((s,u)=>{const n=new D.DisposableStore,i=[],o=d=>{if(i.push(d),i.length>T)return n.dispose(),h.pause(),s({stream:h,buffer:i,ended:!1})},a=d=>u(d),t=()=>s({stream:h,buffer:i,ended:!0});n.add((0,D.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),n.add((0,D.toDisposable)(()=>h.removeListener("end",t))),h.on("end",t),n.add((0,D.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}e.peekStream=I;function g(h,T){const s=A(T);return s.end(h),s}e.toStream=g;function l(){const h=A(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=l;function c(h){let T=!1;return{read:()=>T?null:(T=!0,h)}}e.toReadable=c;function f(h,T,s){const u=A(s);return m(h,{onData:n=>u.write(T.data(n)),onError:n=>u.error(T.error?T.error(n):n),onEnd:()=>u.end()}),u}e.transform=f;function v(h,T,s){let u=!1;return{read:()=>{const n=T.read();return u?n:(u=!0,n!==null?s([h,n]):h)}}}e.prefixedReadable=v;function S(h,T,s){let u=!1;const n=A(s);return m(T,{onData:i=>u?n.write(i):(u=!0,n.write(s([h,i]))),onError:i=>n.error(i),onEnd:()=>{u||(u=!0,n.write(h)),n.end()}}),n}e.prefixedStream=S}),define(Ie[23],Ce([1,0,108]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let b,N;class _{static alloc(d){return D?new _(Buffer.allocUnsafe(d)):new _(new Uint8Array(d))}static wrap(d){return D&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new _(d)}static fromString(d,p){return!(p?.dontUseNodeBuffer||!1)&&D?new _(Buffer.from(d)):(b||(b=new TextEncoder),new _(b.encode(d)))}static fromByteArray(d){const p=_.alloc(d.length);for(let w=0,F=d.length;w<F;w++)p.buffer[w]=d[w];return p}static concat(d,p){if(typeof p>"u"){p=0;for(let j=0,U=d.length;j<U;j++)p+=d[j].byteLength}const w=_.alloc(p);let F=0;for(let j=0,U=d.length;j<U;j++){const C=d[j];w.set(C,F),F+=C.byteLength}return w}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=_.alloc(this.byteLength);return d.set(this),d}toString(){return D?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(d,p){return new _(this.buffer.subarray(d,p))}set(d,p){if(d instanceof _)this.buffer.set(d.buffer,p);else if(d instanceof Uint8Array)this.buffer.set(d,p);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),p);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,p){R(this.buffer,d,p)}readUInt32LE(d){return E(this.buffer,d)}writeUInt32LE(d,p){m(this.buffer,d,p)}readUInt8(d){return I(this.buffer,d)}writeUInt8(d,p){g(this.buffer,d,p)}}e.VSBuffer=_;function A(t,d){return t[d+0]<<0>>>0|t[d+1]<<8>>>0}e.readUInt16LE=A;function y(t,d,p){t[p+0]=d&255,d=d>>>8,t[p+1]=d&255}e.writeUInt16LE=y;function P(t,d){return t[d]*2**24+t[d+1]*2**16+t[d+2]*2**8+t[d+3]}e.readUInt32BE=P;function R(t,d,p){t[p+3]=d,d=d>>>8,t[p+2]=d,d=d>>>8,t[p+1]=d,d=d>>>8,t[p]=d}e.writeUInt32BE=R;function E(t,d){return t[d+0]<<0>>>0|t[d+1]<<8>>>0|t[d+2]<<16>>>0|t[d+3]<<24>>>0}e.readUInt32LE=E;function m(t,d,p){t[p+0]=d&255,d=d>>>8,t[p+1]=d&255,d=d>>>8,t[p+2]=d&255,d=d>>>8,t[p+3]=d&255}e.writeUInt32LE=m;function I(t,d){return t[d]}e.readUInt8=I;function g(t,d,p){t[p]=d}e.writeUInt8=g;function l(t){return r.consumeReadable(t,d=>_.concat(d))}e.readableToBuffer=l;function c(t){return r.toReadable(t)}e.bufferToReadable=c;function f(t){return r.consumeStream(t,d=>_.concat(d))}e.streamToBuffer=f;async function v(t){return t.ended?_.concat(t.buffer):_.concat([...t.buffer,await f(t.stream)])}e.bufferedStreamToBuffer=v;function S(t){return r.toStream(t,d=>_.concat(d))}e.bufferToStream=S;function h(t){return r.transform(t,{data:d=>typeof d=="string"?_.fromString(d):_.wrap(d)},d=>_.concat(d))}e.streamToBufferReadableStream=h;function T(t){return r.newWriteableStream(d=>_.concat(d),t)}e.newWriteableBufferStream=T;function s(t,d){return r.prefixedReadable(t,d,p=>_.concat(p))}e.prefixedBufferReadable=s;function u(t,d){return r.prefixedStream(t,d,p=>_.concat(p))}e.prefixedBufferStream=u;function n(t){let d=0,p=0,w=0;const F=new Uint8Array(Math.floor(t.length/4*3)),j=C=>{switch(p){case 3:F[w++]=d|C,p=0;break;case 2:F[w++]=d|C>>>2,d=C<<6,p=3;break;case 1:F[w++]=d|C>>>4,d=C<<4,p=2;break;default:d=C<<2,p=1}};for(let C=0;C<t.length;C++){const W=t.charCodeAt(C);if(W>=65&&W<=90)j(W-65);else if(W>=97&&W<=122)j(W-97+26);else if(W>=48&&W<=57)j(W-48+52);else if(W===43||W===45)j(62);else if(W===47||W===95)j(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${t[C]}`)}}const U=w;for(;p>0;)j(0);return _.wrap(F).slice(0,U)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:t},d=!0,p=!1){const w=p?o:i;let F="";const j=t.byteLength%3;let U=0;for(;U<t.byteLength-j;U+=3){const C=t[U+0],W=t[U+1],M=t[U+2];F+=w[C>>>2],F+=w[(C<<4|W>>>4)&63],F+=w[(W<<2|M>>>6)&63],F+=w[M&63]}if(j===1){const C=t[U+0];F+=w[C>>>2],F+=w[C<<4&63],d&&(F+="==")}else if(j===2){const C=t[U+0],W=t[U+1];F+=w[C>>>2],F+=w[(C<<4|W>>>4)&63],F+=w[W<<2&63],d&&(F+="=")}return F}e.encodeBase64=a}),define(Ie[38],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(b){return r.test(b)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const N=new Uint8Array(16),_=[];for(let A=0;A<256;A++)_.push(A.toString(16).padStart(2,"0"));return function(){b(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let y=0,P="";return P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+="-",P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P+=_[N[y++]],P}}()}),define(Ie[109],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[110],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class D{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,P=A.notIn.length;y<P;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const P=A.findTokenIndexAtOffset(y-2),R=A.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(A,y){for(let P=A;P<=y;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=D;class b{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)N(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),N(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),N(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),N(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&N(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=b;function N(_,A,y){_.has(A)?_.get(A).push(y):_.set(A,[y])}}),define(Ie[111],Ce([16,17]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Ie[112],Ce([1,0,111]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,b=D*60,N=b*24,_=N*7,A=N*30,y=N*365;function P(E,m,I){typeof E!="number"&&(E=E.getTime());const g=Math.round((new Date().getTime()-E)/1e3);if(g<-30)return(0,r.localize)(0,null,P(new Date().getTime()+g*1e3,!1));if(g<30)return(0,r.localize)(1,null);let l;return g<D?(l=g,m?l===1?I?(0,r.localize)(2,null,l):(0,r.localize)(3,null,l):I?(0,r.localize)(4,null,l):(0,r.localize)(5,null,l):l===1?I?(0,r.localize)(6,null,l):(0,r.localize)(7,null,l):I?(0,r.localize)(8,null,l):(0,r.localize)(9,null,l)):g<b?(l=Math.floor(g/D),m?l===1?I?(0,r.localize)(10,null,l):(0,r.localize)(11,null,l):I?(0,r.localize)(12,null,l):(0,r.localize)(13,null,l):l===1?I?(0,r.localize)(14,null,l):(0,r.localize)(15,null,l):I?(0,r.localize)(16,null,l):(0,r.localize)(17,null,l)):g<N?(l=Math.floor(g/b),m?l===1?I?(0,r.localize)(18,null,l):(0,r.localize)(19,null,l):I?(0,r.localize)(20,null,l):(0,r.localize)(21,null,l):l===1?I?(0,r.localize)(22,null,l):(0,r.localize)(23,null,l):I?(0,r.localize)(24,null,l):(0,r.localize)(25,null,l)):g<_?(l=Math.floor(g/N),m?l===1?(0,r.localize)(26,null,l):(0,r.localize)(27,null,l):l===1?(0,r.localize)(28,null,l):(0,r.localize)(29,null,l)):g<A?(l=Math.floor(g/_),m?l===1?I?(0,r.localize)(30,null,l):(0,r.localize)(31,null,l):I?(0,r.localize)(32,null,l):(0,r.localize)(33,null,l):l===1?I?(0,r.localize)(34,null,l):(0,r.localize)(35,null,l):I?(0,r.localize)(36,null,l):(0,r.localize)(37,null,l)):g<y?(l=Math.floor(g/A),m?l===1?I?(0,r.localize)(38,null,l):(0,r.localize)(39,null,l):I?(0,r.localize)(40,null,l):(0,r.localize)(41,null,l):l===1?I?(0,r.localize)(42,null,l):(0,r.localize)(43,null,l):I?(0,r.localize)(44,null,l):(0,r.localize)(45,null,l)):(l=Math.floor(g/y),m?l===1?I?(0,r.localize)(46,null,l):(0,r.localize)(47,null,l):I?(0,r.localize)(48,null,l):(0,r.localize)(49,null,l):l===1?I?(0,r.localize)(50,null,l):(0,r.localize)(51,null,l):I?(0,r.localize)(52,null,l):(0,r.localize)(53,null,l))}e.fromNow=P;function R(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ie[113],Ce([16,17]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Ie[44],Ce([1,0,18,9,113]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(E,m){return m&&(E.stack||E.stacktrace)?b.localize(0,null,A(E),_(E.stack)||_(E.stacktrace)):A(E)}function _(E){return Array.isArray(E)?E.join(`
`):E}function A(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?b.localize(1,null,E.message):E.message||b.localize(2,null)}function y(E=null,m=!1){if(!E)return b.localize(3,null);if(Array.isArray(E)){const I=r.coalesce(E),g=y(I[0],m);return I.length>1?b.localize(4,null,g,I.length):g}if(D.isString(E))return E;if(E.detail){const I=E.detail;if(I.error)return N(I.error,m);if(I.exception)return N(I.exception,m)}return E.stack?N(E,m):E.message?E.message:b.localize(5,null)}e.toErrorMessage=y;function P(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function R(E,m){let I;return typeof E=="string"?I=new Error(E):I=E,I.actions=m,I}e.createErrorWithActions=R}),define(Ie[78],Ce([1,0,19]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(R){const E=(0,r.extname)(R),m=D[E.toLowerCase()];return m!==void 0?m:_(R)}e.getMediaOrTextMime=N;function _(R){const E=(0,r.extname)(R);return b[E.toLowerCase()]}e.getMediaMime=_;function A(R){for(const E in b)if(b[E]===R)return E}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function P(R,E){const m=y.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:R}e.normalizeMimeType=P}),define(Ie[114],Ce([1,0,4,7]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const b=_=>({onDidChange:r.Event.None,value:_});e.staticObservableValue=b;class N extends D.Disposable{get value(){return this._value}set value(A){A!==this._value&&(this._value=A,this.changeEmitter.fire(A))}constructor(A){super(),this._value=A,this.changeEmitter=this._register(new r.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=N}),define(Ie[39],Ce([1,0,19,20,10,9]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(o){return o===47||o===92}e.isPathSeparator=_;function A(o){return o.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function y(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=y;function P(o,a=r.posix.sep){if(!o)return"";const t=o.length,d=o.charCodeAt(0);if(_(d)){if(_(o.charCodeAt(1))&&!_(o.charCodeAt(2))){let w=3;const F=w;for(;w<t&&!_(o.charCodeAt(w));w++);if(F!==w&&!_(o.charCodeAt(w+1))){for(w+=1;w<t;w++)if(_(o.charCodeAt(w)))return o.slice(0,w+1).replace(/[\\/]/g,a)}}return a}else if(f(d)&&o.charCodeAt(1)===58)return _(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let p=o.indexOf("://");if(p!==-1){for(p+=3;p<t;p++)if(_(o.charCodeAt(p)))return o.slice(0,p+1)}return""}e.getRoot=P;function R(o){if(!D.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let t=2;const d=t;for(;t<o.length&&(a=o.charCodeAt(t),a!==92);t++);return!(d===t||(a=o.charCodeAt(t+1),isNaN(a)||a===92))}e.isUNC=R;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(o,a=D.isWindows){const t=a?E:m;return!(!o||o.length===0||/^\s+$/.test(o)||(t.lastIndex=0,t.test(o))||a&&I.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=g;function l(o,a,t){const d=o===a;return!t||d?d:!o||!a?!1:(0,b.equalsIgnoreCase)(o,a)}e.isEqual=l;function c(o,a,t,d=r.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(t){if(!(0,b.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let w=a.length;return a.charAt(a.length-1)===d&&w--,o.charAt(w)===d}return a.charAt(a.length-1)!==d&&(a+=d),o.indexOf(a)===0}e.isEqualOrParent=c;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function v(o,a){return D.isWindows&&o.endsWith(":")&&(o+=r.sep),(0,r.isAbsolute)(o)||(o=(0,r.join)(a,o)),o=(0,r.normalize)(o),D.isWindows?(o=(0,b.rtrim)(o,r.sep),o.endsWith(":")&&(o+=r.sep)):(o=(0,b.rtrim)(o,r.sep),o||(o=r.sep)),o}e.sanitizeFilePath=v;function S(o){const a=(0,r.normalize)(o);return D.isWindows?o.length>3?!1:h(a)&&(o.length===2||a.charCodeAt(2)===92):a===r.posix.sep}e.isRootOrDriveLetter=S;function h(o,a=D.isWindows){return a?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function T(o){return h(o)?o[0]:void 0}e.getDriveLetter=T;function s(o,a,t){return a.length>o.length?-1:o===a?0:(t&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=s;function u(o){const a=o.split(":");let t,d,p;for(const w of a){const F=Number(w);(0,N.isNumber)(F)?d===void 0?d=F:p===void 0&&(p=F):t=t?[t,w].join(":"):w}if(!t)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:t,line:d!==void 0?d:void 0,column:p!==void 0?p:d!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,a,t=8){let d="";for(let w=0;w<t;w++)d+=n.charAt(Math.floor(Math.random()*n.length));let p;return a?p=`${a}-${d}`:p=d,o?(0,r.join)(o,p):p}e.randomPath=i}),define(Ie[24],Ce([1,0,18,10]),function(ne,e,r,D){"use strict";var b,N,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(n,i,o){let a=n.get(i);return a===void 0&&(a=o,n.set(i,a)),a}e.getOrSet=A;function y(n){const i=[];return n.forEach((o,a)=>{i.push(`${a} => ${o}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=y;function P(n){const i=[];return n.forEach(o=>{i.push(o)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return o-a}value(){return this._value[this._pos]}}e.StringIterator=R;class E{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,D.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const a=this._value.charCodeAt(o);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,D.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var I;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(I||(I={}));class g{constructor(i,o){this._ignorePathCasing=i,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,D.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(c||(c={}));class f{static forUris(i=()=>!1,o=()=>!1){return new f(new g(i,o))}static forPaths(i=!1){return new f(new m(void 0,!i))}static forStrings(){return new f(new R)}static forConfigKeys(){return new f(new E)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,o){if(o){const a=o.slice(0);(0,r.shuffle)(a);for(const t of a)this.set(t,i)}else{const a=i.slice(0);(0,r.shuffle)(a);for(const t of a)this.set(t[0],t[1])}}set(i,o){const a=this._iter.reset(i);let t;this._root||(this._root=new l,this._root.segment=a.value());const d=[];for(t=this._root;;){const w=a.cmp(t.segment);if(w>0)t.left||(t.left=new l,t.left.segment=a.value()),d.push([-1,t]),t=t.left;else if(w<0)t.right||(t.right=new l,t.right.segment=a.value()),d.push([1,t]),t=t.right;else if(a.hasNext())a.next(),t.mid||(t.mid=new l,t.mid.segment=a.value()),d.push([0,t]),t=t.mid;else break}const p=t.value;t.value=o,t.key=i;for(let w=d.length-1;w>=0;w--){const F=d[w][1];F.updateHeight();const j=F.balanceFactor();if(j<-1||j>1){const U=d[w][0],C=d[w+1][0];if(U===1&&C===1)d[w][1]=F.rotateLeft();else if(U===-1&&C===-1)d[w][1]=F.rotateRight();else if(U===1&&C===-1)F.right=d[w+1][1]=d[w+1][1].rotateRight(),d[w][1]=F.rotateLeft();else if(U===-1&&C===1)F.left=d[w+1][1]=d[w+1][1].rotateLeft(),d[w][1]=F.rotateRight();else throw new Error;if(w>0)switch(d[w-1][0]){case-1:d[w-1][1].left=d[w][1];break;case 1:d[w-1][1].right=d[w][1];break;case 0:d[w-1][1].mid=d[w][1];break}else this._root=d[0][1]}}return p}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let a=this._root;for(;a;){const t=o.cmp(a.segment);if(t>0)a=a.left;else if(t<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else break}return a}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const a=this._iter.reset(i),t=[];let d=this._root;for(;d;){const p=a.cmp(d.segment);if(p>0)t.push([-1,d]),d=d.left;else if(p<0)t.push([1,d]),d=d.right;else if(a.hasNext())a.next(),t.push([0,d]),d=d.mid;else break}if(!!d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const p=this._min(d.right);if(p.key){const{key:w,value:F,segment:j}=p;this._delete(p.key,!1),d.key=w,d.value=F,d.segment=j}}else{const p=d.left??d.right;if(t.length>0){const[w,F]=t[t.length-1];switch(w){case-1:F.left=p;break;case 0:F.mid=p;break;case 1:F.right=p;break}}else this._root=p}for(let p=t.length-1;p>=0;p--){const w=t[p][1];w.updateHeight();const F=w.balanceFactor();if(F>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),t[p][1]=w.rotateLeft()):F<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),t[p][1]=w.rotateRight()),p>0)switch(t[p-1][0]){case-1:t[p-1][1].left=t[p][1];break;case 1:t[p-1][1].right=t[p][1];break;case 0:t[p-1][1].mid=t[p][1];break}else this._root=t[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let a=this._root,t;for(;a;){const d=o.cmp(a.segment);if(d>0)a=a.left;else if(d<0)a=a.right;else if(o.hasNext())o.next(),t=a.value||t,a=a.mid;else break}return a&&a.value||t}findSuperstr(i){const o=this._iter.reset(i);let a=this._root;for(;a;){const t=o.cmp(a.segment);if(t>0)a=a.left;else if(t<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[o,a]of this)i(a,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const o=[];return this._dfsEntries(i,o),o[Symbol.iterator]()}_dfsEntries(i,o){!i||(i.left&&this._dfsEntries(i.left,o),i.value&&o.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,o),i.right&&this._dfsEntries(i.right,o))}_isBalanced(){const i=o=>{if(!o)return!0;const a=o.balanceFactor();return a<-1||a>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=f;class v{constructor(i,o){this.uri=i,this.value=o}}class S{constructor(i,o){this[b]="ResourceMap",i instanceof S?(this.map=new Map(i.map),this.toKey=o??S.defaultToKey):(this.map=new Map,this.toKey=i??S.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new v(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o<"u"&&(i=i.bind(o));for(const[a,t]of this.map)i(t.value,t.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=S,S.defaultToKey=n=>n.toString();class h{constructor(i,o){this[N]="ResourceSet",!i||typeof i=="function"?this._map=new S(i):(this._map=new S(o),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,o){this._map.forEach((a,t)=>i.call(o,t,t,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var T;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class s{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const a=this._map.get(i);if(!!a)return o!==0&&this.touch(a,o),a.value}set(i,o,a=0){let t=this._map.get(i);if(t)t.value=o,a!==0&&this.touch(t,a);else{switch(t={key:i,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(t);break;case 1:this.addItemFirst(t);break;case 2:this.addItemLast(t);break;default:this.addItemLast(t);break}this._map.set(i,t),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const a=this._state;let t=this._head;for(;t;){if(o?i.bind(o)(t.value,t.key,this):i(t.value,t.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const i=this,o=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:a.key,done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return t}values(){const i=this,o=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:a.value,done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return t}entries(){const i=this,o=this._state;let a=this._head;const t={[Symbol.iterator](){return t},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const d={value:[a.key,a.value],done:!1};return a=a.next,d}else return{value:void 0,done:!0}}};return t}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>i;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,a=i.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const a=i.next,t=i.previous;i===this._tail?(t.next=void 0,this._tail=t):(a.previous=t,t.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const a=i.next,t=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=t,t.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,a)=>{i.push([a,o])}),i}fromJSON(i){this.clear();for(const[o,a]of i)this.set(o,a)}}e.LinkedMap=s;class u extends s{constructor(i,o=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(Ie[115],Ce([1,0,24,10]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...ee){return function(Z,k){for(let B=0,V=ee.length;B<V;B++){const q=ee[B](Z,k);if(q)return q}return null}}e.or=b,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(ee,Z,k){if(!k||k.length<Z.length)return null;let B;return ee?B=D.startsWithIgnoreCase(k,Z):B=k.indexOf(Z)===0,B?Z.length>0?[{start:0,end:Z.length}]:[]:null}function _(ee,Z){const k=Z.toLowerCase().indexOf(ee.toLowerCase());return k===-1?null:[{start:k,end:k+ee.length}]}e.matchesContiguousSubString=_;function A(ee,Z){return y(ee.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=A;function y(ee,Z,k,B){if(k===ee.length)return[];if(B===Z.length)return null;if(ee[k]===Z[B]){let V=null;return(V=y(ee,Z,k+1,B+1))?f({start:B,end:B+1},V):null}return y(ee,Z,k,B+1)}function P(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function E(ee){return 48<=ee&&ee<=57}function m(ee){return ee===32||ee===9||ee===10||ee===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>I.add(ee.charCodeAt(0)));function g(ee){return m(ee)||I.has(ee)}function l(ee,Z){return ee===Z||g(ee)&&g(Z)}function c(ee){return P(ee)||R(ee)||E(ee)}function f(ee,Z){return Z.length===0?Z=[ee]:ee.end===Z[0].start?Z[0].start=ee.start:Z.unshift(ee),Z}function v(ee,Z){for(let k=Z;k<ee.length;k++){const B=ee.charCodeAt(k);if(R(B)||E(B)||k>0&&!c(ee.charCodeAt(k-1)))return k}return ee.length}function S(ee,Z,k,B){if(k===ee.length)return[];if(B===Z.length)return null;if(ee[k]!==Z[B].toLowerCase())return null;{let V=null,q=B+1;for(V=S(ee,Z,k+1,B+1);!V&&(q=v(Z,q))<Z.length;)V=S(ee,Z,k+1,q),q++;return V===null?null:f({start:B,end:B+1},V)}}function h(ee){let Z=0,k=0,B=0,V=0,q=0;for(let ve=0;ve<ee.length;ve++)q=ee.charCodeAt(ve),R(q)&&Z++,P(q)&&k++,c(q)&&B++,E(q)&&V++;const oe=Z/ee.length,ce=k/ee.length,J=B/ee.length,Ee=V/ee.length;return{upperPercent:oe,lowerPercent:ce,alphaPercent:J,numericPercent:Ee}}function T(ee){const{upperPercent:Z,lowerPercent:k}=ee;return k===0&&Z>.6}function s(ee){const{upperPercent:Z,lowerPercent:k,alphaPercent:B,numericPercent:V}=ee;return k>.2&&Z<.8&&B>.6&&V<.2}function u(ee){let Z=0,k=0,B=0,V=0;for(let q=0;q<ee.length;q++)B=ee.charCodeAt(q),R(B)&&Z++,P(B)&&k++,m(B)&&V++;return(Z===0||k===0)&&V===0?ee.length<=30:Z<=5}function n(ee,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!u(ee)||Z.length>60)return null;const k=h(Z);if(!s(k)){if(!T(k))return null;Z=Z.toLowerCase()}let B=null,V=0;for(ee=ee.toLowerCase();V<Z.length&&(B=S(ee,Z,0,V))===null;)V=v(Z,V+1);return B}e.matchesCamelCase=n;function i(ee,Z,k=!1){if(!Z||Z.length===0)return null;let B=null,V=0;for(ee=ee.toLowerCase(),Z=Z.toLowerCase();V<Z.length&&(B=o(ee,Z,0,V,k))===null;)V=a(Z,V+1);return B}e.matchesWords=i;function o(ee,Z,k,B,V){if(k===ee.length)return[];if(B===Z.length)return null;if(l(ee.charCodeAt(k),Z.charCodeAt(B))){let q=null,oe=B+1;if(q=o(ee,Z,k+1,B+1,V),!V)for(;!q&&(oe=a(Z,oe))<Z.length;)q=o(ee,Z,k+1,oe,V),oe++;return q?ee.charCodeAt(k)!==Z.charCodeAt(B)?q:f({start:B,end:B+1},q):null}else return null}function a(ee,Z){for(let k=Z;k<ee.length;k++)if(g(ee.charCodeAt(k))||k>0&&g(ee.charCodeAt(k-1)))return k;return ee.length}const t=b(e.matchesPrefix,n,_),d=b(e.matchesPrefix,n,A),p=new r.LRUCache(1e4);function w(ee,Z,k=!1){if(typeof ee!="string"||typeof Z!="string")return null;let B=p.get(ee);B||(B=new RegExp(D.convertSimple2RegExpPattern(ee),"i"),p.set(ee,B));const V=B.exec(Z);return V?[{start:V.index,end:V.index+V[0].length}]:k?d(ee,Z):t(ee,Z)}e.matchesFuzzy=w;function F(ee,Z){const k=Ue(ee,ee.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return k?U(k):null}e.matchesFuzzy2=F;function j(ee,Z,k,B,V,q){const oe=Math.min(13,ee.length);for(;k<oe;k++){const ce=Ue(ee,Z,k,B,V,q,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ce)return ce}return[0,q]}e.anyScore=j;function U(ee){if(typeof ee>"u")return[];const Z=[],k=ee[1];for(let B=ee.length-1;B>1;B--){const V=ee[B]+k,q=Z[Z.length-1];q&&q.end===V?q.end=V+1:Z.push({start:V,end:V+1})}return Z}e.createMatches=U;const C=128;function W(){const ee=[],Z=[];for(let k=0;k<=C;k++)Z[k]=0;for(let k=0;k<=C;k++)ee.push(Z.slice(0));return ee}function M(ee){const Z=[];for(let k=0;k<=ee;k++)Z[k]=0;return Z}const O=M(2*C),H=M(2*C),$=W(),z=W(),G=W(),te=!1;function he(ee,Z,k,B,V){function q(ce,J,Ee=" "){for(;ce.length<J;)ce=Ee+ce;return ce}let oe=` |   |${B.split("").map(ce=>q(ce,3)).join("|")}
`;for(let ce=0;ce<=k;ce++)ce===0?oe+=" |":oe+=`${Z[ce-1]}|`,oe+=ee[ce].slice(0,V+1).map(J=>q(J.toString(),3)).join("|")+`
`;return oe}function re(ee,Z,k,B){ee=ee.substr(Z),k=k.substr(B),console.log(he(z,ee,ee.length,k,k.length)),console.log(he(G,ee,ee.length,k,k.length)),console.log(he($,ee,ee.length,k,k.length))}function be(ee,Z){if(Z<0||Z>=ee.length)return!1;const k=ee.codePointAt(Z);switch(k){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(k)}}function le(ee,Z){if(Z<0||Z>=ee.length)return!1;switch(ee.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function fe(ee,Z,k){return Z[ee]!==k[ee]}function Q(ee,Z,k,B,V,q,oe=!1){for(;Z<k&&V<q;)ee[Z]===B[V]&&(oe&&(O[Z]=V),Z+=1),V+=1;return Z===k}e.isPatternInWord=Q;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Se;(function(ee){ee.Default=[-100,0];function Z(k){return!k||k.length===2&&k[0]===-100&&k[1]===0}ee.isDefault=Z})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Z,k){this.firstMatchCanBeWeak=Z,this.boostFullMatch=k}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ue(ee,Z,k,B,V,q,oe=Fe.default){const ce=ee.length>C?C:ee.length,J=B.length>C?C:B.length;if(k>=ce||q>=J||ce-k>J-q||!Q(Z,k,ce,V,q,J,!0))return;Xe(ce,J,k,q,Z,V);let Ee=1,ve=1,Ne=k,ze=q;const Je=[!1];for(Ee=1,Ne=k;Ne<ce;Ee++,Ne++){const Y=O[Ne],me=H[Ne],Be=Ne+1<ce?H[Ne+1]:J;for(ve=Y-q+1,ze=Y;ze<Be;ve++,ze++){let je=Number.MIN_SAFE_INTEGER,et=!1;ze<=me&&(je=ke(ee,Z,Ne,k,B,V,ze,J,q,$[Ee-1][ve-1]===0,Je));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(et=!0,Ke=je+z[Ee-1][ve-1]);const Ve=ze>Y,it=Ve?z[Ee][ve-1]+($[Ee][ve-1]>0?-5:0):0,st=ze>Y+1&&$[Ee][ve-1]>0,ct=st?z[Ee][ve-2]+($[Ee][ve-2]>0?-5:0):0;if(st&&(!Ve||ct>=it)&&(!et||ct>=Ke))z[Ee][ve]=ct,G[Ee][ve]=3,$[Ee][ve]=0;else if(Ve&&(!et||it>=Ke))z[Ee][ve]=it,G[Ee][ve]=2,$[Ee][ve]=0;else if(et)z[Ee][ve]=Ke,G[Ee][ve]=1,$[Ee][ve]=$[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(te&&re(ee,k,B,q),!Je[0]&&!oe.firstMatchCanBeWeak)return;Ee--,ve--;const Ge=[z[Ee][ve],q];let Pe=0,nt=0;for(;Ee>=1;){let Y=ve;do{const me=G[Ee][Y];if(me===3)Y=Y-2;else if(me===2)Y=Y-1;else break}while(Y>=1);Pe>1&&Z[k+Ee-1]===V[q+ve-1]&&!fe(Y+q-1,B,V)&&Pe+1>$[Ee][Y]&&(Y=ve),Y===ve?Pe++:Pe=1,nt||(nt=Y),Ee--,ve=Y-1,Ge.push(ve)}J===ce&&oe.boostFullMatch&&(Ge[0]+=2);const X=nt-ce;return Ge[0]-=X,Ge}e.fuzzyScore=Ue;function Xe(ee,Z,k,B,V,q){let oe=ee-1,ce=Z-1;for(;oe>=k&&ce>=B;)V[oe]===q[ce]&&(H[oe]=ce,oe--),ce--}function ke(ee,Z,k,B,V,q,oe,ce,J,Ee,ve){if(Z[k]!==q[oe])return Number.MIN_SAFE_INTEGER;let Ne=1,ze=!1;return oe===k-B?Ne=ee[k]===V[oe]?7:5:fe(oe,V,q)&&(oe===0||!fe(oe-1,V,q))?(Ne=ee[k]===V[oe]?7:5,ze=!0):be(q,oe)&&(oe===0||!be(q,oe-1))?Ne=5:(be(q,oe-1)||le(q,oe-1))&&(Ne=5,ze=!0),Ne>1&&k===B&&(ve[0]=!0),ze||(ze=fe(oe,V,q)||be(q,oe-1)||le(q,oe-1)),k===B?oe>J&&(Ne-=ze?3:5):Ee?Ne+=ze?2:0:Ne+=ze?0:1,oe+1===ce&&(Ne-=ze?3:5),Ne}function ye(ee,Z,k,B,V,q,oe){return ae(ee,Z,k,B,V,q,!0,oe)}e.fuzzyScoreGracefulAggressive=ye;function De(ee,Z,k,B,V,q,oe){return ae(ee,Z,k,B,V,q,!1,oe)}e.fuzzyScoreGraceful=De;function ae(ee,Z,k,B,V,q,oe,ce){let J=Ue(ee,Z,k,B,V,q,ce);if(J&&!oe)return J;if(ee.length>=3){const Ee=Math.min(7,ee.length-1);for(let ve=k+1;ve<Ee;ve++){const Ne=ue(ee,ve);if(Ne){const ze=Ue(Ne,Ne.toLowerCase(),k,B,V,q,ce);ze&&(ze[0]-=3,(!J||ze[0]>J[0])&&(J=ze))}}}return J}function ue(ee,Z){if(Z+1>=ee.length)return;const k=ee[Z],B=ee[Z+1];if(k!==B)return ee.slice(0,Z)+B+k+ee.slice(Z+2)}}),define(Ie[116],Ce([1,0,117,115,10]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const N=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${N.source}`,"g");function y(c){return c.replace(A,(f,v)=>v?f:`\\${f}`)}e.escapeIcons=y;const P=new RegExp(`\\\\${N.source}`,"g");function R(c){return c.replace(P,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=R;const E=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function m(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(E,(f,v,S,h)=>S?f:v||h||"")}e.stripIcons=m;function I(c){const f=c.indexOf(e.iconStartMarker);return f===-1?{text:c}:g(c,f)}e.parseLabelWithIcons=I;function g(c,f){const v=[];let S="";function h(t){if(t){S+=t;for(const d of t)v.push(u)}}let T=-1,s="",u=0,n,i,o=f;const a=c.length;for(h(c.substr(0,f));o<a;)n=c[o],i=c[o+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(T=o,h(s),s=e.iconStartMarker,o++):n===")"&&T!==-1?(u+=o-T+1,T=-1,s=""):T!==-1?_.test(n)?s+=n:(h(s),T=-1,s=""):h(n),o++;return h(s),{text:S,iconOffsets:v}}function l(c,f,v=!1){const{text:S,iconOffsets:h}=f;if(!h||h.length===0)return(0,D.matchesFuzzy)(c,S,v);const T=(0,b.ltrim)(S," "),s=S.length-T.length,u=(0,D.matchesFuzzy)(c,T,v);if(u)for(const n of u){const i=h[n.start+s]+s;n.start+=i,n.end+=i}return u}e.matchesFuzzyIconAware=l}),define(Ie[29],Ce([1,0,10]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(D||(D={})),function(b){const N="error",_="warning",A="warn",y="info",P="ignore";function R(m){return m?r.equalsIgnoreCase(N,m)?b.Error:r.equalsIgnoreCase(_,m)||r.equalsIgnoreCase(A,m)?b.Warning:r.equalsIgnoreCase(y,m)?b.Info:b.Ignore:b.Ignore}b.fromValue=R;function E(m){switch(m){case b.Error:return N;case b.Warning:return _;case b.Info:return y;default:return P}}b.toString=E}(D||(D={})),e.default=D}),define(Ie[79],Ce([1,0,23,10,2]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(P){return JSON.stringify(P,A)}e.stringify=N;function _(P){let R=JSON.parse(P);return R=y(R),R}e.parse=_;function A(P,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,D.regExpFlags)(R)}:R}function y(P,R=0){if(!P||R>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return b.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 15:return new Date(P.source)}if(P instanceof r.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=y(P[E],R+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=y(P[E],R+1))}return P}e.revive=y}),define(Ie[13],Ce([1,0,20,2]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${b.vscodeRemoteResource}`}set(P,R,E){this._hosts[P]=R,this._ports[P]=E}setConnectionToken(P,R){this._connectionTokens[P]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const R=P.authority;let E=this._hosts[R];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const m=this._ports[R],I=this._connectionTokens[R];let g=`path=${encodeURIComponent(P.path)}`;return typeof I=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),D.URI.from({scheme:r.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${E}:${m}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new N;class _{asBrowserUri(P,R){const E=this.toUri(P,R);return E.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===b.file&&(r.isNative||r.isWebWorker&&r.globals.origin===`${b.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?E.with({scheme:b.vscodeFileResource,authority:E.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(P,R){const E=this.toUri(P,R);return E.scheme===b.vscodeFileResource?E.with({scheme:b.file,authority:E.authority!==_.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(P,R){return D.URI.isUri(P)?P:D.URI.parse(R.toUrl(P))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var A;(function(y){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(P.get("3"));const R="vscode-coi";function E(I){let g;typeof I=="string"?g=new URL(I).searchParams:I instanceof URL?g=I.searchParams:D.URI.isUri(I)&&(g=new URL(I.toString(!0)).searchParams);const l=g?.get(R);if(!!l)return P.get(l)}y.getHeadersFromQuery=E;function m(I,g,l){if(!globalThis.crossOriginIsolated)return;const c=g&&l?"3":l?"2":"1";I instanceof URLSearchParams?I.set(R,c):I[R]=c}y.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(Ie[22],Ce([1,0,39,13,19,20,10,2]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(I){return(0,A.uriToFsPath)(I,!0)}e.originalFSPath=y;class P{constructor(g){this._ignorePathCasing=g}compare(g,l,c=!1){return g===l?0:(0,_.compare)(this.getComparisonKey(g,c),this.getComparisonKey(l,c))}isEqual(g,l,c=!1){return g===l?!0:!g||!l?!1:this.getComparisonKey(g,c)===this.getComparisonKey(l,c)}getComparisonKey(g,l=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,l,c=!1){if(g.scheme===l.scheme){if(g.scheme===D.Schemas.file)return r.isEqualOrParent(y(g),y(l),this._ignorePathCasing(g))&&g.query===l.query&&(c||g.fragment===l.fragment);if((0,e.isEqualAuthority)(g.authority,l.authority))return r.isEqualOrParent(g.path,l.path,this._ignorePathCasing(g),"/")&&g.query===l.query&&(c||g.fragment===l.fragment)}return!1}joinPath(g,...l){return A.URI.joinPath(g,...l)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return b.posix.basename(g.path)}extname(g){return b.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let l;return g.scheme===D.Schemas.file?l=A.URI.file(b.dirname(y(g))).path:(l=b.posix.dirname(g.path),g.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),l="/")),g.with({path:l})}normalizePath(g){if(!g.path.length)return g;let l;return g.scheme===D.Schemas.file?l=A.URI.file(b.normalize(y(g))).path:l=b.posix.normalize(g.path),g.with({path:l})}relativePath(g,l){if(g.scheme!==l.scheme||!(0,e.isEqualAuthority)(g.authority,l.authority))return;if(g.scheme===D.Schemas.file){const v=b.relative(y(g),y(l));return N.isWindows?r.toSlashes(v):v}let c=g.path||"/";const f=l.path||"/";if(this._ignorePathCasing(g)){let v=0;for(const S=Math.min(c.length,f.length);v<S&&!(c.charCodeAt(v)!==f.charCodeAt(v)&&c.charAt(v).toLowerCase()!==f.charAt(v).toLowerCase());v++);c=f.substr(0,v)+c.substr(v)}return b.posix.relative(c,f)}resolvePath(g,l){if(g.scheme===D.Schemas.file){const c=A.URI.file(b.resolve(y(g),l));return g.with({authority:c.authority,path:c.path})}return l=r.toPosixPath(l),g.with({path:b.posix.resolve(g.path,l)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,l){return g===l||g!==void 0&&l!==void 0&&(0,_.equalsIgnoreCase)(g,l)}hasTrailingPathSeparator(g,l=b.sep){if(g.scheme===D.Schemas.file){const c=y(g);return c.length>r.getRoot(c).length&&c[c.length-1]===l}else{const c=g.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,l=b.sep){return(0,e.hasTrailingPathSeparator)(g,l)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,l=b.sep){let c=!1;if(g.scheme===D.Schemas.file){const f=y(g);c=f!==void 0&&f.length===r.getRoot(f).length&&f[f.length-1]===l}else{l="/";const f=g.path;c=f.length===1&&f.charCodeAt(f.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(g,l)?g.with({path:g.path+"/"}):g}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(I=>I.scheme===D.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new P(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(I,g){const l=[];for(let c=0;c<I.length;c++){const f=g(I[c]);I.some((v,S)=>S===c?!1:(0,e.isEqualOrParent)(f,g(v)))||l.push(I[c])}return l}e.distinctParents=R;var E;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function g(l){const c=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(S=>{const[h,T]=S.split(":");h&&T&&c.set(h,T)});const v=l.path.substring(0,l.path.indexOf(";"));return v&&c.set(I.META_DATA_MIME,v),c}I.parseMetaData=g})(E=e.DataUri||(e.DataUri={}));function m(I,g,l){if(g){let c=I.path;return c&&c[0]!==b.posix.sep&&(c=b.posix.sep+c),I.with({scheme:l,authority:g,path:c})}return I.with({scheme:l})}e.toLocalResource=m}),define(Ie[15],Ce([1,0,21,12,4,7,22,20]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=y;function P(fe){const Q=new r.CancellationTokenSource,pe=fe(Q.token),Se=new Promise((Fe,Ue)=>{const Xe=Q.token.onCancellationRequested(()=>{Xe.dispose(),Q.dispose(),Ue(new D.CancellationError)});Promise.resolve(pe).then(ke=>{Xe.dispose(),Q.dispose(),Fe(ke)},ke=>{Xe.dispose(),Q.dispose(),Ue(ke)})});return new class{cancel(){Q.cancel()}then(Fe,Ue){return Se.then(Fe,Ue)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Se.finally(Fe)}}}e.createCancelablePromise=P;function R(fe,Q,pe){return new Promise((Se,Fe)=>{const Ue=Q.onCancellationRequested(()=>{Ue.dispose(),Se(pe)});fe.then(Se,Fe).finally(()=>Ue.dispose())})}e.raceCancellation=R;function E(fe,Q){return new Promise((pe,Se)=>{const Fe=Q.onCancellationRequested(()=>{Fe.dispose(),Se(new D.CancellationError)});fe.then(pe,Se).finally(()=>Fe.dispose())})}e.raceCancellationError=E;async function m(fe){let Q=-1;const pe=fe.map((Fe,Ue)=>Fe.then(Xe=>(Q=Ue,Xe))),Se=await Promise.race(pe);return fe.forEach((Fe,Ue)=>{Ue!==Q&&Fe.cancel()}),Se}e.raceCancellablePromises=m;function I(fe,Q,pe){let Se;const Fe=setTimeout(()=>{Se?.(void 0),pe?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(Fe)),new Promise(Ue=>Se=Ue)])}e.raceTimeout=I;function g(fe){return new Promise((Q,pe)=>{const Se=fe();y(Se)?Se.then(Q,pe):Q(Se)})}e.asPromise=g;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(pe,pe).then(Se)})}return new Promise((pe,Se)=>{this.queuedPromise.then(pe,Se)})}return this.activePromise=Q(),new Promise((pe,Se)=>{this.activePromise.then(Fe=>{this.activePromise=null,pe(Fe)},Fe=>{this.activePromise=null,Se(Fe)})})}}e.Throttler=l;class c{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=c;class f{constructor(){this.promiseMap=new Map}queue(Q,pe){const Fe=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(Q)===Fe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Fe),Fe}}e.SequencerByKey=f;const v=(fe,Q)=>{let pe=!0;const Se=setTimeout(()=>{pe=!1,Q()},fe);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(Se),pe=!1}}},S=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,pe=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,Ue)=>{this.doResolve=Fe,this.doReject=Ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?S(Se):v(pe,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class T{constructor(Q){this.delayer=new h(Q),this.throttler=new l}trigger(Q,pe){return this.delayer.trigger(()=>this.throttler.queue(Q),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Q,pe)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class u extends s{constructor(Q){super(),this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function n(fe,Q){return Q?new Promise((pe,Se)=>{const Fe=setTimeout(()=>{Ue.dispose(),pe()},fe),Ue=Q.onCancellationRequested(()=>{clearTimeout(Fe),Ue.dispose(),Se(new D.CancellationError)})}):P(pe=>n(fe,pe))}e.timeout=n;function i(fe,Q=0){const pe=setTimeout(fe,Q);return(0,N.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=i;function o(fe){const Q=[];let pe=0;const Se=fe.length;function Fe(){return pe<Se?fe[pe++]():null}function Ue(Xe){Xe!=null&&Q.push(Xe);const ke=Fe();return ke?ke.then(Ue):Promise.resolve(Q)}return Promise.resolve(null).then(Ue)}e.sequence=o;function a(fe,Q=Se=>!!Se,pe=null){let Se=0;const Fe=fe.length,Ue=()=>{if(Se>=Fe)return Promise.resolve(pe);const Xe=fe[Se++];return Promise.resolve(Xe()).then(ye=>Q(ye)?Promise.resolve(ye):Ue())};return Ue()}e.first=a;function t(fe,Q=Se=>!!Se,pe=null){if(fe.length===0)return Promise.resolve(pe);let Se=fe.length;const Fe=()=>{Se=-1;for(const Ue of fe)Ue.cancel?.()};return new Promise((Ue,Xe)=>{for(const ke of fe)ke.then(ye=>{--Se>=0&&Q(ye)?(Fe(),Ue(ye)):Se===0&&Ue(pe)}).catch(ye=>{--Se>=0&&(Fe(),Xe(ye))})})}e.firstParallel=t;class d{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Q){return this._size++,new Promise((pe,Se)=>{this.outstandingPromises.push({factory:Q,c:pe,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const pe=Q.factory();pe.then(Q.c,Q.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class p extends d{constructor(){super(1)}}e.Queue=p;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new G;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,pe=_.extUri){const Se=pe.getComparisonKey(Q);let Fe=this.queues.get(Se);return Fe||(Fe=new p,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class F{constructor(Q,pe){this._token=-1,typeof Q=="function"&&typeof pe=="number"&&this.setIfNotSet(Q,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},pe)}setIfNotSet(Q,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},pe))}}e.TimeoutTimer=F;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,pe){this.cancel(),this._token=setInterval(()=>{Q()},pe)}}e.IntervalTimer=j;class U{constructor(Q,pe){this.timeoutToken=-1,this.runner=Q,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class C{constructor(Q,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=C;class W extends U{constructor(Q,pe){super(Q,pe),this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner?.(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class M extends N.Disposable{constructor(Q,pe){super(),this.options=Q,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new N.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(Q)return;const pe=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(fe,Q)=>{const pe=requestIdleCallback(fe,typeof Q=="number"?{timeout:Q}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(pe))}}}}();class O{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function H(fe,Q,pe){let Se;for(let Fe=0;Fe<pe;Fe++)try{return await fe()}catch(Ue){Se=Ue,await n(Q)}throw Se}e.retry=H;class ${hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Q,pe,Se){return this._pending={taskId:Q,cancel:()=>Se?.(),promise:pe},pe.then(()=>this.donePending(Q),()=>this.donePending(Q)),pe}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let pe,Se;const Fe=new Promise((Ue,Xe)=>{pe=Ue,Se=Xe});this._next={run:Q,promise:Fe,promiseResolve:pe,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=$;class z{constructor(Q,pe=()=>Date.now()){this.interval=Q,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,pe)=>{this.completeCallback=Q,this.errorCallback=pe})}complete(Q){return new Promise(pe=>{this.completeCallback(Q),this.resolved=!0,pe()})}error(Q){return new Promise(pe=>{this.errorCallback(Q),this.rejected=!0,pe()})}cancel(){new Promise(Q=>{this.errorCallback(new D.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=G;var te;(function(fe){async function Q(Se){let Fe;const Ue=await Promise.all(Se.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return Ue}fe.settled=Q;function pe(Se){return new Promise(async(Fe,Ue)=>{try{await Se(Fe,Ue)}catch(Xe){Ue(Xe)}})}fe.withAsyncBody=pe})(te=e.Promises||(e.Promises={}));var he;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(he||(he={}));class re{static fromArray(Q){return new re(pe=>{pe.emitMany(Q)})}static fromPromise(Q){return new re(async pe=>{pe.emitMany(await Q)})}static fromPromises(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>pe.emitOne(await Se)))})}static merge(Q){return new re(async pe=>{await Promise.all(Q.map(async Se=>{for await(const Fe of Se)pe.emitOne(Fe)}))})}constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const pe={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(Q(pe)),this.resolve()}catch(Se){this.reject(Se)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,pe){return new re(async Se=>{for await(const Fe of Q)Se.emitOne(pe(Fe))})}map(Q){return re.map(this,Q)}static filter(Q,pe){return new re(async Se=>{for await(const Fe of Q)pe(Fe)&&Se.emitOne(Fe)})}filter(Q){return re.filter(this,Q)}static coalesce(Q){return re.filter(Q,pe=>!!pe)}coalesce(){return re.coalesce(this)}static async toPromise(Q){const pe=[];for await(const Se of Q)pe.push(Se);return pe}toPromise(){return re.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class be extends re{constructor(Q,pe){super(pe),this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function le(fe){const Q=new r.CancellationTokenSource,pe=fe(Q.token);return new be(Q,async Se=>{const Fe=Q.token.onCancellationRequested(()=>{Fe.dispose(),Q.dispose(),Se.reject(new D.CancellationError)});try{for await(const Ue of pe){if(Q.token.isCancellationRequested)return;Se.emitOne(Ue)}Fe.dispose(),Q.dispose()}catch(Ue){Fe.dispose(),Q.dispose(),Se.reject(Ue)}})}e.createCancelableAsyncIterable=le}),define(Ie[118],Ce([1,0,15,19]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new r.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),N=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(p,w,F=!1){const j=p||"",U=w||"",C=b.value.collator.compare(j,U);return b.value.collatorIsNumeric&&C===0&&j!==U?j<U?-1:1:C}e.compareFileNames=A;function y(p,w){const F=N.value.collator;return p=p||"",w=w||"",T(F,p,w)}e.compareFileNamesDefault=y;function P(p,w){const F=N.value.collator;return p=p||"",w=w||"",i(p,w)||T(F,p,w)}e.compareFileNamesUpper=P;function R(p,w){const F=N.value.collator;return p=p||"",w=w||"",n(p,w)||T(F,p,w)}e.compareFileNamesLower=R;function E(p,w){return p=p||"",w=w||"",p===w?0:p<w?-1:1}e.compareFileNamesUnicode=E;function m(p,w,F=!1){F||(p=p&&p.toLowerCase(),w=w&&w.toLowerCase());const[j,U]=S(p),[C,W]=S(w);return j!==C?j<C?-1:1:U===W?0:U<W?-1:1}e.noIntlCompareFileNames=m;function I(p,w){const[F,j]=S(p),[U,C]=S(w);let W=b.value.collator.compare(j,C);if(W===0){if(b.value.collatorIsNumeric&&j!==C)return j<C?-1:1;if(W=b.value.collator.compare(F,U),b.value.collatorIsNumeric&&W===0&&F!==U)return F<U?-1:1}return W}e.compareFileExtensions=I;function g(p,w){p=p||"",w=w||"";const F=h(p),j=h(w),U=N.value.collator,C=_.value.collator;return T(C,F,j)||T(U,p,w)}e.compareFileExtensionsDefault=g;function l(p,w){p=p||"",w=w||"";const F=h(p),j=h(w),U=N.value.collator,C=_.value.collator;return T(C,F,j)||i(p,w)||T(U,p,w)}e.compareFileExtensionsUpper=l;function c(p,w){p=p||"",w=w||"";const F=h(p),j=h(w),U=N.value.collator,C=_.value.collator;return T(C,F,j)||n(p,w)||T(U,p,w)}e.compareFileExtensionsLower=c;function f(p,w){p=p||"",w=w||"";const F=h(p).toLowerCase(),j=h(w).toLowerCase();return F!==j?F<j?-1:1:p!==w?p<w?-1:1:0}e.compareFileExtensionsUnicode=f;const v=/^(.*?)(\.([^.]*))?$/;function S(p,w=!1){const F=p?v.exec(p):[];let j=[F&&F[1]||"",F&&F[3]||""];return w&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function h(p){const w=p?v.exec(p):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function T(p,w,F){const j=p.compare(w,F);return j!==0?j:w.length!==F.length?w.length<F.length?-1:1:0}function s(p){const w=p.charAt(0);return w.toLocaleUpperCase()!==w}function u(p){const w=p.charAt(0);return w.toLocaleLowerCase()!==w}function n(p,w){return s(p)&&u(w)?-1:u(p)&&s(w)?1:0}function i(p,w){return u(p)&&s(w)?-1:s(p)&&u(w)?1:0}function o(p,w,F=!1){return F||(p=p&&p.toLowerCase(),w=w&&w.toLowerCase()),p===w?0:p<w?-1:1}function a(p,w,F=!1){const j=p.split(D.sep),U=w.split(D.sep),C=j.length-1,W=U.length-1;let M,O;for(let H=0;;H++){if(M=C===H,O=W===H,M&&O)return A(j[H],U[H],F);if(M)return-1;if(O)return 1;const $=o(j[H],U[H],F);if($!==0)return $}}e.comparePaths=a;function t(p,w,F){const j=p.toLowerCase(),U=w.toLowerCase(),C=d(p,w,F);if(C)return C;const W=j.endsWith(F),M=U.endsWith(F);if(W!==M)return W?-1:1;const O=A(j,U);return O!==0?O:j.localeCompare(U)}e.compareAnything=t;function d(p,w,F){const j=p.toLowerCase(),U=w.toLowerCase(),C=j.startsWith(F),W=U.startsWith(F);if(C!==W)return C?-1:1;if(C&&W){if(j.length<U.length)return-1;if(j.length>U.length)return 1}return 0}e.compareByPrefix=d}),define(Ie[34],Ce([1,0,18,15,39,24,19,20,10]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",E="[^/\\\\]",m=/\//g;function I(G,te){switch(G){case 0:return"";case 1:return`${E}*?`;default:return`(?:${R}|${E}+${R}${te?`|${R}${E}+`:""})*?`}}function g(G,te){if(!G)return[];const he=[];let re=!1,be=!1,le="";for(const fe of G){switch(fe){case te:if(!re&&!be){he.push(le),le="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":be=!0;break;case"]":be=!1;break}le+=fe}return le&&he.push(le),he}e.splitGlobAware=g;function l(G){if(!G)return"";let te="";const he=g(G,e.GLOB_SPLIT);if(he.every(re=>re===e.GLOBSTAR))te=".*";else{let re=!1;he.forEach((be,le)=>{if(be===e.GLOBSTAR){if(re)return;te+=I(2,le===he.length-1)}else{let fe=!1,Q="",pe=!1,Se="";for(const Fe of be){if(Fe!=="}"&&fe){Q+=Fe;continue}if(pe&&(Fe!=="]"||!Se)){let Ue;Fe==="-"?Ue=Fe:(Fe==="^"||Fe==="!")&&!Se?Ue="^":Fe===e.GLOB_SPLIT?Ue="":Ue=(0,y.escapeRegExpCharacters)(Fe),Se+=Ue;continue}switch(Fe){case"{":fe=!0;continue;case"[":pe=!0;continue;case"}":{te+=`(?:${g(Q,",").map(ke=>l(ke)).join("|")})`,fe=!1,Q="";break}case"]":{te+="["+Se+"]",pe=!1,Se="";break}case"?":te+=E;continue;case"*":te+=I(1);continue;default:te+=(0,y.escapeRegExpCharacters)(Fe)}}le<he.length-1&&(he[le+1]!==e.GLOBSTAR||le+2<he.length)&&(te+=R)}re=be===e.GLOBSTAR})}return te}const c=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,T=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new N.LRUCache(1e4),u=function(){return!1},n=function(){return null};function i(G,te){if(!G)return n;let he;typeof G!="string"?he=G.pattern:he=G,he=he.trim();const re=`${he}_${!!te.trimForExclusions}`;let be=s.get(re);if(be)return o(be,G);let le;return c.test(he)?be=t(he.substr(4),he):(le=f.exec(a(he,te)))?be=d(le[1],he):(te.trimForExclusions?S:v).test(he)?be=p(he,te):(le=h.exec(a(he,te)))?be=w(le[1].substr(1),he,!0):(le=T.exec(a(he,te)))?be=w(le[1],he,!1):be=F(he),s.set(re,be),o(be,G)}function o(G,te){if(typeof te=="string")return G;const he=function(re,be){return(0,b.isEqualOrParent)(re,te.base,!A.isLinux)?G(re.substr(te.base.length+1),be):null};return he.allBasenames=G.allBasenames,he.allPaths=G.allPaths,he.basenames=G.basenames,he.patterns=G.patterns,he}function a(G,te){return te.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function t(G,te){return function(he,re){return typeof he=="string"&&he.endsWith(G)?te:null}}function d(G,te){const he=`/${G}`,re=`\\${G}`,be=function(fe,Q){return typeof fe!="string"?null:Q?Q===G?te:null:fe===G||fe.endsWith(he)||fe.endsWith(re)?te:null},le=[G];return be.basenames=le,be.patterns=[te],be.allBasenames=le,be}function p(G,te){const he=$(G.slice(1,-1).split(",").map(Q=>i(Q,te)).filter(Q=>Q!==n),G),re=he.length;if(!re)return n;if(re===1)return he[0];const be=function(Q,pe){for(let Se=0,Fe=he.length;Se<Fe;Se++)if(he[Se](Q,pe))return G;return null},le=he.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=he.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function w(G,te,he){const re=_.sep===_.posix.sep,be=re?G:G.replace(m,_.sep),le=_.sep+be,fe=_.posix.sep+G;let Q;return he?Q=function(pe,Se){return typeof pe=="string"&&(pe===be||pe.endsWith(le)||!re&&(pe===G||pe.endsWith(fe)))?te:null}:Q=function(pe,Se){return typeof pe=="string"&&(pe===be||!re&&pe===G)?te:null},Q.allPaths=[(he?"*/":"./")+G],Q}function F(G){try{const te=new RegExp(`^${l(G)}$`);return function(he){return te.lastIndex=0,typeof he=="string"&&te.test(he)?G:null}}catch{return n}}function j(G,te,he){return!G||typeof te!="string"?!1:U(G)(te,void 0,he)}e.match=j;function U(G,te={}){if(!G)return u;if(typeof G=="string"||C(G)){const he=i(G,te);if(he===n)return u;const re=function(be,le){return!!he(be,le)};return he.allBasenames&&(re.allBasenames=he.allBasenames),he.allPaths&&(re.allPaths=he.allPaths),re}return O(G,te)}e.parse=U;function C(G){const te=G;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.isRelativePattern=C;function W(G){return G.allBasenames||[]}e.getBasenameTerms=W;function M(G){return G.allPaths||[]}e.getPathTerms=M;function O(G,te){const he=$(Object.getOwnPropertyNames(G).map(Q=>H(Q,G[Q],te)).filter(Q=>Q!==n)),re=he.length;if(!re)return n;if(!he.some(Q=>!!Q.requiresSiblings)){if(re===1)return he[0];const Q=function(Fe,Ue){let Xe;for(let ke=0,ye=he.length;ke<ye;ke++){const De=he[ke](Fe,Ue);if(typeof De=="string")return De;(0,D.isThenable)(De)&&(Xe||(Xe=[]),Xe.push(De))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},pe=he.find(Fe=>!!Fe.allBasenames);pe&&(Q.allBasenames=pe.allBasenames);const Se=he.reduce((Fe,Ue)=>Ue.allPaths?Fe.concat(Ue.allPaths):Fe,[]);return Se.length&&(Q.allPaths=Se),Q}const be=function(Q,pe,Se){let Fe,Ue;for(let Xe=0,ke=he.length;Xe<ke;Xe++){const ye=he[Xe];ye.requiresSiblings&&Se&&(pe||(pe=(0,_.basename)(Q)),Fe||(Fe=pe.substr(0,pe.length-(0,_.extname)(Q).length)));const De=ye(Q,pe,Fe,Se);if(typeof De=="string")return De;(0,D.isThenable)(De)&&(Ue||(Ue=[]),Ue.push(De))}return Ue?(async()=>{for(const Xe of Ue){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},le=he.find(Q=>!!Q.allBasenames);le&&(be.allBasenames=le.allBasenames);const fe=he.reduce((Q,pe)=>pe.allPaths?Q.concat(pe.allPaths):Q,[]);return fe.length&&(be.allPaths=fe),be}function H(G,te,he){if(te===!1)return n;const re=i(G,he);if(re===n)return n;if(typeof te=="boolean")return re;if(te){const be=te.when;if(typeof be=="string"){const le=(fe,Q,pe,Se)=>{if(!Se||!re(fe,Q))return null;const Fe=be.replace("$(basename)",pe),Ue=Se(Fe);return(0,D.isThenable)(Ue)?Ue.then(Xe=>Xe?G:null):Ue?G:null};return le.requiresSiblings=!0,le}}return re}function $(G,te){const he=G.filter(Q=>!!Q.basenames);if(he.length<2)return G;const re=he.reduce((Q,pe)=>{const Se=pe.basenames;return Se?Q.concat(Se):Q},[]);let be;if(te){be=[];for(let Q=0,pe=re.length;Q<pe;Q++)be.push(te)}else be=he.reduce((Q,pe)=>{const Se=pe.patterns;return Se?Q.concat(Se):Q},[]);const le=function(Q,pe){if(typeof Q!="string")return null;if(!pe){let Fe;for(Fe=Q.length;Fe>0;Fe--){const Ue=Q.charCodeAt(Fe-1);if(Ue===47||Ue===92)break}pe=Q.substr(Fe)}const Se=re.indexOf(pe);return Se!==-1?be[Se]:null};le.basenames=re,le.patterns=be,le.allBasenames=re;const fe=G.filter(Q=>!Q.basenames);return fe.push(le),fe}function z(G,te){return(0,r.equals)(G,te,(he,re)=>typeof he=="string"&&typeof re=="string"?he===re:typeof he!="string"&&typeof re!="string"?he.base===re.base&&he.pattern===re.pattern:!1)}e.patternsEquals=z}),define(Ie[80],Ce([1,0,12,116,22,10,2]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",v=!1){if(this.value=f,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(f,v=0){return this.value+=m(this.supportThemeIcons?(0,D.escapeIcons)(f):f).replace(/([ \t]+)/g,(S,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,v){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(f,v,S){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(f),")"),S&&(this.value+=` "${this._escape(this._escape(S,'"'),")")}"`),this.value+=")",this}_escape(f,v){const S=new RegExp((0,N.escapeRegExpCharacters)(v),"g");return f.replace(S,(h,T)=>f.charAt(T-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=y;function P(c){return R(c)?!c.value:Array.isArray(c)?c.every(P):!0}e.isEmptyMarkdownString=P;function R(c){return c instanceof y?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function E(c,f){return c===f?!0:!c||!f?!1:c.value===f.value&&c.isTrusted===f.isTrusted&&c.supportThemeIcons===f.supportThemeIcons&&c.supportHtml===f.supportHtml&&(c.baseUri===f.baseUri||!!c.baseUri&&!!f.baseUri&&(0,b.isEqual)(_.URI.from(c.baseUri),_.URI.from(f.baseUri)))}e.markdownStringEqual=E;function m(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function I(c){return c.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function g(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function l(c){const f=[],v=c.split("|").map(h=>h.trim());c=v[0];const S=v[1];if(S){const h=/height=(\d+)/.exec(S),T=/width=(\d+)/.exec(S),s=h?h[1]:"",u=T?T[1]:"",n=isFinite(parseInt(u)),i=isFinite(parseInt(s));n&&f.push(`width="${u}"`),i&&f.push(`height="${s}"`)}return{href:c,dimensions:f}}e.parseHrefAndDimensions=l}),define(Ie[81],Ce([1,0,18,39,19,20,22,10]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(n,i){const{os:o,tildify:a,relative:t}=i;if(t){const w=P(n,t,o);if(typeof w=="string")return w}let d=n.fsPath;if(o===1&&!N.isWindows?d=d.replace(/\//g,"\\"):o!==1&&N.isWindows&&(d=d.replace(/\\/g,"/")),o!==1&&a?.userHome){const w=a.userHome.fsPath;let F;n.scheme!==a.userHome.scheme&&n.path.startsWith(b.posix.sep)?F=a.userHome.with({path:n.path}).fsPath:F=n.fsPath,d=m(F,w,o)}return(o===1?b.win32:b.posix).normalize(R(d,o===1))}e.getPathLabel=y;function P(n,i,o){const a=o===1?b.win32:b.posix,t=o===3?_.extUri:_.extUriIgnorePathCase,d=i.getWorkspace(),p=(0,r.firstOrDefault)(d.folders);if(!p)return;n.scheme!==p.uri.scheme&&n.path.startsWith(b.posix.sep)&&(n=p.uri.with({path:n.path}));const w=i.getWorkspaceFolder(n);if(!w)return;let F;if(t.isEqual(w.uri,n)?F="":F=t.relativePath(w.uri,n)??"",F&&(F=a.normalize(F)),d.folders.length>1&&!i.noPrefix){const j=w.name?w.name:t.basenameOrAuthority(w.uri);F=F?`${j} \u2022 ${F}`:j}return F}function R(n,i=N.isWindows){return(0,D.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let E=Object.create(null);function m(n,i,o=N.OS){if(o===1||!n||!i)return n;let a=E.original===i?E.normalized:void 0;a||(a=i,N.isWindows&&(a=(0,D.toSlashes)(a)),a=`${(0,A.rtrim)(a,b.posix.sep)}${b.posix.sep}`,E={original:i,normalized:a});let t=n;return N.isWindows&&(t=(0,D.toSlashes)(t)),(o===3?t.startsWith(a):(0,A.startsWithIgnoreCase)(t,a))?`~/${t.substr(a.length)}`:n}e.tildify=m;function I(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=I;const g="\u2026",l="\\\\",c="~";function f(n,i=b.sep){const o=new Array(n.length);let a=!1;for(let t=0;t<n.length;t++){const d=n[t];if(d===""){o[t]=`.${i}`;continue}if(!d){o[t]=d;continue}a=!0;let p="",w=d;w.indexOf(l)===0?(p=w.substr(0,w.indexOf(l)+l.length),w=w.substr(w.indexOf(l)+l.length)):w.indexOf(i)===0?(p=w.substr(0,w.indexOf(i)+i.length),w=w.substr(w.indexOf(i)+i.length)):w.indexOf(c)===0&&(p=w.substr(0,w.indexOf(c)+c.length),w=w.substr(w.indexOf(c)+c.length));const F=w.split(i);for(let j=1;a&&j<=F.length;j++)for(let U=F.length-j;a&&U>=0;U--){a=!1;let C=F.slice(U,U+j).join(i);for(let W=0;!a&&W<n.length;W++)if(W!==t&&n[W]&&n[W].indexOf(C)>-1){const M=U+j===F.length,O=U>0&&n[W].indexOf(i)>-1?i+C:C,H=n[W].endsWith(O);a=!M||H}if(!a){let W="";(F[0].endsWith(":")||p!=="")&&(U===1&&(U=0,j++,C=F[0]+i+C),U>0&&(W=F[0]+i),W=p+W),U>0&&(W=W+g+i),W=W+C,U+j<F.length&&(W=W+i+g),o[t]=W}}a&&(o[t]=d)}return o}e.shorten=f;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function S(n,i=Object.create(null)){const o=[];let a=!1,t="";for(const d of n)if(d==="$"||a&&d==="{")t&&o.push({value:t,type:v.TEXT}),t="",a=!0;else if(d==="}"&&a){const p=i[t];if(typeof p=="string")p.length&&o.push({value:p,type:v.VARIABLE});else if(p){const w=o[o.length-1];(!w||w.type!==v.SEPARATOR)&&o.push({value:p.label,type:v.SEPARATOR})}t="",a=!1}else t+=d;return t&&!a&&o.push({value:t,type:v.TEXT}),o.filter((d,p)=>{if(d.type===v.SEPARATOR){const w=o[p-1],F=o[p+1];return[w,F].every(j=>j&&(j.type===v.VARIABLE||j.type===v.TEXT)&&j.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=S;function h(n,i){return N.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function T(n,i){return N.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):N.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=T;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(n){const i=n.indexOf("/")!==-1?b.posix:b.win32,o=i.basename(n),a=i.dirname(n);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=u}),define(Ie[119],Ce([1,0,2]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(R){return R.toJSON()}class b{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:D(r.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:D(r.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:r.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function N(R,E,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof r.URI)return E.transformOutgoing(R);for(const I in R)if(Object.hasOwnProperty.call(R,I)){const g=N(R[I],E,m+1);g!==null&&(R[I]=g)}}return null}function _(R,E){const m=N(R,E,0);return m===null?R:m}e.transformOutgoingURIs=_;function A(R,E,m,I){if(!R||I>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?r.URI.revive(E.transformIncoming(R)):E.transformIncoming(R);for(const g in R)if(Object.hasOwnProperty.call(R,g)){const l=A(R[g],E,m,I+1);l!==null&&(R[g]=l)}}return null}function y(R,E){const m=A(R,E,!1,0);return m===null?R:m}e.transformIncomingURIs=y;function P(R,E){const m=A(R,E,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=P}),define(Ie[120],Ce([1,0,34,19]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(N,_,A,y,P,R){if(Array.isArray(N)){let E=0;for(const m of N){const I=b(m,_,A,y,P,R);if(I===10)return I;I>E&&(E=I)}return E}else{if(typeof N=="string")return y?N==="*"?5:N===A?10:0:0;if(N){const{language:E,pattern:m,scheme:I,hasAccessToAllModels:g,notebookType:l}=N;if(!y&&!g)return 0;l&&P&&(_=P);let c=0;if(I)if(I===_.scheme)c=10;else if(I==="*")c=5;else return 0;if(E)if(E===A)c=10;else if(E==="*")c=Math.max(c,5);else return 0;if(l)if(l===R)c=10;else if(l==="*"&&R!==void 0)c=Math.max(c,5);else return 0;if(m){let f;if(typeof m=="string"?f=m:f={...m,base:(0,D.normalize)(m.base)},f===_.fsPath||(0,r.match)(f,_.fsPath))c=10;else return 0}return c}else return 0}}e.score=b}),define(Ie[82],Ce([1,0,23,20]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(b||(b={}));function N(E){for(let m=0,I=E.length;m<I;m+=4){const g=E[m+0],l=E[m+1],c=E[m+2],f=E[m+3];E[m+0]=f,E[m+1]=c,E[m+2]=l,E[m+3]=g}}function _(E){const m=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return D.isLittleEndian()||N(m),r.VSBuffer.wrap(m)}function A(E){const m=E.buffer;if(D.isLittleEndian()||N(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const I=new Uint8Array(m.byteLength);return I.set(m),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function y(E){const m=new Uint32Array(P(E));let I=0;if(m[I++]=E.id,E.type==="full")m[I++]=1,m[I++]=E.data.length,m.set(E.data,I),I+=E.data.length;else{m[I++]=2,m[I++]=E.deltas.length;for(const g of E.deltas)m[I++]=g.start,m[I++]=g.deleteCount,g.data?(m[I++]=g.data.length,m.set(g.data,I),I+=g.data.length):m[I++]=0}return _(m)}e.encodeSemanticTokensDto=y;function P(E){let m=0;if(m+=1+1,E.type==="full")m+=1+E.data.length;else{m+=1,m+=(1+1+1)*E.deltas.length;for(const I of E.deltas)I.data&&(m+=I.data.length)}return m}function R(E){const m=A(E);let I=0;const g=m[I++];if(m[I++]===1){const v=m[I++],S=m.subarray(I,I+v);return I+=v,{id:g,type:"full",data:S}}const c=m[I++],f=[];for(let v=0;v<c;v++){const S=m[I++],h=m[I++],T=m[I++];let s;T>0&&(s=m.subarray(I,I+T),I+=T),f[v]={start:S,deleteCount:h,data:s}}return{id:g,type:"delta",deltas:f}}e.decodeSemanticTokensDto=R}),define(Ie[121],Ce([16,17]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Ie[122],Ce([1,0,121,20,123,18,25,109]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=P;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class E{constructor(Y,me,Be,je){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=je}applyUpdate(Y,me){return I(Y,me)}compute(Y,me,Be){return Be}}class m{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=m;function I(X,Y){if(typeof X!="object"||typeof Y!="object"||!X||!Y)return new m(Y,X!==Y);if(Array.isArray(X)||Array.isArray(Y)){const Be=Array.isArray(X)&&Array.isArray(Y)&&N.equals(X,Y);return new m(Y,!Be)}let me=!1;for(const Be in Y)if(Y.hasOwnProperty(Be)){const je=I(X[Be],Y[Be]);je.didChange&&(X[Be]=je.newValue,me=!0)}return new m(X,me)}class g{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return I(Y,me)}validate(Y){return this.defaultValue}}class l{constructor(Y,me,Be,je){this.id=Y,this.name=me,this.defaultValue=Be,this.schema=je}applyUpdate(Y,me){return I(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,Be){return Be}}function c(X,Y){return typeof X>"u"?Y:X==="false"?!1:Boolean(X)}e.boolean=c;class f extends l{constructor(Y,me,Be,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Be),super(Y,me,Be,je)}validate(Y){return c(Y,this.defaultValue)}}function v(X,Y,me,Be){if(typeof X>"u")return Y;let je=parseInt(X,10);return isNaN(je)?Y:(je=Math.max(me,je),je=Math.min(Be,je),je|0)}e.clampedInt=v;class S extends l{static clampedInt(Y,me,Be,je){return v(Y,me,Be,je)}constructor(Y,me,Be,je,et,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Be,Ke.minimum=je,Ke.maximum=et),super(Y,me,Be,Ke),this.minimum=je,this.maximum=et}validate(Y){return S.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class h extends l{static clamp(Y,me,Be){return Y<me?me:Y>Be?Be:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const Be=parseFloat(Y);return isNaN(Be)?me:Be}constructor(Y,me,Be,je,et){typeof et<"u"&&(et.type="number",et.default=Be),super(Y,me,Be,et),this.validationFn=je}validate(Y){return this.validationFn(h.float(Y,this.defaultValue))}}class T extends l{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,Be,je=void 0){typeof je<"u"&&(je.type="string",je.default=Be),super(Y,me,Be,je)}validate(Y){return T.string(Y,this.defaultValue)}}function s(X,Y,me){return typeof X!="string"||me.indexOf(X)===-1?Y:X}e.stringSet=s;class u extends l{constructor(Y,me,Be,je,et=void 0){typeof et<"u"&&(et.type="string",et.enum=je,et.default=Be),super(Y,me,Be,et),this._allowedValues=je}validate(Y){return s(Y,this.defaultValue,this._allowedValues)}}class n extends E{constructor(Y,me,Be,je,et,Ke,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=et,Ve.default=je),super(Y,me,Be,Ve),this._allowedValues=et,this._convert=Ke}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function i(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",tags:["accessibility"],description:r.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,Be){return Be===0?Y.accessibilitySupport:Be}}class a extends E{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:c(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var t;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(t=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function d(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(X){switch(X){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function F(X){switch(X){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class j extends g{constructor(){super(130)}compute(Y,me,Be){const je=["monaco-editor"];return me.get(34)&&je.push(me.get(34)),Y.extraEditorClassName&&je.push(Y.extraEditorClassName),me.get(67)==="default"?je.push("mouse-default"):me.get(67)==="copy"&&je.push("mouse-copy"),me.get(101)&&je.push("showUnused"),me.get(128)&&je.push("showDeprecated"),je.join(" ")}}class U extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Y,me,Be){return Be&&Y.emptySelectionClipboard}}class C extends E{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:r.localize(16,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:r.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:c(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":s(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":s(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(me.loop,this.defaultValue.loop)}}}class W extends E{constructor(){super(46,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?W.OFF:Y==="true"?W.ON:Y:Boolean(Y)?W.ON:W.OFF}}e.EditorFontLigatures=W,W.OFF='"liga" off, "calt" off',W.ON='"liga" on, "calt" on';class M extends g{constructor(){super(45)}compute(Y,me,Be){return Y.fontInfo}}class O extends l{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Y){const me=h.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(Y,me,Be){return Y.fontInfo.fontSize}}class H extends E{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(S.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class $ extends E{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Be,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Be,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Be,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Be,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Be,description:r.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:s(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??s(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??s(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??s(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??s(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??s(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends E{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:r.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:c(me.enabled,this.defaultValue.enabled),delay:S.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:c(me.sticky,this.defaultValue.sticky),above:c(me.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class te extends g{constructor(){super(133)}compute(Y,me,Be){return te.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,Be=Y.scrollBeyondLastLine?me-1:0,je=(Y.viewLineCount+Be)/(Y.pixelRatio*Y.height),et=Math.floor(Y.viewLineCount/je);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Be,desiredRatio:je,minimapLineCount:et}}static _computeMinimapLayout(Y,me){const Be=Y.outerWidth,je=Y.outerHeight,et=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ke=me.stableMinimapLayoutInput,Ve=Ke&&Y.outerHeight===Ke.outerHeight&&Y.lineHeight===Ke.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ke.pixelRatio&&Y.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Y.minimap.enabled===Ke.minimap.enabled&&Y.minimap.side===Ke.minimap.side&&Y.minimap.size===Ke.minimap.size&&Y.minimap.showSlider===Ke.minimap.showSlider&&Y.minimap.renderCharacters===Ke.minimap.renderCharacters&&Y.minimap.maxColumn===Ke.minimap.maxColumn&&Y.minimap.scale===Ke.minimap.scale&&Y.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Y.isViewportWrapping===Ke.isViewportWrapping,it=Y.lineHeight,st=Y.typicalHalfwidthCharacterWidth,ct=Y.scrollBeyondLastLine,at=Y.minimap.renderCharacters;let rt=et>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const _t=Y.minimap.maxColumn,Rt=Y.minimap.size,Ot=Y.minimap.side,mt=Y.verticalScrollbarWidth,yt=Y.viewLineCount,Lt=Y.remainingWidth,Mt=Y.isViewportWrapping,qe=at?2:3;let zt=Math.floor(et*je);const Ft=zt/et;let Tt=!1,ft=!1,It=qe*rt,_e=rt/et,Te=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:gt,desiredRatio:vt,minimapLineCount:Ct}=te.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:ct,height:je,lineHeight:it,pixelRatio:et});if(yt/Ct>1)Tt=!0,ft=!0,rt=1,It=1,_e=rt/et;else{let Et=!1,pt=rt+1;if(Rt==="fit"){const wt=Math.ceil((yt+gt)*It);Mt&&Ve&&Lt<=me.stableFitRemainingWidth?(Et=!0,pt=me.stableFitMaxMinimapScale):Et=wt>zt}if(Rt==="fill"||Et){Tt=!0;const wt=rt;It=Math.min(it*et,Math.max(1,Math.floor(1/vt))),Mt&&Ve&&Lt<=me.stableFitRemainingWidth&&(pt=me.stableFitMaxMinimapScale),rt=Math.min(pt,Math.max(1,Math.floor(It/qe))),rt>wt&&(Te=Math.min(2,rt/wt)),_e=rt/et/Te,zt=Math.ceil(Math.max(tt,yt+gt)*It),Mt?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=Lt,me.stableFitMaxMinimapScale=rt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ge=Math.floor(_t*_e),K=Math.min(ge,Math.max(0,Math.floor((Lt-mt-2)*_e/(st+_e)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(et*K);const Me=Ae/et;Ae=Math.floor(Ae*Te);const Ze=at?1:2,We=Ot==="left"?0:Be-K-mt;return{renderMinimap:Ze,minimapLeft:We,minimapWidth:K,minimapHeightIsEditorHeight:Tt,minimapIsSampling:ft,minimapScale:rt,minimapLineHeight:It,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Ft}}static computeLayout(Y,me){const Be=me.outerWidth|0,je=me.outerHeight|0,et=me.lineHeight|0,Ke=me.lineNumbersDigitCount|0,Ve=me.typicalHalfwidthCharacterWidth,it=me.maxDigitWidth,st=me.pixelRatio,ct=me.viewLineCount,at=Y.get(125),rt=at==="inherit"?Y.get(124):at,_t=rt==="inherit"?Y.get(120):rt,Rt=Y.get(123),Ot=Y.get(2),mt=me.isDominatedByLongLines,yt=Y.get(51),Lt=Y.get(61).renderType!==0,Mt=Y.get(62),qe=Y.get(95),zt=Y.get(66),Ft=Y.get(93),Tt=Ft.verticalScrollbarSize,ft=Ft.verticalHasArrows,It=Ft.arrowSize,_e=Ft.horizontalScrollbarSize,Te=Y.get(59),ge=Y.get(38),K=Y.get(100)!=="never";let Ae;if(typeof Te=="string"&&/^\d+(\.\d+)?ch$/.test(Te)){const $t=parseFloat(Te.substr(0,Te.length-2));Ae=S.clampedInt($t*Ve,0,0,1e3)}else Ae=S.clampedInt(Te,0,0,1e3);ge&&K&&(Ae+=16);let Me=0;if(Lt){const $t=Math.max(Ke,Mt);Me=Math.round($t*it)}let Ze=0;yt&&(Ze=et);let We=0,tt=We+Ze,gt=tt+Me,vt=gt+Ae;const Ct=Be-Ze-Me-Ae;let Dt=!1,Et=!1,pt=-1;Ot!==2&&(rt==="inherit"&&mt?(Dt=!0,Et=!0):_t==="on"||_t==="bounded"?Et=!0:_t==="wordWrapColumn"&&(pt=Rt));const wt=te._computeMinimapLayout({outerWidth:Be,outerHeight:je,lineHeight:et,typicalHalfwidthCharacterWidth:Ve,pixelRatio:st,scrollBeyondLastLine:qe,minimap:zt,verticalScrollbarWidth:Tt,viewLineCount:ct,remainingWidth:Ct,isViewportWrapping:Et},me.memory||new R);wt.renderMinimap!==0&&wt.minimapLeft===0&&(We+=wt.minimapWidth,tt+=wt.minimapWidth,gt+=wt.minimapWidth,vt+=wt.minimapWidth);const ei=Ct-wt.minimapWidth,bt=Math.max(1,Math.floor((ei-Tt-2)/Ve)),qt=ft?It:0;return Et&&(pt=Math.max(1,bt),_t==="bounded"&&(pt=Math.min(pt,Rt))),{width:Be,height:je,glyphMarginLeft:We,glyphMarginWidth:Ze,lineNumbersLeft:tt,lineNumbersWidth:Me,decorationsLeft:gt,decorationsWidth:Ae,contentLeft:vt,contentWidth:ei,minimap:wt,viewportColumn:bt,isWordWrapMinified:Dt,isViewportWrapping:Et,wrappingColumn:pt,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:_e,overviewRuler:{top:qt,width:Tt,height:je-2*qt,right:0}}}}e.EditorLayoutInfoComputer=te;class he extends E{constructor(){const Y={enabled:!0};super(58,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:r.localize(43,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:c(Y.enabled,this.defaultValue.enabled)}}}class re extends E{constructor(){const Y={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:r.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:r.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:c(me.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class be extends E{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:r.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(47,null),r.localize(48,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(49,null,D.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:r.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:r.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:r.localize(53,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:s(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(me.fontFamily,this.defaultValue.fontFamily),padding:c(me.padding,this.defaultValue.padding)}}}class le extends h{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>h.clamp(Y,0,150),{markdownDescription:r.localize(54,null)})}compute(Y,me,Be){return Y.fontInfo.lineHeight}}class fe extends E{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:r.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:r.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(57,null),r.localize(58,null),r.localize(59,null)],default:Y.size,description:r.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:r.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:r.localize(62,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:r.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:r.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:c(me.enabled,this.defaultValue.enabled),autohide:c(me.autohide,this.defaultValue.autohide),size:s(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(me.side,this.defaultValue.side,["right","left"]),showSlider:s(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(me.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(me.scale,1,1,3),maxColumn:S.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(X){return X==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends E{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(67,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:S.clampedInt(me.top,0,0,1e3),bottom:S.clampedInt(me.bottom,0,0,1e3)}}}class Se extends E{constructor(){const Y={enabled:!0,cycle:!1};super(77,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:r.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:r.localize(69,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:c(me.enabled,this.defaultValue.enabled),cycle:c(me.cycle,this.defaultValue.cycle)}}}class Fe extends g{constructor(){super(131)}compute(Y,me,Be){return Y.pixelRatio}}class Ue extends E{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(70,null),r.localize(71,null),r.localize(72,null)]}];super(80,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:r.localize(73,null)},comments:{anyOf:me,default:Y.comments,description:r.localize(74,null)},other:{anyOf:me,default:Y.other,description:r.localize(75,null)}},default:Y,markdownDescription:r.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const st=Y?"on":"off";return{comments:st,strings:st,other:st}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:Be,strings:je}=Y,et=["on","inline","off"];let Ke,Ve,it;return typeof me=="boolean"?Ke=me?"on":"off":Ke=s(me,this.defaultValue.other,et),typeof Be=="boolean"?Ve=Be?"on":"off":Ve=s(Be,this.defaultValue.comments,et),typeof je=="boolean"?it=je?"on":"off":it=s(je,this.defaultValue.strings,et),{other:Ke,comments:Ve,strings:it}}}var Xe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends E{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(77,null),r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"on",description:r.localize(81,null)})}validate(Y){let me=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,Be=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:Be}}}function ye(X){const Y=X.get(88);return Y==="editable"?X.get(82):Y!=="on"}e.filterValidationDecorations=ye;class De extends E{constructor(){const Y=[],me={type:"number",description:r.localize(82,null)};super(92,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:r.localize(83,null),format:"color-hex"}}}]},default:Y,description:r.localize(84,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const Be of Y)if(typeof Be=="number")me.push({column:S.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const je=Be;me.push({column:S.clampedInt(je.column,0,0,1e4),color:je.color})}return me.sort((Be,je)=>Be.column-je.column),me}return this.defaultValue}}function ae(X,Y){if(typeof X!="string")return Y;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends E{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(85,null),r.localize(86,null),r.localize(87,null)],default:"auto",description:r.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(89,null),r.localize(90,null),r.localize(91,null)],default:"auto",description:r.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:r.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:r.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:r.localize(95,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,Be=S.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=S.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(me.vertical,this.defaultValue.vertical),horizontal:ae(me.horizontal,this.defaultValue.horizontal),useShadows:c(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:S.clampedInt(me.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:je,verticalSliderSize:S.clampedInt(me.verticalSliderSize,je,0,1e3),scrollByPage:c(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends E{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:r.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:r.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:r.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:r.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:r.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:r.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:r.localize(102,null)}})}applyUpdate(Y,me){let Be=!1;me.allowedCharacters&&Y&&(_.equals(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},Be=!0)),me.allowedLocales&&Y&&(_.equals(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},Be=!0));const je=super.applyUpdate(Y,me);return Be?new m(je.newValue,!0):je}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:V(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:V(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:V(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Y.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Y,me){if(typeof Y!="object"||!Y)return me;const Be={};for(const[je,et]of Object.entries(Y))et===!0&&(Be[je]=!0);return Be}}class Z extends E{constructor(){const Y={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:r.localize(103,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:c(me.enabled,this.defaultValue.enabled),mode:s(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class k extends E{constructor(){const Y={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:r.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:r.localize(105,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:c(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends E{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(106,null),r.localize(107,null),r.localize(108,null)],default:Y.bracketPairs,description:r.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(110,null),r.localize(111,null),r.localize(112,null)],default:Y.bracketPairsHorizontal,description:r.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:r.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:r.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:Y.highlightActiveIndentation,description:r.localize(119,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:V(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:V(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:V(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function V(X,Y,me){const Be=me.indexOf(X);return Be===-1?Y:me[Be]}class q extends E{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(120,null),r.localize(121,null)],default:Y.insertMode,description:r.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:r.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:r.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:r.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:r.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:r.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:r.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:r.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:r.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:s(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(me.showIcons,this.defaultValue.showIcons),showStatusBar:c(me.showStatusBar,this.defaultValue.showStatusBar),preview:c(me.preview,this.defaultValue.preview),previewMode:s(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(me.showMethods,this.defaultValue.showMethods),showFunctions:c(me.showFunctions,this.defaultValue.showFunctions),showConstructors:c(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(me.showFields,this.defaultValue.showFields),showVariables:c(me.showVariables,this.defaultValue.showVariables),showClasses:c(me.showClasses,this.defaultValue.showClasses),showStructs:c(me.showStructs,this.defaultValue.showStructs),showInterfaces:c(me.showInterfaces,this.defaultValue.showInterfaces),showModules:c(me.showModules,this.defaultValue.showModules),showProperties:c(me.showProperties,this.defaultValue.showProperties),showEvents:c(me.showEvents,this.defaultValue.showEvents),showOperators:c(me.showOperators,this.defaultValue.showOperators),showUnits:c(me.showUnits,this.defaultValue.showUnits),showValues:c(me.showValues,this.defaultValue.showValues),showConstants:c(me.showConstants,this.defaultValue.showConstants),showEnums:c(me.showEnums,this.defaultValue.showEnums),showEnumMembers:c(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(me.showKeywords,this.defaultValue.showKeywords),showWords:c(me.showWords,this.defaultValue.showWords),showColors:c(me.showColors,this.defaultValue.showColors),showFiles:c(me.showFiles,this.defaultValue.showFiles),showReferences:c(me.showReferences,this.defaultValue.showReferences),showFolders:c(me.showFolders,this.defaultValue.showFolders),showTypeParameters:c(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(me.showSnippets,this.defaultValue.showSnippets),showUsers:c(me.showUsers,this.defaultValue.showUsers),showIssues:c(me.showIssues,this.defaultValue.showIssues)}}}class oe extends E{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(163,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends g{constructor(){super(132)}compute(Y,me,Be){return me.get(82)?!0:Y.tabFocusMode}}var J;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(J=e.WrappingIndent||(e.WrappingIndent={}));function Ee(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends g{constructor(){super(134)}compute(Y,me,Be){const je=me.get(133);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class Ne extends E{constructor(){const Y={enabled:!0};super(32,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:r.localize(164,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:c(Y.enabled,this.defaultValue.enabled)}}}const ze="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?Je:D.isLinux?Ge:ze,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Pe(X){return e.editorOptionsRegistry[X.id]=X,X}var nt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Pe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(165,null)})),acceptSuggestionOnEnter:Pe(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(166,null),""],markdownDescription:r.localize(167,null)})),accessibilitySupport:Pe(new o),accessibilityPageSize:Pe(new S(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(168,null),tags:["accessibility"]})),ariaLabel:Pe(new T(4,"ariaLabel",r.localize(169,null))),autoClosingBrackets:Pe(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),autoClosingDelete:Pe(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(173,null),""],description:r.localize(174,null)})),autoClosingOvertype:Pe(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(175,null),""],description:r.localize(176,null)})),autoClosingQuotes:Pe(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(177,null),r.localize(178,null),""],description:r.localize(179,null)})),autoIndent:Pe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[r.localize(180,null),r.localize(181,null),r.localize(182,null),r.localize(183,null),r.localize(184,null)],description:r.localize(185,null)})),automaticLayout:Pe(new f(10,"automaticLayout",!1)),autoSurround:Pe(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(186,null),r.localize(187,null),r.localize(188,null),""],description:r.localize(189,null)})),bracketPairColorization:Pe(new k),bracketPairGuides:Pe(new B),stickyTabStops:Pe(new f(106,"stickyTabStops",!1,{description:r.localize(190,null)})),codeLens:Pe(new f(14,"codeLens",!0,{description:r.localize(191,null)})),codeLensFontFamily:Pe(new T(15,"codeLensFontFamily","",{description:r.localize(192,null)})),codeLensFontSize:Pe(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(193,null)})),colorDecorators:Pe(new f(17,"colorDecorators",!0,{description:r.localize(194,null)})),columnSelection:Pe(new f(18,"columnSelection",!1,{description:r.localize(195,null)})),comments:Pe(new a),contextmenu:Pe(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Pe(new f(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(196,null)})),cursorBlinking:Pe(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:r.localize(197,null)})),cursorSmoothCaretAnimation:Pe(new f(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(198,null)})),cursorStyle:Pe(new n(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:r.localize(199,null)})),cursorSurroundingLines:Pe(new S(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(200,null)})),cursorSurroundingLinesStyle:Pe(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),cursorWidth:Pe(new S(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(204,null)})),disableLayerHinting:Pe(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Pe(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Pe(new f(30,"domReadOnly",!1)),dragAndDrop:Pe(new f(31,"dragAndDrop",!0,{description:r.localize(205,null)})),emptySelectionClipboard:Pe(new U),dropIntoEditor:Pe(new Ne),stickyScroll:Pe(new re),extraEditorClassName:Pe(new T(34,"extraEditorClassName","")),fastScrollSensitivity:Pe(new h(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:r.localize(206,null)})),find:Pe(new C),fixedOverflowWidgets:Pe(new f(37,"fixedOverflowWidgets",!1)),folding:Pe(new f(38,"folding",!0,{description:r.localize(207,null)})),foldingStrategy:Pe(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(208,null),r.localize(209,null)],description:r.localize(210,null)})),foldingHighlight:Pe(new f(40,"foldingHighlight",!0,{description:r.localize(211,null)})),foldingImportsByDefault:Pe(new f(41,"foldingImportsByDefault",!1,{description:r.localize(212,null)})),foldingMaximumRegions:Pe(new S(42,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(213,null)})),unfoldOnClickAfterEndOfLine:Pe(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(214,null)})),fontFamily:Pe(new T(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(215,null)})),fontInfo:Pe(new M),fontLigatures2:Pe(new W),fontSize:Pe(new O),fontWeight:Pe(new H),formatOnPaste:Pe(new f(49,"formatOnPaste",!1,{description:r.localize(216,null)})),formatOnType:Pe(new f(50,"formatOnType",!1,{description:r.localize(217,null)})),glyphMargin:Pe(new f(51,"glyphMargin",!0,{description:r.localize(218,null)})),gotoLocation:Pe(new $),hideCursorInOverviewRuler:Pe(new f(53,"hideCursorInOverviewRuler",!1,{description:r.localize(219,null)})),hover:Pe(new z),inDiffEditor:Pe(new f(55,"inDiffEditor",!1)),letterSpacing:Pe(new h(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:r.localize(220,null)})),lightbulb:Pe(new he),lineDecorationsWidth:Pe(new l(59,"lineDecorationsWidth",10)),lineHeight:Pe(new le),lineNumbers:Pe(new ke),lineNumbersMinChars:Pe(new S(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Pe(new f(63,"linkedEditing",!1,{description:r.localize(221,null)})),links:Pe(new f(64,"links",!0,{description:r.localize(222,null)})),matchBrackets:Pe(new u(65,"matchBrackets","always",["always","near","never"],{description:r.localize(223,null)})),minimap:Pe(new fe),mouseStyle:Pe(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Pe(new h(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:r.localize(224,null)})),mouseWheelZoom:Pe(new f(69,"mouseWheelZoom",!1,{markdownDescription:r.localize(225,null)})),multiCursorMergeOverlapping:Pe(new f(70,"multiCursorMergeOverlapping",!0,{description:r.localize(226,null)})),multiCursorModifier:Pe(new n(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[r.localize(227,null),r.localize(228,null)],markdownDescription:r.localize(229,null)})),multiCursorPaste:Pe(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(230,null),r.localize(231,null)],markdownDescription:r.localize(232,null)})),occurrencesHighlight:Pe(new f(73,"occurrencesHighlight",!0,{description:r.localize(233,null)})),overviewRulerBorder:Pe(new f(74,"overviewRulerBorder",!0,{description:r.localize(234,null)})),overviewRulerLanes:Pe(new S(75,"overviewRulerLanes",3,0,3)),padding:Pe(new pe),parameterHints:Pe(new Se),peekWidgetDefaultFocus:Pe(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(235,null),r.localize(236,null)],description:r.localize(237,null)})),definitionLinkOpensInPeek:Pe(new f(79,"definitionLinkOpensInPeek",!1,{description:r.localize(238,null)})),quickSuggestions:Pe(new Ue),quickSuggestionsDelay:Pe(new S(81,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(239,null)})),readOnly:Pe(new f(82,"readOnly",!1)),renameOnType:Pe(new f(83,"renameOnType",!1,{description:r.localize(240,null),markdownDeprecationMessage:r.localize(241,null)})),renderControlCharacters:Pe(new f(84,"renderControlCharacters",!0,{description:r.localize(242,null),restricted:!0})),renderFinalNewline:Pe(new f(85,"renderFinalNewline",!0,{description:r.localize(243,null)})),renderLineHighlight:Pe(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(244,null)],description:r.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Pe(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(246,null)})),renderValidationDecorations:Pe(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Pe(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(247,null),r.localize(248,null),r.localize(249,null),""],description:r.localize(250,null)})),revealHorizontalRightPadding:Pe(new S(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Pe(new f(91,"roundedSelection",!0,{description:r.localize(251,null)})),rulers:Pe(new De),scrollbar:Pe(new ue),scrollBeyondLastColumn:Pe(new S(94,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(252,null)})),scrollBeyondLastLine:Pe(new f(95,"scrollBeyondLastLine",!0,{description:r.localize(253,null)})),scrollPredominantAxis:Pe(new f(96,"scrollPredominantAxis",!0,{description:r.localize(254,null)})),selectionClipboard:Pe(new f(97,"selectionClipboard",!0,{description:r.localize(255,null),included:D.isLinux})),selectionHighlight:Pe(new f(98,"selectionHighlight",!0,{description:r.localize(256,null)})),selectOnLineNumbers:Pe(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Pe(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(257,null),r.localize(258,null),r.localize(259,null)],description:r.localize(260,null)})),showUnused:Pe(new f(101,"showUnused",!0,{description:r.localize(261,null)})),showDeprecated:Pe(new f(128,"showDeprecated",!0,{description:r.localize(262,null)})),inlayHints:Pe(new be),snippetSuggestions:Pe(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(263,null),r.localize(264,null),r.localize(265,null),r.localize(266,null)],description:r.localize(267,null)})),smartSelect:Pe(new oe),smoothScrolling:Pe(new f(104,"smoothScrolling",!1,{description:r.localize(268,null)})),stopRenderingLineAfter:Pe(new S(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Pe(new q),inlineSuggest:Pe(new Z),suggestFontSize:Pe(new S(109,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Pe(new S(110,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Pe(new f(111,"suggestOnTriggerCharacters",!0,{description:r.localize(271,null)})),suggestSelection:Pe(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(272,null),r.localize(273,null),r.localize(274,null)],description:r.localize(275,null)})),tabCompletion:Pe(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(276,null),r.localize(277,null),r.localize(278,null)],description:r.localize(279,null)})),tabIndex:Pe(new S(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Pe(new ee),unusualLineTerminators:Pe(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(280,null),r.localize(281,null),r.localize(282,null)],description:r.localize(283,null)})),useShadowDOM:Pe(new f(117,"useShadowDOM",!0)),useTabStops:Pe(new f(118,"useTabStops",!0,{description:r.localize(284,null)})),wordSeparators:Pe(new T(119,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:r.localize(285,null)})),wordWrap:Pe(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(286,null),r.localize(287,null),r.localize(288,null),r.localize(289,null)],description:r.localize(290,null)})),wordWrapBreakAfterCharacters:Pe(new T(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Pe(new T(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Pe(new S(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(291,null)})),wordWrapOverride1:Pe(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Pe(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Pe(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ee,{enumDescriptions:[r.localize(292,null),r.localize(293,null),r.localize(294,null),r.localize(295,null)],description:r.localize(296,null)})),wrappingStrategy:Pe(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(297,null),r.localize(298,null)],description:r.localize(299,null)})),editorClassName:Pe(new j),pixelRatio:Pe(new Fe),tabFocusMode:Pe(new ce),layoutInfo:Pe(new te),wrappingInfo:Pe(new ve)}}),define(Ie[124],Ce([16,17]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[125],Ce([16,17]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[126],Ce([16,17]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[127],Ce([16,17]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Ie[128],Ce([16,17]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Ie[129],Ce([16,17]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Ie[130],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[131],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[132],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[133],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[134],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[135],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[136],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[137],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Ie[138],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[139],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[140],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[141],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[142],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[143],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[144],Ce([16,17]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[145],Ce([1,0,22,29,126,244]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(f){return f=f.trim(),f==="*"||_.test(f)}e.isValidVersionStr=y;function P(f){if(!y(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=P;function R(f){if(!f)return null;const v=f.majorBase,S=f.majorMustEqual,h=f.minorBase;let T=f.minorMustEqual;const s=f.patchBase;let u=f.patchMustEqual;f.hasCaret&&(v===0||(T=!1),u=!1);let n=0;if(f.preRelease){const i=A.exec(f.preRelease);if(i){const[,o,a,t]=i;n=Date.UTC(Number(o),Number(a)-1,Number(t))}}return{majorBase:v,majorMustEqual:S,minorBase:h,minorMustEqual:T,patchBase:s,patchMustEqual:u,isMinimum:f.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function E(f,v,S){let h;typeof f=="string"?h=R(P(f)):h=f;let T;v instanceof Date?T=v.getTime():typeof v=="string"&&(T=new Date(v).getTime());let s;if(typeof S=="string"?s=R(P(S)):s=S,!h||!s)return!1;const u=h.majorBase,n=h.minorBase,i=h.patchBase;let o=s.majorBase,a=s.minorBase,t=s.patchBase;const d=s.notBefore;let p=s.majorMustEqual,w=s.minorMustEqual,F=s.patchMustEqual;return s.isMinimum?u>o?!0:u<o?!1:n>a?!0:n<a||T&&T<d?!1:i>=t:(u===1&&o===0&&(!p||!w||!F)&&(o=1,a=0,t=0,p=!0,w=!1,F=!1),u<o?!1:u>o?!p:n<a?!1:n>a?!w:i<t?!1:i>t?!F:!(T&&T<d))}e.isValidVersion=E;function m(f,v,S,h,T){const s=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return s.push([D.default.Error,b.localize(0,null)]),s;if(typeof h.name!="string")return s.push([D.default.Error,b.localize(1,null,"name")]),s;if(typeof h.version!="string")return s.push([D.default.Error,b.localize(2,null,"version")]),s;if(!h.engines)return s.push([D.default.Error,b.localize(3,null,"engines")]),s;if(typeof h.engines.vscode!="string")return s.push([D.default.Error,b.localize(4,null,"engines.vscode")]),s;if(typeof h.extensionDependencies<"u"&&!c(h.extensionDependencies))return s.push([D.default.Error,b.localize(5,null,"extensionDependencies")]),s;if(typeof h.activationEvents<"u"){if(!c(h.activationEvents))return s.push([D.default.Error,b.localize(6,null,"activationEvents")]),s;if(typeof h.main>"u"&&typeof h.browser>"u")return s.push([D.default.Error,b.localize(7,null,"activationEvents","main")]),s}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&s.push([D.default.Warning,b.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return s.push([D.default.Error,b.localize(9,null,"main")]),s;{const i=(0,r.joinPath)(S,h.main);(0,r.isEqualOrParent)(i,S)||s.push([D.default.Warning,b.localize(10,null,i.path,S.path)])}if(typeof h.activationEvents>"u")return s.push([D.default.Error,b.localize(11,null,"activationEvents","main")]),s}if(typeof h.browser<"u"){if(typeof h.browser!="string")return s.push([D.default.Error,b.localize(12,null,"browser")]),s;{const i=(0,r.joinPath)(S,h.browser);(0,r.isEqualOrParent)(i,S)||s.push([D.default.Warning,b.localize(13,null,i.path,S.path)])}if(typeof h.activationEvents>"u")return s.push([D.default.Error,b.localize(14,null,"activationEvents","browser")]),s}if(!N.valid(h.version))return s.push([D.default.Error,b.localize(15,null)]),s;const u=[];if(!I(f,v,h,T,u))for(const i of u)s.push([D.default.Error,i]);return s}e.validateExtensionManifest=m;function I(f,v,S,h,T){return h||typeof S.main>"u"&&typeof S.browser>"u"?!0:l(f,v,S.engines.vscode,T)}e.isValidExtensionVersion=I;function g(f,v,S){return f==="*"||l(v,S,f)}e.isEngineValid=g;function l(f,v,S,h=[]){const T=R(P(S));if(!T)return h.push(b.localize(16,null,S)),!1;if(T.majorBase===0){if(!T.majorMustEqual||!T.minorMustEqual)return h.push(b.localize(17,null,S)),!1}else if(!T.majorMustEqual)return h.push(b.localize(18,null,S)),!1;return E(f,v,T)?!0:(h.push(b.localize(19,null,f,S)),!1)}function c(f){if(!Array.isArray(f))return!1;for(let v=0,S=f.length;v<S;v++)if(typeof f[v]!="string")return!1;return!0}}),define(Ie[83],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(b,N=[],_=!1){this.ctor=b,this.staticArguments=N,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=r}),define(Ie[58],Ce([1,0,83]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var b;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(b=e.InstantiationType||(e.InstantiationType={}));function N(A,y,P){y instanceof r.SyncDescriptor||(y=new r.SyncDescriptor(y,[],Boolean(P))),D.push([A,y])}e.registerSingleton=N;function _(){return D}e.getSingletonServiceDescriptors=_}),define(Ie[146],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(N,_){this.key=N,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class D{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const _ of this._nodes.values())_.outgoing.size===0&&N.push(_);return N}insertEdge(N,_){const A=this.lookupOrInsertNode(N),y=this.lookupOrInsertNode(_);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(N){const _=this._hashFn(N);this._nodes.delete(_);for(const A of this._nodes.values())A.outgoing.delete(_),A.incoming.delete(_)}lookupOrInsertNode(N){const _=this._hashFn(N);let A=this._nodes.get(_);return A||(A=new r(_,N),this._nodes.set(_,A)),A}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[_,A]of this._nodes)N.push(`${_}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,_]of this._nodes){const A=new Set([N]),y=this._findCycle(_,A);if(y)return y}}_findCycle(N,_){for(const[A,y]of N.outgoing){if(_.has(A))return[..._,A].join(" -> ");_.add(A);const P=this._findCycle(y,_);if(P)return P;_.delete(A)}}}e.Graph=D}),define(Ie[3],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function D(_,A,y){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:_,index:y}):(A[r.DI_DEPENDENCIES]=[{id:_,index:y}],A[r.DI_TARGET]=A)}function b(_){if(r.serviceIds.has(_))return r.serviceIds.get(_);const A=function(y,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(A,y,R)};return A.toString=()=>_,r.serviceIds.set(_,A),A}e.createDecorator=b;function N(_){return _}e.refineServiceDecorator=N}),define(Ie[45],Ce([1,0,9,2,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof D.URI)}e.isConfigurationOverrides=N;function _(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=_;var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function P(f,v){const S=Object.create(null);for(const h in f)R(S,h,f[h],v);return S}e.toValuesTree=P;function R(f,v,S,h){const T=v.split("."),s=T.pop();let u=f;for(let n=0;n<T.length;n++){const i=T[n];let o=u[i];switch(typeof o){case"undefined":o=u[i]=Object.create(null);break;case"object":break;default:h(`Ignoring ${v} as ${T.slice(0,n+1).join(".")} is ${JSON.stringify(o)}`);return}u=o}if(typeof u=="object"&&u!==null)try{u[s]=S}catch{h(`Ignoring ${v} as ${T.join(".")} is ${JSON.stringify(u)}`)}else h(`Ignoring ${v} as ${T.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=R;function E(f,v){const S=v.split(".");m(f,S)}e.removeFromValueTree=E;function m(f,v){const S=v.shift();if(v.length===0){delete f[S];return}if(Object.keys(f).indexOf(S)!==-1){const h=f[S];typeof h=="object"&&!Array.isArray(h)&&(m(h,v),Object.keys(h).length===0&&delete f[S])}}function I(f,v,S){function h(u,n){let i=u;for(const o of n){if(typeof i!="object"||i===null)return;i=i[o]}return i}const T=v.split("."),s=h(f,T);return typeof s>"u"?S:s}e.getConfigurationValue=I;function g(f,v,S){Object.keys(v).forEach(h=>{h!=="__proto__"&&(h in f?r.isObject(f[h])&&r.isObject(v[h])?g(f[h],v[h],S):S&&(f[h]=v[h]):f[h]=v[h])})}e.merge=g;function l(f,v,S){const h=f.inspect(v),T=f.inspect(S);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof T.userValue<"u"||typeof T.workspaceValue<"u"||typeof T.workspaceFolderValue<"u"?T.value:h.defaultValue}e.getMigratedSettingValue=l;function c(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(Ie[40],Ce([1,0,20,10,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",r.isMacintosh),N.set("isLinux",r.isLinux),N.set("isWindows",r.isWindows),N.set("isWeb",r.isWeb),N.set("isMacNative",r.isMacintosh&&!r.isWeb),N.set("isEdge",r.isEdge),N.set("isFirefox",r.isFirefox),N.set("isChrome",r.isChrome),N.set("isSafari",r.isSafari);const _=Object.prototype.hasOwnProperty;var A;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return E.INSTANCE}static true(){return m.INSTANCE}static has(C){return I.create(C)}static equals(C,W){return g.create(C,W)}static notEquals(C,W){return f.create(C,W)}static regex(C,W){return n.create(C,W)}static in(C,W){return l.create(C,W)}static notIn(C,W){return c.create(C,W)}static not(C){return v.create(C)}static and(...C){return a.create(C,null)}static or(...C){return t.create(C,null,!0)}static greater(C,W){return h.create(C,W)}static greaterEquals(C,W){return T.create(C,W)}static smaller(C,W){return s.create(C,W)}static smallerEquals(C,W){return u.create(C,W)}static deserialize(C,W=!1){if(!!C)return this._deserializeOrExpression(C,W)}static _deserializeOrExpression(C,W){const M=C.split("||");return t.create(M.map(O=>this._deserializeAndExpression(O,W)),null,!0)}static _deserializeAndExpression(C,W){const M=C.split("&&");return a.create(M.map(O=>this._deserializeOne(O,W)),null)}static _deserializeOne(C,W){if(C=C.trim(),C.indexOf("!=")>=0){const M=C.split("!=");return f.create(M[0].trim(),this._deserializeValue(M[1],W))}if(C.indexOf("==")>=0){const M=C.split("==");return g.create(M[0].trim(),this._deserializeValue(M[1],W))}if(C.indexOf("=~")>=0){const M=C.split("=~");return n.create(M[0].trim(),this._deserializeRegexValue(M[1],W))}if(C.indexOf(" not in ")>=0){const M=C.split(" not in ");return c.create(M[0].trim(),this._deserializeValue(M[1],W))}if(C.indexOf(" in ")>=0){const M=C.split(" in ");return l.create(M[0].trim(),this._deserializeValue(M[1],W))}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const M=C.split(">=");return T.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const M=C.split(">");return h.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const M=C.split("<=");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const M=C.split("<");return s.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(C)?v.create(C.substr(1).trim()):I.create(C)}static _deserializeValue(C,W){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;const M=/^'([^']*)'$/.exec(C);return M?M[1].trim():C}static _deserializeRegexValue(C,W){if((0,D.isFalsyOrWhitespace)(C)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const M=C.indexOf("/"),O=C.lastIndexOf("/");if(M===O||M<0){if(W)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}const H=C.slice(M+1,O),$=C[O+1]==="i"?"i":"";try{return new RegExp(H,$)}catch(z){if(W)throw new Error(`bad regexp-value '${C}', parse error: ${z}`);return console.warn(`bad regexp-value '${C}', parse error: ${z}`),null}}}e.ContextKeyExpr=y;function P(U,C){const W=U?U.substituteConstants():void 0,M=C?C.substituteConstants():void 0;return!W&&!M?!0:!W||!M?!1:W.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function R(U,C){return U.cmp(C)}class E{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class m{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class I{static create(C,W=null){const M=N.get(C);return typeof M=="boolean"?M?m.INSTANCE:E.INSTANCE:new I(C,W)}constructor(C,W){this.key=C,this.negated=W,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:p(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=N.get(this.key);return typeof C=="boolean"?C?m.INSTANCE:E.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class g{static create(C,W,M=null){if(typeof W=="boolean")return W?I.create(C,M):v.create(C,M);const O=N.get(C);return typeof O=="boolean"?W===(O?"true":"false")?m.INSTANCE:E.INSTANCE:new g(C,W,M)}constructor(C,W,M){this.key=C,this.value=W,this.negated=M,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:w(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=N.get(this.key);if(typeof C=="boolean"){const W=C?"true":"false";return this.value===W?m.INSTANCE:E.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class l{static create(C,W){return new l(C,W)}constructor(C,W){this.key=C,this.valueKey=W,this.type=10,this.negated=null}cmp(C){return C.type!==this.type?this.type-C.type:w(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const W=C.getValue(this.valueKey),M=C.getValue(this.key);return Array.isArray(W)?W.includes(M):typeof M=="string"&&typeof W=="object"&&W!==null?_.call(W,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=c.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=l;class c{static create(C,W){return new c(C,W)}constructor(C,W){this.key=C,this.valueKey=W,this.type=11,this._negated=l.create(C,W)}cmp(C){return C.type!==this.type?this.type-C.type:this._negated.cmp(C._negated)}equals(C){return C.type===this.type?this._negated.equals(C._negated):!1}substituteConstants(){return this}evaluate(C){return!this._negated.evaluate(C)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(C){return C.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=c;class f{static create(C,W,M=null){if(typeof W=="boolean")return W?v.create(C,M):I.create(C,M);const O=N.get(C);return typeof O=="boolean"?W===(O?"true":"false")?E.INSTANCE:m.INSTANCE:new f(C,W,M)}constructor(C,W,M){this.key=C,this.value=W,this.negated=M,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:w(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=N.get(this.key);if(typeof C=="boolean"){const W=C?"true":"false";return this.value===W?E.INSTANCE:m.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class v{static create(C,W=null){const M=N.get(C);return typeof M=="boolean"?M?E.INSTANCE:m.INSTANCE:new v(C,W)}constructor(C,W){this.key=C,this.negated=W,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:p(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=N.get(this.key);return typeof C=="boolean"?C?E.INSTANCE:m.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function S(U,C){if(typeof U=="string"){const W=parseFloat(U);isNaN(W)||(U=W)}return typeof U=="string"||typeof U=="number"?C(U):E.INSTANCE}class h{static create(C,W,M=null){return S(W,O=>new h(C,O,M))}constructor(C,W,M){this.key=C,this.value=W,this.negated=M,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:w(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=h;class T{static create(C,W,M=null){return S(W,O=>new T(C,O,M))}constructor(C,W,M){this.key=C,this.value=W,this.negated=M,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:w(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=T;class s{static create(C,W,M=null){return S(W,O=>new s(C,O,M))}constructor(C,W,M){this.key=C,this.value=W,this.negated=M,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:w(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class u{static create(C,W,M=null){return S(W,O=>new u(C,O,M))}constructor(C,W,M){this.key=C,this.value=W,this.negated=M,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:w(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class n{static create(C,W){return new n(C,W)}constructor(C,W){this.key=C,this.regexp=W,this.type=7,this.negated=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const W=this.regexp?this.regexp.source:"",M=C.regexp?C.regexp.source:"";return W<M?-1:W>M?1:0}equals(C){if(C.type===this.type){const W=this.regexp?this.regexp.source:"",M=C.regexp?C.regexp.source:"";return this.key===C.key&&W===M}return!1}substituteConstants(){return this}evaluate(C){const W=C.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{static create(C){return new i(C)}constructor(C){this._actual=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new i(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function o(U){let C=null;for(let W=0,M=U.length;W<M;W++){const O=U[W].substituteConstants();if(U[W]!==O&&C===null){C=[];for(let H=0;H<W;H++)C[H]=U[H]}C!==null&&(C[W]=O)}return C===null?U:C}class a{static create(C,W){return a._normalizeArr(C,W)}constructor(C,W){this.expr=C,this.negated=W,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const O=R(this.expr[W],C.expr[W]);if(O!==0)return O}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(C.expr[W]))return!1;return!0}return!1}substituteConstants(){const C=o(this.expr);return C===this.expr?this:a.create(C,this.negated)}evaluate(C){for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].evaluate(C))return!1;return!0}static _normalizeArr(C,W){const M=[];let O=!1;for(const H of C)if(!!H){if(H.type===1){O=!0;continue}if(H.type===0)return E.INSTANCE;if(H.type===6){M.push(...H.expr);continue}M.push(H)}if(M.length===0&&O)return m.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(R);for(let H=1;H<M.length;H++)M[H-1].equals(M[H])&&(M.splice(H,1),H--);if(M.length===1)return M[0];for(;M.length>1;){const H=M[M.length-1];if(H.type!==9)break;M.pop();const $=M.pop(),z=M.length===0,G=t.create(H.expr.map(te=>a.create([te,$],null)),null,z);G&&(M.push(G),M.sort(R))}return M.length===1?M[0]:new a(M,W)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const W of this.expr)C.push(...W.keys());return C}map(C){return new a(this.expr.map(W=>W.map(C)),null)}negate(){if(!this.negated){const C=[];for(const W of this.expr)C.push(W.negate());this.negated=t.create(C,this,!0)}return this.negated}}class t{static create(C,W,M){return t._normalizeArr(C,W,M)}constructor(C,W){this.expr=C,this.negated=W,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const O=R(this.expr[W],C.expr[W]);if(O!==0)return O}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(C.expr[W]))return!1;return!0}return!1}substituteConstants(){const C=o(this.expr);return C===this.expr?this:t.create(C,this.negated,!1)}evaluate(C){for(let W=0,M=this.expr.length;W<M;W++)if(this.expr[W].evaluate(C))return!0;return!1}static _normalizeArr(C,W,M){let O=[],H=!1;if(C){for(let $=0,z=C.length;$<z;$++){const G=C[$];if(!!G){if(G.type===0){H=!0;continue}if(G.type===1)return m.INSTANCE;if(G.type===9){O=O.concat(G.expr);continue}O.push(G)}}if(O.length===0&&H)return E.INSTANCE;O.sort(R)}if(O.length!==0){if(O.length===1)return O[0];for(let $=1;$<O.length;$++)O[$-1].equals(O[$])&&(O.splice($,1),$--);if(O.length===1)return O[0];if(M){for(let $=0;$<O.length;$++)for(let z=$+1;z<O.length;z++)F(O[$],O[z])&&(O.splice(z,1),z--);if(O.length===1)return O[0]}return new t(O,W)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const W of this.expr)C.push(...W.keys());return C}map(C){return new t(this.expr.map(W=>W.map(C)),null)}negate(){if(!this.negated){const C=[];for(const W of this.expr)C.push(W.negate());for(;C.length>1;){const W=C.shift(),M=C.shift(),O=[];for(const $ of j(W))for(const z of j(M))O.push(a.create([$,z],null));const H=C.length===0;C.unshift(t.create(O,null,H))}this.negated=C[0]}return this.negated}}class d extends I{static all(){return d._info.values()}constructor(C,W,M){super(C,null),this._defaultValue=W,typeof M=="object"?d._info.push({...M,key:C}):M!==!0&&d._info.push({key:C,description:M,type:W!=null?typeof W:void 0})}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return g.create(this.key,C)}notEqualsTo(C){return f.create(this.key,C)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(U,C){return U<C?-1:U>C?1:0}function w(U,C,W,M){return U<W?-1:U>W?1:C<M?-1:C>M?1:0}function F(U,C){if(C.type===6&&U.type!==9&&U.type!==6){for(const O of C.expr)if(U.equals(O))return!0}const W=U.negate(),M=j(W).concat(j(C));M.sort(R);for(let O=0;O<M.length;O++){const $=M[O].negate();for(let z=O+1;z<M.length;z++){const G=M[z];if($.equals(G))return!0}}return!1}e.implies=F;function j(U){return U.type===9?U.expr:[U]}}),define(Ie[147],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[84],Ce([1,0,125,3]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function N(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function _(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function A(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(f,v,S){return A(v,S)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===S?!0:P(S).includes(f)}e.isTargetPlatformCompatible=y;function P(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var I;(function(f){f.Install="install",f.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var g;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var l;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(l=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(v,S){super(v),this.code=S,this.name=S}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[35],Ce([1,0,24,19,10,9,2,127,3]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P($){return $.create===!0}e.isFileOpenForWriteOptions=P;var R;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var E;(function($){$[$.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I($){return!!($.capabilities&2)}e.hasReadWriteCapability=I;function g($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=g;function l($){return!!($.capabilities&32768)}e.hasFileCloneCapability=l;function c($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function f($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=f;function v($){return I($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var S;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(z,G){super(z),this.code=G}}e.FileSystemProviderError=h;function T($,z){const G=new h($.toString(),z);return u(G,z),G}e.createFileSystemProviderError=T;function s($){return $||T((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=s;function u($,z){return $.name=z?`${z} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=u;function n($){if(!$)return S.Unknown;if($ instanceof h)return $.code;const z=/^(.+) \(FileSystemError\)$/.exec($.name);if(!z)return S.Unknown;switch(z[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=n;function i($){if($ instanceof w)return $.fileOperationResult;switch(n($)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var o;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(z,G,te){this.resource=z,this.operation=G,this.target=te}isOperation(z){return this.operation===z}}e.FileOperationEvent=a;var t;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(t=e.FileChangeType||(e.FileChangeType={}));class d{constructor(z,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const te=new Map;for(const he of z){const re=te.get(he.type);switch(re?re.push([he.resource,he]):te.set(he.type,[[he.resource,he]]),he.type){case 1:this.rawAdded.push(he.resource);break;case 0:this.rawUpdated.push(he.resource);break;case 2:this.rawDeleted.push(he.resource);break}}for(const[he,re]of te)switch(he){case 1:this.added=r.TernarySearchTree.forUris(()=>G),this.added.fill(re);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>G),this.updated.fill(re);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>G),this.deleted.fill(re);break}}contains(z,...G){return this.doContains(z,{includeChildren:!1},...G)}affects(z,...G){return this.doContains(z,{includeChildren:!0},...G)}doContains(z,G,...te){if(!z)return!1;const he=te.length>0;return!!((!he||te.includes(1))&&(this.added?.get(z)||G.includeChildren&&this.added?.findSuperstr(z))||(!he||te.includes(0))&&(this.updated?.get(z)||G.includeChildren&&this.updated?.findSuperstr(z))||(!he||te.includes(2))&&(this.deleted?.findSubstr(z)||G.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function p($,z,G){return!$||!z||$===z||z.length>$.length?!1:(z.charAt(z.length-1)!==D.sep&&(z+=D.sep),G?(0,b.startsWithIgnoreCase)($,z):$.indexOf(z)===0)}e.isParent=p;class w extends Error{constructor(z,G,te){super(z),this.fileOperationResult=G,this.options=te}}e.FileOperationError=w;class F extends w{constructor(z,G,te){super(z,2,te),this.stat=G}}e.NotModifiedSinceFileOperationError=F;var j;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function C($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=C;async function W($,z){if(!z.hasProvider(_.URI.from({scheme:$.scheme})))return new Promise(G=>{const te=z.onDidChangeFileSystemProviderRegistrations(he=>{he.scheme===$.scheme&&he.added&&(te.dispose(),G())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(z){return(0,N.isNumber)(z)||(z=0),z<M.KB?(0,A.localize)(1,null,z.toFixed(0)):z<M.MB?(0,A.localize)(2,null,(z/M.KB).toFixed(2)):z<M.GB?(0,A.localize)(3,null,(z/M.MB).toFixed(2)):z<M.TB?(0,A.localize)(4,null,(z/M.GB).toFixed(2)):(0,A.localize)(5,null,(z/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var O;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(O=e.Arch||(e.Arch={}));function H($){return{maxFileSize:$===0?300*M.MB:16*M.GB,maxHeapSize:$===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=H}),define(Ie[59],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...b){this._entries=new Map;for(const[N,_]of b)this.set(N,_)}set(b,N){const _=this._entries.get(b);return this._entries.set(b,N),_}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=r}),define(Ie[148],Ce([1,0,15,12,7,83,146,3,59,149]),function(ne,e,r,D,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class E extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new y.ServiceCollection,f=!1,v,S=R){this._services=c,this._strict=f,this._parent=v,this._enableTracing=S,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=S?v?._globalGraph??new _.Graph(h=>h):void 0}createChild(c){return new m(c,this._strict,this,this._enableTracing)}invokeFunction(c,...f){const v=g.traceInvocation(this._enableTracing,c);let S=!1;try{return c({get:T=>{if(S)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(T,v);if(!s)throw new Error(`[invokeFunction] unknown service '${T}'`);return s}},...f)}finally{S=!0,v.stop()}}createInstance(c,...f){let v,S;return c instanceof N.SyncDescriptor?(v=g.traceCreation(this._enableTracing,c.ctor),S=this._createInstance(c.ctor,c.staticArguments.concat(f),v)):(v=g.traceCreation(this._enableTracing,c),S=this._createInstance(c,f,v)),v.stop(),S}_createInstance(c,f=[],v){const S=A._util.getServiceDependencies(c).sort((s,u)=>s.index-u.index),h=[];for(const s of S){const u=this._getOrCreateServiceInstance(s.id,v);u||this._throwIfStrict(`[createInstance] ${c.name} depends on UNKNOWN service ${s.id}.`,!1),h.push(u)}const T=S.length>0?S[0].index:f.length;if(f.length!==T){console.trace(`[createInstance] First service dependency of ${c.name} at position ${T+1} conflicts with ${f.length} static arguments`);const s=T-f.length;s>0?f=f.concat(new Array(s)):f=f.slice(0,T)}return Reflect.construct(c,f.concat(h))}_setServiceInstance(c,f){if(this._services.get(c)instanceof N.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){const f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(c));const v=this._getServiceInstanceOrDescriptor(c);return v instanceof N.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,v,f.branch(c,!0)):(f.branch(c,!1),v)}_safeCreateAndCacheServiceInstance(c,f,v){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,v)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,v){const S=new _.Graph(s=>s.id.toString());let h=0;const T=[{id:c,desc:f,_trace:v}];for(;T.length;){const s=T.pop();if(S.lookupOrInsertNode(s),h++>1e3)throw new E(S);for(const u of A._util.getServiceDependencies(s.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(u.id);if(n||this._throwIfStrict(`[createInstance] ${c} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(u.id)),n instanceof N.SyncDescriptor){const i={id:u.id,desc:n,_trace:s._trace.branch(u.id,!0)};S.insertEdge(s,i),T.push(i)}}}for(;;){const s=S.roots();if(s.length===0){if(!S.isEmpty())throw new E(S);break}for(const{data:u}of s){if(this._getServiceInstanceOrDescriptor(u.id)instanceof N.SyncDescriptor){const i=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,i)}S.removeNode(u)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,v=[],S,h){if(this._services.get(c)instanceof N.SyncDescriptor)return this._createServiceInstance(c,f,v,S,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,v,S,h);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f,v=[],S,h){if(S){const T=new m(void 0,this._strict,this,this._enableTracing);T._globalGraphImplicitDependency=String(c);const s=new Map,u=new r.IdleValue(()=>{const n=T._createInstance(f,v,h);for(const[i,o]of s){const a=n[i];if(typeof a=="function")for(const t of o)a.apply(n,t)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!u.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let t=s.get(i);return t||(t=new P.LinkedList,s.set(i,t)),(p,w,F)=>{const j=t.push([p,w,F]);return(0,b.toDisposable)(j)}}if(i in n)return n[i];const o=u.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),n[i]=a),a},set(n,i,o){return u.value[i]=o,!0}})}else return this._createInstance(f,v,h)}_throwIfStrict(c,f){if(f&&console.warn(c),this._strict)throw new Error(c)}}e.InstantiationService=m;var I;(function(l){l[l.Creation=0]="Creation",l[l.Invocation=1]="Invocation",l[l.Branch=2]="Branch"})(I||(I={}));class g{static traceInvocation(c,f){return c?new g(1,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(c,f){return c?new g(0,f.name):g._None}constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}branch(c,f){const v=new g(2,c.toString());return this._dep.push([c,f,v]),v}stop(){const c=Date.now()-this._start;g._totals+=c;let f=!1;function v(h,T){const s=[],u=new Array(h+1).join("	");for(const[n,i,o]of T._dep)if(i&&o){f=!0,s.push(`${u}CREATES -> ${n}`);const a=v(h+1,o);a&&s.push(a)}else s.push(`${u}uses -> ${n}`);return s.join(`
`)}const S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(c>2||f)&&g.all.add(S.join(`
`))}}e.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Ie[11],Ce([1,0,44,4,7,24,20,2,3]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function P(){return new Date().toISOString()}var R;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function E(a,t,d){switch(t){case R.Trace:a.trace(d);break;case R.Debug:a.debug(d);break;case R.Info:a.info(d);break;case R.Warning:a.warn(d);break;case R.Error:a.error(d);break;case R.Critical:a.critical(d);break;default:throw new Error("Invalid log level")}}e.log=E;function m(a){let t="";for(let d=0;d<a.length;d++){let p=a[d];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}t+=(d>0?" ":"")+p}return t}e.format=m;class I extends b.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class g extends I{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...d){this.checkLogLevel(R.Trace)&&this.log(R.Trace,m([t,...d]))}debug(t,...d){this.checkLogLevel(R.Debug)&&this.log(R.Debug,m([t,...d]))}info(t,...d){this.checkLogLevel(R.Info)&&this.log(R.Info,m([t,...d]))}warn(t,...d){this.checkLogLevel(R.Warning)&&this.log(R.Warning,m([t,...d]))}error(t,...d){if(this.checkLogLevel(R.Error))if(t instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=t.stack,this.log(R.Error,m(p))}else this.log(R.Error,m([t,...d]))}critical(t,...d){this.checkLogLevel(R.Critical)&&this.log(R.Critical,m([t,...d]))}flush(){}}e.AbstractMessageLogger=g;class l extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!_.isWindows}trace(t,...d){this.getLevel()<=R.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...d):console.log(`[main ${P()}]`,t,...d))}debug(t,...d){this.getLevel()<=R.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...d):console.log(`[main ${P()}]`,t,...d))}info(t,...d){this.getLevel()<=R.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...d):console.log(`[main ${P()}]`,t,...d))}warn(t,...d){this.getLevel()<=R.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,t,...d):console.warn(`[main ${P()}]`,t,...d))}error(t,...d){this.getLevel()<=R.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,t,...d):console.error(`[main ${P()}]`,t,...d))}critical(t,...d){this.getLevel()<=R.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,t,...d):console.error(`[main ${P()}]`,t,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=l;class c extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...d){this.getLevel()<=R.Trace&&console.log("%cTRACE","color: #888",t,...d)}debug(t,...d){this.getLevel()<=R.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...d)}info(t,...d){this.getLevel()<=R.Info&&console.log("%c INFO","color: #33f",t,...d)}warn(t,...d){this.getLevel()<=R.Warning&&console.log("%c WARN","color: #993",t,...d)}error(t,...d){this.getLevel()<=R.Error&&console.log("%c  ERR","color: #f33",t,...d)}critical(t,...d){this.getLevel()<=R.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...d)}dispose(){}flush(){}}e.ConsoleLogger=c;class f extends I{constructor(t,d=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(d)}trace(t,...d){this.getLevel()<=R.Trace&&this.adapter.log(R.Trace,[this.extractMessage(t),...d])}debug(t,...d){this.getLevel()<=R.Debug&&this.adapter.log(R.Debug,[this.extractMessage(t),...d])}info(t,...d){this.getLevel()<=R.Info&&this.adapter.log(R.Info,[this.extractMessage(t),...d])}warn(t,...d){this.getLevel()<=R.Warning&&this.adapter.log(R.Warning,[this.extractMessage(t),...d])}error(t,...d){this.getLevel()<=R.Error&&this.adapter.log(R.Error,[this.extractMessage(t),...d])}critical(t,...d){this.getLevel()<=R.Critical&&this.adapter.log(R.Critical,[this.extractMessage(t),...d])}extractMessage(t){return typeof t=="string"?t:(0,r.toErrorMessage)(t,this.getLevel()<=R.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class v extends I{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const d of this.logServices)d.setLevel(t);super.setLevel(t)}trace(t,...d){for(const p of this.logServices)p.trace(t,...d)}debug(t,...d){for(const p of this.logServices)p.debug(t,...d)}info(t,...d){for(const p of this.logServices)p.info(t,...d)}warn(t,...d){for(const p of this.logServices)p.warn(t,...d)}error(t,...d){for(const p of this.logServices)p.error(t,...d)}critical(t,...d){for(const p of this.logServices)p.critical(t,...d)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=v;class S extends b.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...d){this.logger.trace(t,...d)}debug(t,...d){this.logger.debug(t,...d)}info(t,...d){this.logger.info(t,...d)}warn(t,...d){this.logger.warn(t,...d)}error(t,...d){this.logger.error(t,...d)}critical(t,...d){this.logger.critical(t,...d)}flush(){this.logger.flush()}}e.LogService=S;class h extends b.Disposable{constructor(t,d){super(),this.logLevel=t,this.loggerItems=new N.ResourceMap,this._register(d(p=>this.setLevel(p)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:t})=>t)}getLogger(t){return this.loggerItems.get(t)?.logger}createLogger(t,d,p){let w=this.loggerItems.get(t)?.logger;return w||(p=d?.always?R.Trace:p,w=this.doCreateLogger(t,p??this.logLevel,d),this.loggerItems.set(t,{logger:w,logLevel:p})),w}setLevel(t,d){const p=A.URI.isUri(t)?t:void 0,w=p?d:t;if(p){const F=this.loggerItems.get(p);F&&F.logLevel!==w&&(F.logLevel=w,F.logger.setLevel(w))}else this.logLevel=w,this.loggerItems.forEach(({logLevel:F,logger:j})=>{F===void 0&&j.setLevel(this.logLevel)})}getLogLevel(t){return this.loggerItems.get(t)?.logLevel}dispose(){this.loggerItems.forEach(({logger:t})=>t.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=h;class T{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(t){}getLevel(){return R.Info}trace(t,...d){}debug(t,...d){}info(t,...d){}warn(t,...d){}error(t,...d){}critical(t,...d){}dispose(){}flush(){}}e.NullLogger=T;class s extends T{}e.NullLogService=s;class u extends h{constructor(){super(R.Info,D.Event.None)}doCreateLogger(t,d,p){return new T}}e.NullLoggerService=u;function n(a){if(a.verbose)return R.Trace;if(typeof a.logLevel=="string"){const t=i(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function i(a){switch(a){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Critical;case"off":return R.Off}}e.parseLogLevel=i;function o(a){switch(a){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Critical:return"critical";case R.Off:return"off"}}e.LogLevelToString=o}),define(Ie[85],Ce([1,0,29,128,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var _;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(g,l){return l-g}y.compare=P;const R=Object.create(null);R[y.Error]=(0,D.localize)(0,null),R[y.Warning]=(0,D.localize)(1,null),R[y.Info]=(0,D.localize)(2,null);function E(g){return R[g]||""}y.toString=E;function m(g){switch(g){case r.default.Error:return y.Error;case r.default.Warning:return y.Warning;case r.default.Info:return y.Info;case r.default.Ignore:return y.Hint}}y.fromSeverity=m;function I(g){switch(g){case y.Error:return r.default.Error;case y.Warning:return r.default.Warning;case y.Info:return r.default.Info;case y.Hint:return r.default.Ignore}}y.toSeverity=I}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const P="";function R(m){return E(m,!0)}y.makeKey=R;function E(m,I){const g=[P];return m.source?g.push(m.source.replace("\xA6","\\\xA6")):g.push(P),m.code?typeof m.code=="string"?g.push(m.code.replace("\xA6","\\\xA6")):g.push(m.code.value.replace("\xA6","\\\xA6")):g.push(P),m.severity!==void 0&&m.severity!==null?g.push(_.toString(m.severity)):g.push(P),m.message&&I?g.push(m.message.replace("\xA6","\\\xA6")):g.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?g.push(m.startLineNumber.toString()):g.push(P),m.startColumn!==void 0&&m.startColumn!==null?g.push(m.startColumn.toString()):g.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?g.push(m.endLineNumber.toString()):g.push(P),m.endColumn!==void 0&&m.endColumn!==null?g.push(m.endColumn.toString()):g.push(P),g.push(P),g.join("\xA6")}y.makeKeyOptionalMessage=E})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(Ie[150],Ce([1,0,4,29,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=D.default,e.INotificationService=(0,b.createDecorator)("notificationService");var N;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(Ie[86],Ce([1,0,7,10,2,3]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,N.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function _(R,E){return b.URI.isUri(R)?(0,D.equalsIgnoreCase)(R.scheme,E):(0,D.startsWithIgnoreCase)(R,E+":")}e.matchesScheme=_;function A(R,...E){return E.some(m=>_(R,m))}e.matchesSomeScheme=A;function y(R,E){return R.with({fragment:`${E.startLineNumber},${E.startColumn}${E.endLineNumber?`-${E.endLineNumber}${E.endColumn?`,${E.endColumn}`:""}`:""}`})}e.withSelection=y;function P(R){let E;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return m&&(E={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},R=R.with({fragment:""})),{selection:E,uri:R}}e.extractSelection=P}),define(Ie[151],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__decorate||function(ne,e,r,D){var b=arguments.length,N=b<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,r):D,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ne,e,r,D);else for(var A=ne.length-1;A>=0;A--)(_=ne[A])&&(N=(b<3?_(N):b>3?_(e,r,N):_(e,r))||N);return b>3&&N&&Object.defineProperty(e,r,N),N},$e=this&&this.__param||function(ne,e){return function(r,D){e(r,D,ne)}};define(Ie[152],Ce([1,0,15,21,7,3]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var _;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(E){this.callback=E}report(E){this._value=E,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends b.Disposable{constructor(E,m){super(),this.deferred=new r.DeferredPromise,m.withProgress(E,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};y=xe([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends b.Disposable{constructor(E){super(),this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(E){this.stop();const m=++this.currentOperationId,I=new D.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:I.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Ie[30],Ce([1,0,46,9]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(_,A){r.ok(D.isString(_)),r.ok(D.isObject(A)),r.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new b}),define(Ie[87],Ce([1,0,4,30]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class N{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[b(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new N;D.Registry.add(e.Extensions.JSONContribution,_)}),define(Ie[88],Ce([1,0,18,4,9,124,45,87,30]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(T){T.Multiline="multilineText",T.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(T){T[T.APPLICATION=1]="APPLICATION",T[T.MACHINE=2]="MACHINE",T[T.WINDOW=3]="WINDOW",T[T.RESOURCE=4]="RESOURCE",T[T.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",T[T.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=y.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,u=!0){this.registerConfigurations([s],u)}registerConfigurations(s,u=!0){const n=this.doRegisterConfigurations(s,u);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const u=this.doDeregisterConfigurations(s);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:s,remove:u}){const n=[];n.push(...this.doDeregisterConfigurations(u)),n.push(...this.doRegisterConfigurations(s,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(n)})}registerDefaultConfigurations(s){const u=[],n=[];for(const{overrides:i,source:o}of s)for(const a in i)if(u.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const t=this.configurationDefaultsOverrides.get(a),d=t?.valuesSources??new Map;if(o)for(const j of Object.keys(i[a]))d.set(j,o);const p={...t?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:p,valuesSources:d});const w=(0,_.getLanguageTagSettingPlainKey)(a),F={type:"object",default:p,description:N.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:b.isString(o)?void 0:o,defaultValueSource:o};n.push(...l(a)),this.configurationProperties[a]=F,this.defaultLanguageConfigurationOverridesNode.properties[a]=F}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:o});const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const u=[];for(const{overrides:n,source:i}of s)for(const o in n){const a=this.configurationDefaultsOverrides.get(o),t=b.isString(i)?i:i?.id,d=b.isString(a?.source)?a?.source:a?.source?.id;if(t===d)if(u.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const p=this.configurationProperties[o];p&&(this.updatePropertyDefaultValue(o,p),this.updateSchema(o,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const u of s)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,u){const n=[];return s.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,u,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(s){const u=[],n=i=>{if(i.properties)for(const o in i.properties){u.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>n(o))};for(const i of s){n(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}return u}validateAndRegisterProperties(s,u=!0,n,i,o=3){o=b.isUndefinedOrNull(s.scope)?o:s.scope;const a=[],t=s.properties;if(t)for(const p in t){const w=t[p];if(u&&S(p,w)){delete t[p];continue}if(w.source=n,w.defaultDefaultValue=t[p].default,this.updatePropertyDefaultValue(p,w),e.OVERRIDE_PROPERTY_REGEX.test(p)?w.scope=void 0:(w.scope=b.isUndefinedOrNull(w.scope)?o:w.scope,w.restricted=b.isUndefinedOrNull(w.restricted)?!!i?.includes(p):w.restricted),t[p].hasOwnProperty("included")&&!t[p].included){this.excludedConfigurationProperties[p]=t[p],delete t[p];continue}else this.configurationProperties[p]=t[p],t[p].policy?.name&&this.policyConfigurations.set(t[p].policy.name,p);!t[p].deprecationMessage&&t[p].markdownDeprecationMessage&&(t[p].deprecationMessage=t[p].markdownDeprecationMessage),a.push(p)}const d=s.allOf;if(d)for(const p of d)a.push(...this.validateAndRegisterProperties(p,u,n,i,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const u=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(u)};u(s)}updateSchema(s,u){switch(e.allSettings.properties[s]=u,u.scope){case 1:e.applicationSettings.properties[s]=u;break;case 2:e.machineSettings.properties[s]=u;break;case 6:e.machineOverridableSettings.properties[s]=u;break;case 3:e.windowSettings.properties[s]=u;break;case 4:e.resourceSettings.properties[s]=u;break;case 5:e.resourceSettings.properties[s]=u,this.resourceLanguageSettingsSchema.properties[s]=u;break}}removeFromSchema(s,u){switch(delete e.allSettings.properties[s],u.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const u=`[${s}]`,n={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,n),e.allSettings.properties[u]=n,e.applicationSettings.properties[u]=n,e.machineSettings.properties[u]=n,e.machineOverridableSettings.properties[u]=n,e.windowSettings.properties[u]=n,e.resourceSettings.properties[u]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,u){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,o=n?.source;b.isUndefined(i)&&(i=u.defaultDefaultValue,o=void 0),b.isUndefined(i)&&(i=f(u.type)),u.default=i,u.defaultValueSource=o}}const I="\\[([^\\]]+)\\]",g=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(T){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(T)){let u=g.exec(T);for(;u?.length;){const n=u[1].trim();n&&s.push(n),u=g.exec(T)}}return(0,r.distinct)(s)}e.overrideIdentifiersFromKey=l;function c(T){return T.reduce((s,u)=>`${s}[${u}]`,"")}e.keyFromOverrideIdentifiers=c;function f(T){switch(Array.isArray(T)?T[0]:T){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new m;y.Registry.add(e.Extensions.Configuration,v);function S(T,s){return T.trim()?e.OVERRIDE_PROPERTY_REGEX.test(T)?N.localize(7,null,T):v.getConfigurationProperties()[T]!==void 0?N.localize(8,null,T):s.policy?.name&&v.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,T,s.policy?.name,v.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.validateProperty=S;function h(){const T=[],s=v.getConfigurationProperties();for(const u of Object.keys(s))T.push([u,s[u].scope]);return T.push(["launch",4]),T.push(["task",4]),T}e.getScopes=h}),define(Ie[153],Ce([1,0,18,4,105,7,24,25,9,2,45,88,30]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(u={},n=[],i=[],o){this._contents=u,this._keys=n,this._overrides=i,this.raw=o,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const u=this.raw.map(n=>{if(n instanceof I)return n;const i=new g("");return i.parseRaw(n),i.configurationModel});this._rawConfiguration=u.reduce((n,i)=>i===n?i:n.merge(i),u[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(u){return u?(0,R.getConfigurationValue)(this.contents,u):this.contents}inspect(u,n){const i=this.rawConfiguration.getValue(u),o=n?this.rawConfiguration.getOverrideValue(u,n):void 0,a=n?this.rawConfiguration.override(n).getValue(u):i;return{value:i,override:o,merged:a}}getOverrideValue(u,n){const i=this.getContentsForOverrideIdentifer(n);return i?u?(0,R.getConfigurationValue)(i,u):i:void 0}getKeysForOverrideIdentifier(u){const n=[];for(const i of this.overrides)i.identifiers.includes(u)&&n.push(...i.keys);return r.distinct(n)}getAllOverrideIdentifiers(){const u=[];for(const n of this.overrides)u.push(...n.identifiers);return r.distinct(u)}override(u){let n=this.overrideConfigurations.get(u);return n||(n=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,n)),n}merge(...u){const n=A.deepClone(this.contents),i=A.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const t of u)if(a.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.mergeContents(n,t.contents);for(const d of t.overrides){const[p]=i.filter(w=>r.equals(w.identifiers,d.identifiers));p?(this.mergeContents(p.contents,d.contents),p.keys.push(...d.keys),p.keys=r.distinct(p.keys)):i.push(A.deepClone(d))}for(const d of t.keys)o.indexOf(d)===-1&&o.push(d)}return new I(n,o,i,a.every(t=>t instanceof I)?void 0:a)}freeze(){return this.frozen=!0,this}clone(){return new I(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(u){const n=this.getContentsForOverrideIdentifer(u);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const o of r.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const t=n[o];t&&(typeof a=="object"&&typeof t=="object"?(a=A.deepClone(a),this.mergeContents(a,t)):a=t),i[o]=a}return new I(i,this.keys,this.overrides)}mergeContents(u,n){for(const i of Object.keys(n)){if(i in u&&y.isObject(u[i])&&y.isObject(n[i])){this.mergeContents(u[i],n[i]);continue}u[i]=A.deepClone(n[i])}}checkAndFreeze(u){return this.frozen&&!Object.isFrozen(u)?A.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let n=null,i=null;const o=a=>{a&&(i?this.mergeContents(i,a):i=A.deepClone(a))};for(const a of this.overrides)r.equals(a.identifiers,[u])?n=a.contents:a.identifiers.includes(u)&&o(a.contents);return o(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,n){this.addKey(u),(0,R.addToValueTree)(this.contents,u,n,i=>{throw new Error(i)})}removeValue(u){this.removeKey(u)&&(0,R.removeFromValueTree)(this.contents,u)}addKey(u){let n=this.keys.length;for(let i=0;i<n;i++)u.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,u)}removeKey(u){const n=this.keys.indexOf(u);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=I;class g{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,n){if(!y.isUndefinedOrNull(u)){const i=this.doParseContent(u);this.parseRaw(i,n)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,n){this._raw=u;const{contents:i,keys:o,overrides:a,restricted:t,hasExcludedProperties:d}=this.doParseRaw(u,n);this._configurationModel=new I(i,o,a,d?[u]:void 0),this._restrictedConfigurations=t||[]}doParseContent(u){let n={},i=null,o=[];const a=[],t=[];function d(w){Array.isArray(o)?o.push(w):i!==null&&(o[i]=w)}const p={onObjectBegin:()=>{const w={};d(w),a.push(o),o=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const w=[];d(w),a.push(o),o=w,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:d,onError:(w,F,j)=>{t.push({error:w,offset:F,length:j})}};if(u)try{b.visit(u,p),n=o[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return n}doParseRaw(u,n){const i=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(u,i,!0,n);u=o.raw;const a=(0,R.toValuesTree)(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),t=Object.keys(u),d=this.toOverrides(u,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:a,keys:t,overrides:d,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(u,n,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:u,restricted:[],hasExcludedProperties:a};const t={},d=[];for(const p in u)if(E.OVERRIDE_PROPERTY_REGEX.test(p)&&i){const w=this.filter(u[p],n,!1,o);t[p]=w.raw,a=a||w.hasExcludedProperties,d.push(...w.restricted)}else{const w=n[p],F=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&d.push(p),(F===void 0||o.scopes===void 0||o.scopes.includes(F))&&!(o.skipRestricted&&w?.restricted)?t[p]=u[p]:a=!0}return{raw:t,restricted:d,hasExcludedProperties:a}}toOverrides(u,n){const i=[];for(const o of Object.keys(u))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const t in u[o])a[t]=u[o][t];i.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,R.toValuesTree)(a,n)})}return i}}e.ConfigurationModelParser=g;class l extends N.Disposable{constructor(u,n,i,o){super(),this.userSettingsResource=u,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=l;class c{constructor(u,n,i,o,a,t,d,p,w,F,j,U,C){this.key=u,this.overrides=n,this.value=i,this.overrideIdentifiers=o,this.defaultConfiguration=a,this.policyConfiguration=t,this.applicationConfiguration=d,this.userConfiguration=p,this.localUserConfiguration=w,this.remoteUserConfiguration=F,this.workspaceConfiguration=j,this.folderConfigurationModel=U,this.memoryInspectValue=C}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class f{constructor(u,n,i,o,a=new I,t=new I,d=new _.ResourceMap,p=new I,w=new _.ResourceMap,F=!0){this._defaultConfiguration=u,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=t,this._folderConfigurations=d,this._memoryConfiguration=p,this._memoryConfigurationByResource=w,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(u,n,i){return this.getConsolidatedConfigurationModel(u,n,i).getValue(u)}updateValue(u,n,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new I,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(u):o.setValue(u,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,n,i){const o=this.getConsolidatedConfigurationModel(u,n,i),a=r.distinct(o.overrides.map(p=>p.identifiers).flat()).filter(p=>o.getOverrideValue(u,p)!==void 0),t=this.getFolderConfigurationModelForResource(n.resource,i),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new c(u,n,o.getValue(u),a.length?a:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),i?this._workspaceConfiguration.freeze():void 0,t?t.freeze():void 0,d.inspect(u,n.overrideIdentifier))}keys(u){const n=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,n){this._folderConfigurations.set(u,n),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,n){const i=[];if(!n){const{added:o,updated:a,removed:t}=h(this._defaultConfiguration,u);n=[...o,...a,...t]}for(const o of n)for(const a of(0,E.overrideIdentifiersFromKey)(o)){const t=this._defaultConfiguration.getKeysForOverrideIdentifier(a),d=u.getKeysForOverrideIdentifier(a),p=[...d.filter(w=>t.indexOf(w)===-1),...t.filter(w=>d.indexOf(w)===-1),...t.filter(w=>!A.equals(this._defaultConfiguration.override(a).getValue(w),u.override(a).getValue(w)))];i.push([a,p])}return this.updateDefaultConfiguration(u),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(u){const{added:n,updated:i,removed:o}=h(this._policyConfiguration,u),a=[...n,...i,...o];return a.length&&this.updatePolicyConfiguration(u),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:n,updated:i,removed:o,overrides:a}=h(this.applicationConfiguration,u),t=[...n,...i,...o];return t.length&&this.updateApplicationConfiguration(u),{keys:t,overrides:a}}compareAndUpdateLocalUserConfiguration(u){const{added:n,updated:i,removed:o,overrides:a}=h(this.localUserConfiguration,u),t=[...n,...i,...o];return t.length&&this.updateLocalUserConfiguration(u),{keys:t,overrides:a}}compareAndUpdateRemoteUserConfiguration(u){const{added:n,updated:i,removed:o,overrides:a}=h(this.remoteUserConfiguration,u),t=[...n,...i,...o];return t.length&&this.updateRemoteUserConfiguration(u),{keys:t,overrides:a}}compareAndUpdateWorkspaceConfiguration(u){const{added:n,updated:i,removed:o,overrides:a}=h(this.workspaceConfiguration,u),t=[...n,...i,...o];return t.length&&this.updateWorkspaceConfiguration(u),{keys:t,overrides:a}}compareAndUpdateFolderConfiguration(u,n){const i=this.folderConfigurations.get(u),{added:o,updated:a,removed:t,overrides:d}=h(i,n),p=[...o,...a,...t];return(p.length||!i)&&this.updateFolderConfiguration(u,n),{keys:p,overrides:d}}compareAndDeleteFolderConfiguration(u){const n=this.folderConfigurations.get(u);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:i,updated:o,removed:a,overrides:t}=h(n,void 0);return{keys:[...i,...o,...a],overrides:t}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,n,i){let o=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:u},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&u){const o=n.getFolder(u);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const a=this._memoryConfigurationByResource.get(u);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let n=this._foldersConsolidatedConfigurations.get(u);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(u);o?(n=i.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(u,n)):n=i}return n}getFolderConfigurationModelForResource(u,n){if(n&&u){const i=n.getFolder(u);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,n)=>{const{contents:i,overrides:o,keys:a}=this._folderConfigurations.get(n);return u.push([n,{contents:i,overrides:o,keys:a}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>u.add(n)),this.userConfiguration.freeze().keys.forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>u.add(i))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(u).forEach(o=>n.add(o))),[...n.values()]}static parse(u){const n=this.parseConfigurationModel(u.defaults),i=this.parseConfigurationModel(u.policy),o=this.parseConfigurationModel(u.application),a=this.parseConfigurationModel(u.user),t=this.parseConfigurationModel(u.workspace),d=u.folders.reduce((p,w)=>(p.set(P.URI.revive(w[0]),this.parseConfigurationModel(w[1])),p),new _.ResourceMap);return new f(n,i,o,a,new I,t,d,new I,new _.ResourceMap,!1)}static parseConfigurationModel(u){return new I(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=f;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,n=new Map;for(const o of s)o.keys.forEach(a=>u.add(a)),o.overrides.forEach(([a,t])=>{const d=(0,_.getOrSet)(n,a,new Set);t.forEach(p=>d.add(p))});const i=[];return n.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...u.values()],overrides:i}}e.mergeChanges=v;class S{constructor(u,n,i,o){this.change=u,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;u.keys.forEach(d=>a.add(d)),u.overrides.forEach(([,d])=>d.forEach(p=>a.add(p))),this.affectedKeys=[...a.values()];const t=new I;this.affectedKeys.forEach(d=>t.setValue(d,{})),this.affectedKeysTree=t.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(u,n,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(u,n,this.currentWorkspace);return!A.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(u,n){let i=(0,R.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(u=u[o],!u)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=S;function h(s,u){const{added:n,removed:i,updated:o}=T(u?.rawConfiguration,s?.rawConfiguration),a=[],t=s?.getAllOverrideIdentifiers()||[],d=u?.getAllOverrideIdentifiers()||[];if(u){const p=d.filter(w=>!t.includes(w));for(const w of p)a.push([w,u.getKeysForOverrideIdentifier(w)])}if(s){const p=t.filter(w=>!d.includes(w));for(const w of p)a.push([w,s.getKeysForOverrideIdentifier(w)])}if(u&&s){for(const p of t)if(d.includes(p)){const w=T({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:u.getOverrideValue(void 0,p)||{},keys:u.getKeysForOverrideIdentifier(p)});a.push([p,[...w.added,...w.removed,...w.updated]])}}return{added:n,removed:i,updated:o,overrides:a}}function T(s,u){const n=s?u?s.keys.filter(a=>u.keys.indexOf(a)===-1):[...s.keys]:[],i=u?s?u.keys.filter(a=>s.keys.indexOf(a)===-1):[...u.keys]:[],o=[];if(s&&u){for(const a of u.keys)if(s.keys.indexOf(a)!==-1){const t=(0,R.getConfigurationValue)(u.contents,a),d=(0,R.getConfigurationValue)(s.contents,a);A.equals(t,d)||o.push(a)}}return{added:n,removed:i,updated:o}}}),define(Ie[89],Ce([1,0,12,3]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var b;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends r.ErrorNoTelemetry{static isTemporarilyNotAvailable(A){return A instanceof N&&A._code===b.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof N&&A._code===b.NoResolverFound}static isHandled(A){return A instanceof N&&A.isHandled}constructor(A,y=b.Unknown,P){super(A),this._message=A,this._code=y,this._detail=P,this.isHandled=y===b.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N}),define(Ie[60],Ce([1,0,13]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(P){return P.scheme===r.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=D;function b(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=b;function N(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=N;function _(P){const{host:R,port:E}=y(P);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:E}}e.parseAuthorityWithPort=_;function A(P,R){let{host:E,port:m}=y(P);return typeof m>"u"&&(m=R),{host:E,port:m}}e.parseAuthorityWithOptionalPort=A;function y(P){const R=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,60]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=N;function _(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,c){if(typeof l>"u"||l===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof l=="string"||typeof c=="string"){const f=typeof l=="string"?l:l.value,v=typeof c=="string"?c:c.value;return r.equalsIgnoreCase(f,v)}return l._lower===c._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.ExtensionIdentifier=P;function R(g){return E(g)}e.isApplicationScopedExtension=R;function E(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function m(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function I(g,l){if(l){const c=`onResolveRemoteAuthority:${(0,b.getRemoteName)(l)}`;return g.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[154],Ce([1,0,10,84,26,20,2,12,47]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(u,n){return u.uuid&&n.uuid?u.uuid===n.uuid:u.id===n.id?!0:(0,r.compareIgnoreCase)(u.id,n.id)===0}e.areSameExtensions=P;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(n){const i=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new E(n.identifier,i,o)}static parse(n){const i=R.exec(n);return i&&i[1]&&i[2]?new E({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof E?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=E;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(u){const n=m.exec(u);return n&&n[1]?[l(n[1]),n[2]]:[l(u),void 0]}e.getIdAndVersion=I;function g(u,n){return`${u}.${n}`}e.getExtensionId=g;function l(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=l;function c(u,n){return l(g(u,n))}e.getGalleryExtensionId=c;function f(u,n){const i=[],o=a=>{for(const t of i)if(t.some(d=>P(n(d),n(a))))return t;return null};for(const a of u){const t=o(a);t?t.push(a):i.push([a])}return i}e.groupByExtension=f;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function S(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function h(u,n){const i=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(t=>!P(t.identifier,{id:a}))){const t=u.filter(d=>P(d.identifier,{id:a}));t.length===1&&(i.push(t[0]),o.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=h;async function T(u,n){if(!N.isLinux)return!1;let i;try{i=(await u.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await u.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=T;async function s(u,n){const i=await T(u,n),o=(0,D.getTargetPlatform)(i?"alpine":N.platform,y.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Ie[155],Ce([1,0,20,47,2,38]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function _(P){if(r.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function A(P,R,E,m,I,g,l,c,f,v){const S=Object.create(null);S["common.machineId"]=l,S.sessionID=(0,N.generateUuid)()+Date.now(),S.commitHash=I,S.version=g,S["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,r.PlatformToString)(r.platform),S["common.nodePlatform"]=D.platform,S["common.nodeArch"]=m,S["common.product"]=v||"desktop",c&&(S["common.msftInternal"]=c);let h=0;const T=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-T,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),r.isLinuxSnap&&(S["common.snap"]="true");const s=_(E);s&&(S["common.platformDetail"]=s);try{const u=await P.readFile(b.URI.file(f));S["common.source"]=u.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=A;function y(P){const R=D.env.USERDNSDOMAIN;if(!R)return!1;const E=R.toLowerCase();return P.some(m=>E===m)}e.verifyMicrosoftInternalDomain=y}),define(Ie[156],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,r.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,r.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var b;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(b=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[157],Ce([1,0,25,114,9,45,155,156]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,D.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class P{async publicLog(i,o,a){}async publicLogError(i,o,a){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function R(n,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(o.source),configurationKeys:f(o.sourceConfig)})})}e.configurationTelemetry=R;function E(n,i){return!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=E;function m(n){const i=n.getValue(A.TELEMETRY_SETTING_ID),o=n.getValue("telemetry.enableCrashReporter");if(n.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function I(n){const i={},o={},a={};c(n,a);for(let t in a){t=t.length>150?t.substr(t.length-149):t;const d=a[t];typeof d=="number"?o[t]=d:typeof d=="boolean"?o[t]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${d.length}`),i[t]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(i[t]=d)}return{properties:i,measurements:o}}e.validateTelemetryData=I;const g=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function l(n){if(!n)return"none";for(const i of g)if(n.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=l;function c(n,i,o=0,a){if(!!n)for(const t of Object.getOwnPropertyNames(n)){const d=n[t],p=a?a+t:t;Array.isArray(d)?i[p]=(0,r.safeStringify)(d):d instanceof Date?i[p]=d.toISOString():(0,b.isObject)(d)?o<2?c(d,i,o+1,p+"."):i[p]=(0,r.safeStringify)(d):i[p]=d}}function f(n){if(!n)return[];const i=[];return v(i,"",n),i}function v(n,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(a=>v(n,i?`${i}.${a}`:a,o[a])):n.push(i)}function S(n,i){const o=n.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,_.verifyMicrosoftInternalDomain)(o)||a}e.isInternalTelemetry=S;function h(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=h;function T(n,i){let o=n;const a=[];for(const w of i)for(;;){const F=w.exec(n);if(!F)break;a.push([F.index,w.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(o="";;){const w=d.exec(n);if(!w)break;!t.test(w[0])&&a.every(([F,j])=>w.index<F||w.index>=j)&&(o+=n.substring(p,w.index)+"<REDACTED: user-file-path>",p=d.lastIndex)}return p<n.length&&(o+=n.substr(p)),o}function s(n){if(!n)return n;const i=n.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of o)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return n}function u(n,i){return(0,r.cloneAndChange)(n,o=>{if(typeof o=="string"){let a=o;a=T(a,i);for(const t of i)a=a.replace(t,"");return a=s(a),a}})}e.cleanData=u}),define(Ie[158],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,N,_=5){const A=N(y=>{const P=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(b);if(R){R.data.push(P);return}const E=setTimeout(()=>this.flushBuffer(b),_);R={data:[P],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(b),A.dispose()}},this._terminalBufferMap.set(b,R)});return A}stopBuffering(b){this._terminalBufferMap.get(b)?.dispose()}flushBuffer(b){const N=this._terminalBufferMap.get(b);N&&(this._terminalBufferMap.delete(b),this._callback(b,N.data.join("")))}}e.TerminalDataBufferer=r}),define(Ie[159],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var r;(function(N){N.DARK="dark",N.LIGHT="light",N.HIGH_CONTRAST_DARK="hcDark",N.HIGH_CONTRAST_LIGHT="hcLight"})(r=e.ColorScheme||(e.ColorScheme={}));function D(N){return N===r.HIGH_CONTRAST_DARK||N===r.HIGH_CONTRAST_LIGHT}e.isHighContrast=D;function b(N){return N===r.DARK||N===r.HIGH_CONTRAST_DARK}e.isDark=b}),define(Ie[61],Ce([1,0,117,4,7,3,30,159]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,N.createDecorator)("themeService");var y;(function(c){function f(v){return v&&typeof v=="object"&&typeof v.id=="string"}c.isThemeColor=f})(y=e.ThemeColor||(e.ThemeColor={}));function P(c){return{id:c}}e.themeColorFromId=P;var R;(function(c){function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||y.isThemeColor(i.color))}c.isThemeIcon=f;const v=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function S(i){const o=v.exec(i);if(!o)return;const[,a]=o;return{id:a}}c.fromString=S;function h(i){return{id:i}}c.fromId=h;function T(i,o){let a=i.id;const t=a.lastIndexOf("~");return t!==-1&&(a=a.substring(0,t)),o&&(a=`${a}~${o}`),{id:a}}c.modify=T;function s(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}c.getModifier=s;function u(i,o){return i.id===o.id&&i.color?.id===o.color?.id}c.isEqual=u;function n(i,o){return{id:i.id,color:o?P(o):void 0}}c.asThemeIcon=n,c.asClassNameArray=r.CSSIcon.asClassNameArray,c.asClassName=r.CSSIcon.asClassName,c.asCSSSelector=r.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function E(c){switch(c){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,b.toDisposable)(()=>{const v=this.themingParticipants.indexOf(f);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const I=new m;_.Registry.add(e.Extensions.ThemingContribution,I);function g(c){return I.onColorThemeChange(c)}e.registerThemingParticipant=g;class l extends b.Disposable{constructor(f){super(),this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,v){let S=this.theme.getColor(f);return S&&v&&(S=v(S,this.theme)),S?S.toString():null}}e.Themable=l}),define(Ie[160],Ce([1,0,4,20,3,11]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var _;(function(l){l.Http="http",l.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=E;function m(l,c){return c?c!==1&&l<1024:!D.isWindows&&l<1024}e.isPortPrivileged=m;class I{constructor(c,f,v){this.remoteAddress=c,this.localAddress=f,this._dispose=v,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=I;let g=class{constructor(c){this.logService=c,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],f=Array.from(this._tunnels.values());for(const v of f){const S=Array.from(v.values());for(const h of S){const T=await h.value;T&&c.push(T)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:f}of c.values())await f.then(v=>v?.dispose());c.clear()}this._tunnels.clear()}setEnvironmentTunnel(c,f,v,S,h){this.addTunnelToMap(c,f,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:f,localAddress:v,privacy:S,protocol:h,dispose:()=>Promise.resolve()}))}openTunnel(c,f,v,S,h=!1,T,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${v} on local port ${S}.`),!c)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(c,f,v,S,h,T,s);return u?u.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==f||n.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const f=this._tunnels.get(c.tunnelRemoteHost);if(f){const v=f.get(c.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,v))}}}}async tryDisposeTunnel(c,f,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${f}.`);const S=v.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(f),S}}async closeTunnel(c,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${f} `);const v=this._tunnels.get(c);if(v&&v.has(f)){const S=v.get(f);S.refcount=0,await this.tryDisposeTunnel(c,f,S)}}addTunnelToMap(c,f,v){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(f,{refcount:1,value:v})}async removeEmptyTunnelFromMap(c,f){const v=this._tunnels.get(c);v&&(await v.get(f)||v.delete(f),v.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,f){const v=[c];R(c)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):E(c)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const S=v.map(h=>this._tunnels.get(h));for(const h of S){const T=h?.get(f);if(T)return T}}canTunnel(c){return!!P(c)}doIsPortPrivileged(c,f,v,S){if(f)return!1;if(v){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(S);if(h?.length===4){const T=parseInt(h[1]),s=parseInt(h[2]);if(T>10||T===10&&s>=14)return!1}}return c<1024}createWithProvider(c,f,v,S,h,T,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${v} on local port ${S}.`);const u=v;this._factoryInProgress.add(u);const n=S===void 0?v:S,i={elevationRequired:h?this.isPortPrivileged(n):!1},o={remoteAddress:{host:f,port:v},localAddressPort:S,privacy:T,public:T?T!==A.Private:void 0,protocol:s},a=c.forwardPort(o,i);return a?(this.addTunnelToMap(f,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),a}};g=xe([$e(0,N.ILogService)],g),e.AbstractTunnelService=g}),define(Ie[161],Ce([1,0,13]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function D(y){return y.scheme!==r.Schemas.file&&y.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=D;function b(y){if(y.folders.length)return y.folders.every(P=>D(P.uri))?y.folders[0].uri:void 0;if(y.configuration&&D(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=b;function N(y){return b(y)?.scheme}e.getVirtualWorkspaceScheme=N;function _(y){return b(y)?.authority}e.getVirtualWorkspaceAuthority=_;function A(y){return b(y)!==void 0}e.isVirtualWorkspace=A}),define(Ie[48],Ce([1,0,129,19,24,22,2,3,13]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function P(u){const n=u;return typeof n?.id=="string"&&_.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(u,n){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,D.basename)(u)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=u;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=R;function E(u){const n=u;return typeof n?.id=="string"&&_.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=E;function m(u){const n=u;if(n?.uri)return{id:n.id,uri:_.URI.revive(n.uri)};const i=u;if(i?.configPath)return{id:i.id,configPath:_.URI.revive(i.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=m;var I;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function g(u){const n=u;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=g;function l(u){const n=u;return!!(n&&typeof n=="object"&&_.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=l;class c{constructor(n,i,o,a,t){this._id=n,this._transient=o,this._configuration=a,this._ignorePathCasing=t,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class f{constructor(n,i){this.raw=i,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,N.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function v(u){return new f({uri:u,index:0,name:(0,N.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(u,n){return N.extUriBiasedIgnorePathCase.isEqualOrParent(u,n.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function h(u){let n;return _.URI.isUri(u)?n=u:n=u.configuration,n?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=h;function T(u,n){return!S(u,n)&&!h(u)}e.isSavedWorkspace=T;function s(u){return(typeof u=="string"?(0,D.extname)(u):(0,N.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ie[62],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const N=this._idPool++;return this._data.set(N,b),this.logDebugInfo(),N}get(b,N){return this._data.has(b)?this._data.get(b)[N]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ie[36],Ce([1,0,13,22,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new D.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ie[162],Ce([1,0,15]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class D{constructor(_,A,y){this._deferredPromises=new Map,this._id=_,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const E of P.values())E.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,A){let y=this._value[_];return typeof y>"u"&&(y=A),y}update(_,A){this._value[_]=A;const y=this._deferredPromises.get(_);if(y!==void 0)return y.p;const P=new r.DeferredPromise;return this._deferredPromises.set(_,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=D;class b extends D{setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}constructor(_,A){super(_.identifier.value,!0,A),this._extension=_}}e.ExtensionGlobalMemento=b}),define(Ie[163],Ce([1,0,4,2]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class b{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,A,y,P){const E=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(_)).acceptModelChanged(A.value,y,P);this._onDidChangeNotebookDocument.fire(E)}$acceptDirtyStateChanged(_,A){this._notebooksAndEditors.getNotebookDocument(D.URI.revive(_)).acceptDirty(A)}$acceptModelSaved(_){const A=this._notebooksAndEditors.getNotebookDocument(D.URI.revive(_));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=b}),define(Ie[14],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class D{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=D});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[164],Ce([1,0,26,4]),function(ne,e,r,D){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(A,y){b.set(this,void 0),this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),Ye(this,b,y,"f"),Oe(this,b,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(A){return Oe(this,b,"f").get(this._id,A)}store(A,y){return Oe(this,b,"f").store(this._id,A,y)}delete(A){return Oe(this,b,"f").delete(this._id,A)}}e.ExtensionSecrets=N,b=new WeakMap}),define(Ie[63],Ce([1,0,3,160,4,14]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(y){function P(E){return{remoteAddress:E.remoteAddress,localAddress:E.localAddress,public:!!E.public,privacy:E.privacy??(E.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:E.protocol}}y.fromApiTunnel=P;function R(E){return{remoteAddress:{host:E.tunnelRemoteHost,port:E.tunnelRemotePort},localAddress:E.localAddress,public:E.privacy!==D.TunnelPrivacyId.ConstantPrivate&&E.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:E.privacy,protocol:E.protocol}}y.fromServiceTunnel=R})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(P){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,E,m,I){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=xe([$e(0,N.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ie[49],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class D{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=D}),define(Ie[165],Ce([1,0,23]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class D{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function b(A,y){if(y.serializeBuffersForPostMessage){const P=new D,R=(I,g)=>{if(g instanceof ArrayBuffer){const l=P.add(g);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(g)){const l=N(g);if(l){const c=P.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:c,view:{type:l,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},E=JSON.stringify(A,R),m=P.buffers.map(I=>{const g=new Uint8Array(I);return r.VSBuffer.wrap(g)});return{message:E,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=b;function N(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(A,y){const P=y.map(m=>{const I=new ArrayBuffer(m.byteLength);return new Uint8Array(I).set(m.buffer),I}),R=y.length?(m,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const g=I,{index:l}=g,c=P[l];if(g.view)switch(g.view.type){case 1:return new Int8Array(c,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return I}:void 0;return{message:JSON.parse(A,R),arrayBuffers:P}}e.deserializeWebviewMessage=_}),define(Ie[90],Ce([1,0,137,9,2,7,3,30,35,13]),function(ne,e,r,D,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(G){const te=G;return!!te&&typeof te.getSelection=="function"&&!!te.onDidChangeSelection}e.isEditorPaneWithSelection=m;function I(G,te,he){for(const re of he.visibleEditorPanes)if(re.group.id===te&&G.matches(re.input))return re.getViewState()}e.findViewStateForEditor=I;function g(G){if(o(G))return!1;const te=G;return b.URI.isUri(te?.resource)}e.isResourceEditorInput=g;function l(G){if(o(G))return!1;const te=G;return te?.original!==void 0&&te.modified!==void 0}e.isResourceDiffEditorInput=l;function c(G){if(o(G)||l(G))return!1;const te=G;return te?.primary!==void 0&&te.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function f(G){if(o(G))return!1;const te=G;return te?te.resource===void 0||te.resource.scheme===P.Schemas.untitled||te.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const v=/Untitled-\d+/;function S(G){return G.scheme===P.Schemas.untitled&&G.path.length>1&&!v.test(G.path)}e.isUntitledWithAssociatedResource=S;function h(G){if(o(G))return!1;const te=G;return b.URI.isUri(te?.base?.resource)&&b.URI.isUri(te?.input1?.resource)&&b.URI.isUri(te?.input2?.resource)&&b.URI.isUri(te?.result?.resource)}e.isResourceMergeEditorInput=h;var T;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(T=e.Verbosity||(e.Verbosity={}));var s;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(te,he){let re=this.mapIdToSaveSource.get(te);return re||(re={source:te,label:he},this.mapIdToSaveSource.set(te,re)),re.source}getSourceLabel(te){return this.mapIdToSaveSource.get(te)?.label??te}}e.SaveSourceRegistry=new u;var n;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends N.Disposable{}e.AbstractEditorInput=i;function o(G){return G instanceof i}e.isEditorInput=o;function a(G){const te=G;return b.URI.isUri(te?.preferredResource)}function t(G){const te=G;return o(te?.primary)&&o(te?.secondary)}e.isSideBySideEditorInput=t;function d(G){const te=G;return o(te?.modified)&&o(te?.original)}e.isDiffEditorInput=d;function p(G){return o(G?.editor)}e.isEditorInputWithOptions=p;function w(G){const te=G;return p(G)&&te?.group!==void 0}e.isEditorInputWithOptionsAndGroup=w;function F(G){const te=G;return typeof te?.groupId=="number"&&o(te.editor)}e.isEditorIdentifier=F;var j;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var C;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(C=e.SideBySideEditor||(e.SideBySideEditor={}));class W{getOriginalUri(te,he){if(!te)return;if(h(te))return e.EditorResourceAccessor.getOriginalUri(te.result,he);if(he?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(he?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===C.ANY)return this.getOriginalUri(be,{filterByScheme:he.filterByScheme})??this.getOriginalUri(le,{filterByScheme:he.filterByScheme});te=he.supportSideBySide===C.PRIMARY?be:le}}if(l(te)||c(te)||h(te))return;const re=a(te)?te.preferredResource:te.resource;return!re||!he||!he.filterByScheme?re:this.filterUri(re,he.filterByScheme)}getSideEditors(te){return t(te)||c(te)?{primary:te.primary,secondary:te.secondary}:d(te)||l(te)?{primary:te.modified,secondary:te.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(te,he){if(!te)return;if(h(te))return e.EditorResourceAccessor.getCanonicalUri(te.result,he);if(he?.supportSideBySide){const{primary:be,secondary:le}=this.getSideEditors(te);if(be&&le){if(he?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===C.ANY)return this.getCanonicalUri(be,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:he.filterByScheme});te=he.supportSideBySide===C.PRIMARY?be:le}}if(l(te)||c(te)||h(te))return;const re=te.resource;return!re||!he||!he.filterByScheme?re:this.filterUri(re,he.filterByScheme)}filterUri(te,he){if(Array.isArray(he)){if(he.some(re=>te.scheme===re))return te}else if(he===te.scheme)return te}}e.EditorResourceAccessor=new W;var M;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(te){const he=this.instantiationService=te.get(_.IInstantiationService);for(const[re,be]of this.editorSerializerConstructors)this.createEditorSerializer(re,be,he);this.editorSerializerConstructors.clear()}createEditorSerializer(te,he,re){const be=re.createInstance(he);this.editorSerializerInstances.set(te,be)}registerFileEditorFactory(te){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=te}getFileEditorFactory(){return(0,D.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(te,he){if(this.editorSerializerConstructors.has(te)||this.editorSerializerInstances.has(te))throw new Error(`A editor serializer with type ID '${te}' was already registered.`);return this.instantiationService?this.createEditorSerializer(te,he,this.instantiationService):this.editorSerializerConstructors.set(te,he),(0,N.toDisposable)(()=>{this.editorSerializerConstructors.delete(te),this.editorSerializerInstances.delete(te)})}getEditorSerializer(te){return this.editorSerializerInstances.get(typeof te=="string"?te:te.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new O);async function H(G,te){return!G||!G.length?[]:await Promise.all(G.map(async he=>{const re=b.URI.revive(he.fileUri);if(!re||!await te.canHandleResource(re))return;let le=he.exists,fe=he.type;if(typeof le!="boolean"||typeof fe!="number")try{fe=(await te.stat(re)).isDirectory?y.FileType.Directory:y.FileType.Unknown,le=!0}catch{le=!1}if(!le&&he.openOnlyIfExists||fe===y.FileType.Directory)return;const Q={...he.options,pinned:!0};return le?{resource:re,options:Q}:{resource:re,options:Q,forceUntitled:!0}}))}e.pathsToEditors=H;var $;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}));function z(G){const te=G;if(!te)return!1;const he=te;if(he.modified)return z(he.modified);const re=te;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.isTextEditorViewState=z}),define(Ie[64],Ce([1,0,13,2]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function b(A,y){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===r.Schemas.file&&(A=D.URI.from({scheme:r.Schemas.vscodeRemote,authority:y.authority,path:A.path})),D.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${N(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=b;function N(A){return A.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function _(A){return A.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=_}),define(Ie[166],Ce([1,0,4,7,64]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(A,y,P){this._proxy=A,this._editors=y,this._remoteInfo=P,this._handlePool=0,this._disposables=new D.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const R=y.getVisibleTextEditors();for(const E of this._insets.values())R.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,P,R,E){let m;for(const S of this._editors.getVisibleTextEditors(!0))if(S.value===A){m=S;break}if(!m)throw new Error("not a visible editor");const I=this,g=this._handlePool++,l=new r.Emitter,c=new r.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(S){return(0,b.asWebviewUri)(S,I._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(S){this._options=S,I._proxy.$setOptions(g,S)}get options(){return this._options}set html(S){this._html=S,I._proxy.$setHtml(g,S)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(S){return I._proxy.$postMessage(g,S)}},v=new class{constructor(){this.editor=A,this.line=y,this.height=P,this.webview=f,this.onDidDispose=c.event}dispose(){I._insets.has(g)&&(I._insets.delete(g),I._proxy.$disposeEditorInset(g),c.fire(),c.dispose(),l.dispose())}};return this._proxy.$createEditorInset(g,m.id,m.value.document.uri,y+1,P,R||{},E.identifier,E.extensionLocation),this._insets.set(g,{editor:A,inset:v,onDidReceiveMessage:l}),v}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this._insets.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=N}),define(Ie[167],Ce([1,0,4,15,138]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,P,R){const E={command:A};if(y&&Object.keys(y).length>0&&(E.arguments=y),this.internalSend("request",E),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const I=this.pendingRequests.get(E.seq);if(I){this.pendingRequests.delete(E.seq);const g={type:"response",seq:0,request_seq:E.seq,success:!1,command:A,message:(0,b.localize)(0,null,R,A)};I(g)}},R)}return P&&this.pendingRequests.set(E.seq,P),E.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,D.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const y=A,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,P)=>A.set(P,y)),await(0,D.timeout)(500),A.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=N}),define(Ie[168],Ce([1,0,139,40,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new D.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new D.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new D.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new D.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new D.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new D.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new D.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new D.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new D.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new D.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new D.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new D.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new D.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new D.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new D.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new D.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new D.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new D.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new D.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new D.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new D.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new D.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new D.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new D.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new D.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new D.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new D.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new D.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new D.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new D.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new D.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new D.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new D.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new D.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new D.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new D.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new D.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new D.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new D.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new D.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new D.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new D.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new D.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new D.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new D.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new D.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new D.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new D.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new D.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new D.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new D.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const N=m=>r.localize(51,null,m);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var _;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(_=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var E;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(E=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[169],Ce([1,0,10,2,19,25,13]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(n,i,o){return n.replace(A,function(a,t){return i&&t.length>0&&t[0]!=="_"?a:o&&o.hasOwnProperty(t)?o[t]:a})}e.formatPII=y;function P(n){const i={};for(const o of Object.keys(n))o.startsWith("!")||(i[o]=n[o]);return i}e.filterExceptionsFromTelemetry=P;function R(n){return n.configuration.request==="attach"&&!E(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function E(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(i,"extensionhost")||(0,r.equalsIgnoreCase)(i,"pwa-extensionhost")?n:n.parentSession?E(n.parentSession):void 0}e.getExtensionHostDebugSession=E;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function I(n,i,o){let a,t=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=d.exec(n);){const w=p.index+1,F=w+p[0].length;if(w<=i&&F>=o){a=p[0],t=w;break}}if(a){const w=/\w+/g;let F=null;for(;(F=w.exec(a))&&!(F.index+1+t+F[0].length>=o););F&&(a=a.substring(0,w.lastIndex))}return a?{start:t,end:t+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(n){return!!(n&&n.match(g))}e.isUri=l;function c(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(l(n.path))return D.URI.parse(n.path);if((0,b.isAbsolute)(n.path))return D.URI.file(n.path)}return n.path}function f(n){if(typeof n.path=="object"){const i=D.URI.revive(n.path);if(i)return i.scheme===_.Schemas.file?i.fsPath:i.toString()}return n.path}function v(n,i){const o=i?c:f,a=(0,N.deepClone)(n);return h(a,(t,d)=>{t&&d&&(d.path=o(d))}),a}e.convertToDAPaths=v;function S(n,i){const o=i?c:f,a=(0,N.deepClone)(n);return h(a,(t,d)=>{!t&&d&&(d.path=o(d))}),a}e.convertToVSCPaths=S;function h(n,i){switch(n.type){case"event":{const o=n;switch(o.event){case"output":i(!1,o.body.source);break;case"loadedSource":i(!1,o.body.source);break;case"breakpoint":i(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=n;switch(o.command){case"setBreakpoints":i(!0,o.arguments.source);break;case"breakpointLocations":i(!0,o.arguments.source);break;case"source":i(!0,o.arguments.source);break;case"gotoTargets":i(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(a=>i(!1,a));break;default:break}break}case"response":{const o=n;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(a=>i(!1,a.source));break;case"loadedSources":o.body.sources.forEach(a=>i(!1,a));break;case"scopes":o.body.scopes.forEach(a=>i(!1,a.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(a=>i(!1,a.source));break;case"setBreakpoints":o.body.breakpoints.forEach(a=>i(!1,a.source));break;case"disassemble":o.body?.instructions.forEach(t=>i(!1,t.location));break;default:break}break}}}function T(n){return n.filter(i=>!i.presentation?.hidden).sort((i,o)=>i.presentation?o.presentation?i.presentation.group?o.presentation.group?i.presentation.group!==o.presentation.group?i.presentation.group.localeCompare(o.presentation.group):s(i.presentation.order,o.presentation.order):-1:o.presentation.group?1:s(i.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=T;function s(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}async function u(n,i){const o=n.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(o!=="none"&&(await i.saveAll(),o==="allEditorsInActiveGroup")){const a=i.activeEditorPane;a&&a.input.resource?.scheme===_.Schemas.untitled&&await i.save({editor:a.input,groupId:a.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ie[65],Ce([1,0,23,34,170,78,13,19,20,40]),function(ne,e,r,D,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(H){H[H.Running=1]="Running",H[H.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(H){H[H.Unconfirmed=1]="Unconfirmed",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(H){H[H.WithHardKernelDependency=0]="WithHardKernelDependency",H[H.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",H[H.Pure=2]="Pure",H[H.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(H){H.Always="always",H.Never="never",H.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(H){H[H.ModelChange=1]="ModelChange",H[H.Move=2]="Move",H[H.ChangeCellLanguage=5]="ChangeCellLanguage",H[H.Initialize=6]="Initialize",H[H.ChangeCellMetadata=7]="ChangeCellMetadata",H[H.Output=8]="Output",H[H.OutputItem=9]="OutputItem",H[H.ChangeCellContent=10]="ChangeCellContent",H[H.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",H[H.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",H[H.ChangeCellMime=13]="ChangeCellMime",H[H.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(H){H[H.Handle=0]="Handle",H[H.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(H){H[H.Replace=1]="Replace",H[H.Output=2]="Output",H[H.Metadata=3]="Metadata",H[H.CellLanguage=4]="CellLanguage",H[H.DocumentMetadata=5]="DocumentMetadata",H[H.Move=6]="Move",H[H.OutputItems=7]="OutputItems",H[H.PartialMetadata=8]="PartialMetadata",H[H.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var v;(function(H){H.scheme=_.Schemas.vscodeNotebookCell;const $=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${$.join("")}]+`),G=7;function te(Q,pe){const Se=pe.toString(G),Ue=`${Se.length<$.length?$[Se.length-1]:"z"}${Se}s${(0,r.encodeBase64)(r.VSBuffer.fromString(Q.scheme),!0,!0)}`;return Q.with({scheme:H.scheme,fragment:Ue})}H.generate=te;function he(Q){if(Q.scheme!==H.scheme)return;const pe=Q.fragment.indexOf("s");if(pe<0)return;const Se=parseInt(Q.fragment.substring(0,pe).replace(z,""),G),Fe=(0,r.decodeBase64)(Q.fragment.substring(pe+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Q.with({scheme:Fe,fragment:null})}}H.parse=he;function re(Q,pe){return Q.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${Q.scheme!==_.Schemas.file?Q.scheme:""}`})}H.generateCellOutputUri=re;function be(Q){if(Q.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!pe)return;const Se=pe[1]&&pe[1]!==""?pe[1]:void 0,Fe=pe[2];return{outputId:Se,notebook:Q.with({scheme:Fe||_.Schemas.file,fragment:null})}}H.parseCellOutputUri=be;function le(Q,pe,Se){return H.generate(Q,pe).with({scheme:Se})}H.generateCellPropertyUri=le;function fe(Q,pe){if(Q.scheme===pe)return H.parse(Q.with({scheme:H.scheme}))}H.parseCellPropertyUri=fe})(v=e.CellUri||(e.CellUri={}));const S=H=>y.isWindows?H.replace(/\//g,"\\"):H;class h{constructor($=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=z,this.order=[...new Set($)].map(G=>({pattern:G,matches:D.parse(S(G))}))}sort($){const z=new Map(b.Iterable.map($,te=>[te,S(te)]));let G=[];for(const{matches:te}of this.order)for(const[he,re]of z)if(te(re)){G.push(he),z.delete(he);break}return z.size&&(G=G.concat([...z.keys()].sort((te,he)=>this.defaultOrder.indexOf(te)-this.defaultOrder.indexOf(he)))),G}prioritize($,z){const G=this.findIndex($);if(G===-1){this.order.unshift({pattern:$,matches:D.parse(S($))});return}const te=new Set(z.map(re=>this.findIndex(re,G)));te.delete(-1);const he=Array.from(te).sort();this.order.splice(G+1,0,...he.map(re=>this.order[re]));for(let re=he.length-1;re>=0;re--)this.order.splice(he[re],1)}toArray(){return this.order.map($=>$.pattern)}findIndex($,z=this.order.length){const G=S($);for(let te=0;te<z;te++)if(this.order[te].matches(G))return te;return-1}}e.MimeTypeDisplayOrder=h;function T(H,$,z,G=(te,he)=>te===he){const te=[];function he(le,fe,Q){if(fe===0&&Q.length===0)return;const pe=te[te.length-1];pe&&pe.start+pe.deleteCount===le?(pe.deleteCount+=fe,pe.toInsert.push(...Q)):te.push({start:le,deleteCount:fe,toInsert:Q})}let re=0,be=0;for(;;){if(re===H.length){he(re,0,$.slice(be));break}if(be===$.length){he(re,H.length-re,[]);break}const le=H[re],fe=$[be];if(G(le,fe)){re+=1,be+=1;continue}z(fe)?(he(re,1,[]),re+=1):(he(re,0,[fe]),be+=1)}return te}e.diff=T,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(H){H.default="default",H.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(H){const $=H;return!!((typeof $.include=="string"||D.isRelativePattern($.include))&&(typeof $.exclude=="string"||D.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=u;function n(H,$,z){if(Array.isArray(H.viewType)&&H.viewType.indexOf($)>=0||H.viewType===$)return!0;if(H.filenamePattern){const G=u(H.filenamePattern)?H.filenamePattern.include:H.filenamePattern,te=u(H.filenamePattern)?H.filenamePattern.exclude:void 0;if(D.match(G,(0,A.basename)(z.fsPath).toLowerCase()))return!(te&&D.match(te,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create($){return`${o._prefix}${$}`}static parse($){if($.startsWith(o._prefix))return $.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/";function a(H){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(H)}e.isTextStreamMime=a;const t=new TextDecoder;function d(H){const $=[];let z=!1;for(const G of H)($.length===0||z)&&($.push(G),z=!0);return j($),O(r.VSBuffer.concat($.map(G=>r.VSBuffer.wrap(G))))}e.compressOutputItemStreams=d;const p=`${String.fromCharCode(27)}[A`,w=p.split("").map(H=>H.charCodeAt(0)),F=10;function j(H){H.forEach(($,z)=>{if(z===0||$.length<p.length)return;const G=H[z-1],te=$.subarray(0,p.length);if(te[0]===w[0]&&te[1]===w[1]&&te[2]===w[2]){const he=G.lastIndexOf(F);if(he===-1)return;H[z-1]=G.subarray(0,he),H[z]=$.subarray(p.length)}})}function U(H){let $=H;do H=$,$=H.replace(/[^\n]\x08/gm,"");while($.length<H.length);return H}function C(H){for(H=H.replace(/\r+\n/gm,`
`);H.search(/\r[^$]/g)>-1;){const $=H.match(/^(.*)\r+/m)[1];let z=H.match(/\r+(.*)$/m)[1];z=z+$.slice(z.length,$.length),H=H.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return H}const W="\b".charCodeAt(0),M="\r".charCodeAt(0);function O(H){return!H.buffer.includes(W)&&!H.buffer.includes(M)?H:r.VSBuffer.fromString(C(U(t.decode(H.buffer))))}}),define(Ie[171],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var D;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(D=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ie[172],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function D(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=D;function b(_){return Array.from(_.entries()).map(A=>[A[0],r(A[1].map)])}e.serializeEnvironmentVariableCollections=b;function N(_){return new Map(_.map(A=>[A[0],{map:D(A[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(Ie[41],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(N){N.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var D;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(D=e.TestPosition||(e.TestPosition={}));class b{static fromExtHostTestItem(_,A,y=_.parent){if(_._isRoot)return new b([A]);const P=[_.id];for(let R=y;R&&R.id!==A;R=R.parent)P.push(R.id);return P.push(A),new b(P.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const A=_.indexOf("\0");return A===-1?_:_.slice(0,A)}static fromString(_){return new b(_.split("\0"))}static join(_,A){return new b([..._.path,A])}static joinToString(_,A){return _.toString()+"\0"+A}static parentId(_){const A=_.lastIndexOf("\0");return A===-1?void 0:_.slice(0,A)}static compare(_,A){return _===A?0:A.startsWith(_+"\0")?2:_.startsWith(A+"\0")?3:1}constructor(_,A=_.length){if(this.path=_,this.viewEnd=A,_.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new b(this.path,_)}*idsToRoot(){for(let _=this.viewEnd;_>0;_--)yield new b(this.path,_)}compare(_){if(typeof _=="string")return b.compare(this.toString(),_);for(let A=0;A<_.viewEnd&&A<this.viewEnd;A++)if(_.path[A]!==this.path[A])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=b}),define(Ie[50],Ce([1,0,2,51,41]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(t){t[t.Unset=0]="Unset",t[t.Queued=1]="Queued",t[t.Running=2]="Running",t[t.Passed=3]="Passed",t[t.Failed=4]="Failed",t[t.Skipped=5]="Skipped",t[t.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var _;(function(t){t[t.Run=2]="Run",t[t.Debug=4]="Debug",t[t.Coverage=8]="Coverage",t[t.HasNonDefaultProfile=16]="HasNonDefaultProfile",t[t.HasConfigurable=32]="HasConfigurable"})(_=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(t){t.serialize=d=>({range:d.range.toJSON(),uri:d.uri.toJSON()}),t.deserialize=d=>({range:D.Range.lift(d.range),uri:r.URI.revive(d.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(t){t[t.Error=0]="Error",t[t.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var P;(function(t){t.serialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,location:d.location&&A.serialize(d.location)}),t.deserialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,location:d.location&&A.deserialize(d.location)})})(P=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(t,d)=>`${d?"s":"e"}${t}`;e.getMarkId=R;var E;(function(t){t.serialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&A.serialize(d.location)}),t.deserialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&A.deserialize(d.location)})})(E=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(t){t.serialize=d=>d.type===0?P.serialize(d):E.serialize(d),t.deserialize=d=>d.type===0?P.deserialize(d):E.deserialize(d)})(m=e.ITestMessage||(e.ITestMessage={}));var I;(function(t){t.serializeWithoutMessages=d=>({state:d.state,duration:d.duration,messages:[]}),t.serialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(m.serialize)}),t.deserialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(m.deserialize)})})(I=e.ITestTaskState||(e.ITestTaskState={}));const g="\0",l=(t,d)=>t+g+d;e.namespaceTestTag=l;const c=t=>{const d=t.indexOf(g);return{ctrlId:t.slice(0,d),tagId:t.slice(d+1)}};e.denamespaceTestTag=c;var f;(function(t){t.serialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?.toJSON(),range:d.range?.toJSON()||null,description:d.description,error:d.error,sortText:d.sortText}),t.deserialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?r.URI.revive(d.uri):void 0,range:d.range?D.Range.lift(d.range):null,description:d.description,error:d.error,sortText:d.sortText})})(f=e.ITestItem||(e.ITestItem={}));var v;(function(t){t[t.NotExpandable=0]="NotExpandable",t[t.Expandable=1]="Expandable",t[t.BusyExpanding=2]="BusyExpanding",t[t.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(t){t.serialize=d=>({expand:d.expand,item:f.serialize(d.item)}),t.deserialize=d=>({controllerId:b.TestId.root(d.item.extId),expand:d.expand,item:f.deserialize(d.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var h;(function(t){t.serialize=d=>{let p;return d.item&&(p={},d.item.label!==void 0&&(p.label=d.item.label),d.item.tags!==void 0&&(p.tags=d.item.tags),d.item.busy!==void 0&&(p.busy=d.item.busy),d.item.uri!==void 0&&(p.uri=d.item.uri?.toJSON()),d.item.range!==void 0&&(p.range=d.item.range?.toJSON()),d.item.description!==void 0&&(p.description=d.item.description),d.item.error!==void 0&&(p.error=d.item.error),d.item.sortText!==void 0&&(p.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:p}},t.deserialize=d=>{let p;return d.item&&(p={},d.item.label!==void 0&&(p.label=d.item.label),d.item.tags!==void 0&&(p.tags=d.item.tags),d.item.busy!==void 0&&(p.busy=d.item.busy),d.item.range!==void 0&&(p.range=d.item.range?D.Range.lift(d.item.range):null),d.item.description!==void 0&&(p.description=d.item.description),d.item.error!==void 0&&(p.error=d.item.error),d.item.sortText!==void 0&&(p.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:p}}})(h=e.ITestItemUpdate||(e.ITestItemUpdate={}));const T=(t,d)=>{d.expand!==void 0&&(t.expand=d.expand),d.item!==void 0&&(t.item=t.item?Object.assign(t.item,d.item):d.item)};e.applyTestItemUpdate=T;var s;(function(t){t.serializeWithoutMessages=d=>({...S.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(I.serializeWithoutMessages),retired:d.retired}),t.serialize=d=>({...S.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(I.serialize),retired:d.retired}),t.deserialize=d=>({...S.deserialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(I.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var u;(function(t){t[t.Function=0]="Function",t[t.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var n;(function(t){t[t.Add=0]="Add",t[t.Update=1]="Update",t[t.DocumentSynced=2]="DocumentSynced",t[t.Remove=3]="Remove",t[t.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",t[t.Retire=5]="Retire",t[t.AddTag=6]="AddTag",t[t.RemoveTag=7]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var i;(function(t){t.deserialize=d=>d.op===0?{op:d.op,item:S.deserialize(d.item)}:d.op===1?{op:d.op,item:h.deserialize(d.item)}:d.op===2?{op:d.op,uri:r.URI.revive(d.uri),docv:d.docv}:d,t.serialize=d=>d.op===0?{op:d.op,item:S.serialize(d.item)}:d.op===1?{op:d.op,item:h.serialize(d.item)}:d})(i=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(d){}update(d){}remove(d,p){}complete(){}}e.IncrementalChangeCollector=o;class a{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(d){const p=this.createChangeCollector();for(const w of d)switch(w.op){case 0:{const F=S.deserialize(w.item),j=b.TestId.parentId(F.item.extId)?.toString();if(j){if(this.items.has(j)){const U=this.items.get(j);U.children.add(F.item.extId);const C=this.createItem(F,U);this.items.set(F.item.extId,C),p.add(C)}}else{const U=this.createItem(F);this.roots.add(U),this.items.set(F.item.extId,U),p.add(U)}F.expand===2&&this.busyControllerCount++;break}case 1:{const F=h.deserialize(w.item),j=this.items.get(F.extId);if(!j)break;F.expand!==void 0&&(j.expand===2&&this.busyControllerCount--,F.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,F),p.update(j);break}case 3:{const F=this.items.get(w.itemId);if(!F)break;const j=b.TestId.parentId(F.item.extId)?.toString();j?this.items.get(j).children.delete(F.item.extId):this.roots.delete(F);const U=[[w.itemId]];for(;U.length;)for(const C of U.pop()){const W=this.items.get(C);W&&(U.push(W.children),this.items.delete(C),p.remove(W,W!==F),W.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this._tags.set(w.tag.id,w.tag);break;case 7:this._tags.delete(w.id);break}p.complete()}retireTest(d){}updatePendingRoots(d){this.pendingRootCount+=d}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=a}),define(Ie[66],Ce([1,0,15,4,7,46,50,41]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(f,v)=>f===v,R={range:(f,v)=>f===v?!0:!f||!v?!1:f.equalsRange(v),busy:P,label:P,description:P,error:P,tags:(f,v)=>!(f.length!==v.length||f.some(S=>!v.includes(S)))},E=(f,v)=>{let S;for(const[h,T]of Object.entries(R))T(f[h],v[h])||(S?S[h]=v[h]:S={[h]:v[h]});return S};class m extends b.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new D.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const S of this.tree.values())this.updateExpandability(S)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const S of this.diff)if(S.op===2&&S.uri===v.uri){S.docv=v.docv;return}break}case 1:{const S=this.diff[this.diff.length-1];if(S){if(S.op===1&&S.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(S.item,v.item);return}if(S.op===0&&S.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(S.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,S){const h=this.tree.get(v);if(!!h){if((h.expandLevels===void 0||S>h.expandLevels)&&(h.expandLevels=S),h.expand===1){const T=this.resolveChildren(h);return T.isOpen()?this.expandChildren(h,S-1):T.wait().then(()=>this.expandChildren(h,S-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,S-1)):this.expandChildren(h,S-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,S){switch(S.op){case 3:this.removeItem(A.TestId.joinToString(v.fullId,S.id));break;case 0:this.upsertItem(S.item,v);break;case 5:for(const h of S.ops)this.onTestItemEvent(v,h);break;case 1:this.diffTagRefs(S.new,S.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:S.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,N.assertNever)(S)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,S){const h=A.TestId.fromExtHostTestItem(v,this.root.id,S?.actual),T=this.options.getApiFor(v);T.parent&&T.parent!==S?.actual&&this.options.getChildren(T.parent).delete(v.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:v,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(v,S),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,s,S);return}if(s.actual===v){this.connectItem(v,s,S);return}const u=this.options.getChildren(s.actual),n=s.actual,i=E(this.options.toITestItem(n),this.options.toITestItem(v));this.options.getApiFor(n).listener=void 0,s.actual=v,s.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,n.tags,h.toString()),delete i.tags),this.onTestItemEvent(s,{op:4,update:i})),this.connectItemAndChildren(v,s,S);for(const[o,a]of u)this.options.getChildren(v).get(a.id)||this.removeItem(A.TestId.joinToString(h,a.id));this.documentSynced(s.actual.uri)}diffTagRefs(v,S,h){const T=new Set(S.map(s=>s.id));for(const s of v)T.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:h,item:{tags:v.map(s=>(0,_.namespaceTestTag)(this.options.controllerId,s.id))}}}),T.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const S=this.tags.get(v.id);S?S.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const S=this.tags.get(v);S&&!--S.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,S){this.options.getApiFor(v).parent=S&&S.actual!==this.root?S.actual:void 0}connectItem(v,S,h){this.setItemParent(v,h);const T=this.options.getApiFor(v);T.parent=h?.actual,T.listener=s=>this.onTestItemEvent(S,s),this.updateExpandability(S)}connectItemAndChildren(v,S,h){this.connectItem(v,S,h);for(const[T,s]of this.options.getChildren(v))this.upsertItem(s,S)}updateExpandability(v){let S;this._resolveHandler?v.resolveBarrier?S=v.resolveBarrier.isOpen()?3:2:S=v.actual.canResolveChildren?1:0:S=0,S!==v.expand&&(v.expand=S,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:S}}),S===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,S){if(S<0)return;const h=[];for(const[T,s]of this.options.getChildren(v.actual)){const u=this.expand(A.TestId.joinToString(v.fullId,s.id),S);(0,r.isThenable)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const s=new r.Barrier;return s.open(),s}v.expand=2,this.pushExpandStateUpdate(v);const S=v.resolveBarrier=new r.Barrier,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let T;try{T=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(s){h(s)}return(0,r.isThenable)(T)?T.catch(h).then(()=>{S.open(),this.updateExpandability(v)}):(S.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const S=this.tree.get(v);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const h=[S];for(;h.length;){const T=h.pop();if(!!T){this.options.getApiFor(T.actual).listener=void 0;for(const s of T.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(T.fullId.toString());for(const[s,u]of this.options.getChildren(T.actual))h.push(this.tree.get(A.TestId.joinToString(T.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=m;class I extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=I;class g extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class l extends Error{constructor(v,S,h){super(`TestItem with ID "${v}" is from controller "${S}" and cannot be added as a child of an item from controller "${h}".`)}}e.MixedTestItemController=l;const c=(f,v,S)=>{let h=new Map;return{get size(){return h.size},forEach(T,s){for(const u of h.values())T.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(T){const s=new Map,u=new Set(h.keys()),n={op:5,ops:[]};for(const i of T){if(!(i instanceof S))throw new g(i.id);const o=v(i).controllerId;if(o!==f.controllerId)throw new l(i.id,o,f.controllerId);if(s.has(i.id))throw new I(i.id);s.set(i.id,i),u.delete(i.id),n.ops.push({op:0,item:i})}for(const i of u.keys())n.ops.push({op:3,id:i});f.listener?.(n),h=s},add(T){if(!(T instanceof S))throw new g(T.id);h.set(T.id,T),f.listener?.({op:0,item:T})},delete(T){h.delete(T)&&f.listener?.({op:3,id:T})},get(T){return h.get(T)},toJSON(){return Array.from(h.values())}}};e.createTestItemChildren=c}),define(Ie[91],Ce([1,0,66]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const D=new WeakMap,b=(_,A)=>{const y={controllerId:A};return D.set(_,y),y};e.createPrivateApiFor=b;const N=_=>{const A=D.get(_);if(!A)throw new r.InvalidTestItemError(_?.id||"<unknown>");return A};e.getPrivateApiFor=N}),define(Ie[173],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var D;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(D=e.VariableKind||(e.VariableKind={}));class b extends Error{constructor(_,A){super(A),this.variable=_}}e.VariableError=b}),define(Ie[174],Ce([1,0,19,47,9,25,20,81,142,173,10]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(I,g,l,c){this._contributedVariables=new Map,this._context=I,this._labelService=g,this._userHomePromise=l,c&&(this._envVariablesPromise=c.then(f=>this.prepareEnv(f)))}prepareEnv(I){if(_.isWindows){const g=Object.create(null);return Object.keys(I).forEach(l=>{g[l.toLowerCase()]=I[l]}),g}return I}resolveWithEnvironment(I,g,l){return this.recursiveResolve({env:this.prepareEnv(I),userHome:void 0},g?g.uri:void 0,l)}async resolveAsync(I,g){const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,I?I.uri:void 0,g)}async resolveAnyBase(I,g,l,c){const f=N.deepClone(g);_.isWindows&&f.windows?Object.keys(f.windows).forEach(S=>f[S]=f.windows[S]):_.isMacintosh&&f.osx?Object.keys(f.osx).forEach(S=>f[S]=f.osx[S]):_.isLinux&&f.linux&&Object.keys(f.linux).forEach(S=>f[S]=f.linux[S]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,I?I.uri:void 0,f,l,c)}async resolveAnyAsync(I,g,l){return this.resolveAnyBase(I,g,l)}async resolveAnyMap(I,g,l){const c=new Map;return{newConfig:await this.resolveAnyBase(I,g,l,c),resolvedVariables:c}}resolveWithInteractionReplace(I,g,l,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,g,l,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,g){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,g)}async recursiveResolve(I,g,l,c,f){if(b.isString(l))return this.resolveString(I,g,l,c,f);if(Array.isArray(l))return Promise.all(l.map(v=>this.recursiveResolve(I,g,v,c,f)));if(b.isObject(l)){const v=Object.create(null),S=await Promise.all(Object.keys(l).map(async h=>[await this.resolveString(I,g,h,c,f),await this.recursiveResolve(I,g,l[h],c,f)]));for(const[h,T]of S)v[h]=T;return v}return l}resolveString(I,g,l,c,f){return(0,R.replaceAsync)(l,E.VARIABLE_REGEXP,async(v,S)=>{if(S.includes(E.VARIABLE_LHS))return v;let h=await this.evaluateSingleVariable(I,v,S,g,c);return f?.set(S,h),h!==v&&b.isString(h)&&h.match(E.VARIABLE_REGEXP)&&(h=await this.resolveString(I,g,h,c,f)),h})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}async evaluateSingleVariable(I,g,l,c,f){let v;const S=l.split(":");S.length>1&&(l=S[0],v=S[1]);const h=u=>{const n=this._context.getFilePath();if(n)return n;throw new P.VariableError(u,(0,y.localize)(0,null,g))},T=u=>{const n=h(u);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new P.VariableError(u,(0,y.localize)(1,null,g,r.basename(n)))},s=u=>{if(v){const n=this._context.getFolderUri(v);if(n)return n;throw new P.VariableError(u,(0,y.localize)(2,null,g,v))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new P.VariableError(u,(0,y.localize)(3,null,g)):new P.VariableError(u,(0,y.localize)(4,null,g))};switch(l){case"env":if(v){if(I.env){const u=I.env[_.isWindows?v.toLowerCase():v];if(b.isString(u))return u}return""}throw new P.VariableError(P.VariableKind.Env,(0,y.localize)(5,null,g));case"config":if(v){const u=this._context.getConfigurationValue(c,v);if(b.isUndefinedOrNull(u))throw new P.VariableError(P.VariableKind.Config,(0,y.localize)(6,null,g,v));if(b.isObject(u))throw new P.VariableError(P.VariableKind.Config,(0,y.localize)(7,null,g,v));return u}throw new P.VariableError(P.VariableKind.Config,(0,y.localize)(8,null,g));case"command":return this.resolveFromMap(P.VariableKind.Command,g,v,f,"command");case"input":return this.resolveFromMap(P.VariableKind.Input,g,v,f,"input");case"extensionInstallFolder":if(v){const u=await this._context.getExtension(v);if(!u)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,g,v));return this.fsPath(u.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,g));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(s(P.VariableKind.WorkspaceFolder)));case"cwd":return c||v?(0,A.normalizeDriveLetter)(this.fsPath(s(P.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(s(P.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(I.userHome)return I.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,y.localize)(11,null,g))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new P.VariableError(P.VariableKind.LineNumber,(0,y.localize)(12,null,g))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new P.VariableError(P.VariableKind.SelectedText,(0,y.localize)(13,null,g))}case"file":return h(P.VariableKind.File);case"fileWorkspaceFolder":return T(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||v?r.relative(this.fsPath(s(P.VariableKind.RelativeFile)),h(P.VariableKind.RelativeFile)):h(P.VariableKind.RelativeFile);case"relativeFileDirname":{const u=r.dirname(h(P.VariableKind.RelativeFileDirname));if(c||v){const n=r.relative(this.fsPath(s(P.VariableKind.RelativeFileDirname)),u);return n.length===0?".":n}return u}case"fileDirname":return r.dirname(h(P.VariableKind.FileDirname));case"fileExtname":return r.extname(h(P.VariableKind.FileExtname));case"fileBasename":return r.basename(h(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=r.basename(h(P.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-r.extname(u).length)}case"fileDirnameBasename":return r.basename(r.dirname(h(P.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||g}case"execInstallFolder":{const u=this._context.getAppRoot();return u||g}case"pathSeparator":return r.sep;default:try{const u=v?`${l}:${v}`:l;return this.resolveFromMap(P.VariableKind.Unknown,g,u,f,void 0)}catch{return g}}}}resolveFromMap(I,g,l,c,f){if(l&&c){const v=f===void 0?c[l]:c[f+":"+l];if(typeof v=="string")return v;throw new P.VariableError(I,(0,y.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[92],Ce([1,0,3,90]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var b;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var N;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var A;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(g){const l=g;return(0,D.isEditorInput)(l?.editor)&&(0,D.isEditorInput)(l?.replacement)}e.isEditorReplacement=P;var R;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(E=e.OpenEditorContext||(e.OpenEditorContext={}));function m(g){const l=g;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.isEditorGroup=m;function I(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(Ie[175],Ce([1,0,3,92]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(N){const _=N;return typeof N=="number"||(0,D.isEditorGroup)(_)}e.isPreferredGroup=b}),define(Ie[176],Ce([1,0,3,147]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(D.IEnvironmentService)}),define(Ie[177],Ce([1,0,26,4,19]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(E){this.removedDueToLooping=E}}e.DeltaExtensionsResult=N;class _{constructor(E){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=E,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const E of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(E.identifier))){console.error("Extension `"+E.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(E.identifier),E),this._extensionsArr.push(E),Array.isArray(E.activationEvents))for(let m of E.activationEvents)m==="onUri"&&(m=`onUri:${r.ExtensionIdentifier.toKey(E.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(E)}}set(E){this._extensionDescriptions=E,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(E,m){this._extensionDescriptions=P(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(E);const I=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,I.map(g=>g.identifier)),this._initialize(),this._onDidChange.fire(void 0),new N(I)}static _findLoopingExtensions(E){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,v){this.addNode(f),this.addNode(v),this._arcs.has(f)?this._arcs.get(f).push(v):this._arcs.set(f,[v])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,v){const S=m.getArcs(f);for(let h=0;h<S.length;h++)if(!v.has(S[h]))return!1;return!0}getNodes(){return this._nodesArr}},I=new Map;for(const f of E){const v=r.ExtensionIdentifier.toKey(f.identifier);if(I.set(v,f),f.extensionDependencies)for(const S of f.extensionDependencies){const h=r.ExtensionIdentifier.toKey(S);m.addArc(v,h)}}const g=new Set;m.getNodes().filter(f=>m.getArcs(f).length===0).forEach(f=>g.add(f));const l=m.getNodes().filter(f=>!g.has(f));let c;do{c=!1;for(let f=0;f<l.length;f++){const v=l[f];m.hasOnlyGoodArcs(v,g)&&(l.splice(f,1),f--,g.add(v),c=!0)}}while(c);return l.map(f=>I.get(f))}containsActivationEvent(E){return this._activationMap.has(E)}containsExtension(E){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(E))}getExtensionDescriptionsForActivationEvent(E){const m=this._activationMap.get(E);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(E){const m=this._extensionsMap.get(r.ExtensionIdentifier.toKey(E));return m||void 0}getExtensionDescriptionByUUID(E){for(const m of this._extensionsArr)if(m.uuid===E)return m}getExtensionDescriptionByIdOrUUID(E,m){return this.getExtensionDescription(E)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=_;var A;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(A||(A={}));function y(R,E){const m=R.isBuiltin?0:R.isUnderDevelopment?2:1,I=E.isBuiltin?0:E.isUnderDevelopment?2:1;if(m!==I)return m-I;const g=b.posix.basename(R.extensionLocation.path),l=b.posix.basename(E.extensionLocation.path);return g<l?-1:g>l?1:0}function P(R,E){const m=new Set;return E.forEach(I=>m.add(r.ExtensionIdentifier.toKey(I))),R.filter(I=>!m.has(r.ExtensionIdentifier.toKey(I.identifier)))}}),define(Ie[67],Ce([1,0,23]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var D;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var b;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function _(P){const R=r.VSBuffer.alloc(1);switch(P){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=_;function A(P,R){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A;var y;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[68],Ce([1,0,3,4,11,27,67,60,157,25,2]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let E=class{constructor(l,c){this.initData=l,this._onDidChangeTelemetryEnabled=new D.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new D.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=c.createLogger(R.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(l,c){const f=this.getTelemetryDetails(),v=new m(c,l,this._outputLogger,this.getBuiltInCommonProperties(l),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this._telemetryLoggers.set(l.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(l,c){this._level=l,this._productConfig=c||{usage:!0,error:!0}}getBuiltInCommonProperties(l){const c={};switch(c["common.extname"]=l.name,c["common.extversion"]=l.version,c["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,c["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,c["common.vscodeversion"]=this.initData.version,c["common.isnewappinstall"]=I(this.initData.telemetryInfo.firstSessionDate),c["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case _.UIKind.Web:c["common.uikind"]="web";break;case _.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),c}$onDidChangeTelemetryLevel(l){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=l;const c=this.getTelemetryDetails();this._telemetryLoggers.forEach(f=>{f.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(l,c){const f=this._telemetryLoggers.get(l.value);return f?(f.logError(c),!0):!1}};E=xe([$e(0,N.IExtHostInitDataService),$e(1,b.ILoggerService)],E),e.ExtHostTelemetry=E;class m{constructor(l,c,f,v,S){this._extension=c,this._logger=f,this._commonProperties=v,this._onDidChangeEnableStates=new D.Emitter,this._appender=l,this._telemetryEnablements={isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}}updateTelemetryEnablements(l,c){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:l,isErrorsEnabled:c},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(l){return this._appender.ignoreBuiltInCommonProperties||(l=(0,P.mixin)(l,this._commonProperties)),this._appender.additionalCommonProperties&&(l=(0,P.mixin)(l,this._appender.additionalCommonProperties)),l=(0,y.cleanData)(l,[]),l}logEvent(l,c){l=this._extension.identifier.value+"/"+l,c=this.mixInCommonPropsAndCleanData(c||{}),this._appender.logEvent(l,c),this._logger.trace(l,c)}logUsage(l,c){!this._telemetryEnablements.isUsageEnabled||this.logEvent(l,c)}logError(l,c){!this._telemetryEnablements.isErrorsEnabled||(typeof l=="string"?this.logEvent(l,c):this._appender.logException(l,c))}get apiTelemetryLogger(){if(!this._apiObject){const l=this,c={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return l._telemetryEnablements.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l._onDidChangeEnableStates.event.bind(l)};this._apiObject=Object.freeze(c)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=m;function I(g){const l=Date.now()-new Date(g).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.isNewAppInstall=I,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ie[28],Ce([1,0,4,2,3,26,154]),function(ne,e,r,D,b,N,_){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class y{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class P{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class R{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class E{constructor(a){this.dependency=a}}e.MissingExtensionDependency=E;var m;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class g{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(a,t){const d=[],p=[],w=[],F=[],j=f(this._allExtensions),U=f(a),C=(H,$)=>H.extensionLocation.toString()===$.extensionLocation.toString()||H.isBuiltin===$.isBuiltin||H.isUserBuiltin===$.isUserBuiltin||H.isUnderDevelopment===$.isUnderDevelopment;for(const H of this._allExtensions){const $=U.get(N.ExtensionIdentifier.toKey(H.identifier));if(!$){d.push(H.identifier),j.delete(N.ExtensionIdentifier.toKey(H.identifier));continue}if(!C(H,$)){d.push(H.identifier),j.delete(N.ExtensionIdentifier.toKey(H.identifier));continue}}for(const H of a){const $=j.get(N.ExtensionIdentifier.toKey(H.identifier));if(!$){p.push(H);continue}if(!C($,H)){d.push($.identifier),j.delete(N.ExtensionIdentifier.toKey($.identifier));continue}}const W=c(this._myExtensions),M=c(t);for(const H of this._myExtensions)M.has(N.ExtensionIdentifier.toKey(H))||w.push(H);for(const H of t)W.has(N.ExtensionIdentifier.toKey(H))||F.push(H);const O={toRemove:d,toAdd:p,myToRemove:w,myToAdd:F};return this.delta(O),O}delta(a){const{toRemove:t,toAdd:d,myToRemove:p,myToAdd:w}=a,F=c(t),j=c(p);for(let U=0;U<this._allExtensions.length;U++)F.has(N.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)j.has(N.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of d)this._allExtensions.push(U);for(const U of w)this._myExtensions.push(U)}containsExtension(a){for(const t of this._myExtensions)if(N.ExtensionIdentifier.equals(t,a))return!0;return!1}}e.ExtensionHostExtensions=g;class l{constructor(a){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=N.ExtensionIdentifier.toKey,a)for(const t of a)this.add(t)}get size(){return this._map.size}add(a){return this._map.set(this._toKey(a),a),this}clear(){this._map.clear()}delete(a){return this._map.delete(this._toKey(a))}has(a){return this._map.has(this._toKey(a))}forEach(a,t){this._map.forEach(d=>a.call(t,d,d,this))}*entries(){for(const[a,t]of this._map)yield[t,t]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=l;function c(o){const a=new Set;for(const t of o)a.add(N.ExtensionIdentifier.toKey(t));return a}e.extensionIdentifiersArrayToSet=c;function f(o){const a=new Map;for(const t of o)a.set(N.ExtensionIdentifier.toKey(t.identifier),t);return a}function v(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=v;function S(o,a){if(!v(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=S;class h{constructor(a,t,d,p){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=p}}e.ActivationTimes=h;class T{constructor(a,t){this.description=a,this.value=t}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function n(o,a){return{identifier:new N.ExtensionIdentifier((0,_.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,t){return Promise.resolve(0)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,t){return Promise.resolve()}}e.NullExtensionService=i}),define(Ie[178],Ce([1,0,12,26,28,11,15]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(c,f,v,S){this.startup=c,this.codeLoadingTime=f,this.activateCallTime=v,this.activateResolvedTime=S}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,f){return c===-1||f===-1?-1:f-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class P{constructor(c,f,v,S,h,T){this.activationFailed=c,this.activationFailedError=f,this.activationTimes=v,this.module=S,this.exports=h,this.subscriptions=T}}e.ActivatedExtension=P;class R extends P{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class E extends P{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=E;class m extends P{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let I=class{constructor(c,f,v,S,h){this._logService=h,this._registry=c,this._resolvedExtensionsSet=new Set,f.forEach(T=>this._resolvedExtensionsSet.add(D.ExtensionIdentifier.toKey(T))),this._externalExtensionsMap=new Map,v.forEach(T=>this._externalExtensionsMap.set(D.ExtensionIdentifier.toKey(T),T)),this._host=S,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[c,f]of this._operations)f.dispose()}isActivated(c){const f=this._operations.get(D.ExtensionIdentifier.toKey(c));return Boolean(f&&f.value)}getActivatedExtension(c){const f=this._operations.get(D.ExtensionIdentifier.toKey(c));if(!f||!f.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return f.value}async activateByEvent(c,f){if(this._alreadyActivatedEvents[c])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(c);await this._activateExtensions(v.map(S=>({id:S.identifier,reason:{startup:f,extensionId:S.identifier,activationEvent:c}}))),this._alreadyActivatedEvents[c]=!0}activateById(c,f){const v=this._registry.getExtensionDescription(c);if(!v)throw new Error(`Extension '${c}' is not known`);return this._activateExtensions([{id:v.identifier,reason:f}])}async _activateExtensions(c){const f=c.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(f.map(v=>v.wait()))}_handleActivationRequest(c){if(this._operations.has(D.ExtensionIdentifier.toKey(c.id)))return this._operations.get(D.ExtensionIdentifier.toKey(c.id));if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(c.id)))return this._createAndSaveOperation(c,null,[],null);const f=this._registry.getExtensionDescription(c.id);if(!f){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`),T=this._createAndSaveOperation(c,null,[],new m(h));return this._host.onExtensionActivationError(c.id,h,new b.MissingExtensionDependency(c.id.value)),T}const v=[],S=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const h of S){if(this._resolvedExtensionsSet.has(D.ExtensionIdentifier.toKey(h)))continue;const T=this._operations.get(D.ExtensionIdentifier.toKey(h));if(T){v.push(T);continue}if(this._externalExtensionsMap.has(D.ExtensionIdentifier.toKey(h))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(D.ExtensionIdentifier.toKey(h)),reason:c.reason}));continue}const s=this._registry.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;v.push(this._handleActivationRequest({id:s.identifier,reason:c.reason}));continue}const u=f.displayName||f.identifier.value,n=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),i=this._createAndSaveOperation(c,f.displayName,[],new m(n));return this._host.onExtensionActivationError(f.identifier,n,new b.MissingExtensionDependency(h)),i}return this._createAndSaveOperation(c,f.displayName,v,null)}_createAndSaveOperation(c,f,v,S){const h=new g(c.id,f,c.reason,v,S,this._host,this._logService);return this._operations.set(D.ExtensionIdentifier.toKey(c.id),h),h}};I=xe([$e(4,N.ILogService)],I),e.ExtensionsActivator=I;let g=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(c,f,v,S,h,T,s){this._id=c,this._displayName=f,this._reason=v,this._deps=S,this._value=h,this._host=T,this._logService=s,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let c=0;c<this._deps.length;c++){const f=this._deps[c];if(f.value&&!f.value.activationFailed){this._deps.splice(c,1),c--;continue}if(f.value&&f.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);v.detail=f.value.activationFailedError,this._value=new m(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(c=>c.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(c){const f=new Error;if(c&&c.name&&(f.name=c.name),c&&c.message?f.message=`Activating extension '${this._id.value}' failed: ${c.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${c}.`,c&&c.stack&&(f.stack=c.stack),this._value=new m(f),this._isDisposed&&r.isCancellationError(c))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(c)}}};g=xe([$e(6,N.ILogService)],g)}),define(Ie[179],Ce([1,0,11,27,28]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends r.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:b.ExtensionHostLogFileName}))}};N=xe([$e(0,r.ILoggerService),$e(1,D.IExtHostInitDataService)],N),e.ExtHostLogService=N});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[6],Ce([1,0,18,12,80,24,78,10,9,2,38,35,89,65,28]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g){"use strict";var l,c,f,v,S,h,T,s,u,n,i,o,a,t,d,p,w,F,j,U,C,W,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function O(x){return Object.assign(x,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(x,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[ie,...we]=arguments;return Reflect.construct(x,we,ie.constructor)}}})}let H=h=class{static from(...L){let ie=L;return new h(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(L){l.set(this,void 0),Ye(this,l,L,"f")}dispose(){typeof Oe(this,l,"f")=="function"&&(Oe(this,l,"f").call(this),Ye(this,l,void 0,"f"))}};l=new WeakMap,H=h=xe([O],H),e.Disposable=H;let $=T=class{static Min(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let we=1;we<L.length;we++){const He=L[we];He.isBefore(ie)&&(ie=He)}return ie}static Max(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let we=1;we<L.length;we++){const He=L[we];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(L){if(!L)return!1;if(L instanceof T)return!0;const{line:ie,character:we}=L;return typeof ie=="number"&&typeof we=="number"}static of(L){if(L instanceof T)return L;if(this.isPosition(L))return new T(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(L,ie){if(L<0)throw(0,D.illegalArgument)("line must be non-negative");if(ie<0)throw(0,D.illegalArgument)("character must be non-negative");this._line=L,this._character=ie}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ie=0){if(L===null||ie===null)throw(0,D.illegalArgument)();let we;return typeof L>"u"?we=0:typeof L=="number"?we=L:(we=typeof L.lineDelta=="number"?L.lineDelta:0,ie=typeof L.characterDelta=="number"?L.characterDelta:0),we===0&&ie===0?this:new T(this.line+we,this.character+ie)}with(L,ie=this.character){if(L===null||ie===null)throw(0,D.illegalArgument)();let we;return typeof L>"u"?we=this.line:typeof L=="number"?we=L:(we=typeof L.line=="number"?L.line:this.line,ie=typeof L.character=="number"?L.character:this.character),we===this.line&&ie===this.character?this:new T(we,ie)}toJSON(){return{line:this.line,character:this.character}}};$=T=xe([O],$),e.Position=$;let z=s=class{static isRange(L){return L instanceof s?!0:L?$.isPosition(L.start)&&$.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(L,ie,we,He){let Qe,lt;if(typeof L=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new $(L,ie),lt=new $(we,He)):$.isPosition(L)&&$.isPosition(ie)&&(Qe=$.of(L),lt=$.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");Qe.isBefore(lt)?(this._start=Qe,this._end=lt):(this._start=lt,this._end=Qe)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):$.isPosition(L)?!($.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ie=$.Max(L.start,this._start),we=$.Min(L.end,this._end);if(!ie.isAfter(we))return new s(ie,we)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ie=$.Min(L.start,this._start),we=$.Max(L.end,this.end);return new s(ie,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ie=this.end){if(L===null||ie===null)throw(0,D.illegalArgument)();let we;return L?$.isPosition(L)?we=L:(we=L.start||this.start,ie=L.end||this.end):we=this.start,we.isEqual(this._start)&&ie.isEqual(this.end)?this:new s(we,ie)}toJSON(){return[this.start,this.end]}};z=s=xe([O],z),e.Range=z;let G=u=class extends z{static isSelection(L){return L instanceof u?!0:L?z.isRange(L)&&$.isPosition(L.anchor)&&$.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(L,ie,we,He){let Qe,lt;if(typeof L=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new $(L,ie),lt=new $(we,He)):$.isPosition(L)&&$.isPosition(ie)&&(Qe=$.of(L),lt=$.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");super(Qe,lt),this._anchor=Qe,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=u=xe([O],G),e.Selection=G;class te{constructor(L,ie,we){if(typeof L!="string"||L.length===0)throw(0,D.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,D.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,D.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=te;class he extends Error{static NotAvailable(L,ie){return new he(L,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(L){return new he(L,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ie=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(L),this._message=L,this._code=ie,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,he.prototype)}}e.RemoteAuthorityResolverError=he;var re;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var be;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(be=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=n=class{static isTextEdit(L){return L instanceof n?!0:L?z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ie){return new n(L,ie)}static insert(L,ie){return n.replace(new z(L,L),ie)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const ie=new n(new z(new $(0,0),new $(0,0)),"");return ie.newEol=L,ie}get range(){return this._range}set range(L){if(L&&!z.isRange(L))throw(0,D.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,D.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,D.illegalArgument)("newEol");this._newEol=L}constructor(L,ie){this._range=L,this._newText=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=n=xe([O],le),e.TextEdit=le;let fe=i=class{static isNotebookCellEdit(L){return L instanceof i?!0:L?Vt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ie){return new i(L,ie)}static insertCells(L,ie){return new i(new Vt(L,L),ie)}static deleteCells(L){return new i(L,[])}static updateCellMetadata(L,ie){const we=new i(new Vt(L,L),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(L){const ie=new i(new Vt(0,0),[]);return ie.newNotebookMetadata=L,ie}constructor(L,ie){this.range=L,this.newCells=ie}};fe=i=xe([O],fe),e.NotebookEdit=fe;class Q{static isSnippetTextEdit(L){return L instanceof Q?!0:L?z.isRange(L.range)&&Fe.isSnippetString(L.snippet):!1}static replace(L,ie){return new Q(L,ie)}static insert(L,ie){return Q.replace(new z(L,L),ie)}constructor(L,ie){this.range=L,this.snippet=ie}}e.SnippetTextEdit=Q;var pe;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ie,we,He){this._edits.push({_type:1,from:L,to:ie,options:we,metadata:He})}createFile(L,ie,we){this._edits.push({_type:1,from:void 0,to:L,options:ie,metadata:we})}deleteFile(L,ie,we){this._edits.push({_type:1,from:L,to:void 0,options:ie,metadata:we})}replaceNotebookMetadata(L,ie,we){this._edits.push({_type:3,metadata:we,uri:L,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(L,ie,we,He){const Qe=ie.start,lt=ie.end;(Qe!==lt||we.length>0)&&this._edits.push({_type:5,uri:L,index:Qe,count:lt-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(L,ie,we,He){this._edits.push({_type:3,metadata:He,uri:L,edit:{editType:8,index:ie,metadata:we}})}replace(L,ie,we,He){this._edits.push({_type:2,uri:L,edit:new le(ie,we),metadata:He})}insert(L,ie,we,He){this.replace(L,new z(ie,ie),we,He)}delete(L,ie,we){this.replace(L,ie,"",we)}has(L){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===L.toString())}set(L,ie){if(ie)for(const we of ie){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,fe.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(L,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(L,He.newNotebookMetadata,Qe):this.replaceNotebookCells(L,He.range,He.newCells,Qe):Q.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:L,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this._edits[we]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(L){const ie=[];for(const we of this._edits)we._type===2&&we.uri.toString()===L.toString()&&ie.push(we.edit);return ie}entries(){const L=new N.ResourceMap;for(const ie of this._edits)if(ie._type===2){let we=L.get(ie.uri);we||(we=[ie.uri,[]],L.set(ie.uri,we)),we[1].push(ie.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=xe([O],Se),e.WorkspaceEdit=Se;let Fe=o=class{static isSnippetString(L){return L instanceof o?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this._tabstop=1,this.value=L||""}appendText(L){return this.value+=o._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ie=this._tabstop++){if(typeof L=="function"){const we=new o;we._tabstop=this._tabstop,L(we),this._tabstop=we._tabstop,L=we.value}else L=o._escape(L);return this.value+="${",this.value+=ie,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ie=this._tabstop++){const we=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(L,ie){if(typeof ie=="function"){const we=new o;we._tabstop=this._tabstop,ie(we),this._tabstop=we._tabstop,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Fe=o=xe([O],Fe),e.SnippetString=Fe;var Ue;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Ue=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=a=class{static isLocation(L){return L instanceof a?!0:L?z.isRange(L.range)&&P.URI.isUri(L.uri):!1}constructor(L,ie){if(this.uri=L,ie)if(z.isRange(ie))this.range=z.of(ie);else if($.isPosition(ie))this.range=new z(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=a=xe([O],ke),e.Location=ke;let ye=class{static is(L){return L?typeof L.message=="string"&&L.location&&z.isRange(L.location.range)&&P.URI.isUri(L.location.uri):!1}constructor(L,ie){this.location=L,this.message=ie}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.location.range.isEqual(ie.location.range)&&L.location.uri.toString()===ie.location.uri.toString()}};ye=xe([O],ye),e.DiagnosticRelatedInformation=ye;let De=class{constructor(L,ie,we=Xe.Error){if(!z.isRange(L))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=L,this.message=ie,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.severity===ie.severity&&L.code===ie.code&&L.severity===ie.severity&&L.source===ie.source&&L.range.isEqual(ie.range)&&(0,r.equals)(L.tags,ie.tags)&&(0,r.equals)(L.relatedInformation,ie.relatedInformation,ye.isEqual)}};De=xe([O],De),e.Diagnostic=De;let ae=class{constructor(L,ie){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ie}};ae=xe([O],ae),e.Hover=ae;var ue;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ee=class{constructor(L,ie=ue.Text){this.range=L,this.kind=ie}toJSON(){return{range:this.range,kind:ue[this.kind]}}};ee=xe([O],ee),e.DocumentHighlight=ee;var Z;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Z=e.SymbolKind||(e.SymbolKind={}));var k;(function(x){x[x.Deprecated=1]="Deprecated"})(k=e.SymbolTag||(e.SymbolTag={}));let B=t=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ie,we,He,Qe){this.name=L,this.kind=ie,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof ke?this.location=He:we instanceof z&&(this.location=new ke(He,we)),t.validate(this)}toJSON(){return{name:this.name,kind:Z[this.kind],location:this.location,containerName:this.containerName}}};B=t=xe([O],B),e.SymbolInformation=B;let V=d=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(d.validate)}constructor(L,ie,we,He,Qe){this.name=L,this.detail=ie,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],d.validate(this)}};V=d=xe([O],V),e.DocumentSymbol=V;var q;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(L,ie){this.title=L,this.kind=ie}};oe=xe([O],oe),e.CodeAction=oe;let ce=p=class{constructor(L){this.value=L}append(L){return new p(this.value?this.value+p.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+p.sep)}};ce.sep=".",ce=p=xe([O],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorMove=ce.Refactor.append("move"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let J=class{constructor(L,ie){if(this.range=L,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=xe([O],J),e.SelectionRange=J;class Ee{constructor(L,ie,we,He,Qe,lt){this.kind=L,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.CallHierarchyItem=Ee;class ve{constructor(L,ie){this.fromRanges=ie,this.from=L}}e.CallHierarchyIncomingCall=ve;class Ne{constructor(L,ie){this.fromRanges=ie,this.to=L}}e.CallHierarchyOutgoingCall=Ne;var ze;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(L,ie){this.range=L,this.command=ie}get isResolved(){return!!this.command}};Je=xe([O],Je),e.CodeLens=Je;let Ge=w=class{static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ie=!1){c.set(this,void 0),Ye(this,c,new b.MarkdownString(L,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,c,"f").value}set value(L){Oe(this,c,"f").value=L}get isTrusted(){return Oe(this,c,"f").isTrusted}set isTrusted(L){Oe(this,c,"f").isTrusted=L}get supportThemeIcons(){return Oe(this,c,"f").supportThemeIcons}set supportThemeIcons(L){Oe(this,c,"f").supportThemeIcons=L}get supportHtml(){return Oe(this,c,"f").supportHtml}set supportHtml(L){Oe(this,c,"f").supportHtml=L}get baseUri(){return Oe(this,c,"f").baseUri}set baseUri(L){Oe(this,c,"f").baseUri=L}appendText(L){return Oe(this,c,"f").appendText(L),this}appendMarkdown(L){return Oe(this,c,"f").appendMarkdown(L),this}appendCodeblock(L,ie){return Oe(this,c,"f").appendCodeblock(ie??"",L),this}};c=new WeakMap,Ge=w=xe([O],Ge),e.MarkdownString=Ge;let Pe=class{constructor(L,ie){this.label=L,this.documentation=ie}};Pe=xe([O],Pe),e.ParameterInformation=Pe;let nt=class{constructor(L,ie){this.label=L,this.documentation=ie,this.parameters=[]}};nt=xe([O],nt),e.SignatureInformation=nt;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=xe([O],X),e.SignatureHelp=X;var Y;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let Be=class{constructor(L){this.value=L}};Be=xe([O],Be),e.InlayHintLabelPart=Be;let je=class{constructor(L,ie,we){this.position=L,this.label=ie,this.kind=we}};je=xe([O],je),e.InlayHint=je;var et;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function(x){x[x.Deprecated=1]="Deprecated"})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));let it=class{constructor(L,ie){this.label=L,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};it=xe([O],it),e.CompletionItem=it;let st=class{constructor(L=[],ie=!1){this.items=L,this.isIncomplete=ie}};st=xe([O],st),e.CompletionList=st;let ct=class{constructor(L,ie,we){this.insertText=L,this.range=ie,this.command=we}};ct=xe([O],ct),e.InlineSuggestion=ct;let at=class{constructor(L){this.commands=void 0,this.items=L}};at=xe([O],at),e.InlineSuggestionList=at;let rt=class{constructor(L,ie,we){this.insertText=L,this.range=ie,this.command=we}};rt=xe([O],rt),e.InlineSuggestionNew=rt;let _t=class{constructor(L,ie){this.items=L,this.commands=ie}};_t=xe([O],_t),e.InlineSuggestionsNew=_t;var Rt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Rt=e.ViewColumn||(e.ViewColumn={}));var Ot;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Ot=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var yt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(yt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Lt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Lt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var qe;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(ie){switch(ie){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(L,ie){if(ie&&!P.URI.isUri(ie))throw(0,D.illegalArgument)("target");if(!z.isRange(L)||L.isEmpty)throw(0,D.illegalArgument)("range");this.range=L,this.target=ie}};Ft=xe([O],Ft),e.DocumentLink=Ft;let Tt=class{constructor(L,ie,we,He){this.red=L,this.green=ie,this.blue=we,this.alpha=He}};Tt=xe([O],Tt),e.Color=Tt;let ft=class{constructor(L,ie){if(ie&&!(ie instanceof Tt))throw(0,D.illegalArgument)("color");if(!z.isRange(L)||L.isEmpty)throw(0,D.illegalArgument)("range");this.range=L,this.color=ie}};ft=xe([O],ft),e.ColorInformation=ft;let It=class{constructor(L){if(!L||typeof L!="string")throw(0,D.illegalArgument)("label");this.label=L}};It=xe([O],It),e.ColorPresentation=It;var _e;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(_e=e.ColorFormat||(e.ColorFormat={}));var Te;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Te=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ge;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(ge=e.TerminalExitReason||(e.TerminalExitReason={}));class K{constructor(L,ie,we){if(this.startIndex=L,this.length=ie,this.tooltip=we,typeof L!="number"||L<0)throw(0,D.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,D.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,D.illegalArgument)("tooltip")}}e.TerminalLink=K;var Ae;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Me{constructor(L){if(this.options=L,typeof L!="object")throw(0,D.illegalArgument)("options")}}e.TerminalProfile=Me;var Ze;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=F=class{static from(L){switch(L){case"clean":return F.Clean;case"build":return F.Build;case"rebuild":return F.Rebuild;case"test":return F.Test;default:return}}constructor(L,ie){if(this.label=ie,typeof L!="string"||typeof ie!="string")throw(0,D.illegalArgument)("name");this._id=L}get id(){return this._id}};tt.Clean=new F("clean","Clean"),tt.Build=new F("build","Build"),tt.Rebuild=new F("rebuild","Rebuild"),tt.Test=new F("test","Test"),tt=F=xe([O],tt),e.TaskGroup=tt;function gt(x){let L="";for(let ie=0;ie<x.length;ie++)L+=x[ie].replace(/,/g,",,")+",";return L}let vt=class{constructor(L,ie,we){if(typeof L!="string")throw(0,D.illegalArgument)("process");this._args=[],this._process=L,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=we):this._options=ie)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,D.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)L.push(ie);return gt(L)}};vt=xe([O],vt),e.ProcessExecution=vt;let Ct=class{constructor(L,ie,we){if(this._args=[],Array.isArray(ie)){if(!L)throw(0,D.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,D.illegalArgument)("command");this._command=L,this._args=ie,this._options=we}else{if(typeof L!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=L,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,D.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)L.push(typeof ie=="string"?ie:ie.value);return gt(L)}};Ct=xe([O],Ct),e.ShellExecution=Ct;var Dt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Dt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class pt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=pt;let wt=j=class{constructor(L,ie,we,He,Qe,lt){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=we,this.execution=He,dt=Qe,this.__deprecated=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,dt=lt):(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,dt=lt),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof vt?this._definition={type:j.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:j.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:j.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:j.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,D.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,D.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ie=this._definition.type;(j.EmptyType===ie||j.ProcessType===ie||j.ShellType===ie||j.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,D.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=j=xe([O],wt),e.Task=wt;var ei;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ei=e.ProgressLocation||(e.ProgressLocation={}));var bt;(function(x){function L(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}x.isViewBadge=L})(bt=e.ViewBadge||(e.ViewBadge={}));let qt=U=class{static isTreeItem(L,ie){if(L instanceof U)return!0;const we=L;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!P.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,y.isString)(He.light)&&!P.URI.isUri(He.light)&&!(0,y.isString)(He.dark)&&!P.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!P.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<$t.None&&we.collapsibleState>$t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,g.checkProposedApiEnabled)(ie,"treeItemCheckbox");const He=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==ti.Checked&&He!==ti.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(L,ie=$t.None){this.collapsibleState=ie,P.URI.isUri(L)?this.resourceUri=L:this.label=L}};qt=U=xe([O],qt),e.TreeItem=qt;var $t;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ti;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(ti=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ci=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L,ie){this.value=L,this.id=ie??(0,R.generateUuid)()}};ci=xe([O],ci),e.DataTransferItem=ci;let kt=class{constructor(L){f.set(this,new Map);for(const[ie,we]of L??[]){const He=Oe(this,f,"f").get(ie);He?He.push(we):Oe(this,f,"f").set(ie,[we])}}get(L){return Oe(this,f,"f").get(L)?.[0]}set(L,ie){Oe(this,f,"f").set(L,[ie])}forEach(L,ie){for(const[we,He]of Oe(this,f,"f"))for(const Qe of He)L.call(ie,Qe,we,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[L,ie]of Oe(this,f,"f"))for(const we of ie)yield[L,we]}};kt=xe([O],kt),e.DataTransfer=kt;let ii=class{constructor(L){this.insertText=L}};ii=xe([O],ii),e.DocumentDropEdit=ii;let ui=class{constructor(L){this.insertText=L}};ui=xe([O],ui),e.DocumentPasteEdit=ui;let Ut=class{constructor(L,ie){this.id=L,this.color=ie}};Ut=xe([O],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let Jt=class{constructor(L){this.id=L}};Jt=xe([O],Jt),e.ThemeColor=Jt;var ut;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let di=class{get base(){return this._base}set base(L){this._base=L,this._baseUri=P.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}constructor(L,ie){if(typeof L!="string"&&(!L||!P.URI.isUri(L)&&!P.URI.isUri(L.uri)))throw(0,D.illegalArgument)("base");if(typeof ie!="string")throw(0,D.illegalArgument)("pattern");typeof L=="string"?this.baseUri=P.URI.file(L):P.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};di=xe([O],di),e.RelativePattern=di;let Nt=class{constructor(L,ie,we,He){this.enabled=typeof L=="boolean"?L:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Nt=xe([O],Nt),e.Breakpoint=Nt;let Kt=class extends Nt{constructor(L,ie,we,He,Qe){if(super(ie,we,He,Qe),L===null)throw(0,D.illegalArgument)("location");this.location=L}};Kt=xe([O],Kt),e.SourceBreakpoint=Kt;let ni=class extends Nt{constructor(L,ie,we,He,Qe){super(ie,we,He,Qe),this.functionName=L}};ni=xe([O],ni),e.FunctionBreakpoint=ni;let hi=class extends Nt{constructor(L,ie,we,He,Qe,lt,dt){if(super(He,Qe,lt,dt),!ie)throw(0,D.illegalArgument)("dataId");this.label=L,this.dataId=ie,this.canPersist=we}};hi=xe([O],hi),e.DataBreakpoint=hi;let ri=class{constructor(L,ie,we){this.command=L,this.args=ie||[],this.options=we}};ri=xe([O],ri),e.DebugAdapterExecutable=ri;let fi=class{constructor(L,ie){this.port=L,this.host=ie}};fi=xe([O],fi),e.DebugAdapterServer=fi;let si=class{constructor(L){this.path=L}};si=xe([O],si),e.DebugAdapterNamedPipeServer=si;let Zt=class{constructor(L){this.implementation=L}};Zt=xe([O],Zt),e.DebugAdapterInlineImplementation=Zt;let mi=class{constructor(L,ie){this.range=L,this.expression=ie}};mi=xe([O],mi),e.EvaluatableExpression=mi;var gi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(gi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var pi;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(pi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let vi=class{constructor(L,ie){this.range=L,this.text=ie}};vi=xe([O],vi),e.InlineValueText=vi;let Ei=class{constructor(L,ie,we=!0){this.range=L,this.variableName=ie,this.caseSensitiveLookup=we}};Ei=xe([O],Ei),e.InlineValueVariableLookup=Ei;let Gt=class{constructor(L,ie){this.range=L,this.expression=ie}};Gt=xe([O],Gt),e.InlineValueEvaluatableExpression=Gt;let bi=class{constructor(L,ie){this.frameId=L,this.stoppedLocation=ie}};bi=xe([O],bi),e.InlineValueContext=bi;var Ni;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Ni=e.FileChangeType||(e.FileChangeType={}));let wi=C=class extends Error{static FileExists(L){return new C(L,E.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(L){return new C(L,E.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(L){return new C(L,E.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(L){return new C(L,E.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(L){return new C(L,E.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(L){return new C(L,E.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(L,ie=E.FileSystemProviderErrorCode.Unknown,we){super(P.URI.isUri(L)?L.toString(!0):L),this.code=we?.name??"Unknown",(0,E.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};wi=C=xe([O],wi),e.FileSystemError=wi;let Si=class{constructor(L,ie,we){this.start=L,this.end=ie,this.kind=we}};Si=xe([O],Si),e.FoldingRange=Si;var _i;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ti;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ti=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ki;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(ki=e.CommentMode||(e.CommentMode={}));var Le;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Le=e.CommentThreadState||(e.CommentThreadState={}));class Ht{constructor(L,ie=[]){this.tokenTypes=L,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ht;function Pi(x){return typeof x>"u"||(0,y.isStringArray)(x)}class ht{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ie=0,we=L.tokenTypes.length;ie<we;ie++)this._tokenTypeStrToInt.set(L.tokenTypes[ie],ie);for(let ie=0,we=L.tokenModifiers.length;ie<we;ie++)this._tokenModifierStrToInt.set(L.tokenModifiers[ie],ie)}}push(L,ie,we,He,Qe){if(typeof L=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(L,ie,we,He,Qe);if(z.isRange(L)&&typeof ie=="string"&&Pi(we))return this._push(L,ie,we);throw(0,D.illegalArgument)()}_push(L,ie,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Qe=L.start.character,lt=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(ie);let At=0;if(we)for(const xt of we){if(!this._tokenModifierStrToInt.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(xt);At|=1<<Wt>>>0}this._pushEncoded(He,Qe,lt,dt,At)}_pushEncoded(L,ie,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let xt=0,Wt=0;for(let jt=0;jt<At;jt++){let Qt=this._data[5*jt],Ii=this._data[5*jt+1];Qt===0?(Qt=xt,Ii+=Wt):Qt+=xt,this._data[5*jt]=Qt,this._data[5*jt+1]=Ii,xt=Qt,Wt=Ii}}let lt=L,dt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=L,this._prevChar=ie}static _sortAndDeltaEncode(L){const ie=[],we=L.length/5|0;for(let dt=0;dt<we;dt++)ie[dt]=dt;ie.sort((dt,At)=>{const xt=L[5*dt],Wt=L[5*At];if(xt===Wt){const jt=L[5*dt+1],Qt=L[5*At+1];return jt-Qt}return xt-Wt});const He=new Uint32Array(L.length);let Qe=0,lt=0;for(let dt=0;dt<we;dt++){const At=5*ie[dt],xt=L[At+0],Wt=L[At+1],jt=L[At+2],Qt=L[At+3],Ii=L[At+4],Yi=xt-Qe,In=Yi===0?Wt-lt:Wt,Ci=5*dt;He[Ci+0]=Yi,He[Ci+1]=In,He[Ci+2]=jt,He[Ci+3]=Qt,He[Ci+4]=Ii,Qe=xt,lt=Wt}return He}build(L){return this._dataIsSortedAndDeltaEncoded?new yi(new Uint32Array(this._data),L):new yi(ht._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=ht;class yi{constructor(L,ie){this.resultId=ie,this.data=L}}e.SemanticTokens=yi;class Li{constructor(L,ie,we){this.start=L,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Li;class Ai{constructor(L,ie){this.resultId=ie,this.edits=L}}e.SemanticTokensEdits=Ai;var Mi;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Mi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Ut("arrow-left")},Xt=xe([O],Xt),e.QuickInputButtons=Xt;var Ui;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Bi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Bi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(zi=e.ExtensionKind||(e.ExtensionKind={}));class Ri{static validate(L){if(L.badge){let ie=(0,A.nextCharLength)(L.badge,0);if(ie<L.badge.length&&(ie+=(0,A.nextCharLength)(L.badge,ie)),L.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ie,we){this.badge=L,this.tooltip=ie,this.color=we}}e.FileDecoration=Ri;let Di=class{constructor(L){this.kind=L}};Di=xe([O],Di),e.ColorTheme=Di;var xi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(L){return L instanceof Vt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(L,ie){if(L<0)throw(0,D.illegalArgument)("start must be positive");if(ie<0)throw(0,D.illegalArgument)("end must be positive");L<=ie?(this._start=L,this._end=ie):(this._start=ie,this._end=L)}with(L){let ie=this._start,we=this._end;return L.start!==void 0&&(ie=L.start),L.end!==void 0&&(we=L.end),ie===this._start&&we===this._end?this:new Vt(ie,we)}}e.NotebookRange=Vt;class oi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ie=>oi.isNotebookCellData(ie))}static isNotebookCellData(L){return!0}constructor(L,ie,we,He,Qe,lt,dt){this.kind=L,this.value=ie,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=lt,this.executionSummary=dt,oi.validate(this)}}e.NotebookCellData=oi;class $i{constructor(L){this.cells=L}}e.NotebookData=$i;class Bt{static isNotebookCellOutputItem(L){return L instanceof Bt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ie={name:L.name,message:L.message,stack:L.stack};return Bt.json(ie,"application/vnd.code.notebook.error")}static stdout(L){return Bt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Bt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ie="application/octet-stream"){return new Bt(L,ie)}static text(L,ie=_.Mimes.text){const we=Oe(Bt,v,"f",S).encode(String(L));return new Bt(we,ie)}static json(L,ie="text/x-json"){const we=JSON.stringify(L,void 0,"	");return Bt.text(we,ie)}constructor(L,ie){this.data=L,this.mime=ie;const we=(0,_.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Bt,v=Bt,S={value:new TextEncoder};class se{static isNotebookCellOutput(L){return L instanceof se?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ie=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<L.length;Qe++){const lt=L[Qe],dt=(0,_.normalizeMimeType)(lt.mime);if(!we.has(dt)||(0,I.isTextStreamMime)(dt)){we.add(dt);continue}He.add(Qe),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return He.size===0?L:L.filter((Qe,lt)=>!He.has(lt))}constructor(L,ie,we){this.items=se.ensureUniqueMimeTypes(L,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,R.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=se;var de;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(de=e.NotebookCellKind||(e.NotebookCellKind={}));var Re;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Re=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ot;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ot=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var St;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(St=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pt{constructor(L,ie){this.text=L,this.alignment=ie}}e.NotebookCellStatusBarItem=Pt;var tn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var nn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(nn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rn{constructor(L,ie=[]){this.uri=L,this.provides=(0,r.asArray)(ie)}}e.NotebookRendererScript=rn;let Wi=class{constructor(L,ie){this.label=L,this.timestamp=ie}};Wi=xe([O],Wi),e.TimelineItem=Wi;var sn;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(L,ie){this.ranges=L,this.wordPattern=ie}}e.LinkedEditingRanges=ln;class cn{constructor(L,ie){this._port=L,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=cn;var un;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(un=e.TestResultState||(e.TestResultState={}));var dn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hi=class{constructor(L=void 0,ie=void 0,we=void 0){this.include=L,this.exclude=ie,this.profile=we}};Hi=xe([O],Hi),e.TestRunRequest=Hi;let Vi=W=class{static diff(L,ie,we){const He=new W(L);return He.expectedOutput=ie,He.actualOutput=we,He}constructor(L){this.message=L}};Vi=W=xe([O],Vi),e.TestMessage=Vi;let ji=class{constructor(L){this.id=L}};ji=xe([O],ji),e.TestTag=ji;let ai=class{constructor(L,ie){this.covered=L,this.total=ie}};ai=xe([O],ai),e.CoveredCount=ai;let qi=M=class{static fromDetails(L,ie){const we=new ai(0,0),He=new ai(0,0),Qe=new ai(0,0);for(const dt of ie)if("branches"in dt){we.total+=1,we.covered+=dt.executionCount>0?1:0;for(const At of dt.branches)He.total+=1,He.covered+=At.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=dt.executionCount>0?1:0;const lt=new M(L,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return lt.detailedCoverage=ie,lt}constructor(L,ie,we,He){this.uri=L,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=He}};qi=M=xe([O],qi),e.FileCoverage=qi;let Ki=class{constructor(L,ie,we=[]){this.executionCount=L,this.location=ie,this.branches=we}};Ki=xe([O],Ki),e.StatementCoverage=Ki;let Gi=class{constructor(L,ie){this.executionCount=L,this.location=ie}};Gi=xe([O],Gi),e.BranchCoverage=Gi;let Xi=class{constructor(L,ie){this.executionCount=L,this.location=ie}};Xi=xe([O],Xi),e.FunctionCoverage=Xi;var hn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(L,ie,we,He,Qe,lt){this.kind=L,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.TypeHierarchyItem=gn;class pn{constructor(L){this.uri=L}}e.TextTabInput=pn;class vn{constructor(L,ie){this.original=L,this.modified=ie}}e.TextDiffTabInput=vn;class En{constructor(L,ie,we,He){this.base=L,this.input1=ie,this.input2=we,this.result=He}}e.TextMergeTabInput=En;class bn{constructor(L,ie){this.uri=L,this.viewType=ie}}e.CustomEditorTabInput=bn;class wn{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=wn;class Sn{constructor(L,ie){this.uri=L,this.notebookType=ie}}e.NotebookEditorTabInput=Sn;class _n{constructor(L,ie,we){this.original=L,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=_n;class yn{constructor(){}}e.TerminalEditorTabInput=yn;class Dn{constructor(L,ie){this.uri=L,this.inputBoxUri=ie}}e.InteractiveWindowInput=Dn}),define(Ie[93],Ce([1,0,46,13,10,245,123,6,18]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(g,l){l?P.set(g,l):P.delete(g)}e.setWordDefinitionFor=R;function E(g){return P.get(g)}e.getWordDefinitionFor=E;class m extends N.MirrorTextModel{constructor(l,c,f,v,S,h,T,s){super(c,f,v,S),this._proxy=l,this._languageId=h,this._isDirty=T,this.notebook=s,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,y.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===D.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},save(){return l._save()},getText(c){return c?l._getTextInRange(c):l.getText()},get eol(){return l._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(c){return l._lineAt(c)},offsetAt(c){return l._offsetAt(c)},positionAt(c){return l._positionAt(c)},validateRange(c){return l._validateRange(c)},validatePosition(c){return l._validatePosition(c)},getWordRangeAtPosition(c,f){return l._getWordRangeAtPosition(c,f)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,r.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,r.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const c=this._validateRange(l);if(c.isEmpty)return"";if(c.isSingleLine)return this._lines[c.start.line].substring(c.start.character,c.end.character);const f=this._eol,v=c.start.line,S=c.end.line,h=[];h.push(this._lines[v].substring(c.start.character));for(let T=v+1;T<S;T++)h.push(this._lines[T]);return h.push(this._lines[S].substring(0,c.end.character)),h.join(f)}_lineAt(l){let c;if(l instanceof A.Position?c=l.line:typeof l=="number"&&(c=l),typeof c!="number"||c<0||c>=this._lines.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new I(c,this._lines[c],c===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const c=this._lineStarts.getIndexOf(l),f=this._lines[c.index].length;return new A.Position(c.index,Math.min(c.remainder,f))}_validateRange(l){if(!(l instanceof A.Range))throw new Error("Invalid argument");const c=this._validatePosition(l.start),f=this._validatePosition(l.end);return c===l.start&&f===l.end?l:new A.Range(c.line,c.character,f.line,f.character)}_validatePosition(l){if(!(l instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:c,character:f}=l,v=!1;if(c<0)c=0,f=0,v=!0;else if(c>=this._lines.length)c=this._lines.length-1,f=this._lines[c].length,v=!0;else{const S=this._lines[c].length;f<0?(f=0,v=!0):f>S&&(f=S,v=!0)}return v?new A.Position(c,f):l}_getWordRangeAtPosition(l,c){const f=this._validatePosition(l);if(!c)c=E(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(f.character+1,(0,_.ensureValidWordDefinition)(c),this._lines[f.line],0);if(v)return new A.Range(f.line,v.startColumn-1,f.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class I{constructor(l,c,f){this._line=l,this._text=c,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(Ie[180],Ce([1,0,6,14,4]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y;switch(A){case"light":y=r.ColorThemeKind.Light;break;case"hcDark":y=r.ColorThemeKind.HighContrast;break;case"hcLight":y=r.ColorThemeKind.HighContrastLight;break;default:y=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};N=xe([$e(0,D.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Ie[8],Ce([1,0,18,23,80,24,106,79,25,9,2,51,69,85,91,90,65,41,50,175,6,181]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(_e){function Te(K){const{selectionStartLineNumber:Ae,selectionStartColumn:Me,positionLineNumber:Ze,positionColumn:We}=K,tt=new h.Position(Ae-1,Me-1),gt=new h.Position(Ze-1,We-1);return new h.Selection(tt,gt)}_e.to=Te;function ge(K){const{anchor:Ae,active:Me}=K;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}_e.from=ge})(s=e.Selection||(e.Selection={}));var u;(function(_e){function Te(K){if(!K)return;const{start:Ae,end:Me}=K;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}_e.from=Te;function ge(K){if(!K)return;const{startLineNumber:Ae,startColumn:Me,endLineNumber:Ze,endColumn:We}=K;return new h.Range(Ae-1,Me-1,Ze-1,We-1)}_e.to=ge})(u=e.Range||(e.Range={}));var n;(function(_e){function Te(ge){switch(ge){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}_e.to=Te})(n=e.TokenType||(e.TokenType={}));var i;(function(_e){function Te(K){return new h.Position(K.lineNumber-1,K.column-1)}_e.to=Te;function ge(K){return{lineNumber:K.line+1,column:K.character+1}}_e.from=ge})(i=e.Position||(e.Position={}));var o;(function(_e){function Te(Ae,Me){return(0,r.coalesce)((0,r.asArray)(Ae).map(Ze=>ge(Ze,Me)))}_e.from=Te;function ge(Ae,Me){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:K(Ae.scheme,Me),pattern:me.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function K(Ae,Me){return Me&&typeof Ae=="string"?Me.transformOutgoingScheme(Ae):Ae}})(o=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(_e){function Te(K){switch(K){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}_e.from=Te;function ge(K){switch(K){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}_e.to=ge})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(_e){function Te(K){let Ae;return K.code&&((0,P.isString)(K.code)||(0,P.isNumber)(K.code)?Ae=String(K.code):Ae={value:String(K.code.value),target:K.code.target}),{...u.from(K.range),message:K.message,source:K.source,code:Ae,severity:p.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(d.from),tags:Array.isArray(K.tags)?(0,r.coalesce)(K.tags.map(a.from)):void 0}}_e.from=Te;function ge(K){const Ae=new h.Diagnostic(u.to(K),K.message,p.to(K.severity));return Ae.source=K.source,Ae.code=(0,P.isString)(K.code)?K.code:K.code?.value,Ae.relatedInformation=K.relatedInformation&&K.relatedInformation.map(d.to),Ae.tags=K.tags&&(0,r.coalesce)(K.tags.map(a.to)),Ae}_e.to=ge})(t=e.Diagnostic||(e.Diagnostic={}));var d;(function(_e){function Te(K){return{...u.from(K.location.range),message:K.message,resource:K.location.uri}}_e.from=Te;function ge(K){return new h.DiagnosticRelatedInformation(new h.Location(K.resource,u.to(K)),K.message)}_e.to=ge})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(_e){function Te(K){switch(K){case h.DiagnosticSeverity.Error:return I.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return I.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return I.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return I.MarkerSeverity.Hint}return I.MarkerSeverity.Error}_e.from=Te;function ge(K){switch(K){case I.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case I.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case I.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case I.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}_e.to=ge})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var w;(function(_e){function Te(K){return typeof K=="number"&&K>=h.ViewColumn.One?K-1:K===h.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}_e.from=Te;function ge(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=ge})(w=e.ViewColumn||(e.ViewColumn={}));function F(_e){return typeof _e.range<"u"}function j(_e){return _e.length===0?!0:!!F(_e[0])}e.isDecorationOptionsArr=j;var U;(function(_e){function Te(We){return We.map(_e.from)}_e.fromMany=Te;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function K(We){let tt;if(ge(We)){const{language:Dt,value:Et}=We;tt={value:"```"+Dt+`
`+Et+"\n```\n"}}else h.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const gt=Object.create(null);tt.uris=gt;const vt=Dt=>{try{let Et=R.URI.parse(Dt,!0);Et=Et.with({query:Ae(Et.query,gt)}),gt[Dt]=Et}catch{}return""},Ct=new _.marked.Renderer;return Ct.link=vt,Ct.image=Dt=>typeof Dt=="string"?vt(b.parseHrefAndDimensions(Dt).href):"",(0,_.marked)(tt.value,{renderer:Ct}),tt}_e.from=K;function Ae(We,tt){if(!We)return We;let gt;try{gt=(0,A.parse)(We)}catch{}if(!gt)return We;let vt=!1;return gt=(0,y.cloneAndChange)(gt,Ct=>{if(R.URI.isUri(Ct)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[Dt]=Ct,vt=!0,Dt}else return}),vt?JSON.stringify(gt):We}function Me(We){const tt=new h.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?R.URI.from(We.baseUri):void 0,tt}_e.to=Me;function Ze(We){if(!!We)return typeof We=="string"?We:_e.from(We)}_e.fromStrict=Ze})(U=e.MarkdownString||(e.MarkdownString={}));function C(_e){return j(_e)?_e.map(Te=>({range:u.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?U.fromMany(Te.hoverMessage):Te.hoverMessage?U.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):_e.map(Te=>({range:u.from(Te)}))}e.fromRangeOrRangeWithMessage=C;function W(_e){return typeof _e>"u"?_e:typeof _e=="string"?R.URI.file(_e):_e}e.pathOrURIToURI=W;var M;(function(_e){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?W(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}_e.from=Te})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(_e){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?W(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}_e.from=Te})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(_e){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=Te})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(_e){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?H.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?O.from(ge.light):void 0,dark:ge.dark?O.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?W(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?M.from(ge.before):void 0,after:ge.after?M.from(ge.after):void 0}}_e.from=Te})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(_e){function Te(K){return{text:K.newText,eol:K.newEol&&Ge.from(K.newEol),range:u.from(K.range)}}_e.from=Te;function ge(K){const Ae=new h.TextEdit(u.to(K.range),K.text);return Ae.newEol=typeof K.eol>"u"?void 0:Ge.to(K.eol),Ae}_e.to=ge})(z=e.TextEdit||(e.TextEdit={}));var G;(function(_e){function Te(K,Ae){const Me={edits:[]};if(K instanceof h.WorkspaceEdit){const Ze=new N.ResourceSet;for(const We of K._allEntries())We._type===1&&R.URI.isUri(We.to)&&We.from===void 0&&Ze.add(We.to);for(const We of K._allEntries())We._type===1?Me.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,D.encodeBase64)(D.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Me.edits.push({resource:We.uri,textEdit:z.from(We.edit),versionId:Ze.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Me.edits.push({resource:We.uri,textEdit:{range:u.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ze.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Me.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Me.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(st.from)}})}return Me}_e.from=Te;function ge(K){const Ae=new h.WorkspaceEdit;for(const Me of K.edits)Me.textEdit?Ae.replace(R.URI.revive(Me.resource),u.to(Me.textEdit.range),Me.textEdit.text):Ae.renameFile(R.URI.revive(Me.oldResource),R.URI.revive(Me.newResource),Me.options);return Ae}_e.to=ge})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var te;(function(_e){const Te=Object.create(null);Te[h.SymbolKind.File]=0,Te[h.SymbolKind.Module]=1,Te[h.SymbolKind.Namespace]=2,Te[h.SymbolKind.Package]=3,Te[h.SymbolKind.Class]=4,Te[h.SymbolKind.Method]=5,Te[h.SymbolKind.Property]=6,Te[h.SymbolKind.Field]=7,Te[h.SymbolKind.Constructor]=8,Te[h.SymbolKind.Enum]=9,Te[h.SymbolKind.Interface]=10,Te[h.SymbolKind.Function]=11,Te[h.SymbolKind.Variable]=12,Te[h.SymbolKind.Constant]=13,Te[h.SymbolKind.String]=14,Te[h.SymbolKind.Number]=15,Te[h.SymbolKind.Boolean]=16,Te[h.SymbolKind.Array]=17,Te[h.SymbolKind.Object]=18,Te[h.SymbolKind.Key]=19,Te[h.SymbolKind.Null]=20,Te[h.SymbolKind.EnumMember]=21,Te[h.SymbolKind.Struct]=22,Te[h.SymbolKind.Event]=23,Te[h.SymbolKind.Operator]=24,Te[h.SymbolKind.TypeParameter]=25;function ge(Ae){return typeof Te[Ae]=="number"?Te[Ae]:6}_e.from=ge;function K(Ae){for(const Me in Te)if(Te[Me]===Ae)return Number(Me);return h.SymbolKind.Property}_e.to=K})(te=e.SymbolKind||(e.SymbolKind={}));var he;(function(_e){function Te(K){switch(K){case h.SymbolTag.Deprecated:return 1}}_e.from=Te;function ge(K){switch(K){case 1:return h.SymbolTag.Deprecated}}_e.to=ge})(he=e.SymbolTag||(e.SymbolTag={}));var re;(function(_e){function Te(K){return{name:K.name,kind:te.from(K.kind),tags:K.tags&&K.tags.map(he.from),containerName:K.containerName,location:pe.from(K.location)}}_e.from=Te;function ge(K){const Ae=new h.SymbolInformation(K.name,te.to(K.kind),K.containerName,pe.to(K.location));return Ae.tags=K.tags&&K.tags.map(he.to),Ae}_e.to=ge})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var be;(function(_e){function Te(K){const Ae={name:K.name||"!!MISSING: name!!",detail:K.detail,range:u.from(K.range),selectionRange:u.from(K.selectionRange),kind:te.from(K.kind),tags:K.tags?.map(he.from)??[]};return K.children&&(Ae.children=K.children.map(Te)),Ae}_e.from=Te;function ge(K){const Ae=new h.DocumentSymbol(K.name,K.detail,te.to(K.kind),u.to(K.range),u.to(K.selectionRange));return(0,r.isNonEmptyArray)(K.tags)&&(Ae.tags=K.tags.map(he.to)),K.children&&(Ae.children=K.children.map(ge)),Ae}_e.to=ge})(be=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(_e){function Te(K){const Ae=new h.CallHierarchyItem(te.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),u.to(K.range),u.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}_e.to=Te;function ge(K,Ae,Me){if(Ae=Ae??K._sessionId,Me=Me??K._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,name:K.name,detail:K.detail,kind:te.from(K.kind),uri:K.uri,range:u.from(K.range),selectionRange:u.from(K.selectionRange),tags:K.tags?.map(he.from)}}_e.from=ge})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(_e){function Te(ge){return new h.CallHierarchyIncomingCall(le.to(ge.from),ge.fromRanges.map(K=>u.to(K)))}_e.to=Te})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(_e){function Te(ge){return new h.CallHierarchyOutgoingCall(le.to(ge.to),ge.fromRanges.map(K=>u.to(K)))}_e.to=Te})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(_e){function Te(K){return{range:K.range&&u.from(K.range),uri:K.uri}}_e.from=Te;function ge(K){return new h.Location(R.URI.revive(K.uri),u.to(K.range))}_e.to=ge})(pe=e.location||(e.location={}));var Se;(function(_e){function Te(K){const Ae=K,Me=K;return{originSelectionRange:Ae.originSelectionRange?u.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Me.uri,range:u.from(Ae.targetRange?Ae.targetRange:Me.range),targetSelectionRange:Ae.targetSelectionRange?u.from(Ae.targetSelectionRange):void 0}}_e.from=Te;function ge(K){return{targetUri:R.URI.revive(K.uri),targetRange:u.to(K.range),targetSelectionRange:K.targetSelectionRange?u.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?u.to(K.originSelectionRange):void 0}}_e.to=ge})(Se=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(_e){function Te(K){return{range:u.from(K.range),contents:U.fromMany(K.contents)}}_e.from=Te;function ge(K){return new h.Hover(K.contents.map(U.to),u.to(K.range))}_e.to=ge})(Fe=e.Hover||(e.Hover={}));var Ue;(function(_e){function Te(K){return{range:u.from(K.range),expression:K.expression}}_e.from=Te;function ge(K){return new h.EvaluatableExpression(u.to(K.range),K.expression)}_e.to=ge})(Ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(_e){function Te(K){if(K instanceof h.InlineValueText)return{type:"text",range:u.from(K.range),text:K.text};if(K instanceof h.InlineValueVariableLookup)return{type:"variable",range:u.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=Te;function ge(K){switch(K.type){case"text":return{range:u.to(K.range),text:K.text};case"variable":return{range:u.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:u.to(K.range),expression:K.expression}}}_e.to=ge})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(_e){function Te(K){return{frameId:K.frameId,stoppedLocation:u.from(K.stoppedLocation)}}_e.from=Te;function ge(K){return new h.InlineValueContext(K.frameId,u.to(K.stoppedLocation))}_e.to=ge})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(_e){function Te(K){return{range:u.from(K.range),kind:K.kind}}_e.from=Te;function ge(K){return new h.DocumentHighlight(u.to(K.range),K.kind)}_e.to=ge})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(_e){function Te(ge){switch(ge){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}_e.to=Te})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(_e){function Te(ge){return{triggerKind:De.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}_e.to=Te})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(_e){function Te(K){switch(K){case h.CompletionItemTag.Deprecated:return 1}}_e.from=Te;function ge(K){switch(K){case 1:return h.CompletionItemTag.Deprecated}}_e.to=ge})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(_e){const Te=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ge(Me){return Te.get(Me)??9}_e.from=ge;const K=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Ae(Me){return K.get(Me)??h.CompletionItemKind.Property}_e.to=Ae})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(_e){function Te(ge,K){const Ae=new h.CompletionItem(ge.label);return Ae.insertText=ge.insertText,Ae.kind=ee.to(ge.kind),Ae.tags=ge.tags?.map(ue.to),Ae.detail=ge.detail,Ae.documentation=b.isMarkdownString(ge.documentation)?U.to(ge.documentation):ge.documentation,Ae.sortText=ge.sortText,Ae.filterText=ge.filterText,Ae.preselect=ge.preselect,Ae.commitCharacters=ge.commitCharacters,E.Range.isIRange(ge.range)?Ae.range=u.to(ge.range):typeof ge.range=="object"&&(Ae.range={inserting:u.to(ge.range.insert),replacing:u.to(ge.range.replace)}),Ae.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Ae.insertText=new h.SnippetString(ge.insertText):(Ae.insertText=ge.insertText,Ae.textEdit=Ae.range instanceof h.Range?new h.TextEdit(Ae.range,Ae.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ge.additionalTextEdits.map(Me=>z.to(Me))),Ae.command=K&&ge.command?K.fromInternal(ge.command):void 0,Ae}_e.to=Te})(Z=e.CompletionItem||(e.CompletionItem={}));var k;(function(_e){function Te(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:U.fromStrict(K.documentation)}}_e.from=Te;function ge(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?U.to(K.documentation):K.documentation}}_e.to=ge})(k=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(_e){function Te(K){return{label:K.label,documentation:U.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(k.from):[],activeParameter:K.activeParameter}}_e.from=Te;function ge(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?U.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(k.to):[],activeParameter:K.activeParameter}}_e.to=ge})(B=e.SignatureInformation||(e.SignatureInformation={}));var V;(function(_e){function Te(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.from):[]}}_e.from=Te;function ge(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.to):[]}}_e.to=ge})(V=e.SignatureHelp||(e.SignatureHelp={}));var q;(function(_e){function Te(ge,K){const Ae=new h.InlayHint(i.to(K.position),typeof K.label=="string"?K.label:K.label.map(oe.to.bind(void 0,ge)),K.kind&&ce.to(K.kind));return Ae.textEdits=K.textEdits&&K.textEdits.map(z.to),Ae.tooltip=b.isMarkdownString(K.tooltip)?U.to(K.tooltip):K.tooltip,Ae.paddingLeft=K.paddingLeft,Ae.paddingRight=K.paddingRight,Ae}_e.to=Te})(q=e.InlayHint||(e.InlayHint={}));var oe;(function(_e){function Te(ge,K){const Ae=new h.InlayHintLabelPart(K.label);return Ae.tooltip=b.isMarkdownString(K.tooltip)?U.to(K.tooltip):K.tooltip,m.Command.is(K.command)&&(Ae.command=ge.fromInternal(K.command)),K.location&&(Ae.location=pe.to(K.location)),Ae}_e.to=Te})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ce;(function(_e){function Te(K){return K}_e.from=Te;function ge(K){return K}_e.to=ge})(ce=e.InlayHintKind||(e.InlayHintKind={}));var J;(function(_e){function Te(K){return{range:u.from(K.range),url:K.target,tooltip:K.tooltip}}_e.from=Te;function ge(K){let Ae;if(K.url)try{Ae=typeof K.url=="string"?R.URI.parse(K.url,!0):R.URI.revive(K.url)}catch{}return new h.DocumentLink(u.to(K.range),Ae)}_e.to=ge})(J=e.DocumentLink||(e.DocumentLink={}));var Ee;(function(_e){function Te(K){const Ae=new h.ColorPresentation(K.label);return K.textEdit&&(Ae.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Ae.additionalTextEdits=K.additionalTextEdits.map(Me=>z.to(Me))),Ae}_e.to=Te;function ge(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ae=>z.from(Ae)):void 0}}_e.from=ge})(Ee=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function Te(K){return new h.Color(K[0],K[1],K[2],K[3])}_e.to=Te;function ge(K){return[K.red,K.green,K.blue,K.alpha]}_e.from=ge})(ve=e.Color||(e.Color={}));var Ne;(function(_e){function Te(K){return{range:u.from(K.range)}}_e.from=Te;function ge(K){return new h.SelectionRange(u.to(K.range))}_e.to=ge})(Ne=e.SelectionRange||(e.SelectionRange={}));var ze;(function(_e){function Te(ge){switch(ge){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}_e.to=Te})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function Te(K){switch(K){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=Te;function ge(K){switch(K){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}_e.to=ge})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(_e){function Te(K){if(K===h.EndOfLine.CRLF)return 1;if(K===h.EndOfLine.LF)return 0}_e.from=Te;function ge(K){if(K===1)return h.EndOfLine.CRLF;if(K===0)return h.EndOfLine.LF}_e.to=ge})(Ge=e.EndOfLine||(e.EndOfLine={}));var Pe;(function(_e){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=Te})(Pe=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(_e){function Te(ge){const K={start:ge.start+1,end:ge.end+1};return ge.kind&&(K.kind=X.from(ge.kind)),K}_e.from=Te})(nt=e.FoldingRange||(e.FoldingRange={}));var X;(function(_e){function Te(ge){if(ge)switch(ge){case h.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}_e.from=Te})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(_e){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?u.from(ge.selection):void 0,override:typeof ge.override=="boolean"?l.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=Te})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var me;(function(_e){function Te(Me){return Me instanceof h.RelativePattern?Me.toJSON():typeof Me=="string"?Me:ge(Me)||K(Me)?new h.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}_e.from=Te;function ge(Me){const Ze=Me;return Ze?R.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(Me){const Ze=Me;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ae(Me){return typeof Me=="string"?Me:new h.RelativePattern(R.URI.revive(Me.baseUri),Me.pattern)}_e.to=Ae})(me=e.GlobPattern||(e.GlobPattern={}));var Be;(function(_e){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const K=ge;return{language:K.language,scheme:K.scheme,pattern:me.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}_e.from=Te})(Be=e.LanguageSelector||(e.LanguageSelector={}));var je;(function(_e){function Te(K){return{start:K.start,end:K.end}}_e.from=Te;function ge(K){return new h.NotebookRange(K.start,K.end)}_e.to=ge})(je=e.NotebookRange||(e.NotebookRange={}));var et;(function(_e){function Te(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}_e.to=Te;function ge(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}_e.from=ge})(et=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(_e){function Te(ge){if(ge===c.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ge===c.NotebookCellExecutionState.Pending)return;if(ge===c.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}_e.to=Te})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(_e){function Te(K){switch(K){case h.NotebookCellKind.Markup:return c.CellKind.Markup;case h.NotebookCellKind.Code:default:return c.CellKind.Code}}_e.from=Te;function ge(K){switch(K){case c.CellKind.Markup:return h.NotebookCellKind.Markup;case c.CellKind.Code:default:return h.NotebookCellKind.Code}}_e.to=ge})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(_e){function Te(K){const Ae={metadata:K.metadata??Object.create(null),cells:[]};for(const Me of K.cells)h.NotebookCellData.validate(Me),Ae.cells.push(st.from(Me));return Ae}_e.from=Te;function ge(K){const Ae=new h.NotebookData(K.cells.map(st.to));return(0,P.isEmptyObject)(K.metadata)||(Ae.metadata=K.metadata),Ae}_e.to=ge})(it=e.NotebookData||(e.NotebookData={}));var st;(function(_e){function Te(K){return{cellKind:Ve.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:et.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(at.from):[]}}_e.from=Te;function ge(K){return new h.NotebookCellData(Ve.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(at.to):void 0,K.metadata,K.internalMetadata?et.to(K.internalMetadata):void 0)}_e.to=ge})(st=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(_e){function Te(K){return{mime:K.mime,valueBytes:D.VSBuffer.wrap(K.data)}}_e.from=Te;function ge(K){return new h.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}_e.to=ge})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(_e){function Te(K){return{outputId:K.id,items:K.items.map(ct.from),metadata:K.metadata}}_e.from=Te;function ge(K){const Ae=K.items.map(ct.to);return new h.NotebookCellOutput(Ae,K.outputId,K.metadata)}_e.to=ge})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(_e){function Te(Ae){return K(Ae)?{include:(0,P.withNullAsUndefined)(me.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(me.from(Ae.exclude))}:(0,P.withNullAsUndefined)(me.from(Ae))}_e.from=Te;function ge(Ae){return K(Ae)?{include:me.to(Ae.include),exclude:me.to(Ae.exclude)}:me.to(Ae)}_e.to=ge;function K(Ae){const Me=Ae;return Me?!(0,P.isUndefinedOrNull)(Me.include)&&!(0,P.isUndefinedOrNull)(Me.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(_e){function Te(ge,K,Ae){const Me=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Me,Ae),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}_e.from=Te})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(_e){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}_e.from=Te})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ot;(function(_e){function Te(K){return{uri:K.uri,provides:K.provides}}_e.from=Te;function ge(K){return new h.NotebookRendererScript(R.URI.revive(K.uri),K.provides)}_e.to=ge})(Ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(_e){function Te(K){return{message:U.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:u.from(K.location.range),uri:K.location.uri}}}_e.from=Te;function ge(K){const Ae=new h.TestMessage(typeof K.message=="string"?K.message:U.to(K.message));return Ae.actualOutput=K.actual,Ae.expectedOutput=K.expected,Ae.location=K.location?pe.to(K.location):void 0,Ae}_e.to=ge})(mt=e.TestMessage||(e.TestMessage={}));var yt;(function(_e){_e.namespace=v.namespaceTestTag,_e.denamespace=v.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){function Te(K){const Ae=(0,g.getPrivateApiFor)(K).controllerId;return{extId:f.TestId.fromExtHostTestItem(K,Ae).toString(),label:K.label,uri:R.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Me=>yt.namespace(Ae,Me.id)),range:E.Range.lift(u.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&U.fromStrict(K.error)||null}}_e.from=Te;function ge(K){return{parent:void 0,error:void 0,id:f.TestId.fromString(K.extId).localId,label:K.label,uri:R.URI.revive(K.uri),tags:(K.tags||[]).map(Ae=>{const{tagId:Me}=yt.denamespace(Ae);return new h.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}_e.toPlain=ge})(Lt=e.TestItem||(e.TestItem={})),function(_e){function Te(K){return{id:K.id}}_e.from=Te;function ge(K){return new h.TestTag(K.id)}_e.to=ge}(yt=e.TestTag||(e.TestTag={}));var Mt;(function(_e){const Te=(K,Ae)=>{const Me=[];for(const[We,tt]of Ae)f.TestId.compare(tt.item.extId,We)===2&&(Ae.delete(We),Me.push(tt));const Ze={...Lt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(mt.to)})),children:Me.map(We=>Te(We,Ae))};for(const We of Ze.children)We.parent=Ze;return Ze};function ge(K){const Ae=[],Me=new Map;for(const Ze of K.items){Me.set(Ze.item.extId,Ze);const We=f.TestId.root(Ze.item.extId);K.request.targets.some(tt=>tt.controllerId===We&&tt.testIds.includes(Ze.item.extId))&&Ae.push(Ze)}return{completedAt:K.completedAt,results:Ae.map(Ze=>Te(Ze,Me))}}_e.to=ge})(Mt=e.TestResults||(e.TestResults={}));var qe;(function(_e){function Te(Me){return{covered:Me.covered,total:Me.covered}}function ge(Me){return"line"in Me?i.from(Me):u.from(Me)}function K(Me){return"branches"in Me?{count:Me.executionCount,location:ge(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ge(Ze.location)})):void 0}:{type:0,count:Me.executionCount,location:ge(Me.location)}}_e.fromDetailed=K;function Ae(Me){return{uri:Me.uri,statement:Te(Me.statementCoverage),branch:Me.branchCoverage&&Te(Me.branchCoverage),function:Me.functionCoverage&&Te(Me.functionCoverage),details:Me.detailedCoverage?.map(K)}}_e.fromFile=Ae})(qe=e.TestCoverage||(e.TestCoverage={}));var zt;(function(_e){function Te(ge){switch(ge){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}_e.to=Te})(zt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(_e){function Te(K){const Ae=new h.TypeHierarchyItem(te.to(K.kind),K.name,K.detail||"",R.URI.revive(K.uri),u.to(K.range),u.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}_e.to=Te;function ge(K,Ae,Me){if(Ae=Ae??K._sessionId,Me=Me??K._itemId,Ae===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Me,kind:te.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:u.from(K.range),selectionRange:u.from(K.selectionRange),tags:K.tags?.map(he.from)}}_e.from=ge})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Tt;(function(_e){function Te(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}_e.from=Te})(Tt=e.ViewBadge||(e.ViewBadge={}));var ft;(function(_e){function Te(ge,K){const Ae=ge.fileData;return Ae?new class extends h.DataTransferItem{asFile(){return{name:Ae.name,uri:R.URI.revive(Ae.uri),data:(0,T.once)(()=>K())}}}("",ge.id):new h.DataTransferItem(ge.asString)}_e.toDataTransferItem=Te})(ft=e.DataTransferItem||(e.DataTransferItem={}));var It;(function(_e){function Te(K,Ae){const Me=K.items.map(([Ze,We])=>[Ze,ft.toDataTransferItem(We,()=>Ae(We.id))]);return new h.DataTransfer(Me)}_e.toDataTransfer=Te;async function ge(K){const Ae={items:[]},Me=[];return K.forEach((Ze,We)=>{Me.push((async()=>{const tt=await Ze.asString(),gt=Ze.asFile();Ae.items.push([We,{id:Ze.id,asString:tt,fileData:gt?{name:gt.name,uri:gt.uri}:void 0}])})())}),await Promise.all(Me),Ae}_e.toDataTransferDTO=ge})(It=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[182],Ce([1,0,2,12,6,8,149]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(P,R,E,m={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=E,this._thresholds=m,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,E,m)=>{const g={dispose:this._callbacks.push([R,E,P])};return Array.isArray(m)&&m.push(g),g}}async $participateInSave(P,R){const E=r.URI.revive(P);let m=!1;const I=setTimeout(()=>m=!0,this._thresholds.timeout),g=[];try{for(const l of[...this._callbacks]){if(m)break;const c=this._documents.getDocument(E),f=await this._deliverEventAsyncAndBlameBadListeners(l,{document:c,reason:N.TextDocumentSaveReason.to(R)});g.push(f)}}finally{clearTimeout(I)}return g}_deliverEventAsyncAndBlameBadListeners([P,R,E],m){const I=this._badListeners.get(P);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,P,R,m).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const l=this._badListeners.get(P);this._badListeners.set(P,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,E,m){const I=[],g=Date.now(),{document:l,reason:c}=m,{version:f}=l,v=Object.freeze({document:l,reason:c,waitUntil(S){if(Object.isFrozen(I))throw(0,D.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(S))}});try{R.apply(E,[v])}catch(S){return Promise.reject(S)}return Object.freeze(I),new Promise((S,h)=>{const T=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(T),S(s)}).catch(s=>{clearTimeout(T),h(s)})}).then(S=>{const h={edits:[]};for(const T of S)if(Array.isArray(T)&&T.every(s=>s instanceof b.TextEdit))for(const{newText:s,newEol:u,range:n}of T)h.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:n&&N.Range.from(n),text:s,eol:u&&N.EndOfLine.from(u)}});if(h.edits.length!==0)return f===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ie[183],Ce([1,0,13,2,8,6,65]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(E,m,I,g){this.start=E,this.deletedCount=m,this.deletedItems=I,this.items=g}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(E,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,m,I){this.notebook=E,this._extHostDocument=m,this._cellData=I,this.handle=I.handle,this.uri=D.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(b.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const E=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:b.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return E._mime},set mime(g){E._mime=g},get outputs(){return E._outputs.slice(0)},get metadata(){return E._metadata},get executionSummary(){return E._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(E){this._outputs=E.map(b.NotebookCellOutput.to)}setOutputItems(E,m,I){const g=I.map(b.NotebookCellOutputItem.to),l=this._outputs.find(c=>c.id===E);if(l&&(m||(l.items.length=0),l.items.push(...g),l.items.length>1&&l.items.every(c=>_.isTextStreamMime(c.mime)))){const c=new Map,f=[];l.items.forEach(v=>{let S;c.has(v.mime)?S=c.get(v.mime):(S=[],c.set(v.mime,S),f.push(v.mime)),S.push(v.data)}),l.items.length=0,f.forEach(v=>{const S=_.compressOutputItemStreams(c.get(v));l.items.push({mime:v,data:S.buffer})})}}setMetadata(E){this._metadata=Object.freeze(E)}setInternalMetadata(E){this._internalMetadata=E,this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.ExtHostCell=y;class P{constructor(E,m,I,g,l){this._proxy=E,this._textDocumentsAndEditors=m,this._textDocuments=I,this.uri=g,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0,void 0),this._versionId=l.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const E=this,m={get uri(){return E.uri},get version(){return E._versionId},get notebookType(){return E._notebookType},get isDirty(){return E._isDirty},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E._disposed},get metadata(){return E._metadata},get cellCount(){return E._cells.length},cellAt(I){return I=E._validateIndex(I),E._cells[I].apiCell},getCells(I){return(I?E._getCells(I):E._cells).map(l=>l.apiCell)},save(){return E._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(E){E.metadata&&(this._metadata=Object.freeze({...this._metadata,...E.metadata}))}acceptDirty(E){this._isDirty=E}acceptModelChanged(E,m,I){this._versionId=E.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:I});const g={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},l=[];for(const f of E.rawEvents)f.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,g.contentChanges):f.kind===_.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,g.contentChanges):f.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),l.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),l.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),l.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===_.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),l.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),l.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const c=new Map;for(let f=0;f<l.length;f++){const v=l[f],S=c.get(v.cell);if(S===void 0){const h=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});c.set(v.cell,h-1)}else g.cellChanges[S]={...g.cellChanges[S],...v}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}_validateIndex(E){return E=E|0,E<0?0:E>=this._cells.length?this._cells.length-1:E}_validateRange(E){let m=E.start|0,I=E.end|0;return m<0&&(m=0),I>this._cells.length&&(I=this._cells.length),E.with({start:m,end:I})}_getCells(E){E=this._validateRange(E);const m=[];for(let I=E.start;I<E.end;I++)m.push(this._cells[I]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(E,m,I){if(this._disposed)return;const g=[],l=[],c=[];if(E.reverse().forEach(f=>{const S=f[2].map(s=>{const u=new y(this,this._textDocumentsAndEditors,s);return m||l.push(y.asModelAddData(this.apiNotebook,s)),u}),h=new A(f[0],f[1],[],S),T=this._cells.splice(f[0],f[1],...S);for(const s of T)c.push(s.uri),h.deletedItems.push(s.apiCell);g.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:c}),I)for(const f of g)I.push(f.asApiEvent())}_moveCell(E,m,I){const g=this._cells.splice(E,1);this._cells.splice(m,0,...g);const l=[new A(E,1,g.map(c=>c.apiCell),[]),new A(m,0,[],g)];for(const c of l)I.push(c.asApiEvent())}_setCellOutputs(E,m){this._cells[E].setOutputs(m)}_setCellOutputItems(E,m,I,g){this._cells[E].setOutputItems(m,I,g)}_changeCellLanguage(E,m){const I=this._cells[E];I.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(I.uri,m)}_changeCellMime(E,m){const I=this._cells[E];I.apiCell.mime=m}_changeCellMetadata(E,m){this._cells[E].setMetadata(m)}_changeCellInternalMetadata(E,m){this._cells[E].setInternalMetadata(m)}getCellFromApiCell(E){return this._cells.find(m=>m.apiCell===E)}getCellFromIndex(E){return this._cells[E]}getCell(E){return this._cells.find(m=>m.handle===E)}getCellIndex(E){return this._cells.indexOf(E)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ie[94],Ce([1,0,12,8,6]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(A,y,P,R,E,m){this.id=A,this._proxy=y,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=E,this._visibleRanges=R,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(y){this.selections=[y]},get selections(){return A._selections},set selections(y){if(!Array.isArray(y)||!y.every(b.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");A._selections=y,A._trySetSelections(y)},get visibleRanges(){return A._visibleRanges},revealRange(y,P){A._proxy.$tryRevealRange(A.id,D.NotebookRange.from(y),P??b.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},N.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(D.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=N,N.apiEditorsToExtHost=new WeakMap}),define(Ie[184],Ce([1,0,4,11,8]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const P=this._notebooksAndEditors.getEditorById(A);y.visibleRanges&&P._acceptVisibleRanges(y.visibleRanges.ranges.map(b.NotebookRange.to)),y.selections&&P._acceptSelections(y.selections.selections.map(b.NotebookRange.to)),y.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),y.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this._notebooksAndEditors.getEditorById(y)._acceptViewColumn(b.ViewColumn.to(A[y]))}};N=xe([$e(0,D.ILogService)],N),e.ExtHostNotebookEditors=N}),define(Ie[185],Ce([1,0,8,152,132,21,57,12]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,I,g){const l=this._handles++,{title:c,location:f,cancellable:v}=I,S={label:(0,b.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(l,{location:r.ProgressLocation.from(f),title:c,source:S,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(l,g,!!v)}_withProgress(m,I,g){let l;g&&(l=new N.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,l));const c=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),l?.dispose()};let f;try{f=I(new R(this._proxy,m),g&&l?l.token:N.CancellationToken.None)}catch(v){throw c(m),v}return f.then(v=>c(m),v=>c(m)),f}$acceptProgressCanceled(m){const I=this._mapHandleToCancellationSource.get(m);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=y;function P(E,m){return E.message=m.message,typeof m.increment=="number"&&(typeof E.increment=="number"?E.increment+=m.increment:E.increment=m.increment),E}class R extends D.Progress{constructor(m,I){super(g=>this.throttledReport(g)),this._proxy=m,this._handle=I}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}xe([(0,_.throttle)(100,(E,m)=>P(E,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ie[95],Ce([1,0,51,91,41,66,50,8,2]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(S,h,T,s)=>{let u=h;return{enumerable:!0,configurable:!1,get(){return u},set(n){if(!T(u,n)){const i=u;u=n,S.listener?.(s(n,i))}}}},R=(S,h)=>S===h,E={range:(S,h)=>S===h?!0:!S||!h?!1:S.isEqual(h),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(S,h)=>!(S.length!==h.length||S.some(T=>!h.find(s=>T.id===s.id)))},m=S=>h=>({op:4,update:S(h)}),I=(S,h)=>({range:(()=>{let T;const s=m(u=>({range:r.Range.lift(A.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return T},set(u){S.listener?.({op:6}),E.range(T,u)||(T=u,S.listener?.(s(u)))}}})(),label:P(S,h,E.label,m(T=>({label:T}))),description:P(S,void 0,E.description,m(T=>({description:T}))),sortText:P(S,void 0,E.sortText,m(T=>({sortText:T}))),canResolveChildren:P(S,!1,E.canResolveChildren,T=>({op:2,state:T})),busy:P(S,!1,E.busy,m(T=>({busy:T}))),error:P(S,void 0,E.error,m(T=>({error:A.MarkdownString.fromStrict(T)||null}))),tags:P(S,[],E.tags,(T,s)=>({op:1,new:T.map(A.TestTag.from),old:s.map(A.TestTag.from)}))}),g=S=>{const h=b.TestId.fromString(S.extId),T=new c(h.controllerId,h.localId,S.label,y.URI.revive(S.uri)||void 0);return T.range=A.Range.to(S.range||void 0),T.description=S.description||void 0,T.sortText=S.sortText||void 0,T.tags=S.tags.map(s=>A.TestTag.to({id:(0,_.denamespaceTestTag)(s).tagId})),T},l=S=>{let h;for(const T of S.tests){const s=g(T.item);(0,D.getPrivateApiFor)(s).parent=h,h=s}return h};e.toItemFromContext=l;class c{constructor(h,T,s,u){if(T.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(T)} symbol`);const n=(0,D.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:T,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof f?void 0:n.parent}},children:{value:(0,N.createTestItemChildren)(n,D.getPrivateApiFor,c),enumerable:!0,writable:!1},...I(n,s)})}}e.TestItemImpl=c;class f extends c{constructor(h,T){super(h,h,T,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class v extends N.TestItemCollection{constructor(h,T,s){super({controllerId:h,getDocumentVersion:u=>u&&s.getDocument(u)?.version,getApiFor:D.getPrivateApiFor,getChildren:u=>u.children,root:new f(h,T),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ie[96],Ce([1,0,46,12,77,8,6]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,I,g){const l=A._Keys.nextId();m.$registerTextEditorDecorationType(I.identifier,l,N.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=A,A._Keys=new b.IdGenerator("TextEditorDecorationType");class y{constructor(m,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,I){this._throwIfFinalized();let g=null;if(m instanceof _.Position)g=new _.Range(m,m);else if(m instanceof _.Range)g=m;else throw new Error("Unrecognized location");this._pushEdit(g,I,!1)}insert(m,I){this._throwIfFinalized(),this._pushEdit(new _.Range(m,m),I,!0)}delete(m){this._throwIfFinalized();let I=null;if(m instanceof _.Range)I=m;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(m,I,g){const l=this._document.validateRange(m);this._collectedEdits.push({range:l,text:I,forceMoveMarkers:g})}setEndOfLine(m){if(this._throwIfFinalized(),m!==_.EndOfLine.LF&&m!==_.EndOfLine.CRLF)throw(0,D.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=y;class P{constructor(m,I,g,l){this._proxy=m,this._id=I,this._accept(g),this._logService=l;const c=this;this.value={get tabSize(){return c._tabSize},set tabSize(f){c._setTabSize(f)},get insertSpaces(){return c._insertSpaces},set insertSpaces(f){c._setInsertSpaces(f)},get cursorStyle(){return c._cursorStyle},set cursorStyle(f){c._setCursorStyle(f)},get lineNumbers(){return c._lineNumbers},set lineNumbers(f){c._setLineNumbers(f)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=N.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const I=Math.floor(m);return I>0?I:null}if(typeof m=="string"){const I=parseInt(m,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(m){const I=this._validateTabSize(m);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const I=this._validateInsertSpaces(m);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:N.TextEditorLineNumbersStyle.from(m)})))}assign(m){const I={};let g=!1;if(typeof m.tabSize<"u"){const l=this._validateTabSize(m.tabSize);l==="auto"?(g=!0,I.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,g=!0,I.tabSize=l)}if(typeof m.insertSpaces<"u"){const l=this._validateInsertSpaces(m.insertSpaces);l==="auto"?(g=!0,I.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,g=!0,I.insertSpaces=l)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,g=!0,I.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,g=!0,I.lineNumbers=N.TextEditorLineNumbersStyle.from(m.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(m,I){I.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=P;class R{constructor(m,I,g,l,c,f,v,S){this.id=m,this._proxy=I,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._options=new P(this._proxy,this.id,f,g),this._visibleRanges=v,this._viewColumn=S;const h=this;this.value=Object.freeze({get document(){return l.getValue()},set document(T){throw(0,D.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(T){if(!(T instanceof _.Selection))throw(0,D.illegalArgument)("selection");h._selections=[T],h._trySetSelection()},get selections(){return h._selections},set selections(T){if(!Array.isArray(T)||T.some(s=>!(s instanceof _.Selection)))throw(0,D.illegalArgument)("selections");h._selections=T,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(T){throw(0,D.readonly)("visibleRanges")},get options(){return h._options.value},set options(T){h._disposed||h._options.assign(T)},get viewColumn(){return h._viewColumn},set viewColumn(T){throw(0,D.readonly)("viewColumn")},edit(T,s={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new y(l.getValue(),s);return T(u),h._applyEdit(u)},insertSnippet(T,s,u={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=h._selections.map(i=>N.Range.from(i));else if(s instanceof _.Position){const{lineNumber:i,column:o}=N.Position.from(s);n=[{startLineNumber:i,startColumn:o,endLineNumber:i,endColumn:o}]}else if(s instanceof _.Range)n=[N.Range.from(s)];else{n=[];for(const i of s)if(i instanceof _.Range)n.push(N.Range.from(i));else{const{lineNumber:o,column:a}=N.Position.from(i);n.push({startLineNumber:o,startColumn:a,endLineNumber:o,endColumn:a})}}return I.$tryInsertSnippet(m,l.getValue().version,T.value,n,u)},setDecorations(T,s){const u=s.length===0;u&&!h._hasDecorationsForKey.has(T.key)||(u?h._hasDecorationsForKey.delete(T.key):h._hasDecorationsForKey.add(T.key),h._runOnProxy(()=>{if(N.isDecorationOptionsArr(s))return I.$trySetDecorations(m,T.key,N.fromRangeOrRangeWithMessage(s));{const n=new Array(4*s.length);for(let i=0,o=s.length;i<o;i++){const a=s[i];n[4*i]=a.start.line+1,n[4*i+1]=a.start.character+1,n[4*i+2]=a.end.line+1,n[4*i+3]=a.end.character+1}return I.$trySetDecorationsFast(m,T.key,n)}}))},revealRange(T,s){h._runOnProxy(()=>I.$tryRevealRange(m,N.Range.from(T),s||_.TextEditorRevealType.Default))},show(T){I.$tryShowEditor(m,N.ViewColumn.from(T))},hide(){I.$tryHideEditor(m)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,r.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,r.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,r.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,r.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(N.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const I=m.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const g=I.edits.map(c=>c.range);g.sort((c,f)=>c.end.line===f.end.line?c.end.character===f.end.character?c.start.line===f.start.line?c.start.character-f.start.character:c.start.line-f.start.line:c.end.character-f.end.character:c.end.line-f.end.line);for(let c=0,f=g.length-1;c<f;c++){const v=g[c].end;if(g[c+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=I.edits.map(c=>({range:N.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,l,{setEndOfLine:typeof I.setEndOfLine=="number"?N.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=R}),define(Ie[186],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[187],Ce([1,0,143,12,29,84,87,30,26,186,151]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=A.Registry.as(_.Extensions.JSONContribution);class m{constructor(h,T,s){this._messageHandler=h,this._extension=T,this._extensionPointId=s}_msg(h,T){this._messageHandler({type:h,message:T,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(h){this._msg(b.default.Error,h)}warn(h){this._msg(b.default.Warning,h)}info(h){this._msg(b.default.Info,h)}}e.ExtensionMessageCollector=m;class I{static _toSet(h){const T=new Set;for(let s=0,u=h.length;s<u;s++)T.add(y.ExtensionIdentifier.toKey(h[s].description.identifier));return T}static compute(h,T){if(!h||!h.length)return new I(T,[]);if(!T||!T.length)return new I([],h);const s=this._toSet(h),u=this._toSet(T),n=T.filter(o=>!s.has(y.ExtensionIdentifier.toKey(o.description.identifier))),i=h.filter(o=>!u.has(y.ExtensionIdentifier.toKey(o.description.identifier)));return new I(n,i)}constructor(h,T){this.added=h,this.removed=T}}e.ExtensionPointUserDelta=I;class g{constructor(h,T){this.name=h,this.defaultExtensionKind=T,this._handler=null,this._users=null,this._delta=null}setHandler(h){if(this._handler!==null)throw new Error("Handler already set!");this._handler=h,this._handle()}acceptUsers(h){this._delta=I.compute(this._users,h),this._users=h,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(h){(0,D.onUnexpectedError)(h)}}}e.ExtensionPoint=g;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:r.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:r.localize(31,null)},{label:"onUri",body:"onUri",description:r.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(36,null)},{label:"onRenderer",description:r.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(39,null)},{label:"*",description:r.localize(40,null),body:"*"}]}},badges:{type:"array",description:r.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(42,null)},href:{type:"string",description:r.localize(43,null)},description:{type:"string",description:r.localize(44,null)}}}},markdown:{type:"string",description:r.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(49,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(50,null)},{body:["workspace"],description:r.localize(51,null)},{body:["ui","workspace"],description:r.localize(52,null)},{body:["workspace","ui"],description:r.localize(53,null)},{body:[],description:r.localize(54,null)}]},capabilities:{description:r.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(58,null),r.localize(59,null),r.localize(60,null)]},description:{type:"string",markdownDescription:r.localize(61,null)}}},untrustedWorkspaces:{description:r.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(64,null),r.localize(65,null),r.localize(66,null)]},restrictedConfigurations:{description:r.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(68,null)}}}}},sponsor:{description:r.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(71,null),type:"string"},"vscode:uninstall":{description:r.localize(72,null),type:"string"}}},icon:{type:"string",description:r.localize(73,null)},l10n:{type:"string",description:r.localize(74,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(h){if(this._extensionPoints.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const T=new g(h.extensionPoint,h.defaultExtensionKind);return this._extensionPoints.set(h.extensionPoint,T),e.schema.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,E.registerSchema(c,e.schema),T}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const v={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(v.ExtensionsRegistry,new f),e.ExtensionsRegistry=A.Registry.as(v.ExtensionsRegistry),E.registerSchema(c,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ie[188],Ce([1,0,140,9,25,187,40,4]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var P;(function(m){function I(g,l,c){if(!g)return;const f=D.isString(g.type)?g.type:void 0;if(!f||f.length===0){c.error(r.localize(3,null));return}const v=[];if(Array.isArray(g.required))for(const S of g.required)D.isString(S)&&v.push(S);return{extensionId:l.value,taskType:f,required:v,properties:g.properties?b.deepClone(g.properties):{},when:g.when?_.ContextKeyExpr.deserialize(g.when):void 0}}m.from=I})(P||(P={}));const R=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:y}});class E{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,g)=>{R.setHandler((l,c)=>{this._schema=void 0;try{for(const f of c.removed){const v=f.value;for(const S of v)this.taskTypes&&S.type&&this.taskTypes[S.type]&&delete this.taskTypes[S.type]}for(const f of c.added){const v=f.value;for(const S of v){const h=P.from(S,f.description.identifier,f.collector);h&&(this.taskTypes[h.taskType]=h)}}(c.removed.length>0||c.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){const I=[];for(const g of this.all()){const l={type:"object",additionalProperties:!1};g.required.length>0&&(l.required=g.required.slice(0)),g.properties!==void 0?l.properties=b.deepClone(g.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[g.taskType]},I.push(l)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistryImpl=E,e.TaskDefinitionRegistry=new E}),define(Ie[189],Ce([1,0,141,9,22,25,40,188]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var y;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function H($){if(!$)return O.Strong;switch($.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=H}(y=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(O){function H($){switch($.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=H}(R=e.RevealKind||(e.RevealKind={}));var E;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(E=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function H($){switch($.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=H}(E=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(O){function H($){switch($.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=H}(m=e.PanelKind||(e.PanelKind={}));var I;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:E.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var g;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(g=e.RuntimeType||(e.RuntimeType={})),function(O){function H(z){switch(z.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=H;function $(z){switch(z){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=$}(g=e.RuntimeType||(e.RuntimeType={}));var l;(function(O){function H($){return D.isString($)?$:$.value}O.value=H})(l=e.CommandString||(e.CommandString={}));var c;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function H(z){return z===O.Clean._id||z===O.Build._id||z===O.Rebuild._id||z===O.Test._id}O.is=H;function $(z){if(z!==void 0)return D.isString(z)?H(z)?{_id:z,isDefault:!1}:void 0:z}O.from=$})(c=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var v;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function H($){switch($){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=H})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var S;(function(O){O.parallel="parallel",O.sequence="sequence"})(S=e.DependsOrder||(e.DependsOrder={}));var h;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(h=e.RunOnOptions||(e.RunOnOptions={}));var T;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:h.default,instanceLimit:1}})(T=e.RunOptions||(e.RunOptions={}));class s{constructor(H,$,z,G,te,he){this._label="",this._id=H,$&&(this._label=$),z&&(this.type=z),this.runOptions=G,this.configurationProperties=te,this._source=he}getDefinition(H){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const H={folder:this.getFolderId(),id:this._id};return JSON.stringify(H)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(H,$=!1){if(H===void 0)return!1;if(D.isString(H))return H===this._label||H===this.configurationProperties.identifier||$&&H===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===H._key}getQualifiedLabel(){const H=this.getWorkspaceFolder();return H?`${this._label} (${H.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(H){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),H&&(this._taskLoadMessages=this._taskLoadMessages.concat(H))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class u extends s{constructor(H,$,z,G,te,he,re,be){super(H,z,void 0,re,be,$),this.command={},this._source=$,this.hasDefinedMatchers=he,te&&(this.command=te)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(H=!1){if(H&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case g.Shell:$="shell";break;case g.Process:$="process";break;case g.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(H){return H instanceof u}getMapKey(){const H=this._source.config.workspaceFolder;return H?`${H.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const H=this.getFolderId();if(!H)return;let $=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&($+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:$};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(H){return new u(H._id,H._source,H._label,H.type,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.CustomTask=u;class n extends s{constructor(H,$,z,G,te,he,re){super(H,z,G,he,re,$),this._source=$,this.configures=te}static is(H){return H instanceof n}fromObject(H){return H}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const H=this.getFolderId();if(!H)return;let $=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&($+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:H,id:$};return JSON.stringify(z)}}e.ConfiguringTask=n;class i extends s{constructor(H,$,z,G,te,he,re,be,le){super(H,z,G,be,le,$),this.defines=te,this.hasDefinedMatchers=re,this.command=he,this.icon=le.icon,this.hide=le.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(H){return H instanceof i}getMapKey(){const H=this._source.workspaceFolder;return H?`${this._source.scope.toString()}|${H.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const H={type:"contributed",scope:this._source.scope,id:this._id};return H.folder=this.getFolderId(),JSON.stringify(H)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(H){return new i(H._id,H._source,H._label,H.type,H.defines,H.command,H.hasDefinedMatchers,H.runOptions,H.configurationProperties)}}e.ContributedTask=i;class o extends s{constructor(H,$,z,G,te,he){super(H,z,G,te,he,$),this._source=$}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(H){return H instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(H){return new o(H._id,H._source,H._label,H.type,H.runOptions,H.configurationProperties)}}e.InMemoryTask=o;var a;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var t;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(t=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class d{constructor(H){this._order=new Map;for(let $=0;$<H.length;$++)this._order.set(H[$].uri.toString(),$)}compare(H,$){const z=H.getWorkspaceFolder(),G=$.getWorkspaceFolder();if(z&&G){let te=this._order.get(z.uri.toString());te=te===void 0?0:te+1;let he=this._order.get(G.uri.toString());return he=he===void 0?0:he+1,te===he?H._label.localeCompare($._label):te-he}else return!z&&G?-1:z&&!G?1:0}}e.TaskSorter=d;var p;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(O){O.SingleRun="singleRun",O.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var F;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(F=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(O){function H($,z,G,te,he){if(z){const re={kind:$,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:z};return $==="start"?(re.terminalId=G,re.resolvedVariables=te):$==="processStarted"?re.processId=G:$==="processEnded"&&(re.exitCode=G),Object.freeze(re)}else return Object.freeze({kind:"changed"})}O.create=H})(j=e.TaskEvent||(e.TaskEvent={}));var U;(function(O){function H(z){const G=Object.keys(z).sort();let te="";for(const he of G){let re=z[he];re instanceof Object?re=H(re):typeof re=="string"&&(re=re.replace(/,/g,",,")),te+=he+","+re+","}return te}function $(z){const te={_key:H(z),type:z.taskType};return Object.assign(te,z),te}O.create=$})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var C;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(C=e.TaskSettingId||(e.TaskSettingId={}));var W;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(W=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(O){function H($,z){const G=A.TaskDefinitionRegistry.get($.type);if(G===void 0){const be=N.deepClone($);return delete be._key,U.create(be)}const te=Object.create(null);te.type=G.taskType;const he=new Set;G.required.forEach(be=>he.add(be));const re=G.properties;for(const be of Object.keys(re)){const le=$[be];if(le!=null)te[be]=le;else if(he.has(be)){const fe=re[be];if(fe.default!==void 0)te[be]=N.deepClone(fe.default);else switch(fe.type){case"boolean":te[be]=!1;break;case"number":case"integer":te[be]=0;break;case"string":te[be]="";break;default:z.error(r.localize(2,null,JSON.stringify($,void 0,0),be));return}}}return U.create(te)}O.createTaskIdentifier=H})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[190],Ce([1,0,12]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class D{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,A)=>{this._actualOk=_,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,r.onUnexpectedError)(_))}then(_,A){return this._ensureActual().then(_,A)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=D;class b extends D{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=b}),define(Ie[42],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const D=[];function b(A){const y=new r(A);return D[y.nid]=y,y}e.createProxyIdentifier=b;function N(A){return D[A].sid}e.getStringIdentifierForProxy=N;class _{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=_}),define(Ie[5],Ce([1,0,42]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var b;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput"})(b=e.TabInputKind||(e.TabInputKind={}));var N;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(c){return c._id=E._n++,c}}e.IdObject=E,E._n=0;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[70],Ce([1,0,3,11,5,14]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(b.MainContext.MainThreadTelemetry)}report(y,P,R){const E=this.getUsageKey(y,P);this._reportedUsages.has(E)||(this._reportedUsages.add(E),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};_=xe([$e(0,N.IExtHostRpcService),$e(1,D.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,P){}})}),define(Ie[191],Ce([1,0,4,5,6,26]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,R,E={}){const m=N.ExtensionIdentifier.toKey(y.identifier),I=this._inFlightRequests.get(m)||[],g=[...R].sort().join(" ");let l=I.find(c=>c.providerId===P&&c.scopes===g);if(l)return l.result;{const c=this._getSession(y,m,P,R,E);l={providerId:P,scopes:g,result:c},I.push(l),this._inFlightRequests.set(m,I);try{await c}finally{const f=I.findIndex(v=>v.providerId===P&&v.scopes===g);f>-1&&(I.splice(f),this._inFlightRequests.set(m,I))}return c}}async _getSession(y,P,R,E,m={}){await this._proxy.$ensureProvider(R);const I=y.displayName||y.name;return this._proxy.$getSession(R,E,P,I,m)}async removeSession(y,P){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,R,E){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:R,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===y)||this._providers.push({id:y,label:P});const m=R.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(y,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,E?.supportsMultipleAccounts??!1),new b.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const I=this._providers.findIndex(g=>g.id===y);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(Ie[192],Ce([1,0,5,14,8]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(A,y){this._proxy=A.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>y.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,P){const R=b.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(R,void 0,P?.isRefactoring??!1)}};N=xe([$e(0,D.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Ie[193],Ce([1,0,5]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class D{constructor(N){const _=N.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(A){return _.$writeText(A)}})}}e.ExtHostClipboard=D});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[37],Ce([1,0,9,6,8,25,5,18,11,79,51,246,2,7,3,14,95,23,42,44]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S){"use strict";var h,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(t,d){h.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,T.set(this,void 0),Ye(this,h,t.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=d,Ye(this,T,t.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,p=>{const w=this._apiCommands.get(p);return w?.result===i.Void?w:void 0},d),this._argumentProcessors=[{processArgument(p){return(0,P.revive)(p)}},{processArgument(p){return(0,N.cloneAndChange)(p,function(w){if(R.Range.isIRange(w))return b.Range.to(w);if(E.Position.isIPosition(w))return b.Position.to(w);if(R.Range.isIRange(w.range)&&m.URI.isUri(w.uri))return b.location.to(w);if(w instanceof f.VSBuffer)return w.buffer.buffer;if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const d=this.registerCommand(!1,t.id,async(...p)=>{const w=t.args.map((j,U)=>{if(!j.validate(p[U]))throw new Error(`Invalid argument '${j.name}' when running '${t.id}', received: ${p[U]}`);return j.convert(p[U])}),F=await this.executeCommand(t.internalId,...w);return t.result.convert(F,p,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new D.Disposable(()=>{d.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,d,p,w,F,j){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:p,thisArg:w,description:F,extension:j}),t&&Oe(this,h,"f").$registerCommand(d),new D.Disposable(()=>{this._commands.delete(d)&&t&&Oe(this,h,"f").$unregisterCommand(d)})}executeCommand(t,...d){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,d,!0)}async _doExecuteCommand(t,d,p){if(this._commands.has(t))return Oe(this,h,"f").$fireCommandActivationEvent(t),this._executeContributedCommand(t,d,!1);{let w=!1;const F=(0,N.cloneAndChange)(d,function(j){if(j instanceof D.Position)return b.Position.from(j);if(j instanceof D.Range)return b.Range.from(j);if(j instanceof D.Location)return b.location.from(j);if(D.NotebookRange.isNotebookRange(j))return b.NotebookRange.from(j);if(j instanceof ArrayBuffer)return w=!0,f.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return w=!0,f.VSBuffer.wrap(j);if(j instanceof f.VSBuffer)return w=!0,j;if(!Array.isArray(j))return j});try{const j=await Oe(this,h,"f").$executeCommand(t,w?new v.SerializableObjectWithBuffers(F):F,p);return(0,P.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(t,d,!1);throw j}}}async _executeContributedCommand(t,d,p){const w=this._commands.get(t);if(!w)throw new Error("Unknown command");this._reportTelemetry(w,t);const{callback:F,thisArg:j,description:U}=w;if(U)for(let C=0;C<U.args.length;C++)try{(0,r.validateConstraint)(d[C],U.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${U.args[C].name}' - ${U.args[C].description}`)}try{return await F.apply(j,d)}catch(C){if(t===this.converter.delegatingCommandId){const W=this.converter.getActualCommand(...d);W&&(t=W.command)}throw this._logService.error(C,t,w.extension?.identifier),p?new class extends Error{constructor(){super((0,S.toErrorMessage)(C)),this.id=t,this.source=w.extension?.displayName??w.extension?.name}}:C}}_reportTelemetry(t,d){!t.extension||t.extension.isBuiltin||Oe(this,T,"f").$publicLog2("Extension:ActionExecuted",{extensionId:t.extension.identifier.value,id:d})}$executeContributedCommand(t,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(d=d.map(p=>this._argumentProcessors.reduce((w,F)=>F.processArgument(w),p)),this._executeContributedCommand(t,d,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),Oe(this,h,"f").$getCommands().then(d=>(t&&(d=d.filter(p=>p[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(const[d,p]of this._commands){const{description:w}=p;w&&(t[d]=w)}return Promise.resolve(t)}};h=new WeakMap,T=new WeakMap,s=xe([$e(0,l.IExtHostRpcService),$e(1,y.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class u{constructor(t,d,p){this._commands=t,this._lookupApiCommand=d,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,d){if(!t)return;const p={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return p;const w=this._lookupApiCommand(t.command);if(w)p.id=w.internalId,p.arguments=w.args.map((F,j)=>F.convert(t.arguments&&t.arguments[j]));else if((0,A.isNonEmptyArray)(t.arguments)){const F=++this._cachIdPool;this._cache.set(F,t),d.add((0,I.toDisposable)(()=>{this._cache.delete(F),this._logService.trace("CommandsConverter#DISPOSE",F)})),p.$ident=F,p.id=this.delegatingCommandId,p.arguments=[F],this._logService.trace("CommandsConverter#CREATE",t.command,F)}return p}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const d=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class n{constructor(t,d,p,w){this.name=t,this.description=d,this.validate=p,this.convert=w}optional(){return new n(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,d){return new n(t??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",a=>m.URI.isUri(a),a=>a),n.Position=new n("position","A position in a text document",a=>D.Position.isPosition(a),b.Position.from),n.Range=new n("range","A range in a text document",a=>D.Range.isRange(a),b.Range.from),n.Selection=new n("selection","A selection in a text document",a=>D.Selection.isSelection(a),b.Selection.from),n.Number=new n("number","",a=>typeof a=="number",a=>a),n.String=new n("string","",a=>typeof a=="string",a=>a),n.CallHierarchyItem=new n("item","A call hierarchy item",a=>a instanceof D.CallHierarchyItem,b.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",a=>a instanceof D.TypeHierarchyItem,b.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",a=>a instanceof c.TestItemImpl,b.TestItem.from);class i{constructor(t,d){this.description=t,this.convert=d}}e.ApiCommandResult=i,i.Void=new i("no result",a=>a);class o{constructor(t,d,p,w,F){this.id=t,this.internalId=d,this.description=p,this.args=w,this.result=F}}e.ApiCommand=o}),define(Ie[194],Ce([1,0,2,8,6,69,37,18,82,86,13]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(D.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,c)=>{if((0,A.isFalsyOrEmpty)(l))return;class f extends b.SymbolInformation{static to(S){const h=new f(S.name,D.SymbolKind.to(S.kind),S.containerName||"",new b.Location(c[0],D.Range.to(S.range)));return h.detail=S.detail,h.range=h.location.range,h.selectionRange=D.Range.to(S.selectionRange),h.children=S.children?S.children.map(f.to):[],h}}return l.map(f.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(D.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(D.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(D.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(D.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(D.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(c=>b.Position.isPosition(c)),l=>l.map(D.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(c=>{let f;for(const v of c.reverse())f=new b.SelectionRange(D.Range.to(v),f);return f}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(D.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:D.Range.to(l.range),placeholder:l.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return D.WorkspaceEdit.to(l)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(D.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new b.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const c=(0,y.decodeSemanticTokensDto)(l);if(c.type==="full")return new b.SemanticTokens(c.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new b.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const c=(0,y.decodeSemanticTokensDto)(l);if(c.type==="full")return new b.SemanticTokens(c.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,c,f)=>{if(!l)return new b.CompletionList([]);const v=l.suggestions.map(S=>D.CompletionItem.to(S,f));return new b.CompletionList(v,l.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return D.SignatureHelp.to(l)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,c,f)=>I(v=>new b.CodeLens(D.Range.to(v.range),v.command&&f.fromInternal(v.command)))(l))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>b.Range.isRange(l),l=>b.Selection.isSelection(l)?D.Selection.from(l):D.Range.from(l)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,c,f)=>I(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const S=new b.CodeAction(v.title,v.kind?new b.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=D.WorkspaceEdit.to(v.edit)),v.command&&(S.command=f.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(l))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(c=>new b.ColorInformation(D.Range.to(c.range),D.Color.to(c.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",l=>l instanceof b.Color,D.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:D.Range.from(l.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(D.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,c,f)=>l.map(D.InlayHint.to.bind(void 0,f)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(c=>D.NotebookExclusiveDocumentPattern.to(c))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(D.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",l=>r.URI.isUri(l)||typeof l=="string"&&(0,P.matchesSomeScheme)(l,R.Schemas.http,R.Schemas.https),l=>l),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[D.ViewColumn.from(l),void 0]:[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[D.ViewColumn.from(l),void 0]:[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(D.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(D.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(D.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class m{static register(c){E.forEach(c.registerApiCommand,c)}}e.ExtHostApiCommands=m;function I(l){return c=>{if(Array.isArray(c))return c.map(l)}}function g(l){if(!Array.isArray(l))return;const c=[];for(const f of l)N.isLocationLink(f)?c.push(D.DefinitionLink.to(f)):c.push(D.location.to(f));return c}}),define(Ie[195],Ce([1,0,15,57,4,7,2,69,26,8,6,28,5]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(g,l,c){const f=g.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const t=this._commentControllers.get(a.handle);return t?t.value:a}else if(a&&a.$mid===7){const t=this._commentControllers.get(a.commentControlHandle);if(!t)return a;const d=t.getCommentThread(a.commentThreadHandle);return d?d.value:a}else if(a&&a.$mid===8){const t=this._commentControllers.get(a.thread.commentControlHandle);if(!t)return a;const d=t.getCommentThread(a.thread.commentThreadHandle);return d?{thread:d.value,text:a.text}:a}else if(a&&a.$mid===9){const t=this._commentControllers.get(a.thread.commentControlHandle);if(!t)return a;const d=t.getCommentThread(a.thread.commentThreadHandle);if(!d)return a;const p=a.commentUniqueId,w=d.getCommentByUniqueId(p);return w||a}else if(a&&a.$mid===10){const t=this._commentControllers.get(a.thread.commentControlHandle);if(!t)return a;const d=t.getCommentThread(a.thread.commentThreadHandle);if(!d)return a;const p=a.text,w=a.commentUniqueId,F=d.getCommentByUniqueId(w);return F?(typeof F.body=="string"?F.body=p:F.body.value=p,F):a}return a}})}createCommentController(a,t,d){const p=v.handlePool++,w=new h(a,p,t,d);this._commentControllers.set(w.handle,w);const F=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(a.identifier))||[];return F.push(w),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(a.identifier),F),w.value}$createCommentThreadTemplate(a,t,d){const p=this._commentControllers.get(a);!p||p.$createCommentThreadTemplate(t,d)}async $updateCommentThreadTemplate(a,t,d){const p=this._commentControllers.get(a);!p||p.$updateCommentThreadTemplate(t,d)}$deleteCommentThread(a,t){this._commentControllers.get(a)?.$deleteCommentThread(t)}$provideCommentingRanges(a,t,d){const p=this._commentControllers.get(a);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const w=c.getDocument(_.URI.revive(t));return(0,r.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(w,d)).then(F=>F?F.map(j=>P.Range.from(j)):void 0)}$toggleReaction(a,t,d,p,w){const F=this._commentControllers.get(a);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const j=F.getCommentThread(t);if(j){const U=j.getCommentByUniqueId(p.uniqueIdInThread);if(F!==void 0&&U&&F.reactionHandler)return F.reactionHandler(U,u(w))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class S{set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get state(){return(0,E.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(a){(0,E.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=a,this.modifications.state=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(a,t,d,p,w,F,j,U){this._commentControllerHandle=t,this._id=d,this._uri=p,this._range=w,this._comments=F,this.extensionDescription=j,this._isTemplate=U,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputDisposables.value=new N.DisposableStore,this._id===void 0&&(this._id=`${a}.${this.handle}`),f.$createCommentThread(t,this.handle,this._id,this._uri,P.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(t,this.handle)}});const C=this;this.value={get uri(){return C.uri},get range(){return C.range},set range(W){C.range=W},get comments(){return C.comments},set comments(W){C.comments=W},get collapsibleState(){return C.collapsibleState},set collapsibleState(W){C.collapsibleState=W},get canReply(){return C.canReply},set canReply(W){C.canReply=W},get contextValue(){return C.contextValue},set contextValue(W){C.contextValue=W},get label(){return C.label},set label(W){C.label=W},get state(){return C.state},set state(W){C.state=W},dispose:()=>{C.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new N.DisposableStore);const a=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),t={};a("range")&&(t.range=P.Range.from(this._range)),a("label")&&(t.label=this.label),a("contextValue")&&(t.contextValue=this.contextValue??null),a("comments")&&(t.comments=this._comments.map(d=>T(this,d,this._commentsMap))),a("collapsibleState")&&(t.collapseState=n(this._collapseState)),a("canReply")&&(t.canReply=this.canReply),a("state")&&(t.state=i(this._state)),a("isTemplate")&&(t.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,t)}getCommentByUniqueId(a){for(const t of this._commentsMap){const d=t[0],p=t[1];if(a===p)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose())}}S._handlePool=0,xe([(0,D.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class h{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(a){this._commentingRangeProvider=a,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(a,t,d,p){this._extension=a,this._handle=t,this._id=d,this._label=p,this._threads=new Map,f.$registerCommentController(this.handle,d,p);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(F){w.options=F},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(F){w.commentingRangeProvider=F},get reactionHandler(){return w.reactionHandler},set reactionHandler(F){w.reactionHandler=F},createCommentThread(F,j,U){return w.createCommentThread(F,j,U).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(a,t,d,p){if(typeof a=="string"){const w=new S(this.id,this.handle,a,t,d,p,this._extension,!1);return this._threads.set(w.handle,w),w}else{const w=new S(this.id,this.handle,void 0,a,t,d,this._extension,!1);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(a,t){const d=new S(this.id,this.handle,void 0,_.URI.revive(a),P.Range.to(t),[],this._extension,!0);return d.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(a,t){const d=this._threads.get(a);d&&(d.range=P.Range.to(t))}$deleteCommentThread(a){this._threads.get(a)?.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._localDisposables.forEach(a=>a.dispose())}}function T(o,a,t){let d=t.get(a);d||(d=++o.commentHandle,t.set(a,d));const p=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:d,body:typeof a.body=="string"?a.body:P.MarkdownString.from(a.body),userName:a.author.name,userIconPath:p,label:a.label,commentReactions:a.reactions?a.reactions.map(w=>s(w)):void 0,timestamp:a.timestamp?.toJSON()}}function s(o){return{label:o.label,iconPath:o.iconPath?P.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function u(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?_.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function n(o){if(o!==void 0)switch(o){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function i(o){if(o!==void 0)switch(o){case R.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new v}e.createExtHostComments=I}),define(Ie[196],Ce([1,0,25,5,27,14]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(R,E){this._mainThreadConsole=R.getProxy(D.MainContext.MainThreadConsole),this._includeStack=E.consoleForward.includeStack,this._logNative=E.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,E){const m=this,I=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m._handleConsoleCall(R,E,I,arguments)}})}_handleConsoleCall(R,E,m,I){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:E,arguments:y(I,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,m,I)}};_=xe([$e(0,N.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const A=1e5;function y(P,R){const E=[];if(P.length)for(let m=0;m<P.length;m++){let I=P[m];if(typeof I>"u")I="undefined";else if(I instanceof Error){const g=I;g.stack?I=g.stack:I=g.toString()}E.push(I)}if(R){const m=new Error().stack;m&&E.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,r.safeStringify)(E);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[97],Ce([1,0,2,5,6,3,14,11,18,10,19]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Oi{constructor(I,g){this._logService=g,this._provider=new Map,this._proxy=I.getProxy(D.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,g){const l=Oi._handlePool++;this._provider.set(l,{provider:I,extensionId:g}),this._proxy.$registerDecorationProvider(l,g.value);const c=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(l,null);return}const v=(0,y.asArray)(f);if(v.length<=Oi._maxEventSize){this._proxy.$onDidChange(l,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,v.length);const S=v.map(s=>({uri:s,rank:(0,P.count)(s.path,"/")})),h=(0,y.groupBy)(S,(s,u)=>s.rank-u.rank||(0,P.compare)(s.uri.path,u.uri.path)),T=[];e:for(const s of h){let u;for(const n of s){const i=(0,R.dirname)(n.uri.path);if(u!==i&&(u=i,T.push(n.uri)>=Oi._maxEventSize))break e}}this._proxy.$onDidChange(l,T)});return new b.Disposable(()=>{c?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(I,g,l){if(!this._provider.has(I))return Object.create(null);const c=Object.create(null),{provider:f,extensionId:v}=this._provider.get(I);return await Promise.all(g.map(async S=>{try{const{uri:h,id:T}=S,s=await Promise.resolve(f.provideFileDecoration(r.URI.revive(h),l));if(!s)return;try{b.FileDecoration.validate(s),c[T]=[s.propagate,s.tooltip,s.badge,s.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(h){this._logService.error(h)}})),c}};E._handlePool=0,E._maxEventSize=250,E=xe([$e(0,_.IExtHostRpcService),$e(1,A.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[197],Ce([1,0,130,85,2,5,6,8,4,11,24,36]),function(ne,e,r,D,b,N,_,A,y,P,R,E){"use strict";var m,I,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class l{constructor(v,S,h,T,s,u){this._name=v,this._owner=S,this._maxDiagnosticsPerFile=h,m.set(this,void 0),I.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Ye(this,g,new R.ResourceMap(n=>T.getComparisonKey(n)),"f"),Ye(this,m,s,"f"),Ye(this,I,u,"f")}dispose(){this._isDisposed||(Oe(this,I,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,S){if(!v){this.clear();return}this._checkDisposed();let h=[];if(b.URI.isUri(v)){if(!S){this.delete(v);return}Oe(this,g,"f").set(v,S.slice()),h=[v]}else if(Array.isArray(v)){h=[];let s;v=[...v].sort(l._compareIndexedTuplesByUri);for(const u of v){const[n,i]=u;if((!s||n.toString()!==s.toString())&&(s&&Oe(this,g,"f").get(s).length===0&&Oe(this,g,"f").delete(s),s=n,h.push(n),Oe(this,g,"f").set(n,[])),i)Oe(this,g,"f").get(n)?.push(...i);else{const o=Oe(this,g,"f").get(n);o&&(o.length=0)}}}if(Oe(this,I,"f").fire(h),!Oe(this,m,"f"))return;const T=[];for(const s of h){let u=[];const n=Oe(this,g,"f").get(s);if(n)if(n.length>this._maxDiagnosticsPerFile){u=[];const i=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const a of n)if(a.severity===i[o]&&u.push(A.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;u.push({severity:D.MarkerSeverity.Info,message:(0,r.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=n.map(i=>A.Diagnostic.from(i));T.push([s,u])}Oe(this,m,"f").$changeMany(this._owner,T)}delete(v){this._checkDisposed(),Oe(this,I,"f").fire([v]),Oe(this,g,"f").delete(v),Oe(this,m,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Oe(this,I,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,g,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(v,S){this._checkDisposed();for(const[h,T]of this)v.call(S,h,T,this)}*[(m=new WeakMap,I=new WeakMap,g=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Oe(this,g,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const S=Oe(this,g,"f").get(v);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Oe(this,g,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,S){return v[0].toString()<S[0].toString()?-1:v[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=l;let c=class li{static _mapper(v){const S=new R.ResourceMap;for(const h of v)S.set(h,h);return{uris:Object.freeze(Array.from(S.values()))}}constructor(v,S,h){this._logService=S,this._fileSystemInfoService=h,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:T=>T.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,li._mapper),this._proxy=v.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,S){const{_collections:h,_proxy:T,_onDidChangeDiagnostics:s,_logService:u,_fileSystemInfoService:n}=this,i=new class{$changeMany(t,d){T.$changeMany(t,d),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,t,d.length===0?"CLEARING":d)}$clear(t){T.$clear(t),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,t)}dispose(){T.dispose()}};let o;if(!S)S="_generated_diagnostic_collection_name_#"+li._idPool++,o=S;else if(!h.has(S))o=S;else{this._logService.warn(`DiagnosticCollection with name '${S}' does already exist.`);do o=S+li._idPool++;while(h.has(o))}return new class extends l{constructor(){super(S,o,li._maxDiagnosticsPerFile,n.extUri,i,s),h.set(o,this)}dispose(){super.dispose(),h.delete(o)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const S=new Map,h=[];for(const T of this._collections.values())T.forEach((s,u)=>{let n=S.get(s.toString());typeof n>"u"&&(n=h.length,S.set(s.toString(),n),h.push([s,[]])),h[n][1]=h[n][1].concat(...u)});return h}}_getDiagnostics(v){let S=[];for(const h of this._collections.values())h.has(v)&&(S=S.concat(h.get(v)));return S}$acceptMarkersChange(v){if(!this._mirrorCollection){const S="_generated_mirror",h=new l(S,S,li._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(S,h),this._mirrorCollection=h}for(const[S,h]of v)this._mirrorCollection.set(b.URI.revive(S),h.map(A.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=xe([$e(1,P.ILogService),$e(2,E.IExtHostFileSystemInfo)],c),e.ExtHostDiagnostics=c}),define(Ie[198],Ce([1,0,2,5]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(_){this._proxy=_.getProxy(D.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(A=>A?A.map(y=>r.URI.revive(y)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=b}),define(Ie[199],Ce([1,0,12,2,6,5,13,21,10]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(E,m,I){this._documentsAndEditors=m,this._logService=I,this._documentContentProviders=new Map,this._proxy=E.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,m){if(Object.keys(_.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const I=P._handlePool++;this._documentContentProviders.set(I,m),this._proxy.$registerTextContentProvider(I,E);let g;return typeof m.onDidChange=="function"&&(g=m.onDidChange(l=>{if(l.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(I,l).then(c=>{if(!c&&typeof c!="string")return;const f=this._documentsAndEditors.getDocument(l);if(!f)return;const v=(0,y.splitLines)(c);if(!f.equalLines(v))return this._proxy.$onVirtualDocumentChange(l,c)},r.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(E,m){const I=this._documentContentProviders.get(E);return I?Promise.resolve(I.provideTextDocumentContent(D.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ie[200],Ce([1,0,4,7,2,5,93,8,9,25,6]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(I,g){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new D.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(N.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const c of l)this._onDidRemoveDocument.fire(c.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const c of l)this._onDidAddDocument.fire(c.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const g=this._documentsAndEditors.getDocument(I);if(g)return g}getDocument(I){const g=this.getDocumentData(I);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return g.document}ensureDocumentData(I){const g=this._documentsAndEditors.getDocument(I);if(g)return Promise.resolve(g);let l=this._documentLoader.get(I.toString());return l||(l=this._proxy.$tryOpenDocument(I).then(c=>{this._documentLoader.delete(I.toString());const f=b.URI.revive(c);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(f))},c=>(this._documentLoader.delete(I.toString()),Promise.reject(c))),this._documentLoader.set(I.toString(),l)),l}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(g=>b.URI.revive(g))}$acceptModelLanguageChanged(I,g){const l=b.URI.revive(I),c=this._documentsAndEditors.getDocument(l);if(!c)throw new Error("unknown document");this._onDidRemoveDocument.fire(c.document),c._acceptLanguageId(g),this._onDidAddDocument.fire(c.document)}$acceptModelSaved(I){const g=b.URI.revive(I),l=this._documentsAndEditors.getDocument(g);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(I,g){const l=b.URI.revive(I),c=this._documentsAndEditors.getDocument(l);if(!c)throw new Error("unknown document");c._acceptIsDirty(g),this._onDidChangeDocument.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,g,l){const c=b.URI.revive(I),f=this._documentsAndEditors.getDocument(c);if(!f)throw new Error("unknown document");f._acceptIsDirty(l),f.onEvents(g);let v;g.isUndoing?v=R.TextDocumentChangeReason.Undo:g.isRedoing&&(v=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:f.document,contentChanges:g.changes.map(S=>({range:A.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:v}))}setWordDefinitionFor(I,g){(0,_.setWordDefinitionFor)(I,g)}}e.ExtHostDocuments=E}),define(Ie[52],Ce([1,0,46,4,7,2,3,5,93,14,96,8,11,24,13,170,201]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(h,T){this._extHostRpc=h,this._logService=T,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new D.Emitter,this._onDidRemoveDocuments=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const T=[],s=[],u=[];if(h.removedDocuments)for(const n of h.removedDocuments){const i=N.URI.revive(n),o=this._documents.get(i);o?.unref()&&(this._documents.delete(i),T.push(o.value))}if(h.addedDocuments)for(const n of h.addedDocuments){const i=N.URI.revive(n.uri);let o=this._documents.get(i);if(o&&i.scheme!==g.Schemas.vscodeNotebookCell&&i.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);o||(o=new f(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(i,o),s.push(o.value)),o.ref()}if(h.removedEditors)for(const n of h.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&u.push(i)}if(h.addedEditors)for(const n of h.addedEditors){const i=N.URI.revive(n.documentUri);r.ok(this._documents.has(i),`document '${i}' does not exist`),r.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const o=this._documents.get(i).value,a=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new c.Lazy(()=>o.document),n.selections.map(E.Selection.to),n.options,n.visibleRanges.map(t=>E.Range.to(t)),typeof n.editorPosition=="number"?E.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,a)}h.newActiveEditor!==void 0&&(r.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,b.dispose)(T),(0,b.dispose)(u),h.removedDocuments&&this._onDidRemoveDocuments.fire(T),h.addedDocuments&&this._onDidAddDocuments.fire(s),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const T=this._editors.get(this._activeEditorId);return h?T:T?.value}allEditors(){return[...this._editors.values()]}};v=xe([$e(0,P.IExtHostRpcService),$e(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[53],Ce([1,0,8,5,2,4,3,6,14,9,76]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class E{constructor(c,f,v){this._activeTabIdGetter=v,this._parentGroup=f,this.acceptDtoUpdate(c)}get apiObject(){if(!this._apiObject){const c=this,f={get isActive(){return c._dto.id===c._activeTabIdGetter()},get label(){return c._dto.label},get input(){return c._input},get isDirty(){return c._dto.isDirty},get isPinned(){return c._dto.isPinned},get isPreview(){return c._dto.isPreview},get group(){return c._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(c){this._dto=c,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(b.URI.revive(this._dto.input.base),b.URI.revive(this._dto.input.input1),b.URI.revive(this._dto.input.input2),b.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(b.URI.revive(this._dto.input.uri),b.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(c,f){this._tabs=[],this._activeTabId="",this._dto=c,this._activeGroupIdGetter=f;for(const v of c.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new E(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const c=this,f={get isActive(){return c._dto.groupId===c._activeGroupIdGetter()},get viewColumn(){return r.ViewColumn.to(c._dto.viewColumn)},get activeTab(){return c._tabs.find(v=>v.tabId===c._activeTabId)?.apiObject},get tabs(){return Object.freeze(c._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(c){this._dto=c}acceptTabOperation(c){if(c.kind===0){const v=new E(c.tabDto,this,()=>this.activeTabId());return this._tabs.splice(c.index,0,v),c.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(c.kind===1){const v=this._tabs.splice(c.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(c.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this._tabs.splice(c.index,0,v),v}const f=this._tabs.find(v=>v.tabId===c.tabDto.id);if(!f)throw new Error("INVALID tab");return c.tabDto.isActive?this._activeTabId=c.tabDto.id:this._activeTabId===c.tabDto.id&&!c.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(c.tabDto),f}activeTabId(){return this._activeTabId}}let I=class{constructor(c){this._onDidChangeTabs=new N.Emitter,this._onDidChangeTabGroups=new N.Emitter,this._extHostTabGroups=[],this._proxy=c.getProxy(D.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const c=this,f={onDidChangeTabGroups:c._onDidChangeTabGroups.event,onDidChangeTabs:c._onDidChangeTabs.event,get all(){return Object.freeze(c._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=c._activeGroupId;return(0,P.assertIsDefined)(c._extHostTabGroups.find(h=>h.groupId===v)?.apiObject)},close:async(v,S)=>{const h=Array.isArray(v)?v:[v];return h.length?g(h[0])?this._closeGroups(h,S):this._closeTabs(h,S):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(c){const f=new Set(this._extHostTabGroups.map(n=>n.groupId)),v=new Set(c.map(n=>n.groupId)),S=(0,R.diffSets)(f,v),h=this._extHostTabGroups.filter(n=>S.removed.includes(n.groupId)).map(n=>n.apiObject),T=[],s=[];this._extHostTabGroups=c.map(n=>{const i=new m(n,()=>this._activeGroupId);return S.added.includes(i.groupId)?T.push(i.apiObject):s.push(i.apiObject),i});const u=(0,P.assertIsDefined)(c.find(n=>n.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:T,closed:h,changed:s}))}$acceptTabGroupUpdate(c){const f=this._extHostTabGroups.find(v=>v.groupId===c.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(c),c.isActive&&(this._activeGroupId=c.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const f=this._extHostTabGroups.find(S=>S.groupId===c.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const v=f.acceptTabOperation(c);switch(c.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(c){for(const f of this._extHostTabGroups)for(const v of f.tabs)if(v.apiObject===c)return v}_findExtHostTabGroupFromApi(c){return this._extHostTabGroups.find(f=>f.apiObject===c)}async _closeTabs(c,f){const v=[];for(const S of c){const h=this._findExtHostTabFromApi(S);if(!h)throw new Error("Tab close: Invalid tab not found!");v.push(h.tabId)}return this._proxy.$closeTab(v,f)}async _closeGroups(c,f){const v=[];for(const S of c){const h=this._findExtHostTabGroupFromApi(S);if(!h)throw new Error("Group close: Invalid group not found!");v.push(h.groupId)}return this._proxy.$closeGroup(v,f)}};I=xe([$e(0,y.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function g(l){return l.tabs!==void 0}}),define(Ie[202],Ce([1,0,2,5,7,6,8,247,10,23,28]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const l=this._schemes.indexOf(g);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),l=[];let c,f,v=14,S=14;for(const h of g){let T=c?(0,y.commonPrefixLength)(c,h):0;for(T===0?f=1:f=S;T<h.length;T++)T+1===h.length?(v=S,S=9):S+=1,l.push([f,h.toUpperCase().charCodeAt(T),S]),l.push([f,h.toLowerCase().charCodeAt(T),S]),f=S;c=h,S=v}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new A.StateMachine(l)}}provideDocumentLinks(g){this._initStateMachine();const l=[],c=A.LinkComputer.computeLinks({getLineContent(f){return g.lineAt(f-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const f of c){const v=_.DocumentLink.to(f);v.target&&l.push(v)}return l}}class m{constructor(g,l){this._extHostLanguageFeatures=l,this._linkProvider=new E,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(D.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,l,c,f={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(v,c);let S=2;f.isCaseSensitive&&(S+=1024),f.isReadonly&&(S+=2048),typeof c.copy=="function"&&(S+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,R.checkProposedApiEnabled)(g,"fsChunks"),S+=4),this._proxy.$registerFileSystemProvider(v,l,S).catch(T=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${l}`),console.error(T)});const h=c.onDidChangeFile(T=>{const s=[];for(const u of T){const{uri:n,type:i}=u;if(n.scheme!==l)continue;let o;switch(i){case N.FileChangeType.Changed:o=0;break;case N.FileChangeType.Created:o=1;break;case N.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:n,type:o})}this._proxy.$onFileSystemChange(v,s)});return(0,b.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(g){const{type:l,ctime:c,mtime:f,size:v,permissions:S}=g;return{type:l,ctime:c,mtime:f,size:v,permissions:S}}$stat(g,l){return Promise.resolve(this._getFsProvider(g).stat(r.URI.revive(l))).then(c=>m._asIStat(c))}$readdir(g,l){return Promise.resolve(this._getFsProvider(g).readDirectory(r.URI.revive(l)))}$readFile(g,l){return Promise.resolve(this._getFsProvider(g).readFile(r.URI.revive(l))).then(c=>P.VSBuffer.wrap(c))}$writeFile(g,l,c,f){return Promise.resolve(this._getFsProvider(g).writeFile(r.URI.revive(l),c.buffer,f))}$delete(g,l,c){return Promise.resolve(this._getFsProvider(g).delete(r.URI.revive(l),c))}$rename(g,l,c,f){return Promise.resolve(this._getFsProvider(g).rename(r.URI.revive(l),r.URI.revive(c),f))}$copy(g,l,c,f){const v=this._getFsProvider(g);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(r.URI.revive(l),r.URI.revive(c),f))}$mkdir(g,l){return Promise.resolve(this._getFsProvider(g).createDirectory(r.URI.revive(l)))}$watch(g,l,c,f){const v=this._getFsProvider(g).watch(r.URI.revive(c),f);this._watches.set(l,v)}$unwatch(g,l){const c=this._watches.get(l);c&&(c.dispose(),this._watches.delete(l))}$open(g,l,c){const f=this._getFsProvider(g);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(r.URI.revive(l),c))}$close(g,l){const c=this._getFsProvider(g);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(l))}$read(g,l,c,f){const v=this._getFsProvider(g);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const S=P.VSBuffer.alloc(f);return Promise.resolve(v.read(l,c,S.buffer,0,f)).then(h=>S.slice(0,h))}$write(g,l,c,f){const v=this._getFsProvider(g);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(l,c,f.buffer,0,f.byteLength))}_getFsProvider(g){const l=this._fsProvider.get(g);if(!l){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return l}}e.ExtHostFileSystem=m}),define(Ie[54],Ce([1,0,5,35,6,23,3,14,36,7]),function(ne,e,r,D,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Yt{constructor(m,I){this._fileSystemProvider=new Map,this._proxy=m.getProxy(r.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(l){try{const c=g._fileSystemProvider.get(l.scheme);if(!c)return await g._proxy.$stat(l);await g._proxy.$ensureActivation(l.scheme);const f=await c.stat(l);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(c){Yt._handleError(c)}},async readDirectory(l){try{const c=g._fileSystemProvider.get(l.scheme);return c?(await g._proxy.$ensureActivation(l.scheme),(await c.readDirectory(l)).slice()):await g._proxy.$readdir(l)}catch(c){return Yt._handleError(c)}},async createDirectory(l){try{return await g._proxy.$mkdir(l)}catch(c){return Yt._handleError(c)}},async readFile(l){try{const c=g._fileSystemProvider.get(l.scheme);return c?(await g._proxy.$ensureActivation(l.scheme),(await c.readFile(l)).slice()):(await g._proxy.$readFile(l)).buffer}catch(c){return Yt._handleError(c)}},async writeFile(l,c){try{return await g._proxy.$writeFile(l,N.VSBuffer.wrap(c))}catch(f){return Yt._handleError(f)}},async delete(l,c){try{const f=g._fileSystemProvider.get(l.scheme);return f?(await g._proxy.$ensureActivation(l.scheme),await f.delete(l,{recursive:!1,...c})):await g._proxy.$delete(l,{recursive:!1,useTrash:!1,...c})}catch(f){return Yt._handleError(f)}},async rename(l,c,f){try{return await g._proxy.$rename(l,c,{overwrite:!1,...f})}catch(v){return Yt._handleError(v)}},async copy(l,c,f){try{return await g._proxy.$copy(l,c,{overwrite:!1,...f})}catch(v){return Yt._handleError(v)}},isWritableFileSystem(l){const c=I.getCapabilities(l);if(typeof c=="number")return!(c&2048)}})}static _handleError(m){if(m instanceof b.FileSystemError)throw m;if(!(m instanceof Error))throw new b.FileSystemError(String(m));if(m.name==="ENOPRO")throw b.FileSystemError.Unavailable(m.message);switch(m.name){case D.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(m.message);case D.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(m.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(m.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(m.message);case D.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(m.message);case D.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(m.message);default:throw new b.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,I){return this._fileSystemProvider.set(m,I),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(m))}};R=xe([$e(0,A.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[203],Ce([1,0,4,34,2,5,8,6]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(E,m,I,g,l,c,f,v){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const S=this.ensureWatching(E,I,l);this._config=0,c&&(this._config+=1),f&&(this._config+=2),v&&(this._config+=4);const h=(0,D.parse)(l),T=typeof l=="string",s=g(u=>{if(!c)for(const n of u.created){const i=b.URI.revive(n);h(i.fsPath)&&(!T||m.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!f)for(const n of u.changed){const i=b.URI.revive(n);h(i.fsPath)&&(!T||m.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!v)for(const n of u.deleted){const i=b.URI.revive(n);h(i.fsPath)&&(!T||m.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=A.Disposable.from(S,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}ensureWatching(E,m,I){const g=A.Disposable.from();if(typeof I=="string")return g;const l=E.getProxy(N.MainContext.MainThreadFileSystem);let c=!1;(I.pattern.includes(D.GLOBSTAR)||I.pattern.includes(D.GLOB_SPLIT))&&(c=!0);const f=Math.random();return l.$watch(m.identifier.value,f,I.baseUri,{recursive:c,excludes:[]}),A.Disposable.from({dispose:()=>l.$unwatch(f)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(E,m,I){this._mainContext=E,this._logService=m,this._extHostDocumentsAndEditors=I,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(E,m,I,g,l,c){return new y(this._mainContext,E,m,this._onFileSystemEvent.event,_.GlobPattern.from(I),g,l,c)}$onFileEvent(E){this._onFileSystemEvent.fire(E)}$onDidRunFileOperation(E,m){switch(E){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(I=>({oldUri:b.URI.revive(I.source),newUri:b.URI.revive(I.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(I=>b.URI.revive(I.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(I=>b.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(E){return this._createWillExecuteEvent(E,this._onWillRenameFile)}getOnWillCreateFileEvent(E){return this._createWillExecuteEvent(E,this._onWillCreateFile)}getOnWillDeleteFileEvent(E){return this._createWillExecuteEvent(E,this._onWillDeleteFile)}_createWillExecuteEvent(E,m){return(I,g,l)=>{const c=function(v){I.call(g,v)};return c.extension=E,m.event(c,void 0,l)}}async $onWillRunFileOperation(E,m,I,g){switch(E){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(l=>({oldUri:b.URI.revive(l.source),newUri:b.URI.revive(l.target)}))},I,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(l=>b.URI.revive(l.target))},I,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(l=>b.URI.revive(l.target))},I,g)}}async _fireWillEvent(E,m,I,g){const l=new Set,c=[];if(await E.fireAsync(m,g,async(v,S)=>{const h=Date.now(),T=await Promise.resolve(v);T instanceof A.WorkspaceEdit&&(c.push([S.extension,T]),l.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-h>I&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),g.isCancellationRequested||c.length===0)return;const f={edits:[]};for(const[,v]of c){const{edits:S}=_.WorkspaceEdit.from(v,{getTextDocumentVersion:h=>this._extHostDocumentsAndEditors.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(S)}return{edit:f,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=P}),define(Ie[204],Ce([1,0,2,37]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(_,A,y,P,R){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=P;const E=new D.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new D.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new D.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new D.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new D.ApiCommandResult("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const I=this._extHostNotebooks.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri),notebookEditor:I.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(E)}$willAddInteractiveDocument(_,A,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=b}),define(Ie[205],Ce([1,0,7,5]),function(ne,e,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(_){this._handlePool=0,this._proxy=_.getProxy(D.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,_),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=b}),define(Ie[206],Ce([1,0,2,25,8,6,69,5,10,51,18,9,248,21,7,82,77,62,207,12,15,28]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentSymbols(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentSymbols(V,B);if(!(0,R.isFalsyOrEmpty)(q))return q[0]instanceof N.DocumentSymbol?q.map(b.DocumentSymbol.from):s._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(k){k=k.slice(0).sort((q,oe)=>{let ce=q.location.range.start.compareTo(oe.location.range.start);return ce===0&&(ce=oe.location.range.end.compareTo(q.location.range.end)),ce});const B=[],V=[];for(const q of k){const oe={name:q.name||"!!MISSING: name!!",kind:b.SymbolKind.from(q.kind),tags:q.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:b.Range.from(q.location.range),selectionRange:b.Range.from(q.location.range),children:[]};for(;;){if(V.length===0){V.push(oe),B.push(oe);break}const ce=V[V.length-1];if(P.Range.containsRange(ce.range,oe.range)&&!P.Range.equalsRange(ce.range,oe.range)){ce.children?.push(oe),V.push(oe);break}V.pop()}}return B}}class u{constructor(k,B,V){this._documents=k,this._commands=B,this._provider=V,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideCodeLenses(V,B);if(!q||B.isCancellationRequested)return;const oe=this._cache.add(q),ce=new g.DisposableStore;this._disposables.set(oe,ce);const J={cacheId:oe,lenses:[]};for(let Ee=0;Ee<q.length;Ee++)J.lenses.push({cacheId:[oe,Ee],range:b.Range.from(q[Ee].range),command:this._commands.toInternal(q[Ee].command,ce)});return J}async resolveCodeLens(k,B){const V=k.cacheId&&this._cache.get(...k.cacheId);if(!V)return;let q;if(typeof this._provider.resolveCodeLens!="function"||V.isResolved?q=V:q=await this._provider.resolveCodeLens(V,B),q||(q=V),B.isCancellationRequested)return;const oe=k.cacheId&&this._disposables.get(k.cacheId[0]);if(!!oe)return k.command=this._commands.toInternal(q.command??u._badCmd,oe),k}releaseCodeLenses(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(Z){return Array.isArray(Z)?Z.map(b.DefinitionLink.from):Z?[b.DefinitionLink.from(Z)]:[]}class i{constructor(k,B){this._documents=k,this._provider=B}async provideDefinition(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideDefinition(q,oe,V);return n(ce)}}class o{constructor(k,B){this._documents=k,this._provider=B}async provideDeclaration(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideDeclaration(q,oe,V);return n(ce)}}class a{constructor(k,B){this._documents=k,this._provider=B}async provideImplementation(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideImplementation(q,oe,V);return n(ce)}}class t{constructor(k,B){this._documents=k,this._provider=B}async provideTypeDefinition(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideTypeDefinition(q,oe,V);return n(ce)}}class d{constructor(k,B){this._documents=k,this._provider=B}async provideHover(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideHover(q,oe,V);if(!(!ce||(0,R.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=q.getWordRangeAtPosition(oe)),ce.range||(ce.range=new N.Range(oe,oe)),b.Hover.from(ce)}}class p{constructor(k,B){this._documents=k,this._provider=B}async provideEvaluatableExpression(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideEvaluatableExpression(q,oe,V);if(ce)return b.EvaluatableExpression.from(ce)}}class w{constructor(k,B){this._documents=k,this._provider=B}async provideInlineValues(k,B,V,q){const oe=this._documents.getDocument(k),ce=await this._provider.provideInlineValues(oe,b.Range.to(B),b.InlineValueContext.to(V),q);if(Array.isArray(ce))return ce.map(J=>b.InlineValue.from(J))}}class F{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentHighlights(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideDocumentHighlights(q,oe,V);if(Array.isArray(ce))return ce.map(b.DocumentHighlight.from)}}class j{constructor(k,B){this._documents=k,this._provider=B}async provideLinkedEditingRanges(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.provideLinkedEditingRanges(q,oe,V);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,R.coalesce)(ce.ranges.map(b.Range.from)),wordPattern:ce.wordPattern}}}class U{constructor(k,B){this._documents=k,this._provider=B}async provideReferences(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=await this._provider.provideReferences(oe,ce,V,q);if(Array.isArray(J))return J.map(b.location.from)}}class C{constructor(k,B,V,q,oe,ce,J){this._documents=k,this._commands=B,this._diagnostics=V,this._provider=q,this._logService=oe,this._extension=ce,this._apiDeprecation=J,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(k,B,V,q){const oe=this._documents.getDocument(k),ce=m.Selection.isISelection(B)?b.Selection.to(B):b.Range.to(B),J=[];for(const Ge of this._diagnostics.getDiagnostics(k))if(ce.intersection(Ge.range)&&J.push(Ge)>C._maxCodeActionsPerFile)break;const Ee={diagnostics:J,only:V.only?new N.CodeActionKind(V.only):void 0,triggerKind:b.CodeActionTriggerKind.to(V.trigger)},ve=await this._provider.provideCodeActions(oe,ce,Ee,q);if(!(0,R.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const Ne=this._cache.add(ve),ze=new g.DisposableStore;this._disposables.set(Ne,ze);const Je=[];for(let Ge=0;Ge<ve.length;Ge++){const Pe=ve[Ge];!Pe||(C._isCommand(Pe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Je.push({_isSynthetic:!0,title:Pe.title,command:this._commands.toInternal(Pe,ze)})):(Ee.only&&(Pe.kind?Ee.only.contains(Pe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Je.push({cacheId:[Ne,Ge],title:Pe.title,command:Pe.command&&this._commands.toInternal(Pe.command,ze),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(b.Diagnostic.from),edit:Pe.edit&&b.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,disabled:Pe.disabled?.reason})))}return{cacheId:Ne,actions:Je}}async resolveCodeAction(k,B){const[V,q]=k,oe=this._cache.get(V,q);if(!oe||C._isCommand(oe)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(oe,B)??oe;return ce?.edit?b.WorkspaceEdit.from(ce.edit,void 0):void 0}releaseCodeActions(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}static _isCommand(k){return typeof k.command=="string"&&typeof k.title=="string"}}C._maxCodeActionsPerFile=1e3;class W{constructor(k,B,V,q){this._proxy=k,this._documents=B,this._provider=V,this._handle=q}async prepareDocumentPaste(k,B,V,q){if(!this._provider.prepareDocumentPaste)return;const oe=this._documents.getDocument(k),ce=B.map(Ee=>b.Range.to(Ee)),J=b.DataTransfer.toDataTransfer(V,()=>{throw new S.NotImplementedError});return await this._provider.prepareDocumentPaste(oe,ce,J,q),b.DataTransfer.toDataTransferDTO(J)}async providePasteEdits(k,B,V,q,oe){const ce=this._documents.getDocument(B),J=V.map(Ne=>b.Range.to(Ne)),Ee=b.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,k,Ne)).buffer),ve=await this._provider.provideDocumentPasteEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?b.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class M{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentFormattingEdits(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideDocumentFormattingEdits(q,B,V);if(Array.isArray(oe))return oe.map(b.TextEdit.from)}}class O{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeFormattingEdits(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Range.to(B),J=await this._provider.provideDocumentRangeFormattingEdits(oe,ce,V,q);if(Array.isArray(J))return J.map(b.TextEdit.from)}}class H{constructor(k,B){this._documents=k,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,B,V,q,oe){const ce=this._documents.getDocument(k),J=b.Position.to(B),Ee=await this._provider.provideOnTypeFormattingEdits(ce,J,V,q,oe);if(Array.isArray(Ee))return Ee.map(b.TextEdit.from)}}class ${constructor(k,B){this._provider=k,this._logService=B,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,B){const V=await this._provider.provideWorkspaceSymbols(k,B);if(!(0,R.isNonEmptyArray)(V))return{symbols:[]};const q=this._cache.add(V),oe={cacheId:q,symbols:[]};for(let ce=0;ce<V.length;ce++){const J=V[ce];if(!J||!J.name){this._logService.warn("INVALID SymbolInformation",J);continue}oe.symbols.push({...b.WorkspaceSymbol.from(J),cacheId:[q,ce]})}return oe}async resolveWorkspaceSymbol(k,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const V=this._cache.get(...k.cacheId);if(V){const q=await this._provider.resolveWorkspaceSymbol(V,B);return q&&(0,D.mixin)(k,b.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(k){this._cache.delete(k)}}class z{static supportsResolving(k){return typeof k.prepareRename=="function"}constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}async provideRenameEdits(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B);try{const J=await this._provider.provideRenameEdits(oe,ce,V,q);return J?b.WorkspaceEdit.from(J):void 0}catch(J){const Ee=z._asMessage(J);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(J)}}async resolveRenameLocation(k,B,V){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(k),oe=b.Position.to(B);try{const ce=await this._provider.prepareRename(q,oe,V);let J,Ee;if(N.Range.isRange(ce)?(J=ce,Ee=q.getText(ce)):(0,E.isObject)(ce)&&(J=ce.range,Ee=ce.placeholder),!J||!Ee)return;if(J.start.line>oe.line||J.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(J),text:Ee}}catch(ce){const J=z._asMessage(ce);return J?{rejectReason:J,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class G{constructor(k,B){this.resultId=k,this.tokens=B}}class te{constructor(k,B){this._documents=k,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(k,B,V){const q=this._documents.getDocument(k),oe=B!==0?this._previousResults.get(B):null;let ce=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,oe.resultId,V):await this._provider.provideDocumentSemanticTokens(q,V);return oe&&this._previousResults.delete(B),ce?(ce=te._fixProvidedSemanticTokens(ce),this._send(te._convertToEdits(oe,ce),ce)):null}async releaseDocumentSemanticColoring(k){this._previousResults.delete(k)}static _fixProvidedSemanticTokens(k){return te._isSemanticTokens(k)?te._isCorrectSemanticTokens(k)?k:new N.SemanticTokens(new Uint32Array(k.data),k.resultId):te._isSemanticTokensEdits(k)?te._isCorrectSemanticTokensEdits(k)?k:new N.SemanticTokensEdits(k.edits.map(B=>new N.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),k.resultId):k}static _isSemanticTokens(k){return k&&!!k.data}static _isCorrectSemanticTokens(k){return k.data instanceof Uint32Array}static _isSemanticTokensEdits(k){return k&&Array.isArray(k.edits)}static _isCorrectSemanticTokensEdits(k){for(const B of k.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(k,B){if(!te._isSemanticTokens(B)||!k||!k.tokens)return B;const V=k.tokens,q=V.length,oe=B.data,ce=oe.length;let J=0;const Ee=Math.min(q,ce);for(;J<Ee&&V[J]===oe[J];)J++;if(J===q&&J===ce)return new N.SemanticTokensEdits([],B.resultId);let ve=0;const Ne=Ee-J;for(;ve<Ne&&V[q-ve-1]===oe[ce-ve-1];)ve++;return new N.SemanticTokensEdits([{start:J,deleteCount:q-J-ve,data:oe.subarray(J,ce-ve)}],B.resultId)}_send(k,B){if(te._isSemanticTokens(k)){const V=this._nextResultId++;return this._previousResults.set(V,new G(k.resultId,k.data)),(0,l.encodeSemanticTokensDto)({id:V,type:"full",data:k.data})}if(te._isSemanticTokensEdits(k)){const V=this._nextResultId++;return te._isSemanticTokens(B)?this._previousResults.set(V,new G(B.resultId,B.data)):this._previousResults.set(V,new G(k.resultId)),(0,l.encodeSemanticTokensDto)({id:V,type:"delta",deltas:(k.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}e.DocumentSemanticTokensAdapter=te;class he{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeSemanticTokens(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideDocumentRangeSemanticTokens(q,b.Range.to(B),V);return oe?this._send(oe):null}_send(k){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}e.DocumentRangeSemanticTokensAdapter=he;class re{static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}constructor(k,B,V,q,oe){this._documents=k,this._commands=B,this._provider=V,this._apiDeprecation=q,this._extension=oe,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=oe.getWordRangeAtPosition(ce)||new N.Range(ce,ce),Ee=J.with({end:ce}),ve=new v.StopWatch(!0),Ne=await this._provider.provideCompletionItems(oe,ce,q,b.CompletionContext.to(V));if(!Ne||q.isCancellationRequested)return;const ze=Array.isArray(Ne)?new N.CompletionList(Ne):Ne,Je=re.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ge=new g.DisposableStore;this._disposables.set(Je,Ge);const Pe=[],nt={x:Je,b:Pe,a:{replace:b.Range.from(J),insert:b.Range.from(Ee)},c:ze.isIncomplete||void 0,d:ve.elapsed()};for(let X=0;X<ze.items.length;X++){const Y=ze.items[X],me=this._convertCompletionItem(Y,[Je,X],Ee,J);Pe.push(me)}return nt}async resolveCompletionItem(k,B){if(typeof this._provider.resolveCompletionItem!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveCompletionItem(V,B);if(!!q)return this._convertCompletionItem(q,k)}releaseCompletionItems(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_convertCompletionItem(k,B,V,q){const oe=this._disposables.get(B[0]);if(!oe)throw Error("DisposableStore is missing...");const ce={x:B,a:k.label,b:k.kind!==void 0?b.CompletionItemKind.from(k.kind):void 0,n:k.tags&&k.tags.map(b.CompletionItemTag.from),c:k.detail,d:typeof k.documentation>"u"?void 0:b.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters,l:k.additionalTextEdits&&k.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(k.command,oe)};k.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=k.textEdit.newText):typeof k.insertText=="string"?ce.h=k.insertText:k.insertText instanceof N.SnippetString&&(ce.h=k.insertText.value,ce.i|=4);let J;return k.textEdit?J=k.textEdit.range:k.range&&(J=k.range),N.Range.isRange(J)?ce.j=b.Range.from(J):J&&(!V?.isEqual(J.inserting)||!q?.isEqual(J.replacing))&&(ce.j={insert:b.Range.from(J.inserting),replace:b.Range.from(J.replacing)}),ce}}class be{async provideInlineCompletions(k,B,V,q){}disposeCompletions(k){}handleDidShowCompletionItem(k,B){}}class le extends be{constructor(k,B,V,q){super(),this._extension=k,this._documents=B,this._provider=V,this._commands=q,this._references=new Q,this._isAdditionsProposedApiEnabled=(0,T.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,T.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:b.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=this._isAdditionsProposedApiEnabled?Array.isArray(J)?[]:J.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new g.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const nt=Je.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new g.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class fe extends be{constructor(k,B,V,q){super(),this.extension=k,this._documents=B,this._provider=V,this._commands=q,this._references=new Q,this.isAdditionProposedApiEnabled=(0,T.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=await this._provider.provideInlineCompletionItems(oe,ce,{selectedCompletionInfo:V.selectedSuggestionInfo?{range:b.Range.to(V.selectedSuggestionInfo.range),text:V.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[V.triggerKind]},q);if(!J||q.isCancellationRequested)return;const Ee=Array.isArray(J)?J:J.items,ve=Array.isArray(J)?[]:J.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:Ee}),items:Ee.map((Je,Ge)=>{let Pe;Je.command&&(Ne||(Ne=new g.DisposableStore),Pe=this._commands.toInternal(Je.command,Ne));const nt=Je.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Je.filterText,range:Je.range?b.Range.from(Je.range):void 0,command:Pe,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Je.completeBracketPairs:!1}}),commands:ve.map(Je=>(Ne||(Ne=new g.DisposableStore),this._commands.toInternal(Je,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const V=this._references.get(k)?.items[B];V&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(V)}}class Q{constructor(){this._references=new Map,this._idPool=1}createReferenceId(k){const B=this._idPool++;return this._references.set(B,k),B}disposeReferenceId(k){const B=this._references.get(k);return this._references.delete(k),B}get(k){return this._references.get(k)}}class pe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(k,B,V,q){const oe=this._documents.getDocument(k),ce=b.Position.to(B),J=this.reviveContext(V),Ee=await this._provider.provideSignatureHelp(oe,ce,q,J);if(Ee){const ve=this._cache.add([Ee]);return{...b.SignatureHelp.from(Ee),id:ve}}}reviveContext(k){let B;if(k.activeSignatureHelp){const V=b.SignatureHelp.to(k.activeSignatureHelp),q=this._cache.get(k.activeSignatureHelp.id,0);q?(B=q,B.activeSignature=V.activeSignature,B.activeParameter=V.activeParameter):B=V}return{...k,activeSignatureHelp:B}}releaseSignatureHelp(k){this._cache.delete(k)}}class Se{constructor(k,B,V,q,oe){this._documents=k,this._commands=B,this._provider=V,this._logService=q,this._extension=oe,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(k,B,V){const q=this._documents.getDocument(k),oe=b.Range.to(B),ce=await this._provider.provideInlayHints(q,oe,V);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(V.isCancellationRequested)return;const J=this._cache.add(ce);this._disposables.set(J,new g.DisposableStore);const Ee={hints:[],cacheId:J};for(let ve=0;ve<ce.length;ve++)this._isValidInlayHint(ce[ve],oe)&&Ee.hints.push(this._convertInlayHint(ce[ve],[J,ve]));return this._logService.trace(`[InlayHints] ${Ee.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),Ee}async resolveInlayHint(k,B){if(typeof this._provider.resolveInlayHint!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveInlayHint(V,B);if(!!q&&!!this._isValidInlayHint(q))return this._convertInlayHint(q,k)}releaseHints(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_isValidInlayHint(k,B){return k.label.length===0||Array.isArray(k.label)&&k.label.every(V=>V.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(B&&!B.contains(k.position))}_convertInlayHint(k,B){const V=this._disposables.get(B[0]);if(!V)throw Error("DisposableStore is missing...");const q={label:"",cacheId:B,tooltip:b.MarkdownString.fromStrict(k.tooltip),position:b.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(b.TextEdit.from),kind:k.kind&&b.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?q.label=k.label:q.label=k.label.map(oe=>{const ce={label:oe.value};return ce.tooltip=b.MarkdownString.fromStrict(oe.tooltip),N.Location.isLocation(oe.location)&&(ce.location=b.location.from(oe.location)),oe.command&&(ce.command=this._commands.toInternal(oe.command,V)),ce}),q}}class Fe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new f.Cache("DocumentLink")}async provideLinks(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentLinks(V,B);if(!(!Array.isArray(q)||q.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Fe._validateLink).map(b.DocumentLink.from)};{const oe=this._cache.add(q),ce={links:[],cacheId:oe};for(let J=0;J<q.length;J++){if(!Fe._validateLink(q[J]))continue;const Ee=b.DocumentLink.from(q[J]);Ee.cacheId=[oe,J],ce.links.push(Ee)}return ce}}}static _validateLink(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,B){if(typeof this._provider.resolveDocumentLink!="function")return;const V=this._cache.get(...k);if(!V)return;const q=await this._provider.resolveDocumentLink(V,B);if(!(!q||!Fe._validateLink(q)))return b.DocumentLink.from(q)}releaseLinks(k){this._cache.delete(k)}}class Ue{constructor(k,B){this._documents=k,this._provider=B}async provideColors(k,B){const V=this._documents.getDocument(k),q=await this._provider.provideDocumentColors(V,B);return Array.isArray(q)?q.map(ce=>({color:b.Color.from(ce.color),range:b.Range.from(ce.range)})):[]}async provideColorPresentations(k,B,V){const q=this._documents.getDocument(k),oe=b.Range.to(B.range),ce=b.Color.to(B.color),J=await this._provider.provideColorPresentations(ce,{document:q,range:oe},V);if(!!Array.isArray(J))return J.map(b.ColorPresentation.from)}}class Xe{constructor(k,B){this._documents=k,this._provider=B}async provideFoldingRanges(k,B,V){const q=this._documents.getDocument(k),oe=await this._provider.provideFoldingRanges(q,B,V);if(!!Array.isArray(oe))return oe.map(b.FoldingRange.from)}}class ke{constructor(k,B,V){this._documents=k,this._provider=B,this._logService=V}async provideSelectionRanges(k,B,V){const q=this._documents.getDocument(k),oe=B.map(b.Position.to),ce=await this._provider.provideSelectionRanges(q,oe,V);if(!(0,R.isNonEmptyArray)(ce))return[];if(ce.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const J=[];for(let Ee=0;Ee<oe.length;Ee++){const ve=[];J.push(ve);let Ne=oe[Ee],ze=ce[Ee];for(;;){if(!ze.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(b.SelectionRange.from(ze)),!ze.parent)break;Ne=ze.range,ze=ze.parent}}return J}}class ye{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.prepareCallHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideCallsTo(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(q,V);if(!!oe)return oe.map(ce=>({from:this._cacheAndConvertItem(k,ce.from),fromRanges:ce.fromRanges.map(J=>b.Range.from(J))}))}async provideCallsFrom(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(q,V);if(!!oe)return oe.map(ce=>({to:this._cacheAndConvertItem(k,ce.to),fromRanges:ce.fromRanges.map(J=>b.Range.from(J))}))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),q=b.CallHierarchyItem.from(B,k,V.size.toString(36));return V.set(q._itemId,B),q}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class De{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,V){const q=this._documents.getDocument(k),oe=b.Position.to(B),ce=await this._provider.prepareTypeHierarchy(q,oe,V);if(!ce)return;const J=this._idPool.nextId();return this._cache.set(J,new Map),Array.isArray(ce)?ce.map(Ee=>this._cacheAndConvertItem(J,Ee)):[this._cacheAndConvertItem(J,ce)]}async provideSupertypes(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(k,ce))}async provideSubtypes(k,B,V){const q=this._itemFromCache(k,B);if(!q)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(q,V);if(!!oe)return oe.map(ce=>this._cacheAndConvertItem(k,ce))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const V=this._cache.get(k),q=b.TypeHierarchyItem.from(B,k,V.size.toString(36));return V.set(q._itemId,B),q}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class ae{constructor(k,B,V,q){this._proxy=k,this._documents=B,this._provider=V,this._handle=q}async provideDocumentOnDropEdits(k,B,V,q,oe){const ce=this._documents.getDocument(B),J=b.Position.to(V),Ee=b.DataTransfer.toDataTransfer(q,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),ve=await this._provider.provideDocumentDropEdits(ce,J,Ee,oe);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?b.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class ue{constructor(k,B){this.adapter=k,this.extension=B}}class ee{constructor(k,B,V,q,oe,ce,J,Ee){this._uriTransformer=B,this._documents=V,this._commands=q,this._diagnostics=oe,this._logService=ce,this._apiDeprecation=J,this._extensionTelemetry=Ee,this._adapter=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(k){return b.DocumentSelector.from(k,this._uriTransformer)}_createDisposable(k){return new N.Disposable(()=>{this._adapter.delete(k),this._proxy.$unregister(k)})}_nextHandle(){return ee._handlePool++}async _withAdapter(k,B,V,q,oe,ce=!1){const J=this._adapter.get(k);if(!J||!(J.adapter instanceof B))return q;const Ee=Date.now();ce||this._logService.trace(`[${J.extension.identifier.value}] INVOKE provider '${V.toString().replace(/[\r\n]/g,"")}'`);const ve=V(J.adapter,J.extension);return Promise.resolve(ve).catch(Ne=>{(0,S.isCancellationError)(Ne)||(this._logService.error(`[${J.extension.identifier.value}] provider FAILED`),this._logService.error(Ne),this._extensionTelemetry.onExtensionError(J.extension.identifier,Ne))}).finally(()=>{ce||this._logService.trace(`[${J.extension.identifier.value}] provider DONE after ${Date.now()-Ee}ms`)}),I.CancellationToken.isCancellationToken(oe)?(0,h.raceCancellationError)(ve,oe):ve}_addNewAdapter(k,B){const V=this._nextHandle();return this._adapter.set(V,new ue(k,B)),V}static _extLabel(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,B,V,q){const oe=this._addNewAdapter(new s(this._documents,V),k),ce=q&&q.label||ee._extLabel(k);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(B),ce),this._createDisposable(oe)}$provideDocumentSymbols(k,B,V){return this._withAdapter(k,s,q=>q.provideDocumentSymbols(r.URI.revive(B),V),void 0,V)}registerCodeLensProvider(k,B,V){const q=this._nextHandle(),oe=typeof V.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new u(this._documents,this._commands.converter,V),k)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(B),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(oe));ce=N.Disposable.from(ce,J)}return ce}$provideCodeLenses(k,B,V){return this._withAdapter(k,u,q=>q.provideCodeLenses(r.URI.revive(B),V),void 0,V)}$resolveCodeLens(k,B,V){return this._withAdapter(k,u,q=>q.resolveCodeLens(B,V),void 0,void 0)}$releaseCodeLenses(k,B){this._withAdapter(k,u,V=>Promise.resolve(V.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(k,B,V){const q=this._addNewAdapter(new i(this._documents,V),k);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDefinition(k,B,V,q){return this._withAdapter(k,i,oe=>oe.provideDefinition(r.URI.revive(B),V,q),[],q)}registerDeclarationProvider(k,B,V){const q=this._addNewAdapter(new o(this._documents,V),k);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDeclaration(k,B,V,q){return this._withAdapter(k,o,oe=>oe.provideDeclaration(r.URI.revive(B),V,q),[],q)}registerImplementationProvider(k,B,V){const q=this._addNewAdapter(new a(this._documents,V),k);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideImplementation(k,B,V,q){return this._withAdapter(k,a,oe=>oe.provideImplementation(r.URI.revive(B),V,q),[],q)}registerTypeDefinitionProvider(k,B,V){const q=this._addNewAdapter(new t(this._documents,V),k);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideTypeDefinition(k,B,V,q){return this._withAdapter(k,t,oe=>oe.provideTypeDefinition(r.URI.revive(B),V,q),[],q)}registerHoverProvider(k,B,V,q){const oe=this._addNewAdapter(new d(this._documents,V),k);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideHover(k,B,V,q){return this._withAdapter(k,d,oe=>oe.provideHover(r.URI.revive(B),V,q),void 0,q)}registerEvaluatableExpressionProvider(k,B,V,q){const oe=this._addNewAdapter(new p(this._documents,V),k);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideEvaluatableExpression(k,B,V,q){return this._withAdapter(k,p,oe=>oe.provideEvaluatableExpression(r.URI.revive(B),V,q),void 0,q)}registerInlineValuesProvider(k,B,V,q){const oe=typeof V.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new w(this._documents,V),k);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(B),oe);let J=this._createDisposable(ce);if(oe!==void 0){const Ee=V.onDidChangeInlineValues(ve=>this._proxy.$emitInlineValuesEvent(oe));J=N.Disposable.from(J,Ee)}return J}$provideInlineValues(k,B,V,q,oe){return this._withAdapter(k,w,ce=>ce.provideInlineValues(r.URI.revive(B),V,q,oe),void 0,oe)}registerDocumentHighlightProvider(k,B,V){const q=this._addNewAdapter(new F(this._documents,V),k);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentHighlights(k,B,V,q){return this._withAdapter(k,F,oe=>oe.provideDocumentHighlights(r.URI.revive(B),V,q),void 0,q)}registerLinkedEditingRangeProvider(k,B,V){const q=this._addNewAdapter(new j(this._documents,V),k);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideLinkedEditingRanges(k,B,V,q){return this._withAdapter(k,j,async oe=>{const ce=await oe.provideLinkedEditingRanges(r.URI.revive(B),V,q);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ee._serializeRegExp(ce.wordPattern):void 0}},void 0,q)}registerReferenceProvider(k,B,V){const q=this._addNewAdapter(new U(this._documents,V),k);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideReferences(k,B,V,q,oe){return this._withAdapter(k,U,ce=>ce.provideReferences(r.URI.revive(B),V,q,oe),void 0,oe)}registerCodeActionProvider(k,B,V,q){const oe=new g.DisposableStore,ce=this._addNewAdapter(new C(this._documents,this._commands.converter,this._diagnostics,V,this._logService,k,this._apiDeprecation),k);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(B),{providedKinds:q?.providedCodeActionKinds?.map(J=>J.value),documentation:q?.documentation?.map(J=>({kind:J.kind.value,command:this._commands.converter.toInternal(J.command,oe)}))},ee._extLabel(k),Boolean(V.resolveCodeAction)),oe.add(this._createDisposable(ce)),oe}$provideCodeActions(k,B,V,q,oe){return this._withAdapter(k,C,ce=>ce.provideCodeActions(r.URI.revive(B),V,q,oe),void 0,oe)}$resolveCodeAction(k,B,V){return this._withAdapter(k,C,q=>q.resolveCodeAction(B,V),void 0,void 0)}$releaseCodeActions(k,B){this._withAdapter(k,C,V=>Promise.resolve(V.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(k,B,V){const q=this._addNewAdapter(new M(this._documents,V),k);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(q)}$provideDocumentFormattingEdits(k,B,V,q){return this._withAdapter(k,M,oe=>oe.provideDocumentFormattingEdits(r.URI.revive(B),V,q),void 0,q)}registerDocumentRangeFormattingEditProvider(k,B,V){const q=this._addNewAdapter(new O(this._documents,V),k);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(k,B,V,q,oe){return this._withAdapter(k,O,ce=>ce.provideDocumentRangeFormattingEdits(r.URI.revive(B),V,q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(k,B,V,q){const oe=this._addNewAdapter(new H(this._documents,V),k);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(B),q,k.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(k,B,V,q,oe,ce){return this._withAdapter(k,H,J=>J.provideOnTypeFormattingEdits(r.URI.revive(B),V,q,oe,ce),void 0,ce)}registerWorkspaceSymbolProvider(k,B){const V=this._addNewAdapter(new $(B,this._logService),k);return this._proxy.$registerNavigateTypeSupport(V,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(V)}$provideWorkspaceSymbols(k,B,V){return this._withAdapter(k,$,q=>q.provideWorkspaceSymbols(B,V),{symbols:[]},V)}$resolveWorkspaceSymbol(k,B,V){return this._withAdapter(k,$,q=>q.resolveWorkspaceSymbol(B,V),void 0,void 0)}$releaseWorkspaceSymbols(k,B){this._withAdapter(k,$,V=>V.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(k,B,V){const q=this._addNewAdapter(new z(this._documents,V,this._logService),k);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(B),z.supportsResolving(V)),this._createDisposable(q)}$provideRenameEdits(k,B,V,q,oe){return this._withAdapter(k,z,ce=>ce.provideRenameEdits(r.URI.revive(B),V,q,oe),void 0,oe)}$resolveRenameLocation(k,B,V,q){return this._withAdapter(k,z,oe=>oe.resolveRenameLocation(r.URI.revive(B),V,q),void 0,q)}registerDocumentSemanticTokensProvider(k,B,V,q){const oe=this._addNewAdapter(new te(this._documents,V),k),ce=typeof V.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(B),q,ce);let J=this._createDisposable(oe);if(ce){const Ee=V.onDidChangeSemanticTokens(ve=>this._proxy.$emitDocumentSemanticTokensEvent(ce));J=N.Disposable.from(J,Ee)}return J}$provideDocumentSemanticTokens(k,B,V,q){return this._withAdapter(k,te,oe=>oe.provideDocumentSemanticTokens(r.URI.revive(B),V,q),null,q)}$releaseDocumentSemanticTokens(k,B){this._withAdapter(k,te,V=>V.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,B,V,q){const oe=this._addNewAdapter(new he(this._documents,V),k);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(B),q),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(k,B,V,q){return this._withAdapter(k,he,oe=>oe.provideDocumentRangeSemanticTokens(r.URI.revive(B),V,q),null,q)}registerCompletionItemProvider(k,B,V,q){const oe=this._addNewAdapter(new re(this._documents,this._commands.converter,V,this._apiDeprecation,k),k);return this._proxy.$registerCompletionsProvider(oe,this._transformDocumentSelector(B),q,re.supportsResolving(V),`${k.identifier.value}(${q.join("")})`),this._createDisposable(oe)}$provideCompletionItems(k,B,V,q,oe){return this._withAdapter(k,re,ce=>ce.provideCompletionItems(r.URI.revive(B),V,q,oe),void 0,oe)}$resolveCompletionItem(k,B,V){return this._withAdapter(k,re,q=>q.resolveCompletionItem(B,V),void 0,V)}$releaseCompletionItems(k,B){this._withAdapter(k,re,V=>V.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(k,B,V){const q=new le(k,this._documents,V,this._commands.converter),oe=this._addNewAdapter(q,k);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(B),q.supportsHandleDidShowCompletionItem),this._createDisposable(oe)}registerInlineCompletionsProviderNew(k,B,V){const q=this._addNewAdapter(new fe(k,this._documents,V,this._commands.converter),k);return this._proxy.$registerInlineCompletionsSupport(q,this._transformDocumentSelector(B),!0),this._createDisposable(q)}$provideInlineCompletions(k,B,V,q,oe){return this._withAdapter(k,be,ce=>ce.provideInlineCompletions(r.URI.revive(B),V,q,oe),void 0,oe)}$handleInlineCompletionDidShow(k,B,V){this._withAdapter(k,be,async q=>{q.handleDidShowCompletionItem(B,V)},void 0,void 0)}$freeInlineCompletionsList(k,B){this._withAdapter(k,be,async V=>{V.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(k,B,V,q){const oe=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ce=this._addNewAdapter(new pe(this._documents,V),k);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(B),oe),this._createDisposable(ce)}$provideSignatureHelp(k,B,V,q,oe){return this._withAdapter(k,pe,ce=>ce.provideSignatureHelp(r.URI.revive(B),V,q,oe),void 0,oe)}$releaseSignatureHelp(k,B){this._withAdapter(k,pe,V=>V.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(k,B,V){const q=typeof V.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new Se(this._documents,this._commands.converter,V,this._logService,k),k);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(B),typeof V.resolveInlayHint=="function",q,ee._extLabel(k));let ce=this._createDisposable(oe);if(q!==void 0){const J=V.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(q));ce=N.Disposable.from(ce,J)}return ce}$provideInlayHints(k,B,V,q){return this._withAdapter(k,Se,oe=>oe.provideInlayHints(r.URI.revive(B),V,q),void 0,q)}$resolveInlayHint(k,B,V){return this._withAdapter(k,Se,q=>q.resolveInlayHint(B,V),void 0,V)}$releaseInlayHints(k,B){this._withAdapter(k,Se,V=>V.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(k,B,V){const q=this._addNewAdapter(new Fe(this._documents,V),k);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(B),typeof V.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(k,B,V){return this._withAdapter(k,Fe,q=>q.provideLinks(r.URI.revive(B),V),void 0,V,B.scheme==="output")}$resolveDocumentLink(k,B,V){return this._withAdapter(k,Fe,q=>q.resolveLink(B,V),void 0,void 0,!0)}$releaseDocumentLinks(k,B){this._withAdapter(k,Fe,V=>V.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(k,B,V){const q=this._addNewAdapter(new Ue(this._documents,V),k);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentColors(k,B,V){return this._withAdapter(k,Ue,q=>q.provideColors(r.URI.revive(B),V),[],V)}$provideColorPresentations(k,B,V,q){return this._withAdapter(k,Ue,oe=>oe.provideColorPresentations(r.URI.revive(B),V,q),void 0,q)}registerFoldingRangeProvider(k,B,V){const q=this._nextHandle(),oe=typeof V.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new ue(new Xe(this._documents,V),k)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(B),oe);let ce=this._createDisposable(q);if(oe!==void 0){const J=V.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));ce=N.Disposable.from(ce,J)}return ce}$provideFoldingRanges(k,B,V,q){return this._withAdapter(k,Xe,oe=>oe.provideFoldingRanges(r.URI.revive(B),V,q),void 0,q)}registerSelectionRangeProvider(k,B,V){const q=this._addNewAdapter(new ke(this._documents,V,this._logService),k);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideSelectionRanges(k,B,V,q){return this._withAdapter(k,ke,oe=>oe.provideSelectionRanges(r.URI.revive(B),V,q),[],q)}registerCallHierarchyProvider(k,B,V){const q=this._addNewAdapter(new ye(this._documents,V),k);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$prepareCallHierarchy(k,B,V,q){return this._withAdapter(k,ye,oe=>Promise.resolve(oe.prepareSession(r.URI.revive(B),V,q)),void 0,q)}$provideCallHierarchyIncomingCalls(k,B,V,q){return this._withAdapter(k,ye,oe=>oe.provideCallsTo(B,V,q),void 0,q)}$provideCallHierarchyOutgoingCalls(k,B,V,q){return this._withAdapter(k,ye,oe=>oe.provideCallsFrom(B,V,q),void 0,q)}$releaseCallHierarchy(k,B){this._withAdapter(k,ye,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(k,B,V){const q=this._addNewAdapter(new De(this._documents,V),k);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$prepareTypeHierarchy(k,B,V,q){return this._withAdapter(k,De,oe=>Promise.resolve(oe.prepareSession(r.URI.revive(B),V,q)),void 0,q)}$provideTypeHierarchySupertypes(k,B,V,q){return this._withAdapter(k,De,oe=>oe.provideSupertypes(B,V,q),void 0,q)}$provideTypeHierarchySubtypes(k,B,V,q){return this._withAdapter(k,De,oe=>oe.provideSubtypes(B,V,q),void 0,q)}$releaseTypeHierarchy(k,B){this._withAdapter(k,De,V=>Promise.resolve(V.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(k,B,V){const q=this._nextHandle();return this._adapter.set(q,new ue(new ae(this._proxy,this._documents,V,q),k)),this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(B)),this._createDisposable(q)}$provideDocumentOnDropEdits(k,B,V,q,oe,ce){return this._withAdapter(k,ae,J=>Promise.resolve(J.provideDocumentOnDropEdits(B,r.URI.revive(V),q,oe,ce)),void 0,void 0)}registerDocumentPasteEditProvider(k,B,V,q){const oe=this._nextHandle();return this._adapter.set(oe,new ue(new W(this._proxy,this._documents,V,oe),k)),this._proxy.$registerPasteEditProvider(oe,this._transformDocumentSelector(B),!!V.prepareDocumentPaste,q.pasteMimeTypes),this._createDisposable(oe)}$prepareDocumentPaste(k,B,V,q,oe){return this._withAdapter(k,W,ce=>ce.prepareDocumentPaste(r.URI.revive(B),V,q,oe),void 0,oe)}$providePasteEdits(k,B,V,q,oe,ce){return this._withAdapter(k,W,J=>J.providePasteEdits(B,r.URI.revive(V),q,oe,ce),void 0,ce)}static _serializeRegExp(k){return{pattern:k.source,flags:(0,y.regExpFlags)(k)}}static _serializeIndentationRule(k){return{decreaseIndentPattern:ee._serializeRegExp(k.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?ee._serializeRegExp(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?ee._serializeRegExp(k.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(k){return{beforeText:ee._serializeRegExp(k.beforeText),afterText:k.afterText?ee._serializeRegExp(k.afterText):void 0,previousLineText:k.previousLineText?ee._serializeRegExp(k.previousLineText):void 0,action:k.action}}static _serializeOnEnterRules(k){return k.map(ee._serializeOnEnterRule)}setLanguageConfiguration(k,B,V){const{wordPattern:q}=V;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(B,q):this._documents.setWordDefinitionFor(B,void 0),V.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),V.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const oe=this._nextHandle(),ce={comments:V.comments,brackets:V.brackets,wordPattern:V.wordPattern?ee._serializeRegExp(V.wordPattern):void 0,indentationRules:V.indentationRules?ee._serializeIndentationRule(V.indentationRules):void 0,onEnterRules:V.onEnterRules?ee._serializeOnEnterRules(V.onEnterRules):void 0,__electricCharacterSupport:V.__electricCharacterSupport,__characterPairSupport:V.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,B,ce),this._createDisposable(oe)}$setWordDefinitions(k){for(const B of k)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(Ie[208],Ce([1,0,5,8,6,29,15,7]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(R,E,m,I){this._documents=E,this._commands=m,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,E){await this._proxy.$changeLanguage(R,E);const m=this._documents.getDocumentData(R);if(!m)throw new Error(`document '${R.toString()}' NOT found`);return m.document}async tokenAtPosition(R,E){const m=R.version,I=D.Position.from(E),g=await this._proxy.$tokensAtPosition(R.uri,I),l={type:b.StandardTokenType.Other,range:R.getWordRangeAtPosition(E)??new b.Range(E.line,E.character,E.line,E.character)};if(!g)return l;const c={range:D.Range.to(g.range),type:D.TokenType.to(g.type)};return!c.range.contains(E)||m!==R.version?l:c}createLanguageStatusItem(R,E,m){const I=this._handlePool++,g=this._proxy,l=this._ids,c=`${R.identifier.value}/${E}`;if(l.has(c))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);l.add(c);const f={selector:m,id:E,name:R.displayName??R.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const S=new A.DisposableStore,h=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{S.clear(),this._proxy.$setLanguageStatus(I,{id:c,name:f.name??R.displayName??R.name,source:R.displayName??R.name,selector:D.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===b.LanguageStatusSeverity.Error?N.default.Error:f.severity===b.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:f.command&&this._commands.toInternal(f.command,S),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},T={dispose(){S.dispose(),v?.dispose(),g.$removeLanguageStatus(I),l.delete(c)},get id(){return f.id},get name(){return f.name},set name(s){f.name=s,h()},get selector(){return f.selector},set selector(s){f.selector=s,h()},get text(){return f.text},set text(s){f.text=s,h()},get detail(){return f.detail},set detail(s){f.detail=s,h()},get severity(){return f.severity},set severity(s){f.severity=s,h()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(s){f.accessibilityInformation=s,h()},get command(){return f.command},set command(s){f.command=s,h()},get busy(){return f.busy},set busy(s){f.busy=s,h()}};return h(),T}}e.ExtHostLanguages=y}),define(Ie[71],Ce([1,0,20,10,2,3,11,5,27,14]),function(ne,e,r,D,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(m,I,g){this.logService=g,this.bundleCache=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=m.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===r.LANGUAGE_DEFAULT}getMessage(m,I){const{message:g,args:l,comment:c}=I;if(this.isDefaultLanguage)return(0,D.format2)(g,l??{});let f=g;c&&c.length>0&&(f+=`/${Array.isArray(c)?c.join():c}`);const v=this.bundleCache.get(m)?.contents[f];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,D.format2)(v??f,l??{})}getBundle(m){return this.bundleCache.get(m)?.contents}getBundleUri(m){return this.bundleCache.get(m)?.uri}async initializeLocalizedMessages(m){if(this.isDefaultLanguage||!m.l10n&&!m.isBuiltin||this.bundleCache.has(m.identifier.value))return;let I;const g=await this.getBundleLocation(m);if(!g){this.logService.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this._proxy.$fetchBundleContents(g),c=JSON.parse(l);I=m.isBuiltin?c.contents?.bundle:c}catch(l){this.logService.error(`Failed to load translations for ${m.identifier.value} from ${g}: ${l.message}`);return}I&&this.bundleCache.set(m.identifier.value,{contents:I,uri:g})}async getBundleLocation(m){if(m.isBuiltin){const I=await this._proxy.$fetchBuiltInBundleUri(m.identifier.value);return b.URI.revive(I)}return m.l10n?b.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};R=xe([$e(0,y.IExtHostInitDataService),$e(1,P.IExtHostRpcService),$e(2,_.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Ie[209],Ce([1,0,11,5,27,14,2,4,9]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends r.AbstractLoggerService{constructor(m,I){super(I.logLevel,A.Event.None),this._proxy=m.getProxy(D.MainContext.MainThreadLogger)}$setLevel(m,I){I?this.setLevel(_.URI.revive(I),m):(0,y.isUndefined)(m)||this.setLevel(m)}doCreateLogger(m,I,g){return new R(this._proxy,m,I,g)}};P=xe([$e(0,N.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class R extends r.AbstractMessageLogger{constructor(m,I,g,l){super(l?.always),this.proxy=m,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.proxy.$createLogger(I,l).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,I){const g=[[m,I]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(m){this.proxy.$log(this.file,m)}}}),define(Ie[210],Ce([1,0,5,11,28]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(A){return A&&A.title}let _=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(r.MainContext.MainThreadMessageService)}showMessage(y,P,R,E,m){const I={source:{identifier:y.identifier,label:y.displayName||y.name}};let g;typeof E=="string"||N(E)?g=[E,...m]:(I.modal=E?.modal,I.useCustom=E?.useCustom,I.detail=E?.detail,g=m),I.useCustom&&(0,b.checkProposedApiEnabled)(y,"resolvers");const l=[];for(let c=0;c<g.length;c++){const f=g[c];if(typeof f=="string")l.push({title:f,handle:c,isCloseAffordance:!1});else if(typeof f=="object"){const{title:v,isCloseAffordance:S}=f;l.push({title:v,isCloseAffordance:!!S,handle:c})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(P,R,I,l).then(c=>{if(typeof c=="number")return g[c]})}};_=xe([$e(1,D.ILogService)],_),e.ExtHostMessageService=_}),define(Ie[211],Ce([1,0,23,4,7,24,10,9,2,62,5,37,8,6,42,183,94]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(S=>S.apiEditor)}constructor(S,h,T,s){this._textDocumentsAndEditors=T,this._textDocuments=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new N.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=S.getProxy(R.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=S.getProxy(R.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=S.getProxy(R.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const n=u.notebookEditor?.notebookUri,i=u.cell.handle,a=this._documents.get(n)?.getCell(i);if(a)return a.apiCell}if(u&&u.$mid===13){const n=u.uri,i=this._documents.get(n);if(i)return i.apiNotebook}return u}}),f._registerApiCommands(h)}getEditorById(S){const h=this._editors.get(S);if(!h)throw new Error(`unknown text editor: ${S}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(S){for(const[h,T]of this._editors)if(T.apiEditor===S)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(S,h){const T=this._documents.get(S);if(!T&&!h)throw new Error(`NO notebook document for '${S}'`);return T}_getProviderData(S){const h=this._notebookContentProviders.get(S);if(!h)throw new Error(`NO provider for '${S}'`);return h}registerNotebookContentProvider(S,h,T,s,u){if((0,_.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);return this._notebookContentProviders.set(h,{extension:S,provider:T}),this._notebookProxy.$registerNotebookProvider({id:S.identifier,location:S.extensionLocation},h,m.NotebookDocumentContentOptions.from(s),f._convertNotebookRegistrationData(S,u)),new I.Disposable(()=>{this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(S,h){if(!h)return;const T=h.filenamePattern.map(s=>m.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(h.filenamePattern&&!T){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:h.displayName,filenamePattern:T,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,h,T){const s=f._notebookStatusBarItemProviderHandlePool++,u=typeof T.onDidChangeCellStatusBarItems=="function"?f._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,T),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,u,h);let n;return u!==void 0&&(n=T.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(u))),new I.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,u),n?.dispose()})}async createNotebookDocument(S){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:S.viewType,content:S.content&&m.NotebookData.from(S.content)});return y.URI.revive(h)}async openNotebookDocument(S){const h=this._documents.get(S);if(h)return h.apiNotebook;const T=await this._notebookDocumentsProxy.$tryOpenNotebook(S),s=this._documents.get(y.URI.revive(T));return(0,A.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(S,h){y.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let T;typeof h=="object"?T={position:m.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(m.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:T={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(S.uri,S.notebookType,T),u=s&&this._editors.get(s)?.apiEditor;if(u)return u;throw s?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,h,T,s){const u=this._notebookStatusBarItemProviders.get(S),n=y.URI.revive(h),i=this._documents.get(n);if(!i||!u)return;const o=i.getCellFromIndex(T);if(!o)return;const a=await u.provideCellStatusBarItems(o.apiCell,s);if(!a)return;const t=new b.DisposableStore,d=this._statusBarCache.add([t]),w=(Array.isArray(a)?a:[a]).map(F=>m.NotebookStatusBarItem.from(F,this._commandsConverter,t));return{cacheId:d,items:w}}$releaseNotebookCellStatusBarItems(S){this._statusBarCache.delete(S)}registerNotebookSerializer(S,h,T,s,u){if((0,_.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,T),this._notebookProxy.$registerNotebookSerializer(n,{id:S.identifier,location:S.extensionLocation},h,m.NotebookDocumentContentOptions.from(s),f._convertNotebookRegistrationData(S,u)),(0,b.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(S,h,T){const s=this._notebookSerializer.get(S);if(!s)throw new Error("NO serializer found");const u=await s.deserializeNotebook(h.buffer,T);return new g.SerializableObjectWithBuffers(m.NotebookData.from(u))}async $notebookToData(S,h,T){const s=this._notebookSerializer.get(S);if(!s)throw new Error("NO serializer found");const u=await s.serializeNotebook(m.NotebookData.to(h.value),T);return r.VSBuffer.wrap(u)}async $openNotebook(S,h,T,s,u){const{provider:n}=this._getProviderData(S),i=await n.openNotebook(y.URI.revive(h),{backupId:T,untitledDocumentData:s?.buffer},u);return new g.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(m.NotebookCellData.from)})}_createExtHostEditor(S,h,T){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const s=new c.ExtHostNotebookEditor(h,this._notebookEditorsProxy,S,T.visibleRanges.map(m.NotebookRange.to),T.selections.map(m.NotebookRange.to),typeof T.viewColumn=="number"?m.ViewColumn.to(T.viewColumn):void 0);this._editors.set(h,s)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const T of S.value.removedDocuments){const s=y.URI.revive(T),u=this._documents.get(s);u&&(u.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===s.toString()&&this._editors.delete(n.id)}if(S.value.addedDocuments){const T=[];for(const s of S.value.addedDocuments){const u=y.URI.revive(s.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const n=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,s);T.push(...s.cells.map(i=>l.ExtHostCell.asModelAddData(n.apiNotebook,i))),this._documents.get(u)?.dispose(),this._documents.set(u,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:T}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(S.value.addedEditors)for(const T of S.value.addedEditors){if(this._editors.has(T.id))return;const s=y.URI.revive(T.documentUri),u=this._documents.get(s);u&&this._createExtHostEditor(u,T.id,T)}const h=[];if(S.value.removedEditors)for(const T of S.value.removedEditors){const s=this._editors.get(T);s&&(this._editors.delete(T),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),h.push(s))}if(S.value.visibleEditors){this._visibleNotebookEditors=S.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const T=new Set;this._visibleNotebookEditors.forEach(s=>T.add(s.id));for(const s of this._editors.values()){const u=T.has(s.id);s._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this._activeNotebookEditor=void 0:S.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(S){const h=E.ApiCommandArgument.String.with("notebookType","A notebook type"),T=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new E.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>r.VSBuffer.wrap(u))],new E.ApiCommandResult("Notebook Data",u=>m.NotebookData.to(u.value))),s=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new g.SerializableObjectWithBuffers(m.NotebookData.from(u)))],new E.ApiCommandResult("Bytes",u=>u.buffer));S.registerApiCommand(T),S.registerApiCommand(s)}}e.ExtHostNotebookController=f,f._notebookStatusBarItemProviderHandlePool=0}),define(Ie[212],Ce([1,0,18,15,21,4,7,24,2,26,11,5,37,8,6,64,171,28,42]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(i,o,a,t,d){this._initData=o,this._extHostNotebook=a,this._commands=t,this._logService=d,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(E.MainContext.MainThreadNotebookKernels);const p=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const F=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:F}}else if(w&&"notebookEditor"in w){const F=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:F}}return w})],m.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(i,o,a,t,d,p){for(const re of this._kernelData.values())if(re.controller.id===o&&P.ExtensionIdentifier.equals(i.identifier,re.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const w=this._handlePool++,F=this;this._logService.trace(`NotebookController[${w}], CREATED by ${i.identifier.value}, ${o}`);const j=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${i.identifier}'`);let U=!1;const C=new _.DisposableStore,W=new N.Emitter,M=new N.Emitter,O={id:u(i.identifier,o),notebookType:a,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:t||i.identifier.value,preloads:p?p.map(I.NotebookRendererScript.from):[]};let H=d??j,$;this._proxy.$addKernel(w,O).catch(re=>{console.log(re),U=!0});let z=0;const G=()=>{if(U)return;const re=++z;Promise.resolve().then(()=>{re===z&&this._proxy.$updateKernel(w,O)})},te=new A.ResourceMap,he={get id(){return o},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return O.label},set label(re){O.label=re??i.displayName??i.name,G()},get detail(){return O.detail??""},set detail(re){O.detail=re,G()},get description(){return O.description??""},set description(re){O.description=re,G()},get kind(){return(0,f.checkProposedApiEnabled)(i,"notebookControllerKind"),O.kind??""},set kind(re){(0,f.checkProposedApiEnabled)(i,"notebookControllerKind"),O.kind=re,G()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(re){O.supportedLanguages=re,G()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(re){O.supportsExecutionOrder=re,G()},get rendererScripts(){return O.preloads?O.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(re){H=re??j},get interruptHandler(){return $},set interruptHandler(re){$=re,O.supportsInterrupt=Boolean(re),G()},createNotebookCellExecution(re){if(U)throw new Error("notebook controller is DISPOSED");if(!te.has(re.notebook.uri))throw F._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(te.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return F._createNotebookCellExecution(re,u(i.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${w}], DISPOSED`),U=!0,this._kernelData.delete(w),C.dispose(),W.dispose(),M.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(re,be){be===g.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(i,"notebookControllerAffinityHidden"),F._proxy.$updateNotebookPriority(w,re.uri,be)},onDidReceiveMessage:M.event,postMessage(re,be){return(0,f.checkProposedApiEnabled)(i,"notebookMessaging"),F._proxy.$postMessage(w,be&&F._extHostNotebook.getIdByEditor(be),re)},asWebviewUri(re){return(0,f.checkProposedApiEnabled)(i,"notebookMessaging"),(0,l.asWebviewUri)(re,F._initData.remote)}};return this._kernelData.set(w,{extensionId:i.identifier,controller:he,onDidReceiveMessage:M,onDidChangeSelection:W,associatedNotebooks:te}),he}getIdByController(i){for(const[o,a]of this._kernelData)if(a.controller===i)return u(a.extensionId,i.id);return null}$acceptNotebookAssociation(i,o,a){const t=this._kernelData.get(i);if(t){const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));a?t.associatedNotebooks.set(d.uri,!0):t.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,d.uri.toString(),a),t.onDidChangeSelection.fire({selected:a,notebook:d.apiNotebook})}}async $executeCells(i,o,a){const t=this._kernelData.get(i);if(!t)return;const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(o)),p=[];for(const w of a){const F=d.getCell(w);F&&p.push(F.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,d.uri.toString(),p.length),await t.controller.executeHandler.call(t.controller,p,d.apiNotebook,t.controller)}catch(w){this._logService.error(`NotebookController[${i}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(i,o,a){const t=this._kernelData.get(i);if(!t)return;const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,d.apiNotebook);else for(const p of a){const w=d.getCell(p);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,o,a){const t=this._kernelData.get(i);if(!t)return;const d=this._extHostNotebook.getEditorById(o);t.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:a}))}$cellExecutionChanged(i,o,a){const d=this._extHostNotebook.getNotebookDocument(y.URI.revive(i)).getCell(o);if(d){const p=a?I.NotebookCellExecutionState.to(a):g.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:p})}}_createNotebookCellExecution(i,o){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const d=new T(o,t,this._proxy);this._activeExecutions.set(t.uri,d);const p=d.onDidChangeState(()=>{d.state===h.Resolved&&(d.dispose(),p.dispose(),this._activeExecutions.delete(t.uri))});return d.asApiObject()}};S=xe([$e(4,R.ILogService)],S),e.ExtHostNotebookKernels=S;var h;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(h||(h={}));class T extends _.Disposable{get state(){return this._state}constructor(i,o,a){super(),this._cell=o,this._proxy=a,this._handle=T.HANDLE++,this._onDidChangeState=new N.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new s(10,t=>this.update(t)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const o=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let o=this._cell;if(i&&(o=this._cell.notebook.getCellFromApiCell(i)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(i){return i.map(o=>{const a=g.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return a===o.items?I.NotebookCellOutput.from(o):I.NotebookCellOutput.from({items:a,id:o.id,metadata:o.metadata})})}async updateOutputs(i,o,a){const t=this.cellIndexToHandle(o),d=this.validateAndConvertOutputs((0,r.asArray)(i));return this.updateSoon({editType:c.CellExecutionUpdateType.Output,cellHandle:t,append:a,outputs:d})}async updateOutputItems(i,o,a){return i=g.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(i),!0),this.updateSoon({editType:c.CellExecutionUpdateType.OutputItems,items:i.map(I.NotebookCellOutputItem.from),outputId:o.id,append:a})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(a){i._executionOrder=a,i.update([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(a){if(i._state===h.Resolved||i._state===h.Started)throw new Error("Cannot call start again");i._state=h.Started,i._onDidChangeState.fire(),i.update({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,t){if(i._state===h.Resolved)throw new Error("Cannot call resolve twice");i._state=h.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new v.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:a}))},clearOutput(a){return i.verifyStateForOutput(),i.updateOutputs([],a,!1)},appendOutput(a,t){return i.verifyStateForOutput(),i.updateOutputs(a,t,!0)},replaceOutput(a,t){return i.verifyStateForOutput(),i.updateOutputs(a,t,!1)},appendOutputItems(a,t){return i.verifyStateForOutput(),i.updateOutputItems(a,t,!0)},replaceOutputItems(a,t){return i.verifyStateForOutput(),i.updateOutputItems(a,t,!1)}})}}T.HANDLE=0;class s{constructor(i,o){this.delay=i,this.callback=o,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new D.DeferredPromise,this.startedTimer=Date.now(),(0,D.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const o=this.batch;return this.batch=[],this.callback(o).finally(()=>i.complete())}}function u(n,i){return`${n.value}/${i}`}e.createKernelId=u}),define(Ie[213],Ce([1,0,4,5,94]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(A,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(D.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,P){const R=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(y)?.fire({editor:R.apiEditor,message:P})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(R=>R.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(R,E,m)=>this.getOrCreateEmitterFor(y).event(R,E,m),postMessage:(R,E)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,E]=[E,R]);const m=E&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(E);return this.proxy.$postMessage(m?.id,y,R)}}}getOrCreateEmitterFor(A){let y=this._rendererMessageEmitters.get(A);return y||(y=new r.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,y),y)}}e.ExtHostNotebookRenderers=N}),define(Ie[214],Ce([1,0,21,4,7,5,2,6,12,18,29,61]),function(ne,e,r,D,b,N,_,A,y,P,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(I,g,l){const c=I.getProxy(N.MainContext.MainThreadQuickOpen);class f{constructor(o,a){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=a}showQuickPick(o,a,t=r.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(o),p=++this._instances,w=c.$show(p,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},t),F={},j=w.then(()=>F);return Promise.race([j,d]).then(U=>{if(U!==F)return d.then(C=>{const W=[];for(let M=0;M<C.length;M++){const O=C[M];typeof O=="string"?W.push({label:O,handle:M}):O.kind===A.QuickPickItemKind.Separator?W.push({type:"separator",label:O.label}):W.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:M})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=M=>{a.onDidSelectItem(C[M])}),c.$setItems(p,W),w.then(M=>{if(typeof M=="number")return C[M];if(Array.isArray(M))return M.map(O=>C[O])})})}).then(void 0,U=>{if(!(0,y.isCancellationError)(U))return c.$setError(p,U),Promise.reject(U)})}$onItemSelected(o){this._onDidSelectItem?.(o)}showInput(o,a=r.CancellationToken.None){return this._validateInput=o?.validateInput,c.$input(o,typeof this._validateInput=="function",a).then(void 0,t=>{if(!(0,y.isCancellationError)(t))return Promise.reject(t)})}async $validateInput(o){if(!this._validateInput)return;const a=await this._validateInput(o);if(!a||typeof a=="string")return a;let t;switch(a.severity){case A.InputBoxValidationSeverity.Info:t=R.default.Info;break;case A.InputBoxValidationSeverity.Warning:t=R.default.Warning;break;case A.InputBoxValidationSeverity.Error:t=R.default.Error;break;default:t=a.message?R.default.Error:R.default.Ignore;break}return{content:a.message,severity:t}}async showWorkspaceFolderPick(o,a=r.CancellationToken.None){const t=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!t)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(p=>p.uri.toString()===t.uri.toString())}createQuickPick(o){const a=new u(o,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(o){const a=new n(o,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(o,a){this._sessions.get(o)?._fireDidChangeValue(a)}$onDidAccept(o){this._sessions.get(o)?._fireDidAccept()}$onDidChangeActive(o,a){const t=this._sessions.get(o);t instanceof u&&t._fireDidChangeActive(a)}$onDidChangeSelection(o,a){const t=this._sessions.get(o);t instanceof u&&t._fireDidChangeSelection(a)}$onDidTriggerButton(o,a){this._sessions.get(o)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(o,a,t){const d=this._sessions.get(o);d instanceof u&&d._fireDidTriggerItemButton(a,t)}$onDidHide(o){this._sessions.get(o)?._fireDidHide()}}class v{constructor(o,a){this._extensionId=o,this._onDidDispose=a,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((a,t)=>{const d=a===A.QuickInputButtons.Back?-1:t;this._handlesToButtons.set(d,a)}),this.update({buttons:o.map((a,t)=>({...s(a),tooltip:a.tooltip,handle:a===A.QuickInputButtons.Back?-1:t}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const a=this._handlesToButtons.get(o);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,b.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),c.$dispose(this._id))}update(o){if(!this._disposed){for(const a of Object.keys(o)){const t=o[a];this._pendingUpdate[a]=t===void 0?null:t}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){c.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function S(i){if(i instanceof A.ThemeIcon)return{id:i.id};const o=T(i),a=h(i);return{dark:typeof o=="string"?_.URI.file(o):o,light:typeof a=="string"?_.URI.file(a):a}}function h(i){return typeof i=="object"&&"light"in i?i.light:i}function T(i){return typeof i=="object"&&"dark"in i?i.dark:i}function s(i){const o=S(i.iconPath);let a,t;return"id"in o?t=E.ThemeIcon.asClassName(o):a=o,{iconPath:a,iconClass:t}}class u extends v{constructor(o,a){super(o.identifier,a),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((t,d)=>{this._handlesToItems.set(d,t),this._itemsToHandles.set(t,d)});const a=[];for(let t=0;t<o.length;t++){const d=o[t];d.kind===A.QuickPickItemKind.Separator?a.push({type:"separator",label:d.label}):a.push({handle:t,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((p,w)=>({...s(p),tooltip:p.tooltip,handle:w}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(o){const a=(0,P.coalesce)(o.map(t=>this._handlesToItems.get(t)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(o){const a=(0,P.coalesce)(o.map(t=>this._handlesToItems.get(t)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(o,a){const t=this._handlesToItems.get(o);if(!t||!t.buttons||!t.buttons.length)return;const d=t.buttons[a];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:t})}}class n extends v{constructor(o,a){super(o.identifier,a),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,o?typeof o=="string"?this.update({validationMessage:o,severity:R.default.Error}):this.update({validationMessage:o.message,severity:o.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new f(g,l)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r};define(Ie[215],Ce([1,0,2,4,57,7,15,5,18,118,11,26,61,8,28]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g){"use strict";var l,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(d){if(d)return typeof d.iconPath=="string"?r.URI.file(d.iconPath):r.URI.isUri(d.iconPath)||m.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function v(d,p){if(!d.iconPath&&!p.iconPath)return 0;if(d.iconPath){if(!p.iconPath)return 1}else return-1;const w=typeof d.iconPath=="string"?d.iconPath:r.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,F=typeof p.iconPath=="string"?p.iconPath:r.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,P.comparePaths)(w,F)}function S(d,p){let w=0;if(d.strikeThrough!==p.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==p.faded)return d.faded?1:-1;if(d.tooltip!==p.tooltip)return(d.tooltip||"").localeCompare(p.tooltip||"");if(w=v(d,p),w!==0)return w;if(d.light&&p.light)w=v(d.light,p.light);else{if(d.light)return 1;if(p.light)return-1}if(w!==0)return w;if(d.dark&&p.dark)w=v(d.dark,p.dark);else{if(d.dark)return 1;if(p.dark)return-1}return w}function h(d,p){if(d.command!==p.command)return d.command<p.command?-1:1;if(d.title!==p.title)return d.title<p.title?-1:1;if(d.tooltip!==p.tooltip){if(d.tooltip!==void 0&&p.tooltip!==void 0)return d.tooltip<p.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(d.arguments===p.arguments)return 0;if(d.arguments)if(p.arguments){if(d.arguments.length!==p.arguments.length)return d.arguments.length-p.arguments.length}else return 1;else return-1;for(let w=0;w<d.arguments.length;w++){const F=d.arguments[w],j=p.arguments[w];if(F!==j)return F<j?-1:1}return 0}function T(d,p){let w=(0,P.comparePaths)(d.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(w!==0)return w;if(d.command&&p.command)w=h(d.command,p.command);else{if(d.command)return 1;if(p.command)return-1}if(w!==0)return w;if(d.decorations&&p.decorations)w=S(d.decorations,p.decorations);else{if(d.decorations)return 1;if(p.decorations)return-1}return w}function s(d,p){for(let w=0;w<d.length;w++)if(d[w]!==p[w])return!1;return!0}function u(d,p){return d.command===p.command&&d.title===p.title&&d.tooltip===p.tooltip&&(d.arguments&&p.arguments?s(d.arguments,p.arguments):d.arguments===p.arguments)}function n(d,p){return(0,y.equals)(d,p,u)}class i{get value(){return this._value}set value(p){p=p??"",Oe(this,l,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,l,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,l,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,l,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,l,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,w,F){this._extension=p,this._sourceControlHandle=F,l.set(this,void 0),this._value="",this._onDidChange=new D.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,l,w,"f")}showValidationMessage(p,w){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,l,"f").$showValidationMessage(this._sourceControlHandle,p,w)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=i,l=new WeakMap;class o{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,w,F,j,U){this._proxy=p,this._commands=w,this._sourceControlHandle=F,this._id=j,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new D.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,w){const F=this._resourceStatesCommandsMap.get(p);return F?(0,_.asPromise)(()=>this._commands.executeCommand(F.command,...F.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(T),F=(0,y.sortedDiff)(this._resourceSnapshot,p,T).map(C=>{const W=C.toInsert.map(M=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,M);const H=M.resourceUri;let $;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const pe=new N.DisposableStore;$=this._commands.converter.toInternal(M.command,pe),this._resourceStatesDisposablesMap.set(O,pe)}else this._resourceStatesCommandsMap.set(O,M.command);const z=f(M.decorations),G=M.decorations&&f(M.decorations.light)||z,te=M.decorations&&f(M.decorations.dark)||z,he=[G,te],re=M.decorations&&M.decorations.tooltip||"",be=M.decorations&&!!M.decorations.strikeThrough,le=M.decorations&&!!M.decorations.faded,fe=M.contextValue||"";return{rawResource:[O,H,he,re,be,le,fe,$],handle:O}});return{start:C.start,deleteCount:C.deleteCount,toInsert:W}}),j=F.map(({start:C,deleteCount:W,toInsert:M})=>[C,W,M.map(O=>O.rawResource)]),U=F.reverse();for(const{start:C,deleteCount:W,toInsert:M}of U){const O=M.map($=>$.handle),H=this._handlesSnapshot.splice(C,W,...O);for(const $ of H)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=p,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class a{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,c,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,c,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,c,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new N.DisposableStore,this._acceptInputCommand=p;const w=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,c,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new N.DisposableStore,this._actionButton=p;const w=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(F=>F.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,c,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&n(this._statusBarCommands,p))return;this._statusBarDisposables.value=new N.DisposableStore,this._statusBarCommands=p;const w=(p||[]).map(F=>this._commands.converter.toInternal(F,this._statusBarDisposables.value));Oe(this,c,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}constructor(p,w,F,j,U,C){this._extension=p,this._commands=F,this._id=j,this._label=U,this._rootUri=C,c.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new N.MutableDisposable,this._statusBarDisposables=new N.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new D.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=a._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,c,w,"f"),this._inputBox=new i(p,Oe(this,c,"f"),this.handle),Oe(this,c,"f").$registerSourceControl(this.handle,j,U,C)}createResourceGroup(p,w){const F=new o(Oe(this,c,"f"),this._commands,this.handle,p,w),j=D.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,j),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const p=[],w=[];for(const[F,j]of this.createdResourceGroups){j.dispose();const U=F.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(F),this.eventuallyUpdateResourceStates()});D.Event.once(F.onDidDispose)(()=>{this.updatedResourceGroups.delete(F),U.dispose(),this._groups.delete(F.handle),Oe(this,c,"f").$unregisterGroup(this.handle,F.handle)}),p.push([F.handle,F.id,F.label,F.features]);const C=F._takeResourceStateSnapshot();C.length>0&&w.push([F.handle,C]),this._groups.set(F.handle,F)}Oe(this,c,"f").$registerGroups(this.handle,p,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(w=>{const F=w._takeResourceStateSnapshot();F.length!==0&&p.push([w.handle,F])}),p.length>0&&Oe(this,c,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,c,"f").$unregisterSourceControl(this.handle)}}c=new WeakMap,a._handlePool=0,xe([(0,b.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),xe([(0,b.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let t=class Ji{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,w,F){this._commands=w,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new D.Emitter,this._proxy=p.getProxy(A.MainContext.MainThreadSCM),this._telemetry=p.getProxy(A.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const U=this._sourceControls.get(j.sourceControlHandle);if(!U)return j;const C=U.getResourceGroup(j.groupHandle);return C?C.getResourceState(j.handle):j}else if(j&&j.$mid===4){const U=this._sourceControls.get(j.sourceControlHandle);return U?U.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const U=this._sourceControls.get(j.handle);return U||j}return j}})}createSourceControl(p,w,F,j){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,w,F,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const U=Ji._handlePool++,C=new a(p,this._proxy,this._commands,w,F,j);this._sourceControls.set(U,C);const W=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier))||[];return W.push(C),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(p.identifier),W),C}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const w=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier)),F=w&&w[w.length-1];return F&&F.inputBox}$provideOriginalResource(p,w,F){const j=r.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,j.toString());const U=this._sourceControls.get(p);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(j,F)).then(C=>C||null)}$onInputBoxValueChange(p,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const F=this._sourceControls.get(p);return F&&F.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(p,w,F,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,w,F);const U=this._sourceControls.get(p);if(!U)return Promise.resolve(void 0);const C=U.getResourceGroup(w);return C?C.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(p,w,F){this.logService.trace("ExtHostSCM#$validateInput",p);const j=this._sourceControls.get(p);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>j.inputBox.validateInput(w,F)).then(U=>{if(!U)return Promise.resolve(void 0);const C=I.MarkdownString.fromStrict(U.message);return C?Promise.resolve([C,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};t._handlePool=0,t=xe([$e(2,R.ILogService)],t),e.ExtHostSCM=t}),define(Ie[72],Ce([1,0,5,4,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(A){this._onDidChangePassword=new D.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,P){return this._proxy.$setPassword(A,y,P)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[216],Ce([1,0,6,5,133,7,8,9]),function(ne,e,r,D,b,N,_,A){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(g,l,c,f,v=r.StatusBarAlignment.Left,S){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new N.DisposableStore,Ye(this,y,g,"f"),Ye(this,P,l,"f"),this._entryId=R.ID_GEN++,this._extension=c,this._id=f,this._alignment=v,this._priority=this.validatePriority(S)}validatePriority(g){if(!!(0,A.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!R.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Oe(this,P,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Oe(this,P,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let l;this._name?l=this._name:l=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let c=this._color;this._backgroundColor&&(c=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=_.MarkdownString.fromStrict(this._tooltip);Oe(this,y,"f").$setEntry(this._entryId,g,l,this._text,f,this._command?.internal,c,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,y=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class E{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const l={message:g};return this._messages.unshift(l),this._update(),new r.Disposable(()=>{const c=this._messages.indexOf(l);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(g,l){this._proxy=g.getProxy(D.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new E(this)}createStatusBarEntry(g,l,c,f){return new R(this._proxy,this._commands,g,l,c,f)}setStatusBarMessage(g,l){const c=this._statusMessage.setMessage(g);let f;return typeof l=="number"?f=setTimeout(()=>c.dispose(),l):typeof l<"u"&&l.then(()=>c.dispose(),()=>c.dispose()),new r.Disposable(()=>{c.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=m}),define(Ie[73],Ce([1,0,5,4,3]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(A){this._onDidChangeStorage=new D.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,P){return this._proxy.$initializeExtensionStorage(A,y).then(R=>R||P)}setValue(A,y,P){return this._proxy.$setValue(A,y,P)}$acceptValue(A,y,P){this._onDidChangeStorage.fire({shared:A,key:y,value:P})}}e.ExtHostStorage=N,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(Ie[74],Ce([1,0,3,27,11,54,2]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(P,R,E){this._logService=R,this._extHostFileSystem=E,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(P){return _.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(P){if(this._value)return _.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return _.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=xe([$e(0,D.IExtHostInitDataService),$e(1,b.ILogService),$e(2,N.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ie[55],Ce([1,0,4,5,3,2,14,7,6,134,12,172,21,38,158,61,9,15,8]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class S{constructor(t,d,p,w){this._proxy=t,this._id=d,this._creationOptions=p,this._name=w,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const F=this;this.value={get name(){return F._name||""},get processId(){return F._pidPromise},get creationOptions(){return F._creationOptions},get exitStatus(){return F._exitStatus},get state(){return F._state},sendText(j,U=!0){F._checkDisposed(),F._proxy.$sendText(F._id,j,U)},show(j){F._checkDisposed(),F._proxy.$show(F._id,j)},hide(){F._checkDisposed(),F._proxy.$hide(F._id)},dispose(){F._disposed||(F._disposed=!0,F._proxy.$dispose(F._id))},get dimensions(){if(!(F._cols===void 0||F._rows===void 0))return{columns:F._cols,rows:F._rows}}}}async create(t,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,c.withNullAsUndefined)(t.shellPath),shellArgs:(0,c.withNullAsUndefined)(t.shellArgs),cwd:(0,c.withNullAsUndefined)(t.cwd),env:(0,c.withNullAsUndefined)(t.env),icon:(0,c.withNullAsUndefined)(i(t.iconPath)),color:l.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,c.withNullAsUndefined)(t.message),strictEnv:(0,c.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,c.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,c.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,c.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(t.location,d?.resolvedExtHostIdentifier),isTransient:(0,c.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,d,p,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:l.ThemeColor.isThemeColor(w)?w.id:void 0,location:this._serializeParentTerminal(t,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,d){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in t?{viewColumn:v.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitStatus(t,d){this._exitStatus=Object.freeze({code:t,reason:d})}setDimensions(t,d){return t===this._cols&&d===this._rows||t===0||d===0?!1:(this._cols=t,this._rows=d,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=S;class h{get onProcessReady(){return this._onProcessReady.event}constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${d}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,d){this._pty.setDimensions?.({columns:t,rows:d})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose?.((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions?.(d=>{d&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this._pty.onDidChangeName?.(d=>{this._onDidChangeProperty.fire({type:"title",value:d})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=h;let T=1,s=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(t,d){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new r.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=d.getProxy(D.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[p,w]of this._terminalProcesses)w.shutdown(!0)}})}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,d){const p=new S(this._proxy,(0,I.generateUuid)(),t,t.name),w=new h(t.pty);return p.createExtensionTerminal(t.location,this._serializeParentTerminal(t,d).resolvedExtHostIdentifier,i(t.iconPath),o(t.color)).then(F=>{const j=this._setupExtHostProcessListeners(F,w);this._terminalProcessDisposables[F]=j}),this._terminals.push(p),p.value}_serializeParentTerminal(t,d){if(d=d||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const p=t.location.parentTerminal;if(p){const w=this._terminals.find(F=>F.value===p);w&&(d.resolvedExtHostIdentifier=w._id)}}else t.location&&typeof t.location!="object"?d.location=t.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(t,d){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const w=new h(d),F=this._setupExtHostProcessListeners(t,w);this._terminalProcessDisposables[t]=F}async $acceptActiveTerminalChanged(t){const d=this._activeTerminal;if(t===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(t);p&&(this._activeTerminal=p,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,d){const p=this._getTerminalById(t);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:d})}async $acceptTerminalDimensions(t,d,p){const w=this._getTerminalById(t);w&&w.setDimensions(d,p)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(t,d,p){this._terminalProcesses.get(t)?.resize(d,p)}async $acceptTerminalTitleChange(t,d){const p=this._getTerminalById(t);p&&(p.name=d)}async $acceptTerminalClosed(t,d,p){const w=this._getTerminalObjectIndexById(this._terminals,t);if(w!==null){const F=this._terminals.splice(w,1)[0];F.setExitStatus(d,p),this._onDidCloseTerminal.fire(F.value)}}$acceptTerminalOpened(t,d,p,w){if(d){const U=this._getTerminalObjectIndexById(this._terminals,d);if(U!==null){this._terminals[U]._id=t,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const F={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:N.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},j=new S(this._proxy,t,F,p);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(t,d){this._getTerminalById(t)?._setProcessId(d)}async $startExtensionTerminal(t,d){const p=this._getTerminalById(t);if(!p)return{message:(0,P.localize)(0,null,t)};p.isOpen||await new Promise(F=>{const j=this.onDidOpenTerminal(async U=>{U===p.value&&(j.dispose(),F())})});const w=this._terminalProcesses.get(t);w?w.startSendingEvents(d):this._extensionTerminalAwaitingStart[t]={initialDimensions:d}}_setupExtHostProcessListeners(t,d){const p=new A.DisposableStore;p.add(d.onProcessReady(F=>this._proxy.$sendProcessReady(t,F.pid,F.cwd))),p.add(d.onDidChangeProperty(F=>this._proxy.$sendProcessProperty(t,F))),this._bufferer.startBuffering(t,d.onProcessData),p.add(d.onProcessExit(F=>this._onProcessExit(t,F))),this._terminalProcesses.set(t,d);const w=this._extensionTerminalAwaitingStart[t];return w&&d instanceof h&&(d.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),p}$acceptProcessAckDataEvent(t,d){this._terminalProcesses.get(t)?.acknowledgeDataEvent(d)}$acceptProcessInput(t,d){this._terminalProcesses.get(t)?.input(d)}$acceptTerminalInteraction(t){const d=this._getTerminalById(t);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(t,d,p){try{this._terminalProcesses.get(t)?.resize(d,p)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(t,d){this._terminalProcesses.get(t)?.shutdown(d)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(d=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(d=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:d}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,d,p){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,p),this._proxy.$registerProfileProvider(d,t.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(t,d){const p=new m.CancellationTokenSource().token;let w=await this._profileProviders.get(t)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,d);return}this.createTerminalFromOptions(w.options,d)}}async $provideLinks(t,d){const p=this._getTerminalById(t);if(!p)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const F=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,F);const j=[],U={terminal:p.value,line:d},C=[];for(const O of this._linkProviders)C.push(f.Promises.withAsyncBody(async H=>{F.token.onCancellationRequested(()=>H({provider:O,links:[]}));const $=await O.provideTerminalLinks(U,F.token)||[];F.token.isCancellationRequested||H({provider:O,links:$})}));const W=await Promise.all(C);if(F.token.isCancellationRequested)return[];const M=new Map;for(const O of W)O&&O.links.length>0&&j.push(...O.links.map(H=>{const $={id:T++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return M.set($.id,{provider:O.provider,link:H}),$}));return this._terminalLinkCache.set(t,M),j}$activateLink(t,d){const p=this._terminalLinkCache.get(t)?.get(d);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(t,d){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const p=this._terminalProcessDisposables[t];p&&(p.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,d)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,d){const p=this._getTerminalObjectIndexById(t,d);return p!==null?t[p]:null}_getTerminalObjectIndexById(t,d){let p=null;return t.some((w,F)=>w._id===d?(p=F,!0):!1),p}getEnvironmentVariableCollection(t){let d=this._environmentVariableCollections.get(t.identifier.value);return d||(d=new u,this._setEnvironmentVariableCollection(t.identifier.value,d)),d}_syncEnvironmentVariableCollection(t,d){const p=(0,E.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(t,d.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(t){t.forEach(d=>{const p=d[0],w=new u(d[1]);this._setEnvironmentVariableCollection(p,w)})}$acceptDefaultProfile(t,d){const p=this._defaultProfile;this._defaultProfile=t,this._defaultAutomationProfile=d,p?.path!==t.path&&this._onDidChangeShell.fire(t.path)}_setEnvironmentVariableCollection(t,d){this._environmentVariableCollections.set(t,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,d)})}};s=xe([$e(1,_.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class u{get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(t)}get size(){return this.map.size}replace(t,d){this._setIfDiffers(t,{value:d,type:y.EnvironmentVariableMutatorType.Replace})}append(t,d){this._setIfDiffers(t,{value:d,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,d){this._setIfDiffers(t,{value:d,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,d){const p=this.map.get(t);(!p||p.value!==d.value||p.type!==d.type)&&(this.map.set(t,d),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,d){this.map.forEach((p,w)=>t.call(d,w,p,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let n=class extends s{constructor(t){super(!1,t)}createTerminal(t,d,p){throw new R.NotSupportedError}createTerminalFromOptions(t,d){throw new R.NotSupportedError}};n=xe([$e(0,_.IExtHostRpcService)],n),e.WorkerExtHostTerminalService=n;function i(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function o(a){return l.ThemeColor.isThemeColor(a)?a:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)},Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r};define(Ie[217],Ce([1,0,18,23,21,4,181,218,7,25,9,38,5,14,95,8,6,41,66,50]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S){"use strict";var h,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(U,C,W){this.editors=W,this.resultsChangedEmitter=new N.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(m.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new n(this.proxy),C.registerArgumentProcessor({processArgument:M=>{if(M?.$mid!==14)return M;const O=M,H=O.tests[O.tests.length-1].item.extId;return this.controllers.get(f.TestId.root(H))?.collection.tree.get(H)?.actual??(0,g.toItemFromContext)(M)}})}createTestController(U,C,W){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const M=new y.DisposableStore,O=M.add(new g.ExtHostTestItemCollection(U,C,this.editors));O.root.label=C;const H=new Map,$=this.proxy,z={items:O.root.children,get label(){return C},set label(te){C=te,O.root.label=te,$.$updateController(U,{label:C})},get refreshHandler(){return W},set refreshHandler(te){W=te,$.$updateController(U,{canRefresh:!!te})},get id(){return U},createRunProfile:(te,he,re,be,le)=>{let fe=(0,A.hash)(te);for(;H.has(fe);)fe++;return new w(this.proxy,H,U,fe,te,he,re,be,le)},createTestItem(te,he,re){return new g.TestItemImpl(U,te,he,re)},createTestRun:(te,he,re=!0)=>this.runTracker.createTestRun(U,O,te,he,re),set resolveHandler(te){O.resolveHandler=te},get resolveHandler(){return O.resolveHandler},dispose:()=>{M.dispose()}};$.$registerTestController(U,C,!!W),M.add((0,y.toDisposable)(()=>$.$unregisterTestController(U)));const G={controller:z,collection:O,profiles:H};return this.controllers.set(U,G),M.add((0,y.toDisposable)(()=>this.controllers.delete(U))),M.add(O.onDidGenerateDiff(te=>$.$publishDiff(U,te.map(S.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(U,C=b.CancellationToken.None){const W=i(U);if(!W)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(W.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(O=>f.TestId.fromExtHostTestItem(O,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:F[W.kind],profileId:W.profileId,controllerId:W.controllerId}],exclude:U.exclude?.map(O=>O.id)},C)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,C,W){return(0,r.mapFind)(this.runTracker.trackers,O=>O.id===U?O.getCoverage(C):void 0)?.provideFileCoverage(W)??Promise.resolve([])}$resolveFileCoverage(U,C,W,M){return(0,r.mapFind)(this.runTracker.trackers,H=>H.id===U?H.getCoverage(C):void 0)?.resolveFileCoverage(W,M)??Promise.resolve([])}$configureRunProfile(U,C){this.controllers.get(U)?.profiles.get(C)?.configureHandler?.()}async $refreshTests(U,C){await this.controllers.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,P.deepFreeze)(l.TestResults.to(C))).concat(this.results).sort((C,W)=>W.completedAt-C.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,C){const W=this.controllers.get(f.TestId.fromString(U).controllerId)?.collection;W&&(await W.expand(U,C<0?1/0:C),W.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(S.TestsDiffOp.deserialize))}async $runControllerTests(U,C){return Promise.all(U.map(W=>this.runControllerTestRequest(W,C)))}async runControllerTestRequest(U,C){const W=this.controllers.get(U.controllerId);if(!W)return{};const{collection:M,profiles:O}=W,H=O.get(U.profileId);if(!H)return{};const $=U.testIds.map(he=>M.tree.get(he)).filter(R.isDefined),z=U.excludeExtIds.map(he=>W.collection.tree.get(he)).filter(R.isDefined).filter(he=>$.some(re=>re.fullId.compare(he.fullId)===2));if(!$.length)return{};const G=new c.TestRunRequest($.some(he=>he.actual instanceof g.TestItemRootImpl)?void 0:$.map(he=>he.actual),z.map(he=>he.actual),H),te=this.runTracker.prepareForMainThreadTestRun(G,o.fromInternal(U,W.collection),C);try{return await H.runHandler(G,C),{}}catch(he){return{error:String(he)}}finally{te.isRunning&&!C.isCancellationRequested&&await N.Event.toPromise(te.onEnd),te.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};s=xe([$e(0,I.IExtHostRpcService)],s),e.ExtHostTesting=s;class u extends y.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,C,W){super(),this.dto=U,this.proxy=C,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new N.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(W)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const C=this.dto.id,W=this.dto.controllerId,M=(0,E.generateUuid)(),O=new a(this.proxy,C,M),H=te=>(he,...re)=>{if(z){console.warn(`Setting the state of test "${he.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(he)||(this.ensureTestIsKnown(he),te(he,...re))},$=(te,he)=>{const re=he instanceof Array?he.map(l.TestMessage.from):[l.TestMessage.from(he)];if(te.uri&&te.range){const be={range:l.Range.from(te.range),uri:te.uri};for(const le of re)le.location=le.location||be}this.proxy.$appendTestMessagesInRun(C,M,f.TestId.fromExtHostTestItem(te,W).toString(),re)};let z=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return O.coverageProvider},set coverageProvider(te){O.coverageProvider=te},enqueued:H(te=>{this.proxy.$updateTestStateInRun(C,M,f.TestId.fromExtHostTestItem(te,W).toString(),1)}),skipped:H(te=>{this.proxy.$updateTestStateInRun(C,M,f.TestId.fromExtHostTestItem(te,W).toString(),5)}),started:H(te=>{this.proxy.$updateTestStateInRun(C,M,f.TestId.fromExtHostTestItem(te,W).toString(),2)}),errored:H((te,he,re)=>{$(te,he),this.proxy.$updateTestStateInRun(C,M,f.TestId.fromExtHostTestItem(te,W).toString(),6,re)}),failed:H((te,he,re)=>{$(te,he),this.proxy.$updateTestStateInRun(C,M,f.TestId.fromExtHostTestItem(te,W).toString(),4,re)}),passed:H((te,he)=>{this.proxy.$updateTestStateInRun(C,M,f.TestId.fromExtHostTestItem(te,this.dto.controllerId).toString(),3,he)}),appendOutput:(te,he,re)=>{z||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(C,M,D.VSBuffer.fromString(te),he&&l.location.from(he),re&&f.TestId.fromExtHostTestItem(re,W).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(C,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:G,coverage:O}),this.proxy.$startedTestRunTask(C,{id:M,name:U,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof g.TestItemImpl))throw new v.InvalidTestItemError(U.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const C=[],W=this.dto.colllection.root;for(;;){const M=l.TestItem.from(U);if(C.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),U===W))break;U=U.parent||W}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,C)}}class n{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,C,W){return this.getTracker(U,C,W)}cancelRunById(U){for(const C of this.tracked.values())if(C.id===U){C.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,C,W,M,O){const H=this.tracked.get(W);if(H)return H.createRun(M);const $=o.fromPublic(U,C,W,O),z=i(W);this.proxy.$startedExtensionTestRun({controllerId:U,profile:z&&{group:F[z.kind],id:z.profileId},exclude:W.exclude?.map(te=>f.TestId.fromExtHostTestItem(te,C.root.id).toString())??[],id:$.id,include:W.include?.map(te=>f.TestId.fromExtHostTestItem(te,C.root.id).toString())??[C.root.id],persist:O});const G=this.getTracker(W,$);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun($.id)),G.createRun(M)}getTracker(U,C,W){const M=new u(C,this.proxy,W);return this.tracked.set(U,M),M.onEnd(()=>this.tracked.delete(U)),M}}e.TestRunCoordinator=n;const i=j=>{if(!!j.profile){if(!(j.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class o{static fromPublic(U,C,W,M){return new o(U,(0,E.generateUuid)(),W.include?.map(O=>f.TestId.fromExtHostTestItem(O,U).toString())??[U],W.exclude?.map(O=>f.TestId.fromExtHostTestItem(O,U).toString())??[],M,C)}static fromInternal(U,C){return new o(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,W,M,O,H){this.controllerId=U,this.id=C,this.isPersisted=O,this.colllection=H,this.includePrefix=W.map($=>$+"\0"),this.excludePrefix=M.map($=>$+"\0")}isIncluded(U){const C=f.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const W of this.excludePrefix)if(C===W||C.startsWith(W))return!1;for(const W of this.includePrefix)if(C===W||C.startsWith(W))return!0;return!1}}e.TestRunDto=o;class a{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,C,W){this.proxy=U,this.runId=C,this.taskId=W}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(C){throw this.fileCoverage=void 0,C}}async resolveFileCoverage(U,C){const W=await this.fileCoverage;let M=W?.[U];return!this._coverageProvider||!W||!M?[]:(M.detailedCoverage||(M=W[U]=await this._coverageProvider.resolveFileCoverage?.(M,C)??M),M.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class t extends S.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,l.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const C=f.TestId.parentId(U.item.extId);if(C&&this.alreadyRemoved.has(C.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:C,removed:W}=this;return{get added(){return[...U].map(M=>M.revived)},get updated(){return[...C].map(M=>M.revived)},get removed(){return[...W].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new N.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,C){return{...U,revived:l.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}createChangeCollector(){return new t(this.changeEmitter)}}e.MirroredTestCollection=d;class p{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,_.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class w{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Oe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Oe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Oe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?l.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Oe(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,C,W,M,O,H,$,z=!1,G=void 0){this.controllerId=W,this.profileId=M,this._label=O,this.kind=H,this.runHandler=$,this._isDefault=z,this._tag=G,h.set(this,void 0),T.set(this,void 0),Ye(this,h,U,"f"),Ye(this,T,C,"f"),C.set(M,this);const te=F[H];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);Oe(this,h,"f").$publishTestRunProfile({profileId:M,controllerId:W,tag:G?l.TestTag.namespace(this.controllerId,G.id):null,label:O,group:te,isDefault:z,hasConfigurationHandler:!1})}dispose(){Oe(this,T,"f")?.delete(this.profileId)&&(Ye(this,T,void 0,"f"),Oe(this,h,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=w,h=new WeakMap,T=new WeakMap;const F={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(Ie[219],Ce([1,0,18,4,5,96,8,6]),function(ne,e,r,D,b,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new D.Emitter,this._onDidChangeTextEditorOptions=new D.Emitter,this._onDidChangeTextEditorVisibleRanges=new D.Emitter,this._onDidChangeTextEditorViewColumn=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const E=this._extHostDocumentsAndEditors.allEditors();return R?E:E.map(m=>m.value)}async showTextDocument(R,E,m){let I;typeof E=="number"?I={position:_.ViewColumn.from(E),preserveFocus:m}:typeof E=="object"?I={position:_.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?_.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:I={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(R.uri,I),l=g&&this._extHostDocumentsAndEditors.getEditor(g);if(l)return l.value;throw g?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,E){return new N.TextEditorDecorationType(this._proxy,R,E).value}$acceptEditorPropertiesChanged(R,E){const m=this._extHostDocumentsAndEditors.getEditor(R);if(!m)throw new Error("unknown text editor");if(E.options&&m._acceptOptions(E.options),E.selections){const I=E.selections.selections.map(_.Selection.to);m._acceptSelections(I)}if(E.visibleRanges){const I=r.coalesce(E.visibleRanges.map(_.Range.to));m._acceptVisibleRanges(I)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...E.options,lineNumbers:_.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const I=A.TextEditorSelectionChangeKind.fromValue(E.selections.source),g=E.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:g,kind:I})}if(E.visibleRanges){const I=r.coalesce(E.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:I})}}$acceptEditorPositionData(R){for(const E in R){const m=this._extHostDocumentsAndEditors.getEditor(E);if(!m)throw new Error("Unknown text editor");const I=_.ViewColumn.to(R[E]);m.value.viewColumn!==I&&(m._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:I}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y}),define(Ie[220],Ce([1,0,2,3,5,7,6,8,9]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,D.createDecorator)("IExtHostTimeline");class P{constructor(m,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const l=g.uri===void 0?void 0:r.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(R(l))?.get(g.handle)}return g}})}async $getTimeline(m,I,g,l){return this._providers.get(m)?.provideTimeline(r.URI.revive(I),g,l)}registerTimelineProvider(m,I,g,l){const c=new N.DisposableStore,f=this.convertTimelineItem(I.id,l,c).bind(this);let v;I.onDidChange&&(v=I.onDidChange(h=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:I.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:m,onDidChange:void 0,async provideTimeline(h,T,s){T?.resetCache&&(c.clear(),S.get(I.id)?.clear());const u=await I.provideTimeline(h,T,s);if(u==null)return;const n=f(h,T);return{...u,source:I.id,items:u.items.map(n)}},dispose(){for(const h of S.values())h.get(I.id)?.clear();v?.dispose(),c.dispose()}})}convertTimelineItem(m,I,g){return(l,c)=>{let f;if(c?.cacheResults){let v=this._itemsBySourceAndUriMap.get(m);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(m,v));const S=R(l);f=v.get(S),f===void 0&&(f=new Map,v.set(S,f))}return v=>{const{iconPath:S,...h}=v,T=`${m}|${v.id??v.timestamp}`;f?.set(T,v);let s,u,n;v.iconPath&&(S instanceof _.ThemeIcon?n={id:S.id,color:S.color}:r.URI.isUri(S)?(s=S,u=S):{light:s,dark:u}=S);let i;return _.MarkdownString.isMarkdownString(h.tooltip)?i=A.MarkdownString.from(h.tooltip):(0,y.isString)(h.tooltip)?i=h.tooltip:_.MarkdownString.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=A.MarkdownString.from(h.detail)):(0,y.isString)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=h.detail),{...h,id:h.id??void 0,handle:T,source:m,command:v.command?I.toInternal(v.command,g):void 0,icon:s,iconDark:u,themeIcon:n,tooltip:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,N.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=P;function R(E){return E?.toString()}}),define(Ie[221],Ce([1,0,7,13,2,5]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(y){this._openers=new Map,this._proxy=y.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,R,E){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=E.schemes.find(I=>!_.supportedSchemes.has(I));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,E.schemes,y,E.label),(0,r.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,R){const E=this._openers.get(y);if(!E)throw new Error(`Unknown opener with id: ${y}`);const m=b.URI.revive(P);return E.canOpenExternalUri(m,R)}async $openUri(y,P,R){const E=this._openers.get(y);if(!E)throw new Error(`Unknown opener id: '${y}'`);return E.openExternalUri(b.URI.revive(P.resolvedUri),{sourceUri:b.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([D.Schemas.http,D.Schemas.https])}),define(Ie[222],Ce([1,0,5,2,7,12,26]),function(ne,e,r,D,b,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(_.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const E=A.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(P)),this.handlers.set(E,R),this._proxy.$registerUriHandler(E,P),(0,b.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(P)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(P,R){const E=this.handlers.get(P);if(!E)return Promise.resolve(void 0);try{E.handleUri(D.URI.revive(R))}catch(m){(0,N.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return D.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=A,A.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[56],Ce([1,0,4,13,2,145,165,64,5]),function(ne,e,r,D,b,N,_,A,y){"use strict";var P,R,E,m,I,g,l,c,f,v,S,h,T;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(w,F,j,U,C,W,M){P.set(this,void 0),R.set(this,void 0),E.set(this,void 0),m.set(this,void 0),I.set(this,void 0),g.set(this,void 0),l.set(this,""),c.set(this,void 0),f.set(this,!1),v.set(this,!1),S.set(this,void 0),h.set(this,void 0),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,T.set(this,new r.Emitter),this._onDidDispose=Oe(this,T,"f").event,Ye(this,P,w,"f"),Ye(this,R,F,"f"),Ye(this,c,j,"f"),Ye(this,m,U,"f"),Ye(this,I,C,"f"),Ye(this,g,W,"f"),Ye(this,S,u(W),"f"),Ye(this,h,n(W),"f"),Ye(this,E,M,"f")}dispose(){Ye(this,f,!0,"f"),Oe(this,T,"f").fire(),Oe(this,T,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return Ye(this,v,!0,"f"),(0,A.asWebviewUri)(w,Oe(this,m,"f"))}get cspSource(){const w=Oe(this,g,"f").extensionLocation;if(w.scheme===D.Schemas.https||w.scheme===D.Schemas.http){let F=w.toString();return F.endsWith("/")||(F+="/"),F+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,l,"f")}set html(w){this.assertNotDisposed(),Oe(this,l,"f")!==w&&(Ye(this,l,w,"f"),Oe(this,h,"f")&&!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(Ye(this,v,!0,"f"),Oe(this,E,"f").report("Webview vscode-resource: uris",Oe(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,R,"f").$setHtml(Oe(this,P,"f"),this.rewriteOldResourceUrlsIfNeeded(w)))}get options(){return this.assertNotDisposed(),Oe(this,c,"f")}set options(w){this.assertNotDisposed(),Oe(this,R,"f").$setOptions(Oe(this,P,"f"),a(Oe(this,g,"f"),Oe(this,I,"f"),w)),Ye(this,c,w,"f")}async postMessage(w){if(Oe(this,f,"f"))return!1;const F=(0,_.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Oe(this,S,"f")});return Oe(this,R,"f").$postMessage(Oe(this,P,"f"),F.message,...F.buffers)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(w){if(!Oe(this,h,"f"))return w;const F=Oe(this,g,"f").extensionLocation?.scheme===D.Schemas.vscodeRemote,j=Oe(this,g,"f").extensionLocation.scheme===D.Schemas.vscodeRemote?Oe(this,g,"f").extensionLocation.authority:void 0;return w.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,C,W,M,O,H)=>{const $=b.URI.from({scheme:M||"file",path:decodeURIComponent(O)}),z=(0,A.asWebviewUri)($,{isRemote:F,authority:j}).toString();return`${C}${z}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(U,C,W,M,O,H)=>{const $=b.URI.from({scheme:M||"file",path:decodeURIComponent(O)}),z=(0,A.asWebviewUri)($,{isRemote:F,authority:j}).toString();return`${C}${z}${H}`})}}e.ExtHostWebview=s,P=new WeakMap,R=new WeakMap,E=new WeakMap,m=new WeakMap,I=new WeakMap,g=new WeakMap,l=new WeakMap,c=new WeakMap,f=new WeakMap,v=new WeakMap,S=new WeakMap,h=new WeakMap,T=new WeakMap;function u(p){try{const w=(0,N.normalizeVersion)((0,N.parseVersion)(p.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;function n(p){try{const w=(0,N.normalizeVersion)((0,N.parseVersion)(p.engines.vscode));return w?w.majorBase<1||w.majorBase===1&&w.minorBase<60:!1}catch{return!1}}class i{constructor(w,F,j,U,C){this.remoteInfo=F,this.workspace=j,this._logService=U,this._deprecationService=C,this._webviews=new Map,this._webviewProxy=w.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(w,F,j){const U=this.getWebview(w);if(U){const{message:C}=(0,_.deserializeWebviewMessage)(F,j.value);U._onMessageEmitter.fire(C)}}$onMissingCsp(w,F){this._logService.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,F,j){const U=new s(w,this._webviewProxy,t(F),this.remoteInfo,this.workspace,j,this._deprecationService);return this._webviews.set(w,U),U._onDidDispose(()=>{this._webviews.delete(w)}),U}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=i;function o(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=o;function a(p,w,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||d(p,w)}}e.serializeWebviewOptions=a;function t(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(w=>b.URI.from(w))}}e.reviveOptions=t;function d(p,w){return[...(w?.getWorkspaceFolders()||[]).map(F=>F.uri),p.extensionLocation]}}),define(Ie[223],Ce([1,0,21,218,7,13,22,2,8,56,62,5,6]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(u,n){this.document=u,this._storagePath=n,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,n){await this.getEdit(u).undo(),n||this.disposeBackup()}async redo(u,n){await this.getEdit(u).redo(),n||this.disposeBackup()}disposeEdits(u){for(const n of u)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=T(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const n=this._edits.get(u,0);if(!n)throw new Error("No edit found");return n}}class g{constructor(){this._documents=new Map}get(u,n){return this._documents.get(this.key(u,n))}add(u,n,i){const o=this.key(u,n.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${u} resource:${n.uri}`);const a=new I(n,i);return this._documents.set(o,a),a}delete(u,n){const i=this.key(u,n.uri);this._documents.delete(i)}key(u,n){return`${u}@@@${n}`}}var l;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(l||(l={}));class c{constructor(){this._providers=new Map}addTextProvider(u,n,i){return this.add(0,u,n,i)}addCustomProvider(u,n,i){return this.add(1,u,n,i)}get(u){return this._providers.get(u)}add(u,n,i,o){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:u,extension:i,provider:o}),new m.Disposable(()=>this._providers.delete(n))}}class f{constructor(u,n,i,o,a){this._extHostDocuments=n,this._extensionStoragePaths=i,this._extHostWebview=o,this._extHostWebviewPanels=a,this._editorProviders=new c,this._documents=new g,this._proxy=u.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,n,i,o){const a=new b.DisposableStore;return S(i)?(a.add(this._editorProviders.addTextProvider(n,u,i)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(u),n,o.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(u))):(a.add(this._editorProviders.addCustomProvider(n,u,i)),v(i)&&a.add(i.onDidChangeCustomDocument(t=>{const d=this.getCustomDocumentEntry(n,t.document.uri);if(h(t)){const p=d.addEdit(t);this._proxy.$onDidEdit(t.document.uri,n,p,t.label)}else this._proxy.$onContentChange(t.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(u),n,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(u))),m.Disposable.from(a,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(u,n,i,o,a){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${n}'`);const d=A.URI.revive(u),p=await t.provider.openCustomDocument(d,{backupId:i,untitledDocumentData:o?.buffer},a);let w;return v(t.provider)&&this._extensionStoragePaths&&(w=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(n,p,w),{editable:v(t.provider)}}async $disposeCustomDocument(u,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${n}'`);const o=A.URI.revive(u),{document:a}=this.getCustomDocumentEntry(n,o);this._documents.delete(n,a),a.dispose()}async $resolveWebviewEditor(u,n,i,o,a,t){const d=this._editorProviders.get(i);if(!d)throw new Error(`No provider found for '${i}'`);const p=y.ViewColumn.to(a),w=this._extHostWebview.createNewWebview(n,o.contentOptions,d.extension),F=this._extHostWebviewPanels.createNewWebviewPanel(n,i,o.title,p,o.options,w,!0),j=A.URI.revive(u);switch(d.type){case 1:{const{document:U}=this.getCustomDocumentEntry(i,j);return d.provider.resolveCustomEditor(U,F,t)}case 0:{const U=this._extHostDocuments.getDocument(j);return d.provider.resolveCustomTextEditor(U,F,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,n,i){this.getCustomDocumentEntry(n,u).disposeEdits(i)}async $onMoveCustomEditor(u,n,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const a=this._extHostWebviewPanels.getWebviewPanel(u);if(!a)throw new Error("No webview found");const t=A.URI.revive(n),d=this._extHostDocuments.getDocument(t);await o.provider.moveCustomTextEditor(d,a,r.CancellationToken.None)}async $undo(u,n,i,o){return this.getCustomDocumentEntry(n,u).undo(i,o)}async $redo(u,n,i,o){return this.getCustomDocumentEntry(n,u).redo(i,o)}async $revert(u,n,i){const o=this.getCustomDocumentEntry(n,u);await this.getCustomEditorProvider(n).revertCustomDocument(o.document,i),o.disposeBackup()}async $onSave(u,n,i){const o=this.getCustomDocumentEntry(n,u);await this.getCustomEditorProvider(n).saveCustomDocument(o.document,i),o.disposeBackup()}async $onSaveAs(u,n,i,o){const a=this.getCustomDocumentEntry(n,u);return this.getCustomEditorProvider(n).saveCustomDocumentAs(a.document,A.URI.revive(i),o)}async $backup(u,n,i){const o=this.getCustomDocumentEntry(n,u),t=await this.getCustomEditorProvider(n).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},i);return o.updateBackup(t),t.id}getCustomDocumentEntry(u,n){const i=this._documents.get(u,A.URI.revive(n));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(u){const i=this._editorProviders.get(u)?.provider;if(!i||!v(i))throw new Error("Custom document is not editable");return i}}e.ExtHostCustomEditors=f;function v(s){return!!s.onDidChangeCustomDocument}function S(s){return typeof s.resolveCustomTextEditor=="function"}function h(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function T(s){const u=s.scheme===N.Schemas.file||s.scheme===N.Schemas.untitled?s.fsPath:s.toString();return(0,D.hash)(u)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[224],Ce([1,0,4,7,2,38,8,56,5,6]),function(ne,e,r,D,b,N,_,A,y,P){"use strict";var R,E,m,I,g,l,c,f,v,S,h,T,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends D.Disposable{constructor(a,t,d,p){super(),R.set(this,void 0),E.set(this,void 0),m.set(this,void 0),I.set(this,void 0),g.set(this,void 0),l.set(this,void 0),c.set(this,void 0),f.set(this,void 0),v.set(this,!0),S.set(this,void 0),h.set(this,!1),T.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,T,"f").event,s.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Oe(this,s,"f").event,Ye(this,R,a,"f"),Ye(this,E,t,"f"),Ye(this,I,d,"f"),Ye(this,m,p.viewType,"f"),Ye(this,g,p.panelOptions,"f"),Ye(this,f,p.viewColumn,"f"),Ye(this,l,p.title,"f"),Ye(this,S,p.active,"f")}dispose(){Oe(this,h,"f")||(Ye(this,h,!0,"f"),Oe(this,T,"f").fire(),Oe(this,E,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,I,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,l,"f")}set title(a){this.assertNotDisposed(),Oe(this,l,"f")!==a&&(Ye(this,l,a,"f"),Oe(this,E,"f").$setTitle(Oe(this,R,"f"),a))}get iconPath(){return this.assertNotDisposed(),Oe(this,c,"f")}set iconPath(a){this.assertNotDisposed(),Oe(this,c,"f")!==a&&(Ye(this,c,a,"f"),Oe(this,E,"f").$setIconPath(Oe(this,R,"f"),b.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Oe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,f,"f")=="number"&&Oe(this,f,"f")<0))return Oe(this,f,"f")}get active(){return this.assertNotDisposed(),Oe(this,S,"f")}get visible(){return this.assertNotDisposed(),Oe(this,v,"f")}_updateViewState(a){Oe(this,h,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Ye(this,S,a.active,"f"),Ye(this,v,a.visible,"f"),Ye(this,f,a.viewColumn,"f"),Oe(this,s,"f").fire({webviewPanel:this}))}reveal(a,t){this.assertNotDisposed(),Oe(this,E,"f").$reveal(Oe(this,R,"f"),{viewColumn:typeof a>"u"?void 0:_.ViewColumn.from(a),preserveFocus:!!t})}assertNotDisposed(){if(Oe(this,h,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,E=new WeakMap,m=new WeakMap,I=new WeakMap,g=new WeakMap,l=new WeakMap,c=new WeakMap,f=new WeakMap,v=new WeakMap,S=new WeakMap,h=new WeakMap,T=new WeakMap,s=new WeakMap;class n{static newHandle(){return(0,N.generateUuid)()}constructor(a,t,d){this.webviews=t,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(a,t,d,p,w={}){const F=typeof p=="object"?p.viewColumn:p,j={viewColumn:_.ViewColumn.from(F),preserveFocus:typeof p=="object"&&!!p.preserveFocus},U=(0,A.shouldSerializeBuffersForPostMessage)(a),C=n.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(a),C,t,{title:d,panelOptions:i(w),webviewOptions:(0,A.serializeWebviewOptions)(a,this.workspace,w),serializeBuffersForPostMessage:U},j);const W=this.webviews.createNewWebview(C,w,a);return this.createNewWebviewPanel(C,t,d,F,w,W,!0)}$onDidChangeWebviewPanelViewStates(a){const t=Object.keys(a);t.sort((d,p)=>{const w=a[d],F=a[p];return w.active?1:F.active?-1:+w.visible-+F.visible});for(const d of t){const p=this.getWebviewPanel(d);if(!p)continue;const w=a[d];p._updateViewState({active:w.active,visible:w.visible,viewColumn:_.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,t,d){if(this._serializers.has(t))throw new Error(`Serializer for '${t}' already registered`);return this._serializers.set(t,{serializer:d,extension:a}),this._proxy.$registerSerializer(t,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(a)}),new P.Disposable(()=>{this._serializers.delete(t),this._proxy.$unregisterSerializer(t)})}async $deserializeWebviewPanel(a,t,d,p){const w=this._serializers.get(t);if(!w)throw new Error(`No serializer found for '${t}'`);const{serializer:F,extension:j}=w,U=this.webviews.createNewWebview(a,d.webviewOptions,j),C=this.createNewWebviewPanel(a,t,d.title,p,d.panelOptions,U,d.active);await F.deserializeWebviewPanel(C,d.state)}createNewWebviewPanel(a,t,d,p,w,F,j){const U=new u(a,this._proxy,F,{viewType:t,title:d,viewColumn:p,panelOptions:w,active:j});return this._webviewPanels.set(a,U),U}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=n;function i(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[225],Ce([1,0,4,7,56,8,5,6]),function(ne,e,r,D,b,N,_,A){"use strict";var y,P,R,E,m,I,g,l,c,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends D.Disposable{constructor(s,u,n,i,o,a,t){super(),y.set(this,void 0),P.set(this,void 0),R.set(this,void 0),E.set(this,void 0),m.set(this,!1),I.set(this,void 0),g.set(this,void 0),l.set(this,void 0),c.set(this,void 0),f.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Oe(this,f,"f").event,v.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Ye(this,R,n,"f"),Ye(this,g,i,"f"),Ye(this,y,s,"f"),Ye(this,P,u,"f"),Ye(this,E,o,"f"),Ye(this,I,t,"f")}dispose(){Oe(this,m,"f")||(Ye(this,m,!0,"f"),Oe(this,v,"f").fire(),Oe(this,E,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,g,"f")}set title(s){this.assertNotDisposed(),Oe(this,g,"f")!==s&&(Ye(this,g,s,"f"),Oe(this,P,"f").$setWebviewViewTitle(Oe(this,y,"f"),s))}get description(){return this.assertNotDisposed(),Oe(this,l,"f")}set description(s){this.assertNotDisposed(),Oe(this,l,"f")!==s&&(Ye(this,l,s,"f"),Oe(this,P,"f").$setWebviewViewDescription(Oe(this,y,"f"),s))}get visible(){return Oe(this,I,"f")}get webview(){return Oe(this,E,"f")}get viewType(){return Oe(this,R,"f")}_setVisible(s){s===Oe(this,I,"f")||Oe(this,m,"f")||(Ye(this,I,s,"f"),Oe(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,c,"f")}set badge(s){this.assertNotDisposed(),!(s?.value===Oe(this,c,"f")?.value&&s?.tooltip===Oe(this,c,"f")?.tooltip)&&(Ye(this,c,N.ViewBadge.from(s),"f"),Oe(this,P,"f").$setWebviewViewBadge(Oe(this,y,"f"),s))}show(s){this.assertNotDisposed(),Oe(this,P,"f").$show(Oe(this,y,"f"),!!s)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,P=new WeakMap,R=new WeakMap,E=new WeakMap,m=new WeakMap,I=new WeakMap,g=new WeakMap,l=new WeakMap,c=new WeakMap,f=new WeakMap,v=new WeakMap;class h{constructor(s,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,u,n,i){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:n,extension:s}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(s),u,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(s)}),new A.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(s,u,n,i,o){const a=this._viewProviders.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:t,extension:d}=a,p=this._extHostWebview.createNewWebview(s,{},d),w=new S(s,this._proxy,u,n,p,d,!0);this._webviewViews.set(s,w),await t.resolveWebviewView(w,{state:i},o)}async $onDidChangeWebviewViewVisibility(s,u){this.getWebviewView(s)._setVisible(u)}async $disposeWebviewView(s){const u=this.getWebviewView(s);this._webviewViews.delete(s),u.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const u=this._webviewViews.get(s);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=h}),define(Ie[98],Ce([1,0,4,5,2,13,10,3,14]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Zi{get state(){return this._state}constructor(E){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zi.InitialState,this._proxy=E.getProxy(D.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,m){let I;if(typeof E=="string"){I=E;try{E=b.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,_.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,I,m)}async asExternalUri(E,m){if((0,_.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(E,m);return b.URI.from(I)}};P.InitialState={focused:!0},P=xe([$e(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ie[226],Ce([1,0,196,27,14]),function(ne,e,r,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends r.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}_nativeConsoleLogMessage(A,y,P){y.apply(console,P)}};N=xe([$e(0,b.IExtHostRpcService),$e(1,D.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(Ie[227],Ce([1,0,15,23,21,12,4,7,119,190,42]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(w,F){try{return JSON.stringify(w,F)}catch{return"null"}}const I="$$ref$$",g={[I]:-1};class l{constructor(F,j){this.jsonString=F,this.referencedBuffers=j}}function c(w,F=null,j=!1){const U=[];return{jsonString:(j?m:JSON.stringify)(w,(W,M)=>{if(typeof M>"u")return g;if(typeof M=="object"){if(M instanceof D.VSBuffer){const O=U.push(M)-1;return{[I]:O}}if(F)return F(W,M)}return M}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=c;function f(w,F,j){return JSON.parse(w,(U,C)=>{if(C){const W=C[I];if(typeof W=="number")return F[W];if(j&&C.$mid===1)return j.transformIncoming(C)}return C})}e.parseJsonAndRestoreBufferRefs=f;function v(w,F){return JSON.stringify(w,F)}function S(w){return w?(F,j)=>j&&j.$mid===1?w.transformOutgoing(j):j:null}var h;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var T;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(T=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},u=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(F,j=null,U=null){super(),this[E]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=F,this._logger=j,this._uriTransformer=U,this._uriReplacer=S(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let C=0,W=R.ProxyIdentifier.count;C<W;C++)this._locals[C]=null,this._proxies[C]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(C=>this._receiveOneMessage(C))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(F=>{this._pendingRPCReplies[F].resolveErr(N.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(F){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(F){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(F){this._responsiveState!==F&&(this._responsiveState=F,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(F){return this._uriTransformer?(0,y.transformIncomingURIs)(F,this._uriTransformer):F}getProxy(F){const{nid:j,sid:U}=F;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,U)),this._proxies[j]}_createProxy(F,j){const U={get:(C,W)=>(typeof W=="string"&&!C[W]&&W.charCodeAt(0)===36&&(C[W]=(...M)=>this._remoteCall(F,W,M)),W===n?j:C[W])};return new Proxy(Object.create(null),U)}set(F,j){return this._locals[F.nid]=j,j}assertRegistered(F){for(let j=0,U=F.length;j<U;j++){const C=F[j];if(!this._locals[C.nid])throw new Error(`Missing proxy instance ${C.sid}`)}}_receiveOneMessage(F){if(this._isDisposed)return;const j=F.byteLength,U=o.read(F,0),C=U.readUInt8(),W=U.readUInt32();switch(C){case 1:case 2:{let{rpcId:M,method:O,args:H}=t.deserializeRequestJSONArgs(U);this._uriTransformer&&(H=(0,y.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(j,W,M,O,H,C===2);break}case 3:case 4:{let{rpcId:M,method:O,args:H}=t.deserializeRequestMixedArgs(U);this._uriTransformer&&(H=(0,y.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(j,W,M,O,H,C===4);break}case 5:{this._logger?.logIncoming(j,W,0,"ack"),this._onDidReceiveAcknowledge(W);break}case 6:{this._receiveCancel(j,W);break}case 7:{this._receiveReply(j,W,void 0);break}case 9:{let M=t.deserializeReplyOKJSON(U);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(j,W,M);break}case 10:{const M=t.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(j,W,M);break}case 8:{const M=t.deserializeReplyOKVSBuffer(U);this._receiveReply(j,W,M);break}case 11:{let M=t.deserializeReplyErrError(U);this._uriTransformer&&(M=(0,y.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(j,W,M);break}case 12:{this._receiveReplyErr(j,W,void 0);break}default:console.error("received unexpected message"),console.error(F)}}_receiveRequest(F,j,U,C,W,M){this._logger?.logIncoming(F,j,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(U)}.${C}(`,W);const O=String(j);let H,$;if(M){const G=new b.CancellationTokenSource;W.push(G.token),H=this._invokeHandler(U,C,W),$=()=>G.cancel()}else H=this._invokeHandler(U,C,W),$=s;this._cancelInvokedHandlers[O]=$;const z=t.serializeAcknowledged(j);this._logger?.logOutgoing(z.byteLength,j,1,"ack"),this._protocol.send(z),H.then(G=>{delete this._cancelInvokedHandlers[O];const te=t.serializeReplyOK(j,G,this._uriReplacer);this._logger?.logOutgoing(te.byteLength,j,1,"reply:",G),this._protocol.send(te)},G=>{delete this._cancelInvokedHandlers[O];const te=t.serializeReplyErr(j,G);this._logger?.logOutgoing(te.byteLength,j,1,"replyErr:",G),this._protocol.send(te)})}_receiveCancel(F,j){this._logger?.logIncoming(F,j,1,"receiveCancel");const U=String(j);this._cancelInvokedHandlers[U]?.()}_receiveReply(F,j,U){this._logger?.logIncoming(F,j,0,"receiveReply:",U);const C=String(j);if(!this._pendingRPCReplies.hasOwnProperty(C))return;const W=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C],W.resolveOk(U)}_receiveReplyErr(F,j,U){this._logger?.logIncoming(F,j,0,"receiveReplyErr:",U);const C=String(j);if(!this._pendingRPCReplies.hasOwnProperty(C))return;const W=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C];let M;U&&(U.$isError?(M=new Error,M.name=U.name,M.message=U.message,M.stack=U.stack):M=U),W.resolveErr(M)}_invokeHandler(F,j,U){try{return Promise.resolve(this._doInvokeHandler(F,j,U))}catch(C){return Promise.reject(C)}}_doInvokeHandler(F,j,U){const C=this._locals[F];if(!C)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(F));const W=C[j];if(typeof W!="function")throw new Error("Unknown method "+j+" on actor "+(0,R.getStringIdentifierForProxy)(F));return W.apply(C,U)}_remoteCall(F,j,U){if(this._isDisposed)return new P.CanceledLazyPromise;let C=null;if(U.length>0&&b.CancellationToken.isCancellationToken(U[U.length-1])&&(C=U.pop()),C&&C.isCancellationRequested)return Promise.reject(N.canceled());const W=t.serializeRequestArguments(U,this._uriReplacer),M=++this._lastMessageId,O=String(M),H=new P.LazyPromise;C&&C.onCancellationRequested(()=>{const z=t.serializeCancel(M);this._logger?.logOutgoing(z.byteLength,M,0,"cancel"),this._protocol.send(t.serializeCancel(M))}),this._pendingRPCReplies[O]=H,this._onWillSendRequest(M);const $=t.serializeRequest(M,F,j,W,!!C);return this._logger?.logOutgoing($.byteLength,M,0,`request: ${(0,R.getStringIdentifierForProxy)(F)}.${j}(`,U),this._protocol.send($),H}}e.RPCProtocol=i,E=u,i.UNRESPONSIVE_TIME=3*1e3;class o{static alloc(F,j,U){const C=new o(D.VSBuffer.alloc(U+1+4),0);return C.writeUInt8(F),C.writeUInt32(j),C}static read(F,j){return new o(F,j)}get buffer(){return this._buff}constructor(F,j){this._buff=F,this._offset=j}static sizeUInt8(){return 1}writeUInt8(F){this._buff.writeUInt8(F,this._offset),this._offset+=1}readUInt8(){const F=this._buff.readUInt8(this._offset);return this._offset+=1,F}writeUInt32(F){this._buff.writeUInt32BE(F,this._offset),this._offset+=4}readUInt32(){const F=this._buff.readUInt32BE(this._offset);return this._offset+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this._buff.writeUInt8(F.byteLength,this._offset),this._offset+=1,this._buff.set(F,this._offset),this._offset+=F.byteLength}readShortString(){const F=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,U}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readLongString(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,U}writeBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readVSBuffer(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+F);return this._offset+=F,j}static sizeMixedArray(F){let j=0;j+=1;for(let U=0,C=F.length;U<C;U++){const W=F[U];switch(j+=1,W.type){case 1:j+=this.sizeLongString(W.value);break;case 2:j+=this.sizeVSBuffer(W.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(W.value);for(let M=0;M<W.buffers.length;++M)j+=this.sizeVSBuffer(W.buffers[M]);break;case 4:break}}return j}writeMixedArray(F){this._buff.writeUInt8(F.length,this._offset),this._offset+=1;for(let j=0,U=F.length;j<U;j++){const C=F[j];switch(C.type){case 1:this.writeUInt8(1),this.writeLongString(C.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C.value);break;case 3:this.writeUInt8(3),this.writeUInt32(C.buffers.length),this.writeLongString(C.value);for(let W=0;W<C.buffers.length;++W)this.writeBuffer(C.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(F);for(let U=0;U<F;U++)switch(this.readUInt8()){case 1:j[U]=this.readLongString();break;case 2:j[U]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),M=this.readLongString(),O=[];for(let H=0;H<W;++H)O.push(this.readVSBuffer());j[U]=new R.SerializableObjectWithBuffers(f(M,O,null));break}case 4:j[U]=void 0;break}return j}}o.sizeUInt32=4;var a;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(a||(a={}));class t{static _useMixedArgSerialization(F){for(let j=0,U=F.length;j<U;j++)if(F[j]instanceof D.VSBuffer||F[j]instanceof R.SerializableObjectWithBuffers||typeof F[j]>"u")return!0;return!1}static serializeRequestArguments(F,j){if(this._useMixedArgSerialization(F)){const U=[];for(let C=0,W=F.length;C<W;C++){const M=F[C];if(M instanceof D.VSBuffer)U[C]={type:2,value:M};else if(typeof M>"u")U[C]={type:4};else if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:H}=c(M.value,j);U[C]={type:3,value:D.VSBuffer.fromString(O),buffers:H}}else U[C]={type:1,value:D.VSBuffer.fromString(v(M,j))}}return{type:1,args:U}}return{type:0,args:v(F,j)}}static serializeRequest(F,j,U,C,W){switch(C.type){case 0:return this._requestJSONArgs(F,j,U,C.args,W);case 1:return this._requestMixedArgs(F,j,U,C.args,W)}}static _requestJSONArgs(F,j,U,C,W){const M=D.VSBuffer.fromString(U),O=D.VSBuffer.fromString(C);let H=0;H+=o.sizeUInt8(),H+=o.sizeShortString(M),H+=o.sizeLongString(O);const $=o.alloc(W?2:1,F,H);return $.writeUInt8(j),$.writeShortString(M),$.writeLongString(O),$.buffer}static deserializeRequestJSONArgs(F){const j=F.readUInt8(),U=F.readShortString(),C=F.readLongString();return{rpcId:j,method:U,args:JSON.parse(C)}}static _requestMixedArgs(F,j,U,C,W){const M=D.VSBuffer.fromString(U);let O=0;O+=o.sizeUInt8(),O+=o.sizeShortString(M),O+=o.sizeMixedArray(C);const H=o.alloc(W?4:3,F,O);return H.writeUInt8(j),H.writeShortString(M),H.writeMixedArray(C),H.buffer}static deserializeRequestMixedArgs(F){const j=F.readUInt8(),U=F.readShortString(),C=F.readMixedArray(),W=new Array(C.length);for(let M=0,O=C.length;M<O;M++){const H=C[M];typeof H=="string"?W[M]=JSON.parse(H):W[M]=H}return{rpcId:j,method:U,args:W}}static serializeAcknowledged(F){return o.alloc(5,F,0).buffer}static serializeCancel(F){return o.alloc(6,F,0).buffer}static serializeReplyOK(F,j,U){if(typeof j>"u")return this._serializeReplyOKEmpty(F);if(j instanceof D.VSBuffer)return this._serializeReplyOKVSBuffer(F,j);if(j instanceof R.SerializableObjectWithBuffers){const{jsonString:C,referencedBuffers:W}=c(j.value,U,!0);return this._serializeReplyOKJSONWithBuffers(F,C,W)}else return this._serializeReplyOKJSON(F,m(j,U))}static _serializeReplyOKEmpty(F){return o.alloc(7,F,0).buffer}static _serializeReplyOKVSBuffer(F,j){let U=0;U+=o.sizeVSBuffer(j);const C=o.alloc(8,F,U);return C.writeVSBuffer(j),C.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static _serializeReplyOKJSON(F,j){const U=D.VSBuffer.fromString(j);let C=0;C+=o.sizeLongString(U);const W=o.alloc(9,F,C);return W.writeLongString(U),W.buffer}static _serializeReplyOKJSONWithBuffers(F,j,U){const C=D.VSBuffer.fromString(j);let W=0;W+=o.sizeUInt32,W+=o.sizeLongString(C);for(const O of U)W+=o.sizeVSBuffer(O);const M=o.alloc(10,F,W);M.writeUInt32(U.length),M.writeLongString(C);for(const O of U)M.writeBuffer(O);return M.buffer}static deserializeReplyOKJSON(F){const j=F.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(F,j){const U=F.readUInt32(),C=F.readLongString(),W=[];for(let M=0;M<U;++M)W.push(F.readVSBuffer());return new R.SerializableObjectWithBuffers(f(C,W,j))}static serializeReplyErr(F,j){const U=j?m(N.transformErrorForSerialization(j),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(F);const C=D.VSBuffer.fromString(U);let W=0;W+=o.sizeLongString(C);const M=o.alloc(11,F,W);return M.writeLongString(C),M.buffer}static deserializeReplyErrError(F){const j=F.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(F){return o.alloc(12,F,0).buffer}}var d;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var p;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(p||(p={}))}),define(Ie[228],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(N){const _=A=>{self.removeEventListener("message",_);const y=A.data;Object.defineProperties(self,{postMessage:{value(P,R){y.postMessage(P,R)}},onmessage:{get(){return y.onmessage},set(P){y.onmessage=P}}}),y.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",_)}.toString();class D extends EventTarget{constructor(N,_,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${r})('${_}'))`,P=new Blob([y],{type:"application/javascript"}),R=URL.createObjectURL(P),E=new MessageChannel,m=R,I={type:"_newWorker",id:m,port:E.port2,url:R,options:A};N(I,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{N({type:"_terminateWorker",id:m}),URL.revokeObjectURL(R),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(g){E.port1.onmessage=g}},onmessageerror:{get(){return E.port1.onmessageerror},set(g){E.port1.onmessageerror=g}}}),E.port1.addEventListener("messageerror",g=>{const l=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(l)}),E.port1.addEventListener("message",g=>{const l=new MessageEvent("message",{data:g.data});this.dispatchEvent(l)}),E.port1.start()}}e.NestedWorker=D}),define(Ie[229],Ce([1,0,4,30,40,3,35,12,15]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new b.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new b.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new b.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(g){this.channels.has(g.id)||(this.channels.set(g.id,g),this._onDidRegisterChannel.fire(g.id))}getChannels(){const g=[];return this.channels.forEach(l=>g.push(l)),g}getChannel(g){return this.channels.get(g)}removeChannel(g){this.channels.delete(g),this._onDidRemoveChannel.fire(g)}}D.Registry.add(e.Extensions.OutputChannels,new R);function E(I,g,l,c,f){return(0,y.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(l,c);const S=D.Registry.as(e.Extensions.OutputChannels);try{await m(l,1,c,f,v),S.registerChannel({id:I,label:g,file:l,log:!0})}catch(h){(0,A.isCancellationError)(h)||f.error("Error while registering log channel",l.toString(),(0,A.getErrorMessage)(h))}})}e.registerLogChannel=E;async function m(I,g,l,c,f){if(!await l.exists(I)){if(f.isCancellationRequested)throw new A.CancellationError;if(g>10)throw new Error("Timed out while waiting for file to be created");c.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,y.timeout)(1e3,f),await m(I,g+1,l,c,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new b.RawContextKey("activeOutputChannel","")}),define(Ie[99],Ce([1,0,5,3,14,26,11,229,54,27,36,112,23,9,35,4,7,28]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class v extends _.AbstractMessageLogger{get disposed(){return this._disposed}constructor(s,u,n,i,o){super(),this.id=s,this.name=u,this.logger=n,this.proxy=i,this.extension=o,this.offset=0,this._disposed=!1,this.visible=!1,this._register(n.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.logger.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const s=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,s)}replace(s){const u=this.offset;this.info(s),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,u),this.visible&&this.logger.flush()}show(s,u){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof s=="boolean"?s:u))}hide(){this.proxy.$close(this.id)}log(s,u){this.offset+=m.VSBuffer.fromString(u).byteLength,(0,_.log)(this.logger,s,u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class S extends v{appendLine(s){this.append(s)}}let h=class{constructor(s,u,n,i,o,a){this.initData=u,this.extHostFileSystem=n,this.extHostFileSystemInfo=i,this.loggerService=o,this.logService=a,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=s.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(u.logsLocation,`output_logging_${(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.visibleChannelId=s;for(const[u,n]of this.channels)n.visible=u===this.visibleChannelId}createOutputChannel(s,u,n){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const i=typeof u=="object"&&u.log;i&&(0,f.checkProposedApiEnabled)(n,"extensionLog");const o=(0,I.isString)(u)?u:void 0;if((0,I.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.getDefaultLogLevel(n),t=i?this.doCreateLogOutputChannel(s,a,n):this.doCreateOutputChannel(s,o,n);return t.then(d=>{this.channels.set(d.id,d),d.visible=d.id===this.visibleChannelId}),i?this.createExtHostLogOutputChannel(s,a,t):this.createExtHostOutputChannel(s,t)}async doCreateOutputChannel(s,u,n){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const i=await this.outputDirectoryPromise,o=this.extHostFileSystemInfo.extUri.joinPath(i,`${this.namePool++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),t=await this.proxy.$register(s,o,!1,u,n.identifier.value);return new v(t,s,a,this.proxy,n)}async doCreateLogOutputChannel(s,u,n){const i=await this.createExtensionLogDirectory(n),o=this.extHostFileSystemInfo.extUri.joinPath(i,`${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(o,{name:s},u),t=await this.proxy.$register(s,o,!0,void 0,n.identifier.value);return new S(t,s,a,this.proxy,n)}getDefaultLogLevel(s){let u;const n=this.initData.environment.extensionLogLevel?.find(([i])=>N.ExtensionIdentifier.equals(s.identifier,i))?.[1];return n&&(u=(0,_.parseLogLevel)(n)),u??this.logService.getLevel()}createExtensionLogDirectory(s){let u=this.extensionLogDirectoryPromise.get(s.identifier.value);if(!u){const n=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,s.identifier.value);this.extensionLogDirectoryPromise.set(s.identifier.value,u=(async()=>{try{await this.extHostFileSystem.value.createDirectory(n)}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileExists)throw i}return n})())}return u}createExtHostOutputChannel(s,u){let n=!1;const i=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return s},append(o){i(),u.then(a=>a.append(o))},appendLine(o){i(),u.then(a=>a.appendLine(o))},clear(){i(),u.then(o=>o.clear())},replace(o){i(),u.then(a=>a.replace(o))},show(o,a){i(),u.then(t=>t.show(o,a))},hide(){i(),u.then(o=>o.hide())},dispose(){n=!0,u.then(o=>o.dispose())}}}createExtHostLogOutputChannel(s,u,n){const i=new c.DisposableStore,o=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},a=i.add(new l.Emitter);return n.then(t=>{i.add(t),i.add(t.onDidChangeLogLevel(d=>{u=d,a.fire(d)}))}),{...this.createExtHostOutputChannel(s,n),get logLevel(){return u},onDidChangeLogLevel:a.event,trace(t,...d){o(),n.then(p=>p.trace(t,...d))},debug(t,...d){o(),n.then(p=>p.debug(t,...d))},info(t,...d){o(),n.then(p=>p.info(t,...d))},warn(t,...d){o(),n.then(p=>p.warn(t,...d))},error(t,...d){o(),n.then(p=>p.error(t,...d))},dispose(){i.dispose()}}}};h=xe([$e(0,b.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,_.ILoggerService),$e(5,_.ILogService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(Ie[230],Ce([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ie[231],Ce([1,0,39,13,19,20,22,2,3,161,48,176,230]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let I=class en{constructor(l,c,f,v){this.localUserHome=l,this.remoteAgentService=c,this.environmentService=f,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||N.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome??l})()}hasValidBasename(l,c,f){return typeof c=="string"||typeof c>"u"?this.resolveOS.then(v=>this.doHasValidBasename(l,v,c)):this.doHasValidBasename(l,c,f)}doHasValidBasename(l,c,f){return l.scheme===D.Schemas.file||l.scheme===D.Schemas.vscodeRemote?(0,r.isValidBasename)(f??(0,_.basename)(l),c===1):!0}get defaultUriScheme(){return en.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(l,c){if(l.remoteAuthority)return D.Schemas.vscodeRemote;const f=(0,P.getVirtualWorkspaceScheme)(c.getWorkspace());if(f)return f;const v=c.getWorkspace().folders[0];if(v)return v.uri.scheme;const S=c.getWorkspace().configuration;return S?S.scheme:D.Schemas.file}userHome(l){return l?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(l=>l===1?b.win32:b.posix)}async fileURI(l){let c="";if(await this.resolveOS===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const v=l.indexOf("/",2);v===-1?(c=l.substring(2),l="/"):(c=l.substring(2,v),l=l.substring(v)||"/")}return A.URI.from({scheme:D.Schemas.file,authority:c,path:l,query:"",fragment:""})}};I=xe([$e(1,m.IRemoteAgentService),$e(2,E.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(Ie[100],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(_,A){this.line=_,this.character=A}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,A){return new r(0,0)}with(_){return new r(0,0)}}e.Position=r;class D{constructor(_,A,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(_,A),this.end=new r(y,P)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new D(0,0,0,0)}with(_){return new D(0,0,0,0)}}e.Range=D;var b;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[43],Ce([1,0,18,34,25,39,10,3,19,12,100,15]),function(ne,e,r,D,b,N,_,A,y,P,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",I=" characters skipped \u27EB",g=(m.length+I.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var l;(function(re){re[re.file=0]="file",re[re.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(re){re[re.File=1]="File",re[re.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function f(re){return!!re.preview}e.resultIsMatch=f;function v(re){return!!re.resource}e.isFileMatch=v;function S(re){return!!re.message}e.isProgressMessage=S;var h;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class T{constructor(be){this.resource=be,this.results=[]}}e.FileMatch=T;class s{constructor(be,le,fe){this.ranges=le;const Q=Array.isArray(le)?le:[le];if(fe&&fe.matchLines===1&&u(Q)){be=(0,_.getNLines)(be,fe.matchLines);let pe="",Se=0,Fe=0;const Ue=Math.floor(fe.charsPerLine/5),Xe=[];for(const ke of Q){const ye=Math.max(ke.startColumn-Ue,0),De=ke.startColumn+fe.charsPerLine;if(ye>Fe+Ue+g){const ae=m+(ye-Fe)+I;pe+=ae+be.slice(ye,De),Se+=ye-(Fe+ae.length)}else pe+=be.slice(Fe,De);Xe.push(new i(0,ke.startColumn-Se,ke.endColumn-Se)),Fe=De}this.preview={text:pe,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const pe=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:be,matches:(0,r.mapArrayOrNot)(le,Se=>new n(Se.startLineNumber-pe,Se.startColumn,Se.endLineNumber-pe,Se.endColumn))}}}}e.TextSearchMatch=s;function u(re){const be=re[0].startLineNumber;for(const le of re)if(le.startLineNumber!==be||le.endLineNumber!==be)return!1;return!0}class n{constructor(be,le,fe,Q){this.startLineNumber=be,this.startColumn=le,this.endLineNumber=fe,this.endColumn=Q}}e.SearchRange=n;class i extends n{constructor(be,le,fe){super(be,le,be,fe)}}e.OneLineRange=i;var o;(function(re){re.List="list",re.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var a;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function t(re,be=!0){const le=re&&re.files&&re.files.exclude,fe=be&&re&&re.search&&re.search.exclude;if(!le&&!fe)return;if(!le||!fe)return le||fe;let Q=Object.create(null);return Q=b.mixin(Q,b.deepClone(le)),Q=b.mixin(Q,b.deepClone(fe),!0),Q}e.getExcludes=t;function d(re,be){return re.excludePattern&&D.match(re.excludePattern,be)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&D.match(re.includePattern,be)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(le=>{const fe=le.folder.fsPath;if(N.isEqualOrParent(be,fe)){const Q=y.relative(fe,be);return!le.includePattern||!!D.match(le.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var p;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(be,le){super(be),this.code=le}}e.SearchError=w;function F(re){const be=re.message;if((0,P.isCancellationError)(re))return new w(be,p.canceled);try{const le=JSON.parse(be);return new w(le.message,le.code)}catch{return new w(be,p.other)}}e.deserializeSearchError=F;function j(re){const be={message:re.message,code:re.code};return new Error(JSON.stringify(be))}e.serializeSearchError=j;function U(re){return re.type==="error"?!0:re.type==="success"}e.isSerializedSearchComplete=U;function C(re){return re.type==="success"}e.isSerializedSearchSuccess=C;function W(re){return!!re.path}e.isSerializedFileMatch=W;function M(re,be){const le=re.searchPath?re.searchPath:re.relativePath;return(0,_.fuzzyContains)(le,be)}e.isFilePatternMatch=M;class O{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function H(re,be){const le={...re||{},...be||{}};return Object.keys(le).filter(fe=>{const Q=le[fe];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=H;class ${constructor(be,le){this._parsedIncludeExpression=null,this._excludeExpression={...be.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=D.parse(this._excludeExpression);let fe=be.includePattern;le.includePattern&&(fe?fe={...fe,...le.includePattern}:fe=le.includePattern),fe&&(this._parsedIncludeExpression=D.parse(fe))}matchesExcludesSync(be,le,fe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe))}includedInQuerySync(be,le,fe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(be,le,fe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(be,le,fe))}includedInQuery(be,le,fe){const Q=this._parsedExcludeExpression(be,le,fe),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(be,le,fe):!0;return(0,E.isThenable)(Q)?Q.then(Se=>Se?!1:pe()):pe()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=$;function z(re){for(const be in re)if(typeof re[be]!="boolean")return!0;return!1}function G(re){if(!re)return;let be;return le=>(be||(be=(re()||Promise.resolve([])).then(fe=>fe?he(fe):{})),be.then(fe=>!!fe[le]))}e.hasSiblingPromiseFn=G;function te(re){if(!re)return;let be;return le=>{if(!be){const fe=re();be=fe?he(fe):{}}return!!be[le]}}e.hasSiblingFn=te;function he(re){const be={};for(const le of re)be[le]=!0;return be}}),define(Ie[31],Ce([1,0,18,15,21,4,7,24,13,107,22,10,9,2,136,3,11,150,48,36,27,14,8,6,49,43,5]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h,T,s,u,n,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(C,W,M){return new R.ExtUri(O=>w(O,M)).isEqual(C,W)}function t(C,W,M){return a(C.uri,W.uri,M)?0:(0,E.compare)(C.uri.toString(),W.uri.toString())}function d(C,W,M){return C.index!==W.index?C.index<W.index?-1:1:a(C.uri,W.uri,M)?(0,E.compare)(C.name,W.name):(0,E.compare)(C.uri.toString(),W.uri.toString())}function p(C,W,M,O){const H=C.slice(0).sort((z,G)=>M(z,G,O)),$=W.slice(0).sort((z,G)=>M(z,G,O));return(0,r.delta)(H,$,(z,G)=>M(z,G,O))}function w(C,W){const M=W.getCapabilities(C.scheme);return!(M&&M&1024)}class F extends v.Workspace{static toExtHostWorkspace(W,M,O,H){if(!W)return{workspace:null,added:[],removed:[]};const{id:$,name:z,folders:G,configuration:te,transient:he,isUntitled:re}=W,be=[],le=M;M?G.forEach((Se,Fe)=>{const Ue=I.URI.revive(Se.uri),Xe=F._findFolder(O||M,Ue,H);Xe?(Xe.name=Se.name,Xe.index=Se.index,be.push(Xe)):be.push({uri:Ue,name:Se.name,index:Fe})}):be.push(...G.map(({uri:Se,name:Fe,index:Ue})=>({uri:I.URI.revive(Se),name:Fe,index:Ue}))),be.sort((Se,Fe)=>Se.index<Fe.index?-1:1);const fe=new F($,z,be,!!he,te?I.URI.revive(te):null,!!re,Se=>w(Se,H)),{added:Q,removed:pe}=p(le?le.workspaceFolders:[],fe.workspaceFolders,t,H);return{workspace:fe,added:Q,removed:pe}}static _findFolder(W,M,O){for(let H=0;H<W.folders.length;H++){const $=W.workspaceFolders[H];if(a($.uri,M,O))return $}}constructor(W,M,O,H,$,z,G){super(W,O.map(te=>new v.WorkspaceFolder(te)),H,$,G),this._name=M,this._isUntitled=z,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),O.forEach(te=>{this._workspaceFolders.push(te),this._structure.set(te.uri,te)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(W,M){return M&&this._structure.get(W)&&(W=(0,R.dirname)(W)),this._structure.findSubstr(W)}resolveWorkspaceFolder(W){return this._structure.get(W)}}let j=class{constructor(W,M,O,H,$){this._onDidChangeWorkspace=new N.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new N.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=H,this._extHostFileSystemInfo=O,this._uriTransformerService=$,this._requestIdProvider=new P.Counter,this._barrier=new D.Barrier,this._proxy=W.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=W.getProxy(o.MainContext.MainThreadMessageService);const z=M.workspace;this._confirmedWorkspace=z?new F(z.id,z.name,[],!!z.transient,z.configuration?I.URI.revive(z.configuration):null,!!z.isUntitled,G=>w(G,O)):void 0}$initializeWorkspace(W,M){this._trusted=M,this.$acceptWorkspaceData(W),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?I.URI.from({scheme:y.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(W,M,O,...H){const $=[];if(Array.isArray(H)&&H.forEach(re=>{I.URI.isUri(re.uri)&&!$.some(be=>a(be.uri,re.uri,this._extHostFileSystemInfo))&&$.push({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri)})}),this._unconfirmedWorkspace||[M,O].some(re=>typeof re!="number"||re<0)||O===0&&$.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+O>z.length)return!1;const G=z.slice(0);G.splice(M,O,...$.map(re=>({uri:re.uri,name:re.name||(0,R.basenameOrAuthority)(re.uri),index:void 0})));for(let re=0;re<G.length;re++){const be=G[re];if(G.some((le,fe)=>fe!==re&&a(be.uri,le.uri,this._extHostFileSystemInfo)))return!1}G.forEach((re,be)=>re.index=be);const{added:te,removed:he}=p(z,G,d,this._extHostFileSystemInfo);if(te.length===0&&he.length===0)return!1;if(this._proxy){const re=W.displayName||W.name;this._proxy.$updateWorkspaceFolders(re,M,O,$).then(void 0,be=>{this._unconfirmedWorkspace=void 0;const le={source:{identifier:W.identifier,label:W.displayName||W.name}};this._messageService.$showMessage(f.Severity.Error,(0,g.localize)(0,null,re,be.toString()),le,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(W,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,M)}async getWorkspaceFolder2(W,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,M)}async resolveWorkspaceFolder(W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(W)}getPath(){if(!this._actualWorkspace)return;const{folders:W}=this._actualWorkspace;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,M){let O,H="";if(typeof W=="string"?(O=I.URI.file(W),H=W):typeof W<"u"&&(O=W,H=W.fsPath),!O)return H;const $=this.getWorkspaceFolder(O,!0);if(!$)return H;typeof M>"u"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let z=(0,R.relativePath)($.uri,O);return M&&$.name&&(z=`${$.name}/${z}`),z}trySetWorkspaceFolders(W){this._actualWorkspace&&(this._unconfirmedWorkspace=F.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:W,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:M,added:O,removed:H}=F.toExtHostWorkspace(W,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:H}))}findFiles(W,M,O,H,$=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let z;if(M===null?z=!1:M&&(typeof M=="string"?z=M:z=M.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:te}=U(s.GlobPattern.from(W));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(G),(0,m.withUndefinedAsNull)(te),(0,m.withUndefinedAsNull)(z),(0,m.withUndefinedAsNull)(O),$).then(he=>Array.isArray(he)?he.map(re=>I.URI.revive(re)):[])}async findTextInFiles(W,M,O,H,$=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),G=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:te,folder:he}=U(s.GlobPattern.from(M.include)),re=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,be={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:G,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:te,excludePattern:re},le=!1;if(this._activeSearchCallbacks[z]=fe=>{if(le)return;const Q=I.URI.revive(fe.resource);fe.results.forEach(pe=>{(0,i.resultIsMatch)(pe)?O({uri:Q,preview:{text:pe.preview.text,matches:(0,r.mapArrayOrNot)(pe.preview.matches,Se=>new u.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,r.mapArrayOrNot)(pe.ranges,Se=>new u.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):O({uri:Q,text:pe.text,lineNumber:pe.lineNumber})})},$.isCancellationRequested)return{};try{const fe=await this._proxy.$startTextSearch(W,(0,m.withUndefinedAsNull)(he),be,z,$);return delete this._activeSearchCallbacks[z],fe||{}}catch(fe){throw delete this._activeSearchCallbacks[z],fe}}$handleTextSearchResult(W,M){this._activeSearchCallbacks[M]?.(W)}saveAll(W){return this._proxy.$saveAll(W)}resolveProxy(W){return this._proxy.$resolveProxy(W)}get trusted(){return this._trusted}requestWorkspaceTrust(W){return this._proxy.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(W,M){if(this._editSessionIdentityProviders.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this._editSessionIdentityProviders.set(W,M);const O=this._uriTransformerService.transformOutgoingScheme(W),H=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(H,O),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(W),this._proxy.$unregisterEditSessionIdentityProvider(H)})}async $getEditSessionIdentifier(W,M){this._logService.info("Getting edit session identifier for workspaceFolder",W);const O=await this.resolveWorkspaceFolder(I.URI.revive(W));if(!O){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const H=this._editSessionIdentityProviders.get(O.uri.scheme);if(this._logService.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!H),!H)return;const $=await H.provideEditSessionIdentity(O,M);if(this._logService.info("Provider returned edit session identifier: ",$),!!$)return $}};j=xe([$e(0,T.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,S.IExtHostFileSystemInfo),$e(3,c.ILogService),$e(4,n.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function U(C){let W,M;return C&&(typeof C=="string"?W=C:(W=C.pattern,M=I.URI.revive(C.baseUri))),{includePattern:W,folder:M}}}),define(Ie[32],Ce([1,0,25,4,31,5,6,153,88,9,15,3,14,11,2]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(u,n){if(n){const i=n.split(".");let o=u;for(let a=0;o&&a<i.length;a++)o=o[i[a]];return o}}function c(u){return u instanceof g.URI}function f(u){return u&&u.uri instanceof g.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function S(u){return u&&u.uri instanceof g.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function h(u){if(c(u))return{resource:u};if(f(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(S(u))return{resource:u.uri};if(u===null)return{resource:null}}let T=class{constructor(n,i,o){this._proxy=n.getProxy(N.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=o,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new s(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(n,i))}};T=xe([$e(0,m.IExtHostRpcService),$e(1,b.IExtHostWorkspace),$e(2,I.ILogService)],T),e.ExtHostConfiguration=T;class s{constructor(n,i,o,a){this._onDidChangeConfiguration=new D.Emitter,this._proxy=n,this._logService=a,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,o))}getConfiguration(n,i,o){const a=h(i)||{},t=this._toReadonlyValue(n?l(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,a,o?.identifier);function d(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(w){return typeof l(t,w)<"u"},get:(w,F)=>{this._validateConfigurationAccess(n?`${n}.${w}`:w,a,o?.identifier);let j=l(t,w);if(typeof j>"u")j=F;else{let U;const C=(W,M)=>{let O;const H=()=>{U=U||(0,r.deepClone)(t),O=O||l(U,M)};return(0,P.isObject)(W)?new Proxy(W,{get:($,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return H(),()=>O;if(U)return O=O||l(U,M),O[z];const G=$[z];return typeof z=="string"?C(G,`${M}.${z}`):G},set:($,z,G)=>(H(),O&&(O[z]=G),!0),deleteProperty:($,z)=>(H(),O&&delete O[z],!0),defineProperty:($,z,G)=>(H(),O&&Object.defineProperty(O,z,G),!0)}):W};j=C(j,w)}return j},update:(w,F,j,U)=>{w=n?`${n}.${w}`:w;const C=d(j);return F!==void 0?this._proxy.$updateConfigurationOption(C,w,F,a,U):this._proxy.$removeConfigurationOption(C,w,a,U)},inspect:w=>{w=n?`${n}.${w}`:w;const F=this._configuration.inspect(w,a,this._extHostWorkspace.workspace);if(F)return{key:w,defaultValue:(0,r.deepClone)(F.policy?.value??F.default?.value),globalValue:(0,r.deepClone)(F.user?.value??F.application?.value),workspaceValue:(0,r.deepClone)(F.workspace?.value),workspaceFolderValue:(0,r.deepClone)(F.workspaceFolder?.value),defaultLanguageValue:(0,r.deepClone)(F.default?.override),globalLanguageValue:(0,r.deepClone)(F.user?.override??F.application?.override),workspaceLanguageValue:(0,r.deepClone)(F.workspace?.override),workspaceFolderLanguageValue:(0,r.deepClone)(F.workspaceFolder?.override),languageIds:(0,r.deepClone)(F.overrideIdentifiers)}}};return typeof t=="object"&&(0,r.mixin)(p,t,!1),Object.freeze(p)}_toReadonlyValue(n){const i=o=>(0,P.isObject)(o)?new Proxy(o,{get:(a,t)=>i(a[t]),set:(a,t,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(t)}' of object`)},deleteProperty:(a,t)=>{throw new Error(`TypeError: Cannot delete read only property '${String(t)}' of object`)},defineProperty:(a,t)=>{throw new Error(`TypeError: Cannot define property '${String(t)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return i(n)}_validateConfigurationAccess(n,i,o){const a=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),t=o?`[${o.value}] `:"";if(a===4){typeof i?.resource>"u"&&this._logService.warn(`${t}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){i?.resource&&this._logService.warn(`${t}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const o=new A.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,t)=>o.affectsConfiguration(a,h(t))})}_toMap(n){return n.reduce((i,o)=>(i.set(o[0],o[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[101],Ce([1,0,2,15,4,5,6,31,52,32,21,55,14,27,3,13,20,11,70,189,12]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(M){function O($){if($!=null)return $}M.from=O;function H($){if($!=null)return $}M.to=H})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(M){function O($){if($!=null)return $}M.from=O;function H($){if($!=null)return $}M.to=H})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(M){function O($){if($!=null)return $}M.from=O;function H($){if($!=null)return $}M.to=H})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(M){function O(z){if(z){const G=z;return G&&!!G.process}else return!1}M.is=O;function H(z){if(z==null)return;const G={process:z.process,args:z.args};return z.options&&(G.options=n.from(z.options)),G}M.from=H;function $(z){if(z!=null)return new _.ProcessExecution(z.process,z.args,z.options)}M.to=$})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(M){function O($){if($!=null)return $}M.from=O;function H($){if($!=null)return $}M.to=H})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(M){function O(z){if(z){const G=z;return G&&(!!G.commandLine||!!G.command)}else return!1}M.is=O;function H(z){if(z==null)return;const G={};return z.commandLine!==void 0?G.commandLine=z.commandLine:(G.command=z.command,G.args=z.args),z.options&&(G.options=o.from(z.options)),G}M.from=H;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new _.ShellExecution(z.commandLine,z.options):new _.ShellExecution(z.command,z.args?z.args:[],z.options)}M.to=$})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var t;(function(M){function O(z){if(z){const G=z;return G&&G.customExecution==="customExecution"}else return!1}M.is=O;function H(z){return{customExecution:"customExecution"}}M.from=H;function $(z,G){return G.get(z)}M.to=$})(t=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(M){function O(H,$){let z;return H.scope!==void 0&&typeof H.scope!="number"?z=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===_.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=S.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:z}}M.from=O})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(M){function O(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}M.from=O})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(M){function O(z,G){if(z==null)return[];const te=[];for(const he of z){const re=H(he,G);re&&te.push(re)}return te}M.fromMany=O;function H(z,G){if(z==null)return;let te;z.execution instanceof _.ProcessExecution?te=i.from(z.execution):z.execution instanceof _.ShellExecution?te=a.from(z.execution):z.execution&&z.execution instanceof _.CustomExecution&&(te=t.from(z.execution));const he=s.from(z.definition);let re;return z.scope?typeof z.scope=="number"?re=z.scope:re=z.scope.uri:re=_.TaskScope.Workspace,!he||!re?void 0:{_id:z._id,definition:he,name:z.name,source:{extensionId:G.identifier.value,label:z.source,scope:re},execution:te,isBackground:z.isBackground,group:p.from(z.group),presentationOptions:u.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}M.from=H;async function $(z,G,te){if(z==null)return;let he;i.is(z.execution)?he=i.to(z.execution):a.is(z.execution)?he=a.to(z.execution):t.is(z.execution)&&(he=t.to(z._id,te));const re=s.to(z.definition);let be;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?be=z.source.scope:be=await G.resolveWorkspaceFolder(r.URI.revive(z.source.scope)):be=_.TaskScope.Workspace),!re||!be)return;const le=new _.Task(re,be,z.name,z.source.label,he,z.problemMatchers);return z.isBackground!==void 0&&(le.isBackground=z.isBackground),z.group!==void 0&&(le.group=_.TaskGroup.from(z.group._id),le.group&&z.group.isDefault&&(le.group=new _.TaskGroup(le.group.id,le.group.label),z.group.isDefault===!0&&(le.group.isDefault=z.group.isDefault))),z.presentationOptions&&(le.presentationOptions=u.to(z.presentationOptions)),z._id&&(le._id=z._id),z.detail&&(le.detail=z.detail),le}M.to=$})(w=e.TaskDTO||(e.TaskDTO={}));var F;(function(M){function O($){return $}M.from=O;function H($){if(!!$)return Object.assign(Object.create(null),$)}M.to=H})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class j{constructor(O,H,$){this._id=H,this._task=$,T.set(this,void 0),Ye(this,T,O,"f")}get task(){return this._task}terminate(){Oe(this,T,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}T=new WeakMap;var U;(function(M){function O(H){return{id:H._id,task:void 0}}M.from=O})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let C=class{constructor(O,H,$,z,G,te,he,re){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=O.getProxy(N.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=z,this._configurationService=G,this._terminalService=te,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=he,this._deprecationService=re,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,H,$){if(!$)return new _.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:H,provider:$,extension:O}),this._proxy.$registerTaskProvider(z,H),new _.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(O,H){this._proxy.$registerTaskSystem(O,H)}fetchTasks(O){return this._proxy.$fetchTasks(F.from(O)).then(async H=>{const $=[];for(const z of H){const G=await w.to(z,this._workspaceProvider,this._providedCustomExecutions2);G&&$.push(G)}return $})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(H=>O.push(H)),O}terminateTask(O){if(!(O instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,H,$){const z=this._providedCustomExecutions2.get(O.id);z&&(this._activeCustomExecutions2.set(O.id,z),this._terminalService.attachPtyToTerminal(H,await z.callback($))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){const H=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:H,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:O.exitCode})}$provideTasks(O,H){const $=this._handlers.get(O);if(!$)return Promise.reject(new Error("no handler found"));const z=[],G=(0,D.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(te=>this.provideTasksInternal(H,z,$,te));return new Promise(te=>{G.then(he=>{Promise.all(z).then(()=>{te(he)})})})}async $resolveTask(O,H){const $=this._handlers.get(O);if(!$)return Promise.reject(new Error("no handler found"));if(H.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await w.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const G=await $.provider.resolveTask(z,R.CancellationToken.None);if(!G)return;this.checkDeprecation(G,$);const te=w.from(G,$.extension);if(!te)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return t.is(te.execution)&&await this.addCustomExecution(te,G,!0),await this.resolveTaskInternal(te)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,H,$){const z=await this._proxy.$createTaskId(O);!$&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,H.execution)),this._providedCustomExecutions2.set(z,H.execution)}async getTaskExecution(O,H){if(typeof O=="string"){const G=this._taskExecutionPromises.get(O);if(!G)throw new h.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return G}const $=this._taskExecutionPromises.get(O.id);if($)return $;const z=new Promise((G,te)=>{function he(re,be,le){le?G(new j(re,be.id,le)):te("Unexpected: Task does not exist.")}H?he(this,O,H):w.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(re=>he(this,O,re))});return this._taskExecutionPromises.set(O.id,z),z.then(G=>(this._taskExecutions.set(O.id,G),G),G=>Promise.reject(G))}checkDeprecation(O,H){O._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));const $=this._notProvidedCustomExecutions.values();let z=$.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=$.next()}};C=xe([$e(0,m.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,E.IExtHostTerminalService),$e(6,f.ILogService),$e(7,v.IExtHostApiDeprecationService)],C),e.ExtHostTaskBase=C;let W=class extends C{constructor(O,H,$,z,G,te,he,re){super(O,H,$,z,G,te,he,re),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask(O,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const $=w.from(H,O);if($===void 0)throw new Error("Task is not valid");if(t.is($.execution))await this.addCustomExecution($,H,!1);else throw new h.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution($),H);return this._proxy.$executeTask($).catch(G=>{throw new Error(G)}),z}provideTasksInternal(O,H,$,z){const G=[];if(z)for(const te of z){this.checkDeprecation(te,$),(!te.definition||!O[te.definition.type])&&this._logService.warn(`The task [${te.source}, ${te.name}] uses an undefined task type. The task will be ignored in the future.`);const he=w.from(te,$.extension);he&&t.is(he.execution)?(G.push(he),H.push(this.addCustomExecution(he,te,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:$.extension}}async resolveTaskInternal(O){if(t.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,H,$){}};W=xe([$e(0,m.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,E.IExtHostTerminalService),$e(6,f.ILogService),$e(7,v.IExtHostApiDeprecationService)],W),e.WorkerExtHostTask=W,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Ie[232],Ce([1,0,19,21,44,34,22,207,43]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,I,g){this.config=m,this.provider=I,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&N.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&N.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const I=this.config.folderQueries||[];return new Promise((g,l)=>{const c=f=>{this.resultCount++,m(f)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const v=f.toString(),S=r.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,S)||this.matchFile(c,{base:f,basename:S})}),Promise.all(I.map(f=>this.searchInFolder(f,c))).then(f=>{g({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{l(new Error((0,b.toErrorMessage)(f)))})})}async searchInFolder(m,I){const g=new D.CancellationTokenSource,l=this.getSearchOptionsForFolder(m),c=this.initDirectoryTree(),f=new y.QueryGlobTester(this.config,m),v=!f.hasSiblingExcludeClauses();let S;try{this.activeCancellationTokens.add(g),S=A.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,g.token),T=S.elapsed(),s=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(u=>{const n=r.posix.relative(m.folder.path,u.path);if(v){const i=r.basename(u.path);this.matchFile(I,{base:m.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(c,m.folder,n,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,f,I),{providerTime:T,postProcessTime:s.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(m){const I=(0,y.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),g=(0,y.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:g,includes:I,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},I,g,l){if(g===this.filePattern){const f=r.basename(this.filePattern);this.matchFile(l,{base:I,relativePath:this.filePattern,basename:f})}function c(f){const v=r.basename(f),S=r.dirname(f);let h=m[S];h||(h=m[S]=[],c(S)),h.push({base:I,relativePath:f,basename:v})}c(g)}matchDirectoryTree({rootEntries:m,pathToEntries:I},g,l){const c=this,f=this.filePattern;function v(S){const h=(0,y.hasSiblingFn)(()=>S.map(T=>T.basename));for(let T=0,s=S.length;T<s;T++){const u=S[T],{relativePath:n,basename:i}=u;if(g.matchesExcludesSync(n,i,f!==i?h:void 0))continue;const o=I[n];if(o)v(o);else{if(n===f)continue;c.matchFile(l,u)}if(c.isLimitHit)break}}v(m)}matchFile(m,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(I))}}class R{constructor(){this.sessions=new Map}fileSearch(m,I,g,l){const c=this.getSessionTokenSource(m.cacheKey),f=new P(m,I,c&&c.token);let v=0;const S=h=>{v+=h.length,g(h.map(T=>this.rawMatchToSearchItem(T)))};return this.doSearch(f,R.BATCH_SIZE,S,l).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:h.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new D.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:_.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,I,g,l){l.onCancellationRequested(()=>{m.cancel()});const c=v=>{v&&(f.push(v),I>0&&f.length>=I&&(g(f),f=[]))};let f=[];return m.search(c).then(v=>(f.length&&g(f),v),v=>(f.length&&g(f),Promise.reject(v)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ie[233],Ce([1,0,18,76,34,81,24,13,19,22,10,9,2,249,144,45,11,48,92,231,43]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let T=class{constructor(p,w,F,j,U){this.configurationService=p,this.workspaceContextService=w,this.editorGroupsService=F,this.logService=j,this.pathService=U}text(p,w,F={}){p=this.getContentPattern(p,F);const j=this.configurationService.getValue(),U=w&&w.some(W=>!this.configurationService.getValue({resource:W}).search.useRipgrep);return{...this.commonQuery(w?.map(f.toWorkspaceFolder),F),type:2,contentPattern:p,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:j.search.usePCRE2||U||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}getContentPattern(p,w){const F=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const j={...p,wordSeparators:F.editor.wordSeparators};return this.isCaseSensitive(p,w)&&(j.isCaseSensitive=!0),this.isMultiline(p)&&(j.isMultiline=!0),j}file(p,w={}){return{...this.commonQuery(p,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(p,w){return p?(p=Array.isArray(p)?p.map(o):o(p),w?this.parseSearchPaths(p):{pattern:u(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],w={}){const F=this.handleIncludeExclude(w.includePattern,w.expandPatterns),j=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),U=p.length>1,C=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(O=>this.getFolderQueryForSearchPath(O,w,j)):p.map(O=>this.getFolderQueryForRoot(O,w,j,U))).filter(O=>!!O),W={_reason:w._reason,folderQueries:C,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:j.pattern,includePattern:F.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=r.coalesce(r.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const H=O.filter(z=>(0,h.pathIncludedInQuery)(W,z.fsPath)),$=this.commonQueryFromFileList(H);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify($)),{...W,...$}}const M=w.extraFileResources&&w.extraFileResources.filter(O=>(0,h.pathIncludedInQuery)(W,O.fsPath));return W.extraFileResources=M&&M.length?M:void 0,W}commonQueryFromFileList(p){const w=[],F=new _.ResourceMap,j={};let U=!1;return p.forEach(C=>{if(C.scheme===A.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(C)){const M=this.workspaceContextService.getWorkspaceFolder(C)?.uri??C.with({path:y.dirname(C.fsPath)});let O=F.get(M);O||(U=!0,O={folder:M,includePattern:{}},w.push(O),F.set(M,O));const H=y.relative(M.fsPath,C.fsPath);(0,E.assertIsDefined)(O.includePattern)[H.replace(/\\/g,"/")]=!0}else C.fsPath&&(U=!0,j[C.fsPath]=!0)}),{folderQueries:w,includePattern:j,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(p,w){if(w.isSmartCase){if(p.isRegExp){if(R.containsUppercaseCharacter(p.pattern,!0))return!0}else if(R.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,I.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const w=$=>y.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),j=(Array.isArray(p)?p:n(p)).map($=>{const z=this.pathService.resolvedUserHome;return z?(0,N.untildify)($,z.scheme===A.Schemas.file?z.fsPath:z.path):$}),U=D.groupBy(j,$=>w($)?"searchPaths":"exprSegments"),C=(U.exprSegments||[]).map($=>R.rtrim($,"/")).map($=>R.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),i($))),W={},M=this.expandSearchPathPatterns(U.searchPaths||[]);M&&M.length&&(W.searchPaths=M);const O=r.flatten(C),H=u(...O);return H&&(W.pattern=H),W}getExcludesForFolder(p,w){return w.disregardExcludeSettings?void 0:(0,h.getExcludes)(p,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const w=r.flatten(p.map(j=>{let{pathPortion:U,globPortion:C}=s(j);C&&(C=a(C));const W=this.expandOneSearchPath(U);return r.flatten(W.map(M=>this.resolveOneSearchPathPattern(M,C)))})),F=new Map;return w.forEach(j=>{const U=j.searchPath.toString(),C=F.get(U);C?j.pattern&&(C.pattern=C.pattern||{},C.pattern[j.pattern]=!0):F.set(U,{searchPath:j.searchPath,pattern:j.pattern?u(j.pattern):void 0})}),Array.from(F.values())}expandOneSearchPath(p){if(y.isAbsolute(p)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==A.Schemas.file?[{searchPath:w[0].uri.with({path:p})}]:[{searchPath:m.URI.file(y.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=o(p),p.startsWith("../")||p===".."){const j=y.posix.resolve(w.path,p);return[{searchPath:w.with({path:j})}]}const F=a(p);return[{searchPath:w,pattern:F}]}else{if(p==="./"||p===".\\")return[];{const w=p.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(U=>{const C=w.match(new RegExp(`^${R.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return C?{match:C,folder:U}:null}).filter(E.isDefined);if(j.length)return j.map(U=>{const C=U.match[1];return{searchPath:U.folder.uri,pattern:C&&a(C)}});{const U=p.match(/\.[\/\\](.+)[\/\\]?/),C=U?U[1]:p,W=g.localize(0,null,C);throw new Error(W)}}}}resolveOneSearchPathPattern(p,w){const F=p.pattern&&w?`${p.pattern}/${w}`:p.pattern||w,j=[{searchPath:p.searchPath,pattern:F}];return F&&!F.endsWith("**")&&j.push({searchPath:p.searchPath,pattern:F+"/**"}),j}getFolderQueryForSearchPath(p,w,F){const j=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(p.searchPath),w,F,!1);return j?{...j,includePattern:p.pattern}:null}getFolderQueryForRoot(p,w,F,j){let U;const C=m.URI.isUri(p)?p:p.uri;if(F.searchPaths){const $=F.searchPaths.filter(z=>(0,P.isEqual)(z.searchPath,C))[0];if($&&!$.pattern)return null;$&&(U=$.pattern)}const W=this.configurationService.getValue({resource:C}),O={...this.getExcludesForFolder(W,w)||{},...U||{}},H=m.URI.isUri(p)?(0,P.basename)(p):p.name;return{folder:C,folderName:j?H:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!W.search.followSymlinks}}};T=xe([$e(0,l.IConfigurationService),$e(1,f.IWorkspaceContextService),$e(2,v.IEditorGroupsService),$e(3,c.ILogService),$e(4,S.IPathService)],T),e.QueryBuilder=T;function s(d){const p=d.match(/[\*\{\}\(\)\[\]\?]/);if(p){const w=p.index,F=d.substr(0,w).match(/[/|\\][^/\\]*$/);if(F){let j=d.substr(0,F.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:d.substr((F.index||0)+1)}}}return{pathPortion:d}}function u(...d){return d.length?d.reduce((p,w)=>(p[w]=!0,p),Object.create(null)):void 0}function n(d){return b.splitGlobAware(d,",").map(p=>p.trim()).filter(p=>!!p.length)}function i(d){return[`**/${d}/**`,`**/${d}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function o(d){return d.replace(/\\/g,"/")}function a(d){return o(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function t(d,p){d=r.distinct(d,j=>j.toString());const w=[],F=p.getWorkspace();return d&&d.forEach(j=>{let U;if(p.getWorkbenchState()===2)U=(0,P.relativePath)(F.folders[0].uri,j),U&&U!=="."&&(U="./"+U);else{const C=p.getWorkspaceFolder(j);if(C){const W=C.name;if(F.folders.filter(O=>O.name===W).length===1){const O=(0,P.relativePath)(C.uri,j);O===""?U=`./${C.name}`:U=`./${C.name}/${O}`}else U=j.fsPath}}U&&w.push(U)}),w}e.resolveResourcesForSearchIncludes=t}),define(Ie[234],Ce([1,0,22,2,21,12,3,233,43,48]),function(ne,e,r,D,b,N,_,A,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function E(l,c){const f=c.activationEvents;if(!f)return Promise.resolve(void 0);const v=[],S=[];for(const i of f)if(/^workspaceContains:/.test(i)){const o=i.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||l.forceUsingSearch?S.push(o):v.push(o)}if(v.length===0&&S.length===0)return Promise.resolve(void 0);let h;const T=new Promise((i,o)=>{h=i}),s=i=>h({activationEvent:i}),u=Promise.all(v.map(i=>m(l,i,s))).then(()=>{}),n=I(l,c.identifier,S,s);return Promise.all([u,n]).then(()=>{h(void 0)}),T}e.checkActivateWorkspaceContainsExtension=E;async function m(l,c,f){for(const v of l.folders)if(await l.exists(r.joinPath(D.URI.revive(v),c))){f(`workspaceContains:${c}`);return}}async function I(l,c,f,v){if(f.length===0)return Promise.resolve(void 0);const S=new b.CancellationTokenSource,h=l.checkExists(l.folders,f,S.token),T=setTimeout(async()=>{S.cancel(),l.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},R);let s=!1;try{s=await h}catch(u){N.isCancellationError(u)||N.onUnexpectedError(u)}S.dispose(),clearTimeout(T),s&&v(`workspaceContains:${f.join(",")}`)}function g(l,c,f,v){const S=l.get(_.IInstantiationService),h=l.get(y.ISearchService),s=S.createInstance(A.QueryBuilder).file(c.map(u=>(0,P.toWorkspaceFolder)(D.URI.revive(u))),{_reason:"checkExists",includePattern:f,exists:!0});return h.fileSearch(s,v).then(u=>!!u.limitHit,u=>N.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=g});var Ye=this&&this.__classPrivateFieldSet||function(ne,e,r,D,b){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?b.call(ne,r):b?b.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,D){if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!D:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?D:r==="a"?D.call(ne):D?D.value:e.get(ne)};define(Ie[33],Ce([1,0,131,19,75,22,15,7,24,2,11,5,32,178,73,31,28,177,12,26,23,162,6,89,3,27,74,14,59,63,55,4,234,72,164,13,71]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h,T,s,u,n,i,o,a,t,d,p,w,F,j,U,C,W){"use strict";var M,O,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let $=class Fi extends A.Disposable{constructor(le,fe,Q,pe,Se,Fe,Ue,Xe,ke,ye,De){super(),this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=fe,this._extHostContext=Q,this._initData=Ue,this._extHostWorkspace=pe,this._extHostConfiguration=Se,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=De,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const ae=(0,c.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(te(this._globalRegistry,ae)),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=le.createChild(new t.ServiceCollection([g.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let ue=[],ee=[];this._initData.remote.isRemote&&(ue=this._initData.allExtensions.filter(k=>!k.main&&!k.browser).map(k=>k.identifier),ee=this._initData.allExtensions.filter(k=>!ae.has(S.ExtensionIdentifier.toKey(k.identifier.value))).filter(k=>(k.main||k.browser)&&k.api==="none").map(k=>k.identifier));const Z=(0,c.extensionIdentifiersArrayToSet)(ee);this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,ue,ee,{onExtensionActivationError:(k,B,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(k,v.transformErrorForSerialization(B),V)},actualActivateExtension:async(k,B)=>{if(Z.has(S.ExtensionIdentifier.toKey(k)))return await this._mainThreadExtensionsProxy.$activateExtension(k,B),new I.HostExtension;const V=this._myRegistry.getExtensionDescription(k);return this._activateExtension(V,B)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(le){v.onUnexpectedError(le)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let le=[];try{le=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(le)}terminate(le,fe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${le}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(pe=>{this._logService.error(pe)}),this._extHostContext.dispose();const Q=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),Q]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${fe}`):this._logService.info(`Extension host exiting with code ${fe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(fe)})}isActivated(le){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(le):!1}async getExtension(le){const fe=await this._mainThreadExtensionsProxy.$getExtension(le);let Q;if(fe?.browserNlsBundleUris){Q={};for(const pe of Object.keys(fe.browserNlsBundleUris))Q[pe]=P.URI.revive(fe.browserNlsBundleUris[pe])}return fe&&{...fe,identifier:new S.ExtensionIdentifier(fe.identifier.value),extensionLocation:P.URI.revive(fe.extensionLocation),browserNlsBundleUris:Q}}_activateByEvent(le,fe){return this._activator.activateByEvent(le,fe)}_activateById(le,fe){return this._activator.activateById(le,fe)}activateByIdWithErrors(le,fe){return this._activateById(le,fe).then(()=>{const Q=this._activator.getActivatedExtension(le);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(le=>this._myRegistry)}getExtensionExports(le){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(le).exports:null}async _realPathExtensionUri(le){if(le.scheme!==C.Schemas.file)return le;const fe=await this._hostUtils.realpath(le.fsPath);return P.URI.file(fe)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(le=>new re(le))),this._extensionPathIndex}async _createExtensionPathIndex(le){const fe=y.TernarySearchTree.forUris(Q=>N.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(le.map(async Q=>{if(this._getEntryPoint(Q)){const pe=await this._realPathExtensionUri(Q.extensionLocation);fe.set(pe,Q)}})),fe}_deactivate(le){let fe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(le))return fe;const Q=this._activator.getActivatedExtension(le);if(!Q)return fe;try{typeof Q.module.deactivate=="function"&&(fe=Promise.resolve(Q.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${le.value}':`),this._logService.error(pe)}try{(0,A.dispose)(Q.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this._logService.error(pe)}return fe}async _activateExtension(le,fe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(le.identifier),this._doActivateExtension(le,fe).then(Q=>{const pe=Q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(le.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,fe),this._logExtensionActivationTimes(le,fe,"success",pe),Q},Q=>{throw this._logExtensionActivationTimes(le,fe,"failure"),Q})}_logExtensionActivationTimes(le,fe,Q,pe){const Se=z(le,fe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...pe||{},outcome:Q})}_doActivateExtension(le,fe){const Q=z(le,fe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Q);const pe=this._getEntryPoint(le);if(!pe)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${le.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this._logService.flush();const Se=new I.ExtensionActivationTimesBuilder(fe.startup);return Promise.all([this._loadCommonJSModule(le,(0,N.joinPath)(le.extensionLocation,pe),Se),this._loadExtensionContext(le)]).then(Fe=>(b.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),Fi._callActivate(this._logService,le.identifier,Fe[0],Fe[1],Se))).then(Fe=>(b.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),Fe))}_loadExtensionContext(le){const fe=new T.ExtensionGlobalMemento(le,this._storage),Q=new T.ExtensionMemento(le.identifier.value,!1,this._storage),pe=new U.ExtensionSecrets(le,this._secretState),Se=le.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Fe=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([fe.whenReady,Q.whenReady,this._storagePath.whenReady]).then(()=>{const Ue=this;let Xe,ke;const ye=(0,c.isProposedApiEnabled)(le,"ipc")?this._initData.messagePorts?.get(S.ExtensionIdentifier.toKey(le.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:Q,secrets:pe,subscriptions:[],get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(De){return D.join(le.extensionLocation.fsPath,De)},get storagePath(){return Ue._storagePath.workspaceValue(le)?.fsPath},get globalStoragePath(){return Ue._storagePath.globalValue(le).fsPath},get logPath(){return D.join(Ue._initData.logsLocation.fsPath,le.identifier.value)},get logUri(){return P.URI.joinPath(Ue._initData.logsLocation,le.identifier.value)},get storageUri(){return Ue._storagePath.workspaceValue(le)},get globalStorageUri(){return Ue._storagePath.globalValue(le)},get extensionMode(){return Se},get extension(){return Xe===void 0&&(Xe=new G(Ue,le.identifier,le,Fe,!1)),Xe},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(le,"extensionRuntime"),Ue.extensionRuntime},get environmentVariableCollection(){return Ue._extHostTerminalService.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!ke){if(!ye)return;const De=w.Event.buffer(w.Event.fromDOMEventEmitter(ye,"message",ae=>ae.data));ye.start(),ke={onDidReceiveMessage:De,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(le,fe,Q,pe,Se){return Q=Q||{activate:void 0,deactivate:void 0},this._callActivateOptional(le,fe,Q,pe,Se).then(Fe=>new I.ActivatedExtension(!1,null,Se.build(),Q,Fe,pe.subscriptions))}static _callActivateOptional(le,fe,Q,pe,Se){if(typeof Q.activate=="function")try{Se.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const Fe=typeof global=="object"?global:self,Ue=Q.activate.apply(Fe,[pe]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(Ue).then(Xe=>(Se.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(Q)}_activateOneStartupFinished(le,fe){this._activateById(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:fe}).then(void 0,Q=>{this._logService.error(Q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const le of this._myRegistry.getAllExtensionDescriptions())if(le.activationEvents)for(const fe of le.activationEvents)fe==="onStartupFinished"&&this._activateOneStartupFinished(le,fe)}_handleEagerExtensions(){const le=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const fe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Q=this._handleWorkspaceContainsEagerExtensions(fe),pe=Promise.all([le,Q]).then(()=>{});return Promise.race([pe,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(le){return le.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(fe=>this._handleWorkspaceContainsEagerExtension(le,fe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(le,fe){if(this.isActivated(fe.identifier))return;const Q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:le.map(Fe=>Fe.uri),forceUsingSearch:Q,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ue,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ue,Xe)},Se=await(0,F.checkActivateWorkspaceContainsExtension)(pe,fe);if(!!Se)return this._activateById(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:Se.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(le){throw console.error(le),le}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:fe}=this._initData.environment;if(!le||!fe)throw new Error(r.localize(0,null));const Q=await this._loadCommonJSModule(null,fe,new I.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(r.localize(1,null,fe.toString()));return new Promise((pe,Se)=>{const Fe=(ke,ye)=>{ke?Se(ke):pe(typeof ye=="number"&&ye>0?1:0)},Ue=(0,N.originalFSPath)(fe),Xe=Q.run(Ue,Fe);Xe&&Xe.then&&Xe.then(()=>{pe(0)}).catch(ke=>{Se(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,fe){return this._resolvers[le]=fe,(0,A.toDisposable)(()=>{delete this._resolvers[le]})}async _activateAndGetResolver(le){const fe=le.indexOf("+");if(fe===-1)throw new Error("Not an authority that can be resolved!");const Q=le.substr(0,fe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this._resolvers[Q]}}async $resolveAuthority(le,fe){this._logService.info(`$resolveAuthority invoked for authority (${he(le)})`);const{authorityPrefix:Q,resolver:pe}=await this._activateAndGetResolver(le);if(!pe)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),b.mark(`code/extHost/willResolveAuthority/${Q}`);const Se=await pe.resolve(le,{resolveAttempt:fe});b.mark(`code/extHost/didResolveAuthorityOK/${Q}`);const Fe={authority:le,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},Ue={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Ue,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(b.mark(`code/extHost/didResolveAuthorityError/${Q}`),Se instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(le,fe){this._logService.info(`$getCanonicalURI invoked for authority (${he(le)})`);const{resolver:Q}=await this._activateAndGetResolver(le);if(!Q)return null;const pe=P.URI.revive(fe);if(typeof Q.getCanonicalURI>"u")return pe;const Se=await(0,_.asPromise)(()=>Q.getCanonicalURI(pe));return Se||pe}static _applyExtensionsDelta(le,fe,Q){const pe=new f.ExtensionDescriptionRegistry(le.getAllExtensionDescriptions());pe.deltaExtensions(Q.toAdd,Q.toRemove);const Se=(0,c.extensionIdentifiersArrayToSet)(fe.getAllExtensionDescriptions().map(Ue=>Ue.identifier));for(const Ue of Q.myToRemove)Se.delete(S.ExtensionIdentifier.toKey(Ue));for(const Ue of Q.myToAdd)Se.add(S.ExtensionIdentifier.toKey(Ue));const Fe=te(pe,Se);return{globalRegistry:pe,myExtensions:Fe}}$startExtensionHost(le){le.toAdd.forEach(pe=>pe.extensionLocation=P.URI.revive(pe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le);return this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),this._startExtensionHost()}$activateByEvent(le,fe){return fe===1?this._activateByEvent(le,!1):this._readyToRunExtensions.wait().then(Q=>this._activateByEvent(le,!1))}async $activate(le,fe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(le)?(await this._activateById(le,fe),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(Fe=>Fe.extensionLocation=P.URI.revive(Fe.extensionLocation));const{globalRegistry:fe,myExtensions:Q}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,le),pe=await this._createExtensionPathIndex(Q);return(await this.getExtensionPathIndex()).setSearchTree(pe),this._globalRegistry.set(fe.getAllExtensionDescriptions()),this._myRegistry.set(Q),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const fe=h.VSBuffer.alloc(le),Q=Math.random()%256;for(let pe=0;pe<le;pe++)fe.writeUInt8(Q,pe);return fe}async $updateRemoteConnectionData(le){this._remoteConnectionData=le,this._onDidChangeRemoteConnectionData.fire()}};$=xe([$e(0,n.IInstantiationService),$e(1,e.IHostUtils),$e(2,a.IExtHostRpcService),$e(3,l.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,R.ILogService),$e(6,i.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,d.IExtHostTunnelService),$e(9,p.IExtHostTerminalService),$e(10,W.IExtHostLocalizationService)],$),e.AbstractExtHostExtensionService=$;function z(be,le){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class G{constructor(le,fe,Q,pe,Se){M.set(this,void 0),O.set(this,void 0),H.set(this,void 0),Ye(this,M,le,"f"),Ye(this,O,fe,"f"),Ye(this,H,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=D.normalize((0,N.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=pe,this.isFromDifferentExtensionHost=Se}get isActive(){return Oe(this,M,"f").isActivated(Oe(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,M,"f").getExtensionExports(Oe(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,M,"f").activateByIdWithErrors(Oe(this,H,"f"),{startup:!1,extensionId:Oe(this,O,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,M=new WeakMap,O=new WeakMap,H=new WeakMap;function te(be,le){return be.getAllExtensionDescriptions().filter(fe=>le.has(S.ExtensionIdentifier.toKey(fe.identifier)))}function he(be){const le=be.indexOf("+");return le===-1?be:be.substring(0,le)}class re{constructor(le){this._searchTree=le}setSearchTree(le){this._searchTree=le}findSubstr(le){return this._searchTree.findSubstr(le)}forEach(le){return this._searchTree.forEach(le)}}e.ExtensionPaths=re}),define(Ie[235],Ce([1,0,75,2,5,32,28,26,14,27,3,33,47,11,10]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(T,s,u,n,i,o,a){this._apiFactory=T,this._extensionRegistry=s,this._instaService=u,this._extHostConfiguration=n,this._extHostExtensionService=i,this._initData=o,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const T=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,s,this._extensionRegistry,T,this._logService)),this.register(this._instaService.createInstance(v,s)),this.register(this._instaService.createInstance(c)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,s,this._initData.environment.appUriScheme))}register(T){if("nodeModuleName"in T)if(Array.isArray(T.nodeModuleName))for(const s of T.nodeModuleName)this._factories.set(s,T);else this._factories.set(T.nodeModuleName,T);typeof T.alternativeModuleName=="function"&&this._alternatives.push(s=>T.alternativeModuleName(s))}};l=xe([$e(2,R.IInstantiationService),$e(3,N.IExtHostConfiguration),$e(4,E.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,I.ILogService)],l),e.RequireInterceptor=l;let c=class Qi{constructor(T){if(T.environment.appRoot&&Qi.aliased.size){const s=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(T.environment.appRoot.fsPath)),u="[a-z0-9_.-]",n=`@${u}+\\/${u}+|${u}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${i}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(T){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(T));if(!s)return;const[,u,n,i]=s,o=Qi.aliased.get(n);if(o!==void 0)return console.warn(`${n} as been renamed to ${o}, please update your imports`),u+o+i}forceForwardSlashes(T){return T.replace(/\\/g,"/")}};c.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),c=xe([$e(0,P.IExtHostInitDataService)],c);class f{constructor(T,s,u,n,i){this._apiFactory=T,this._extensionPaths=s,this._extensionRegistry=u,this._configProvider=n,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(T,s){const u=this._extensionPaths.findSubstr(s);if(u){let n=this._extApiImpl.get(A.ExtensionIdentifier.toKey(u.identifier));return n||(n=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(u.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((i,o)=>n+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(T,s,u){this._extensionPaths=T,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(b.MainContext.MainThreadTelemetry);const{environment:n}=u,i=s.getProxy(b.MainContext.MainThreadKeytar);if(n.appRoot){let o=n.appRoot.fsPath;m.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,a)=>i.$getPassword(o,a),setPassword:(o,a,t)=>i.$setPassword(o,a,t),deletePassword:(o,a)=>i.$deletePassword(o,a),findPassword:o=>i.$findPassword(o),findCredentials(o){return i.$findCredentials(o)}}}load(T,s){const u=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(T){const s=T.length;if(s<=7||!this.alternativeNames)return;const u=s-7;if((T.charAt(u)==="/"||T.charAt(u)==="\\")&&T.endsWith("keytar")&&(T=T.replace(/\\/g,"/"),this.alternativeNames.has(T)))return"keytar"}};v=xe([$e(1,y.IExtHostRpcService),$e(2,P.IExtHostInitDataService)],v);let S=class{constructor(T,s,u){this._extensionPaths=T,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(b.MainContext.MainThreadTelemetry);const n=u.getProxy(b.MainContext.MainThreadWindow);this._impl=(i,o)=>{const a=D.URI.parse(i);return o?this.callOriginal(i,o):a.scheme==="http"||a.scheme==="https"?n.$openUri(a,i,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?n.$openUri(a,i,{}):this.callOriginal(i,o)}}load(T,s,u){const n=this._extensionPaths.findSubstr(s);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=u(T),this._impl}callOriginal(T,s){return this.sendNoForwardTelemetry(),this._original(T,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=xe([$e(2,y.IExtHostRpcService)],S)}),define(Ie[102],Ce([1,0,201,7,19,47,3,52,53,33,6,31,174,32]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class g extends m.AbstractVariableResolverService{constructor(f,v,S,h,T,s,u){function n(){if(S){const i=S.activeEditor();if(i)return i.document.uri;const o=h.tabGroups.all.find(a=>a.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof R.TextDiffTabInput||o.input instanceof R.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof R.TextTabInput||o.input instanceof R.NotebookEditorTabInput||o.input instanceof R.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:i=>{const o=s.folders.filter(a=>a.name===i);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(i,o)=>T.getConfiguration(void 0,i).get(o),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=n();if(i)return b.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const i=n();if(i){const o=v.getWorkspaceFolder(i);if(o)return b.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(S){const i=S.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(S){const i=S.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>f.getExtension(i)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(N.env))}}let l=class extends D.Disposable{constructor(f,v,S,h,T){super(),this.extensionService=f,this.workspaceService=v,this.editorService=S,this.configurationService=h,this.editorTabs=T,this._resolver=new r.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new g(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};l=xe([$e(0,P.IExtHostExtensionService),$e(1,E.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,I.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],l),e.ExtHostVariableResolverProviderService=l}),define(Ie[103],Ce([1,0,15,4,9,2,3,5,53,33,14,6,31,167,169,32,102]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,i,o,a,t,d){this._workspaceService=i,this._extensionService=o,this._configurationService=a,this._editorTabs=t,this._variableResolver=d,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new S(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(w=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}asDebugSourceUri(n,i){const o=n;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let a=`debug:${encodeURIComponent(o.path||"")}`,t="?";return i&&(a+=`${t}session=${encodeURIComponent(i.id)}`,t="&"),a+=`${t}ref=${o.sourceReference}`,N.URI.parse(a)}else{if(o.path)return N.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const i=[];for(const o of n.getAllExtensionDescriptions())if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0)for(const t of a)(0,g.isDebuggerMainContribution)(t)&&i.push(t.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(i=>n.push(i)),n}addBreakpoints(n){this.startBreakpoints();const i=n.filter(t=>{const d=t.id;return this._breakpoints.has(d)?!1:(this._breakpoints.set(d,t),!0)});this.fireBreakpointChanges(i,[],[]);const o=[],a=new Map;for(const t of i)if(t instanceof E.SourceBreakpoint){let d=a.get(t.location.uri.toString());d||(d={type:"sourceMulti",uri:t.location.uri,lines:[]},a.set(t.location.uri.toString(),d),o.push(d)),d.lines.push({id:t.id,enabled:t.enabled,condition:t.condition,hitCondition:t.hitCondition,logMessage:t.logMessage,line:t.location.range.start.line,character:t.location.range.start.character})}else t instanceof E.FunctionBreakpoint&&o.push({type:"function",id:t.id,enabled:t.enabled,hitCondition:t.hitCondition,logMessage:t.logMessage,condition:t.condition,functionName:t.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(n){this.startBreakpoints();const i=n.filter(d=>this._breakpoints.delete(d.id));this.fireBreakpointChanges([],i,[]);const o=i.filter(d=>d instanceof E.SourceBreakpoint).map(d=>d.id),a=i.filter(d=>d instanceof E.FunctionBreakpoint).map(d=>d.id),t=i.filter(d=>d instanceof E.DataBreakpoint).map(d=>d.id);return this._debugServiceProxy.$unregisterBreakpoints(o,a,t)}startDebugging(n,i,o){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,i,o){if(!i)return new E.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:a,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,a),new E.Disposable(()=>{this._configProviders=this._configProviders.filter(t=>t.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(n,i,o){if(!o)return new E.Disposable(()=>{});if(!this.definesDebugType(n,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:a,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,a),new E.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(t=>t.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(n,i){if(!i)return new E.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:o,factory:i}),new E.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==i)})}async $runInTerminal(n,i){return Promise.resolve(void 0)}async $substituteVariables(n,i){let o;const a=await this.getFolder(n);return a&&(o={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,i)}createDebugAdapter(n,i){if(n.type==="implementation")return new T(n.implementation)}createSignService(){}async $startDASession(n,i){const o=this,a=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(t=>{if(!t)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const d=this.convertToDto(t),p=this.createDebugAdapter(d,a);if(!p)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const w=p;return this._debugAdapters.set(n,w),this.getDebugAdapterTrackers(a).then(F=>(F&&this._debugAdaptersTrackers.set(n,F),w.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const U=j,C={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(U.arguments.value);C.body={signature:W},w.sendResponse(C)}else throw new Error("no signer")}catch(W){C.success=!1,C.message=W.message,w.sendResponse(C)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(j),j=(0,g.convertToVSCPaths)(j,!0),o._debugServiceProxy.$acceptDAMessage(n,j)}),w.onError(j=>{F&&F.onError&&F.onError(j),this._debugServiceProxy.$acceptDAError(n,j.name,j.message,j.stack)}),w.onExit(j=>{F&&F.onExit&&F.onExit((0,b.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,b.withNullAsUndefined)(j),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),w.startSession()))})}$sendDAMessage(n,i){i=(0,g.convertToDAPaths)(i,!1);const o=this._debugAdaptersTrackers.get(n);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this._debugAdapters.get(n)?.sendMessage(i)}$stopDASession(n){const i=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),i&&i.onWillStopSession&&i.onWillStopSession();const o=this._debugAdapters.get(n);return this._debugAdapters.delete(n),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const i=[],o=[],a=[];if(n.added)for(const t of n.added){const d=t.id;if(d&&!this._breakpoints.has(d)){let p;if(t.type==="function")p=new E.FunctionBreakpoint(t.functionName,t.enabled,t.condition,t.hitCondition,t.logMessage);else if(t.type==="data")p=new E.DataBreakpoint(t.label,t.dataId,t.canPersist,t.enabled,t.hitCondition,t.condition,t.logMessage);else{const w=N.URI.revive(t.uri);p=new E.SourceBreakpoint(new E.Location(w,new E.Position(t.line,t.character)),t.enabled,t.condition,t.hitCondition,t.logMessage)}p._id=d,this._breakpoints.set(d,p),i.push(p)}}if(n.removed)for(const t of n.removed){const d=this._breakpoints.get(t);d&&(this._breakpoints.delete(t),o.push(d))}if(n.changed){for(const t of n.changed)if(t.id){const d=this._breakpoints.get(t.id);if(d){if(d instanceof E.FunctionBreakpoint&&t.type==="function"){const p=d;p.enabled=t.enabled,p.condition=t.condition,p.hitCondition=t.hitCondition,p.logMessage=t.logMessage,p.functionName=t.functionName}else if(d instanceof E.SourceBreakpoint&&t.type==="source"){const p=d;p.enabled=t.enabled,p.condition=t.condition,p.hitCondition=t.hitCondition,p.logMessage=t.logMessage,p.location=new E.Location(N.URI.revive(t.uri),new E.Position(t.line,t.character))}a.push(d)}}}this.fireBreakpointChanges(i,o,a)}$provideDebugConfigurations(n,i,o){return(0,r.asPromise)(async()=>{const a=this.getConfigProviderByHandle(n);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const t=await this.getFolder(i);return a.provideDebugConfigurations(t,o)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(n,i,o,a){return(0,r.asPromise)(async()=>{const t=this.getConfigProviderByHandle(n);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const d=await this.getFolder(i);return t.resolveDebugConfiguration(d,o,a)})}$resolveDebugConfigurationWithSubstitutedVariables(n,i,o,a){return(0,r.asPromise)(async()=>{const t=this.getConfigProviderByHandle(n);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const d=await this.getFolder(i);return t.resolveDebugConfigurationWithSubstitutedVariables(d,o,a)})}async $provideDebugAdapter(n,i){const o=this.getAdapterDescriptorFactoryByHandle(n);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(i);return this.getAdapterDescriptor(o,a).then(t=>{if(!t)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(t)})}async $acceptDebugSessionStarted(n){const i=await this.getSession(n);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(n){const i=await this.getSession(n);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,i){(await this.getSession(n))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(n,i){const a={session:await this.getSession(n),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(n){if(n instanceof E.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof E.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const i=this._adapterFactories.filter(o=>o.type===n);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(n){const i=this._adapterFactories.filter(o=>o.handle===n);if(i.length>0)return i[0].factory}getConfigProviderByHandle(n){const i=this._configProviders.filter(o=>o.handle===n);if(i.length>0)return i[0].provider}definesDebugType(n,i){if(n.contributes){const o=n.contributes.debuggers;if(o&&o.length>0){for(const a of o)if(a.label&&a.type&&a.type===i)return!0}}return!1}getDebugAdapterTrackers(n){const o=n.configuration.type,a=this._trackerFactories.filter(t=>t.type===o||t.type==="*").map(t=>(0,r.asPromise)(()=>t.factory.createDebugAdapterTracker(n)).then(d=>d,d=>null));return Promise.race([Promise.all(a).then(t=>{const d=t.filter(p=>!!p);if(d.length>0)return new h(d)}),new Promise((t,d)=>{const p=setTimeout(()=>{clearTimeout(p),d(new Error("timeout"))},1e3)})]).catch(t=>{})}async getAdapterDescriptor(n,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new E.DebugAdapterServer(o));if(n){const t=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>n.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,t))).then(d=>{if(d)return d})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,a))}daExecutableFromPackage(n,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,i,o){(n.length>0||i.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:i,changed:o}))}async getSession(n){if(n)if(typeof n=="string"){const i=this._debugSessions.get(n);if(i)return i}else{let i=this._debugSessions.get(n.id);if(!i){const o=await this.getFolder(n.folderUri),a=n.parent?this._debugSessions.get(n.parent):void 0;i=new v(this._debugServiceProxy,n.id,n.type,n.name,o,n.configuration,a),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(n){if(n){const i=N.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};f=xe([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,l.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,c.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class v{constructor(n,i,o,a,t,d,p){this._debugServiceProxy=n,this._id=i,this._type=o,this._name=a,this._workspaceFolder=t,this._configuration=d,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,i)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=v;class S{constructor(n){this.value=Object.freeze({append(i){n.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=S;class h{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(i=>i.onError?i.onError(n):void 0)}onExit(n,i){this.trackers.forEach(o=>o.onExit?o.onExit(n,i):void 0)}}class T extends I.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends f{constructor(n,i,o,a,t,d){super(n,i,o,a,t,d)}};s=xe([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,l.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,c.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Ie[236],Ce([1,0,12,75,2,5,227,11,58,59,27,148,14,49,33,68]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{static async installEarlyHandler(S){const h=S.get(A.ILogService),s=S.get(m.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(u=>{h.error(u);const n=r.transformErrorForSerialization(u);s.$onUnexpectedError(n)})}static async installFullHandler(S){const h=S.get(A.ILogService),T=S.get(m.IExtHostRpcService),s=S.get(g.IExtHostExtensionService),u=S.get(l.IExtHostTelemetry),n=T.getProxy(N.MainContext.MainThreadExtensionService),i=T.getProxy(N.MainContext.MainThreadErrors),o=await s.getExtensionPathIndex(),a=new WeakMap;Error.prepareStackTrace=(t,d)=>{let p="",w,F;for(const j of d)p+=`
	at ${j.toString()}`,F=j.getFileName(),!w&&F&&(w=o.findSubstr(b.URI.file(F)));return a.set(t,w?.identifier),`${t.name||"Error"}: ${t.message||""}${p}`},r.setUnexpectedErrorHandler(t=>{h.error(t);const d=r.transformErrorForSerialization(t),p=a.get(t);if(!p){i.$onUnexpectedError(d);return}n.$onExtensionRuntimeError(p,d);const w=u.onExtensionError(p,t);h.trace("forwarded error to extension?",w,p)})}}Error.stackTraceLimit=100;class f{constructor(S,h,T,s,u){this._hostUtils=T,this._rpcProtocol=new _.RPCProtocol(S,null,s),h=f._transform(h,this._rpcProtocol);const n=new P.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...h,messagePorts:u}),n.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),n.set(I.IURITransformerService,new I.URITransformerService(s)),n.set(g.IHostUtils,T);const i=new E.InstantiationService(n,!0);i.invokeFunction(c.installEarlyHandler),this._logService=i.invokeFunction(o=>o.get(A.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",h),this._extensionService=i.invokeFunction(o=>o.get(g.IExtHostExtensionService)),this._extensionService.initialize(),i.invokeFunction(c.installFullHandler)}async asBrowserUri(S){const h=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService);return b.URI.revive(await h.$asBrowserUri(S))}terminate(S){this._extensionService.terminate(S)}static _transform(S,h){S.allExtensions.forEach(s=>{s.extensionLocation=b.URI.revive(h.transformIncomingURIs(s.extensionLocation));const u={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(n=>u[n]=b.URI.revive(h.transformIncomingURIs(s.browserNlsBundleUris[n]))),s.browserNlsBundleUris=u)}),S.environment.appRoot=b.URI.revive(h.transformIncomingURIs(S.environment.appRoot));const T=S.environment.extensionDevelopmentLocationURI;return T&&(S.environment.extensionDevelopmentLocationURI=T.map(s=>b.URI.revive(h.transformIncomingURIs(s)))),S.environment.extensionTestsLocationURI=b.URI.revive(h.transformIncomingURIs(S.environment.extensionTestsLocationURI)),S.environment.globalStorageHome=b.URI.revive(h.transformIncomingURIs(S.environment.globalStorageHome)),S.environment.workspaceStorageHome=b.URI.revive(h.transformIncomingURIs(S.environment.workspaceStorageHome)),S.nlsBaseUrl=b.URI.revive(h.transformIncomingURIs(S.nlsBaseUrl)),S.logsLocation=b.URI.revive(h.transformIncomingURIs(S.logsLocation)),S.logFile=b.URI.revive(h.transformIncomingURIs(S.logFile)),S.workspace=h.transformIncomingURIs(S.workspace),S}}e.ExtensionHostMain=f}),define(Ie[237],Ce([1,0,18,15,21,44,13,19,22,2,43]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(v,S,h,T){this.query=v,this.provider=S,this.fileUtils=h,this.processType=T,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,S){const h=this.query.folderQueries||[],T=new b.CancellationTokenSource;return S.onCancellationRequested(()=>T.cancel()),new Promise((s,u)=>{this.collector=new I(v);let n=!1;const i=(o,a)=>{if(!n&&!this.isLimitHit){const t=this.resultSize(o);l(o)&&typeof this.query.maxResults=="number"&&this.resultCount+t>this.query.maxResults&&(this.isLimitHit=!0,n=!0,T.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const d=this.resultSize(o);this.resultCount+=d,(d>0||!l(o))&&this.collector.add(o,a)}};Promise.all(h.map((o,a)=>this.searchInFolder(o,t=>i(t,a),T.token))).then(o=>{T.dispose(),this.collector.flush();const a=o.some(t=>!!t&&!!t.limitHit);s({limitHit:this.isLimitHit||a,messages:(0,r.flatten)(o.map(t=>t?.message?Array.isArray(t.message)?t.message:[t.message]:[])),stats:{type:this.processType}})},o=>{T.dispose();const a=(0,N.toErrorMessage)(o);u(new Error(a))})})}resultSize(v){return l(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,S){const h=Array.isArray(v.ranges)?v.ranges:[v.ranges],T=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:h.slice(0,S),preview:{matches:T.slice(0,S),text:v.preview.text},uri:v.uri}}async searchInFolder(v,S,h){const T=new R.QueryGlobTester(this.query,v),s=[],u={report:o=>{if(!this.validateProviderResult(o))return;const a=v.folder.scheme===_.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(o.uri))):void 0,t=y.relativePath(v.folder,o.uri);if(t){const d=T.includedInQuery(t,A.basename(t),a);(0,D.isThenable)(d)?s.push(d.then(p=>{p&&S(o)})):d&&S(o)}}},n=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,u,h);return s.length&&await Promise.all(s),i}validateProviderResult(v){if(l(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const S=(0,R.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),h=(0,R.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),T={folder:P.URI.from(v.folder),excludes:h,includes:S,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return T.usePCRE2=this.query.usePCRE2,T}}e.TextSearchManager=E;function m(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class I{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new c(512,S=>this.sendItems(S))}add(v,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!y.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(g(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=I;function g(f){return l(f)?{preview:{matches:(0,r.mapArrayOrNot)(f.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:f.preview.text},ranges:(0,r.mapArrayOrNot)(f.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function l(f){return!!f.preview}e.extensionResultIsMatch=l;class c{constructor(v,S){this.maxBatchSize=v,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,S){!v||this.addItemToBatch(v,S)}addItems(v,S){!v||this.addItemsToBatch(v,S)}addItemToBatch(v,S){this.batch.push(v),this.batchSize+=S,this.onUpdate()}addItemsToBatch(v,S){this.batch=this.batch.concat(v),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<c.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},c.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=c,c.TIMEOUT=4e3,c.START_BATCH_AFTER_COUNT=50}),define(Ie[104],Ce([1,0,7,5,3,232,14,49,11,2,237]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let E=class{constructor(l,c,f){this.extHostRpc=l,this._uriTransformer=c,this._logService=f,this._proxy=this.extHostRpc.getProxy(D.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new N.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,c){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const f=this._handlePool++;return this._textSearchProvider.set(f,c),this._proxy.$registerTextSearchProvider(f,this._transformScheme(l)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(l,c){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const f=this._handlePool++;return this._fileSearchProvider.set(f,c),this._proxy.$registerFileSearchProvider(f,this._transformScheme(l)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(l,c,f,v){const S=m(f),h=this._fileSearchProvider.get(l);if(h)return this._fileSearchManager.fileSearch(S,h,T=>{this._proxy.$handleFileMatch(l,c,T.map(s=>s.resource))},v);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,c,f,v){const S=this._textSearchProvider.get(l);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const h=m(f);return this.createTextSearchManager(h,S).search(s=>this._proxy.$handleTextMatch(l,c,s),v)}$enableExtensionHostSearch(){}createTextSearchManager(l,c){return new R.TextSearchManager(l,c,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};E=xe([$e(0,_.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,y.ILogService)],E),e.ExtHostSearch=E;function m(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(I),extraFileResources:g.extraFileResources&&g.extraFileResources.map(l=>P.URI.revive(l))}}e.reviveQuery=m;function I(g){return{...g,folder:P.URI.revive(g.folder)}}}),define(Ie[238],Ce([1,0,58,99,31,97,32,37,52,55,101,103,104,73,63,70,98,54,36,72,68,53,209,11,179,102,71]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h,T,s,u,n,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,r.registerSingleton)(u.ILoggerService,s.ExtHostLoggerService,1),(0,r.registerSingleton)(u.ILogService,n.ExtHostLogService,1),(0,r.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,!1),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,r.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,r.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,!1),(0,r.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService,!1),(0,r.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,!1),(0,r.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,!1),(0,r.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,r.registerSingleton)(D.IExtHostOutputService,D.ExtHostOutputService,1),(0,r.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,r.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,!1),(0,r.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,!1),(0,r.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,!1),(0,r.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,!1),(0,r.registerSingleton)(c.IExtHostWindow,c.ExtHostWindow,!1),(0,r.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace,!1),(0,r.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,!1),(0,r.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry,!1),(0,r.registerSingleton)(T.IExtHostEditorTabs,T.ExtHostEditorTabs,!1),(0,r.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,!1)}),define(Ie[239],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const N=this._dragOperations.get(b);return this._dragOperations.delete(b),N}}addDragOperationTransfer(b,N){this._dragOperations.set(b,N)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,N){this._renderedElements.set(b,N)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=r}),define(Ie[240],Ce([1,0,135,6,22,2,4,7,15,6,9,18,8,21,239,28]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(S,h){if((0,R.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let T;return Array.isArray(S.highlights)&&(T=S.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),T=T.length?T:void 0),{label:S.label,highlights:T}}}class f{constructor(h,T,s){this._proxy=h,this.commands=T,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeviewsService;function u(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}T.registerArgumentProcessor({processArgument:n=>u(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(i=>u(i)?this.convertArgument(i):i):n})}registerTreeDataProvider(h,T,s){const u=this.createTreeView(h,{treeDataProvider:T},s);return{dispose:()=>u.dispose()}}createTreeView(h,T,s){if(!T||!T.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=T.dragAndDropController?.dropMimeTypes??[],n=T.dragAndDropController?.dragMimeTypes??[],i=!!T.dragAndDropController?.handleDrag,o=!!T.dragAndDropController?.handleDrop,a=this.createExtHostTreeView(h,T,s),t=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!T.showCollapseAll,canSelectMany:!!T.canSelectMany,dropMimeTypes:u,dragMimeTypes:n,hasHandleDrag:i,hasHandleDrop:o});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,l.checkProposedApiEnabled)(s,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(d){a.message=d},get title(){return a.title},set title(d){a.title=d},get description(){return a.description},set description(d){a.description=d},get badge(){return a.badge},set badge(d){d!==void 0&&P.ViewBadge.isViewBadge(d)?a.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(a.badge=void 0)},reveal:(d,p)=>a.reveal(d,p),dispose:async()=>{await t,this.treeViews.delete(h),a.dispose()}}}$getChildren(h,T){const s=this.treeViews.get(h);return s?s.getChildren(T):Promise.reject(new Error((0,r.localize)(0,null,h)))}async $handleDrop(h,T,s,u,n,i,o,a){const t=this.treeViews.get(h);if(!t)return Promise.reject(new Error((0,r.localize)(1,null,h)));const d=m.DataTransfer.toDataTransfer(s,async p=>(await this._proxy.$resolveDropFileData(h,T,p)).buffer);return o===h&&a&&await this.addAdditionalTransferItems(d,t,a,n,i),t.onDrop(d,u,n)}async addAdditionalTransferItems(h,T,s,u,n){const i=this.treeDragAndDropService.removeDragOperationTransfer(n);if(i)(await i)?.forEach((o,a)=>{o&&h.set(a,o)});else if(n&&T.handleDrag){const o=T.handleDrag(s,h,u);this.treeDragAndDropService.addDragOperationTransfer(n,o),await o}return h}async $handleDrag(h,T,s,u){const n=this.treeViews.get(h);if(!n)return Promise.reject(new Error((0,r.localize)(2,null,h)));const i=await this.addAdditionalTransferItems(new D.DataTransfer,n,T,u,s);if(!!i)return m.DataTransfer.toDataTransferDTO(i)}async $hasResolve(h){const T=this.treeViews.get(h);if(!T)throw new Error((0,r.localize)(3,null,h));return T.hasResolve}$resolve(h,T,s){const u=this.treeViews.get(h);if(!u)throw new Error((0,r.localize)(4,null,h));return u.resolveTreeItem(T,s)}$setExpanded(h,T,s){const u=this.treeViews.get(h);if(!u)throw new Error((0,r.localize)(5,null,h));u.setExpanded(T,s)}$setSelection(h,T){const s=this.treeViews.get(h);if(!s)throw new Error((0,r.localize)(6,null,h));s.setSelection(T)}$setFocus(h,T){const s=this.treeViews.get(h);if(!s)throw new Error((0,r.localize)(7,null,h));s.setFocus(T)}$setVisible(h,T){const s=this.treeViews.get(h);if(!s)throw new Error((0,r.localize)(8,null,h));s.setVisible(T)}$changeCheckboxState(h,T){const s=this.treeViews.get(h);if(!s)throw new Error((0,r.localize)(9,null,h));s.setCheckboxState(T)}createExtHostTreeView(h,T,s){const u=new v(h,T,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(h,u),u}convertArgument(h){const T=this.treeViews.get(h.$treeViewId);return T&&"$treeItemHandle"in h?T.getExtensionElement(h.$treeItemHandle):T&&"$focusedTreeItem"in h&&h.$focusedTreeItem?T.focusedElement:null}}e.ExtHostTreeViews=f;class v extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.isUndefinedOrNull)(h))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(h,T,s,u,n,i){if(super(),this.viewId=h,this.proxy=s,this.commands=u,this.logService=n,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new _.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,i.contributes&&i.contributes.views)for(const t in i.contributes.views)for(const d of i.contributes.views[t])d.id===h&&(this._title=d.name);this.dataProvider=T.treeDataProvider,this.dndController=T.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let o,a;this._register(_.Event.debounce(this._onDidChangeData.event,(t,d)=>(t||(t={message:!1,elements:[]}),d.element!==!1&&(o||(o=new Promise(p=>a=p),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(d.element)?t.elements.push(...d.element):t.elements.push(d.element)),d.message&&(t.message=!0),t),200,!0)(({message:t,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=a;return o=null,this.refresh(d).then(()=>p())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(h){const T=h?this.getExtensionElement(h):void 0;if(h&&!T)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(h);return s||(s=await this.fetchChildrenNodes(T)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.elements.get(h)}reveal(h,T){T=T||{select:!0,focus:!1};const s=(0,R.isUndefinedOrNull)(T.select)?!0:T.select,u=(0,R.isUndefinedOrNull)(T.focus)?!1:T.focus,n=(0,R.isUndefinedOrNull)(T.expand)?!1:T.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(i=>this.resolveTreeNode(h,i[i.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:i.map(a=>a.item)},{select:s,focus:u,expand:n})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:u,expand:n})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}get badge(){return this._badge}set badge(h){this._badge?.value===h?.value&&this._badge?.tooltip===h?.tooltip||(this._badge=m.ViewBadge.from(h),this.proxy.$setBadge(this.viewId,h))}setExpanded(h,T){const s=this.getExtensionElement(h);s&&(T?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(h){(0,E.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(h){this._focusedHandle=h}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(h){const T=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:s.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);T.forEach(s=>{s.treeItem.checkboxState=s.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:T.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,T,s){const u=[];for(const n of h){const i=this.getExtensionElement(n);i&&u.push(i)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,T,s),T}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(h,T,s){const u=T?this.getExtensionElement(T):void 0;if(!(!u&&T||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,T){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(h);if(s){const u=this.nodes.get(s);if(u){const n=await this.dataProvider.resolveTreeItem(u.extensionItem,s,T)??u.extensionItem;return this.validateTreeItem(n),u.item.tooltip=this.getTooltip(n.tooltip),u.item.command=this.getCommand(u.disposableStore,n.command),u.item}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(T=>T?this.resolveUnknownParentChain(T).then(s=>this.resolveTreeNode(T,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}resolveParent(h){const T=this.nodes.get(h);return T?Promise.resolve(T.parent?this.elements.get(T.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,T){const s=this.nodes.get(h);return s?Promise.resolve(s):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(u=>this.createHandle(h,u,T,!0)).then(u=>this.getChildren(T?T.item.handle:void 0).then(()=>{const n=this.getExtensionElement(u);if(n){const i=this.nodes.get(n);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(h){if(h){let T;if(typeof h=="string"){const s=this.getExtensionElement(h);T=s?this.nodes.get(s):void 0}else T=h;return T&&T.children||void 0}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const T=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=h?this.nodes.get(h):void 0,u=await this.dataProvider.getChildren(h);if(T.token.isCancellationRequested)return;const n=await Promise.all((0,E.coalesce)(u||[]).map(async i=>{const o=await this.dataProvider.getTreeItem(i);return o&&!T.token.isCancellationRequested?this.createAndRegisterTreeNode(i,o,s):null}));return T.token.isCancellationRequested?void 0:(0,E.coalesce)(n)}finally{T.dispose()}}refresh(h){if(h.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(h);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const T=new Set,s=h.map(n=>this.nodes.get(n));for(const n of s)if(n&&!T.has(n.item.handle)){let i=n;for(;i&&i.parent&&s.findIndex(o=>i&&i.parent&&o&&o.item.handle===i.parent.item.handle)===-1;){const o=this.elements.get(i.parent.item.handle);i=o?this.nodes.get(o):void 0}i&&!i.parent&&T.add(n.item.handle)}const u=[];return T.forEach(n=>{const i=this.elements.get(n);if(i){const o=this.nodes.get(i);o&&(!o.parent||!T.has(o.parent.item.handle))&&u.push(n)}}),u}refreshHandles(h){const T={};return Promise.all(h.map(s=>this.refreshNode(s).then(u=>{u&&(T[s]=u.item)}))).then(()=>Object.keys(T).length?this.proxy.$refresh(this.viewId,T):void 0)}refreshNode(h){const T=this.getExtensionElement(h);if(T){const s=this.nodes.get(T);if(s)return this.clearChildren(T),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(T)).then(u=>{if(u){const n=this.createTreeNode(T,u,s.parent);return this.updateNodeCache(T,n,s,s.parent),s.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,T,s){const u=this.createTreeNode(h,T,s);if(T.id&&this.elements.has(u.item.handle))throw new Error((0,r.localize)(10,null,T.id));return this.addNodeToCache(h,u),this.addNodeToParentCache(u,s),u}getTooltip(h){return P.MarkdownString.isMarkdownString(h)?m.MarkdownString.from(h):h}getCommand(h,T){return T?{...this.commands.toInternal(T,h),originalId:T.command}:void 0}getCheckbox(h){if(!h.checkboxState)return;let T,s;return typeof h.checkboxState=="number"?T=h.checkboxState:(T=h.checkboxState.state,s=h.checkboxState.tooltip),{isChecked:T===P.TreeItemCheckboxState.Checked,tooltip:s}}validateTreeItem(h){if(!P.TreeItem.isTreeItem(h,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(h,T,s){this.validateTreeItem(T);const u=new A.DisposableStore,n=this.createHandle(h,T,s),i=this.getLightIconPath(T);return{item:{handle:n,parentHandle:s?s.item.handle:void 0,label:c(T.label,this.extension),description:T.description,resourceUri:T.resourceUri,tooltip:this.getTooltip(T.tooltip),command:this.getCommand(u,T.command),contextValue:T.contextValue,icon:i,iconDark:this.getDarkIconPath(T)||i,themeIcon:this.getThemeIcon(T),collapsibleState:(0,R.isUndefinedOrNull)(T.collapsibleState)?P.TreeItemCollapsibleState.None:T.collapsibleState,accessibilityInformation:T.accessibilityInformation,checkbox:this.getCheckbox(T)},extensionItem:T,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(h){return h.iconPath instanceof P.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:T,label:s,resourceUri:u},n,i){if(T)return`${v.ID_HANDLE_PREFIX}/${T}`;const o=c(s,this.extension),a=n?n.item.handle:v.LABEL_HANDLE_PREFIX;let t=o?o.label:u?(0,b.basename)(u):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const d=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,p=this.getChildrenNodes(n)||[];let w,F=0;do{if(w=`${a}/${F}:${t}`,i||!this.elements.has(w)||d===w)break;F++}while(F<=p.length);return w}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof P.ThemeIcon))return typeof h.iconPath=="string"||N.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof P.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return N.URI.isUri(h)?h:N.URI.file(h)}addNodeToCache(h,T){this.elements.set(T.item.handle,h),this.nodes.set(h,T)}updateNodeCache(h,T,s,u){this.elements.delete(T.item.handle),this.nodes.delete(h),T.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(h,T);const n=this.getChildrenNodes(u)||[],i=n.filter(o=>o.item.handle===s.item.handle)[0];i&&n.splice(n.indexOf(i),1,T)}addNodeToParentCache(h,T){T?(T.children||(T.children=[]),T.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const T=this.nodes.get(h);if(T){if(T.children)for(const s of T.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}T.children=void 0}}else this.clearAll()}clear(h){const T=this.nodes.get(h);if(T){if(T.children)for(const s of T.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}this.nodes.delete(h),this.elements.delete(T.item.handle),T.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ie[241],Ce([1,0,21,12,4,29,2,122,250,110,120,35,5,67,194,193,37,195,32,197,198,199,182,200,52,33,202,203,206,208,210,99,185,214,215,216,73,55,219,240,8,6,222,56,98,31,166,205,60,97,101,103,104,11,49,14,27,211,180,63,70,191,220,74,54,225,223,224,192,36,217,221,72,53,68,212,100,213,13,86,184,163,204,7,28,168,71]),function(ne,e,r,D,b,N,_,A,y,P,R,E,m,I,g,l,c,f,v,S,h,T,s,u,n,i,o,a,t,d,p,w,F,j,U,C,W,M,O,H,$,z,G,te,he,re,be,le,fe,Q,pe,Se,Fe,Ue,Xe,ke,ye,De,ae,ue,ee,Z,k,B,V,q,oe,ce,J,Ee,ve,Ne,ze,Je,Ge,Pe,nt,X,Y,me,Be,je,et,Ke,Ve,it,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ct(at){const rt=at.get(ye.IExtHostInitDataService),_t=at.get(Ee.IExtHostFileSystemInfo),Rt=at.get(V.IExtHostConsumerFileSystem),Ot=at.get(i.IExtHostExtensionService),mt=at.get(re.IExtHostWorkspace),yt=at.get(Ge.IExtHostTelemetry),Lt=at.get(v.IExtHostConfiguration),Mt=at.get(Xe.IURITransformerService),qe=at.get(ke.IExtHostRpcService),zt=at.get(W.IExtHostStorage),Ft=at.get(B.IExtensionStoragePaths),Tt=at.get(Ue.ILoggerService),ft=at.get(Ue.ILogService),It=at.get(ue.IExtHostTunnelService),_e=at.get(ee.IExtHostApiDeprecationService),Te=at.get(he.IExtHostWindow),ge=at.get(ze.IExtHostSecretState),K=at.get(Je.IExtHostEditorTabs);qe.set(m.ExtHostContext.ExtHostFileSystemInfo,_t),qe.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Tt),qe.set(m.ExtHostContext.ExtHostWorkspace,mt),qe.set(m.ExtHostContext.ExtHostConfiguration,Lt),qe.set(m.ExtHostContext.ExtHostExtensionService,Ot),qe.set(m.ExtHostContext.ExtHostStorage,zt),qe.set(m.ExtHostContext.ExtHostTunnelService,It),qe.set(m.ExtHostContext.ExtHostWindow,Te),qe.set(m.ExtHostContext.ExtHostSecretState,ge),qe.set(m.ExtHostContext.ExtHostTelemetry,yt),qe.set(m.ExtHostContext.ExtHostEditorTabs,K);const Ae=qe.set(m.ExtHostContext.ExtHostDecorations,at.get(Q.IExtHostDecorations)),Me=qe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),Ze=qe.set(m.ExtHostContext.ExtHostCommands,at.get(c.IExtHostCommands)),We=qe.set(m.ExtHostContext.ExtHostTerminalService,at.get(M.IExtHostTerminalService)),tt=qe.set(m.ExtHostContext.ExtHostDebugService,at.get(Se.IExtHostDebugService)),gt=qe.set(m.ExtHostContext.ExtHostSearch,at.get(Fe.IExtHostSearch)),vt=qe.set(m.ExtHostContext.ExtHostTask,at.get(pe.IExtHostTask)),Ct=qe.set(m.ExtHostContext.ExtHostOutputService,at.get(w.IExtHostOutputService)),Dt=qe.set(m.ExtHostContext.ExtHostLocalization,at.get(st.IExtHostLocalizationService)),Et=qe.set(m.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(qe)),pt=qe.set(m.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(qe,Me)),wt=qe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new T.ExtHostDocumentContentProvider(qe,Me,ft)),ei=qe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(ft,pt,qe.getProxy(m.MainContext.MainThreadBulkEdits))),bt=qe.set(m.ExtHostContext.ExtHostNotebook,new De.ExtHostNotebookController(qe,Ze,Me,pt)),qt=qe.set(m.ExtHostContext.ExtHostNotebookDocuments,new je.ExtHostNotebookDocuments(bt)),$t=qe.set(m.ExtHostContext.ExtHostNotebookEditors,new Be.ExtHostNotebookEditors(ft,bt)),ti=qe.set(m.ExtHostContext.ExtHostNotebookKernels,new Pe.ExtHostNotebookKernels(qe,rt,bt,Ze,ft)),ci=qe.set(m.ExtHostContext.ExtHostNotebookRenderers,new X.ExtHostNotebookRenderers(qe,bt)),kt=qe.set(m.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(qe,Me)),ii=qe.set(m.ExtHostContext.ExtHostTreeViews,new H.ExtHostTreeViews(qe.getProxy(m.MainContext.MainThreadTreeViews),Ze,ft)),ui=qe.set(m.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(qe.getProxy(m.MainContext.MainThreadEditorInsets),kt,rt.remote)),Ut=qe.set(m.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(qe,ft,_t)),Jt=qe.set(m.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(qe,pt,Ze.converter,Mt)),ut=qe.set(m.ExtHostContext.ExtHostLanguageFeatures,new t.ExtHostLanguageFeatures(qe,Mt,pt,Ze,Ut,ft,_e,yt)),di=qe.set(m.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(qe,ut)),Nt=qe.set(m.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(qe,ft,Me)),Kt=qe.set(m.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(qe,mt,Ze)),ni=qe.set(m.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(qe,Ze,ft)),hi=qe.set(m.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(qe,Ze,pt)),ri=qe.set(m.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(qe.getProxy(m.MainContext.MainThreadProgress))),fi=qe.set(m.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(qe)),si=qe.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),Zt=qe.set(m.ExtHostContext.ExtHostAuthentication,new Z.ExtHostAuthentication(qe)),mi=qe.set(m.ExtHostContext.ExtHostTimeline,new k.ExtHostTimeline(qe,Ze)),gi=qe.set(m.ExtHostContext.ExtHostWebviews,new te.ExtHostWebviews(qe,rt.remote,mt,ft,_e)),pi=qe.set(m.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(qe,gi,mt)),vi=qe.set(m.ExtHostContext.ExtHostCustomEditors,new oe.ExtHostCustomEditors(qe,pt,Ft,gi,pi)),Ei=qe.set(m.ExtHostContext.ExtHostWebviewViews,new q.ExtHostWebviewViews(qe,gi)),Gt=qe.set(m.ExtHostContext.ExtHostTesting,new ve.ExtHostTesting(qe,Ze,Me)),bi=qe.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(qe));qe.set(m.ExtHostContext.ExtHostInteractive,new et.ExtHostInteractive(qe,bt,Me,Ze,ft));const Ni=Object.values(m.ExtHostContext);qe.assertRegistered(Ni);const wi=new J.ExtHostBulkEdits(qe,Me),Si=new l.ExtHostClipboard(qe),_i=new p.ExtHostMessageService(qe,ft),Ti=new h.ExtHostDialogs(qe),ki=new C.ExtHostStatusBar(qe,Ze.converter);return g.ExtHostApiCommands.register(Ze),function(Le,Ht,Pi){const ht=function(){let se=!Le.isUnderDevelopment;function de(){se||(ft.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const St=ot;typeof St.scheme>"u"&&de(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return ot}}(),yi={getSession(se,de,Re){return Zt.getSession(Le,se,de,Re)},async hasSession(se,de){return(0,Ve.checkProposedApiEnabled)(Le,"authSession"),!!await Zt.getSession(Le,se,de,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,de,Re,ot){return Zt.registerAuthenticationProvider(se,de,Re,ot)}},Li={registerCommand(se,de,Re){return Ze.registerCommand(!0,se,de,Re,void 0,Le)},registerTextEditorCommand(se,de,Re){return Ze.registerCommand(!0,se,(...ot)=>{const St=kt.getActiveTextEditor();if(!St){ft.warn("Cannot execute "+se+" because there is no active text editor.");return}return St.edit(Pt=>{de.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||ft.warn("Edits from command "+se+" were not applied.")},Pt=>{ft.warn("An error occurred while running command "+se,Pt)})},void 0,void 0,Le)},registerDiffInformationCommand:(se,de,Re)=>((0,Ve.checkProposedApiEnabled)(Le,"diffCommand"),Ze.registerCommand(!0,se,async(...ot)=>{const St=Me.activeEditor(!0);if(!St){ft.warn("Cannot execute "+se+" because there is no active text editor.");return}const Pt=await kt.getDiffInformation(St.id);de.apply(Re,[Pt,...ot])},void 0,void 0,Le)),executeCommand(se,...de){return Ze.executeCommand(se,...de)},getCommands(se=!1){return Ze.getCommands(se)}},Ai={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Si.value},get shell(){return We.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Le,"envShellEvent"),We.onDidChangeShell},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ge.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(se){return(0,Ve.checkProposedApiEnabled)(Le,"telemetry"),yt.instantiateLogger(Le,se)},openExternal(se,de){return Te.openUri(se,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===rt.environment.appUriScheme)return Et.createAppUri(se);try{return await Te.asExternalUri(se,{allowTunneling:!!rt.remote.authority})}catch(de){if((0,me.matchesScheme)(se,Y.Schemas.http)||(0,me.matchesScheme)(se,Y.Schemas.https))return se;throw de}},get remoteName(){return(0,fe.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Le,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return(0,Ve.checkProposedApiEnabled)(Le,"extensionLog"),ft.getLevel()},get onDidChangeLogLevel(){return(0,Ve.checkProposedApiEnabled)(Le,"extensionLog"),ft.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Ai);const Mi={createTestController(se,de,Re){return Gt.createTestController(se,de,Re)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.createTestObserver()},runTests(se){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.runTests(se)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Le,"testObserver"),Gt.results}},Xt=rt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ui={getExtension(se,de){(0,Ve.isProposedApiEnabled)(Le,"extensionsAny")||(de=!1);const Re=Ht.mine.getExtensionDescription(se);if(Re)return new i.Extension(Ot,Le.identifier,Re,Xt,!1);if(de){const ot=Ht.all.getExtensionDescription(se);if(ot)return new i.Extension(Ot,Le.identifier,ot,Xt,!0)}},get all(){const se=[];for(const de of Ht.mine.getAllExtensionDescriptions())se.push(new i.Extension(Ot,Le.identifier,de,Xt,!1));return se},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Le,"extensionsAny");const se=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of Ht.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);de.push(new i.Extension(Ot,Le.identifier,Re,Xt,ot))}return de},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Le,"extensionsAny")?b.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Bi={createDiagnosticCollection(se){return Ut.createDiagnosticCollection(Le.identifier,se)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:se=>Ut.getDiagnostics(se),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(se,de){return Jt.changeLanguage(se.uri,de)},match(se,de){const Re=pt.getDocumentData(de.uri)?.notebook;return(0,R.score)($.LanguageSelector.from(se),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,de,Re){return ut.registerCodeActionProvider(Le,ht(se),de,Re)},registerDocumentPasteEditProvider(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"documentPaste"),ut.registerDocumentPasteEditProvider(Le,ht(se),de,Re)},registerCodeLensProvider(se,de){return ut.registerCodeLensProvider(Le,ht(se),de)},registerDefinitionProvider(se,de){return ut.registerDefinitionProvider(Le,ht(se),de)},registerDeclarationProvider(se,de){return ut.registerDeclarationProvider(Le,ht(se),de)},registerImplementationProvider(se,de){return ut.registerImplementationProvider(Le,ht(se),de)},registerTypeDefinitionProvider(se,de){return ut.registerTypeDefinitionProvider(Le,ht(se),de)},registerHoverProvider(se,de){return ut.registerHoverProvider(Le,ht(se),de,Le.identifier)},registerEvaluatableExpressionProvider(se,de){return ut.registerEvaluatableExpressionProvider(Le,ht(se),de,Le.identifier)},registerInlineValuesProvider(se,de){return ut.registerInlineValuesProvider(Le,ht(se),de,Le.identifier)},registerDocumentHighlightProvider(se,de){return ut.registerDocumentHighlightProvider(Le,ht(se),de)},registerLinkedEditingRangeProvider(se,de){return ut.registerLinkedEditingRangeProvider(Le,ht(se),de)},registerReferenceProvider(se,de){return ut.registerReferenceProvider(Le,ht(se),de)},registerRenameProvider(se,de){return ut.registerRenameProvider(Le,ht(se),de)},registerDocumentSymbolProvider(se,de,Re){return ut.registerDocumentSymbolProvider(Le,ht(se),de,Re)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Le,se)},registerDocumentFormattingEditProvider(se,de){return ut.registerDocumentFormattingEditProvider(Le,ht(se),de)},registerDocumentRangeFormattingEditProvider(se,de){return ut.registerDocumentRangeFormattingEditProvider(Le,ht(se),de)},registerOnTypeFormattingEditProvider(se,de,Re,...ot){return ut.registerOnTypeFormattingEditProvider(Le,ht(se),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,de,Re){return ut.registerDocumentSemanticTokensProvider(Le,ht(se),de,Re)},registerDocumentRangeSemanticTokensProvider(se,de,Re){return ut.registerDocumentRangeSemanticTokensProvider(Le,ht(se),de,Re)},registerSignatureHelpProvider(se,de,Re,...ot){return typeof Re=="object"?ut.registerSignatureHelpProvider(Le,ht(se),de,Re):ut.registerSignatureHelpProvider(Le,ht(se),de,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(se,de,...Re){return ut.registerCompletionItemProvider(Le,ht(se),de,Re)},registerInlineCompletionItemProvider(se,de){return de.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Le,ht(se),de)},registerInlineCompletionItemProviderNew(se,de){if((0,Ve.checkProposedApiEnabled)(Le,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(Le,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Le,ht(se),de)},registerDocumentLinkProvider(se,de){return ut.registerDocumentLinkProvider(Le,ht(se),de)},registerColorProvider(se,de){return ut.registerColorProvider(Le,ht(se),de)},registerFoldingRangeProvider(se,de){return ut.registerFoldingRangeProvider(Le,ht(se),de)},registerSelectionRangeProvider(se,de){return ut.registerSelectionRangeProvider(Le,se,de)},registerCallHierarchyProvider(se,de){return ut.registerCallHierarchyProvider(Le,se,de)},registerTypeHierarchyProvider(se,de){return ut.registerTypeHierarchyProvider(Le,se,de)},setLanguageConfiguration:(se,de)=>ut.setLanguageConfiguration(Le,se,de),getTokenInformationAtPosition(se,de){return(0,Ve.checkProposedApiEnabled)(Le,"tokenInformation"),Jt.tokenAtPosition(se,de)},registerInlayHintsProvider(se,de){return ut.registerInlayHintsProvider(Le,se,de)},createLanguageStatusItem(se,de){return Jt.createLanguageStatusItem(Le,se,de)},registerDocumentDropEditProvider(se,de){return ut.registerDocumentOnDropEditProvider(Le,se,de)}},zi={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return We.activeTerminal},get terminals(){return We.terminals},async showTextDocument(se,de,Re){const ot=await(_.URI.isUri(se)?Promise.resolve(Ri.openTextDocument(se)):Promise.resolve(se));return kt.showTextDocument(ot,de,Re)},createTextEditorDecorationType(se){return kt.createTextEditorDecorationType(Le,se)},onDidChangeActiveTextEditor(se,de,Re){return kt.onDidChangeActiveTextEditor(se,de,Re)},onDidChangeVisibleTextEditors(se,de,Re){return kt.onDidChangeVisibleTextEditors(se,de,Re)},onDidChangeTextEditorSelection(se,de,Re){return kt.onDidChangeTextEditorSelection(se,de,Re)},onDidChangeTextEditorOptions(se,de,Re){return kt.onDidChangeTextEditorOptions(se,de,Re)},onDidChangeTextEditorVisibleRanges(se,de,Re){return kt.onDidChangeTextEditorVisibleRanges(se,de,Re)},onDidChangeTextEditorViewColumn(se,de,Re){return kt.onDidChangeTextEditorViewColumn(se,de,Re)},onDidCloseTerminal(se,de,Re){return We.onDidCloseTerminal(se,de,Re)},onDidOpenTerminal(se,de,Re){return We.onDidOpenTerminal(se,de,Re)},onDidChangeActiveTerminal(se,de,Re){return We.onDidChangeActiveTerminal(se,de,Re)},onDidChangeTerminalDimensions(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"terminalDimensions"),We.onDidChangeTerminalDimensions(se,de,Re)},onDidChangeTerminalState(se,de,Re){return We.onDidChangeTerminalState(se,de,Re)},onDidWriteTerminalData(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),We.onDidWriteTerminalData(se,de,Re)},get state(){return Te.state},onDidChangeWindowState(se,de,Re){return Te.onDidChangeWindowState(se,de,Re)},showInformationMessage(se,...de){return _i.showMessage(Le,N.default.Info,se,de[0],de.slice(1))},showWarningMessage(se,...de){return _i.showMessage(Le,N.default.Warning,se,de[0],de.slice(1))},showErrorMessage(se,...de){return _i.showMessage(Le,N.default.Error,se,de[0],de.slice(1))},showQuickPick(se,de,Re){return Kt.showQuickPick(se,de,Re)},showWorkspaceFolderPick(se){return Kt.showWorkspaceFolderPick(se)},showInputBox(se,de){return Kt.showInput(se,de)},showOpenDialog(se){return Ti.showOpenDialog(se)},showSaveDialog(se){return Ti.showSaveDialog(se)},createStatusBarItem(se,de,Re){let ot,St,Pt;return typeof se=="string"?(ot=se,St=de,Pt=Re):(St=se,Pt=de),ki.createStatusBarEntry(Le,ot,St,Pt)},setStatusBarMessage(se,de){return ki.setStatusBarMessage(se,de)},withScmProgress(se){return _e.report("window.withScmProgress",Le,"Use 'withProgress' instead."),ri.withProgress(Le,{location:z.ProgressLocation.SourceControl},(de,Re)=>se({report(ot){}}))},withProgress(se,de){return ri.withProgress(Le,se,de)},createOutputChannel(se,de){return Ct.createOutputChannel(se,de,Le)},createWebviewPanel(se,de,Re,ot){return pi.createWebviewPanel(Le,se,de,Re,ot)},createWebviewTextEditorInset(se,de,Re,ot){return(0,Ve.checkProposedApiEnabled)(Le,"editorInsets"),ui.createWebviewEditorInset(se,de,Re,ot,Le)},createTerminal(se,de,Re){return typeof se=="object"?"pty"in se?We.createExtensionTerminal(se):We.createTerminalFromOptions(se):We.createTerminal(se,de,Re)},registerTerminalLinkProvider(se){return We.registerLinkProvider(se)},registerTerminalProfileProvider(se,de){return We.registerProfileProvider(Le,se,de)},registerTreeDataProvider(se,de){return ii.registerTreeDataProvider(se,de,Le)},createTreeView(se,de){return ii.createTreeView(se,de,Le)},registerWebviewPanelSerializer:(se,de)=>pi.registerWebviewPanelSerializer(Le,se,de),registerCustomEditorProvider:(se,de,Re={})=>vi.registerCustomEditorProvider(Le,se,de,Re),registerFileDecorationProvider(se){return Ae.registerFileDecorationProvider(se,Le.identifier)},registerUriHandler(se){return Et.registerUriHandler(Le.identifier,se)},createQuickPick(){return Kt.createQuickPick(Le)},createInputBox(){return Kt.createInputBox(Le)},get activeColorTheme(){return si.activeColorTheme},onDidChangeActiveColorTheme(se,de,Re){return si.onDidChangeActiveColorTheme(se,de,Re)},registerWebviewViewProvider(se,de,Re){return Ei.registerWebviewViewProvider(Le,se,de,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,de,Re){return bt.onDidChangeActiveNotebookEditor(se,de,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,de,Re){return $t.onDidChangeNotebookEditorSelection(se,de,Re)},onDidChangeNotebookEditorVisibleRanges(se,de,Re){return $t.onDidChangeNotebookEditorVisibleRanges(se,de,Re)},showNotebookDocument(se,de){return _.URI.isUri(se)&&_e.report("window.showNotebookDocument(uri)",Le,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(se,de)},registerExternalUriOpener(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"externalUriOpener"),bi.registerExternalUriOpener(Le.identifier,se,de,Re)},get tabGroups(){return K.tabGroups}},Ri={get rootPath(){return _e.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(se){throw D.readonly()},getWorkspaceFolder(se){return mt.getWorkspaceFolder(se)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(se){throw D.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(se){throw D.readonly()},updateWorkspaceFolders:(se,de,...Re)=>mt.updateWorkspaceFolders(Le,se,de||0,...Re),onDidChangeWorkspaceFolders:function(se,de,Re){return mt.onDidChangeWorkspace(se,de,Re)},asRelativePath:(se,de)=>mt.getRelativePath(se,de),findFiles:(se,de,Re,ot)=>mt.findFiles(se,de,Re,Le.identifier,ot),findTextInFiles:(se,de,Re,ot)=>{(0,Ve.checkProposedApiEnabled)(Le,"findTextInFiles");let St,Pt;return typeof de=="object"?(St=de,Pt=Re):(St={},Pt=de,ot=Re),mt.findTextInFiles(se,St||{},Pt,Le.identifier,ot)},saveAll:se=>mt.saveAll(se),applyEdit(se,de){return wi.applyWorkspaceEdit(se,Le,de)},createFileSystemWatcher:(se,de,Re,ot)=>Nt.createFileSystemWatcher(mt,Le,se,de,Re,ot),get textDocuments(){return pt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw D.readonly()},openTextDocument(se){let de;const Re=se;if(typeof se=="string")de=Promise.resolve(_.URI.file(se));else if(_.URI.isUri(se))de=Promise.resolve(se);else if(!Re||typeof Re=="object")de=pt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>pt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(se,de,Re)=>pt.onDidAddDocument(se,de,Re),onDidCloseTextDocument:(se,de,Re)=>pt.onDidRemoveDocument(se,de,Re),onDidChangeTextDocument:(se,de,Re)=>pt.onDidChangeDocument(se,de,Re),onDidSaveTextDocument:(se,de,Re)=>pt.onDidSaveDocument(se,de,Re),onWillSaveTextDocument:(se,de,Re)=>ei.getOnWillSaveTextDocumentEvent(Le)(se,de,Re),get notebookDocuments(){return bt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,de){let Re;if(_.URI.isUri(se))Re=se,await bt.openNotebookDocument(se);else if(typeof se=="string")Re=_.URI.revive(await bt.createNotebookDocument({viewType:se,content:de}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,de,Re){return qt.onDidSaveNotebookDocument(se,de,Re)},onDidChangeNotebookDocument(se,de,Re){return qt.onDidChangeNotebookDocument(se,de,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(se,de,Re,ot){return bt.registerNotebookSerializer(Le,se,de,Re,(0,Ve.isProposedApiEnabled)(Le,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,de,Re,ot)=>((0,Ve.checkProposedApiEnabled)(Le,"notebookContentProvider"),_e.report("workspace.registerNotebookContentProvider",Le,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(Le,se,de,Re,(0,Ve.isProposedApiEnabled)(Le,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,de,Re)=>Pi.onDidChangeConfiguration(se,de,Re),getConfiguration(se,de){return de=arguments.length===1?void 0:de,Pi.getConfiguration(se,de,Le)},registerTextDocumentContentProvider(se,de){return wt.registerTextDocumentContentProvider(se,de)},registerTaskProvider:(se,de)=>(_e.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Le,se,de)),registerFileSystemProvider(se,de,Re){return(0,Ke.combinedDisposable)(di.registerFileSystemProvider(Le,se,de,Re),Rt.addFileSystemProvider(se,de))},get fs(){return Rt.value},registerFileSearchProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"fileSearchProvider"),gt.registerFileSearchProvider(se,de)),registerTextSearchProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"textSearchProvider"),gt.registerTextSearchProvider(se,de)),registerRemoteAuthorityResolver:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"resolvers"),Ot.registerRemoteAuthorityResolver(se,de)),registerResourceLabelFormatter:se=>((0,Ve.checkProposedApiEnabled)(Le,"resolvers"),fi.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,de,Re)=>Nt.onDidCreateFile(se,de,Re),onDidDeleteFiles:(se,de,Re)=>Nt.onDidDeleteFile(se,de,Re),onDidRenameFiles:(se,de,Re)=>Nt.onDidRenameFile(se,de,Re),onWillCreateFiles:(se,de,Re)=>Nt.getOnWillCreateFileEvent(Le)(se,de,Re),onWillDeleteFiles:(se,de,Re)=>Nt.getOnWillDeleteFileEvent(Le)(se,de,Re),onWillRenameFiles:(se,de,Re)=>Nt.getOnWillRenameFileEvent(Le)(se,de,Re),openTunnel:se=>((0,Ve.checkProposedApiEnabled)(Le,"tunnels"),It.openTunnel(Le,se).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Le,"tunnels"),It.getTunnels()},onDidChangeTunnels:(se,de,Re)=>((0,Ve.checkProposedApiEnabled)(Le,"tunnels"),It.onDidChangeTunnels(se,de,Re)),registerPortAttributesProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"portsAttributes"),It.registerPortsAttributesProvider(se,de)),registerTimelineProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"timeline"),mi.registerTimelineProvider(se,de,Le.identifier,Ze.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:se=>((0,Ve.checkProposedApiEnabled)(Le,"workspaceTrust"),mt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,de,Re)=>mt.onDidGrantWorkspaceTrust(se,de,Re),registerEditSessionIdentityProvider:(se,de)=>((0,Ve.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(se,de))},Di={get inputBox(){return _e.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Le)},createSourceControl(se,de,Re){return ni.createSourceControl(Le,se,de,Re)}},xi={createCommentController(se,de){return hi.createCommentController(Le,se,de)}},Vt={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(se,de,Re){return tt.onDidStartDebugSession(se,de,Re)},onDidTerminateDebugSession(se,de,Re){return tt.onDidTerminateDebugSession(se,de,Re)},onDidChangeActiveDebugSession(se,de,Re){return tt.onDidChangeActiveDebugSession(se,de,Re)},onDidReceiveDebugSessionCustomEvent(se,de,Re){return tt.onDidReceiveDebugSessionCustomEvent(se,de,Re)},onDidChangeBreakpoints(se,de,Re){return tt.onDidChangeBreakpoints(se,de,Re)},registerDebugConfigurationProvider(se,de,Re){return tt.registerDebugConfigurationProvider(se,de,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,de){return tt.registerDebugAdapterDescriptorFactory(Le,se,de)},registerDebugAdapterTrackerFactory(se,de){return tt.registerDebugAdapterTrackerFactory(se,de)},startDebugging(se,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?tt.startDebugging(se,de,{parentSession:Re}):tt.startDebugging(se,de,Re||{})},stopDebugging(se){return tt.stopDebugging(se)},addBreakpoints(se){return tt.addBreakpoints(se)},removeBreakpoints(se){return tt.removeBreakpoints(se)},asDebugSourceUri(se,de){return tt.asDebugSourceUri(se,de)}},oi={registerTaskProvider:(se,de)=>vt.registerTaskProvider(Le,se,de),fetchTasks:se=>vt.fetchTasks(se),executeTask:se=>vt.executeTask(Le,se),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(se,de,Re)=>vt.onDidStartTask(se,de,Re),onDidEndTask:(se,de,Re)=>vt.onDidEndTask(se,de,Re),onDidStartTaskProcess:(se,de,Re)=>vt.onDidStartTaskProcess(se,de,Re),onDidEndTaskProcess:(se,de,Re)=>vt.onDidEndTaskProcess(se,de,Re)},$i={createNotebookController(se,de,Re,ot,St){return ti.createNotebookController(Le,se,de,Re,ot,(0,Ve.isProposedApiEnabled)(Le,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(se,de)=>bt.registerNotebookCellStatusBarItemProvider(Le,se,de),createRendererMessaging(se){return ci.createRendererMessaging(Le,se)},onDidChangeNotebookCellExecutionState(se,de,Re){return(0,Ve.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(se,de,Re)}},Bt={t(...se){if(typeof se[0]=="string"){const de=se.shift(),Re=!se||typeof se[0]!="object"?se:se[0];return Dt.getMessage(Le.identifier.value,{message:de,args:Re})}return Dt.getMessage(Le.identifier.value,se[0])},get bundle(){return Dt.getBundle(Le.identifier.value)},get uri(){return Dt.getBundleUri(Le.identifier.value)}};return{version:rt.version,authentication:yi,commands:Li,comments:xi,debug:Vt,env:Ai,extensions:Ui,l10n:Bt,languages:Bi,notebooks:$i,scm:Di,tasks:oi,tests:Mi,window:zi,workspace:Ri,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:D.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:z.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionItemNew:z.InlineSuggestionNew,InlineCompletionList:z.InlineSuggestionList,InlineCompletionListNew:z.InlineSuggestionsNew,Hover:z.Hover,IndentAction:P.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:I.UIKind,Uri:_.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TerminalExitReason:z.TerminalExitReason,LogLevel:Ue.LogLevel}}}e.createApiFactoryAndRegisterActors=ct}),define(Ie[242],Ce([1,0,241,33,2,235,6,15,226]),function(ne,e,r,D,b,N,_,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends N.RequireInterceptor{_installInterceptor(){}getModule(I,g){for(const l of this._alternatives){const c=l(I);if(c){I=c;break}}if(this._factories.has(I))return this._factories.get(I).load(I,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends D.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const I=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,I,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(I){return I.browser}async _loadCommonJSModule(I,g,l){g=g.with({path:E(g.path,".js")});const c=I?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const f=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(g)),v=await fetch(f.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),v.status!==200)throw new Error(v.statusText);const S=await v.text(),h=`${g.toString(!0)}#vscode-extension`,T=`${S}
//# sourceURL=${h}`;let s;try{s=new Function("module","exports","require",T)}catch(o){throw console.error(c?`Loading code for extension ${c} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${g.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}I&&await this._extHostLocalizationService.initializeLocalizedMessages(I);const u={},n={exports:u},i=o=>{const a=this._fakeModules.getModule(o,g);if(a===void 0)throw new Error(`Cannot load module '${o}'`);return a};try{return l.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),s(n,u,i),n.exports!==u?n.exports:u}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),l.codeLoadingStop()}}async $setRemoteEnvironment(I){}async _waitForDebuggerAttachment(I=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+I;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=R;function E(m,I){return m.endsWith(I)?m:m+I}}),define(Ie[243],Ce([1,0,58,33,74,242]),function(ne,e,r,D,b,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(D.IExtHostExtensionService,N.ExtHostExtensionService,!1),(0,r.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths,!1)}),define(Ie[251],Ce([1,0,23,4,67,236,228,19,75,13,2,238,243]),function(ne,e,r,D,b,N,_,A,y,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function I(s){return/^(file|vscode-remote):/i.test(s)}const g=fetch.bind(self);function l(s){self.fetch=async function(u,n){return u instanceof Request||I(String(u))&&(u=(await s(R.URI.parse(String(u)))).toString(!0)),g(u,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,n,i,o,a){(async()=>(I(n.toString())&&(n=(await s(R.URI.parse(n.toString()))).toString(!0)),super.open(u,n,i??!0,o,a)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(u,n){if(/^file:/i.test(u.toString()))u=P.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(p){function w(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const F=fetch.bind(self);self.fetch=function(U,C){return U instanceof Request?F(U,C):F(w(U),C)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,C,W,M,O){return super.open(U,w(C),W??!0,M,O)}};const j=importScripts.bind(self);self.importScripts=(...U)=>{j(...U.map(w))},j(p)}.toString()}('${u}'))`;n=n||{},n.name=n.name||A.basename(u.toString());const a=new Blob([o],{type:"application/javascript"}),t=URL.createObjectURL(a);return new s(t,n)}}else self.Worker=class extends _.NestedWorker{constructor(s,u){super(m,s,{name:A.basename(s.toString()),...u})}};const c=new class{constructor(){this.pid=void 0}exit(s){E()}async exists(s){return!0}async realpath(s){return s}};class f{constructor(){const u=new MessageChannel,n=new D.Emitter;let i=!1;m(u.port2,[u.port2]),u.port1.onmessage=o=>{const{data:a}=o;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const t=r.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,b.isMessageOfType)(t,2)){i=!0,S("received terminate message from renderer");return}n.fire(t)},this.protocol={onMessage:n.event,send:o=>{if(!i){const a=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);u.port1.postMessage(a,[a])}}}}}function v(s){return new Promise(u=>{const n=s.onMessage(i=>{n.dispose();const o=JSON.parse(i.toString());s.send((0,b.createMessageOfType)(0)),u({protocol:s,initData:o})});s.send((0,b.createMessageOfType)(1))})}let S=s=>E();function h(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function T(){y.mark("code/extHost/willConnectToRenderer");const s=new f;return{onmessage(u){!h(u)||v(s.protocol).then(n=>{y.mark("code/extHost/didWaitForInitData");const i=new N.ExtensionHostMain(n.protocol,n.initData,c,null,u.data);l(o=>i.asBrowserUri(o)),S=o=>i.terminate(o)})}}}e.create=T})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6455bf1608dfa1b955717f66295f0f9200db0f73/core/vs/workbench/api/worker/extensionHostWorker.js.map
